dnl @synopsis XYCE_ARG_CHECK_MPI
dnl
dnl Check to make sure any definitions set in XYCE_ARG_CONFIG_MPI
dnl are valid, set the MPI flags.  Test MPI compile using C++ compiler.
dnl
dnl @author Mike Heroux <mheroux@cs.sandia.gov>
dnl
AC_DEFUN([XYCE_ARG_CHECK_MPI],
[

if test "X${USE_MPI}" = "Xyes"; then

  if test -n "${MPI_DIR}" && test -z "${MPI_INC}"; then
    MPI_INC=${MPI_DIR}/include
  fi

  if test -n "${MPI_DIR}" && test -z "${MPI_LIBDIR}"; then
    MPI_LIBDIR=${MPI_DIR}/lib
  fi

  if test -n "${MPI_INC}"; then
    CPPFLAGS="${CPPFLAGS} ${MPI_INC}"
  fi

  if test -n "${MPI_LIBDIR}"; then
    LDFLAGS="${LDFLAGS} ${MPI_LIBDIR}"
  fi

  if test -z "${MPI_LIBS}" && test -n "${MPI_LIBDIR}"; then
    MPI_LIBS="-lmpi"
  fi

  if test -n "${MPI_LIBS}"; then
    LIBS="${MPI_LIBS}"
  fi

  AC_LANG_PUSH(C++)
  AC_MSG_CHECKING(whether MPI will link using C++ compiler)
  AC_LINK_IFELSE(
    [AC_LANG_PROGRAM([[#include <mpi.h>]],[[int c; char** v; MPI_Init(&c,&v);]])],
  [AC_MSG_RESULT(yes)], 
  [AC_MSG_RESULT(no)  
   AC_MSG_ERROR(MPI cannot link)]
  )
fi
])
