
//-------------------------------------------------------------------------
//   Copyright 2002-2019 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bjt504t.va with ADMS
//                  interface for Xyce 6.12.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
//                  THIS FILE WAS GENERATED WITH AN EXPERIMENTAL VERSION
//                  OF XYCE/ADMS THAT HAS NOT BEEN RELEASED YET.
//                  Do not regenerate this file using the released version,
//                  or you will lose the optimizations that can be performed
//                  by the experimental code.
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Mon, 08 Apr 2019 13:58:39
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSbjt504tva.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

#include <algorithm>

namespace Xyce {
namespace Device {
namespace ADMSbjt504tva {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_dt;
const int Instance::admsNodeID_e1;
const int Instance::admsNodeID_b1;
const int Instance::admsNodeID_b2;
const int Instance::admsNodeID_c1;
const int Instance::admsNodeID_c2;
const int Instance::admsNodeID_c3;
const int Instance::admsNodeID_c4;
const int Instance::admsNodeID_noi;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbjt504tva::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbjt504tva::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("MULT", static_cast<double>(1.0), &ADMSbjt504tva::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Multiplication factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSbjt504tva::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSbjt504tva::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbjt504tva::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<int>(504), &ADMSbjt504tva::Model::LEVEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Model level");
  p.addPar("TREF", static_cast<double>(25.0), &ADMSbjt504tva::Model::TREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTA", static_cast<double>(0.0), &ADMSbjt504tva::Model::DTA)
    .setUnit(U_UNKNOWN)
    .setDescription("Difference between the local and global ambient temperatures")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EXMOD", static_cast<int>(1), &ADMSbjt504tva::Model::EXMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for extended modeling of the reverse current gain");
  p.addPar("EXPHI", static_cast<int>(1), &ADMSbjt504tva::Model::EXPHI)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for the distributed high-frequency effects in transient");
  p.addPar("EXAVL", static_cast<int>(0), &ADMSbjt504tva::Model::EXAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for extended modeling of avalanche currents");
  p.addPar("EXSUB", static_cast<int>(0), &ADMSbjt504tva::Model::EXSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for extended modelling of substrate currents");
  p.addPar("IS", static_cast<double>(22.0*1.0e-18), &ADMSbjt504tva::Model::IS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-emitter saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IK", static_cast<double>(0.1), &ADMSbjt504tva::Model::IK)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-emitter high injection knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VER", static_cast<double>(2.5), &ADMSbjt504tva::Model::VER)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VEF", static_cast<double>(44.0), &ADMSbjt504tva::Model::VEF)
    .setUnit(U_UNKNOWN)
    .setDescription("Forward Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BF", static_cast<double>(215.0), &ADMSbjt504tva::Model::BF)
    .setUnit(U_UNKNOWN)
    .setDescription("Ideal forward current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBF", static_cast<double>(2.7*1.0e-15), &ADMSbjt504tva::Model::IBF)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation current of the non-ideal forward base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MLF", static_cast<double>(2.0), &ADMSbjt504tva::Model::MLF)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor of the non-ideal forward base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIBI", static_cast<double>(0.0), &ADMSbjt504tva::Model::XIBI)
    .setUnit(U_UNKNOWN)
    .setDescription("Part of ideal base current that belongs to the sidewall")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IZEB", static_cast<double>(0.0), &ADMSbjt504tva::Model::IZEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-factor of emitter-base Zener tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NZEB", static_cast<double>(22.0), &ADMSbjt504tva::Model::NZEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient of emitter-base Zener tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BRI", static_cast<double>(7.0), &ADMSbjt504tva::Model::BRI)
    .setUnit(U_UNKNOWN)
    .setDescription("Ideal reverse current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBR", static_cast<double>(1.0*1.0e-15), &ADMSbjt504tva::Model::IBR)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation current of the non-ideal reverse base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VLR", static_cast<double>(0.2), &ADMSbjt504tva::Model::VLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-over voltage of the non-ideal reverse base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XEXT", static_cast<double>(0.63), &ADMSbjt504tva::Model::XEXT)
    .setUnit(U_UNKNOWN)
    .setDescription("Part of currents and charges that belong to extrinsic region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAVL", static_cast<double>(1.1*1.0e-6), &ADMSbjt504tva::Model::WAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Epilayer thickness used in weak-avalanche model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VAVL", static_cast<double>(3.0), &ADMSbjt504tva::Model::VAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Voltage determining curvature of avalanche current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFH", static_cast<double>(0.3), &ADMSbjt504tva::Model::SFH)
    .setUnit(U_UNKNOWN)
    .setDescription("Current spreading factor of avalanche model when EXAVL=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(5.0), &ADMSbjt504tva::Model::RE)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBC", static_cast<double>(23.0), &ADMSbjt504tva::Model::RBC)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant part of the base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBV", static_cast<double>(18.0), &ADMSbjt504tva::Model::RBV)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias value of the variable part of the base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCC", static_cast<double>(12.0), &ADMSbjt504tva::Model::RCC)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant part of the collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCV", static_cast<double>(150.0), &ADMSbjt504tva::Model::RCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance of the un-modulated epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCRCV", static_cast<double>(1250.0), &ADMSbjt504tva::Model::SCRCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Space charge resistance of the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IHC", static_cast<double>(4.0*1.0e-3), &ADMSbjt504tva::Model::IHC)
    .setUnit(U_UNKNOWN)
    .setDescription("Critical current for velocity saturation in the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXI", static_cast<double>(0.3), &ADMSbjt504tva::Model::AXI)
    .setUnit(U_UNKNOWN)
    .setDescription("Smoothness parameter for the onset of quasi-saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE", static_cast<double>(73.0*1.0e-15), &ADMSbjt504tva::Model::CJE)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias emitter-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDE", static_cast<double>(0.95), &ADMSbjt504tva::Model::VDE)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-base diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PE", static_cast<double>(0.4), &ADMSbjt504tva::Model::PE)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-base grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJE", static_cast<double>(0.4), &ADMSbjt504tva::Model::XCJE)
    .setUnit(U_UNKNOWN)
    .setDescription("Sidewall fraction of the emitter-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEO", static_cast<double>(0.0), &ADMSbjt504tva::Model::CBEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-base overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJC", static_cast<double>(78.0*1.0e-15), &ADMSbjt504tva::Model::CJC)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias collector-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDC", static_cast<double>(0.68), &ADMSbjt504tva::Model::VDC)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-base diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PC", static_cast<double>(0.5), &ADMSbjt504tva::Model::PC)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-base grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XP", static_cast<double>(0.35), &ADMSbjt504tva::Model::XP)
    .setUnit(U_UNKNOWN)
    .setDescription("Constant part of Cjc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MC", static_cast<double>(0.5), &ADMSbjt504tva::Model::MC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for current modulation of CB depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJC", static_cast<double>(32.0*1.0e-3), &ADMSbjt504tva::Model::XCJC)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of CB depletion capacitance under the emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCBLX", static_cast<double>(0.0), &ADMSbjt504tva::Model::RCBLX)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance Collector Buried Layer eXtrinsic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCBLI", static_cast<double>(0.0), &ADMSbjt504tva::Model::RCBLI)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance Collector Buried Layer Intrinsic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCO", static_cast<double>(0.0), &ADMSbjt504tva::Model::CBCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-base overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTAU", static_cast<double>(1.0), &ADMSbjt504tva::Model::MTAU)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor of the emitter stored charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUE", static_cast<double>(2.0*1.0e-12), &ADMSbjt504tva::Model::TAUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimum transit time of stored emitter charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUB", static_cast<double>(4.2*1.0e-12), &ADMSbjt504tva::Model::TAUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Transit time of stored base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEPI", static_cast<double>(41.0*1.0e-12), &ADMSbjt504tva::Model::TEPI)
    .setUnit(U_UNKNOWN)
    .setDescription("Transit time of stored epilayer charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUR", static_cast<double>(520.0*1.0e-12), &ADMSbjt504tva::Model::TAUR)
    .setUnit(U_UNKNOWN)
    .setDescription("Transit time of reverse extrinsic stored base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DEG", static_cast<double>(0.0), &ADMSbjt504tva::Model::DEG)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap difference over the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XREC", static_cast<double>(0.0), &ADMSbjt504tva::Model::XREC)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-factor of the recombination part of Ib1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XQB", static_cast<double>(0.33333333333333333333), &ADMSbjt504tva::Model::XQB)
    .setUnit(U_UNKNOWN)
    .setDescription("Emitter-fraction of base diffusion charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AQBO", static_cast<double>(0.3), &ADMSbjt504tva::Model::AQBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the zero-bias base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AE", static_cast<double>(0.0), &ADMSbjt504tva::Model::AE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AB", static_cast<double>(1.0), &ADMSbjt504tva::Model::AB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEPI", static_cast<double>(2.5), &ADMSbjt504tva::Model::AEPI)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEX", static_cast<double>(0.62), &ADMSbjt504tva::Model::AEX)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the extrinsic base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AC", static_cast<double>(2.0), &ADMSbjt504tva::Model::AC)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the collector contact")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ACBL", static_cast<double>(2.0), &ADMSbjt504tva::Model::ACBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the resistivity of the collector buried layer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBF", static_cast<double>(50.0*1.0e-3), &ADMSbjt504tva::Model::DVGBF)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage difference of the forward current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBR", static_cast<double>(45.0*1.0e-3), &ADMSbjt504tva::Model::DVGBR)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage difference of the reverse current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGB", static_cast<double>(1.17), &ADMSbjt504tva::Model::VGB)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage of the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGC", static_cast<double>(1.18), &ADMSbjt504tva::Model::VGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage of the collector")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGJ", static_cast<double>(1.15), &ADMSbjt504tva::Model::VGJ)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage recombination emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGZEB", static_cast<double>(1.15), &ADMSbjt504tva::Model::VGZEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage at Tref of Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVGEB", static_cast<double>(4.73e-4), &ADMSbjt504tva::Model::AVGEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient band-gap voltage for Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVGEB", static_cast<double>(636.0), &ADMSbjt504tva::Model::TVGEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient band-gap voltage for Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGTE", static_cast<double>(0.05), &ADMSbjt504tva::Model::DVGTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage difference of emitter stored charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DAIS", static_cast<double>(0.0), &ADMSbjt504tva::Model::DAIS)
    .setUnit(U_UNKNOWN)
    .setDescription("Fine tuning of temperature dependence of C-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AF", static_cast<double>(2.0), &ADMSbjt504tva::Model::AF)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent of the Flicker-noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KF", static_cast<double>(20.0*1.0e-12), &ADMSbjt504tva::Model::KF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker-noise coefficient of the ideal base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KFN", static_cast<double>(20.0*1.0e-12), &ADMSbjt504tva::Model::KFN)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker-noise coefficient of the non-ideal base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KAVL", static_cast<int>(0), &ADMSbjt504tva::Model::KAVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Switch for white noise contribution due to avalanche");
  p.addPar("KC", static_cast<int>(0), &ADMSbjt504tva::Model::KC)
    .setUnit(U_UNKNOWN)
    .setDescription("Switch for RF correlation noise model selection");
  p.addPar("KE", static_cast<double>(0.0), &ADMSbjt504tva::Model::KE)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of QE in excess phase shift")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FTAUN", static_cast<double>(0.0), &ADMSbjt504tva::Model::FTAUN)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of noise transit time to total transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISS", static_cast<double>(48.0*1.0e-18), &ADMSbjt504tva::Model::ISS)
    .setUnit(U_UNKNOWN)
    .setDescription("Base-substrate saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ICSS", static_cast<double>((-1.0)), &ADMSbjt504tva::Model::ICSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-substrate ideal saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKS", static_cast<double>(250.0*1.0e-6), &ADMSbjt504tva::Model::IKS)
    .setUnit(U_UNKNOWN)
    .setDescription("Base-substrate high injection knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS", static_cast<double>(315.0*1.0e-15), &ADMSbjt504tva::Model::CJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-bias collector-substrate depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDS", static_cast<double>(0.62), &ADMSbjt504tva::Model::VDS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-substrate diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(0.34), &ADMSbjt504tva::Model::PS)
    .setUnit(U_UNKNOWN)
    .setDescription("Collector-substrate grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGS", static_cast<double>(1.20), &ADMSbjt504tva::Model::VGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Band-gap voltage of the substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AS", static_cast<double>(1.58), &ADMSbjt504tva::Model::AS)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASUB", static_cast<double>(2.0), &ADMSbjt504tva::Model::ASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for mobility of minorities in the substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH", static_cast<double>(300.0), &ADMSbjt504tva::Model::RTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(3.0*1.0e-9), &ADMSbjt504tva::Model::CTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ATH", static_cast<double>(0.0), &ADMSbjt504tva::Model::ATH)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient of the thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSbjt504tva::Model::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Multiplication factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSbjt504tva::Model::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>(1), &ADMSbjt504tva::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for NPN (1) or PNP (-1) transistor type");
  p.addPar("GMIN", static_cast<double>(1.0e-13), &ADMSbjt504tva::Model::GMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimum conductance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("MULT")))
  {
    MULT = model_.MULT;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter MULT : ] 0.0,  (+inf) [
  if ( (!((MULT >0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter MULT value " << MULT << " out of range ] 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double VGZEB_Tr;
  //Begin block initial_instance
  {
    if (((model_.TYPE)==1))
    {
      An = 7.03e7;
      Bn = 1.23e8;
    }
    else
    {
      An = 1.58e8;
      Bn = 2.04e8;
    }
    Xext1 = (1.0-(model_.XEXT));
    CTH_M = ((model_.CTH)*MULT);
    CBEO_M = ((model_.CBEO)*MULT);
    CBCO_M = ((model_.CBCO)*MULT);
    invMULT = (1.0/MULT);
    SCRCV_M = ((model_.SCRCV)*invMULT);
    {
      double value_pow_0 = pow(MULT,(1.0-(model_.AF)));
      KF_M = ((model_.KF)*value_pow_0);
    }
    {
      double value_pow_0 = pow(MULT,(1.0-((2.0*((model_.MLF)-1.0))+((model_.AF)*(2.0-(model_.MLF))))));
      KFN_M = ((model_.KFN)*value_pow_0);
    }
    {
      double value_pow_0 = pow(2.0,(2.0-(model_.PE)));
      pow2_2mPE = value_pow_0;
    }
    pow2_PEm2 = (1.0/pow2_2mPE);
    Trk = ((model_.TREF)+273.15);
    Tamb = (admsTemperature+(model_.DTA));

    d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 = d_dxa_dV_dt_GND =  0.0;
    dxa = ((((model_.VGZEB)+((((model_.AVGEB)*Trk)*Trk)/(Trk+(model_.TVGEB))))-0.05)/0.1);
    if ((((model_.VGZEB)+((((model_.AVGEB)*Trk)*Trk)/(Trk+(model_.TVGEB))))<0.05))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        VGZEBOK = (0.05+(0.1*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        VGZEBOK = (((model_.VGZEB)+((((model_.AVGEB)*Trk)*Trk)/(Trk+(model_.TVGEB))))+(0.1*value_log_1));
      }
    }
    VGZEBOK = VGZEBOK;
    VGZEB_Tr = (model_.VGZEB);
    inv_VGZEB_Tr = (1.0/VGZEB_Tr);
    inv_VDE = (1.0/(model_.VDE));
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    MULT(1.0),
    An(0.0),
    Bn(0.0),
    Trk(0.0),
    Tamb(0.0),
    pow2_2mPE(0.0),
    pow2_PEm2(0.0),
    inv_VDE(0.0),
    inv_VGZEB_Tr(0.0),
    VGZEBOK(0.0),
    invMULT(0.0),
    SCRCV_M(0.0),
    KF_M(0.0),
    KFN_M(0.0),
    CTH_M(0.0),
    Xext1(0.0),
    CBEO_M(0.0),
    CBCO_M(0.0),
    dxa(0.0),
    d_dxa_dV_s_c1(0.0),
    d_dxa_dV_b_c(0.0),
    d_dxa_dV_b_b1(0.0),
    d_dxa_dV_c3_c1(0.0),
    d_dxa_dV_c3_c4(0.0),
    d_dxa_dV_b1_b2(0.0),
    d_dxa_dV_c4_c1(0.0),
    d_dxa_dV_b1_e1(0.0),
    d_dxa_dV_b2_e1(0.0),
    d_dxa_dV_b2_c2(0.0),
    d_dxa_dV_b2_c1(0.0),
    d_dxa_dV_c1_c2(0.0),
    d_dxa_dV_dt_GND(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_dt(-1),
    li_e1(-1),
    li_b1(-1),
    li_b2(-1),
    li_c1(-1),
    li_c2(-1),
    li_c3(-1),
    li_c4(-1),
    li_noi(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_is(-1),
    li_branch_idt(-1),
    f_c1_Equ_c1_Node_Ptr(0),
    f_c1_Equ_c2_Node_Ptr(0),
    f_c2_Equ_c1_Node_Ptr(0),
    f_c2_Equ_c2_Node_Ptr(0),
    f_c1_Equ_b2_Node_Ptr(0),
    f_c2_Equ_b2_Node_Ptr(0),
    f_c1_Equ_dt_Node_Ptr(0),
    f_c2_Equ_dt_Node_Ptr(0),
    f_e1_Equ_c1_Node_Ptr(0),
    f_e1_Equ_c2_Node_Ptr(0),
    f_e1_Equ_b2_Node_Ptr(0),
    f_c2_Equ_e1_Node_Ptr(0),
    f_e1_Equ_e1_Node_Ptr(0),
    f_e1_Equ_dt_Node_Ptr(0),
    f_b1_Equ_b1_Node_Ptr(0),
    f_b1_Equ_e1_Node_Ptr(0),
    f_e1_Equ_b1_Node_Ptr(0),
    f_b1_Equ_dt_Node_Ptr(0),
    f_b2_Equ_b2_Node_Ptr(0),
    f_b2_Equ_e1_Node_Ptr(0),
    f_b2_Equ_dt_Node_Ptr(0),
    f_b2_Equ_c1_Node_Ptr(0),
    f_b2_Equ_c2_Node_Ptr(0),
    f_b1_Equ_s_Node_Ptr(0),
    f_b1_Equ_c1_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_c1_Node_Ptr(0),
    f_b1_Equ_c4_Node_Ptr(0),
    f_s_Equ_c4_Node_Ptr(0),
    f_b1_Equ_c2_Node_Ptr(0),
    f_s_Equ_c2_Node_Ptr(0),
    f_b1_Equ_b2_Node_Ptr(0),
    f_s_Equ_b2_Node_Ptr(0),
    f_s_Equ_b1_Node_Ptr(0),
    f_s_Equ_dt_Node_Ptr(0),
    f_b_Equ_s_Node_Ptr(0),
    f_b_Equ_c1_Node_Ptr(0),
    f_b_Equ_c2_Node_Ptr(0),
    f_b_Equ_b2_Node_Ptr(0),
    f_b_Equ_e1_Node_Ptr(0),
    f_s_Equ_e1_Node_Ptr(0),
    f_b_Equ_c3_Node_Ptr(0),
    f_b_Equ_c4_Node_Ptr(0),
    f_s_Equ_c3_Node_Ptr(0),
    f_b_Equ_b1_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_b_Equ_c_Node_Ptr(0),
    f_s_Equ_c_Node_Ptr(0),
    f_b_Equ_dt_Node_Ptr(0),
    f_c1_Equ_s_Node_Ptr(0),
    f_b1_Equ_c3_Node_Ptr(0),
    f_b2_Equ_c3_Node_Ptr(0),
    f_b2_Equ_c4_Node_Ptr(0),
    f_b1_Equ_b_Node_Ptr(0),
    f_b2_Equ_b_Node_Ptr(0),
    f_b2_Equ_b1_Node_Ptr(0),
    f_b1_Equ_c_Node_Ptr(0),
    f_b2_Equ_c_Node_Ptr(0),
    f_c2_Equ_c3_Node_Ptr(0),
    f_c2_Equ_c4_Node_Ptr(0),
    f_c2_Equ_b1_Node_Ptr(0),
    f_c2_Equ_b_Node_Ptr(0),
    f_c2_Equ_c_Node_Ptr(0),
    f_e_Equ_dt_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_e1_Node_Ptr(0),
    f_e1_Equ_e_Node_Ptr(0),
    f_dt_Equ_dt_Node_Ptr(0),
    f_dt_Equ_s_Node_Ptr(0),
    f_dt_Equ_c1_Node_Ptr(0),
    f_dt_Equ_b1_Node_Ptr(0),
    f_dt_Equ_e1_Node_Ptr(0),
    f_dt_Equ_e_Node_Ptr(0),
    f_dt_Equ_c3_Node_Ptr(0),
    f_dt_Equ_c4_Node_Ptr(0),
    f_dt_Equ_b2_Node_Ptr(0),
    f_dt_Equ_b_Node_Ptr(0),
    f_dt_Equ_c_Node_Ptr(0),
    f_dt_Equ_c2_Node_Ptr(0),
    f_e1_Equ_c3_Node_Ptr(0),
    f_e1_Equ_c4_Node_Ptr(0),
    f_e1_Equ_b_Node_Ptr(0),
    f_e1_Equ_c_Node_Ptr(0),
    f_c1_Equ_e1_Node_Ptr(0),
    f_c1_Equ_b1_Node_Ptr(0),
    f_c1_Equ_c4_Node_Ptr(0),
    f_c1_Equ_c3_Node_Ptr(0),
    f_c1_Equ_b_Node_Ptr(0),
    f_c1_Equ_c_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_c3_Equ_s_Node_Ptr(0),
    f_c3_Equ_c1_Node_Ptr(0),
    f_c3_Equ_c2_Node_Ptr(0),
    f_c3_Equ_b2_Node_Ptr(0),
    f_c3_Equ_e1_Node_Ptr(0),
    f_c3_Equ_c3_Node_Ptr(0),
    f_c3_Equ_c4_Node_Ptr(0),
    f_c3_Equ_b1_Node_Ptr(0),
    f_c3_Equ_b_Node_Ptr(0),
    f_c3_Equ_c_Node_Ptr(0),
    f_c3_Equ_dt_Node_Ptr(0),
    f_c_Equ_dt_Node_Ptr(0),
    f_c_Equ_c3_Node_Ptr(0),
    f_c_Equ_c4_Node_Ptr(0),
    f_c_Equ_c1_Node_Ptr(0),
    f_c_Equ_c2_Node_Ptr(0),
    f_c_Equ_b2_Node_Ptr(0),
    f_c_Equ_b1_Node_Ptr(0),
    f_c4_Equ_dt_Node_Ptr(0),
    f_c4_Equ_c4_Node_Ptr(0),
    f_c4_Equ_c1_Node_Ptr(0),
    f_c4_Equ_b2_Node_Ptr(0),
    f_c4_Equ_e1_Node_Ptr(0),
    f_c4_Equ_c2_Node_Ptr(0),
    f_c4_Equ_b1_Node_Ptr(0),
    f_c4_Equ_c3_Node_Ptr(0),
    f_c4_Equ_s_Node_Ptr(0),
    f_c4_Equ_b_Node_Ptr(0),
    f_c4_Equ_c_Node_Ptr(0),
    f_noi_Equ_c1_Node_Ptr(0),
    f_noi_Equ_c2_Node_Ptr(0),
    f_noi_Equ_b2_Node_Ptr(0),
    f_noi_Equ_e1_Node_Ptr(0),
    f_noi_Equ_dt_Node_Ptr(0),
    f_noi_Equ_noi_Node_Ptr(0),
    f_b2_Equ_noi_Node_Ptr(0),
    f_e1_Equ_noi_Node_Ptr(0),
    f_c2_Equ_noi_Node_Ptr(0),
    q_c1_Equ_c1_Node_Ptr(0),
    q_c1_Equ_c2_Node_Ptr(0),
    q_c2_Equ_c1_Node_Ptr(0),
    q_c2_Equ_c2_Node_Ptr(0),
    q_c1_Equ_b2_Node_Ptr(0),
    q_c2_Equ_b2_Node_Ptr(0),
    q_c1_Equ_dt_Node_Ptr(0),
    q_c2_Equ_dt_Node_Ptr(0),
    q_e1_Equ_c1_Node_Ptr(0),
    q_e1_Equ_c2_Node_Ptr(0),
    q_e1_Equ_b2_Node_Ptr(0),
    q_c2_Equ_e1_Node_Ptr(0),
    q_e1_Equ_e1_Node_Ptr(0),
    q_e1_Equ_dt_Node_Ptr(0),
    q_b1_Equ_b1_Node_Ptr(0),
    q_b1_Equ_e1_Node_Ptr(0),
    q_e1_Equ_b1_Node_Ptr(0),
    q_b1_Equ_dt_Node_Ptr(0),
    q_b2_Equ_b2_Node_Ptr(0),
    q_b2_Equ_e1_Node_Ptr(0),
    q_b2_Equ_dt_Node_Ptr(0),
    q_b2_Equ_c1_Node_Ptr(0),
    q_b2_Equ_c2_Node_Ptr(0),
    q_b1_Equ_s_Node_Ptr(0),
    q_b1_Equ_c1_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_c1_Node_Ptr(0),
    q_b1_Equ_c4_Node_Ptr(0),
    q_s_Equ_c4_Node_Ptr(0),
    q_b1_Equ_c2_Node_Ptr(0),
    q_s_Equ_c2_Node_Ptr(0),
    q_b1_Equ_b2_Node_Ptr(0),
    q_s_Equ_b2_Node_Ptr(0),
    q_s_Equ_b1_Node_Ptr(0),
    q_s_Equ_dt_Node_Ptr(0),
    q_b_Equ_s_Node_Ptr(0),
    q_b_Equ_c1_Node_Ptr(0),
    q_b_Equ_c2_Node_Ptr(0),
    q_b_Equ_b2_Node_Ptr(0),
    q_b_Equ_e1_Node_Ptr(0),
    q_s_Equ_e1_Node_Ptr(0),
    q_b_Equ_c3_Node_Ptr(0),
    q_b_Equ_c4_Node_Ptr(0),
    q_s_Equ_c3_Node_Ptr(0),
    q_b_Equ_b1_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_b_Equ_c_Node_Ptr(0),
    q_s_Equ_c_Node_Ptr(0),
    q_b_Equ_dt_Node_Ptr(0),
    q_c1_Equ_s_Node_Ptr(0),
    q_b1_Equ_c3_Node_Ptr(0),
    q_b2_Equ_c3_Node_Ptr(0),
    q_b2_Equ_c4_Node_Ptr(0),
    q_b1_Equ_b_Node_Ptr(0),
    q_b2_Equ_b_Node_Ptr(0),
    q_b2_Equ_b1_Node_Ptr(0),
    q_b1_Equ_c_Node_Ptr(0),
    q_b2_Equ_c_Node_Ptr(0),
    q_c2_Equ_c3_Node_Ptr(0),
    q_c2_Equ_c4_Node_Ptr(0),
    q_c2_Equ_b1_Node_Ptr(0),
    q_c2_Equ_b_Node_Ptr(0),
    q_c2_Equ_c_Node_Ptr(0),
    q_e_Equ_dt_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_e1_Node_Ptr(0),
    q_e1_Equ_e_Node_Ptr(0),
    q_dt_Equ_dt_Node_Ptr(0),
    q_dt_Equ_s_Node_Ptr(0),
    q_dt_Equ_c1_Node_Ptr(0),
    q_dt_Equ_b1_Node_Ptr(0),
    q_dt_Equ_e1_Node_Ptr(0),
    q_dt_Equ_e_Node_Ptr(0),
    q_dt_Equ_c3_Node_Ptr(0),
    q_dt_Equ_c4_Node_Ptr(0),
    q_dt_Equ_b2_Node_Ptr(0),
    q_dt_Equ_b_Node_Ptr(0),
    q_dt_Equ_c_Node_Ptr(0),
    q_dt_Equ_c2_Node_Ptr(0),
    q_e1_Equ_c3_Node_Ptr(0),
    q_e1_Equ_c4_Node_Ptr(0),
    q_e1_Equ_b_Node_Ptr(0),
    q_e1_Equ_c_Node_Ptr(0),
    q_c1_Equ_e1_Node_Ptr(0),
    q_c1_Equ_b1_Node_Ptr(0),
    q_c1_Equ_c4_Node_Ptr(0),
    q_c1_Equ_c3_Node_Ptr(0),
    q_c1_Equ_b_Node_Ptr(0),
    q_c1_Equ_c_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_c3_Equ_s_Node_Ptr(0),
    q_c3_Equ_c1_Node_Ptr(0),
    q_c3_Equ_c2_Node_Ptr(0),
    q_c3_Equ_b2_Node_Ptr(0),
    q_c3_Equ_e1_Node_Ptr(0),
    q_c3_Equ_c3_Node_Ptr(0),
    q_c3_Equ_c4_Node_Ptr(0),
    q_c3_Equ_b1_Node_Ptr(0),
    q_c3_Equ_b_Node_Ptr(0),
    q_c3_Equ_c_Node_Ptr(0),
    q_c3_Equ_dt_Node_Ptr(0),
    q_c_Equ_dt_Node_Ptr(0),
    q_c_Equ_c3_Node_Ptr(0),
    q_c_Equ_c4_Node_Ptr(0),
    q_c_Equ_c1_Node_Ptr(0),
    q_c_Equ_c2_Node_Ptr(0),
    q_c_Equ_b2_Node_Ptr(0),
    q_c_Equ_b1_Node_Ptr(0),
    q_c4_Equ_dt_Node_Ptr(0),
    q_c4_Equ_c4_Node_Ptr(0),
    q_c4_Equ_c1_Node_Ptr(0),
    q_c4_Equ_b2_Node_Ptr(0),
    q_c4_Equ_e1_Node_Ptr(0),
    q_c4_Equ_c2_Node_Ptr(0),
    q_c4_Equ_b1_Node_Ptr(0),
    q_c4_Equ_c3_Node_Ptr(0),
    q_c4_Equ_s_Node_Ptr(0),
    q_c4_Equ_b_Node_Ptr(0),
    q_c4_Equ_c_Node_Ptr(0),
    q_noi_Equ_c1_Node_Ptr(0),
    q_noi_Equ_c2_Node_Ptr(0),
    q_noi_Equ_b2_Node_Ptr(0),
    q_noi_Equ_e1_Node_Ptr(0),
    q_noi_Equ_dt_Node_Ptr(0),
    q_noi_Equ_noi_Node_Ptr(0),
    q_b2_Equ_noi_Node_Ptr(0),
    q_e1_Equ_noi_Node_Ptr(0),
    q_c2_Equ_noi_Node_Ptr(0),
    A_c1_Equ_c1_NodeOffset(-1),
    A_c1_Equ_c2_NodeOffset(-1),
    A_c2_Equ_c1_NodeOffset(-1),
    A_c2_Equ_c2_NodeOffset(-1),
    A_c1_Equ_b2_NodeOffset(-1),
    A_c2_Equ_b2_NodeOffset(-1),
    A_c1_Equ_dt_NodeOffset(-1),
    A_c2_Equ_dt_NodeOffset(-1),
    A_e1_Equ_c1_NodeOffset(-1),
    A_e1_Equ_c2_NodeOffset(-1),
    A_e1_Equ_b2_NodeOffset(-1),
    A_c2_Equ_e1_NodeOffset(-1),
    A_e1_Equ_e1_NodeOffset(-1),
    A_e1_Equ_dt_NodeOffset(-1),
    A_b1_Equ_b1_NodeOffset(-1),
    A_b1_Equ_e1_NodeOffset(-1),
    A_e1_Equ_b1_NodeOffset(-1),
    A_b1_Equ_dt_NodeOffset(-1),
    A_b2_Equ_b2_NodeOffset(-1),
    A_b2_Equ_e1_NodeOffset(-1),
    A_b2_Equ_dt_NodeOffset(-1),
    A_b2_Equ_c1_NodeOffset(-1),
    A_b2_Equ_c2_NodeOffset(-1),
    A_b1_Equ_s_NodeOffset(-1),
    A_b1_Equ_c1_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_c1_NodeOffset(-1),
    A_b1_Equ_c4_NodeOffset(-1),
    A_s_Equ_c4_NodeOffset(-1),
    A_b1_Equ_c2_NodeOffset(-1),
    A_s_Equ_c2_NodeOffset(-1),
    A_b1_Equ_b2_NodeOffset(-1),
    A_s_Equ_b2_NodeOffset(-1),
    A_s_Equ_b1_NodeOffset(-1),
    A_s_Equ_dt_NodeOffset(-1),
    A_b_Equ_s_NodeOffset(-1),
    A_b_Equ_c1_NodeOffset(-1),
    A_b_Equ_c2_NodeOffset(-1),
    A_b_Equ_b2_NodeOffset(-1),
    A_b_Equ_e1_NodeOffset(-1),
    A_s_Equ_e1_NodeOffset(-1),
    A_b_Equ_c3_NodeOffset(-1),
    A_b_Equ_c4_NodeOffset(-1),
    A_s_Equ_c3_NodeOffset(-1),
    A_b_Equ_b1_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_b_Equ_c_NodeOffset(-1),
    A_s_Equ_c_NodeOffset(-1),
    A_b_Equ_dt_NodeOffset(-1),
    A_c1_Equ_s_NodeOffset(-1),
    A_b1_Equ_c3_NodeOffset(-1),
    A_b2_Equ_c3_NodeOffset(-1),
    A_b2_Equ_c4_NodeOffset(-1),
    A_b1_Equ_b_NodeOffset(-1),
    A_b2_Equ_b_NodeOffset(-1),
    A_b2_Equ_b1_NodeOffset(-1),
    A_b1_Equ_c_NodeOffset(-1),
    A_b2_Equ_c_NodeOffset(-1),
    A_c2_Equ_c3_NodeOffset(-1),
    A_c2_Equ_c4_NodeOffset(-1),
    A_c2_Equ_b1_NodeOffset(-1),
    A_c2_Equ_b_NodeOffset(-1),
    A_c2_Equ_c_NodeOffset(-1),
    A_e_Equ_dt_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_e1_NodeOffset(-1),
    A_e1_Equ_e_NodeOffset(-1),
    A_dt_Equ_dt_NodeOffset(-1),
    A_dt_Equ_s_NodeOffset(-1),
    A_dt_Equ_c1_NodeOffset(-1),
    A_dt_Equ_b1_NodeOffset(-1),
    A_dt_Equ_e1_NodeOffset(-1),
    A_dt_Equ_e_NodeOffset(-1),
    A_dt_Equ_c3_NodeOffset(-1),
    A_dt_Equ_c4_NodeOffset(-1),
    A_dt_Equ_b2_NodeOffset(-1),
    A_dt_Equ_b_NodeOffset(-1),
    A_dt_Equ_c_NodeOffset(-1),
    A_dt_Equ_c2_NodeOffset(-1),
    A_e1_Equ_c3_NodeOffset(-1),
    A_e1_Equ_c4_NodeOffset(-1),
    A_e1_Equ_b_NodeOffset(-1),
    A_e1_Equ_c_NodeOffset(-1),
    A_c1_Equ_e1_NodeOffset(-1),
    A_c1_Equ_b1_NodeOffset(-1),
    A_c1_Equ_c4_NodeOffset(-1),
    A_c1_Equ_c3_NodeOffset(-1),
    A_c1_Equ_b_NodeOffset(-1),
    A_c1_Equ_c_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_c3_Equ_s_NodeOffset(-1),
    A_c3_Equ_c1_NodeOffset(-1),
    A_c3_Equ_c2_NodeOffset(-1),
    A_c3_Equ_b2_NodeOffset(-1),
    A_c3_Equ_e1_NodeOffset(-1),
    A_c3_Equ_c3_NodeOffset(-1),
    A_c3_Equ_c4_NodeOffset(-1),
    A_c3_Equ_b1_NodeOffset(-1),
    A_c3_Equ_b_NodeOffset(-1),
    A_c3_Equ_c_NodeOffset(-1),
    A_c3_Equ_dt_NodeOffset(-1),
    A_c_Equ_dt_NodeOffset(-1),
    A_c_Equ_c3_NodeOffset(-1),
    A_c_Equ_c4_NodeOffset(-1),
    A_c_Equ_c1_NodeOffset(-1),
    A_c_Equ_c2_NodeOffset(-1),
    A_c_Equ_b2_NodeOffset(-1),
    A_c_Equ_b1_NodeOffset(-1),
    A_c4_Equ_dt_NodeOffset(-1),
    A_c4_Equ_c4_NodeOffset(-1),
    A_c4_Equ_c1_NodeOffset(-1),
    A_c4_Equ_b2_NodeOffset(-1),
    A_c4_Equ_e1_NodeOffset(-1),
    A_c4_Equ_c2_NodeOffset(-1),
    A_c4_Equ_b1_NodeOffset(-1),
    A_c4_Equ_c3_NodeOffset(-1),
    A_c4_Equ_s_NodeOffset(-1),
    A_c4_Equ_b_NodeOffset(-1),
    A_c4_Equ_c_NodeOffset(-1),
    A_noi_Equ_c1_NodeOffset(-1),
    A_noi_Equ_c2_NodeOffset(-1),
    A_noi_Equ_b2_NodeOffset(-1),
    A_noi_Equ_e1_NodeOffset(-1),
    A_noi_Equ_dt_NodeOffset(-1),
    A_noi_Equ_noi_NodeOffset(-1),
    A_b2_Equ_noi_NodeOffset(-1),
    A_e1_Equ_noi_NodeOffset(-1),
    A_c2_Equ_noi_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 8 + 0;
  numExtVars = 5;


  // Right now, we only have store for limited probes...
  setNumStoreVars(4);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 5;

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_noi));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_c1)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_c1,admsNodeID_c4));
  }
  if (collapseNode_c4)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_c4,admsNodeID_c3));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 13+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_c1 = false;
  collapseNode_c4 = false;
  if (((model_.RCBLX)>0.0))
  {

    if (!(((model_.RCBLI)>0.0)))
    {

      collapseNode_c1 = true;

    }

  }

  else
  {

    collapseNode_c4 = true;

    if (!(((model_.RCBLI)>0.0)))
    {

      collapseNode_c1 = true;

    }

  }


  if (collapseNode_c1)
  {
    numIntVars--;
  }
  if (collapseNode_c4)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbjt504tva::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_dt = localLIDVec[nodeMap[admsNodeID_dt]];
  li_e1 = localLIDVec[nodeMap[admsNodeID_e1]];
  li_b1 = localLIDVec[nodeMap[admsNodeID_b1]];
  li_b2 = localLIDVec[nodeMap[admsNodeID_b2]];
  li_c1 = localLIDVec[nodeMap[admsNodeID_c1]];
  li_c2 = localLIDVec[nodeMap[admsNodeID_c2]];
  li_c3 = localLIDVec[nodeMap[admsNodeID_c3]];
  li_c4 = localLIDVec[nodeMap[admsNodeID_c4]];
  li_noi = localLIDVec[nodeMap[admsNodeID_noi]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_dt = " << li_dt << std::endl;
    Xyce::dout() << "\nli_e1 = " << li_e1 << std::endl;
    Xyce::dout() << "\nli_b1 = " << li_b1 << std::endl;
    Xyce::dout() << "\nli_b2 = " << li_b2 << std::endl;
    Xyce::dout() << "\nli_c1 = " << li_c1 << std::endl;
    Xyce::dout() << "\nli_c2 = " << li_c2 << std::endl;
    Xyce::dout() << "\nli_c3 = " << li_c3 << std::endl;
    Xyce::dout() << "\nli_c4 = " << li_c4 << std::endl;
    Xyce::dout() << "\nli_noi = " << li_noi << std::endl;

    Xyce::dout() << "\nEnd of ADMSbjt504tva::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_e1, getName(), "e1");
  addInternalNode(symbol_table, li_b1, getName(), "b1");
  addInternalNode(symbol_table, li_b2, getName(), "b2");
  if (!collapseNode_c1)
  {
    addInternalNode(symbol_table, li_c1, getName(), "c1");
  }
  addInternalNode(symbol_table, li_c2, getName(), "c2");
  addInternalNode(symbol_table, li_c3, getName(), "c3");
  if (!collapseNode_c4)
  {
    addInternalNode(symbol_table, li_c4, getName(), "c4");
  }
  addInternalNode(symbol_table, li_noi, getName(), "noi");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_D4");
    addBranchDataNode( symbol_table, li_branch_idt, getName(), "BRANCH_D5");
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

    li_store_admsProbeID_V_b2_c1 = stoLIDVec[i++];
    li_store_admsProbeID_V_b2_c2 = stoLIDVec[i++];
    li_store_admsProbeID_V_b1_e1 = stoLIDVec[i++];
    li_store_admsProbeID_V_b1_b2 = stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_idt = branchLIDVecRef[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_dt)];
  A_c_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c3)];
  A_c_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c4)];
  A_c_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c1)];
  A_c_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c2)];
  A_c_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b2)];
  A_c_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b1)];
  A_c_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_s)];
  A_b_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c1)];
  A_b_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c2)];
  A_b_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b2)];
  A_b_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e1)];
  A_b_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c3)];
  A_b_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c4)];
  A_b_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b1)];
  A_b_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c)];
  A_b_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dt)];
  A_b_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_dt)];
  A_e_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e1)];
  A_e_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c1)];
  A_s_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c4)];
  A_s_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c2)];
  A_s_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b2)];
  A_s_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b1)];
  A_s_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_dt)];
  A_s_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_e1)];
  A_s_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c3)];
  A_s_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
  A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c)];
  A_s_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_dt)];
  A_dt_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_s)];
  A_dt_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c1)];
  A_dt_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b1)];
  A_dt_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_e1)];
  A_dt_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_e)];
  A_dt_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c3)];
  A_dt_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c4)];
  A_dt_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b2)];
  A_dt_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b)];
  A_dt_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c)];
  A_dt_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_c2)];
  A_dt_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c1)];
  A_e1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c2)];
  A_e1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b2)];
  A_e1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_e1)];
  A_e1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_dt)];
  A_e1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b1)];
  A_e1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_e)];
  A_e1_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c3)];
  A_e1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c4)];
  A_e1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b)];
  A_e1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c)];
  A_e1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_noi)];
  A_e1_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b1)];
  A_b1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_e1)];
  A_b1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_dt)];
  A_b1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_s)];
  A_b1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c1)];
  A_b1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c4)];
  A_b1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c2)];
  A_b1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b2)];
  A_b1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c3)];
  A_b1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b)];
  A_b1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c)];
  A_b1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b2)];
  A_b2_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_e1)];
  A_b2_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_dt)];
  A_b2_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c1)];
  A_b2_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c2)];
  A_b2_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c3)];
  A_b2_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c4)];
  A_b2_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b)];
  A_b2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b1)];
  A_b2_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c)];
  A_b2_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_noi)];
  A_b2_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c1)];
  A_c1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c2)];
  A_c1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b2)];
  A_c1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_dt)];
  A_c1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_s)];
  A_c1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_e1)];
  A_c1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b1)];
  A_c1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c4)];
  A_c1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c3)];
  A_c1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b)];
  A_c1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c)];
  A_c1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c1)];
  A_c2_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c2)];
  A_c2_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b2)];
  A_c2_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_dt)];
  A_c2_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_e1)];
  A_c2_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c3)];
  A_c2_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c4)];
  A_c2_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b1)];
  A_c2_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b)];
  A_c2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c)];
  A_c2_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_noi)];
  A_c2_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_s)];
  A_c3_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c1)];
  A_c3_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c2)];
  A_c3_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b2)];
  A_c3_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_e1)];
  A_c3_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c3)];
  A_c3_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c4)];
  A_c3_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b1)];
  A_c3_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b)];
  A_c3_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c)];
  A_c3_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_dt)];
  A_c3_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_dt)];
  A_c4_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c4)];
  A_c4_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c1)];
  A_c4_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b2)];
  A_c4_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_e1)];
  A_c4_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c2)];
  A_c4_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b1)];
  A_c4_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c3)];
  A_c4_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_s)];
  A_c4_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b)];
  A_c4_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c)];
  A_c4_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_c1)];
  A_noi_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_c2)];
  A_noi_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_b2)];
  A_noi_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_e1)];
  A_noi_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_dt)];
  A_noi_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_noi)];
  A_noi_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
  f_c_Equ_b_Node_Ptr = &(dFdx[li_c][A_c_Equ_b_NodeOffset]);
  q_c_Equ_b_Node_Ptr = &(dQdx[li_c][A_c_Equ_b_NodeOffset]);
  f_c_Equ_c_Node_Ptr = &(dFdx[li_c][A_c_Equ_c_NodeOffset]);
  q_c_Equ_c_Node_Ptr = &(dQdx[li_c][A_c_Equ_c_NodeOffset]);
  f_c_Equ_dt_Node_Ptr = &(dFdx[li_c][A_c_Equ_dt_NodeOffset]);
  q_c_Equ_dt_Node_Ptr = &(dQdx[li_c][A_c_Equ_dt_NodeOffset]);
  f_c_Equ_c3_Node_Ptr = &(dFdx[li_c][A_c_Equ_c3_NodeOffset]);
  q_c_Equ_c3_Node_Ptr = &(dQdx[li_c][A_c_Equ_c3_NodeOffset]);
  f_c_Equ_c4_Node_Ptr = &(dFdx[li_c][A_c_Equ_c4_NodeOffset]);
  q_c_Equ_c4_Node_Ptr = &(dQdx[li_c][A_c_Equ_c4_NodeOffset]);
  f_c_Equ_c1_Node_Ptr = &(dFdx[li_c][A_c_Equ_c1_NodeOffset]);
  q_c_Equ_c1_Node_Ptr = &(dQdx[li_c][A_c_Equ_c1_NodeOffset]);
  f_c_Equ_c2_Node_Ptr = &(dFdx[li_c][A_c_Equ_c2_NodeOffset]);
  q_c_Equ_c2_Node_Ptr = &(dQdx[li_c][A_c_Equ_c2_NodeOffset]);
  f_c_Equ_b2_Node_Ptr = &(dFdx[li_c][A_c_Equ_b2_NodeOffset]);
  q_c_Equ_b2_Node_Ptr = &(dQdx[li_c][A_c_Equ_b2_NodeOffset]);
  f_c_Equ_b1_Node_Ptr = &(dFdx[li_c][A_c_Equ_b1_NodeOffset]);
  q_c_Equ_b1_Node_Ptr = &(dQdx[li_c][A_c_Equ_b1_NodeOffset]);
  f_b_Equ_s_Node_Ptr = &(dFdx[li_b][A_b_Equ_s_NodeOffset]);
  q_b_Equ_s_Node_Ptr = &(dQdx[li_b][A_b_Equ_s_NodeOffset]);
  f_b_Equ_c1_Node_Ptr = &(dFdx[li_b][A_b_Equ_c1_NodeOffset]);
  q_b_Equ_c1_Node_Ptr = &(dQdx[li_b][A_b_Equ_c1_NodeOffset]);
  f_b_Equ_c2_Node_Ptr = &(dFdx[li_b][A_b_Equ_c2_NodeOffset]);
  q_b_Equ_c2_Node_Ptr = &(dQdx[li_b][A_b_Equ_c2_NodeOffset]);
  f_b_Equ_b2_Node_Ptr = &(dFdx[li_b][A_b_Equ_b2_NodeOffset]);
  q_b_Equ_b2_Node_Ptr = &(dQdx[li_b][A_b_Equ_b2_NodeOffset]);
  f_b_Equ_e1_Node_Ptr = &(dFdx[li_b][A_b_Equ_e1_NodeOffset]);
  q_b_Equ_e1_Node_Ptr = &(dQdx[li_b][A_b_Equ_e1_NodeOffset]);
  f_b_Equ_c3_Node_Ptr = &(dFdx[li_b][A_b_Equ_c3_NodeOffset]);
  q_b_Equ_c3_Node_Ptr = &(dQdx[li_b][A_b_Equ_c3_NodeOffset]);
  f_b_Equ_c4_Node_Ptr = &(dFdx[li_b][A_b_Equ_c4_NodeOffset]);
  q_b_Equ_c4_Node_Ptr = &(dQdx[li_b][A_b_Equ_c4_NodeOffset]);
  f_b_Equ_b1_Node_Ptr = &(dFdx[li_b][A_b_Equ_b1_NodeOffset]);
  q_b_Equ_b1_Node_Ptr = &(dQdx[li_b][A_b_Equ_b1_NodeOffset]);
  f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
  q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
  f_b_Equ_c_Node_Ptr = &(dFdx[li_b][A_b_Equ_c_NodeOffset]);
  q_b_Equ_c_Node_Ptr = &(dQdx[li_b][A_b_Equ_c_NodeOffset]);
  f_b_Equ_dt_Node_Ptr = &(dFdx[li_b][A_b_Equ_dt_NodeOffset]);
  q_b_Equ_dt_Node_Ptr = &(dQdx[li_b][A_b_Equ_dt_NodeOffset]);
  f_b_Equ_e_Node_Ptr = &(dFdx[li_b][A_b_Equ_e_NodeOffset]);
  q_b_Equ_e_Node_Ptr = &(dQdx[li_b][A_b_Equ_e_NodeOffset]);
  f_e_Equ_dt_Node_Ptr = &(dFdx[li_e][A_e_Equ_dt_NodeOffset]);
  q_e_Equ_dt_Node_Ptr = &(dQdx[li_e][A_e_Equ_dt_NodeOffset]);
  f_e_Equ_e_Node_Ptr = &(dFdx[li_e][A_e_Equ_e_NodeOffset]);
  q_e_Equ_e_Node_Ptr = &(dQdx[li_e][A_e_Equ_e_NodeOffset]);
  f_e_Equ_e1_Node_Ptr = &(dFdx[li_e][A_e_Equ_e1_NodeOffset]);
  q_e_Equ_e1_Node_Ptr = &(dQdx[li_e][A_e_Equ_e1_NodeOffset]);
  f_e_Equ_b_Node_Ptr = &(dFdx[li_e][A_e_Equ_b_NodeOffset]);
  q_e_Equ_b_Node_Ptr = &(dQdx[li_e][A_e_Equ_b_NodeOffset]);
  f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
  q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
  f_s_Equ_c1_Node_Ptr = &(dFdx[li_s][A_s_Equ_c1_NodeOffset]);
  q_s_Equ_c1_Node_Ptr = &(dQdx[li_s][A_s_Equ_c1_NodeOffset]);
  f_s_Equ_c4_Node_Ptr = &(dFdx[li_s][A_s_Equ_c4_NodeOffset]);
  q_s_Equ_c4_Node_Ptr = &(dQdx[li_s][A_s_Equ_c4_NodeOffset]);
  f_s_Equ_c2_Node_Ptr = &(dFdx[li_s][A_s_Equ_c2_NodeOffset]);
  q_s_Equ_c2_Node_Ptr = &(dQdx[li_s][A_s_Equ_c2_NodeOffset]);
  f_s_Equ_b2_Node_Ptr = &(dFdx[li_s][A_s_Equ_b2_NodeOffset]);
  q_s_Equ_b2_Node_Ptr = &(dQdx[li_s][A_s_Equ_b2_NodeOffset]);
  f_s_Equ_b1_Node_Ptr = &(dFdx[li_s][A_s_Equ_b1_NodeOffset]);
  q_s_Equ_b1_Node_Ptr = &(dQdx[li_s][A_s_Equ_b1_NodeOffset]);
  f_s_Equ_dt_Node_Ptr = &(dFdx[li_s][A_s_Equ_dt_NodeOffset]);
  q_s_Equ_dt_Node_Ptr = &(dQdx[li_s][A_s_Equ_dt_NodeOffset]);
  f_s_Equ_e1_Node_Ptr = &(dFdx[li_s][A_s_Equ_e1_NodeOffset]);
  q_s_Equ_e1_Node_Ptr = &(dQdx[li_s][A_s_Equ_e1_NodeOffset]);
  f_s_Equ_c3_Node_Ptr = &(dFdx[li_s][A_s_Equ_c3_NodeOffset]);
  q_s_Equ_c3_Node_Ptr = &(dQdx[li_s][A_s_Equ_c3_NodeOffset]);
  f_s_Equ_b_Node_Ptr = &(dFdx[li_s][A_s_Equ_b_NodeOffset]);
  q_s_Equ_b_Node_Ptr = &(dQdx[li_s][A_s_Equ_b_NodeOffset]);
  f_s_Equ_c_Node_Ptr = &(dFdx[li_s][A_s_Equ_c_NodeOffset]);
  q_s_Equ_c_Node_Ptr = &(dQdx[li_s][A_s_Equ_c_NodeOffset]);
  f_dt_Equ_dt_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_dt_NodeOffset]);
  q_dt_Equ_dt_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_dt_NodeOffset]);
  f_dt_Equ_s_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_s_NodeOffset]);
  q_dt_Equ_s_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_s_NodeOffset]);
  f_dt_Equ_c1_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_c1_NodeOffset]);
  q_dt_Equ_c1_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_c1_NodeOffset]);
  f_dt_Equ_b1_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_b1_NodeOffset]);
  q_dt_Equ_b1_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_b1_NodeOffset]);
  f_dt_Equ_e1_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_e1_NodeOffset]);
  q_dt_Equ_e1_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_e1_NodeOffset]);
  f_dt_Equ_e_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_e_NodeOffset]);
  q_dt_Equ_e_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_e_NodeOffset]);
  f_dt_Equ_c3_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_c3_NodeOffset]);
  q_dt_Equ_c3_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_c3_NodeOffset]);
  f_dt_Equ_c4_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_c4_NodeOffset]);
  q_dt_Equ_c4_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_c4_NodeOffset]);
  f_dt_Equ_b2_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_b2_NodeOffset]);
  q_dt_Equ_b2_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_b2_NodeOffset]);
  f_dt_Equ_b_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_b_NodeOffset]);
  q_dt_Equ_b_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_b_NodeOffset]);
  f_dt_Equ_c_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_c_NodeOffset]);
  q_dt_Equ_c_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_c_NodeOffset]);
  f_dt_Equ_c2_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_c2_NodeOffset]);
  q_dt_Equ_c2_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_c2_NodeOffset]);
  f_e1_Equ_c1_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_c1_NodeOffset]);
  q_e1_Equ_c1_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_c1_NodeOffset]);
  f_e1_Equ_c2_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_c2_NodeOffset]);
  q_e1_Equ_c2_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_c2_NodeOffset]);
  f_e1_Equ_b2_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_b2_NodeOffset]);
  q_e1_Equ_b2_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_b2_NodeOffset]);
  f_e1_Equ_e1_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_e1_NodeOffset]);
  q_e1_Equ_e1_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_e1_NodeOffset]);
  f_e1_Equ_dt_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_dt_NodeOffset]);
  q_e1_Equ_dt_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_dt_NodeOffset]);
  f_e1_Equ_b1_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_b1_NodeOffset]);
  q_e1_Equ_b1_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_b1_NodeOffset]);
  f_e1_Equ_e_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_e_NodeOffset]);
  q_e1_Equ_e_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_e_NodeOffset]);
  f_e1_Equ_c3_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_c3_NodeOffset]);
  q_e1_Equ_c3_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_c3_NodeOffset]);
  f_e1_Equ_c4_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_c4_NodeOffset]);
  q_e1_Equ_c4_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_c4_NodeOffset]);
  f_e1_Equ_b_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_b_NodeOffset]);
  q_e1_Equ_b_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_b_NodeOffset]);
  f_e1_Equ_c_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_c_NodeOffset]);
  q_e1_Equ_c_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_c_NodeOffset]);
  f_e1_Equ_noi_Node_Ptr = &(dFdx[li_e1][A_e1_Equ_noi_NodeOffset]);
  q_e1_Equ_noi_Node_Ptr = &(dQdx[li_e1][A_e1_Equ_noi_NodeOffset]);
  f_b1_Equ_b1_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_b1_NodeOffset]);
  q_b1_Equ_b1_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_b1_NodeOffset]);
  f_b1_Equ_e1_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_e1_NodeOffset]);
  q_b1_Equ_e1_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_e1_NodeOffset]);
  f_b1_Equ_dt_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_dt_NodeOffset]);
  q_b1_Equ_dt_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_dt_NodeOffset]);
  f_b1_Equ_s_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_s_NodeOffset]);
  q_b1_Equ_s_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_s_NodeOffset]);
  f_b1_Equ_c1_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_c1_NodeOffset]);
  q_b1_Equ_c1_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_c1_NodeOffset]);
  f_b1_Equ_c4_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_c4_NodeOffset]);
  q_b1_Equ_c4_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_c4_NodeOffset]);
  f_b1_Equ_c2_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_c2_NodeOffset]);
  q_b1_Equ_c2_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_c2_NodeOffset]);
  f_b1_Equ_b2_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_b2_NodeOffset]);
  q_b1_Equ_b2_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_b2_NodeOffset]);
  f_b1_Equ_c3_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_c3_NodeOffset]);
  q_b1_Equ_c3_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_c3_NodeOffset]);
  f_b1_Equ_b_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_b_NodeOffset]);
  q_b1_Equ_b_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_b_NodeOffset]);
  f_b1_Equ_c_Node_Ptr = &(dFdx[li_b1][A_b1_Equ_c_NodeOffset]);
  q_b1_Equ_c_Node_Ptr = &(dQdx[li_b1][A_b1_Equ_c_NodeOffset]);
  f_b2_Equ_b2_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_b2_NodeOffset]);
  q_b2_Equ_b2_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_b2_NodeOffset]);
  f_b2_Equ_e1_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_e1_NodeOffset]);
  q_b2_Equ_e1_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_e1_NodeOffset]);
  f_b2_Equ_dt_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_dt_NodeOffset]);
  q_b2_Equ_dt_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_dt_NodeOffset]);
  f_b2_Equ_c1_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_c1_NodeOffset]);
  q_b2_Equ_c1_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_c1_NodeOffset]);
  f_b2_Equ_c2_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_c2_NodeOffset]);
  q_b2_Equ_c2_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_c2_NodeOffset]);
  f_b2_Equ_c3_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_c3_NodeOffset]);
  q_b2_Equ_c3_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_c3_NodeOffset]);
  f_b2_Equ_c4_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_c4_NodeOffset]);
  q_b2_Equ_c4_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_c4_NodeOffset]);
  f_b2_Equ_b_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_b_NodeOffset]);
  q_b2_Equ_b_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_b_NodeOffset]);
  f_b2_Equ_b1_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_b1_NodeOffset]);
  q_b2_Equ_b1_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_b1_NodeOffset]);
  f_b2_Equ_c_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_c_NodeOffset]);
  q_b2_Equ_c_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_c_NodeOffset]);
  f_b2_Equ_noi_Node_Ptr = &(dFdx[li_b2][A_b2_Equ_noi_NodeOffset]);
  q_b2_Equ_noi_Node_Ptr = &(dQdx[li_b2][A_b2_Equ_noi_NodeOffset]);
  f_c1_Equ_c1_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_c1_NodeOffset]);
  q_c1_Equ_c1_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_c1_NodeOffset]);
  f_c1_Equ_c2_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_c2_NodeOffset]);
  q_c1_Equ_c2_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_c2_NodeOffset]);
  f_c1_Equ_b2_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_b2_NodeOffset]);
  q_c1_Equ_b2_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_b2_NodeOffset]);
  f_c1_Equ_dt_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_dt_NodeOffset]);
  q_c1_Equ_dt_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_dt_NodeOffset]);
  f_c1_Equ_s_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_s_NodeOffset]);
  q_c1_Equ_s_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_s_NodeOffset]);
  f_c1_Equ_e1_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_e1_NodeOffset]);
  q_c1_Equ_e1_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_e1_NodeOffset]);
  f_c1_Equ_b1_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_b1_NodeOffset]);
  q_c1_Equ_b1_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_b1_NodeOffset]);
  f_c1_Equ_c4_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_c4_NodeOffset]);
  q_c1_Equ_c4_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_c4_NodeOffset]);
  f_c1_Equ_c3_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_c3_NodeOffset]);
  q_c1_Equ_c3_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_c3_NodeOffset]);
  f_c1_Equ_b_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_b_NodeOffset]);
  q_c1_Equ_b_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_b_NodeOffset]);
  f_c1_Equ_c_Node_Ptr = &(dFdx[li_c1][A_c1_Equ_c_NodeOffset]);
  q_c1_Equ_c_Node_Ptr = &(dQdx[li_c1][A_c1_Equ_c_NodeOffset]);
  f_c2_Equ_c1_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_c1_NodeOffset]);
  q_c2_Equ_c1_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_c1_NodeOffset]);
  f_c2_Equ_c2_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_c2_NodeOffset]);
  q_c2_Equ_c2_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_c2_NodeOffset]);
  f_c2_Equ_b2_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_b2_NodeOffset]);
  q_c2_Equ_b2_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_b2_NodeOffset]);
  f_c2_Equ_dt_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_dt_NodeOffset]);
  q_c2_Equ_dt_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_dt_NodeOffset]);
  f_c2_Equ_e1_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_e1_NodeOffset]);
  q_c2_Equ_e1_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_e1_NodeOffset]);
  f_c2_Equ_c3_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_c3_NodeOffset]);
  q_c2_Equ_c3_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_c3_NodeOffset]);
  f_c2_Equ_c4_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_c4_NodeOffset]);
  q_c2_Equ_c4_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_c4_NodeOffset]);
  f_c2_Equ_b1_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_b1_NodeOffset]);
  q_c2_Equ_b1_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_b1_NodeOffset]);
  f_c2_Equ_b_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_b_NodeOffset]);
  q_c2_Equ_b_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_b_NodeOffset]);
  f_c2_Equ_c_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_c_NodeOffset]);
  q_c2_Equ_c_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_c_NodeOffset]);
  f_c2_Equ_noi_Node_Ptr = &(dFdx[li_c2][A_c2_Equ_noi_NodeOffset]);
  q_c2_Equ_noi_Node_Ptr = &(dQdx[li_c2][A_c2_Equ_noi_NodeOffset]);
  f_c3_Equ_s_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_s_NodeOffset]);
  q_c3_Equ_s_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_s_NodeOffset]);
  f_c3_Equ_c1_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_c1_NodeOffset]);
  q_c3_Equ_c1_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_c1_NodeOffset]);
  f_c3_Equ_c2_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_c2_NodeOffset]);
  q_c3_Equ_c2_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_c2_NodeOffset]);
  f_c3_Equ_b2_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_b2_NodeOffset]);
  q_c3_Equ_b2_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_b2_NodeOffset]);
  f_c3_Equ_e1_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_e1_NodeOffset]);
  q_c3_Equ_e1_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_e1_NodeOffset]);
  f_c3_Equ_c3_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_c3_NodeOffset]);
  q_c3_Equ_c3_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_c3_NodeOffset]);
  f_c3_Equ_c4_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_c4_NodeOffset]);
  q_c3_Equ_c4_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_c4_NodeOffset]);
  f_c3_Equ_b1_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_b1_NodeOffset]);
  q_c3_Equ_b1_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_b1_NodeOffset]);
  f_c3_Equ_b_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_b_NodeOffset]);
  q_c3_Equ_b_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_b_NodeOffset]);
  f_c3_Equ_c_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_c_NodeOffset]);
  q_c3_Equ_c_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_c_NodeOffset]);
  f_c3_Equ_dt_Node_Ptr = &(dFdx[li_c3][A_c3_Equ_dt_NodeOffset]);
  q_c3_Equ_dt_Node_Ptr = &(dQdx[li_c3][A_c3_Equ_dt_NodeOffset]);
  f_c4_Equ_dt_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_dt_NodeOffset]);
  q_c4_Equ_dt_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_dt_NodeOffset]);
  f_c4_Equ_c4_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_c4_NodeOffset]);
  q_c4_Equ_c4_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_c4_NodeOffset]);
  f_c4_Equ_c1_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_c1_NodeOffset]);
  q_c4_Equ_c1_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_c1_NodeOffset]);
  f_c4_Equ_b2_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_b2_NodeOffset]);
  q_c4_Equ_b2_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_b2_NodeOffset]);
  f_c4_Equ_e1_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_e1_NodeOffset]);
  q_c4_Equ_e1_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_e1_NodeOffset]);
  f_c4_Equ_c2_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_c2_NodeOffset]);
  q_c4_Equ_c2_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_c2_NodeOffset]);
  f_c4_Equ_b1_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_b1_NodeOffset]);
  q_c4_Equ_b1_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_b1_NodeOffset]);
  f_c4_Equ_c3_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_c3_NodeOffset]);
  q_c4_Equ_c3_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_c3_NodeOffset]);
  f_c4_Equ_s_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_s_NodeOffset]);
  q_c4_Equ_s_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_s_NodeOffset]);
  f_c4_Equ_b_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_b_NodeOffset]);
  q_c4_Equ_b_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_b_NodeOffset]);
  f_c4_Equ_c_Node_Ptr = &(dFdx[li_c4][A_c4_Equ_c_NodeOffset]);
  q_c4_Equ_c_Node_Ptr = &(dQdx[li_c4][A_c4_Equ_c_NodeOffset]);
  f_noi_Equ_c1_Node_Ptr = &(dFdx[li_noi][A_noi_Equ_c1_NodeOffset]);
  q_noi_Equ_c1_Node_Ptr = &(dQdx[li_noi][A_noi_Equ_c1_NodeOffset]);
  f_noi_Equ_c2_Node_Ptr = &(dFdx[li_noi][A_noi_Equ_c2_NodeOffset]);
  q_noi_Equ_c2_Node_Ptr = &(dQdx[li_noi][A_noi_Equ_c2_NodeOffset]);
  f_noi_Equ_b2_Node_Ptr = &(dFdx[li_noi][A_noi_Equ_b2_NodeOffset]);
  q_noi_Equ_b2_Node_Ptr = &(dQdx[li_noi][A_noi_Equ_b2_NodeOffset]);
  f_noi_Equ_e1_Node_Ptr = &(dFdx[li_noi][A_noi_Equ_e1_NodeOffset]);
  q_noi_Equ_e1_Node_Ptr = &(dQdx[li_noi][A_noi_Equ_e1_NodeOffset]);
  f_noi_Equ_dt_Node_Ptr = &(dFdx[li_noi][A_noi_Equ_dt_NodeOffset]);
  q_noi_Equ_dt_Node_Ptr = &(dQdx[li_noi][A_noi_Equ_dt_NodeOffset]);
  f_noi_Equ_noi_Node_Ptr = &(dFdx[li_noi][A_noi_Equ_noi_NodeOffset]);
  q_noi_Equ_noi_Node_Ptr = &(dQdx[li_noi][A_noi_Equ_noi_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c];
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b];
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e];
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s];
  (*extData.daeFVectorPtr)[li_dt] += staticContributions[admsNodeID_dt];
  (*extData.daeFVectorPtr)[li_e1] += staticContributions[admsNodeID_e1];
  (*extData.daeFVectorPtr)[li_b1] += staticContributions[admsNodeID_b1];
  (*extData.daeFVectorPtr)[li_b2] += staticContributions[admsNodeID_b2];
  (*extData.daeFVectorPtr)[li_c1] += staticContributions[admsNodeID_c1];
  (*extData.daeFVectorPtr)[li_c2] += staticContributions[admsNodeID_c2];
  (*extData.daeFVectorPtr)[li_c3] += staticContributions[admsNodeID_c3];
  (*extData.daeFVectorPtr)[li_c4] += staticContributions[admsNodeID_c4];
  (*extData.daeFVectorPtr)[li_noi] += staticContributions[admsNodeID_noi];

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dFdxdVp = extData.dFdxdVpVectorRawPtr;
    dFdxdVp[li_c] += Jdxp_static[admsNodeID_c];
    dFdxdVp[li_b] += Jdxp_static[admsNodeID_b];
    dFdxdVp[li_e] += Jdxp_static[admsNodeID_e];
    dFdxdVp[li_s] += Jdxp_static[admsNodeID_s];
    dFdxdVp[li_dt] += Jdxp_static[admsNodeID_dt];
    dFdxdVp[li_e1] += Jdxp_static[admsNodeID_e1];
    dFdxdVp[li_b1] += Jdxp_static[admsNodeID_b1];
    dFdxdVp[li_b2] += Jdxp_static[admsNodeID_b2];
    dFdxdVp[li_c1] += Jdxp_static[admsNodeID_c1];
    dFdxdVp[li_c2] += Jdxp_static[admsNodeID_c2];
    dFdxdVp[li_c3] += Jdxp_static[admsNodeID_c3];
    dFdxdVp[li_c4] += Jdxp_static[admsNodeID_c4];
    dFdxdVp[li_noi] += Jdxp_static[admsNodeID_noi];


  }

  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_idt] = leadCurrentF[admsNodeID_dt];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c];
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b];
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e];
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s];
  (*extData.daeQVectorPtr)[li_dt] += dynamicContributions[admsNodeID_dt];
  (*extData.daeQVectorPtr)[li_e1] += dynamicContributions[admsNodeID_e1];
  (*extData.daeQVectorPtr)[li_b1] += dynamicContributions[admsNodeID_b1];
  (*extData.daeQVectorPtr)[li_b2] += dynamicContributions[admsNodeID_b2];
  (*extData.daeQVectorPtr)[li_c1] += dynamicContributions[admsNodeID_c1];
  (*extData.daeQVectorPtr)[li_c2] += dynamicContributions[admsNodeID_c2];
  (*extData.daeQVectorPtr)[li_c3] += dynamicContributions[admsNodeID_c3];
  (*extData.daeQVectorPtr)[li_c4] += dynamicContributions[admsNodeID_c4];
  (*extData.daeQVectorPtr)[li_noi] += dynamicContributions[admsNodeID_noi];

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dQdxdVp = extData.dQdxdVpVectorRawPtr;
    dQdxdVp[li_c] += Jdxp_dynamic[admsNodeID_c];
    dQdxdVp[li_b] += Jdxp_dynamic[admsNodeID_b];
    dQdxdVp[li_e] += Jdxp_dynamic[admsNodeID_e];
    dQdxdVp[li_s] += Jdxp_dynamic[admsNodeID_s];
    dQdxdVp[li_dt] += Jdxp_dynamic[admsNodeID_dt];
    dQdxdVp[li_e1] += Jdxp_dynamic[admsNodeID_e1];
    dQdxdVp[li_b1] += Jdxp_dynamic[admsNodeID_b1];
    dQdxdVp[li_b2] += Jdxp_dynamic[admsNodeID_b2];
    dQdxdVp[li_c1] += Jdxp_dynamic[admsNodeID_c1];
    dQdxdVp[li_c2] += Jdxp_dynamic[admsNodeID_c2];
    dQdxdVp[li_c3] += Jdxp_dynamic[admsNodeID_c3];
    dQdxdVp[li_c4] += Jdxp_dynamic[admsNodeID_c4];
    dQdxdVp[li_noi] += Jdxp_dynamic[admsNodeID_noi];

  }

  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_idt] = leadCurrentQ[admsNodeID_dt];
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_admsProbeID_V_b2_c1] = probeVars[admsProbeID_V_b2_c1];
  stoVec[li_store_admsProbeID_V_b2_c2] = probeVars[admsProbeID_V_b2_c2];
  stoVec[li_store_admsProbeID_V_b1_e1] = probeVars[admsProbeID_V_b1_e1];
  stoVec[li_store_admsProbeID_V_b1_b2] = probeVars[admsProbeID_V_b1_b2];

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bjt504tva instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbjt504tva::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double common;
  double d_common_dV_dt_GND;
  double powerREC;
  double d_powerREC_dV_dt_GND;
  double powerRBC;
  double d_powerRBC_dV_dt_GND;
  double powerRCCxx;
  double d_powerRCCxx_dV_dt_GND;
  double powerRCCex;
  double d_powerRCCex_dV_dt_GND;
  double powerRCCin;
  double d_powerRCCin_dV_dt_GND;
  double powerRBV;
  double d_powerRBV_dV_dt_GND;
  double d_powerRBV_dV_b_c;
  double d_powerRBV_dV_b_b1;
  double d_powerRBV_dV_b1_b2;
  double d_powerRBV_dV_c4_c1;
  double d_powerRBV_dV_c3_c1;
  double d_powerRBV_dV_c3_c4;
  double d_powerRBV_dV_b2_e1;
  double d_powerRBV_dV_b2_c2;
  double d_powerRBV_dV_b2_c1;
  double d_powerRBV_dV_c1_c2;
  double In_N;
  double d_In_N_dV_dt_GND;
  double d_In_N_dV_b2_e1;
  double d_In_N_dV_b2_c2;
  double d_In_N_dV_b2_c1;
  double d_In_N_dV_c1_c2;
  double powerCCS;
  double d_powerCCS_dV_dt_GND;
  double d_powerCCS_dV_b2_e1;
  double d_powerCCS_dV_b2_c2;
  double d_powerCCS_dV_b2_c1;
  double d_powerCCS_dV_c1_c2;
  double Gem_N;
  double d_Gem_N_dV_dt_GND;
  double d_Gem_N_dV_b2_c2;
  double d_Gem_N_dV_b2_c1;
  double d_Gem_N_dV_c1_c2;
  double d_Gem_N_dV_b_c;
  double d_Gem_N_dV_b_b1;
  double d_Gem_N_dV_b1_b2;
  double d_Gem_N_dV_c4_c1;
  double d_Gem_N_dV_c3_c1;
  double d_Gem_N_dV_c3_c4;
  double d_Gem_N_dV_b2_e1;
  double powerIIS;
  double d_powerIIS_dV_dt_GND;
  double d_powerIIS_dV_b2_c2;
  double d_powerIIS_dV_b2_c1;
  double d_powerIIS_dV_c1_c2;
  double d_powerIIS_dV_b_c;
  double d_powerIIS_dV_b_b1;
  double d_powerIIS_dV_b1_b2;
  double d_powerIIS_dV_c4_c1;
  double d_powerIIS_dV_c3_c1;
  double d_powerIIS_dV_c3_c4;
  double d_powerIIS_dV_b2_e1;
  double Taub_N;
  double d_Taub_N_dV_dt_GND;
  double d_Taub_N_dV_b2_e1;
  double d_Taub_N_dV_b_c;
  double d_Taub_N_dV_b_b1;
  double d_Taub_N_dV_b1_b2;
  double d_Taub_N_dV_c4_c1;
  double d_Taub_N_dV_c3_c1;
  double d_Taub_N_dV_c3_c4;
  double d_Taub_N_dV_b2_c2;
  double d_Taub_N_dV_b2_c1;
  double d_Taub_N_dV_c1_c2;
  double taun;
  double d_taun_dV_dt_GND;
  double d_taun_dV_b2_e1;
  double d_taun_dV_b_c;
  double d_taun_dV_b_b1;
  double d_taun_dV_b1_b2;
  double d_taun_dV_c4_c1;
  double d_taun_dV_c3_c1;
  double d_taun_dV_c3_c4;
  double d_taun_dV_b2_c2;
  double d_taun_dV_b2_c1;
  double d_taun_dV_c1_c2;
  double powerFBCS;
  double d_powerFBCS_dV_b2_c2;
  double d_powerFBCS_dV_b2_c1;
  double d_powerFBCS_dV_c1_c2;
  double d_powerFBCS_dV_dt_GND;
  double d_powerFBCS_dV_b2_e1;
  double powerFBC1fB1;
  double d_powerFBC1fB1_dV_b2_c2;
  double d_powerFBC1fB1_dV_b2_c1;
  double d_powerFBC1fB1_dV_c1_c2;
  double d_powerFBC1fB1_dV_dt_GND;
  double d_powerFBC1fB1_dV_b2_e1;
  double exponentFBC1fB2;
  double powerFBC1fB2;
  double d_powerFBC1fB2_dV_dt_GND;
  double d_powerFBC1fB2_dV_b2_e1;
  double powerEBSCS;
  double d_powerEBSCS_dV_dt_GND;
  double d_powerEBSCS_dV_b1_e1;
  double powerEBSC1f;
  double d_powerEBSC1f_dV_dt_GND;
  double d_powerEBSC1f_dV_b1_e1;
  double powerRBCS;
  double d_powerRBCS_dV_dt_GND;
  double d_powerRBCS_dV_b1_b2;
  double d_powerRBCS_dV_b2_c2;
  double d_powerRBCS_dV_c1_c2;
  double d_powerRBCS_dV_c4_c1;
  double d_powerRBCS_dV_b2_e1;
  double powerRBC1f;
  double d_powerRBC1f_dV_dt_GND;
  double d_powerRBC1f_dV_b1_b2;
  double d_powerRBC1f_dV_b2_c2;
  double d_powerRBC1f_dV_c1_c2;
  double d_powerRBC1f_dV_c4_c1;
  double d_powerRBC1f_dV_b2_e1;
  double powerExCS;
  double d_powerExCS_dV_dt_GND;
  double d_powerExCS_dV_b1_b2;
  double d_powerExCS_dV_b2_c2;
  double d_powerExCS_dV_c1_c2;
  double d_powerExCS_dV_c4_c1;
  double powerExC1f;
  double d_powerExC1f_dV_dt_GND;
  double d_powerExC1f_dV_b1_b2;
  double d_powerExC1f_dV_b2_c2;
  double d_powerExC1f_dV_c1_c2;
  double d_powerExC1f_dV_c4_c1;
  double powerExCSMOD;
  double d_powerExCSMOD_dV_dt_GND;
  double d_powerExCSMOD_dV_b_c;
  double d_powerExCSMOD_dV_b_b1;
  double d_powerExCSMOD_dV_b1_b2;
  double d_powerExCSMOD_dV_c4_c1;
  double d_powerExCSMOD_dV_c3_c1;
  double d_powerExCSMOD_dV_c3_c4;
  double d_powerExCSMOD_dV_b2_e1;
  double d_powerExCSMOD_dV_b2_c2;
  double d_powerExCSMOD_dV_b2_c1;
  double d_powerExCSMOD_dV_c1_c2;
  double d_powerExCSMOD_dV_s_c1;
  double powerExC1fMOD;
  double d_powerExC1fMOD_dV_dt_GND;
  double d_powerExC1fMOD_dV_b_c;
  double d_powerExC1fMOD_dV_b_b1;
  double d_powerExC1fMOD_dV_b1_b2;
  double d_powerExC1fMOD_dV_c4_c1;
  double d_powerExC1fMOD_dV_c3_c1;
  double d_powerExC1fMOD_dV_c3_c4;
  double d_powerExC1fMOD_dV_b2_e1;
  double d_powerExC1fMOD_dV_b2_c2;
  double d_powerExC1fMOD_dV_b2_c1;
  double d_powerExC1fMOD_dV_c1_c2;
  double d_powerExC1fMOD_dV_s_c1;
  double powerSubsCS_B1S;
  double d_powerSubsCS_B1S_dV_dt_GND;
  double d_powerSubsCS_B1S_dV_b1_b2;
  double d_powerSubsCS_B1S_dV_b2_c2;
  double d_powerSubsCS_B1S_dV_c1_c2;
  double d_powerSubsCS_B1S_dV_c4_c1;
  double d_powerSubsCS_B1S_dV_s_c1;
  double powerSubsCS_BS;
  double d_powerSubsCS_BS_dV_dt_GND;
  double d_powerSubsCS_BS_dV_b_c;
  double d_powerSubsCS_BS_dV_b_b1;
  double d_powerSubsCS_BS_dV_b1_b2;
  double d_powerSubsCS_BS_dV_c4_c1;
  double d_powerSubsCS_BS_dV_c3_c1;
  double d_powerSubsCS_BS_dV_c3_c4;
  double d_powerSubsCS_BS_dV_b2_e1;
  double d_powerSubsCS_BS_dV_b2_c2;
  double d_powerSubsCS_BS_dV_b2_c1;
  double d_powerSubsCS_BS_dV_c1_c2;
  double d_powerSubsCS_BS_dV_s_c1;
  double Vb2c1;
  double d_Vb2c1_dV_b2_c1;
  double Vb2c2;
  double d_Vb2c2_dV_b2_c2;
  double Vb2e1;
  double d_Vb2e1_dV_b2_e1;
  double Vb1e1;
  double d_Vb1e1_dV_b1_e1;
  double Vb1b2;
  double d_Vb1b2_dV_b1_b2;
  double Vsc1;
  double d_Vsc1_dV_s_c1;
  double Vc1c2;
  double d_Vc1c2_dV_c1_c2;
  double Vee1;
  double d_Vee1_dV_e_e1;
  double Vbb1;
  double d_Vbb1_dV_b_b1;
  double Vbe;
  double d_Vbe_dV_b_e;
  double Vbc;
  double d_Vbc_dV_b_c;
  double Vc4c1;
  double d_Vc4c1_dV_c4_c1;
  double Vc3c4;
  double d_Vc3c4_dV_c3_c1;
  double d_Vc3c4_dV_c3_c4;
  double Vb1c4;
  double d_Vb1c4_dV_b1_b2;
  double d_Vb1c4_dV_b2_c2;
  double d_Vb1c4_dV_c1_c2;
  double d_Vb1c4_dV_c4_c1;
  double Vcc3;
  double d_Vcc3_dV_b_c;
  double d_Vcc3_dV_b_b1;
  double d_Vcc3_dV_b1_b2;
  double d_Vcc3_dV_b2_c2;
  double d_Vcc3_dV_c1_c2;
  double d_Vcc3_dV_c4_c1;
  double d_Vcc3_dV_c3_c1;
  double d_Vcc3_dV_c3_c4;
  double Vbc3;
  double d_Vbc3_dV_b_c;
  double d_Vbc3_dV_b_b1;
  double d_Vbc3_dV_b1_b2;
  double d_Vbc3_dV_b2_c2;
  double d_Vbc3_dV_c1_c2;
  double d_Vbc3_dV_c4_c1;
  double d_Vbc3_dV_c3_c1;
  double d_Vbc3_dV_c3_c4;
  double Vsc4;
  double d_Vsc4_dV_s_c1;
  double d_Vsc4_dV_c4_c1;
  double Vsc3;
  double d_Vsc3_dV_s_c1;
  double d_Vsc3_dV_c4_c1;
  double d_Vsc3_dV_c3_c1;
  double d_Vsc3_dV_c3_c4;
  double expl;
  double eVb2c2;
  double d_eVb2c2_dV_b2_c2;
  double d_eVb2c2_dV_dt_GND;
  double eVb2e1;
  double d_eVb2e1_dV_b2_e1;
  double d_eVb2e1_dV_dt_GND;
  double eVb1e1;
  double d_eVb1e1_dV_b1_e1;
  double d_eVb1e1_dV_dt_GND;
  double eVb1c4;
  double d_eVb1c4_dV_b1_b2;
  double d_eVb1c4_dV_b2_c2;
  double d_eVb1c4_dV_c1_c2;
  double d_eVb1c4_dV_c4_c1;
  double d_eVb1c4_dV_dt_GND;
  double eVb1b2;
  double d_eVb1b2_dV_b1_b2;
  double d_eVb1b2_dV_dt_GND;
  double eVbc3;
  double d_eVbc3_dV_b_c;
  double d_eVbc3_dV_b_b1;
  double d_eVbc3_dV_b1_b2;
  double d_eVbc3_dV_b2_c2;
  double d_eVbc3_dV_c1_c2;
  double d_eVbc3_dV_c4_c1;
  double d_eVbc3_dV_c3_c1;
  double d_eVbc3_dV_c3_c4;
  double d_eVbc3_dV_dt_GND;
  double eVsc1;
  double d_eVsc1_dV_s_c1;
  double d_eVsc1_dV_dt_GND;
  double eVsc3;
  double d_eVsc3_dV_s_c1;
  double d_eVsc3_dV_c4_c1;
  double d_eVsc3_dV_c3_c1;
  double d_eVsc3_dV_c3_c4;
  double d_eVsc3_dV_dt_GND;
  double eVsc4;
  double d_eVsc4_dV_s_c1;
  double d_eVsc4_dV_c4_c1;
  double d_eVsc4_dV_dt_GND;
  double eVbc3VDC;
  double d_eVbc3VDC_dV_b_c;
  double d_eVbc3VDC_dV_b_b1;
  double d_eVbc3VDC_dV_b1_b2;
  double d_eVbc3VDC_dV_b2_c2;
  double d_eVbc3VDC_dV_c1_c2;
  double d_eVbc3VDC_dV_c4_c1;
  double d_eVbc3VDC_dV_c3_c1;
  double d_eVbc3VDC_dV_c3_c4;
  double d_eVbc3VDC_dV_dt_GND;
  double eVb1c4VDC;
  double d_eVb1c4VDC_dV_b1_b2;
  double d_eVb1c4VDC_dV_b2_c2;
  double d_eVb1c4VDC_dV_c1_c2;
  double d_eVb1c4VDC_dV_c4_c1;
  double d_eVb1c4VDC_dV_dt_GND;
  double eVb2c2VDC;
  double d_eVb2c2VDC_dV_b2_c2;
  double d_eVb2c2VDC_dV_dt_GND;
  double eVb2c1VDC;
  double d_eVb2c1VDC_dV_b2_c1;
  double d_eVb2c1VDC_dV_dt_GND;
  double K0;
  double d_K0_dV_b2_c2;
  double d_K0_dV_dt_GND;
  double Kw;
  double d_Kw_dV_b2_c1;
  double d_Kw_dV_dt_GND;
  double pW;
  double d_pW_dV_b2_c1;
  double d_pW_dV_dt_GND;
  double Ec;
  double d_Ec_dV_dt_GND;
  double d_Ec_dV_b2_c2;
  double d_Ec_dV_b2_c1;
  double Ic1c2;
  double d_Ic1c2_dV_dt_GND;
  double d_Ic1c2_dV_b2_c2;
  double d_Ic1c2_dV_b2_c1;
  double d_Ic1c2_dV_c1_c2;
  double pav;
  double d_pav_dV_dt_GND;
  double d_pav_dV_b2_c2;
  double d_pav_dV_b2_c1;
  double d_pav_dV_c1_c2;
  double tmpV;
  double d_tmpV_dV_b2_c1;
  double Vqs_th;
  double d_Vqs_th_dV_dt_GND;
  double d_Vqs_th_dV_b2_c2;
  double d_Vqs_th_dV_b2_c1;
  double d_Vqs_th_dV_c1_c2;
  double eps_VDC;
  double d_eps_VDC_dV_dt_GND;
  double eps2;
  double d_eps2_dV_dt_GND;
  double x2;
  double d_x2_dV_b_c;
  double d_x2_dV_b_b1;
  double d_x2_dV_b1_b2;
  double d_x2_dV_c4_c1;
  double d_x2_dV_c3_c1;
  double d_x2_dV_c3_c4;
  double d_x2_dV_b2_e1;
  double d_x2_dV_dt_GND;
  double d_x2_dV_b2_c2;
  double d_x2_dV_b2_c1;
  double d_x2_dV_c1_c2;
  double Vqs;
  double d_Vqs_dV_dt_GND;
  double d_Vqs_dV_b2_c2;
  double d_Vqs_dV_b2_c1;
  double d_Vqs_dV_c1_c2;
  double Iqs;
  double d_Iqs_dV_dt_GND;
  double d_Iqs_dV_b2_c2;
  double d_Iqs_dV_b2_c1;
  double d_Iqs_dV_c1_c2;
  double Ic1c2_Iqs;
  double d_Ic1c2_Iqs_dV_dt_GND;
  double d_Ic1c2_Iqs_dV_b2_c2;
  double d_Ic1c2_Iqs_dV_b2_c1;
  double d_Ic1c2_Iqs_dV_c1_c2;
  double alpha1;
  double d_alpha1_dV_b2_c2;
  double d_alpha1_dV_b2_c1;
  double d_alpha1_dV_c1_c2;
  double d_alpha1_dV_dt_GND;
  double alpha;
  double d_alpha_dV_b2_c2;
  double d_alpha_dV_b2_c1;
  double d_alpha_dV_c1_c2;
  double d_alpha_dV_dt_GND;
  double vyi;
  double d_vyi_dV_dt_GND;
  double d_vyi_dV_b2_c2;
  double d_vyi_dV_b2_c1;
  double d_vyi_dV_c1_c2;
  double yi;
  double d_yi_dV_b2_c2;
  double d_yi_dV_b2_c1;
  double d_yi_dV_c1_c2;
  double d_yi_dV_dt_GND;
  double xi_w;
  double d_xi_w_dV_b2_c2;
  double d_xi_w_dV_b2_c1;
  double d_xi_w_dV_c1_c2;
  double d_xi_w_dV_dt_GND;
  double gp0;
  double d_gp0_dV_dt_GND;
  double d_gp0_dV_b2_c2;
  double d_gp0_dV_b2_c1;
  double d_gp0_dV_c1_c2;
  double gp0_help;
  double d_gp0_help_dV_dt_GND;
  double d_gp0_help_dV_b2_c2;
  double d_gp0_help_dV_b2_c1;
  double d_gp0_help_dV_c1_c2;
  double gp02;
  double d_gp02_dV_dt_GND;
  double d_gp02_dV_b2_c2;
  double d_gp02_dV_b2_c1;
  double d_gp02_dV_c1_c2;
  double sqr_arg;
  double d_sqr_arg_dV_dt_GND;
  double d_sqr_arg_dV_b2_c2;
  double d_sqr_arg_dV_b2_c1;
  double d_sqr_arg_dV_c1_c2;
  double p0star;
  double d_p0star_dV_dt_GND;
  double d_p0star_dV_b2_c2;
  double d_p0star_dV_b2_c1;
  double d_p0star_dV_c1_c2;
  double eVb2c2star;
  double d_eVb2c2star_dV_dt_GND;
  double d_eVb2c2star_dV_b2_c2;
  double d_eVb2c2star_dV_b2_c1;
  double d_eVb2c2star_dV_c1_c2;
  double B1;
  double d_B1_dV_dt_GND;
  double d_B1_dV_b2_c2;
  double d_B1_dV_b2_c1;
  double d_B1_dV_c1_c2;
  double B2;
  double d_B2_dV_dt_GND;
  double d_B2_dV_b2_c2;
  double d_B2_dV_b2_c1;
  double d_B2_dV_c1_c2;
  double Vxi0;
  double d_Vxi0_dV_dt_GND;
  double d_Vxi0_dV_b2_c2;
  double d_Vxi0_dV_b2_c1;
  double d_Vxi0_dV_c1_c2;
  double Vch;
  double d_Vch_dV_dt_GND;
  double d_Vch_dV_b2_c2;
  double d_Vch_dV_b2_c1;
  double d_Vch_dV_c1_c2;
  double Icap;
  double d_Icap_dV_dt_GND;
  double d_Icap_dV_b2_c2;
  double d_Icap_dV_b2_c1;
  double d_Icap_dV_c1_c2;
  double Icap_IHC;
  double d_Icap_IHC_dV_dt_GND;
  double d_Icap_IHC_dV_b2_c2;
  double d_Icap_IHC_dV_b2_c1;
  double d_Icap_IHC_dV_c1_c2;
  double Vfe;
  double d_Vfe_dV_dt_GND;
  double a_VDE;
  double d_a_VDE_dV_dt_GND;
  double Vje;
  double d_Vje_dV_b2_e1;
  double d_Vje_dV_dt_GND;
  double d_Vje_dV_b2_c2;
  double d_Vje_dV_b2_c1;
  double d_Vje_dV_c1_c2;
  double E0BE;
  double d_E0BE_dV_b2_e1;
  double d_E0BE_dV_dt_GND;
  double d_E0BE_dV_b2_c2;
  double d_E0BE_dV_b2_c1;
  double d_E0BE_dV_c1_c2;
  double Vte;
  double d_Vte_dV_dt_GND;
  double d_Vte_dV_b2_e1;
  double d_Vte_dV_b2_c2;
  double d_Vte_dV_b2_c1;
  double d_Vte_dV_c1_c2;
  double Vjunc;
  double d_Vjunc_dV_b2_c1;
  double d_Vjunc_dV_dt_GND;
  double d_Vjunc_dV_b2_c2;
  double d_Vjunc_dV_c1_c2;
  double bjc;
  double d_bjc_dV_dt_GND;
  double Vfc;
  double d_Vfc_dV_dt_GND;
  double Vjc;
  double d_Vjc_dV_b2_c1;
  double d_Vjc_dV_dt_GND;
  double d_Vjc_dV_b2_c2;
  double d_Vjc_dV_c1_c2;
  double d_Vjc_dV_b2_e1;
  double fI;
  double d_fI_dV_dt_GND;
  double d_fI_dV_b2_c2;
  double d_fI_dV_b2_c1;
  double d_fI_dV_c1_c2;
  double Vcv;
  double d_Vcv_dV_dt_GND;
  double d_Vcv_dV_b2_c2;
  double d_Vcv_dV_b2_c1;
  double d_Vcv_dV_c1_c2;
  double d_Vcv_dV_b2_e1;
  double Vtc;
  double d_Vtc_dV_dt_GND;
  double d_Vtc_dV_b2_c2;
  double d_Vtc_dV_b2_c1;
  double d_Vtc_dV_c1_c2;
  double d_Vtc_dV_b2_e1;
  double If0;
  double d_If0_dV_dt_GND;
  double f1;
  double d_f1_dV_dt_GND;
  double d_f1_dV_b2_e1;
  double n0;
  double d_n0_dV_dt_GND;
  double d_n0_dV_b2_e1;
  double f2;
  double d_f2_dV_dt_GND;
  double d_f2_dV_b2_c2;
  double d_f2_dV_b2_c1;
  double d_f2_dV_c1_c2;
  double nB;
  double d_nB_dV_dt_GND;
  double d_nB_dV_b2_c2;
  double d_nB_dV_b2_c1;
  double d_nB_dV_c1_c2;
  double termE;
  double d_termE_dV_dt_GND;
  double d_termE_dV_b2_e1;
  double d_termE_dV_b2_c2;
  double d_termE_dV_b2_c1;
  double d_termE_dV_c1_c2;
  double termC;
  double d_termC_dV_dt_GND;
  double d_termC_dV_b2_c2;
  double d_termC_dV_b2_c1;
  double d_termC_dV_c1_c2;
  double d_termC_dV_b2_e1;
  double q0I;
  double d_q0I_dV_dt_GND;
  double d_q0I_dV_b2_e1;
  double d_q0I_dV_b2_c2;
  double d_q0I_dV_b2_c1;
  double d_q0I_dV_c1_c2;
  double q1I;
  double d_q1I_dV_dt_GND;
  double d_q1I_dV_b2_e1;
  double d_q1I_dV_b2_c2;
  double d_q1I_dV_b2_c1;
  double d_q1I_dV_c1_c2;
  double qBI;
  double d_qBI_dV_dt_GND;
  double d_qBI_dV_b2_e1;
  double d_qBI_dV_b2_c2;
  double d_qBI_dV_b2_c1;
  double d_qBI_dV_c1_c2;
  double Ir;
  double d_Ir_dV_dt_GND;
  double d_Ir_dV_b2_c2;
  double d_Ir_dV_b2_c1;
  double d_Ir_dV_c1_c2;
  double If;
  double d_If_dV_dt_GND;
  double d_If_dV_b2_e1;
  double In;
  double d_In_dV_dt_GND;
  double d_In_dV_b2_e1;
  double d_In_dV_b2_c2;
  double d_In_dV_b2_c1;
  double d_In_dV_c1_c2;
  double Ibf0;
  double d_Ibf0_dV_dt_GND;
  double Ib1;
  double d_Ib1_dV_b2_c2;
  double d_Ib1_dV_b2_c1;
  double d_Ib1_dV_c1_c2;
  double d_Ib1_dV_dt_GND;
  double d_Ib1_dV_b2_e1;
  double Ib1_s;
  double d_Ib1_s_dV_dt_GND;
  double d_Ib1_s_dV_b1_e1;
  double tmpExp;
  double d_tmpExp_dV_b1_b2;
  double d_tmpExp_dV_b2_c2;
  double d_tmpExp_dV_c1_c2;
  double d_tmpExp_dV_c4_c1;
  double d_tmpExp_dV_b2_e1;
  double d_tmpExp_dV_dt_GND;
  double Ib2;
  double d_Ib2_dV_dt_GND;
  double d_Ib2_dV_b2_e1;
  double Ib3;
  double d_Ib3_dV_dt_GND;
  double d_Ib3_dV_b1_b2;
  double d_Ib3_dV_b2_c2;
  double d_Ib3_dV_c1_c2;
  double d_Ib3_dV_c4_c1;
  double d_Ib3_dV_b2_e1;
  double eZEB;
  double d_eZEB_dV_dt_GND;
  double d_eZEB_dV_b2_e1;
  double d_eZEB_dV_b2_c2;
  double d_eZEB_dV_b2_c1;
  double d_eZEB_dV_c1_c2;
  double x;
  double d_x_dV_b2_e1;
  double d_x_dV_dt_GND;
  double dE0BE;
  double d_dE0BE_dV_b2_e1;
  double d_dE0BE_dV_dt_GND;
  double edZEB;
  double d_edZEB_dV_b2_e1;
  double d_edZEB_dV_dt_GND;
  double DZEB;
  double d_DZEB_dV_b2_e1;
  double d_DZEB_dV_dt_GND;
  double Izteb;
  double d_Izteb_dV_dt_GND;
  double d_Izteb_dV_b2_e1;
  double d_Izteb_dV_b2_c2;
  double d_Izteb_dV_b2_c1;
  double d_Izteb_dV_c1_c2;
  double g1;
  double d_g1_dV_dt_GND;
  double d_g1_dV_b1_b2;
  double d_g1_dV_b2_c2;
  double d_g1_dV_c1_c2;
  double d_g1_dV_c4_c1;
  double g2;
  double d_g2_dV_b1_b2;
  double d_g2_dV_b2_c2;
  double d_g2_dV_c1_c2;
  double d_g2_dV_c4_c1;
  double d_g2_dV_dt_GND;
  double nBex;
  double d_nBex_dV_dt_GND;
  double d_nBex_dV_b1_b2;
  double d_nBex_dV_b2_c2;
  double d_nBex_dV_c1_c2;
  double d_nBex_dV_c4_c1;
  double pWex;
  double d_pWex_dV_b1_b2;
  double d_pWex_dV_b2_c2;
  double d_pWex_dV_c1_c2;
  double d_pWex_dV_c4_c1;
  double d_pWex_dV_dt_GND;
  double Iex;
  double d_Iex_dV_dt_GND;
  double d_Iex_dV_b1_b2;
  double d_Iex_dV_b2_c2;
  double d_Iex_dV_c1_c2;
  double d_Iex_dV_c4_c1;
  double Isub;
  double d_Isub_dV_dt_GND;
  double d_Isub_dV_b1_b2;
  double d_Isub_dV_b2_c2;
  double d_Isub_dV_c1_c2;
  double d_Isub_dV_c4_c1;
  double d_Isub_dV_s_c1;
  double Isf;
  double d_Isf_dV_dt_GND;
  double d_Isf_dV_s_c1;
  double XIex;
  double d_XIex_dV_dt_GND;
  double d_XIex_dV_b_c;
  double d_XIex_dV_b_b1;
  double d_XIex_dV_b1_b2;
  double d_XIex_dV_c4_c1;
  double d_XIex_dV_c3_c1;
  double d_XIex_dV_c3_c4;
  double d_XIex_dV_b2_e1;
  double d_XIex_dV_b2_c2;
  double d_XIex_dV_b2_c1;
  double d_XIex_dV_c1_c2;
  double d_XIex_dV_s_c1;
  double XIsub;
  double d_XIsub_dV_dt_GND;
  double d_XIsub_dV_b_c;
  double d_XIsub_dV_b_b1;
  double d_XIsub_dV_b1_b2;
  double d_XIsub_dV_c4_c1;
  double d_XIsub_dV_c3_c1;
  double d_XIsub_dV_c3_c4;
  double d_XIsub_dV_b2_e1;
  double d_XIsub_dV_b2_c2;
  double d_XIsub_dV_b2_c1;
  double d_XIsub_dV_c1_c2;
  double d_XIsub_dV_s_c1;
  double Xg1;
  double d_Xg1_dV_dt_GND;
  double d_Xg1_dV_b_c;
  double d_Xg1_dV_b_b1;
  double d_Xg1_dV_b1_b2;
  double d_Xg1_dV_b2_c2;
  double d_Xg1_dV_c1_c2;
  double d_Xg1_dV_c4_c1;
  double d_Xg1_dV_c3_c1;
  double d_Xg1_dV_c3_c4;
  double XnBex;
  double d_XnBex_dV_dt_GND;
  double d_XnBex_dV_b_c;
  double d_XnBex_dV_b_b1;
  double d_XnBex_dV_b1_b2;
  double d_XnBex_dV_b2_c2;
  double d_XnBex_dV_c1_c2;
  double d_XnBex_dV_c4_c1;
  double d_XnBex_dV_c3_c1;
  double d_XnBex_dV_c3_c4;
  double XIMex;
  double d_XIMex_dV_dt_GND;
  double d_XIMex_dV_b_c;
  double d_XIMex_dV_b_b1;
  double d_XIMex_dV_b1_b2;
  double d_XIMex_dV_b2_c2;
  double d_XIMex_dV_c1_c2;
  double d_XIMex_dV_c4_c1;
  double d_XIMex_dV_c3_c1;
  double d_XIMex_dV_c3_c4;
  double XIMsub;
  double d_XIMsub_dV_dt_GND;
  double d_XIMsub_dV_b_c;
  double d_XIMsub_dV_b_b1;
  double d_XIMsub_dV_b1_b2;
  double d_XIMsub_dV_b2_c2;
  double d_XIMsub_dV_c1_c2;
  double d_XIMsub_dV_c4_c1;
  double d_XIMsub_dV_c3_c1;
  double d_XIMsub_dV_c3_c4;
  double d_XIMsub_dV_s_c1;
  double Vex_bias;
  double d_Vex_bias_dV_dt_GND;
  double Vex;
  double d_Vex_dV_dt_GND;
  double vdif;
  double d_vdif_dV_b_c;
  double d_vdif_dV_b_b1;
  double d_vdif_dV_b1_b2;
  double d_vdif_dV_b2_c2;
  double d_vdif_dV_c1_c2;
  double d_vdif_dV_c4_c1;
  double d_vdif_dV_c3_c1;
  double d_vdif_dV_c3_c4;
  double d_vdif_dV_dt_GND;
  double VBex;
  double d_VBex_dV_dt_GND;
  double d_VBex_dV_b_c;
  double d_VBex_dV_b_b1;
  double d_VBex_dV_b1_b2;
  double d_VBex_dV_c4_c1;
  double d_VBex_dV_c3_c1;
  double d_VBex_dV_c3_c4;
  double d_VBex_dV_b2_e1;
  double d_VBex_dV_b2_c2;
  double d_VBex_dV_b2_c1;
  double d_VBex_dV_c1_c2;
  double Fex;
  double d_Fex_dV_dt_GND;
  double d_Fex_dV_b_c;
  double d_Fex_dV_b_b1;
  double d_Fex_dV_b1_b2;
  double d_Fex_dV_c4_c1;
  double d_Fex_dV_c3_c1;
  double d_Fex_dV_c3_c4;
  double d_Fex_dV_b2_e1;
  double d_Fex_dV_b2_c2;
  double d_Fex_dV_b2_c1;
  double d_Fex_dV_c1_c2;
  double d_Fex_dV_s_c1;
  double q0Q;
  double d_q0Q_dV_dt_GND;
  double d_q0Q_dV_b2_e1;
  double d_q0Q_dV_b2_c2;
  double d_q0Q_dV_b2_c1;
  double d_q0Q_dV_c1_c2;
  double q1Q;
  double d_q1Q_dV_dt_GND;
  double d_q1Q_dV_b_c;
  double d_q1Q_dV_b_b1;
  double d_q1Q_dV_b1_b2;
  double d_q1Q_dV_c4_c1;
  double d_q1Q_dV_c3_c1;
  double d_q1Q_dV_c3_c4;
  double d_q1Q_dV_b2_e1;
  double d_q1Q_dV_b2_c2;
  double d_q1Q_dV_b2_c1;
  double d_q1Q_dV_c1_c2;
  double qBQ;
  double d_qBQ_dV_dt_GND;
  double d_qBQ_dV_b_c;
  double d_qBQ_dV_b_b1;
  double d_qBQ_dV_b1_b2;
  double d_qBQ_dV_c4_c1;
  double d_qBQ_dV_c3_c1;
  double d_qBQ_dV_c3_c4;
  double d_qBQ_dV_b2_e1;
  double d_qBQ_dV_b2_c2;
  double d_qBQ_dV_b2_c1;
  double d_qBQ_dV_c1_c2;
  double Rb2;
  double d_Rb2_dV_dt_GND;
  double d_Rb2_dV_b_c;
  double d_Rb2_dV_b_b1;
  double d_Rb2_dV_b1_b2;
  double d_Rb2_dV_c4_c1;
  double d_Rb2_dV_c3_c1;
  double d_Rb2_dV_c3_c4;
  double d_Rb2_dV_b2_e1;
  double d_Rb2_dV_b2_c2;
  double d_Rb2_dV_b2_c1;
  double d_Rb2_dV_c1_c2;
  double Ib1b2;
  double d_Ib1b2_dV_dt_GND;
  double d_Ib1b2_dV_b1_b2;
  double d_Ib1b2_dV_b_c;
  double d_Ib1b2_dV_b_b1;
  double d_Ib1b2_dV_c4_c1;
  double d_Ib1b2_dV_c3_c1;
  double d_Ib1b2_dV_c3_c4;
  double d_Ib1b2_dV_b2_e1;
  double d_Ib1b2_dV_b2_c2;
  double d_Ib1b2_dV_b2_c1;
  double d_Ib1b2_dV_c1_c2;
  double Iavl;
  double d_Iavl_dV_dt_GND;
  double d_Iavl_dV_b2_c2;
  double d_Iavl_dV_b2_c1;
  double d_Iavl_dV_c1_c2;
  double d_Iavl_dV_b_c;
  double d_Iavl_dV_b_b1;
  double d_Iavl_dV_b1_b2;
  double d_Iavl_dV_c4_c1;
  double d_Iavl_dV_c3_c1;
  double d_Iavl_dV_c3_c4;
  double d_Iavl_dV_b2_e1;
  double Gem;
  double d_Gem_dV_dt_GND;
  double d_Gem_dV_b2_c1;
  double d_Gem_dV_b2_c2;
  double d_Gem_dV_c1_c2;
  double dEdx0;
  double xd;
  double d_xd_dV_dt_GND;
  double d_xd_dV_b2_c2;
  double d_xd_dV_b2_c1;
  double d_xd_dV_c1_c2;
  double xi_w1;
  double d_xi_w1_dV_b2_c2;
  double d_xi_w1_dV_b2_c1;
  double d_xi_w1_dV_c1_c2;
  double d_xi_w1_dV_dt_GND;
  double Weff;
  double d_Weff_dV_b2_c2;
  double d_Weff_dV_b2_c1;
  double d_Weff_dV_c1_c2;
  double d_Weff_dV_dt_GND;
  double Wd;
  double d_Wd_dV_dt_GND;
  double d_Wd_dV_b2_c2;
  double d_Wd_dV_b2_c1;
  double d_Wd_dV_c1_c2;
  double Eav;
  double d_Eav_dV_dt_GND;
  double d_Eav_dV_b2_c1;
  double d_Eav_dV_b2_c2;
  double d_Eav_dV_c1_c2;
  double E0;
  double d_E0_dV_dt_GND;
  double d_E0_dV_b2_c1;
  double d_E0_dV_b2_c2;
  double d_E0_dV_c1_c2;
  double SHw;
  double d_SHw_dV_b2_c2;
  double d_SHw_dV_b2_c1;
  double d_SHw_dV_c1_c2;
  double d_SHw_dV_dt_GND;
  double Efi;
  double Ew;
  double d_Ew_dV_dt_GND;
  double d_Ew_dV_b2_c1;
  double d_Ew_dV_b2_c2;
  double d_Ew_dV_c1_c2;
  double Em;
  double d_Em_dV_dt_GND;
  double d_Em_dV_b2_c1;
  double d_Em_dV_b2_c2;
  double d_Em_dV_c1_c2;
  double EmEav_Em;
  double d_EmEav_Em_dV_dt_GND;
  double d_EmEav_Em_dV_b2_c1;
  double d_EmEav_Em_dV_b2_c2;
  double d_EmEav_Em_dV_c1_c2;
  double lambda;
  double d_lambda_dV_dt_GND;
  double d_lambda_dV_b2_c2;
  double d_lambda_dV_b2_c1;
  double d_lambda_dV_c1_c2;
  double Gmax;
  double d_Gmax_dV_dt_GND;
  double d_Gmax_dV_b2_c2;
  double d_Gmax_dV_b2_c1;
  double d_Gmax_dV_c1_c2;
  double d_Gmax_dV_b_c;
  double d_Gmax_dV_b_b1;
  double d_Gmax_dV_b1_b2;
  double d_Gmax_dV_c4_c1;
  double d_Gmax_dV_c3_c1;
  double d_Gmax_dV_c3_c4;
  double d_Gmax_dV_b2_e1;
  double Vb2c2star;
  double d_Vb2c2star_dV_dt_GND;
  double d_Vb2c2star_dV_b2_c2;
  double d_Vb2c2star_dV_b2_c1;
  double d_Vb2c2star_dV_c1_c2;
  double power;
  double d_power_dV_dt_GND;
  double d_power_dV_b2_e1;
  double d_power_dV_b2_c2;
  double d_power_dV_b2_c1;
  double d_power_dV_c1_c2;
  double d_power_dV_b_c;
  double d_power_dV_b_b1;
  double d_power_dV_b1_b2;
  double d_power_dV_c4_c1;
  double d_power_dV_c3_c1;
  double d_power_dV_c3_c4;
  double d_power_dV_e_e1;
  double d_power_dV_b1_e1;
  double d_power_dV_s_c1;
  double Qte;
  double d_Qte_dV_dt_GND;
  double d_Qte_dV_b2_e1;
  double d_Qte_dV_b2_c2;
  double d_Qte_dV_b2_c1;
  double d_Qte_dV_c1_c2;
  double Vje_s;
  double d_Vje_s_dV_b1_e1;
  double d_Vje_s_dV_dt_GND;
  double d_Vje_s_dV_b2_e1;
  double d_Vje_s_dV_b2_c2;
  double d_Vje_s_dV_b2_c1;
  double d_Vje_s_dV_c1_c2;
  double Qte_s;
  double d_Qte_s_dV_dt_GND;
  double d_Qte_s_dV_b1_e1;
  double d_Qte_s_dV_b2_e1;
  double d_Qte_s_dV_b2_c2;
  double d_Qte_s_dV_b2_c1;
  double d_Qte_s_dV_c1_c2;
  double Qtc;
  double d_Qtc_dV_dt_GND;
  double d_Qtc_dV_b2_c2;
  double d_Qtc_dV_b2_c1;
  double d_Qtc_dV_c1_c2;
  double d_Qtc_dV_b2_e1;
  double Qb0;
  double d_Qb0_dV_dt_GND;
  double Qbe_qs;
  double d_Qbe_qs_dV_dt_GND;
  double d_Qbe_qs_dV_b2_e1;
  double d_Qbe_qs_dV_b_c;
  double d_Qbe_qs_dV_b_b1;
  double d_Qbe_qs_dV_b1_b2;
  double d_Qbe_qs_dV_c4_c1;
  double d_Qbe_qs_dV_c3_c1;
  double d_Qbe_qs_dV_c3_c4;
  double d_Qbe_qs_dV_b2_c2;
  double d_Qbe_qs_dV_b2_c1;
  double d_Qbe_qs_dV_c1_c2;
  double Qbc_qs;
  double d_Qbc_qs_dV_dt_GND;
  double d_Qbc_qs_dV_b2_c2;
  double d_Qbc_qs_dV_b2_c1;
  double d_Qbc_qs_dV_c1_c2;
  double d_Qbc_qs_dV_b_c;
  double d_Qbc_qs_dV_b_b1;
  double d_Qbc_qs_dV_b1_b2;
  double d_Qbc_qs_dV_c4_c1;
  double d_Qbc_qs_dV_c3_c1;
  double d_Qbc_qs_dV_c3_c4;
  double d_Qbc_qs_dV_b2_e1;
  double a_VDC;
  double d_a_VDC_dV_dt_GND;
  double Vjcex;
  double d_Vjcex_dV_b1_b2;
  double d_Vjcex_dV_b2_c2;
  double d_Vjcex_dV_c1_c2;
  double d_Vjcex_dV_c4_c1;
  double d_Vjcex_dV_dt_GND;
  double d_Vjcex_dV_b1_e1;
  double d_Vjcex_dV_b2_e1;
  double d_Vjcex_dV_b2_c1;
  double Vtexv;
  double d_Vtexv_dV_dt_GND;
  double d_Vtexv_dV_b1_b2;
  double d_Vtexv_dV_b2_c2;
  double d_Vtexv_dV_c1_c2;
  double d_Vtexv_dV_c4_c1;
  double d_Vtexv_dV_b1_e1;
  double d_Vtexv_dV_b2_e1;
  double d_Vtexv_dV_b2_c1;
  double Qtex;
  double d_Qtex_dV_dt_GND;
  double d_Qtex_dV_b1_b2;
  double d_Qtex_dV_b2_c2;
  double d_Qtex_dV_c1_c2;
  double d_Qtex_dV_c4_c1;
  double d_Qtex_dV_b1_e1;
  double d_Qtex_dV_b2_e1;
  double d_Qtex_dV_b2_c1;
  double XVjcex;
  double d_XVjcex_dV_b_c;
  double d_XVjcex_dV_b_b1;
  double d_XVjcex_dV_b1_b2;
  double d_XVjcex_dV_b2_c2;
  double d_XVjcex_dV_c1_c2;
  double d_XVjcex_dV_c4_c1;
  double d_XVjcex_dV_c3_c1;
  double d_XVjcex_dV_c3_c4;
  double d_XVjcex_dV_dt_GND;
  double d_XVjcex_dV_b1_e1;
  double d_XVjcex_dV_b2_e1;
  double d_XVjcex_dV_b2_c1;
  double XVtexv;
  double d_XVtexv_dV_dt_GND;
  double d_XVtexv_dV_b_c;
  double d_XVtexv_dV_b_b1;
  double d_XVtexv_dV_b1_b2;
  double d_XVtexv_dV_b2_c2;
  double d_XVtexv_dV_c1_c2;
  double d_XVtexv_dV_c4_c1;
  double d_XVtexv_dV_c3_c1;
  double d_XVtexv_dV_c3_c4;
  double d_XVtexv_dV_b1_e1;
  double d_XVtexv_dV_b2_e1;
  double d_XVtexv_dV_b2_c1;
  double XQtex;
  double d_XQtex_dV_dt_GND;
  double d_XQtex_dV_b_c;
  double d_XQtex_dV_b_b1;
  double d_XQtex_dV_b1_b2;
  double d_XQtex_dV_b2_c2;
  double d_XQtex_dV_c1_c2;
  double d_XQtex_dV_c4_c1;
  double d_XQtex_dV_c3_c1;
  double d_XQtex_dV_c3_c4;
  double d_XQtex_dV_b1_e1;
  double d_XQtex_dV_b2_e1;
  double d_XQtex_dV_b2_c1;
  double a_VDS;
  double d_a_VDS_dV_dt_GND;
  double Vfs;
  double d_Vfs_dV_dt_GND;
  double Vjs;
  double d_Vjs_dV_s_c1;
  double d_Vjs_dV_dt_GND;
  double d_Vjs_dV_b_c;
  double d_Vjs_dV_b_b1;
  double d_Vjs_dV_c3_c1;
  double d_Vjs_dV_c3_c4;
  double d_Vjs_dV_b1_b2;
  double d_Vjs_dV_c4_c1;
  double d_Vjs_dV_b1_e1;
  double d_Vjs_dV_b2_e1;
  double d_Vjs_dV_b2_c2;
  double d_Vjs_dV_b2_c1;
  double d_Vjs_dV_c1_c2;
  double Qts;
  double d_Qts_dV_dt_GND;
  double d_Qts_dV_s_c1;
  double d_Qts_dV_b_c;
  double d_Qts_dV_b_b1;
  double d_Qts_dV_c3_c1;
  double d_Qts_dV_c3_c4;
  double d_Qts_dV_b1_b2;
  double d_Qts_dV_c4_c1;
  double d_Qts_dV_b1_e1;
  double d_Qts_dV_b2_e1;
  double d_Qts_dV_b2_c2;
  double d_Qts_dV_b2_c1;
  double d_Qts_dV_c1_c2;
  double Qe0;
  double d_Qe0_dV_dt_GND;
  double Qe_qs;
  double d_Qe_qs_dV_dt_GND;
  double d_Qe_qs_dV_b1_b2;
  double d_Qe_qs_dV_b2_c2;
  double d_Qe_qs_dV_c1_c2;
  double d_Qe_qs_dV_c4_c1;
  double d_Qe_qs_dV_b2_e1;
  double Qepi0;
  double d_Qepi0_dV_dt_GND;
  double Qepi;
  double d_Qepi_dV_dt_GND;
  double d_Qepi_dV_b2_c2;
  double d_Qepi_dV_b2_c1;
  double d_Qepi_dV_c1_c2;
  double Qex;
  double d_Qex_dV_dt_GND;
  double d_Qex_dV_b1_b2;
  double d_Qex_dV_b2_c2;
  double d_Qex_dV_c1_c2;
  double d_Qex_dV_c4_c1;
  double XQex;
  double d_XQex_dV_dt_GND;
  double d_XQex_dV_b_c;
  double d_XQex_dV_b_b1;
  double d_XQex_dV_b1_b2;
  double d_XQex_dV_c4_c1;
  double d_XQex_dV_c3_c1;
  double d_XQex_dV_c3_c4;
  double d_XQex_dV_b2_e1;
  double d_XQex_dV_b2_c2;
  double d_XQex_dV_b2_c1;
  double d_XQex_dV_c1_c2;
  double d_XQex_dV_s_c1;
  double Xg2;
  double d_Xg2_dV_b_c;
  double d_Xg2_dV_b_b1;
  double d_Xg2_dV_b1_b2;
  double d_Xg2_dV_b2_c2;
  double d_Xg2_dV_c1_c2;
  double d_Xg2_dV_c4_c1;
  double d_Xg2_dV_c3_c1;
  double d_Xg2_dV_c3_c4;
  double d_Xg2_dV_dt_GND;
  double XpWex;
  double d_XpWex_dV_b_c;
  double d_XpWex_dV_b_b1;
  double d_XpWex_dV_b1_b2;
  double d_XpWex_dV_b2_c2;
  double d_XpWex_dV_c1_c2;
  double d_XpWex_dV_c4_c1;
  double d_XpWex_dV_c3_c1;
  double d_XpWex_dV_c3_c4;
  double d_XpWex_dV_dt_GND;
  double Qb1b2;
  double d_Qb1b2_dV_b1_b2;
  double d_Qb1b2_dV_dt_GND;
  double d_Qb1b2_dV_b2_e1;
  double d_Qb1b2_dV_b2_c2;
  double d_Qb1b2_dV_b2_c1;
  double d_Qb1b2_dV_c1_c2;
  double d_Qb1b2_dV_b_c;
  double d_Qb1b2_dV_b_b1;
  double d_Qb1b2_dV_c4_c1;
  double d_Qb1b2_dV_c3_c1;
  double d_Qb1b2_dV_c3_c4;
  double dVteVje;
  double d_dVteVje_dV_b2_e1;
  double d_dVteVje_dV_dt_GND;
  double d_dVteVje_dV_b2_c2;
  double d_dVteVje_dV_b2_c1;
  double d_dVteVje_dV_c1_c2;
  double Vb2e1Vfe;
  double d_Vb2e1Vfe_dV_b2_e1;
  double d_Vb2e1Vfe_dV_dt_GND;
  double dVjeVb2e1;
  double d_dVjeVb2e1_dV_b2_e1;
  double d_dVjeVb2e1_dV_dt_GND;
  double dVteVb2e1;
  double d_dVteVb2e1_dV_b2_e1;
  double d_dVteVb2e1_dV_dt_GND;
  double d_dVteVb2e1_dV_b2_c2;
  double d_dVteVb2e1_dV_b2_c1;
  double d_dVteVb2e1_dV_c1_c2;
  double dQteVb2e1;
  double d_dQteVb2e1_dV_dt_GND;
  double d_dQteVb2e1_dV_b2_e1;
  double d_dQteVb2e1_dV_b2_c2;
  double d_dQteVb2e1_dV_b2_c1;
  double d_dQteVb2e1_dV_c1_c2;
  double dn0Vb2e1;
  double d_dn0Vb2e1_dV_dt_GND;
  double d_dn0Vb2e1_dV_b2_e1;
  double dQbeVb2e1;
  double d_dQbeVb2e1_dV_dt_GND;
  double d_dQbeVb2e1_dV_b_c;
  double d_dQbeVb2e1_dV_b_b1;
  double d_dQbeVb2e1_dV_b1_b2;
  double d_dQbeVb2e1_dV_c4_c1;
  double d_dQbeVb2e1_dV_c3_c1;
  double d_dQbeVb2e1_dV_c3_c4;
  double d_dQbeVb2e1_dV_b2_e1;
  double d_dQbeVb2e1_dV_b2_c2;
  double d_dQbeVb2e1_dV_b2_c1;
  double d_dQbeVb2e1_dV_c1_c2;
  double dQeVb2e1;
  double d_dQeVb2e1_dV_dt_GND;
  double d_dQeVb2e1_dV_b1_b2;
  double d_dQeVb2e1_dV_b2_c2;
  double d_dQeVb2e1_dV_c1_c2;
  double d_dQeVb2e1_dV_c4_c1;
  double d_dQeVb2e1_dV_b2_e1;
  double Qe;
  double d_Qe_dV_dt_GND;
  double d_Qe_dV_b1_b2;
  double d_Qe_dV_b2_c2;
  double d_Qe_dV_c1_c2;
  double d_Qe_dV_c4_c1;
  double d_Qe_dV_b2_e1;
  double Qbe_qs_eff;
  double d_Qbe_qs_eff_dV_dt_GND;
  double d_Qbe_qs_eff_dV_b2_e1;
  double d_Qbe_qs_eff_dV_b_c;
  double d_Qbe_qs_eff_dV_b_b1;
  double d_Qbe_qs_eff_dV_b1_b2;
  double d_Qbe_qs_eff_dV_c4_c1;
  double d_Qbe_qs_eff_dV_c3_c1;
  double d_Qbe_qs_eff_dV_c3_c4;
  double d_Qbe_qs_eff_dV_b2_c2;
  double d_Qbe_qs_eff_dV_b2_c1;
  double d_Qbe_qs_eff_dV_c1_c2;
  double Qbc;
  double d_Qbc_dV_dt_GND;
  double d_Qbc_dV_b2_e1;
  double d_Qbc_dV_b_c;
  double d_Qbc_dV_b_b1;
  double d_Qbc_dV_b1_b2;
  double d_Qbc_dV_c4_c1;
  double d_Qbc_dV_c3_c1;
  double d_Qbc_dV_c3_c4;
  double d_Qbc_dV_b2_c2;
  double d_Qbc_dV_b2_c1;
  double d_Qbc_dV_c1_c2;
  double Qbe;
  double d_Qbe_dV_dt_GND;
  double d_Qbe_dV_b2_e1;
  double d_Qbe_dV_b_c;
  double d_Qbe_dV_b_b1;
  double d_Qbe_dV_b1_b2;
  double d_Qbe_dV_c4_c1;
  double d_Qbe_dV_c3_c1;
  double d_Qbe_dV_c3_c4;
  double d_Qbe_dV_b2_c2;
  double d_Qbe_dV_b2_c1;
  double d_Qbe_dV_c1_c2;
  double RTH_Tamb_M;
  double GCCin_TM;
  double d_GCCin_TM_dV_dt_GND;
  double GCCex_TM;
  double d_GCCex_TM_dV_dt_GND;
  double GCCxx_TM;
  double d_GCCxx_TM_dV_dt_GND;
  double RCV_TM;
  double d_RCV_TM_dV_dt_GND;
  double RCCin_TM;
  double d_RCCin_TM_dV_dt_GND;
  double RCCex_TM;
  double d_RCCex_TM_dV_dt_GND;
  double RCCxx_TM;
  double d_RCCxx_TM_dV_dt_GND;
  double RBV_TM;
  double d_RBV_TM_dV_dt_GND;
  double RBC_TM;
  double d_RBC_TM_dV_dt_GND;
  double RE_TM;
  double d_RE_TM_dV_dt_GND;
  double CJS_TM;
  double d_CJS_TM_dV_dt_GND;
  double CJC_TM;
  double d_CJC_TM_dV_dt_GND;
  double CJE_TM;
  double d_CJE_TM_dV_dt_GND;
  double IKS_TM;
  double d_IKS_TM_dV_dt_GND;
  double ICSS_TM;
  double d_ICSS_TM_dV_dt_GND;
  double ISS_TM;
  double d_ISS_TM_dV_dt_GND;
  double IHC_M;
  double IZEB_TM;
  double d_IZEB_TM_dV_dt_GND;
  double IBR_TM;
  double d_IBR_TM_dV_dt_GND;
  double IBF_TM;
  double d_IBF_TM_dV_dt_GND;
  double IK_TM;
  double d_IK_TM_dV_dt_GND;
  double IS_TM;
  double d_IS_TM_dV_dt_GND;
  double RTH_Tamb;
  double DEG_T;
  double d_DEG_T_dV_dt_GND;
  double BnT;
  double d_BnT_dV_dt_GND;
  double Tk300;
  double d_Tk300_dV_dt_GND;
  double TAUR_T;
  double d_TAUR_T_dV_dt_GND;
  double TEPI_T;
  double d_TEPI_T_dV_dt_GND;
  double TAUB_T;
  double d_TAUB_T_dV_dt_GND;
  double TAUE_T;
  double d_TAUE_T_dV_dt_GND;
  double IKS_T;
  double d_IKS_T_dV_dt_GND;
  double ICSS_T;
  double d_ICSS_T_dV_dt_GND;
  double ISS_T;
  double d_ISS_T_dV_dt_GND;
  double VER_T;
  double d_VER_T_dV_dt_GND;
  double VEF_T;
  double d_VEF_T_dV_dt_GND;
  double IZEB_T;
  double d_IZEB_T_dV_dt_GND;
  double nZEB_T;
  double d_nZEB_T_dV_dt_GND;
  double y;
  double d_y_dV_dt_GND;
  double tempx;
  double d_tempx_dV_dt_GND;
  double IBR_T;
  double d_IBR_T_dV_dt_GND;
  double IBF_T;
  double d_IBF_T_dV_dt_GND;
  double IK_T;
  double d_IK_T_dV_dt_GND;
  double IS_T;
  double d_IS_T_dV_dt_GND;
  double BRI_T;
  double d_BRI_T_dV_dt_GND;
  double BF_T;
  double d_BF_T_dV_dt_GND;
  double RCV_T;
  double d_RCV_T_dV_dt_GND;
  double RCCin_T;
  double d_RCCin_T_dV_dt_GND;
  double RCCex_T;
  double d_RCCex_T_dV_dt_GND;
  double RCCxx_T;
  double d_RCCxx_T_dV_dt_GND;
  double RBC_T;
  double d_RBC_T_dV_dt_GND;
  double RBV_T;
  double d_RBV_T_dV_dt_GND;
  double RE_T;
  double d_RE_T_dV_dt_GND;
  double XP_T;
  double d_XP_T_dV_dt_GND;
  double CJC_T;
  double d_CJC_T_dV_dt_GND;
  double CJCscaleINV;
  double d_CJCscaleINV_dV_dt_GND;
  double CJCscale;
  double d_CJCscale_dV_dt_GND;
  double CJS_T;
  double d_CJS_T_dV_dt_GND;
  double CJE_T;
  double d_CJE_T_dV_dt_GND;
  double CJE_T_div_CJE;
  double d_CJE_T_div_CJE_dV_dt_GND;
  double inv_VDE_T;
  double d_inv_VDE_T_dV_dt_GND;
  double VDS_T;
  double d_VDS_T_dV_dt_GND;
  double UdsT;
  double d_UdsT_dV_dt_GND;
  double VDC_T;
  double d_VDC_T_dV_dt_GND;
  double UdcT;
  double d_UdcT_dV_dt_GND;
  double VDE_T;
  double d_VDE_T_dV_dt_GND;
  double UdeT;
  double d_UdeT_dV_dt_GND;
  double VGZEB_T;
  double d_VGZEB_T_dV_dt_GND;
  double lntN;
  double d_lntN_dV_dt_GND;
  double VdtINV;
  double d_VdtINV_dV_dt_GND;
  double VtrINV;
  double VtINV;
  double d_VtINV_dV_dt_GND;
  double Vtr;
  double Vt;
  double d_Vt_dV_dt_GND;
  double tN;
  double d_tN_dV_dt_GND;
  double Tk;
  double d_Tk_dV_dt_GND;
  double Vdt;
  double d_Vdt_dV_dt_GND;
  double Tki;
  double d_Tki_dV_dt_GND;
  // temporary variables for limiting
  double Vb1b2_orig,Vb1b2_limited,Vb1b2_old;
  double Vb1e1_orig,Vb1e1_limited,Vb1e1_old;
  double Vb2c2_orig,Vb2c2_limited,Vb2c2_old;
  double Vb2c1_orig,Vb2c1_limited,Vb2c1_old;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (16))
  {
    probeVars.resize(16);
    d_probeVars.resize(16);
    for (int i=0;i<16;i++)
    {
      d_probeVars[i].resize(16);
      for (int j=0;j<16;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(13+0);
    d_staticContributions.resize(13+0);
    for (int i=0;i<13+0;i++)
      d_staticContributions[i].resize(16);
    dynamicContributions.resize(13+0);
    d_dynamicContributions.resize(13+0);
    for (int i=0;i<13+0;i++)
      d_dynamicContributions[i].resize(16);
    probeDiffs.resize(16,0.0);
    Jdxp_static.resize(13+0);
    Jdxp_dynamic.resize(13+0);
  }

  noiseContribsPower.resize(26);
  noiseContribsExponent.resize(26);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
    staticContributions[i]=0;
    for (int j=0;j<16;j++)
      d_staticContributions[i][j] = 0.0;
    dynamicContributions[i]=0;
    for (int j=0;j<16;j++)
      d_dynamicContributions[i][j] = 0.0;
    Jdxp_static[i]=0;
    Jdxp_dynamic[i]=0;
  }

  for (int i=0; i < 16 ; ++i)
  {
    probeDiffs[i] = 0.0;
  }
  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_noi_GND] = (*solVectorPtr)[li_noi];
  d_probeVars[admsProbeID_V_noi_GND][admsProbeID_V_noi_GND] = 1.0;
  probeVars[admsProbeID_V_c3_c1] = (*solVectorPtr)[li_c3] - (*solVectorPtr)[li_c1];
  d_probeVars[admsProbeID_V_c3_c1][admsProbeID_V_c3_c1] = 1.0;
  probeVars[admsProbeID_V_c3_c4] = (*solVectorPtr)[li_c3] - (*solVectorPtr)[li_c4];
  d_probeVars[admsProbeID_V_c3_c4][admsProbeID_V_c3_c4] = 1.0;
  probeVars[admsProbeID_V_c4_c1] = (*solVectorPtr)[li_c4] - (*solVectorPtr)[li_c1];
  d_probeVars[admsProbeID_V_c4_c1][admsProbeID_V_c4_c1] = 1.0;
  probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
  d_probeVars[admsProbeID_V_b_c][admsProbeID_V_b_c] = 1.0;
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e] = 1.0;
  probeVars[admsProbeID_V_b_b1] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_b1];
  d_probeVars[admsProbeID_V_b_b1][admsProbeID_V_b_b1] = 1.0;
  probeVars[admsProbeID_V_e_e1] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_e1];
  d_probeVars[admsProbeID_V_e_e1][admsProbeID_V_e_e1] = 1.0;
  probeVars[admsProbeID_V_c1_c2] = (*solVectorPtr)[li_c1] - (*solVectorPtr)[li_c2];
  d_probeVars[admsProbeID_V_c1_c2][admsProbeID_V_c1_c2] = 1.0;
  probeVars[admsProbeID_V_s_c1] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_c1];
  d_probeVars[admsProbeID_V_s_c1][admsProbeID_V_s_c1] = 1.0;
  probeVars[admsProbeID_V_b1_b2] = (*solVectorPtr)[li_b1] - (*solVectorPtr)[li_b2];
  d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2] = 1.0;
  probeVars[admsProbeID_V_b1_e1] = (*solVectorPtr)[li_b1] - (*solVectorPtr)[li_e1];
  d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1] = 1.0;
  probeVars[admsProbeID_V_b2_e1] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_e1];
  d_probeVars[admsProbeID_V_b2_e1][admsProbeID_V_b2_e1] = 1.0;
  probeVars[admsProbeID_V_b2_c2] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_c2];
  d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2] = 1.0;
  probeVars[admsProbeID_V_b2_c1] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_c1];
  d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1] = 1.0;
  probeVars[admsProbeID_V_dt_GND] = (*solVectorPtr)[li_dt];
  d_probeVars[admsProbeID_V_dt_GND][admsProbeID_V_dt_GND] = 1.0;


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[admsProbeID_V_b1_b2] *= (model_.TYPE);
  d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2] *= (model_.TYPE);
  probeVars[admsProbeID_V_b1_e1] *= (model_.TYPE);
  d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1] *= (model_.TYPE);
  probeVars[admsProbeID_V_b2_c2] *= (model_.TYPE);
  d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2] *= (model_.TYPE);
  probeVars[admsProbeID_V_b2_c1] *= (model_.TYPE);
  d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1] *= (model_.TYPE);

  // Copy probes into limiting vars

  Vb1b2_orig = Vb1b2_limited = probeVars[admsProbeID_V_b1_b2];
  probeDiffs[admsProbeID_V_b1_b2] = 0.0;
  Vb1e1_orig = Vb1e1_limited = probeVars[admsProbeID_V_b1_e1];
  probeDiffs[admsProbeID_V_b1_e1] = 0.0;
  Vb2c2_orig = Vb2c2_limited = probeVars[admsProbeID_V_b2_c2];
  probeDiffs[admsProbeID_V_b2_c2] = 0.0;
  Vb2c1_orig = Vb2c1_limited = probeVars[admsProbeID_V_b2_c1];
  probeDiffs[admsProbeID_V_b2_c1] = 0.0;

  origFlag = true;

  if (getSolverState().newtonIter == 0)
  {

    if (!(getSolverState().dcopFlag)||(getSolverState().locaEnabledFlag && getSolverState().dcopFlag))
    {
      Vb1b2_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b1_b2];
      Vb1e1_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b1_e1];
      Vb2c2_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b2_c2];
      Vb2c1_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b2_c1];
    }
    else
    {
      Vb1b2_old = Vb1b2_limited;
      Vb1e1_old = Vb1e1_limited;
      Vb2c2_old = Vb2c2_limited;
      Vb2c1_old = Vb2c1_limited;
    }
  }
  else
  {
    Vb1b2_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b1_b2];
    Vb1e1_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b1_e1];
    Vb2c2_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b2_c2];
    Vb2c1_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b2_c1];
  }
  // -- code converted from analog/code block

  d_Tki_dV_dt_GND = d_probeVars[admsProbeID_V_dt_GND][admsProbeID_V_dt_GND];
  Tki = (probeVars[admsProbeID_V_dt_GND]);
  if ((Tki<0.0))
  {
    {
      double value_log_0 = log((1.0-Tki));
      double  deriv_log_0_d0 = (1.0/(1.0-Tki));

      d_Tki_dV_dt_GND = (-(deriv_log_0_d0*((-d_Tki_dV_dt_GND))));
      Tki = (-value_log_0);
    }
  }
  if ((Tki<200.0))
  {

    d_Vdt_dV_dt_GND = d_Tki_dV_dt_GND;
    Vdt = Tki;
  }
  else
  {
    {
      double value_log_0 = log((1.0+(Tki-200.0)));
      double  deriv_log_0_d0 = (1.0/(1.0+(Tki-200.0)));

      d_Vdt_dV_dt_GND = (deriv_log_0_d0*(d_Tki_dV_dt_GND));
      Vdt = (200.0+value_log_0);
    }
  }

  Vdt = Vdt;

  d_Tk_dV_dt_GND = d_Vdt_dV_dt_GND;
  Tk = (Tamb+Vdt);

  d_tN_dV_dt_GND = (d_Tk_dV_dt_GND/Trk);
  tN = (Tk/Trk);

  d_Vt_dV_dt_GND = (8.61708691805812512584e-5*d_Tk_dV_dt_GND);
  Vt = (8.61708691805812512584e-5*Tk);
  Vtr = (8.61708691805812512584e-5*Trk);

  d_VtINV_dV_dt_GND = (-d_Vt_dV_dt_GND/Vt/Vt);
  VtINV = (1.0/Vt);
  VtrINV = (1.0/Vtr);

  d_VdtINV_dV_dt_GND = d_VtINV_dV_dt_GND;
  VdtINV = (VtINV-VtrINV);
  {
    double value_log_0 = log(tN);
    double  deriv_log_0_d0 = (1.0/tN);

    d_lntN_dV_dt_GND = (deriv_log_0_d0*(d_tN_dV_dt_GND));
    lntN = value_log_0;
  }

  d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
  d_dxa_dV_dt_GND = ((-(((Tk+(model_.TVGEB))*((((model_.AVGEB)*Tk)*d_Tk_dV_dt_GND)+(((model_.AVGEB)*d_Tk_dV_dt_GND)*Tk))-(((model_.AVGEB)*Tk)*Tk)*d_Tk_dV_dt_GND)/(Tk+(model_.TVGEB))/(Tk+(model_.TVGEB))))/0.1);
  dxa = (((VGZEBOK-((((model_.AVGEB)*Tk)*Tk)/(Tk+(model_.TVGEB))))-0.05)/0.1);
  if (((VGZEBOK-((((model_.AVGEB)*Tk)*Tk)/(Tk+(model_.TVGEB))))<0.05))
  {
    {
      double value_exp_0 = exp(dxa);
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VGZEB_T_dV_dt_GND = (0.1*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))));
      VGZEB_T = (0.05+(0.1*value_log_1));
    }
  }
  else
  {
    {
      double value_exp_0 = exp((-dxa));
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VGZEB_T_dV_dt_GND = ((-(((Tk+(model_.TVGEB))*((((model_.AVGEB)*Tk)*d_Tk_dV_dt_GND)+(((model_.AVGEB)*d_Tk_dV_dt_GND)*Tk))-(((model_.AVGEB)*Tk)*Tk)*d_Tk_dV_dt_GND)/(Tk+(model_.TVGEB))/(Tk+(model_.TVGEB))))+(0.1*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND)))))));
      VGZEB_T = ((VGZEBOK-((((model_.AVGEB)*Tk)*Tk)/(Tk+(model_.TVGEB))))+(0.1*value_log_1));
    }
  }

  VGZEB_T = VGZEB_T;
  {
    double value_log_0 = log(tN);
    double  deriv_log_0_d0 = (1.0/tN);

    d_UdeT_dV_dt_GND = ((((((-3.0)*Vt)*(deriv_log_0_d0*(d_tN_dV_dt_GND)))+(((-3.0)*d_Vt_dV_dt_GND)*value_log_0))+((model_.VDE)*d_tN_dV_dt_GND))+((-d_tN_dV_dt_GND)*(model_.VGB)));
    UdeT = (((((-3.0)*Vt)*value_log_0)+((model_.VDE)*tN))+((1.0-tN)*(model_.VGB)));
  }

  d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
  d_dxa_dV_dt_GND = ((Vt*(-d_UdeT_dV_dt_GND)-(0.05-UdeT)*d_Vt_dV_dt_GND)/Vt/Vt);
  dxa = ((0.05-UdeT)/Vt);
  if ((0.05<UdeT))
  {
    {
      double value_exp_0 = exp(dxa);
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VDE_T_dV_dt_GND = (d_UdeT_dV_dt_GND+((Vt*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_Vt_dV_dt_GND*value_log_1)));
      VDE_T = (UdeT+(Vt*value_log_1));
    }
  }
  else
  {
    {
      double value_exp_0 = exp((-dxa));
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VDE_T_dV_dt_GND = ((Vt*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_Vt_dV_dt_GND*value_log_1));
      VDE_T = (0.05+(Vt*value_log_1));
    }
  }

  VDE_T = VDE_T;
  {
    double value_log_0 = log(tN);
    double  deriv_log_0_d0 = (1.0/tN);

    d_UdcT_dV_dt_GND = ((((((-3.0)*Vt)*(deriv_log_0_d0*(d_tN_dV_dt_GND)))+(((-3.0)*d_Vt_dV_dt_GND)*value_log_0))+((model_.VDC)*d_tN_dV_dt_GND))+((-d_tN_dV_dt_GND)*(model_.VGC)));
    UdcT = (((((-3.0)*Vt)*value_log_0)+((model_.VDC)*tN))+((1.0-tN)*(model_.VGC)));
  }

  d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
  d_dxa_dV_dt_GND = ((Vt*(-d_UdcT_dV_dt_GND)-(0.05-UdcT)*d_Vt_dV_dt_GND)/Vt/Vt);
  dxa = ((0.05-UdcT)/Vt);
  if ((0.05<UdcT))
  {
    {
      double value_exp_0 = exp(dxa);
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VDC_T_dV_dt_GND = (d_UdcT_dV_dt_GND+((Vt*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_Vt_dV_dt_GND*value_log_1)));
      VDC_T = (UdcT+(Vt*value_log_1));
    }
  }
  else
  {
    {
      double value_exp_0 = exp((-dxa));
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VDC_T_dV_dt_GND = ((Vt*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_Vt_dV_dt_GND*value_log_1));
      VDC_T = (0.05+(Vt*value_log_1));
    }
  }

  VDC_T = VDC_T;
  {
    double value_log_0 = log(tN);
    double  deriv_log_0_d0 = (1.0/tN);

    d_UdsT_dV_dt_GND = ((((((-3.0)*Vt)*(deriv_log_0_d0*(d_tN_dV_dt_GND)))+(((-3.0)*d_Vt_dV_dt_GND)*value_log_0))+((model_.VDS)*d_tN_dV_dt_GND))+((-d_tN_dV_dt_GND)*(model_.VGS)));
    UdsT = (((((-3.0)*Vt)*value_log_0)+((model_.VDS)*tN))+((1.0-tN)*(model_.VGS)));
  }

  d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
  d_dxa_dV_dt_GND = ((Vt*(-d_UdsT_dV_dt_GND)-(0.05-UdsT)*d_Vt_dV_dt_GND)/Vt/Vt);
  dxa = ((0.05-UdsT)/Vt);
  if ((0.05<UdsT))
  {
    {
      double value_exp_0 = exp(dxa);
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VDS_T_dV_dt_GND = (d_UdsT_dV_dt_GND+((Vt*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_Vt_dV_dt_GND*value_log_1)));
      VDS_T = (UdsT+(Vt*value_log_1));
    }
  }
  else
  {
    {
      double value_exp_0 = exp((-dxa));
      double value_log_1 = log((1.0+value_exp_0));
      double  deriv_exp_0_d0 = value_exp_0;
      double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

      d_VDS_T_dV_dt_GND = ((Vt*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_Vt_dV_dt_GND*value_log_1));
      VDS_T = (0.05+(Vt*value_log_1));
    }
  }

  VDS_T = VDS_T;

  d_inv_VDE_T_dV_dt_GND = (-d_VDE_T_dV_dt_GND/VDE_T/VDE_T);
  inv_VDE_T = (1.0/VDE_T);
  {
    double value_pow_0 = pow(((model_.VDE)*inv_VDE_T),(model_.PE));
    double  deriv_pow_0_d0 = ((((model_.VDE)*inv_VDE_T) == 0.0)?0.0:(value_pow_0*(model_.PE)/((model_.VDE)*inv_VDE_T)));

    d_CJE_T_div_CJE_dV_dt_GND = (deriv_pow_0_d0*(((model_.VDE)*d_inv_VDE_T_dV_dt_GND)));
    CJE_T_div_CJE = value_pow_0;
  }

  d_CJE_T_dV_dt_GND = ((model_.CJE)*d_CJE_T_div_CJE_dV_dt_GND);
  CJE_T = ((model_.CJE)*CJE_T_div_CJE);
  {
    double value_pow_0 = pow(((model_.VDS)/VDS_T),(model_.PS));
    double  deriv_pow_0_d0 = ((((model_.VDS)/VDS_T) == 0.0)?0.0:(value_pow_0*(model_.PS)/((model_.VDS)/VDS_T)));

    d_CJS_T_dV_dt_GND = ((model_.CJS)*(deriv_pow_0_d0*((-(model_.VDS)*d_VDS_T_dV_dt_GND/VDS_T/VDS_T))));
    CJS_T = ((model_.CJS)*value_pow_0);
  }
  {
    double value_pow_0 = pow(((model_.VDC)/VDC_T),(model_.PC));
    double  deriv_pow_0_d0 = ((((model_.VDC)/VDC_T) == 0.0)?0.0:(value_pow_0*(model_.PC)/((model_.VDC)/VDC_T)));

    d_CJCscale_dV_dt_GND = ((1.0-(model_.XP))*(deriv_pow_0_d0*((-(model_.VDC)*d_VDC_T_dV_dt_GND/VDC_T/VDC_T))));
    CJCscale = (((1.0-(model_.XP))*value_pow_0)+(model_.XP));
  }

  d_CJCscaleINV_dV_dt_GND = (-d_CJCscale_dV_dt_GND/CJCscale/CJCscale);
  CJCscaleINV = (1.0/CJCscale);

  d_CJC_T_dV_dt_GND = ((model_.CJC)*d_CJCscale_dV_dt_GND);
  CJC_T = ((model_.CJC)*CJCscale);

  d_XP_T_dV_dt_GND = ((model_.XP)*d_CJCscaleINV_dV_dt_GND);
  XP_T = ((model_.XP)*CJCscaleINV);
  {
    double value_exp_0 = exp((lntN*(model_.AE)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RE_T_dV_dt_GND = ((model_.RE)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.AE)))));
    RE_T = ((model_.RE)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*((model_.AB)-(model_.AQBO))));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RBV_T_dV_dt_GND = ((model_.RBV)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*((model_.AB)-(model_.AQBO))))));
    RBV_T = ((model_.RBV)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(model_.AEX)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RBC_T_dV_dt_GND = ((model_.RBC)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.AEX)))));
    RBC_T = ((model_.RBC)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(model_.AC)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RCCxx_T_dV_dt_GND = ((model_.RCC)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.AC)))));
    RCCxx_T = ((model_.RCC)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(model_.ACBL)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RCCex_T_dV_dt_GND = ((model_.RCBLX)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.ACBL)))));
    RCCex_T = ((model_.RCBLX)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(model_.ACBL)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RCCin_T_dV_dt_GND = ((model_.RCBLI)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.ACBL)))));
    RCCin_T = ((model_.RCBLI)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(model_.AEPI)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_RCV_T_dV_dt_GND = ((model_.RCV)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.AEPI)))));
    RCV_T = ((model_.RCV)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(((model_.AE)-(model_.AB))-(model_.AQBO))));
    double value_exp_1 = exp(((-(model_.DVGBF))*VdtINV));
    double  deriv_exp_0_d0 = value_exp_0;
    double  deriv_exp_1_d0 = value_exp_1;

    d_BF_T_dV_dt_GND = ((((model_.BF)*value_exp_0)*(deriv_exp_1_d0*(((-(model_.DVGBF))*d_VdtINV_dV_dt_GND))))+(((model_.BF)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(((model_.AE)-(model_.AB))-(model_.AQBO))))))*value_exp_1));
    BF_T = (((model_.BF)*value_exp_0)*value_exp_1);
  }
  {
    double value_exp_0 = exp(((-(model_.DVGBR))*VdtINV));
    double  deriv_exp_0_d0 = value_exp_0;

    d_BRI_T_dV_dt_GND = ((model_.BRI)*(deriv_exp_0_d0*(((-(model_.DVGBR))*d_VdtINV_dV_dt_GND))));
    BRI_T = ((model_.BRI)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(((4.0-(model_.AB))-(model_.AQBO))+(model_.DAIS))));
    double value_exp_1 = exp(((-(model_.VGB))*VdtINV));
    double  deriv_exp_0_d0 = value_exp_0;
    double  deriv_exp_1_d0 = value_exp_1;

    d_IS_T_dV_dt_GND = ((((model_.IS)*value_exp_0)*(deriv_exp_1_d0*(((-(model_.VGB))*d_VdtINV_dV_dt_GND))))+(((model_.IS)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(((4.0-(model_.AB))-(model_.AQBO))+(model_.DAIS))))))*value_exp_1));
    IS_T = (((model_.IS)*value_exp_0)*value_exp_1);
  }
  {
    double value_exp_0 = exp((lntN*(1.0-(model_.AB))));
    double  deriv_exp_0_d0 = value_exp_0;

    d_IK_T_dV_dt_GND = ((model_.IK)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(1.0-(model_.AB))))));
    IK_T = ((model_.IK)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(6.0-(2.0*(model_.MLF)))));
    double value_exp_1 = exp((((-(model_.VGJ))*VdtINV)/(model_.MLF)));
    double  deriv_exp_0_d0 = value_exp_0;
    double  deriv_exp_1_d0 = value_exp_1;

    d_IBF_T_dV_dt_GND = ((((model_.IBF)*value_exp_0)*(deriv_exp_1_d0*((((-(model_.VGJ))*d_VdtINV_dV_dt_GND)/(model_.MLF)))))+(((model_.IBF)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(6.0-(2.0*(model_.MLF)))))))*value_exp_1));
    IBF_T = (((model_.IBF)*value_exp_0)*value_exp_1);
  }
  {
    double value_exp_0 = exp((((-(model_.VGC))*VdtINV)/2.0));
    double  deriv_exp_0_d0 = value_exp_0;

    d_IBR_T_dV_dt_GND = (((((model_.IBR)*tN)*tN)*(deriv_exp_0_d0*((((-(model_.VGC))*d_VdtINV_dV_dt_GND)/2.0))))+(((((model_.IBR)*tN)*d_tN_dV_dt_GND)+(((model_.IBR)*d_tN_dV_dt_GND)*tN))*value_exp_0));
    IBR_T = ((((model_.IBR)*tN)*tN)*value_exp_0);
  }
  {
    double value_pow_0 = pow((VGZEB_T*inv_VGZEB_Tr),(-0.5));
    double  deriv_pow_0_d0 = (((VGZEB_T*inv_VGZEB_Tr) == 0.0)?0.0:(value_pow_0*(-0.5)/(VGZEB_T*inv_VGZEB_Tr)));

    d_tempx_dV_dt_GND = (deriv_pow_0_d0*((d_VGZEB_T_dV_dt_GND*inv_VGZEB_Tr)));
    tempx = value_pow_0;
  }

  d_y_dV_dt_GND = (-d_CJE_T_div_CJE_dV_dt_GND/CJE_T_div_CJE/CJE_T_div_CJE);
  y = (1.0/CJE_T_div_CJE);

  d_nZEB_T_dV_dt_GND = ((((((((((model_.NZEB)*VGZEB_T)*VGZEB_T)*tempx)*y)*(model_.VDE))*d_inv_VDE_T_dV_dt_GND)+((((((((model_.NZEB)*VGZEB_T)*VGZEB_T)*tempx)*d_y_dV_dt_GND)+((((((model_.NZEB)*VGZEB_T)*VGZEB_T)*d_tempx_dV_dt_GND)+(((((model_.NZEB)*VGZEB_T)*d_VGZEB_T_dV_dt_GND)+(((model_.NZEB)*d_VGZEB_T_dV_dt_GND)*VGZEB_T))*tempx))*y))*(model_.VDE))*inv_VDE_T))*inv_VGZEB_Tr)*inv_VGZEB_Tr);
  nZEB_T = (((((((((model_.NZEB)*VGZEB_T)*VGZEB_T)*tempx)*y)*(model_.VDE))*inv_VDE_T)*inv_VGZEB_Tr)*inv_VGZEB_Tr);
  {
    double value_exp_0 = exp(((model_.NZEB)-nZEB_T));
    double  deriv_exp_0_d0 = value_exp_0;

    d_IZEB_T_dV_dt_GND = (((((((((model_.IZEB)*tempx)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*(deriv_exp_0_d0*((-d_nZEB_T_dV_dt_GND))))+(((((((((model_.IZEB)*tempx)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*d_CJE_T_div_CJE_dV_dt_GND)+((((((((model_.IZEB)*tempx)*VDE_T)*d_VDE_T_dV_dt_GND)+(((((model_.IZEB)*tempx)*d_VDE_T_dV_dt_GND)+(((model_.IZEB)*d_tempx_dV_dt_GND)*VDE_T))*VDE_T))*inv_VDE)*inv_VDE)*CJE_T_div_CJE))*value_exp_0));
    IZEB_T = ((((((((model_.IZEB)*tempx)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*(model_.AQBO)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_tempx_dV_dt_GND = (deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.AQBO))));
    tempx = value_exp_0;
  }

  d_VEF_T_dV_dt_GND = ((((model_.VEF)*tempx)*d_CJCscaleINV_dV_dt_GND)+(((model_.VEF)*d_tempx_dV_dt_GND)*CJCscaleINV));
  VEF_T = (((model_.VEF)*tempx)*CJCscaleINV);

  d_VER_T_dV_dt_GND = ((((model_.VER)*tempx)*d_y_dV_dt_GND)+(((model_.VER)*d_tempx_dV_dt_GND)*y));
  VER_T = (((model_.VER)*tempx)*y);
  {
    double value_exp_0 = exp((lntN*(4.0-(model_.AS))));
    double value_exp_1 = exp(((-(model_.VGS))*VdtINV));
    double  deriv_exp_0_d0 = value_exp_0;
    double  deriv_exp_1_d0 = value_exp_1;

    d_ISS_T_dV_dt_GND = ((((model_.ISS)*value_exp_0)*(deriv_exp_1_d0*(((-(model_.VGS))*d_VdtINV_dV_dt_GND))))+(((model_.ISS)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(4.0-(model_.AS))))))*value_exp_1));
    ISS_T = (((model_.ISS)*value_exp_0)*value_exp_1);
  }
  {
    double value_exp_0 = exp((lntN*(3.5-(0.5*(model_.ASUB)))));
    double value_exp_1 = exp(((-(model_.VGS))*VdtINV));
    double  deriv_exp_0_d0 = value_exp_0;
    double  deriv_exp_1_d0 = value_exp_1;

    d_ICSS_T_dV_dt_GND = ((((model_.ICSS)*value_exp_0)*(deriv_exp_1_d0*(((-(model_.VGS))*d_VdtINV_dV_dt_GND))))+(((model_.ICSS)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(3.5-(0.5*(model_.ASUB)))))))*value_exp_1));
    ICSS_T = (((model_.ICSS)*value_exp_0)*value_exp_1);
  }
  if ((ISS_T>0.0))
  {
    {
      double value_exp_0 = exp((lntN*(1.0-(model_.AS))));
      double  deriv_exp_0_d0 = value_exp_0;

      d_IKS_T_dV_dt_GND = (((((model_.IKS)*value_exp_0)*(IS_T/(model_.IS)))*(-(model_.ISS)*d_ISS_T_dV_dt_GND/ISS_T/ISS_T))+(((((model_.IKS)*value_exp_0)*(d_IS_T_dV_dt_GND/(model_.IS)))+(((model_.IKS)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(1.0-(model_.AS))))))*(IS_T/(model_.IS))))*((model_.ISS)/ISS_T)));
      IKS_T = ((((model_.IKS)*value_exp_0)*(IS_T/(model_.IS)))*((model_.ISS)/ISS_T));
    }
  }
  else
  {
    {
      double value_exp_0 = exp((lntN*(1.0-(model_.AS))));
      double  deriv_exp_0_d0 = value_exp_0;

      d_IKS_T_dV_dt_GND = ((model_.IKS)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(1.0-(model_.AS))))));
      IKS_T = ((model_.IKS)*value_exp_0);
    }
  }
  {
    double value_exp_0 = exp((lntN*((model_.AB)-2.0)));
    double value_exp_1 = exp(((-(model_.DVGTE))*VdtINV));
    double  deriv_exp_0_d0 = value_exp_0;
    double  deriv_exp_1_d0 = value_exp_1;

    d_TAUE_T_dV_dt_GND = ((((model_.TAUE)*value_exp_0)*(deriv_exp_1_d0*(((-(model_.DVGTE))*d_VdtINV_dV_dt_GND))))+(((model_.TAUE)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*((model_.AB)-2.0)))))*value_exp_1));
    TAUE_T = (((model_.TAUE)*value_exp_0)*value_exp_1);
  }
  {
    double value_exp_0 = exp((lntN*(((model_.AQBO)+(model_.AB))-1.0)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_TAUB_T_dV_dt_GND = ((model_.TAUB)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(((model_.AQBO)+(model_.AB))-1.0)))));
    TAUB_T = ((model_.TAUB)*value_exp_0);
  }
  {
    double value_exp_0 = exp((lntN*((model_.AEPI)-1.0)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_TEPI_T_dV_dt_GND = ((model_.TEPI)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*((model_.AEPI)-1.0)))));
    TEPI_T = ((model_.TEPI)*value_exp_0);
  }

  d_TAUR_T_dV_dt_GND = (((model_.TAUR)*(d_TAUB_T_dV_dt_GND+d_TEPI_T_dV_dt_GND))/((model_.TAUB)+(model_.TEPI)));
  TAUR_T = (((model_.TAUR)*(TAUB_T+TEPI_T))/((model_.TAUB)+(model_.TEPI)));

  d_Tk300_dV_dt_GND = d_Tk_dV_dt_GND;
  Tk300 = (Tk-300.0);
  if ((Tk<525.0))
  {

    d_BnT_dV_dt_GND = (Bn*((7.2e-4*d_Tk300_dV_dt_GND)-(((1.6e-6*Tk300)*d_Tk300_dV_dt_GND)+((1.6e-6*d_Tk300_dV_dt_GND)*Tk300))));
    BnT = (Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
  }
  else
  {

    d_BnT_dV_dt_GND =  0.0;
    BnT = (Bn*1.081);
  }
  {
    double value_exp_0 = exp((lntN*(model_.AQBO)));
    double  deriv_exp_0_d0 = value_exp_0;

    d_DEG_T_dV_dt_GND = ((model_.DEG)*(deriv_exp_0_d0*((d_lntN_dV_dt_GND*(model_.AQBO)))));
    DEG_T = ((model_.DEG)*value_exp_0);
  }
  {
    double value_pow_0 = pow((Tamb/Trk),(model_.ATH));
    RTH_Tamb = ((model_.RTH)*value_pow_0);
  }

  d_IS_TM_dV_dt_GND = (d_IS_T_dV_dt_GND*MULT);
  IS_TM = (IS_T*MULT);

  d_IK_TM_dV_dt_GND = (d_IK_T_dV_dt_GND*MULT);
  IK_TM = (IK_T*MULT);

  d_IBF_TM_dV_dt_GND = (d_IBF_T_dV_dt_GND*MULT);
  IBF_TM = (IBF_T*MULT);

  d_IBR_TM_dV_dt_GND = (d_IBR_T_dV_dt_GND*MULT);
  IBR_TM = (IBR_T*MULT);

  d_IZEB_TM_dV_dt_GND = (d_IZEB_T_dV_dt_GND*MULT);
  IZEB_TM = (IZEB_T*MULT);
  IHC_M = ((model_.IHC)*MULT);

  d_ISS_TM_dV_dt_GND = (d_ISS_T_dV_dt_GND*MULT);
  ISS_TM = (ISS_T*MULT);

  d_ICSS_TM_dV_dt_GND = (d_ICSS_T_dV_dt_GND*MULT);
  ICSS_TM = (ICSS_T*MULT);

  d_IKS_TM_dV_dt_GND = (d_IKS_T_dV_dt_GND*MULT);
  IKS_TM = (IKS_T*MULT);

  d_CJE_TM_dV_dt_GND = (d_CJE_T_dV_dt_GND*MULT);
  CJE_TM = (CJE_T*MULT);

  d_CJC_TM_dV_dt_GND = (d_CJC_T_dV_dt_GND*MULT);
  CJC_TM = (CJC_T*MULT);

  d_CJS_TM_dV_dt_GND = (d_CJS_T_dV_dt_GND*MULT);
  CJS_TM = (CJS_T*MULT);

  d_RE_TM_dV_dt_GND = (d_RE_T_dV_dt_GND*invMULT);
  RE_TM = (RE_T*invMULT);

  d_RBC_TM_dV_dt_GND = (d_RBC_T_dV_dt_GND*invMULT);
  RBC_TM = (RBC_T*invMULT);

  d_RBV_TM_dV_dt_GND = (d_RBV_T_dV_dt_GND*invMULT);
  RBV_TM = (RBV_T*invMULT);

  d_RCCxx_TM_dV_dt_GND = (d_RCCxx_T_dV_dt_GND*invMULT);
  RCCxx_TM = (RCCxx_T*invMULT);

  d_RCCex_TM_dV_dt_GND = (d_RCCex_T_dV_dt_GND*invMULT);
  RCCex_TM = (RCCex_T*invMULT);

  d_RCCin_TM_dV_dt_GND = (d_RCCin_T_dV_dt_GND*invMULT);
  RCCin_TM = (RCCin_T*invMULT);

  d_RCV_TM_dV_dt_GND = (d_RCV_T_dV_dt_GND*invMULT);
  RCV_TM = (RCV_T*invMULT);
  if (((model_.RCC)>0.0))
  {

    d_GCCxx_TM_dV_dt_GND = (-d_RCCxx_TM_dV_dt_GND/RCCxx_TM/RCCxx_TM);
    GCCxx_TM = (1.0/RCCxx_TM);
  }
  else
  {

    d_GCCxx_TM_dV_dt_GND =  0.0;
    GCCxx_TM = 0;
  }
  if (((model_.RCBLX)>0.0))
  {

    d_GCCex_TM_dV_dt_GND = (-d_RCCex_TM_dV_dt_GND/RCCex_TM/RCCex_TM);
    GCCex_TM = (1.0/RCCex_TM);
  }
  else
  {

    d_GCCex_TM_dV_dt_GND =  0.0;
    GCCex_TM = 0;
  }
  if (((model_.RCBLI)>0.0))
  {

    d_GCCin_TM_dV_dt_GND = (-d_RCCin_TM_dV_dt_GND/RCCin_TM/RCCin_TM);
    GCCin_TM = (1.0/RCCin_TM);
  }
  else
  {

    d_GCCin_TM_dV_dt_GND =  0.0;
    GCCin_TM = 0;
  }
  RTH_Tamb_M = (RTH_Tamb*invMULT);
  {


    //Vb2c1 = ($limit(V(b2,c1),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb2c1_limited = AnalogFunctions::trunc_ev(Vb2c1_limited,Vb2c1_old,(-(model_.VER)),0.7);
      if (Vb2c1_limited != Vb2c1_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b2_c1] = Vb2c1_limited - Vb2c1_orig;
        probeVars[admsProbeID_V_b2_c1] += probeDiffs[admsProbeID_V_b2_c1];
      }
    }
    Vb2c1 = probeVars[admsProbeID_V_b2_c1];

    d_Vb2c1_dV_b2_c1 = d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1];



    //Vb2c2 = ($limit(V(b2,c2),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb2c2_limited = AnalogFunctions::trunc_ev(Vb2c2_limited,Vb2c2_old,(-(model_.VER)),0.7);
      if (Vb2c2_limited != Vb2c2_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b2_c2] = Vb2c2_limited - Vb2c2_orig;
        probeVars[admsProbeID_V_b2_c2] += probeDiffs[admsProbeID_V_b2_c2];
      }
    }
    Vb2c2 = probeVars[admsProbeID_V_b2_c2];

    d_Vb2c2_dV_b2_c2 = d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];


    d_Vb2e1_dV_b2_e1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_b2_e1][admsProbeID_V_b2_e1]);
    Vb2e1 = ((model_.TYPE)*(probeVars[admsProbeID_V_b2_e1]));


    //Vb1e1 = ($limit(V(b1,e1),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb1e1_limited = AnalogFunctions::trunc_ev(Vb1e1_limited,Vb1e1_old,(-(model_.VER)),0.7);
      if (Vb1e1_limited != Vb1e1_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b1_e1] = Vb1e1_limited - Vb1e1_orig;
        probeVars[admsProbeID_V_b1_e1] += probeDiffs[admsProbeID_V_b1_e1];
      }
    }
    Vb1e1 = probeVars[admsProbeID_V_b1_e1];

    d_Vb1e1_dV_b1_e1 = d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1];



    //Vb1b2 = ($limit(V(b1,b2),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb1b2_limited = AnalogFunctions::trunc_ev(Vb1b2_limited,Vb1b2_old,(-(model_.VER)),0.7);
      if (Vb1b2_limited != Vb1b2_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b1_b2] = Vb1b2_limited - Vb1b2_orig;
        probeVars[admsProbeID_V_b1_b2] += probeDiffs[admsProbeID_V_b1_b2];
      }
    }
    Vb1b2 = probeVars[admsProbeID_V_b1_b2];

    d_Vb1b2_dV_b1_b2 = d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];


    d_Vsc1_dV_s_c1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_s_c1][admsProbeID_V_s_c1]);
    Vsc1 = ((model_.TYPE)*(probeVars[admsProbeID_V_s_c1]));

    d_Vc1c2_dV_c1_c2 = ((model_.TYPE)*d_probeVars[admsProbeID_V_c1_c2][admsProbeID_V_c1_c2]);
    Vc1c2 = ((model_.TYPE)*(probeVars[admsProbeID_V_c1_c2]));

    d_Vee1_dV_e_e1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_e_e1][admsProbeID_V_e_e1]);
    Vee1 = ((model_.TYPE)*(probeVars[admsProbeID_V_e_e1]));

    d_Vbb1_dV_b_b1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_b_b1][admsProbeID_V_b_b1]);
    Vbb1 = ((model_.TYPE)*(probeVars[admsProbeID_V_b_b1]));

    d_Vbe_dV_b_e = ((model_.TYPE)*d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e]);
    Vbe = ((model_.TYPE)*(probeVars[admsProbeID_V_b_e]));

    d_Vbc_dV_b_c = ((model_.TYPE)*d_probeVars[admsProbeID_V_b_c][admsProbeID_V_b_c]);
    Vbc = ((model_.TYPE)*(probeVars[admsProbeID_V_b_c]));
    if (((model_.RCBLX)>0.0))
    {
      if (((model_.RCBLI)>0.0))
      {

        d_Vc4c1_dV_c4_c1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_c4_c1][admsProbeID_V_c4_c1]);
        Vc4c1 = ((model_.TYPE)*(probeVars[admsProbeID_V_c4_c1]));

        d_Vc3c4_dV_c3_c1 =  0.0;
        d_Vc3c4_dV_c3_c4 = ((model_.TYPE)*d_probeVars[admsProbeID_V_c3_c4][admsProbeID_V_c3_c4]);
        Vc3c4 = ((model_.TYPE)*(probeVars[admsProbeID_V_c3_c4]));
      }
      else
      {

        d_Vc4c1_dV_c4_c1 =  0.0;
        Vc4c1 = 0;

        d_Vc3c4_dV_c3_c4 =  0.0;
        d_Vc3c4_dV_c3_c1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_c3_c1][admsProbeID_V_c3_c1]);
        Vc3c4 = ((model_.TYPE)*(probeVars[admsProbeID_V_c3_c1]));
      }
    }
    else
    {
      if (((model_.RCBLI)>0.0))
      {

        d_Vc4c1_dV_c4_c1 = ((model_.TYPE)*d_probeVars[admsProbeID_V_c4_c1][admsProbeID_V_c4_c1]);
        Vc4c1 = ((model_.TYPE)*(probeVars[admsProbeID_V_c4_c1]));

        d_Vc3c4_dV_c3_c1 = d_Vc3c4_dV_c3_c4 =  0.0;
        Vc3c4 = 0;
      }
      else
      {

        d_Vc4c1_dV_c4_c1 =  0.0;
        Vc4c1 = 0;

        d_Vc3c4_dV_c3_c1 = d_Vc3c4_dV_c3_c4 =  0.0;
        Vc3c4 = 0;
      }
    }

    d_Vb1c4_dV_c4_c1 = (-d_Vc4c1_dV_c4_c1);
    d_Vb1c4_dV_c1_c2 = (-d_Vc1c2_dV_c1_c2);
    d_Vb1c4_dV_b2_c2 = d_Vb2c2_dV_b2_c2;
    d_Vb1c4_dV_b1_b2 = d_Vb1b2_dV_b1_b2;
    Vb1c4 = (((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);

    d_Vcc3_dV_c3_c4 = (-d_Vc3c4_dV_c3_c4);
    d_Vcc3_dV_c3_c1 = (-d_Vc3c4_dV_c3_c1);
    d_Vcc3_dV_c4_c1 = d_Vb1c4_dV_c4_c1;
    d_Vcc3_dV_c1_c2 = d_Vb1c4_dV_c1_c2;
    d_Vcc3_dV_b2_c2 = d_Vb1c4_dV_b2_c2;
    d_Vcc3_dV_b1_b2 = d_Vb1c4_dV_b1_b2;
    d_Vcc3_dV_b_b1 = d_Vbb1_dV_b_b1;
    d_Vcc3_dV_b_c = (-d_Vbc_dV_b_c);
    Vcc3 = ((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);

    d_Vbc3_dV_c3_c4 = d_Vcc3_dV_c3_c4;
    d_Vbc3_dV_c3_c1 = d_Vcc3_dV_c3_c1;
    d_Vbc3_dV_c4_c1 = d_Vcc3_dV_c4_c1;
    d_Vbc3_dV_c1_c2 = d_Vcc3_dV_c1_c2;
    d_Vbc3_dV_b2_c2 = d_Vcc3_dV_b2_c2;
    d_Vbc3_dV_b1_b2 = d_Vcc3_dV_b1_b2;
    d_Vbc3_dV_b_b1 = d_Vcc3_dV_b_b1;
    d_Vbc3_dV_b_c = (d_Vbc_dV_b_c+d_Vcc3_dV_b_c);
    Vbc3 = (Vbc+Vcc3);

    d_Vsc4_dV_c4_c1 = (-d_Vc4c1_dV_c4_c1);
    d_Vsc4_dV_s_c1 = d_Vsc1_dV_s_c1;
    Vsc4 = (Vsc1-Vc4c1);

    d_Vsc3_dV_c3_c4 = (-d_Vc3c4_dV_c3_c4);
    d_Vsc3_dV_c3_c1 = (-d_Vc3c4_dV_c3_c1);
    d_Vsc3_dV_c4_c1 = d_Vsc4_dV_c4_c1;
    d_Vsc3_dV_s_c1 = d_Vsc4_dV_s_c1;
    Vsc3 = (Vsc4-Vc3c4);
    if (((Vb2c2*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vb2c2*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb2c2_dV_dt_GND = (deriv_exp_0_d0*((Vb2c2*d_VtINV_dV_dt_GND)));
        d_eVb2c2_dV_b2_c2 = (deriv_exp_0_d0*((d_Vb2c2_dV_b2_c2*VtINV)));
        eVb2c2 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb2c2_dV_dt_GND = (expl*(Vb2c2*d_VtINV_dV_dt_GND));
      d_eVb2c2_dV_b2_c2 = (expl*(d_Vb2c2_dV_b2_c2*VtINV));
      eVb2c2 = (expl*(1.0+((Vb2c2*VtINV)-400.0)));
    }
    if (((Vb2e1*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vb2e1*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb2e1_dV_dt_GND = (deriv_exp_0_d0*((Vb2e1*d_VtINV_dV_dt_GND)));
        d_eVb2e1_dV_b2_e1 = (deriv_exp_0_d0*((d_Vb2e1_dV_b2_e1*VtINV)));
        eVb2e1 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb2e1_dV_dt_GND = (expl*(Vb2e1*d_VtINV_dV_dt_GND));
      d_eVb2e1_dV_b2_e1 = (expl*(d_Vb2e1_dV_b2_e1*VtINV));
      eVb2e1 = (expl*(1.0+((Vb2e1*VtINV)-400.0)));
    }
    if (((Vb1e1*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vb1e1*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb1e1_dV_dt_GND = (deriv_exp_0_d0*((Vb1e1*d_VtINV_dV_dt_GND)));
        d_eVb1e1_dV_b1_e1 = (deriv_exp_0_d0*((d_Vb1e1_dV_b1_e1*VtINV)));
        eVb1e1 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb1e1_dV_dt_GND = (expl*(Vb1e1*d_VtINV_dV_dt_GND));
      d_eVb1e1_dV_b1_e1 = (expl*(d_Vb1e1_dV_b1_e1*VtINV));
      eVb1e1 = (expl*(1.0+((Vb1e1*VtINV)-400.0)));
    }
    if (((Vb1c4*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vb1c4*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb1c4_dV_dt_GND = (deriv_exp_0_d0*((Vb1c4*d_VtINV_dV_dt_GND)));
        d_eVb1c4_dV_c4_c1 = (deriv_exp_0_d0*((d_Vb1c4_dV_c4_c1*VtINV)));
        d_eVb1c4_dV_c1_c2 = (deriv_exp_0_d0*((d_Vb1c4_dV_c1_c2*VtINV)));
        d_eVb1c4_dV_b2_c2 = (deriv_exp_0_d0*((d_Vb1c4_dV_b2_c2*VtINV)));
        d_eVb1c4_dV_b1_b2 = (deriv_exp_0_d0*((d_Vb1c4_dV_b1_b2*VtINV)));
        eVb1c4 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb1c4_dV_dt_GND = (expl*(Vb1c4*d_VtINV_dV_dt_GND));
      d_eVb1c4_dV_c4_c1 = (expl*(d_Vb1c4_dV_c4_c1*VtINV));
      d_eVb1c4_dV_c1_c2 = (expl*(d_Vb1c4_dV_c1_c2*VtINV));
      d_eVb1c4_dV_b2_c2 = (expl*(d_Vb1c4_dV_b2_c2*VtINV));
      d_eVb1c4_dV_b1_b2 = (expl*(d_Vb1c4_dV_b1_b2*VtINV));
      eVb1c4 = (expl*(1.0+((Vb1c4*VtINV)-400.0)));
    }
    if (((Vb1b2*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vb1b2*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb1b2_dV_dt_GND = (deriv_exp_0_d0*((Vb1b2*d_VtINV_dV_dt_GND)));
        d_eVb1b2_dV_b1_b2 = (deriv_exp_0_d0*((d_Vb1b2_dV_b1_b2*VtINV)));
        eVb1b2 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb1b2_dV_dt_GND = (expl*(Vb1b2*d_VtINV_dV_dt_GND));
      d_eVb1b2_dV_b1_b2 = (expl*(d_Vb1b2_dV_b1_b2*VtINV));
      eVb1b2 = (expl*(1.0+((Vb1b2*VtINV)-400.0)));
    }
    if (((Vbc3*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vbc3*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVbc3_dV_dt_GND = (deriv_exp_0_d0*((Vbc3*d_VtINV_dV_dt_GND)));
        d_eVbc3_dV_c3_c4 = (deriv_exp_0_d0*((d_Vbc3_dV_c3_c4*VtINV)));
        d_eVbc3_dV_c3_c1 = (deriv_exp_0_d0*((d_Vbc3_dV_c3_c1*VtINV)));
        d_eVbc3_dV_c4_c1 = (deriv_exp_0_d0*((d_Vbc3_dV_c4_c1*VtINV)));
        d_eVbc3_dV_c1_c2 = (deriv_exp_0_d0*((d_Vbc3_dV_c1_c2*VtINV)));
        d_eVbc3_dV_b2_c2 = (deriv_exp_0_d0*((d_Vbc3_dV_b2_c2*VtINV)));
        d_eVbc3_dV_b1_b2 = (deriv_exp_0_d0*((d_Vbc3_dV_b1_b2*VtINV)));
        d_eVbc3_dV_b_b1 = (deriv_exp_0_d0*((d_Vbc3_dV_b_b1*VtINV)));
        d_eVbc3_dV_b_c = (deriv_exp_0_d0*((d_Vbc3_dV_b_c*VtINV)));
        eVbc3 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVbc3_dV_dt_GND = (expl*(Vbc3*d_VtINV_dV_dt_GND));
      d_eVbc3_dV_c3_c4 = (expl*(d_Vbc3_dV_c3_c4*VtINV));
      d_eVbc3_dV_c3_c1 = (expl*(d_Vbc3_dV_c3_c1*VtINV));
      d_eVbc3_dV_c4_c1 = (expl*(d_Vbc3_dV_c4_c1*VtINV));
      d_eVbc3_dV_c1_c2 = (expl*(d_Vbc3_dV_c1_c2*VtINV));
      d_eVbc3_dV_b2_c2 = (expl*(d_Vbc3_dV_b2_c2*VtINV));
      d_eVbc3_dV_b1_b2 = (expl*(d_Vbc3_dV_b1_b2*VtINV));
      d_eVbc3_dV_b_b1 = (expl*(d_Vbc3_dV_b_b1*VtINV));
      d_eVbc3_dV_b_c = (expl*(d_Vbc3_dV_b_c*VtINV));
      eVbc3 = (expl*(1.0+((Vbc3*VtINV)-400.0)));
    }
    if (((Vsc1*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vsc1*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVsc1_dV_dt_GND = (deriv_exp_0_d0*((Vsc1*d_VtINV_dV_dt_GND)));
        d_eVsc1_dV_s_c1 = (deriv_exp_0_d0*((d_Vsc1_dV_s_c1*VtINV)));
        eVsc1 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVsc1_dV_dt_GND = (expl*(Vsc1*d_VtINV_dV_dt_GND));
      d_eVsc1_dV_s_c1 = (expl*(d_Vsc1_dV_s_c1*VtINV));
      eVsc1 = (expl*(1.0+((Vsc1*VtINV)-400.0)));
    }
    if (((Vsc3*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vsc3*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVsc3_dV_dt_GND = (deriv_exp_0_d0*((Vsc3*d_VtINV_dV_dt_GND)));
        d_eVsc3_dV_c3_c4 = (deriv_exp_0_d0*((d_Vsc3_dV_c3_c4*VtINV)));
        d_eVsc3_dV_c3_c1 = (deriv_exp_0_d0*((d_Vsc3_dV_c3_c1*VtINV)));
        d_eVsc3_dV_c4_c1 = (deriv_exp_0_d0*((d_Vsc3_dV_c4_c1*VtINV)));
        d_eVsc3_dV_s_c1 = (deriv_exp_0_d0*((d_Vsc3_dV_s_c1*VtINV)));
        eVsc3 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVsc3_dV_dt_GND = (expl*(Vsc3*d_VtINV_dV_dt_GND));
      d_eVsc3_dV_c3_c4 = (expl*(d_Vsc3_dV_c3_c4*VtINV));
      d_eVsc3_dV_c3_c1 = (expl*(d_Vsc3_dV_c3_c1*VtINV));
      d_eVsc3_dV_c4_c1 = (expl*(d_Vsc3_dV_c4_c1*VtINV));
      d_eVsc3_dV_s_c1 = (expl*(d_Vsc3_dV_s_c1*VtINV));
      eVsc3 = (expl*(1.0+((Vsc3*VtINV)-400.0)));
    }
    if (((Vsc4*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp((Vsc4*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVsc4_dV_dt_GND = (deriv_exp_0_d0*((Vsc4*d_VtINV_dV_dt_GND)));
        d_eVsc4_dV_c4_c1 = (deriv_exp_0_d0*((d_Vsc4_dV_c4_c1*VtINV)));
        d_eVsc4_dV_s_c1 = (deriv_exp_0_d0*((d_Vsc4_dV_s_c1*VtINV)));
        eVsc4 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVsc4_dV_dt_GND = (expl*(Vsc4*d_VtINV_dV_dt_GND));
      d_eVsc4_dV_c4_c1 = (expl*(d_Vsc4_dV_c4_c1*VtINV));
      d_eVsc4_dV_s_c1 = (expl*(d_Vsc4_dV_s_c1*VtINV));
      eVsc4 = (expl*(1.0+((Vsc4*VtINV)-400.0)));
    }
    if ((((Vbc3-VDC_T)*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp(((Vbc3-VDC_T)*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVbc3VDC_dV_dt_GND = (deriv_exp_0_d0*((((Vbc3-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV))));
        d_eVbc3VDC_dV_c3_c4 = (deriv_exp_0_d0*((d_Vbc3_dV_c3_c4*VtINV)));
        d_eVbc3VDC_dV_c3_c1 = (deriv_exp_0_d0*((d_Vbc3_dV_c3_c1*VtINV)));
        d_eVbc3VDC_dV_c4_c1 = (deriv_exp_0_d0*((d_Vbc3_dV_c4_c1*VtINV)));
        d_eVbc3VDC_dV_c1_c2 = (deriv_exp_0_d0*((d_Vbc3_dV_c1_c2*VtINV)));
        d_eVbc3VDC_dV_b2_c2 = (deriv_exp_0_d0*((d_Vbc3_dV_b2_c2*VtINV)));
        d_eVbc3VDC_dV_b1_b2 = (deriv_exp_0_d0*((d_Vbc3_dV_b1_b2*VtINV)));
        d_eVbc3VDC_dV_b_b1 = (deriv_exp_0_d0*((d_Vbc3_dV_b_b1*VtINV)));
        d_eVbc3VDC_dV_b_c = (deriv_exp_0_d0*((d_Vbc3_dV_b_c*VtINV)));
        eVbc3VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVbc3VDC_dV_dt_GND = (expl*(((Vbc3-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV)));
      d_eVbc3VDC_dV_c3_c4 = (expl*(d_Vbc3_dV_c3_c4*VtINV));
      d_eVbc3VDC_dV_c3_c1 = (expl*(d_Vbc3_dV_c3_c1*VtINV));
      d_eVbc3VDC_dV_c4_c1 = (expl*(d_Vbc3_dV_c4_c1*VtINV));
      d_eVbc3VDC_dV_c1_c2 = (expl*(d_Vbc3_dV_c1_c2*VtINV));
      d_eVbc3VDC_dV_b2_c2 = (expl*(d_Vbc3_dV_b2_c2*VtINV));
      d_eVbc3VDC_dV_b1_b2 = (expl*(d_Vbc3_dV_b1_b2*VtINV));
      d_eVbc3VDC_dV_b_b1 = (expl*(d_Vbc3_dV_b_b1*VtINV));
      d_eVbc3VDC_dV_b_c = (expl*(d_Vbc3_dV_b_c*VtINV));
      eVbc3VDC = (expl*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb1c4-VDC_T)*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp(((Vb1c4-VDC_T)*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb1c4VDC_dV_dt_GND = (deriv_exp_0_d0*((((Vb1c4-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV))));
        d_eVb1c4VDC_dV_c4_c1 = (deriv_exp_0_d0*((d_Vb1c4_dV_c4_c1*VtINV)));
        d_eVb1c4VDC_dV_c1_c2 = (deriv_exp_0_d0*((d_Vb1c4_dV_c1_c2*VtINV)));
        d_eVb1c4VDC_dV_b2_c2 = (deriv_exp_0_d0*((d_Vb1c4_dV_b2_c2*VtINV)));
        d_eVb1c4VDC_dV_b1_b2 = (deriv_exp_0_d0*((d_Vb1c4_dV_b1_b2*VtINV)));
        eVb1c4VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb1c4VDC_dV_dt_GND = (expl*(((Vb1c4-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV)));
      d_eVb1c4VDC_dV_c4_c1 = (expl*(d_Vb1c4_dV_c4_c1*VtINV));
      d_eVb1c4VDC_dV_c1_c2 = (expl*(d_Vb1c4_dV_c1_c2*VtINV));
      d_eVb1c4VDC_dV_b2_c2 = (expl*(d_Vb1c4_dV_b2_c2*VtINV));
      d_eVb1c4VDC_dV_b1_b2 = (expl*(d_Vb1c4_dV_b1_b2*VtINV));
      eVb1c4VDC = (expl*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c2-VDC_T)*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp(((Vb2c2-VDC_T)*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb2c2VDC_dV_dt_GND = (deriv_exp_0_d0*((((Vb2c2-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV))));
        d_eVb2c2VDC_dV_b2_c2 = (deriv_exp_0_d0*((d_Vb2c2_dV_b2_c2*VtINV)));
        eVb2c2VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb2c2VDC_dV_dt_GND = (expl*(((Vb2c2-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV)));
      d_eVb2c2VDC_dV_b2_c2 = (expl*(d_Vb2c2_dV_b2_c2*VtINV));
      eVb2c2VDC = (expl*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c1-VDC_T)*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp(((Vb2c1-VDC_T)*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb2c1VDC_dV_dt_GND = (deriv_exp_0_d0*((((Vb2c1-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV))));
        d_eVb2c1VDC_dV_b2_c1 = (deriv_exp_0_d0*((d_Vb2c1_dV_b2_c1*VtINV)));
        eVb2c1VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_eVb2c1VDC_dV_dt_GND = (expl*(((Vb2c1-VDC_T)*d_VtINV_dV_dt_GND)+((-d_VDC_T_dV_dt_GND)*VtINV)));
      d_eVb2c1VDC_dV_b2_c1 = (expl*(d_Vb2c1_dV_b2_c1*VtINV));
      eVb2c1VDC = (expl*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0)));
    }
    {
      double value_sqrt_0 = sqrt((1.0+(4.0*eVb2c2VDC)));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_K0_dV_dt_GND = (deriv_sqrt_0_d0*((4.0*d_eVb2c2VDC_dV_dt_GND)));
      d_K0_dV_b2_c2 = (deriv_sqrt_0_d0*((4.0*d_eVb2c2VDC_dV_b2_c2)));
      K0 = value_sqrt_0;
    }
    {
      double value_sqrt_0 = sqrt((1.0+(4.0*eVb2c1VDC)));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_Kw_dV_dt_GND = (deriv_sqrt_0_d0*((4.0*d_eVb2c1VDC_dV_dt_GND)));
      d_Kw_dV_b2_c1 = (deriv_sqrt_0_d0*((4.0*d_eVb2c1VDC_dV_b2_c1)));
      Kw = value_sqrt_0;
    }

    d_pW_dV_dt_GND = (((1.0+Kw)*(2.0*d_eVb2c1VDC_dV_dt_GND)-(2.0*eVb2c1VDC)*d_Kw_dV_dt_GND)/(1.0+Kw)/(1.0+Kw));
    d_pW_dV_b2_c1 = (((1.0+Kw)*(2.0*d_eVb2c1VDC_dV_b2_c1)-(2.0*eVb2c1VDC)*d_Kw_dV_b2_c1)/(1.0+Kw)/(1.0+Kw));
    pW = ((2.0*eVb2c1VDC)/(1.0+Kw));
    {
      double value_log_0 = log(((K0+1.0)/(Kw+1.0)));
      double  deriv_log_0_d0 = (1.0/((K0+1.0)/(Kw+1.0)));

      d_Ec_dV_b2_c1 = (Vt*((-d_Kw_dV_b2_c1)-(deriv_log_0_d0*((-(K0+1.0)*d_Kw_dV_b2_c1/(Kw+1.0)/(Kw+1.0))))));
      d_Ec_dV_b2_c2 = (Vt*(d_K0_dV_b2_c2-(deriv_log_0_d0*((d_K0_dV_b2_c2/(Kw+1.0))))));
      d_Ec_dV_dt_GND = ((Vt*((d_K0_dV_dt_GND-d_Kw_dV_dt_GND)-(deriv_log_0_d0*((((Kw+1.0)*d_K0_dV_dt_GND-(K0+1.0)*d_Kw_dV_dt_GND)/(Kw+1.0)/(Kw+1.0))))))+(d_Vt_dV_dt_GND*((K0-Kw)-value_log_0)));
      Ec = (Vt*((K0-Kw)-value_log_0));
    }

    d_Ic1c2_dV_c1_c2 = (d_Vc1c2_dV_c1_c2/RCV_TM);
    d_Ic1c2_dV_b2_c1 = (d_Ec_dV_b2_c1/RCV_TM);
    d_Ic1c2_dV_b2_c2 = (d_Ec_dV_b2_c2/RCV_TM);
    d_Ic1c2_dV_dt_GND = ((RCV_TM*d_Ec_dV_dt_GND-(Ec+Vc1c2)*d_RCV_TM_dV_dt_GND)/RCV_TM/RCV_TM);
    Ic1c2 = ((Ec+Vc1c2)/RCV_TM);
    if ((Ic1c2>0.0))
    {
      if ((Vb2c1<100.0))
      {

        d_tmpV_dV_b2_c1 = d_Vb2c1_dV_b2_c1;
        tmpV = Vb2c1;
      }
      else
      {
        {
          double value_log_0 = log((1.0+(Vb2c1-100.0)));
          double  deriv_log_0_d0 = (1.0/(1.0+(Vb2c1-100.0)));

          d_tmpV_dV_b2_c1 = (deriv_log_0_d0*(d_Vb2c1_dV_b2_c1));
          tmpV = (100.0+value_log_0);
        }
      }

      tmpV = tmpV;
      {
        double value_log_0 = log(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0));
        double  deriv_log_0_d0 = (1.0/((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0));

        d_Vqs_th_dV_c1_c2 = ((2.0*Vt)*(deriv_log_0_d0*((((0.5*d_Ic1c2_dV_c1_c2)*RCV_TM)*VtINV))));
        d_Vqs_th_dV_b2_c1 = (((2.0*Vt)*(deriv_log_0_d0*((((0.5*d_Ic1c2_dV_b2_c1)*RCV_TM)*VtINV))))-d_tmpV_dV_b2_c1);
        d_Vqs_th_dV_b2_c2 = ((2.0*Vt)*(deriv_log_0_d0*((((0.5*d_Ic1c2_dV_b2_c2)*RCV_TM)*VtINV))));
        d_Vqs_th_dV_dt_GND = (d_VDC_T_dV_dt_GND+(((2.0*Vt)*(deriv_log_0_d0*(((((0.5*Ic1c2)*RCV_TM)*d_VtINV_dV_dt_GND)+((((0.5*Ic1c2)*d_RCV_TM_dV_dt_GND)+((0.5*d_Ic1c2_dV_dt_GND)*RCV_TM))*VtINV)))))+((2.0*d_Vt_dV_dt_GND)*value_log_0)));
        Vqs_th = ((VDC_T+((2.0*Vt)*value_log_0))-tmpV);
      }

      d_eps_VDC_dV_dt_GND = (0.2*d_VDC_T_dV_dt_GND);
      eps_VDC = (0.2*VDC_T);

      d_eps2_dV_dt_GND = ((eps_VDC*d_eps_VDC_dV_dt_GND)+(d_eps_VDC_dV_dt_GND*eps_VDC));
      eps2 = (eps_VDC*eps_VDC);

      d_x2_dV_b_c = d_x2_dV_b_b1 = d_x2_dV_b1_b2 = d_x2_dV_c4_c1 = d_x2_dV_c3_c1 = d_x2_dV_c3_c4 = d_x2_dV_b2_e1 =  0.0;
      d_x2_dV_c1_c2 = ((Vqs_th*d_Vqs_th_dV_c1_c2)+(d_Vqs_th_dV_c1_c2*Vqs_th));
      d_x2_dV_b2_c1 = ((Vqs_th*d_Vqs_th_dV_b2_c1)+(d_Vqs_th_dV_b2_c1*Vqs_th));
      d_x2_dV_b2_c2 = ((Vqs_th*d_Vqs_th_dV_b2_c2)+(d_Vqs_th_dV_b2_c2*Vqs_th));
      d_x2_dV_dt_GND = ((Vqs_th*d_Vqs_th_dV_dt_GND)+(d_Vqs_th_dV_dt_GND*Vqs_th));
      x2 = (Vqs_th*Vqs_th);
      if ((Vqs_th<0.0))
      {
        {
          double value_sqrt_0 = sqrt((x2+eps2));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Vqs_dV_c1_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))-d_Vqs_th_dV_c1_c2)/(value_sqrt_0-Vqs_th)/(value_sqrt_0-Vqs_th));
          d_Vqs_dV_b2_c1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c1))-d_Vqs_th_dV_b2_c1)/(value_sqrt_0-Vqs_th)/(value_sqrt_0-Vqs_th));
          d_Vqs_dV_b2_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))-d_Vqs_th_dV_b2_c2)/(value_sqrt_0-Vqs_th)/(value_sqrt_0-Vqs_th));
          d_Vqs_dV_dt_GND = (((value_sqrt_0-Vqs_th)*(0.5*d_eps2_dV_dt_GND)-(0.5*eps2)*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))-d_Vqs_th_dV_dt_GND))/(value_sqrt_0-Vqs_th)/(value_sqrt_0-Vqs_th));
          Vqs = ((0.5*eps2)/(value_sqrt_0-Vqs_th));
        }
      }
      else
      {
        {
          double value_sqrt_0 = sqrt((x2+eps2));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Vqs_dV_c1_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))+d_Vqs_th_dV_c1_c2));
          d_Vqs_dV_b2_c1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c1))+d_Vqs_th_dV_b2_c1));
          d_Vqs_dV_b2_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))+d_Vqs_th_dV_b2_c2));
          d_Vqs_dV_dt_GND = (0.5*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))+d_Vqs_th_dV_dt_GND));
          Vqs = (0.5*(value_sqrt_0+Vqs_th));
        }
      }

      Vqs = Vqs;

      d_Iqs_dV_c1_c2 = (((SCRCV_M*(Vqs+(IHC_M*RCV_TM)))*((Vqs*d_Vqs_dV_c1_c2)+(d_Vqs_dV_c1_c2*(Vqs+(IHC_M*SCRCV_M))))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*d_Vqs_dV_c1_c2))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      d_Iqs_dV_b2_c1 = (((SCRCV_M*(Vqs+(IHC_M*RCV_TM)))*((Vqs*d_Vqs_dV_b2_c1)+(d_Vqs_dV_b2_c1*(Vqs+(IHC_M*SCRCV_M))))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*d_Vqs_dV_b2_c1))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      d_Iqs_dV_b2_c2 = (((SCRCV_M*(Vqs+(IHC_M*RCV_TM)))*((Vqs*d_Vqs_dV_b2_c2)+(d_Vqs_dV_b2_c2*(Vqs+(IHC_M*SCRCV_M))))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*d_Vqs_dV_b2_c2))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      d_Iqs_dV_dt_GND = (((SCRCV_M*(Vqs+(IHC_M*RCV_TM)))*((Vqs*d_Vqs_dV_dt_GND)+(d_Vqs_dV_dt_GND*(Vqs+(IHC_M*SCRCV_M))))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*(d_Vqs_dV_dt_GND+(IHC_M*d_RCV_TM_dV_dt_GND))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      Iqs = ((Vqs*(Vqs+(IHC_M*SCRCV_M)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));

      d_Ic1c2_Iqs_dV_c1_c2 = ((Iqs*d_Ic1c2_dV_c1_c2-Ic1c2*d_Iqs_dV_c1_c2)/Iqs/Iqs);
      d_Ic1c2_Iqs_dV_b2_c1 = ((Iqs*d_Ic1c2_dV_b2_c1-Ic1c2*d_Iqs_dV_b2_c1)/Iqs/Iqs);
      d_Ic1c2_Iqs_dV_b2_c2 = ((Iqs*d_Ic1c2_dV_b2_c2-Ic1c2*d_Iqs_dV_b2_c2)/Iqs/Iqs);
      d_Ic1c2_Iqs_dV_dt_GND = ((Iqs*d_Ic1c2_dV_dt_GND-Ic1c2*d_Iqs_dV_dt_GND)/Iqs/Iqs);
      Ic1c2_Iqs = (Ic1c2/Iqs);

      d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 =  0.0;
      d_dxa_dV_c1_c2 = (d_Ic1c2_Iqs_dV_c1_c2/(model_.AXI));
      d_dxa_dV_b2_c1 = (d_Ic1c2_Iqs_dV_b2_c1/(model_.AXI));
      d_dxa_dV_b2_c2 = (d_Ic1c2_Iqs_dV_b2_c2/(model_.AXI));
      d_dxa_dV_dt_GND = (d_Ic1c2_Iqs_dV_dt_GND/(model_.AXI));
      dxa = ((Ic1c2_Iqs-1.0)/(model_.AXI));
      if ((Ic1c2_Iqs<1.0))
      {
        {
          double value_exp_0 = exp(dxa);
          double value_log_1 = log((1.0+value_exp_0));
          double  deriv_exp_0_d0 = value_exp_0;
          double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

          d_alpha1_dV_dt_GND = ((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))));
          d_alpha1_dV_c1_c2 = ((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2)))));
          d_alpha1_dV_b2_c1 = ((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1)))));
          d_alpha1_dV_b2_c2 = ((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2)))));
          alpha1 = (1.0+((model_.AXI)*value_log_1));
        }
      }
      else
      {
        {
          double value_exp_0 = exp((-dxa));
          double value_log_1 = log((1.0+value_exp_0));
          double  deriv_exp_0_d0 = value_exp_0;
          double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

          d_alpha1_dV_c1_c2 = (d_Ic1c2_Iqs_dV_c1_c2+((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2)))))));
          d_alpha1_dV_b2_c1 = (d_Ic1c2_Iqs_dV_b2_c1+((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1)))))));
          d_alpha1_dV_b2_c2 = (d_Ic1c2_Iqs_dV_b2_c2+((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2)))))));
          d_alpha1_dV_dt_GND = (d_Ic1c2_Iqs_dV_dt_GND+((model_.AXI)*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND)))))));
          alpha1 = (Ic1c2_Iqs+((model_.AXI)*value_log_1));
        }
      }

      alpha1 = alpha1;
      {
        double value_exp_0 = exp(((-1.0)/(model_.AXI)));
        double value_log_1 = log((1.0+value_exp_0));

        d_alpha_dV_dt_GND = (d_alpha1_dV_dt_GND/(1.0+((model_.AXI)*value_log_1)));
        d_alpha_dV_c1_c2 = (d_alpha1_dV_c1_c2/(1.0+((model_.AXI)*value_log_1)));
        d_alpha_dV_b2_c1 = (d_alpha1_dV_b2_c1/(1.0+((model_.AXI)*value_log_1)));
        d_alpha_dV_b2_c2 = (d_alpha1_dV_b2_c2/(1.0+((model_.AXI)*value_log_1)));
        alpha = (alpha1/(1.0+((model_.AXI)*value_log_1)));
      }

      d_vyi_dV_c1_c2 = (d_Vqs_dV_c1_c2/(IHC_M*SCRCV_M));
      d_vyi_dV_b2_c1 = (d_Vqs_dV_b2_c1/(IHC_M*SCRCV_M));
      d_vyi_dV_b2_c2 = (d_Vqs_dV_b2_c2/(IHC_M*SCRCV_M));
      d_vyi_dV_dt_GND = (d_Vqs_dV_dt_GND/(IHC_M*SCRCV_M));
      vyi = (Vqs/(IHC_M*SCRCV_M));
      {
        double value_sqrt_0 = sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_yi_dV_dt_GND = ((((2.0*alpha)*(1.0+vyi))*(deriv_sqrt_0_d0*(((((4.0*alpha)*vyi)*d_vyi_dV_dt_GND)+((((4.0*alpha)*d_vyi_dV_dt_GND)+((4.0*d_alpha_dV_dt_GND)*vyi))*(1.0+vyi)))))-(1.0+value_sqrt_0)*(((2.0*alpha)*d_vyi_dV_dt_GND)+((2.0*d_alpha_dV_dt_GND)*(1.0+vyi))))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
        d_yi_dV_c1_c2 = ((((2.0*alpha)*(1.0+vyi))*(deriv_sqrt_0_d0*(((((4.0*alpha)*vyi)*d_vyi_dV_c1_c2)+((((4.0*alpha)*d_vyi_dV_c1_c2)+((4.0*d_alpha_dV_c1_c2)*vyi))*(1.0+vyi)))))-(1.0+value_sqrt_0)*(((2.0*alpha)*d_vyi_dV_c1_c2)+((2.0*d_alpha_dV_c1_c2)*(1.0+vyi))))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
        d_yi_dV_b2_c1 = ((((2.0*alpha)*(1.0+vyi))*(deriv_sqrt_0_d0*(((((4.0*alpha)*vyi)*d_vyi_dV_b2_c1)+((((4.0*alpha)*d_vyi_dV_b2_c1)+((4.0*d_alpha_dV_b2_c1)*vyi))*(1.0+vyi)))))-(1.0+value_sqrt_0)*(((2.0*alpha)*d_vyi_dV_b2_c1)+((2.0*d_alpha_dV_b2_c1)*(1.0+vyi))))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
        d_yi_dV_b2_c2 = ((((2.0*alpha)*(1.0+vyi))*(deriv_sqrt_0_d0*(((((4.0*alpha)*vyi)*d_vyi_dV_b2_c2)+((((4.0*alpha)*d_vyi_dV_b2_c2)+((4.0*d_alpha_dV_b2_c2)*vyi))*(1.0+vyi)))))-(1.0+value_sqrt_0)*(((2.0*alpha)*d_vyi_dV_b2_c2)+((2.0*d_alpha_dV_b2_c2)*(1.0+vyi))))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
        yi = ((1.0+value_sqrt_0)/((2.0*alpha)*(1.0+vyi)));
      }

      d_xi_w_dV_dt_GND = (((1.0+(pW*yi))*((-d_yi_dV_dt_GND)+((pW*d_yi_dV_dt_GND)+(d_pW_dV_dt_GND*yi)))-((1.0-yi)+(pW*yi))*((pW*d_yi_dV_dt_GND)+(d_pW_dV_dt_GND*yi)))/(1.0+(pW*yi))/(1.0+(pW*yi)));
      d_xi_w_dV_c1_c2 = (((1.0+(pW*yi))*((-d_yi_dV_c1_c2)+(pW*d_yi_dV_c1_c2))-((1.0-yi)+(pW*yi))*(pW*d_yi_dV_c1_c2))/(1.0+(pW*yi))/(1.0+(pW*yi)));
      d_xi_w_dV_b2_c1 = (((1.0+(pW*yi))*((-d_yi_dV_b2_c1)+((pW*d_yi_dV_b2_c1)+(d_pW_dV_b2_c1*yi)))-((1.0-yi)+(pW*yi))*((pW*d_yi_dV_b2_c1)+(d_pW_dV_b2_c1*yi)))/(1.0+(pW*yi))/(1.0+(pW*yi)));
      d_xi_w_dV_b2_c2 = (((1.0+(pW*yi))*((-d_yi_dV_b2_c2)+(pW*d_yi_dV_b2_c2))-((1.0-yi)+(pW*yi))*(pW*d_yi_dV_b2_c2))/(1.0+(pW*yi))/(1.0+(pW*yi)));
      xi_w = (((1.0-yi)+(pW*yi))/(1.0+(pW*yi)));

      d_gp0_dV_c1_c2 = (((((0.5*Ic1c2)*RCV_TM)*d_xi_w_dV_c1_c2)+(((0.5*d_Ic1c2_dV_c1_c2)*RCV_TM)*xi_w))*VtINV);
      d_gp0_dV_b2_c1 = (((((0.5*Ic1c2)*RCV_TM)*d_xi_w_dV_b2_c1)+(((0.5*d_Ic1c2_dV_b2_c1)*RCV_TM)*xi_w))*VtINV);
      d_gp0_dV_b2_c2 = (((((0.5*Ic1c2)*RCV_TM)*d_xi_w_dV_b2_c2)+(((0.5*d_Ic1c2_dV_b2_c2)*RCV_TM)*xi_w))*VtINV);
      d_gp0_dV_dt_GND = (((((0.5*Ic1c2)*RCV_TM)*xi_w)*d_VtINV_dV_dt_GND)+(((((0.5*Ic1c2)*RCV_TM)*d_xi_w_dV_dt_GND)+((((0.5*Ic1c2)*d_RCV_TM_dV_dt_GND)+((0.5*d_Ic1c2_dV_dt_GND)*RCV_TM))*xi_w))*VtINV));
      gp0 = ((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV);

      d_gp0_help_dV_c1_c2 = ((2.0*d_gp0_dV_c1_c2)+(pW*d_gp0_dV_c1_c2));
      d_gp0_help_dV_b2_c1 = ((2.0*d_gp0_dV_b2_c1)+((pW*(d_pW_dV_b2_c1+d_gp0_dV_b2_c1))+(d_pW_dV_b2_c1*((pW+gp0)+1.0))));
      d_gp0_help_dV_b2_c2 = ((2.0*d_gp0_dV_b2_c2)+(pW*d_gp0_dV_b2_c2));
      d_gp0_help_dV_dt_GND = ((2.0*d_gp0_dV_dt_GND)+((pW*(d_pW_dV_dt_GND+d_gp0_dV_dt_GND))+(d_pW_dV_dt_GND*((pW+gp0)+1.0))));
      gp0_help = ((2.0*gp0)+(pW*((pW+gp0)+1.0)));

      d_gp02_dV_c1_c2 = (0.5*d_gp0_dV_c1_c2);
      d_gp02_dV_b2_c1 = (0.5*d_gp0_dV_b2_c1);
      d_gp02_dV_b2_c2 = (0.5*d_gp0_dV_b2_c2);
      d_gp02_dV_dt_GND = (0.5*d_gp0_dV_dt_GND);
      gp02 = (0.5*(gp0-1.0));

      d_sqr_arg_dV_c1_c2 = (((gp02*d_gp02_dV_c1_c2)+(d_gp02_dV_c1_c2*gp02))+d_gp0_help_dV_c1_c2);
      d_sqr_arg_dV_b2_c1 = (((gp02*d_gp02_dV_b2_c1)+(d_gp02_dV_b2_c1*gp02))+d_gp0_help_dV_b2_c1);
      d_sqr_arg_dV_b2_c2 = (((gp02*d_gp02_dV_b2_c2)+(d_gp02_dV_b2_c2*gp02))+d_gp0_help_dV_b2_c2);
      d_sqr_arg_dV_dt_GND = (((gp02*d_gp02_dV_dt_GND)+(d_gp02_dV_dt_GND*gp02))+d_gp0_help_dV_dt_GND);
      sqr_arg = ((gp02*gp02)+gp0_help);
      if ((gp0>=1.0))
      {
        {
          double value_sqrt_0 = sqrt(sqr_arg);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_p0star_dV_c1_c2 = (d_gp02_dV_c1_c2+(deriv_sqrt_0_d0*(d_sqr_arg_dV_c1_c2)));
          d_p0star_dV_b2_c1 = (d_gp02_dV_b2_c1+(deriv_sqrt_0_d0*(d_sqr_arg_dV_b2_c1)));
          d_p0star_dV_b2_c2 = (d_gp02_dV_b2_c2+(deriv_sqrt_0_d0*(d_sqr_arg_dV_b2_c2)));
          d_p0star_dV_dt_GND = (d_gp02_dV_dt_GND+(deriv_sqrt_0_d0*(d_sqr_arg_dV_dt_GND)));
          p0star = (gp02+value_sqrt_0);
        }
      }
      else
      {
        {
          double value_sqrt_0 = sqrt(sqr_arg);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_p0star_dV_c1_c2 = (((value_sqrt_0-gp02)*d_gp0_help_dV_c1_c2-gp0_help*((deriv_sqrt_0_d0*(d_sqr_arg_dV_c1_c2))-d_gp02_dV_c1_c2))/(value_sqrt_0-gp02)/(value_sqrt_0-gp02));
          d_p0star_dV_b2_c1 = (((value_sqrt_0-gp02)*d_gp0_help_dV_b2_c1-gp0_help*((deriv_sqrt_0_d0*(d_sqr_arg_dV_b2_c1))-d_gp02_dV_b2_c1))/(value_sqrt_0-gp02)/(value_sqrt_0-gp02));
          d_p0star_dV_b2_c2 = (((value_sqrt_0-gp02)*d_gp0_help_dV_b2_c2-gp0_help*((deriv_sqrt_0_d0*(d_sqr_arg_dV_b2_c2))-d_gp02_dV_b2_c2))/(value_sqrt_0-gp02)/(value_sqrt_0-gp02));
          d_p0star_dV_dt_GND = (((value_sqrt_0-gp02)*d_gp0_help_dV_dt_GND-gp0_help*((deriv_sqrt_0_d0*(d_sqr_arg_dV_dt_GND))-d_gp02_dV_dt_GND))/(value_sqrt_0-gp02)/(value_sqrt_0-gp02));
          p0star = (gp0_help/(value_sqrt_0-gp02));
        }
      }
      {
        double value_exp_0 = exp((VDC_T*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_eVb2c2star_dV_c1_c2 = (((p0star*d_p0star_dV_c1_c2)+(d_p0star_dV_c1_c2*(p0star+1.0)))*value_exp_0);
        d_eVb2c2star_dV_b2_c1 = (((p0star*d_p0star_dV_b2_c1)+(d_p0star_dV_b2_c1*(p0star+1.0)))*value_exp_0);
        d_eVb2c2star_dV_b2_c2 = (((p0star*d_p0star_dV_b2_c2)+(d_p0star_dV_b2_c2*(p0star+1.0)))*value_exp_0);
        d_eVb2c2star_dV_dt_GND = (((p0star*(p0star+1.0))*(deriv_exp_0_d0*(((VDC_T*d_VtINV_dV_dt_GND)+(d_VDC_T_dV_dt_GND*VtINV)))))+(((p0star*d_p0star_dV_dt_GND)+(d_p0star_dV_dt_GND*(p0star+1.0)))*value_exp_0));
        eVb2c2star = ((p0star*(p0star+1.0))*value_exp_0);
      }

      d_B1_dV_c1_c2 = ((0.5*SCRCV_M)*d_Ic1c2_dV_c1_c2);
      d_B1_dV_b2_c1 = ((0.5*SCRCV_M)*d_Ic1c2_dV_b2_c1);
      d_B1_dV_b2_c2 = ((0.5*SCRCV_M)*d_Ic1c2_dV_b2_c2);
      d_B1_dV_dt_GND = ((0.5*SCRCV_M)*d_Ic1c2_dV_dt_GND);
      B1 = ((0.5*SCRCV_M)*(Ic1c2-IHC_M));

      d_B2_dV_c1_c2 = (((SCRCV_M*RCV_TM)*IHC_M)*d_Ic1c2_dV_c1_c2);
      d_B2_dV_b2_c1 = (((SCRCV_M*RCV_TM)*IHC_M)*d_Ic1c2_dV_b2_c1);
      d_B2_dV_b2_c2 = (((SCRCV_M*RCV_TM)*IHC_M)*d_Ic1c2_dV_b2_c2);
      d_B2_dV_dt_GND = ((((SCRCV_M*RCV_TM)*IHC_M)*d_Ic1c2_dV_dt_GND)+(((SCRCV_M*d_RCV_TM_dV_dt_GND)*IHC_M)*Ic1c2));
      B2 = (((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2);
      {
        double value_sqrt_0 = sqrt(((B1*B1)+B2));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Vxi0_dV_c1_c2 = (d_B1_dV_c1_c2+(deriv_sqrt_0_d0*((((B1*d_B1_dV_c1_c2)+(d_B1_dV_c1_c2*B1))+d_B2_dV_c1_c2))));
        d_Vxi0_dV_b2_c1 = (d_B1_dV_b2_c1+(deriv_sqrt_0_d0*((((B1*d_B1_dV_b2_c1)+(d_B1_dV_b2_c1*B1))+d_B2_dV_b2_c1))));
        d_Vxi0_dV_b2_c2 = (d_B1_dV_b2_c2+(deriv_sqrt_0_d0*((((B1*d_B1_dV_b2_c2)+(d_B1_dV_b2_c2*B1))+d_B2_dV_b2_c2))));
        d_Vxi0_dV_dt_GND = (d_B1_dV_dt_GND+(deriv_sqrt_0_d0*((((B1*d_B1_dV_dt_GND)+(d_B1_dV_dt_GND*B1))+d_B2_dV_dt_GND))));
        Vxi0 = (B1+value_sqrt_0);
      }

      d_Vch_dV_c1_c2 = (VDC_T*(((Ic1c2+Iqs)*(2.0*d_Ic1c2_dV_c1_c2)-(2.0*Ic1c2)*(d_Ic1c2_dV_c1_c2+d_Iqs_dV_c1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)));
      d_Vch_dV_b2_c1 = (VDC_T*(((Ic1c2+Iqs)*(2.0*d_Ic1c2_dV_b2_c1)-(2.0*Ic1c2)*(d_Ic1c2_dV_b2_c1+d_Iqs_dV_b2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs)));
      d_Vch_dV_b2_c2 = (VDC_T*(((Ic1c2+Iqs)*(2.0*d_Ic1c2_dV_b2_c2)-(2.0*Ic1c2)*(d_Ic1c2_dV_b2_c2+d_Iqs_dV_b2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)));
      d_Vch_dV_dt_GND = ((VDC_T*(((Ic1c2+Iqs)*(2.0*d_Ic1c2_dV_dt_GND)-(2.0*Ic1c2)*(d_Ic1c2_dV_dt_GND+d_Iqs_dV_dt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs)))+(d_VDC_T_dV_dt_GND*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))));
      Vch = (VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));

      d_Icap_dV_c1_c2 = (((IHC_M+Ic1c2)*(IHC_M*d_Ic1c2_dV_c1_c2)-(IHC_M*Ic1c2)*d_Ic1c2_dV_c1_c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      d_Icap_dV_b2_c1 = (((IHC_M+Ic1c2)*(IHC_M*d_Ic1c2_dV_b2_c1)-(IHC_M*Ic1c2)*d_Ic1c2_dV_b2_c1)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      d_Icap_dV_b2_c2 = (((IHC_M+Ic1c2)*(IHC_M*d_Ic1c2_dV_b2_c2)-(IHC_M*Ic1c2)*d_Ic1c2_dV_b2_c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      d_Icap_dV_dt_GND = (((IHC_M+Ic1c2)*(IHC_M*d_Ic1c2_dV_dt_GND)-(IHC_M*Ic1c2)*d_Ic1c2_dV_dt_GND)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      Icap = ((IHC_M*Ic1c2)/(IHC_M+Ic1c2));

      d_Icap_IHC_dV_c1_c2 = (-IHC_M*d_Ic1c2_dV_c1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      d_Icap_IHC_dV_b2_c1 = (-IHC_M*d_Ic1c2_dV_b2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      d_Icap_IHC_dV_b2_c2 = (-IHC_M*d_Ic1c2_dV_b2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      d_Icap_IHC_dV_dt_GND = (-IHC_M*d_Ic1c2_dV_dt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
      Icap_IHC = (IHC_M/(IHC_M+Ic1c2));
    }
    else
    {

      d_Iqs_dV_dt_GND = d_Iqs_dV_b2_c2 = d_Iqs_dV_b2_c1 = d_Iqs_dV_c1_c2 =  0.0;
      Iqs = 0.0;

      d_p0star_dV_b2_c1 = d_p0star_dV_c1_c2 =  0.0;
      d_p0star_dV_dt_GND = (((1.0+K0)*(2.0*d_eVb2c2VDC_dV_dt_GND)-(2.0*eVb2c2VDC)*d_K0_dV_dt_GND)/(1.0+K0)/(1.0+K0));
      d_p0star_dV_b2_c2 = (((1.0+K0)*(2.0*d_eVb2c2VDC_dV_b2_c2)-(2.0*eVb2c2VDC)*d_K0_dV_b2_c2)/(1.0+K0)/(1.0+K0));
      p0star = ((2.0*eVb2c2VDC)/(1.0+K0));

      d_eVb2c2star_dV_b2_c1 = d_eVb2c2star_dV_c1_c2 =  0.0;
      d_eVb2c2star_dV_dt_GND = d_eVb2c2_dV_dt_GND;
      d_eVb2c2star_dV_b2_c2 = d_eVb2c2_dV_b2_c2;
      eVb2c2star = eVb2c2;
      if (((fabs(Vc1c2)<(1.0e-5*Vt))||(fabs(Ec)<((1.0e-40*Vt)*(K0+Kw)))))
      {

        d_pav_dV_c1_c2 = (0.5*d_p0star_dV_c1_c2);
        d_pav_dV_b2_c1 = (0.5*(d_p0star_dV_b2_c1+d_pW_dV_b2_c1));
        d_pav_dV_b2_c2 = (0.5*d_p0star_dV_b2_c2);
        d_pav_dV_dt_GND = (0.5*(d_p0star_dV_dt_GND+d_pW_dV_dt_GND));
        pav = (0.5*(p0star+pW));

        d_xi_w_dV_c1_c2 = (((pav+1.0)*d_pav_dV_c1_c2-pav*d_pav_dV_c1_c2)/(pav+1.0)/(pav+1.0));
        d_xi_w_dV_b2_c1 = (((pav+1.0)*d_pav_dV_b2_c1-pav*d_pav_dV_b2_c1)/(pav+1.0)/(pav+1.0));
        d_xi_w_dV_b2_c2 = (((pav+1.0)*d_pav_dV_b2_c2-pav*d_pav_dV_b2_c2)/(pav+1.0)/(pav+1.0));
        d_xi_w_dV_dt_GND = (((pav+1.0)*d_pav_dV_dt_GND-pav*d_pav_dV_dt_GND)/(pav+1.0)/(pav+1.0));
        xi_w = (pav/(pav+1.0));
      }
      else
      {

        d_xi_w_dV_c1_c2 =  0.0;
        d_xi_w_dV_b2_c1 = ((((Ec+Vb2c2)-Vb2c1)*d_Ec_dV_b2_c1-Ec*(d_Ec_dV_b2_c1-d_Vb2c1_dV_b2_c1))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
        d_xi_w_dV_b2_c2 = ((((Ec+Vb2c2)-Vb2c1)*d_Ec_dV_b2_c2-Ec*(d_Ec_dV_b2_c2+d_Vb2c2_dV_b2_c2))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
        d_xi_w_dV_dt_GND = ((((Ec+Vb2c2)-Vb2c1)*d_Ec_dV_dt_GND-Ec*d_Ec_dV_dt_GND)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
        xi_w = (Ec/((Ec+Vb2c2)-Vb2c1));
      }

      d_Vxi0_dV_dt_GND = d_Vxi0_dV_b2_c2 = d_Vxi0_dV_b2_c1 =  0.0;
      d_Vxi0_dV_c1_c2 = d_Vc1c2_dV_c1_c2;
      Vxi0 = Vc1c2;

      d_Vch_dV_b2_c2 = d_Vch_dV_b2_c1 = d_Vch_dV_c1_c2 =  0.0;
      d_Vch_dV_dt_GND = (0.1*d_VDC_T_dV_dt_GND);
      Vch = (0.1*VDC_T);

      d_Icap_dV_c1_c2 = d_Ic1c2_dV_c1_c2;
      d_Icap_dV_b2_c1 = d_Ic1c2_dV_b2_c1;
      d_Icap_dV_b2_c2 = d_Ic1c2_dV_b2_c2;
      d_Icap_dV_dt_GND = d_Ic1c2_dV_dt_GND;
      Icap = Ic1c2;

      d_Icap_IHC_dV_c1_c2 = (-(d_Icap_dV_c1_c2/IHC_M));
      d_Icap_IHC_dV_b2_c1 = (-(d_Icap_dV_b2_c1/IHC_M));
      d_Icap_IHC_dV_b2_c2 = (-(d_Icap_dV_b2_c2/IHC_M));
      d_Icap_IHC_dV_dt_GND = (-(d_Icap_dV_dt_GND/IHC_M));
      Icap_IHC = (1.0-(Icap/IHC_M));
    }
    {
      double value_pow_0 = pow(3.0,((-1.0)/(model_.PE)));

      d_Vfe_dV_dt_GND = (d_VDE_T_dV_dt_GND*(1.0-value_pow_0));
      Vfe = (VDE_T*(1.0-value_pow_0));
    }

    d_a_VDE_dV_dt_GND = (0.1*d_VDE_T_dV_dt_GND);
    a_VDE = (0.1*VDE_T);

    d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
    d_dxa_dV_dt_GND = ((a_VDE*(-d_Vfe_dV_dt_GND)-(Vb2e1-Vfe)*d_a_VDE_dV_dt_GND)/a_VDE/a_VDE);
    d_dxa_dV_b2_e1 = (d_Vb2e1_dV_b2_e1/a_VDE);
    dxa = ((Vb2e1-Vfe)/a_VDE);
    if ((Vb2e1<Vfe))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vje_dV_c1_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2))))));
        d_Vje_dV_b2_c1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1))))));
        d_Vje_dV_b2_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2))))));
        d_Vje_dV_dt_GND = (-((a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_a_VDE_dV_dt_GND*value_log_1)));
        d_Vje_dV_b2_e1 = (d_Vb2e1_dV_b2_e1-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_e1))))));
        Vje = (Vb2e1-(a_VDE*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vje_dV_c1_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2)))))));
        d_Vje_dV_b2_c1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1)))))));
        d_Vje_dV_b2_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2)))))));
        d_Vje_dV_b2_e1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_e1)))))));
        d_Vje_dV_dt_GND = (d_Vfe_dV_dt_GND-((a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_a_VDE_dV_dt_GND*value_log_1)));
        Vje = (Vfe-(a_VDE*value_log_1));
      }
    }

    Vje = Vje;
    {
      double value_pow_0 = pow((1.0-(Vje*inv_VDE_T)),(1.0-(model_.PE)));
      double  deriv_pow_0_d0 = (((1.0-(Vje*inv_VDE_T)) == 0.0)?0.0:(value_pow_0*(1.0-(model_.PE))/(1.0-(Vje*inv_VDE_T))));

      d_E0BE_dV_c1_c2 = (deriv_pow_0_d0*((-(d_Vje_dV_c1_c2*inv_VDE_T))));
      d_E0BE_dV_b2_c1 = (deriv_pow_0_d0*((-(d_Vje_dV_b2_c1*inv_VDE_T))));
      d_E0BE_dV_b2_c2 = (deriv_pow_0_d0*((-(d_Vje_dV_b2_c2*inv_VDE_T))));
      d_E0BE_dV_dt_GND = (deriv_pow_0_d0*((-((Vje*d_inv_VDE_T_dV_dt_GND)+(d_Vje_dV_dt_GND*inv_VDE_T)))));
      d_E0BE_dV_b2_e1 = (deriv_pow_0_d0*((-(d_Vje_dV_b2_e1*inv_VDE_T))));
      E0BE = value_pow_0;
    }

    d_Vte_dV_c1_c2 = (((VDE_T/(1.0-(model_.PE)))*(-d_E0BE_dV_c1_c2))+(3.0*(-d_Vje_dV_c1_c2)));
    d_Vte_dV_b2_c1 = (((VDE_T/(1.0-(model_.PE)))*(-d_E0BE_dV_b2_c1))+(3.0*(-d_Vje_dV_b2_c1)));
    d_Vte_dV_b2_c2 = (((VDE_T/(1.0-(model_.PE)))*(-d_E0BE_dV_b2_c2))+(3.0*(-d_Vje_dV_b2_c2)));
    d_Vte_dV_b2_e1 = (((VDE_T/(1.0-(model_.PE)))*(-d_E0BE_dV_b2_e1))+(3.0*(d_Vb2e1_dV_b2_e1-d_Vje_dV_b2_e1)));
    d_Vte_dV_dt_GND = ((((VDE_T/(1.0-(model_.PE)))*(-d_E0BE_dV_dt_GND))+((d_VDE_T_dV_dt_GND/(1.0-(model_.PE)))*(1.0-E0BE)))+(3.0*(-d_Vje_dV_dt_GND)));
    Vte = (((VDE_T/(1.0-(model_.PE)))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));

    d_Vjunc_dV_c1_c2 = d_Vxi0_dV_c1_c2;
    d_Vjunc_dV_b2_c2 = d_Vxi0_dV_b2_c2;
    d_Vjunc_dV_dt_GND = d_Vxi0_dV_dt_GND;
    d_Vjunc_dV_b2_c1 = (d_Vb2c1_dV_b2_c1+d_Vxi0_dV_b2_c1);
    Vjunc = (Vb2c1+Vxi0);

    d_bjc_dV_dt_GND = (((1.0-XP_T)*(-d_XP_T_dV_dt_GND)-(2.0-XP_T)*(-d_XP_T_dV_dt_GND))/(1.0-XP_T)/(1.0-XP_T));
    bjc = ((2.0-XP_T)/(1.0-XP_T));
    {
      double value_pow_0 = pow(bjc,((-1.0)/(model_.PC)));
      double  deriv_pow_0_d0 = ((bjc == 0.0)?0.0:(value_pow_0*((-1.0)/(model_.PC))/bjc));

      d_Vfc_dV_dt_GND = ((VDC_T*(-(deriv_pow_0_d0*(d_bjc_dV_dt_GND))))+(d_VDC_T_dV_dt_GND*(1.0-value_pow_0)));
      Vfc = (VDC_T*(1.0-value_pow_0));
    }

    d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 =  0.0;
    d_dxa_dV_c1_c2 = ((Vch*d_Vjunc_dV_c1_c2-(Vjunc-Vfc)*d_Vch_dV_c1_c2)/Vch/Vch);
    d_dxa_dV_b2_c2 = ((Vch*d_Vjunc_dV_b2_c2-(Vjunc-Vfc)*d_Vch_dV_b2_c2)/Vch/Vch);
    d_dxa_dV_dt_GND = ((Vch*(d_Vjunc_dV_dt_GND-d_Vfc_dV_dt_GND)-(Vjunc-Vfc)*d_Vch_dV_dt_GND)/Vch/Vch);
    d_dxa_dV_b2_c1 = ((Vch*d_Vjunc_dV_b2_c1-(Vjunc-Vfc)*d_Vch_dV_b2_c1)/Vch/Vch);
    dxa = ((Vjunc-Vfc)/Vch);
    if ((Vjunc<Vfc))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vjc_dV_b2_e1 = (-(Vch*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_e1))))));
        d_Vjc_dV_c1_c2 = (d_Vjunc_dV_c1_c2-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2)))))+(d_Vch_dV_c1_c2*value_log_1)));
        d_Vjc_dV_b2_c2 = (d_Vjunc_dV_b2_c2-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2)))))+(d_Vch_dV_b2_c2*value_log_1)));
        d_Vjc_dV_dt_GND = (d_Vjunc_dV_dt_GND-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_Vch_dV_dt_GND*value_log_1)));
        d_Vjc_dV_b2_c1 = (d_Vjunc_dV_b2_c1-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1)))))+(d_Vch_dV_b2_c1*value_log_1)));
        Vjc = (Vjunc-(Vch*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vjc_dV_b2_e1 = (-(Vch*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_e1)))))));
        d_Vjc_dV_c1_c2 = (-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2))))))+(d_Vch_dV_c1_c2*value_log_1)));
        d_Vjc_dV_b2_c1 = (-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1))))))+(d_Vch_dV_b2_c1*value_log_1)));
        d_Vjc_dV_b2_c2 = (-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2))))))+(d_Vch_dV_b2_c2*value_log_1)));
        d_Vjc_dV_dt_GND = (d_Vfc_dV_dt_GND-((Vch*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_Vch_dV_dt_GND*value_log_1)));
        Vjc = (Vfc-(Vch*value_log_1));
      }
    }

    Vjc = Vjc;
    {
      double value_pow_0 = pow(Icap_IHC,(model_.MC));
      double  deriv_pow_0_d0 = ((Icap_IHC == 0.0)?0.0:(value_pow_0*(model_.MC)/Icap_IHC));

      d_fI_dV_c1_c2 = (deriv_pow_0_d0*(d_Icap_IHC_dV_c1_c2));
      d_fI_dV_b2_c1 = (deriv_pow_0_d0*(d_Icap_IHC_dV_b2_c1));
      d_fI_dV_b2_c2 = (deriv_pow_0_d0*(d_Icap_IHC_dV_b2_c2));
      d_fI_dV_dt_GND = (deriv_pow_0_d0*(d_Icap_IHC_dV_dt_GND));
      fI = value_pow_0;
    }
    {
      double value_pow_0 = pow((1.0-(Vjc/VDC_T)),(1.0-(model_.PC)));
      double  deriv_pow_0_d0 = (((1.0-(Vjc/VDC_T)) == 0.0)?0.0:(value_pow_0*(1.0-(model_.PC))/(1.0-(Vjc/VDC_T))));

      d_Vcv_dV_b2_e1 = (((VDC_T/(1.0-(model_.PC)))*(-(fI*(deriv_pow_0_d0*((-(d_Vjc_dV_b2_e1/VDC_T)))))))+((fI*bjc)*(-d_Vjc_dV_b2_e1)));
      d_Vcv_dV_c1_c2 = (((VDC_T/(1.0-(model_.PC)))*(-((fI*(deriv_pow_0_d0*((-(d_Vjc_dV_c1_c2/VDC_T)))))+(d_fI_dV_c1_c2*value_pow_0))))+(((fI*bjc)*(d_Vjunc_dV_c1_c2-d_Vjc_dV_c1_c2))+((d_fI_dV_c1_c2*bjc)*(Vjunc-Vjc))));
      d_Vcv_dV_b2_c1 = (((VDC_T/(1.0-(model_.PC)))*(-((fI*(deriv_pow_0_d0*((-(d_Vjc_dV_b2_c1/VDC_T)))))+(d_fI_dV_b2_c1*value_pow_0))))+(((fI*bjc)*(d_Vjunc_dV_b2_c1-d_Vjc_dV_b2_c1))+((d_fI_dV_b2_c1*bjc)*(Vjunc-Vjc))));
      d_Vcv_dV_b2_c2 = (((VDC_T/(1.0-(model_.PC)))*(-((fI*(deriv_pow_0_d0*((-(d_Vjc_dV_b2_c2/VDC_T)))))+(d_fI_dV_b2_c2*value_pow_0))))+(((fI*bjc)*(d_Vjunc_dV_b2_c2-d_Vjc_dV_b2_c2))+((d_fI_dV_b2_c2*bjc)*(Vjunc-Vjc))));
      d_Vcv_dV_dt_GND = ((((VDC_T/(1.0-(model_.PC)))*(-((fI*(deriv_pow_0_d0*((-((VDC_T*d_Vjc_dV_dt_GND-Vjc*d_VDC_T_dV_dt_GND)/VDC_T/VDC_T)))))+(d_fI_dV_dt_GND*value_pow_0))))+((d_VDC_T_dV_dt_GND/(1.0-(model_.PC)))*(1.0-(fI*value_pow_0))))+(((fI*bjc)*(d_Vjunc_dV_dt_GND-d_Vjc_dV_dt_GND))+(((fI*d_bjc_dV_dt_GND)+(d_fI_dV_dt_GND*bjc))*(Vjunc-Vjc))));
      Vcv = (((VDC_T/(1.0-(model_.PC)))*(1.0-(fI*value_pow_0)))+((fI*bjc)*(Vjunc-Vjc)));
    }

    d_Vtc_dV_b2_e1 = ((1.0-XP_T)*d_Vcv_dV_b2_e1);
    d_Vtc_dV_c1_c2 = ((1.0-XP_T)*d_Vcv_dV_c1_c2);
    d_Vtc_dV_b2_c1 = (((1.0-XP_T)*d_Vcv_dV_b2_c1)+(XP_T*d_Vb2c1_dV_b2_c1));
    d_Vtc_dV_b2_c2 = ((1.0-XP_T)*d_Vcv_dV_b2_c2);
    d_Vtc_dV_dt_GND = ((((1.0-XP_T)*d_Vcv_dV_dt_GND)+((-d_XP_T_dV_dt_GND)*Vcv))+(d_XP_T_dV_dt_GND*Vb2c1));
    Vtc = (((1.0-XP_T)*Vcv)+(XP_T*Vb2c1));

    d_If0_dV_dt_GND = ((IK_TM*(4.0*d_IS_TM_dV_dt_GND)-(4.0*IS_TM)*d_IK_TM_dV_dt_GND)/IK_TM/IK_TM);
    If0 = ((4.0*IS_TM)/IK_TM);

    d_f1_dV_b2_e1 = (If0*d_eVb2e1_dV_b2_e1);
    d_f1_dV_dt_GND = ((If0*d_eVb2e1_dV_dt_GND)+(d_If0_dV_dt_GND*eVb2e1));
    f1 = (If0*eVb2e1);
    {
      double value_sqrt_0 = sqrt((1.0+f1));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_n0_dV_b2_e1 = (((1.0+value_sqrt_0)*d_f1_dV_b2_e1-f1*(deriv_sqrt_0_d0*(d_f1_dV_b2_e1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_n0_dV_dt_GND = (((1.0+value_sqrt_0)*d_f1_dV_dt_GND-f1*(deriv_sqrt_0_d0*(d_f1_dV_dt_GND)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      n0 = (f1/(1.0+value_sqrt_0));
    }

    d_f2_dV_c1_c2 = (If0*d_eVb2c2star_dV_c1_c2);
    d_f2_dV_b2_c1 = (If0*d_eVb2c2star_dV_b2_c1);
    d_f2_dV_b2_c2 = (If0*d_eVb2c2star_dV_b2_c2);
    d_f2_dV_dt_GND = ((If0*d_eVb2c2star_dV_dt_GND)+(d_If0_dV_dt_GND*eVb2c2star));
    f2 = (If0*eVb2c2star);
    {
      double value_sqrt_0 = sqrt((1.0+f2));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_nB_dV_c1_c2 = (((1.0+value_sqrt_0)*d_f2_dV_c1_c2-f2*(deriv_sqrt_0_d0*(d_f2_dV_c1_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nB_dV_b2_c1 = (((1.0+value_sqrt_0)*d_f2_dV_b2_c1-f2*(deriv_sqrt_0_d0*(d_f2_dV_b2_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nB_dV_b2_c2 = (((1.0+value_sqrt_0)*d_f2_dV_b2_c2-f2*(deriv_sqrt_0_d0*(d_f2_dV_b2_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nB_dV_dt_GND = (((1.0+value_sqrt_0)*d_f2_dV_dt_GND-f2*(deriv_sqrt_0_d0*(d_f2_dV_dt_GND)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      nB = (f2/(1.0+value_sqrt_0));
    }
    if (((model_.DEG)==0.0))
    {

      d_q0I_dV_c1_c2 = ((d_Vte_dV_c1_c2/VER_T)+(d_Vtc_dV_c1_c2/VEF_T));
      d_q0I_dV_b2_c1 = ((d_Vte_dV_b2_c1/VER_T)+(d_Vtc_dV_b2_c1/VEF_T));
      d_q0I_dV_b2_c2 = ((d_Vte_dV_b2_c2/VER_T)+(d_Vtc_dV_b2_c2/VEF_T));
      d_q0I_dV_b2_e1 = ((d_Vte_dV_b2_e1/VER_T)+(d_Vtc_dV_b2_e1/VEF_T));
      d_q0I_dV_dt_GND = (((VER_T*d_Vte_dV_dt_GND-Vte*d_VER_T_dV_dt_GND)/VER_T/VER_T)+((VEF_T*d_Vtc_dV_dt_GND-Vtc*d_VEF_T_dV_dt_GND)/VEF_T/VEF_T));
      q0I = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    }
    else
    {

      d_termE_dV_c1_c2 = (((d_Vte_dV_c1_c2/VER_T)*DEG_T)*VtINV);
      d_termE_dV_b2_c1 = (((d_Vte_dV_b2_c1/VER_T)*DEG_T)*VtINV);
      d_termE_dV_b2_c2 = (((d_Vte_dV_b2_c2/VER_T)*DEG_T)*VtINV);
      d_termE_dV_b2_e1 = (((d_Vte_dV_b2_e1/VER_T)*DEG_T)*VtINV);
      d_termE_dV_dt_GND = (((((Vte/VER_T)+1.0)*DEG_T)*d_VtINV_dV_dt_GND)+(((((Vte/VER_T)+1.0)*d_DEG_T_dV_dt_GND)+(((VER_T*d_Vte_dV_dt_GND-Vte*d_VER_T_dV_dt_GND)/VER_T/VER_T)*DEG_T))*VtINV));
      termE = ((((Vte/VER_T)+1.0)*DEG_T)*VtINV);

      d_termC_dV_b2_e1 = ((((-d_Vtc_dV_b2_e1)/VEF_T)*DEG_T)*VtINV);
      d_termC_dV_c1_c2 = ((((-d_Vtc_dV_c1_c2)/VEF_T)*DEG_T)*VtINV);
      d_termC_dV_b2_c1 = ((((-d_Vtc_dV_b2_c1)/VEF_T)*DEG_T)*VtINV);
      d_termC_dV_b2_c2 = ((((-d_Vtc_dV_b2_c2)/VEF_T)*DEG_T)*VtINV);
      d_termC_dV_dt_GND = (((((-Vtc)/VEF_T)*DEG_T)*d_VtINV_dV_dt_GND)+(((((-Vtc)/VEF_T)*d_DEG_T_dV_dt_GND)+(((VEF_T*(-d_Vtc_dV_dt_GND)-(-Vtc)*d_VEF_T_dV_dt_GND)/VEF_T/VEF_T)*DEG_T))*VtINV));
      termC = ((((-Vtc)/VEF_T)*DEG_T)*VtINV);
      {
        double value_exp_0 = exp(termE);
        double value_exp_1 = exp(termC);
        double value_exp_2 = exp((DEG_T*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_exp_1_d0 = value_exp_1;
        double  deriv_exp_2_d0 = value_exp_2;

        d_q0I_dV_c1_c2 = (((deriv_exp_0_d0*(d_termE_dV_c1_c2))-(deriv_exp_1_d0*(d_termC_dV_c1_c2)))/(value_exp_2-1.0));
        d_q0I_dV_b2_c1 = (((deriv_exp_0_d0*(d_termE_dV_b2_c1))-(deriv_exp_1_d0*(d_termC_dV_b2_c1)))/(value_exp_2-1.0));
        d_q0I_dV_b2_c2 = (((deriv_exp_0_d0*(d_termE_dV_b2_c2))-(deriv_exp_1_d0*(d_termC_dV_b2_c2)))/(value_exp_2-1.0));
        d_q0I_dV_b2_e1 = (((deriv_exp_0_d0*(d_termE_dV_b2_e1))-(deriv_exp_1_d0*(d_termC_dV_b2_e1)))/(value_exp_2-1.0));
        d_q0I_dV_dt_GND = (((value_exp_2-1.0)*((deriv_exp_0_d0*(d_termE_dV_dt_GND))-(deriv_exp_1_d0*(d_termC_dV_dt_GND)))-(value_exp_0-value_exp_1)*(deriv_exp_2_d0*(((DEG_T*d_VtINV_dV_dt_GND)+(d_DEG_T_dV_dt_GND*VtINV)))))/(value_exp_2-1.0)/(value_exp_2-1.0));
        q0I = ((value_exp_0-value_exp_1)/(value_exp_2-1.0));
      }
    }

    d_eps2_dV_dt_GND =  0.0;
    eps2 = (0.1*0.1);

    d_x2_dV_b_c = d_x2_dV_b_b1 = d_x2_dV_b1_b2 = d_x2_dV_c4_c1 = d_x2_dV_c3_c1 = d_x2_dV_c3_c4 =  0.0;
    d_x2_dV_c1_c2 = ((q0I*d_q0I_dV_c1_c2)+(d_q0I_dV_c1_c2*q0I));
    d_x2_dV_b2_c1 = ((q0I*d_q0I_dV_b2_c1)+(d_q0I_dV_b2_c1*q0I));
    d_x2_dV_b2_c2 = ((q0I*d_q0I_dV_b2_c2)+(d_q0I_dV_b2_c2*q0I));
    d_x2_dV_b2_e1 = ((q0I*d_q0I_dV_b2_e1)+(d_q0I_dV_b2_e1*q0I));
    d_x2_dV_dt_GND = ((q0I*d_q0I_dV_dt_GND)+(d_q0I_dV_dt_GND*q0I));
    x2 = (q0I*q0I);
    if ((q0I<0.0))
    {
      {
        double value_sqrt_0 = sqrt((x2+eps2));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_q1I_dV_c1_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))-d_q0I_dV_c1_c2)/(value_sqrt_0-q0I)/(value_sqrt_0-q0I));
        d_q1I_dV_b2_c1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c1))-d_q0I_dV_b2_c1)/(value_sqrt_0-q0I)/(value_sqrt_0-q0I));
        d_q1I_dV_b2_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))-d_q0I_dV_b2_c2)/(value_sqrt_0-q0I)/(value_sqrt_0-q0I));
        d_q1I_dV_b2_e1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_e1))-d_q0I_dV_b2_e1)/(value_sqrt_0-q0I)/(value_sqrt_0-q0I));
        d_q1I_dV_dt_GND = (((value_sqrt_0-q0I)*(0.5*d_eps2_dV_dt_GND)-(0.5*eps2)*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))-d_q0I_dV_dt_GND))/(value_sqrt_0-q0I)/(value_sqrt_0-q0I));
        q1I = ((0.5*eps2)/(value_sqrt_0-q0I));
      }
    }
    else
    {
      {
        double value_sqrt_0 = sqrt((x2+eps2));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_q1I_dV_c1_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))+d_q0I_dV_c1_c2));
        d_q1I_dV_b2_c1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c1))+d_q0I_dV_b2_c1));
        d_q1I_dV_b2_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))+d_q0I_dV_b2_c2));
        d_q1I_dV_dt_GND = (0.5*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))+d_q0I_dV_dt_GND));
        d_q1I_dV_b2_e1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_e1))+d_q0I_dV_b2_e1));
        q1I = (0.5*(value_sqrt_0+q0I));
      }
    }

    q1I = q1I;

    d_qBI_dV_c1_c2 = ((q1I*(0.5*d_nB_dV_c1_c2))+(d_q1I_dV_c1_c2*(1.0+(0.5*(n0+nB)))));
    d_qBI_dV_b2_c1 = ((q1I*(0.5*d_nB_dV_b2_c1))+(d_q1I_dV_b2_c1*(1.0+(0.5*(n0+nB)))));
    d_qBI_dV_b2_c2 = ((q1I*(0.5*d_nB_dV_b2_c2))+(d_q1I_dV_b2_c2*(1.0+(0.5*(n0+nB)))));
    d_qBI_dV_b2_e1 = ((q1I*(0.5*d_n0_dV_b2_e1))+(d_q1I_dV_b2_e1*(1.0+(0.5*(n0+nB)))));
    d_qBI_dV_dt_GND = ((q1I*(0.5*(d_n0_dV_dt_GND+d_nB_dV_dt_GND)))+(d_q1I_dV_dt_GND*(1.0+(0.5*(n0+nB)))));
    qBI = (q1I*(1.0+(0.5*(n0+nB))));

    d_Ir_dV_c1_c2 = (IS_TM*d_eVb2c2star_dV_c1_c2);
    d_Ir_dV_b2_c1 = (IS_TM*d_eVb2c2star_dV_b2_c1);
    d_Ir_dV_b2_c2 = (IS_TM*d_eVb2c2star_dV_b2_c2);
    d_Ir_dV_dt_GND = ((IS_TM*d_eVb2c2star_dV_dt_GND)+(d_IS_TM_dV_dt_GND*eVb2c2star));
    Ir = (IS_TM*eVb2c2star);

    d_If_dV_b2_e1 = (IS_TM*d_eVb2e1_dV_b2_e1);
    d_If_dV_dt_GND = ((IS_TM*d_eVb2e1_dV_dt_GND)+(d_IS_TM_dV_dt_GND*eVb2e1));
    If = (IS_TM*eVb2e1);

    d_In_dV_c1_c2 = ((qBI*(-d_Ir_dV_c1_c2)-(If-Ir)*d_qBI_dV_c1_c2)/qBI/qBI);
    d_In_dV_b2_c1 = ((qBI*(-d_Ir_dV_b2_c1)-(If-Ir)*d_qBI_dV_b2_c1)/qBI/qBI);
    d_In_dV_b2_c2 = ((qBI*(-d_Ir_dV_b2_c2)-(If-Ir)*d_qBI_dV_b2_c2)/qBI/qBI);
    d_In_dV_b2_e1 = ((qBI*d_If_dV_b2_e1-(If-Ir)*d_qBI_dV_b2_e1)/qBI/qBI);
    d_In_dV_dt_GND = ((qBI*(d_If_dV_dt_GND-d_Ir_dV_dt_GND)-(If-Ir)*d_qBI_dV_dt_GND)/qBI/qBI);
    In = ((If-Ir)/qBI);

    d_Ibf0_dV_dt_GND = ((BF_T*d_IS_TM_dV_dt_GND-IS_TM*d_BF_T_dV_dt_GND)/BF_T/BF_T);
    Ibf0 = (IS_TM/BF_T);
    if (((model_.XREC)==0.0))
    {

      d_Ib1_dV_b2_c2 = d_Ib1_dV_b2_c1 = d_Ib1_dV_c1_c2 =  0.0;
      d_Ib1_dV_b2_e1 = (((1.0-(model_.XIBI))*Ibf0)*d_eVb2e1_dV_b2_e1);
      d_Ib1_dV_dt_GND = ((((1.0-(model_.XIBI))*Ibf0)*d_eVb2e1_dV_dt_GND)+(((1.0-(model_.XIBI))*d_Ibf0_dV_dt_GND)*(eVb2e1-1.0)));
      Ib1 = (((1.0-(model_.XIBI))*Ibf0)*(eVb2e1-1.0));
    }
    else
    {

      d_Ib1_dV_c1_c2 = (((1.0-(model_.XIBI))*Ibf0)*((((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(d_Vtc_dV_c1_c2/VEF_T))+(((model_.XREC)*d_eVb2c2star_dV_c1_c2)*(1.0+(Vtc/VEF_T)))));
      d_Ib1_dV_b2_c1 = (((1.0-(model_.XIBI))*Ibf0)*((((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(d_Vtc_dV_b2_c1/VEF_T))+(((model_.XREC)*d_eVb2c2star_dV_b2_c1)*(1.0+(Vtc/VEF_T)))));
      d_Ib1_dV_b2_c2 = (((1.0-(model_.XIBI))*Ibf0)*((((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(d_Vtc_dV_b2_c2/VEF_T))+(((model_.XREC)*d_eVb2c2star_dV_b2_c2)*(1.0+(Vtc/VEF_T)))));
      d_Ib1_dV_b2_e1 = (((1.0-(model_.XIBI))*Ibf0)*(((1.0-(model_.XREC))*d_eVb2e1_dV_b2_e1)+((((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(d_Vtc_dV_b2_e1/VEF_T))+(((model_.XREC)*d_eVb2e1_dV_b2_e1)*(1.0+(Vtc/VEF_T))))));
      d_Ib1_dV_dt_GND = ((((1.0-(model_.XIBI))*Ibf0)*(((1.0-(model_.XREC))*d_eVb2e1_dV_dt_GND)+((((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*((VEF_T*d_Vtc_dV_dt_GND-Vtc*d_VEF_T_dV_dt_GND)/VEF_T/VEF_T))+(((model_.XREC)*(d_eVb2e1_dV_dt_GND+d_eVb2c2star_dV_dt_GND))*(1.0+(Vtc/VEF_T))))))+(((1.0-(model_.XIBI))*d_Ibf0_dV_dt_GND)*(((1.0-(model_.XREC))*(eVb2e1-1.0))+(((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))));
      Ib1 = (((1.0-(model_.XIBI))*Ibf0)*(((1.0-(model_.XREC))*(eVb2e1-1.0))+(((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T)))));
    }

    d_Ib1_s_dV_b1_e1 = (((model_.XIBI)*Ibf0)*d_eVb1e1_dV_b1_e1);
    d_Ib1_s_dV_dt_GND = ((((model_.XIBI)*Ibf0)*d_eVb1e1_dV_dt_GND)+(((model_.XIBI)*d_Ibf0_dV_dt_GND)*(eVb1e1-1.0)));
    Ib1_s = (((model_.XIBI)*Ibf0)*(eVb1e1-1.0));
    if ((((Vb2e1*VtINV)/(model_.MLF))<400.0))
    {
      {
        double value_exp_0 = exp(((Vb2e1*VtINV)/(model_.MLF)));
        double  deriv_exp_0_d0 = value_exp_0;

        d_tmpExp_dV_b1_b2 = d_tmpExp_dV_b2_c2 = d_tmpExp_dV_c1_c2 = d_tmpExp_dV_c4_c1 =  0.0;
        d_tmpExp_dV_dt_GND = (deriv_exp_0_d0*(((Vb2e1*d_VtINV_dV_dt_GND)/(model_.MLF))));
        d_tmpExp_dV_b2_e1 = (deriv_exp_0_d0*(((d_Vb2e1_dV_b2_e1*VtINV)/(model_.MLF))));
        tmpExp = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_tmpExp_dV_b1_b2 = d_tmpExp_dV_b2_c2 = d_tmpExp_dV_c1_c2 = d_tmpExp_dV_c4_c1 =  0.0;
      d_tmpExp_dV_dt_GND = (expl*((Vb2e1*d_VtINV_dV_dt_GND)/(model_.MLF)));
      d_tmpExp_dV_b2_e1 = (expl*((d_Vb2e1_dV_b2_e1*VtINV)/(model_.MLF)));
      tmpExp = (expl*(1.0+(((Vb2e1*VtINV)/(model_.MLF))-400.0)));
    }

    d_Ib2_dV_b2_e1 = ((IBF_TM*d_tmpExp_dV_b2_e1)+((model_.GMIN)*d_Vb2e1_dV_b2_e1));
    d_Ib2_dV_dt_GND = ((IBF_TM*d_tmpExp_dV_dt_GND)+(d_IBF_TM_dV_dt_GND*(tmpExp-1.0)));
    Ib2 = ((IBF_TM*(tmpExp-1.0))+((model_.GMIN)*Vb2e1));
    if ((((0.5*Vb1c4)*VtINV)<400.0))
    {
      {
        double value_exp_0 = exp(((0.5*Vb1c4)*VtINV));
        double  deriv_exp_0_d0 = value_exp_0;

        d_tmpExp_dV_b2_e1 =  0.0;
        d_tmpExp_dV_dt_GND = (deriv_exp_0_d0*(((0.5*Vb1c4)*d_VtINV_dV_dt_GND)));
        d_tmpExp_dV_c4_c1 = (deriv_exp_0_d0*(((0.5*d_Vb1c4_dV_c4_c1)*VtINV)));
        d_tmpExp_dV_c1_c2 = (deriv_exp_0_d0*(((0.5*d_Vb1c4_dV_c1_c2)*VtINV)));
        d_tmpExp_dV_b2_c2 = (deriv_exp_0_d0*(((0.5*d_Vb1c4_dV_b2_c2)*VtINV)));
        d_tmpExp_dV_b1_b2 = (deriv_exp_0_d0*(((0.5*d_Vb1c4_dV_b1_b2)*VtINV)));
        tmpExp = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_tmpExp_dV_b2_e1 =  0.0;
      d_tmpExp_dV_dt_GND = (expl*((0.5*Vb1c4)*d_VtINV_dV_dt_GND));
      d_tmpExp_dV_c4_c1 = (expl*((0.5*d_Vb1c4_dV_c4_c1)*VtINV));
      d_tmpExp_dV_c1_c2 = (expl*((0.5*d_Vb1c4_dV_c1_c2)*VtINV));
      d_tmpExp_dV_b2_c2 = (expl*((0.5*d_Vb1c4_dV_b2_c2)*VtINV));
      d_tmpExp_dV_b1_b2 = (expl*((0.5*d_Vb1c4_dV_b1_b2)*VtINV));
      tmpExp = (expl*(1.0+(((0.5*Vb1c4)*VtINV)-400.0)));
    }
    {
      double value_exp_0 = exp(((0.5*(model_.VLR))*VtINV));
      double  deriv_exp_0_d0 = value_exp_0;

      d_Ib3_dV_b2_e1 = (-(IBR_TM*(eVb1c4-1.0))*d_tmpExp_dV_b2_e1/(tmpExp+value_exp_0)/(tmpExp+value_exp_0));
      d_Ib3_dV_c4_c1 = ((((tmpExp+value_exp_0)*(IBR_TM*d_eVb1c4_dV_c4_c1)-(IBR_TM*(eVb1c4-1.0))*d_tmpExp_dV_c4_c1)/(tmpExp+value_exp_0)/(tmpExp+value_exp_0))+((model_.GMIN)*d_Vb1c4_dV_c4_c1));
      d_Ib3_dV_c1_c2 = ((((tmpExp+value_exp_0)*(IBR_TM*d_eVb1c4_dV_c1_c2)-(IBR_TM*(eVb1c4-1.0))*d_tmpExp_dV_c1_c2)/(tmpExp+value_exp_0)/(tmpExp+value_exp_0))+((model_.GMIN)*d_Vb1c4_dV_c1_c2));
      d_Ib3_dV_b2_c2 = ((((tmpExp+value_exp_0)*(IBR_TM*d_eVb1c4_dV_b2_c2)-(IBR_TM*(eVb1c4-1.0))*d_tmpExp_dV_b2_c2)/(tmpExp+value_exp_0)/(tmpExp+value_exp_0))+((model_.GMIN)*d_Vb1c4_dV_b2_c2));
      d_Ib3_dV_b1_b2 = ((((tmpExp+value_exp_0)*(IBR_TM*d_eVb1c4_dV_b1_b2)-(IBR_TM*(eVb1c4-1.0))*d_tmpExp_dV_b1_b2)/(tmpExp+value_exp_0)/(tmpExp+value_exp_0))+((model_.GMIN)*d_Vb1c4_dV_b1_b2));
      d_Ib3_dV_dt_GND = (((tmpExp+value_exp_0)*((IBR_TM*d_eVb1c4_dV_dt_GND)+(d_IBR_TM_dV_dt_GND*(eVb1c4-1.0)))-(IBR_TM*(eVb1c4-1.0))*(d_tmpExp_dV_dt_GND+(deriv_exp_0_d0*(((0.5*(model_.VLR))*d_VtINV_dV_dt_GND)))))/(tmpExp+value_exp_0)/(tmpExp+value_exp_0));
      Ib3 = (((IBR_TM*(eVb1c4-1.0))/(tmpExp+value_exp_0))+((model_.GMIN)*Vb1c4));
    }
    if (((((model_.IZEB)>0.0)&&((model_.NZEB)>0.0))&&(Vb2e1<0)))
    {
      if (((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))<400.0))
      {
        {
          double value_exp_0 = exp((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE)))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_eZEB_dV_c1_c2 = (deriv_exp_0_d0*((nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_c1_c2)/(2.0*E0BE)/(2.0*E0BE))))));
          d_eZEB_dV_b2_c1 = (deriv_exp_0_d0*((nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_b2_c1)/(2.0*E0BE)/(2.0*E0BE))))));
          d_eZEB_dV_b2_c2 = (deriv_exp_0_d0*((nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_b2_c2)/(2.0*E0BE)/(2.0*E0BE))))));
          d_eZEB_dV_b2_e1 = (deriv_exp_0_d0*((nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_b2_e1)/(2.0*E0BE)/(2.0*E0BE))))));
          d_eZEB_dV_dt_GND = (deriv_exp_0_d0*(((nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_dt_GND)/(2.0*E0BE)/(2.0*E0BE))))+(d_nZEB_T_dV_dt_GND*(1-(pow2_2mPE/(2.0*E0BE)))))));
          eZEB = value_exp_0;
        }
      }
      else
      {
        {
          double value_exp_0 = exp(400.0);
          expl = value_exp_0;
        }

        d_eZEB_dV_c1_c2 = (expl*(nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_c1_c2)/(2.0*E0BE)/(2.0*E0BE)))));
        d_eZEB_dV_b2_c1 = (expl*(nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_b2_c1)/(2.0*E0BE)/(2.0*E0BE)))));
        d_eZEB_dV_b2_c2 = (expl*(nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_b2_c2)/(2.0*E0BE)/(2.0*E0BE)))));
        d_eZEB_dV_b2_e1 = (expl*(nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_b2_e1)/(2.0*E0BE)/(2.0*E0BE)))));
        d_eZEB_dV_dt_GND = (expl*((nZEB_T*(-(-pow2_2mPE*(2.0*d_E0BE_dV_dt_GND)/(2.0*E0BE)/(2.0*E0BE))))+(d_nZEB_T_dV_dt_GND*(1-(pow2_2mPE/(2.0*E0BE))))));
        eZEB = (expl*(1.0+((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))-400.0)));
      }

      d_x_dV_dt_GND = (Vb2e1*d_inv_VDE_T_dV_dt_GND);
      d_x_dV_b2_e1 = (d_Vb2e1_dV_b2_e1*inv_VDE_T);
      x = (Vb2e1*inv_VDE_T);
      {
        double value_pow_0 = pow((-x),((-2.0)-(model_.PE)));
        double  deriv_pow_0_d0 = (((-x) == 0.0)?0.0:(value_pow_0*((-2.0)-(model_.PE))/(-x)));

        d_dE0BE_dV_dt_GND = (((value_pow_0*(((model_.PE)*(-((3*d_x_dV_dt_GND)*((model_.PE)-1))))-((((6*x)*x)*d_x_dV_dt_GND)+((((6*x)*d_x_dV_dt_GND)+((6*d_x_dV_dt_GND)*x))*(((model_.PE)-1)+x)))))+((deriv_pow_0_d0*((-d_x_dV_dt_GND)))*(((model_.PE)*((1-((model_.PE)*(model_.PE)))-((3*x)*((model_.PE)-1))))-(((6*x)*x)*(((model_.PE)-1)+x)))))*0.16666666666666666667);
        d_dE0BE_dV_b2_e1 = (((value_pow_0*(((model_.PE)*(-((3*d_x_dV_b2_e1)*((model_.PE)-1))))-((((6*x)*x)*d_x_dV_b2_e1)+((((6*x)*d_x_dV_b2_e1)+((6*d_x_dV_b2_e1)*x))*(((model_.PE)-1)+x)))))+((deriv_pow_0_d0*((-d_x_dV_b2_e1)))*(((model_.PE)*((1-((model_.PE)*(model_.PE)))-((3*x)*((model_.PE)-1))))-(((6*x)*x)*(((model_.PE)-1)+x)))))*0.16666666666666666667);
        dE0BE = ((value_pow_0*(((model_.PE)*((1-((model_.PE)*(model_.PE)))-((3*x)*((model_.PE)-1))))-(((6*x)*x)*(((model_.PE)-1)+x))))*0.16666666666666666667);
      }
      if (((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))<400.0))
      {
        {
          double value_exp_0 = exp((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE)));
          double  deriv_exp_0_d0 = value_exp_0;

          d_edZEB_dV_dt_GND = (deriv_exp_0_d0*((((VGZEB_T*dE0BE)*((Vb2e1*pow2_2mPE)*d_nZEB_T_dV_dt_GND)-((Vb2e1*pow2_2mPE)*nZEB_T)*((VGZEB_T*d_dE0BE_dV_dt_GND)+(d_VGZEB_T_dV_dt_GND*dE0BE)))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE))));
          d_edZEB_dV_b2_e1 = (deriv_exp_0_d0*((((VGZEB_T*dE0BE)*((d_Vb2e1_dV_b2_e1*pow2_2mPE)*nZEB_T)-((Vb2e1*pow2_2mPE)*nZEB_T)*(VGZEB_T*d_dE0BE_dV_b2_e1))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE))));
          edZEB = value_exp_0;
        }
      }
      else
      {
        {
          double value_exp_0 = exp(400.0);
          expl = value_exp_0;
        }

        d_edZEB_dV_dt_GND = (expl*(((VGZEB_T*dE0BE)*((Vb2e1*pow2_2mPE)*d_nZEB_T_dV_dt_GND)-((Vb2e1*pow2_2mPE)*nZEB_T)*((VGZEB_T*d_dE0BE_dV_dt_GND)+(d_VGZEB_T_dV_dt_GND*dE0BE)))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE)));
        d_edZEB_dV_b2_e1 = (expl*(((VGZEB_T*dE0BE)*((d_Vb2e1_dV_b2_e1*pow2_2mPE)*nZEB_T)-((Vb2e1*pow2_2mPE)*nZEB_T)*(VGZEB_T*d_dE0BE_dV_b2_e1))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE)));
        edZEB = (expl*(1.0+((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))-400.0)));
      }

      d_DZEB_dV_dt_GND = (-(((pow2_2mPE*nZEB_T)*(((VGZEB_T*dE0BE)*(-d_edZEB_dV_dt_GND))+(((VGZEB_T*d_dE0BE_dV_dt_GND)+(d_VGZEB_T_dV_dt_GND*dE0BE))*(1-edZEB)))-((VGZEB_T*dE0BE)*(1-edZEB))*(pow2_2mPE*d_nZEB_T_dV_dt_GND))/(pow2_2mPE*nZEB_T)/(pow2_2mPE*nZEB_T)));
      d_DZEB_dV_b2_e1 = ((-d_Vb2e1_dV_b2_e1)-((((VGZEB_T*dE0BE)*(-d_edZEB_dV_b2_e1))+((VGZEB_T*d_dE0BE_dV_b2_e1)*(1-edZEB)))/(pow2_2mPE*nZEB_T)));
      DZEB = ((-Vb2e1)-(((VGZEB_T*dE0BE)*(1-edZEB))/(pow2_2mPE*nZEB_T)));

      d_Izteb_dV_c1_c2 = (((((((2.0*IZEB_TM)*DZEB)*E0BE)*d_eZEB_dV_c1_c2)+((((2.0*IZEB_TM)*DZEB)*d_E0BE_dV_c1_c2)*eZEB))*inv_VDE_T)*pow2_PEm2);
      d_Izteb_dV_b2_c1 = (((((((2.0*IZEB_TM)*DZEB)*E0BE)*d_eZEB_dV_b2_c1)+((((2.0*IZEB_TM)*DZEB)*d_E0BE_dV_b2_c1)*eZEB))*inv_VDE_T)*pow2_PEm2);
      d_Izteb_dV_b2_c2 = (((((((2.0*IZEB_TM)*DZEB)*E0BE)*d_eZEB_dV_b2_c2)+((((2.0*IZEB_TM)*DZEB)*d_E0BE_dV_b2_c2)*eZEB))*inv_VDE_T)*pow2_PEm2);
      d_Izteb_dV_b2_e1 = (((((((2.0*IZEB_TM)*DZEB)*E0BE)*d_eZEB_dV_b2_e1)+(((((2.0*IZEB_TM)*DZEB)*d_E0BE_dV_b2_e1)+(((2.0*IZEB_TM)*d_DZEB_dV_b2_e1)*E0BE))*eZEB))*inv_VDE_T)*pow2_PEm2);
      d_Izteb_dV_dt_GND = (((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*d_inv_VDE_T_dV_dt_GND)+((((((2.0*IZEB_TM)*DZEB)*E0BE)*d_eZEB_dV_dt_GND)+(((((2.0*IZEB_TM)*DZEB)*d_E0BE_dV_dt_GND)+((((2.0*IZEB_TM)*d_DZEB_dV_dt_GND)+((2.0*d_IZEB_TM_dV_dt_GND)*DZEB))*E0BE))*eZEB))*inv_VDE_T))*pow2_PEm2);
      Izteb = ((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T)*pow2_PEm2);
    }
    else
    {

      d_DZEB_dV_b2_e1 = d_DZEB_dV_dt_GND =  0.0;
      DZEB = 0;

      d_Izteb_dV_dt_GND = d_Izteb_dV_b2_e1 = d_Izteb_dV_b2_c2 = d_Izteb_dV_b2_c1 = d_Izteb_dV_c1_c2 =  0.0;
      Izteb = 0;
    }

    d_g1_dV_c4_c1 = (If0*d_eVb1c4_dV_c4_c1);
    d_g1_dV_c1_c2 = (If0*d_eVb1c4_dV_c1_c2);
    d_g1_dV_b2_c2 = (If0*d_eVb1c4_dV_b2_c2);
    d_g1_dV_b1_b2 = (If0*d_eVb1c4_dV_b1_b2);
    d_g1_dV_dt_GND = ((If0*d_eVb1c4_dV_dt_GND)+(d_If0_dV_dt_GND*eVb1c4));
    g1 = (If0*eVb1c4);

    d_g2_dV_dt_GND = (4.0*d_eVb1c4VDC_dV_dt_GND);
    d_g2_dV_c4_c1 = (4.0*d_eVb1c4VDC_dV_c4_c1);
    d_g2_dV_c1_c2 = (4.0*d_eVb1c4VDC_dV_c1_c2);
    d_g2_dV_b2_c2 = (4.0*d_eVb1c4VDC_dV_b2_c2);
    d_g2_dV_b1_b2 = (4.0*d_eVb1c4VDC_dV_b1_b2);
    g2 = (4.0*eVb1c4VDC);
    {
      double value_sqrt_0 = sqrt((1.0+g1));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_nBex_dV_c4_c1 = (((1.0+value_sqrt_0)*d_g1_dV_c4_c1-(g1-If0)*(deriv_sqrt_0_d0*(d_g1_dV_c4_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nBex_dV_c1_c2 = (((1.0+value_sqrt_0)*d_g1_dV_c1_c2-(g1-If0)*(deriv_sqrt_0_d0*(d_g1_dV_c1_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nBex_dV_b2_c2 = (((1.0+value_sqrt_0)*d_g1_dV_b2_c2-(g1-If0)*(deriv_sqrt_0_d0*(d_g1_dV_b2_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nBex_dV_b1_b2 = (((1.0+value_sqrt_0)*d_g1_dV_b1_b2-(g1-If0)*(deriv_sqrt_0_d0*(d_g1_dV_b1_b2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_nBex_dV_dt_GND = (((1.0+value_sqrt_0)*(d_g1_dV_dt_GND-d_If0_dV_dt_GND)-(g1-If0)*(deriv_sqrt_0_d0*(d_g1_dV_dt_GND)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      nBex = ((g1-If0)/(1.0+value_sqrt_0));
    }
    {
      double value_sqrt_0 = sqrt((1.0+g2));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_pWex_dV_dt_GND = (((1.0+value_sqrt_0)*d_g2_dV_dt_GND-g2*(deriv_sqrt_0_d0*(d_g2_dV_dt_GND)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_pWex_dV_c4_c1 = (((1.0+value_sqrt_0)*d_g2_dV_c4_c1-g2*(deriv_sqrt_0_d0*(d_g2_dV_c4_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_pWex_dV_c1_c2 = (((1.0+value_sqrt_0)*d_g2_dV_c1_c2-g2*(deriv_sqrt_0_d0*(d_g2_dV_c1_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_pWex_dV_b2_c2 = (((1.0+value_sqrt_0)*d_g2_dV_b2_c2-g2*(deriv_sqrt_0_d0*(d_g2_dV_b2_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      d_pWex_dV_b1_b2 = (((1.0+value_sqrt_0)*d_g2_dV_b1_b2-g2*(deriv_sqrt_0_d0*(d_g2_dV_b1_b2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
      pWex = (g2/(1.0+value_sqrt_0));
    }

    d_Iex_dV_c4_c1 = ((IK_TM*d_nBex_dV_c4_c1)/(2.0*BRI_T));
    d_Iex_dV_c1_c2 = ((IK_TM*d_nBex_dV_c1_c2)/(2.0*BRI_T));
    d_Iex_dV_b2_c2 = ((IK_TM*d_nBex_dV_b2_c2)/(2.0*BRI_T));
    d_Iex_dV_b1_b2 = ((IK_TM*d_nBex_dV_b1_b2)/(2.0*BRI_T));
    d_Iex_dV_dt_GND = (((2.0*BRI_T)*((IK_TM*d_nBex_dV_dt_GND)+(d_IK_TM_dV_dt_GND*nBex))-(IK_TM*nBex)*(2.0*d_BRI_T_dV_dt_GND))/(2.0*BRI_T)/(2.0*BRI_T));
    Iex = ((IK_TM*nBex)/(2.0*BRI_T));
    if (((model_.EXSUB)==1.0))
    {
      {
        double value_sqrt_0 = sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Isub_dV_s_c1 = (((2.0*ISS_TM)*(-d_eVsc4_dV_s_c1))/(1.0+value_sqrt_0));
        d_Isub_dV_c4_c1 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*(d_eVb1c4_dV_c4_c1-d_eVsc4_dV_c4_c1))-((2.0*ISS_TM)*(eVb1c4-eVsc4))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_c4_c1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_c1_c2 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_c1_c2)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_c1_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_b2_c2 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_b2_c2)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_b2_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_b1_b2 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_b1_b2)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_b1_b2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_dt_GND = (((1.0+value_sqrt_0)*(((2.0*ISS_TM)*(d_eVb1c4_dV_dt_GND-d_eVsc4_dV_dt_GND))+((2.0*d_ISS_TM_dV_dt_GND)*(eVb1c4-eVsc4)))-((2.0*ISS_TM)*(eVb1c4-eVsc4))*(deriv_sqrt_0_d0*((((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_dt_GND)+((4.0*((IKS_TM*d_IS_TM_dV_dt_GND-IS_TM*d_IKS_TM_dV_dt_GND)/IKS_TM/IKS_TM))*eVb1c4)))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        Isub = (((2.0*ISS_TM)*(eVb1c4-eVsc4))/(1.0+value_sqrt_0));
      }
    }
    else
    {
      {
        double value_sqrt_0 = sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Isub_dV_s_c1 =  0.0;
        d_Isub_dV_c4_c1 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_c4_c1)-((2.0*ISS_TM)*(eVb1c4-1.0))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_c4_c1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_c1_c2 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_c1_c2)-((2.0*ISS_TM)*(eVb1c4-1.0))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_c1_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_b2_c2 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_b2_c2)-((2.0*ISS_TM)*(eVb1c4-1.0))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_b2_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_b1_b2 = (((1.0+value_sqrt_0)*((2.0*ISS_TM)*d_eVb1c4_dV_b1_b2)-((2.0*ISS_TM)*(eVb1c4-1.0))*(deriv_sqrt_0_d0*(((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_b1_b2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_Isub_dV_dt_GND = (((1.0+value_sqrt_0)*(((2.0*ISS_TM)*d_eVb1c4_dV_dt_GND)+((2.0*d_ISS_TM_dV_dt_GND)*(eVb1c4-1.0)))-((2.0*ISS_TM)*(eVb1c4-1.0))*(deriv_sqrt_0_d0*((((4.0*(IS_TM/IKS_TM))*d_eVb1c4_dV_dt_GND)+((4.0*((IKS_TM*d_IS_TM_dV_dt_GND-IS_TM*d_IKS_TM_dV_dt_GND)/IKS_TM/IKS_TM))*eVb1c4)))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        Isub = (((2.0*ISS_TM)*(eVb1c4-1.0))/(1.0+value_sqrt_0));
      }
    }
    if (((model_.ICSS)<0.0))
    {

      d_Isf_dV_s_c1 = (ISS_TM*d_eVsc1_dV_s_c1);
      d_Isf_dV_dt_GND = ((ISS_TM*d_eVsc1_dV_dt_GND)+(d_ISS_TM_dV_dt_GND*(eVsc1-1.0)));
      Isf = (ISS_TM*(eVsc1-1.0));
    }
    else
    {

      d_Isf_dV_s_c1 = (ICSS_TM*d_eVsc1_dV_s_c1);
      d_Isf_dV_dt_GND = ((ICSS_TM*d_eVsc1_dV_dt_GND)+(d_ICSS_TM_dV_dt_GND*(eVsc1-1.0)));
      Isf = (ICSS_TM*(eVsc1-1.0));
    }

    d_XIex_dV_dt_GND = d_XIex_dV_b_c = d_XIex_dV_b_b1 = d_XIex_dV_b1_b2 = d_XIex_dV_c4_c1 = d_XIex_dV_c3_c1 = d_XIex_dV_c3_c4 = d_XIex_dV_b2_e1 = d_XIex_dV_b2_c2 = d_XIex_dV_b2_c1 = d_XIex_dV_c1_c2 = d_XIex_dV_s_c1 =  0.0;
    XIex = 0.0;

    d_XIsub_dV_dt_GND = d_XIsub_dV_b_c = d_XIsub_dV_b_b1 = d_XIsub_dV_b1_b2 = d_XIsub_dV_c4_c1 = d_XIsub_dV_c3_c1 = d_XIsub_dV_c3_c4 = d_XIsub_dV_b2_e1 = d_XIsub_dV_b2_c2 = d_XIsub_dV_b2_c1 = d_XIsub_dV_c1_c2 = d_XIsub_dV_s_c1 =  0.0;
    XIsub = 0.0;
    if ((((model_.EXMOD)==1)||((model_.EXMOD)==2)))
    {

      d_Iex_dV_c4_c1 = (d_Iex_dV_c4_c1*Xext1);
      d_Iex_dV_c1_c2 = (d_Iex_dV_c1_c2*Xext1);
      d_Iex_dV_b2_c2 = (d_Iex_dV_b2_c2*Xext1);
      d_Iex_dV_b1_b2 = (d_Iex_dV_b1_b2*Xext1);
      d_Iex_dV_dt_GND = (d_Iex_dV_dt_GND*Xext1);
      Iex = (Iex*Xext1);

      d_Isub_dV_s_c1 = (d_Isub_dV_s_c1*Xext1);
      d_Isub_dV_c4_c1 = (d_Isub_dV_c4_c1*Xext1);
      d_Isub_dV_c1_c2 = (d_Isub_dV_c1_c2*Xext1);
      d_Isub_dV_b2_c2 = (d_Isub_dV_b2_c2*Xext1);
      d_Isub_dV_b1_b2 = (d_Isub_dV_b1_b2*Xext1);
      d_Isub_dV_dt_GND = (d_Isub_dV_dt_GND*Xext1);
      Isub = (Isub*Xext1);

      d_Xg1_dV_c3_c4 = (If0*d_eVbc3_dV_c3_c4);
      d_Xg1_dV_c3_c1 = (If0*d_eVbc3_dV_c3_c1);
      d_Xg1_dV_c4_c1 = (If0*d_eVbc3_dV_c4_c1);
      d_Xg1_dV_c1_c2 = (If0*d_eVbc3_dV_c1_c2);
      d_Xg1_dV_b2_c2 = (If0*d_eVbc3_dV_b2_c2);
      d_Xg1_dV_b1_b2 = (If0*d_eVbc3_dV_b1_b2);
      d_Xg1_dV_b_b1 = (If0*d_eVbc3_dV_b_b1);
      d_Xg1_dV_b_c = (If0*d_eVbc3_dV_b_c);
      d_Xg1_dV_dt_GND = ((If0*d_eVbc3_dV_dt_GND)+(d_If0_dV_dt_GND*eVbc3));
      Xg1 = (If0*eVbc3);
      {
        double value_sqrt_0 = sqrt((1.0+Xg1));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_XnBex_dV_c3_c4 = (((1.0+value_sqrt_0)*d_Xg1_dV_c3_c4-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_c3_c4)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_c3_c1 = (((1.0+value_sqrt_0)*d_Xg1_dV_c3_c1-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_c3_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_c4_c1 = (((1.0+value_sqrt_0)*d_Xg1_dV_c4_c1-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_c4_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_c1_c2 = (((1.0+value_sqrt_0)*d_Xg1_dV_c1_c2-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_c1_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_b2_c2 = (((1.0+value_sqrt_0)*d_Xg1_dV_b2_c2-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_b2_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_b1_b2 = (((1.0+value_sqrt_0)*d_Xg1_dV_b1_b2-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_b1_b2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_b_b1 = (((1.0+value_sqrt_0)*d_Xg1_dV_b_b1-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_b_b1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_b_c = (((1.0+value_sqrt_0)*d_Xg1_dV_b_c-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_b_c)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XnBex_dV_dt_GND = (((1.0+value_sqrt_0)*(d_Xg1_dV_dt_GND-d_If0_dV_dt_GND)-(Xg1-If0)*(deriv_sqrt_0_d0*(d_Xg1_dV_dt_GND)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        XnBex = ((Xg1-If0)/(1.0+value_sqrt_0));
      }

      d_XIMex_dV_c3_c4 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_c3_c4)/BRI_T);
      d_XIMex_dV_c3_c1 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_c3_c1)/BRI_T);
      d_XIMex_dV_c4_c1 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_c4_c1)/BRI_T);
      d_XIMex_dV_c1_c2 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_c1_c2)/BRI_T);
      d_XIMex_dV_b2_c2 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_b2_c2)/BRI_T);
      d_XIMex_dV_b1_b2 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_b1_b2)/BRI_T);
      d_XIMex_dV_b_b1 = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_b_b1)/BRI_T);
      d_XIMex_dV_b_c = (((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_b_c)/BRI_T);
      d_XIMex_dV_dt_GND = ((BRI_T*(((((model_.XEXT)*0.5)*IK_TM)*d_XnBex_dV_dt_GND)+((((model_.XEXT)*0.5)*d_IK_TM_dV_dt_GND)*XnBex))-((((model_.XEXT)*0.5)*IK_TM)*XnBex)*d_BRI_T_dV_dt_GND)/BRI_T/BRI_T);
      XIMex = (((((model_.XEXT)*0.5)*IK_TM)*XnBex)/BRI_T);
      if (((model_.EXSUB)==1.0))
      {
        {
          double value_sqrt_0 = sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_XIMsub_dV_s_c1 = (((((model_.XEXT)*2.0)*ISS_TM)*(-d_eVsc3_dV_s_c1))/(1.0+value_sqrt_0));
          d_XIMsub_dV_c3_c4 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*(d_eVbc3_dV_c3_c4-d_eVsc3_dV_c3_c4))-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c3_c4))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_c3_c1 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*(d_eVbc3_dV_c3_c1-d_eVsc3_dV_c3_c1))-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c3_c1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_c4_c1 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*(d_eVbc3_dV_c4_c1-d_eVsc3_dV_c4_c1))-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c4_c1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_c1_c2 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_c1_c2)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c1_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b2_c2 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b2_c2)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b2_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b1_b2 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b1_b2)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b1_b2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b_b1 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b_b1)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b_b1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b_c = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b_c)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b_c))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_dt_GND = (((1.0+value_sqrt_0)*(((((model_.XEXT)*2.0)*ISS_TM)*(d_eVbc3_dV_dt_GND-d_eVsc3_dV_dt_GND))+((((model_.XEXT)*2.0)*d_ISS_TM_dV_dt_GND)*(eVbc3-eVsc3)))-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))*(deriv_sqrt_0_d0*(((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_dt_GND)+(((IKS_T*(4.0*d_IS_T_dV_dt_GND)-(4.0*IS_T)*d_IKS_T_dV_dt_GND)/IKS_T/IKS_T)*eVbc3)))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          XIMsub = (((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-eVsc3))/(1.0+value_sqrt_0));
        }
      }
      else
      {
        {
          double value_sqrt_0 = sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_XIMsub_dV_s_c1 =  0.0;
          d_XIMsub_dV_c3_c4 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_c3_c4)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c3_c4))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_c3_c1 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_c3_c1)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c3_c1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_c4_c1 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_c4_c1)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c4_c1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_c1_c2 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_c1_c2)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_c1_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b2_c2 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b2_c2)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b2_c2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b1_b2 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b1_b2)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b1_b2))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b_b1 = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b_b1)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b_b1))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_b_c = (((1.0+value_sqrt_0)*((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_b_c)-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_b_c))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          d_XIMsub_dV_dt_GND = (((1.0+value_sqrt_0)*(((((model_.XEXT)*2.0)*ISS_TM)*d_eVbc3_dV_dt_GND)+((((model_.XEXT)*2.0)*d_ISS_TM_dV_dt_GND)*(eVbc3-1.0)))-((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))*(deriv_sqrt_0_d0*(((((4.0*IS_T)/IKS_T)*d_eVbc3_dV_dt_GND)+(((IKS_T*(4.0*d_IS_T_dV_dt_GND)-(4.0*IS_T)*d_IKS_T_dV_dt_GND)/IKS_T/IKS_T)*eVbc3)))))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
          XIMsub = (((((model_.XEXT)*2.0)*ISS_TM)*(eVbc3-1.0))/(1.0+value_sqrt_0));
        }
      }
      if (((model_.EXMOD)==1))
      {

        d_Vex_bias_dV_dt_GND = ((((model_.XEXT)*((IS_TM/BRI_T)+ISS_TM))*d_RCCxx_TM_dV_dt_GND)+(((model_.XEXT)*(((BRI_T*d_IS_TM_dV_dt_GND-IS_TM*d_BRI_T_dV_dt_GND)/BRI_T/BRI_T)+d_ISS_TM_dV_dt_GND))*RCCxx_TM));
        Vex_bias = (((model_.XEXT)*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM);
        {
          double value_log_0 = log((Vex_bias*VtINV));
          double  deriv_log_0_d0 = (1.0/(Vex_bias*VtINV));

          d_Vex_dV_dt_GND = ((Vt*(-(deriv_log_0_d0*(((Vex_bias*d_VtINV_dV_dt_GND)+(d_Vex_bias_dV_dt_GND*VtINV))))))+(d_Vt_dV_dt_GND*(2.0-value_log_0)));
          Vex = (Vt*(2.0-value_log_0));
        }

        d_vdif_dV_dt_GND = (-d_Vex_dV_dt_GND);
        d_vdif_dV_c3_c4 = d_Vbc3_dV_c3_c4;
        d_vdif_dV_c3_c1 = d_Vbc3_dV_c3_c1;
        d_vdif_dV_c4_c1 = d_Vbc3_dV_c4_c1;
        d_vdif_dV_c1_c2 = d_Vbc3_dV_c1_c2;
        d_vdif_dV_b2_c2 = d_Vbc3_dV_b2_c2;
        d_vdif_dV_b1_b2 = d_Vbc3_dV_b1_b2;
        d_vdif_dV_b_b1 = d_Vbc3_dV_b_b1;
        d_vdif_dV_b_c = d_Vbc3_dV_b_c;
        vdif = (Vbc3-Vex);

        d_eps2_dV_dt_GND =  0.0;
        eps2 = (0.11*0.11);

        d_x2_dV_b2_e1 = d_x2_dV_b2_c1 =  0.0;
        d_x2_dV_dt_GND = ((vdif*d_vdif_dV_dt_GND)+(d_vdif_dV_dt_GND*vdif));
        d_x2_dV_c3_c4 = ((vdif*d_vdif_dV_c3_c4)+(d_vdif_dV_c3_c4*vdif));
        d_x2_dV_c3_c1 = ((vdif*d_vdif_dV_c3_c1)+(d_vdif_dV_c3_c1*vdif));
        d_x2_dV_c4_c1 = ((vdif*d_vdif_dV_c4_c1)+(d_vdif_dV_c4_c1*vdif));
        d_x2_dV_c1_c2 = ((vdif*d_vdif_dV_c1_c2)+(d_vdif_dV_c1_c2*vdif));
        d_x2_dV_b2_c2 = ((vdif*d_vdif_dV_b2_c2)+(d_vdif_dV_b2_c2*vdif));
        d_x2_dV_b1_b2 = ((vdif*d_vdif_dV_b1_b2)+(d_vdif_dV_b1_b2*vdif));
        d_x2_dV_b_b1 = ((vdif*d_vdif_dV_b_b1)+(d_vdif_dV_b_b1*vdif));
        d_x2_dV_b_c = ((vdif*d_vdif_dV_b_c)+(d_vdif_dV_b_c*vdif));
        x2 = (vdif*vdif);
        if ((vdif<0.0))
        {
          {
            double value_sqrt_0 = sqrt((x2+eps2));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_VBex_dV_c1_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))-d_vdif_dV_c1_c2)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_b2_c1 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_b2_c1))/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_b2_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))-d_vdif_dV_b2_c2)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_b2_e1 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_b2_e1))/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_c3_c4 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c3_c4))-d_vdif_dV_c3_c4)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_c3_c1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c3_c1))-d_vdif_dV_c3_c1)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_c4_c1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c4_c1))-d_vdif_dV_c4_c1)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_b1_b2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b1_b2))-d_vdif_dV_b1_b2)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_b_b1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b_b1))-d_vdif_dV_b_b1)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_b_c = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b_c))-d_vdif_dV_b_c)/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            d_VBex_dV_dt_GND = (((value_sqrt_0-vdif)*(0.5*d_eps2_dV_dt_GND)-(0.5*eps2)*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))-d_vdif_dV_dt_GND))/(value_sqrt_0-vdif)/(value_sqrt_0-vdif));
            VBex = ((0.5*eps2)/(value_sqrt_0-vdif));
          }
        }
        else
        {
          {
            double value_sqrt_0 = sqrt((x2+eps2));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_VBex_dV_c1_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))+d_vdif_dV_c1_c2));
            d_VBex_dV_b2_c1 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_b2_c1)));
            d_VBex_dV_b2_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))+d_vdif_dV_b2_c2));
            d_VBex_dV_dt_GND = (0.5*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))+d_vdif_dV_dt_GND));
            d_VBex_dV_b2_e1 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_b2_e1)));
            d_VBex_dV_c3_c4 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c3_c4))+d_vdif_dV_c3_c4));
            d_VBex_dV_c3_c1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c3_c1))+d_vdif_dV_c3_c1));
            d_VBex_dV_c4_c1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c4_c1))+d_vdif_dV_c4_c1));
            d_VBex_dV_b1_b2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b1_b2))+d_vdif_dV_b1_b2));
            d_VBex_dV_b_b1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b_b1))+d_vdif_dV_b_b1));
            d_VBex_dV_b_c = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b_c))+d_vdif_dV_b_c));
            VBex = (0.5*(value_sqrt_0+vdif));
          }
        }

        VBex = VBex;

        d_Fex_dV_s_c1 = (-VBex*(d_XIMsub_dV_s_c1*RCCxx_TM)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_c1_c2 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_c1_c2-VBex*(((d_XIMex_dV_c1_c2+d_XIMsub_dV_c1_c2)*RCCxx_TM)+d_VBex_dV_c1_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_b2_c1 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_b2_c1-VBex*d_VBex_dV_b2_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_b2_c2 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_b2_c2-VBex*(((d_XIMex_dV_b2_c2+d_XIMsub_dV_b2_c2)*RCCxx_TM)+d_VBex_dV_b2_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_b2_e1 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_b2_e1-VBex*d_VBex_dV_b2_e1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_c3_c4 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_c3_c4-VBex*(((d_XIMex_dV_c3_c4+d_XIMsub_dV_c3_c4)*RCCxx_TM)+d_VBex_dV_c3_c4))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_c3_c1 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_c3_c1-VBex*(((d_XIMex_dV_c3_c1+d_XIMsub_dV_c3_c1)*RCCxx_TM)+d_VBex_dV_c3_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_c4_c1 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_c4_c1-VBex*(((d_XIMex_dV_c4_c1+d_XIMsub_dV_c4_c1)*RCCxx_TM)+d_VBex_dV_c4_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_b1_b2 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_b1_b2-VBex*(((d_XIMex_dV_b1_b2+d_XIMsub_dV_b1_b2)*RCCxx_TM)+d_VBex_dV_b1_b2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_b_b1 = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_b_b1-VBex*(((d_XIMex_dV_b_b1+d_XIMsub_dV_b_b1)*RCCxx_TM)+d_VBex_dV_b_b1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_b_c = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_b_c-VBex*(((d_XIMex_dV_b_c+d_XIMsub_dV_b_c)*RCCxx_TM)+d_VBex_dV_b_c))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        d_Fex_dV_dt_GND = ((((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)*d_VBex_dV_dt_GND-VBex*((d_Vex_bias_dV_dt_GND+(((XIMex+XIMsub)*d_RCCxx_TM_dV_dt_GND)+((d_XIMex_dV_dt_GND+d_XIMsub_dV_dt_GND)*RCCxx_TM)))+d_VBex_dV_dt_GND))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
        Fex = (VBex/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
      }
      else
      {

        d_Vex_dV_dt_GND =  0.0;
        Vex = 0.0;

        d_vdif_dV_b_c = d_vdif_dV_b_b1 = d_vdif_dV_b1_b2 = d_vdif_dV_b2_c2 = d_vdif_dV_c1_c2 = d_vdif_dV_c4_c1 = d_vdif_dV_c3_c1 = d_vdif_dV_c3_c4 = d_vdif_dV_dt_GND =  0.0;
        vdif = 0.0;

        d_VBex_dV_dt_GND = d_VBex_dV_b_c = d_VBex_dV_b_b1 = d_VBex_dV_b1_b2 = d_VBex_dV_c4_c1 = d_VBex_dV_c3_c1 = d_VBex_dV_c3_c4 = d_VBex_dV_b2_e1 = d_VBex_dV_b2_c2 = d_VBex_dV_b2_c1 = d_VBex_dV_c1_c2 =  0.0;
        VBex = 0.0;

        d_Fex_dV_dt_GND = d_Fex_dV_b_c = d_Fex_dV_b_b1 = d_Fex_dV_b1_b2 = d_Fex_dV_c4_c1 = d_Fex_dV_c3_c1 = d_Fex_dV_c3_c4 = d_Fex_dV_b2_e1 = d_Fex_dV_b2_c2 = d_Fex_dV_b2_c1 = d_Fex_dV_c1_c2 = d_Fex_dV_s_c1 =  0.0;
        Fex = 1.0;
      }

      d_XIex_dV_s_c1 = (d_Fex_dV_s_c1*XIMex);
      d_XIex_dV_c1_c2 = ((Fex*d_XIMex_dV_c1_c2)+(d_Fex_dV_c1_c2*XIMex));
      d_XIex_dV_b2_c1 = (d_Fex_dV_b2_c1*XIMex);
      d_XIex_dV_b2_c2 = ((Fex*d_XIMex_dV_b2_c2)+(d_Fex_dV_b2_c2*XIMex));
      d_XIex_dV_b2_e1 = (d_Fex_dV_b2_e1*XIMex);
      d_XIex_dV_c3_c4 = ((Fex*d_XIMex_dV_c3_c4)+(d_Fex_dV_c3_c4*XIMex));
      d_XIex_dV_c3_c1 = ((Fex*d_XIMex_dV_c3_c1)+(d_Fex_dV_c3_c1*XIMex));
      d_XIex_dV_c4_c1 = ((Fex*d_XIMex_dV_c4_c1)+(d_Fex_dV_c4_c1*XIMex));
      d_XIex_dV_b1_b2 = ((Fex*d_XIMex_dV_b1_b2)+(d_Fex_dV_b1_b2*XIMex));
      d_XIex_dV_b_b1 = ((Fex*d_XIMex_dV_b_b1)+(d_Fex_dV_b_b1*XIMex));
      d_XIex_dV_b_c = ((Fex*d_XIMex_dV_b_c)+(d_Fex_dV_b_c*XIMex));
      d_XIex_dV_dt_GND = ((Fex*d_XIMex_dV_dt_GND)+(d_Fex_dV_dt_GND*XIMex));
      XIex = (Fex*XIMex);

      d_XIsub_dV_s_c1 = ((Fex*d_XIMsub_dV_s_c1)+(d_Fex_dV_s_c1*XIMsub));
      d_XIsub_dV_c1_c2 = ((Fex*d_XIMsub_dV_c1_c2)+(d_Fex_dV_c1_c2*XIMsub));
      d_XIsub_dV_b2_c1 = (d_Fex_dV_b2_c1*XIMsub);
      d_XIsub_dV_b2_c2 = ((Fex*d_XIMsub_dV_b2_c2)+(d_Fex_dV_b2_c2*XIMsub));
      d_XIsub_dV_b2_e1 = (d_Fex_dV_b2_e1*XIMsub);
      d_XIsub_dV_c3_c4 = ((Fex*d_XIMsub_dV_c3_c4)+(d_Fex_dV_c3_c4*XIMsub));
      d_XIsub_dV_c3_c1 = ((Fex*d_XIMsub_dV_c3_c1)+(d_Fex_dV_c3_c1*XIMsub));
      d_XIsub_dV_c4_c1 = ((Fex*d_XIMsub_dV_c4_c1)+(d_Fex_dV_c4_c1*XIMsub));
      d_XIsub_dV_b1_b2 = ((Fex*d_XIMsub_dV_b1_b2)+(d_Fex_dV_b1_b2*XIMsub));
      d_XIsub_dV_b_b1 = ((Fex*d_XIMsub_dV_b_b1)+(d_Fex_dV_b_b1*XIMsub));
      d_XIsub_dV_b_c = ((Fex*d_XIMsub_dV_b_c)+(d_Fex_dV_b_c*XIMsub));
      d_XIsub_dV_dt_GND = ((Fex*d_XIMsub_dV_dt_GND)+(d_Fex_dV_dt_GND*XIMsub));
      XIsub = (Fex*XIMsub);
    }
    else
    {

      d_Fex_dV_dt_GND = d_Fex_dV_b_c = d_Fex_dV_b_b1 = d_Fex_dV_b1_b2 = d_Fex_dV_c4_c1 = d_Fex_dV_c3_c1 = d_Fex_dV_c3_c4 = d_Fex_dV_b2_e1 = d_Fex_dV_b2_c2 = d_Fex_dV_b2_c1 = d_Fex_dV_c1_c2 = d_Fex_dV_s_c1 =  0.0;
      Fex = 0;

      d_XnBex_dV_dt_GND = d_XnBex_dV_b_c = d_XnBex_dV_b_b1 = d_XnBex_dV_b1_b2 = d_XnBex_dV_b2_c2 = d_XnBex_dV_c1_c2 = d_XnBex_dV_c4_c1 = d_XnBex_dV_c3_c1 = d_XnBex_dV_c3_c4 =  0.0;
      XnBex = 0;
    }

    d_q0Q_dV_c1_c2 = ((d_Vte_dV_c1_c2/VER_T)+(d_Vtc_dV_c1_c2/VEF_T));
    d_q0Q_dV_b2_c1 = ((d_Vte_dV_b2_c1/VER_T)+(d_Vtc_dV_b2_c1/VEF_T));
    d_q0Q_dV_b2_c2 = ((d_Vte_dV_b2_c2/VER_T)+(d_Vtc_dV_b2_c2/VEF_T));
    d_q0Q_dV_b2_e1 = ((d_Vte_dV_b2_e1/VER_T)+(d_Vtc_dV_b2_e1/VEF_T));
    d_q0Q_dV_dt_GND = (((VER_T*d_Vte_dV_dt_GND-Vte*d_VER_T_dV_dt_GND)/VER_T/VER_T)+((VEF_T*d_Vtc_dV_dt_GND-Vtc*d_VEF_T_dV_dt_GND)/VEF_T/VEF_T));
    q0Q = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));

    d_eps2_dV_dt_GND =  0.0;
    eps2 = (0.1*0.1);

    d_x2_dV_b_c = d_x2_dV_b_b1 = d_x2_dV_b1_b2 = d_x2_dV_c4_c1 = d_x2_dV_c3_c1 = d_x2_dV_c3_c4 =  0.0;
    d_x2_dV_c1_c2 = ((q0Q*d_q0Q_dV_c1_c2)+(d_q0Q_dV_c1_c2*q0Q));
    d_x2_dV_b2_c1 = ((q0Q*d_q0Q_dV_b2_c1)+(d_q0Q_dV_b2_c1*q0Q));
    d_x2_dV_b2_c2 = ((q0Q*d_q0Q_dV_b2_c2)+(d_q0Q_dV_b2_c2*q0Q));
    d_x2_dV_b2_e1 = ((q0Q*d_q0Q_dV_b2_e1)+(d_q0Q_dV_b2_e1*q0Q));
    d_x2_dV_dt_GND = ((q0Q*d_q0Q_dV_dt_GND)+(d_q0Q_dV_dt_GND*q0Q));
    x2 = (q0Q*q0Q);
    if ((q0Q<0.0))
    {
      {
        double value_sqrt_0 = sqrt((x2+eps2));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_q1Q_dV_c1_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))-d_q0Q_dV_c1_c2)/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_b2_c1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c1))-d_q0Q_dV_b2_c1)/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_b2_c2 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))-d_q0Q_dV_b2_c2)/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_b2_e1 = (-(0.5*eps2)*((deriv_sqrt_0_d0*(d_x2_dV_b2_e1))-d_q0Q_dV_b2_e1)/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_c3_c4 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_c3_c4))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_c3_c1 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_c3_c1))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_c4_c1 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_c4_c1))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_b1_b2 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_b1_b2))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_b_b1 = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_b_b1))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_b_c = (-(0.5*eps2)*(deriv_sqrt_0_d0*(d_x2_dV_b_c))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        d_q1Q_dV_dt_GND = (((value_sqrt_0-q0Q)*(0.5*d_eps2_dV_dt_GND)-(0.5*eps2)*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))-d_q0Q_dV_dt_GND))/(value_sqrt_0-q0Q)/(value_sqrt_0-q0Q));
        q1Q = ((0.5*eps2)/(value_sqrt_0-q0Q));
      }
    }
    else
    {
      {
        double value_sqrt_0 = sqrt((x2+eps2));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_q1Q_dV_c1_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_c1_c2))+d_q0Q_dV_c1_c2));
        d_q1Q_dV_b2_c1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c1))+d_q0Q_dV_b2_c1));
        d_q1Q_dV_b2_c2 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_c2))+d_q0Q_dV_b2_c2));
        d_q1Q_dV_dt_GND = (0.5*((deriv_sqrt_0_d0*((d_x2_dV_dt_GND+d_eps2_dV_dt_GND)))+d_q0Q_dV_dt_GND));
        d_q1Q_dV_b2_e1 = (0.5*((deriv_sqrt_0_d0*(d_x2_dV_b2_e1))+d_q0Q_dV_b2_e1));
        d_q1Q_dV_c3_c4 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_c3_c4)));
        d_q1Q_dV_c3_c1 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_c3_c1)));
        d_q1Q_dV_c4_c1 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_c4_c1)));
        d_q1Q_dV_b1_b2 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_b1_b2)));
        d_q1Q_dV_b_b1 = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_b_b1)));
        d_q1Q_dV_b_c = (0.5*(deriv_sqrt_0_d0*(d_x2_dV_b_c)));
        q1Q = (0.5*(value_sqrt_0+q0Q));
      }
    }

    q1Q = q1Q;

    d_qBQ_dV_c1_c2 = ((q1Q*(0.5*d_nB_dV_c1_c2))+(d_q1Q_dV_c1_c2*(1.0+(0.5*(n0+nB)))));
    d_qBQ_dV_b2_c1 = ((q1Q*(0.5*d_nB_dV_b2_c1))+(d_q1Q_dV_b2_c1*(1.0+(0.5*(n0+nB)))));
    d_qBQ_dV_b2_c2 = ((q1Q*(0.5*d_nB_dV_b2_c2))+(d_q1Q_dV_b2_c2*(1.0+(0.5*(n0+nB)))));
    d_qBQ_dV_b2_e1 = ((q1Q*(0.5*d_n0_dV_b2_e1))+(d_q1Q_dV_b2_e1*(1.0+(0.5*(n0+nB)))));
    d_qBQ_dV_c3_c4 = (d_q1Q_dV_c3_c4*(1.0+(0.5*(n0+nB))));
    d_qBQ_dV_c3_c1 = (d_q1Q_dV_c3_c1*(1.0+(0.5*(n0+nB))));
    d_qBQ_dV_c4_c1 = (d_q1Q_dV_c4_c1*(1.0+(0.5*(n0+nB))));
    d_qBQ_dV_b1_b2 = (d_q1Q_dV_b1_b2*(1.0+(0.5*(n0+nB))));
    d_qBQ_dV_b_b1 = (d_q1Q_dV_b_b1*(1.0+(0.5*(n0+nB))));
    d_qBQ_dV_b_c = (d_q1Q_dV_b_c*(1.0+(0.5*(n0+nB))));
    d_qBQ_dV_dt_GND = ((q1Q*(0.5*(d_n0_dV_dt_GND+d_nB_dV_dt_GND)))+(d_q1Q_dV_dt_GND*(1.0+(0.5*(n0+nB)))));
    qBQ = (q1Q*(1.0+(0.5*(n0+nB))));

    d_Rb2_dV_c1_c2 = (-(3.0*RBV_TM)*d_qBQ_dV_c1_c2/qBQ/qBQ);
    d_Rb2_dV_b2_c1 = (-(3.0*RBV_TM)*d_qBQ_dV_b2_c1/qBQ/qBQ);
    d_Rb2_dV_b2_c2 = (-(3.0*RBV_TM)*d_qBQ_dV_b2_c2/qBQ/qBQ);
    d_Rb2_dV_b2_e1 = (-(3.0*RBV_TM)*d_qBQ_dV_b2_e1/qBQ/qBQ);
    d_Rb2_dV_c3_c4 = (-(3.0*RBV_TM)*d_qBQ_dV_c3_c4/qBQ/qBQ);
    d_Rb2_dV_c3_c1 = (-(3.0*RBV_TM)*d_qBQ_dV_c3_c1/qBQ/qBQ);
    d_Rb2_dV_c4_c1 = (-(3.0*RBV_TM)*d_qBQ_dV_c4_c1/qBQ/qBQ);
    d_Rb2_dV_b1_b2 = (-(3.0*RBV_TM)*d_qBQ_dV_b1_b2/qBQ/qBQ);
    d_Rb2_dV_b_b1 = (-(3.0*RBV_TM)*d_qBQ_dV_b_b1/qBQ/qBQ);
    d_Rb2_dV_b_c = (-(3.0*RBV_TM)*d_qBQ_dV_b_c/qBQ/qBQ);
    d_Rb2_dV_dt_GND = ((qBQ*(3.0*d_RBV_TM_dV_dt_GND)-(3.0*RBV_TM)*d_qBQ_dV_dt_GND)/qBQ/qBQ);
    Rb2 = ((3.0*RBV_TM)/qBQ);

    d_Ib1b2_dV_c1_c2 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_c1_c2/Rb2/Rb2);
    d_Ib1b2_dV_b2_c1 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_b2_c1/Rb2/Rb2);
    d_Ib1b2_dV_b2_c2 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_b2_c2/Rb2/Rb2);
    d_Ib1b2_dV_b2_e1 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_b2_e1/Rb2/Rb2);
    d_Ib1b2_dV_c3_c4 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_c3_c4/Rb2/Rb2);
    d_Ib1b2_dV_c3_c1 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_c3_c1/Rb2/Rb2);
    d_Ib1b2_dV_c4_c1 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_c4_c1/Rb2/Rb2);
    d_Ib1b2_dV_b_b1 = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_b_b1/Rb2/Rb2);
    d_Ib1b2_dV_b_c = (-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_b_c/Rb2/Rb2);
    d_Ib1b2_dV_b1_b2 = ((Rb2*(((2.0*Vt)*d_eVb1b2_dV_b1_b2)+d_Vb1b2_dV_b1_b2)-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_b1_b2)/Rb2/Rb2);
    d_Ib1b2_dV_dt_GND = ((Rb2*(((2.0*Vt)*d_eVb1b2_dV_dt_GND)+((2.0*d_Vt_dV_dt_GND)*(eVb1b2-1.0)))-(((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)*d_Rb2_dV_dt_GND)/Rb2/Rb2);
    Ib1b2 = ((((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)/Rb2);

    d_Iavl_dV_dt_GND = d_Iavl_dV_b2_c2 = d_Iavl_dV_b2_c1 = d_Iavl_dV_c1_c2 = d_Iavl_dV_b_c = d_Iavl_dV_b_b1 = d_Iavl_dV_b1_b2 = d_Iavl_dV_c4_c1 = d_Iavl_dV_c3_c1 = d_Iavl_dV_c3_c4 = d_Iavl_dV_b2_e1 =  0.0;
    Iavl = 0.0;

    d_Gem_dV_dt_GND = d_Gem_dV_b2_c1 = d_Gem_dV_b2_c2 = d_Gem_dV_c1_c2 =  0.0;
    Gem = 0.0;
    if (((Ic1c2>0.0)&&(Vb2c1<VDC_T)))
    {
      dEdx0 = ((2.0*(model_.VAVL))/((model_.WAVL)*(model_.WAVL)));

      d_sqr_arg_dV_c1_c2 = (-(VDC_T-Vb2c1)*d_Icap_IHC_dV_c1_c2/Icap_IHC/Icap_IHC);
      d_sqr_arg_dV_b2_c2 = (-(VDC_T-Vb2c1)*d_Icap_IHC_dV_b2_c2/Icap_IHC/Icap_IHC);
      d_sqr_arg_dV_b2_c1 = ((Icap_IHC*(-d_Vb2c1_dV_b2_c1)-(VDC_T-Vb2c1)*d_Icap_IHC_dV_b2_c1)/Icap_IHC/Icap_IHC);
      d_sqr_arg_dV_dt_GND = ((Icap_IHC*d_VDC_T_dV_dt_GND-(VDC_T-Vb2c1)*d_Icap_IHC_dV_dt_GND)/Icap_IHC/Icap_IHC);
      sqr_arg = ((VDC_T-Vb2c1)/Icap_IHC);
      {
        double value_sqrt_0 = sqrt(((2.0*sqr_arg)/dEdx0));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_xd_dV_c1_c2 = (deriv_sqrt_0_d0*(((2.0*d_sqr_arg_dV_c1_c2)/dEdx0)));
        d_xd_dV_b2_c1 = (deriv_sqrt_0_d0*(((2.0*d_sqr_arg_dV_b2_c1)/dEdx0)));
        d_xd_dV_b2_c2 = (deriv_sqrt_0_d0*(((2.0*d_sqr_arg_dV_b2_c2)/dEdx0)));
        d_xd_dV_dt_GND = (deriv_sqrt_0_d0*(((2.0*d_sqr_arg_dV_dt_GND)/dEdx0)));
        xd = value_sqrt_0;
      }
      if (((model_.EXAVL)==0.0))
      {

        d_Weff_dV_b2_c2 = d_Weff_dV_b2_c1 = d_Weff_dV_c1_c2 = d_Weff_dV_dt_GND =  0.0;
        Weff = (model_.WAVL);
      }
      else
      {

        d_xi_w1_dV_dt_GND = (-(0.5*d_xi_w_dV_dt_GND));
        d_xi_w1_dV_c1_c2 = (-(0.5*d_xi_w_dV_c1_c2));
        d_xi_w1_dV_b2_c1 = (-(0.5*d_xi_w_dV_b2_c1));
        d_xi_w1_dV_b2_c2 = (-(0.5*d_xi_w_dV_b2_c2));
        xi_w1 = (1.0-(0.5*xi_w));

        d_Weff_dV_dt_GND = ((((model_.WAVL)*xi_w1)*d_xi_w1_dV_dt_GND)+(((model_.WAVL)*d_xi_w1_dV_dt_GND)*xi_w1));
        d_Weff_dV_c1_c2 = ((((model_.WAVL)*xi_w1)*d_xi_w1_dV_c1_c2)+(((model_.WAVL)*d_xi_w1_dV_c1_c2)*xi_w1));
        d_Weff_dV_b2_c1 = ((((model_.WAVL)*xi_w1)*d_xi_w1_dV_b2_c1)+(((model_.WAVL)*d_xi_w1_dV_b2_c1)*xi_w1));
        d_Weff_dV_b2_c2 = ((((model_.WAVL)*xi_w1)*d_xi_w1_dV_b2_c2)+(((model_.WAVL)*d_xi_w1_dV_b2_c2)*xi_w1));
        Weff = (((model_.WAVL)*xi_w1)*xi_w1);
      }
      {
        double value_sqrt_0 = sqrt(((xd*xd)+(Weff*Weff)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Wd_dV_c1_c2 = ((value_sqrt_0*((xd*d_Weff_dV_c1_c2)+(d_xd_dV_c1_c2*Weff))-(xd*Weff)*(deriv_sqrt_0_d0*((((xd*d_xd_dV_c1_c2)+(d_xd_dV_c1_c2*xd))+((Weff*d_Weff_dV_c1_c2)+(d_Weff_dV_c1_c2*Weff))))))/value_sqrt_0/value_sqrt_0);
        d_Wd_dV_b2_c1 = ((value_sqrt_0*((xd*d_Weff_dV_b2_c1)+(d_xd_dV_b2_c1*Weff))-(xd*Weff)*(deriv_sqrt_0_d0*((((xd*d_xd_dV_b2_c1)+(d_xd_dV_b2_c1*xd))+((Weff*d_Weff_dV_b2_c1)+(d_Weff_dV_b2_c1*Weff))))))/value_sqrt_0/value_sqrt_0);
        d_Wd_dV_b2_c2 = ((value_sqrt_0*((xd*d_Weff_dV_b2_c2)+(d_xd_dV_b2_c2*Weff))-(xd*Weff)*(deriv_sqrt_0_d0*((((xd*d_xd_dV_b2_c2)+(d_xd_dV_b2_c2*xd))+((Weff*d_Weff_dV_b2_c2)+(d_Weff_dV_b2_c2*Weff))))))/value_sqrt_0/value_sqrt_0);
        d_Wd_dV_dt_GND = ((value_sqrt_0*((xd*d_Weff_dV_dt_GND)+(d_xd_dV_dt_GND*Weff))-(xd*Weff)*(deriv_sqrt_0_d0*((((xd*d_xd_dV_dt_GND)+(d_xd_dV_dt_GND*xd))+((Weff*d_Weff_dV_dt_GND)+(d_Weff_dV_dt_GND*Weff))))))/value_sqrt_0/value_sqrt_0);
        Wd = ((xd*Weff)/value_sqrt_0);
      }

      d_Eav_dV_c1_c2 = (-(VDC_T-Vb2c1)*d_Wd_dV_c1_c2/Wd/Wd);
      d_Eav_dV_b2_c2 = (-(VDC_T-Vb2c1)*d_Wd_dV_b2_c2/Wd/Wd);
      d_Eav_dV_b2_c1 = ((Wd*(-d_Vb2c1_dV_b2_c1)-(VDC_T-Vb2c1)*d_Wd_dV_b2_c1)/Wd/Wd);
      d_Eav_dV_dt_GND = ((Wd*d_VDC_T_dV_dt_GND-(VDC_T-Vb2c1)*d_Wd_dV_dt_GND)/Wd/Wd);
      Eav = ((VDC_T-Vb2c1)/Wd);

      d_E0_dV_c1_c2 = (d_Eav_dV_c1_c2+((((0.5*Wd)*dEdx0)*d_Icap_IHC_dV_c1_c2)+(((0.5*d_Wd_dV_c1_c2)*dEdx0)*Icap_IHC)));
      d_E0_dV_b2_c2 = (d_Eav_dV_b2_c2+((((0.5*Wd)*dEdx0)*d_Icap_IHC_dV_b2_c2)+(((0.5*d_Wd_dV_b2_c2)*dEdx0)*Icap_IHC)));
      d_E0_dV_b2_c1 = (d_Eav_dV_b2_c1+((((0.5*Wd)*dEdx0)*d_Icap_IHC_dV_b2_c1)+(((0.5*d_Wd_dV_b2_c1)*dEdx0)*Icap_IHC)));
      d_E0_dV_dt_GND = (d_Eav_dV_dt_GND+((((0.5*Wd)*dEdx0)*d_Icap_IHC_dV_dt_GND)+(((0.5*d_Wd_dV_dt_GND)*dEdx0)*Icap_IHC)));
      E0 = (Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
      if (((model_.EXAVL)==0))
      {

        d_Em_dV_c1_c2 = d_E0_dV_c1_c2;
        d_Em_dV_b2_c2 = d_E0_dV_b2_c2;
        d_Em_dV_b2_c1 = d_E0_dV_b2_c1;
        d_Em_dV_dt_GND = d_E0_dV_dt_GND;
        Em = E0;
      }
      else
      {

        d_SHw_dV_dt_GND = ((2.0*(model_.SFH))*(2.0*d_xi_w_dV_dt_GND));
        d_SHw_dV_c1_c2 = ((2.0*(model_.SFH))*(2.0*d_xi_w_dV_c1_c2));
        d_SHw_dV_b2_c1 = ((2.0*(model_.SFH))*(2.0*d_xi_w_dV_b2_c1));
        d_SHw_dV_b2_c2 = ((2.0*(model_.SFH))*(2.0*d_xi_w_dV_b2_c2));
        SHw = (1.0+((2.0*(model_.SFH))*(1.0+(2.0*xi_w))));
        Efi = ((1.0+(model_.SFH))/(1.0+(2.0*(model_.SFH))));

        d_Ew_dV_c1_c2 = (d_Eav_dV_c1_c2-((((0.5*Wd)*dEdx0)*(-(((IHC_M*SHw)*d_Ic1c2_dV_c1_c2-Ic1c2*(IHC_M*d_SHw_dV_c1_c2))/(IHC_M*SHw)/(IHC_M*SHw))))+(((0.5*d_Wd_dV_c1_c2)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw))))));
        d_Ew_dV_b2_c2 = (d_Eav_dV_b2_c2-((((0.5*Wd)*dEdx0)*(-(((IHC_M*SHw)*d_Ic1c2_dV_b2_c2-Ic1c2*(IHC_M*d_SHw_dV_b2_c2))/(IHC_M*SHw)/(IHC_M*SHw))))+(((0.5*d_Wd_dV_b2_c2)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw))))));
        d_Ew_dV_b2_c1 = (d_Eav_dV_b2_c1-((((0.5*Wd)*dEdx0)*(-(((IHC_M*SHw)*d_Ic1c2_dV_b2_c1-Ic1c2*(IHC_M*d_SHw_dV_b2_c1))/(IHC_M*SHw)/(IHC_M*SHw))))+(((0.5*d_Wd_dV_b2_c1)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw))))));
        d_Ew_dV_dt_GND = (d_Eav_dV_dt_GND-((((0.5*Wd)*dEdx0)*(-(((IHC_M*SHw)*d_Ic1c2_dV_dt_GND-Ic1c2*(IHC_M*d_SHw_dV_dt_GND))/(IHC_M*SHw)/(IHC_M*SHw))))+(((0.5*d_Wd_dV_dt_GND)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw))))));
        Ew = (Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw)))));

        d_sqr_arg_dV_c1_c2 = ((((Ew-E0)*(d_Ew_dV_c1_c2-d_E0_dV_c1_c2))+((d_Ew_dV_c1_c2-d_E0_dV_c1_c2)*(Ew-E0)))+(((((0.1*Eav)*Eav)*d_Icap_dV_c1_c2)+((((0.1*Eav)*d_Eav_dV_c1_c2)+((0.1*d_Eav_dV_c1_c2)*Eav))*Icap))/IHC_M));
        d_sqr_arg_dV_b2_c2 = ((((Ew-E0)*(d_Ew_dV_b2_c2-d_E0_dV_b2_c2))+((d_Ew_dV_b2_c2-d_E0_dV_b2_c2)*(Ew-E0)))+(((((0.1*Eav)*Eav)*d_Icap_dV_b2_c2)+((((0.1*Eav)*d_Eav_dV_b2_c2)+((0.1*d_Eav_dV_b2_c2)*Eav))*Icap))/IHC_M));
        d_sqr_arg_dV_b2_c1 = ((((Ew-E0)*(d_Ew_dV_b2_c1-d_E0_dV_b2_c1))+((d_Ew_dV_b2_c1-d_E0_dV_b2_c1)*(Ew-E0)))+(((((0.1*Eav)*Eav)*d_Icap_dV_b2_c1)+((((0.1*Eav)*d_Eav_dV_b2_c1)+((0.1*d_Eav_dV_b2_c1)*Eav))*Icap))/IHC_M));
        d_sqr_arg_dV_dt_GND = ((((Ew-E0)*(d_Ew_dV_dt_GND-d_E0_dV_dt_GND))+((d_Ew_dV_dt_GND-d_E0_dV_dt_GND)*(Ew-E0)))+(((((0.1*Eav)*Eav)*d_Icap_dV_dt_GND)+((((0.1*Eav)*d_Eav_dV_dt_GND)+((0.1*d_Eav_dV_dt_GND)*Eav))*Icap))/IHC_M));
        sqr_arg = (((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/IHC_M));
        {
          double value_sqrt_0 = sqrt(sqr_arg);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Em_dV_c1_c2 = (0.5*((d_Ew_dV_c1_c2+d_E0_dV_c1_c2)+(deriv_sqrt_0_d0*(d_sqr_arg_dV_c1_c2))));
          d_Em_dV_b2_c2 = (0.5*((d_Ew_dV_b2_c2+d_E0_dV_b2_c2)+(deriv_sqrt_0_d0*(d_sqr_arg_dV_b2_c2))));
          d_Em_dV_b2_c1 = (0.5*((d_Ew_dV_b2_c1+d_E0_dV_b2_c1)+(deriv_sqrt_0_d0*(d_sqr_arg_dV_b2_c1))));
          d_Em_dV_dt_GND = (0.5*((d_Ew_dV_dt_GND+d_E0_dV_dt_GND)+(deriv_sqrt_0_d0*(d_sqr_arg_dV_dt_GND))));
          Em = (0.5*((Ew+E0)+value_sqrt_0));
        }
      }

      d_EmEav_Em_dV_c1_c2 = ((Em*(d_Em_dV_c1_c2-d_Eav_dV_c1_c2)-(Em-Eav)*d_Em_dV_c1_c2)/Em/Em);
      d_EmEav_Em_dV_b2_c2 = ((Em*(d_Em_dV_b2_c2-d_Eav_dV_b2_c2)-(Em-Eav)*d_Em_dV_b2_c2)/Em/Em);
      d_EmEav_Em_dV_b2_c1 = ((Em*(d_Em_dV_b2_c1-d_Eav_dV_b2_c1)-(Em-Eav)*d_Em_dV_b2_c1)/Em/Em);
      d_EmEav_Em_dV_dt_GND = ((Em*(d_Em_dV_dt_GND-d_Eav_dV_dt_GND)-(Em-Eav)*d_Em_dV_dt_GND)/Em/Em);
      EmEav_Em = ((Em-Eav)/Em);
      if ((fabs(EmEav_Em)>1.0e-7))
      {

        d_lambda_dV_c1_c2 = ((EmEav_Em*(0.5*d_Wd_dV_c1_c2)-(0.5*Wd)*d_EmEav_Em_dV_c1_c2)/EmEav_Em/EmEav_Em);
        d_lambda_dV_b2_c1 = ((EmEav_Em*(0.5*d_Wd_dV_b2_c1)-(0.5*Wd)*d_EmEav_Em_dV_b2_c1)/EmEav_Em/EmEav_Em);
        d_lambda_dV_b2_c2 = ((EmEav_Em*(0.5*d_Wd_dV_b2_c2)-(0.5*Wd)*d_EmEav_Em_dV_b2_c2)/EmEav_Em/EmEav_Em);
        d_lambda_dV_dt_GND = ((EmEav_Em*(0.5*d_Wd_dV_dt_GND)-(0.5*Wd)*d_EmEav_Em_dV_dt_GND)/EmEav_Em/EmEav_Em);
        lambda = ((0.5*Wd)/EmEav_Em);
        {
          double value_exp_0 = exp(((-BnT)/Em));
          double value_exp_1 = exp((((-BnT)/Em)*(1.0+(Weff/lambda))));
          double  deriv_exp_0_d0 = value_exp_0;
          double  deriv_exp_1_d0 = value_exp_1;

          d_Gem_dV_c1_c2 = (((((An/BnT)*Em)*lambda)*((deriv_exp_0_d0*((-(-BnT)*d_Em_dV_c1_c2/Em/Em)))-(deriv_exp_1_d0*(((((-BnT)/Em)*((lambda*d_Weff_dV_c1_c2-Weff*d_lambda_dV_c1_c2)/lambda/lambda))+((-(-BnT)*d_Em_dV_c1_c2/Em/Em)*(1.0+(Weff/lambda))))))))+(((((An/BnT)*Em)*d_lambda_dV_c1_c2)+(((An/BnT)*d_Em_dV_c1_c2)*lambda))*(value_exp_0-value_exp_1)));
          d_Gem_dV_b2_c2 = (((((An/BnT)*Em)*lambda)*((deriv_exp_0_d0*((-(-BnT)*d_Em_dV_b2_c2/Em/Em)))-(deriv_exp_1_d0*(((((-BnT)/Em)*((lambda*d_Weff_dV_b2_c2-Weff*d_lambda_dV_b2_c2)/lambda/lambda))+((-(-BnT)*d_Em_dV_b2_c2/Em/Em)*(1.0+(Weff/lambda))))))))+(((((An/BnT)*Em)*d_lambda_dV_b2_c2)+(((An/BnT)*d_Em_dV_b2_c2)*lambda))*(value_exp_0-value_exp_1)));
          d_Gem_dV_b2_c1 = (((((An/BnT)*Em)*lambda)*((deriv_exp_0_d0*((-(-BnT)*d_Em_dV_b2_c1/Em/Em)))-(deriv_exp_1_d0*(((((-BnT)/Em)*((lambda*d_Weff_dV_b2_c1-Weff*d_lambda_dV_b2_c1)/lambda/lambda))+((-(-BnT)*d_Em_dV_b2_c1/Em/Em)*(1.0+(Weff/lambda))))))))+(((((An/BnT)*Em)*d_lambda_dV_b2_c1)+(((An/BnT)*d_Em_dV_b2_c1)*lambda))*(value_exp_0-value_exp_1)));
          d_Gem_dV_dt_GND = (((((An/BnT)*Em)*lambda)*((deriv_exp_0_d0*(((Em*(-d_BnT_dV_dt_GND)-(-BnT)*d_Em_dV_dt_GND)/Em/Em)))-(deriv_exp_1_d0*(((((-BnT)/Em)*((lambda*d_Weff_dV_dt_GND-Weff*d_lambda_dV_dt_GND)/lambda/lambda))+(((Em*(-d_BnT_dV_dt_GND)-(-BnT)*d_Em_dV_dt_GND)/Em/Em)*(1.0+(Weff/lambda))))))))+(((((An/BnT)*Em)*d_lambda_dV_dt_GND)+((((An/BnT)*d_Em_dV_dt_GND)+((-An*d_BnT_dV_dt_GND/BnT/BnT)*Em))*lambda))*(value_exp_0-value_exp_1)));
          Gem = ((((An/BnT)*Em)*lambda)*(value_exp_0-value_exp_1));
        }
      }
      else
      {
        {
          double value_exp_0 = exp(((-BnT)/Em));
          double  deriv_exp_0_d0 = value_exp_0;

          d_Gem_dV_dt_GND = (((An*Weff)*(deriv_exp_0_d0*(((Em*(-d_BnT_dV_dt_GND)-(-BnT)*d_Em_dV_dt_GND)/Em/Em))))+((An*d_Weff_dV_dt_GND)*value_exp_0));
          d_Gem_dV_c1_c2 = (((An*Weff)*(deriv_exp_0_d0*((-(-BnT)*d_Em_dV_c1_c2/Em/Em))))+((An*d_Weff_dV_c1_c2)*value_exp_0));
          d_Gem_dV_b2_c1 = (((An*Weff)*(deriv_exp_0_d0*((-(-BnT)*d_Em_dV_b2_c1/Em/Em))))+((An*d_Weff_dV_b2_c1)*value_exp_0));
          d_Gem_dV_b2_c2 = (((An*Weff)*(deriv_exp_0_d0*((-(-BnT)*d_Em_dV_b2_c2/Em/Em))))+((An*d_Weff_dV_b2_c2)*value_exp_0));
          Gem = ((An*Weff)*value_exp_0);
        }
      }

      d_Gmax_dV_b2_e1 = (((-Vt*(Ic1c2*d_Rb2_dV_b2_e1)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(d_qBI_dV_b2_e1/BF_T))+(-RE_TM*d_Rb2_dV_b2_e1/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_c3_c4 = ((-Vt*(Ic1c2*d_Rb2_dV_c3_c4)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(-RE_TM*d_Rb2_dV_c3_c4/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_c3_c1 = ((-Vt*(Ic1c2*d_Rb2_dV_c3_c1)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(-RE_TM*d_Rb2_dV_c3_c1/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_c4_c1 = ((-Vt*(Ic1c2*d_Rb2_dV_c4_c1)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(-RE_TM*d_Rb2_dV_c4_c1/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_b1_b2 = ((-Vt*(Ic1c2*d_Rb2_dV_b1_b2)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(-RE_TM*d_Rb2_dV_b1_b2/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_b_b1 = ((-Vt*(Ic1c2*d_Rb2_dV_b_b1)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(-RE_TM*d_Rb2_dV_b_b1/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_b_c = ((-Vt*(Ic1c2*d_Rb2_dV_b_c)/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(-RE_TM*d_Rb2_dV_b_c/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_c1_c2 = (((-Vt*((Ic1c2*d_Rb2_dV_c1_c2)+(d_Ic1c2_dV_c1_c2*(RBC_TM+Rb2)))/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(d_qBI_dV_c1_c2/BF_T))+(-RE_TM*d_Rb2_dV_c1_c2/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_b2_c1 = (((-Vt*((Ic1c2*d_Rb2_dV_b2_c1)+(d_Ic1c2_dV_b2_c1*(RBC_TM+Rb2)))/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(d_qBI_dV_b2_c1/BF_T))+(-RE_TM*d_Rb2_dV_b2_c1/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_b2_c2 = (((-Vt*((Ic1c2*d_Rb2_dV_b2_c2)+(d_Ic1c2_dV_b2_c2*(RBC_TM+Rb2)))/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+(d_qBI_dV_b2_c2/BF_T))+(-RE_TM*d_Rb2_dV_b2_c2/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      d_Gmax_dV_dt_GND = (((((Ic1c2*(RBC_TM+Rb2))*d_Vt_dV_dt_GND-Vt*((Ic1c2*(d_RBC_TM_dV_dt_GND+d_Rb2_dV_dt_GND))+(d_Ic1c2_dV_dt_GND*(RBC_TM+Rb2))))/(Ic1c2*(RBC_TM+Rb2))/(Ic1c2*(RBC_TM+Rb2)))+((BF_T*d_qBI_dV_dt_GND-qBI*d_BF_T_dV_dt_GND)/BF_T/BF_T))+(((RBC_TM+Rb2)*d_RE_TM_dV_dt_GND-RE_TM*(d_RBC_TM_dV_dt_GND+d_Rb2_dV_dt_GND))/(RBC_TM+Rb2)/(RBC_TM+Rb2)));
      Gmax = (((Vt/(Ic1c2*(RBC_TM+Rb2)))+(qBI/BF_T))+(RE_TM/(RBC_TM+Rb2)));

      d_Iavl_dV_b2_e1 = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_b2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_c3_c4 = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_c3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_c3_c1 = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_c3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_c4_c1 = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_c4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_b1_b2 = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_b1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_b_b1 = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_b_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_b_c = (-(Ic1c2*Gem)*(-Gem*d_Gmax_dV_b_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_c1_c2 = ((((Gem+(Gem/Gmax))+1.0)*((Ic1c2*d_Gem_dV_c1_c2)+(d_Ic1c2_dV_c1_c2*Gem))-(Ic1c2*Gem)*(d_Gem_dV_c1_c2+((Gmax*d_Gem_dV_c1_c2-Gem*d_Gmax_dV_c1_c2)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_b2_c1 = ((((Gem+(Gem/Gmax))+1.0)*((Ic1c2*d_Gem_dV_b2_c1)+(d_Ic1c2_dV_b2_c1*Gem))-(Ic1c2*Gem)*(d_Gem_dV_b2_c1+((Gmax*d_Gem_dV_b2_c1-Gem*d_Gmax_dV_b2_c1)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_b2_c2 = ((((Gem+(Gem/Gmax))+1.0)*((Ic1c2*d_Gem_dV_b2_c2)+(d_Ic1c2_dV_b2_c2*Gem))-(Ic1c2*Gem)*(d_Gem_dV_b2_c2+((Gmax*d_Gem_dV_b2_c2-Gem*d_Gmax_dV_b2_c2)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      d_Iavl_dV_dt_GND = ((((Gem+(Gem/Gmax))+1.0)*((Ic1c2*d_Gem_dV_dt_GND)+(d_Ic1c2_dV_dt_GND*Gem))-(Ic1c2*Gem)*(d_Gem_dV_dt_GND+((Gmax*d_Gem_dV_dt_GND-Gem*d_Gmax_dV_dt_GND)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
      Iavl = ((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0));
    }
    if ((eVb2c2star>0.0))
    {
      {
        double value_log_0 = log(eVb2c2star);
        double  deriv_log_0_d0 = (1.0/eVb2c2star);

        d_Vb2c2star_dV_c1_c2 = (Vt*(deriv_log_0_d0*(d_eVb2c2star_dV_c1_c2)));
        d_Vb2c2star_dV_b2_c1 = (Vt*(deriv_log_0_d0*(d_eVb2c2star_dV_b2_c1)));
        d_Vb2c2star_dV_b2_c2 = (Vt*(deriv_log_0_d0*(d_eVb2c2star_dV_b2_c2)));
        d_Vb2c2star_dV_dt_GND = ((Vt*(deriv_log_0_d0*(d_eVb2c2star_dV_dt_GND)))+(d_Vt_dV_dt_GND*value_log_0));
        Vb2c2star = (Vt*value_log_0);
      }
    }
    else
    {

      d_Vb2c2star_dV_dt_GND = d_Vb2c2star_dV_b2_c1 = d_Vb2c2star_dV_c1_c2 =  0.0;
      d_Vb2c2star_dV_b2_c2 = d_Vb2c2_dV_b2_c2;
      Vb2c2star = Vb2c2;
    }

    d_power_dV_s_c1 = ((((d_XIex_dV_s_c1*Vbc3)+((Isub*(-d_Vsc4_dV_s_c1))+(d_Isub_dV_s_c1*(Vb1c4-Vsc4))))+((XIsub*(-d_Vsc3_dV_s_c1))+(d_XIsub_dV_s_c1*(Vbc3-Vsc3))))+((Isf*d_Vsc1_dV_s_c1)+(d_Isf_dV_s_c1*Vsc1)));
    d_power_dV_b1_e1 = ((Ib1_s*d_Vb1e1_dV_b1_e1)+(d_Ib1_s_dV_b1_e1*Vb1e1));
    d_power_dV_e_e1 = (((Vee1*d_Vee1_dV_e_e1)+(d_Vee1_dV_e_e1*Vee1))/RE_TM);
    d_power_dV_c3_c4 = ((((((-(d_Iavl_dV_c3_c4*Vb2c2star))+(((Vcc3*d_Vcc3_dV_c3_c4)+(d_Vcc3_dV_c3_c4*Vcc3))*GCCxx_TM))+(((Vc3c4*d_Vc3c4_dV_c3_c4)+(d_Vc3c4_dV_c3_c4*Vc3c4))*GCCex_TM))+(d_Ib1b2_dV_c3_c4*Vb1b2))+((XIex*d_Vbc3_dV_c3_c4)+(d_XIex_dV_c3_c4*Vbc3)))+((XIsub*(d_Vbc3_dV_c3_c4-d_Vsc3_dV_c3_c4))+(d_XIsub_dV_c3_c4*(Vbc3-Vsc3))));
    d_power_dV_c3_c1 = ((((((-(d_Iavl_dV_c3_c1*Vb2c2star))+(((Vcc3*d_Vcc3_dV_c3_c1)+(d_Vcc3_dV_c3_c1*Vcc3))*GCCxx_TM))+(((Vc3c4*d_Vc3c4_dV_c3_c1)+(d_Vc3c4_dV_c3_c1*Vc3c4))*GCCex_TM))+(d_Ib1b2_dV_c3_c1*Vb1b2))+((XIex*d_Vbc3_dV_c3_c1)+(d_XIex_dV_c3_c1*Vbc3)))+((XIsub*(d_Vbc3_dV_c3_c1-d_Vsc3_dV_c3_c1))+(d_XIsub_dV_c3_c1*(Vbc3-Vsc3))));
    d_power_dV_c4_c1 = ((((((((-(d_Iavl_dV_c4_c1*Vb2c2star))+(((Vcc3*d_Vcc3_dV_c4_c1)+(d_Vcc3_dV_c4_c1*Vcc3))*GCCxx_TM))+(((Vc4c1*d_Vc4c1_dV_c4_c1)+(d_Vc4c1_dV_c4_c1*Vc4c1))*GCCin_TM))+(d_Ib1b2_dV_c4_c1*Vb1b2))+(((Iex+Ib3)*d_Vb1c4_dV_c4_c1)+((d_Iex_dV_c4_c1+d_Ib3_dV_c4_c1)*Vb1c4)))+((XIex*d_Vbc3_dV_c4_c1)+(d_XIex_dV_c4_c1*Vbc3)))+((Isub*(d_Vb1c4_dV_c4_c1-d_Vsc4_dV_c4_c1))+(d_Isub_dV_c4_c1*(Vb1c4-Vsc4))))+((XIsub*(d_Vbc3_dV_c4_c1-d_Vsc3_dV_c4_c1))+(d_XIsub_dV_c4_c1*(Vbc3-Vsc3))));
    d_power_dV_b1_b2 = (((((((-(d_Iavl_dV_b1_b2*Vb2c2star))+(((Vcc3*d_Vcc3_dV_b1_b2)+(d_Vcc3_dV_b1_b2*Vcc3))*GCCxx_TM))+((Ib1b2*d_Vb1b2_dV_b1_b2)+(d_Ib1b2_dV_b1_b2*Vb1b2)))+(((Iex+Ib3)*d_Vb1c4_dV_b1_b2)+((d_Iex_dV_b1_b2+d_Ib3_dV_b1_b2)*Vb1c4)))+((XIex*d_Vbc3_dV_b1_b2)+(d_XIex_dV_b1_b2*Vbc3)))+((Isub*d_Vb1c4_dV_b1_b2)+(d_Isub_dV_b1_b2*(Vb1c4-Vsc4))))+((XIsub*d_Vbc3_dV_b1_b2)+(d_XIsub_dV_b1_b2*(Vbc3-Vsc3))));
    d_power_dV_b_b1 = ((((((-(d_Iavl_dV_b_b1*Vb2c2star))+(((Vcc3*d_Vcc3_dV_b_b1)+(d_Vcc3_dV_b_b1*Vcc3))*GCCxx_TM))+(((Vbb1*d_Vbb1_dV_b_b1)+(d_Vbb1_dV_b_b1*Vbb1))/RBC_TM))+(d_Ib1b2_dV_b_b1*Vb1b2))+((XIex*d_Vbc3_dV_b_b1)+(d_XIex_dV_b_b1*Vbc3)))+((XIsub*d_Vbc3_dV_b_b1)+(d_XIsub_dV_b_b1*(Vbc3-Vsc3))));
    d_power_dV_b_c = (((((-(d_Iavl_dV_b_c*Vb2c2star))+(((Vcc3*d_Vcc3_dV_b_c)+(d_Vcc3_dV_b_c*Vcc3))*GCCxx_TM))+(d_Ib1b2_dV_b_c*Vb1b2))+((XIex*d_Vbc3_dV_b_c)+(d_XIex_dV_b_c*Vbc3)))+((XIsub*d_Vbc3_dV_b_c)+(d_XIsub_dV_b_c*(Vbc3-Vsc3))));
    d_power_dV_c1_c2 = (((((((((((In*(-d_Vb2c2star_dV_c1_c2))+(d_In_dV_c1_c2*(Vb2e1-Vb2c2star)))+((Ic1c2*d_Vb2c2star_dV_c1_c2)+(d_Ic1c2_dV_c1_c2*(Vb2c2star-Vb2c1))))-((Iavl*d_Vb2c2star_dV_c1_c2)+(d_Iavl_dV_c1_c2*Vb2c2star)))+(((Vcc3*d_Vcc3_dV_c1_c2)+(d_Vcc3_dV_c1_c2*Vcc3))*GCCxx_TM))+(d_Ib1b2_dV_c1_c2*Vb1b2))+((d_Ib1_dV_c1_c2-d_Izteb_dV_c1_c2)*Vb2e1))+(((Iex+Ib3)*d_Vb1c4_dV_c1_c2)+((d_Iex_dV_c1_c2+d_Ib3_dV_c1_c2)*Vb1c4)))+((XIex*d_Vbc3_dV_c1_c2)+(d_XIex_dV_c1_c2*Vbc3)))+((Isub*d_Vb1c4_dV_c1_c2)+(d_Isub_dV_c1_c2*(Vb1c4-Vsc4))))+((XIsub*d_Vbc3_dV_c1_c2)+(d_XIsub_dV_c1_c2*(Vbc3-Vsc3))));
    d_power_dV_b2_c1 = ((((((((In*(-d_Vb2c2star_dV_b2_c1))+(d_In_dV_b2_c1*(Vb2e1-Vb2c2star)))+((Ic1c2*(d_Vb2c2star_dV_b2_c1-d_Vb2c1_dV_b2_c1))+(d_Ic1c2_dV_b2_c1*(Vb2c2star-Vb2c1))))-((Iavl*d_Vb2c2star_dV_b2_c1)+(d_Iavl_dV_b2_c1*Vb2c2star)))+(d_Ib1b2_dV_b2_c1*Vb1b2))+((d_Ib1_dV_b2_c1-d_Izteb_dV_b2_c1)*Vb2e1))+(d_XIex_dV_b2_c1*Vbc3))+(d_XIsub_dV_b2_c1*(Vbc3-Vsc3)));
    d_power_dV_b2_c2 = (((((((((((In*(-d_Vb2c2star_dV_b2_c2))+(d_In_dV_b2_c2*(Vb2e1-Vb2c2star)))+((Ic1c2*d_Vb2c2star_dV_b2_c2)+(d_Ic1c2_dV_b2_c2*(Vb2c2star-Vb2c1))))-((Iavl*d_Vb2c2star_dV_b2_c2)+(d_Iavl_dV_b2_c2*Vb2c2star)))+(((Vcc3*d_Vcc3_dV_b2_c2)+(d_Vcc3_dV_b2_c2*Vcc3))*GCCxx_TM))+(d_Ib1b2_dV_b2_c2*Vb1b2))+((d_Ib1_dV_b2_c2-d_Izteb_dV_b2_c2)*Vb2e1))+(((Iex+Ib3)*d_Vb1c4_dV_b2_c2)+((d_Iex_dV_b2_c2+d_Ib3_dV_b2_c2)*Vb1c4)))+((XIex*d_Vbc3_dV_b2_c2)+(d_XIex_dV_b2_c2*Vbc3)))+((Isub*d_Vb1c4_dV_b2_c2)+(d_Isub_dV_b2_c2*(Vb1c4-Vsc4))))+((XIsub*d_Vbc3_dV_b2_c2)+(d_XIsub_dV_b2_c2*(Vbc3-Vsc3))));
    d_power_dV_b2_e1 = ((((((((In*d_Vb2e1_dV_b2_e1)+(d_In_dV_b2_e1*(Vb2e1-Vb2c2star)))-(d_Iavl_dV_b2_e1*Vb2c2star))+(d_Ib1b2_dV_b2_e1*Vb1b2))+((((Ib1+Ib2)-Izteb)*d_Vb2e1_dV_b2_e1)+(((d_Ib1_dV_b2_e1+d_Ib2_dV_b2_e1)-d_Izteb_dV_b2_e1)*Vb2e1)))+(d_Ib3_dV_b2_e1*Vb1c4))+(d_XIex_dV_b2_e1*Vbc3))+(d_XIsub_dV_b2_e1*(Vbc3-Vsc3)));
    d_power_dV_dt_GND = (((((((((((((((((In*(-d_Vb2c2star_dV_dt_GND))+(d_In_dV_dt_GND*(Vb2e1-Vb2c2star)))+((Ic1c2*d_Vb2c2star_dV_dt_GND)+(d_Ic1c2_dV_dt_GND*(Vb2c2star-Vb2c1))))-((Iavl*d_Vb2c2star_dV_dt_GND)+(d_Iavl_dV_dt_GND*Vb2c2star)))+(-(Vee1*Vee1)*d_RE_TM_dV_dt_GND/RE_TM/RE_TM))+((Vcc3*Vcc3)*d_GCCxx_TM_dV_dt_GND))+((Vc3c4*Vc3c4)*d_GCCex_TM_dV_dt_GND))+((Vc4c1*Vc4c1)*d_GCCin_TM_dV_dt_GND))+(-(Vbb1*Vbb1)*d_RBC_TM_dV_dt_GND/RBC_TM/RBC_TM))+(d_Ib1b2_dV_dt_GND*Vb1b2))+(((d_Ib1_dV_dt_GND+d_Ib2_dV_dt_GND)-d_Izteb_dV_dt_GND)*Vb2e1))+(d_Ib1_s_dV_dt_GND*Vb1e1))+((d_Iex_dV_dt_GND+d_Ib3_dV_dt_GND)*Vb1c4))+(d_XIex_dV_dt_GND*Vbc3))+(d_Isub_dV_dt_GND*(Vb1c4-Vsc4)))+(d_XIsub_dV_dt_GND*(Vbc3-Vsc3)))+(d_Isf_dV_dt_GND*Vsc1));
    power = ((((((((((((((((In*(Vb2e1-Vb2c2star))+(Ic1c2*(Vb2c2star-Vb2c1)))-(Iavl*Vb2c2star))+((Vee1*Vee1)/RE_TM))+((Vcc3*Vcc3)*GCCxx_TM))+((Vc3c4*Vc3c4)*GCCex_TM))+((Vc4c1*Vc4c1)*GCCin_TM))+((Vbb1*Vbb1)/RBC_TM))+(Ib1b2*Vb1b2))+(((Ib1+Ib2)-Izteb)*Vb2e1))+(Ib1_s*Vb1e1))+((Iex+Ib3)*Vb1c4))+(XIex*Vbc3))+(Isub*(Vb1c4-Vsc4)))+(XIsub*(Vbc3-Vsc3)))+(Isf*Vsc1));

    d_Qte_dV_c1_c2 = (((1.0-(model_.XCJE))*CJE_TM)*d_Vte_dV_c1_c2);
    d_Qte_dV_b2_c1 = (((1.0-(model_.XCJE))*CJE_TM)*d_Vte_dV_b2_c1);
    d_Qte_dV_b2_c2 = (((1.0-(model_.XCJE))*CJE_TM)*d_Vte_dV_b2_c2);
    d_Qte_dV_b2_e1 = (((1.0-(model_.XCJE))*CJE_TM)*d_Vte_dV_b2_e1);
    d_Qte_dV_dt_GND = ((((1.0-(model_.XCJE))*CJE_TM)*d_Vte_dV_dt_GND)+(((1.0-(model_.XCJE))*d_CJE_TM_dV_dt_GND)*Vte));
    Qte = (((1.0-(model_.XCJE))*CJE_TM)*Vte);

    d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
    d_dxa_dV_dt_GND = ((a_VDE*(-d_Vfe_dV_dt_GND)-(Vb1e1-Vfe)*d_a_VDE_dV_dt_GND)/a_VDE/a_VDE);
    d_dxa_dV_b1_e1 = (d_Vb1e1_dV_b1_e1/a_VDE);
    dxa = ((Vb1e1-Vfe)/a_VDE);
    if ((Vb1e1<Vfe))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vje_s_dV_c1_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2))))));
        d_Vje_s_dV_b2_c1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1))))));
        d_Vje_s_dV_b2_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2))))));
        d_Vje_s_dV_b2_e1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_e1))))));
        d_Vje_s_dV_dt_GND = (-((a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_a_VDE_dV_dt_GND*value_log_1)));
        d_Vje_s_dV_b1_e1 = (d_Vb1e1_dV_b1_e1-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_e1))))));
        Vje_s = (Vb1e1-(a_VDE*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vje_s_dV_c1_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2)))))));
        d_Vje_s_dV_b2_c1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1)))))));
        d_Vje_s_dV_b2_c2 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2)))))));
        d_Vje_s_dV_b2_e1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_e1)))))));
        d_Vje_s_dV_b1_e1 = (-(a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_e1)))))));
        d_Vje_s_dV_dt_GND = (d_Vfe_dV_dt_GND-((a_VDE*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_a_VDE_dV_dt_GND*value_log_1)));
        Vje_s = (Vfe-(a_VDE*value_log_1));
      }
    }

    Vje_s = Vje_s;
    {
      double value_pow_0 = pow((1.0-(Vje_s*inv_VDE_T)),(1.0-(model_.PE)));
      double  deriv_pow_0_d0 = (((1.0-(Vje_s*inv_VDE_T)) == 0.0)?0.0:(value_pow_0*(1.0-(model_.PE))/(1.0-(Vje_s*inv_VDE_T))));

      d_Qte_s_dV_c1_c2 = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(-(deriv_pow_0_d0*((-(d_Vje_s_dV_c1_c2*inv_VDE_T))))))+(3.0*(-d_Vje_s_dV_c1_c2))));
      d_Qte_s_dV_b2_c1 = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(-(deriv_pow_0_d0*((-(d_Vje_s_dV_b2_c1*inv_VDE_T))))))+(3.0*(-d_Vje_s_dV_b2_c1))));
      d_Qte_s_dV_b2_c2 = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(-(deriv_pow_0_d0*((-(d_Vje_s_dV_b2_c2*inv_VDE_T))))))+(3.0*(-d_Vje_s_dV_b2_c2))));
      d_Qte_s_dV_b2_e1 = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(-(deriv_pow_0_d0*((-(d_Vje_s_dV_b2_e1*inv_VDE_T))))))+(3.0*(-d_Vje_s_dV_b2_e1))));
      d_Qte_s_dV_b1_e1 = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(-(deriv_pow_0_d0*((-(d_Vje_s_dV_b1_e1*inv_VDE_T))))))+(3.0*(d_Vb1e1_dV_b1_e1-d_Vje_s_dV_b1_e1))));
      d_Qte_s_dV_dt_GND = ((((model_.XCJE)*CJE_TM)*((((VDE_T/(1.0-(model_.PE)))*(-(deriv_pow_0_d0*((-((Vje_s*d_inv_VDE_T_dV_dt_GND)+(d_Vje_s_dV_dt_GND*inv_VDE_T)))))))+((d_VDE_T_dV_dt_GND/(1.0-(model_.PE)))*(1.0-value_pow_0)))+(3.0*(-d_Vje_s_dV_dt_GND))))+(((model_.XCJE)*d_CJE_TM_dV_dt_GND)*(((VDE_T/(1.0-(model_.PE)))*(1.0-value_pow_0))+(3.0*(Vb1e1-Vje_s)))));
      Qte_s = (((model_.XCJE)*CJE_TM)*(((VDE_T/(1.0-(model_.PE)))*(1.0-value_pow_0))+(3.0*(Vb1e1-Vje_s))));
    }

    d_Qtc_dV_b2_e1 = (((model_.XCJC)*CJC_TM)*d_Vtc_dV_b2_e1);
    d_Qtc_dV_c1_c2 = (((model_.XCJC)*CJC_TM)*d_Vtc_dV_c1_c2);
    d_Qtc_dV_b2_c1 = (((model_.XCJC)*CJC_TM)*d_Vtc_dV_b2_c1);
    d_Qtc_dV_b2_c2 = (((model_.XCJC)*CJC_TM)*d_Vtc_dV_b2_c2);
    d_Qtc_dV_dt_GND = ((((model_.XCJC)*CJC_TM)*d_Vtc_dV_dt_GND)+(((model_.XCJC)*d_CJC_TM_dV_dt_GND)*Vtc));
    Qtc = (((model_.XCJC)*CJC_TM)*Vtc);

    d_Qb0_dV_dt_GND = ((TAUB_T*d_IK_TM_dV_dt_GND)+(d_TAUB_T_dV_dt_GND*IK_TM));
    Qb0 = (TAUB_T*IK_TM);

    d_Qbe_qs_dV_c1_c2 = (((0.5*Qb0)*n0)*d_q1Q_dV_c1_c2);
    d_Qbe_qs_dV_b2_c1 = (((0.5*Qb0)*n0)*d_q1Q_dV_b2_c1);
    d_Qbe_qs_dV_b2_c2 = (((0.5*Qb0)*n0)*d_q1Q_dV_b2_c2);
    d_Qbe_qs_dV_c3_c4 = (((0.5*Qb0)*n0)*d_q1Q_dV_c3_c4);
    d_Qbe_qs_dV_c3_c1 = (((0.5*Qb0)*n0)*d_q1Q_dV_c3_c1);
    d_Qbe_qs_dV_c4_c1 = (((0.5*Qb0)*n0)*d_q1Q_dV_c4_c1);
    d_Qbe_qs_dV_b1_b2 = (((0.5*Qb0)*n0)*d_q1Q_dV_b1_b2);
    d_Qbe_qs_dV_b_b1 = (((0.5*Qb0)*n0)*d_q1Q_dV_b_b1);
    d_Qbe_qs_dV_b_c = (((0.5*Qb0)*n0)*d_q1Q_dV_b_c);
    d_Qbe_qs_dV_b2_e1 = ((((0.5*Qb0)*n0)*d_q1Q_dV_b2_e1)+(((0.5*Qb0)*d_n0_dV_b2_e1)*q1Q));
    d_Qbe_qs_dV_dt_GND = ((((0.5*Qb0)*n0)*d_q1Q_dV_dt_GND)+((((0.5*Qb0)*d_n0_dV_dt_GND)+((0.5*d_Qb0_dV_dt_GND)*n0))*q1Q));
    Qbe_qs = (((0.5*Qb0)*n0)*q1Q);

    d_Qbc_qs_dV_b2_e1 = (((0.5*Qb0)*nB)*d_q1Q_dV_b2_e1);
    d_Qbc_qs_dV_c3_c4 = (((0.5*Qb0)*nB)*d_q1Q_dV_c3_c4);
    d_Qbc_qs_dV_c3_c1 = (((0.5*Qb0)*nB)*d_q1Q_dV_c3_c1);
    d_Qbc_qs_dV_c4_c1 = (((0.5*Qb0)*nB)*d_q1Q_dV_c4_c1);
    d_Qbc_qs_dV_b1_b2 = (((0.5*Qb0)*nB)*d_q1Q_dV_b1_b2);
    d_Qbc_qs_dV_b_b1 = (((0.5*Qb0)*nB)*d_q1Q_dV_b_b1);
    d_Qbc_qs_dV_b_c = (((0.5*Qb0)*nB)*d_q1Q_dV_b_c);
    d_Qbc_qs_dV_c1_c2 = ((((0.5*Qb0)*nB)*d_q1Q_dV_c1_c2)+(((0.5*Qb0)*d_nB_dV_c1_c2)*q1Q));
    d_Qbc_qs_dV_b2_c1 = ((((0.5*Qb0)*nB)*d_q1Q_dV_b2_c1)+(((0.5*Qb0)*d_nB_dV_b2_c1)*q1Q));
    d_Qbc_qs_dV_b2_c2 = ((((0.5*Qb0)*nB)*d_q1Q_dV_b2_c2)+(((0.5*Qb0)*d_nB_dV_b2_c2)*q1Q));
    d_Qbc_qs_dV_dt_GND = ((((0.5*Qb0)*nB)*d_q1Q_dV_dt_GND)+((((0.5*Qb0)*d_nB_dV_dt_GND)+((0.5*d_Qb0_dV_dt_GND)*nB))*q1Q));
    Qbc_qs = (((0.5*Qb0)*nB)*q1Q);

    d_a_VDC_dV_dt_GND = (0.1*d_VDC_T_dV_dt_GND);
    a_VDC = (0.1*VDC_T);

    d_dxa_dV_s_c1 = d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c1 =  0.0;
    d_dxa_dV_dt_GND = ((a_VDC*(-d_Vfc_dV_dt_GND)-(Vb1c4-Vfc)*d_a_VDC_dV_dt_GND)/a_VDC/a_VDC);
    d_dxa_dV_c4_c1 = (d_Vb1c4_dV_c4_c1/a_VDC);
    d_dxa_dV_c1_c2 = (d_Vb1c4_dV_c1_c2/a_VDC);
    d_dxa_dV_b2_c2 = (d_Vb1c4_dV_b2_c2/a_VDC);
    d_dxa_dV_b1_b2 = (d_Vb1c4_dV_b1_b2/a_VDC);
    dxa = ((Vb1c4-Vfc)/a_VDC);
    if ((Vb1c4<Vfc))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vjcex_dV_b2_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1))))));
        d_Vjcex_dV_b2_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_e1))))));
        d_Vjcex_dV_b1_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_e1))))));
        d_Vjcex_dV_dt_GND = (-((a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_a_VDC_dV_dt_GND*value_log_1)));
        d_Vjcex_dV_c4_c1 = (d_Vb1c4_dV_c4_c1-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c4_c1))))));
        d_Vjcex_dV_c1_c2 = (d_Vb1c4_dV_c1_c2-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2))))));
        d_Vjcex_dV_b2_c2 = (d_Vb1c4_dV_b2_c2-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2))))));
        d_Vjcex_dV_b1_b2 = (d_Vb1c4_dV_b1_b2-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_b2))))));
        Vjcex = (Vb1c4-(a_VDC*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vjcex_dV_c1_c2 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2)))))));
        d_Vjcex_dV_b2_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1)))))));
        d_Vjcex_dV_b2_c2 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2)))))));
        d_Vjcex_dV_b2_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_e1)))))));
        d_Vjcex_dV_b1_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_e1)))))));
        d_Vjcex_dV_c4_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c4_c1)))))));
        d_Vjcex_dV_b1_b2 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_b2)))))));
        d_Vjcex_dV_dt_GND = (d_Vfc_dV_dt_GND-((a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_a_VDC_dV_dt_GND*value_log_1)));
        Vjcex = (Vfc-(a_VDC*value_log_1));
      }
    }

    Vjcex = Vjcex;
    {
      double value_pow_0 = pow((1.0-(Vjcex/VDC_T)),(1.0-(model_.PC)));
      double  deriv_pow_0_d0 = (((1.0-(Vjcex/VDC_T)) == 0.0)?0.0:(value_pow_0*(1.0-(model_.PC))/(1.0-(Vjcex/VDC_T))));

      d_Vtexv_dV_b2_c1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_b2_c1/VDC_T))))))+(bjc*(-d_Vjcex_dV_b2_c1)));
      d_Vtexv_dV_b2_e1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_b2_e1/VDC_T))))))+(bjc*(-d_Vjcex_dV_b2_e1)));
      d_Vtexv_dV_b1_e1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_b1_e1/VDC_T))))))+(bjc*(-d_Vjcex_dV_b1_e1)));
      d_Vtexv_dV_c4_c1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_c4_c1/VDC_T))))))+(bjc*(d_Vb1c4_dV_c4_c1-d_Vjcex_dV_c4_c1)));
      d_Vtexv_dV_c1_c2 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_c1_c2/VDC_T))))))+(bjc*(d_Vb1c4_dV_c1_c2-d_Vjcex_dV_c1_c2)));
      d_Vtexv_dV_b2_c2 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_b2_c2/VDC_T))))))+(bjc*(d_Vb1c4_dV_b2_c2-d_Vjcex_dV_b2_c2)));
      d_Vtexv_dV_b1_b2 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_Vjcex_dV_b1_b2/VDC_T))))))+(bjc*(d_Vb1c4_dV_b1_b2-d_Vjcex_dV_b1_b2)));
      d_Vtexv_dV_dt_GND = ((((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-((VDC_T*d_Vjcex_dV_dt_GND-Vjcex*d_VDC_T_dV_dt_GND)/VDC_T/VDC_T))))))+((d_VDC_T_dV_dt_GND/(1.0-(model_.PC)))*(1.0-value_pow_0)))+((bjc*(-d_Vjcex_dV_dt_GND))+(d_bjc_dV_dt_GND*(Vb1c4-Vjcex))));
      Vtexv = (((VDC_T/(1.0-(model_.PC)))*(1.0-value_pow_0))+(bjc*(Vb1c4-Vjcex)));
    }

    d_Qtex_dV_b2_c1 = (((CJC_TM*((1.0-XP_T)*d_Vtexv_dV_b2_c1))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_b2_e1 = (((CJC_TM*((1.0-XP_T)*d_Vtexv_dV_b2_e1))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_b1_e1 = (((CJC_TM*((1.0-XP_T)*d_Vtexv_dV_b1_e1))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_c4_c1 = (((CJC_TM*(((1.0-XP_T)*d_Vtexv_dV_c4_c1)+(XP_T*d_Vb1c4_dV_c4_c1)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_c1_c2 = (((CJC_TM*(((1.0-XP_T)*d_Vtexv_dV_c1_c2)+(XP_T*d_Vb1c4_dV_c1_c2)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_b2_c2 = (((CJC_TM*(((1.0-XP_T)*d_Vtexv_dV_b2_c2)+(XP_T*d_Vb1c4_dV_b2_c2)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_b1_b2 = (((CJC_TM*(((1.0-XP_T)*d_Vtexv_dV_b1_b2)+(XP_T*d_Vb1c4_dV_b1_b2)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    d_Qtex_dV_dt_GND = ((((CJC_TM*((((1.0-XP_T)*d_Vtexv_dV_dt_GND)+((-d_XP_T_dV_dt_GND)*Vtexv))+(d_XP_T_dV_dt_GND*Vb1c4)))+(d_CJC_TM_dV_dt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    Qtex = (((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));

    d_dxa_dV_s_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c1 =  0.0;
    d_dxa_dV_dt_GND = ((a_VDC*(-d_Vfc_dV_dt_GND)-(Vbc3-Vfc)*d_a_VDC_dV_dt_GND)/a_VDC/a_VDC);
    d_dxa_dV_c3_c4 = (d_Vbc3_dV_c3_c4/a_VDC);
    d_dxa_dV_c3_c1 = (d_Vbc3_dV_c3_c1/a_VDC);
    d_dxa_dV_c4_c1 = (d_Vbc3_dV_c4_c1/a_VDC);
    d_dxa_dV_c1_c2 = (d_Vbc3_dV_c1_c2/a_VDC);
    d_dxa_dV_b2_c2 = (d_Vbc3_dV_b2_c2/a_VDC);
    d_dxa_dV_b1_b2 = (d_Vbc3_dV_b1_b2/a_VDC);
    d_dxa_dV_b_b1 = (d_Vbc3_dV_b_b1/a_VDC);
    d_dxa_dV_b_c = (d_Vbc3_dV_b_c/a_VDC);
    dxa = ((Vbc3-Vfc)/a_VDC);
    if ((Vbc3<Vfc))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_XVjcex_dV_b2_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1))))));
        d_XVjcex_dV_b2_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_e1))))));
        d_XVjcex_dV_b1_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_e1))))));
        d_XVjcex_dV_dt_GND = (-((a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_a_VDC_dV_dt_GND*value_log_1)));
        d_XVjcex_dV_c3_c4 = (d_Vbc3_dV_c3_c4-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c3_c4))))));
        d_XVjcex_dV_c3_c1 = (d_Vbc3_dV_c3_c1-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c3_c1))))));
        d_XVjcex_dV_c4_c1 = (d_Vbc3_dV_c4_c1-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c4_c1))))));
        d_XVjcex_dV_c1_c2 = (d_Vbc3_dV_c1_c2-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2))))));
        d_XVjcex_dV_b2_c2 = (d_Vbc3_dV_b2_c2-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2))))));
        d_XVjcex_dV_b1_b2 = (d_Vbc3_dV_b1_b2-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_b2))))));
        d_XVjcex_dV_b_b1 = (d_Vbc3_dV_b_b1-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b_b1))))));
        d_XVjcex_dV_b_c = (d_Vbc3_dV_b_c-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b_c))))));
        XVjcex = (Vbc3-(a_VDC*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_XVjcex_dV_c1_c2 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2)))))));
        d_XVjcex_dV_b2_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1)))))));
        d_XVjcex_dV_b2_c2 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2)))))));
        d_XVjcex_dV_b2_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_e1)))))));
        d_XVjcex_dV_b1_e1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_e1)))))));
        d_XVjcex_dV_c4_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c4_c1)))))));
        d_XVjcex_dV_b1_b2 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_b2)))))));
        d_XVjcex_dV_c3_c4 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c3_c4)))))));
        d_XVjcex_dV_c3_c1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c3_c1)))))));
        d_XVjcex_dV_b_b1 = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b_b1)))))));
        d_XVjcex_dV_b_c = (-(a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b_c)))))));
        d_XVjcex_dV_dt_GND = (d_Vfc_dV_dt_GND-((a_VDC*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_a_VDC_dV_dt_GND*value_log_1)));
        XVjcex = (Vfc-(a_VDC*value_log_1));
      }
    }

    XVjcex = XVjcex;
    {
      double value_pow_0 = pow((1.0-(XVjcex/VDC_T)),(1.0-(model_.PC)));
      double  deriv_pow_0_d0 = (((1.0-(XVjcex/VDC_T)) == 0.0)?0.0:(value_pow_0*(1.0-(model_.PC))/(1.0-(XVjcex/VDC_T))));

      d_XVtexv_dV_b2_c1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b2_c1/VDC_T))))))+(bjc*(-d_XVjcex_dV_b2_c1)));
      d_XVtexv_dV_b2_e1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b2_e1/VDC_T))))))+(bjc*(-d_XVjcex_dV_b2_e1)));
      d_XVtexv_dV_b1_e1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b1_e1/VDC_T))))))+(bjc*(-d_XVjcex_dV_b1_e1)));
      d_XVtexv_dV_c3_c4 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_c3_c4/VDC_T))))))+(bjc*(d_Vbc3_dV_c3_c4-d_XVjcex_dV_c3_c4)));
      d_XVtexv_dV_c3_c1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_c3_c1/VDC_T))))))+(bjc*(d_Vbc3_dV_c3_c1-d_XVjcex_dV_c3_c1)));
      d_XVtexv_dV_c4_c1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_c4_c1/VDC_T))))))+(bjc*(d_Vbc3_dV_c4_c1-d_XVjcex_dV_c4_c1)));
      d_XVtexv_dV_c1_c2 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_c1_c2/VDC_T))))))+(bjc*(d_Vbc3_dV_c1_c2-d_XVjcex_dV_c1_c2)));
      d_XVtexv_dV_b2_c2 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b2_c2/VDC_T))))))+(bjc*(d_Vbc3_dV_b2_c2-d_XVjcex_dV_b2_c2)));
      d_XVtexv_dV_b1_b2 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b1_b2/VDC_T))))))+(bjc*(d_Vbc3_dV_b1_b2-d_XVjcex_dV_b1_b2)));
      d_XVtexv_dV_b_b1 = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b_b1/VDC_T))))))+(bjc*(d_Vbc3_dV_b_b1-d_XVjcex_dV_b_b1)));
      d_XVtexv_dV_b_c = (((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-(d_XVjcex_dV_b_c/VDC_T))))))+(bjc*(d_Vbc3_dV_b_c-d_XVjcex_dV_b_c)));
      d_XVtexv_dV_dt_GND = ((((VDC_T/(1.0-(model_.PC)))*(-(deriv_pow_0_d0*((-((VDC_T*d_XVjcex_dV_dt_GND-XVjcex*d_VDC_T_dV_dt_GND)/VDC_T/VDC_T))))))+((d_VDC_T_dV_dt_GND/(1.0-(model_.PC)))*(1.0-value_pow_0)))+((bjc*(-d_XVjcex_dV_dt_GND))+(d_bjc_dV_dt_GND*(Vbc3-XVjcex))));
      XVtexv = (((VDC_T/(1.0-(model_.PC)))*(1.0-value_pow_0))+(bjc*(Vbc3-XVjcex)));
    }

    d_XQtex_dV_b2_c1 = (((CJC_TM*((1.0-XP_T)*d_XVtexv_dV_b2_c1))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_b2_e1 = (((CJC_TM*((1.0-XP_T)*d_XVtexv_dV_b2_e1))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_b1_e1 = (((CJC_TM*((1.0-XP_T)*d_XVtexv_dV_b1_e1))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_c3_c4 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_c3_c4)+(XP_T*d_Vbc3_dV_c3_c4)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_c3_c1 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_c3_c1)+(XP_T*d_Vbc3_dV_c3_c1)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_c4_c1 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_c4_c1)+(XP_T*d_Vbc3_dV_c4_c1)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_c1_c2 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_c1_c2)+(XP_T*d_Vbc3_dV_c1_c2)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_b2_c2 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_b2_c2)+(XP_T*d_Vbc3_dV_b2_c2)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_b1_b2 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_b1_b2)+(XP_T*d_Vbc3_dV_b1_b2)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_b_b1 = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_b_b1)+(XP_T*d_Vbc3_dV_b_b1)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_b_c = (((CJC_TM*(((1.0-XP_T)*d_XVtexv_dV_b_c)+(XP_T*d_Vbc3_dV_b_c)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    d_XQtex_dV_dt_GND = ((((CJC_TM*((((1.0-XP_T)*d_XVtexv_dV_dt_GND)+((-d_XP_T_dV_dt_GND)*XVtexv))+(d_XP_T_dV_dt_GND*Vbc3)))+(d_CJC_TM_dV_dt_GND*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))))*(1.0-(model_.XCJC)))*(model_.XEXT));
    XQtex = (((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-(model_.XCJC)))*(model_.XEXT));

    d_a_VDS_dV_dt_GND = (0.1*d_VDS_T_dV_dt_GND);
    a_VDS = (0.1*VDS_T);
    {
      double value_pow_0 = pow(2.0,((-1.0)/(model_.PS)));

      d_Vfs_dV_dt_GND = (d_VDS_T_dV_dt_GND*(1.0-value_pow_0));
      Vfs = (VDS_T*(1.0-value_pow_0));
    }

    d_dxa_dV_b_c = d_dxa_dV_b_b1 = d_dxa_dV_c3_c1 = d_dxa_dV_c3_c4 = d_dxa_dV_b1_b2 = d_dxa_dV_c4_c1 = d_dxa_dV_b1_e1 = d_dxa_dV_b2_e1 = d_dxa_dV_b2_c2 = d_dxa_dV_b2_c1 = d_dxa_dV_c1_c2 =  0.0;
    d_dxa_dV_dt_GND = ((a_VDS*(-d_Vfs_dV_dt_GND)-(Vsc1-Vfs)*d_a_VDS_dV_dt_GND)/a_VDS/a_VDS);
    d_dxa_dV_s_c1 = (d_Vsc1_dV_s_c1/a_VDS);
    dxa = ((Vsc1-Vfs)/a_VDS);
    if ((Vsc1<Vfs))
    {
      {
        double value_exp_0 = exp(dxa);
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vjs_dV_c1_c2 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c1_c2))))));
        d_Vjs_dV_b2_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c1))))));
        d_Vjs_dV_b2_c2 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_c2))))));
        d_Vjs_dV_b2_e1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b2_e1))))));
        d_Vjs_dV_b1_e1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_e1))))));
        d_Vjs_dV_c4_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c4_c1))))));
        d_Vjs_dV_b1_b2 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b1_b2))))));
        d_Vjs_dV_c3_c4 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c3_c4))))));
        d_Vjs_dV_c3_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_c3_c1))))));
        d_Vjs_dV_b_b1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b_b1))))));
        d_Vjs_dV_b_c = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_b_c))))));
        d_Vjs_dV_dt_GND = (-((a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_dt_GND)))))+(d_a_VDS_dV_dt_GND*value_log_1)));
        d_Vjs_dV_s_c1 = (d_Vsc1_dV_s_c1-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*(d_dxa_dV_s_c1))))));
        Vjs = (Vsc1-(a_VDS*value_log_1));
      }
    }
    else
    {
      {
        double value_exp_0 = exp((-dxa));
        double value_log_1 = log((1.0+value_exp_0));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

        d_Vjs_dV_c1_c2 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c1_c2)))))));
        d_Vjs_dV_b2_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c1)))))));
        d_Vjs_dV_b2_c2 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_c2)))))));
        d_Vjs_dV_b2_e1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b2_e1)))))));
        d_Vjs_dV_b1_e1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_e1)))))));
        d_Vjs_dV_c4_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c4_c1)))))));
        d_Vjs_dV_b1_b2 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b1_b2)))))));
        d_Vjs_dV_c3_c4 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c3_c4)))))));
        d_Vjs_dV_c3_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_c3_c1)))))));
        d_Vjs_dV_b_b1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b_b1)))))));
        d_Vjs_dV_b_c = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_b_c)))))));
        d_Vjs_dV_s_c1 = (-(a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_s_c1)))))));
        d_Vjs_dV_dt_GND = (d_Vfs_dV_dt_GND-((a_VDS*(deriv_log_1_d0*((deriv_exp_0_d0*((-d_dxa_dV_dt_GND))))))+(d_a_VDS_dV_dt_GND*value_log_1)));
        Vjs = (Vfs-(a_VDS*value_log_1));
      }
    }

    Vjs = Vjs;
    {
      double value_pow_0 = pow((1.0-(Vjs/VDS_T)),(1.0-(model_.PS)));
      double  deriv_pow_0_d0 = (((1.0-(Vjs/VDS_T)) == 0.0)?0.0:(value_pow_0*(1.0-(model_.PS))/(1.0-(Vjs/VDS_T))));

      d_Qts_dV_c1_c2 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_c1_c2/VDS_T))))))+(2.0*(-d_Vjs_dV_c1_c2))));
      d_Qts_dV_b2_c1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b2_c1/VDS_T))))))+(2.0*(-d_Vjs_dV_b2_c1))));
      d_Qts_dV_b2_c2 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b2_c2/VDS_T))))))+(2.0*(-d_Vjs_dV_b2_c2))));
      d_Qts_dV_b2_e1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b2_e1/VDS_T))))))+(2.0*(-d_Vjs_dV_b2_e1))));
      d_Qts_dV_b1_e1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b1_e1/VDS_T))))))+(2.0*(-d_Vjs_dV_b1_e1))));
      d_Qts_dV_c4_c1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_c4_c1/VDS_T))))))+(2.0*(-d_Vjs_dV_c4_c1))));
      d_Qts_dV_b1_b2 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b1_b2/VDS_T))))))+(2.0*(-d_Vjs_dV_b1_b2))));
      d_Qts_dV_c3_c4 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_c3_c4/VDS_T))))))+(2.0*(-d_Vjs_dV_c3_c4))));
      d_Qts_dV_c3_c1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_c3_c1/VDS_T))))))+(2.0*(-d_Vjs_dV_c3_c1))));
      d_Qts_dV_b_b1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b_b1/VDS_T))))))+(2.0*(-d_Vjs_dV_b_b1))));
      d_Qts_dV_b_c = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_b_c/VDS_T))))))+(2.0*(-d_Vjs_dV_b_c))));
      d_Qts_dV_s_c1 = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-(d_Vjs_dV_s_c1/VDS_T))))))+(2.0*(d_Vsc1_dV_s_c1-d_Vjs_dV_s_c1))));
      d_Qts_dV_dt_GND = ((CJS_TM*((((VDS_T/(1.0-(model_.PS)))*(-(deriv_pow_0_d0*((-((VDS_T*d_Vjs_dV_dt_GND-Vjs*d_VDS_T_dV_dt_GND)/VDS_T/VDS_T))))))+((d_VDS_T_dV_dt_GND/(1.0-(model_.PS)))*(1.0-value_pow_0)))+(2.0*(-d_Vjs_dV_dt_GND))))+(d_CJS_TM_dV_dt_GND*(((VDS_T/(1.0-(model_.PS)))*(1.0-value_pow_0))+(2.0*(Vsc1-Vjs)))));
      Qts = (CJS_TM*(((VDS_T/(1.0-(model_.PS)))*(1.0-value_pow_0))+(2.0*(Vsc1-Vjs))));
    }
    {
      double value_pow_0 = pow((IS_TM/IK_TM),(1.0/(model_.MTAU)));
      double  deriv_pow_0_d0 = (((IS_TM/IK_TM) == 0.0)?0.0:(value_pow_0*(1.0/(model_.MTAU))/(IS_TM/IK_TM)));

      d_Qe0_dV_dt_GND = (((TAUE_T*IK_TM)*(deriv_pow_0_d0*(((IK_TM*d_IS_TM_dV_dt_GND-IS_TM*d_IK_TM_dV_dt_GND)/IK_TM/IK_TM))))+(((TAUE_T*d_IK_TM_dV_dt_GND)+(d_TAUE_T_dV_dt_GND*IK_TM))*value_pow_0));
      Qe0 = ((TAUE_T*IK_TM)*value_pow_0);
    }
    if (((Vb2e1/((model_.MTAU)*Vt))<400.0))
    {
      {
        double value_exp_0 = exp((Vb2e1/((model_.MTAU)*Vt)));
        double  deriv_exp_0_d0 = value_exp_0;

        d_tmpExp_dV_b1_b2 = d_tmpExp_dV_b2_c2 = d_tmpExp_dV_c1_c2 = d_tmpExp_dV_c4_c1 =  0.0;
        d_tmpExp_dV_dt_GND = (deriv_exp_0_d0*((-Vb2e1*((model_.MTAU)*d_Vt_dV_dt_GND)/((model_.MTAU)*Vt)/((model_.MTAU)*Vt))));
        d_tmpExp_dV_b2_e1 = (deriv_exp_0_d0*((d_Vb2e1_dV_b2_e1/((model_.MTAU)*Vt))));
        tmpExp = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }

      d_tmpExp_dV_b1_b2 = d_tmpExp_dV_b2_c2 = d_tmpExp_dV_c1_c2 = d_tmpExp_dV_c4_c1 =  0.0;
      d_tmpExp_dV_dt_GND = (expl*(-Vb2e1*((model_.MTAU)*d_Vt_dV_dt_GND)/((model_.MTAU)*Vt)/((model_.MTAU)*Vt)));
      d_tmpExp_dV_b2_e1 = (expl*(d_Vb2e1_dV_b2_e1/((model_.MTAU)*Vt)));
      tmpExp = (expl*(1.0+((Vb2e1/((model_.MTAU)*Vt))-400.0)));
    }

    d_Qe_qs_dV_b2_e1 = (Qe0*d_tmpExp_dV_b2_e1);
    d_Qe_qs_dV_c4_c1 = (Qe0*d_tmpExp_dV_c4_c1);
    d_Qe_qs_dV_c1_c2 = (Qe0*d_tmpExp_dV_c1_c2);
    d_Qe_qs_dV_b2_c2 = (Qe0*d_tmpExp_dV_b2_c2);
    d_Qe_qs_dV_b1_b2 = (Qe0*d_tmpExp_dV_b1_b2);
    d_Qe_qs_dV_dt_GND = ((Qe0*d_tmpExp_dV_dt_GND)+(d_Qe0_dV_dt_GND*tmpExp));
    Qe_qs = (Qe0*tmpExp);

    d_Qepi0_dV_dt_GND = ((RCV_TM*(((4.0*TEPI_T)*d_Vt_dV_dt_GND)+((4.0*d_TEPI_T_dV_dt_GND)*Vt))-((4.0*TEPI_T)*Vt)*d_RCV_TM_dV_dt_GND)/RCV_TM/RCV_TM);
    Qepi0 = (((4.0*TEPI_T)*Vt)/RCV_TM);

    d_Qepi_dV_c1_c2 = ((((0.5*Qepi0)*xi_w)*d_p0star_dV_c1_c2)+(((0.5*Qepi0)*d_xi_w_dV_c1_c2)*((p0star+pW)+2.0)));
    d_Qepi_dV_b2_c1 = ((((0.5*Qepi0)*xi_w)*(d_p0star_dV_b2_c1+d_pW_dV_b2_c1))+(((0.5*Qepi0)*d_xi_w_dV_b2_c1)*((p0star+pW)+2.0)));
    d_Qepi_dV_b2_c2 = ((((0.5*Qepi0)*xi_w)*d_p0star_dV_b2_c2)+(((0.5*Qepi0)*d_xi_w_dV_b2_c2)*((p0star+pW)+2.0)));
    d_Qepi_dV_dt_GND = ((((0.5*Qepi0)*xi_w)*(d_p0star_dV_dt_GND+d_pW_dV_dt_GND))+((((0.5*Qepi0)*d_xi_w_dV_dt_GND)+((0.5*d_Qepi0_dV_dt_GND)*xi_w))*((p0star+pW)+2.0)));
    Qepi = (((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));

    d_Qex_dV_c4_c1 = (((TAUR_T*0.5)*((Qb0*d_nBex_dV_c4_c1)+(Qepi0*d_pWex_dV_c4_c1)))/(TAUB_T+TEPI_T));
    d_Qex_dV_c1_c2 = (((TAUR_T*0.5)*((Qb0*d_nBex_dV_c1_c2)+(Qepi0*d_pWex_dV_c1_c2)))/(TAUB_T+TEPI_T));
    d_Qex_dV_b2_c2 = (((TAUR_T*0.5)*((Qb0*d_nBex_dV_b2_c2)+(Qepi0*d_pWex_dV_b2_c2)))/(TAUB_T+TEPI_T));
    d_Qex_dV_b1_b2 = (((TAUR_T*0.5)*((Qb0*d_nBex_dV_b1_b2)+(Qepi0*d_pWex_dV_b1_b2)))/(TAUB_T+TEPI_T));
    d_Qex_dV_dt_GND = (((TAUB_T+TEPI_T)*(((TAUR_T*0.5)*(((Qb0*d_nBex_dV_dt_GND)+(d_Qb0_dV_dt_GND*nBex))+((Qepi0*d_pWex_dV_dt_GND)+(d_Qepi0_dV_dt_GND*pWex))))+((d_TAUR_T_dV_dt_GND*0.5)*((Qb0*nBex)+(Qepi0*pWex))))-((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(d_TAUB_T_dV_dt_GND+d_TEPI_T_dV_dt_GND))/(TAUB_T+TEPI_T)/(TAUB_T+TEPI_T));
    Qex = (((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(TAUB_T+TEPI_T));

    d_XQex_dV_dt_GND = d_XQex_dV_b_c = d_XQex_dV_b_b1 = d_XQex_dV_b1_b2 = d_XQex_dV_c4_c1 = d_XQex_dV_c3_c1 = d_XQex_dV_c3_c4 = d_XQex_dV_b2_e1 = d_XQex_dV_b2_c2 = d_XQex_dV_b2_c1 = d_XQex_dV_c1_c2 = d_XQex_dV_s_c1 =  0.0;
    XQex = 0.0;
    if (((model_.EXMOD)==1))
    {

      d_Qex_dV_c4_c1 = (d_Qex_dV_c4_c1*(1.0-(model_.XEXT)));
      d_Qex_dV_c1_c2 = (d_Qex_dV_c1_c2*(1.0-(model_.XEXT)));
      d_Qex_dV_b2_c2 = (d_Qex_dV_b2_c2*(1.0-(model_.XEXT)));
      d_Qex_dV_b1_b2 = (d_Qex_dV_b1_b2*(1.0-(model_.XEXT)));
      d_Qex_dV_dt_GND = (d_Qex_dV_dt_GND*(1.0-(model_.XEXT)));
      Qex = (Qex*(1.0-(model_.XEXT)));

      d_Xg2_dV_dt_GND = (4.0*d_eVbc3VDC_dV_dt_GND);
      d_Xg2_dV_c3_c4 = (4.0*d_eVbc3VDC_dV_c3_c4);
      d_Xg2_dV_c3_c1 = (4.0*d_eVbc3VDC_dV_c3_c1);
      d_Xg2_dV_c4_c1 = (4.0*d_eVbc3VDC_dV_c4_c1);
      d_Xg2_dV_c1_c2 = (4.0*d_eVbc3VDC_dV_c1_c2);
      d_Xg2_dV_b2_c2 = (4.0*d_eVbc3VDC_dV_b2_c2);
      d_Xg2_dV_b1_b2 = (4.0*d_eVbc3VDC_dV_b1_b2);
      d_Xg2_dV_b_b1 = (4.0*d_eVbc3VDC_dV_b_b1);
      d_Xg2_dV_b_c = (4.0*d_eVbc3VDC_dV_b_c);
      Xg2 = (4.0*eVbc3VDC);
      {
        double value_sqrt_0 = sqrt((1.0+Xg2));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_XpWex_dV_dt_GND = (((1.0+value_sqrt_0)*d_Xg2_dV_dt_GND-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_dt_GND)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_c3_c4 = (((1.0+value_sqrt_0)*d_Xg2_dV_c3_c4-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_c3_c4)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_c3_c1 = (((1.0+value_sqrt_0)*d_Xg2_dV_c3_c1-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_c3_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_c4_c1 = (((1.0+value_sqrt_0)*d_Xg2_dV_c4_c1-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_c4_c1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_c1_c2 = (((1.0+value_sqrt_0)*d_Xg2_dV_c1_c2-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_c1_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_b2_c2 = (((1.0+value_sqrt_0)*d_Xg2_dV_b2_c2-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_b2_c2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_b1_b2 = (((1.0+value_sqrt_0)*d_Xg2_dV_b1_b2-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_b1_b2)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_b_b1 = (((1.0+value_sqrt_0)*d_Xg2_dV_b_b1-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_b_b1)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        d_XpWex_dV_b_c = (((1.0+value_sqrt_0)*d_Xg2_dV_b_c-Xg2*(deriv_sqrt_0_d0*(d_Xg2_dV_b_c)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
        XpWex = (Xg2/(1.0+value_sqrt_0));
      }

      d_XQex_dV_s_c1 = (((((0.5*d_Fex_dV_s_c1)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
      d_XQex_dV_c1_c2 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_c1_c2)+(Qepi0*d_XpWex_dV_c1_c2)))+((((0.5*d_Fex_dV_c1_c2)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_b2_c1 = (((((0.5*d_Fex_dV_b2_c1)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
      d_XQex_dV_b2_c2 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_b2_c2)+(Qepi0*d_XpWex_dV_b2_c2)))+((((0.5*d_Fex_dV_b2_c2)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_b2_e1 = (((((0.5*d_Fex_dV_b2_e1)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
      d_XQex_dV_c3_c4 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_c3_c4)+(Qepi0*d_XpWex_dV_c3_c4)))+((((0.5*d_Fex_dV_c3_c4)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_c3_c1 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_c3_c1)+(Qepi0*d_XpWex_dV_c3_c1)))+((((0.5*d_Fex_dV_c3_c1)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_c4_c1 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_c4_c1)+(Qepi0*d_XpWex_dV_c4_c1)))+((((0.5*d_Fex_dV_c4_c1)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_b1_b2 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_b1_b2)+(Qepi0*d_XpWex_dV_b1_b2)))+((((0.5*d_Fex_dV_b1_b2)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_b_b1 = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_b_b1)+(Qepi0*d_XpWex_dV_b_b1)))+((((0.5*d_Fex_dV_b_b1)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_b_c = ((((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*d_XnBex_dV_b_c)+(Qepi0*d_XpWex_dV_b_c)))+((((0.5*d_Fex_dV_b_c)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex))))/(TAUB_T+TEPI_T));
      d_XQex_dV_dt_GND = (((TAUB_T+TEPI_T)*(((((0.5*Fex)*(model_.XEXT))*TAUR_T)*(((Qb0*d_XnBex_dV_dt_GND)+(d_Qb0_dV_dt_GND*XnBex))+((Qepi0*d_XpWex_dV_dt_GND)+(d_Qepi0_dV_dt_GND*XpWex))))+(((((0.5*Fex)*(model_.XEXT))*d_TAUR_T_dV_dt_GND)+(((0.5*d_Fex_dV_dt_GND)*(model_.XEXT))*TAUR_T))*((Qb0*XnBex)+(Qepi0*XpWex))))-((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(d_TAUB_T_dV_dt_GND+d_TEPI_T_dV_dt_GND))/(TAUB_T+TEPI_T)/(TAUB_T+TEPI_T));
      XQex = (((((0.5*Fex)*(model_.XEXT))*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
    }

    d_Qb1b2_dV_b1_b2 = d_Qb1b2_dV_dt_GND = d_Qb1b2_dV_b2_e1 = d_Qb1b2_dV_b2_c2 = d_Qb1b2_dV_b2_c1 = d_Qb1b2_dV_c1_c2 = d_Qb1b2_dV_b_c = d_Qb1b2_dV_b_b1 = d_Qb1b2_dV_c4_c1 = d_Qb1b2_dV_c3_c1 = d_Qb1b2_dV_c3_c4 =  0.0;
    Qb1b2 = 0.0;
    if (((model_.EXPHI)==1))
    {
      {
        double value_pow_0 = pow((1.0-(Vje*inv_VDE_T)),(-(model_.PE)));
        double  deriv_pow_0_d0 = (((1.0-(Vje*inv_VDE_T)) == 0.0)?0.0:(value_pow_0*(-(model_.PE))/(1.0-(Vje*inv_VDE_T))));

        d_dVteVje_dV_c1_c2 = (deriv_pow_0_d0*((-(d_Vje_dV_c1_c2*inv_VDE_T))));
        d_dVteVje_dV_b2_c1 = (deriv_pow_0_d0*((-(d_Vje_dV_b2_c1*inv_VDE_T))));
        d_dVteVje_dV_b2_c2 = (deriv_pow_0_d0*((-(d_Vje_dV_b2_c2*inv_VDE_T))));
        d_dVteVje_dV_dt_GND = (deriv_pow_0_d0*((-((Vje*d_inv_VDE_T_dV_dt_GND)+(d_Vje_dV_dt_GND*inv_VDE_T)))));
        d_dVteVje_dV_b2_e1 = (deriv_pow_0_d0*((-(d_Vje_dV_b2_e1*inv_VDE_T))));
        dVteVje = (value_pow_0-3.0);
      }

      d_Vb2e1Vfe_dV_dt_GND = ((a_VDE*(-d_Vfe_dV_dt_GND)-(Vb2e1-Vfe)*d_a_VDE_dV_dt_GND)/a_VDE/a_VDE);
      d_Vb2e1Vfe_dV_b2_e1 = (d_Vb2e1_dV_b2_e1/a_VDE);
      Vb2e1Vfe = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1Vfe<0.0))
      {
        {
          double value_exp_0 = exp(Vb2e1Vfe);
          double  deriv_exp_0_d0 = value_exp_0;

          d_dVjeVb2e1_dV_dt_GND = (-(deriv_exp_0_d0*(d_Vb2e1Vfe_dV_dt_GND))/(1.0+value_exp_0)/(1.0+value_exp_0));
          d_dVjeVb2e1_dV_b2_e1 = (-(deriv_exp_0_d0*(d_Vb2e1Vfe_dV_b2_e1))/(1.0+value_exp_0)/(1.0+value_exp_0));
          dVjeVb2e1 = (1.0/(1.0+value_exp_0));
        }
      }
      else
      {
        {
          double value_exp_0 = exp((-Vb2e1Vfe));
          double value_exp_1 = exp((-Vb2e1Vfe));
          double  deriv_exp_0_d0 = value_exp_0;
          double  deriv_exp_1_d0 = value_exp_1;

          d_dVjeVb2e1_dV_dt_GND = (((1.0+value_exp_1)*(deriv_exp_0_d0*((-d_Vb2e1Vfe_dV_dt_GND)))-value_exp_0*(deriv_exp_1_d0*((-d_Vb2e1Vfe_dV_dt_GND))))/(1.0+value_exp_1)/(1.0+value_exp_1));
          d_dVjeVb2e1_dV_b2_e1 = (((1.0+value_exp_1)*(deriv_exp_0_d0*((-d_Vb2e1Vfe_dV_b2_e1)))-value_exp_0*(deriv_exp_1_d0*((-d_Vb2e1Vfe_dV_b2_e1))))/(1.0+value_exp_1)/(1.0+value_exp_1));
          dVjeVb2e1 = (value_exp_0/(1.0+value_exp_1));
        }
      }

      d_dVteVb2e1_dV_c1_c2 = (d_dVteVje_dV_c1_c2*dVjeVb2e1);
      d_dVteVb2e1_dV_b2_c1 = (d_dVteVje_dV_b2_c1*dVjeVb2e1);
      d_dVteVb2e1_dV_b2_c2 = (d_dVteVje_dV_b2_c2*dVjeVb2e1);
      d_dVteVb2e1_dV_dt_GND = ((dVteVje*d_dVjeVb2e1_dV_dt_GND)+(d_dVteVje_dV_dt_GND*dVjeVb2e1));
      d_dVteVb2e1_dV_b2_e1 = ((dVteVje*d_dVjeVb2e1_dV_b2_e1)+(d_dVteVje_dV_b2_e1*dVjeVb2e1));
      dVteVb2e1 = ((dVteVje*dVjeVb2e1)+3.0);

      d_dQteVb2e1_dV_c1_c2 = (((1.0-(model_.XCJE))*CJE_TM)*d_dVteVb2e1_dV_c1_c2);
      d_dQteVb2e1_dV_b2_c1 = (((1.0-(model_.XCJE))*CJE_TM)*d_dVteVb2e1_dV_b2_c1);
      d_dQteVb2e1_dV_b2_c2 = (((1.0-(model_.XCJE))*CJE_TM)*d_dVteVb2e1_dV_b2_c2);
      d_dQteVb2e1_dV_b2_e1 = (((1.0-(model_.XCJE))*CJE_TM)*d_dVteVb2e1_dV_b2_e1);
      d_dQteVb2e1_dV_dt_GND = ((((1.0-(model_.XCJE))*CJE_TM)*d_dVteVb2e1_dV_dt_GND)+(((1.0-(model_.XCJE))*d_CJE_TM_dV_dt_GND)*dVteVb2e1));
      dQteVb2e1 = (((1.0-(model_.XCJE))*CJE_TM)*dVteVb2e1);
      {
        double value_sqrt_0 = sqrt((1.0+f1));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_dn0Vb2e1_dV_b2_e1 = ((((If0*eVb2e1)*VtINV)*(-0.5*(deriv_sqrt_0_d0*(d_f1_dV_b2_e1))/value_sqrt_0/value_sqrt_0))+(((If0*d_eVb2e1_dV_b2_e1)*VtINV)*(0.5/value_sqrt_0)));
        d_dn0Vb2e1_dV_dt_GND = ((((If0*eVb2e1)*VtINV)*(-0.5*(deriv_sqrt_0_d0*(d_f1_dV_dt_GND))/value_sqrt_0/value_sqrt_0))+((((If0*eVb2e1)*d_VtINV_dV_dt_GND)+(((If0*d_eVb2e1_dV_dt_GND)+(d_If0_dV_dt_GND*eVb2e1))*VtINV))*(0.5/value_sqrt_0)));
        dn0Vb2e1 = (((If0*eVb2e1)*VtINV)*(0.5/value_sqrt_0));
      }

      d_dQbeVb2e1_dV_c1_c2 = (((0.5*Qb0)*d_q1Q_dV_c1_c2)*dn0Vb2e1);
      d_dQbeVb2e1_dV_b2_c1 = (((0.5*Qb0)*d_q1Q_dV_b2_c1)*dn0Vb2e1);
      d_dQbeVb2e1_dV_b2_c2 = (((0.5*Qb0)*d_q1Q_dV_b2_c2)*dn0Vb2e1);
      d_dQbeVb2e1_dV_b2_e1 = ((((0.5*Qb0)*q1Q)*d_dn0Vb2e1_dV_b2_e1)+(((0.5*Qb0)*d_q1Q_dV_b2_e1)*dn0Vb2e1));
      d_dQbeVb2e1_dV_c3_c4 = (((0.5*Qb0)*d_q1Q_dV_c3_c4)*dn0Vb2e1);
      d_dQbeVb2e1_dV_c3_c1 = (((0.5*Qb0)*d_q1Q_dV_c3_c1)*dn0Vb2e1);
      d_dQbeVb2e1_dV_c4_c1 = (((0.5*Qb0)*d_q1Q_dV_c4_c1)*dn0Vb2e1);
      d_dQbeVb2e1_dV_b1_b2 = (((0.5*Qb0)*d_q1Q_dV_b1_b2)*dn0Vb2e1);
      d_dQbeVb2e1_dV_b_b1 = (((0.5*Qb0)*d_q1Q_dV_b_b1)*dn0Vb2e1);
      d_dQbeVb2e1_dV_b_c = (((0.5*Qb0)*d_q1Q_dV_b_c)*dn0Vb2e1);
      d_dQbeVb2e1_dV_dt_GND = ((((0.5*Qb0)*q1Q)*d_dn0Vb2e1_dV_dt_GND)+((((0.5*Qb0)*d_q1Q_dV_dt_GND)+((0.5*d_Qb0_dV_dt_GND)*q1Q))*dn0Vb2e1));
      dQbeVb2e1 = (((0.5*Qb0)*q1Q)*dn0Vb2e1);

      d_dQeVb2e1_dV_b2_e1 = (d_Qe_qs_dV_b2_e1/((model_.MTAU)*Vt));
      d_dQeVb2e1_dV_c4_c1 = (d_Qe_qs_dV_c4_c1/((model_.MTAU)*Vt));
      d_dQeVb2e1_dV_c1_c2 = (d_Qe_qs_dV_c1_c2/((model_.MTAU)*Vt));
      d_dQeVb2e1_dV_b2_c2 = (d_Qe_qs_dV_b2_c2/((model_.MTAU)*Vt));
      d_dQeVb2e1_dV_b1_b2 = (d_Qe_qs_dV_b1_b2/((model_.MTAU)*Vt));
      d_dQeVb2e1_dV_dt_GND = ((((model_.MTAU)*Vt)*d_Qe_qs_dV_dt_GND-Qe_qs*((model_.MTAU)*d_Vt_dV_dt_GND))/((model_.MTAU)*Vt)/((model_.MTAU)*Vt));
      dQeVb2e1 = (Qe_qs/((model_.MTAU)*Vt));

      d_Qb1b2_dV_c3_c4 = ((0.2*Vb1b2)*d_dQbeVb2e1_dV_c3_c4);
      d_Qb1b2_dV_c3_c1 = ((0.2*Vb1b2)*d_dQbeVb2e1_dV_c3_c1);
      d_Qb1b2_dV_c4_c1 = ((0.2*Vb1b2)*(d_dQbeVb2e1_dV_c4_c1+d_dQeVb2e1_dV_c4_c1));
      d_Qb1b2_dV_b_b1 = ((0.2*Vb1b2)*d_dQbeVb2e1_dV_b_b1);
      d_Qb1b2_dV_b_c = ((0.2*Vb1b2)*d_dQbeVb2e1_dV_b_c);
      d_Qb1b2_dV_c1_c2 = ((0.2*Vb1b2)*((d_dQteVb2e1_dV_c1_c2+d_dQbeVb2e1_dV_c1_c2)+d_dQeVb2e1_dV_c1_c2));
      d_Qb1b2_dV_b2_c1 = ((0.2*Vb1b2)*(d_dQteVb2e1_dV_b2_c1+d_dQbeVb2e1_dV_b2_c1));
      d_Qb1b2_dV_b2_c2 = ((0.2*Vb1b2)*((d_dQteVb2e1_dV_b2_c2+d_dQbeVb2e1_dV_b2_c2)+d_dQeVb2e1_dV_b2_c2));
      d_Qb1b2_dV_b2_e1 = ((0.2*Vb1b2)*((d_dQteVb2e1_dV_b2_e1+d_dQbeVb2e1_dV_b2_e1)+d_dQeVb2e1_dV_b2_e1));
      d_Qb1b2_dV_dt_GND = ((0.2*Vb1b2)*((d_dQteVb2e1_dV_dt_GND+d_dQbeVb2e1_dV_dt_GND)+d_dQeVb2e1_dV_dt_GND));
      d_Qb1b2_dV_b1_b2 = (((0.2*Vb1b2)*(d_dQbeVb2e1_dV_b1_b2+d_dQeVb2e1_dV_b1_b2))+((0.2*d_Vb1b2_dV_b1_b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)));
      Qb1b2 = ((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));

      d_Qe_dV_b2_e1 = ((1-(model_.KE))*d_Qe_qs_dV_b2_e1);
      d_Qe_dV_c4_c1 = ((1-(model_.KE))*d_Qe_qs_dV_c4_c1);
      d_Qe_dV_c1_c2 = ((1-(model_.KE))*d_Qe_qs_dV_c1_c2);
      d_Qe_dV_b2_c2 = ((1-(model_.KE))*d_Qe_qs_dV_b2_c2);
      d_Qe_dV_b1_b2 = ((1-(model_.KE))*d_Qe_qs_dV_b1_b2);
      d_Qe_dV_dt_GND = ((1-(model_.KE))*d_Qe_qs_dV_dt_GND);
      Qe = ((1-(model_.KE))*Qe_qs);

      d_Qbe_qs_eff_dV_c1_c2 = (d_Qbe_qs_dV_c1_c2+((model_.KE)*d_Qe_qs_dV_c1_c2));
      d_Qbe_qs_eff_dV_b2_c1 = d_Qbe_qs_dV_b2_c1;
      d_Qbe_qs_eff_dV_b2_c2 = (d_Qbe_qs_dV_b2_c2+((model_.KE)*d_Qe_qs_dV_b2_c2));
      d_Qbe_qs_eff_dV_c3_c4 = d_Qbe_qs_dV_c3_c4;
      d_Qbe_qs_eff_dV_c3_c1 = d_Qbe_qs_dV_c3_c1;
      d_Qbe_qs_eff_dV_c4_c1 = (d_Qbe_qs_dV_c4_c1+((model_.KE)*d_Qe_qs_dV_c4_c1));
      d_Qbe_qs_eff_dV_b1_b2 = (d_Qbe_qs_dV_b1_b2+((model_.KE)*d_Qe_qs_dV_b1_b2));
      d_Qbe_qs_eff_dV_b_b1 = d_Qbe_qs_dV_b_b1;
      d_Qbe_qs_eff_dV_b_c = d_Qbe_qs_dV_b_c;
      d_Qbe_qs_eff_dV_b2_e1 = (d_Qbe_qs_dV_b2_e1+((model_.KE)*d_Qe_qs_dV_b2_e1));
      d_Qbe_qs_eff_dV_dt_GND = (d_Qbe_qs_dV_dt_GND+((model_.KE)*d_Qe_qs_dV_dt_GND));
      Qbe_qs_eff = (Qbe_qs+((model_.KE)*Qe_qs));

      d_Qbc_dV_c1_c2 = (((model_.XQB)*d_Qbe_qs_eff_dV_c1_c2)+d_Qbc_qs_dV_c1_c2);
      d_Qbc_dV_b2_c1 = (((model_.XQB)*d_Qbe_qs_eff_dV_b2_c1)+d_Qbc_qs_dV_b2_c1);
      d_Qbc_dV_b2_c2 = (((model_.XQB)*d_Qbe_qs_eff_dV_b2_c2)+d_Qbc_qs_dV_b2_c2);
      d_Qbc_dV_c3_c4 = (((model_.XQB)*d_Qbe_qs_eff_dV_c3_c4)+d_Qbc_qs_dV_c3_c4);
      d_Qbc_dV_c3_c1 = (((model_.XQB)*d_Qbe_qs_eff_dV_c3_c1)+d_Qbc_qs_dV_c3_c1);
      d_Qbc_dV_c4_c1 = (((model_.XQB)*d_Qbe_qs_eff_dV_c4_c1)+d_Qbc_qs_dV_c4_c1);
      d_Qbc_dV_b1_b2 = (((model_.XQB)*d_Qbe_qs_eff_dV_b1_b2)+d_Qbc_qs_dV_b1_b2);
      d_Qbc_dV_b_b1 = (((model_.XQB)*d_Qbe_qs_eff_dV_b_b1)+d_Qbc_qs_dV_b_b1);
      d_Qbc_dV_b_c = (((model_.XQB)*d_Qbe_qs_eff_dV_b_c)+d_Qbc_qs_dV_b_c);
      d_Qbc_dV_b2_e1 = (((model_.XQB)*d_Qbe_qs_eff_dV_b2_e1)+d_Qbc_qs_dV_b2_e1);
      d_Qbc_dV_dt_GND = (((model_.XQB)*d_Qbe_qs_eff_dV_dt_GND)+d_Qbc_qs_dV_dt_GND);
      Qbc = (((model_.XQB)*Qbe_qs_eff)+Qbc_qs);

      d_Qbe_dV_c1_c2 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_c1_c2);
      d_Qbe_dV_b2_c1 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_b2_c1);
      d_Qbe_dV_b2_c2 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_b2_c2);
      d_Qbe_dV_c3_c4 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_c3_c4);
      d_Qbe_dV_c3_c1 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_c3_c1);
      d_Qbe_dV_c4_c1 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_c4_c1);
      d_Qbe_dV_b1_b2 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_b1_b2);
      d_Qbe_dV_b_b1 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_b_b1);
      d_Qbe_dV_b_c = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_b_c);
      d_Qbe_dV_b2_e1 = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_b2_e1);
      d_Qbe_dV_dt_GND = ((1-(model_.XQB))*d_Qbe_qs_eff_dV_dt_GND);
      Qbe = ((1-(model_.XQB))*Qbe_qs_eff);
    }
    else
    {

      d_Qbe_dV_c1_c2 = d_Qbe_qs_dV_c1_c2;
      d_Qbe_dV_b2_c1 = d_Qbe_qs_dV_b2_c1;
      d_Qbe_dV_b2_c2 = d_Qbe_qs_dV_b2_c2;
      d_Qbe_dV_c3_c4 = d_Qbe_qs_dV_c3_c4;
      d_Qbe_dV_c3_c1 = d_Qbe_qs_dV_c3_c1;
      d_Qbe_dV_c4_c1 = d_Qbe_qs_dV_c4_c1;
      d_Qbe_dV_b1_b2 = d_Qbe_qs_dV_b1_b2;
      d_Qbe_dV_b_b1 = d_Qbe_qs_dV_b_b1;
      d_Qbe_dV_b_c = d_Qbe_qs_dV_b_c;
      d_Qbe_dV_b2_e1 = d_Qbe_qs_dV_b2_e1;
      d_Qbe_dV_dt_GND = d_Qbe_qs_dV_dt_GND;
      Qbe = Qbe_qs;

      d_Qbc_dV_b2_e1 = d_Qbc_qs_dV_b2_e1;
      d_Qbc_dV_c3_c4 = d_Qbc_qs_dV_c3_c4;
      d_Qbc_dV_c3_c1 = d_Qbc_qs_dV_c3_c1;
      d_Qbc_dV_c4_c1 = d_Qbc_qs_dV_c4_c1;
      d_Qbc_dV_b1_b2 = d_Qbc_qs_dV_b1_b2;
      d_Qbc_dV_b_b1 = d_Qbc_qs_dV_b_b1;
      d_Qbc_dV_b_c = d_Qbc_qs_dV_b_c;
      d_Qbc_dV_c1_c2 = d_Qbc_qs_dV_c1_c2;
      d_Qbc_dV_b2_c1 = d_Qbc_qs_dV_b2_c1;
      d_Qbc_dV_b2_c2 = d_Qbc_qs_dV_b2_c2;
      d_Qbc_dV_dt_GND = d_Qbc_qs_dV_dt_GND;
      Qbc = Qbc_qs;

      d_Qe_dV_b2_e1 = d_Qe_qs_dV_b2_e1;
      d_Qe_dV_c4_c1 = d_Qe_qs_dV_c4_c1;
      d_Qe_dV_c1_c2 = d_Qe_qs_dV_c1_c2;
      d_Qe_dV_b2_c2 = d_Qe_qs_dV_b2_c2;
      d_Qe_dV_b1_b2 = d_Qe_qs_dV_b1_b2;
      d_Qe_dV_dt_GND = d_Qe_qs_dV_dt_GND;
      Qe = Qe_qs;
    }
    // I(c1,c2) <+ ((TYPE*Ic1c2))
    {
      double contribTemp;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*Ic1c2);
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_Ic1c2_dV_c1_c2);
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_Ic1c2_dV_b2_c1);
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_Ic1c2_dV_b2_c2);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_Ic1c2_dV_dt_GND);
      staticContributions[admsNodeID_c1] += contribTemp;
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_c2] -= contribTemp;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_c1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_static[admsNodeID_c2] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(c2,e1) <+ ((TYPE*In))
    {
      double contribTemp;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*In);
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_In_dV_c1_c2);
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_In_dV_b2_c1);
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_In_dV_b2_c2);
      d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_In_dV_b2_e1);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_In_dV_dt_GND);
      staticContributions[admsNodeID_c2] += contribTemp;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_e1] -= contribTemp;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_c2] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_static[admsNodeID_e1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(b1,e1) <+ ((TYPE*Ib1_s))
    {
      double contribTemp;
      double d_contribTemp_dV_b1_e1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*Ib1_s);
      d_contribTemp_dV_b1_e1 = ((model_.TYPE)*d_Ib1_s_dV_b1_e1);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_Ib1_s_dV_dt_GND);
      staticContributions[admsNodeID_b1] += contribTemp;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_e1] -= contribTemp;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1];
      Jdxp_static[admsNodeID_e1] -= d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1];
    }
    // I(b2,e1) <+ ((TYPE*((Ib1+Ib2)-Izteb)))
    {
      double contribTemp;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_dt_GND;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      contribTemp= ((model_.TYPE)*((Ib1+Ib2)-Izteb));
      d_contribTemp_dV_b2_e1 = ((model_.TYPE)*((d_Ib1_dV_b2_e1+d_Ib2_dV_b2_e1)-d_Izteb_dV_b2_e1));
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*((d_Ib1_dV_dt_GND+d_Ib2_dV_dt_GND)-d_Izteb_dV_dt_GND));
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*(d_Ib1_dV_c1_c2-d_Izteb_dV_c1_c2));
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*(d_Ib1_dV_b2_c1-d_Izteb_dV_b2_c1));
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*(d_Ib1_dV_b2_c2-d_Izteb_dV_b2_c2));
      staticContributions[admsNodeID_b2] += contribTemp;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      staticContributions[admsNodeID_e1] -= contribTemp;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;

      Jdxp_static[admsNodeID_b2] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_static[admsNodeID_e1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(b1,s) <+ ((TYPE*Isub))
    {
      double contribTemp;
      double d_contribTemp_dV_s_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*Isub);
      d_contribTemp_dV_s_c1 = ((model_.TYPE)*d_Isub_dV_s_c1);
      d_contribTemp_dV_c4_c1 = ((model_.TYPE)*d_Isub_dV_c4_c1);
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_Isub_dV_c1_c2);
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_Isub_dV_b2_c2);
      d_contribTemp_dV_b1_b2 = ((model_.TYPE)*d_Isub_dV_b1_b2);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_Isub_dV_dt_GND);
      staticContributions[admsNodeID_b1] += contribTemp;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_s] -= contribTemp;
      d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_s][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_static[admsNodeID_s] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(b,s) <+ ((TYPE*XIsub))
    {
      double contribTemp;
      double d_contribTemp_dV_s_c1;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*XIsub);
      d_contribTemp_dV_s_c1 = ((model_.TYPE)*d_XIsub_dV_s_c1);
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_XIsub_dV_c1_c2);
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_XIsub_dV_b2_c1);
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_XIsub_dV_b2_c2);
      d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_XIsub_dV_b2_e1);
      d_contribTemp_dV_c3_c4 = ((model_.TYPE)*d_XIsub_dV_c3_c4);
      d_contribTemp_dV_c3_c1 = ((model_.TYPE)*d_XIsub_dV_c3_c1);
      d_contribTemp_dV_c4_c1 = ((model_.TYPE)*d_XIsub_dV_c4_c1);
      d_contribTemp_dV_b1_b2 = ((model_.TYPE)*d_XIsub_dV_b1_b2);
      d_contribTemp_dV_b_b1 = ((model_.TYPE)*d_XIsub_dV_b_b1);
      d_contribTemp_dV_b_c = ((model_.TYPE)*d_XIsub_dV_b_c);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_XIsub_dV_dt_GND);
      staticContributions[admsNodeID_b] += contribTemp;
      d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_s] -= contribTemp;
      d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_s][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_s][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_static[admsNodeID_s] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(s,c1) <+ ((TYPE*Isf))
    staticContributions[admsNodeID_s] += ((model_.TYPE)*Isf);
    d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1] += ((model_.TYPE)*d_Isf_dV_s_c1);
    d_staticContributions[admsNodeID_s][admsProbeID_V_dt_GND] += ((model_.TYPE)*d_Isf_dV_dt_GND);
    staticContributions[admsNodeID_c1] -= ((model_.TYPE)*Isf);
    d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1] -= ((model_.TYPE)*d_Isf_dV_s_c1);
    d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= ((model_.TYPE)*d_Isf_dV_dt_GND);
    // I(b1,b2) <+ ((TYPE*Ib1b2))
    {
      double contribTemp;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*Ib1b2);
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_Ib1b2_dV_c1_c2);
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_Ib1b2_dV_b2_c1);
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_Ib1b2_dV_b2_c2);
      d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_Ib1b2_dV_b2_e1);
      d_contribTemp_dV_c3_c4 = ((model_.TYPE)*d_Ib1b2_dV_c3_c4);
      d_contribTemp_dV_c3_c1 = ((model_.TYPE)*d_Ib1b2_dV_c3_c1);
      d_contribTemp_dV_c4_c1 = ((model_.TYPE)*d_Ib1b2_dV_c4_c1);
      d_contribTemp_dV_b_b1 = ((model_.TYPE)*d_Ib1b2_dV_b_b1);
      d_contribTemp_dV_b_c = ((model_.TYPE)*d_Ib1b2_dV_b_c);
      d_contribTemp_dV_b1_b2 = ((model_.TYPE)*d_Ib1b2_dV_b1_b2);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_Ib1b2_dV_dt_GND);
      staticContributions[admsNodeID_b1] += contribTemp;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_b2] -= contribTemp;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_static[admsNodeID_b2] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(b2,c2) <+ ((TYPE*((-1.0)*Iavl)))
    {
      double contribTemp;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*((-1.0)*Iavl));
      d_contribTemp_dV_b2_e1 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_b2_e1));
      d_contribTemp_dV_c3_c4 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_c3_c4));
      d_contribTemp_dV_c3_c1 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_c3_c1));
      d_contribTemp_dV_c4_c1 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_c4_c1));
      d_contribTemp_dV_b1_b2 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_b1_b2));
      d_contribTemp_dV_b_b1 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_b_b1));
      d_contribTemp_dV_b_c = ((model_.TYPE)*((-1.0)*d_Iavl_dV_b_c));
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_c1_c2));
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_b2_c1));
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*((-1.0)*d_Iavl_dV_b2_c2));
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*((-1.0)*d_Iavl_dV_dt_GND));
      staticContributions[admsNodeID_b2] += contribTemp;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_c2] -= contribTemp;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_b2] += d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_static[admsNodeID_c2] -= d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(e,e1) <+ (((TYPE*Vee1)/RE_TM))
    staticContributions[admsNodeID_e] += (((model_.TYPE)*Vee1)/RE_TM);
    d_staticContributions[admsNodeID_e][admsProbeID_V_dt_GND] += (-((model_.TYPE)*Vee1)*d_RE_TM_dV_dt_GND/RE_TM/RE_TM);
    d_staticContributions[admsNodeID_e][admsProbeID_V_e_e1] += (((model_.TYPE)*d_Vee1_dV_e_e1)/RE_TM);
    staticContributions[admsNodeID_e1] -= (((model_.TYPE)*Vee1)/RE_TM);
    d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= (-((model_.TYPE)*Vee1)*d_RE_TM_dV_dt_GND/RE_TM/RE_TM);
    d_staticContributions[admsNodeID_e1][admsProbeID_V_e_e1] -= (((model_.TYPE)*d_Vee1_dV_e_e1)/RE_TM);
    // I(b,b1) <+ (((TYPE*Vbb1)/RBC_TM))
    staticContributions[admsNodeID_b] += (((model_.TYPE)*Vbb1)/RBC_TM);
    d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND] += (-((model_.TYPE)*Vbb1)*d_RBC_TM_dV_dt_GND/RBC_TM/RBC_TM);
    d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] += (((model_.TYPE)*d_Vbb1_dV_b_b1)/RBC_TM);
    staticContributions[admsNodeID_b1] -= (((model_.TYPE)*Vbb1)/RBC_TM);
    d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] -= (-((model_.TYPE)*Vbb1)*d_RBC_TM_dV_dt_GND/RBC_TM/RBC_TM);
    d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1] -= (((model_.TYPE)*d_Vbb1_dV_b_b1)/RBC_TM);
    // I(dt,GND) <+ ((V(dt,GND)/RTH_Tamb_M))
    staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_V_dt_GND])/RTH_Tamb_M);
    d_staticContributions[admsNodeID_dt][admsProbeID_V_dt_GND] += (d_probeVars[admsProbeID_V_dt_GND][admsProbeID_V_dt_GND]/RTH_Tamb_M);
    // I(dt,GND) <+ (ddt((CTH_M*V(dt,GND))))
    dynamicContributions[admsNodeID_dt] += ((CTH_M*(probeVars[admsProbeID_V_dt_GND])));
    d_dynamicContributions[admsNodeID_dt][admsProbeID_V_dt_GND] += ((CTH_M*d_probeVars[admsProbeID_V_dt_GND][admsProbeID_V_dt_GND]));
    // I(dt,GND) <+ (((-1.0)*power))
    {
      double contribTemp;
      double d_contribTemp_dV_s_c1;
      double d_contribTemp_dV_b1_e1;
      double d_contribTemp_dV_e_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((-1.0)*power);
      d_contribTemp_dV_s_c1 = ((-1.0)*d_power_dV_s_c1);
      d_contribTemp_dV_b1_e1 = ((-1.0)*d_power_dV_b1_e1);
      d_contribTemp_dV_e_e1 = ((-1.0)*d_power_dV_e_e1);
      d_contribTemp_dV_c3_c4 = ((-1.0)*d_power_dV_c3_c4);
      d_contribTemp_dV_c3_c1 = ((-1.0)*d_power_dV_c3_c1);
      d_contribTemp_dV_c4_c1 = ((-1.0)*d_power_dV_c4_c1);
      d_contribTemp_dV_b1_b2 = ((-1.0)*d_power_dV_b1_b2);
      d_contribTemp_dV_b_b1 = ((-1.0)*d_power_dV_b_b1);
      d_contribTemp_dV_b_c = ((-1.0)*d_power_dV_b_c);
      d_contribTemp_dV_c1_c2 = ((-1.0)*d_power_dV_c1_c2);
      d_contribTemp_dV_b2_c1 = ((-1.0)*d_power_dV_b2_c1);
      d_contribTemp_dV_b2_c2 = ((-1.0)*d_power_dV_b2_c2);
      d_contribTemp_dV_b2_e1 = ((-1.0)*d_power_dV_b2_e1);
      d_contribTemp_dV_dt_GND = ((-1.0)*d_power_dV_dt_GND);
      staticContributions[admsNodeID_dt] += contribTemp;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_e_e1] += d_contribTemp_dV_e_e1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_dt][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_dt] += d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(b2,e1) <+ (ddt((TYPE*((Qte+Qbe)+Qe))))
    {
      double contribTemp;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (((model_.TYPE)*((Qte+Qbe)+Qe)));
      d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Qbe_dV_c3_c4));
      d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Qbe_dV_c3_c1));
      d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_Qbe_dV_c4_c1+d_Qe_dV_c4_c1)));
      d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_Qbe_dV_b1_b2+d_Qe_dV_b1_b2)));
      d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Qbe_dV_b_b1));
      d_contribTemp_dV_b_c = (((model_.TYPE)*d_Qbe_dV_b_c));
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*((d_Qte_dV_c1_c2+d_Qbe_dV_c1_c2)+d_Qe_dV_c1_c2)));
      d_contribTemp_dV_b2_c1 = (((model_.TYPE)*(d_Qte_dV_b2_c1+d_Qbe_dV_b2_c1)));
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*((d_Qte_dV_b2_c2+d_Qbe_dV_b2_c2)+d_Qe_dV_b2_c2)));
      d_contribTemp_dV_b2_e1 = (((model_.TYPE)*((d_Qte_dV_b2_e1+d_Qbe_dV_b2_e1)+d_Qe_dV_b2_e1)));
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*((d_Qte_dV_dt_GND+d_Qbe_dV_dt_GND)+d_Qe_dV_dt_GND)));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      dynamicContributions[admsNodeID_e1] -= contribTemp;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_dynamic[admsNodeID_b2] += d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_dynamic[admsNodeID_e1] -= d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(b1,e1) <+ (ddt((TYPE*Qte_s)))
    {
      double contribTemp;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_b1_e1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (((model_.TYPE)*Qte_s));
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*d_Qte_s_dV_c1_c2));
      d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qte_s_dV_b2_c1));
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*d_Qte_s_dV_b2_c2));
      d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qte_s_dV_b2_e1));
      d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_Qte_s_dV_b1_e1));
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*d_Qte_s_dV_dt_GND));
      dynamicContributions[admsNodeID_b1] += contribTemp;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      dynamicContributions[admsNodeID_e1] -= contribTemp;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_dynamic[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1];
      Jdxp_dynamic[admsNodeID_e1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1];
    }
    // I(b2,c2) <+ (ddt((TYPE*((Qtc+Qbc)+Qepi))))
    {
      double contribTemp;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (((model_.TYPE)*((Qtc+Qbc)+Qepi)));
      d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Qbc_dV_c3_c4));
      d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Qbc_dV_c3_c1));
      d_contribTemp_dV_c4_c1 = (((model_.TYPE)*d_Qbc_dV_c4_c1));
      d_contribTemp_dV_b1_b2 = (((model_.TYPE)*d_Qbc_dV_b1_b2));
      d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Qbc_dV_b_b1));
      d_contribTemp_dV_b_c = (((model_.TYPE)*d_Qbc_dV_b_c));
      d_contribTemp_dV_b2_e1 = (((model_.TYPE)*(d_Qtc_dV_b2_e1+d_Qbc_dV_b2_e1)));
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*((d_Qtc_dV_c1_c2+d_Qbc_dV_c1_c2)+d_Qepi_dV_c1_c2)));
      d_contribTemp_dV_b2_c1 = (((model_.TYPE)*((d_Qtc_dV_b2_c1+d_Qbc_dV_b2_c1)+d_Qepi_dV_b2_c1)));
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*((d_Qtc_dV_b2_c2+d_Qbc_dV_b2_c2)+d_Qepi_dV_b2_c2)));
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*((d_Qtc_dV_dt_GND+d_Qbc_dV_dt_GND)+d_Qepi_dV_dt_GND)));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      dynamicContributions[admsNodeID_c2] -= contribTemp;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_c2][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_dynamic[admsNodeID_b2] += d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_dynamic[admsNodeID_c2] -= d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(s,c1) <+ (ddt((TYPE*Qts)))
    {
      double contribTemp;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_b1_e1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_s_c1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (((model_.TYPE)*Qts));
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*d_Qts_dV_c1_c2));
      d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qts_dV_b2_c1));
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*d_Qts_dV_b2_c2));
      d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qts_dV_b2_e1));
      d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_Qts_dV_b1_e1));
      d_contribTemp_dV_c4_c1 = (((model_.TYPE)*d_Qts_dV_c4_c1));
      d_contribTemp_dV_b1_b2 = (((model_.TYPE)*d_Qts_dV_b1_b2));
      d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Qts_dV_c3_c4));
      d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Qts_dV_c3_c1));
      d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Qts_dV_b_b1));
      d_contribTemp_dV_b_c = (((model_.TYPE)*d_Qts_dV_b_c));
      d_contribTemp_dV_s_c1 = (((model_.TYPE)*d_Qts_dV_s_c1));
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*d_Qts_dV_dt_GND));
      dynamicContributions[admsNodeID_s] += contribTemp;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      dynamicContributions[admsNodeID_c1] -= contribTemp;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
      d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_dynamic[admsNodeID_s] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_dynamic[admsNodeID_c1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(b1,b2) <+ (ddt((TYPE*Qb1b2)))
    {
      double contribTemp;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_dt_GND;
      double d_contribTemp_dV_b1_b2;
      contribTemp= (((model_.TYPE)*Qb1b2));
      d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Qb1b2_dV_c3_c4));
      d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Qb1b2_dV_c3_c1));
      d_contribTemp_dV_c4_c1 = (((model_.TYPE)*d_Qb1b2_dV_c4_c1));
      d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Qb1b2_dV_b_b1));
      d_contribTemp_dV_b_c = (((model_.TYPE)*d_Qb1b2_dV_b_c));
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*d_Qb1b2_dV_c1_c2));
      d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qb1b2_dV_b2_c1));
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*d_Qb1b2_dV_b2_c2));
      d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qb1b2_dV_b2_e1));
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*d_Qb1b2_dV_dt_GND));
      d_contribTemp_dV_b1_b2 = (((model_.TYPE)*d_Qb1b2_dV_b1_b2));
      dynamicContributions[admsNodeID_b1] += contribTemp;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      dynamicContributions[admsNodeID_b2] -= contribTemp;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;

      Jdxp_dynamic[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_dynamic[admsNodeID_b2] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(b,e) <+ (ddt(((TYPE*CBEO_M)*Vbe)))
    dynamicContributions[admsNodeID_b] += ((((model_.TYPE)*CBEO_M)*Vbe));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] += ((((model_.TYPE)*CBEO_M)*d_Vbe_dV_b_e));
    dynamicContributions[admsNodeID_e] -= ((((model_.TYPE)*CBEO_M)*Vbe));
    d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e] -= ((((model_.TYPE)*CBEO_M)*d_Vbe_dV_b_e));
    // I(b,c) <+ (ddt(((TYPE*CBCO_M)*Vbc)))
    dynamicContributions[admsNodeID_b] += ((((model_.TYPE)*CBCO_M)*Vbc));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] += ((((model_.TYPE)*CBCO_M)*d_Vbc_dV_b_c));
    dynamicContributions[admsNodeID_c] -= ((((model_.TYPE)*CBCO_M)*Vbc));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c] -= ((((model_.TYPE)*CBCO_M)*d_Vbc_dV_b_c));
  }
  if (((model_.RCBLX)>0.0))
  {
    // I(b,c3) <+ ((TYPE*XIex))
    {
      double contribTemp;
      double d_contribTemp_dV_s_c1;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_dt_GND;
      contribTemp= ((model_.TYPE)*XIex);
      d_contribTemp_dV_s_c1 = ((model_.TYPE)*d_XIex_dV_s_c1);
      d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_XIex_dV_c1_c2);
      d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_XIex_dV_b2_c1);
      d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_XIex_dV_b2_c2);
      d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_XIex_dV_b2_e1);
      d_contribTemp_dV_c3_c4 = ((model_.TYPE)*d_XIex_dV_c3_c4);
      d_contribTemp_dV_c3_c1 = ((model_.TYPE)*d_XIex_dV_c3_c1);
      d_contribTemp_dV_c4_c1 = ((model_.TYPE)*d_XIex_dV_c4_c1);
      d_contribTemp_dV_b1_b2 = ((model_.TYPE)*d_XIex_dV_b1_b2);
      d_contribTemp_dV_b_b1 = ((model_.TYPE)*d_XIex_dV_b_b1);
      d_contribTemp_dV_b_c = ((model_.TYPE)*d_XIex_dV_b_c);
      d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_XIex_dV_dt_GND);
      staticContributions[admsNodeID_b] += contribTemp;
      d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_c3] -= contribTemp;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_static[admsNodeID_c3] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(c,c3) <+ (((TYPE*Vcc3)*GCCxx_TM))
    {
      double contribTemp;
      double d_contribTemp_dV_dt_GND;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      contribTemp= (((model_.TYPE)*Vcc3)*GCCxx_TM);
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*Vcc3)*d_GCCxx_TM_dV_dt_GND);
      d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Vcc3_dV_c3_c4)*GCCxx_TM);
      d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Vcc3_dV_c3_c1)*GCCxx_TM);
      d_contribTemp_dV_c4_c1 = (((model_.TYPE)*d_Vcc3_dV_c4_c1)*GCCxx_TM);
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*d_Vcc3_dV_c1_c2)*GCCxx_TM);
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*d_Vcc3_dV_b2_c2)*GCCxx_TM);
      d_contribTemp_dV_b1_b2 = (((model_.TYPE)*d_Vcc3_dV_b1_b2)*GCCxx_TM);
      d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Vcc3_dV_b_b1)*GCCxx_TM);
      d_contribTemp_dV_b_c = (((model_.TYPE)*d_Vcc3_dV_b_c)*GCCxx_TM);
      staticContributions[admsNodeID_c] += contribTemp;
      d_staticContributions[admsNodeID_c][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      staticContributions[admsNodeID_c3] -= contribTemp;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;

      Jdxp_static[admsNodeID_c] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_static[admsNodeID_c3] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(b,c3) <+ (ddt((TYPE*(XQtex+XQex))))
    {
      double contribTemp;
      double d_contribTemp_dV_s_c1;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_b1_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (((model_.TYPE)*(XQtex+XQex)));
      d_contribTemp_dV_s_c1 = (((model_.TYPE)*d_XQex_dV_s_c1));
      d_contribTemp_dV_b2_c1 = (((model_.TYPE)*(d_XQtex_dV_b2_c1+d_XQex_dV_b2_c1)));
      d_contribTemp_dV_b2_e1 = (((model_.TYPE)*(d_XQtex_dV_b2_e1+d_XQex_dV_b2_e1)));
      d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_XQtex_dV_b1_e1));
      d_contribTemp_dV_c3_c4 = (((model_.TYPE)*(d_XQtex_dV_c3_c4+d_XQex_dV_c3_c4)));
      d_contribTemp_dV_c3_c1 = (((model_.TYPE)*(d_XQtex_dV_c3_c1+d_XQex_dV_c3_c1)));
      d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_XQtex_dV_c4_c1+d_XQex_dV_c4_c1)));
      d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_XQtex_dV_c1_c2+d_XQex_dV_c1_c2)));
      d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_XQtex_dV_b2_c2+d_XQex_dV_b2_c2)));
      d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_XQtex_dV_b1_b2+d_XQex_dV_b1_b2)));
      d_contribTemp_dV_b_b1 = (((model_.TYPE)*(d_XQtex_dV_b_b1+d_XQex_dV_b_b1)));
      d_contribTemp_dV_b_c = (((model_.TYPE)*(d_XQtex_dV_b_c+d_XQex_dV_b_c)));
      d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_XQtex_dV_dt_GND+d_XQex_dV_dt_GND)));
      dynamicContributions[admsNodeID_b] += contribTemp;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      dynamicContributions[admsNodeID_c3] -= contribTemp;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_c3][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_dynamic[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_dynamic[admsNodeID_c3] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    if (((model_.RCBLI)>0.0))
    {
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += (((model_.TYPE)*Vc4c1)*GCCin_TM);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] += (((model_.TYPE)*Vc4c1)*d_GCCin_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] += (((model_.TYPE)*d_Vc4c1_dV_c4_c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc4c1)*GCCin_TM);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= (((model_.TYPE)*Vc4c1)*d_GCCin_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= (((model_.TYPE)*d_Vc4c1_dV_c4_c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_Ib3_dV_b2_e1);
        d_contribTemp_dV_c4_c1 = ((model_.TYPE)*(d_Ib3_dV_c4_c1+d_Iex_dV_c4_c1));
        d_contribTemp_dV_c1_c2 = ((model_.TYPE)*(d_Ib3_dV_c1_c2+d_Iex_dV_c1_c2));
        d_contribTemp_dV_b2_c2 = ((model_.TYPE)*(d_Ib3_dV_b2_c2+d_Iex_dV_b2_c2));
        d_contribTemp_dV_b1_b2 = ((model_.TYPE)*(d_Ib3_dV_b1_b2+d_Iex_dV_b1_b2));
        d_contribTemp_dV_dt_GND = ((model_.TYPE)*(d_Ib3_dV_dt_GND+d_Iex_dV_dt_GND));
        staticContributions[admsNodeID_b1] += contribTemp;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        staticContributions[admsNodeID_c4] -= contribTemp;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c4] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(c3,c4) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND] += (((model_.TYPE)*Vc3c4)*d_GCCex_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4] += (((model_.TYPE)*d_Vc3c4_dV_c3_c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] += (((model_.TYPE)*d_Vc3c4_dV_c3_c1)*GCCex_TM);
      staticContributions[admsNodeID_c4] -= (((model_.TYPE)*Vc3c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= (((model_.TYPE)*Vc3c4)*d_GCCex_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4] -= (((model_.TYPE)*d_Vc3c4_dV_c3_c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] -= (((model_.TYPE)*d_Vc3c4_dV_c3_c1)*GCCex_TM);
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_b1_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qtex_dV_b2_c1));
        d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qtex_dV_b2_e1));
        d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_Qtex_dV_b1_e1));
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_Qtex_dV_c4_c1+d_Qex_dV_c4_c1)));
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_Qtex_dV_c1_c2+d_Qex_dV_c1_c2)));
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_Qtex_dV_b2_c2+d_Qex_dV_b2_c2)));
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_Qtex_dV_b1_b2+d_Qex_dV_b1_b2)));
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_Qtex_dV_dt_GND+d_Qex_dV_dt_GND)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        dynamicContributions[admsNodeID_c4] -= contribTemp;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_dynamic[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_dynamic[admsNodeID_c4] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
    }
    else
    {
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_Ib3_dV_b2_e1);
        d_contribTemp_dV_c4_c1 = ((model_.TYPE)*(d_Ib3_dV_c4_c1+d_Iex_dV_c4_c1));
        d_contribTemp_dV_c1_c2 = ((model_.TYPE)*(d_Ib3_dV_c1_c2+d_Iex_dV_c1_c2));
        d_contribTemp_dV_b2_c2 = ((model_.TYPE)*(d_Ib3_dV_b2_c2+d_Iex_dV_b2_c2));
        d_contribTemp_dV_b1_b2 = ((model_.TYPE)*(d_Ib3_dV_b1_b2+d_Iex_dV_b1_b2));
        d_contribTemp_dV_dt_GND = ((model_.TYPE)*(d_Ib3_dV_dt_GND+d_Iex_dV_dt_GND));
        staticContributions[admsNodeID_b1] += contribTemp;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        staticContributions[admsNodeID_c1] -= contribTemp;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c1] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_b1_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qtex_dV_b2_c1));
        d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qtex_dV_b2_e1));
        d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_Qtex_dV_b1_e1));
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_Qtex_dV_c4_c1+d_Qex_dV_c4_c1)));
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_Qtex_dV_c1_c2+d_Qex_dV_c1_c2)));
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_Qtex_dV_b2_c2+d_Qex_dV_b2_c2)));
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_Qtex_dV_b1_b2+d_Qex_dV_b1_b2)));
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_Qtex_dV_dt_GND+d_Qex_dV_dt_GND)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        dynamicContributions[admsNodeID_c1] -= contribTemp;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_dynamic[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_dynamic[admsNodeID_c1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND] += (((model_.TYPE)*Vc3c4)*d_GCCex_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4] += (((model_.TYPE)*d_Vc3c4_dV_c3_c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] += (((model_.TYPE)*d_Vc3c4_dV_c3_c1)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc3c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= (((model_.TYPE)*Vc3c4)*d_GCCex_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] -= (((model_.TYPE)*d_Vc3c4_dV_c3_c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -= (((model_.TYPE)*d_Vc3c4_dV_c3_c1)*GCCex_TM);
    }
  }
  else
  {
    // V(c3,c4) <+ (0)
    // do nothing at all
    if (((model_.RCBLI)>0.0))
    {
      // I(b,c4) <+ ((TYPE*XIex))
      {
        double contribTemp;
        double d_contribTemp_dV_s_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_c3_c4;
        double d_contribTemp_dV_c3_c1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_b_b1;
        double d_contribTemp_dV_b_c;
        double d_contribTemp_dV_dt_GND;
        contribTemp= ((model_.TYPE)*XIex);
        d_contribTemp_dV_s_c1 = ((model_.TYPE)*d_XIex_dV_s_c1);
        d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_XIex_dV_c1_c2);
        d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_XIex_dV_b2_c1);
        d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_XIex_dV_b2_c2);
        d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_XIex_dV_b2_e1);
        d_contribTemp_dV_c3_c4 = ((model_.TYPE)*d_XIex_dV_c3_c4);
        d_contribTemp_dV_c3_c1 = ((model_.TYPE)*d_XIex_dV_c3_c1);
        d_contribTemp_dV_c4_c1 = ((model_.TYPE)*d_XIex_dV_c4_c1);
        d_contribTemp_dV_b1_b2 = ((model_.TYPE)*d_XIex_dV_b1_b2);
        d_contribTemp_dV_b_b1 = ((model_.TYPE)*d_XIex_dV_b_b1);
        d_contribTemp_dV_b_c = ((model_.TYPE)*d_XIex_dV_b_c);
        d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_XIex_dV_dt_GND);
        staticContributions[admsNodeID_b] += contribTemp;
        d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
        d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        staticContributions[admsNodeID_c4] -= contribTemp;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_static[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c4] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(c,c4) <+ (((TYPE*Vcc3)*GCCxx_TM))
      {
        double contribTemp;
        double d_contribTemp_dV_dt_GND;
        double d_contribTemp_dV_c3_c4;
        double d_contribTemp_dV_c3_c1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_b_b1;
        double d_contribTemp_dV_b_c;
        contribTemp= (((model_.TYPE)*Vcc3)*GCCxx_TM);
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*Vcc3)*d_GCCxx_TM_dV_dt_GND);
        d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Vcc3_dV_c3_c4)*GCCxx_TM);
        d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Vcc3_dV_c3_c1)*GCCxx_TM);
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*d_Vcc3_dV_c4_c1)*GCCxx_TM);
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*d_Vcc3_dV_c1_c2)*GCCxx_TM);
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*d_Vcc3_dV_b2_c2)*GCCxx_TM);
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*d_Vcc3_dV_b1_b2)*GCCxx_TM);
        d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Vcc3_dV_b_b1)*GCCxx_TM);
        d_contribTemp_dV_b_c = (((model_.TYPE)*d_Vcc3_dV_b_c)*GCCxx_TM);
        staticContributions[admsNodeID_c] += contribTemp;
        d_staticContributions[admsNodeID_c][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
        staticContributions[admsNodeID_c4] -= contribTemp;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;

        Jdxp_static[admsNodeID_c] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c4] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += (((model_.TYPE)*Vc4c1)*GCCin_TM);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] += (((model_.TYPE)*Vc4c1)*d_GCCin_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] += (((model_.TYPE)*d_Vc4c1_dV_c4_c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc4c1)*GCCin_TM);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= (((model_.TYPE)*Vc4c1)*d_GCCin_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= (((model_.TYPE)*d_Vc4c1_dV_c4_c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_Ib3_dV_b2_e1);
        d_contribTemp_dV_c4_c1 = ((model_.TYPE)*(d_Ib3_dV_c4_c1+d_Iex_dV_c4_c1));
        d_contribTemp_dV_c1_c2 = ((model_.TYPE)*(d_Ib3_dV_c1_c2+d_Iex_dV_c1_c2));
        d_contribTemp_dV_b2_c2 = ((model_.TYPE)*(d_Ib3_dV_b2_c2+d_Iex_dV_b2_c2));
        d_contribTemp_dV_b1_b2 = ((model_.TYPE)*(d_Ib3_dV_b1_b2+d_Iex_dV_b1_b2));
        d_contribTemp_dV_dt_GND = ((model_.TYPE)*(d_Ib3_dV_dt_GND+d_Iex_dV_dt_GND));
        staticContributions[admsNodeID_b1] += contribTemp;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        staticContributions[admsNodeID_c4] -= contribTemp;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c4] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_b1_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qtex_dV_b2_c1));
        d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qtex_dV_b2_e1));
        d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_Qtex_dV_b1_e1));
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_Qtex_dV_c4_c1+d_Qex_dV_c4_c1)));
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_Qtex_dV_c1_c2+d_Qex_dV_c1_c2)));
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_Qtex_dV_b2_c2+d_Qex_dV_b2_c2)));
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_Qtex_dV_b1_b2+d_Qex_dV_b1_b2)));
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_Qtex_dV_dt_GND+d_Qex_dV_dt_GND)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        dynamicContributions[admsNodeID_c4] -= contribTemp;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_dynamic[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_dynamic[admsNodeID_c4] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(b,c4) <+ (ddt((TYPE*(XQtex+XQex))))
      {
        double contribTemp;
        double d_contribTemp_dV_s_c1;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_b1_e1;
        double d_contribTemp_dV_c3_c4;
        double d_contribTemp_dV_c3_c1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_b_b1;
        double d_contribTemp_dV_b_c;
        double d_contribTemp_dV_dt_GND;
        contribTemp= (((model_.TYPE)*(XQtex+XQex)));
        d_contribTemp_dV_s_c1 = (((model_.TYPE)*d_XQex_dV_s_c1));
        d_contribTemp_dV_b2_c1 = (((model_.TYPE)*(d_XQtex_dV_b2_c1+d_XQex_dV_b2_c1)));
        d_contribTemp_dV_b2_e1 = (((model_.TYPE)*(d_XQtex_dV_b2_e1+d_XQex_dV_b2_e1)));
        d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_XQtex_dV_b1_e1));
        d_contribTemp_dV_c3_c4 = (((model_.TYPE)*(d_XQtex_dV_c3_c4+d_XQex_dV_c3_c4)));
        d_contribTemp_dV_c3_c1 = (((model_.TYPE)*(d_XQtex_dV_c3_c1+d_XQex_dV_c3_c1)));
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_XQtex_dV_c4_c1+d_XQex_dV_c4_c1)));
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_XQtex_dV_c1_c2+d_XQex_dV_c1_c2)));
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_XQtex_dV_b2_c2+d_XQex_dV_b2_c2)));
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_XQtex_dV_b1_b2+d_XQex_dV_b1_b2)));
        d_contribTemp_dV_b_b1 = (((model_.TYPE)*(d_XQtex_dV_b_b1+d_XQex_dV_b_b1)));
        d_contribTemp_dV_b_c = (((model_.TYPE)*(d_XQtex_dV_b_c+d_XQex_dV_b_c)));
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_XQtex_dV_dt_GND+d_XQex_dV_dt_GND)));
        dynamicContributions[admsNodeID_b] += contribTemp;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        dynamicContributions[admsNodeID_c4] -= contribTemp;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
        d_dynamicContributions[admsNodeID_c4][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_dynamic[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_dynamic[admsNodeID_c4] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
    }
    else
    {
      // I(b,c1) <+ ((TYPE*XIex))
      {
        double contribTemp;
        double d_contribTemp_dV_s_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_c3_c4;
        double d_contribTemp_dV_c3_c1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_b_b1;
        double d_contribTemp_dV_b_c;
        double d_contribTemp_dV_dt_GND;
        contribTemp= ((model_.TYPE)*XIex);
        d_contribTemp_dV_s_c1 = ((model_.TYPE)*d_XIex_dV_s_c1);
        d_contribTemp_dV_c1_c2 = ((model_.TYPE)*d_XIex_dV_c1_c2);
        d_contribTemp_dV_b2_c1 = ((model_.TYPE)*d_XIex_dV_b2_c1);
        d_contribTemp_dV_b2_c2 = ((model_.TYPE)*d_XIex_dV_b2_c2);
        d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_XIex_dV_b2_e1);
        d_contribTemp_dV_c3_c4 = ((model_.TYPE)*d_XIex_dV_c3_c4);
        d_contribTemp_dV_c3_c1 = ((model_.TYPE)*d_XIex_dV_c3_c1);
        d_contribTemp_dV_c4_c1 = ((model_.TYPE)*d_XIex_dV_c4_c1);
        d_contribTemp_dV_b1_b2 = ((model_.TYPE)*d_XIex_dV_b1_b2);
        d_contribTemp_dV_b_b1 = ((model_.TYPE)*d_XIex_dV_b_b1);
        d_contribTemp_dV_b_c = ((model_.TYPE)*d_XIex_dV_b_c);
        d_contribTemp_dV_dt_GND = ((model_.TYPE)*d_XIex_dV_dt_GND);
        staticContributions[admsNodeID_b] += contribTemp;
        d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
        d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        staticContributions[admsNodeID_c1] -= contribTemp;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_static[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(c,c1) <+ (((TYPE*Vcc3)*GCCxx_TM))
      {
        double contribTemp;
        double d_contribTemp_dV_dt_GND;
        double d_contribTemp_dV_c3_c4;
        double d_contribTemp_dV_c3_c1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_b_b1;
        double d_contribTemp_dV_b_c;
        contribTemp= (((model_.TYPE)*Vcc3)*GCCxx_TM);
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*Vcc3)*d_GCCxx_TM_dV_dt_GND);
        d_contribTemp_dV_c3_c4 = (((model_.TYPE)*d_Vcc3_dV_c3_c4)*GCCxx_TM);
        d_contribTemp_dV_c3_c1 = (((model_.TYPE)*d_Vcc3_dV_c3_c1)*GCCxx_TM);
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*d_Vcc3_dV_c4_c1)*GCCxx_TM);
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*d_Vcc3_dV_c1_c2)*GCCxx_TM);
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*d_Vcc3_dV_b2_c2)*GCCxx_TM);
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*d_Vcc3_dV_b1_b2)*GCCxx_TM);
        d_contribTemp_dV_b_b1 = (((model_.TYPE)*d_Vcc3_dV_b_b1)*GCCxx_TM);
        d_contribTemp_dV_b_c = (((model_.TYPE)*d_Vcc3_dV_b_c)*GCCxx_TM);
        staticContributions[admsNodeID_c] += contribTemp;
        d_staticContributions[admsNodeID_c][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
        staticContributions[admsNodeID_c1] -= contribTemp;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;

        Jdxp_static[admsNodeID_c] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c1] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        d_contribTemp_dV_b2_e1 = ((model_.TYPE)*d_Ib3_dV_b2_e1);
        d_contribTemp_dV_c4_c1 = ((model_.TYPE)*(d_Ib3_dV_c4_c1+d_Iex_dV_c4_c1));
        d_contribTemp_dV_c1_c2 = ((model_.TYPE)*(d_Ib3_dV_c1_c2+d_Iex_dV_c1_c2));
        d_contribTemp_dV_b2_c2 = ((model_.TYPE)*(d_Ib3_dV_b2_c2+d_Iex_dV_b2_c2));
        d_contribTemp_dV_b1_b2 = ((model_.TYPE)*(d_Ib3_dV_b1_b2+d_Iex_dV_b1_b2));
        d_contribTemp_dV_dt_GND = ((model_.TYPE)*(d_Ib3_dV_dt_GND+d_Iex_dV_dt_GND));
        staticContributions[admsNodeID_b1] += contribTemp;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        staticContributions[admsNodeID_c1] -= contribTemp;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_static[admsNodeID_b1] += d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_static[admsNodeID_c1] -= d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        double contribTemp;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_b1_e1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_dt_GND;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        d_contribTemp_dV_b2_c1 = (((model_.TYPE)*d_Qtex_dV_b2_c1));
        d_contribTemp_dV_b2_e1 = (((model_.TYPE)*d_Qtex_dV_b2_e1));
        d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_Qtex_dV_b1_e1));
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_Qtex_dV_c4_c1+d_Qex_dV_c4_c1)));
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_Qtex_dV_c1_c2+d_Qex_dV_c1_c2)));
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_Qtex_dV_b2_c2+d_Qex_dV_b2_c2)));
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_Qtex_dV_b1_b2+d_Qex_dV_b1_b2)));
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_Qtex_dV_dt_GND+d_Qex_dV_dt_GND)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        dynamicContributions[admsNodeID_c1] -= contribTemp;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_dynamic[admsNodeID_b1] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_dynamic[admsNodeID_c1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(b,c1) <+ (ddt((TYPE*(XQtex+XQex))))
      {
        double contribTemp;
        double d_contribTemp_dV_s_c1;
        double d_contribTemp_dV_b2_c1;
        double d_contribTemp_dV_b2_e1;
        double d_contribTemp_dV_b1_e1;
        double d_contribTemp_dV_c3_c4;
        double d_contribTemp_dV_c3_c1;
        double d_contribTemp_dV_c4_c1;
        double d_contribTemp_dV_c1_c2;
        double d_contribTemp_dV_b2_c2;
        double d_contribTemp_dV_b1_b2;
        double d_contribTemp_dV_b_b1;
        double d_contribTemp_dV_b_c;
        double d_contribTemp_dV_dt_GND;
        contribTemp= (((model_.TYPE)*(XQtex+XQex)));
        d_contribTemp_dV_s_c1 = (((model_.TYPE)*d_XQex_dV_s_c1));
        d_contribTemp_dV_b2_c1 = (((model_.TYPE)*(d_XQtex_dV_b2_c1+d_XQex_dV_b2_c1)));
        d_contribTemp_dV_b2_e1 = (((model_.TYPE)*(d_XQtex_dV_b2_e1+d_XQex_dV_b2_e1)));
        d_contribTemp_dV_b1_e1 = (((model_.TYPE)*d_XQtex_dV_b1_e1));
        d_contribTemp_dV_c3_c4 = (((model_.TYPE)*(d_XQtex_dV_c3_c4+d_XQex_dV_c3_c4)));
        d_contribTemp_dV_c3_c1 = (((model_.TYPE)*(d_XQtex_dV_c3_c1+d_XQex_dV_c3_c1)));
        d_contribTemp_dV_c4_c1 = (((model_.TYPE)*(d_XQtex_dV_c4_c1+d_XQex_dV_c4_c1)));
        d_contribTemp_dV_c1_c2 = (((model_.TYPE)*(d_XQtex_dV_c1_c2+d_XQex_dV_c1_c2)));
        d_contribTemp_dV_b2_c2 = (((model_.TYPE)*(d_XQtex_dV_b2_c2+d_XQex_dV_b2_c2)));
        d_contribTemp_dV_b1_b2 = (((model_.TYPE)*(d_XQtex_dV_b1_b2+d_XQex_dV_b1_b2)));
        d_contribTemp_dV_b_b1 = (((model_.TYPE)*(d_XQtex_dV_b_b1+d_XQex_dV_b_b1)));
        d_contribTemp_dV_b_c = (((model_.TYPE)*(d_XQtex_dV_b_c+d_XQex_dV_b_c)));
        d_contribTemp_dV_dt_GND = (((model_.TYPE)*(d_XQtex_dV_dt_GND+d_XQex_dV_dt_GND)));
        dynamicContributions[admsNodeID_b] += contribTemp;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1] += d_contribTemp_dV_s_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1] += d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
        d_dynamicContributions[admsNodeID_b][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
        dynamicContributions[admsNodeID_c1] -= contribTemp;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1] -= d_contribTemp_dV_s_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] -= d_contribTemp_dV_b1_e1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
        d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

        Jdxp_dynamic[admsNodeID_b] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
        Jdxp_dynamic[admsNodeID_c1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b1_e1*probeDiffs[admsProbeID_V_b1_e1]*d_probeVars[admsProbeID_V_b1_e1][admsProbeID_V_b1_e1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      }
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND] += (((model_.TYPE)*Vc3c4)*d_GCCex_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4] += (((model_.TYPE)*d_Vc3c4_dV_c3_c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] += (((model_.TYPE)*d_Vc3c4_dV_c3_c1)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc3c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] -= (((model_.TYPE)*Vc3c4)*d_GCCex_TM_dV_dt_GND);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] -= (((model_.TYPE)*d_Vc3c4_dV_c3_c4)*GCCex_TM);
      d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -= (((model_.TYPE)*d_Vc3c4_dV_c3_c1)*GCCex_TM);
    }
  }
  {

    d_common_dV_dt_GND = ((4.0*1.3806226e-23)*d_Tk_dV_dt_GND);
    common = ((4.0*1.3806226e-23)*Tk);

    d_powerREC_dV_dt_GND = ((RE_TM*d_common_dV_dt_GND-common*d_RE_TM_dV_dt_GND)/RE_TM/RE_TM);
    powerREC = (common/RE_TM);

    d_powerRBC_dV_dt_GND = ((RBC_TM*d_common_dV_dt_GND-common*d_RBC_TM_dV_dt_GND)/RBC_TM/RBC_TM);
    powerRBC = (common/RBC_TM);

    d_powerRCCxx_dV_dt_GND = ((common*d_GCCxx_TM_dV_dt_GND)+(d_common_dV_dt_GND*GCCxx_TM));
    powerRCCxx = (common*GCCxx_TM);

    d_powerRCCex_dV_dt_GND = ((common*d_GCCex_TM_dV_dt_GND)+(d_common_dV_dt_GND*GCCex_TM));
    powerRCCex = (common*GCCex_TM);

    d_powerRCCin_dV_dt_GND = ((common*d_GCCin_TM_dV_dt_GND)+(d_common_dV_dt_GND*GCCin_TM));
    powerRCCin = (common*GCCin_TM);

    d_powerRBV_dV_c1_c2 = (((-common*d_Rb2_dV_c1_c2/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_b2_c1 = (((-common*d_Rb2_dV_b2_c1/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_b2_c2 = (((-common*d_Rb2_dV_b2_c2/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_b2_e1 = (((-common*d_Rb2_dV_b2_e1/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_c3_c4 = (((-common*d_Rb2_dV_c3_c4/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_c3_c1 = (((-common*d_Rb2_dV_c3_c1/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_c4_c1 = (((-common*d_Rb2_dV_c4_c1/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_b1_b2 = ((((common/Rb2)*(4.0*d_eVb1b2_dV_b1_b2))+((-common*d_Rb2_dV_b1_b2/Rb2/Rb2)*((4.0*eVb1b2)+5.0)))*0.33333333333333333333);
    d_powerRBV_dV_b_b1 = (((-common*d_Rb2_dV_b_b1/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_b_c = (((-common*d_Rb2_dV_b_c/Rb2/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    d_powerRBV_dV_dt_GND = ((((common/Rb2)*(4.0*d_eVb1b2_dV_dt_GND))+(((Rb2*d_common_dV_dt_GND-common*d_Rb2_dV_dt_GND)/Rb2/Rb2)*((4.0*eVb1b2)+5.0)))*0.33333333333333333333);
    powerRBV = (((common/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);

    d_In_N_dV_c1_c2 = ((qBI*d_Ir_dV_c1_c2-(If+Ir)*d_qBI_dV_c1_c2)/qBI/qBI);
    d_In_N_dV_b2_c1 = ((qBI*d_Ir_dV_b2_c1-(If+Ir)*d_qBI_dV_b2_c1)/qBI/qBI);
    d_In_N_dV_b2_c2 = ((qBI*d_Ir_dV_b2_c2-(If+Ir)*d_qBI_dV_b2_c2)/qBI/qBI);
    d_In_N_dV_b2_e1 = ((qBI*d_If_dV_b2_e1-(If+Ir)*d_qBI_dV_b2_e1)/qBI/qBI);
    d_In_N_dV_dt_GND = ((qBI*(d_If_dV_dt_GND+d_Ir_dV_dt_GND)-(If+Ir)*d_qBI_dV_dt_GND)/qBI/qBI);
    In_N = ((If+Ir)/qBI);
    {
      double value_fabs_0 = fabs(In_N);
      double  deriv_fabs_0_d0 = (((In_N)>=0)?(+1.0):(-1.0));

      d_powerCCS_dV_c1_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_In_N_dV_c1_c2)));
      d_powerCCS_dV_b2_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_In_N_dV_b2_c1)));
      d_powerCCS_dV_b2_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_In_N_dV_b2_c2)));
      d_powerCCS_dV_b2_e1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_In_N_dV_b2_e1)));
      d_powerCCS_dV_dt_GND = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_In_N_dV_dt_GND)));
      powerCCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    if (((model_.KAVL)>0))
    {
      {
        double value_fabs_0 = fabs((Iavl/In_N));
        double  deriv_fabs_0_d0 = ((((Iavl/In_N))>=0)?(+1.0):(-1.0));

        d_Gem_N_dV_b2_e1 = (deriv_fabs_0_d0*(((In_N*d_Iavl_dV_b2_e1-Iavl*d_In_N_dV_b2_e1)/In_N/In_N)));
        d_Gem_N_dV_c3_c4 = (deriv_fabs_0_d0*((d_Iavl_dV_c3_c4/In_N)));
        d_Gem_N_dV_c3_c1 = (deriv_fabs_0_d0*((d_Iavl_dV_c3_c1/In_N)));
        d_Gem_N_dV_c4_c1 = (deriv_fabs_0_d0*((d_Iavl_dV_c4_c1/In_N)));
        d_Gem_N_dV_b1_b2 = (deriv_fabs_0_d0*((d_Iavl_dV_b1_b2/In_N)));
        d_Gem_N_dV_b_b1 = (deriv_fabs_0_d0*((d_Iavl_dV_b_b1/In_N)));
        d_Gem_N_dV_b_c = (deriv_fabs_0_d0*((d_Iavl_dV_b_c/In_N)));
        d_Gem_N_dV_c1_c2 = (deriv_fabs_0_d0*(((In_N*d_Iavl_dV_c1_c2-Iavl*d_In_N_dV_c1_c2)/In_N/In_N)));
        d_Gem_N_dV_b2_c1 = (deriv_fabs_0_d0*(((In_N*d_Iavl_dV_b2_c1-Iavl*d_In_N_dV_b2_c1)/In_N/In_N)));
        d_Gem_N_dV_b2_c2 = (deriv_fabs_0_d0*(((In_N*d_Iavl_dV_b2_c2-Iavl*d_In_N_dV_b2_c2)/In_N/In_N)));
        d_Gem_N_dV_dt_GND = (deriv_fabs_0_d0*(((In_N*d_Iavl_dV_dt_GND-Iavl*d_In_N_dV_dt_GND)/In_N/In_N)));
        Gem_N = value_fabs_0;
      }
    }
    else
    {

      d_Gem_N_dV_dt_GND = d_Gem_N_dV_b2_c2 = d_Gem_N_dV_b2_c1 = d_Gem_N_dV_c1_c2 = d_Gem_N_dV_b_c = d_Gem_N_dV_b_b1 = d_Gem_N_dV_b1_b2 = d_Gem_N_dV_c4_c1 = d_Gem_N_dV_c3_c1 = d_Gem_N_dV_c3_c4 = d_Gem_N_dV_b2_e1 =  0.0;
      Gem_N = 0.0;
    }

    d_powerIIS_dV_b2_e1 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_b2_e1)+(((2.0*1.6021918e-19)*d_Iavl_dV_b2_e1)*(Gem_N+1)));
    d_powerIIS_dV_c3_c4 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_c3_c4)+(((2.0*1.6021918e-19)*d_Iavl_dV_c3_c4)*(Gem_N+1)));
    d_powerIIS_dV_c3_c1 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_c3_c1)+(((2.0*1.6021918e-19)*d_Iavl_dV_c3_c1)*(Gem_N+1)));
    d_powerIIS_dV_c4_c1 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_c4_c1)+(((2.0*1.6021918e-19)*d_Iavl_dV_c4_c1)*(Gem_N+1)));
    d_powerIIS_dV_b1_b2 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_b1_b2)+(((2.0*1.6021918e-19)*d_Iavl_dV_b1_b2)*(Gem_N+1)));
    d_powerIIS_dV_b_b1 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_b_b1)+(((2.0*1.6021918e-19)*d_Iavl_dV_b_b1)*(Gem_N+1)));
    d_powerIIS_dV_b_c = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_b_c)+(((2.0*1.6021918e-19)*d_Iavl_dV_b_c)*(Gem_N+1)));
    d_powerIIS_dV_c1_c2 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_c1_c2)+(((2.0*1.6021918e-19)*d_Iavl_dV_c1_c2)*(Gem_N+1)));
    d_powerIIS_dV_b2_c1 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_b2_c1)+(((2.0*1.6021918e-19)*d_Iavl_dV_b2_c1)*(Gem_N+1)));
    d_powerIIS_dV_b2_c2 = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_b2_c2)+(((2.0*1.6021918e-19)*d_Iavl_dV_b2_c2)*(Gem_N+1)));
    d_powerIIS_dV_dt_GND = ((((2.0*1.6021918e-19)*Iavl)*d_Gem_N_dV_dt_GND)+(((2.0*1.6021918e-19)*d_Iavl_dV_dt_GND)*(Gem_N+1)));
    powerIIS = (((2.0*1.6021918e-19)*Iavl)*(Gem_N+1));
    if ((In_N>0.0))
    {

      d_Taub_N_dV_c1_c2 = ((In_N*(d_Qbe_dV_c1_c2+d_Qbc_dV_c1_c2)-(Qbe+Qbc)*d_In_N_dV_c1_c2)/In_N/In_N);
      d_Taub_N_dV_b2_c1 = ((In_N*(d_Qbe_dV_b2_c1+d_Qbc_dV_b2_c1)-(Qbe+Qbc)*d_In_N_dV_b2_c1)/In_N/In_N);
      d_Taub_N_dV_b2_c2 = ((In_N*(d_Qbe_dV_b2_c2+d_Qbc_dV_b2_c2)-(Qbe+Qbc)*d_In_N_dV_b2_c2)/In_N/In_N);
      d_Taub_N_dV_c3_c4 = ((d_Qbe_dV_c3_c4+d_Qbc_dV_c3_c4)/In_N);
      d_Taub_N_dV_c3_c1 = ((d_Qbe_dV_c3_c1+d_Qbc_dV_c3_c1)/In_N);
      d_Taub_N_dV_c4_c1 = ((d_Qbe_dV_c4_c1+d_Qbc_dV_c4_c1)/In_N);
      d_Taub_N_dV_b1_b2 = ((d_Qbe_dV_b1_b2+d_Qbc_dV_b1_b2)/In_N);
      d_Taub_N_dV_b_b1 = ((d_Qbe_dV_b_b1+d_Qbc_dV_b_b1)/In_N);
      d_Taub_N_dV_b_c = ((d_Qbe_dV_b_c+d_Qbc_dV_b_c)/In_N);
      d_Taub_N_dV_b2_e1 = ((In_N*(d_Qbe_dV_b2_e1+d_Qbc_dV_b2_e1)-(Qbe+Qbc)*d_In_N_dV_b2_e1)/In_N/In_N);
      d_Taub_N_dV_dt_GND = ((In_N*(d_Qbe_dV_dt_GND+d_Qbc_dV_dt_GND)-(Qbe+Qbc)*d_In_N_dV_dt_GND)/In_N/In_N);
      Taub_N = ((Qbe+Qbc)/In_N);
    }
    else
    {

      d_Taub_N_dV_c1_c2 = (((TAUB_T*q1Q)*d_qBI_dV_c1_c2)+((TAUB_T*d_q1Q_dV_c1_c2)*qBI));
      d_Taub_N_dV_b2_c1 = (((TAUB_T*q1Q)*d_qBI_dV_b2_c1)+((TAUB_T*d_q1Q_dV_b2_c1)*qBI));
      d_Taub_N_dV_b2_c2 = (((TAUB_T*q1Q)*d_qBI_dV_b2_c2)+((TAUB_T*d_q1Q_dV_b2_c2)*qBI));
      d_Taub_N_dV_b2_e1 = (((TAUB_T*q1Q)*d_qBI_dV_b2_e1)+((TAUB_T*d_q1Q_dV_b2_e1)*qBI));
      d_Taub_N_dV_c3_c4 = ((TAUB_T*d_q1Q_dV_c3_c4)*qBI);
      d_Taub_N_dV_c3_c1 = ((TAUB_T*d_q1Q_dV_c3_c1)*qBI);
      d_Taub_N_dV_c4_c1 = ((TAUB_T*d_q1Q_dV_c4_c1)*qBI);
      d_Taub_N_dV_b1_b2 = ((TAUB_T*d_q1Q_dV_b1_b2)*qBI);
      d_Taub_N_dV_b_b1 = ((TAUB_T*d_q1Q_dV_b_b1)*qBI);
      d_Taub_N_dV_b_c = ((TAUB_T*d_q1Q_dV_b_c)*qBI);
      d_Taub_N_dV_dt_GND = (((TAUB_T*q1Q)*d_qBI_dV_dt_GND)+(((TAUB_T*d_q1Q_dV_dt_GND)+(d_TAUB_T_dV_dt_GND*q1Q))*qBI));
      Taub_N = ((TAUB_T*q1Q)*qBI);
    }
    if (((model_.KC)==1))
    {

      d_taun_dV_c1_c2 = ((model_.XQB)*d_Taub_N_dV_c1_c2);
      d_taun_dV_b2_c1 = ((model_.XQB)*d_Taub_N_dV_b2_c1);
      d_taun_dV_b2_c2 = ((model_.XQB)*d_Taub_N_dV_b2_c2);
      d_taun_dV_c3_c4 = ((model_.XQB)*d_Taub_N_dV_c3_c4);
      d_taun_dV_c3_c1 = ((model_.XQB)*d_Taub_N_dV_c3_c1);
      d_taun_dV_c4_c1 = ((model_.XQB)*d_Taub_N_dV_c4_c1);
      d_taun_dV_b1_b2 = ((model_.XQB)*d_Taub_N_dV_b1_b2);
      d_taun_dV_b_b1 = ((model_.XQB)*d_Taub_N_dV_b_b1);
      d_taun_dV_b_c = ((model_.XQB)*d_Taub_N_dV_b_c);
      d_taun_dV_b2_e1 = ((model_.XQB)*d_Taub_N_dV_b2_e1);
      d_taun_dV_dt_GND = ((model_.XQB)*d_Taub_N_dV_dt_GND);
      taun = ((model_.XQB)*Taub_N);
    }
    else
    {
      if (((model_.KC)==2))
      {

        d_taun_dV_c1_c2 = ((model_.FTAUN)*d_Taub_N_dV_c1_c2);
        d_taun_dV_b2_c1 = ((model_.FTAUN)*d_Taub_N_dV_b2_c1);
        d_taun_dV_b2_c2 = ((model_.FTAUN)*d_Taub_N_dV_b2_c2);
        d_taun_dV_c3_c4 = ((model_.FTAUN)*d_Taub_N_dV_c3_c4);
        d_taun_dV_c3_c1 = ((model_.FTAUN)*d_Taub_N_dV_c3_c1);
        d_taun_dV_c4_c1 = ((model_.FTAUN)*d_Taub_N_dV_c4_c1);
        d_taun_dV_b1_b2 = ((model_.FTAUN)*d_Taub_N_dV_b1_b2);
        d_taun_dV_b_b1 = ((model_.FTAUN)*d_Taub_N_dV_b_b1);
        d_taun_dV_b_c = ((model_.FTAUN)*d_Taub_N_dV_b_c);
        d_taun_dV_b2_e1 = ((model_.FTAUN)*d_Taub_N_dV_b2_e1);
        d_taun_dV_dt_GND = ((model_.FTAUN)*d_Taub_N_dV_dt_GND);
        taun = ((model_.FTAUN)*Taub_N);
      }
      else
      {

        d_taun_dV_dt_GND = d_taun_dV_b2_e1 = d_taun_dV_b_c = d_taun_dV_b_b1 = d_taun_dV_b1_b2 = d_taun_dV_c4_c1 = d_taun_dV_c3_c1 = d_taun_dV_c3_c4 = d_taun_dV_b2_c2 = d_taun_dV_b2_c1 = d_taun_dV_c1_c2 =  0.0;
        taun = 0;
      }
    }
    {
      double value_fabs_0 = fabs(Ib1);
      double value_fabs_1 = fabs(Ib2);
      double value_fabs_2 = fabs(Izteb);
      double  deriv_fabs_0_d0 = (((Ib1)>=0)?(+1.0):(-1.0));
      double  deriv_fabs_1_d0 = (((Ib2)>=0)?(+1.0):(-1.0));
      double  deriv_fabs_2_d0 = (((Izteb)>=0)?(+1.0):(-1.0));

      d_powerFBCS_dV_b2_e1 = ((2.0*1.6021918e-19)*(((deriv_fabs_0_d0*(d_Ib1_dV_b2_e1))+(deriv_fabs_1_d0*(d_Ib2_dV_b2_e1)))+(deriv_fabs_2_d0*(d_Izteb_dV_b2_e1))));
      d_powerFBCS_dV_dt_GND = ((2.0*1.6021918e-19)*(((deriv_fabs_0_d0*(d_Ib1_dV_dt_GND))+(deriv_fabs_1_d0*(d_Ib2_dV_dt_GND)))+(deriv_fabs_2_d0*(d_Izteb_dV_dt_GND))));
      d_powerFBCS_dV_c1_c2 = ((2.0*1.6021918e-19)*((deriv_fabs_0_d0*(d_Ib1_dV_c1_c2))+(deriv_fabs_2_d0*(d_Izteb_dV_c1_c2))));
      d_powerFBCS_dV_b2_c1 = ((2.0*1.6021918e-19)*((deriv_fabs_0_d0*(d_Ib1_dV_b2_c1))+(deriv_fabs_2_d0*(d_Izteb_dV_b2_c1))));
      d_powerFBCS_dV_b2_c2 = ((2.0*1.6021918e-19)*((deriv_fabs_0_d0*(d_Ib1_dV_b2_c2))+(deriv_fabs_2_d0*(d_Izteb_dV_b2_c2))));
      powerFBCS = ((2.0*1.6021918e-19)*((value_fabs_0+value_fabs_1)+value_fabs_2));
    }
    {
      double value_fabs_0 = fabs(Ib1);
      double value_pow_1 = pow((value_fabs_0/(1-(model_.XIBI))),(model_.AF));
      double  deriv_fabs_0_d0 = (((Ib1)>=0)?(+1.0):(-1.0));
      double  deriv_pow_1_d0 = (((value_fabs_0/(1-(model_.XIBI))) == 0.0)?0.0:(value_pow_1*(model_.AF)/(value_fabs_0/(1-(model_.XIBI)))));

      d_powerFBC1fB1_dV_b2_e1 = (((1.0-(model_.XIBI))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Ib1_dV_b2_e1))/(1-(model_.XIBI))))))*KF_M);
      d_powerFBC1fB1_dV_dt_GND = (((1.0-(model_.XIBI))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Ib1_dV_dt_GND))/(1-(model_.XIBI))))))*KF_M);
      d_powerFBC1fB1_dV_c1_c2 = (((1.0-(model_.XIBI))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Ib1_dV_c1_c2))/(1-(model_.XIBI))))))*KF_M);
      d_powerFBC1fB1_dV_b2_c1 = (((1.0-(model_.XIBI))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Ib1_dV_b2_c1))/(1-(model_.XIBI))))))*KF_M);
      d_powerFBC1fB1_dV_b2_c2 = (((1.0-(model_.XIBI))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Ib1_dV_b2_c2))/(1-(model_.XIBI))))))*KF_M);
      powerFBC1fB1 = (((1.0-(model_.XIBI))*value_pow_1)*KF_M);
    }
    exponentFBC1fB2 = ((2.0*((model_.MLF)-1.0))+((model_.AF)*(2.0-(model_.MLF))));
    {
      double value_fabs_0 = fabs(Ib2);
      double value_pow_1 = pow(value_fabs_0,exponentFBC1fB2);
      double  deriv_fabs_0_d0 = (((Ib2)>=0)?(+1.0):(-1.0));
      double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*exponentFBC1fB2/value_fabs_0));

      d_powerFBC1fB2_dV_b2_e1 = (KFN_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib2_dV_b2_e1)))));
      d_powerFBC1fB2_dV_dt_GND = (KFN_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib2_dV_dt_GND)))));
      powerFBC1fB2 = (KFN_M*value_pow_1);
    }
    {
      double value_fabs_0 = fabs(Ib1_s);
      double  deriv_fabs_0_d0 = (((Ib1_s)>=0)?(+1.0):(-1.0));

      d_powerEBSCS_dV_b1_e1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib1_s_dV_b1_e1)));
      d_powerEBSCS_dV_dt_GND = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib1_s_dV_dt_GND)));
      powerEBSCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    if (((model_.XIBI)==0))
    {

      d_powerEBSC1f_dV_dt_GND = d_powerEBSC1f_dV_b1_e1 =  0.0;
      powerEBSC1f = 0.0;
    }
    else
    {
      {
        double value_fabs_0 = fabs((Ib1_s/(model_.XIBI)));
        double value_pow_1 = pow(value_fabs_0,(model_.AF));
        double  deriv_fabs_0_d0 = ((((Ib1_s/(model_.XIBI)))>=0)?(+1.0):(-1.0));
        double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.AF)/value_fabs_0));

        d_powerEBSC1f_dV_b1_e1 = ((KF_M*(model_.XIBI))*(deriv_pow_1_d0*((deriv_fabs_0_d0*((d_Ib1_s_dV_b1_e1/(model_.XIBI)))))));
        d_powerEBSC1f_dV_dt_GND = ((KF_M*(model_.XIBI))*(deriv_pow_1_d0*((deriv_fabs_0_d0*((d_Ib1_s_dV_dt_GND/(model_.XIBI)))))));
        powerEBSC1f = ((KF_M*(model_.XIBI))*value_pow_1);
      }
    }
    {
      double value_fabs_0 = fabs(Ib3);
      double  deriv_fabs_0_d0 = (((Ib3)>=0)?(+1.0):(-1.0));

      d_powerRBCS_dV_b2_e1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib3_dV_b2_e1)));
      d_powerRBCS_dV_c4_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib3_dV_c4_c1)));
      d_powerRBCS_dV_c1_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib3_dV_c1_c2)));
      d_powerRBCS_dV_b2_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib3_dV_b2_c2)));
      d_powerRBCS_dV_b1_b2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib3_dV_b1_b2)));
      d_powerRBCS_dV_dt_GND = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Ib3_dV_dt_GND)));
      powerRBCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    {
      double value_fabs_0 = fabs(Ib3);
      double value_pow_1 = pow(value_fabs_0,(model_.AF));
      double  deriv_fabs_0_d0 = (((Ib3)>=0)?(+1.0):(-1.0));
      double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.AF)/value_fabs_0));

      d_powerRBC1f_dV_b2_e1 = (KF_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib3_dV_b2_e1)))));
      d_powerRBC1f_dV_c4_c1 = (KF_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib3_dV_c4_c1)))));
      d_powerRBC1f_dV_c1_c2 = (KF_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib3_dV_c1_c2)))));
      d_powerRBC1f_dV_b2_c2 = (KF_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib3_dV_b2_c2)))));
      d_powerRBC1f_dV_b1_b2 = (KF_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib3_dV_b1_b2)))));
      d_powerRBC1f_dV_dt_GND = (KF_M*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Ib3_dV_dt_GND)))));
      powerRBC1f = (KF_M*value_pow_1);
    }
    {
      double value_fabs_0 = fabs(Iex);
      double  deriv_fabs_0_d0 = (((Iex)>=0)?(+1.0):(-1.0));

      d_powerExCS_dV_c4_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Iex_dV_c4_c1)));
      d_powerExCS_dV_c1_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Iex_dV_c1_c2)));
      d_powerExCS_dV_b2_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Iex_dV_b2_c2)));
      d_powerExCS_dV_b1_b2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Iex_dV_b1_b2)));
      d_powerExCS_dV_dt_GND = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Iex_dV_dt_GND)));
      powerExCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    {
      double value_fabs_0 = fabs(Iex);
      double value_pow_1 = pow((value_fabs_0/(1-((model_.EXMOD)*(model_.XEXT)))),(model_.AF));
      double  deriv_fabs_0_d0 = (((Iex)>=0)?(+1.0):(-1.0));
      double  deriv_pow_1_d0 = (((value_fabs_0/(1-((model_.EXMOD)*(model_.XEXT)))) == 0.0)?0.0:(value_pow_1*(model_.AF)/(value_fabs_0/(1-((model_.EXMOD)*(model_.XEXT))))));

      d_powerExC1f_dV_c4_c1 = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Iex_dV_c4_c1))/(1-((model_.EXMOD)*(model_.XEXT)))))));
      d_powerExC1f_dV_c1_c2 = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Iex_dV_c1_c2))/(1-((model_.EXMOD)*(model_.XEXT)))))));
      d_powerExC1f_dV_b2_c2 = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Iex_dV_b2_c2))/(1-((model_.EXMOD)*(model_.XEXT)))))));
      d_powerExC1f_dV_b1_b2 = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Iex_dV_b1_b2))/(1-((model_.EXMOD)*(model_.XEXT)))))));
      d_powerExC1f_dV_dt_GND = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_Iex_dV_dt_GND))/(1-((model_.EXMOD)*(model_.XEXT)))))));
      powerExC1f = ((KF_M*(1-((model_.EXMOD)*(model_.XEXT))))*value_pow_1);
    }
    {
      double value_fabs_0 = fabs(XIex);
      double  deriv_fabs_0_d0 = (((XIex)>=0)?(+1.0):(-1.0));

      d_powerExCSMOD_dV_s_c1 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_s_c1)))*(model_.EXMOD));
      d_powerExCSMOD_dV_c1_c2 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_c1_c2)))*(model_.EXMOD));
      d_powerExCSMOD_dV_b2_c1 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_b2_c1)))*(model_.EXMOD));
      d_powerExCSMOD_dV_b2_c2 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_b2_c2)))*(model_.EXMOD));
      d_powerExCSMOD_dV_b2_e1 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_b2_e1)))*(model_.EXMOD));
      d_powerExCSMOD_dV_c3_c4 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_c3_c4)))*(model_.EXMOD));
      d_powerExCSMOD_dV_c3_c1 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_c3_c1)))*(model_.EXMOD));
      d_powerExCSMOD_dV_c4_c1 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_c4_c1)))*(model_.EXMOD));
      d_powerExCSMOD_dV_b1_b2 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_b1_b2)))*(model_.EXMOD));
      d_powerExCSMOD_dV_b_b1 = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_b_b1)))*(model_.EXMOD));
      d_powerExCSMOD_dV_b_c = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_b_c)))*(model_.EXMOD));
      d_powerExCSMOD_dV_dt_GND = (((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIex_dV_dt_GND)))*(model_.EXMOD));
      powerExCSMOD = (((2.0*1.6021918e-19)*value_fabs_0)*(model_.EXMOD));
    }
    if (((model_.XEXT)==0.0))
    {

      d_powerExC1fMOD_dV_dt_GND = d_powerExC1fMOD_dV_b_c = d_powerExC1fMOD_dV_b_b1 = d_powerExC1fMOD_dV_b1_b2 = d_powerExC1fMOD_dV_c4_c1 = d_powerExC1fMOD_dV_c3_c1 = d_powerExC1fMOD_dV_c3_c4 = d_powerExC1fMOD_dV_b2_e1 = d_powerExC1fMOD_dV_b2_c2 = d_powerExC1fMOD_dV_b2_c1 = d_powerExC1fMOD_dV_c1_c2 = d_powerExC1fMOD_dV_s_c1 =  0.0;
      powerExC1fMOD = 0.0;
    }
    else
    {
      {
        double value_fabs_0 = fabs(XIex);
        double value_pow_1 = pow((value_fabs_0/(model_.XEXT)),(model_.AF));
        double  deriv_fabs_0_d0 = (((XIex)>=0)?(+1.0):(-1.0));
        double  deriv_pow_1_d0 = (((value_fabs_0/(model_.XEXT)) == 0.0)?0.0:(value_pow_1*(model_.AF)/(value_fabs_0/(model_.XEXT))));

        d_powerExC1fMOD_dV_s_c1 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_s_c1))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_c1_c2 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_c1_c2))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_b2_c1 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_b2_c1))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_b2_c2 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_b2_c2))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_b2_e1 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_b2_e1))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_c3_c4 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_c3_c4))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_c3_c1 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_c3_c1))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_c4_c1 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_c4_c1))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_b1_b2 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_b1_b2))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_b_b1 = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_b_b1))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_b_c = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_b_c))/(model_.XEXT)))));
        d_powerExC1fMOD_dV_dt_GND = (((KF_M*(model_.EXMOD))*(model_.XEXT))*(deriv_pow_1_d0*(((deriv_fabs_0_d0*(d_XIex_dV_dt_GND))/(model_.XEXT)))));
        powerExC1fMOD = (((KF_M*(model_.EXMOD))*(model_.XEXT))*value_pow_1);
      }
    }
    {
      double value_fabs_0 = fabs(Isub);
      double  deriv_fabs_0_d0 = (((Isub)>=0)?(+1.0):(-1.0));

      d_powerSubsCS_B1S_dV_s_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Isub_dV_s_c1)));
      d_powerSubsCS_B1S_dV_c4_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Isub_dV_c4_c1)));
      d_powerSubsCS_B1S_dV_c1_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Isub_dV_c1_c2)));
      d_powerSubsCS_B1S_dV_b2_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Isub_dV_b2_c2)));
      d_powerSubsCS_B1S_dV_b1_b2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Isub_dV_b1_b2)));
      d_powerSubsCS_B1S_dV_dt_GND = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_Isub_dV_dt_GND)));
      powerSubsCS_B1S = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    {
      double value_fabs_0 = fabs(XIsub);
      double  deriv_fabs_0_d0 = (((XIsub)>=0)?(+1.0):(-1.0));

      d_powerSubsCS_BS_dV_s_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_s_c1)));
      d_powerSubsCS_BS_dV_c1_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_c1_c2)));
      d_powerSubsCS_BS_dV_b2_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_b2_c1)));
      d_powerSubsCS_BS_dV_b2_c2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_b2_c2)));
      d_powerSubsCS_BS_dV_b2_e1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_b2_e1)));
      d_powerSubsCS_BS_dV_c3_c4 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_c3_c4)));
      d_powerSubsCS_BS_dV_c3_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_c3_c1)));
      d_powerSubsCS_BS_dV_c4_c1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_c4_c1)));
      d_powerSubsCS_BS_dV_b1_b2 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_b1_b2)));
      d_powerSubsCS_BS_dV_b_b1 = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_b_b1)));
      d_powerSubsCS_BS_dV_b_c = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_b_c)));
      d_powerSubsCS_BS_dV_dt_GND = ((2.0*1.6021918e-19)*(deriv_fabs_0_d0*(d_XIsub_dV_dt_GND)));
      powerSubsCS_BS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    // I(noi,GND) <+ (white_noise(powerCCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[0]= powerCCS;
    }
    // I(noi,GND) <+ (V(noi,GND))
    staticContributions[admsNodeID_noi] += (probeVars[admsProbeID_V_noi_GND]);
    d_staticContributions[admsNodeID_noi][admsProbeID_V_noi_GND] += d_probeVars[admsProbeID_V_noi_GND][admsProbeID_V_noi_GND];
    // I(b2,e1) <+ ((taun*ddt(V(noi,GND))))
    {
      double contribTemp;
      double d_contribTemp_dV_noi_GND;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (taun*((probeVars[admsProbeID_V_noi_GND])));
      d_contribTemp_dV_noi_GND = (taun*(d_probeVars[admsProbeID_V_noi_GND][admsProbeID_V_noi_GND]));
      d_contribTemp_dV_c1_c2 = ((taun*(0.0))+(d_taun_dV_c1_c2*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_b2_c1 = ((taun*(0.0))+(d_taun_dV_b2_c1*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_b2_c2 = ((taun*(0.0))+(d_taun_dV_b2_c2*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_c3_c4 = ((taun*(0.0))+(d_taun_dV_c3_c4*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_c3_c1 = ((taun*(0.0))+(d_taun_dV_c3_c1*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_c4_c1 = ((taun*(0.0))+(d_taun_dV_c4_c1*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_b1_b2 = ((taun*(0.0))+(d_taun_dV_b1_b2*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_b_b1 = ((taun*(0.0))+(d_taun_dV_b_b1*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_b_c = ((taun*(0.0))+(d_taun_dV_b_c*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_b2_e1 = ((taun*(0.0))+(d_taun_dV_b2_e1*((probeVars[admsProbeID_V_noi_GND]))));
      d_contribTemp_dV_dt_GND = ((taun*(0.0))+(d_taun_dV_dt_GND*((probeVars[admsProbeID_V_noi_GND]))));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_noi_GND] += d_contribTemp_dV_noi_GND;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      dynamicContributions[admsNodeID_e1] -= contribTemp;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_noi_GND] -= d_contribTemp_dV_noi_GND;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_dynamicContributions[admsNodeID_e1][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_dynamic[admsNodeID_b2] += d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
      Jdxp_dynamic[admsNodeID_e1] -= d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2]+d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2];
    }
    // I(c2,b2) <+ ((Gem_N*V(noi,GND)))
    {
      double contribTemp;
      double d_contribTemp_dV_noi_GND;
      double d_contribTemp_dV_b2_e1;
      double d_contribTemp_dV_c3_c4;
      double d_contribTemp_dV_c3_c1;
      double d_contribTemp_dV_c4_c1;
      double d_contribTemp_dV_b1_b2;
      double d_contribTemp_dV_b_b1;
      double d_contribTemp_dV_b_c;
      double d_contribTemp_dV_c1_c2;
      double d_contribTemp_dV_b2_c1;
      double d_contribTemp_dV_b2_c2;
      double d_contribTemp_dV_dt_GND;
      contribTemp= (Gem_N*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_noi_GND = (Gem_N*d_probeVars[admsProbeID_V_noi_GND][admsProbeID_V_noi_GND]);
      d_contribTemp_dV_b2_e1 = (d_Gem_N_dV_b2_e1*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_c3_c4 = (d_Gem_N_dV_c3_c4*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_c3_c1 = (d_Gem_N_dV_c3_c1*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_c4_c1 = (d_Gem_N_dV_c4_c1*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_b1_b2 = (d_Gem_N_dV_b1_b2*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_b_b1 = (d_Gem_N_dV_b_b1*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_b_c = (d_Gem_N_dV_b_c*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_c1_c2 = (d_Gem_N_dV_c1_c2*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_b2_c1 = (d_Gem_N_dV_b2_c1*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_b2_c2 = (d_Gem_N_dV_b2_c2*(probeVars[admsProbeID_V_noi_GND]));
      d_contribTemp_dV_dt_GND = (d_Gem_N_dV_dt_GND*(probeVars[admsProbeID_V_noi_GND]));
      staticContributions[admsNodeID_c2] += contribTemp;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_noi_GND] += d_contribTemp_dV_noi_GND;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1] += d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4] += d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] += d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] += d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2] += d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1] += d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c] += d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2] += d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] += d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] += d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND] += d_contribTemp_dV_dt_GND;
      staticContributions[admsNodeID_b2] -= contribTemp;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_noi_GND] -= d_contribTemp_dV_noi_GND;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1] -= d_contribTemp_dV_b2_e1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4] -= d_contribTemp_dV_c3_c4;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] -= d_contribTemp_dV_c3_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -= d_contribTemp_dV_c4_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] -= d_contribTemp_dV_b1_b2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1] -= d_contribTemp_dV_b_b1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c] -= d_contribTemp_dV_b_c;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2] -= d_contribTemp_dV_c1_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] -= d_contribTemp_dV_b2_c1;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -= d_contribTemp_dV_b2_c2;
      d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND] -= d_contribTemp_dV_dt_GND;

      Jdxp_static[admsNodeID_c2] += d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
      Jdxp_static[admsNodeID_b2] -= d_contribTemp_dV_b1_b2*probeDiffs[admsProbeID_V_b1_b2]*d_probeVars[admsProbeID_V_b1_b2][admsProbeID_V_b1_b2]+d_contribTemp_dV_b2_c1*probeDiffs[admsProbeID_V_b2_c1]*d_probeVars[admsProbeID_V_b2_c1][admsProbeID_V_b2_c1]+d_contribTemp_dV_b2_c2*probeDiffs[admsProbeID_V_b2_c2]*d_probeVars[admsProbeID_V_b2_c2][admsProbeID_V_b2_c2];
    }
    // I(c2,e1) <+ (V(noi,GND))
    staticContributions[admsNodeID_c2] += (probeVars[admsProbeID_V_noi_GND]);
    d_staticContributions[admsNodeID_c2][admsProbeID_V_noi_GND] += d_probeVars[admsProbeID_V_noi_GND][admsProbeID_V_noi_GND];
    staticContributions[admsNodeID_e1] -= (probeVars[admsProbeID_V_noi_GND]);
    d_staticContributions[admsNodeID_e1][admsProbeID_V_noi_GND] -= d_probeVars[admsProbeID_V_noi_GND][admsProbeID_V_noi_GND];
    // I(c2,b2) <+ (white_noise(powerIIS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[1]= powerIIS;
    }
    // I(b2,e1) <+ (white_noise(powerFBCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[2]= powerFBCS;
    }
    // I(e,e1) <+ (white_noise(powerREC))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[3]= powerREC;
    }
    // I(b,b1) <+ (white_noise(powerRBC))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[4]= powerRBC;
    }
    // I(b1,b2) <+ (white_noise(powerRBV))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[5]= powerRBV;
    }
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB1,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[6]= powerFBC1fB1;
      noiseContribsExponent[6]= 1;
    }
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB2,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[7]= powerFBC1fB2;
      noiseContribsExponent[7]= 1;
    }
    // I(e1,b1) <+ (white_noise(powerEBSCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[8]= powerEBSCS;
    }
    // I(e1,b1) <+ (flicker_noise(powerEBSC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[9]= powerEBSC1f;
      noiseContribsExponent[9]= 1;
    }
    // I(b1,c4) <+ (white_noise(powerRBCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[10]= powerRBCS;
    }
    // I(b1,c4) <+ (flicker_noise(powerRBC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[11]= powerRBC1f;
      noiseContribsExponent[11]= 1;
    }
    // I(b1,c4) <+ (white_noise(powerExCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[12]= powerExCS;
    }
    // I(b1,c4) <+ (flicker_noise(powerExC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[13]= powerExC1f;
      noiseContribsExponent[13]= 1;
    }
    // I(b,c3) <+ (white_noise(powerExCSMOD))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[14]= powerExCSMOD;
    }
    // I(b,c3) <+ (flicker_noise(powerExC1fMOD,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[15]= powerExC1fMOD;
      noiseContribsExponent[15]= 1;
    }
    // I(b1,s) <+ (white_noise(powerSubsCS_B1S))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[16]= powerSubsCS_B1S;
    }
    // I(b,s) <+ (white_noise(powerSubsCS_BS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[17]= powerSubsCS_BS;
    }
    if (((model_.RCBLX)>0.0))
    {
      if (((model_.RCBLI)>0.0))
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[18]= powerRCCxx;
        }
        // I(c3,c4) <+ (white_noise(powerRCCex))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[19]= powerRCCex;
        }
        // I(c4,c1) <+ (white_noise(powerRCCin))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[20]= powerRCCin;
        }
      }
      else
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[21]= powerRCCxx;
        }
        // I(c3,c1) <+ (white_noise(powerRCCex))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[22]= powerRCCex;
        }
      }
    }
    else
    {
      if (((model_.RCBLI)>0.0))
      {
        // I(c,c4) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[23]= powerRCCxx;
        }
        // I(c4,c1) <+ (white_noise(powerRCCin))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[24]= powerRCCin;
        }
      }
      else
      {
        // I(c,c1) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[25]= powerRCCxx;
        }
      }
    }
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_noi_GND] =  "
                 <<probeVars[admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c3_c1] =  "
                 <<probeVars[admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c3_c4] =  "
                 <<probeVars[admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c4_c1] =  "
                 <<probeVars[admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
                 <<probeVars[admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_b1] =  "
                 <<probeVars[admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_e1] =  "
                 <<probeVars[admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c1_c2] =  "
                 <<probeVars[admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_c1] =  "
                 <<probeVars[admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b1_b2] =  "
                 <<probeVars[admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b1_e1] =  "
                 <<probeVars[admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_e1] =  "
                 <<probeVars[admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_c2] =  "
                 <<probeVars[admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_c1] =  "
                 <<probeVars[admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_dt_GND] =  "
                 <<probeVars[admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c] =  "
                 <<Jdxp_static[admsNodeID_c] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c] =  "
                 <<Jdxp_dynamic[admsNodeID_c] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b] =  "
                 <<Jdxp_static[admsNodeID_b] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b] =  "
                 <<Jdxp_dynamic[admsNodeID_b] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e] =  "
                 <<Jdxp_static[admsNodeID_e] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e] =  "
                 <<Jdxp_dynamic[admsNodeID_e] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_s] =  "
                 <<Jdxp_static[admsNodeID_s] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_s] =  "
                 <<Jdxp_dynamic[admsNodeID_s] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dt] =  "
                 <<staticContributions[admsNodeID_dt] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dt] =  "
                 <<dynamicContributions[admsNodeID_dt] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_dt] =  "
                 <<Jdxp_static[admsNodeID_dt] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_dt] =  "
                 <<Jdxp_dynamic[admsNodeID_dt] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e1] =  "
                 <<staticContributions[admsNodeID_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e1] =  "
                 <<dynamicContributions[admsNodeID_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_e1][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e1] =  "
                 <<Jdxp_static[admsNodeID_e1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e1] =  "
                 <<Jdxp_dynamic[admsNodeID_e1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b1] =  "
                 <<staticContributions[admsNodeID_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b1] =  "
                 <<dynamicContributions[admsNodeID_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b1] =  "
                 <<Jdxp_static[admsNodeID_b1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b1] =  "
                 <<Jdxp_dynamic[admsNodeID_b1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b2] =  "
                 <<staticContributions[admsNodeID_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b2] =  "
                 <<dynamicContributions[admsNodeID_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b2] =  "
                 <<Jdxp_static[admsNodeID_b2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b2] =  "
                 <<Jdxp_dynamic[admsNodeID_b2] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c1] =  "
                 <<staticContributions[admsNodeID_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c1] =  "
                 <<dynamicContributions[admsNodeID_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c1] =  "
                 <<Jdxp_static[admsNodeID_c1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c1] =  "
                 <<Jdxp_dynamic[admsNodeID_c1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c2] =  "
                 <<staticContributions[admsNodeID_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c2] =  "
                 <<dynamicContributions[admsNodeID_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_c2][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c2] =  "
                 <<Jdxp_static[admsNodeID_c2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c2] =  "
                 <<Jdxp_dynamic[admsNodeID_c2] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c3] =  "
                 <<staticContributions[admsNodeID_c3] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c3] =  "
                 <<dynamicContributions[admsNodeID_c3] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_c3][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c3] =  "
                 <<Jdxp_static[admsNodeID_c3] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c3] =  "
                 <<Jdxp_dynamic[admsNodeID_c3] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c4] =  "
                 <<staticContributions[admsNodeID_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c4] =  "
                 <<dynamicContributions[admsNodeID_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_c4][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c4] =  "
                 <<Jdxp_static[admsNodeID_c4] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c4] =  "
                 <<Jdxp_dynamic[admsNodeID_c4] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_noi] =  "
                 <<staticContributions[admsNodeID_noi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND) =  " <<d_staticContributions[admsNodeID_noi][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_noi] =  "
                 <<dynamicContributions[admsNodeID_noi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_noi_GND) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_noi_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_c3_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_c3_c4] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_c4_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b_b1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_e_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_c1_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_s_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b1_b2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b1_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b2_e1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b2_c2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_b2_c1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_dt_GND) =  " <<d_dynamicContributions[admsNodeID_noi][admsProbeID_V_dt_GND] << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_noi] =  "
                 <<Jdxp_static[admsNodeID_noi] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_noi] =  "
                 <<Jdxp_dynamic[admsNodeID_noi] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 13; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 26;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_noi_GND");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_noi;
  noiseData.li_Neg[0]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c2_b2");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_c2;
  noiseData.li_Neg[1]=li_b2;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b2_e1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_b2;
  noiseData.li_Neg[2]=li_e1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_e_e1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_e;
  noiseData.li_Neg[3]=li_e1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_b1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_b;
  noiseData.li_Neg[4]=li_b1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b1_b2");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_b1;
  noiseData.li_Neg[5]=li_b2;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_b2_e1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_b2;
  noiseData.li_Neg[6]=li_e1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_b2_e1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_b2;
  noiseData.li_Neg[7]=li_e1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_e1_b1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_e1;
  noiseData.li_Neg[8]=li_b1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_e1_b1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_e1;
  noiseData.li_Neg[9]=li_b1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b1_c4");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_b1;
  noiseData.li_Neg[10]=li_c4;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_b1_c4");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_b1;
  noiseData.li_Neg[11]=li_c4;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b1_c4");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_b1;
  noiseData.li_Neg[12]=li_c4;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_b1_c4");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_b1;
  noiseData.li_Neg[13]=li_c4;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_c3");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_b;
  noiseData.li_Neg[14]=li_c3;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_b_c3");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[15]=theNoiseName;
  noiseData.li_Pos[15]=li_b;
  noiseData.li_Neg[15]=li_c3;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b1_s");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[16]=theNoiseName;
  noiseData.li_Pos[16]=li_b1;
  noiseData.li_Neg[16]=li_s;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_s");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[17]=theNoiseName;
  noiseData.li_Pos[17]=li_b;
  noiseData.li_Neg[17]=li_s;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c_c3");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[18]=theNoiseName;
  noiseData.li_Pos[18]=li_c;
  noiseData.li_Neg[18]=li_c3;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c3_c4");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[19]=theNoiseName;
  noiseData.li_Pos[19]=li_c3;
  noiseData.li_Neg[19]=li_c4;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c4_c1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[20]=theNoiseName;
  noiseData.li_Pos[20]=li_c4;
  noiseData.li_Neg[20]=li_c1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c_c3");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[21]=theNoiseName;
  noiseData.li_Pos[21]=li_c;
  noiseData.li_Neg[21]=li_c3;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c3_c1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[22]=theNoiseName;
  noiseData.li_Pos[22]=li_c3;
  noiseData.li_Neg[22]=li_c1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c_c4");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[23]=theNoiseName;
  noiseData.li_Pos[23]=li_c;
  noiseData.li_Neg[23]=li_c4;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c4_c1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[24]=theNoiseName;
  noiseData.li_Pos[24]=li_c4;
  noiseData.li_Neg[24]=li_c1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_c_c1");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[25]=theNoiseName;
  noiseData.li_Pos[25]=li_c;
  noiseData.li_Neg[25]=li_c1;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];

  noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];

  noiseData.noiseDens[7] /= pow(noiseData.freq,noiseContribsExponent[7]);noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];

  noiseData.noiseDens[9] /= pow(noiseData.freq,noiseContribsExponent[9]);noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];

  noiseData.noiseDens[11] /= pow(noiseData.freq,noiseContribsExponent[11]);noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];

  noiseData.noiseDens[13] /= pow(noiseData.freq,noiseContribsExponent[13]);noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];
  noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
  noiseData.noiseDens[15] = noiseContribsPower[15];

  noiseData.noiseDens[15] /= pow(noiseData.freq,noiseContribsExponent[15]);noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));
  noiseData.noiseDens[16] = noiseContribsPower[16];
  noiseData.lnNoiseDens[16] = std::log(std::max(noiseData.noiseDens[16],N_MINLOG));
  noiseData.noiseDens[17] = noiseContribsPower[17];
  noiseData.lnNoiseDens[17] = std::log(std::max(noiseData.noiseDens[17],N_MINLOG));
  noiseData.noiseDens[18] = noiseContribsPower[18];
  noiseData.lnNoiseDens[18] = std::log(std::max(noiseData.noiseDens[18],N_MINLOG));
  noiseData.noiseDens[19] = noiseContribsPower[19];
  noiseData.lnNoiseDens[19] = std::log(std::max(noiseData.noiseDens[19],N_MINLOG));
  noiseData.noiseDens[20] = noiseContribsPower[20];
  noiseData.lnNoiseDens[20] = std::log(std::max(noiseData.noiseDens[20],N_MINLOG));
  noiseData.noiseDens[21] = noiseContribsPower[21];
  noiseData.lnNoiseDens[21] = std::log(std::max(noiseData.noiseDens[21],N_MINLOG));
  noiseData.noiseDens[22] = noiseContribsPower[22];
  noiseData.lnNoiseDens[22] = std::log(std::max(noiseData.noiseDens[22],N_MINLOG));
  noiseData.noiseDens[23] = noiseContribsPower[23];
  noiseData.lnNoiseDens[23] = std::log(std::max(noiseData.noiseDens[23],N_MINLOG));
  noiseData.noiseDens[24] = noiseContribsPower[24];
  noiseData.lnNoiseDens[24] = std::log(std::max(noiseData.noiseDens[24],N_MINLOG));
  noiseData.noiseDens[25] = noiseContribsPower[25];
  noiseData.lnNoiseDens[25] = std::log(std::max(noiseData.noiseDens[25],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_c1_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1] -d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  (*f_c1_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  (*f_c2_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2];
  (*f_c2_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2];
  (*f_c1_Equ_b2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1];
  (*f_c2_Equ_b2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1];
  (*f_c1_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND];
  (*f_c2_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND];
  (*f_e1_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2];
  (*f_e1_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2];
  (*f_e1_Equ_b2_Node_Ptr) +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1];
  (*f_c2_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1];
  (*f_e1_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_e1][admsProbeID_V_e_e1] -d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1];
  (*f_e1_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND];
  (*f_b1_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_e1];
  (*f_b1_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_e1];
  (*f_e1_Equ_b1_Node_Ptr) +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_e1];
  (*f_b1_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND];
  (*f_b2_Equ_b2_Node_Ptr) +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1];
  (*f_b2_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1];
  (*f_b2_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND];
  (*f_b2_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2];
  (*f_b2_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2];
  (*f_b1_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_s_c1];
  (*f_b1_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_s_c1];
  (*f_s_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1];
  (*f_s_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1];
  (*f_b1_Equ_c4_Node_Ptr) +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1];
  (*f_s_Equ_c4_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1];
  (*f_b1_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2];
  (*f_s_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2];
  (*f_b1_Equ_b2_Node_Ptr) +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2];
  (*f_s_Equ_b2_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2];
  (*f_s_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2];
  (*f_s_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_dt_GND];
  (*f_b_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1];
  (*f_b_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1];
  (*f_b_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2];
  (*f_b_Equ_b2_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1];
  (*f_b_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1];
  (*f_s_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b2_e1];
  (*f_b_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  (*f_b_Equ_c4_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  (*f_s_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c4];
  (*f_b_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2];
  (*f_b_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1];
  (*f_s_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_s][admsProbeID_V_b_b1];
  (*f_b_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_c];
  (*f_s_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b_c];
  (*f_b_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND];
  (*f_c1_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1];
  (*f_b1_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c4];
  (*f_b2_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  (*f_b2_Equ_c4_Node_Ptr) +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  (*f_b1_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1];
  (*f_b2_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1];
  (*f_b2_Equ_b1_Node_Ptr) +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] -d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1];
  (*f_b1_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b_c];
  (*f_b2_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c];
  (*f_c2_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  (*f_c2_Equ_c4_Node_Ptr) +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  (*f_c2_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2];
  (*f_c2_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1];
  (*f_c2_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c];
  (*f_e_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_dt_GND];
  (*f_e_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_e_e1];
  (*f_e_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_e_e1];
  (*f_e1_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_e_e1];
  (*f_dt_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_dt_GND];
  (*f_dt_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_c1];
  (*f_dt_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_c1];
  (*f_dt_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_e1];
  (*f_dt_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_e1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_e_e1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_e1];
  (*f_dt_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_e_e1];
  (*f_dt_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c4];
  (*f_dt_Equ_c4_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c4];
  (*f_dt_Equ_b2_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_b2];
  (*f_dt_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_b1];
  (*f_dt_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_c];
  (*f_dt_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c1_c2];
  (*f_c1_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1];
  (*f_c1_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2];
  (*f_c1_Equ_c4_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1];
  (*f_c1_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4];
  (*f_c1_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1];
  (*f_c1_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c];
  (*f_c_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1];
  (*f_c_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b_c];
  (*f_c3_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  (*f_c3_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  (*f_c3_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2];
  (*f_c3_Equ_b2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c1];
  (*f_c3_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_e1];
  (*f_c3_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  (*f_c3_Equ_c4_Node_Ptr) +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  (*f_c3_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2];
  (*f_c3_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1];
  (*f_c3_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c];
  (*f_c3_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND];
  (*f_c_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_dt_GND];
  (*f_c_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4];
  (*f_c_Equ_c4_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4];
  (*f_c_Equ_c1_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1];
  (*f_c_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2];
  (*f_c_Equ_b2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2];
  (*f_c_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2];
  (*f_c4_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND];
  (*f_c4_Equ_c4_Node_Ptr) +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1];
  (*f_c4_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_c4][admsProbeID_V_s_c1] -d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1];
  (*f_c4_Equ_b2_Node_Ptr) +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1];
  (*f_c4_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1];
  (*f_c4_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2];
  (*f_c4_Equ_b1_Node_Ptr) +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2];
  (*f_c4_Equ_c3_Node_Ptr) +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4];
  (*f_c4_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_s_c1];
  (*f_c4_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1];
  (*f_c4_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c];
  (*f_noi_Equ_c1_Node_Ptr) +=  -d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_noi][admsProbeID_V_c1_c2];
  (*f_noi_Equ_c2_Node_Ptr) +=  -d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_noi][admsProbeID_V_c1_c2];
  (*f_noi_Equ_b2_Node_Ptr) +=  +d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c1];
  (*f_noi_Equ_e1_Node_Ptr) +=  -d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_e1];
  (*f_noi_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_noi][admsProbeID_V_dt_GND];
  (*f_noi_Equ_noi_Node_Ptr) +=  +d_staticContributions[admsNodeID_noi][admsProbeID_V_noi_GND];
  (*f_b2_Equ_noi_Node_Ptr) +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_noi_GND];
  (*f_e1_Equ_noi_Node_Ptr) +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_noi_GND];
  (*f_c2_Equ_noi_Node_Ptr) +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_noi_GND];

#else
  //use the offsets instead of pointers
  dFdx[li_c1][A_c1_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1] -d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  dFdx[li_c1][A_c1_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  dFdx[li_c2][A_c2_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2];
  dFdx[li_c2][A_c2_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c2][admsProbeID_V_c1_c2];
  dFdx[li_c1][A_c1_Equ_b2_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_c1];
  dFdx[li_c2][A_c2_Equ_b2_NodeOffset] +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_c1];
  dFdx[li_c1][A_c1_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_dt_GND];
  dFdx[li_c2][A_c2_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_dt_GND];
  dFdx[li_e1][A_e1_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2];
  dFdx[li_e1][A_e1_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_e1][admsProbeID_V_c1_c2];
  dFdx[li_e1][A_e1_Equ_b2_NodeOffset] +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_c1];
  dFdx[li_c2][A_c2_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b2_e1];
  dFdx[li_e1][A_e1_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_e1][admsProbeID_V_e_e1] -d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -d_staticContributions[admsNodeID_e1][admsProbeID_V_b2_e1];
  dFdx[li_e1][A_e1_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_dt_GND];
  dFdx[li_b1][A_b1_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_e1];
  dFdx[li_b1][A_b1_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_e1];
  dFdx[li_e1][A_e1_Equ_b1_NodeOffset] +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_b1_e1];
  dFdx[li_b1][A_b1_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_dt_GND];
  dFdx[li_b2][A_b2_Equ_b2_NodeOffset] +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1];
  dFdx[li_b2][A_b2_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_e1];
  dFdx[li_b2][A_b2_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_dt_GND];
  dFdx[li_b2][A_b2_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2];
  dFdx[li_b2][A_b2_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_b2][admsProbeID_V_c1_c2];
  dFdx[li_b1][A_b1_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_s_c1];
  dFdx[li_b1][A_b1_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_s_c1];
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1];
  dFdx[li_s][A_s_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_s][admsProbeID_V_s_c1];
  dFdx[li_b1][A_b1_Equ_c4_NodeOffset] +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_b1][admsProbeID_V_c4_c1];
  dFdx[li_s][A_s_Equ_c4_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_s][admsProbeID_V_c4_c1];
  dFdx[li_b1][A_b1_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_b1][admsProbeID_V_c1_c2];
  dFdx[li_s][A_s_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_s][admsProbeID_V_c1_c2];
  dFdx[li_b1][A_b1_Equ_b2_NodeOffset] +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_b1][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b2_c2];
  dFdx[li_s][A_s_Equ_b2_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_s][admsProbeID_V_b2_c2];
  dFdx[li_s][A_s_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_s][admsProbeID_V_b1_b2];
  dFdx[li_s][A_s_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_dt_GND];
  dFdx[li_b][A_b_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1];
  dFdx[li_b][A_b_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_b][admsProbeID_V_s_c1];
  dFdx[li_b][A_b_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_b][admsProbeID_V_c1_c2];
  dFdx[li_b][A_b_Equ_b2_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_b][admsProbeID_V_b2_c1];
  dFdx[li_b][A_b_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b2_e1];
  dFdx[li_s][A_s_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b2_e1];
  dFdx[li_b][A_b_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  dFdx[li_b][A_b_Equ_c4_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  dFdx[li_s][A_s_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_s][admsProbeID_V_c3_c4];
  dFdx[li_b][A_b_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_b][admsProbeID_V_b1_b2];
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_b][admsProbeID_V_b_b1];
  dFdx[li_s][A_s_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_s][admsProbeID_V_b_b1];
  dFdx[li_b][A_b_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_c];
  dFdx[li_s][A_s_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_b_c];
  dFdx[li_b][A_b_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_dt_GND];
  dFdx[li_c1][A_c1_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_s_c1];
  dFdx[li_b1][A_b1_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_b1][admsProbeID_V_c3_c4];
  dFdx[li_b2][A_b2_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  dFdx[li_b2][A_b2_Equ_c4_NodeOffset] +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  dFdx[li_b1][A_b1_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_b1][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_b1][admsProbeID_V_b_b1];
  dFdx[li_b2][A_b2_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1];
  dFdx[li_b2][A_b2_Equ_b1_NodeOffset] +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_b1_b2] -d_staticContributions[admsNodeID_b2][admsProbeID_V_b_b1];
  dFdx[li_b1][A_b1_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_b1][admsProbeID_V_b_c];
  dFdx[li_b2][A_b2_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_b2][admsProbeID_V_b_c];
  dFdx[li_c2][A_c2_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  dFdx[li_c2][A_c2_Equ_c4_NodeOffset] +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  dFdx[li_c2][A_c2_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b1_b2];
  dFdx[li_c2][A_c2_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c2][admsProbeID_V_b_b1];
  dFdx[li_c2][A_c2_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c2][admsProbeID_V_b_c];
  dFdx[li_e][A_e_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_dt_GND];
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_e_e1];
  dFdx[li_e][A_e_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_e_e1];
  dFdx[li_e1][A_e1_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_e_e1];
  dFdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_dt_GND];
  dFdx[li_dt][A_dt_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_c1];
  dFdx[li_dt][A_dt_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_c1];
  dFdx[li_dt][A_dt_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_e1];
  dFdx[li_dt][A_dt_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_e1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_e_e1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_e1];
  dFdx[li_dt][A_dt_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_e_e1];
  dFdx[li_dt][A_dt_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c4];
  dFdx[li_dt][A_dt_Equ_c4_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c3_c4];
  dFdx[li_dt][A_dt_Equ_b2_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b1_b2];
  dFdx[li_dt][A_dt_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_b1];
  dFdx[li_dt][A_dt_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_c];
  dFdx[li_dt][A_dt_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_c1_c2];
  dFdx[li_c1][A_c1_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b2_e1];
  dFdx[li_c1][A_c1_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b1_b2];
  dFdx[li_c1][A_c1_Equ_c4_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_c1][admsProbeID_V_c4_c1];
  dFdx[li_c1][A_c1_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c1][admsProbeID_V_c3_c4];
  dFdx[li_c1][A_c1_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c1][admsProbeID_V_b_b1];
  dFdx[li_c1][A_c1_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c1][admsProbeID_V_b_c];
  dFdx[li_c][A_c_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1];
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b_c];
  dFdx[li_c3][A_c3_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  dFdx[li_c3][A_c3_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  dFdx[li_c3][A_c3_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c3][admsProbeID_V_c1_c2];
  dFdx[li_c3][A_c3_Equ_b2_NodeOffset] +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_c1];
  dFdx[li_c3][A_c3_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b2_e1];
  dFdx[li_c3][A_c3_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  dFdx[li_c3][A_c3_Equ_c4_NodeOffset] +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  dFdx[li_c3][A_c3_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b1_b2];
  dFdx[li_c3][A_c3_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c3][admsProbeID_V_b_b1];
  dFdx[li_c3][A_c3_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c3][admsProbeID_V_b_c];
  dFdx[li_c3][A_c3_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_c3][admsProbeID_V_dt_GND];
  dFdx[li_c][A_c_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_dt_GND];
  dFdx[li_c][A_c_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4];
  dFdx[li_c][A_c_Equ_c4_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c4];
  dFdx[li_c][A_c_Equ_c1_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_c][admsProbeID_V_c4_c1] -d_staticContributions[admsNodeID_c][admsProbeID_V_c3_c1];
  dFdx[li_c][A_c_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c][admsProbeID_V_c1_c2];
  dFdx[li_c][A_c_Equ_b2_NodeOffset] +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c][admsProbeID_V_b2_c2];
  dFdx[li_c][A_c_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c][admsProbeID_V_b1_b2];
  dFdx[li_c4][A_c4_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_dt_GND];
  dFdx[li_c4][A_c4_Equ_c4_NodeOffset] +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4] +d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1];
  dFdx[li_c4][A_c4_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_c4][admsProbeID_V_s_c1] -d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -d_staticContributions[admsNodeID_c4][admsProbeID_V_c4_c1];
  dFdx[li_c4][A_c4_Equ_b2_NodeOffset] +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c1] -d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1];
  dFdx[li_c4][A_c4_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_e1];
  dFdx[li_c4][A_c4_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_c4][admsProbeID_V_c1_c2];
  dFdx[li_c4][A_c4_Equ_b1_NodeOffset] +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b1_b2];
  dFdx[li_c4][A_c4_Equ_c3_NodeOffset] +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c1] +d_staticContributions[admsNodeID_c4][admsProbeID_V_c3_c4];
  dFdx[li_c4][A_c4_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_s_c1];
  dFdx[li_c4][A_c4_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c] +d_staticContributions[admsNodeID_c4][admsProbeID_V_b_b1];
  dFdx[li_c4][A_c4_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c4][admsProbeID_V_b_c];
  dFdx[li_noi][A_noi_Equ_c1_NodeOffset] +=  -d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c1] +d_staticContributions[admsNodeID_noi][admsProbeID_V_c1_c2];
  dFdx[li_noi][A_noi_Equ_c2_NodeOffset] +=  -d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c2] -d_staticContributions[admsNodeID_noi][admsProbeID_V_c1_c2];
  dFdx[li_noi][A_noi_Equ_b2_NodeOffset] +=  +d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_e1] +d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c2] +d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_c1];
  dFdx[li_noi][A_noi_Equ_e1_NodeOffset] +=  -d_staticContributions[admsNodeID_noi][admsProbeID_V_b2_e1];
  dFdx[li_noi][A_noi_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_noi][admsProbeID_V_dt_GND];
  dFdx[li_noi][A_noi_Equ_noi_NodeOffset] +=  +d_staticContributions[admsNodeID_noi][admsProbeID_V_noi_GND];
  dFdx[li_b2][A_b2_Equ_noi_NodeOffset] +=  +d_staticContributions[admsNodeID_b2][admsProbeID_V_noi_GND];
  dFdx[li_e1][A_e1_Equ_noi_NodeOffset] +=  +d_staticContributions[admsNodeID_e1][admsProbeID_V_noi_GND];
  dFdx[li_c2][A_c2_Equ_noi_NodeOffset] +=  +d_staticContributions[admsNodeID_c2][admsProbeID_V_noi_GND];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_c1_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  (*q_c1_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  (*q_c2_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c1];
  (*q_c2_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c1_c2];
  (*q_c1_Equ_b2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1];
  (*q_c2_Equ_b2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_e1] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_b2];
  (*q_c1_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND];
  (*q_c2_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_dt_GND];
  (*q_e1_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1];
  (*q_e1_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2];
  (*q_e1_Equ_b2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2];
  (*q_c2_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_e1];
  (*q_e1_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1];
  (*q_e1_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_dt_GND];
  (*q_b1_Equ_b1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1];
  (*q_b1_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1];
  (*q_e1_Equ_b1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2];
  (*q_b1_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND];
  (*q_b2_Equ_b2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2];
  (*q_b2_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1];
  (*q_b2_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND];
  (*q_b2_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1];
  (*q_b2_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2];
  (*q_b1_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2];
  (*q_s_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c1];
  (*q_s_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c1_c2];
  (*q_b1_Equ_c4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c4];
  (*q_s_Equ_c4_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c4] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c4_c1];
  (*q_b1_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2];
  (*q_s_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c1_c2];
  (*q_b1_Equ_b2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1];
  (*q_s_Equ_b2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c1];
  (*q_s_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_e1];
  (*q_s_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_dt_GND];
  (*q_b_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1];
  (*q_b_Equ_c1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1];
  (*q_b_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2];
  (*q_b_Equ_b2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1];
  (*q_b_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1];
  (*q_s_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_e1];
  (*q_b_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  (*q_b_Equ_c4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  (*q_s_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c4];
  (*q_b_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1];
  (*q_b_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  (*q_s_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_b1];
  (*q_b_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c];
  (*q_s_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c];
  (*q_b_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_dt_GND];
  (*q_c1_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1];
  (*q_b1_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c4];
  (*q_b2_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  (*q_b2_Equ_c4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  (*q_b1_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_b1];
  (*q_b2_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1];
  (*q_b2_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2];
  (*q_b1_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_c];
  (*q_b2_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c];
  (*q_c2_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  (*q_c2_Equ_c4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  (*q_c2_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_b2];
  (*q_c2_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_b1];
  (*q_c2_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_c];
  (*q_e_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  (*q_dt_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_dt][admsProbeID_V_dt_GND];
  (*q_e1_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4];
  (*q_e1_Equ_c4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4];
  (*q_e1_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1];
  (*q_e1_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c];
  (*q_c1_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1];
  (*q_c1_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1];
  (*q_c1_Equ_c4_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1];
  (*q_c1_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4];
  (*q_c1_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1];
  (*q_c1_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c];
  (*q_b_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  (*q_e_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  (*q_c_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c];
  (*q_c_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c];
  (*q_c3_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  (*q_c3_Equ_c1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  (*q_c3_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c1_c2];
  (*q_c3_Equ_b2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c1];
  (*q_c3_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_e1];
  (*q_c3_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  (*q_c3_Equ_c4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  (*q_c3_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_e1];
  (*q_c3_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_b1];
  (*q_c3_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_c];
  (*q_c3_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_dt_GND];
  (*q_c4_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_dt_GND];
  (*q_c4_Equ_c4_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c4] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1];
  (*q_c4_Equ_c1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_s_c1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1];
  (*q_c4_Equ_b2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1];
  (*q_c4_Equ_e1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1];
  (*q_c4_Equ_c2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2];
  (*q_c4_Equ_b1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1];
  (*q_c4_Equ_c3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c4];
  (*q_c4_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_s_c1];
  (*q_c4_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_b1];
  (*q_c4_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_c];
  (*q_b2_Equ_noi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_noi_GND];
  (*q_e1_Equ_noi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_noi_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_c1][A_c1_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  dQdx[li_c1][A_c1_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c1_c2];
  dQdx[li_c2][A_c2_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c1];
  dQdx[li_c2][A_c2_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c1_c2];
  dQdx[li_c1][A_c1_Equ_b2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_c1];
  dQdx[li_c2][A_c2_Equ_b2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_e1] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_b2];
  dQdx[li_c1][A_c1_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_dt_GND];
  dQdx[li_c2][A_c2_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_dt_GND];
  dQdx[li_e1][A_e1_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1];
  dQdx[li_e1][A_e1_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c1_c2];
  dQdx[li_e1][A_e1_Equ_b2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2];
  dQdx[li_c2][A_c2_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b2_e1];
  dQdx[li_e1][A_e1_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b2_e1];
  dQdx[li_e1][A_e1_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_dt_GND];
  dQdx[li_b1][A_b1_Equ_b1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1];
  dQdx[li_b1][A_b1_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1];
  dQdx[li_e1][A_e1_Equ_b1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b1_b2];
  dQdx[li_b1][A_b1_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_dt_GND];
  dQdx[li_b2][A_b2_Equ_b2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2];
  dQdx[li_b2][A_b2_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_e1];
  dQdx[li_b2][A_b2_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_dt_GND];
  dQdx[li_b2][A_b2_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1];
  dQdx[li_b2][A_b2_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c1_c2];
  dQdx[li_b1][A_b1_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2];
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c1];
  dQdx[li_s][A_s_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c1_c2];
  dQdx[li_b1][A_b1_Equ_c4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c4];
  dQdx[li_s][A_s_Equ_c4_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c4] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c4_c1];
  dQdx[li_b1][A_b1_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c1_c2];
  dQdx[li_s][A_s_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_c1_c2];
  dQdx[li_b1][A_b1_Equ_b2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b2_c1];
  dQdx[li_s][A_s_Equ_b2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_c1];
  dQdx[li_s][A_s_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_e1];
  dQdx[li_s][A_s_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_dt_GND];
  dQdx[li_b][A_b_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1];
  dQdx[li_b][A_b_Equ_c1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c1];
  dQdx[li_b][A_b_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c1_c2];
  dQdx[li_b][A_b_Equ_b2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_c1];
  dQdx[li_b][A_b_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b2_e1];
  dQdx[li_s][A_s_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b2_e1];
  dQdx[li_b][A_b_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  dQdx[li_b][A_b_Equ_c4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_c3_c4];
  dQdx[li_s][A_s_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_c3_c4];
  dQdx[li_b][A_b_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b1_e1];
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_b1];
  dQdx[li_b][A_b_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c];
  dQdx[li_s][A_s_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c];
  dQdx[li_b][A_b_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_dt_GND];
  dQdx[li_c1][A_c1_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_s_c1];
  dQdx[li_b1][A_b1_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_c3_c4];
  dQdx[li_b2][A_b2_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  dQdx[li_b2][A_b2_Equ_c4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_c3_c4];
  dQdx[li_b1][A_b1_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_b1];
  dQdx[li_b2][A_b2_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1];
  dQdx[li_b2][A_b2_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b1_b2];
  dQdx[li_b1][A_b1_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b1][admsProbeID_V_b_c];
  dQdx[li_b2][A_b2_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b2][admsProbeID_V_b_c];
  dQdx[li_c2][A_c2_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  dQdx[li_c2][A_c2_Equ_c4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_c3_c4];
  dQdx[li_c2][A_c2_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b1_b2];
  dQdx[li_c2][A_c2_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_b1];
  dQdx[li_c2][A_c2_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c2][admsProbeID_V_b_c];
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  dQdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_dt][admsProbeID_V_dt_GND];
  dQdx[li_e1][A_e1_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4];
  dQdx[li_e1][A_e1_Equ_c4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_c3_c4];
  dQdx[li_e1][A_e1_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_b1];
  dQdx[li_e1][A_e1_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e1][admsProbeID_V_b_c];
  dQdx[li_c1][A_c1_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b2_e1];
  dQdx[li_c1][A_c1_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b1_e1];
  dQdx[li_c1][A_c1_Equ_c4_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c4_c1];
  dQdx[li_c1][A_c1_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_c3_c4];
  dQdx[li_c1][A_c1_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_b1];
  dQdx[li_c1][A_c1_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c1][admsProbeID_V_b_c];
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c];
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c];
  dQdx[li_c3][A_c3_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  dQdx[li_c3][A_c3_Equ_c1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_s_c1];
  dQdx[li_c3][A_c3_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c1_c2];
  dQdx[li_c3][A_c3_Equ_b2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_c1];
  dQdx[li_c3][A_c3_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b2_e1];
  dQdx[li_c3][A_c3_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  dQdx[li_c3][A_c3_Equ_c4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_c3_c4];
  dQdx[li_c3][A_c3_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b1_e1];
  dQdx[li_c3][A_c3_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_b1];
  dQdx[li_c3][A_c3_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c3][admsProbeID_V_b_c];
  dQdx[li_c3][A_c3_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c3][admsProbeID_V_dt_GND];
  dQdx[li_c4][A_c4_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_dt_GND];
  dQdx[li_c4][A_c4_Equ_c4_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c4] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1];
  dQdx[li_c4][A_c4_Equ_c1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c1] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_s_c1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c4_c1] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1];
  dQdx[li_c4][A_c4_Equ_b2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c1];
  dQdx[li_c4][A_c4_Equ_e1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_e1];
  dQdx[li_c4][A_c4_Equ_c2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b2_c2] -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c1_c2];
  dQdx[li_c4][A_c4_Equ_b1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_b1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_b2] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b1_e1];
  dQdx[li_c4][A_c4_Equ_c3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c1] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_c3_c4];
  dQdx[li_c4][A_c4_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_s_c1];
  dQdx[li_c4][A_c4_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_c] +d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_b1];
  dQdx[li_c4][A_c4_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c4][admsProbeID_V_b_c];
  dQdx[li_b2][A_b2_Equ_noi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b2][admsProbeID_V_noi_GND];
  dQdx[li_e1][A_e1_Equ_noi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e1][admsProbeID_V_noi_GND];


#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter LEVEL : [ 504, 505 [
  if ( (!((LEVEL >=504 && LEVEL <505 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter LEVEL value " << LEVEL << " out of range [ 504, 505 [";
  }

  //    Parameter TREF : [ (-273.0),  (+inf) [
  if ( (!((TREF >=(-273.0)))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TREF value " << TREF << " out of range [ (-273.0),  (+inf) [";
  }

  //    Parameter EXMOD : [ 0, 2 ]
  if ( (!((EXMOD >=0 && EXMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter EXMOD value " << EXMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter EXPHI : [ 0, 1 ]
  if ( (!((EXPHI >=0 && EXPHI <=1 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter EXPHI value " << EXPHI << " out of range [ 0, 1 ]";
  }

  //    Parameter EXAVL : [ 0, 1 ]
  if ( (!((EXAVL >=0 && EXAVL <=1 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter EXAVL value " << EXAVL << " out of range [ 0, 1 ]";
  }

  //    Parameter EXSUB : [ 0, 1 ]
  if ( (!((EXSUB >=0 && EXSUB <=1 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter EXSUB value " << EXSUB << " out of range [ 0, 1 ]";
  }

  //    Parameter IS : ] 0.0,  (+inf) [
  if ( (!((IS >0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IS value " << IS << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IK : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IK >=1.0*1.0e-12))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IK value " << IK << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter VER : [ 0.01,  (+inf) [
  if ( (!((VER >=0.01))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VER value " << VER << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter VEF : [ 0.01,  (+inf) [
  if ( (!((VEF >=0.01))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VEF value " << VEF << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter BF : [ 0.1*1.0e-3,  (+inf) [
  if ( (!((BF >=0.1*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter BF value " << BF << " out of range [ 0.1*1.0e-3,  (+inf) [";
  }

  //    Parameter IBF : [ 0.0,  (+inf) [
  if ( (!((IBF >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IBF value " << IBF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MLF : [ 0.1,  (+inf) [
  if ( (!((MLF >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter MLF value " << MLF << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter XIBI : [ 0.0, 1.0 ]
  if ( (!((XIBI >=0.0 && XIBI <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XIBI value " << XIBI << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter IZEB : [ 0.0,  (+inf) [
  if ( (!((IZEB >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IZEB value " << IZEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NZEB : [ 0.0,  (+inf) [
  if ( (!((NZEB >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter NZEB value " << NZEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter BRI : [ 1.0e-4,  (+inf) [
  if ( (!((BRI >=1.0e-4))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter BRI value " << BRI << " out of range [ 1.0e-4,  (+inf) [";
  }

  //    Parameter IBR : [ 0.0,  (+inf) [
  if ( (!((IBR >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IBR value " << IBR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XEXT : [ 0.0, 1.0 ]
  if ( (!((XEXT >=0.0 && XEXT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XEXT value " << XEXT << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter WAVL : [ 1.0*1.0e-9,  (+inf) [
  if ( (!((WAVL >=1.0*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter WAVL value " << WAVL << " out of range [ 1.0*1.0e-9,  (+inf) [";
  }

  //    Parameter VAVL : [ 0.01,  (+inf) [
  if ( (!((VAVL >=0.01))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VAVL value " << VAVL << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter SFH : [ 0.0,  (+inf) [
  if ( (!((SFH >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter SFH value " << SFH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RE : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RE >=1.0*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RE value " << RE << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RBC : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RBC >=1.0*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RBC value " << RBC << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RBV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RBV >=1.0*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RBV value " << RBV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RCC : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RCC >=1.0*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RCC value " << RCC << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RCV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RCV >=1.0*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RCV value " << RCV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter SCRCV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((SCRCV >=1.0*1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter SCRCV value " << SCRCV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter IHC : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IHC >=1.0*1.0e-12))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IHC value " << IHC << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter AXI : [ 0.02,  (+inf) [
  if ( (!((AXI >=0.02))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter AXI value " << AXI << " out of range [ 0.02,  (+inf) [";
  }

  //    Parameter CJE : [ 0.0,  (+inf) [
  if ( (!((CJE >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter CJE value " << CJE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDE : [ 0.05,  (+inf) [
  if ( (!((VDE >=0.05))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VDE value " << VDE << " out of range [ 0.05,  (+inf) [";
  }

  //    Parameter PE : [ 0.01, 0.99 [
  if ( (!((PE >=0.01 && PE <0.99 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter PE value " << PE << " out of range [ 0.01, 0.99 [";
  }

  //    Parameter XCJE : [ 0.0, 1.0 ]
  if ( (!((XCJE >=0.0 && XCJE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XCJE value " << XCJE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter CBEO : [ 0.0,  (+inf) [
  if ( (!((CBEO >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter CBEO value " << CBEO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CJC : [ 0.0,  (+inf) [
  if ( (!((CJC >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter CJC value " << CJC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDC : [ 0.05,  (+inf) [
  if ( (!((VDC >=0.05))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VDC value " << VDC << " out of range [ 0.05,  (+inf) [";
  }

  //    Parameter PC : [ 0.01, 0.99 [
  if ( (!((PC >=0.01 && PC <0.99 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter PC value " << PC << " out of range [ 0.01, 0.99 [";
  }

  //    Parameter XP : [ 0.0, 0.99 [
  if ( (!((XP >=0.0 && XP <0.99 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XP value " << XP << " out of range [ 0.0, 0.99 [";
  }

  //    Parameter MC : [ 0.0, 1.0 [
  if ( (!((MC >=0.0 && MC <1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter MC value " << MC << " out of range [ 0.0, 1.0 [";
  }

  //    Parameter XCJC : [ 0.0, 1.0 ]
  if ( (!((XCJC >=0.0 && XCJC <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XCJC value " << XCJC << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter RCBLX : [ 0.0,  (+inf) [
  if ( (!((RCBLX >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RCBLX value " << RCBLX << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RCBLI : [ 0.0,  (+inf) [
  if ( (!((RCBLI >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RCBLI value " << RCBLI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBCO : [ 0.0,  (+inf) [
  if ( (!((CBCO >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter CBCO value " << CBCO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MTAU : [ 0.1,  (+inf) [
  if ( (!((MTAU >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter MTAU value " << MTAU << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter TAUE : [ 0.0,  (+inf) [
  if ( (!((TAUE >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TAUE value " << TAUE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TAUB : ] 0.0,  (+inf) [
  if ( (!((TAUB >0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TAUB value " << TAUB << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter TEPI : [ 0.0,  (+inf) [
  if ( (!((TEPI >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TEPI value " << TEPI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TAUR : [ 0.0,  (+inf) [
  if ( (!((TAUR >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TAUR value " << TAUR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XREC : [ 0.0,  (+inf) [
  if ( (!((XREC >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XREC value " << XREC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XQB : [ 0.0, 1.0 ]
  if ( (!((XQB >=0.0 && XQB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter XQB value " << XQB << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter ACBL : [ 0.0,  (+inf) [
  if ( (!((ACBL >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter ACBL value " << ACBL << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VGB : [ 0.1,  (+inf) [
  if ( (!((VGB >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VGB value " << VGB << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGC : [ 0.1,  (+inf) [
  if ( (!((VGC >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VGC value " << VGC << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGJ : [ 0.1,  (+inf) [
  if ( (!((VGJ >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VGJ value " << VGJ << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGZEB : [ 0.1,  (+inf) [
  if ( (!((VGZEB >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VGZEB value " << VGZEB << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter AVGEB :  ] (-inf)  (+inf) [

  //    Parameter TVGEB : [ 0.0,  (+inf) [
  if ( (!((TVGEB >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TVGEB value " << TVGEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AF : [ 0.01,  (+inf) [
  if ( (!((AF >=0.01))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter AF value " << AF << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter KF : [ 0.0,  (+inf) [
  if ( (!((KF >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter KF value " << KF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KFN : [ 0.0,  (+inf) [
  if ( (!((KFN >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter KFN value " << KFN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KAVL : [ 0, 1 ]
  if ( (!((KAVL >=0 && KAVL <=1 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter KAVL value " << KAVL << " out of range [ 0, 1 ]";
  }

  //    Parameter KC : [ 0, 2 ]
  if ( (!((KC >=0 && KC <=2 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter KC value " << KC << " out of range [ 0, 2 ]";
  }

  //    Parameter KE : [ 0.0, 1.0 ]
  if ( (!((KE >=0.0 && KE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter KE value " << KE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter FTAUN : [ 0.0, 1.0 ]
  if ( (!((FTAUN >=0.0 && FTAUN <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter FTAUN value " << FTAUN << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter ISS : [ 0.0,  (+inf) [
  if ( (!((ISS >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter ISS value " << ISS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ICSS :  ] (-inf)  (+inf) [

  //    Parameter IKS : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IKS >=1.0*1.0e-12))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter IKS value " << IKS << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter CJS : [ 0.0,  (+inf) [
  if ( (!((CJS >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter CJS value " << CJS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDS : ] 0.05,  (+inf) [
  if ( (!((VDS >0.05))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VDS value " << VDS << " out of range ] 0.05,  (+inf) [";
  }

  //    Parameter PS : ] 0.01, 0.99 [
  if ( (!((PS >0.01 && PS <0.99 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter PS value " << PS << " out of range ] 0.01, 0.99 [";
  }

  //    Parameter VGS : [ 0.1,  (+inf) [
  if ( (!((VGS >=0.1))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter VGS value " << VGS << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter RTH : ] 0.0,  (+inf) [
  if ( (!((RTH >0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter RTH value " << RTH << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter CTH : [ 0.0,  (+inf) [
  if ( (!((CTH >=0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter CTH value " << CTH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MULT : ] 0.0,  (+inf) [
  if ( (!((MULT >0.0))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter MULT value " << MULT << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter GMIN : ] 0.0, 1e-10 ]
  if ( (!((GMIN >0.0 && GMIN <=1e-10 ))) )
  {
    UserWarning(*this) << "ADMSbjt504tva: Parameter GMIN value " << GMIN << " out of range ] 0.0, 1e-10 ]";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(504),
    TREF(25.0),
    DTA(0.0),
    EXMOD(1),
    EXPHI(1),
    EXAVL(0),
    EXSUB(0),
    IS(22.0*1.0e-18),
    IK(0.1),
    VER(2.5),
    VEF(44.0),
    BF(215.0),
    IBF(2.7*1.0e-15),
    MLF(2.0),
    XIBI(0.0),
    IZEB(0.0),
    NZEB(22.0),
    BRI(7.0),
    IBR(1.0*1.0e-15),
    VLR(0.2),
    XEXT(0.63),
    WAVL(1.1*1.0e-6),
    VAVL(3.0),
    SFH(0.3),
    RE(5.0),
    RBC(23.0),
    RBV(18.0),
    RCC(12.0),
    RCV(150.0),
    SCRCV(1250.0),
    IHC(4.0*1.0e-3),
    AXI(0.3),
    CJE(73.0*1.0e-15),
    VDE(0.95),
    PE(0.4),
    XCJE(0.4),
    CBEO(0.0),
    CJC(78.0*1.0e-15),
    VDC(0.68),
    PC(0.5),
    XP(0.35),
    MC(0.5),
    XCJC(32.0*1.0e-3),
    RCBLX(0.0),
    RCBLI(0.0),
    CBCO(0.0),
    MTAU(1.0),
    TAUE(2.0*1.0e-12),
    TAUB(4.2*1.0e-12),
    TEPI(41.0*1.0e-12),
    TAUR(520.0*1.0e-12),
    DEG(0.0),
    XREC(0.0),
    XQB(0.33333333333333333333),
    AQBO(0.3),
    AE(0.0),
    AB(1.0),
    AEPI(2.5),
    AEX(0.62),
    AC(2.0),
    ACBL(2.0),
    DVGBF(50.0*1.0e-3),
    DVGBR(45.0*1.0e-3),
    VGB(1.17),
    VGC(1.18),
    VGJ(1.15),
    VGZEB(1.15),
    AVGEB(4.73e-4),
    TVGEB(636.0),
    DVGTE(0.05),
    DAIS(0.0),
    AF(2.0),
    KF(20.0*1.0e-12),
    KFN(20.0*1.0e-12),
    KAVL(0),
    KC(0),
    KE(0.0),
    FTAUN(0.0),
    ISS(48.0*1.0e-18),
    ICSS((-1.0)),
    IKS(250.0*1.0e-6),
    CJS(315.0*1.0e-15),
    VDS(0.62),
    PS(0.34),
    VGS(1.20),
    AS(1.58),
    ASUB(2.0),
    RTH(300.0),
    CTH(3.0*1.0e-9),
    ATH(0.0),
    MULT(1.0),
    TYPE(1),
    GMIN(1.0e-13)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
  if (deviceMap.empty() ||
      ((deviceMap.find("Q") != deviceMap.end() && (levelSet.find(505)!=levelSet.end()))))
  {
    BJT::registerDevice();

    Config<Traits>::addConfiguration()
      .registerDevice("q", 505)
      .registerModelType("npn", 505)
      .registerModelType("pnp", 505);
  }
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_An,
   AdmsSensFadType & instanceVar_Bn,
   AdmsSensFadType & instanceVar_Trk,
   AdmsSensFadType & instanceVar_Tamb,
   AdmsSensFadType & instanceVar_pow2_2mPE,
   AdmsSensFadType & instanceVar_pow2_PEm2,
   AdmsSensFadType & instanceVar_inv_VDE,
   AdmsSensFadType & instanceVar_inv_VGZEB_Tr,
   AdmsSensFadType & instanceVar_VGZEBOK,
   AdmsSensFadType & instanceVar_invMULT,
   AdmsSensFadType & instanceVar_SCRCV_M,
   AdmsSensFadType & instanceVar_KF_M,
   AdmsSensFadType & instanceVar_KFN_M,
   AdmsSensFadType & instanceVar_CTH_M,
   AdmsSensFadType & instanceVar_Xext1,
   AdmsSensFadType & instanceVar_CBEO_M,
   AdmsSensFadType & instanceVar_CBCO_M,
   AdmsSensFadType & instanceVar_dxa,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_XQB,
   bool modelPar_given_XQB,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_KE,
   bool modelPar_given_KE,
   AdmsSensFadType & modelPar_FTAUN,
   bool modelPar_given_FTAUN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_ATH,
   bool modelPar_given_ATH,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_KC,
   bool modelPar_given_KC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType VGZEB_Tr;
  //Begin block initial_instance
  {
    if ((modelPar_TYPE==1))
    {
      instanceVar_An = 7.03e7;
      instanceVar_Bn = 1.23e8;
    }
    else
    {
      instanceVar_An = 1.58e8;
      instanceVar_Bn = 2.04e8;
    }
    instanceVar_Xext1 = (1.0-modelPar_XEXT);
    instanceVar_CTH_M = (modelPar_CTH*instancePar_MULT);
    instanceVar_CBEO_M = (modelPar_CBEO*instancePar_MULT);
    instanceVar_CBCO_M = (modelPar_CBCO*instancePar_MULT);
    instanceVar_invMULT = (1.0/instancePar_MULT);
    instanceVar_SCRCV_M = (modelPar_SCRCV*instanceVar_invMULT);
    {
      AdmsSensFadType value_pow_0 = pow(instancePar_MULT,(1.0-modelPar_AF));
      instanceVar_KF_M = (modelPar_KF*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow(instancePar_MULT,(1.0-((2.0*(modelPar_MLF-1.0))+(modelPar_AF*(2.0-modelPar_MLF)))));
      instanceVar_KFN_M = (modelPar_KFN*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow(2.0,(2.0-modelPar_PE));
      instanceVar_pow2_2mPE = value_pow_0;
    }
    instanceVar_pow2_PEm2 = (1.0/instanceVar_pow2_2mPE);
    instanceVar_Trk = (modelPar_TREF+273.15);
    instanceVar_Tamb = (admsTemperature+modelPar_DTA);
    instanceVar_dxa = (((modelPar_VGZEB+(((modelPar_AVGEB*instanceVar_Trk)*instanceVar_Trk)/(instanceVar_Trk+modelPar_TVGEB)))-0.05)/0.1);
    if (((modelPar_VGZEB+(((modelPar_AVGEB*instanceVar_Trk)*instanceVar_Trk)/(instanceVar_Trk+modelPar_TVGEB)))<0.05))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        instanceVar_VGZEBOK = (0.05+(0.1*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        instanceVar_VGZEBOK = ((modelPar_VGZEB+(((modelPar_AVGEB*instanceVar_Trk)*instanceVar_Trk)/(instanceVar_Trk+modelPar_TVGEB)))+(0.1*value_log_1));
      }
    }
    instanceVar_VGZEBOK = instanceVar_VGZEBOK;
    VGZEB_Tr = modelPar_VGZEB;
    instanceVar_inv_VGZEB_Tr = (1.0/VGZEB_Tr);
    instanceVar_inv_VDE = (1.0/modelPar_VDE);
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_XQB,
   bool modelPar_given_XQB,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_KE,
   bool modelPar_given_KE,
   AdmsSensFadType & modelPar_FTAUN,
   bool modelPar_given_FTAUN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_ATH,
   bool modelPar_given_ATH,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_KC,
   bool modelPar_given_KC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_noi_GND,
   const int admsProbeID_V_c3_c1,
   const int admsProbeID_V_c3_c4,
   const int admsProbeID_V_c4_c1,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_b_b1,
   const int admsProbeID_V_e_e1,
   const int admsProbeID_V_c1_c2,
   const int admsProbeID_V_s_c1,
   const int admsProbeID_V_b1_b2,
   const int admsProbeID_V_b1_e1,
   const int admsProbeID_V_b2_e1,
   const int admsProbeID_V_b2_c2,
   const int admsProbeID_V_b2_c1,
   const int admsProbeID_V_dt_GND,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_s,
   const int admsNodeID_dt,
   const int admsNodeID_e1,
   const int admsNodeID_b1,
   const int admsNodeID_b2,
   const int admsNodeID_c1,
   const int admsNodeID_c2,
   const int admsNodeID_c3,
   const int admsNodeID_c4,
   const int admsNodeID_noi,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_An,
   AdmsSensFadType & instanceVar_Bn,
   AdmsSensFadType & instanceVar_Trk,
   AdmsSensFadType & instanceVar_Tamb,
   AdmsSensFadType & instanceVar_pow2_2mPE,
   AdmsSensFadType & instanceVar_pow2_PEm2,
   AdmsSensFadType & instanceVar_inv_VDE,
   AdmsSensFadType & instanceVar_inv_VGZEB_Tr,
   AdmsSensFadType & instanceVar_VGZEBOK,
   AdmsSensFadType & instanceVar_invMULT,
   AdmsSensFadType & instanceVar_SCRCV_M,
   AdmsSensFadType & instanceVar_KF_M,
   AdmsSensFadType & instanceVar_KFN_M,
   AdmsSensFadType & instanceVar_CTH_M,
   AdmsSensFadType & instanceVar_Xext1,
   AdmsSensFadType & instanceVar_CBEO_M,
   AdmsSensFadType & instanceVar_CBCO_M,
   AdmsSensFadType & instanceVar_dxa,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_XQB,
   bool modelPar_given_XQB,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_KE,
   bool modelPar_given_KE,
   AdmsSensFadType & modelPar_FTAUN,
   bool modelPar_given_FTAUN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_ATH,
   bool modelPar_given_ATH,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_KC,
   bool modelPar_given_KC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType common;
  AdmsSensFadType powerREC;
  AdmsSensFadType powerRBC;
  AdmsSensFadType powerRCCxx;
  AdmsSensFadType powerRCCex;
  AdmsSensFadType powerRCCin;
  AdmsSensFadType powerRBV;
  AdmsSensFadType In_N;
  AdmsSensFadType powerCCS;
  AdmsSensFadType Gem_N;
  AdmsSensFadType powerIIS;
  AdmsSensFadType Taub_N;
  AdmsSensFadType taun;
  AdmsSensFadType powerFBCS;
  AdmsSensFadType powerFBC1fB1;
  AdmsSensFadType exponentFBC1fB2;
  AdmsSensFadType powerFBC1fB2;
  AdmsSensFadType powerEBSCS;
  AdmsSensFadType powerEBSC1f;
  AdmsSensFadType powerRBCS;
  AdmsSensFadType powerRBC1f;
  AdmsSensFadType powerExCS;
  AdmsSensFadType powerExC1f;
  AdmsSensFadType powerExCSMOD;
  AdmsSensFadType powerExC1fMOD;
  AdmsSensFadType powerSubsCS_B1S;
  AdmsSensFadType powerSubsCS_BS;
  AdmsSensFadType Vb2c1;
  AdmsSensFadType Vb2c2;
  AdmsSensFadType Vb2e1;
  AdmsSensFadType Vb1e1;
  AdmsSensFadType Vb1b2;
  AdmsSensFadType Vsc1;
  AdmsSensFadType Vc1c2;
  AdmsSensFadType Vee1;
  AdmsSensFadType Vbb1;
  AdmsSensFadType Vbe;
  AdmsSensFadType Vbc;
  AdmsSensFadType Vc4c1;
  AdmsSensFadType Vc3c4;
  AdmsSensFadType Vb1c4;
  AdmsSensFadType Vcc3;
  AdmsSensFadType Vbc3;
  AdmsSensFadType Vsc4;
  AdmsSensFadType Vsc3;
  double expl;
  AdmsSensFadType eVb2c2;
  AdmsSensFadType eVb2e1;
  AdmsSensFadType eVb1e1;
  AdmsSensFadType eVb1c4;
  AdmsSensFadType eVb1b2;
  AdmsSensFadType eVbc3;
  AdmsSensFadType eVsc1;
  AdmsSensFadType eVsc3;
  AdmsSensFadType eVsc4;
  AdmsSensFadType eVbc3VDC;
  AdmsSensFadType eVb1c4VDC;
  AdmsSensFadType eVb2c2VDC;
  AdmsSensFadType eVb2c1VDC;
  AdmsSensFadType K0;
  AdmsSensFadType Kw;
  AdmsSensFadType pW;
  AdmsSensFadType Ec;
  AdmsSensFadType Ic1c2;
  AdmsSensFadType pav;
  AdmsSensFadType tmpV;
  AdmsSensFadType Vqs_th;
  AdmsSensFadType eps_VDC;
  AdmsSensFadType eps2;
  AdmsSensFadType x2;
  AdmsSensFadType Vqs;
  AdmsSensFadType Iqs;
  AdmsSensFadType Ic1c2_Iqs;
  AdmsSensFadType alpha1;
  AdmsSensFadType alpha;
  AdmsSensFadType vyi;
  AdmsSensFadType yi;
  AdmsSensFadType xi_w;
  AdmsSensFadType gp0;
  AdmsSensFadType gp0_help;
  AdmsSensFadType gp02;
  AdmsSensFadType sqr_arg;
  AdmsSensFadType p0star;
  AdmsSensFadType eVb2c2star;
  AdmsSensFadType B1;
  AdmsSensFadType B2;
  AdmsSensFadType Vxi0;
  AdmsSensFadType Vch;
  AdmsSensFadType Icap;
  AdmsSensFadType Icap_IHC;
  AdmsSensFadType Vfe;
  AdmsSensFadType a_VDE;
  AdmsSensFadType Vje;
  AdmsSensFadType E0BE;
  AdmsSensFadType Vte;
  AdmsSensFadType Vjunc;
  AdmsSensFadType bjc;
  AdmsSensFadType Vfc;
  AdmsSensFadType Vjc;
  AdmsSensFadType fI;
  AdmsSensFadType Vcv;
  AdmsSensFadType Vtc;
  AdmsSensFadType If0;
  AdmsSensFadType f1;
  AdmsSensFadType n0;
  AdmsSensFadType f2;
  AdmsSensFadType nB;
  AdmsSensFadType termE;
  AdmsSensFadType termC;
  AdmsSensFadType q0I;
  AdmsSensFadType q1I;
  AdmsSensFadType qBI;
  AdmsSensFadType Ir;
  AdmsSensFadType If;
  AdmsSensFadType In;
  AdmsSensFadType Ibf0;
  AdmsSensFadType Ib1;
  AdmsSensFadType Ib1_s;
  AdmsSensFadType tmpExp;
  AdmsSensFadType Ib2;
  AdmsSensFadType Ib3;
  AdmsSensFadType eZEB;
  AdmsSensFadType x;
  AdmsSensFadType dE0BE;
  AdmsSensFadType edZEB;
  AdmsSensFadType DZEB;
  AdmsSensFadType Izteb;
  AdmsSensFadType g1;
  AdmsSensFadType g2;
  AdmsSensFadType nBex;
  AdmsSensFadType pWex;
  AdmsSensFadType Iex;
  AdmsSensFadType Isub;
  AdmsSensFadType Isf;
  AdmsSensFadType XIex;
  AdmsSensFadType XIsub;
  AdmsSensFadType Xg1;
  AdmsSensFadType XnBex;
  AdmsSensFadType XIMex;
  AdmsSensFadType XIMsub;
  AdmsSensFadType Vex_bias;
  AdmsSensFadType Vex;
  AdmsSensFadType vdif;
  AdmsSensFadType VBex;
  AdmsSensFadType Fex;
  AdmsSensFadType q0Q;
  AdmsSensFadType q1Q;
  AdmsSensFadType qBQ;
  AdmsSensFadType Rb2;
  AdmsSensFadType Ib1b2;
  AdmsSensFadType Iavl;
  AdmsSensFadType Gem;
  AdmsSensFadType dEdx0;
  AdmsSensFadType xd;
  AdmsSensFadType xi_w1;
  AdmsSensFadType Weff;
  AdmsSensFadType Wd;
  AdmsSensFadType Eav;
  AdmsSensFadType E0;
  AdmsSensFadType SHw;
  AdmsSensFadType Efi;
  AdmsSensFadType Ew;
  AdmsSensFadType Em;
  AdmsSensFadType EmEav_Em;
  AdmsSensFadType lambda;
  AdmsSensFadType Gmax;
  AdmsSensFadType Vb2c2star;
  AdmsSensFadType power;
  AdmsSensFadType Qte;
  AdmsSensFadType Vje_s;
  AdmsSensFadType Qte_s;
  AdmsSensFadType Qtc;
  AdmsSensFadType Qb0;
  AdmsSensFadType Qbe_qs;
  AdmsSensFadType Qbc_qs;
  AdmsSensFadType a_VDC;
  AdmsSensFadType Vjcex;
  AdmsSensFadType Vtexv;
  AdmsSensFadType Qtex;
  AdmsSensFadType XVjcex;
  AdmsSensFadType XVtexv;
  AdmsSensFadType XQtex;
  AdmsSensFadType a_VDS;
  AdmsSensFadType Vfs;
  AdmsSensFadType Vjs;
  AdmsSensFadType Qts;
  AdmsSensFadType Qe0;
  AdmsSensFadType Qe_qs;
  AdmsSensFadType Qepi0;
  AdmsSensFadType Qepi;
  AdmsSensFadType Qex;
  AdmsSensFadType XQex;
  AdmsSensFadType Xg2;
  AdmsSensFadType XpWex;
  AdmsSensFadType Qb1b2;
  AdmsSensFadType dVteVje;
  AdmsSensFadType Vb2e1Vfe;
  AdmsSensFadType dVjeVb2e1;
  AdmsSensFadType dVteVb2e1;
  AdmsSensFadType dQteVb2e1;
  AdmsSensFadType dn0Vb2e1;
  AdmsSensFadType dQbeVb2e1;
  AdmsSensFadType dQeVb2e1;
  AdmsSensFadType Qe;
  AdmsSensFadType Qbe_qs_eff;
  AdmsSensFadType Qbc;
  AdmsSensFadType Qbe;
  AdmsSensFadType RTH_Tamb_M;
  AdmsSensFadType GCCin_TM;
  AdmsSensFadType GCCex_TM;
  AdmsSensFadType GCCxx_TM;
  AdmsSensFadType RCV_TM;
  AdmsSensFadType RCCin_TM;
  AdmsSensFadType RCCex_TM;
  AdmsSensFadType RCCxx_TM;
  AdmsSensFadType RBV_TM;
  AdmsSensFadType RBC_TM;
  AdmsSensFadType RE_TM;
  AdmsSensFadType CJS_TM;
  AdmsSensFadType CJC_TM;
  AdmsSensFadType CJE_TM;
  AdmsSensFadType IKS_TM;
  AdmsSensFadType ICSS_TM;
  AdmsSensFadType ISS_TM;
  AdmsSensFadType IHC_M;
  AdmsSensFadType IZEB_TM;
  AdmsSensFadType IBR_TM;
  AdmsSensFadType IBF_TM;
  AdmsSensFadType IK_TM;
  AdmsSensFadType IS_TM;
  AdmsSensFadType RTH_Tamb;
  AdmsSensFadType DEG_T;
  AdmsSensFadType BnT;
  AdmsSensFadType Tk300;
  AdmsSensFadType TAUR_T;
  AdmsSensFadType TEPI_T;
  AdmsSensFadType TAUB_T;
  AdmsSensFadType TAUE_T;
  AdmsSensFadType IKS_T;
  AdmsSensFadType ICSS_T;
  AdmsSensFadType ISS_T;
  AdmsSensFadType VER_T;
  AdmsSensFadType VEF_T;
  AdmsSensFadType IZEB_T;
  AdmsSensFadType nZEB_T;
  AdmsSensFadType y;
  AdmsSensFadType tempx;
  AdmsSensFadType IBR_T;
  AdmsSensFadType IBF_T;
  AdmsSensFadType IK_T;
  AdmsSensFadType IS_T;
  AdmsSensFadType BRI_T;
  AdmsSensFadType BF_T;
  AdmsSensFadType RCV_T;
  AdmsSensFadType RCCin_T;
  AdmsSensFadType RCCex_T;
  AdmsSensFadType RCCxx_T;
  AdmsSensFadType RBC_T;
  AdmsSensFadType RBV_T;
  AdmsSensFadType RE_T;
  AdmsSensFadType XP_T;
  AdmsSensFadType CJC_T;
  AdmsSensFadType CJCscaleINV;
  AdmsSensFadType CJCscale;
  AdmsSensFadType CJS_T;
  AdmsSensFadType CJE_T;
  AdmsSensFadType CJE_T_div_CJE;
  AdmsSensFadType inv_VDE_T;
  AdmsSensFadType VDS_T;
  AdmsSensFadType UdsT;
  AdmsSensFadType VDC_T;
  AdmsSensFadType UdcT;
  AdmsSensFadType VDE_T;
  AdmsSensFadType UdeT;
  AdmsSensFadType VGZEB_T;
  AdmsSensFadType lntN;
  AdmsSensFadType VdtINV;
  AdmsSensFadType VtrINV;
  AdmsSensFadType VtINV;
  AdmsSensFadType Vtr;
  AdmsSensFadType Vt;
  AdmsSensFadType tN;
  AdmsSensFadType Tk;
  double Vdt;
  double Tki;


  // -- code converted from analog/code block
  Tki = (probeVars[admsProbeID_V_dt_GND]);
  if ((Tki<0.0))
  {
    {
      double value_log_0 = log((1.0-Tki));
      Tki = (-value_log_0);
    }
  }
  if ((Tki<200.0))
  {
    Vdt = Tki;
  }
  else
  {
    {
      double value_log_0 = log((1.0+(Tki-200.0)));
      Vdt = (200.0+value_log_0);
    }
  }
  Vdt = Vdt;
  Tk = (instanceVar_Tamb+Vdt);
  tN = (Tk/instanceVar_Trk);
  Vt = (8.61708691805812512584e-5*Tk);
  Vtr = (8.61708691805812512584e-5*instanceVar_Trk);
  VtINV = (1.0/Vt);
  VtrINV = (1.0/Vtr);
  VdtINV = (VtINV-VtrINV);
  {
    AdmsSensFadType value_log_0 = log(tN);
    lntN = value_log_0;
  }
  instanceVar_dxa = (((instanceVar_VGZEBOK-(((modelPar_AVGEB*Tk)*Tk)/(Tk+modelPar_TVGEB)))-0.05)/0.1);
  if (((instanceVar_VGZEBOK-(((modelPar_AVGEB*Tk)*Tk)/(Tk+modelPar_TVGEB)))<0.05))
  {
    {
      AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VGZEB_T = (0.05+(0.1*value_log_1));
    }
  }
  else
  {
    {
      AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VGZEB_T = ((instanceVar_VGZEBOK-(((modelPar_AVGEB*Tk)*Tk)/(Tk+modelPar_TVGEB)))+(0.1*value_log_1));
    }
  }
  VGZEB_T = VGZEB_T;
  {
    AdmsSensFadType value_log_0 = log(tN);
    UdeT = (((((-3.0)*Vt)*value_log_0)+(modelPar_VDE*tN))+((1.0-tN)*modelPar_VGB));
  }
  instanceVar_dxa = ((0.05-UdeT)/Vt);
  if ((0.05<UdeT))
  {
    {
      AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VDE_T = (UdeT+(Vt*value_log_1));
    }
  }
  else
  {
    {
      AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VDE_T = (0.05+(Vt*value_log_1));
    }
  }
  VDE_T = VDE_T;
  {
    AdmsSensFadType value_log_0 = log(tN);
    UdcT = (((((-3.0)*Vt)*value_log_0)+(modelPar_VDC*tN))+((1.0-tN)*modelPar_VGC));
  }
  instanceVar_dxa = ((0.05-UdcT)/Vt);
  if ((0.05<UdcT))
  {
    {
      AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VDC_T = (UdcT+(Vt*value_log_1));
    }
  }
  else
  {
    {
      AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VDC_T = (0.05+(Vt*value_log_1));
    }
  }
  VDC_T = VDC_T;
  {
    AdmsSensFadType value_log_0 = log(tN);
    UdsT = (((((-3.0)*Vt)*value_log_0)+(modelPar_VDS*tN))+((1.0-tN)*modelPar_VGS));
  }
  instanceVar_dxa = ((0.05-UdsT)/Vt);
  if ((0.05<UdsT))
  {
    {
      AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VDS_T = (UdsT+(Vt*value_log_1));
    }
  }
  else
  {
    {
      AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      VDS_T = (0.05+(Vt*value_log_1));
    }
  }
  VDS_T = VDS_T;
  inv_VDE_T = (1.0/VDE_T);
  {
    AdmsSensFadType value_pow_0 = pow((modelPar_VDE*inv_VDE_T),modelPar_PE);
    CJE_T_div_CJE = value_pow_0;
  }
  CJE_T = (modelPar_CJE*CJE_T_div_CJE);
  {
    AdmsSensFadType value_pow_0 = pow((modelPar_VDS/VDS_T),modelPar_PS);
    CJS_T = (modelPar_CJS*value_pow_0);
  }
  {
    AdmsSensFadType value_pow_0 = pow((modelPar_VDC/VDC_T),modelPar_PC);
    CJCscale = (((1.0-modelPar_XP)*value_pow_0)+modelPar_XP);
  }
  CJCscaleINV = (1.0/CJCscale);
  CJC_T = (modelPar_CJC*CJCscale);
  XP_T = (modelPar_XP*CJCscaleINV);
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_AE));
    RE_T = (modelPar_RE*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(modelPar_AB-modelPar_AQBO)));
    RBV_T = (modelPar_RBV*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_AEX));
    RBC_T = (modelPar_RBC*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_AC));
    RCCxx_T = (modelPar_RCC*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_ACBL));
    RCCex_T = (modelPar_RCBLX*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_ACBL));
    RCCin_T = (modelPar_RCBLI*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_AEPI));
    RCV_T = (modelPar_RCV*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*((modelPar_AE-modelPar_AB)-modelPar_AQBO)));
    AdmsSensFadType value_exp_1 = exp(((-modelPar_DVGBF)*VdtINV));
    BF_T = ((modelPar_BF*value_exp_0)*value_exp_1);
  }
  {
    AdmsSensFadType value_exp_0 = exp(((-modelPar_DVGBR)*VdtINV));
    BRI_T = (modelPar_BRI*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(((4.0-modelPar_AB)-modelPar_AQBO)+modelPar_DAIS)));
    AdmsSensFadType value_exp_1 = exp(((-modelPar_VGB)*VdtINV));
    IS_T = ((modelPar_IS*value_exp_0)*value_exp_1);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(1.0-modelPar_AB)));
    IK_T = (modelPar_IK*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(6.0-(2.0*modelPar_MLF))));
    AdmsSensFadType value_exp_1 = exp((((-modelPar_VGJ)*VdtINV)/modelPar_MLF));
    IBF_T = ((modelPar_IBF*value_exp_0)*value_exp_1);
  }
  {
    AdmsSensFadType value_exp_0 = exp((((-modelPar_VGC)*VdtINV)/2.0));
    IBR_T = (((modelPar_IBR*tN)*tN)*value_exp_0);
  }
  {
    AdmsSensFadType value_pow_0 = pow((VGZEB_T*instanceVar_inv_VGZEB_Tr),(-0.5));
    tempx = value_pow_0;
  }
  y = (1.0/CJE_T_div_CJE);
  nZEB_T = ((((((((modelPar_NZEB*VGZEB_T)*VGZEB_T)*tempx)*y)*modelPar_VDE)*inv_VDE_T)*instanceVar_inv_VGZEB_Tr)*instanceVar_inv_VGZEB_Tr);
  {
    AdmsSensFadType value_exp_0 = exp((modelPar_NZEB-nZEB_T));
    IZEB_T = (((((((modelPar_IZEB*tempx)*VDE_T)*VDE_T)*instanceVar_inv_VDE)*instanceVar_inv_VDE)*CJE_T_div_CJE)*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_AQBO));
    tempx = value_exp_0;
  }
  VEF_T = ((modelPar_VEF*tempx)*CJCscaleINV);
  VER_T = ((modelPar_VER*tempx)*y);
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(4.0-modelPar_AS)));
    AdmsSensFadType value_exp_1 = exp(((-modelPar_VGS)*VdtINV));
    ISS_T = ((modelPar_ISS*value_exp_0)*value_exp_1);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(3.5-(0.5*modelPar_ASUB))));
    AdmsSensFadType value_exp_1 = exp(((-modelPar_VGS)*VdtINV));
    ICSS_T = ((modelPar_ICSS*value_exp_0)*value_exp_1);
  }
  if ((ISS_T>0.0))
  {
    {
      AdmsSensFadType value_exp_0 = exp((lntN*(1.0-modelPar_AS)));
      IKS_T = (((modelPar_IKS*value_exp_0)*(IS_T/modelPar_IS))*(modelPar_ISS/ISS_T));
    }
  }
  else
  {
    {
      AdmsSensFadType value_exp_0 = exp((lntN*(1.0-modelPar_AS)));
      IKS_T = (modelPar_IKS*value_exp_0);
    }
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(modelPar_AB-2.0)));
    AdmsSensFadType value_exp_1 = exp(((-modelPar_DVGTE)*VdtINV));
    TAUE_T = ((modelPar_TAUE*value_exp_0)*value_exp_1);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*((modelPar_AQBO+modelPar_AB)-1.0)));
    TAUB_T = (modelPar_TAUB*value_exp_0);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*(modelPar_AEPI-1.0)));
    TEPI_T = (modelPar_TEPI*value_exp_0);
  }
  TAUR_T = ((modelPar_TAUR*(TAUB_T+TEPI_T))/(modelPar_TAUB+modelPar_TEPI));
  Tk300 = (Tk-300.0);
  if ((Tk<525.0))
  {
    BnT = (instanceVar_Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
  }
  else
  {
    BnT = (instanceVar_Bn*1.081);
  }
  {
    AdmsSensFadType value_exp_0 = exp((lntN*modelPar_AQBO));
    DEG_T = (modelPar_DEG*value_exp_0);
  }
  {
    AdmsSensFadType value_pow_0 = pow((instanceVar_Tamb/instanceVar_Trk),modelPar_ATH);
    RTH_Tamb = (modelPar_RTH*value_pow_0);
  }
  IS_TM = (IS_T*instancePar_MULT);
  IK_TM = (IK_T*instancePar_MULT);
  IBF_TM = (IBF_T*instancePar_MULT);
  IBR_TM = (IBR_T*instancePar_MULT);
  IZEB_TM = (IZEB_T*instancePar_MULT);
  IHC_M = (modelPar_IHC*instancePar_MULT);
  ISS_TM = (ISS_T*instancePar_MULT);
  ICSS_TM = (ICSS_T*instancePar_MULT);
  IKS_TM = (IKS_T*instancePar_MULT);
  CJE_TM = (CJE_T*instancePar_MULT);
  CJC_TM = (CJC_T*instancePar_MULT);
  CJS_TM = (CJS_T*instancePar_MULT);
  RE_TM = (RE_T*instanceVar_invMULT);
  RBC_TM = (RBC_T*instanceVar_invMULT);
  RBV_TM = (RBV_T*instanceVar_invMULT);
  RCCxx_TM = (RCCxx_T*instanceVar_invMULT);
  RCCex_TM = (RCCex_T*instanceVar_invMULT);
  RCCin_TM = (RCCin_T*instanceVar_invMULT);
  RCV_TM = (RCV_T*instanceVar_invMULT);
  if ((modelPar_RCC>0.0))
  {
    GCCxx_TM = (1.0/RCCxx_TM);
  }
  else
  {
    GCCxx_TM = 0;
  }
  if ((modelPar_RCBLX>0.0))
  {
    GCCex_TM = (1.0/RCCex_TM);
  }
  else
  {
    GCCex_TM = 0;
  }
  if ((modelPar_RCBLI>0.0))
  {
    GCCin_TM = (1.0/RCCin_TM);
  }
  else
  {
    GCCin_TM = 0;
  }
  RTH_Tamb_M = (RTH_Tamb*instanceVar_invMULT);
  {
    Vb2c1 = probeVars[admsProbeID_V_b2_c1];

    Vb2c2 = probeVars[admsProbeID_V_b2_c2];

    Vb2e1 = (modelPar_TYPE*(probeVars[admsProbeID_V_b2_e1]));
    Vb1e1 = probeVars[admsProbeID_V_b1_e1];

    Vb1b2 = probeVars[admsProbeID_V_b1_b2];

    Vsc1 = (modelPar_TYPE*(probeVars[admsProbeID_V_s_c1]));
    Vc1c2 = (modelPar_TYPE*(probeVars[admsProbeID_V_c1_c2]));
    Vee1 = (modelPar_TYPE*(probeVars[admsProbeID_V_e_e1]));
    Vbb1 = (modelPar_TYPE*(probeVars[admsProbeID_V_b_b1]));
    Vbe = (modelPar_TYPE*(probeVars[admsProbeID_V_b_e]));
    Vbc = (modelPar_TYPE*(probeVars[admsProbeID_V_b_c]));
    if ((modelPar_RCBLX>0.0))
    {
      if ((modelPar_RCBLI>0.0))
      {
        Vc4c1 = (modelPar_TYPE*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = (modelPar_TYPE*(probeVars[admsProbeID_V_c3_c4]));
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = (modelPar_TYPE*(probeVars[admsProbeID_V_c3_c1]));
      }
    }
    else
    {
      if ((modelPar_RCBLI>0.0))
      {
        Vc4c1 = (modelPar_TYPE*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = 0;
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = 0;
      }
    }
    Vb1c4 = (((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);
    Vcc3 = ((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);
    Vbc3 = (Vbc+Vcc3);
    Vsc4 = (Vsc1-Vc4c1);
    Vsc3 = (Vsc4-Vc3c4);
    if (((Vb2c2*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vb2c2*VtINV));
        eVb2c2 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb2c2 = (expl*(1.0+((Vb2c2*VtINV)-400.0)));
    }
    if (((Vb2e1*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vb2e1*VtINV));
        eVb2e1 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb2e1 = (expl*(1.0+((Vb2e1*VtINV)-400.0)));
    }
    if (((Vb1e1*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vb1e1*VtINV));
        eVb1e1 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb1e1 = (expl*(1.0+((Vb1e1*VtINV)-400.0)));
    }
    if (((Vb1c4*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vb1c4*VtINV));
        eVb1c4 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb1c4 = (expl*(1.0+((Vb1c4*VtINV)-400.0)));
    }
    if (((Vb1b2*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vb1b2*VtINV));
        eVb1b2 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb1b2 = (expl*(1.0+((Vb1b2*VtINV)-400.0)));
    }
    if (((Vbc3*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vbc3*VtINV));
        eVbc3 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVbc3 = (expl*(1.0+((Vbc3*VtINV)-400.0)));
    }
    if (((Vsc1*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vsc1*VtINV));
        eVsc1 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVsc1 = (expl*(1.0+((Vsc1*VtINV)-400.0)));
    }
    if (((Vsc3*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vsc3*VtINV));
        eVsc3 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVsc3 = (expl*(1.0+((Vsc3*VtINV)-400.0)));
    }
    if (((Vsc4*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vsc4*VtINV));
        eVsc4 = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVsc4 = (expl*(1.0+((Vsc4*VtINV)-400.0)));
    }
    if ((((Vbc3-VDC_T)*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((Vbc3-VDC_T)*VtINV));
        eVbc3VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVbc3VDC = (expl*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb1c4-VDC_T)*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((Vb1c4-VDC_T)*VtINV));
        eVb1c4VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb1c4VDC = (expl*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c2-VDC_T)*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((Vb2c2-VDC_T)*VtINV));
        eVb2c2VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb2c2VDC = (expl*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0)));
    }
    if ((((Vb2c1-VDC_T)*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((Vb2c1-VDC_T)*VtINV));
        eVb2c1VDC = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      eVb2c1VDC = (expl*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0)));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt((1.0+(4.0*eVb2c2VDC)));
      K0 = value_sqrt_0;
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt((1.0+(4.0*eVb2c1VDC)));
      Kw = value_sqrt_0;
    }
    pW = ((2.0*eVb2c1VDC)/(1.0+Kw));
    {
      AdmsSensFadType value_log_0 = log(((K0+1.0)/(Kw+1.0)));
      Ec = (Vt*((K0-Kw)-value_log_0));
    }
    Ic1c2 = ((Ec+Vc1c2)/RCV_TM);
    if ((Ic1c2>0.0))
    {
      if ((Vb2c1<100.0))
      {
        tmpV = Vb2c1;
      }
      else
      {
        {
          AdmsSensFadType value_log_0 = log((1.0+(Vb2c1-100.0)));
          tmpV = (100.0+value_log_0);
        }
      }
      tmpV = tmpV;
      {
        AdmsSensFadType value_log_0 = log(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0));
        Vqs_th = ((VDC_T+((2.0*Vt)*value_log_0))-tmpV);
      }
      eps_VDC = (0.2*VDC_T);
      eps2 = (eps_VDC*eps_VDC);
      x2 = (Vqs_th*Vqs_th);
      if ((Vqs_th<0.0))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
          Vqs = ((0.5*eps2)/(value_sqrt_0-Vqs_th));
        }
      }
      else
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
          Vqs = (0.5*(value_sqrt_0+Vqs_th));
        }
      }
      Vqs = Vqs;
      Iqs = ((Vqs*(Vqs+(IHC_M*instanceVar_SCRCV_M)))/(instanceVar_SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
      Ic1c2_Iqs = (Ic1c2/Iqs);
      instanceVar_dxa = ((Ic1c2_Iqs-1.0)/modelPar_AXI);
      if ((Ic1c2_Iqs<1.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
          AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
          alpha1 = (1.0+(modelPar_AXI*value_log_1));
        }
      }
      else
      {
        {
          AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
          AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
          alpha1 = (Ic1c2_Iqs+(modelPar_AXI*value_log_1));
        }
      }
      alpha1 = alpha1;
      {
        AdmsSensFadType value_exp_0 = exp(((-1.0)/modelPar_AXI));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        alpha = (alpha1/(1.0+(modelPar_AXI*value_log_1)));
      }
      vyi = (Vqs/(IHC_M*instanceVar_SCRCV_M));
      {
        AdmsSensFadType value_sqrt_0 = sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))));
        yi = ((1.0+value_sqrt_0)/((2.0*alpha)*(1.0+vyi)));
      }
      xi_w = (((1.0-yi)+(pW*yi))/(1.0+(pW*yi)));
      gp0 = ((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV);
      gp0_help = ((2.0*gp0)+(pW*((pW+gp0)+1.0)));
      gp02 = (0.5*(gp0-1.0));
      sqr_arg = ((gp02*gp02)+gp0_help);
      if ((gp0>=1.0))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt(sqr_arg);
          p0star = (gp02+value_sqrt_0);
        }
      }
      else
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt(sqr_arg);
          p0star = (gp0_help/(value_sqrt_0-gp02));
        }
      }
      {
        AdmsSensFadType value_exp_0 = exp((VDC_T*VtINV));
        eVb2c2star = ((p0star*(p0star+1.0))*value_exp_0);
      }
      B1 = ((0.5*instanceVar_SCRCV_M)*(Ic1c2-IHC_M));
      B2 = (((instanceVar_SCRCV_M*RCV_TM)*IHC_M)*Ic1c2);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((B1*B1)+B2));
        Vxi0 = (B1+value_sqrt_0);
      }
      Vch = (VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));
      Icap = ((IHC_M*Ic1c2)/(IHC_M+Ic1c2));
      Icap_IHC = (IHC_M/(IHC_M+Ic1c2));
    }
    else
    {
      Iqs = 0.0;
      p0star = ((2.0*eVb2c2VDC)/(1.0+K0));
      eVb2c2star = eVb2c2;
      if (((fabs(Vc1c2)<(1.0e-5*Vt))||(fabs(Ec)<((1.0e-40*Vt)*(K0+Kw)))))
      {
        pav = (0.5*(p0star+pW));
        xi_w = (pav/(pav+1.0));
      }
      else
      {
        xi_w = (Ec/((Ec+Vb2c2)-Vb2c1));
      }
      Vxi0 = Vc1c2;
      Vch = (0.1*VDC_T);
      Icap = Ic1c2;
      Icap_IHC = (1.0-(Icap/IHC_M));
    }
    {
      AdmsSensFadType value_pow_0 = pow(3.0,((-1.0)/modelPar_PE));
      Vfe = (VDE_T*(1.0-value_pow_0));
    }
    a_VDE = (0.1*VDE_T);
    instanceVar_dxa = ((Vb2e1-Vfe)/a_VDE);
    if ((Vb2e1<Vfe))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vje = (Vb2e1-(a_VDE*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vje = (Vfe-(a_VDE*value_log_1));
      }
    }
    Vje = Vje;
    {
      AdmsSensFadType value_pow_0 = pow((1.0-(Vje*inv_VDE_T)),(1.0-modelPar_PE));
      E0BE = value_pow_0;
    }
    Vte = (((VDE_T/(1.0-modelPar_PE))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));
    Vjunc = (Vb2c1+Vxi0);
    bjc = ((2.0-XP_T)/(1.0-XP_T));
    {
      AdmsSensFadType value_pow_0 = pow(bjc,((-1.0)/modelPar_PC));
      Vfc = (VDC_T*(1.0-value_pow_0));
    }
    instanceVar_dxa = ((Vjunc-Vfc)/Vch);
    if ((Vjunc<Vfc))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vjc = (Vjunc-(Vch*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vjc = (Vfc-(Vch*value_log_1));
      }
    }
    Vjc = Vjc;
    {
      AdmsSensFadType value_pow_0 = pow(Icap_IHC,modelPar_MC);
      fI = value_pow_0;
    }
    {
      AdmsSensFadType value_pow_0 = pow((1.0-(Vjc/VDC_T)),(1.0-modelPar_PC));
      Vcv = (((VDC_T/(1.0-modelPar_PC))*(1.0-(fI*value_pow_0)))+((fI*bjc)*(Vjunc-Vjc)));
    }
    Vtc = (((1.0-XP_T)*Vcv)+(XP_T*Vb2c1));
    If0 = ((4.0*IS_TM)/IK_TM);
    f1 = (If0*eVb2e1);
    {
      AdmsSensFadType value_sqrt_0 = sqrt((1.0+f1));
      n0 = (f1/(1.0+value_sqrt_0));
    }
    f2 = (If0*eVb2c2star);
    {
      AdmsSensFadType value_sqrt_0 = sqrt((1.0+f2));
      nB = (f2/(1.0+value_sqrt_0));
    }
    if ((modelPar_DEG==0.0))
    {
      q0I = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    }
    else
    {
      termE = ((((Vte/VER_T)+1.0)*DEG_T)*VtINV);
      termC = ((((-Vtc)/VEF_T)*DEG_T)*VtINV);
      {
        AdmsSensFadType value_exp_0 = exp(termE);
        AdmsSensFadType value_exp_1 = exp(termC);
        AdmsSensFadType value_exp_2 = exp((DEG_T*VtINV));
        q0I = ((value_exp_0-value_exp_1)/(value_exp_2-1.0));
      }
    }
    eps2 = (0.1*0.1);
    x2 = (q0I*q0I);
    if ((q0I<0.0))
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
        q1I = ((0.5*eps2)/(value_sqrt_0-q0I));
      }
    }
    else
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
        q1I = (0.5*(value_sqrt_0+q0I));
      }
    }
    q1I = q1I;
    qBI = (q1I*(1.0+(0.5*(n0+nB))));
    Ir = (IS_TM*eVb2c2star);
    If = (IS_TM*eVb2e1);
    In = ((If-Ir)/qBI);
    Ibf0 = (IS_TM/BF_T);
    if ((modelPar_XREC==0.0))
    {
      Ib1 = (((1.0-modelPar_XIBI)*Ibf0)*(eVb2e1-1.0));
    }
    else
    {
      Ib1 = (((1.0-modelPar_XIBI)*Ibf0)*(((1.0-modelPar_XREC)*(eVb2e1-1.0))+((modelPar_XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T)))));
    }
    Ib1_s = ((modelPar_XIBI*Ibf0)*(eVb1e1-1.0));
    if ((((Vb2e1*VtINV)/modelPar_MLF)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((Vb2e1*VtINV)/modelPar_MLF));
        tmpExp = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      tmpExp = (expl*(1.0+(((Vb2e1*VtINV)/modelPar_MLF)-400.0)));
    }
    Ib2 = ((IBF_TM*(tmpExp-1.0))+(modelPar_GMIN*Vb2e1));
    if ((((0.5*Vb1c4)*VtINV)<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((0.5*Vb1c4)*VtINV));
        tmpExp = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      tmpExp = (expl*(1.0+(((0.5*Vb1c4)*VtINV)-400.0)));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.5*modelPar_VLR)*VtINV));
      Ib3 = (((IBR_TM*(eVb1c4-1.0))/(tmpExp+value_exp_0))+(modelPar_GMIN*Vb1c4));
    }
    if ((((modelPar_IZEB>0.0)&&(modelPar_NZEB>0.0))&&(Vb2e1<0)))
    {
      if (((nZEB_T*(1-(instanceVar_pow2_2mPE/(2.0*E0BE))))<400.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp((nZEB_T*(1-(instanceVar_pow2_2mPE/(2.0*E0BE)))));
          eZEB = value_exp_0;
        }
      }
      else
      {
        {
          double value_exp_0 = exp(400.0);
          expl = value_exp_0;
        }
        eZEB = (expl*(1.0+((nZEB_T*(1-(instanceVar_pow2_2mPE/(2.0*E0BE))))-400.0)));
      }
      x = (Vb2e1*inv_VDE_T);
      {
        AdmsSensFadType value_pow_0 = pow((-x),((-2.0)-modelPar_PE));
        dE0BE = ((value_pow_0*((modelPar_PE*((1-(modelPar_PE*modelPar_PE))-((3*x)*(modelPar_PE-1))))-(((6*x)*x)*((modelPar_PE-1)+x))))*0.16666666666666666667);
      }
      if (((((Vb2e1*instanceVar_pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))<400.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp((((Vb2e1*instanceVar_pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE)));
          edZEB = value_exp_0;
        }
      }
      else
      {
        {
          double value_exp_0 = exp(400.0);
          expl = value_exp_0;
        }
        edZEB = (expl*(1.0+((((Vb2e1*instanceVar_pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))-400.0)));
      }
      DZEB = ((-Vb2e1)-(((VGZEB_T*dE0BE)*(1-edZEB))/(instanceVar_pow2_2mPE*nZEB_T)));
      Izteb = ((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T)*instanceVar_pow2_PEm2);
    }
    else
    {
      DZEB = 0;
      Izteb = 0;
    }
    g1 = (If0*eVb1c4);
    g2 = (4.0*eVb1c4VDC);
    {
      AdmsSensFadType value_sqrt_0 = sqrt((1.0+g1));
      nBex = ((g1-If0)/(1.0+value_sqrt_0));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt((1.0+g2));
      pWex = (g2/(1.0+value_sqrt_0));
    }
    Iex = ((IK_TM*nBex)/(2.0*BRI_T));
    if ((modelPar_EXSUB==1.0))
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)));
        Isub = (((2.0*ISS_TM)*(eVb1c4-eVsc4))/(1.0+value_sqrt_0));
      }
    }
    else
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)));
        Isub = (((2.0*ISS_TM)*(eVb1c4-1.0))/(1.0+value_sqrt_0));
      }
    }
    if ((modelPar_ICSS<0.0))
    {
      Isf = (ISS_TM*(eVsc1-1.0));
    }
    else
    {
      Isf = (ICSS_TM*(eVsc1-1.0));
    }
    XIex = 0.0;
    XIsub = 0.0;
    if (((modelPar_EXMOD==1)||(modelPar_EXMOD==2)))
    {
      Iex = (Iex*instanceVar_Xext1);
      Isub = (Isub*instanceVar_Xext1);
      Xg1 = (If0*eVbc3);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((1.0+Xg1));
        XnBex = ((Xg1-If0)/(1.0+value_sqrt_0));
      }
      XIMex = ((((modelPar_XEXT*0.5)*IK_TM)*XnBex)/BRI_T);
      if ((modelPar_EXSUB==1.0))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)));
          XIMsub = ((((modelPar_XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))/(1.0+value_sqrt_0));
        }
      }
      else
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)));
          XIMsub = ((((modelPar_XEXT*2.0)*ISS_TM)*(eVbc3-1.0))/(1.0+value_sqrt_0));
        }
      }
      if ((modelPar_EXMOD==1))
      {
        Vex_bias = ((modelPar_XEXT*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM);
        {
          AdmsSensFadType value_log_0 = log((Vex_bias*VtINV));
          Vex = (Vt*(2.0-value_log_0));
        }
        vdif = (Vbc3-Vex);
        eps2 = (0.11*0.11);
        x2 = (vdif*vdif);
        if ((vdif<0.0))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
            VBex = ((0.5*eps2)/(value_sqrt_0-vdif));
          }
        }
        else
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
            VBex = (0.5*(value_sqrt_0+vdif));
          }
        }
        VBex = VBex;
        Fex = (VBex/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
      }
      else
      {
        Vex = 0.0;
        vdif = 0.0;
        VBex = 0.0;
        Fex = 1.0;
      }
      XIex = (Fex*XIMex);
      XIsub = (Fex*XIMsub);
    }
    else
    {
      Fex = 0;
      XnBex = 0;
    }
    q0Q = ((1.0+(Vte/VER_T))+(Vtc/VEF_T));
    eps2 = (0.1*0.1);
    x2 = (q0Q*q0Q);
    if ((q0Q<0.0))
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
        q1Q = ((0.5*eps2)/(value_sqrt_0-q0Q));
      }
    }
    else
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((x2+eps2));
        q1Q = (0.5*(value_sqrt_0+q0Q));
      }
    }
    q1Q = q1Q;
    qBQ = (q1Q*(1.0+(0.5*(n0+nB))));
    Rb2 = ((3.0*RBV_TM)/qBQ);
    Ib1b2 = ((((2.0*Vt)*(eVb1b2-1.0))+Vb1b2)/Rb2);
    Iavl = 0.0;
    Gem = 0.0;
    if (((Ic1c2>0.0)&&(Vb2c1<VDC_T)))
    {
      dEdx0 = ((2.0*modelPar_VAVL)/(modelPar_WAVL*modelPar_WAVL));
      sqr_arg = ((VDC_T-Vb2c1)/Icap_IHC);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((2.0*sqr_arg)/dEdx0));
        xd = value_sqrt_0;
      }
      if ((modelPar_EXAVL==0.0))
      {
        Weff = modelPar_WAVL;
      }
      else
      {
        xi_w1 = (1.0-(0.5*xi_w));
        Weff = ((modelPar_WAVL*xi_w1)*xi_w1);
      }
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((xd*xd)+(Weff*Weff)));
        Wd = ((xd*Weff)/value_sqrt_0);
      }
      Eav = ((VDC_T-Vb2c1)/Wd);
      E0 = (Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
      if ((modelPar_EXAVL==0))
      {
        Em = E0;
      }
      else
      {
        SHw = (1.0+((2.0*modelPar_SFH)*(1.0+(2.0*xi_w))));
        Efi = ((1.0+modelPar_SFH)/(1.0+(2.0*modelPar_SFH)));
        Ew = (Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw)))));
        sqr_arg = (((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/IHC_M));
        {
          AdmsSensFadType value_sqrt_0 = sqrt(sqr_arg);
          Em = (0.5*((Ew+E0)+value_sqrt_0));
        }
      }
      EmEav_Em = ((Em-Eav)/Em);
      if ((fabs(EmEav_Em)>1.0e-7))
      {
        lambda = ((0.5*Wd)/EmEav_Em);
        {
          AdmsSensFadType value_exp_0 = exp(((-BnT)/Em));
          AdmsSensFadType value_exp_1 = exp((((-BnT)/Em)*(1.0+(Weff/lambda))));
          Gem = ((((instanceVar_An/BnT)*Em)*lambda)*(value_exp_0-value_exp_1));
        }
      }
      else
      {
        {
          AdmsSensFadType value_exp_0 = exp(((-BnT)/Em));
          Gem = ((instanceVar_An*Weff)*value_exp_0);
        }
      }
      Gmax = (((Vt/(Ic1c2*(RBC_TM+Rb2)))+(qBI/BF_T))+(RE_TM/(RBC_TM+Rb2)));
      Iavl = ((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0));
    }
    if ((eVb2c2star>0.0))
    {
      {
        AdmsSensFadType value_log_0 = log(eVb2c2star);
        Vb2c2star = (Vt*value_log_0);
      }
    }
    else
    {
      Vb2c2star = Vb2c2;
    }
    power = ((((((((((((((((In*(Vb2e1-Vb2c2star))+(Ic1c2*(Vb2c2star-Vb2c1)))-(Iavl*Vb2c2star))+((Vee1*Vee1)/RE_TM))+((Vcc3*Vcc3)*GCCxx_TM))+((Vc3c4*Vc3c4)*GCCex_TM))+((Vc4c1*Vc4c1)*GCCin_TM))+((Vbb1*Vbb1)/RBC_TM))+(Ib1b2*Vb1b2))+(((Ib1+Ib2)-Izteb)*Vb2e1))+(Ib1_s*Vb1e1))+((Iex+Ib3)*Vb1c4))+(XIex*Vbc3))+(Isub*(Vb1c4-Vsc4)))+(XIsub*(Vbc3-Vsc3)))+(Isf*Vsc1));
    Qte = (((1.0-modelPar_XCJE)*CJE_TM)*Vte);
    instanceVar_dxa = ((Vb1e1-Vfe)/a_VDE);
    if ((Vb1e1<Vfe))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vje_s = (Vb1e1-(a_VDE*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vje_s = (Vfe-(a_VDE*value_log_1));
      }
    }
    Vje_s = Vje_s;
    {
      AdmsSensFadType value_pow_0 = pow((1.0-(Vje_s*inv_VDE_T)),(1.0-modelPar_PE));
      Qte_s = ((modelPar_XCJE*CJE_TM)*(((VDE_T/(1.0-modelPar_PE))*(1.0-value_pow_0))+(3.0*(Vb1e1-Vje_s))));
    }
    Qtc = ((modelPar_XCJC*CJC_TM)*Vtc);
    Qb0 = (TAUB_T*IK_TM);
    Qbe_qs = (((0.5*Qb0)*n0)*q1Q);
    Qbc_qs = (((0.5*Qb0)*nB)*q1Q);
    a_VDC = (0.1*VDC_T);
    instanceVar_dxa = ((Vb1c4-Vfc)/a_VDC);
    if ((Vb1c4<Vfc))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vjcex = (Vb1c4-(a_VDC*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vjcex = (Vfc-(a_VDC*value_log_1));
      }
    }
    Vjcex = Vjcex;
    {
      AdmsSensFadType value_pow_0 = pow((1.0-(Vjcex/VDC_T)),(1.0-modelPar_PC));
      Vtexv = (((VDC_T/(1.0-modelPar_PC))*(1.0-value_pow_0))+(bjc*(Vb1c4-Vjcex)));
    }
    Qtex = (((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-modelPar_XCJC))*(1.0-modelPar_XEXT));
    instanceVar_dxa = ((Vbc3-Vfc)/a_VDC);
    if ((Vbc3<Vfc))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        XVjcex = (Vbc3-(a_VDC*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        XVjcex = (Vfc-(a_VDC*value_log_1));
      }
    }
    XVjcex = XVjcex;
    {
      AdmsSensFadType value_pow_0 = pow((1.0-(XVjcex/VDC_T)),(1.0-modelPar_PC));
      XVtexv = (((VDC_T/(1.0-modelPar_PC))*(1.0-value_pow_0))+(bjc*(Vbc3-XVjcex)));
    }
    XQtex = (((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-modelPar_XCJC))*modelPar_XEXT);
    a_VDS = (0.1*VDS_T);
    {
      AdmsSensFadType value_pow_0 = pow(2.0,((-1.0)/modelPar_PS));
      Vfs = (VDS_T*(1.0-value_pow_0));
    }
    instanceVar_dxa = ((Vsc1-Vfs)/a_VDS);
    if ((Vsc1<Vfs))
    {
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_dxa);
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vjs = (Vsc1-(a_VDS*value_log_1));
      }
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp((-instanceVar_dxa));
        AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
        Vjs = (Vfs-(a_VDS*value_log_1));
      }
    }
    Vjs = Vjs;
    {
      AdmsSensFadType value_pow_0 = pow((1.0-(Vjs/VDS_T)),(1.0-modelPar_PS));
      Qts = (CJS_TM*(((VDS_T/(1.0-modelPar_PS))*(1.0-value_pow_0))+(2.0*(Vsc1-Vjs))));
    }
    {
      AdmsSensFadType value_pow_0 = pow((IS_TM/IK_TM),(1.0/modelPar_MTAU));
      Qe0 = ((TAUE_T*IK_TM)*value_pow_0);
    }
    if (((Vb2e1/(modelPar_MTAU*Vt))<400.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp((Vb2e1/(modelPar_MTAU*Vt)));
        tmpExp = value_exp_0;
      }
    }
    else
    {
      {
        double value_exp_0 = exp(400.0);
        expl = value_exp_0;
      }
      tmpExp = (expl*(1.0+((Vb2e1/(modelPar_MTAU*Vt))-400.0)));
    }
    Qe_qs = (Qe0*tmpExp);
    Qepi0 = (((4.0*TEPI_T)*Vt)/RCV_TM);
    Qepi = (((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));
    Qex = (((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(TAUB_T+TEPI_T));
    XQex = 0.0;
    if ((modelPar_EXMOD==1))
    {
      Qex = (Qex*(1.0-modelPar_XEXT));
      Xg2 = (4.0*eVbc3VDC);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((1.0+Xg2));
        XpWex = (Xg2/(1.0+value_sqrt_0));
      }
      XQex = (((((0.5*Fex)*modelPar_XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(TAUB_T+TEPI_T));
    }
    Qb1b2 = 0.0;
    if ((modelPar_EXPHI==1))
    {
      {
        AdmsSensFadType value_pow_0 = pow((1.0-(Vje*inv_VDE_T)),(-modelPar_PE));
        dVteVje = (value_pow_0-3.0);
      }
      Vb2e1Vfe = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1Vfe<0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(Vb2e1Vfe);
          dVjeVb2e1 = (1.0/(1.0+value_exp_0));
        }
      }
      else
      {
        {
          AdmsSensFadType value_exp_0 = exp((-Vb2e1Vfe));
          AdmsSensFadType value_exp_1 = exp((-Vb2e1Vfe));
          dVjeVb2e1 = (value_exp_0/(1.0+value_exp_1));
        }
      }
      dVteVb2e1 = ((dVteVje*dVjeVb2e1)+3.0);
      dQteVb2e1 = (((1.0-modelPar_XCJE)*CJE_TM)*dVteVb2e1);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((1.0+f1));
        dn0Vb2e1 = (((If0*eVb2e1)*VtINV)*(0.5/value_sqrt_0));
      }
      dQbeVb2e1 = (((0.5*Qb0)*q1Q)*dn0Vb2e1);
      dQeVb2e1 = (Qe_qs/(modelPar_MTAU*Vt));
      Qb1b2 = ((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));
      Qe = ((1-modelPar_KE)*Qe_qs);
      Qbe_qs_eff = (Qbe_qs+(modelPar_KE*Qe_qs));
      Qbc = ((modelPar_XQB*Qbe_qs_eff)+Qbc_qs);
      Qbe = ((1-modelPar_XQB)*Qbe_qs_eff);
    }
    else
    {
      Qbe = Qbe_qs;
      Qbc = Qbc_qs;
      Qe = Qe_qs;
    }
    // I(c1,c2) <+ ((TYPE*Ic1c2))
    staticContributions[admsNodeID_c1] += (modelPar_TYPE*Ic1c2);
    staticContributions[admsNodeID_c2] -= (modelPar_TYPE*Ic1c2);
    // I(c2,e1) <+ ((TYPE*In))
    staticContributions[admsNodeID_c2] += (modelPar_TYPE*In);
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*In);
    // I(b1,e1) <+ ((TYPE*Ib1_s))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Ib1_s);
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*Ib1_s);
    // I(b2,e1) <+ ((TYPE*((Ib1+Ib2)-Izteb)))
    staticContributions[admsNodeID_b2] += (modelPar_TYPE*((Ib1+Ib2)-Izteb));
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*((Ib1+Ib2)-Izteb));
    // I(b1,s) <+ ((TYPE*Isub))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Isub);
    staticContributions[admsNodeID_s] -= (modelPar_TYPE*Isub);
    // I(b,s) <+ ((TYPE*XIsub))
    staticContributions[admsNodeID_b] += (modelPar_TYPE*XIsub);
    staticContributions[admsNodeID_s] -= (modelPar_TYPE*XIsub);
    // I(s,c1) <+ ((TYPE*Isf))
    staticContributions[admsNodeID_s] += (modelPar_TYPE*Isf);
    staticContributions[admsNodeID_c1] -= (modelPar_TYPE*Isf);
    // I(b1,b2) <+ ((TYPE*Ib1b2))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Ib1b2);
    staticContributions[admsNodeID_b2] -= (modelPar_TYPE*Ib1b2);
    // I(b2,c2) <+ ((TYPE*((-1.0)*Iavl)))
    staticContributions[admsNodeID_b2] += (modelPar_TYPE*((-1.0)*Iavl));
    staticContributions[admsNodeID_c2] -= (modelPar_TYPE*((-1.0)*Iavl));
    // I(e,e1) <+ (((TYPE*Vee1)/RE_TM))
    staticContributions[admsNodeID_e] += ((modelPar_TYPE*Vee1)/RE_TM);
    staticContributions[admsNodeID_e1] -= ((modelPar_TYPE*Vee1)/RE_TM);
    // I(b,b1) <+ (((TYPE*Vbb1)/RBC_TM))
    staticContributions[admsNodeID_b] += ((modelPar_TYPE*Vbb1)/RBC_TM);
    staticContributions[admsNodeID_b1] -= ((modelPar_TYPE*Vbb1)/RBC_TM);
    // I(dt,GND) <+ ((V(dt,GND)/RTH_Tamb_M))
    staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_V_dt_GND])/RTH_Tamb_M);
    // I(dt,GND) <+ (ddt((CTH_M*V(dt,GND))))
    dynamicContributions[admsNodeID_dt] += ((instanceVar_CTH_M*(probeVars[admsProbeID_V_dt_GND])));
    // I(dt,GND) <+ (((-1.0)*power))
    staticContributions[admsNodeID_dt] += ((-1.0)*power);
    // I(b2,e1) <+ (ddt((TYPE*((Qte+Qbe)+Qe))))
    dynamicContributions[admsNodeID_b2] += ((modelPar_TYPE*((Qte+Qbe)+Qe)));
    dynamicContributions[admsNodeID_e1] -= ((modelPar_TYPE*((Qte+Qbe)+Qe)));
    // I(b1,e1) <+ (ddt((TYPE*Qte_s)))
    dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*Qte_s));
    dynamicContributions[admsNodeID_e1] -= ((modelPar_TYPE*Qte_s));
    // I(b2,c2) <+ (ddt((TYPE*((Qtc+Qbc)+Qepi))))
    dynamicContributions[admsNodeID_b2] += ((modelPar_TYPE*((Qtc+Qbc)+Qepi)));
    dynamicContributions[admsNodeID_c2] -= ((modelPar_TYPE*((Qtc+Qbc)+Qepi)));
    // I(s,c1) <+ (ddt((TYPE*Qts)))
    dynamicContributions[admsNodeID_s] += ((modelPar_TYPE*Qts));
    dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*Qts));
    // I(b1,b2) <+ (ddt((TYPE*Qb1b2)))
    dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*Qb1b2));
    dynamicContributions[admsNodeID_b2] -= ((modelPar_TYPE*Qb1b2));
    // I(b,e) <+ (ddt(((TYPE*CBEO_M)*Vbe)))
    dynamicContributions[admsNodeID_b] += (((modelPar_TYPE*instanceVar_CBEO_M)*Vbe));
    dynamicContributions[admsNodeID_e] -= (((modelPar_TYPE*instanceVar_CBEO_M)*Vbe));
    // I(b,c) <+ (ddt(((TYPE*CBCO_M)*Vbc)))
    dynamicContributions[admsNodeID_b] += (((modelPar_TYPE*instanceVar_CBCO_M)*Vbc));
    dynamicContributions[admsNodeID_c] -= (((modelPar_TYPE*instanceVar_CBCO_M)*Vbc));
  }
  if ((modelPar_RCBLX>0.0))
  {
    // I(b,c3) <+ ((TYPE*XIex))
    staticContributions[admsNodeID_b] += (modelPar_TYPE*XIex);
    staticContributions[admsNodeID_c3] -= (modelPar_TYPE*XIex);
    // I(c,c3) <+ (((TYPE*Vcc3)*GCCxx_TM))
    staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*GCCxx_TM);
    staticContributions[admsNodeID_c3] -= ((modelPar_TYPE*Vcc3)*GCCxx_TM);
    // I(b,c3) <+ (ddt((TYPE*(XQtex+XQex))))
    dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
    dynamicContributions[admsNodeID_c3] -= ((modelPar_TYPE*(XQtex+XQex)));
    if ((modelPar_RCBLI>0.0))
    {
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*(Ib3+Iex));
      // I(c3,c4) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c4] -= ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(Qtex+Qex)));
    }
    else
    {
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*(Ib3+Iex));
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc3c4)*GCCex_TM);
    }
  }
  else
  {
    // V(c3,c4) <+ (0)
    // do nothing at all
    if ((modelPar_RCBLI>0.0))
    {
      // I(b,c4) <+ ((TYPE*XIex))
      staticContributions[admsNodeID_b] += (modelPar_TYPE*XIex);
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*XIex);
      // I(c,c4) <+ (((TYPE*Vcc3)*GCCxx_TM))
      staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      staticContributions[admsNodeID_c4] -= ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc4c1)*GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*(Ib3+Iex));
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(b,c4) <+ (ddt((TYPE*(XQtex+XQex))))
      dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(XQtex+XQex)));
    }
    else
    {
      // I(b,c1) <+ ((TYPE*XIex))
      staticContributions[admsNodeID_b] += (modelPar_TYPE*XIex);
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*XIex);
      // I(c,c1) <+ (((TYPE*Vcc3)*GCCxx_TM))
      staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vcc3)*GCCxx_TM);
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(Ib3+Iex));
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*(Ib3+Iex));
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(b,c1) <+ (ddt((TYPE*(XQtex+XQex))))
      dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(XQtex+XQex)));
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*GCCex_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc3c4)*GCCex_TM);
    }
  }
  {
    common = ((4.0*1.3806226e-23)*Tk);
    powerREC = (common/RE_TM);
    powerRBC = (common/RBC_TM);
    powerRCCxx = (common*GCCxx_TM);
    powerRCCex = (common*GCCex_TM);
    powerRCCin = (common*GCCin_TM);
    powerRBV = (((common/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    In_N = ((If+Ir)/qBI);
    {
      AdmsSensFadType value_fabs_0 = fabs(In_N);
      powerCCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    if ((modelPar_KAVL>0))
    {
      {
        AdmsSensFadType value_fabs_0 = fabs((Iavl/In_N));
        Gem_N = value_fabs_0;
      }
    }
    else
    {
      Gem_N = 0.0;
    }
    powerIIS = (((2.0*1.6021918e-19)*Iavl)*(Gem_N+1));
    if ((In_N>0.0))
    {
      Taub_N = ((Qbe+Qbc)/In_N);
    }
    else
    {
      Taub_N = ((TAUB_T*q1Q)*qBI);
    }
    if ((modelPar_KC==1))
    {
      taun = (modelPar_XQB*Taub_N);
    }
    else
    {
      if ((modelPar_KC==2))
      {
        taun = (modelPar_FTAUN*Taub_N);
      }
      else
      {
        taun = 0;
      }
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Ib1);
      AdmsSensFadType value_fabs_1 = fabs(Ib2);
      AdmsSensFadType value_fabs_2 = fabs(Izteb);
      powerFBCS = ((2.0*1.6021918e-19)*((value_fabs_0+value_fabs_1)+value_fabs_2));
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Ib1);
      AdmsSensFadType value_pow_1 = pow((value_fabs_0/(1-modelPar_XIBI)),modelPar_AF);
      powerFBC1fB1 = (((1.0-modelPar_XIBI)*value_pow_1)*instanceVar_KF_M);
    }
    exponentFBC1fB2 = ((2.0*(modelPar_MLF-1.0))+(modelPar_AF*(2.0-modelPar_MLF)));
    {
      AdmsSensFadType value_fabs_0 = fabs(Ib2);
      AdmsSensFadType value_pow_1 = pow(value_fabs_0,exponentFBC1fB2);
      powerFBC1fB2 = (instanceVar_KFN_M*value_pow_1);
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Ib1_s);
      powerEBSCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    if ((modelPar_XIBI==0))
    {
      powerEBSC1f = 0.0;
    }
    else
    {
      {
        AdmsSensFadType value_fabs_0 = fabs((Ib1_s/modelPar_XIBI));
        AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelPar_AF);
        powerEBSC1f = ((instanceVar_KF_M*modelPar_XIBI)*value_pow_1);
      }
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Ib3);
      powerRBCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Ib3);
      AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelPar_AF);
      powerRBC1f = (instanceVar_KF_M*value_pow_1);
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Iex);
      powerExCS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Iex);
      AdmsSensFadType value_pow_1 = pow((value_fabs_0/(1-(modelPar_EXMOD*modelPar_XEXT))),modelPar_AF);
      powerExC1f = ((instanceVar_KF_M*(1-(modelPar_EXMOD*modelPar_XEXT)))*value_pow_1);
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(XIex);
      powerExCSMOD = (((2.0*1.6021918e-19)*value_fabs_0)*modelPar_EXMOD);
    }
    if ((modelPar_XEXT==0.0))
    {
      powerExC1fMOD = 0.0;
    }
    else
    {
      {
        AdmsSensFadType value_fabs_0 = fabs(XIex);
        AdmsSensFadType value_pow_1 = pow((value_fabs_0/modelPar_XEXT),modelPar_AF);
        powerExC1fMOD = (((instanceVar_KF_M*modelPar_EXMOD)*modelPar_XEXT)*value_pow_1);
      }
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(Isub);
      powerSubsCS_B1S = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    {
      AdmsSensFadType value_fabs_0 = fabs(XIsub);
      powerSubsCS_BS = ((2.0*1.6021918e-19)*value_fabs_0);
    }
    // I(noi,GND) <+ (white_noise(powerCCS))
    // I(noi,GND) <+ (V(noi,GND))
    staticContributions[admsNodeID_noi] += (probeVars[admsProbeID_V_noi_GND]);
    // I(b2,e1) <+ ((taun*ddt(V(noi,GND))))
    dynamicContributions[admsNodeID_b2] += (taun*((probeVars[admsProbeID_V_noi_GND])));
    dynamicContributions[admsNodeID_e1] -= (taun*((probeVars[admsProbeID_V_noi_GND])));
    // I(c2,b2) <+ ((Gem_N*V(noi,GND)))
    staticContributions[admsNodeID_c2] += (Gem_N*(probeVars[admsProbeID_V_noi_GND]));
    staticContributions[admsNodeID_b2] -= (Gem_N*(probeVars[admsProbeID_V_noi_GND]));
    // I(c2,e1) <+ (V(noi,GND))
    staticContributions[admsNodeID_c2] += (probeVars[admsProbeID_V_noi_GND]);
    staticContributions[admsNodeID_e1] -= (probeVars[admsProbeID_V_noi_GND]);
    // I(c2,b2) <+ (white_noise(powerIIS))
    // I(b2,e1) <+ (white_noise(powerFBCS))
    // I(e,e1) <+ (white_noise(powerREC))
    // I(b,b1) <+ (white_noise(powerRBC))
    // I(b1,b2) <+ (white_noise(powerRBV))
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB1,1))
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB2,1))
    // I(e1,b1) <+ (white_noise(powerEBSCS))
    // I(e1,b1) <+ (flicker_noise(powerEBSC1f,1))
    // I(b1,c4) <+ (white_noise(powerRBCS))
    // I(b1,c4) <+ (flicker_noise(powerRBC1f,1))
    // I(b1,c4) <+ (white_noise(powerExCS))
    // I(b1,c4) <+ (flicker_noise(powerExC1f,1))
    // I(b,c3) <+ (white_noise(powerExCSMOD))
    // I(b,c3) <+ (flicker_noise(powerExC1fMOD,1))
    // I(b1,s) <+ (white_noise(powerSubsCS_B1S))
    // I(b,s) <+ (white_noise(powerSubsCS_BS))
    if ((modelPar_RCBLX>0.0))
    {
      if ((modelPar_RCBLI>0.0))
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        // I(c3,c4) <+ (white_noise(powerRCCex))
        // I(c4,c1) <+ (white_noise(powerRCCin))
      }
      else
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        // I(c3,c1) <+ (white_noise(powerRCCex))
      }
    }
    else
    {
      if ((modelPar_RCBLI>0.0))
      {
        // I(c,c4) <+ (white_noise(powerRCCxx))
        // I(c4,c1) <+ (white_noise(powerRCCin))
      }
      else
      {
        // I(c,c1) <+ (white_noise(powerRCCxx))
      }
    }
  }
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(13+0);
  dqdp.resize(13+0);
  Findices.resize(13+0);
  Qindices.resize(13+0);

  std::vector <double> probeVars(16);
  std::vector <AdmsSensFadType> staticContributions(13+0);
  std::vector <AdmsSensFadType> dynamicContributions(13+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_TREF=mod.TREF;
  bool modelPar_given_TREF=mod.given("TREF");
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  AdmsSensFadType modelPar_IK=mod.IK;
  bool modelPar_given_IK=mod.given("IK");
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  AdmsSensFadType modelPar_BF=mod.BF;
  bool modelPar_given_BF=mod.given("BF");
  AdmsSensFadType modelPar_IBF=mod.IBF;
  bool modelPar_given_IBF=mod.given("IBF");
  AdmsSensFadType modelPar_MLF=mod.MLF;
  bool modelPar_given_MLF=mod.given("MLF");
  AdmsSensFadType modelPar_XIBI=mod.XIBI;
  bool modelPar_given_XIBI=mod.given("XIBI");
  AdmsSensFadType modelPar_IZEB=mod.IZEB;
  bool modelPar_given_IZEB=mod.given("IZEB");
  AdmsSensFadType modelPar_NZEB=mod.NZEB;
  bool modelPar_given_NZEB=mod.given("NZEB");
  AdmsSensFadType modelPar_BRI=mod.BRI;
  bool modelPar_given_BRI=mod.given("BRI");
  AdmsSensFadType modelPar_IBR=mod.IBR;
  bool modelPar_given_IBR=mod.given("IBR");
  AdmsSensFadType modelPar_VLR=mod.VLR;
  bool modelPar_given_VLR=mod.given("VLR");
  AdmsSensFadType modelPar_XEXT=mod.XEXT;
  bool modelPar_given_XEXT=mod.given("XEXT");
  AdmsSensFadType modelPar_WAVL=mod.WAVL;
  bool modelPar_given_WAVL=mod.given("WAVL");
  AdmsSensFadType modelPar_VAVL=mod.VAVL;
  bool modelPar_given_VAVL=mod.given("VAVL");
  AdmsSensFadType modelPar_SFH=mod.SFH;
  bool modelPar_given_SFH=mod.given("SFH");
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  AdmsSensFadType modelPar_RBC=mod.RBC;
  bool modelPar_given_RBC=mod.given("RBC");
  AdmsSensFadType modelPar_RBV=mod.RBV;
  bool modelPar_given_RBV=mod.given("RBV");
  AdmsSensFadType modelPar_RCC=mod.RCC;
  bool modelPar_given_RCC=mod.given("RCC");
  AdmsSensFadType modelPar_RCV=mod.RCV;
  bool modelPar_given_RCV=mod.given("RCV");
  AdmsSensFadType modelPar_SCRCV=mod.SCRCV;
  bool modelPar_given_SCRCV=mod.given("SCRCV");
  AdmsSensFadType modelPar_IHC=mod.IHC;
  bool modelPar_given_IHC=mod.given("IHC");
  AdmsSensFadType modelPar_AXI=mod.AXI;
  bool modelPar_given_AXI=mod.given("AXI");
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  AdmsSensFadType modelPar_VDE=mod.VDE;
  bool modelPar_given_VDE=mod.given("VDE");
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  AdmsSensFadType modelPar_XCJE=mod.XCJE;
  bool modelPar_given_XCJE=mod.given("XCJE");
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  AdmsSensFadType modelPar_VDC=mod.VDC;
  bool modelPar_given_VDC=mod.given("VDC");
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  AdmsSensFadType modelPar_XP=mod.XP;
  bool modelPar_given_XP=mod.given("XP");
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  AdmsSensFadType modelPar_XCJC=mod.XCJC;
  bool modelPar_given_XCJC=mod.given("XCJC");
  AdmsSensFadType modelPar_RCBLX=mod.RCBLX;
  bool modelPar_given_RCBLX=mod.given("RCBLX");
  AdmsSensFadType modelPar_RCBLI=mod.RCBLI;
  bool modelPar_given_RCBLI=mod.given("RCBLI");
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  AdmsSensFadType modelPar_MTAU=mod.MTAU;
  bool modelPar_given_MTAU=mod.given("MTAU");
  AdmsSensFadType modelPar_TAUE=mod.TAUE;
  bool modelPar_given_TAUE=mod.given("TAUE");
  AdmsSensFadType modelPar_TAUB=mod.TAUB;
  bool modelPar_given_TAUB=mod.given("TAUB");
  AdmsSensFadType modelPar_TEPI=mod.TEPI;
  bool modelPar_given_TEPI=mod.given("TEPI");
  AdmsSensFadType modelPar_TAUR=mod.TAUR;
  bool modelPar_given_TAUR=mod.given("TAUR");
  AdmsSensFadType modelPar_DEG=mod.DEG;
  bool modelPar_given_DEG=mod.given("DEG");
  AdmsSensFadType modelPar_XREC=mod.XREC;
  bool modelPar_given_XREC=mod.given("XREC");
  AdmsSensFadType modelPar_XQB=mod.XQB;
  bool modelPar_given_XQB=mod.given("XQB");
  AdmsSensFadType modelPar_AQBO=mod.AQBO;
  bool modelPar_given_AQBO=mod.given("AQBO");
  AdmsSensFadType modelPar_AE=mod.AE;
  bool modelPar_given_AE=mod.given("AE");
  AdmsSensFadType modelPar_AB=mod.AB;
  bool modelPar_given_AB=mod.given("AB");
  AdmsSensFadType modelPar_AEPI=mod.AEPI;
  bool modelPar_given_AEPI=mod.given("AEPI");
  AdmsSensFadType modelPar_AEX=mod.AEX;
  bool modelPar_given_AEX=mod.given("AEX");
  AdmsSensFadType modelPar_AC=mod.AC;
  bool modelPar_given_AC=mod.given("AC");
  AdmsSensFadType modelPar_ACBL=mod.ACBL;
  bool modelPar_given_ACBL=mod.given("ACBL");
  AdmsSensFadType modelPar_DVGBF=mod.DVGBF;
  bool modelPar_given_DVGBF=mod.given("DVGBF");
  AdmsSensFadType modelPar_DVGBR=mod.DVGBR;
  bool modelPar_given_DVGBR=mod.given("DVGBR");
  AdmsSensFadType modelPar_VGB=mod.VGB;
  bool modelPar_given_VGB=mod.given("VGB");
  AdmsSensFadType modelPar_VGC=mod.VGC;
  bool modelPar_given_VGC=mod.given("VGC");
  AdmsSensFadType modelPar_VGJ=mod.VGJ;
  bool modelPar_given_VGJ=mod.given("VGJ");
  AdmsSensFadType modelPar_VGZEB=mod.VGZEB;
  bool modelPar_given_VGZEB=mod.given("VGZEB");
  AdmsSensFadType modelPar_AVGEB=mod.AVGEB;
  bool modelPar_given_AVGEB=mod.given("AVGEB");
  AdmsSensFadType modelPar_TVGEB=mod.TVGEB;
  bool modelPar_given_TVGEB=mod.given("TVGEB");
  AdmsSensFadType modelPar_DVGTE=mod.DVGTE;
  bool modelPar_given_DVGTE=mod.given("DVGTE");
  AdmsSensFadType modelPar_DAIS=mod.DAIS;
  bool modelPar_given_DAIS=mod.given("DAIS");
  AdmsSensFadType modelPar_AF=mod.AF;
  bool modelPar_given_AF=mod.given("AF");
  AdmsSensFadType modelPar_KF=mod.KF;
  bool modelPar_given_KF=mod.given("KF");
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  AdmsSensFadType modelPar_KE=mod.KE;
  bool modelPar_given_KE=mod.given("KE");
  AdmsSensFadType modelPar_FTAUN=mod.FTAUN;
  bool modelPar_given_FTAUN=mod.given("FTAUN");
  AdmsSensFadType modelPar_ISS=mod.ISS;
  bool modelPar_given_ISS=mod.given("ISS");
  AdmsSensFadType modelPar_ICSS=mod.ICSS;
  bool modelPar_given_ICSS=mod.given("ICSS");
  AdmsSensFadType modelPar_IKS=mod.IKS;
  bool modelPar_given_IKS=mod.given("IKS");
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  AdmsSensFadType modelPar_VDS=mod.VDS;
  bool modelPar_given_VDS=mod.given("VDS");
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  AdmsSensFadType modelPar_VGS=mod.VGS;
  bool modelPar_given_VGS=mod.given("VGS");
  AdmsSensFadType modelPar_AS=mod.AS;
  bool modelPar_given_AS=mod.given("AS");
  AdmsSensFadType modelPar_ASUB=mod.ASUB;
  bool modelPar_given_ASUB=mod.given("ASUB");
  AdmsSensFadType modelPar_RTH=mod.RTH;
  bool modelPar_given_RTH=mod.given("RTH");
  AdmsSensFadType modelPar_CTH=mod.CTH;
  bool modelPar_given_CTH=mod.given("CTH");
  AdmsSensFadType modelPar_ATH=mod.ATH;
  bool modelPar_given_ATH=mod.given("ATH");
  AdmsSensFadType modelPar_MULT=mod.MULT;
  bool modelPar_given_MULT=mod.given("MULT");
  AdmsSensFadType modelPar_GMIN=mod.GMIN;
  bool modelPar_given_GMIN=mod.given("GMIN");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_EXMOD=mod.EXMOD;
  bool modelPar_given_EXMOD=mod.given("EXMOD");
  int modelPar_EXPHI=mod.EXPHI;
  bool modelPar_given_EXPHI=mod.given("EXPHI");
  int modelPar_EXAVL=mod.EXAVL;
  bool modelPar_given_EXAVL=mod.given("EXAVL");
  int modelPar_EXSUB=mod.EXSUB;
  bool modelPar_given_EXSUB=mod.given("EXSUB");
  int modelPar_KAVL=mod.KAVL;
  bool modelPar_given_KAVL=mod.given("KAVL");
  int modelPar_KC=mod.KC;
  bool modelPar_given_KC=mod.given("KC");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_MULT=in.MULT;
  bool instancePar_given_MULT=in.given("MULT");
  inParamMap["MULT"] = &instancePar_MULT;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_An=in.An;
  AdmsSensFadType instanceVar_Bn=in.Bn;
  AdmsSensFadType instanceVar_Trk=in.Trk;
  AdmsSensFadType instanceVar_Tamb=in.Tamb;
  AdmsSensFadType instanceVar_pow2_2mPE=in.pow2_2mPE;
  AdmsSensFadType instanceVar_pow2_PEm2=in.pow2_PEm2;
  AdmsSensFadType instanceVar_inv_VDE=in.inv_VDE;
  AdmsSensFadType instanceVar_inv_VGZEB_Tr=in.inv_VGZEB_Tr;
  AdmsSensFadType instanceVar_VGZEBOK=in.VGZEBOK;
  AdmsSensFadType instanceVar_invMULT=in.invMULT;
  AdmsSensFadType instanceVar_SCRCV_M=in.SCRCV_M;
  AdmsSensFadType instanceVar_KF_M=in.KF_M;
  AdmsSensFadType instanceVar_KFN_M=in.KFN_M;
  AdmsSensFadType instanceVar_CTH_M=in.CTH_M;
  AdmsSensFadType instanceVar_Xext1=in.Xext1;
  AdmsSensFadType instanceVar_CBEO_M=in.CBEO_M;
  AdmsSensFadType instanceVar_CBCO_M=in.CBCO_M;
  AdmsSensFadType instanceVar_dxa=in.dxa;


  //non-reals


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_noi_GND] = (*solVectorPtr)[in.li_noi];
  probeVars[in.admsProbeID_V_c3_c1] = (*solVectorPtr)[in.li_c3]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_c3_c4] = (*solVectorPtr)[in.li_c3]- (*solVectorPtr)[in.li_c4];
  probeVars[in.admsProbeID_V_c4_c1] = (*solVectorPtr)[in.li_c4]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_b_b1] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_b1];
  probeVars[in.admsProbeID_V_e_e1] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_c1_c2] = (*solVectorPtr)[in.li_c1]- (*solVectorPtr)[in.li_c2];
  probeVars[in.admsProbeID_V_s_c1] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_b1_b2] = (*solVectorPtr)[in.li_b1]- (*solVectorPtr)[in.li_b2];
  probeVars[in.admsProbeID_V_b1_e1] = (*solVectorPtr)[in.li_b1]- (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_b2_e1] = (*solVectorPtr)[in.li_b2]- (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_b2_c2] = (*solVectorPtr)[in.li_b2]- (*solVectorPtr)[in.li_c2];
  probeVars[in.admsProbeID_V_b2_c1] = (*solVectorPtr)[in.li_b2]- (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_dt_GND] = (*solVectorPtr)[in.li_dt];


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")

  probeVars[in.admsProbeID_V_b1_b2] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b1_e1] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b2_c2] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b2_c1] *= modelPar_TYPE;

  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_An,
     instanceVar_Bn,
     instanceVar_Trk,
     instanceVar_Tamb,
     instanceVar_pow2_2mPE,
     instanceVar_pow2_PEm2,
     instanceVar_inv_VDE,
     instanceVar_inv_VGZEB_Tr,
     instanceVar_VGZEBOK,
     instanceVar_invMULT,
     instanceVar_SCRCV_M,
     instanceVar_KF_M,
     instanceVar_KFN_M,
     instanceVar_CTH_M,
     instanceVar_Xext1,
     instanceVar_CBEO_M,
     instanceVar_CBCO_M,
     instanceVar_dxa,
     // model parameters
     // reals
     modelPar_TREF,
     modelPar_given_TREF,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_IK,
     modelPar_given_IK,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_BF,
     modelPar_given_BF,
     modelPar_IBF,
     modelPar_given_IBF,
     modelPar_MLF,
     modelPar_given_MLF,
     modelPar_XIBI,
     modelPar_given_XIBI,
     modelPar_IZEB,
     modelPar_given_IZEB,
     modelPar_NZEB,
     modelPar_given_NZEB,
     modelPar_BRI,
     modelPar_given_BRI,
     modelPar_IBR,
     modelPar_given_IBR,
     modelPar_VLR,
     modelPar_given_VLR,
     modelPar_XEXT,
     modelPar_given_XEXT,
     modelPar_WAVL,
     modelPar_given_WAVL,
     modelPar_VAVL,
     modelPar_given_VAVL,
     modelPar_SFH,
     modelPar_given_SFH,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RBC,
     modelPar_given_RBC,
     modelPar_RBV,
     modelPar_given_RBV,
     modelPar_RCC,
     modelPar_given_RCC,
     modelPar_RCV,
     modelPar_given_RCV,
     modelPar_SCRCV,
     modelPar_given_SCRCV,
     modelPar_IHC,
     modelPar_given_IHC,
     modelPar_AXI,
     modelPar_given_AXI,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_VDE,
     modelPar_given_VDE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_XCJE,
     modelPar_given_XCJE,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_VDC,
     modelPar_given_VDC,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_XP,
     modelPar_given_XP,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_XCJC,
     modelPar_given_XCJC,
     modelPar_RCBLX,
     modelPar_given_RCBLX,
     modelPar_RCBLI,
     modelPar_given_RCBLI,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_MTAU,
     modelPar_given_MTAU,
     modelPar_TAUE,
     modelPar_given_TAUE,
     modelPar_TAUB,
     modelPar_given_TAUB,
     modelPar_TEPI,
     modelPar_given_TEPI,
     modelPar_TAUR,
     modelPar_given_TAUR,
     modelPar_DEG,
     modelPar_given_DEG,
     modelPar_XREC,
     modelPar_given_XREC,
     modelPar_XQB,
     modelPar_given_XQB,
     modelPar_AQBO,
     modelPar_given_AQBO,
     modelPar_AE,
     modelPar_given_AE,
     modelPar_AB,
     modelPar_given_AB,
     modelPar_AEPI,
     modelPar_given_AEPI,
     modelPar_AEX,
     modelPar_given_AEX,
     modelPar_AC,
     modelPar_given_AC,
     modelPar_ACBL,
     modelPar_given_ACBL,
     modelPar_DVGBF,
     modelPar_given_DVGBF,
     modelPar_DVGBR,
     modelPar_given_DVGBR,
     modelPar_VGB,
     modelPar_given_VGB,
     modelPar_VGC,
     modelPar_given_VGC,
     modelPar_VGJ,
     modelPar_given_VGJ,
     modelPar_VGZEB,
     modelPar_given_VGZEB,
     modelPar_AVGEB,
     modelPar_given_AVGEB,
     modelPar_TVGEB,
     modelPar_given_TVGEB,
     modelPar_DVGTE,
     modelPar_given_DVGTE,
     modelPar_DAIS,
     modelPar_given_DAIS,
     modelPar_AF,
     modelPar_given_AF,
     modelPar_KF,
     modelPar_given_KF,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_KE,
     modelPar_given_KE,
     modelPar_FTAUN,
     modelPar_given_FTAUN,
     modelPar_ISS,
     modelPar_given_ISS,
     modelPar_ICSS,
     modelPar_given_ICSS,
     modelPar_IKS,
     modelPar_given_IKS,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_VDS,
     modelPar_given_VDS,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_VGS,
     modelPar_given_VGS,
     modelPar_AS,
     modelPar_given_AS,
     modelPar_ASUB,
     modelPar_given_ASUB,
     modelPar_RTH,
     modelPar_given_RTH,
     modelPar_CTH,
     modelPar_given_CTH,
     modelPar_ATH,
     modelPar_given_ATH,
     modelPar_MULT,
     modelPar_given_MULT,
     modelPar_GMIN,
     modelPar_given_GMIN,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_EXMOD,
     modelPar_given_EXMOD,
     modelPar_EXPHI,
     modelPar_given_EXPHI,
     modelPar_EXAVL,
     modelPar_given_EXAVL,
     modelPar_EXSUB,
     modelPar_given_EXSUB,
     modelPar_KAVL,
     modelPar_given_KAVL,
     modelPar_KC,
     modelPar_given_KC,
     modelPar_TYPE,
     modelPar_given_TYPE,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_noi_GND,
     in.admsProbeID_V_c3_c1,
     in.admsProbeID_V_c3_c4,
     in.admsProbeID_V_c4_c1,
     in.admsProbeID_V_b_c,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_b_b1,
     in.admsProbeID_V_e_e1,
     in.admsProbeID_V_c1_c2,
     in.admsProbeID_V_s_c1,
     in.admsProbeID_V_b1_b2,
     in.admsProbeID_V_b1_e1,
     in.admsProbeID_V_b2_e1,
     in.admsProbeID_V_b2_c2,
     in.admsProbeID_V_b2_c1,
     in.admsProbeID_V_dt_GND,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_s,
     in.admsNodeID_dt,
     in.admsNodeID_e1,
     in.admsNodeID_b1,
     in.admsNodeID_b2,
     in.admsNodeID_c1,
     in.admsNodeID_c2,
     in.admsNodeID_c3,
     in.admsNodeID_c4,
     in.admsNodeID_noi,
     // instance parameters
     // reals
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_An,
     instanceVar_Bn,
     instanceVar_Trk,
     instanceVar_Tamb,
     instanceVar_pow2_2mPE,
     instanceVar_pow2_PEm2,
     instanceVar_inv_VDE,
     instanceVar_inv_VGZEB_Tr,
     instanceVar_VGZEBOK,
     instanceVar_invMULT,
     instanceVar_SCRCV_M,
     instanceVar_KF_M,
     instanceVar_KFN_M,
     instanceVar_CTH_M,
     instanceVar_Xext1,
     instanceVar_CBEO_M,
     instanceVar_CBCO_M,
     instanceVar_dxa,
     // model parameters
     // reals
     modelPar_TREF,
     modelPar_given_TREF,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_IK,
     modelPar_given_IK,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_BF,
     modelPar_given_BF,
     modelPar_IBF,
     modelPar_given_IBF,
     modelPar_MLF,
     modelPar_given_MLF,
     modelPar_XIBI,
     modelPar_given_XIBI,
     modelPar_IZEB,
     modelPar_given_IZEB,
     modelPar_NZEB,
     modelPar_given_NZEB,
     modelPar_BRI,
     modelPar_given_BRI,
     modelPar_IBR,
     modelPar_given_IBR,
     modelPar_VLR,
     modelPar_given_VLR,
     modelPar_XEXT,
     modelPar_given_XEXT,
     modelPar_WAVL,
     modelPar_given_WAVL,
     modelPar_VAVL,
     modelPar_given_VAVL,
     modelPar_SFH,
     modelPar_given_SFH,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RBC,
     modelPar_given_RBC,
     modelPar_RBV,
     modelPar_given_RBV,
     modelPar_RCC,
     modelPar_given_RCC,
     modelPar_RCV,
     modelPar_given_RCV,
     modelPar_SCRCV,
     modelPar_given_SCRCV,
     modelPar_IHC,
     modelPar_given_IHC,
     modelPar_AXI,
     modelPar_given_AXI,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_VDE,
     modelPar_given_VDE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_XCJE,
     modelPar_given_XCJE,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_VDC,
     modelPar_given_VDC,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_XP,
     modelPar_given_XP,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_XCJC,
     modelPar_given_XCJC,
     modelPar_RCBLX,
     modelPar_given_RCBLX,
     modelPar_RCBLI,
     modelPar_given_RCBLI,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_MTAU,
     modelPar_given_MTAU,
     modelPar_TAUE,
     modelPar_given_TAUE,
     modelPar_TAUB,
     modelPar_given_TAUB,
     modelPar_TEPI,
     modelPar_given_TEPI,
     modelPar_TAUR,
     modelPar_given_TAUR,
     modelPar_DEG,
     modelPar_given_DEG,
     modelPar_XREC,
     modelPar_given_XREC,
     modelPar_XQB,
     modelPar_given_XQB,
     modelPar_AQBO,
     modelPar_given_AQBO,
     modelPar_AE,
     modelPar_given_AE,
     modelPar_AB,
     modelPar_given_AB,
     modelPar_AEPI,
     modelPar_given_AEPI,
     modelPar_AEX,
     modelPar_given_AEX,
     modelPar_AC,
     modelPar_given_AC,
     modelPar_ACBL,
     modelPar_given_ACBL,
     modelPar_DVGBF,
     modelPar_given_DVGBF,
     modelPar_DVGBR,
     modelPar_given_DVGBR,
     modelPar_VGB,
     modelPar_given_VGB,
     modelPar_VGC,
     modelPar_given_VGC,
     modelPar_VGJ,
     modelPar_given_VGJ,
     modelPar_VGZEB,
     modelPar_given_VGZEB,
     modelPar_AVGEB,
     modelPar_given_AVGEB,
     modelPar_TVGEB,
     modelPar_given_TVGEB,
     modelPar_DVGTE,
     modelPar_given_DVGTE,
     modelPar_DAIS,
     modelPar_given_DAIS,
     modelPar_AF,
     modelPar_given_AF,
     modelPar_KF,
     modelPar_given_KF,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_KE,
     modelPar_given_KE,
     modelPar_FTAUN,
     modelPar_given_FTAUN,
     modelPar_ISS,
     modelPar_given_ISS,
     modelPar_ICSS,
     modelPar_given_ICSS,
     modelPar_IKS,
     modelPar_given_IKS,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_VDS,
     modelPar_given_VDS,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_VGS,
     modelPar_given_VGS,
     modelPar_AS,
     modelPar_given_AS,
     modelPar_ASUB,
     modelPar_given_ASUB,
     modelPar_RTH,
     modelPar_given_RTH,
     modelPar_CTH,
     modelPar_given_CTH,
     modelPar_ATH,
     modelPar_given_ATH,
     modelPar_MULT,
     modelPar_given_MULT,
     modelPar_GMIN,
     modelPar_given_GMIN,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_EXMOD,
     modelPar_given_EXMOD,
     modelPar_EXPHI,
     modelPar_given_EXPHI,
     modelPar_EXAVL,
     modelPar_given_EXAVL,
     modelPar_EXSUB,
     modelPar_given_EXSUB,
     modelPar_KAVL,
     modelPar_given_KAVL,
     modelPar_KC,
     modelPar_given_KC,
     modelPar_TYPE,
     modelPar_given_TYPE,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_dt] += staticContributions[in.admsNodeID_dt].dx(0);
  dqdp[in.admsNodeID_dt] += dynamicContributions[in.admsNodeID_dt].dx(0);
  Findices[in.admsNodeID_dt] = in.li_dt;
  Qindices[in.admsNodeID_dt] = in.li_dt;
  dfdp[in.admsNodeID_e1] += staticContributions[in.admsNodeID_e1].dx(0);
  dqdp[in.admsNodeID_e1] += dynamicContributions[in.admsNodeID_e1].dx(0);
  Findices[in.admsNodeID_e1] = in.li_e1;
  Qindices[in.admsNodeID_e1] = in.li_e1;
  dfdp[in.admsNodeID_b1] += staticContributions[in.admsNodeID_b1].dx(0);
  dqdp[in.admsNodeID_b1] += dynamicContributions[in.admsNodeID_b1].dx(0);
  Findices[in.admsNodeID_b1] = in.li_b1;
  Qindices[in.admsNodeID_b1] = in.li_b1;
  dfdp[in.admsNodeID_b2] += staticContributions[in.admsNodeID_b2].dx(0);
  dqdp[in.admsNodeID_b2] += dynamicContributions[in.admsNodeID_b2].dx(0);
  Findices[in.admsNodeID_b2] = in.li_b2;
  Qindices[in.admsNodeID_b2] = in.li_b2;
  dfdp[in.admsNodeID_c1] += staticContributions[in.admsNodeID_c1].dx(0);
  dqdp[in.admsNodeID_c1] += dynamicContributions[in.admsNodeID_c1].dx(0);
  Findices[in.admsNodeID_c1] = in.li_c1;
  Qindices[in.admsNodeID_c1] = in.li_c1;
  dfdp[in.admsNodeID_c2] += staticContributions[in.admsNodeID_c2].dx(0);
  dqdp[in.admsNodeID_c2] += dynamicContributions[in.admsNodeID_c2].dx(0);
  Findices[in.admsNodeID_c2] = in.li_c2;
  Qindices[in.admsNodeID_c2] = in.li_c2;
  dfdp[in.admsNodeID_c3] += staticContributions[in.admsNodeID_c3].dx(0);
  dqdp[in.admsNodeID_c3] += dynamicContributions[in.admsNodeID_c3].dx(0);
  Findices[in.admsNodeID_c3] = in.li_c3;
  Qindices[in.admsNodeID_c3] = in.li_c3;
  dfdp[in.admsNodeID_c4] += staticContributions[in.admsNodeID_c4].dx(0);
  dqdp[in.admsNodeID_c4] += dynamicContributions[in.admsNodeID_c4].dx(0);
  Findices[in.admsNodeID_c4] = in.li_c4;
  Qindices[in.admsNodeID_c4] = in.li_c4;
  dfdp[in.admsNodeID_noi] += staticContributions[in.admsNodeID_noi].dx(0);
  dqdp[in.admsNodeID_noi] += dynamicContributions[in.admsNodeID_noi].dx(0);
  Findices[in.admsNodeID_noi] = in.li_noi;
  Qindices[in.admsNodeID_noi] = in.li_noi;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((13+0)*sizeInstance);
  dqdp.resize((13+0)*sizeInstance);
  Findices.resize((13+0)*sizeInstance);
  Qindices.resize((13+0)*sizeInstance);

  std::vector <double> probeVars(16);
  std::vector <AdmsSensFadType> staticContributions(13+0);
  std::vector <AdmsSensFadType> dynamicContributions(13+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_TREF=mod.TREF;
  bool modelPar_given_TREF=mod.given("TREF");
  modParamMap["TREF"] = &modelPar_TREF;
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  modParamMap["DTA"] = &modelPar_DTA;
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  modParamMap["IS"] = &modelPar_IS;
  AdmsSensFadType modelPar_IK=mod.IK;
  bool modelPar_given_IK=mod.given("IK");
  modParamMap["IK"] = &modelPar_IK;
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  modParamMap["VER"] = &modelPar_VER;
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  modParamMap["VEF"] = &modelPar_VEF;
  AdmsSensFadType modelPar_BF=mod.BF;
  bool modelPar_given_BF=mod.given("BF");
  modParamMap["BF"] = &modelPar_BF;
  AdmsSensFadType modelPar_IBF=mod.IBF;
  bool modelPar_given_IBF=mod.given("IBF");
  modParamMap["IBF"] = &modelPar_IBF;
  AdmsSensFadType modelPar_MLF=mod.MLF;
  bool modelPar_given_MLF=mod.given("MLF");
  modParamMap["MLF"] = &modelPar_MLF;
  AdmsSensFadType modelPar_XIBI=mod.XIBI;
  bool modelPar_given_XIBI=mod.given("XIBI");
  modParamMap["XIBI"] = &modelPar_XIBI;
  AdmsSensFadType modelPar_IZEB=mod.IZEB;
  bool modelPar_given_IZEB=mod.given("IZEB");
  modParamMap["IZEB"] = &modelPar_IZEB;
  AdmsSensFadType modelPar_NZEB=mod.NZEB;
  bool modelPar_given_NZEB=mod.given("NZEB");
  modParamMap["NZEB"] = &modelPar_NZEB;
  AdmsSensFadType modelPar_BRI=mod.BRI;
  bool modelPar_given_BRI=mod.given("BRI");
  modParamMap["BRI"] = &modelPar_BRI;
  AdmsSensFadType modelPar_IBR=mod.IBR;
  bool modelPar_given_IBR=mod.given("IBR");
  modParamMap["IBR"] = &modelPar_IBR;
  AdmsSensFadType modelPar_VLR=mod.VLR;
  bool modelPar_given_VLR=mod.given("VLR");
  modParamMap["VLR"] = &modelPar_VLR;
  AdmsSensFadType modelPar_XEXT=mod.XEXT;
  bool modelPar_given_XEXT=mod.given("XEXT");
  modParamMap["XEXT"] = &modelPar_XEXT;
  AdmsSensFadType modelPar_WAVL=mod.WAVL;
  bool modelPar_given_WAVL=mod.given("WAVL");
  modParamMap["WAVL"] = &modelPar_WAVL;
  AdmsSensFadType modelPar_VAVL=mod.VAVL;
  bool modelPar_given_VAVL=mod.given("VAVL");
  modParamMap["VAVL"] = &modelPar_VAVL;
  AdmsSensFadType modelPar_SFH=mod.SFH;
  bool modelPar_given_SFH=mod.given("SFH");
  modParamMap["SFH"] = &modelPar_SFH;
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  modParamMap["RE"] = &modelPar_RE;
  AdmsSensFadType modelPar_RBC=mod.RBC;
  bool modelPar_given_RBC=mod.given("RBC");
  modParamMap["RBC"] = &modelPar_RBC;
  AdmsSensFadType modelPar_RBV=mod.RBV;
  bool modelPar_given_RBV=mod.given("RBV");
  modParamMap["RBV"] = &modelPar_RBV;
  AdmsSensFadType modelPar_RCC=mod.RCC;
  bool modelPar_given_RCC=mod.given("RCC");
  modParamMap["RCC"] = &modelPar_RCC;
  AdmsSensFadType modelPar_RCV=mod.RCV;
  bool modelPar_given_RCV=mod.given("RCV");
  modParamMap["RCV"] = &modelPar_RCV;
  AdmsSensFadType modelPar_SCRCV=mod.SCRCV;
  bool modelPar_given_SCRCV=mod.given("SCRCV");
  modParamMap["SCRCV"] = &modelPar_SCRCV;
  AdmsSensFadType modelPar_IHC=mod.IHC;
  bool modelPar_given_IHC=mod.given("IHC");
  modParamMap["IHC"] = &modelPar_IHC;
  AdmsSensFadType modelPar_AXI=mod.AXI;
  bool modelPar_given_AXI=mod.given("AXI");
  modParamMap["AXI"] = &modelPar_AXI;
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  modParamMap["CJE"] = &modelPar_CJE;
  AdmsSensFadType modelPar_VDE=mod.VDE;
  bool modelPar_given_VDE=mod.given("VDE");
  modParamMap["VDE"] = &modelPar_VDE;
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  modParamMap["PE"] = &modelPar_PE;
  AdmsSensFadType modelPar_XCJE=mod.XCJE;
  bool modelPar_given_XCJE=mod.given("XCJE");
  modParamMap["XCJE"] = &modelPar_XCJE;
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  modParamMap["CBEO"] = &modelPar_CBEO;
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  modParamMap["CJC"] = &modelPar_CJC;
  AdmsSensFadType modelPar_VDC=mod.VDC;
  bool modelPar_given_VDC=mod.given("VDC");
  modParamMap["VDC"] = &modelPar_VDC;
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  modParamMap["PC"] = &modelPar_PC;
  AdmsSensFadType modelPar_XP=mod.XP;
  bool modelPar_given_XP=mod.given("XP");
  modParamMap["XP"] = &modelPar_XP;
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  modParamMap["MC"] = &modelPar_MC;
  AdmsSensFadType modelPar_XCJC=mod.XCJC;
  bool modelPar_given_XCJC=mod.given("XCJC");
  modParamMap["XCJC"] = &modelPar_XCJC;
  AdmsSensFadType modelPar_RCBLX=mod.RCBLX;
  bool modelPar_given_RCBLX=mod.given("RCBLX");
  modParamMap["RCBLX"] = &modelPar_RCBLX;
  AdmsSensFadType modelPar_RCBLI=mod.RCBLI;
  bool modelPar_given_RCBLI=mod.given("RCBLI");
  modParamMap["RCBLI"] = &modelPar_RCBLI;
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  modParamMap["CBCO"] = &modelPar_CBCO;
  AdmsSensFadType modelPar_MTAU=mod.MTAU;
  bool modelPar_given_MTAU=mod.given("MTAU");
  modParamMap["MTAU"] = &modelPar_MTAU;
  AdmsSensFadType modelPar_TAUE=mod.TAUE;
  bool modelPar_given_TAUE=mod.given("TAUE");
  modParamMap["TAUE"] = &modelPar_TAUE;
  AdmsSensFadType modelPar_TAUB=mod.TAUB;
  bool modelPar_given_TAUB=mod.given("TAUB");
  modParamMap["TAUB"] = &modelPar_TAUB;
  AdmsSensFadType modelPar_TEPI=mod.TEPI;
  bool modelPar_given_TEPI=mod.given("TEPI");
  modParamMap["TEPI"] = &modelPar_TEPI;
  AdmsSensFadType modelPar_TAUR=mod.TAUR;
  bool modelPar_given_TAUR=mod.given("TAUR");
  modParamMap["TAUR"] = &modelPar_TAUR;
  AdmsSensFadType modelPar_DEG=mod.DEG;
  bool modelPar_given_DEG=mod.given("DEG");
  modParamMap["DEG"] = &modelPar_DEG;
  AdmsSensFadType modelPar_XREC=mod.XREC;
  bool modelPar_given_XREC=mod.given("XREC");
  modParamMap["XREC"] = &modelPar_XREC;
  AdmsSensFadType modelPar_XQB=mod.XQB;
  bool modelPar_given_XQB=mod.given("XQB");
  modParamMap["XQB"] = &modelPar_XQB;
  AdmsSensFadType modelPar_AQBO=mod.AQBO;
  bool modelPar_given_AQBO=mod.given("AQBO");
  modParamMap["AQBO"] = &modelPar_AQBO;
  AdmsSensFadType modelPar_AE=mod.AE;
  bool modelPar_given_AE=mod.given("AE");
  modParamMap["AE"] = &modelPar_AE;
  AdmsSensFadType modelPar_AB=mod.AB;
  bool modelPar_given_AB=mod.given("AB");
  modParamMap["AB"] = &modelPar_AB;
  AdmsSensFadType modelPar_AEPI=mod.AEPI;
  bool modelPar_given_AEPI=mod.given("AEPI");
  modParamMap["AEPI"] = &modelPar_AEPI;
  AdmsSensFadType modelPar_AEX=mod.AEX;
  bool modelPar_given_AEX=mod.given("AEX");
  modParamMap["AEX"] = &modelPar_AEX;
  AdmsSensFadType modelPar_AC=mod.AC;
  bool modelPar_given_AC=mod.given("AC");
  modParamMap["AC"] = &modelPar_AC;
  AdmsSensFadType modelPar_ACBL=mod.ACBL;
  bool modelPar_given_ACBL=mod.given("ACBL");
  modParamMap["ACBL"] = &modelPar_ACBL;
  AdmsSensFadType modelPar_DVGBF=mod.DVGBF;
  bool modelPar_given_DVGBF=mod.given("DVGBF");
  modParamMap["DVGBF"] = &modelPar_DVGBF;
  AdmsSensFadType modelPar_DVGBR=mod.DVGBR;
  bool modelPar_given_DVGBR=mod.given("DVGBR");
  modParamMap["DVGBR"] = &modelPar_DVGBR;
  AdmsSensFadType modelPar_VGB=mod.VGB;
  bool modelPar_given_VGB=mod.given("VGB");
  modParamMap["VGB"] = &modelPar_VGB;
  AdmsSensFadType modelPar_VGC=mod.VGC;
  bool modelPar_given_VGC=mod.given("VGC");
  modParamMap["VGC"] = &modelPar_VGC;
  AdmsSensFadType modelPar_VGJ=mod.VGJ;
  bool modelPar_given_VGJ=mod.given("VGJ");
  modParamMap["VGJ"] = &modelPar_VGJ;
  AdmsSensFadType modelPar_VGZEB=mod.VGZEB;
  bool modelPar_given_VGZEB=mod.given("VGZEB");
  modParamMap["VGZEB"] = &modelPar_VGZEB;
  AdmsSensFadType modelPar_AVGEB=mod.AVGEB;
  bool modelPar_given_AVGEB=mod.given("AVGEB");
  modParamMap["AVGEB"] = &modelPar_AVGEB;
  AdmsSensFadType modelPar_TVGEB=mod.TVGEB;
  bool modelPar_given_TVGEB=mod.given("TVGEB");
  modParamMap["TVGEB"] = &modelPar_TVGEB;
  AdmsSensFadType modelPar_DVGTE=mod.DVGTE;
  bool modelPar_given_DVGTE=mod.given("DVGTE");
  modParamMap["DVGTE"] = &modelPar_DVGTE;
  AdmsSensFadType modelPar_DAIS=mod.DAIS;
  bool modelPar_given_DAIS=mod.given("DAIS");
  modParamMap["DAIS"] = &modelPar_DAIS;
  AdmsSensFadType modelPar_AF=mod.AF;
  bool modelPar_given_AF=mod.given("AF");
  modParamMap["AF"] = &modelPar_AF;
  AdmsSensFadType modelPar_KF=mod.KF;
  bool modelPar_given_KF=mod.given("KF");
  modParamMap["KF"] = &modelPar_KF;
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  modParamMap["KFN"] = &modelPar_KFN;
  AdmsSensFadType modelPar_KE=mod.KE;
  bool modelPar_given_KE=mod.given("KE");
  modParamMap["KE"] = &modelPar_KE;
  AdmsSensFadType modelPar_FTAUN=mod.FTAUN;
  bool modelPar_given_FTAUN=mod.given("FTAUN");
  modParamMap["FTAUN"] = &modelPar_FTAUN;
  AdmsSensFadType modelPar_ISS=mod.ISS;
  bool modelPar_given_ISS=mod.given("ISS");
  modParamMap["ISS"] = &modelPar_ISS;
  AdmsSensFadType modelPar_ICSS=mod.ICSS;
  bool modelPar_given_ICSS=mod.given("ICSS");
  modParamMap["ICSS"] = &modelPar_ICSS;
  AdmsSensFadType modelPar_IKS=mod.IKS;
  bool modelPar_given_IKS=mod.given("IKS");
  modParamMap["IKS"] = &modelPar_IKS;
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  modParamMap["CJS"] = &modelPar_CJS;
  AdmsSensFadType modelPar_VDS=mod.VDS;
  bool modelPar_given_VDS=mod.given("VDS");
  modParamMap["VDS"] = &modelPar_VDS;
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  modParamMap["PS"] = &modelPar_PS;
  AdmsSensFadType modelPar_VGS=mod.VGS;
  bool modelPar_given_VGS=mod.given("VGS");
  modParamMap["VGS"] = &modelPar_VGS;
  AdmsSensFadType modelPar_AS=mod.AS;
  bool modelPar_given_AS=mod.given("AS");
  modParamMap["AS"] = &modelPar_AS;
  AdmsSensFadType modelPar_ASUB=mod.ASUB;
  bool modelPar_given_ASUB=mod.given("ASUB");
  modParamMap["ASUB"] = &modelPar_ASUB;
  AdmsSensFadType modelPar_RTH=mod.RTH;
  bool modelPar_given_RTH=mod.given("RTH");
  modParamMap["RTH"] = &modelPar_RTH;
  AdmsSensFadType modelPar_CTH=mod.CTH;
  bool modelPar_given_CTH=mod.given("CTH");
  modParamMap["CTH"] = &modelPar_CTH;
  AdmsSensFadType modelPar_ATH=mod.ATH;
  bool modelPar_given_ATH=mod.given("ATH");
  modParamMap["ATH"] = &modelPar_ATH;
  AdmsSensFadType modelPar_MULT=mod.MULT;
  bool modelPar_given_MULT=mod.given("MULT");
  modParamMap["MULT"] = &modelPar_MULT;
  AdmsSensFadType modelPar_GMIN=mod.GMIN;
  bool modelPar_given_GMIN=mod.given("GMIN");
  modParamMap["GMIN"] = &modelPar_GMIN;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_EXMOD=mod.EXMOD;
  bool modelPar_given_EXMOD=mod.given("EXMOD");
  int modelPar_EXPHI=mod.EXPHI;
  bool modelPar_given_EXPHI=mod.given("EXPHI");
  int modelPar_EXAVL=mod.EXAVL;
  bool modelPar_given_EXAVL=mod.given("EXAVL");
  int modelPar_EXSUB=mod.EXSUB;
  bool modelPar_given_EXSUB=mod.given("EXSUB");
  int modelPar_KAVL=mod.KAVL;
  bool modelPar_given_KAVL=mod.given("KAVL");
  int modelPar_KC=mod.KC;
  bool modelPar_given_KC=mod.given("KC");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 13+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_MULT=in.MULT;
    bool instancePar_given_MULT=in.given("MULT");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("MULT")))
    {
      instancePar_MULT = modelPar_MULT;
    }


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_An=in.An;
    AdmsSensFadType instanceVar_Bn=in.Bn;
    AdmsSensFadType instanceVar_Trk=in.Trk;
    AdmsSensFadType instanceVar_Tamb=in.Tamb;
    AdmsSensFadType instanceVar_pow2_2mPE=in.pow2_2mPE;
    AdmsSensFadType instanceVar_pow2_PEm2=in.pow2_PEm2;
    AdmsSensFadType instanceVar_inv_VDE=in.inv_VDE;
    AdmsSensFadType instanceVar_inv_VGZEB_Tr=in.inv_VGZEB_Tr;
    AdmsSensFadType instanceVar_VGZEBOK=in.VGZEBOK;
    AdmsSensFadType instanceVar_invMULT=in.invMULT;
    AdmsSensFadType instanceVar_SCRCV_M=in.SCRCV_M;
    AdmsSensFadType instanceVar_KF_M=in.KF_M;
    AdmsSensFadType instanceVar_KFN_M=in.KFN_M;
    AdmsSensFadType instanceVar_CTH_M=in.CTH_M;
    AdmsSensFadType instanceVar_Xext1=in.Xext1;
    AdmsSensFadType instanceVar_CBEO_M=in.CBEO_M;
    AdmsSensFadType instanceVar_CBCO_M=in.CBCO_M;
    AdmsSensFadType instanceVar_dxa=in.dxa;


    //non-reals



    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_noi_GND] = (*solVectorPtr)[in.li_noi];
    probeVars[in.admsProbeID_V_c3_c1] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_c3_c4] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c4];
    probeVars[in.admsProbeID_V_c4_c1] = (*solVectorPtr)[in.li_c4] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_b_b1] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_b1];
    probeVars[in.admsProbeID_V_e_e1] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_c1_c2] = (*solVectorPtr)[in.li_c1] - (*solVectorPtr)[in.li_c2];
    probeVars[in.admsProbeID_V_s_c1] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_b1_b2] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_b2];
    probeVars[in.admsProbeID_V_b1_e1] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_b2_e1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_b2_c2] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c2];
    probeVars[in.admsProbeID_V_b2_c1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_dt_GND] = (*solVectorPtr)[in.li_dt];


    // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    probeVars[in.admsProbeID_V_b1_b2] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b1_e1] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b2_c2] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b2_c1] *= modelPar_TYPE;


    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_An,
       instanceVar_Bn,
       instanceVar_Trk,
       instanceVar_Tamb,
       instanceVar_pow2_2mPE,
       instanceVar_pow2_PEm2,
       instanceVar_inv_VDE,
       instanceVar_inv_VGZEB_Tr,
       instanceVar_VGZEBOK,
       instanceVar_invMULT,
       instanceVar_SCRCV_M,
       instanceVar_KF_M,
       instanceVar_KFN_M,
       instanceVar_CTH_M,
       instanceVar_Xext1,
       instanceVar_CBEO_M,
       instanceVar_CBCO_M,
       instanceVar_dxa,
       // model parameters
       // reals
       modelPar_TREF,
       modelPar_given_TREF,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_IK,
       modelPar_given_IK,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_BF,
       modelPar_given_BF,
       modelPar_IBF,
       modelPar_given_IBF,
       modelPar_MLF,
       modelPar_given_MLF,
       modelPar_XIBI,
       modelPar_given_XIBI,
       modelPar_IZEB,
       modelPar_given_IZEB,
       modelPar_NZEB,
       modelPar_given_NZEB,
       modelPar_BRI,
       modelPar_given_BRI,
       modelPar_IBR,
       modelPar_given_IBR,
       modelPar_VLR,
       modelPar_given_VLR,
       modelPar_XEXT,
       modelPar_given_XEXT,
       modelPar_WAVL,
       modelPar_given_WAVL,
       modelPar_VAVL,
       modelPar_given_VAVL,
       modelPar_SFH,
       modelPar_given_SFH,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RBC,
       modelPar_given_RBC,
       modelPar_RBV,
       modelPar_given_RBV,
       modelPar_RCC,
       modelPar_given_RCC,
       modelPar_RCV,
       modelPar_given_RCV,
       modelPar_SCRCV,
       modelPar_given_SCRCV,
       modelPar_IHC,
       modelPar_given_IHC,
       modelPar_AXI,
       modelPar_given_AXI,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_VDE,
       modelPar_given_VDE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_XCJE,
       modelPar_given_XCJE,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_VDC,
       modelPar_given_VDC,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_XP,
       modelPar_given_XP,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_XCJC,
       modelPar_given_XCJC,
       modelPar_RCBLX,
       modelPar_given_RCBLX,
       modelPar_RCBLI,
       modelPar_given_RCBLI,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_MTAU,
       modelPar_given_MTAU,
       modelPar_TAUE,
       modelPar_given_TAUE,
       modelPar_TAUB,
       modelPar_given_TAUB,
       modelPar_TEPI,
       modelPar_given_TEPI,
       modelPar_TAUR,
       modelPar_given_TAUR,
       modelPar_DEG,
       modelPar_given_DEG,
       modelPar_XREC,
       modelPar_given_XREC,
       modelPar_XQB,
       modelPar_given_XQB,
       modelPar_AQBO,
       modelPar_given_AQBO,
       modelPar_AE,
       modelPar_given_AE,
       modelPar_AB,
       modelPar_given_AB,
       modelPar_AEPI,
       modelPar_given_AEPI,
       modelPar_AEX,
       modelPar_given_AEX,
       modelPar_AC,
       modelPar_given_AC,
       modelPar_ACBL,
       modelPar_given_ACBL,
       modelPar_DVGBF,
       modelPar_given_DVGBF,
       modelPar_DVGBR,
       modelPar_given_DVGBR,
       modelPar_VGB,
       modelPar_given_VGB,
       modelPar_VGC,
       modelPar_given_VGC,
       modelPar_VGJ,
       modelPar_given_VGJ,
       modelPar_VGZEB,
       modelPar_given_VGZEB,
       modelPar_AVGEB,
       modelPar_given_AVGEB,
       modelPar_TVGEB,
       modelPar_given_TVGEB,
       modelPar_DVGTE,
       modelPar_given_DVGTE,
       modelPar_DAIS,
       modelPar_given_DAIS,
       modelPar_AF,
       modelPar_given_AF,
       modelPar_KF,
       modelPar_given_KF,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_KE,
       modelPar_given_KE,
       modelPar_FTAUN,
       modelPar_given_FTAUN,
       modelPar_ISS,
       modelPar_given_ISS,
       modelPar_ICSS,
       modelPar_given_ICSS,
       modelPar_IKS,
       modelPar_given_IKS,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_VDS,
       modelPar_given_VDS,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_VGS,
       modelPar_given_VGS,
       modelPar_AS,
       modelPar_given_AS,
       modelPar_ASUB,
       modelPar_given_ASUB,
       modelPar_RTH,
       modelPar_given_RTH,
       modelPar_CTH,
       modelPar_given_CTH,
       modelPar_ATH,
       modelPar_given_ATH,
       modelPar_MULT,
       modelPar_given_MULT,
       modelPar_GMIN,
       modelPar_given_GMIN,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_EXMOD,
       modelPar_given_EXMOD,
       modelPar_EXPHI,
       modelPar_given_EXPHI,
       modelPar_EXAVL,
       modelPar_given_EXAVL,
       modelPar_EXSUB,
       modelPar_given_EXSUB,
       modelPar_KAVL,
       modelPar_given_KAVL,
       modelPar_KC,
       modelPar_given_KC,
       modelPar_TYPE,
       modelPar_given_TYPE,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_noi_GND,
       in.admsProbeID_V_c3_c1,
       in.admsProbeID_V_c3_c4,
       in.admsProbeID_V_c4_c1,
       in.admsProbeID_V_b_c,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_b_b1,
       in.admsProbeID_V_e_e1,
       in.admsProbeID_V_c1_c2,
       in.admsProbeID_V_s_c1,
       in.admsProbeID_V_b1_b2,
       in.admsProbeID_V_b1_e1,
       in.admsProbeID_V_b2_e1,
       in.admsProbeID_V_b2_c2,
       in.admsProbeID_V_b2_c1,
       in.admsProbeID_V_dt_GND,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_s,
       in.admsNodeID_dt,
       in.admsNodeID_e1,
       in.admsNodeID_b1,
       in.admsNodeID_b2,
       in.admsNodeID_c1,
       in.admsNodeID_c2,
       in.admsNodeID_c3,
       in.admsNodeID_c4,
       in.admsNodeID_noi,
       // instance parameters
       // reals
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_An,
       instanceVar_Bn,
       instanceVar_Trk,
       instanceVar_Tamb,
       instanceVar_pow2_2mPE,
       instanceVar_pow2_PEm2,
       instanceVar_inv_VDE,
       instanceVar_inv_VGZEB_Tr,
       instanceVar_VGZEBOK,
       instanceVar_invMULT,
       instanceVar_SCRCV_M,
       instanceVar_KF_M,
       instanceVar_KFN_M,
       instanceVar_CTH_M,
       instanceVar_Xext1,
       instanceVar_CBEO_M,
       instanceVar_CBCO_M,
       instanceVar_dxa,
       // model parameters
       // reals
       modelPar_TREF,
       modelPar_given_TREF,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_IK,
       modelPar_given_IK,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_BF,
       modelPar_given_BF,
       modelPar_IBF,
       modelPar_given_IBF,
       modelPar_MLF,
       modelPar_given_MLF,
       modelPar_XIBI,
       modelPar_given_XIBI,
       modelPar_IZEB,
       modelPar_given_IZEB,
       modelPar_NZEB,
       modelPar_given_NZEB,
       modelPar_BRI,
       modelPar_given_BRI,
       modelPar_IBR,
       modelPar_given_IBR,
       modelPar_VLR,
       modelPar_given_VLR,
       modelPar_XEXT,
       modelPar_given_XEXT,
       modelPar_WAVL,
       modelPar_given_WAVL,
       modelPar_VAVL,
       modelPar_given_VAVL,
       modelPar_SFH,
       modelPar_given_SFH,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RBC,
       modelPar_given_RBC,
       modelPar_RBV,
       modelPar_given_RBV,
       modelPar_RCC,
       modelPar_given_RCC,
       modelPar_RCV,
       modelPar_given_RCV,
       modelPar_SCRCV,
       modelPar_given_SCRCV,
       modelPar_IHC,
       modelPar_given_IHC,
       modelPar_AXI,
       modelPar_given_AXI,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_VDE,
       modelPar_given_VDE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_XCJE,
       modelPar_given_XCJE,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_VDC,
       modelPar_given_VDC,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_XP,
       modelPar_given_XP,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_XCJC,
       modelPar_given_XCJC,
       modelPar_RCBLX,
       modelPar_given_RCBLX,
       modelPar_RCBLI,
       modelPar_given_RCBLI,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_MTAU,
       modelPar_given_MTAU,
       modelPar_TAUE,
       modelPar_given_TAUE,
       modelPar_TAUB,
       modelPar_given_TAUB,
       modelPar_TEPI,
       modelPar_given_TEPI,
       modelPar_TAUR,
       modelPar_given_TAUR,
       modelPar_DEG,
       modelPar_given_DEG,
       modelPar_XREC,
       modelPar_given_XREC,
       modelPar_XQB,
       modelPar_given_XQB,
       modelPar_AQBO,
       modelPar_given_AQBO,
       modelPar_AE,
       modelPar_given_AE,
       modelPar_AB,
       modelPar_given_AB,
       modelPar_AEPI,
       modelPar_given_AEPI,
       modelPar_AEX,
       modelPar_given_AEX,
       modelPar_AC,
       modelPar_given_AC,
       modelPar_ACBL,
       modelPar_given_ACBL,
       modelPar_DVGBF,
       modelPar_given_DVGBF,
       modelPar_DVGBR,
       modelPar_given_DVGBR,
       modelPar_VGB,
       modelPar_given_VGB,
       modelPar_VGC,
       modelPar_given_VGC,
       modelPar_VGJ,
       modelPar_given_VGJ,
       modelPar_VGZEB,
       modelPar_given_VGZEB,
       modelPar_AVGEB,
       modelPar_given_AVGEB,
       modelPar_TVGEB,
       modelPar_given_TVGEB,
       modelPar_DVGTE,
       modelPar_given_DVGTE,
       modelPar_DAIS,
       modelPar_given_DAIS,
       modelPar_AF,
       modelPar_given_AF,
       modelPar_KF,
       modelPar_given_KF,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_KE,
       modelPar_given_KE,
       modelPar_FTAUN,
       modelPar_given_FTAUN,
       modelPar_ISS,
       modelPar_given_ISS,
       modelPar_ICSS,
       modelPar_given_ICSS,
       modelPar_IKS,
       modelPar_given_IKS,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_VDS,
       modelPar_given_VDS,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_VGS,
       modelPar_given_VGS,
       modelPar_AS,
       modelPar_given_AS,
       modelPar_ASUB,
       modelPar_given_ASUB,
       modelPar_RTH,
       modelPar_given_RTH,
       modelPar_CTH,
       modelPar_given_CTH,
       modelPar_ATH,
       modelPar_given_ATH,
       modelPar_MULT,
       modelPar_given_MULT,
       modelPar_GMIN,
       modelPar_given_GMIN,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_EXMOD,
       modelPar_given_EXMOD,
       modelPar_EXPHI,
       modelPar_given_EXPHI,
       modelPar_EXAVL,
       modelPar_given_EXAVL,
       modelPar_EXSUB,
       modelPar_given_EXSUB,
       modelPar_KAVL,
       modelPar_given_KAVL,
       modelPar_KC,
       modelPar_given_KC,
       modelPar_TYPE,
       modelPar_given_TYPE,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);


    // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_c+inst*(13+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(13+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(13+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(13+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(13+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(13+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(13+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(13+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(13+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(13+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(13+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(13+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(13+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(13+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(13+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(13+0)] = in.li_s;
    dfdp[in.admsNodeID_dt+inst*(13+0)] += staticContributions[in.admsNodeID_dt].dx(0);
    dqdp[in.admsNodeID_dt+inst*(13+0)] += dynamicContributions[in.admsNodeID_dt].dx(0);
    Findices[in.admsNodeID_dt+inst*(13+0)] = in.li_dt;
    Qindices[in.admsNodeID_dt+inst*(13+0)] = in.li_dt;
    dfdp[in.admsNodeID_e1+inst*(13+0)] += staticContributions[in.admsNodeID_e1].dx(0);
    dqdp[in.admsNodeID_e1+inst*(13+0)] += dynamicContributions[in.admsNodeID_e1].dx(0);
    Findices[in.admsNodeID_e1+inst*(13+0)] = in.li_e1;
    Qindices[in.admsNodeID_e1+inst*(13+0)] = in.li_e1;
    dfdp[in.admsNodeID_b1+inst*(13+0)] += staticContributions[in.admsNodeID_b1].dx(0);
    dqdp[in.admsNodeID_b1+inst*(13+0)] += dynamicContributions[in.admsNodeID_b1].dx(0);
    Findices[in.admsNodeID_b1+inst*(13+0)] = in.li_b1;
    Qindices[in.admsNodeID_b1+inst*(13+0)] = in.li_b1;
    dfdp[in.admsNodeID_b2+inst*(13+0)] += staticContributions[in.admsNodeID_b2].dx(0);
    dqdp[in.admsNodeID_b2+inst*(13+0)] += dynamicContributions[in.admsNodeID_b2].dx(0);
    Findices[in.admsNodeID_b2+inst*(13+0)] = in.li_b2;
    Qindices[in.admsNodeID_b2+inst*(13+0)] = in.li_b2;
    dfdp[in.admsNodeID_c1+inst*(13+0)] += staticContributions[in.admsNodeID_c1].dx(0);
    dqdp[in.admsNodeID_c1+inst*(13+0)] += dynamicContributions[in.admsNodeID_c1].dx(0);
    Findices[in.admsNodeID_c1+inst*(13+0)] = in.li_c1;
    Qindices[in.admsNodeID_c1+inst*(13+0)] = in.li_c1;
    dfdp[in.admsNodeID_c2+inst*(13+0)] += staticContributions[in.admsNodeID_c2].dx(0);
    dqdp[in.admsNodeID_c2+inst*(13+0)] += dynamicContributions[in.admsNodeID_c2].dx(0);
    Findices[in.admsNodeID_c2+inst*(13+0)] = in.li_c2;
    Qindices[in.admsNodeID_c2+inst*(13+0)] = in.li_c2;
    dfdp[in.admsNodeID_c3+inst*(13+0)] += staticContributions[in.admsNodeID_c3].dx(0);
    dqdp[in.admsNodeID_c3+inst*(13+0)] += dynamicContributions[in.admsNodeID_c3].dx(0);
    Findices[in.admsNodeID_c3+inst*(13+0)] = in.li_c3;
    Qindices[in.admsNodeID_c3+inst*(13+0)] = in.li_c3;
    dfdp[in.admsNodeID_c4+inst*(13+0)] += staticContributions[in.admsNodeID_c4].dx(0);
    dqdp[in.admsNodeID_c4+inst*(13+0)] += dynamicContributions[in.admsNodeID_c4].dx(0);
    Findices[in.admsNodeID_c4+inst*(13+0)] = in.li_c4;
    Qindices[in.admsNodeID_c4+inst*(13+0)] = in.li_c4;
    dfdp[in.admsNodeID_noi+inst*(13+0)] += staticContributions[in.admsNodeID_noi].dx(0);
    dqdp[in.admsNodeID_noi+inst*(13+0)] += dynamicContributions[in.admsNodeID_noi].dx(0);
    Findices[in.admsNodeID_noi+inst*(13+0)] = in.li_noi;
    Qindices[in.admsNodeID_noi+inst*(13+0)] = in.li_noi;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbjt504tva
} // namespace Device
} // namespace Xyce
