
//-------------------------------------------------------------------------
//   Copyright 2002-2019 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file BSIM6.1.1.va with ADMS
//                  interface for Xyce 6.11.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Tue, 02 Apr 2019 10:14:13
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSbsim6.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

#include <algorithm>

namespace Xyce {
namespace Device {
namespace ADMSbsim6 {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_d;
const int Instance::admsNodeID_g;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_di;
const int Instance::admsNodeID_si;
const int Instance::admsNodeID_gi;
const int Instance::admsNodeID_gm;
const int Instance::admsNodeID_bi;
const int Instance::admsNodeID_sbulk;
const int Instance::admsNodeID_dbulk;
const int Instance::admsNodeID_N1;
const int Instance::admsNodeID_N2;
const int Instance::admsNodeID_t;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbsim6::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbsim6::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(10*1.0e-6), &ADMSbsim6::Instance::L)
    .setUnit(U_METER)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("W", static_cast<double>(10*1.0e-6), &ADMSbsim6::Instance::W)
    .setUnit(U_METER)
    .setDescription("Total width including fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<int>(1), &ADMSbsim6::Instance::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers");
  p.addPar("NRS", static_cast<double>(1.0), &ADMSbsim6::Instance::NRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares in source")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRD", static_cast<double>(1.0), &ADMSbsim6::Instance::NRD)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares in drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBSDOFF", static_cast<double>(0.0), &ADMSbsim6::Instance::VFBSDOFF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MINZ", static_cast<int>(0), &ADMSbsim6::Instance::MINZ)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimize either D or S");
  p.addPar("XGW", static_cast<double>(0.0), &ADMSbsim6::Instance::XGW)
    .setUnit(U_METER)
    .setDescription("Dist from gate contact center to dev edge [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsim6::Instance::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contacts");
  p.addPar("RGATEMOD", static_cast<int>(0), &ADMSbsim6::Instance::RGATEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate resistance model selector");
  p.addPar("RBODYMOD", static_cast<int>(0), &ADMSbsim6::Instance::RBODYMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distributed body R model");
  p.addPar("GEOMOD", static_cast<int>(0), &ADMSbsim6::Instance::GEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geo dependent parasitics model");
  p.addPar("RGEOMOD", static_cast<int>(0), &ADMSbsim6::Instance::RGEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-dependent source/drain resistance,  0: RSH-based, 1: Holistic");
  p.addPar("RBPB", static_cast<double>(50.0), &ADMSbsim6::Instance::RBPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPD", static_cast<double>(50.0), &ADMSbsim6::Instance::RBPD)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPS", static_cast<double>(50.0), &ADMSbsim6::Instance::RBPS)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and sbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBDB", static_cast<double>(50.0), &ADMSbsim6::Instance::RBDB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and dbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSB", static_cast<double>(50.0), &ADMSbsim6::Instance::RBSB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and sbNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SA", static_cast<double>(0.0), &ADMSbsim6::Instance::SA)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SB", static_cast<double>(0.0), &ADMSbsim6::Instance::SB)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SD", static_cast<double>(0.0), &ADMSbsim6::Instance::SD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between neighboring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCA", static_cast<int>(0.0), &ADMSbsim6::Instance::SCA)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCB", static_cast<int>(0.0), &ADMSbsim6::Instance::SCB)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCC", static_cast<int>(0.0), &ADMSbsim6::Instance::SCC)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SC", static_cast<int>(0.0), &ADMSbsim6::Instance::SC)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance to a single well edge if <=0.0, turn off WPE");
  p.addPar("AS", static_cast<double>(0.0), &ADMSbsim6::Instance::AS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source to Substrate Junction Area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AD", static_cast<double>(0.0), &ADMSbsim6::Instance::AD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain to Substrate Junction Area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(0.0), &ADMSbsim6::Instance::PS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source to Substrate Junction Perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PD", static_cast<double>(0.0), &ADMSbsim6::Instance::PD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain to Substrate Junction Perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSbsim6::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbsim6::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("L", static_cast<double>(10*1.0e-6), &ADMSbsim6::Model::L)
    .setUnit(U_METER)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBSDOFF", static_cast<double>(0.0), &ADMSbsim6::Model::VFBSDOFF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XGW", static_cast<double>(0.0), &ADMSbsim6::Model::XGW)
    .setUnit(U_METER)
    .setDescription("Dist from gate contact center to dev edge [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsim6::Model::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contacts");
  p.addPar("RGATEMOD", static_cast<int>(0), &ADMSbsim6::Model::RGATEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate resistance model selector");
  p.addPar("RBODYMOD", static_cast<int>(0), &ADMSbsim6::Model::RBODYMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distributed body R model");
  p.addPar("GEOMOD", static_cast<int>(0), &ADMSbsim6::Model::GEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geo dependent parasitics model");
  p.addPar("RGEOMOD", static_cast<int>(0), &ADMSbsim6::Model::RGEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-dependent source/drain resistance,  0: RSH-based, 1: Holistic");
  p.addPar("RBPB", static_cast<double>(50.0), &ADMSbsim6::Model::RBPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPD", static_cast<double>(50.0), &ADMSbsim6::Model::RBPD)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPS", static_cast<double>(50.0), &ADMSbsim6::Model::RBPS)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and sbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBDB", static_cast<double>(50.0), &ADMSbsim6::Model::RBDB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and dbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSB", static_cast<double>(50.0), &ADMSbsim6::Model::RBSB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and sbNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SA", static_cast<double>(0.0), &ADMSbsim6::Model::SA)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SB", static_cast<double>(0.0), &ADMSbsim6::Model::SB)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SD", static_cast<double>(0.0), &ADMSbsim6::Model::SD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between neighboring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCA", static_cast<int>(0.0), &ADMSbsim6::Model::SCA)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCB", static_cast<int>(0.0), &ADMSbsim6::Model::SCB)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCC", static_cast<int>(0.0), &ADMSbsim6::Model::SCC)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SC", static_cast<int>(0.0), &ADMSbsim6::Model::SC)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance to a single well edge if <=0.0, turn off WPE");
  p.addPar("TYPE", static_cast<int>(1), &ADMSbsim6::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("CVMOD", static_cast<int>(0), &ADMSbsim6::Model::CVMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Consistent IV-CV, 1: Different IV-CV");
  p.addPar("COVMOD", static_cast<int>(0), &ADMSbsim6::Model::COVMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Use Bias-independent Overlap Capacitances,  1: Use Bias-dependent Overlap Capacitances");
  p.addPar("RDSMOD", static_cast<int>(0), &ADMSbsim6::Model::RDSMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Internal bias dependent and external bias independent s/d resistance model,  1: External s/d resistance model,  2: Internal s/d resistance model");
  p.addPar("WPEMOD", static_cast<int>(0), &ADMSbsim6::Model::WPEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Model flag");
  p.addPar("ASYMMOD", static_cast<int>(0), &ADMSbsim6::Model::ASYMMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Asymmetry Model turned off - forward mode parameters used,  1: Asymmetry Model turned on");
  p.addPar("GIDLMOD", static_cast<int>(0), &ADMSbsim6::Model::GIDLMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off GIDL Current,  1: Turn on GIDL Current");
  p.addPar("IGCMOD", static_cast<int>(0), &ADMSbsim6::Model::IGCMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off Igc, Igs and Igd,  1: Turn on Igc, Igs and Igd");
  p.addPar("IGBMOD", static_cast<int>(0), &ADMSbsim6::Model::IGBMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off Igb,  1: Turn on Igb");
  p.addPar("TNOIMOD", static_cast<int>(0), &ADMSbsim6::Model::TNOIMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise model selector");
  p.addPar("SHMOD", static_cast<int>(0), &ADMSbsim6::Model::SHMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0 : Self heating model OFF,  1 : Self heating model ON");
  p.addPar("MOBSCALE", static_cast<int>(0), &ADMSbsim6::Model::MOBSCALE)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility scaling model, 0: Old Model,  1: New Model");
  p.addPar("LLONG", static_cast<double>(10*1.0e-6), &ADMSbsim6::Model::LLONG)
    .setUnit(U_METER)
    .setDescription("L of extracted Long channel device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMLT", static_cast<double>(1.0), &ADMSbsim6::Model::LMLT)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Shrinking Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WMLT", static_cast<double>(1.0), &ADMSbsim6::Model::WMLT)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Shrinking Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XL", static_cast<double>(0.0), &ADMSbsim6::Model::XL)
    .setUnit(U_UNKNOWN)
    .setDescription("L offset for channel length due to mask/etch effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WWIDE", static_cast<double>(10*1.0e-6), &ADMSbsim6::Model::WWIDE)
    .setUnit(U_METER)
    .setDescription("W of extracted Wide channel device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XW", static_cast<double>(0.0), &ADMSbsim6::Model::XW)
    .setUnit(U_UNKNOWN)
    .setDescription("W offset for channel width due to mask/etch effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LINT", static_cast<double>(0.0), &ADMSbsim6::Model::LINT)
    .setUnit(U_UNKNOWN)
    .setDescription("delta L for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LL", static_cast<double>(0.0), &ADMSbsim6::Model::LL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LW", static_cast<double>(0.0), &ADMSbsim6::Model::LW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LWL", static_cast<double>(0.0), &ADMSbsim6::Model::LWL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLN", static_cast<double>(1.0), &ADMSbsim6::Model::LLN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LWN", static_cast<double>(1.0), &ADMSbsim6::Model::LWN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WINT", static_cast<double>(0.0), &ADMSbsim6::Model::WINT)
    .setUnit(U_UNKNOWN)
    .setDescription("delta W for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WL", static_cast<double>(0.0), &ADMSbsim6::Model::WL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WW", static_cast<double>(0.0), &ADMSbsim6::Model::WW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WWL", static_cast<double>(0.0), &ADMSbsim6::Model::WWL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLN", static_cast<double>(1.0), &ADMSbsim6::Model::WLN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WWN", static_cast<double>(1.0), &ADMSbsim6::Model::WWN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLC", static_cast<double>(0.0), &ADMSbsim6::Model::DLC)
    .setUnit(U_UNKNOWN)
    .setDescription("delta L for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLC", static_cast<double>(0.0), &ADMSbsim6::Model::LLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LWC", static_cast<double>(0.0), &ADMSbsim6::Model::LWC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LWLC", static_cast<double>(0.0), &ADMSbsim6::Model::LWLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DWC", static_cast<double>(0.0), &ADMSbsim6::Model::DWC)
    .setUnit(U_UNKNOWN)
    .setDescription("delta W for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLC", static_cast<double>(0.0), &ADMSbsim6::Model::WLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WWC", static_cast<double>(0.0), &ADMSbsim6::Model::WWC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WWLC", static_cast<double>(0.0), &ADMSbsim6::Model::WWLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXE", static_cast<double>(3.0e-9), &ADMSbsim6::Model::TOXE)
    .setUnit(U_METER)
    .setDescription("Effective gate dielectric thickness relative to SiO2, m")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXP", 0.0, &ADMSbsim6::Model::TOXP)
    .setUnit(U_METER)
    .setDescription("Physical gate dielectric thickness,If not given, TOXP is calculated from TOXE and DTOX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTOX", static_cast<double>(0.0), &ADMSbsim6::Model::DTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("Difference between effective dielectric thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEP", static_cast<double>(1e24), &ADMSbsim6::Model::NDEP)
    .setUnit(U_METERM3)
    .setDescription("Channel Doping Concentration for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPL1", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPL1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPLEXP1", static_cast<double>(1.0), &ADMSbsim6::Model::NDEPLEXP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPL2", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of NDEP - For Short Channel Devices")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPLEXP2", static_cast<double>(2.0), &ADMSbsim6::Model::NDEPLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPW", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NDEPWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPWL", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NDEPWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNDEP", static_cast<double>(0.0), &ADMSbsim6::Model::LNDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNDEP", static_cast<double>(0.0), &ADMSbsim6::Model::WNDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNDEP", static_cast<double>(0.0), &ADMSbsim6::Model::PNDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCV", 0.0, &ADMSbsim6::Model::NDEPCV)
    .setUnit(U_METERM3)
    .setDescription("Channel Doping Concentration for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVL1", 0.0, &ADMSbsim6::Model::NDEPCVL1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVLEXP1", 0.0, &ADMSbsim6::Model::NDEPCVLEXP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVL2", 0.0, &ADMSbsim6::Model::NDEPCVL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NDEPCV - For Short Channel Devices")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVLEXP2", 0.0, &ADMSbsim6::Model::NDEPCVLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVW", 0.0, &ADMSbsim6::Model::NDEPCVW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVWEXP", 0.0, &ADMSbsim6::Model::NDEPCVWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVWL", 0.0, &ADMSbsim6::Model::NDEPCVWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDEPCVWLEXP", 0.0, &ADMSbsim6::Model::NDEPCVWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNDEPCV", 0.0, &ADMSbsim6::Model::LNDEPCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNDEPCV", 0.0, &ADMSbsim6::Model::WNDEPCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNDEPCV", 0.0, &ADMSbsim6::Model::PNDEPCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGATE", static_cast<double>(5e25), &ADMSbsim6::Model::NGATE)
    .setUnit(U_METERM3)
    .setDescription("Gate Doping Concentration")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNGATE", static_cast<double>(0.0), &ADMSbsim6::Model::LNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNGATE", static_cast<double>(0.0), &ADMSbsim6::Model::WNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNGATE", static_cast<double>(0.0), &ADMSbsim6::Model::PNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EASUB", static_cast<double>(4.05), &ADMSbsim6::Model::EASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Electron affinity of substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NI0SUB", static_cast<double>(1.1e16), &ADMSbsim6::Model::NI0SUB)
    .setUnit(U_METERM3)
    .setDescription("Intrinsic carrier concentration of the substrate at 300.15K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BG0SUB", static_cast<double>(1.17), &ADMSbsim6::Model::BG0SUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Band gap of substrate at 300.15K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSRSUB", static_cast<double>(11.9), &ADMSbsim6::Model::EPSRSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the channel material")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSROX", static_cast<double>(3.9), &ADMSbsim6::Model::EPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJ", static_cast<double>(1.5e-7), &ADMSbsim6::Model::XJ)
    .setUnit(U_UNKNOWN)
    .setDescription("S/D junction depth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LXJ", static_cast<double>(0.0), &ADMSbsim6::Model::LXJ)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WXJ", static_cast<double>(0.0), &ADMSbsim6::Model::WXJ)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PXJ", static_cast<double>(0.0), &ADMSbsim6::Model::PXJ)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVFB", static_cast<double>(0.0), &ADMSbsim6::Model::LVFB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVFB", static_cast<double>(0.0), &ADMSbsim6::Model::WVFB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVFB", static_cast<double>(0.0), &ADMSbsim6::Model::PVFB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFB", static_cast<double>((-0.5)), &ADMSbsim6::Model::VFB)
    .setUnit(U_VOLT)
    .setDescription("Flat band voltage ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCV", 0.0, &ADMSbsim6::Model::VFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Flat band voltage for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVFBCV", 0.0, &ADMSbsim6::Model::LVFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVFBCV", 0.0, &ADMSbsim6::Model::WVFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVFBCV", 0.0, &ADMSbsim6::Model::PVFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCVL", static_cast<double>(0.0), &ADMSbsim6::Model::VFBCVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCVLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VFBCVLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCVW", static_cast<double>(0.0), &ADMSbsim6::Model::VFBCVW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCVWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VFBCVWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCVWL", static_cast<double>(0.0), &ADMSbsim6::Model::VFBCVWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBCVWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VFBCVWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PERMOD", static_cast<int>(1), &ADMSbsim6::Model::PERMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Whether PS/PD (when given) include gate-edge perimeter");
  p.addPar("DWJ", 0.0, &ADMSbsim6::Model::DWJ)
    .setUnit(U_UNKNOWN)
    .setDescription("delta W for S/D junctions")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSD", static_cast<double>(1e26), &ADMSbsim6::Model::NSD)
    .setUnit(U_METERM3)
    .setDescription("S/D Doping Concentration")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNSD", static_cast<double>(0.0), &ADMSbsim6::Model::LNSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNSD", static_cast<double>(0.0), &ADMSbsim6::Model::WNSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNSD", static_cast<double>(0.0), &ADMSbsim6::Model::PNSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVT0", static_cast<double>(0.0), &ADMSbsim6::Model::DELVT0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP0", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTP0", static_cast<double>(0), &ADMSbsim6::Model::LDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDVTP0", static_cast<double>(0), &ADMSbsim6::Model::WDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTP0", static_cast<double>(0), &ADMSbsim6::Model::PDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP1", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTP1", static_cast<double>(0), &ADMSbsim6::Model::LDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDVTP1", static_cast<double>(0), &ADMSbsim6::Model::WDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTP1", static_cast<double>(0), &ADMSbsim6::Model::PDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP2", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTP2", static_cast<double>(0), &ADMSbsim6::Model::LDVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDVTP2", static_cast<double>(0), &ADMSbsim6::Model::WDVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTP2", static_cast<double>(0), &ADMSbsim6::Model::PDVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP3", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTP3", static_cast<double>(0), &ADMSbsim6::Model::LDVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDVTP3", static_cast<double>(0), &ADMSbsim6::Model::WDVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTP3", static_cast<double>(0), &ADMSbsim6::Model::PDVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP4", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTP4", static_cast<double>(0), &ADMSbsim6::Model::LDVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDVTP4", static_cast<double>(0), &ADMSbsim6::Model::WDVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTP4", static_cast<double>(0), &ADMSbsim6::Model::PDVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTP5", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDVTP5", static_cast<double>(0), &ADMSbsim6::Model::LDVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDVTP5", static_cast<double>(0), &ADMSbsim6::Model::WDVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDVTP5", static_cast<double>(0), &ADMSbsim6::Model::PDVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIN", static_cast<double>(0.045), &ADMSbsim6::Model::PHIN)
    .setUnit(U_VOLT)
    .setDescription("Nonuniform vertical doping effect on surface potential, V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPHIN", static_cast<double>(0.0), &ADMSbsim6::Model::LPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPHIN", static_cast<double>(0.0), &ADMSbsim6::Model::WPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPHIN", static_cast<double>(0.0), &ADMSbsim6::Model::PPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0", static_cast<double>(0.08), &ADMSbsim6::Model::ETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LETA0", static_cast<double>(0.0), &ADMSbsim6::Model::LETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WETA0", static_cast<double>(0.0), &ADMSbsim6::Model::WETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PETA0", static_cast<double>(0.0), &ADMSbsim6::Model::PETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0R", 0.0, &ADMSbsim6::Model::ETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LETA0R", 0.0, &ADMSbsim6::Model::LETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WETA0R", 0.0, &ADMSbsim6::Model::WETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PETA0R", 0.0, &ADMSbsim6::Model::PETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DSUB", static_cast<double>(1.0), &ADMSbsim6::Model::DSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Length scaling exponent for DIBL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETAB", static_cast<double>((-0.07)), &ADMSbsim6::Model::ETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("Body bias coefficient for subthreshold DIBL effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETABEXP", static_cast<double>(1.0), &ADMSbsim6::Model::ETABEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent coefficient of ETAB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LETAB", static_cast<double>(0.0), &ADMSbsim6::Model::LETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WETAB", static_cast<double>(0.0), &ADMSbsim6::Model::WETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PETAB", static_cast<double>(0.0), &ADMSbsim6::Model::PETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1", static_cast<double>(0.0), &ADMSbsim6::Model::K1)
    .setUnit(U_UNKNOWN)
    .setDescription("First-order body-bias Vth shift due to Vertical Non-uniform doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1L", static_cast<double>(0.0), &ADMSbsim6::Model::K1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K1LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1W", static_cast<double>(0.0), &ADMSbsim6::Model::K1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1WEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K1WEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1WL", static_cast<double>(0.0), &ADMSbsim6::Model::K1WL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K1WLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K1WLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK1", static_cast<double>(0.0), &ADMSbsim6::Model::LK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WK1", static_cast<double>(0.0), &ADMSbsim6::Model::WK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK1", static_cast<double>(0.0), &ADMSbsim6::Model::PK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2", static_cast<double>(0.0), &ADMSbsim6::Model::K2)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth shift due to Vertical Non-uniform doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2L", static_cast<double>(0.0), &ADMSbsim6::Model::K2L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K2LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2W", static_cast<double>(0.0), &ADMSbsim6::Model::K2W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2WEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K2WEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2WL", static_cast<double>(0.0), &ADMSbsim6::Model::K2WL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2WLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K2WLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2", static_cast<double>(0.0), &ADMSbsim6::Model::LK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WK2", static_cast<double>(0.0), &ADMSbsim6::Model::WK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2", static_cast<double>(0.0), &ADMSbsim6::Model::PK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ADOS", static_cast<double>(0.0), &ADMSbsim6::Model::ADOS)
    .setUnit(U_UNKNOWN)
    .setDescription("Quantum mechanical effect prefactor cum switch in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BDOS", static_cast<double>(1.0), &ADMSbsim6::Model::BDOS)
    .setUnit(U_UNKNOWN)
    .setDescription("Charge centroid parameter - slope of CV curve under QME in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QM0", static_cast<double>(1.0e-3), &ADMSbsim6::Model::QM0)
    .setUnit(U_UNKNOWN)
    .setDescription("Charge centroid parameter - starting point for QME in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETAQM", static_cast<double>(0.54), &ADMSbsim6::Model::ETAQM)
    .setUnit(U_UNKNOWN)
    .setDescription("Bulk charge coefficient for charge centroid in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIT", static_cast<double>(0.0), &ADMSbsim6::Model::CIT)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for interface trap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIT", static_cast<double>(0.0), &ADMSbsim6::Model::LCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCIT", static_cast<double>(0.0), &ADMSbsim6::Model::WCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIT", static_cast<double>(0.0), &ADMSbsim6::Model::PCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub-threshold slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTORL", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTORL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTORLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NFACTORLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTORW", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTORW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTORWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NFACTORWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTORWL", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTORWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTORWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NFACTORWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::LNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::WNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::PNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCD", static_cast<double>(1e-9), &ADMSbsim6::Model::CDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("drain-bias sensitivity of sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDL", static_cast<double>(0.0), &ADMSbsim6::Model::CDSCDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::CDSCDLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCDSCD", static_cast<double>(0.0), &ADMSbsim6::Model::LCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCDSCD", static_cast<double>(0.0), &ADMSbsim6::Model::WCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCDSCD", static_cast<double>(0.0), &ADMSbsim6::Model::PCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDR", 0.0, &ADMSbsim6::Model::CDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("drain-bias sensitivity of sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDLR", 0.0, &ADMSbsim6::Model::CDSCDLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCDSCDR", 0.0, &ADMSbsim6::Model::LCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCDSCDR", 0.0, &ADMSbsim6::Model::WCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCDSCDR", 0.0, &ADMSbsim6::Model::PCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::CDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("body-bias sensitivity of sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCBL", static_cast<double>(0.0), &ADMSbsim6::Model::CDSCBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of CDSCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCBLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::CDSCBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of CDSCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::LCDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::WCDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::PCDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSAT", static_cast<double>(1e5), &ADMSbsim6::Model::VSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation Velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::LVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::WVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::PVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATL", static_cast<double>(0.0), &ADMSbsim6::Model::VSATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VSATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATW", static_cast<double>(0.0), &ADMSbsim6::Model::VSATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VSATWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATWL", static_cast<double>(0.0), &ADMSbsim6::Model::VSATWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VSATWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATR", 0.0, &ADMSbsim6::Model::VSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation Velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSATR", 0.0, &ADMSbsim6::Model::LVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVSATR", 0.0, &ADMSbsim6::Model::WVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSATR", 0.0, &ADMSbsim6::Model::PVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA", static_cast<double>(0.125), &ADMSbsim6::Model::DELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("Smoothing function factor for Vdsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::LDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::WDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::PDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTAL", static_cast<double>(0.0), &ADMSbsim6::Model::DELTAL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of DELTA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTALEXP", static_cast<double>(1.0), &ADMSbsim6::Model::DELTALEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of DELTA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCV", 0.0, &ADMSbsim6::Model::VSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("VSAT parameter for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVSATCV", 0.0, &ADMSbsim6::Model::LVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVSATCV", 0.0, &ADMSbsim6::Model::WVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVSATCV", 0.0, &ADMSbsim6::Model::PVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCVL", 0.0, &ADMSbsim6::Model::VSATCVL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCVLEXP", 0.0, &ADMSbsim6::Model::VSATCVLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCVW", 0.0, &ADMSbsim6::Model::VSATCVW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCVWEXP", 0.0, &ADMSbsim6::Model::VSATCVWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCVWL", 0.0, &ADMSbsim6::Model::VSATCVWL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSATCVWLEXP", 0.0, &ADMSbsim6::Model::VSATCVWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UP1", static_cast<double>(0.0), &ADMSbsim6::Model::UP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP1", static_cast<double>(1.0e-8), &ADMSbsim6::Model::LP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length exponential coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UP2", static_cast<double>(0.0), &ADMSbsim6::Model::UP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP2", static_cast<double>(1.0e-8), &ADMSbsim6::Model::LP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length exponential coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULU0", static_cast<double>(1.0), &ADMSbsim6::Model::MULU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0", static_cast<double>(67.0e-3), &ADMSbsim6::Model::U0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0L", static_cast<double>(0.0), &ADMSbsim6::Model::U0L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of U0L")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::U0LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of U0L")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LU0", static_cast<double>(0.0), &ADMSbsim6::Model::LU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WU0", static_cast<double>(0.0), &ADMSbsim6::Model::WU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PU0", static_cast<double>(0.0), &ADMSbsim6::Model::PU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("U0R", 0.0, &ADMSbsim6::Model::U0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LU0R", 0.0, &ADMSbsim6::Model::LU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WU0R", 0.0, &ADMSbsim6::Model::WU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PU0R", 0.0, &ADMSbsim6::Model::PU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETAMOB", static_cast<double>(1.0), &ADMSbsim6::Model::ETAMOB)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter (should be kept close to 1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UA", static_cast<double>(0.001), &ADMSbsim6::Model::UA)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAL", static_cast<double>(0.0), &ADMSbsim6::Model::UAL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of  UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UALEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UALEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of  UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAW", static_cast<double>(0.0), &ADMSbsim6::Model::UAW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UAWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAWL", static_cast<double>(0.0), &ADMSbsim6::Model::UAWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UAWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUA", static_cast<double>(0.0), &ADMSbsim6::Model::LUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUA", static_cast<double>(0.0), &ADMSbsim6::Model::WUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUA", static_cast<double>(0.0), &ADMSbsim6::Model::PUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UAR", 0.0, &ADMSbsim6::Model::UAR)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUAR", 0.0, &ADMSbsim6::Model::LUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUAR", 0.0, &ADMSbsim6::Model::WUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUAR", 0.0, &ADMSbsim6::Model::PUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EU", static_cast<double>(1.5), &ADMSbsim6::Model::EU)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEU", static_cast<double>(0.0), &ADMSbsim6::Model::LEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEU", static_cast<double>(0.0), &ADMSbsim6::Model::WEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEU", static_cast<double>(0.0), &ADMSbsim6::Model::PEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EUL", static_cast<double>(0.0), &ADMSbsim6::Model::EUL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EULEXP", static_cast<double>(1.0), &ADMSbsim6::Model::EULEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EUW", static_cast<double>(0.0), &ADMSbsim6::Model::EUW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EUWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::EUWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EUWL", static_cast<double>(0.0), &ADMSbsim6::Model::EUWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EUWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::EUWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UD", static_cast<double>(0.001), &ADMSbsim6::Model::UD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UDL", static_cast<double>(0.0), &ADMSbsim6::Model::UDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UDLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UDLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUD", static_cast<double>(0.0), &ADMSbsim6::Model::LUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUD", static_cast<double>(0.0), &ADMSbsim6::Model::WUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUD", static_cast<double>(0.0), &ADMSbsim6::Model::PUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UDR", 0.0, &ADMSbsim6::Model::UDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUDR", 0.0, &ADMSbsim6::Model::LUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUDR", 0.0, &ADMSbsim6::Model::WUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUDR", 0.0, &ADMSbsim6::Model::PUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCS", static_cast<double>(2.0), &ADMSbsim6::Model::UCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCS", static_cast<double>(0.0), &ADMSbsim6::Model::LUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUCS", static_cast<double>(0.0), &ADMSbsim6::Model::WUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCS", static_cast<double>(0.0), &ADMSbsim6::Model::PUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCSR", 0.0, &ADMSbsim6::Model::UCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCSR", 0.0, &ADMSbsim6::Model::LUCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUCSR", 0.0, &ADMSbsim6::Model::WUCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCSR", 0.0, &ADMSbsim6::Model::PUCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UC", static_cast<double>(0.0), &ADMSbsim6::Model::UC)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction with body bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCL", static_cast<double>(0.0), &ADMSbsim6::Model::UCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UCLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCW", static_cast<double>(0.0), &ADMSbsim6::Model::UCW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UCWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCWL", static_cast<double>(0.0), &ADMSbsim6::Model::UCWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UCWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUC", static_cast<double>(0.0), &ADMSbsim6::Model::LUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUC", static_cast<double>(0.0), &ADMSbsim6::Model::WUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUC", static_cast<double>(0.0), &ADMSbsim6::Model::PUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCR", 0.0, &ADMSbsim6::Model::UCR)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction with body bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCR", 0.0, &ADMSbsim6::Model::LUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUCR", 0.0, &ADMSbsim6::Model::WUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCR", 0.0, &ADMSbsim6::Model::PUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLM", static_cast<double>(0.0), &ADMSbsim6::Model::PCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLML", static_cast<double>(0.0), &ADMSbsim6::Model::PCLML)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PCLMLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLM", static_cast<double>(0.0), &ADMSbsim6::Model::LPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPCLM", static_cast<double>(0.0), &ADMSbsim6::Model::WPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLM", static_cast<double>(0.0), &ADMSbsim6::Model::PPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMR", 0.0, &ADMSbsim6::Model::PCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLMR", 0.0, &ADMSbsim6::Model::LPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPCLMR", 0.0, &ADMSbsim6::Model::WPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLMR", 0.0, &ADMSbsim6::Model::PPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMG", static_cast<double>(0.0), &ADMSbsim6::Model::PCLMG)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM prefactor gate voltage dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMCV", 0.0, &ADMSbsim6::Model::PCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM parameter for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMCVL", 0.0, &ADMSbsim6::Model::PCLMCVL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCLMCVLEXP", 0.0, &ADMSbsim6::Model::PCLMCVLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCLMCV", 0.0, &ADMSbsim6::Model::LPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPCLMCV", 0.0, &ADMSbsim6::Model::WPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPCLMCV", 0.0, &ADMSbsim6::Model::PPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCBE1", static_cast<double>(4.24e8), &ADMSbsim6::Model::PSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate current body-effect coeff")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSCBE1", static_cast<double>(0.0), &ADMSbsim6::Model::LPSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPSCBE1", static_cast<double>(0.0), &ADMSbsim6::Model::WPSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSCBE1", static_cast<double>(0.0), &ADMSbsim6::Model::PPSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCBE2", static_cast<double>(1.0e-8), &ADMSbsim6::Model::PSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate current body-effect coeff")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSCBE2", static_cast<double>(0.0), &ADMSbsim6::Model::LPSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPSCBE2", static_cast<double>(0.0), &ADMSbsim6::Model::WPSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSCBE2", static_cast<double>(0.0), &ADMSbsim6::Model::PPSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDITS", static_cast<double>(0.0), &ADMSbsim6::Model::PDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for drain-induced Vth shifts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDITS", static_cast<double>(0.0), &ADMSbsim6::Model::LPDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPDITS", static_cast<double>(0.0), &ADMSbsim6::Model::WPDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDITS", static_cast<double>(0.0), &ADMSbsim6::Model::PPDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDITSL", static_cast<double>(0.0), &ADMSbsim6::Model::PDITSL)
    .setUnit(U_UNKNOWN)
    .setDescription("L dep of drain-induced Vth shifts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::PDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Vds dep of drain-induced Vth shifts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::LPDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::WPDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::PPDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSH", static_cast<double>(0.0), &ADMSbsim6::Model::RSH)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-drain sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRWG", static_cast<double>(1.0), &ADMSbsim6::Model::PRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("gate bias dependence of S/D extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPRWG", static_cast<double>(0.0), &ADMSbsim6::Model::LPRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPRWG", static_cast<double>(0.0), &ADMSbsim6::Model::WPRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPRWG", static_cast<double>(0.0), &ADMSbsim6::Model::PPRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRWB", static_cast<double>(0.0), &ADMSbsim6::Model::PRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("Body bias dependence of resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPRWB", static_cast<double>(0.0), &ADMSbsim6::Model::LPRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPRWB", static_cast<double>(0.0), &ADMSbsim6::Model::WPRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPRWB", static_cast<double>(0.0), &ADMSbsim6::Model::PPRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRWBL", static_cast<double>(0.0), &ADMSbsim6::Model::PRWBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PPRWB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRWBLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PRWBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PPRWB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WR", static_cast<double>(1.0), &ADMSbsim6::Model::WR)
    .setUnit(U_UNKNOWN)
    .setDescription("W dependence parameter of S/D extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LWR", static_cast<double>(0.0), &ADMSbsim6::Model::LWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WWR", static_cast<double>(0.0), &ADMSbsim6::Model::WWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWR", static_cast<double>(0.0), &ADMSbsim6::Model::PWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::RSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Source Resistance per unit width at high Vgs (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::LRSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WRSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::WRSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::PRSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSW", static_cast<double>(10.0), &ADMSbsim6::Model::RSW)
    .setUnit(U_UNKNOWN)
    .setDescription("zero bias Source Resistance (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRSW", static_cast<double>(0.0), &ADMSbsim6::Model::LRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WRSW", static_cast<double>(0.0), &ADMSbsim6::Model::WRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRSW", static_cast<double>(0.0), &ADMSbsim6::Model::PRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSWL", static_cast<double>(0.0), &ADMSbsim6::Model::RSWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RSW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::RSWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RSW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDWMIN", 0.0, &ADMSbsim6::Model::RDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain Resistance per unit width at high Vgs (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRDWMIN", 0.0, &ADMSbsim6::Model::LRDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WRDWMIN", 0.0, &ADMSbsim6::Model::WRDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDWMIN", 0.0, &ADMSbsim6::Model::PRDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDW", 0.0, &ADMSbsim6::Model::RDW)
    .setUnit(U_UNKNOWN)
    .setDescription("zero bias Drain Resistance (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRDW", 0.0, &ADMSbsim6::Model::LRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WRDW", 0.0, &ADMSbsim6::Model::WRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDW", 0.0, &ADMSbsim6::Model::PRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDWL", 0.0, &ADMSbsim6::Model::RDWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDWLEXP", 0.0, &ADMSbsim6::Model::RDWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::RDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("S/D Resistance per unit width at high Vgs (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::LRDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WRDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::WRDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::PRDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDSW", static_cast<double>(20.0), &ADMSbsim6::Model::RDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("zero bias Resistance (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDSWL", static_cast<double>(0.0), &ADMSbsim6::Model::RDSWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDSW (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDSWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::RDSWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDSW (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LRDSW", static_cast<double>(0.0), &ADMSbsim6::Model::LRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WRDSW", static_cast<double>(0.0), &ADMSbsim6::Model::WRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRDSW", static_cast<double>(0.0), &ADMSbsim6::Model::PRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSAT", static_cast<double>(1.0), &ADMSbsim6::Model::PSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Gmsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSAT", static_cast<double>(0.0), &ADMSbsim6::Model::LPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPSAT", static_cast<double>(0.0), &ADMSbsim6::Model::WPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSAT", static_cast<double>(0.0), &ADMSbsim6::Model::PPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSATL", static_cast<double>(0.0), &ADMSbsim6::Model::PSATL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSATLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PSATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSATB", static_cast<double>(0.0), &ADMSbsim6::Model::PSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("Body bias effect on Idsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSATR", 0.0, &ADMSbsim6::Model::PSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("Gmsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSATR", 0.0, &ADMSbsim6::Model::LPSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPSATR", 0.0, &ADMSbsim6::Model::WPSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSATR", 0.0, &ADMSbsim6::Model::PPSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPSATB", static_cast<double>(0.0), &ADMSbsim6::Model::LPSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPSATB", static_cast<double>(0.0), &ADMSbsim6::Model::WPSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPSATB", static_cast<double>(0.0), &ADMSbsim6::Model::PPSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSATX", static_cast<double>(1.0), &ADMSbsim6::Model::PSATX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWG", static_cast<double>(0.0), &ADMSbsim6::Model::PTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Idsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPTWG", static_cast<double>(0.0), &ADMSbsim6::Model::LPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPTWG", static_cast<double>(0.0), &ADMSbsim6::Model::WPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPTWG", static_cast<double>(0.0), &ADMSbsim6::Model::PPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGL", static_cast<double>(0.0), &ADMSbsim6::Model::PTWGL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PTWGLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGR", 0.0, &ADMSbsim6::Model::PTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("Idsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPTWGR", 0.0, &ADMSbsim6::Model::LPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPTWGR", 0.0, &ADMSbsim6::Model::WPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPTWGR", 0.0, &ADMSbsim6::Model::PPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGLR", 0.0, &ADMSbsim6::Model::PTWGLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGLEXPR", 0.0, &ADMSbsim6::Model::PTWGLEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1", static_cast<double>(0.0), &ADMSbsim6::Model::A1)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-saturation effect parameter for strong inversion region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA1", static_cast<double>(0.0), &ADMSbsim6::Model::LA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WA1", static_cast<double>(0.0), &ADMSbsim6::Model::WA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA1", static_cast<double>(0.0), &ADMSbsim6::Model::PA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A11", static_cast<double>(0.0), &ADMSbsim6::Model::A11)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA11", static_cast<double>(0.0), &ADMSbsim6::Model::LA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WA11", static_cast<double>(0.0), &ADMSbsim6::Model::WA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA11", static_cast<double>(0.0), &ADMSbsim6::Model::PA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A2", static_cast<double>(0.0), &ADMSbsim6::Model::A2)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-saturation effect parameter for moderate inversion region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA2", static_cast<double>(0.0), &ADMSbsim6::Model::LA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WA2", static_cast<double>(0.0), &ADMSbsim6::Model::WA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA2", static_cast<double>(0.0), &ADMSbsim6::Model::PA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A21", static_cast<double>(0.0), &ADMSbsim6::Model::A21)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LA21", static_cast<double>(0.0), &ADMSbsim6::Model::LA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WA21", static_cast<double>(0.0), &ADMSbsim6::Model::WA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PA21", static_cast<double>(0.0), &ADMSbsim6::Model::PA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLCL", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLCLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PDIBLCLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::LPDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::WPDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::PPDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLCR", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLCLR", 0.0, &ADMSbsim6::Model::PDIBLCLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLCLEXPR", 0.0, &ADMSbsim6::Model::PDIBLCLEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBLCR", 0.0, &ADMSbsim6::Model::LPDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPDIBLCR", 0.0, &ADMSbsim6::Model::WPDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBLCR", 0.0, &ADMSbsim6::Model::PPDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::LPDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::WPDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::PPDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PVAG", static_cast<double>(1.0), &ADMSbsim6::Model::PVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("Vg dependence of early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPVAG", static_cast<double>(0.0), &ADMSbsim6::Model::LPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPVAG", static_cast<double>(0.0), &ADMSbsim6::Model::WPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPVAG", static_cast<double>(0.0), &ADMSbsim6::Model::PPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::FPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FPROUTL", static_cast<double>(0.0), &ADMSbsim6::Model::FPROUTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of FPROUT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FPROUTLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::FPROUTLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of FPROUT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LFPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::LFPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WFPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::WFPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PFPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::PFPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::ALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("first parameter of Iii, m/V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA0L", static_cast<double>(0.0), &ADMSbsim6::Model::ALPHA0L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of ALPHA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA0LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::ALPHA0LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of ALPHA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::LALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::WALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::PALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETA0", static_cast<double>(0.0), &ADMSbsim6::Model::BETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("Vds dependent parameter of Iii, 1/V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBETA0", static_cast<double>(0.0), &ADMSbsim6::Model::LBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBETA0", static_cast<double>(0.0), &ADMSbsim6::Model::WBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBETA0", static_cast<double>(0.0), &ADMSbsim6::Model::PBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGBACC", static_cast<double>(1.36e-2), &ADMSbsim6::Model::AIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGBACC", static_cast<double>(1.71e-3), &ADMSbsim6::Model::BIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGBACC", static_cast<double>(0.075), &ADMSbsim6::Model::CIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NIGBACC", static_cast<double>(1.0), &ADMSbsim6::Model::NIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igbacc slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGBINV", static_cast<double>(1.11e-2), &ADMSbsim6::Model::AIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGBINV", static_cast<double>(9.49e-4), &ADMSbsim6::Model::BIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGBINV", static_cast<double>(0.006), &ADMSbsim6::Model::CIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EIGBINV", static_cast<double>(1.1), &ADMSbsim6::Model::EIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parm for the Si bandgap for Igbinv")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NIGBINV", static_cast<double>(3.0), &ADMSbsim6::Model::NIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igbinv slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGC", 0.0, &ADMSbsim6::Model::AIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGC", 0.0, &ADMSbsim6::Model::BIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGC", 0.0, &ADMSbsim6::Model::CIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGS", 0.0, &ADMSbsim6::Model::AIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGS", 0.0, &ADMSbsim6::Model::BIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGS", 0.0, &ADMSbsim6::Model::CIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGD", 0.0, &ADMSbsim6::Model::AIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BIGD", 0.0, &ADMSbsim6::Model::BIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CIGD", 0.0, &ADMSbsim6::Model::CIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLCIG", 0.0, &ADMSbsim6::Model::DLCIG)
    .setUnit(U_METER)
    .setDescription("Delta L for Ig model [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLCIGD", 0.0, &ADMSbsim6::Model::DLCIGD)
    .setUnit(U_METER)
    .setDescription("Delta L for Ig model [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POXEDGE", static_cast<double>(1.0), &ADMSbsim6::Model::POXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Factor for the gate edge Tox")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTOX", static_cast<double>(1.0), &ADMSbsim6::Model::NTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for Tox ratio")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXREF", static_cast<double>(3.0e-9), &ADMSbsim6::Model::TOXREF)
    .setUnit(U_METER)
    .setDescription("Target tox value")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIGCD", static_cast<double>(1.0), &ADMSbsim6::Model::PIGCD)
    .setUnit(U_UNKNOWN)
    .setDescription("Igc, S/D partition parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGCL", static_cast<double>(0.0), &ADMSbsim6::Model::AIGCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AIGC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGCW", static_cast<double>(0.0), &ADMSbsim6::Model::AIGCW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AIGC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGSL", static_cast<double>(0.0), &ADMSbsim6::Model::AIGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AIGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGSW", static_cast<double>(0.0), &ADMSbsim6::Model::AIGSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AIGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGDL", static_cast<double>(0.0), &ADMSbsim6::Model::AIGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AIGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AIGDW", static_cast<double>(0.0), &ADMSbsim6::Model::AIGDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AIGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIGCDL", static_cast<double>(0.0), &ADMSbsim6::Model::PIGCDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PIGCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGC", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAIGC", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGC", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGC", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBIGC", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGC", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGC", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCIGC", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGC", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGS", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAIGS", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGS", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGS", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBIGS", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGS", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGS", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCIGS", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGS", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPOXEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::LPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPOXEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::WPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPOXEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::PPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDLCIG", static_cast<double>(0.0), &ADMSbsim6::Model::LDLCIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDLCIG", static_cast<double>(0.0), &ADMSbsim6::Model::WDLCIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDLCIG", static_cast<double>(0.0), &ADMSbsim6::Model::PDLCIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LDLCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LDLCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WDLCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WDLCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PDLCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PDLCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LNTOX", static_cast<double>(0.0), &ADMSbsim6::Model::LNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WNTOX", static_cast<double>(0.0), &ADMSbsim6::Model::WNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PNTOX", static_cast<double>(0.0), &ADMSbsim6::Model::PNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::AGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("pre-exponential coeff. for GIDL in mho")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLL", static_cast<double>(0.0), &ADMSbsim6::Model::AGIDLL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSbsim6::Model::AGIDLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDL", static_cast<double>(2.3e9), &ADMSbsim6::Model::BGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GIDL in")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDL", static_cast<double>(0.5), &ADMSbsim6::Model::CGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GIDL in V/m")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EGIDL", static_cast<double>(0.8), &ADMSbsim6::Model::EGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("band bending parameter for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGISL", 0.0, &ADMSbsim6::Model::AGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("pre-exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGISLL", 0.0, &ADMSbsim6::Model::AGISLL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AGISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGISLW", 0.0, &ADMSbsim6::Model::AGISLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AGISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAGISL", 0.0, &ADMSbsim6::Model::LAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAGISL", 0.0, &ADMSbsim6::Model::WAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAGISL", 0.0, &ADMSbsim6::Model::PAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGISL", 0.0, &ADMSbsim6::Model::BGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LBGISL", 0.0, &ADMSbsim6::Model::LBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBGISL", 0.0, &ADMSbsim6::Model::WBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBGISL", 0.0, &ADMSbsim6::Model::PBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGISL", 0.0, &ADMSbsim6::Model::CGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGISL", 0.0, &ADMSbsim6::Model::LCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCGISL", 0.0, &ADMSbsim6::Model::WCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGISL", 0.0, &ADMSbsim6::Model::PCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EGISL", 0.0, &ADMSbsim6::Model::EGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("band bending parameter for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LEGISL", 0.0, &ADMSbsim6::Model::LEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEGISL", 0.0, &ADMSbsim6::Model::WEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PEGISL", 0.0, &ADMSbsim6::Model::PEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CF", static_cast<double>(0.0), &ADMSbsim6::Model::CF)
    .setUnit(U_FARAD)
    .setDescription("Outer Fringe Cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCF", static_cast<double>(0.0), &ADMSbsim6::Model::LCF)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCF", static_cast<double>(0.0), &ADMSbsim6::Model::WCF)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCF", static_cast<double>(0.0), &ADMSbsim6::Model::PCF)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFRCOEFF", static_cast<double>(1.0), &ADMSbsim6::Model::CFRCOEFF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for Outer Fringe Cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGSO", static_cast<double>(0.0), &ADMSbsim6::Model::CGSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Source overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGDO", static_cast<double>(0.0), &ADMSbsim6::Model::CGDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Drain overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBO", static_cast<double>(0.0), &ADMSbsim6::Model::CGBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Body overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGSL", static_cast<double>(0.0), &ADMSbsim6::Model::CGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGSL", static_cast<double>(0.0), &ADMSbsim6::Model::LCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCGSL", static_cast<double>(0.0), &ADMSbsim6::Model::WCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGSL", static_cast<double>(0.0), &ADMSbsim6::Model::PCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGDL", static_cast<double>(0.0), &ADMSbsim6::Model::CGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCGDL", static_cast<double>(0.0), &ADMSbsim6::Model::LCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCGDL", static_cast<double>(0.0), &ADMSbsim6::Model::WCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCGDL", static_cast<double>(0.0), &ADMSbsim6::Model::PCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CKAPPAS", static_cast<double>(0.6), &ADMSbsim6::Model::CKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCKAPPAS", static_cast<double>(0.0), &ADMSbsim6::Model::LCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCKAPPAS", static_cast<double>(0.0), &ADMSbsim6::Model::WCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCKAPPAS", static_cast<double>(0.0), &ADMSbsim6::Model::PCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CKAPPAD", static_cast<double>(0.6), &ADMSbsim6::Model::CKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LCKAPPAD", static_cast<double>(0.0), &ADMSbsim6::Model::LCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WCKAPPAD", static_cast<double>(0.0), &ADMSbsim6::Model::WCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PCKAPPAD", static_cast<double>(0.0), &ADMSbsim6::Model::PCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DMCG", static_cast<double>(0.0), &ADMSbsim6::Model::DMCG)
    .setUnit(U_METER)
    .setDescription("Distance of Mid-Contact to Gate edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DMCI", 0.0, &ADMSbsim6::Model::DMCI)
    .setUnit(U_METER)
    .setDescription("Distance of Mid-Contact to Isolation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DMDG", static_cast<double>(0.0), &ADMSbsim6::Model::DMDG)
    .setUnit(U_METER)
    .setDescription("Distance of Mid-Diffusion to Gate edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DMCGT", static_cast<double>(0.0), &ADMSbsim6::Model::DMCGT)
    .setUnit(U_METER)
    .setDescription("Dist of Mid-Contact to Gate edge in Test")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XGL", static_cast<double>(0.0), &ADMSbsim6::Model::XGL)
    .setUnit(U_METER)
    .setDescription("Variation in Ldrawn")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSHG", static_cast<double>(0.1), &ADMSbsim6::Model::RSHG)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS", static_cast<double>(5.0e-4), &ADMSbsim6::Model::CJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit area source-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJD", 0.0, &ADMSbsim6::Model::CJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit area drain-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWS", static_cast<double>(5.0e-10), &ADMSbsim6::Model::CJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length source-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWD", 0.0, &ADMSbsim6::Model::CJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length drain-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWGS", static_cast<double>(0.0), &ADMSbsim6::Model::CJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length source-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJSWGD", 0.0, &ADMSbsim6::Model::CJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length drain-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBS", static_cast<double>(1.0), &ADMSbsim6::Model::PBS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBD", 0.0, &ADMSbsim6::Model::PBD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWS", static_cast<double>(1.0), &ADMSbsim6::Model::PBSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Source-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWD", 0.0, &ADMSbsim6::Model::PBSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Drain-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWGS", 0.0, &ADMSbsim6::Model::PBSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Source-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBSWGD", 0.0, &ADMSbsim6::Model::PBSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Drain-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJS", static_cast<double>(0.5), &ADMSbsim6::Model::MJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJD", 0.0, &ADMSbsim6::Model::MJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWS", static_cast<double>(0.33), &ADMSbsim6::Model::MJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWD", 0.0, &ADMSbsim6::Model::MJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWGS", 0.0, &ADMSbsim6::Model::MJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MJSWGD", 0.0, &ADMSbsim6::Model::MJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSS", static_cast<double>(1.0e-4), &ADMSbsim6::Model::JSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSD", 0.0, &ADMSbsim6::Model::JSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWS", static_cast<double>(0.0), &ADMSbsim6::Model::JSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWD", 0.0, &ADMSbsim6::Model::JSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWGS", static_cast<double>(0.0), &ADMSbsim6::Model::JSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JSWGD", 0.0, &ADMSbsim6::Model::JSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJS", static_cast<double>(1.0), &ADMSbsim6::Model::NJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJD", 0.0, &ADMSbsim6::Model::NJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHSFWD", static_cast<double>(0.1), &ADMSbsim6::Model::IJTHSFWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Forward source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHDFWD", 0.0, &ADMSbsim6::Model::IJTHDFWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Forward drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHSREV", static_cast<double>(0.1), &ADMSbsim6::Model::IJTHSREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJTHDREV", 0.0, &ADMSbsim6::Model::IJTHDREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVS", static_cast<double>(10.0), &ADMSbsim6::Model::BVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BVD", 0.0, &ADMSbsim6::Model::BVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJBVS", static_cast<double>(1.0), &ADMSbsim6::Model::XJBVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for source diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJBVD", 0.0, &ADMSbsim6::Model::XJBVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for drain diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSS", static_cast<double>(0.0), &ADMSbsim6::Model::JTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSD", 0.0, &ADMSbsim6::Model::JTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWS", static_cast<double>(0.0), &ADMSbsim6::Model::JTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWD", 0.0, &ADMSbsim6::Model::JTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWGS", static_cast<double>(0.0), &ADMSbsim6::Model::JTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTSSWGD", 0.0, &ADMSbsim6::Model::JTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JTWEFF", static_cast<double>(0.0), &ADMSbsim6::Model::JTWEFF)
    .setUnit(U_UNKNOWN)
    .setDescription("Trap assisted tunneling current width dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTS", static_cast<double>(20.0), &ADMSbsim6::Model::NJTS)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSD", 0.0, &ADMSbsim6::Model::NJTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSW", static_cast<double>(20.0), &ADMSbsim6::Model::NJTSSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSWD", 0.0, &ADMSbsim6::Model::NJTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSWG", static_cast<double>(20.0), &ADMSbsim6::Model::NJTSSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NJTSSWGD", 0.0, &ADMSbsim6::Model::NJTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSS", static_cast<double>(10.0), &ADMSbsim6::Model::VTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSD", 0.0, &ADMSbsim6::Model::VTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWS", static_cast<double>(10.0), &ADMSbsim6::Model::VTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWD", 0.0, &ADMSbsim6::Model::VTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWGS", static_cast<double>(10.0), &ADMSbsim6::Model::VTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTSSWGD", 0.0, &ADMSbsim6::Model::VTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCRG1", static_cast<double>(12.0), &ADMSbsim6::Model::XRCRG1)
    .setUnit(U_UNKNOWN)
    .setDescription("1st fitting parm the bias-dependent Rg //make it binnable")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XRCRG2", static_cast<double>(1.0), &ADMSbsim6::Model::XRCRG2)
    .setUnit(U_UNKNOWN)
    .setDescription("2nd fitting parm the bias-dependent Rg  //make it binnable")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GBMIN", static_cast<double>(1.0e-12), &ADMSbsim6::Model::GBMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimum body conductance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPS0", static_cast<double>(50.0), &ADMSbsim6::Model::RBPS0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBPS 50 Ohms")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPSL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPSW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPSNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPSNF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPD0", static_cast<double>(50.0), &ADMSbsim6::Model::RBPD0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPDL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBPD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPDW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBPD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPDNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPDNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBPD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBX0", static_cast<double>(100.0), &ADMSbsim6::Model::RBPBX0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBXL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBPBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBXW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBXW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBPBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBXNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBXNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBPBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBY0", static_cast<double>(100.0), &ADMSbsim6::Model::RBPBY0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBYL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBYL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBYW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBYW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBPBYNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBYNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSBX0", static_cast<double>(100.0), &ADMSbsim6::Model::RBSBX0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBSBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSBY0", static_cast<double>(100.0), &ADMSbsim6::Model::RBSBY0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBSBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBDBX0", static_cast<double>(100.0), &ADMSbsim6::Model::RBDBX0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBDBY0", static_cast<double>(100.0), &ADMSbsim6::Model::RBDBY0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSDBXL", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBSBX and RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSDBXW", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBXW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBSBX and RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSDBXNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBXNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBSBX and RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSDBYL", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBYL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBSBY and RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSDBYW", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBYW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBSBY and RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBSDBYNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBYNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBSBY and RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EF", static_cast<double>(1.0), &ADMSbsim6::Model::EF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker Noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EM", static_cast<double>(4.1e7), &ADMSbsim6::Model::EM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOIA", static_cast<double>(6.250e+40), &ADMSbsim6::Model::NOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOIB", static_cast<double>(3.125e+25), &ADMSbsim6::Model::NOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOIC", static_cast<double>(8.750e+8), &ADMSbsim6::Model::NOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSbsim6::Model::LINTNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NTNOI", static_cast<double>(1.0), &ADMSbsim6::Model::NTNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RNOIA", static_cast<double>(0.577), &ADMSbsim6::Model::RNOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RNOIB", static_cast<double>(0.5164), &ADMSbsim6::Model::RNOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RNOIC", static_cast<double>(0.395), &ADMSbsim6::Model::RNOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOIA", static_cast<double>(0.0), &ADMSbsim6::Model::TNOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOIB", static_cast<double>(0.0), &ADMSbsim6::Model::TNOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOIC", static_cast<double>(0.0), &ADMSbsim6::Model::TNOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("Correlation coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BINUNIT", static_cast<int>(1), &ADMSbsim6::Model::BINUNIT)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit of L and W for Binning, 1 : micro-meter, 0 : default");
  p.addPar("DLBIN", static_cast<double>(0.0), &ADMSbsim6::Model::DLBIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DWBIN", static_cast<double>(0.0), &ADMSbsim6::Model::DWBIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSbsim6::Model::TNOM)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature at which the model was extracted")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSbsim6::Model::DTEMP)
    .setUnit(U_UNKNOWN)
    .setDescription("Offset of Device Temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBGASUB", static_cast<double>(4.73e-4), &ADMSbsim6::Model::TBGASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap Temperature Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBGBSUB", static_cast<double>(636.0), &ADMSbsim6::Model::TBGBSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap Temperature Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::TNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature exponent for NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UTE", static_cast<double>((-1.5)), &ADMSbsim6::Model::UTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUTE", static_cast<double>(0.0), &ADMSbsim6::Model::LUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUTE", static_cast<double>(0.0), &ADMSbsim6::Model::WUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUTE", static_cast<double>(0.0), &ADMSbsim6::Model::PUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UTEL", static_cast<double>(0.0), &ADMSbsim6::Model::UTEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for UTE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UA1", static_cast<double>(1.0e-3), &ADMSbsim6::Model::UA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUA1", static_cast<double>(0.0), &ADMSbsim6::Model::LUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUA1", static_cast<double>(0.0), &ADMSbsim6::Model::WUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUA1", static_cast<double>(0.0), &ADMSbsim6::Model::PUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UA1L", static_cast<double>(0.0), &ADMSbsim6::Model::UA1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for UA1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UC1", static_cast<double>(0.056e-9), &ADMSbsim6::Model::UC1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUC1", static_cast<double>(0.0), &ADMSbsim6::Model::LUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUC1", static_cast<double>(0.0), &ADMSbsim6::Model::WUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUC1", static_cast<double>(0.0), &ADMSbsim6::Model::PUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UD1", static_cast<double>(0.0), &ADMSbsim6::Model::UD1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUD1", static_cast<double>(0.0), &ADMSbsim6::Model::LUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUD1", static_cast<double>(0.0), &ADMSbsim6::Model::WUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUD1", static_cast<double>(0.0), &ADMSbsim6::Model::PUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UD1L", static_cast<double>(0.0), &ADMSbsim6::Model::UD1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for UD1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UCSTE", static_cast<double>((-4.775e-3)), &ADMSbsim6::Model::UCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LUCSTE", static_cast<double>(0.0), &ADMSbsim6::Model::LUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WUCSTE", static_cast<double>(0.0), &ADMSbsim6::Model::WUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PUCSTE", static_cast<double>(0.0), &ADMSbsim6::Model::PUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TETA0", static_cast<double>(0.0), &ADMSbsim6::Model::TETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PRT", static_cast<double>(0.0), &ADMSbsim6::Model::PRT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPRT", static_cast<double>(0.0), &ADMSbsim6::Model::LPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPRT", static_cast<double>(0.0), &ADMSbsim6::Model::WPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPRT", static_cast<double>(0.0), &ADMSbsim6::Model::PPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AT", static_cast<double>((-1.56e-3)), &ADMSbsim6::Model::AT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for saturation velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAT", static_cast<double>(0.0), &ADMSbsim6::Model::LAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAT", static_cast<double>(0.0), &ADMSbsim6::Model::WAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PAT", static_cast<double>(0.0), &ADMSbsim6::Model::PAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ATL", static_cast<double>(0.0), &ADMSbsim6::Model::ATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for AT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::TDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for DELTA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::PTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::LPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WPTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::WPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PPTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::PPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTWGTL", static_cast<double>(0.0), &ADMSbsim6::Model::PTWGTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for PTWGT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1", static_cast<double>((-0.11)), &ADMSbsim6::Model::KT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1EXP", static_cast<double>(1.0), &ADMSbsim6::Model::KT1EXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1L", static_cast<double>(0.0), &ADMSbsim6::Model::KT1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKT1", static_cast<double>(0.0), &ADMSbsim6::Model::LKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKT1", static_cast<double>(0.0), &ADMSbsim6::Model::WKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKT1", static_cast<double>(0.0), &ADMSbsim6::Model::PKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT2", static_cast<double>(0.022), &ADMSbsim6::Model::KT2)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKT2", static_cast<double>(0.0), &ADMSbsim6::Model::LKT2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKT2", static_cast<double>(0.0), &ADMSbsim6::Model::WKT2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKT2", static_cast<double>(0.0), &ADMSbsim6::Model::PKT2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IIT", static_cast<double>(0.0), &ADMSbsim6::Model::IIT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for BETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LIIT", static_cast<double>(0.0), &ADMSbsim6::Model::LIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WIIT", static_cast<double>(0.0), &ADMSbsim6::Model::WIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIIT", static_cast<double>(0.0), &ADMSbsim6::Model::PIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGT", static_cast<double>(2.5), &ADMSbsim6::Model::IGT)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate Current Temperature Dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LIGT", static_cast<double>(0.0), &ADMSbsim6::Model::LIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WIGT", static_cast<double>(0.0), &ADMSbsim6::Model::WIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PIGT", static_cast<double>(0.0), &ADMSbsim6::Model::PIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::TGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for GIDL/GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LTGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WTGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PTGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCJ", static_cast<double>(0.0), &ADMSbsim6::Model::TCJ)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJS/CJD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCJSW", static_cast<double>(0.0), &ADMSbsim6::Model::TCJSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJSWS/CJSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TCJSWG", static_cast<double>(0.0), &ADMSbsim6::Model::TCJSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJSWGS/CJSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TPB", static_cast<double>(0.0), &ADMSbsim6::Model::TPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBS/PBD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TPBSW", static_cast<double>(0.0), &ADMSbsim6::Model::TPBSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBSWS/PBSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TPBSWG", static_cast<double>(0.0), &ADMSbsim6::Model::TPBSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBSWGS/PBSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTIS", static_cast<double>(3.0), &ADMSbsim6::Model::XTIS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTID", 0.0, &ADMSbsim6::Model::XTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSS", static_cast<double>(0.02), &ADMSbsim6::Model::XTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSD", 0.0, &ADMSbsim6::Model::XTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWS", static_cast<double>(0.02), &ADMSbsim6::Model::XTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWD", 0.0, &ADMSbsim6::Model::XTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWGS", static_cast<double>(0.02), &ADMSbsim6::Model::XTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWGS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XTSSWGD", 0.0, &ADMSbsim6::Model::XTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWGD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTS", static_cast<double>(0.0), &ADMSbsim6::Model::TNJTS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSD", 0.0, &ADMSbsim6::Model::TNJTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSW", static_cast<double>(0.0), &ADMSbsim6::Model::TNJTSSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSWD", 0.0, &ADMSbsim6::Model::TNJTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSWG", static_cast<double>(0.0), &ADMSbsim6::Model::TNJTSSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNJTSSWGD", 0.0, &ADMSbsim6::Model::TNJTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH0", static_cast<double>(0.0), &ADMSbsim6::Model::RTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH0", static_cast<double>(1.0E-05), &ADMSbsim6::Model::CTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WTH0", static_cast<double>(0.0), &ADMSbsim6::Model::WTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient for Rth and Cth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SAREF", static_cast<double>(1.0e-6), &ADMSbsim6::Model::SAREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference distance between OD edge from Poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SBREF", static_cast<double>(1.0e-6), &ADMSbsim6::Model::SBREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference distance between OD edge from Poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLOD", static_cast<double>(0.0), &ADMSbsim6::Model::WLOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Parameter for Stress Effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KU0", static_cast<double>(0.0), &ADMSbsim6::Model::KU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility degradation/enhancement Parameter for Stress Effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::KVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation Velocity degradation/enhancement Parameter for Stress Effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TKU0", static_cast<double>(0.0), &ADMSbsim6::Model::TKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature Coefficient for KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKU0", static_cast<double>(0.0), &ADMSbsim6::Model::LKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Dependence of KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKU0", static_cast<double>(0.0), &ADMSbsim6::Model::WKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Dependence of KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKU0", static_cast<double>(0.0), &ADMSbsim6::Model::PKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross Term Dependence of KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLODKU0", static_cast<double>(0.0), &ADMSbsim6::Model::LLODKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Parameter for u0 stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLODKU0", static_cast<double>(0.0), &ADMSbsim6::Model::WLODKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Parameter for u0 stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::KVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Threshold Shift parameter for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::LKVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KVTH0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::WKVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KVTH0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::PKVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KVTH0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLODVTH", static_cast<double>(0.0), &ADMSbsim6::Model::LLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Parameter for Vth stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLODVTH", static_cast<double>(0.0), &ADMSbsim6::Model::WLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Parameter for Vth stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STK2", static_cast<double>(0.0), &ADMSbsim6::Model::STK2)
    .setUnit(U_UNKNOWN)
    .setDescription("K2 shift factor related to Vth change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LODK2", static_cast<double>(0.0), &ADMSbsim6::Model::LODK2)
    .setUnit(U_UNKNOWN)
    .setDescription("K2 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STETA0", static_cast<double>(0.0), &ADMSbsim6::Model::STETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("eta0 shift related to Vth0 change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LODETA0", static_cast<double>(0.0), &ADMSbsim6::Model::LODETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("eta0 modification foator for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEB", static_cast<double>(0.0), &ADMSbsim6::Model::WEB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEC", static_cast<double>(0.0), &ADMSbsim6::Model::WEC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::KVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::LKVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::WKVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::PKVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("K2WE", static_cast<double>(0.0), &ADMSbsim6::Model::K2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LK2WE", static_cast<double>(0.0), &ADMSbsim6::Model::LK2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WK2WE", static_cast<double>(0.0), &ADMSbsim6::Model::WK2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PK2WE", static_cast<double>(0.0), &ADMSbsim6::Model::PK2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::KU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::LKU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::WKU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::PKU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCREF", static_cast<double>(1.0e-6), &ADMSbsim6::Model::SCREF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EDGEFET", static_cast<int>(1), &ADMSbsim6::Model::EDGEFET)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Edge FET Model Off, 1: Edge FET Model ON");
  p.addPar("WEDGE", static_cast<double>(10.0e-9), &ADMSbsim6::Model::WEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DGAMMAEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::DGAMMAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DGAMMAEDGEL", static_cast<double>(0.0), &ADMSbsim6::Model::DGAMMAEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DGAMMAEDGELEXP", static_cast<double>(1.0), &ADMSbsim6::Model::DGAMMAEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVTEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::DVTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth shift for Edge FET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFACTOREDGE", 0.0, &ADMSbsim6::Model::NFACTOREDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CITEDGE", 0.0, &ADMSbsim6::Model::CITEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCDEDGE", 0.0, &ADMSbsim6::Model::CDSCDEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CDSCBEDGE", 0.0, &ADMSbsim6::Model::CDSCBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETA0EDGE", 0.0, &ADMSbsim6::Model::ETA0EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ETABEDGE", 0.0, &ADMSbsim6::Model::ETABEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1EDGE", 0.0, &ADMSbsim6::Model::KT1EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1LEDGE", 0.0, &ADMSbsim6::Model::KT1LEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT2EDGE", 0.0, &ADMSbsim6::Model::KT2EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT1EXPEDGE", 0.0, &ADMSbsim6::Model::KT1EXPEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNFACTOREDGE", 0.0, &ADMSbsim6::Model::TNFACTOREDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TETA0EDGE", 0.0, &ADMSbsim6::Model::TETA0EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVT0EDGE", static_cast<double>(2.2), &ADMSbsim6::Model::DVT0EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVT1EDGE", static_cast<double>(0.53), &ADMSbsim6::Model::DVT1EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVT2EDGE", static_cast<double>(0.0), &ADMSbsim6::Model::DVT2EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Body-bias coefficient for SCE effect for Edge FET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("L")))
  {
    L = model_.L;
  }
  if (!(given("VFBSDOFF")))
  {
    VFBSDOFF = model_.VFBSDOFF;
  }
  if (!(given("XGW")))
  {
    XGW = model_.XGW;
  }
  if (!(given("NGCON")))
  {
    NGCON = model_.NGCON;
  }
  if (!(given("RGATEMOD")))
  {
    RGATEMOD = model_.RGATEMOD;
  }
  if (!(given("RBODYMOD")))
  {
    RBODYMOD = model_.RBODYMOD;
  }
  if (!(given("GEOMOD")))
  {
    GEOMOD = model_.GEOMOD;
  }
  if (!(given("RGEOMOD")))
  {
    RGEOMOD = model_.RGEOMOD;
  }
  if (!(given("RBPB")))
  {
    RBPB = model_.RBPB;
  }
  if (!(given("RBPD")))
  {
    RBPD = model_.RBPD;
  }
  if (!(given("RBPS")))
  {
    RBPS = model_.RBPS;
  }
  if (!(given("RBDB")))
  {
    RBDB = model_.RBDB;
  }
  if (!(given("RBSB")))
  {
    RBSB = model_.RBSB;
  }
  if (!(given("SA")))
  {
    SA = model_.SA;
  }
  if (!(given("SB")))
  {
    SB = model_.SB;
  }
  if (!(given("SD")))
  {
    SD = model_.SD;
  }
  if (!(given("SCA")))
  {
    SCA = model_.SCA;
  }
  if (!(given("SCB")))
  {
    SCB = model_.SCB;
  }
  if (!(given("SCC")))
  {
    SCC = model_.SCC;
  }
  if (!(given("SC")))
  {
    SC = model_.SC;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter L : ] 0,  (+inf) [
  if ( (!((L >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter L value " << L << " out of range ] 0,  (+inf) [";
  }

  //    Parameter W : ] 0,  (+inf) [
  if ( (!((W >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter W value " << W << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NF : [ 1,  (+inf) [
  if ( (!((NF >=1))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NF value " << NF << " out of range [ 1,  (+inf) [";
  }

  //    Parameter NRS : [ 0,  (+inf) [
  if ( (!((NRS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NRS value " << NRS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NRD : [ 0,  (+inf) [
  if ( (!((NRD >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NRD value " << NRD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter MINZ : [ 0, 1 ]
  if ( (!((MINZ >=0 && MINZ <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter MINZ value " << MINZ << " out of range [ 0, 1 ]";
  }

  //    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

  //    Parameter RGATEMOD : [ 0, 3 ]
  if ( (!((RGATEMOD >=0 && RGATEMOD <=3 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RGATEMOD value " << RGATEMOD << " out of range [ 0, 3 ]";
  }

  //    Parameter RBODYMOD : [ 0, 2 ]
  if ( (!((RBODYMOD >=0 && RBODYMOD <=2 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBODYMOD value " << RBODYMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter GEOMOD : [ 0, 10 ]
  if ( (!((GEOMOD >=0 && GEOMOD <=10 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter GEOMOD value " << GEOMOD << " out of range [ 0, 10 ]";
  }

  //    Parameter RGEOMOD : [ 0, 8 ]
  if ( (!((RGEOMOD >=0 && RGEOMOD <=8 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RGEOMOD value " << RGEOMOD << " out of range [ 0, 8 ]";
  }

  //    Parameter RBPB : [ 0,  (+inf) [
  if ( (!((RBPB >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPB value " << RBPB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPD : [ 0,  (+inf) [
  if ( (!((RBPD >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPD value " << RBPD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPS : [ 0,  (+inf) [
  if ( (!((RBPS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPS value " << RBPS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBDB : [ 0,  (+inf) [
  if ( (!((RBDB >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBDB value " << RBDB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSB : [ 0,  (+inf) [
  if ( (!((RBSB >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSB value " << RBSB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCA :  ] (-inf)  (+inf) [

  //    Parameter SCB :  ] (-inf)  (+inf) [

  //    Parameter SCC :  ] (-inf)  (+inf) [

  //    Parameter SC :  ] (-inf)  (+inf) [

  //    Parameter AS : [ 0,  (+inf) [
  if ( (!((AS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter AS value " << AS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter AD : [ 0,  (+inf) [
  if ( (!((AD >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter AD value " << AD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PS : [ 0,  (+inf) [
  if ( (!((PS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PS value " << PS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PD : [ 0,  (+inf) [
  if ( (!((PD >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PD value " << PD << " out of range [ 0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double ToxRatioEdge;
  double Rbpby;
  double Rbpbx;
  double Rbdby;
  double Rbdbx;
  double Rbsby;
  double Rbsbx;
  double Rbsb;
  double Rbdb;
  double Rbps;
  double Rbpd;
  double Rbpb;
  double Bodymode;
  double Lnnf;
  double Lnw;
  double Lnl;
  double Rtot;
  double Rint;
  double Rend;
  double NTOX_i;
  double POXEDGE_i;
  double BIN_WL;
  double BIN_W;
  double BIN_L;
  double Weff1;
  double Leff1;
  double dWB;
  double LW_WLN_WWN1;
  double dLB;
  double LW_LLN_LWN1;
  double Inv_WL;
  double Inv_Wwide;
  double Inv_Llong;
  double Inv_Wact;
  double Inv_Lact;
  double Inv_W;
  double Inv_L;
  double dWJ;
  double dWCV;
  double dLCV;
  double dWIV;
  double LW_WLN_WWN;
  double W_WWN;
  double L_WLN;
  double dLIV;
  double LW_LLN_LWN;
  double W_LWN;
  double L_LLN;
  double W_by_NF;
  double W_mult;
  double W_WWN1;
  double W_LWN1;
  double L_WLN1;
  double L_LLN1;
  //Begin block initial_instance
  {
    CDSCDR_i = 0;
    ETA0R_i = 0;
    ETA0R_t = 0;
    L_LLN1 = 0;
    L_WLN1 = 0;
    PCLMR_i = 0;
    PDIBLCR_i = 0;
    PSATR_i = 0;
    PTWGR_i = 0;
    PTWGR_t = 0;
    U0R_i = 0;
    U0R_t = 0;
    UAR_i = 0;
    UAR_t = 0;
    UCR_i = 0;
    UCR_t = 0;
    UCSR_i = 0;
    UCSR_t = 0;
    UDR_i = 0;
    UDR_t = 0;
    UD_a = 0;
    VSATR_i = 0;
    VSATR_t = 0;
    W_LWN1 = 0;
    W_WWN1 = 0;
    if (((model_.TYPE)==1))
    {
      devsign = 1;
    }
    else
    {
      devsign = (-1);
    }
    epssi = ((model_.EPSRSUB)*8.85418e-12);
    epsox = ((model_.EPSROX)*8.85418e-12);
    Cox = (((model_.EPSROX)*8.85418e-12)/(model_.TOXE));
    epsratio = ((model_.EPSRSUB)/(model_.EPSROX));
    if ((!(model_.given("TOXP"))))
    {
      BSIM6TOXP = ((((model_.TOXE)*(model_.EPSROX))/3.9)-(model_.DTOX));
    }
    else
    {
      BSIM6TOXP = (model_.TOXP);
    }
    L_mult = (L*(model_.LMLT));
    W_mult = (W*(model_.WMLT));
    Lnew = (L_mult+(model_.XL));
    if ((Lnew<=0))
    {
      std::cerr  << "Fatal: Ldrawn*LMLT+XL = %e for  %M is non-positive" << Lnew <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    W_by_NF = (W_mult/NF);
    Wnew = (W_by_NF+(model_.XW));
    if ((Wnew<=0))
    {
      std::cerr  << "Fatal: W/NF*WMLT+XW = %e for  %M is non-positive" << Wnew <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    L_LLN = pow(Lnew,(-(model_.LLN)));
    W_LWN = pow(Wnew,(-(model_.LWN)));
    LW_LLN_LWN = (L_LLN*W_LWN);
    dLIV = ((((model_.LINT)+((model_.LL)*L_LLN))+((model_.LW)*W_LWN))+((model_.LWL)*LW_LLN_LWN));
    L_WLN = pow(Lnew,(-(model_.WLN)));
    W_WWN = pow(Wnew,(-(model_.WWN)));
    LW_WLN_WWN = (L_WLN*W_WWN);
    dWIV = ((((model_.WINT)+((model_.WL)*L_WLN))+((model_.WW)*W_WWN))+((model_.WWL)*LW_WLN_WWN));
    Leff = (Lnew-(2.0*dLIV));
    if ((Leff<=0))
    {
      std::cerr  << "Fatal: Effective channel length = %e for  %M is non-positive" << Leff <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Leff<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel length = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << Leff <<  std::endl; 
      }
    }
    Weff = (Wnew-(2.0*dWIV));
    if ((Weff<=0))
    {
      std::cerr  << "Fatal: Effective channel Width = %e for  %M is non-positive" << Weff <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Weff<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel width = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << Leff <<  std::endl; 
      }
    }
    dLCV = ((((model_.DLC)+((model_.LLC)*L_LLN))+((model_.LWC)*W_LWN))+((model_.LWLC)*LW_LLN_LWN));
    dWCV = ((((model_.DWC)+((model_.WLC)*L_WLN))+((model_.WWC)*W_WWN))+((model_.WWLC)*LW_WLN_WWN));
    Lact = (Lnew-(2.0*dLCV));
    if ((Lact<=0))
    {
      std::cerr  << "Fatal: Effective channel length for CV = %e for  %M is non-positive" << Lact <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Lact<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel length for CV = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << Leff <<  std::endl; 
      }
    }
    Wact = (Wnew-(2.0*dWCV));
    if ((Wact<=0))
    {
      std::cerr  << "Fatal: Effective channel width for CV = %e for  %M is non-positive" << Wact <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    else
    {
      if ((Wact<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel width for CV = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << Leff <<  std::endl; 
      }
    }
    dWJ = ((((model_.DWJ)+((model_.WLC)/pow(Lnew,(model_.WLN))))+((model_.WWC)/pow(Wnew,(model_.WWN))))+(((model_.WWLC)/pow(Lnew,(model_.WLN)))/pow(Wnew,(model_.WWN))));
    Weffcj = (Wnew-(2.0*dWJ));
    if ((Weffcj<=0))
    {
      std::cerr  << "Fatal: Effective channel width for S/D junctions = %e for  %M is non-positive" << Weffcj <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    Inv_L = (1.0e-6/Leff);
    Inv_W = (1.0e-6/Weff);
    Inv_Lact = (1.0e-6/Lact);
    Inv_Wact = (1.0e-6/Wact);
    Inv_Llong = (1.0e-6/(model_.LLONG));
    Inv_Wwide = (1.0e-6/(model_.WWIDE));
    Inv_WL = (Inv_L*Inv_W);
    L_LLN1 = L_LLN;
    L_WLN1 = L_WLN;
    if (((model_.DLBIN)!=0))
    {
      if (((model_.DLBIN)<=(-Lnew)))
      {
        std::cerr  << "Fatal: DLBIN for  %M = %e is <= -Ldrawn*LMLT" << (model_.DLBIN) <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
      else
      {
        L_LLN1 = pow((Lnew+(model_.DLBIN)),(-(model_.LLN)));
        L_WLN1 = pow((Lnew+(model_.DLBIN)),(-(model_.WLN)));
      }
    }
    W_LWN1 = W_LWN;
    W_WWN1 = W_WWN;
    if (((model_.DWBIN)!=0))
    {
      if (((model_.DWBIN)<=(-Wnew)))
      {
        std::cerr  << "Fatal: DWBIN for  %M = %e is <= -Wdrawn*WMLT" << (model_.DWBIN) <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
      else
      {
        W_LWN1 = pow((Wnew+(model_.DWBIN)),(-(model_.LWN)));
        W_WWN1 = pow((Wnew+(model_.DWBIN)),(-(model_.WWN)));
      }
    }
    LW_LLN_LWN1 = (L_LLN1*W_LWN1);
    dLB = ((((model_.LINT)+((model_.LL)*L_LLN1))+((model_.LW)*W_LWN1))+((model_.LWL)*LW_LLN_LWN1));
    LW_WLN_WWN1 = (L_WLN1*W_WWN1);
    dWB = ((((model_.WINT)+((model_.WL)*L_WLN1))+((model_.WW)*W_WWN1))+((model_.WWL)*LW_WLN_WWN1));
    Leff1 = ((Lnew-(2.0*dLB))+(model_.DLBIN));
    if ((Leff1<=0))
    {
      std::cerr  << "Fatal: Effective channel length for binning = %e for  %M is non-positive" << Leff1 <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    Weff1 = ((Wnew-(2.0*dWB))+(model_.DWBIN));
    if ((Weff1<=0))
    {
      std::cerr  << "Fatal: Effective channel width for binning = %e for  %M is non-positive" << Weff1 <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if (((model_.BINUNIT)==1))
    {
      BIN_L = (1.0e-6/Leff1);
      BIN_W = (1.0e-6/Weff1);
    }
    else
    {
      BIN_L = (1.0/Leff1);
      BIN_W = (1.0/Weff1);
    }
    BIN_WL = (BIN_L*BIN_W);
    VFB_i = ((((model_.VFB)+(BIN_L*(model_.LVFB)))+(BIN_W*(model_.WVFB)))+(BIN_WL*(model_.PVFB)));
    VFBCV_i = ((((model_.VFBCV)+(BIN_L*(model_.LVFBCV)))+(BIN_W*(model_.WVFBCV)))+(BIN_WL*(model_.PVFBCV)));
    NSD_i = ((((model_.NSD)+(BIN_L*(model_.LNSD)))+(BIN_W*(model_.WNSD)))+(BIN_WL*(model_.PNSD)));
    NDEP_i = ((((model_.NDEP)+(BIN_L*(model_.LNDEP)))+(BIN_W*(model_.WNDEP)))+(BIN_WL*(model_.PNDEP)));
    NDEPCV_i = ((((model_.NDEPCV)+(BIN_L*(model_.LNDEPCV)))+(BIN_W*(model_.WNDEPCV)))+(BIN_WL*(model_.PNDEPCV)));
    NGATE_i = ((((model_.NGATE)+(BIN_L*(model_.LNGATE)))+(BIN_W*(model_.WNGATE)))+(BIN_WL*(model_.PNGATE)));
    CIT_i = ((((model_.CIT)+(BIN_L*(model_.LCIT)))+(BIN_W*(model_.WCIT)))+(BIN_WL*(model_.PCIT)));
    NFACTOR_i = ((((model_.NFACTOR)+(BIN_L*(model_.LNFACTOR)))+(BIN_W*(model_.WNFACTOR)))+(BIN_WL*(model_.PNFACTOR)));
    CDSCD_i = ((((model_.CDSCD)+(BIN_L*(model_.LCDSCD)))+(BIN_W*(model_.WCDSCD)))+(BIN_WL*(model_.PCDSCD)));
    CDSCB_i = ((((model_.CDSCB)+(BIN_L*(model_.LCDSCB)))+(BIN_W*(model_.WCDSCB)))+(BIN_WL*(model_.PCDSCB)));
    DVTP0_i = ((((model_.DVTP0)+(BIN_L*(model_.LDVTP0)))+(BIN_W*(model_.WDVTP0)))+(BIN_WL*(model_.PDVTP0)));
    DVTP1_i = ((((model_.DVTP1)+(BIN_L*(model_.LDVTP1)))+(BIN_W*(model_.WDVTP1)))+(BIN_WL*(model_.PDVTP1)));
    DVTP2_i = ((((model_.DVTP2)+(BIN_L*(model_.LDVTP2)))+(BIN_W*(model_.WDVTP2)))+(BIN_WL*(model_.PDVTP2)));
    DVTP3_i = ((((model_.DVTP3)+(BIN_L*(model_.LDVTP3)))+(BIN_W*(model_.WDVTP3)))+(BIN_WL*(model_.PDVTP3)));
    DVTP4_i = ((((model_.DVTP4)+(BIN_L*(model_.LDVTP4)))+(BIN_W*(model_.WDVTP4)))+(BIN_WL*(model_.PDVTP4)));
    DVTP5_i = ((((model_.DVTP5)+(BIN_L*(model_.LDVTP5)))+(BIN_W*(model_.WDVTP5)))+(BIN_WL*(model_.PDVTP5)));
    K2_i = ((((model_.K2)+(BIN_L*(model_.LK2)))+(BIN_W*(model_.WK2)))+(BIN_WL*(model_.PK2)));
    K1_i = ((((model_.K1)+(BIN_L*(model_.LK1)))+(BIN_W*(model_.WK1)))+(BIN_WL*(model_.PK1)));
    XJ_i = ((((model_.XJ)+(BIN_L*(model_.LXJ)))+(BIN_W*(model_.WXJ)))+(BIN_WL*(model_.PXJ)));
    PHIN_i = ((((model_.PHIN)+(BIN_L*(model_.LPHIN)))+(BIN_W*(model_.WPHIN)))+(BIN_WL*(model_.PPHIN)));
    ETA0_i = ((((model_.ETA0)+(BIN_L*(model_.LETA0)))+(BIN_W*(model_.WETA0)))+(BIN_WL*(model_.PETA0)));
    ETAB_i = ((((model_.ETAB)+(BIN_L*(model_.LETAB)))+(BIN_W*(model_.WETAB)))+(BIN_WL*(model_.PETAB)));
    DELTA_i = ((((model_.DELTA)+(BIN_L*(model_.LDELTA)))+(BIN_W*(model_.WDELTA)))+(BIN_WL*(model_.PDELTA)));
    U0_i = ((((model_.U0)+(BIN_L*(model_.LU0)))+(BIN_W*(model_.WU0)))+(BIN_WL*(model_.PU0)));
    UA_i = ((((model_.UA)+(BIN_L*(model_.LUA)))+(BIN_W*(model_.WUA)))+(BIN_WL*(model_.PUA)));
    UD_i = ((((model_.UD)+(BIN_L*(model_.LUD)))+(BIN_W*(model_.WUD)))+(BIN_WL*(model_.PUD)));
    EU_i = ((((model_.EU)+(BIN_L*(model_.LEU)))+(BIN_W*(model_.WEU)))+(BIN_WL*(model_.PEU)));
    UCS_i = ((((model_.UCS)+(BIN_L*(model_.LUCS)))+(BIN_W*(model_.WUCS)))+(BIN_WL*(model_.PUCS)));
    UC_i = ((((model_.UC)+(BIN_L*(model_.LUC)))+(BIN_W*(model_.WUC)))+(BIN_WL*(model_.PUC)));
    PCLM_i = ((((model_.PCLM)+(BIN_L*(model_.LPCLM)))+(BIN_W*(model_.WPCLM)))+(BIN_WL*(model_.PPCLM)));
    PCLMCV_i = ((((model_.PCLMCV)+(BIN_L*(model_.LPCLMCV)))+(BIN_W*(model_.WPCLMCV)))+(BIN_WL*(model_.PPCLMCV)));
    RSW_i = ((((model_.RSW)+(BIN_L*(model_.LRSW)))+(BIN_W*(model_.WRSW)))+(BIN_WL*(model_.PRSW)));
    RDW_i = ((((model_.RDW)+(BIN_L*(model_.LRDW)))+(BIN_W*(model_.WRDW)))+(BIN_WL*(model_.PRDW)));
    PRWG_i = ((((model_.PRWG)+(BIN_L*(model_.LPRWG)))+(BIN_W*(model_.WPRWG)))+(BIN_WL*(model_.PPRWG)));
    PRWB_i = ((((model_.PRWB)+(BIN_L*(model_.LPRWB)))+(BIN_W*(model_.WPRWB)))+(BIN_WL*(model_.PPRWB)));
    WR_i = ((((model_.WR)+(BIN_L*(model_.LWR)))+(BIN_W*(model_.WWR)))+(BIN_WL*(model_.PWR)));
    RSWMIN_i = ((((model_.RSWMIN)+(BIN_L*(model_.LRSWMIN)))+(BIN_W*(model_.WRSWMIN)))+(BIN_WL*(model_.PRSWMIN)));
    RDWMIN_i = ((((model_.RDWMIN)+(BIN_L*(model_.LRDWMIN)))+(BIN_W*(model_.WRDWMIN)))+(BIN_WL*(model_.PRDWMIN)));
    RDSW_i = ((((model_.RDSW)+(BIN_L*(model_.LRDSW)))+(BIN_W*(model_.WRDSW)))+(BIN_WL*(model_.PRDSW)));
    RDSWMIN_i = ((((model_.RDSWMIN)+(BIN_L*(model_.LRDSWMIN)))+(BIN_W*(model_.WRDSWMIN)))+(BIN_WL*(model_.PRDSWMIN)));
    PTWG_i = ((((model_.PTWG)+(BIN_L*(model_.LPTWG)))+(BIN_W*(model_.WPTWG)))+(BIN_WL*(model_.PPTWG)));
    PDIBLC_i = ((((model_.PDIBLC)+(BIN_L*(model_.LPDIBLC)))+(BIN_W*(model_.WPDIBLC)))+(BIN_WL*(model_.PPDIBLC)));
    PDIBLCB_i = ((((model_.PDIBLCB)+(BIN_L*(model_.LPDIBLCB)))+(BIN_W*(model_.WPDIBLCB)))+(BIN_WL*(model_.PPDIBLCB)));
    PSCBE1_i = ((((model_.PSCBE1)+(BIN_L*(model_.LPSCBE1)))+(BIN_W*(model_.WPSCBE1)))+(BIN_WL*(model_.PPSCBE1)));
    PSCBE2_i = ((((model_.PSCBE2)+(BIN_L*(model_.LPSCBE2)))+(BIN_W*(model_.WPSCBE2)))+(BIN_WL*(model_.PPSCBE2)));
    PDITS_i = ((((model_.PDITS)+(BIN_L*(model_.LPDITS)))+(BIN_W*(model_.WPDITS)))+(BIN_WL*(model_.PPDITS)));
    PDITSD_i = ((((model_.PDITSD)+(BIN_L*(model_.LPDITSD)))+(BIN_W*(model_.WPDITSD)))+(BIN_WL*(model_.PPDITSD)));
    FPROUT_i = ((((model_.FPROUT)+(BIN_L*(model_.LFPROUT)))+(BIN_W*(model_.WFPROUT)))+(BIN_WL*(model_.PFPROUT)));
    PVAG_i = ((((model_.PVAG)+(BIN_L*(model_.LPVAG)))+(BIN_W*(model_.WPVAG)))+(BIN_WL*(model_.PPVAG)));
    VSAT_i = ((((model_.VSAT)+(BIN_L*(model_.LVSAT)))+(BIN_W*(model_.WVSAT)))+(BIN_WL*(model_.PVSAT)));
    PSAT_i = ((((model_.PSAT)+(BIN_L*(model_.LPSAT)))+(BIN_W*(model_.WPSAT)))+(BIN_WL*(model_.PPSAT)));
    VSATCV_i = ((((model_.VSATCV)+(BIN_L*(model_.LVSATCV)))+(BIN_W*(model_.WVSATCV)))+(BIN_WL*(model_.PVSATCV)));
    CF_i = ((((model_.CF)+(BIN_L*(model_.LCF)))+(BIN_W*(model_.WCF)))+(BIN_WL*(model_.PCF)));
    CGSL_i = ((((model_.CGSL)+(BIN_L*(model_.LCGSL)))+(BIN_W*(model_.WCGSL)))+(BIN_WL*(model_.PCGSL)));
    CGDL_i = ((((model_.CGDL)+(BIN_L*(model_.LCGDL)))+(BIN_W*(model_.WCGDL)))+(BIN_WL*(model_.PCGDL)));
    CKAPPAS_i = ((((model_.CKAPPAS)+(BIN_L*(model_.LCKAPPAS)))+(BIN_W*(model_.WCKAPPAS)))+(BIN_WL*(model_.PCKAPPAS)));
    CKAPPAD_i = ((((model_.CKAPPAD)+(BIN_L*(model_.LCKAPPAD)))+(BIN_W*(model_.WCKAPPAD)))+(BIN_WL*(model_.PCKAPPAD)));
    ALPHA0_i = ((((model_.ALPHA0)+(BIN_L*(model_.LALPHA0)))+(BIN_W*(model_.WALPHA0)))+(BIN_WL*(model_.PALPHA0)));
    BETA0_i = ((((model_.BETA0)+(BIN_L*(model_.LBETA0)))+(BIN_W*(model_.WBETA0)))+(BIN_WL*(model_.PBETA0)));
    KVTH0WE_i = ((((model_.KVTH0WE)+(BIN_L*(model_.LKVTH0WE)))+(BIN_W*(model_.WKVTH0WE)))+(BIN_WL*(model_.PKVTH0WE)));
    K2WE_i = ((((model_.K2WE)+(BIN_L*(model_.LK2WE)))+(BIN_W*(model_.WK2WE)))+(BIN_WL*(model_.PK2WE)));
    KU0WE_i = ((((model_.KU0WE)+(BIN_L*(model_.LKU0WE)))+(BIN_W*(model_.WKU0WE)))+(BIN_WL*(model_.PKU0WE)));
    AGIDL_i = ((((model_.AGIDL)+(BIN_L*(model_.LAGIDL)))+(BIN_W*(model_.WAGIDL)))+(BIN_WL*(model_.PAGIDL)));
    BGIDL_i = ((((model_.BGIDL)+(BIN_L*(model_.LBGIDL)))+(BIN_W*(model_.WBGIDL)))+(BIN_WL*(model_.PBGIDL)));
    CGIDL_i = ((((model_.CGIDL)+(BIN_L*(model_.LCGIDL)))+(BIN_W*(model_.WCGIDL)))+(BIN_WL*(model_.PCGIDL)));
    EGIDL_i = ((((model_.EGIDL)+(BIN_L*(model_.LEGIDL)))+(BIN_W*(model_.WEGIDL)))+(BIN_WL*(model_.PEGIDL)));
    AGISL_i = ((((model_.AGISL)+(BIN_L*(model_.LAGISL)))+(BIN_W*(model_.WAGISL)))+(BIN_WL*(model_.PAGISL)));
    BGISL_i = ((((model_.BGISL)+(BIN_L*(model_.LBGISL)))+(BIN_W*(model_.WBGISL)))+(BIN_WL*(model_.PBGISL)));
    CGISL_i = ((((model_.CGISL)+(BIN_L*(model_.LCGISL)))+(BIN_W*(model_.WCGISL)))+(BIN_WL*(model_.PCGISL)));
    EGISL_i = ((((model_.EGISL)+(BIN_L*(model_.LEGISL)))+(BIN_W*(model_.WEGISL)))+(BIN_WL*(model_.PEGISL)));
    UTE_i = ((((model_.UTE)+(BIN_L*(model_.LUTE)))+(BIN_W*(model_.WUTE)))+(BIN_WL*(model_.PUTE)));
    UA1_i = ((((model_.UA1)+(BIN_L*(model_.LUA1)))+(BIN_W*(model_.WUA1)))+(BIN_WL*(model_.PUA1)));
    UC1_i = ((((model_.UC1)+(BIN_L*(model_.LUC1)))+(BIN_W*(model_.WUC1)))+(BIN_WL*(model_.PUC1)));
    UD1_i = ((((model_.UD1)+(BIN_L*(model_.LUD1)))+(BIN_W*(model_.WUD1)))+(BIN_WL*(model_.PUD1)));
    UCSTE_i = ((((model_.UCSTE)+(BIN_L*(model_.LUCSTE)))+(BIN_W*(model_.WUCSTE)))+(BIN_WL*(model_.PUCSTE)));
    PRT_i = ((((model_.PRT)+(BIN_L*(model_.LPRT)))+(BIN_W*(model_.WPRT)))+(BIN_WL*(model_.PPRT)));
    AT_i = ((((model_.AT)+(BIN_L*(model_.LAT)))+(BIN_W*(model_.WAT)))+(BIN_WL*(model_.PAT)));
    PTWGT_i = ((((model_.PTWGT)+(BIN_L*(model_.LPTWGT)))+(BIN_W*(model_.WPTWGT)))+(BIN_WL*(model_.PPTWGT)));
    IIT_i = ((((model_.IIT)+(BIN_L*(model_.LIIT)))+(BIN_W*(model_.WIIT)))+(BIN_WL*(model_.PIIT)));
    TGIDL_i = ((((model_.TGIDL)+(BIN_L*(model_.LTGIDL)))+(BIN_W*(model_.WTGIDL)))+(BIN_WL*(model_.PTGIDL)));
    IGT_i = ((((model_.IGT)+(BIN_L*(model_.LIGT)))+(BIN_W*(model_.WIGT)))+(BIN_WL*(model_.PIGT)));
    AIGBINV_i = ((((model_.AIGBINV)+(BIN_L*(model_.LAIGBINV)))+(BIN_W*(model_.WAIGBINV)))+(BIN_WL*(model_.PAIGBINV)));
    BIGBINV_i = ((((model_.BIGBINV)+(BIN_L*(model_.LBIGBINV)))+(BIN_W*(model_.WBIGBINV)))+(BIN_WL*(model_.PBIGBINV)));
    CIGBINV_i = ((((model_.CIGBINV)+(BIN_L*(model_.LCIGBINV)))+(BIN_W*(model_.WCIGBINV)))+(BIN_WL*(model_.PCIGBINV)));
    EIGBINV_i = ((((model_.EIGBINV)+(BIN_L*(model_.LEIGBINV)))+(BIN_W*(model_.WEIGBINV)))+(BIN_WL*(model_.PEIGBINV)));
    NIGBINV_i = ((((model_.NIGBINV)+(BIN_L*(model_.LNIGBINV)))+(BIN_W*(model_.WNIGBINV)))+(BIN_WL*(model_.PNIGBINV)));
    AIGBACC_i = ((((model_.AIGBACC)+(BIN_L*(model_.LAIGBACC)))+(BIN_W*(model_.WAIGBACC)))+(BIN_WL*(model_.PAIGBACC)));
    BIGBACC_i = ((((model_.BIGBACC)+(BIN_L*(model_.LBIGBACC)))+(BIN_W*(model_.WBIGBACC)))+(BIN_WL*(model_.PBIGBACC)));
    CIGBACC_i = ((((model_.CIGBACC)+(BIN_L*(model_.LCIGBACC)))+(BIN_W*(model_.WCIGBACC)))+(BIN_WL*(model_.PCIGBACC)));
    NIGBACC_i = ((((model_.NIGBACC)+(BIN_L*(model_.LNIGBACC)))+(BIN_W*(model_.WNIGBACC)))+(BIN_WL*(model_.PNIGBACC)));
    AIGC_i = ((((model_.AIGC)+(BIN_L*(model_.LAIGC)))+(BIN_W*(model_.WAIGC)))+(BIN_WL*(model_.PAIGC)));
    BIGC_i = ((((model_.BIGC)+(BIN_L*(model_.LBIGC)))+(BIN_W*(model_.WBIGC)))+(BIN_WL*(model_.PBIGC)));
    CIGC_i = ((((model_.CIGC)+(BIN_L*(model_.LCIGC)))+(BIN_W*(model_.WCIGC)))+(BIN_WL*(model_.PCIGC)));
    AIGS_i = ((((model_.AIGS)+(BIN_L*(model_.LAIGS)))+(BIN_W*(model_.WAIGS)))+(BIN_WL*(model_.PAIGS)));
    BIGS_i = ((((model_.BIGS)+(BIN_L*(model_.LBIGS)))+(BIN_W*(model_.WBIGS)))+(BIN_WL*(model_.PBIGS)));
    CIGS_i = ((((model_.CIGS)+(BIN_L*(model_.LCIGS)))+(BIN_W*(model_.WCIGS)))+(BIN_WL*(model_.PCIGS)));
    AIGD_i = ((((model_.AIGD)+(BIN_L*(model_.LAIGD)))+(BIN_W*(model_.WAIGD)))+(BIN_WL*(model_.PAIGD)));
    BIGD_i = ((((model_.BIGD)+(BIN_L*(model_.LBIGD)))+(BIN_W*(model_.WBIGD)))+(BIN_WL*(model_.PBIGD)));
    CIGD_i = ((((model_.CIGD)+(BIN_L*(model_.LCIGD)))+(BIN_W*(model_.WCIGD)))+(BIN_WL*(model_.PCIGD)));
    POXEDGE_i = ((((model_.POXEDGE)+(BIN_L*(model_.LPOXEDGE)))+(BIN_W*(model_.WPOXEDGE)))+(BIN_WL*(model_.PPOXEDGE)));
    DLCIG_i = ((((model_.DLCIG)+(BIN_L*(model_.LDLCIG)))+(BIN_W*(model_.WDLCIG)))+(BIN_WL*(model_.PDLCIG)));
    DLCIGD_i = ((((model_.DLCIGD)+(BIN_L*(model_.LDLCIGD)))+(BIN_W*(model_.WDLCIGD)))+(BIN_WL*(model_.PDLCIGD)));
    NTOX_i = ((((model_.NTOX)+(BIN_L*(model_.LNTOX)))+(BIN_W*(model_.WNTOX)))+(BIN_WL*(model_.PNTOX)));
    KT1_i = ((((model_.KT1)+(BIN_L*(model_.LKT1)))+(BIN_W*(model_.WKT1)))+(BIN_WL*(model_.PKT1)));
    KT2_i = ((((model_.KT2)+(BIN_L*(model_.LKT2)))+(BIN_W*(model_.WKT2)))+(BIN_WL*(model_.PKT2)));
    PSATB_i = ((((model_.PSATB)+(BIN_L*(model_.LPSATB)))+(BIN_W*(model_.WPSATB)))+(BIN_WL*(model_.PPSATB)));
    A1_i = ((((model_.A1)+(BIN_L*(model_.LA1)))+(BIN_W*(model_.WA1)))+(BIN_WL*(model_.PA1)));
    A11_i = ((((model_.A11)+(BIN_L*(model_.LA11)))+(BIN_W*(model_.WA11)))+(BIN_WL*(model_.PA11)));
    A2_i = ((((model_.A2)+(BIN_L*(model_.LA2)))+(BIN_W*(model_.WA2)))+(BIN_WL*(model_.PA2)));
    A21_i = ((((model_.A21)+(BIN_L*(model_.LA21)))+(BIN_W*(model_.WA21)))+(BIN_WL*(model_.PA21)));
    if (((model_.ASYMMOD)!=0))
    {
      CDSCDR_i = ((((model_.CDSCDR)+(BIN_L*(model_.LCDSCDR)))+(BIN_W*(model_.WCDSCDR)))+(BIN_WL*(model_.PCDSCDR)));
      ETA0R_i = ((((model_.ETA0R)+(BIN_L*(model_.LETA0R)))+(BIN_W*(model_.WETA0R)))+(BIN_WL*(model_.PETA0R)));
      U0R_i = ((((model_.U0R)+(BIN_L*(model_.LU0R)))+(BIN_W*(model_.WU0R)))+(BIN_WL*(model_.PU0R)));
      UAR_i = ((((model_.UAR)+(BIN_L*(model_.LUAR)))+(BIN_W*(model_.WUAR)))+(BIN_WL*(model_.PUAR)));
      UDR_i = ((((model_.UDR)+(BIN_L*(model_.LUDR)))+(BIN_W*(model_.WUDR)))+(BIN_WL*(model_.PUDR)));
      UCSR_i = ((((model_.UCSR)+(BIN_L*(model_.LUCSR)))+(BIN_W*(model_.WUCSR)))+(BIN_WL*(model_.PUCSR)));
      UCR_i = ((((model_.UCR)+(BIN_L*(model_.LUCR)))+(BIN_W*(model_.WUCR)))+(BIN_WL*(model_.PUCR)));
      PCLMR_i = ((((model_.PCLMR)+(BIN_L*(model_.LPCLMR)))+(BIN_W*(model_.WPCLMR)))+(BIN_WL*(model_.PPCLMR)));
      PDIBLCR_i = ((((model_.PDIBLCR)+(BIN_L*(model_.LPDIBLCR)))+(BIN_W*(model_.WPDIBLCR)))+(BIN_WL*(model_.PPDIBLCR)));
      VSATR_i = ((((model_.VSATR)+(BIN_L*(model_.LVSATR)))+(BIN_W*(model_.WVSATR)))+(BIN_WL*(model_.PVSATR)));
      PSATR_i = ((((model_.PSATR)+(BIN_L*(model_.LPSATR)))+(BIN_W*(model_.WPSATR)))+(BIN_WL*(model_.PPSATR)));
      PTWGR_i = ((((model_.PTWGR)+(BIN_L*(model_.LPTWGR)))+(BIN_W*(model_.WPTWGR)))+(BIN_WL*(model_.PPTWGR)));
    }
    T0 = (((model_.NDEPL1)*std::max((pow(Inv_L,(model_.NDEPLEXP1))-pow(Inv_Llong,(model_.NDEPLEXP1))),static_cast<double>(0)))+((model_.NDEPL2)*std::max((pow(Inv_L,(model_.NDEPLEXP2))-pow(Inv_Llong,(model_.NDEPLEXP2))),static_cast<double>(0))));
    T1 = (((model_.NDEPW)*std::max((pow(Inv_W,(model_.NDEPWEXP))-pow(Inv_Wwide,(model_.NDEPWEXP))),static_cast<double>(0)))+((model_.NDEPWL)*pow((Inv_W*Inv_L),(model_.NDEPWLEXP))));
    NDEP_i = (NDEP_i*((1.0+T0.val())+T1.val()));
    T0 = ((model_.NFACTORL)*std::max((pow(Inv_L,(model_.NFACTORLEXP))-pow(Inv_Llong,(model_.NFACTORLEXP))),static_cast<double>(0)));
    T1 = (((model_.NFACTORW)*std::max((pow(Inv_W,(model_.NFACTORWEXP))-pow(Inv_Wwide,(model_.NFACTORWEXP))),static_cast<double>(0)))+((model_.NFACTORWL)*pow(Inv_WL,(model_.NFACTORWLEXP))));
    NFACTOR_i = (NFACTOR_i*((1.0+T0.val())+T1.val()));
    T0 = (1.0+((model_.CDSCDL)*std::max((pow(Inv_L,(model_.CDSCDLEXP))-pow(Inv_Llong,(model_.CDSCDLEXP))),static_cast<double>(0))));
    CDSCD_i = (CDSCD_i*T0.val());
    if (((model_.ASYMMOD)!=0))
    {
      CDSCDR_i = (CDSCDR_i*T0.val());
    }
    CDSCB_i = (CDSCB_i*(1.0+((model_.CDSCBL)*std::max((pow(Inv_L,(model_.CDSCBLEXP))-pow(Inv_Llong,(model_.CDSCBLEXP))),static_cast<double>(0)))));
    U0_i = ((model_.MULU0)*U0_i);
    if (((model_.MOBSCALE)!=1))
    {
      if (((model_.U0LEXP)>0))
      {
        U0_i = (U0_i*(1.0-((model_.U0L)*std::max((pow(Inv_L,(model_.U0LEXP))-pow(Inv_Llong,(model_.U0LEXP))),static_cast<double>(0)))));
        if (((model_.ASYMMOD)!=0))
        {
          U0R_i = (U0R_i*(1.0-((model_.U0L)*std::max((pow(Inv_L,(model_.U0LEXP))-pow(Inv_Llong,(model_.U0LEXP))),static_cast<double>(0)))));
        }
      }
      else
      {
        U0_i = (U0_i*(1.0-(model_.U0L)));
        if (((model_.ASYMMOD)!=0))
        {
          U0R_i = (U0R_i*(1.0-(model_.U0L)));
        }
      }
    }
    else
    {
      U0_i = (U0_i*((1.0-((model_.UP1)*exp(((-Leff)/(model_.LP1)))))-((model_.UP2)*exp(((-Leff)/(model_.LP2))))));
      if (((model_.ASYMMOD)!=0))
      {
        U0R_i = (U0R_i*((1.0-((model_.UP1)*exp(((-Leff)/(model_.LP1)))))-((model_.UP2)*exp(((-Leff)/(model_.LP2))))));
      }
    }
    T0 = ((model_.UAL)*std::max((pow(Inv_L,(model_.UALEXP))-pow(Inv_Llong,(model_.UALEXP))),static_cast<double>(0)));
    T1 = (((model_.UAW)*std::max((pow(Inv_W,(model_.UAWEXP))-pow(Inv_Wwide,(model_.UAWEXP))),static_cast<double>(0)))+((model_.UAWL)*pow(Inv_WL,(model_.UAWLEXP))));
    UA_i = (UA_i*((1.0+T0.val())+T1.val()));
    if (((model_.ASYMMOD)!=0))
    {
      UAR_i = (UAR_i*((1.0+T0.val())+T1.val()));
    }
    T0 = ((model_.EUL)*std::max((pow(Inv_L,(model_.EULEXP))-pow(Inv_Llong,(model_.EULEXP))),static_cast<double>(0)));
    T1 = (((model_.EUW)*std::max((pow(Inv_W,(model_.EUWEXP))-pow(Inv_Wwide,(model_.EUWEXP))),static_cast<double>(0)))+((model_.EUWL)*pow(Inv_WL,(model_.EUWLEXP))));
    EU_i = (EU_i*((1.0+T0.val())+T1.val()));
    T0 = (1.0+((model_.UDL)*std::max((pow(Inv_L,(model_.UDLEXP))-pow(Inv_Llong,(model_.UDLEXP))),static_cast<double>(0))));
    UD_i = (UD_i*T0.val());
    if (((model_.ASYMMOD)!=0))
    {
      UDR_i = (UDR_i*T0.val());
    }
    T0 = ((model_.UCL)*std::max((pow(Inv_L,(model_.UCLEXP))-pow(Inv_Llong,(model_.UCLEXP))),static_cast<double>(0)));
    T1 = (((model_.UCW)*std::max((pow(Inv_W,(model_.UCWEXP))-pow(Inv_Wwide,(model_.UCWEXP))),static_cast<double>(0)))+((model_.UCWL)*pow(Inv_WL,(model_.UCWLEXP))));
    UC_i = (UC_i*((1.0+T0.val())+T1.val()));
    if (((model_.ASYMMOD)!=0))
    {
      UCR_i = (UCR_i*((1.0+T0.val())+T1.val()));
    }
    T0 = std::max((pow(Inv_L,(model_.DSUB))-pow(Inv_Llong,(model_.DSUB))),static_cast<double>(0));
    ETA0_i = (ETA0_i*T0.val());
    if (((model_.ASYMMOD)!=0))
    {
      ETA0R_i = (ETA0R_i*T0.val());
    }
    ETAB_i = (ETAB_i*std::max((pow(Inv_L,(model_.ETABEXP))-pow(Inv_Llong,(model_.ETABEXP))),static_cast<double>(0)));
    T0 = (1.0+((model_.PDIBLCL)*std::max((pow(Inv_L,(model_.PDIBLCLEXP))-pow(Inv_Llong,(model_.PDIBLCLEXP))),static_cast<double>(0))));
    PDIBLC_i = (PDIBLC_i*T0.val());
    if (((model_.ASYMMOD)!=0))
    {
      PDIBLCR_i = (PDIBLCR_i*T0.val());
    }
    T0 = (DELTA_i*(1.0+((model_.DELTAL)*std::max((pow(Inv_L,(model_.DELTALEXP))-pow(Inv_Llong,(model_.DELTALEXP))),static_cast<double>(0)))));
    DELTA_i = std::min(T0.val(),static_cast<double>(0.5));
    FPROUT_i = (FPROUT_i*(1.0+((model_.FPROUTL)*std::max((pow(Inv_L,(model_.FPROUTLEXP))-pow(Inv_Llong,(model_.FPROUTLEXP))),static_cast<double>(0)))));
    T0 = (1.0+((model_.PCLML)*std::max((pow(Inv_L,(model_.PCLMLEXP))-pow(Inv_Llong,(model_.PCLMLEXP))),static_cast<double>(0))));
    PCLM_i = (PCLM_i*T0.val());
    PCLM_i = std::max(PCLM_i,static_cast<double>(0));
    if (((model_.ASYMMOD)!=0))
    {
      PCLMR_i = (PCLMR_i*T0.val());
      PCLMR_i = std::max(PCLMR_i,static_cast<double>(0));
    }
    T0 = ((model_.VSATL)*std::max((pow(Inv_L,(model_.VSATLEXP))-pow(Inv_Llong,(model_.VSATLEXP))),static_cast<double>(0)));
    T1 = (((model_.VSATW)*std::max((pow(Inv_W,(model_.VSATWEXP))-pow(Inv_Wwide,(model_.VSATWEXP))),static_cast<double>(0)))+((model_.VSATWL)*pow(Inv_WL,(model_.VSATWLEXP))));
    VSAT_i = (VSAT_i*((1.0+T0.val())+T1.val()));
    if (((model_.ASYMMOD)!=0))
    {
      VSATR_i = (VSATR_i*((1.0+T0.val())+T1.val()));
    }
    PSAT_i = std::max((PSAT_i*(1.0+((model_.PSATL)*std::max((pow(Inv_L,(model_.PSATLEXP))-pow(Inv_Llong,(model_.PSATLEXP))),static_cast<double>(0))))),static_cast<double>(0.25));
    if (((model_.ASYMMOD)!=0))
    {
      PSATR_i = std::max((PSATR_i*(1.0+((model_.PSATL)*std::max((pow(Inv_L,(model_.PSATLEXP))-pow(Inv_Llong,(model_.PSATLEXP))),static_cast<double>(0))))),static_cast<double>(0.25));
    }
    T0 = (1.0+((model_.PTWGL)*std::max((pow(Inv_L,(model_.PTWGLEXP))-pow(Inv_Llong,(model_.PTWGLEXP))),static_cast<double>(0))));
    PTWG_i = (PTWG_i*T0.val());
    if (((model_.ASYMMOD)!=0))
    {
      PTWGR_i = (PTWGR_i*T0.val());
    }
    ALPHA0_i = (ALPHA0_i*(1.0+((model_.ALPHA0L)*std::max((pow(Inv_L,(model_.ALPHA0LEXP))-pow(Inv_Llong,(model_.ALPHA0LEXP))),static_cast<double>(0)))));
    AGIDL_i = (AGIDL_i*((1.0+((model_.AGIDLL)*Inv_L))+((model_.AGIDLW)*Inv_W)));
    AGISL_i = (AGISL_i*((1.0+((model_.AGISLL)*Inv_L))+((model_.AGISLW)*Inv_W)));
    AIGC_i = (AIGC_i*((1.0+((model_.AIGCL)*Inv_L))+((model_.AIGCW)*Inv_W)));
    AIGS_i = (AIGS_i*((1.0+((model_.AIGSL)*Inv_L))+((model_.AIGSW)*Inv_W)));
    AIGD_i = (AIGD_i*((1.0+((model_.AIGDL)*Inv_L))+((model_.AIGDW)*Inv_W)));
    PIGCD_i = ((model_.PIGCD)*(1.0+((model_.PIGCDL)*Inv_L)));
    T0 = (((model_.NDEPCVL1)*std::max((pow(Inv_Lact,(model_.NDEPCVLEXP1))-pow(Inv_Llong,(model_.NDEPCVLEXP1))),static_cast<double>(0)))+((model_.NDEPCVL2)*std::max((pow(Inv_Lact,(model_.NDEPCVLEXP2))-pow(Inv_Llong,(model_.NDEPCVLEXP2))),static_cast<double>(0))));
    T1 = (((model_.NDEPCVW)*std::max((pow(Inv_Wact,(model_.NDEPCVWEXP))-pow(Inv_Wwide,(model_.NDEPCVWEXP))),static_cast<double>(0)))+((model_.NDEPCVWL)*pow((Inv_Wact*Inv_Lact),(model_.NDEPCVWLEXP))));
    NDEPCV_i = (NDEPCV_i*((1.0+T0.val())+T1.val()));
    T0 = ((model_.VFBCVL)*std::max((pow(Inv_Lact,(model_.VFBCVLEXP))-pow(Inv_Llong,(model_.VFBCVLEXP))),static_cast<double>(0)));
    T1 = (((model_.VFBCVW)*std::max((pow(Inv_Wact,(model_.VFBCVWEXP))-pow(Inv_Wwide,(model_.VFBCVWEXP))),static_cast<double>(0)))+((model_.VFBCVWL)*pow(Inv_WL,(model_.VFBCVWLEXP))));
    VFBCV_i = (VFBCV_i*((1.0+T0.val())+T1.val()));
    T0 = ((model_.VSATCVL)*std::max((pow(Inv_Lact,(model_.VSATCVLEXP))-pow(Inv_Llong,(model_.VSATCVLEXP))),static_cast<double>(0)));
    T1 = (((model_.VSATCVW)*std::max((pow(Inv_W,(model_.VSATCVWEXP))-pow(Inv_Wwide,(model_.VSATCVWEXP))),static_cast<double>(0)))+((model_.VSATCVWL)*pow(Inv_WL,(model_.VSATCVWLEXP))));
    VSATCV_i = (VSATCV_i*((1.0+T0.val())+T1.val()));
    PCLMCV_i = (PCLMCV_i*(1.0+((model_.PCLMCVL)*std::max((pow(Inv_Lact,(model_.PCLMCVLEXP))-pow(Inv_Llong,(model_.PCLMCVLEXP))),static_cast<double>(0)))));
    PCLMCV_i = std::max(PCLMCV_i,static_cast<double>(0));
    T0 = ((model_.K1L)*std::max((pow(Inv_L,(model_.K1LEXP))-pow(Inv_Llong,(model_.K1LEXP))),static_cast<double>(0)));
    T1 = (((model_.K1W)*std::max((pow(Inv_W,(model_.K1WEXP))-pow(Inv_Wwide,(model_.K1WEXP))),static_cast<double>(0)))+((model_.K1WL)*pow(Inv_WL,(model_.K1WLEXP))));
    K1_i = (K1_i*((1.0+T0.val())+T1.val()));
    T0 = ((model_.K2L)*std::max((pow(Inv_L,(model_.K2LEXP))-pow(Inv_Llong,(model_.K2LEXP))),static_cast<double>(0)));
    T1 = (((model_.K2W)*std::max((pow(Inv_W,(model_.K2WEXP))-pow(Inv_Wwide,(model_.K2WEXP))),static_cast<double>(0)))+((model_.K2WL)*pow(Inv_WL,(model_.K2WLEXP))));
    K2_i = (K2_i*((1.0+T0)+T1));
    PRWB_i = (PRWB_i*(1.0+((model_.PRWBL)*std::max((pow(Inv_L,(model_.PRWBLEXP))-pow(Inv_Llong,(model_.PRWBLEXP))),static_cast<double>(0)))));
    UTE_i = (UTE_i*(1.0+(Inv_L*(model_.UTEL))));
    UA1_i = (UA1_i*(1.0+(Inv_L*(model_.UA1L))));
    UD1_i = (UD1_i*(1.0+(Inv_L*(model_.UD1L))));
    AT_i = (AT_i*(1.0+(Inv_L*(model_.ATL))));
    PTWGT_i = (PTWGT_i*(1.0+(Inv_L*(model_.PTWGTL))));
    if (((model_.RDSMOD)==1))
    {
      RSW_i = (RSW_i*(1.0+((model_.RSWL)*std::max((pow(Inv_L,(model_.RSWLEXP))-pow(Inv_Llong,(model_.RSWLEXP))),static_cast<double>(0)))));
      RDW_i = (RDW_i*(1.0+((model_.RDWL)*std::max((pow(Inv_L,(model_.RDWLEXP))-pow(Inv_Llong,(model_.RDWLEXP))),static_cast<double>(0)))));
    }
    else
    {
      RDSW_i = (RDSW_i*(1.0+((model_.RDSWL)*std::max((pow(Inv_L,(model_.RDSWLEXP))-pow(Inv_Llong,(model_.RDSWLEXP))),static_cast<double>(0)))));
    }
    if ((UCS_i<1.0))
    {
      UCS_i = 1.0;
    }
    else
    {
      if ((UCS_i>2.0))
      {
        UCS_i = 2.0;
      }
    }
    if (((model_.ASYMMOD)!=0))
    {
      if ((UCSR_i<1.0))
      {
        UCSR_i = 1.0;
      }
      else
      {
        if ((UCSR_i>2.0))
        {
          UCSR_i = 2.0;
        }
      }
      if ((UCR_i<0))
      {
        std::cerr  << "Fatal: UCR_i = %e is negative." << UCR_i <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
    }
    if ((CGIDL_i<0))
    {
      std::cerr  << "Fatal: CGIDL_i = %e is negative." << CGIDL_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((CGISL_i<0))
    {
      std::cerr  << "Fatal: CGISL_i = %e is negative." << CGISL_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((CKAPPAD_i<=0))
    {
      std::cerr  << "Fatal: CKAPPAD_i = %e is non-positive." << CKAPPAD_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((CKAPPAS_i<=0))
    {
      std::cerr  << "Fatal: CKAPPAS_i = %e is non-positive." << CKAPPAS_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((PDITS_i<0))
    {
      std::cerr  << "Fatal: PDITS_i = %e is negative." << PDITS_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((CIT_i<0))
    {
      std::cerr  << "Fatal: CIT_i = %e is negative." << CIT_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((NFACTOR_i<0))
    {
      std::cerr  << "Fatal: NFACTOR_i = %e is negative." << NFACTOR_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((K1_i<0))
    {
      std::cerr  << "Fatal: K1_i = %e is positive." << K1_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((NSD_i<=0))
    {
      std::cerr  << "Fatal: NSD_i = %e is non-positive." << NSD_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((NDEP_i<=0))
    {
      std::cerr  << "Fatal: NDEP_i = %e is non-positive." << NDEP_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if ((NDEPCV_i<=0))
    {
      std::cerr  << "Fatal: NDEPCV_i = %e is non-positive." << NDEPCV_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if (((model_.IGBMOD)!=0))
    {
      if ((NIGBINV_i<=0))
      {
        std::cerr  << "Fatal: NIGBINV_i = %e is non-positive." << NIGBINV_i <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
      if ((NIGBACC_i<=0))
      {
        std::cerr  << "Fatal: NIGBACC_i = %e is non-positive." << NIGBACC_i <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
    }
    if (((model_.IGCMOD)!=0))
    {
      if ((POXEDGE_i<=0))
      {
        std::cerr  << "Fatal: POXEDGE_i = %e is non-positive." << POXEDGE_i <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
    }
    if ((CDSCD_i<0))
    {
      std::cerr  << "Fatal: CDSCD_i = %e is negative." << CDSCD_i <<  std::endl; 
      UserError(*this) << "$finish called." << std::endl; 
    }
    if (((model_.ASYMMOD)!=0))
    {
      if ((CDSCDR_i<0))
      {
        std::cerr  << "Fatal: CDSCDR_i = %e is negative." << CDSCDR_i <<  std::endl; 
        UserError(*this) << "$finish called." << std::endl; 
      }
    }
    nuEndD = 0;
    nuEndS = 0;
    nuIntD = 0;
    nuIntS = 0;
    Rend = 0;
    Rint = 0;
    DMCGeff = ((model_.DMCG)-(model_.DMCGT));
    DMCIeff = (model_.DMCI);
    DMDGeff = ((model_.DMDG)-(model_.DMCGT));
    if (((model_.RSH)>0))
    {
      if (((!given("NRD"))&&(RGEOMOD!=0)))
      {
        if ((GEOMOD<9))
        {
          if (((NF%2)!=0))
          {
            nuEndD = 1.0;
            nuEndS = 1.0;
            nuIntD = (2.0*std::max(((NF-1.0)/2.0),static_cast<double>(0.0)));
            nuIntS = nuIntD;
          }
          else
          {
            if ((MINZ==1))
            {
              nuEndD = 2.0;
              nuIntD = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
              nuEndS = 0.0;
              nuIntS = NF;
            }
            else
            {
              nuEndD = 0.0;
              nuIntD = NF;
              nuEndS = 2.0;
              nuIntS = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
            }
          }
          if ((0==1))
          {
            if ((nuIntS==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
            }
          }
          else
          {
            if ((nuIntD==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
            }
          }
        }
        if ( GEOMOD == (0))
        {
          if ((0==1))
          {
            if ((1==1))
            {
              if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
              {
                if ((nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                }
              }
              else
                if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
              {
                if ((nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                }
              }
              else
                if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
          else
          {
            if ((0==1))
            {
              if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
              {
                if ((nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                }
              }
              else
                if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
              {
                if ((nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                }
              }
              else
                if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
        }
        else
          if ( GEOMOD == (1))
          {
            if ((0==1))
            {
              if ((1==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if ((DMCGeff==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if ((DMCGeff==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( GEOMOD == (2))
            {
              if ((0==1))
              {
                if ((1==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( GEOMOD == (3))
              {
                if ((0==1))
                {
                  if ((1==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( GEOMOD == (4))
                {
                  if ((0==1))
                  {
                    if ((1==1))
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                        {
                          if (((DMCGeff+DMCIeff)==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                        {
                          if (((DMCGeff+DMCIeff)==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMDGeff)/Weff);
                  }
                }
                else
                  if ( GEOMOD == (5))
                  {
                    if ((0==1))
                    {
                      if ((1==1))
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                          {
                            if ((DMCGeff==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                          {
                            if ((DMCGeff==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      if ((nuEndD==0))
                      {
                        Rend = 0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
                      }
                    }
                  }
                  else
                    if ( GEOMOD == (6))
                    {
                      if ((0==1))
                      {
                        Rend = (((model_.RSH)*DMDGeff)/Weff);
                      }
                      else
                      {
                        if ((0==1))
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                          {
                            if ((nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                            }
                          }
                          else
                            if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                            {
                              if (((DMCGeff+DMCIeff)==0.0))
                              {
                              }
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                          {
                            if ((nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                            }
                          }
                          else
                            if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                            {
                              if (((DMCGeff+DMCIeff)==0.0))
                              {
                              }
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                    }
                    else
                      if ( GEOMOD == (7))
                      {
                        if ((0==1))
                        {
                          if ((nuEndS==0))
                          {
                            Rend = 0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                              {
                                if ((DMCGeff==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                              {
                                if ((DMCGeff==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( GEOMOD == (8))
                        {
                          Rend = (((model_.RSH)*DMDGeff)/Weff);
                        }
                        else
                          if ( GEOMOD == (9))
                          {
                            if ((0==1))
                            {
                              Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                              if ((NF==2.0))
                              {
                                Rint = 0.0;
                              }
                              else
                              {
                                Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                              Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                            }
                          }
                          else
                            if ( GEOMOD == (10))
                            {
                              if ((0==1))
                              {
                                Rend = 0.0;
                                Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                              }
                              else
                              {
                                Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                                if ((NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                                }
                              }
                            }
                            else
                            {
                              Rint = 0.0;
                            }
        if ((Rint<=0.0))
        {
          Rtot = Rend;
        }
        else
        {
          if ((Rend<=0.0))
          {
            Rtot = Rint;
          }
          else
          {
            Rtot = ((Rint*Rend)/(Rint+Rend));
          }
        }
        if ((Rtot==0.0))
        {
        }
      }
    }
    if (((model_.RSH)>0))
    {
      if (((!given("NRS"))&&(RGEOMOD!=0)))
      {
        if ((GEOMOD<9))
        {
          if (((NF%2)!=0))
          {
            nuEndD = 1.0;
            nuEndS = 1.0;
            nuIntD = (2.0*std::max(((NF-1.0)/2.0),static_cast<double>(0.0)));
            nuIntS = nuIntD;
          }
          else
          {
            if ((MINZ==1))
            {
              nuEndD = 2.0;
              nuIntD = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
              nuEndS = 0.0;
              nuIntS = NF;
            }
            else
            {
              nuEndD = 0.0;
              nuIntD = NF;
              nuEndS = 2.0;
              nuIntS = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
            }
          }
          if ((1==1))
          {
            if ((nuIntS==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
            }
          }
          else
          {
            if ((nuIntD==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
            }
          }
        }
        if ( GEOMOD == (0))
        {
          if ((1==1))
          {
            if ((1==1))
            {
              if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
              {
                if ((nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                }
              }
              else
                if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
              {
                if ((nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                }
              }
              else
                if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
          else
          {
            if ((0==1))
            {
              if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
              {
                if ((nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                }
              }
              else
                if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
              {
                if ((nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                }
              }
              else
                if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                {
                  if (((DMCGeff+DMCIeff)==0.0))
                  {
                  }
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
        }
        else
          if ( GEOMOD == (1))
          {
            if ((1==1))
            {
              if ((1==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if ((DMCGeff==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if ((DMCGeff==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( GEOMOD == (2))
            {
              if ((1==1))
              {
                if ((1==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( GEOMOD == (3))
              {
                if ((1==1))
                {
                  if ((1==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( GEOMOD == (4))
                {
                  if ((1==1))
                  {
                    if ((1==1))
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                        {
                          if (((DMCGeff+DMCIeff)==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                        {
                          if (((DMCGeff+DMCIeff)==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMDGeff)/Weff);
                  }
                }
                else
                  if ( GEOMOD == (5))
                  {
                    if ((1==1))
                    {
                      if ((1==1))
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                          {
                            if ((DMCGeff==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                          {
                            if ((DMCGeff==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      if ((nuEndD==0))
                      {
                        Rend = 0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
                      }
                    }
                  }
                  else
                    if ( GEOMOD == (6))
                    {
                      if ((1==1))
                      {
                        Rend = (((model_.RSH)*DMDGeff)/Weff);
                      }
                      else
                      {
                        if ((0==1))
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                          {
                            if ((nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                            }
                          }
                          else
                            if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                            {
                              if (((DMCGeff+DMCIeff)==0.0))
                              {
                              }
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                          {
                            if ((nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                            }
                          }
                          else
                            if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                            {
                              if (((DMCGeff+DMCIeff)==0.0))
                              {
                              }
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                    }
                    else
                      if ( GEOMOD == (7))
                      {
                        if ((1==1))
                        {
                          if ((nuEndS==0))
                          {
                            Rend = 0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                              {
                                if ((DMCGeff==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                              {
                                if ((DMCGeff==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( GEOMOD == (8))
                        {
                          Rend = (((model_.RSH)*DMDGeff)/Weff);
                        }
                        else
                          if ( GEOMOD == (9))
                          {
                            if ((1==1))
                            {
                              Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                              if ((NF==2.0))
                              {
                                Rint = 0.0;
                              }
                              else
                              {
                                Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                              Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                            }
                          }
                          else
                            if ( GEOMOD == (10))
                            {
                              if ((1==1))
                              {
                                Rend = 0.0;
                                Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                              }
                              else
                              {
                                Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                                if ((NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                                }
                              }
                            }
                            else
                            {
                              Rint = 0.0;
                            }
        if ((Rint<=0.0))
        {
          Rtot = Rend;
        }
        else
        {
          if ((Rend<=0.0))
          {
            Rtot = Rint;
          }
          else
          {
            Rtot = ((Rint*Rend)/(Rint+Rend));
          }
        }
        if ((Rtot==0.0))
        {
        }
      }
    }
    if (given("NRS"))
    {
      RSourceGeo = ((model_.RSH)*NRS);
    }
    else
    {
      if ((RGEOMOD>0))
      {
        {
          if ((GEOMOD<9))
          {
            if (((NF%2)!=0))
            {
              nuEndD = 1.0;
              nuEndS = 1.0;
              nuIntD = (2.0*std::max(((NF-1.0)/2.0),static_cast<double>(0.0)));
              nuIntS = nuIntD;
            }
            else
            {
              if ((MINZ==1))
              {
                nuEndD = 2.0;
                nuIntD = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
                nuEndS = 0.0;
                nuIntS = NF;
              }
              else
              {
                nuEndD = 0.0;
                nuIntD = NF;
                nuEndS = 2.0;
                nuIntS = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
              }
            }
            if ((1==1))
            {
              if ((nuIntS==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
              }
            }
            else
            {
              if ((nuIntD==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
              }
            }
          }
          if ( GEOMOD == (0))
          {
            if ((1==1))
            {
              if ((1==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( GEOMOD == (1))
            {
              if ((1==1))
              {
                if ((1==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( GEOMOD == (2))
              {
                if ((1==1))
                {
                  if ((1==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if (((DMCGeff+DMCIeff)==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if (((DMCGeff+DMCIeff)==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( GEOMOD == (3))
                {
                  if ((1==1))
                  {
                    if ((1==1))
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    if ((0==1))
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                      {
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                        }
                      }
                      else
                        if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                      {
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                        }
                      }
                      else
                        if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                }
                else
                  if ( GEOMOD == (4))
                  {
                    if ((1==1))
                    {
                      if ((1==1))
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                          {
                            if (((DMCGeff+DMCIeff)==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                          {
                            if (((DMCGeff+DMCIeff)==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMDGeff)/Weff);
                    }
                  }
                  else
                    if ( GEOMOD == (5))
                    {
                      if ((1==1))
                      {
                        if ((1==1))
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                          {
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                            }
                          }
                          else
                            if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                            {
                              if ((DMCGeff==0.0))
                              {
                              }
                              if ((nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                          {
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                            }
                          }
                          else
                            if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                            {
                              if ((DMCGeff==0.0))
                              {
                              }
                              if ((nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                      else
                      {
                        if ((nuEndD==0))
                        {
                          Rend = 0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
                        }
                      }
                    }
                    else
                      if ( GEOMOD == (6))
                      {
                        if ((1==1))
                        {
                          Rend = (((model_.RSH)*DMDGeff)/Weff);
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                              {
                                if (((DMCGeff+DMCIeff)==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                              {
                                if (((DMCGeff+DMCIeff)==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( GEOMOD == (7))
                        {
                          if ((1==1))
                          {
                            if ((nuEndS==0))
                            {
                              Rend = 0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
                            }
                          }
                          else
                          {
                            if ((0==1))
                            {
                              if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                              {
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                                }
                              }
                              else
                                if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                                {
                                  if ((DMCGeff==0.0))
                                  {
                                  }
                                  if ((nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                            else
                            {
                              if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                              {
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                                }
                              }
                              else
                                if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                                {
                                  if ((DMCGeff==0.0))
                                  {
                                  }
                                  if ((nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                          }
                        }
                        else
                          if ( GEOMOD == (8))
                          {
                            Rend = (((model_.RSH)*DMDGeff)/Weff);
                          }
                          else
                            if ( GEOMOD == (9))
                            {
                              if ((1==1))
                              {
                                Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                                if ((NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                                Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                              }
                            }
                            else
                              if ( GEOMOD == (10))
                              {
                                if ((1==1))
                                {
                                  Rend = 0.0;
                                  Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                                }
                                else
                                {
                                  Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                                  if ((NF==2.0))
                                  {
                                    Rint = 0.0;
                                  }
                                  else
                                  {
                                    Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                                  }
                                }
                              }
                              else
                              {
                                Rint = 0.0;
                              }
          if ((Rint<=0.0))
          {
            RSourceGeo = Rend;
          }
          else
          {
            if ((Rend<=0.0))
            {
              RSourceGeo = Rint;
            }
            else
            {
              RSourceGeo = ((Rint*Rend)/(Rint+Rend));
            }
          }
          if ((RSourceGeo==0.0))
          {
          }
        }
      }
      else
      {
        RSourceGeo = 0.0;
      }
    }
    if (given("NRD"))
    {
      RDrainGeo = ((model_.RSH)*NRD);
    }
    else
    {
      if ((RGEOMOD>0))
      {
        {
          if ((GEOMOD<9))
          {
            if (((NF%2)!=0))
            {
              nuEndD = 1.0;
              nuEndS = 1.0;
              nuIntD = (2.0*std::max(((NF-1.0)/2.0),static_cast<double>(0.0)));
              nuIntS = nuIntD;
            }
            else
            {
              if ((MINZ==1))
              {
                nuEndD = 2.0;
                nuIntD = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
                nuEndS = 0.0;
                nuIntS = NF;
              }
              else
              {
                nuEndD = 0.0;
                nuIntD = NF;
                nuEndS = 2.0;
                nuIntS = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
              }
            }
            if ((0==1))
            {
              if ((nuIntS==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
              }
            }
            else
            {
              if ((nuIntD==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
              }
            }
          }
          if ( GEOMOD == (0))
          {
            if ((0==1))
            {
              if ((1==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                {
                  if ((nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                  }
                }
                else
                  if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                  {
                    if (((DMCGeff+DMCIeff)==0.0))
                    {
                    }
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( GEOMOD == (1))
            {
              if ((0==1))
              {
                if ((1==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if (((DMCGeff+DMCIeff)==0.0))
                      {
                      }
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                  {
                    if ((nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                    }
                  }
                  else
                    if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                    {
                      if ((DMCGeff==0.0))
                      {
                      }
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( GEOMOD == (2))
              {
                if ((0==1))
                {
                  if ((1==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if ((DMCGeff==0.0))
                        {
                        }
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                      {
                        if (((DMCGeff+DMCIeff)==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                    {
                      if ((nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                      }
                    }
                    else
                      if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                      {
                        if (((DMCGeff+DMCIeff)==0.0))
                        {
                        }
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( GEOMOD == (3))
                {
                  if ((0==1))
                  {
                    if ((1==1))
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                      {
                        if ((nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                        }
                      }
                      else
                        if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    if ((0==1))
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                      {
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                        }
                      }
                      else
                        if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                      {
                        if ((nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                        }
                      }
                      else
                        if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                        {
                          if ((DMCGeff==0.0))
                          {
                          }
                          if ((nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                }
                else
                  if ( GEOMOD == (4))
                  {
                    if ((0==1))
                    {
                      if ((1==1))
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                          {
                            if (((DMCGeff+DMCIeff)==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                        {
                          if ((nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                          }
                        }
                        else
                          if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                          {
                            if (((DMCGeff+DMCIeff)==0.0))
                            {
                            }
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      Rend = (((model_.RSH)*DMDGeff)/Weff);
                    }
                  }
                  else
                    if ( GEOMOD == (5))
                    {
                      if ((0==1))
                      {
                        if ((1==1))
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                          {
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                            }
                          }
                          else
                            if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                            {
                              if ((DMCGeff==0.0))
                              {
                              }
                              if ((nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                          {
                            if ((nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
                            }
                          }
                          else
                            if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                            {
                              if ((DMCGeff==0.0))
                              {
                              }
                              if ((nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                      else
                      {
                        if ((nuEndD==0))
                        {
                          Rend = 0;
                        }
                        else
                        {
                          Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
                        }
                      }
                    }
                    else
                      if ( GEOMOD == (6))
                      {
                        if ((0==1))
                        {
                          Rend = (((model_.RSH)*DMDGeff)/Weff);
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                              {
                                if (((DMCGeff+DMCIeff)==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                            {
                              if ((nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                              }
                            }
                            else
                              if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                              {
                                if (((DMCGeff+DMCIeff)==0.0))
                                {
                                }
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( GEOMOD == (7))
                        {
                          if ((0==1))
                          {
                            if ((nuEndS==0))
                            {
                              Rend = 0;
                            }
                            else
                            {
                              Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
                            }
                          }
                          else
                          {
                            if ((0==1))
                            {
                              if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
                              {
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                                }
                              }
                              else
                                if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
                                {
                                  if ((DMCGeff==0.0))
                                  {
                                  }
                                  if ((nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                            else
                            {
                              if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
                              {
                                if ((nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
                                }
                              }
                              else
                                if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
                                {
                                  if ((DMCGeff==0.0))
                                  {
                                  }
                                  if ((nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                          }
                        }
                        else
                          if ( GEOMOD == (8))
                          {
                            Rend = (((model_.RSH)*DMDGeff)/Weff);
                          }
                          else
                            if ( GEOMOD == (9))
                            {
                              if ((0==1))
                              {
                                Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                                if ((NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                                Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                              }
                            }
                            else
                              if ( GEOMOD == (10))
                              {
                                if ((0==1))
                                {
                                  Rend = 0.0;
                                  Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
                                }
                                else
                                {
                                  Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
                                  if ((NF==2.0))
                                  {
                                    Rint = 0.0;
                                  }
                                  else
                                  {
                                    Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
                                  }
                                }
                              }
                              else
                              {
                                Rint = 0.0;
                              }
          if ((Rint<=0.0))
          {
            RDrainGeo = Rend;
          }
          else
          {
            if ((Rend<=0.0))
            {
              RDrainGeo = Rint;
            }
            else
            {
              RDrainGeo = ((Rint*Rend)/(Rint+Rend));
            }
          }
          if ((RDrainGeo==0.0))
          {
          }
        }
      }
      else
      {
        RDrainGeo = 0.0;
      }
    }
    if ((RSourceGeo<=1.0e-3))
    {
      RSourceGeo = 1.0e-3;
    }
    if ((RDrainGeo<=1.0e-3))
    {
      RDrainGeo = 1.0e-3;
    }
    if (((model_.RDSMOD)==1))
    {
      if ((RSWMIN_i<=0))
      {
        RSWMIN_i = 0;
      }
      if ((RDWMIN_i<=0))
      {
        RDWMIN_i = 0;
      }
      if ((RSW_i<=0))
      {
        RSW_i = 0;
      }
      if ((RDW_i<=0))
      {
        RDW_i = 0;
      }
    }
    else
    {
      if ((RDSWMIN_i<=0))
      {
        RDSWMIN_i = 0;
      }
      if ((RDSW_i<=0))
      {
        RDSW_i = 0;
      }
    }
    Grbsb = 0.0;
    Grbdb = 0.0;
    Grbpb = 0.0;
    Grbps = 0.0;
    Grbpd = 0.0;
    if ((RBODYMOD!=0))
    {
      Lnl = log((Leff*1.0e6));
      Lnw = log((Weff*1.0e6));
      Lnnf = log(static_cast<double>(NF));
      Bodymode = 5;
      Rbpb = RBPB;
      Rbpd = RBPD;
      Rbps = RBPS;
      Rbdb = RBDB;
      Rbsb = RBSB;
      if (((!(model_.given("RBPS0")))||(!(model_.given("RBPD0")))))
      {
        Bodymode = 1;
      }
      else
      {
        if ((((!(model_.given("RBSBX0")))&&(!(model_.given("RBSBY0"))))||((!(model_.given("RBDBX0")))&&(!(model_.given("RBDBY0"))))))
        {
          Bodymode = 3;
        }
      }
      if ((RBODYMOD==2))
      {
        if ((Bodymode==5))
        {
          Rbsbx = ((model_.RBSBX0)*exp(((((model_.RBSDBXL)*Lnl)+((model_.RBSDBXW)*Lnw))+((model_.RBSDBXNF)*Lnnf))));
          Rbsby = ((model_.RBSBY0)*exp(((((model_.RBSDBYL)*Lnl)+((model_.RBSDBYW)*Lnw))+((model_.RBSDBYNF)*Lnnf))));
          Rbsb = ((Rbsbx*Rbsby)/(Rbsbx+Rbsby));
          Rbdbx = ((model_.RBDBX0)*exp(((((model_.RBSDBXL)*Lnl)+((model_.RBSDBXW)*Lnw))+((model_.RBSDBXNF)*Lnnf))));
          Rbdby = ((model_.RBDBY0)*exp(((((model_.RBSDBYL)*Lnl)+((model_.RBSDBYW)*Lnw))+((model_.RBSDBYNF)*Lnnf))));
          Rbdb = ((Rbdbx*Rbdby)/(Rbdbx+Rbdby));
        }
        if (((Bodymode==3)||(Bodymode==5)))
        {
          Rbps = ((model_.RBPS0)*exp(((((model_.RBPSL)*Lnl)+((model_.RBPSW)*Lnw))+((model_.RBPSNF)*Lnnf))));
          Rbpd = ((model_.RBPD0)*exp(((((model_.RBPDL)*Lnl)+((model_.RBPDW)*Lnw))+((model_.RBPDNF)*Lnnf))));
        }
        Rbpbx = ((model_.RBPBX0)*exp(((((model_.RBPBXL)*Lnl)+((model_.RBPBXW)*Lnw))+((model_.RBPBXNF)*Lnnf))));
        Rbpby = ((model_.RBPBY0)*exp(((((model_.RBPBYL)*Lnl)+((model_.RBPBYW)*Lnw))+((model_.RBPBYNF)*Lnnf))));
        Rbpb = ((Rbpbx*Rbpby)/(Rbpbx+Rbpby));
      }
      if (((RBODYMOD==1)||((RBODYMOD==2)&&(Bodymode==5))))
      {
        if ((Rbdb<1.0e-3))
        {
          Grbdb = 1.0e3;
        }
        else
        {
          Grbdb = ((model_.GBMIN)+(1.0/Rbdb));
        }
        if ((Rbpb<1.0e-3))
        {
          Grbpb = 1.0e3;
        }
        else
        {
          Grbpb = ((model_.GBMIN)+(1.0/Rbpb));
        }
        if ((Rbps<1.0e-3))
        {
          Grbps = 1.0e3;
        }
        else
        {
          Grbps = ((model_.GBMIN)+(1.0/Rbps));
        }
        if ((Rbsb<1.0e-3))
        {
          Grbsb = 1.0e3;
        }
        else
        {
          Grbsb = ((model_.GBMIN)+(1.0/Rbsb));
        }
        if ((Rbpd<1.0e-3))
        {
          Grbpd = 1.0e3;
        }
        else
        {
          Grbpd = ((model_.GBMIN)+(1.0/Rbpd));
        }
      }
      else
      {
        if (((RBODYMOD==2)&&(Bodymode==3)))
        {
          Grbdb = (model_.GBMIN);
          Grbsb = (model_.GBMIN);
          if ((Rbpb<1.0e-3))
          {
            Grbpb = 1.0e3;
          }
          else
          {
            Grbpb = ((model_.GBMIN)+(1.0/Rbpb));
          }
          if ((Rbps<1.0e-3))
          {
            Grbps = 1.0e3;
          }
          else
          {
            Grbps = ((model_.GBMIN)+(1.0/Rbps));
          }
          if ((Rbpd<1.0e-3))
          {
            Grbpd = 1.0e3;
          }
          else
          {
            Grbpd = ((model_.GBMIN)+(1.0/Rbpd));
          }
        }
        else
        {
          if (((RBODYMOD==2)&&(Bodymode==1)))
          {
            Grbdb = (model_.GBMIN);
            Grbsb = (model_.GBMIN);
            Grbps = 1.0e3;
            Grbpd = 1.0e3;
            if ((Rbpb<1.0e-3))
            {
              Grbpb = 1.0e3;
            }
            else
            {
              Grbpb = ((model_.GBMIN)+(1.0/Rbpb));
            }
          }
        }
      }
    }
    Grgeltd = (((model_.RSHG)*(XGW+((Weffcj/3.0)/NGCON)))/((NGCON*NF)*(Lnew-(model_.XGL))));
    if ((Grgeltd>0.0))
    {
      Grgeltd = (1.0/Grgeltd);
    }
    else
    {
      Grgeltd = 1.0e3;
      if ((RGATEMOD!=0))
      {
      }
    }
    T0 = ((model_.TOXE)*(model_.TOXE));
    T1 = ((model_.TOXE)*POXEDGE_i);
    T2 = (T1*T1);
    ToxRatio = (exp((NTOX_i*log(((model_.TOXREF)/(model_.TOXE)))))/T0.val());
    ToxRatioEdge = (exp((NTOX_i*log(((model_.TOXREF)/T1.val()))))/T2.val());
    Aechvb = (((model_.TYPE)==1)?4.97232e-7:3.42537e-7);
    Bechvb = (((model_.TYPE)==1)?7.45669e11:1.16645e12);
    AechvbEdge = ((Aechvb*Weff)*ToxRatioEdge);
    BechvbEdge = (((-Bechvb)*(model_.TOXE))*POXEDGE_i);
    Aechvb = (Aechvb*((Weff*Leff)*ToxRatio));
    Bechvb = (Bechvb*(-(model_.TOXE)));
    if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
    {
      gth = ((((model_.WTH0)+Weff)*NF)/(model_.RTH0));
      cth = (((model_.CTH0)*((model_.WTH0)+Weff))*NF);
    }
    else
    {
      gth = 1.0;
      cth = 0.0;
    }
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(10*1.0e-6),
    W(10*1.0e-6),
    NF(1),
    NRS(1.0),
    NRD(1.0),
    VFBSDOFF(0.0),
    MINZ(0),
    XGW(0.0),
    NGCON(1),
    RGATEMOD(0),
    RBODYMOD(0),
    GEOMOD(0),
    RGEOMOD(0),
    RBPB(50.0),
    RBPD(50.0),
    RBPS(50.0),
    RBDB(50.0),
    RBSB(50.0),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    AS(0.0),
    AD(0.0),
    PS(0.0),
    PD(0.0),
    T0(0.0),
    T1(0.0),
    T2(0.0),
    epssi(0.0),
    epsox(0.0),
    Weff(0.0),
    Leff(0.0),
    Wact(0.0),
    Lact(0.0),
    Weffcj(0.0),
    Cox(0.0),
    epsratio(0.0),
    Lnew(0.0),
    L_mult(0.0),
    Wnew(0.0),
    DVTP0_i(0.0),
    DVTP1_i(0.0),
    DVTP2_i(0.0),
    DVTP3_i(0.0),
    DVTP4_i(0.0),
    DVTP5_i(0.0),
    A1_i(0.0),
    A11_i(0.0),
    A2_i(0.0),
    A21_i(0.0),
    PSAT_i(0.0),
    PSATR_i(0.0),
    devsign(0),
    BSIM6TOXP(0.0),
    DMCGeff(0.0),
    DMDGeff(0.0),
    DMCIeff(0.0),
    RSourceGeo(0.0),
    RDrainGeo(0.0),
    Grgeltd(0.0),
    Grbsb(0.0),
    Grbdb(0.0),
    Grbpb(0.0),
    Grbps(0.0),
    Grbpd(0.0),
    Aechvb(0.0),
    Bechvb(0.0),
    AechvbEdge(0.0),
    BechvbEdge(0.0),
    ToxRatio(0.0),
    U0R_t(0.0),
    UAR_t(0.0),
    UCR_t(0.0),
    UDR_t(0.0),
    UCSR_t(0.0),
    VSATR_t(0.0),
    PTWGR_t(0.0),
    ETA0R_t(0.0),
    PSATB_i(0.0),
    KT1_i(0.0),
    KT2_i(0.0),
    NGATE_i(0.0),
    NSD_i(0.0),
    NDEP_i(0.0),
    VFB_i(0.0),
    CIT_i(0.0),
    CDSCD_i(0.0),
    CDSCDR_i(0.0),
    CDSCB_i(0.0),
    NFACTOR_i(0.0),
    PHIN_i(0.0),
    ETA0_i(0.0),
    ETA0R_i(0.0),
    ETAB_i(0.0),
    K2_i(0.0),
    K1_i(0.0),
    DELTA_i(0.0),
    U0_i(0.0),
    U0R_i(0.0),
    VSAT_i(0.0),
    VSATR_i(0.0),
    VSATCV_i(0.0),
    UA_i(0.0),
    UAR_i(0.0),
    EU_i(0.0),
    UD_i(0.0),
    UDR_i(0.0),
    UD_a(0.0),
    UCS_i(0.0),
    UCSR_i(0.0),
    UC_i(0.0),
    UCR_i(0.0),
    PDIBLC_i(0.0),
    PDIBLCR_i(0.0),
    PDIBLCB_i(0.0),
    PSCBE1_i(0.0),
    PSCBE2_i(0.0),
    PDITS_i(0.0),
    PDITSD_i(0.0),
    FPROUT_i(0.0),
    PRWG_i(0.0),
    WR_i(0.0),
    RDWMIN_i(0.0),
    RSWMIN_i(0.0),
    RDW_i(0.0),
    RSW_i(0.0),
    RDSW_i(0.0),
    RDSWMIN_i(0.0),
    PTWG_i(0.0),
    PTWGR_i(0.0),
    PVAG_i(0.0),
    XJ_i(0.0),
    PCLM_i(0.0),
    PCLMR_i(0.0),
    PCLMCV_i(0.0),
    PRWB_i(0.0),
    CF_i(0.0),
    CGSL_i(0.0),
    CGDL_i(0.0),
    CKAPPAS_i(0.0),
    CKAPPAD_i(0.0),
    VFBCV_i(0.0),
    NDEPCV_i(0.0),
    ALPHA0_i(0.0),
    BETA0_i(0.0),
    AGIDL_i(0.0),
    BGIDL_i(0.0),
    CGIDL_i(0.0),
    EGIDL_i(0.0),
    AGISL_i(0.0),
    BGISL_i(0.0),
    CGISL_i(0.0),
    EGISL_i(0.0),
    UTE_i(0.0),
    UA1_i(0.0),
    UC1_i(0.0),
    UD1_i(0.0),
    UCSTE_i(0.0),
    PRT_i(0.0),
    AT_i(0.0),
    PTWGT_i(0.0),
    IIT_i(0.0),
    TGIDL_i(0.0),
    KVTH0WE_i(0.0),
    K2WE_i(0.0),
    KU0WE_i(0.0),
    AIGBINV_i(0.0),
    BIGBINV_i(0.0),
    CIGBINV_i(0.0),
    EIGBINV_i(0.0),
    NIGBINV_i(0.0),
    AIGBACC_i(0.0),
    BIGBACC_i(0.0),
    CIGBACC_i(0.0),
    NIGBACC_i(0.0),
    AIGC_i(0.0),
    BIGC_i(0.0),
    CIGC_i(0.0),
    AIGS_i(0.0),
    BIGS_i(0.0),
    CIGS_i(0.0),
    AIGD_i(0.0),
    BIGD_i(0.0),
    CIGD_i(0.0),
    PIGCD_i(0.0),
    DLCIG_i(0.0),
    DLCIGD_i(0.0),
    IGT_i(0.0),
    nuIntD(0.0),
    nuEndD(0.0),
    nuIntS(0.0),
    nuEndS(0.0),
    gth(0.0),
    cth(0.0),
    li_d(-1),
    li_g(-1),
    li_s(-1),
    li_b(-1),
    li_di(-1),
    li_si(-1),
    li_gi(-1),
    li_gm(-1),
    li_bi(-1),
    li_sbulk(-1),
    li_dbulk(-1),
    li_N1(-1),
    li_N2(-1),
    li_t(-1),
    li_branch_id(-1),
    li_branch_ig(-1),
    li_branch_is(-1),
    li_branch_ib(-1),
    f_di_Equ_t_Node_Ptr(0),
    f_si_Equ_t_Node_Ptr(0),
    f_di_Equ_si_Node_Ptr(0),
    f_di_Equ_bi_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_bi_Node_Ptr(0),
    f_di_Equ_di_Node_Ptr(0),
    f_si_Equ_di_Node_Ptr(0),
    f_di_Equ_gi_Node_Ptr(0),
    f_si_Equ_gi_Node_Ptr(0),
    f_di_Equ_sbulk_Node_Ptr(0),
    f_si_Equ_sbulk_Node_Ptr(0),
    f_di_Equ_dbulk_Node_Ptr(0),
    f_si_Equ_dbulk_Node_Ptr(0),
    f_N2_Equ_sbulk_Node_Ptr(0),
    f_N2_Equ_si_Node_Ptr(0),
    f_N2_Equ_dbulk_Node_Ptr(0),
    f_N2_Equ_di_Node_Ptr(0),
    f_N2_Equ_t_Node_Ptr(0),
    f_N2_Equ_bi_Node_Ptr(0),
    f_N2_Equ_gi_Node_Ptr(0),
    f_N1_Equ_sbulk_Node_Ptr(0),
    f_N1_Equ_si_Node_Ptr(0),
    f_N1_Equ_dbulk_Node_Ptr(0),
    f_N1_Equ_di_Node_Ptr(0),
    f_N1_Equ_bi_Node_Ptr(0),
    f_N1_Equ_gi_Node_Ptr(0),
    f_N1_Equ_t_Node_Ptr(0),
    f_N1_Equ_N2_Node_Ptr(0),
    f_N1_Equ_N1_Node_Ptr(0),
    f_di_Equ_N2_Node_Ptr(0),
    f_si_Equ_N2_Node_Ptr(0),
    f_gi_Equ_N1_Node_Ptr(0),
    f_si_Equ_N1_Node_Ptr(0),
    f_gi_Equ_sbulk_Node_Ptr(0),
    f_gi_Equ_si_Node_Ptr(0),
    f_gi_Equ_dbulk_Node_Ptr(0),
    f_gi_Equ_di_Node_Ptr(0),
    f_gi_Equ_t_Node_Ptr(0),
    f_gi_Equ_bi_Node_Ptr(0),
    f_gi_Equ_gi_Node_Ptr(0),
    f_di_Equ_N1_Node_Ptr(0),
    f_N2_Equ_N2_Node_Ptr(0),
    f_bi_Equ_t_Node_Ptr(0),
    f_bi_Equ_si_Node_Ptr(0),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_di_Node_Ptr(0),
    f_bi_Equ_gi_Node_Ptr(0),
    f_bi_Equ_sbulk_Node_Ptr(0),
    f_bi_Equ_dbulk_Node_Ptr(0),
    f_gm_Equ_gm_Node_Ptr(0),
    f_gm_Equ_si_Node_Ptr(0),
    f_si_Equ_gm_Node_Ptr(0),
    f_gm_Equ_bi_Node_Ptr(0),
    f_gm_Equ_di_Node_Ptr(0),
    f_gm_Equ_gi_Node_Ptr(0),
    f_gm_Equ_sbulk_Node_Ptr(0),
    f_gm_Equ_dbulk_Node_Ptr(0),
    f_gm_Equ_t_Node_Ptr(0),
    f_di_Equ_gm_Node_Ptr(0),
    f_bi_Equ_gm_Node_Ptr(0),
    f_d_Equ_si_Node_Ptr(0),
    f_d_Equ_bi_Node_Ptr(0),
    f_d_Equ_di_Node_Ptr(0),
    f_d_Equ_gi_Node_Ptr(0),
    f_d_Equ_t_Node_Ptr(0),
    f_d_Equ_d_Node_Ptr(0),
    f_di_Equ_d_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_s_Equ_bi_Node_Ptr(0),
    f_s_Equ_di_Node_Ptr(0),
    f_s_Equ_gi_Node_Ptr(0),
    f_s_Equ_t_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_g_Equ_t_Node_Ptr(0),
    f_g_Equ_si_Node_Ptr(0),
    f_g_Equ_bi_Node_Ptr(0),
    f_g_Equ_di_Node_Ptr(0),
    f_g_Equ_gi_Node_Ptr(0),
    f_g_Equ_g_Node_Ptr(0),
    f_g_Equ_gm_Node_Ptr(0),
    f_gm_Equ_g_Node_Ptr(0),
    f_gi_Equ_gm_Node_Ptr(0),
    f_t_Equ_s_Node_Ptr(0),
    f_t_Equ_si_Node_Ptr(0),
    f_t_Equ_d_Node_Ptr(0),
    f_t_Equ_di_Node_Ptr(0),
    f_t_Equ_bi_Node_Ptr(0),
    f_t_Equ_t_Node_Ptr(0),
    f_t_Equ_gi_Node_Ptr(0),
    f_t_Equ_sbulk_Node_Ptr(0),
    f_t_Equ_dbulk_Node_Ptr(0),
    f_t_Equ_gm_Node_Ptr(0),
    f_sbulk_Equ_bi_Node_Ptr(0),
    f_sbulk_Equ_sbulk_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_b_Equ_sbulk_Node_Ptr(0),
    f_sbulk_Equ_b_Node_Ptr(0),
    f_b_Equ_bi_Node_Ptr(0),
    f_bi_Equ_b_Node_Ptr(0),
    f_b_Equ_dbulk_Node_Ptr(0),
    f_dbulk_Equ_b_Node_Ptr(0),
    f_dbulk_Equ_dbulk_Node_Ptr(0),
    f_dbulk_Equ_bi_Node_Ptr(0),
    f_sbulk_Equ_t_Node_Ptr(0),
    f_b_Equ_t_Node_Ptr(0),
    f_dbulk_Equ_t_Node_Ptr(0),
    f_sbulk_Equ_si_Node_Ptr(0),
    f_sbulk_Equ_di_Node_Ptr(0),
    f_sbulk_Equ_gi_Node_Ptr(0),
    f_dbulk_Equ_si_Node_Ptr(0),
    f_dbulk_Equ_di_Node_Ptr(0),
    f_dbulk_Equ_gi_Node_Ptr(0),
    f_dbulk_Equ_sbulk_Node_Ptr(0),
    f_sbulk_Equ_dbulk_Node_Ptr(0),
    q_di_Equ_t_Node_Ptr(0),
    q_si_Equ_t_Node_Ptr(0),
    q_di_Equ_si_Node_Ptr(0),
    q_di_Equ_bi_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_bi_Node_Ptr(0),
    q_di_Equ_di_Node_Ptr(0),
    q_si_Equ_di_Node_Ptr(0),
    q_di_Equ_gi_Node_Ptr(0),
    q_si_Equ_gi_Node_Ptr(0),
    q_di_Equ_sbulk_Node_Ptr(0),
    q_si_Equ_sbulk_Node_Ptr(0),
    q_di_Equ_dbulk_Node_Ptr(0),
    q_si_Equ_dbulk_Node_Ptr(0),
    q_N2_Equ_sbulk_Node_Ptr(0),
    q_N2_Equ_si_Node_Ptr(0),
    q_N2_Equ_dbulk_Node_Ptr(0),
    q_N2_Equ_di_Node_Ptr(0),
    q_N2_Equ_t_Node_Ptr(0),
    q_N2_Equ_bi_Node_Ptr(0),
    q_N2_Equ_gi_Node_Ptr(0),
    q_N1_Equ_sbulk_Node_Ptr(0),
    q_N1_Equ_si_Node_Ptr(0),
    q_N1_Equ_dbulk_Node_Ptr(0),
    q_N1_Equ_di_Node_Ptr(0),
    q_N1_Equ_bi_Node_Ptr(0),
    q_N1_Equ_gi_Node_Ptr(0),
    q_N1_Equ_t_Node_Ptr(0),
    q_N1_Equ_N2_Node_Ptr(0),
    q_N1_Equ_N1_Node_Ptr(0),
    q_di_Equ_N2_Node_Ptr(0),
    q_si_Equ_N2_Node_Ptr(0),
    q_gi_Equ_N1_Node_Ptr(0),
    q_si_Equ_N1_Node_Ptr(0),
    q_gi_Equ_sbulk_Node_Ptr(0),
    q_gi_Equ_si_Node_Ptr(0),
    q_gi_Equ_dbulk_Node_Ptr(0),
    q_gi_Equ_di_Node_Ptr(0),
    q_gi_Equ_t_Node_Ptr(0),
    q_gi_Equ_bi_Node_Ptr(0),
    q_gi_Equ_gi_Node_Ptr(0),
    q_di_Equ_N1_Node_Ptr(0),
    q_N2_Equ_N2_Node_Ptr(0),
    q_bi_Equ_t_Node_Ptr(0),
    q_bi_Equ_si_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_di_Node_Ptr(0),
    q_bi_Equ_gi_Node_Ptr(0),
    q_bi_Equ_sbulk_Node_Ptr(0),
    q_bi_Equ_dbulk_Node_Ptr(0),
    q_gm_Equ_gm_Node_Ptr(0),
    q_gm_Equ_si_Node_Ptr(0),
    q_si_Equ_gm_Node_Ptr(0),
    q_gm_Equ_bi_Node_Ptr(0),
    q_gm_Equ_di_Node_Ptr(0),
    q_gm_Equ_gi_Node_Ptr(0),
    q_gm_Equ_sbulk_Node_Ptr(0),
    q_gm_Equ_dbulk_Node_Ptr(0),
    q_gm_Equ_t_Node_Ptr(0),
    q_di_Equ_gm_Node_Ptr(0),
    q_bi_Equ_gm_Node_Ptr(0),
    q_d_Equ_si_Node_Ptr(0),
    q_d_Equ_bi_Node_Ptr(0),
    q_d_Equ_di_Node_Ptr(0),
    q_d_Equ_gi_Node_Ptr(0),
    q_d_Equ_t_Node_Ptr(0),
    q_d_Equ_d_Node_Ptr(0),
    q_di_Equ_d_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_s_Equ_bi_Node_Ptr(0),
    q_s_Equ_di_Node_Ptr(0),
    q_s_Equ_gi_Node_Ptr(0),
    q_s_Equ_t_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_g_Equ_t_Node_Ptr(0),
    q_g_Equ_si_Node_Ptr(0),
    q_g_Equ_bi_Node_Ptr(0),
    q_g_Equ_di_Node_Ptr(0),
    q_g_Equ_gi_Node_Ptr(0),
    q_g_Equ_g_Node_Ptr(0),
    q_g_Equ_gm_Node_Ptr(0),
    q_gm_Equ_g_Node_Ptr(0),
    q_gi_Equ_gm_Node_Ptr(0),
    q_t_Equ_s_Node_Ptr(0),
    q_t_Equ_si_Node_Ptr(0),
    q_t_Equ_d_Node_Ptr(0),
    q_t_Equ_di_Node_Ptr(0),
    q_t_Equ_bi_Node_Ptr(0),
    q_t_Equ_t_Node_Ptr(0),
    q_t_Equ_gi_Node_Ptr(0),
    q_t_Equ_sbulk_Node_Ptr(0),
    q_t_Equ_dbulk_Node_Ptr(0),
    q_t_Equ_gm_Node_Ptr(0),
    q_sbulk_Equ_bi_Node_Ptr(0),
    q_sbulk_Equ_sbulk_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_b_Equ_sbulk_Node_Ptr(0),
    q_sbulk_Equ_b_Node_Ptr(0),
    q_b_Equ_bi_Node_Ptr(0),
    q_bi_Equ_b_Node_Ptr(0),
    q_b_Equ_dbulk_Node_Ptr(0),
    q_dbulk_Equ_b_Node_Ptr(0),
    q_dbulk_Equ_dbulk_Node_Ptr(0),
    q_dbulk_Equ_bi_Node_Ptr(0),
    q_sbulk_Equ_t_Node_Ptr(0),
    q_b_Equ_t_Node_Ptr(0),
    q_dbulk_Equ_t_Node_Ptr(0),
    q_sbulk_Equ_si_Node_Ptr(0),
    q_sbulk_Equ_di_Node_Ptr(0),
    q_sbulk_Equ_gi_Node_Ptr(0),
    q_dbulk_Equ_si_Node_Ptr(0),
    q_dbulk_Equ_di_Node_Ptr(0),
    q_dbulk_Equ_gi_Node_Ptr(0),
    q_dbulk_Equ_sbulk_Node_Ptr(0),
    q_sbulk_Equ_dbulk_Node_Ptr(0),
    A_di_Equ_t_NodeOffset(-1),
    A_si_Equ_t_NodeOffset(-1),
    A_di_Equ_si_NodeOffset(-1),
    A_di_Equ_bi_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_bi_NodeOffset(-1),
    A_di_Equ_di_NodeOffset(-1),
    A_si_Equ_di_NodeOffset(-1),
    A_di_Equ_gi_NodeOffset(-1),
    A_si_Equ_gi_NodeOffset(-1),
    A_di_Equ_sbulk_NodeOffset(-1),
    A_si_Equ_sbulk_NodeOffset(-1),
    A_di_Equ_dbulk_NodeOffset(-1),
    A_si_Equ_dbulk_NodeOffset(-1),
    A_N2_Equ_sbulk_NodeOffset(-1),
    A_N2_Equ_si_NodeOffset(-1),
    A_N2_Equ_dbulk_NodeOffset(-1),
    A_N2_Equ_di_NodeOffset(-1),
    A_N2_Equ_t_NodeOffset(-1),
    A_N2_Equ_bi_NodeOffset(-1),
    A_N2_Equ_gi_NodeOffset(-1),
    A_N1_Equ_sbulk_NodeOffset(-1),
    A_N1_Equ_si_NodeOffset(-1),
    A_N1_Equ_dbulk_NodeOffset(-1),
    A_N1_Equ_di_NodeOffset(-1),
    A_N1_Equ_bi_NodeOffset(-1),
    A_N1_Equ_gi_NodeOffset(-1),
    A_N1_Equ_t_NodeOffset(-1),
    A_N1_Equ_N2_NodeOffset(-1),
    A_N1_Equ_N1_NodeOffset(-1),
    A_di_Equ_N2_NodeOffset(-1),
    A_si_Equ_N2_NodeOffset(-1),
    A_gi_Equ_N1_NodeOffset(-1),
    A_si_Equ_N1_NodeOffset(-1),
    A_gi_Equ_sbulk_NodeOffset(-1),
    A_gi_Equ_si_NodeOffset(-1),
    A_gi_Equ_dbulk_NodeOffset(-1),
    A_gi_Equ_di_NodeOffset(-1),
    A_gi_Equ_t_NodeOffset(-1),
    A_gi_Equ_bi_NodeOffset(-1),
    A_gi_Equ_gi_NodeOffset(-1),
    A_di_Equ_N1_NodeOffset(-1),
    A_N2_Equ_N2_NodeOffset(-1),
    A_bi_Equ_t_NodeOffset(-1),
    A_bi_Equ_si_NodeOffset(-1),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_di_NodeOffset(-1),
    A_bi_Equ_gi_NodeOffset(-1),
    A_bi_Equ_sbulk_NodeOffset(-1),
    A_bi_Equ_dbulk_NodeOffset(-1),
    A_gm_Equ_gm_NodeOffset(-1),
    A_gm_Equ_si_NodeOffset(-1),
    A_si_Equ_gm_NodeOffset(-1),
    A_gm_Equ_bi_NodeOffset(-1),
    A_gm_Equ_di_NodeOffset(-1),
    A_gm_Equ_gi_NodeOffset(-1),
    A_gm_Equ_sbulk_NodeOffset(-1),
    A_gm_Equ_dbulk_NodeOffset(-1),
    A_gm_Equ_t_NodeOffset(-1),
    A_di_Equ_gm_NodeOffset(-1),
    A_bi_Equ_gm_NodeOffset(-1),
    A_d_Equ_si_NodeOffset(-1),
    A_d_Equ_bi_NodeOffset(-1),
    A_d_Equ_di_NodeOffset(-1),
    A_d_Equ_gi_NodeOffset(-1),
    A_d_Equ_t_NodeOffset(-1),
    A_d_Equ_d_NodeOffset(-1),
    A_di_Equ_d_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_s_Equ_bi_NodeOffset(-1),
    A_s_Equ_di_NodeOffset(-1),
    A_s_Equ_gi_NodeOffset(-1),
    A_s_Equ_t_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_g_Equ_t_NodeOffset(-1),
    A_g_Equ_si_NodeOffset(-1),
    A_g_Equ_bi_NodeOffset(-1),
    A_g_Equ_di_NodeOffset(-1),
    A_g_Equ_gi_NodeOffset(-1),
    A_g_Equ_g_NodeOffset(-1),
    A_g_Equ_gm_NodeOffset(-1),
    A_gm_Equ_g_NodeOffset(-1),
    A_gi_Equ_gm_NodeOffset(-1),
    A_t_Equ_s_NodeOffset(-1),
    A_t_Equ_si_NodeOffset(-1),
    A_t_Equ_d_NodeOffset(-1),
    A_t_Equ_di_NodeOffset(-1),
    A_t_Equ_bi_NodeOffset(-1),
    A_t_Equ_t_NodeOffset(-1),
    A_t_Equ_gi_NodeOffset(-1),
    A_t_Equ_sbulk_NodeOffset(-1),
    A_t_Equ_dbulk_NodeOffset(-1),
    A_t_Equ_gm_NodeOffset(-1),
    A_sbulk_Equ_bi_NodeOffset(-1),
    A_sbulk_Equ_sbulk_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_b_Equ_sbulk_NodeOffset(-1),
    A_sbulk_Equ_b_NodeOffset(-1),
    A_b_Equ_bi_NodeOffset(-1),
    A_bi_Equ_b_NodeOffset(-1),
    A_b_Equ_dbulk_NodeOffset(-1),
    A_dbulk_Equ_b_NodeOffset(-1),
    A_dbulk_Equ_dbulk_NodeOffset(-1),
    A_dbulk_Equ_bi_NodeOffset(-1),
    A_sbulk_Equ_t_NodeOffset(-1),
    A_b_Equ_t_NodeOffset(-1),
    A_dbulk_Equ_t_NodeOffset(-1),
    A_sbulk_Equ_si_NodeOffset(-1),
    A_sbulk_Equ_di_NodeOffset(-1),
    A_sbulk_Equ_gi_NodeOffset(-1),
    A_dbulk_Equ_si_NodeOffset(-1),
    A_dbulk_Equ_di_NodeOffset(-1),
    A_dbulk_Equ_gi_NodeOffset(-1),
    A_dbulk_Equ_sbulk_NodeOffset(-1),
    A_sbulk_Equ_dbulk_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 10 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_gm));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_N2));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_N1));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_gm));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_N2));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_N1));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_gm));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_N1));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_gm));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_gm));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_gm));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_N2));
  jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_N1));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_N2));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_t));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_sbulk));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_dbulk));
  jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_gm));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_di)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_di,admsNodeID_d));
  }
  if (collapseNode_si)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  }
  if (collapseNode_gi)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_gi,admsNodeID_gm));
  }
  if (collapseNode_gm)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_gm,admsNodeID_g));
  }
  if (collapseNode_bi)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_bi,admsNodeID_b));
  }
  if (collapseNode_sbulk)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_sbulk,admsNodeID_b));
  }
  if (collapseNode_dbulk)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_dbulk,admsNodeID_b));
  }
  if (collapseNode_t)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_t,admsNodeID_GND));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 14+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_di = false;
  collapseNode_si = false;
  collapseNode_gi = false;
  collapseNode_gm = false;
  collapseNode_bi = false;
  collapseNode_sbulk = false;
  collapseNode_dbulk = false;
  collapseNode_t = false;
  if (!(((model_.RDSMOD)!=2)))
  {

    collapseNode_di = true;

    collapseNode_si = true;

  }

  if ((RGATEMOD==0))
  {

    collapseNode_gm = true;

  }

  if (!((RGATEMOD==3)))
  {

    collapseNode_gi = true;

  }

  if (!((((model_.SHMOD)!=0)&&((model_.RTH0)>0))))
  {

    collapseNode_t = true;

  }

  if (!((RBODYMOD!=0)))
  {

    collapseNode_sbulk = true;

    collapseNode_bi = true;

    collapseNode_dbulk = true;

  }


  if (collapseNode_di)
  {
    numIntVars--;
  }
  if (collapseNode_si)
  {
    numIntVars--;
  }
  if (collapseNode_gi)
  {
    numIntVars--;
  }
  if (collapseNode_gm)
  {
    numIntVars--;
  }
  if (collapseNode_bi)
  {
    numIntVars--;
  }
  if (collapseNode_sbulk)
  {
    numIntVars--;
  }
  if (collapseNode_dbulk)
  {
    numIntVars--;
  }
  if (collapseNode_t)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbsim6::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_d = localLIDVec[nodeMap[admsNodeID_d]];
  li_g = localLIDVec[nodeMap[admsNodeID_g]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_di = localLIDVec[nodeMap[admsNodeID_di]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_gi = localLIDVec[nodeMap[admsNodeID_gi]];
  li_gm = localLIDVec[nodeMap[admsNodeID_gm]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_sbulk = localLIDVec[nodeMap[admsNodeID_sbulk]];
  li_dbulk = localLIDVec[nodeMap[admsNodeID_dbulk]];
  li_N1 = localLIDVec[nodeMap[admsNodeID_N1]];
  li_N2 = localLIDVec[nodeMap[admsNodeID_N2]];
  if (collapseNode_t)
  {
    li_t = -1;
  }
  else
  {
    li_t = localLIDVec[nodeMap[admsNodeID_t]];
  }


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_d = " << li_d << std::endl;
    Xyce::dout() << "\nli_g = " << li_g << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_di = " << li_di << std::endl;
    Xyce::dout() << "\nli_si = " << li_si << std::endl;
    Xyce::dout() << "\nli_gi = " << li_gi << std::endl;
    Xyce::dout() << "\nli_gm = " << li_gm << std::endl;
    Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
    Xyce::dout() << "\nli_sbulk = " << li_sbulk << std::endl;
    Xyce::dout() << "\nli_dbulk = " << li_dbulk << std::endl;
    Xyce::dout() << "\nli_N1 = " << li_N1 << std::endl;
    Xyce::dout() << "\nli_N2 = " << li_N2 << std::endl;
    Xyce::dout() << "\nli_t = " << li_t << std::endl;

    Xyce::dout() << "\nEnd of ADMSbsim6::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  if (!collapseNode_di)
  {
    addInternalNode(symbol_table, li_di, getName(), "di");
  }
  if (!collapseNode_si)
  {
    addInternalNode(symbol_table, li_si, getName(), "si");
  }
  if (!collapseNode_gi)
  {
    addInternalNode(symbol_table, li_gi, getName(), "gi");
  }
  if (!collapseNode_gm)
  {
    addInternalNode(symbol_table, li_gm, getName(), "gm");
  }
  if (!collapseNode_bi)
  {
    addInternalNode(symbol_table, li_bi, getName(), "bi");
  }
  if (!collapseNode_sbulk)
  {
    addInternalNode(symbol_table, li_sbulk, getName(), "sbulk");
  }
  if (!collapseNode_dbulk)
  {
    addInternalNode(symbol_table, li_dbulk, getName(), "dbulk");
  }
  addInternalNode(symbol_table, li_N1, getName(), "N1");
  addInternalNode(symbol_table, li_N2, getName(), "N2");
  if (!collapseNode_t)
  {
    addInternalNode(symbol_table, li_t, getName(), "t");
  }

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_id, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_ig, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_D4");
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_id = branchLIDVecRef[i++];
    li_branch_ig = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_si)];
  A_d_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_bi)];
  A_d_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_di)];
  A_d_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_gi)];
  A_d_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_t)];
    A_d_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_d)];
  A_d_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_t)];
    A_g_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_si)];
  A_g_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_bi)];
  A_g_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_di)];
  A_g_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_gi)];
  A_g_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_g)];
  A_g_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_gm)];
  A_g_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
  A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bi)];
  A_s_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_di)];
  A_s_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_gi)];
  A_s_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_t)];
    A_s_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_sbulk)];
  A_b_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bi)];
  A_b_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dbulk)];
  A_b_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_t)];
    A_b_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_t)];
    A_di_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_si)];
  A_di_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_bi)];
  A_di_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_di)];
  A_di_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_gi)];
  A_di_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_sbulk)];
  A_di_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_dbulk)];
  A_di_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_N2)];
  A_di_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_N1)];
  A_di_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_gm)];
  A_di_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_d)];
  A_di_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_t)];
    A_si_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
  A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bi)];
  A_si_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_di)];
  A_si_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_gi)];
  A_si_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_sbulk)];
  A_si_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_dbulk)];
  A_si_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_N2)];
  A_si_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_N1)];
  A_si_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_gm)];
  A_si_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
  A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_N1)];
  A_gi_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_sbulk)];
  A_gi_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_si)];
  A_gi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_dbulk)];
  A_gi_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_di)];
  A_gi_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_t)];
    A_gi_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_bi)];
  A_gi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_gi)];
  A_gi_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_gm)];
  A_gi_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_gm)];
  A_gm_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_si)];
  A_gm_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_bi)];
  A_gm_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_di)];
  A_gm_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_gi)];
  A_gm_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_sbulk)];
  A_gm_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_dbulk)];
  A_gm_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_t)];
    A_gm_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_g)];
  A_gm_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_t)];
    A_bi_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_si)];
  A_bi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
  A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_di)];
  A_bi_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_gi)];
  A_bi_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_sbulk)];
  A_bi_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_dbulk)];
  A_bi_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_gm)];
  A_bi_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_b)];
  A_bi_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_bi)];
  A_sbulk_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_sbulk)];
  A_sbulk_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_b)];
  A_sbulk_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_t)];
    A_sbulk_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_si)];
  A_sbulk_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_di)];
  A_sbulk_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_gi)];
  A_sbulk_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_dbulk)];
  A_sbulk_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_b)];
  A_dbulk_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_dbulk)];
  A_dbulk_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_bi)];
  A_dbulk_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_t)];
    A_dbulk_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_si)];
  A_dbulk_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_di)];
  A_dbulk_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_gi)];
  A_dbulk_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_sbulk)];
  A_dbulk_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_sbulk)];
  A_N1_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_si)];
  A_N1_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_dbulk)];
  A_N1_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_di)];
  A_N1_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_bi)];
  A_N1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_gi)];
  A_N1_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_t)];
    A_N1_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_N2)];
  A_N1_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_N1)];
  A_N1_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_sbulk)];
  A_N2_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_si)];
  A_N2_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_dbulk)];
  A_N2_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_di)];
  A_N2_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_t)];
    A_N2_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_bi)];
  A_N2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_gi)];
  A_N2_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_N2)];
  A_N2_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_s)];
    A_t_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_si)];
    A_t_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_d)];
    A_t_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_di)];
    A_t_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_bi)];
    A_t_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_t)];
    A_t_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_gi)];
    A_t_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_sbulk)];
    A_t_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_dbulk)];
    A_t_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_t)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_gm)];
    A_t_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
  f_d_Equ_si_Node_Ptr = &(dFdx[li_d][A_d_Equ_si_NodeOffset]);
  q_d_Equ_si_Node_Ptr = &(dQdx[li_d][A_d_Equ_si_NodeOffset]);
  f_d_Equ_bi_Node_Ptr = &(dFdx[li_d][A_d_Equ_bi_NodeOffset]);
  q_d_Equ_bi_Node_Ptr = &(dQdx[li_d][A_d_Equ_bi_NodeOffset]);
  f_d_Equ_di_Node_Ptr = &(dFdx[li_d][A_d_Equ_di_NodeOffset]);
  q_d_Equ_di_Node_Ptr = &(dQdx[li_d][A_d_Equ_di_NodeOffset]);
  f_d_Equ_gi_Node_Ptr = &(dFdx[li_d][A_d_Equ_gi_NodeOffset]);
  q_d_Equ_gi_Node_Ptr = &(dQdx[li_d][A_d_Equ_gi_NodeOffset]);
  if (!collapseNode_t)
  {
    f_d_Equ_t_Node_Ptr = &(dFdx[li_d][A_d_Equ_t_NodeOffset]);
    q_d_Equ_t_Node_Ptr = &(dQdx[li_d][A_d_Equ_t_NodeOffset]);
  }
  f_d_Equ_d_Node_Ptr = &(dFdx[li_d][A_d_Equ_d_NodeOffset]);
  q_d_Equ_d_Node_Ptr = &(dQdx[li_d][A_d_Equ_d_NodeOffset]);
  if (!collapseNode_t)
  {
    f_g_Equ_t_Node_Ptr = &(dFdx[li_g][A_g_Equ_t_NodeOffset]);
    q_g_Equ_t_Node_Ptr = &(dQdx[li_g][A_g_Equ_t_NodeOffset]);
  }
  f_g_Equ_si_Node_Ptr = &(dFdx[li_g][A_g_Equ_si_NodeOffset]);
  q_g_Equ_si_Node_Ptr = &(dQdx[li_g][A_g_Equ_si_NodeOffset]);
  f_g_Equ_bi_Node_Ptr = &(dFdx[li_g][A_g_Equ_bi_NodeOffset]);
  q_g_Equ_bi_Node_Ptr = &(dQdx[li_g][A_g_Equ_bi_NodeOffset]);
  f_g_Equ_di_Node_Ptr = &(dFdx[li_g][A_g_Equ_di_NodeOffset]);
  q_g_Equ_di_Node_Ptr = &(dQdx[li_g][A_g_Equ_di_NodeOffset]);
  f_g_Equ_gi_Node_Ptr = &(dFdx[li_g][A_g_Equ_gi_NodeOffset]);
  q_g_Equ_gi_Node_Ptr = &(dQdx[li_g][A_g_Equ_gi_NodeOffset]);
  f_g_Equ_g_Node_Ptr = &(dFdx[li_g][A_g_Equ_g_NodeOffset]);
  q_g_Equ_g_Node_Ptr = &(dQdx[li_g][A_g_Equ_g_NodeOffset]);
  f_g_Equ_gm_Node_Ptr = &(dFdx[li_g][A_g_Equ_gm_NodeOffset]);
  q_g_Equ_gm_Node_Ptr = &(dQdx[li_g][A_g_Equ_gm_NodeOffset]);
  f_s_Equ_si_Node_Ptr = &(dFdx[li_s][A_s_Equ_si_NodeOffset]);
  q_s_Equ_si_Node_Ptr = &(dQdx[li_s][A_s_Equ_si_NodeOffset]);
  f_s_Equ_bi_Node_Ptr = &(dFdx[li_s][A_s_Equ_bi_NodeOffset]);
  q_s_Equ_bi_Node_Ptr = &(dQdx[li_s][A_s_Equ_bi_NodeOffset]);
  f_s_Equ_di_Node_Ptr = &(dFdx[li_s][A_s_Equ_di_NodeOffset]);
  q_s_Equ_di_Node_Ptr = &(dQdx[li_s][A_s_Equ_di_NodeOffset]);
  f_s_Equ_gi_Node_Ptr = &(dFdx[li_s][A_s_Equ_gi_NodeOffset]);
  q_s_Equ_gi_Node_Ptr = &(dQdx[li_s][A_s_Equ_gi_NodeOffset]);
  if (!collapseNode_t)
  {
    f_s_Equ_t_Node_Ptr = &(dFdx[li_s][A_s_Equ_t_NodeOffset]);
    q_s_Equ_t_Node_Ptr = &(dQdx[li_s][A_s_Equ_t_NodeOffset]);
  }
  f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
  q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
  f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
  q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
  f_b_Equ_sbulk_Node_Ptr = &(dFdx[li_b][A_b_Equ_sbulk_NodeOffset]);
  q_b_Equ_sbulk_Node_Ptr = &(dQdx[li_b][A_b_Equ_sbulk_NodeOffset]);
  f_b_Equ_bi_Node_Ptr = &(dFdx[li_b][A_b_Equ_bi_NodeOffset]);
  q_b_Equ_bi_Node_Ptr = &(dQdx[li_b][A_b_Equ_bi_NodeOffset]);
  f_b_Equ_dbulk_Node_Ptr = &(dFdx[li_b][A_b_Equ_dbulk_NodeOffset]);
  q_b_Equ_dbulk_Node_Ptr = &(dQdx[li_b][A_b_Equ_dbulk_NodeOffset]);
  if (!collapseNode_t)
  {
    f_b_Equ_t_Node_Ptr = &(dFdx[li_b][A_b_Equ_t_NodeOffset]);
    q_b_Equ_t_Node_Ptr = &(dQdx[li_b][A_b_Equ_t_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_di_Equ_t_Node_Ptr = &(dFdx[li_di][A_di_Equ_t_NodeOffset]);
    q_di_Equ_t_Node_Ptr = &(dQdx[li_di][A_di_Equ_t_NodeOffset]);
  }
  f_di_Equ_si_Node_Ptr = &(dFdx[li_di][A_di_Equ_si_NodeOffset]);
  q_di_Equ_si_Node_Ptr = &(dQdx[li_di][A_di_Equ_si_NodeOffset]);
  f_di_Equ_bi_Node_Ptr = &(dFdx[li_di][A_di_Equ_bi_NodeOffset]);
  q_di_Equ_bi_Node_Ptr = &(dQdx[li_di][A_di_Equ_bi_NodeOffset]);
  f_di_Equ_di_Node_Ptr = &(dFdx[li_di][A_di_Equ_di_NodeOffset]);
  q_di_Equ_di_Node_Ptr = &(dQdx[li_di][A_di_Equ_di_NodeOffset]);
  f_di_Equ_gi_Node_Ptr = &(dFdx[li_di][A_di_Equ_gi_NodeOffset]);
  q_di_Equ_gi_Node_Ptr = &(dQdx[li_di][A_di_Equ_gi_NodeOffset]);
  f_di_Equ_sbulk_Node_Ptr = &(dFdx[li_di][A_di_Equ_sbulk_NodeOffset]);
  q_di_Equ_sbulk_Node_Ptr = &(dQdx[li_di][A_di_Equ_sbulk_NodeOffset]);
  f_di_Equ_dbulk_Node_Ptr = &(dFdx[li_di][A_di_Equ_dbulk_NodeOffset]);
  q_di_Equ_dbulk_Node_Ptr = &(dQdx[li_di][A_di_Equ_dbulk_NodeOffset]);
  f_di_Equ_N2_Node_Ptr = &(dFdx[li_di][A_di_Equ_N2_NodeOffset]);
  q_di_Equ_N2_Node_Ptr = &(dQdx[li_di][A_di_Equ_N2_NodeOffset]);
  f_di_Equ_N1_Node_Ptr = &(dFdx[li_di][A_di_Equ_N1_NodeOffset]);
  q_di_Equ_N1_Node_Ptr = &(dQdx[li_di][A_di_Equ_N1_NodeOffset]);
  f_di_Equ_gm_Node_Ptr = &(dFdx[li_di][A_di_Equ_gm_NodeOffset]);
  q_di_Equ_gm_Node_Ptr = &(dQdx[li_di][A_di_Equ_gm_NodeOffset]);
  f_di_Equ_d_Node_Ptr = &(dFdx[li_di][A_di_Equ_d_NodeOffset]);
  q_di_Equ_d_Node_Ptr = &(dQdx[li_di][A_di_Equ_d_NodeOffset]);
  if (!collapseNode_t)
  {
    f_si_Equ_t_Node_Ptr = &(dFdx[li_si][A_si_Equ_t_NodeOffset]);
    q_si_Equ_t_Node_Ptr = &(dQdx[li_si][A_si_Equ_t_NodeOffset]);
  }
  f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
  q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
  f_si_Equ_bi_Node_Ptr = &(dFdx[li_si][A_si_Equ_bi_NodeOffset]);
  q_si_Equ_bi_Node_Ptr = &(dQdx[li_si][A_si_Equ_bi_NodeOffset]);
  f_si_Equ_di_Node_Ptr = &(dFdx[li_si][A_si_Equ_di_NodeOffset]);
  q_si_Equ_di_Node_Ptr = &(dQdx[li_si][A_si_Equ_di_NodeOffset]);
  f_si_Equ_gi_Node_Ptr = &(dFdx[li_si][A_si_Equ_gi_NodeOffset]);
  q_si_Equ_gi_Node_Ptr = &(dQdx[li_si][A_si_Equ_gi_NodeOffset]);
  f_si_Equ_sbulk_Node_Ptr = &(dFdx[li_si][A_si_Equ_sbulk_NodeOffset]);
  q_si_Equ_sbulk_Node_Ptr = &(dQdx[li_si][A_si_Equ_sbulk_NodeOffset]);
  f_si_Equ_dbulk_Node_Ptr = &(dFdx[li_si][A_si_Equ_dbulk_NodeOffset]);
  q_si_Equ_dbulk_Node_Ptr = &(dQdx[li_si][A_si_Equ_dbulk_NodeOffset]);
  f_si_Equ_N2_Node_Ptr = &(dFdx[li_si][A_si_Equ_N2_NodeOffset]);
  q_si_Equ_N2_Node_Ptr = &(dQdx[li_si][A_si_Equ_N2_NodeOffset]);
  f_si_Equ_N1_Node_Ptr = &(dFdx[li_si][A_si_Equ_N1_NodeOffset]);
  q_si_Equ_N1_Node_Ptr = &(dQdx[li_si][A_si_Equ_N1_NodeOffset]);
  f_si_Equ_gm_Node_Ptr = &(dFdx[li_si][A_si_Equ_gm_NodeOffset]);
  q_si_Equ_gm_Node_Ptr = &(dQdx[li_si][A_si_Equ_gm_NodeOffset]);
  f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
  q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
  f_gi_Equ_N1_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_N1_NodeOffset]);
  q_gi_Equ_N1_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_N1_NodeOffset]);
  f_gi_Equ_sbulk_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_sbulk_NodeOffset]);
  q_gi_Equ_sbulk_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_sbulk_NodeOffset]);
  f_gi_Equ_si_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_si_NodeOffset]);
  q_gi_Equ_si_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_si_NodeOffset]);
  f_gi_Equ_dbulk_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_dbulk_NodeOffset]);
  q_gi_Equ_dbulk_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_dbulk_NodeOffset]);
  f_gi_Equ_di_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_di_NodeOffset]);
  q_gi_Equ_di_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_di_NodeOffset]);
  if (!collapseNode_t)
  {
    f_gi_Equ_t_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_t_NodeOffset]);
    q_gi_Equ_t_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_t_NodeOffset]);
  }
  f_gi_Equ_bi_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_bi_NodeOffset]);
  q_gi_Equ_bi_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_bi_NodeOffset]);
  f_gi_Equ_gi_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_gi_NodeOffset]);
  q_gi_Equ_gi_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_gi_NodeOffset]);
  f_gi_Equ_gm_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_gm_NodeOffset]);
  q_gi_Equ_gm_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_gm_NodeOffset]);
  f_gm_Equ_gm_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_gm_NodeOffset]);
  q_gm_Equ_gm_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_gm_NodeOffset]);
  f_gm_Equ_si_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_si_NodeOffset]);
  q_gm_Equ_si_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_si_NodeOffset]);
  f_gm_Equ_bi_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_bi_NodeOffset]);
  q_gm_Equ_bi_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_bi_NodeOffset]);
  f_gm_Equ_di_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_di_NodeOffset]);
  q_gm_Equ_di_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_di_NodeOffset]);
  f_gm_Equ_gi_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_gi_NodeOffset]);
  q_gm_Equ_gi_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_gi_NodeOffset]);
  f_gm_Equ_sbulk_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_sbulk_NodeOffset]);
  q_gm_Equ_sbulk_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_sbulk_NodeOffset]);
  f_gm_Equ_dbulk_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_dbulk_NodeOffset]);
  q_gm_Equ_dbulk_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_dbulk_NodeOffset]);
  if (!collapseNode_t)
  {
    f_gm_Equ_t_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_t_NodeOffset]);
    q_gm_Equ_t_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_t_NodeOffset]);
  }
  f_gm_Equ_g_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_g_NodeOffset]);
  q_gm_Equ_g_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_g_NodeOffset]);
  if (!collapseNode_t)
  {
    f_bi_Equ_t_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_t_NodeOffset]);
    q_bi_Equ_t_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_t_NodeOffset]);
  }
  f_bi_Equ_si_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_si_NodeOffset]);
  q_bi_Equ_si_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_si_NodeOffset]);
  f_bi_Equ_bi_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_bi_NodeOffset]);
  q_bi_Equ_bi_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_bi_NodeOffset]);
  f_bi_Equ_di_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_di_NodeOffset]);
  q_bi_Equ_di_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_di_NodeOffset]);
  f_bi_Equ_gi_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_gi_NodeOffset]);
  q_bi_Equ_gi_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_gi_NodeOffset]);
  f_bi_Equ_sbulk_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_sbulk_NodeOffset]);
  q_bi_Equ_sbulk_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_sbulk_NodeOffset]);
  f_bi_Equ_dbulk_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_dbulk_NodeOffset]);
  q_bi_Equ_dbulk_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_dbulk_NodeOffset]);
  f_bi_Equ_gm_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_gm_NodeOffset]);
  q_bi_Equ_gm_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_gm_NodeOffset]);
  f_bi_Equ_b_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_b_NodeOffset]);
  q_bi_Equ_b_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_b_NodeOffset]);
  f_sbulk_Equ_bi_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset]);
  q_sbulk_Equ_bi_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset]);
  f_sbulk_Equ_sbulk_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset]);
  q_sbulk_Equ_sbulk_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset]);
  f_sbulk_Equ_b_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_b_NodeOffset]);
  q_sbulk_Equ_b_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_b_NodeOffset]);
  if (!collapseNode_t)
  {
    f_sbulk_Equ_t_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_t_NodeOffset]);
    q_sbulk_Equ_t_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_t_NodeOffset]);
  }
  f_sbulk_Equ_si_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_si_NodeOffset]);
  q_sbulk_Equ_si_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_si_NodeOffset]);
  f_sbulk_Equ_di_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_di_NodeOffset]);
  q_sbulk_Equ_di_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_di_NodeOffset]);
  f_sbulk_Equ_gi_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset]);
  q_sbulk_Equ_gi_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset]);
  f_sbulk_Equ_dbulk_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_dbulk_NodeOffset]);
  q_sbulk_Equ_dbulk_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_dbulk_NodeOffset]);
  f_dbulk_Equ_b_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_b_NodeOffset]);
  q_dbulk_Equ_b_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_b_NodeOffset]);
  f_dbulk_Equ_dbulk_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset]);
  q_dbulk_Equ_dbulk_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset]);
  f_dbulk_Equ_bi_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset]);
  q_dbulk_Equ_bi_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset]);
  if (!collapseNode_t)
  {
    f_dbulk_Equ_t_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_t_NodeOffset]);
    q_dbulk_Equ_t_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_t_NodeOffset]);
  }
  f_dbulk_Equ_si_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_si_NodeOffset]);
  q_dbulk_Equ_si_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_si_NodeOffset]);
  f_dbulk_Equ_di_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_di_NodeOffset]);
  q_dbulk_Equ_di_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_di_NodeOffset]);
  f_dbulk_Equ_gi_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset]);
  q_dbulk_Equ_gi_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset]);
  f_dbulk_Equ_sbulk_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset]);
  q_dbulk_Equ_sbulk_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset]);
  f_N1_Equ_sbulk_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_sbulk_NodeOffset]);
  q_N1_Equ_sbulk_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_sbulk_NodeOffset]);
  f_N1_Equ_si_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_si_NodeOffset]);
  q_N1_Equ_si_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_si_NodeOffset]);
  f_N1_Equ_dbulk_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_dbulk_NodeOffset]);
  q_N1_Equ_dbulk_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_dbulk_NodeOffset]);
  f_N1_Equ_di_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_di_NodeOffset]);
  q_N1_Equ_di_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_di_NodeOffset]);
  f_N1_Equ_bi_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_bi_NodeOffset]);
  q_N1_Equ_bi_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_bi_NodeOffset]);
  f_N1_Equ_gi_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_gi_NodeOffset]);
  q_N1_Equ_gi_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_gi_NodeOffset]);
  if (!collapseNode_t)
  {
    f_N1_Equ_t_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_t_NodeOffset]);
    q_N1_Equ_t_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_t_NodeOffset]);
  }
  f_N1_Equ_N2_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_N2_NodeOffset]);
  q_N1_Equ_N2_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_N2_NodeOffset]);
  f_N1_Equ_N1_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_N1_NodeOffset]);
  q_N1_Equ_N1_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_N1_NodeOffset]);
  f_N2_Equ_sbulk_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_sbulk_NodeOffset]);
  q_N2_Equ_sbulk_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_sbulk_NodeOffset]);
  f_N2_Equ_si_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_si_NodeOffset]);
  q_N2_Equ_si_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_si_NodeOffset]);
  f_N2_Equ_dbulk_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_dbulk_NodeOffset]);
  q_N2_Equ_dbulk_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_dbulk_NodeOffset]);
  f_N2_Equ_di_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_di_NodeOffset]);
  q_N2_Equ_di_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_di_NodeOffset]);
  if (!collapseNode_t)
  {
    f_N2_Equ_t_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_t_NodeOffset]);
    q_N2_Equ_t_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_t_NodeOffset]);
  }
  f_N2_Equ_bi_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_bi_NodeOffset]);
  q_N2_Equ_bi_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_bi_NodeOffset]);
  f_N2_Equ_gi_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_gi_NodeOffset]);
  q_N2_Equ_gi_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_gi_NodeOffset]);
  f_N2_Equ_N2_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_N2_NodeOffset]);
  q_N2_Equ_N2_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_N2_NodeOffset]);
  if (!collapseNode_t)
  {
    f_t_Equ_s_Node_Ptr = &(dFdx[li_t][A_t_Equ_s_NodeOffset]);
    q_t_Equ_s_Node_Ptr = &(dQdx[li_t][A_t_Equ_s_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_si_Node_Ptr = &(dFdx[li_t][A_t_Equ_si_NodeOffset]);
    q_t_Equ_si_Node_Ptr = &(dQdx[li_t][A_t_Equ_si_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_d_Node_Ptr = &(dFdx[li_t][A_t_Equ_d_NodeOffset]);
    q_t_Equ_d_Node_Ptr = &(dQdx[li_t][A_t_Equ_d_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_di_Node_Ptr = &(dFdx[li_t][A_t_Equ_di_NodeOffset]);
    q_t_Equ_di_Node_Ptr = &(dQdx[li_t][A_t_Equ_di_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_bi_Node_Ptr = &(dFdx[li_t][A_t_Equ_bi_NodeOffset]);
    q_t_Equ_bi_Node_Ptr = &(dQdx[li_t][A_t_Equ_bi_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_t_Node_Ptr = &(dFdx[li_t][A_t_Equ_t_NodeOffset]);
    q_t_Equ_t_Node_Ptr = &(dQdx[li_t][A_t_Equ_t_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_gi_Node_Ptr = &(dFdx[li_t][A_t_Equ_gi_NodeOffset]);
    q_t_Equ_gi_Node_Ptr = &(dQdx[li_t][A_t_Equ_gi_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_sbulk_Node_Ptr = &(dFdx[li_t][A_t_Equ_sbulk_NodeOffset]);
    q_t_Equ_sbulk_Node_Ptr = &(dQdx[li_t][A_t_Equ_sbulk_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_dbulk_Node_Ptr = &(dFdx[li_t][A_t_Equ_dbulk_NodeOffset]);
    q_t_Equ_dbulk_Node_Ptr = &(dQdx[li_t][A_t_Equ_dbulk_NodeOffset]);
  }
  if (!collapseNode_t)
  {
    f_t_Equ_gm_Node_Ptr = &(dFdx[li_t][A_t_Equ_gm_NodeOffset]);
    q_t_Equ_gm_Node_Ptr = &(dQdx[li_t][A_t_Equ_gm_NodeOffset]);
  }


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_d] += staticContributions[admsNodeID_d].val();
  (*extData.daeFVectorPtr)[li_g] += staticContributions[admsNodeID_g].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_di] += staticContributions[admsNodeID_di].val();
  (*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si].val();
  (*extData.daeFVectorPtr)[li_gi] += staticContributions[admsNodeID_gi].val();
  (*extData.daeFVectorPtr)[li_gm] += staticContributions[admsNodeID_gm].val();
  (*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi].val();
  (*extData.daeFVectorPtr)[li_sbulk] += staticContributions[admsNodeID_sbulk].val();
  (*extData.daeFVectorPtr)[li_dbulk] += staticContributions[admsNodeID_dbulk].val();
  (*extData.daeFVectorPtr)[li_N1] += staticContributions[admsNodeID_N1].val();
  (*extData.daeFVectorPtr)[li_N2] += staticContributions[admsNodeID_N2].val();
  if (!collapseNode_t)
    (*extData.daeFVectorPtr)[li_t] += staticContributions[admsNodeID_t].val();


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_id] = leadCurrentF[admsNodeID_d];
    leadF[li_branch_ig] = leadCurrentF[admsNodeID_g];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_id] = solVec[li_d] - solVec[li_s];
    junctionV[li_branch_ig] = solVec[li_g] - solVec[li_s];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_d] += dynamicContributions[admsNodeID_d].val();
  (*extData.daeQVectorPtr)[li_g] += dynamicContributions[admsNodeID_g].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_di] += dynamicContributions[admsNodeID_di].val();
  (*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si].val();
  (*extData.daeQVectorPtr)[li_gi] += dynamicContributions[admsNodeID_gi].val();
  (*extData.daeQVectorPtr)[li_gm] += dynamicContributions[admsNodeID_gm].val();
  (*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi].val();
  (*extData.daeQVectorPtr)[li_sbulk] += dynamicContributions[admsNodeID_sbulk].val();
  (*extData.daeQVectorPtr)[li_dbulk] += dynamicContributions[admsNodeID_dbulk].val();
  (*extData.daeQVectorPtr)[li_N1] += dynamicContributions[admsNodeID_N1].val();
  (*extData.daeQVectorPtr)[li_N2] += dynamicContributions[admsNodeID_N2].val();
  if (!collapseNode_t)
    (*extData.daeQVectorPtr)[li_t] += dynamicContributions[admsNodeID_t].val();


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_id] = leadCurrentQ[admsNodeID_d];
    leadQ[li_branch_ig] = leadCurrentQ[admsNodeID_g];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bsim6 instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbsim6::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType gspr;
  AdmsFadType gdpr;
  AdmsFadType QGI;
  AdmsFadType QBI;
  AdmsFadType QG;
  AdmsFadType QD;
  AdmsFadType QS;
  AdmsFadType QDI;
  AdmsFadType QSI;
  AdmsFadType QB;
  AdmsFadType ids_edge;
  AdmsFadType Vdssate;
  AdmsFadType Vdsatedge;
  AdmsFadType vdsatedge;
  double DGAMMAEDGE_i;
  AdmsFadType dvth_sce;
  AdmsFadType theta_sce_edge;
  AdmsFadType litl_edge;
  AdmsFadType dvth_dibl;
  AdmsFadType ETA0EDGE_t;
  AdmsFadType NFACTOREDGE_t;
  AdmsFadType Qovg;
  AdmsFadType Qovb;
  AdmsFadType Qovd;
  AdmsFadType Qovs;
  AdmsFadType Vgdov;
  AdmsFadType Vgsov;
  double Cgdof;
  double Cgsof;
  AdmsFadType QGi;
  AdmsFadType WLCOXVtinv;
  AdmsFadType QBi;
  AdmsFadType Coxeffinv;
  AdmsFadType XDCinv;
  AdmsFadType qiaCV;
  AdmsFadType qbaCV;
  AdmsFadType Qd2;
  AdmsFadType Qd1;
  AdmsFadType Qi;
  AdmsFadType qbeff;
  AdmsFadType dqgeff;
  AdmsFadType Tempd;
  AdmsFadType Temps;
  AdmsFadType sid;
  AdmsFadType sis;
  AdmsFadType vgpqm;
  AdmsFadType MdL_less_1;
  AdmsFadType inv_MdL_2;
  AdmsFadType inv_MdL;
  AdmsFadType MdL_2;
  AdmsFadType zsat;
  AdmsFadType dps;
  AdmsFadType qb;
  AdmsFadType qbd;
  AdmsFadType VdssatCV;
  AdmsFadType VdsatCV;
  AdmsFadType vdsatcv;
  AdmsFadType LambdaC_by2;
  double DPD;
  AdmsFadType invgamg2;
  AdmsFadType gamg2;
  AdmsFadType vgfbCV;
  AdmsFadType QSi;
  AdmsFadType QDi;
  AdmsFadType Gtnoi;
  AdmsFadType sidn;
  AdmsFadType Vtn;
  AdmsFadType Lvsat;
  AdmsFadType mid;
  AdmsFadType mig;
  AdmsFadType migid;
  AdmsFadType sqid;
  AdmsFadType sqig;
  AdmsFadType cm_igid;
  AdmsFadType thetanoisq;
  AdmsFadType betanoisq;
  AdmsFadType ctnoi;
  AdmsFadType FNPowerAt1Hz;
  AdmsFadType Swi;
  AdmsFadType T10;
  AdmsFadType Ssi;
  AdmsFadType Nstar;
  AdmsFadType Nl;
  AdmsFadType N0;
  AdmsFadType DelClm;
  double Leffnoisq;
  double Leffnoi;
  AdmsFadType Esatnoi;
  double LINTNOI_i;
  AdmsFadType Nt;
  AdmsFadType Qbd;
  AdmsFadType Qbs;
  AdmsFadType sarg;
  AdmsFadType arg;
  AdmsFadType Ibd;
  AdmsFadType Ibs;
  AdmsFadType IGISL;
  AdmsFadType IGIDL;
  AdmsFadType igidl;
  AdmsFadType igisl;
  AdmsFadType IGCD;
  AdmsFadType IGCS;
  AdmsFadType IGB;
  AdmsFadType IGD;
  AdmsFadType IGS;
  AdmsFadType igd_mult;
  AdmsFadType igs_mult;
  AdmsFadType T1_exp;
  AdmsFadType Vdseffx;
  AdmsFadType igc0;
  AdmsFadType Vaux_Igbinv;
  AdmsFadType Vaux_Igbacc;
  AdmsFadType Voxminv;
  AdmsFadType Voxmacc;
  AdmsFadType Voxm;
  AdmsFadType igd;
  AdmsFadType igs;
  AdmsFadType igcd;
  AdmsFadType igcs;
  AdmsFadType igb;
  AdmsFadType igbacc;
  AdmsFadType igbinv;
  AdmsFadType ISUB;
  AdmsFadType Iii;
  AdmsFadType idsovvds;
  AdmsFadType Gcrg;
  AdmsFadType ids;
  AdmsFadType ueff;
  AdmsFadType Dtot;
  AdmsFadType Nsat;
  AdmsFadType DQSD;
  AdmsFadType Vgd_eff;
  AdmsFadType Vgs_eff;
  AdmsFadType Dr;
  AdmsFadType Rdsi;
  AdmsFadType Rdrain;
  AdmsFadType Rsource;
  AdmsFadType Dptwg;
  AdmsFadType Dvsat;
  AdmsFadType Mscbe;
  AdmsFadType VaSCBE;
  AdmsFadType VaDITS;
  AdmsFadType MdL;
  AdmsFadType Vasat;
  AdmsFadType Fp;
  AdmsFadType Moc;
  AdmsFadType VaDIBL;
  AdmsFadType Vgst2Vtm;
  AdmsFadType diffVds;
  AdmsFadType DIBLfactor;
  AdmsFadType PVAGfactor;
  AdmsFadType EsatL;
  AdmsFadType Esat;
  AdmsFadType Dmob;
  AdmsFadType Eeffm;
  AdmsFadType qia;
  AdmsFadType qba;
  AdmsFadType Qd;
  AdmsFadType Qs;
  AdmsFadType Qb;
  AdmsFadType DQSD2;
  AdmsFadType qdeff;
  AdmsFadType vdeff;
  AdmsFadType Vdseff;
  AdmsFadType Vdssat;
  AdmsFadType Vdsat;
  AdmsFadType vdsat;
  AdmsFadType qdsat;
  AdmsFadType ln_T1_T2;
  AdmsFadType T12;
  AdmsFadType T11;
  AdmsFadType LambdaC;
  AdmsFadType Rdss;
  double WeffWRFactor;
  AdmsFadType Dmobs;
  AdmsFadType Eeffs;
  AdmsFadType qis;
  AdmsFadType qbs;
  double EeffFactor;
  AdmsFadType psiavg;
  AdmsFadType psipclamp;
  AdmsFadType qs;
  AdmsFadType T6;
  AdmsFadType T5;
  AdmsFadType T7;
  AdmsFadType sqrtpsisainv;
  AdmsFadType sqrtpsisa;
  AdmsFadType T9;
  AdmsFadType sqrtpsip;
  AdmsFadType T8;
  AdmsFadType psip;
  AdmsFadType gammaPD;
  AdmsFadType vgfbPD;
  AdmsFadType phib_n;
  AdmsFadType inv_gam;
  AdmsFadType VTH;
  AdmsFadType psip_th;
  AdmsFadType nq;
  double q_vth;
  AdmsFadType gam;
  AdmsFadType vgfb;
  AdmsFadType Vth_shift;
  AdmsFadType dVth_VNUD;
  AdmsFadType vfb;
  AdmsFadType vs;
  AdmsFadType vg;
  AdmsFadType T4;
  AdmsFadType dVth_ldop;
  AdmsFadType dvth_temp;
  AdmsFadType dVth_dibl;
  AdmsFadType inv_nVt;
  AdmsFadType nVt;
  AdmsFadType n;
  AdmsFadType cdsc;
  AdmsFadType Cdep;
  AdmsFadType Xdep;
  AdmsFadType sqrtPhistVbs;
  AdmsFadType PhistVbs;
  AdmsFadType UCS_a;
  AdmsFadType UC_a;
  AdmsFadType UA_a;
  AdmsFadType U0_a;
  AdmsFadType PTWG_a;
  AdmsFadType VSAT_a;
  AdmsFadType PSAT_a;
  AdmsFadType PCLM_a;
  AdmsFadType PDIBLC_a;
  AdmsFadType ETA0_a;
  AdmsFadType CDSCD_a;
  AdmsFadType wr;
  AdmsFadType wf;
  AdmsFadType Vbsx;
  AdmsFadType Vdsx;
  double sigvds;
  AdmsFadType Vgs_ov_noswap;
  AdmsFadType Vgd_ov_noswap;
  AdmsFadType Vgs_noswap;
  AdmsFadType Vgd_noswap;
  AdmsFadType Vbd_jct;
  AdmsFadType Vbs_jct;
  AdmsFadType Vdb_noswap;
  AdmsFadType Vsb_noswap;
  AdmsFadType Vds_noswap;
  AdmsFadType Vds;
  AdmsFadType Vs;
  AdmsFadType Vd;
  AdmsFadType Vg;
  AdmsFadType mu_well;
  AdmsFadType k2_well;
  AdmsFadType vth0_well;
  AdmsFadType local_scc;
  AdmsFadType local_scb;
  AdmsFadType local_sca;
  double Wdrn;
  AdmsFadType eta_stress;
  AdmsFadType k2_stress;
  AdmsFadType vth0_stress;
  AdmsFadType vsat_mult;
  AdmsFadType mu0_mult;
  AdmsFadType rho;
  AdmsFadType Inv_od;
  AdmsFadType rho_ref;
  double Inv_odref;
  double Inv_sbref;
  double Inv_saref;
  int i;
  AdmsFadType Inv_sb;
  AdmsFadType Inv_sa;
  AdmsFadType ku0_temp;
  AdmsFadType kstress_vth0;
  AdmsFadType tmp1_stress_vth;
  AdmsFadType kstress_u0;
  AdmsFadType tmp1_stress;
  double W_tmp_stress;
  AdmsFadType Czbdswg;
  AdmsFadType Czbdsw;
  AdmsFadType Czbd;
  AdmsFadType Czbsswg;
  AdmsFadType Czbssw;
  AdmsFadType Czbs;
  AdmsFadType DslpRev;
  AdmsFadType IVjdmRev;
  AdmsFadType VjdmRev;
  AdmsFadType DslpFwd;
  AdmsFadType IVjdmFwd;
  AdmsFadType VjdmFwd;
  AdmsFadType XExpBVD;
  AdmsFadType Nvtmd;
  AdmsFadType Isbd;
  AdmsFadType SslpRev;
  AdmsFadType IVjsmRev;
  AdmsFadType VjsmRev;
  AdmsFadType SslpFwd;
  AdmsFadType IVjsmFwd;
  AdmsFadType VjsmFwd;
  AdmsFadType Tb;
  AdmsFadType XExpBVS;
  AdmsFadType Nvtms;
  AdmsFadType Isbs;
  AdmsFadType PDeff;
  AdmsFadType PSeff;
  AdmsFadType ADeff;
  AdmsFadType ASeff;
  AdmsFadType PSiso;
  AdmsFadType PDiso;
  AdmsFadType PSsha;
  AdmsFadType PDsha;
  double PSmer;
  double PDmer;
  AdmsFadType ASiso;
  AdmsFadType ADiso;
  double ASsha;
  double ADsha;
  double ASmer;
  double ADmer;
  AdmsFadType temp_ADeff;
  AdmsFadType temp_ASeff;
  AdmsFadType temp_PDeff;
  AdmsFadType temp_PSeff;
  AdmsFadType NJTSSWGD_t;
  AdmsFadType NJTSSWD_t;
  AdmsFadType NJTSD_t;
  AdmsFadType NJTSSWG_t;
  AdmsFadType NJTSSW_t;
  AdmsFadType NJTS_t;
  AdmsFadType JTSSWGD_t;
  AdmsFadType JTSSWD_t;
  AdmsFadType JTSD_t;
  AdmsFadType JTSSWGS_t;
  AdmsFadType JTSSWS_t;
  AdmsFadType JTSS_t;
  AdmsFadType JSWGD_t;
  AdmsFadType JSWD_t;
  AdmsFadType JSD_t;
  AdmsFadType JSWGS_t;
  AdmsFadType JSWS_t;
  AdmsFadType JSS_t;
  AdmsFadType T3;
  AdmsFadType PBSWGD_t;
  AdmsFadType PBSWGS_t;
  AdmsFadType PBSWD_t;
  AdmsFadType PBSWS_t;
  AdmsFadType PBD_t;
  AdmsFadType PBS_t;
  AdmsFadType CJSWGD_t;
  AdmsFadType CJSWGS_t;
  AdmsFadType CJSWD_t;
  AdmsFadType CJSWS_t;
  AdmsFadType CJD_t;
  AdmsFadType CJS_t;
  AdmsFadType igtemp;
  AdmsFadType BGISL_t;
  AdmsFadType BGIDL_t;
  AdmsFadType BETA0_t;
  AdmsFadType A2_t;
  AdmsFadType A1_t;
  AdmsFadType PTWG_t;
  AdmsFadType DELTA_t;
  AdmsFadType VSATCV_t;
  AdmsFadType VSAT_t;
  AdmsFadType rdstemp;
  AdmsFadType UCS_t;
  AdmsFadType UD_t;
  AdmsFadType UC_t;
  AdmsFadType UA_t;
  AdmsFadType U0_t;
  double eta_mu;
  AdmsFadType ETA0_t;
  AdmsFadType NFACTOR_t;
  double litl;
  double T1DEP;
  AdmsFadType sqrtPhist;
  AdmsFadType Phist;
  AdmsFadType Vfbsdr;
  AdmsFadType Vbi;
  AdmsFadType phib;
  AdmsFadType ni;
  double Eg0;
  AdmsFadType Eg;
  double Vtm0;
  AdmsFadType Vtm;
  AdmsFadType delTemp;
  AdmsFadType TRatio;
  AdmsFadType inv_Vt;
  AdmsFadType Vt;
  AdmsFadType TK;
  AdmsFadType delTemp1;
  AdmsFadType DevTemp;
  double Tnom;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (21))
  {
    probeVars.resize(21);
    staticContributions.resize(14+0);
    dynamicContributions.resize(14+0);
  }

  noiseContribsPower.resize(16);
  noiseContribsExponent.resize(16);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 14+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_bi_dbulk] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_dbulk];
  probeVars[admsProbeID_V_bi_dbulk].diff(admsProbeID_V_bi_dbulk,21);
  probeVars[admsProbeID_V_b_dbulk] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_dbulk];
  probeVars[admsProbeID_V_b_dbulk].diff(admsProbeID_V_b_dbulk,21);
  probeVars[admsProbeID_V_b_bi] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_b_bi].diff(admsProbeID_V_b_bi,21);
  probeVars[admsProbeID_V_b_sbulk] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_sbulk];
  probeVars[admsProbeID_V_b_sbulk].diff(admsProbeID_V_b_sbulk,21);
  probeVars[admsProbeID_V_bi_sbulk] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_sbulk];
  probeVars[admsProbeID_V_bi_sbulk].diff(admsProbeID_V_bi_sbulk,21);
  probeVars[admsProbeID_V_di_si] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_di_si].diff(admsProbeID_V_di_si,21);
  probeVars[admsProbeID_V_gm_gi] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_gi];
  probeVars[admsProbeID_V_gm_gi].diff(admsProbeID_V_gm_gi,21);
  probeVars[admsProbeID_V_g_gm] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_gm];
  probeVars[admsProbeID_V_g_gm].diff(admsProbeID_V_g_gm,21);
  probeVars[admsProbeID_V_s_si] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_s_si].diff(admsProbeID_V_s_si,21);
  probeVars[admsProbeID_V_d_di] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_d_di].diff(admsProbeID_V_d_di,21);
  probeVars[admsProbeID_V_gm_bi] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_gm_bi].diff(admsProbeID_V_gm_bi,21);
  probeVars[admsProbeID_V_N1_GND] = (*solVectorPtr)[li_N1];
  probeVars[admsProbeID_V_N1_GND].diff(admsProbeID_V_N1_GND,21);
  probeVars[admsProbeID_V_N2_GND] = (*solVectorPtr)[li_N2];
  probeVars[admsProbeID_V_N2_GND].diff(admsProbeID_V_N2_GND,21);
  probeVars[admsProbeID_V_gm_si] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_gm_si].diff(admsProbeID_V_gm_si,21);
  probeVars[admsProbeID_V_gm_di] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_gm_di].diff(admsProbeID_V_gm_di,21);
  probeVars[admsProbeID_V_dbulk_di] = (*solVectorPtr)[li_dbulk] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_dbulk_di].diff(admsProbeID_V_dbulk_di,21);
  probeVars[admsProbeID_V_sbulk_si] = (*solVectorPtr)[li_sbulk] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_sbulk_si].diff(admsProbeID_V_sbulk_si,21);
  probeVars[admsProbeID_V_si_bi] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_si_bi].diff(admsProbeID_V_si_bi,21);
  probeVars[admsProbeID_V_di_bi] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_di_bi].diff(admsProbeID_V_di_bi,21);
  probeVars[admsProbeID_V_gi_bi] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_bi];
  probeVars[admsProbeID_V_gi_bi].diff(admsProbeID_V_gi_bi,21);
  probeVars[admsProbeID_Temp_t_GND] = ((collapseNode_t)?(0):((*solVectorPtr)[li_t]));
  probeVars[admsProbeID_Temp_t_GND].diff(admsProbeID_Temp_t_GND,21);
  // -- code converted from analog/code block
  if (((model_.TNOM)<=(-273.15)))
  {
    T0 = (300.15-273.15);
    std::cerr  << "Warning: TNOM = %e C <= %e C. Setting TNOM to %e C." << (model_.TNOM) << (-273.15) << T0 <<  std::endl; 
    Tnom = 300.15;
  }
  else
  {
    Tnom = ((model_.TNOM)+273.15);
  }
  DevTemp = (admsTemperature+(model_.DTEMP));
  if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
  {
    delTemp1 = (probeVars[admsProbeID_Temp_t_GND]);
  }
  else
  {
    delTemp1 = 0;
  }
  DevTemp = (delTemp1+DevTemp);
  TK = DevTemp;
  Vt = adms_vt(DevTemp);
  inv_Vt = (1.0/Vt);
  TRatio = (DevTemp/Tnom);
  delTemp = (DevTemp-Tnom);
  Vtm = (8.617087e-5*DevTemp);
  Vtm0 = (8.617087e-5*Tnom);
  Eg = ((model_.BG0SUB)-((((model_.TBGASUB)*DevTemp)*DevTemp)/(DevTemp+(model_.TBGBSUB))));
  Eg0 = ((model_.BG0SUB)-((((model_.TBGASUB)*Tnom)*Tnom)/(Tnom+(model_.TBGBSUB))));
  T1 = ((DevTemp/Tnom)*sqrt((DevTemp/Tnom)));
  ni = (((model_.NI0SUB)*T1)*AnalogFunctions::lexp<AdmsFadType>(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
  if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
  {
    T0 = AnalogFunctions::lln<AdmsFadType>((NDEP_i/ni));
    phib = sqrt(((T0*T0)+1.0E-6));
  }
  else
  {
    phib = AnalogFunctions::lln<AdmsFadType>((NDEP_i/ni));
  }
  if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
  {
    T0 = AnalogFunctions::lln<AdmsFadType>((((NDEP_i*(model_.NSD))/ni)*ni));
    Vbi = sqrt(((T0*T0)+1.0E-6));
  }
  else
  {
    Vbi = AnalogFunctions::lln<AdmsFadType>((((NDEP_i*(model_.NSD))/ni)*ni));
  }
  if ((NGATE_i>0))
  {
    Vfbsdr = ((((-devsign)*Vt)*AnalogFunctions::lln<AdmsFadType>((NGATE_i/NSD_i)))+VFBSDOFF);
  }
  else
  {
    Vfbsdr = 0.0;
  }
  Phist = max(((0.4+(Vt*phib))+PHIN_i),static_cast<double>(0.4));
  sqrtPhist = sqrt(Phist);
  T1DEP = sqrt(((2.0*epssi)/(1.60219e-19*NDEP_i)));
  litl = sqrt((((epssi/epsox)*(model_.TOXE))*XJ_i));
  NFACTOR_t = (NFACTOR_i*AnalogFunctions::hypsmooth<AdmsFadType>((1.0+((model_.TNFACTOR)*(TRatio-1.0))),1e-3));
  ETA0_t = (ETA0_i*(1.0+((model_.TETA0)*(TRatio-1.0))));
  if (((model_.ASYMMOD)!=0))
  {
    ETA0R_t = (ETA0R_i*(1.0+((model_.TETA0)*(TRatio-1.0))));
  }
  eta_mu = (((model_.TYPE)!=1)?(0.33333333333333333*(model_.ETAMOB)):(0.5*(model_.ETAMOB)));
  U0_t = (U0_i*pow(TRatio,UTE_i));
  UA_t = (UA_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3));
  UC_t = (UC_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
  UD_t = (UD_i*pow(TRatio,UD1_i));
  UCS_t = (UCS_i*pow(TRatio,UCSTE_i));
  if (((model_.ASYMMOD)!=0))
  {
    U0R_t = (U0R_i*pow(TRatio,UTE_i));
    UAR_t = (UAR_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3));
    UCR_t = (UCR_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
    UDR_t = (UDR_i*pow(TRatio,UD1_i));
    UCSR_t = (UCSR_i*pow(TRatio,UCSTE_i));
  }
  rdstemp = pow(TRatio,PRT_i);
  VSAT_t = (VSAT_i*pow(TRatio,(-AT_i)));
  if ((VSAT_t<100.0))
  {
    std::cerr  << "Warning: VSAT(%f) = %e is less than 100, setting it to 100." << DevTemp << VSAT_t <<  std::endl; 
    VSAT_t = 100.0;
  }
  if (((model_.ASYMMOD)!=0))
  {
    VSATR_t = (VSATR_i*pow(TRatio,(-AT_i)));
    if ((VSATR_t<100.0))
    {
      std::cerr  << "Warning: VSATR(%f) = %e is less than 100, setting it to 100." << DevTemp << VSATR_t <<  std::endl; 
      VSATR_t = 100.0;
    }
  }
  VSATCV_t = (VSATCV_i*pow(TRatio,(-AT_i)));
  if ((VSATCV_t<100.0))
  {
    std::cerr  << "Warning: VSATCV(%f) = %e is less than 100, setting it to 100." << DevTemp << VSATCV_t <<  std::endl; 
    VSATCV_t = 100.0;
  }
  DELTA_t = (1.0/(AnalogFunctions::hypsmooth<AdmsFadType>((((1.0/DELTA_i)*(1.0+((model_.TDELTA)*delTemp)))-2.0),1.0E-3)+2.0));
  PTWG_t = (PTWG_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
  if (((model_.ASYMMOD)!=0))
  {
    PTWGR_t = (PTWGR_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
  }
  A1_t = (A1_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(A11_i*delTemp))-1.0E-6),1.0E-3));
  A2_t = (A2_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(A21_i*delTemp))-1.0E-6),1.0E-3));
  BETA0_t = (BETA0_i*pow(TRatio,IIT_i));
  BGIDL_t = (BGIDL_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
  BGISL_t = (BGISL_i*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
  igtemp = AnalogFunctions::lexp<AdmsFadType>((IGT_i*AnalogFunctions::lln<AdmsFadType>(TRatio)));
  CJS_t = ((model_.CJS)*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3));
  CJD_t = ((model_.CJD)*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3));
  CJSWS_t = ((model_.CJSWS)*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3));
  CJSWD_t = ((model_.CJSWD)*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3));
  CJSWGS_t = ((model_.CJSWGS)*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3));
  CJSWGD_t = ((model_.CJSWGD)*AnalogFunctions::hypsmooth<AdmsFadType>(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3));
  PBS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0E-3)+0.01);
  PBD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0E-3)+0.01);
  PBSWS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0E-3)+0.01);
  PBSWD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0E-3)+0.01);
  PBSWGS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3)+0.01);
  PBSWGD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3)+0.01);
  T0 = ((Eg0/Vtm0)-(Eg/Vtm));
  T1 = AnalogFunctions::lln<AdmsFadType>(TRatio);
  T3 = AnalogFunctions::lexp<AdmsFadType>(((T0+((model_.XTIS)*T1))/(model_.NJS)));
  JSS_t = ((model_.JSS)*T3);
  JSWS_t = ((model_.JSWS)*T3);
  JSWGS_t = ((model_.JSWGS)*T3);
  T3 = AnalogFunctions::lexp<AdmsFadType>(((T0+((model_.XTID)*T1))/(model_.NJD)));
  JSD_t = ((model_.JSD)*T3);
  JSWD_t = ((model_.JSWD)*T3);
  JSWGD_t = ((model_.JSWGD)*T3);
  JTSS_t = ((model_.JTSS)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSS))*(TRatio-1.0))/Vtm)));
  JTSSWS_t = ((model_.JTSSWS)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWS))*(TRatio-1.0))/Vtm)));
  JTSSWGS_t = (((model_.JTSSWGS)*(sqrt(((model_.JTWEFF)/Weffcj))+1.0))*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWGS))*(TRatio-1))/Vtm)));
  JTSD_t = ((model_.JTSD)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSD))*(TRatio-1.0))/Vtm)));
  JTSSWD_t = ((model_.JTSSWD)*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWD))*(TRatio-1.0))/Vtm)));
  JTSSWGD_t = (((model_.JTSSWGD)*(sqrt(((model_.JTWEFF)/Weffcj))+1.0))*AnalogFunctions::lexp<AdmsFadType>((((Eg0*(model_.XTSSWGD))*(TRatio-1))/Vtm)));
  NJTS_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSW_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSWG_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSWD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSWGD_t = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  {
    if ((GEOMOD<9))
    {
      if (((NF%2)!=0))
      {
        nuEndD = 1.0;
        nuEndS = 1.0;
        nuIntD = (2.0*std::max(((NF-1.0)/2.0),static_cast<double>(0.0)));
        nuIntS = nuIntD;
      }
      else
      {
        if ((MINZ==1))
        {
          nuEndD = 2.0;
          nuIntD = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
          nuEndS = 0.0;
          nuIntS = NF;
        }
        else
        {
          nuEndD = 0.0;
          nuIntD = NF;
          nuEndS = 2.0;
          nuIntS = (2.0*std::max(((NF/2.0)-1.0),static_cast<double>(0.0)));
        }
      }
    }
    T0 = (DMCGeff+DMCIeff);
    T1 = (DMCGeff+DMCGeff);
    T2 = (DMDGeff+DMDGeff);
    PSiso = ((T0+T0)+Weffcj);
    PDiso = ((T0+T0)+Weffcj);
    PSsha = T1;
    PDsha = T1;
    PSmer = T2.val();
    PDmer = T2.val();
    ASiso = (T0*Weffcj);
    ADiso = (T0*Weffcj);
    ASsha = (DMCGeff*Weffcj);
    ADsha = (DMCGeff*Weffcj);
    ASmer = (DMDGeff*Weffcj);
    ADmer = (DMDGeff*Weffcj);
    if ( GEOMOD == (0))
    {
      temp_PSeff = ((nuEndS*PSiso)+(nuIntS*PSsha));
      temp_PDeff = ((nuEndD*PDiso)+(nuIntD*PDsha));
      temp_ASeff = ((nuEndS*ASiso)+(nuIntS*ASsha));
      temp_ADeff = ((nuEndD*ADiso)+(nuIntD*ADsha));
    }
    else
      if ( GEOMOD == (1))
      {
        temp_PSeff = ((nuEndS*PSiso)+(nuIntS*PSsha));
        temp_PDeff = ((nuEndD+nuIntD)*PDsha);
        temp_ASeff = ((nuEndS*ASiso)+(nuIntS*ASsha));
        temp_ADeff = ((nuEndD+nuIntD)*ADsha);
      }
      else
        if ( GEOMOD == (2))
        {
          temp_PSeff = ((nuEndS+nuIntS)*PSsha);
          temp_PDeff = ((nuEndD*PDiso)+(nuIntD*PDsha));
          temp_ASeff = ((nuEndS+nuIntS)*ASsha);
          temp_ADeff = ((nuEndD*ADiso)+(nuIntD*ADsha));
        }
        else
          if ( GEOMOD == (3))
          {
            temp_PSeff = ((nuEndS+nuIntS)*PSsha);
            temp_PDeff = ((nuEndD+nuIntD)*PDsha);
            temp_ASeff = ((nuEndS+nuIntS)*ASsha);
            temp_ADeff = ((nuEndD+nuIntD)*ADsha);
          }
          else
            if ( GEOMOD == (4))
            {
              temp_PSeff = ((nuEndS*PSiso)+(nuIntS*PSsha));
              temp_PDeff = ((nuEndD*PDmer)+(nuIntD*PDsha));
              temp_ASeff = ((nuEndS*ASiso)+(nuIntS*ASsha));
              temp_ADeff = ((nuEndD*ADmer)+(nuIntD*ADsha));
            }
            else
              if ( GEOMOD == (5))
              {
                temp_PSeff = ((nuEndS+nuIntS)*PSsha);
                temp_PDeff = ((nuEndD*PDmer)+(nuIntD*PDsha));
                temp_ASeff = ((nuEndS+nuIntS)*ASsha);
                temp_ADeff = ((nuEndD*ADmer)+(nuIntD*ADsha));
              }
              else
                if ( GEOMOD == (6))
                {
                  temp_PSeff = ((nuEndS*PSmer)+(nuIntS*PSsha));
                  temp_PDeff = ((nuEndD*PDiso)+(nuIntD*PDsha));
                  temp_ASeff = ((nuEndS*ASmer)+(nuIntS*ASsha));
                  temp_ADeff = ((nuEndD*ADiso)+(nuIntD*ADsha));
                }
                else
                  if ( GEOMOD == (7))
                  {
                    temp_PSeff = ((nuEndS*PSmer)+(nuIntS*PSsha));
                    temp_PDeff = ((nuEndD+nuIntD)*PDsha);
                    temp_ASeff = ((nuEndS*ASmer)+(nuIntS*ASsha));
                    temp_ADeff = ((nuEndD+nuIntD)*ADsha);
                  }
                  else
                    if ( GEOMOD == (8))
                    {
                      temp_PSeff = ((nuEndS*PSmer)+(nuIntS*PSsha));
                      temp_PDeff = ((nuEndD*PDmer)+(nuIntD*PDsha));
                      temp_ASeff = ((nuEndS*ASmer)+(nuIntS*ASsha));
                      temp_ADeff = ((nuEndD*ADmer)+(nuIntD*ADsha));
                    }
                    else
                      if ( GEOMOD == (9))
                      {
                        temp_PSeff = (PSiso+((NF-1.0)*PSsha));
                        temp_PDeff = (NF*PDsha);
                        temp_ASeff = (ASiso+((NF-1.0)*ASsha));
                        temp_ADeff = (NF*ADsha);
                      }
                      else
                        if ( GEOMOD == (10))
                        {
                          temp_PSeff = (NF*PSsha);
                          temp_PDeff = (PDiso+((NF-1.0)*PDsha));
                          temp_ASeff = (NF*ASsha);
                          temp_ADeff = (ADiso+((NF-1.0)*ADsha));
                        }
                        else
                        {
                          temp_PSeff = 0;
                          temp_PDeff = 0;
                          temp_ASeff = 0;
                          temp_ADeff = 0;
                        }
  }
  if (given("AS"))
  {
    ASeff = ((AS*(model_.WMLT))*(model_.LMLT));
  }
  else
  {
    ASeff = temp_ASeff;
  }
  if ((ASeff<0.0))
  {
    std::cerr  << "Warning: (instance %M) ASeff = %e is negative, set to zero." << ASeff <<  std::endl; 
    ASeff = 0.0;
  }
  if (given("AD"))
  {
    ADeff = ((AD*(model_.WMLT))*(model_.LMLT));
  }
  else
  {
    ADeff = temp_ADeff;
  }
  if ((ADeff<0.0))
  {
    std::cerr  << "Warning: (instance %M) ADeff = %e is negative, set to zero." << ADeff <<  std::endl; 
    ADeff = 0.0;
  }
  if (given("PS"))
  {
    if (((model_.PERMOD)==0))
    {
      PSeff = (PS*(model_.WMLT));
    }
    else
    {
      PSeff = std::max(((PS*(model_.WMLT))-(Weffcj*NF)),static_cast<double>(0.0));
    }
  }
  else
  {
    PSeff = temp_PSeff;
    if ((PSeff<0.0))
    {
      std::cerr  << "Warning: (instance %M) PSeff = %e is negative.Set to 0.0" << PSeff <<  std::endl; 
      PSeff = 0.0;
    }
  }
  if (given("PD"))
  {
    if (((model_.PERMOD)==0))
    {
      PDeff = (PD*(model_.WMLT));
    }
    else
    {
      PDeff = std::max(((PD*(model_.WMLT))-(Weffcj*NF)),static_cast<double>(0.0));
    }
  }
  else
  {
    PDeff = temp_PDeff;
    if ((PDeff<0.0))
    {
      std::cerr  << "Warning: (instance %M) PDeff = %e is negative.Set to 0.0" << PDeff <<  std::endl; 
      PDeff = 0.0;
    }
  }
  Isbs = (((ASeff*JSS_t)+(PSeff*JSWS_t))+((Weffcj*NF)*JSWGS_t));
  if ((Isbs>0.0))
  {
    Nvtms = (Vtm*(model_.NJS));
    XExpBVS = (AnalogFunctions::lexp<AdmsFadType>(((-(model_.BVS))/Nvtms))*(model_.XJBVS));
    T2 = max(((model_.IJTHSFWD)/Isbs),static_cast<double>(10.0));
    Tb = ((1.0+T2)-XExpBVS);
    VjsmFwd = (Nvtms*AnalogFunctions::lln<AdmsFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4*XExpBVS)))))));
    T0 = AnalogFunctions::lexp<AdmsFadType>((VjsmFwd/Nvtms));
    IVjsmFwd = (Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
    SslpFwd = ((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
    T2 = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.IJTHSREV)/Isbs)-10.0),1.0E-3)+10.0);
    VjsmRev = ((-(model_.BVS))-(Nvtms*AnalogFunctions::lln<AdmsFadType>(((T2-1.0)/(model_.XJBVS)))));
    T1 = ((model_.XJBVS)*AnalogFunctions::lexp<AdmsFadType>(((-((model_.BVS)+VjsmRev))/Nvtms)));
    IVjsmRev = (Isbs*(1.0+T1));
    SslpRev = (((-Isbs)*T1)/Nvtms);
  }
  else
  {
    Nvtms = 0;
    XExpBVS = 0;
    VjsmFwd = 0;
    IVjsmFwd = 0;
    SslpFwd = 0;
    VjsmRev = 0;
    IVjsmRev = 0;
    SslpRev = 0;
  }
  Isbd = (((ADeff*JSD_t)+(PDeff*JSWD_t))+((Weffcj*NF)*JSWGD_t));
  if ((Isbd>0.0))
  {
    Nvtmd = (Vtm*(model_.NJD));
    XExpBVD = (AnalogFunctions::lexp<AdmsFadType>(((-(model_.BVD))/Nvtmd))*(model_.XJBVD));
    T2 = max(((model_.IJTHDFWD)/Isbd),static_cast<double>(10.0));
    Tb = ((1.0+T2)-XExpBVD);
    VjdmFwd = (Nvtmd*AnalogFunctions::lln<AdmsFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4*XExpBVD)))))));
    T0 = AnalogFunctions::lexp<AdmsFadType>((VjdmFwd/Nvtmd));
    IVjdmFwd = (Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
    DslpFwd = ((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
    T2 = (AnalogFunctions::hypsmooth<AdmsFadType>((((model_.IJTHDREV)/Isbd)-10.0),1.0E-3)+10.0);
    VjdmRev = ((-(model_.BVD))-(Nvtmd*AnalogFunctions::lln<AdmsFadType>(((T2-1.0)/(model_.XJBVD)))));
    T1 = ((model_.XJBVD)*AnalogFunctions::lexp<AdmsFadType>(((-((model_.BVD)+VjdmRev))/Nvtmd)));
    IVjdmRev = (Isbd*(1.0+T1));
    DslpRev = (((-Isbd)*T1)/Nvtmd);
  }
  else
  {
    Nvtmd = 0;
    XExpBVD = 0;
    VjdmFwd = 0;
    IVjdmFwd = 0;
    DslpFwd = 0;
    VjdmRev = 0;
    IVjdmRev = 0;
    DslpRev = 0;
  }
  Czbs = (CJS_t*ASeff);
  Czbssw = (CJSWS_t*PSeff);
  Czbsswg = ((CJSWGS_t*Weffcj)*NF);
  Czbd = (CJD_t*ADeff);
  Czbdsw = (CJSWD_t*PDeff);
  Czbdswg = ((CJSWGD_t*Weffcj)*NF);
  if (((((((model_.KU0)!=0)||((model_.KVSAT)!=0))||((model_.KVTH0)!=0))||((model_.STK2)!=0))||((model_.STETA0)!=0)))
  {
    T0 = pow(Lnew,(model_.LLODKU0));
    W_tmp_stress = (Wnew+(model_.WLOD));
    T1 = pow(W_tmp_stress,(model_.WLODKU0));
    tmp1_stress = ((((model_.LKU0)/T0)+((model_.WKU0)/T1))+((model_.PKU0)/(T0*T1)));
    kstress_u0 = (1.0+tmp1_stress);
    T0 = pow(Lnew,(model_.LLODVTH));
    T1 = pow(W_tmp_stress,(model_.WLODVTH));
    tmp1_stress_vth = ((((model_.LKVTH0)/T0)+((model_.WKVTH0)/T1))+((model_.PKVTH0)/(T0*T1)));
    kstress_vth0 = (1.0+tmp1_stress_vth);
    T0 = (TRatio-1.0);
    ku0_temp = ((kstress_u0*(1.0+((model_.TKU0)*T0)))+1.0e-9);
    Inv_sa = 0;
    Inv_sb = 0;
    for (i=0;(i<NF);i=(i+1) )//Begin block forloop
    {
      T0 = ((1.0/NF)/((SA+(0.5*L_mult))+(i*(SD+L_mult))));
      T1 = ((1.0/NF)/((SB+(0.5*L_mult))+(i*(SD+L_mult))));
      Inv_sa = (Inv_sa+T0);
      Inv_sb = (Inv_sb+T1);
    }
    // End block forloop
    Inv_saref = (1.0/((model_.SAREF)+(0.5*L_mult)));
    Inv_sbref = (1.0/((model_.SBREF)+(0.5*L_mult)));
    Inv_odref = (Inv_saref+Inv_sbref);
    rho_ref = (((model_.KU0)/ku0_temp)*Inv_odref);
    Inv_od = (Inv_sa+Inv_sb);
    rho = (((model_.KU0)/ku0_temp)*Inv_od);
    mu0_mult = ((1.0+rho)/(1.0+rho_ref));
    vsat_mult = ((1.0+(rho*(model_.KVSAT)))/(1.0+(rho_ref*(model_.KVSAT))));
    vth0_stress = (((model_.KVTH0)/kstress_vth0)*(Inv_od-Inv_odref));
    k2_stress = (((model_.STK2)/pow(kstress_vth0,(model_.LODK2)))*(Inv_od-Inv_odref));
    eta_stress = (((model_.STETA0)/pow(kstress_vth0,(model_.LODETA0)))*(Inv_od-Inv_odref));
    U0_t = (U0_t*mu0_mult);
    VSAT_t = (VSAT_t*vsat_mult);
    K2_i = (K2_i+k2_stress);
    ETA0_t = (ETA0_t+eta_stress);
  }
  else
  {
    vth0_stress = 0;
  }
  if ((model_.WPEMOD))
  {
    Wdrn = (W/NF);
    local_sca = SCA;
    local_scb = SCB;
    local_scc = SCC;
    if ((((!given("SCA"))&&(!given("SCB")))&&(!given("SCC"))))
    {
      if ((given("SC")&&(SC>0.0)))
      {
        T1 = (SC+Wdrn);
        T2 = (1.0/(model_.SCREF));
        local_sca = (((model_.SCREF)*(model_.SCREF))/(SC*T1));
        local_scb = (((((0.1*SC)+(0.01*(model_.SCREF)))*exp((((-10.0)*SC)*T2)))-(((0.1*T1)+(0.01*(model_.SCREF)))*exp((((-10.0)*T1)*T2))))/Wdrn);
        local_scc = (((((0.05*SC)+(0.0025*(model_.SCREF)))*exp((((-20.0)*SC)*T2)))-(((0.05*T1)+(0.0025*(model_.SCREF)))*exp((((-20.0)*T1)*T2))))/Wdrn);
      }
      else
      {
      }
    }
  }
  vth0_well = (KVTH0WE_i*((local_sca+((model_.WEB)*local_scb))+((model_.WEC)*local_scc)));
  k2_well = (K2WE_i*((local_sca+((model_.WEB)*local_scb))+((model_.WEC)*local_scc)));
  mu_well = (1.0+(KU0WE_i*((local_sca+((model_.WEB)*local_scb))+((model_.WEC)*local_scc))));
  U0_t = (U0_t*mu_well);
  K2_i = (K2_i+k2_well);
  Vg = (devsign*(probeVars[admsProbeID_V_gi_bi]));
  Vd = (devsign*(probeVars[admsProbeID_V_di_bi]));
  Vs = (devsign*(probeVars[admsProbeID_V_si_bi]));
  Vds = (Vd-Vs);
  Vds_noswap = Vds;
  Vsb_noswap = Vs;
  Vdb_noswap = Vd;
  Vbs_jct = (devsign*(probeVars[admsProbeID_V_sbulk_si]));
  Vbd_jct = (devsign*(probeVars[admsProbeID_V_dbulk_di]));
  Vgd_noswap = (Vg-Vd);
  Vgs_noswap = (Vg-Vs);
  Vgd_ov_noswap = (devsign*(probeVars[admsProbeID_V_gm_di]));
  Vgs_ov_noswap = (devsign*(probeVars[admsProbeID_V_gm_si]));
  sigvds = 1.0;
  if ((Vds<0.0))
  {
    sigvds = (-1.0);
    Vd = (devsign*(probeVars[admsProbeID_V_si_bi]));
    Vs = (devsign*(probeVars[admsProbeID_V_di_bi]));
  }
  Vds = (Vd-Vs);
  Vdsx = (sqrt(((Vds*Vds)+0.01))-0.1);
  Vbsx = (-(Vs+(0.5*(Vds-Vdsx))));
  T0 = tanh(((0.6*Vds_noswap)/Vtm));
  wf = (0.5+(0.5*T0));
  wr = (1.0-wf);
  if (((model_.ASYMMOD)!=0))
  {
    CDSCD_a = ((CDSCDR_i*wr)+(CDSCD_i*wf));
    ETA0_a = ((ETA0R_t*wr)+(ETA0_t*wf));
    PDIBLC_a = ((PDIBLCR_i*wr)+(PDIBLC_i*wf));
    PCLM_a = ((PCLMR_i*wr)+(PCLM_i*wf));
    PSAT_a = ((PSATR_i*wr)+(PSAT_i*wf));
    VSAT_a = ((VSATR_t*wr)+(VSAT_t*wf));
    PTWG_a = ((PTWGR_t*wr)+(PTWG_t*wf));
    U0_a = ((U0R_t*wr)+(U0_t*wf));
    UA_a = ((UAR_t*wr)+(UA_t*wf));
    UC_a = ((UCR_t*wr)+(UC_t*wf));
    UD_a = ((UDR_t*wr)+(UD_t*wf));
    UCS_a = ((UCSR_t*wr)+(UCS_t*wf));
  }
  else
  {
    CDSCD_a = CDSCD_i;
    ETA0_a = ETA0_i;
    PDIBLC_a = PDIBLC_i;
    PCLM_a = PCLM_i;
    PSAT_a = PSAT_i;
    VSAT_a = VSAT_t;
    PTWG_a = PTWG_t;
    U0_a = U0_t;
    UA_a = UA_t;
    UC_a = UC_t;
    UD_a = UD_t;
    UCS_a = UCS_t;
  }
  PhistVbs = (0.5*(((Phist-Vbsx)+0.05)+sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))));
  sqrtPhistVbs = sqrt(PhistVbs);
  Xdep = (T1DEP*sqrtPhistVbs);
  Cdep = (epssi/Xdep);
  cdsc = (((CIT_i+NFACTOR_t)+(CDSCD_a*Vdsx))-(CDSCB_i*Vbsx));
  T1 = (1.0+(cdsc/Cox));
  n = (0.5*((T1+1)+sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)))));
  nVt = (n*Vt);
  inv_nVt = (1.0/nVt);
  dVth_dibl = ((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx);
  dvth_temp = (((KT1_i+((model_.KT1L)/Leff))+(KT2_i*Vbsx))*(pow(TRatio,(model_.KT1EXP))-1.0));
  dVth_dibl = ((0.5*((dVth_dibl)-sqrt((((dVth_dibl)*(dVth_dibl))+((0.25*5.0e-5)*5.0e-5)))))+(0.25*5.0e-5));
  if ((DVTP0_i>0.0))
  {
    T0 = ((-DVTP1_i)*Vdsx);
    if ((T0<(-80.0)))
    {
      T2 = 1.804851387e-35;
    }
    else
    {
      T2 = exp(T0);
    }
    T3 = (Leff+(DVTP0_i*(1.0+T2)));
    dVth_ldop = ((-nVt)*AnalogFunctions::lln<AdmsFadType>((Leff/T3)));
  }
  else
  {
    dVth_ldop = 0;
  }
  T4 = (DVTP5_i+(DVTP2_i/pow(Leff,DVTP3_i)));
  dVth_ldop = (dVth_ldop-(T4*tanh((DVTP4_i*Vdsx))));
  VFB_i = (VFB_i+(model_.DELVT0));
  vg = (Vg*inv_nVt);
  vs = (Vs*inv_nVt);
  vfb = (VFB_i*inv_nVt);
  dVth_VNUD = ((K1_i*(sqrtPhistVbs-sqrtPhist))-(K2_i*Vbsx));
  Vth_shift = (((((dVth_dibl+dVth_ldop)+dVth_VNUD)-dvth_temp)+vth0_stress)+vth0_well);
  vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
  gam = (sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_Vt))/Cox);
  q_vth = 0.5;
  T0 = AnalogFunctions::hypsmooth<AdmsFadType>(((2*phib)+(Vs*inv_Vt)),1e-3);
  nq = (1.0+(gam/(2.0*sqrt(T0))));
  psip_th = AnalogFunctions::hypsmooth<AdmsFadType>((((((Vs*inv_Vt)+(2*phib))+log(q_vth))+(2*q_vth))+log((((2*nq)/gam)*((((2*q_vth)*nq)/gam)+(2*sqrt(T0)))))),1e-3);
  VTH = (((VFB_i+((psip_th-(Vs*inv_Vt))*Vt))+((Vt*gam)*sqrt(psip_th)))+Vth_shift);
  gam = (sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))/Cox);
  inv_gam = (1.0/gam);
  phib_n = (phib/n);
  T1 = (1.0);
  vgfbPD = (vgfb/T1);
  gammaPD = (gam/T1);
  T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
  T2 = (T1+sqrt(((T1*T1)+(6.0*vgfbPD))));
  if ((vgfbPD<0.0))
  {
    T3 = ((vgfbPD-T2)/gammaPD);
    psip = (-log(((1.0-T2)+(T3*T3))));
  }
  else
  {
    T3 = exp((-T2));
    T1 = (0.5*gammaPD);
    T2 = (sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))-T1);
    psip = (((T2*T2)+1.0)-T3);
  }
  T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
  sqrtpsip = sqrt(T8);
  T9 = (1.0+(gam/(2.0*sqrtpsip)));
  T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
  T1 = ((psip-(2.0*phib_n))-vs);
  T2 = (T1-log(((4.0*T0)*sqrtpsip)));
  T8 = (0.5*((T2-0.201491)-sqrt(((T2*(T2+0.402982))+2.446562))));
  sqrtpsisa = sqrtpsip;
  if ((T8<=(-68.0)))
  {
    T4 = (-100.0);
    T5 = 20.0;
    if ((T8<(T4-(0.5*T5))))
    {
      T3 = exp(T4);
    }
    else
    {
      if ((T8>(T4+(0.5*T5))))
      {
        T3 = exp(T8);
      }
      else
      {
        T2 = ((T8-T4)/T5);
        T6 = (T2*T2);
        T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
      }
    }
    qs = (T3*(((1.0+T1)-T8)-log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
  }
  else
  {
    T3 = exp(T8);
    sqrtpsisainv = (1.0/sqrtpsisa);
    T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
    T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
    T3 = (T3-(T4/T5));
    T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
    T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
    T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
    T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
    qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
  }
  psipclamp = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))));
  sqrtpsip = sqrt(psipclamp);
  psiavg = (psip-(2.0*qs));
  T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
  nq = (1.0+(gam/(sqrtpsip+sqrt(T0))));
  EeffFactor = (1.0e-8/(epsratio*(model_.TOXE)));
  T0 = (nVt*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
  qbs = (0.5*((T0)+sqrt((((T0)*(T0))+((0.25*0.1)*0.1)))));
  qis = (((2.0*nq)*nVt)*qs);
  Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
  T2 = pow((0.5*(1.0+(qis/qbs))),UCS_a);
  T3 = (((UA_a+(UC_a*Vbsx))*pow(Eeffs,EU_i))+(UD_a/T2));
  T4 = (1.0+T3);
  Dmobs = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
  WeffWRFactor = (1.0/(pow((Weff*1.0e6),WR_i)*NF));
  if (((model_.RDSMOD)==1))
  {
    Rdss = 0.0;
  }
  else
  {
    T0 = (1.0+(PRWG_i*qis));
    T1 = (PRWB_i*(sqrtPhistVbs-sqrtPhist));
    T2 = ((1.0/T0)+T1);
    T3 = (T2+sqrt(((T2*T2)+0.01)));
    Rdss = ((((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF)*rdstemp);
    if (((model_.RDSMOD)==2))
    {
      Rdss = (((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF))+RDrainGeo)*rdstemp);
    }
  }
  T0 = pow(Dmobs,(1.0/PSAT_a));
  if ((PSATB_i<0))
  {
    T1 = (1.0/(1.0+(PSATB_i*Vbsx)));
  }
  else
  {
    T1 = (1.0-(PSATB_i*Vbsx));
  }
  T2 = ((((10.0*(model_.PSATX))*qs)*T1)/((10.0*(model_.PSATX))+(qs*T1)));
  if ((PTWG_a<0))
  {
    LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))));
  }
  else
  {
    LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)));
  }
  if ((Rdss==0))
  {
    T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
    T1 = ((2.0*LambdaC)*(qs-T0));
    T2 = sqrt((1.0+(T1*T1)));
    ln_T1_T2 = asinh(T1);
    if ((T1!=0))
    {
      T3 = (T2+((1.0/T1)*ln_T1_T2));
    }
    else
    {
      T3 = (T2+(1.0/T2));
    }
    T4 = ((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
    if ((T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
    }
    else
    {
      T5 = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
    }
    T6 = (((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0)));
    T0 = (T0-(T4/T6));
    T1 = ((2.0*LambdaC)*(qs-T0));
    T2 = sqrt((1.0+(T1*T1)));
    ln_T1_T2 = asinh(T1);
    if ((T1!=0))
    {
      T3 = (T2+((1.0/T1)*ln_T1_T2));
    }
    else
    {
      T3 = (T2+(1.0/T2));
    }
    T4 = ((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
    if ((T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
    }
    else
    {
      T5 = (((T1/T2)*(T1/T2))*(T1/T2));
    }
    T6 = (((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0)));
    qdsat = (T0-(T4/T6));
  }
  else
  {
    T11 = (((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a);
    T12 = (((T11*LambdaC)*Rdss)/(2.0*nVt));
    T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
    T1 = ((2.0*LambdaC)*(qs-T0));
    T2 = sqrt((1.0+(T1*T1)));
    ln_T1_T2 = asinh(T1);
    if ((T1!=0))
    {
      T3 = (T2+((1.0/T1)*ln_T1_T2));
    }
    else
    {
      T3 = (T2+(1.0/T2));
    }
    T4 = (((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
    if ((T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
    }
    else
    {
      T5 = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
    }
    T6 = ((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0)));
    T0 = (T0-(T4/T6));
    T1 = ((2.0*LambdaC)*(qs-T0));
    T2 = sqrt((1.0+(T1*T1)));
    ln_T1_T2 = asinh(T1);
    if ((T1!=0))
    {
      T3 = (T2+((1.0/T1)*ln_T1_T2));
    }
    else
    {
      T3 = (T2+(1.0/T2));
    }
    T4 = (((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
    if ((T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
    }
    else
    {
      T5 = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
    }
    T6 = ((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0)));
    qdsat = (T0-(T4/T6));
  }
  vdsat = ((psip-(2.0*phib_n))-((2.0*qdsat)+log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
  Vdsat = (vdsat*nVt);
  Vdssat = (0.5*(((Vdsat-Vs))+sqrt(((((Vdsat-Vs))*((Vdsat-Vs)))+((0.25*1e-3)*1e-3)))));
  T7 = pow((Vds/Vdssat),(1.0/DELTA_t));
  T8 = pow((1.0+T7),(-DELTA_t));
  Vdseff = (Vds*T8);
  vdeff = ((Vdseff+Vs)*inv_nVt);
  T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
  sqrtpsip = sqrt(T8);
  T9 = (1.0+(gam/(2.0*sqrtpsip)));
  T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
  T1 = ((psip-(2.0*phib_n))-vdeff);
  T2 = (T1-log(((4.0*T0)*sqrtpsip)));
  T8 = (0.5*((T2-0.201491)-sqrt(((T2*(T2+0.402982))+2.446562))));
  sqrtpsisa = sqrtpsip;
  if ((T8<=(-68.0)))
  {
    T4 = (-100.0);
    T5 = 20.0;
    if ((T8<(T4-(0.5*T5))))
    {
      T3 = exp(T4);
    }
    else
    {
      if ((T8>(T4+(0.5*T5))))
      {
        T3 = exp(T8);
      }
      else
      {
        T2 = ((T8-T4)/T5);
        T6 = (T2*T2);
        T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
      }
    }
    qdeff = (T3*(((1.0+T1)-T8)-log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
  }
  else
  {
    T3 = exp(T8);
    sqrtpsisainv = (1.0/sqrtpsisa);
    T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
    T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
    T3 = (T3-(T4/T5));
    T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
    T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
    T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
    T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
    qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
  }
  psiavg = (((psip-qs)-qdeff)-1.0);
  T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
  T2 = sqrt(T0);
  nq = (1.0+(gam/(sqrtpsip+T2)));
  DQSD2 = ((qs-qdeff)*(qs-qdeff));
  T0 = (1.0/((1.0+qs)+qdeff));
  T1 = (DQSD2*T0);
  Qb = ((vgfb-psip)-((nq-1.0)*((qs+qdeff)+(0.33333333333333333*T1))));
  T2 = (0.33333333333333333*nq);
  T3 = (T1*T0);
  Qs = (T2*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
  Qd = (T2*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
  qba = (0.5*(((nVt*Qb))+sqrt(((((nVt*Qb))*((nVt*Qb)))+((0.25*0.1)*0.1)))));
  qia = (nVt*(Qs+Qd));
  Eeffm = (EeffFactor*(qba+(eta_mu*qia)));
  T2 = pow((0.5*(1.0+(qia/qba))),UCS_a);
  T3 = (((UA_a+(UC_a*Vbsx))*pow(Eeffm,EU_i))+(UD_a/T2));
  T4 = (1.0+T3);
  Dmob = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
  Esat = ((2.0*VSAT_a)/(U0_a/Dmob));
  EsatL = (Esat*Leff);
  if ((PVAG_i>0))
  {
    PVAGfactor = (1.0+((PVAG_i*qia)/EsatL));
  }
  else
  {
    PVAGfactor = (1.0/(1.0-((PVAG_i*qia)/EsatL)));
  }
  DIBLfactor = PDIBLC_a;
  diffVds = (Vds-Vdseff);
  Vgst2Vtm = (qia+(2.0*nVt));
  if ((DIBLfactor>0))
  {
    T3 = (Vgst2Vtm/(Vdssat+Vgst2Vtm));
    T4 = AnalogFunctions::hypsmooth<AdmsFadType>((1.0+(PDIBLCB_i*Vbsx)),1e-3);
    T5 = (1/T4);
    VaDIBL = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5);
    Moc = (1.0+(diffVds/VaDIBL));
  }
  else
  {
    Moc = 1.0;
  }
  if ((FPROUT_i<=0.0))
  {
    Fp = 1.0;
  }
  else
  {
    T9 = ((FPROUT_i*sqrt(Leff))/Vgst2Vtm);
    Fp = (1.0/(1.0+T9));
  }
  Vasat = (Vdssat+EsatL);
  if ((PCLM_a!=0))
  {
    if (((model_.PCLMG)<0.0))
    {
      T1 = ((PCLM_a/(1.0-(((model_.PCLMG)*qia)/EsatL)))/Fp);
    }
    else
    {
      T1 = ((PCLM_a*(1.0+(((model_.PCLMG)*qia)/EsatL)))/Fp);
    }
    MdL = (1.0+(T1*AnalogFunctions::lln<AdmsFadType>((1.0+((diffVds/T1)/Vasat)))));
  }
  else
  {
    MdL = 1.0;
  }
  Moc = (Moc*MdL);
  T1 = AnalogFunctions::lexp<AdmsFadType>((PDITSD_i*Vds));
  if ((PDITS_i>0.0))
  {
    T2 = (1.0+((model_.PDITSL)*Leff));
    VaDITS = ((1.0+(T2*T1))/PDITS_i);
    VaDITS = (VaDITS*Fp);
  }
  else
  {
    VaDITS = 5.540622384e+34;
  }
  T4 = (diffVds/VaDITS);
  T0 = (1.0+T4);
  Moc = (Moc*T0);
  if ((PSCBE2_i>0.0))
  {
    if ((diffVds>((PSCBE1_i*litl)/80.0)))
    {
      T0 = ((PSCBE1_i*litl)/diffVds);
      VaSCBE = ((Leff*exp(T0))/PSCBE2_i);
    }
    else
    {
      VaSCBE = ((5.540622384e+34*Leff)/PSCBE2_i);
    }
  }
  else
  {
    VaSCBE = 5.540622384e+34;
  }
  Mscbe = (1.0+(diffVds/VaSCBE));
  Moc = (Moc*Mscbe);
  T0 = pow(Dmob,(1.0/PSAT_a));
  if ((PSATB_i<0))
  {
    T1 = (1.0/(1.0+(PSATB_i*Vbsx)));
  }
  else
  {
    T1 = (1.0-(PSATB_i*Vbsx));
  }
  T2 = ((((10.0*(model_.PSATX))*qia)*T1)/((10.0*(model_.PSATX))+(qia*T1)));
  if ((PTWG_a<0))
  {
    LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))));
  }
  else
  {
    LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)));
  }
  T1 = ((2.0*LambdaC)*(qs-qdeff));
  T2 = sqrt((1.0+(T1*T1)));
  if ((T1!=0))
  {
    Dvsat = (0.5*(T2+((1.0/T1)*asinh(T1))));
  }
  else
  {
    Dvsat = (0.5*(T2+(1.0/T2)));
  }
  Dptwg = Dvsat;
  Rsource = 0.0;
  Rdrain = 0.0;
  if (((model_.RDSMOD)==1))
  {
    Rdsi = 0.0;
    Dr = 1.0;
    T2 = (Vgs_noswap-Vfbsdr);
    T3 = sqrt(((T2*T2)+0.01));
    Vgs_eff = (0.5*(T2+T3));
    T5 = (1.0+(PRWG_i*Vgs_eff));
    T6 = ((1.0/T5)+(PRWB_i*Vsb_noswap));
    T4 = (0.5*(T6+sqrt(((T6*T6)+0.01))));
    Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(RSW_i*T4))*WeffWRFactor)));
    T2 = (Vgd_noswap-Vfbsdr);
    T3 = sqrt(((T2*T2)+0.01));
    Vgd_eff = (0.5*(T2+T3));
    T5 = (1.0+(PRWG_i*Vgd_eff));
    T6 = ((1.0/T5)+(PRWB_i*Vdb_noswap));
    T4 = (0.5*(T6+sqrt(((T6*T6)+0.01))));
    Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(RDW_i*T4))*WeffWRFactor)));
  }
  else
  {
    T0 = (1.0+(PRWG_i*qia));
    T1 = (PRWB_i*(sqrtPhistVbs-sqrtPhist));
    T2 = ((1.0/T0)+T1);
    T3 = (0.5*(T2+sqrt(((T2*T2)+0.01))));
    Rdsi = (((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*NF);
    Rdrain = RDrainGeo;
    Rsource = RSourceGeo;
    Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi));
    if (((model_.RDSMOD)==2))
    {
      Rdsi = (rdstemp*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF))+RDrainGeo));
      Rdrain = 0;
      Rsource = 0;
      Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi));
    }
  }
  T0 = (A1_t+(A2_t/(qia+((2.0*n)*Vtm))));
  DQSD = (qs-qdeff);
  T1 = ((T0*DQSD)*DQSD);
  T2 = ((T1+1.0)-0.001);
  T3 = ((-1.0)+(0.5*(T2+sqrt(((T2*T2)+0.004)))));
  Nsat = (0.5*(1.0+sqrt((1.0+T3))));
  Dtot = ((Dmob*Dvsat)*Dr);
  ueff = (U0_a/Dtot);
  ids = (((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat);
  Gcrg = 0.0;
  if ((RGATEMOD>1))
  {
    idsovvds = ((((ueff*Weff)/Leff)*Cox)*qia);
    T9 = ((model_.XRCRG2)*Vt);
    T0 = ((((T9*ueff)*Weff)/Leff)*Cox);
    Gcrg = (((model_.XRCRG1)*NF)*(T0+idsovvds));
    if ((RGATEMOD==2))
    {
      T11 = (Grgeltd+Gcrg);
      Gcrg = ((Grgeltd*Gcrg)/T11);
    }
  }
  if (((ALPHA0_i<=0.0)||(BETA0_t<=0.0)))
  {
    Iii = 0.0;
  }
  else
  {
    if ((diffVds>(BETA0_t/80.0)))
    {
      T1 = ((-BETA0_t)/diffVds);
      Iii = ((((ALPHA0_i*diffVds)*ids)*AnalogFunctions::lexp<AdmsFadType>(T1))/Mscbe);
    }
    else
    {
      Iii = ((((ALPHA0_i*diffVds)*ids)*1.804851387e-35)/Mscbe);
    }
  }
  ISUB = (Iii*devsign);
  igbinv = 0.0;
  igbacc = 0.0;
  igb = 0.0;
  igcs = 0.0;
  igcd = 0.0;
  igs = 0.0;
  igd = 0.0;
  if ((((model_.IGCMOD)!=0)||((model_.IGBMOD)!=0)))
  {
    Voxm = (nVt*(((vgfb-psip)+qs)+qdeff));
    T1 = sqrt(((Voxm*Voxm)+1.0E-4));
    Voxmacc = (0.5*((-Voxm)+T1));
    Voxminv = (0.5*(Voxm+T1));
    if (((model_.IGBMOD)!=0))
    {
      T1 = ((Voxmacc/NIGBACC_i)/Vt);
      Vaux_Igbacc = ((NIGBACC_i*Vt)*AnalogFunctions::lln<AdmsFadType>((1+AnalogFunctions::lexp<AdmsFadType>((-T1)))));
      T2 = (AIGBACC_i-(BIGBACC_i*Voxmacc));
      T3 = (1.0+(CIGBACC_i*Voxmacc));
      T4 = ((((-7.45669e11)*(model_.TOXE))*T2)*T3);
      T5 = AnalogFunctions::lexp<AdmsFadType>(T4);
      T6 = 4.97232e-7;
      igbacc = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5);
      igbacc = (igbacc*igtemp);
      T1 = (((Voxminv-EIGBINV_i)/NIGBINV_i)/Vt);
      Vaux_Igbinv = ((NIGBINV_i*Vt)*AnalogFunctions::lln<AdmsFadType>((1.0+AnalogFunctions::lexp<AdmsFadType>(T1))));
      T2 = (AIGBINV_i-(BIGBINV_i*Voxminv));
      T3 = (1.0+(CIGBINV_i*Voxminv));
      T4 = ((((-9.82222e11)*(model_.TOXE))*T2)*T3);
      T5 = AnalogFunctions::lexp<AdmsFadType>(T4);
      T6 = 3.75956e-7;
      igbinv = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5);
      igbinv = (igbinv*igtemp);
      igb = (igbacc+igbinv);
    }
    if (((model_.IGCMOD)!=0))
    {
      T1 = (AIGC_i-(BIGC_i*Voxminv));
      T2 = (1.0+(CIGC_i*Voxminv));
      T3 = ((Bechvb*T1)*T2);
      T4 = (((nq*nVt)*(qs+qdeff))*AnalogFunctions::lexp<AdmsFadType>(T3));
      igc0 = ((((NF*Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp);
      Vdseffx = (sqrt(((Vdseff*Vdseff)+0.01))-0.1);
      T1 = (PIGCD_i*Vdseffx);
      T1_exp = AnalogFunctions::lexp<AdmsFadType>((-T1));
      T3 = (((T1+T1_exp)-1.0)+1.0E-4);
      T4 = ((1.0-((T1+1.0)*T1_exp))+1.0E-4);
      T5 = ((T1*T1)+2.0E-4);
      if ((sigvds>0))
      {
        igcd = ((igc0*T4)/T5);
        igcs = ((igc0*T3)/T5);
      }
      else
      {
        igcs = ((igc0*T4)/T5);
        igcd = ((igc0*T3)/T5);
      }
      T2 = (Vgs_noswap-Vfbsdr);
      Vgs_eff = sqrt(((T2*T2)+1.0e-4));
      T1 = (AIGS_i-(BIGS_i*Vgs_eff));
      T2 = (1.0+(CIGS_i*Vgs_eff));
      T3 = ((BechvbEdge*T1)*T2);
      T4 = AnalogFunctions::lexp<AdmsFadType>(T3);
      igs_mult = (((igtemp*NF)*AechvbEdge)*DLCIG_i);
      igs = (((igs_mult*Vgs_noswap)*Vgs_eff)*T4);
      T2 = (Vgd_noswap-Vfbsdr);
      Vgd_eff = sqrt(((T2*T2)+1.0e-4));
      T1 = (AIGD_i-(BIGD_i*Vgd_eff));
      T2 = (1.0+(CIGD_i*Vgd_eff));
      T3 = ((BechvbEdge*T1)*T2);
      T4 = AnalogFunctions::lexp<AdmsFadType>(T3);
      igd_mult = (((igtemp*NF)*AechvbEdge)*DLCIGD_i);
      igd = (((igd_mult*Vgd_noswap)*Vgd_eff)*T4);
    }
  }
  IGS = (devsign*igs);
  IGD = (devsign*igd);
  IGB = (devsign*igb);
  IGCS = (devsign*igcs);
  IGCD = (devsign*igcd);
  igisl = 0.0;
  igidl = 0.0;
  if (((model_.GIDLMOD)!=0))
  {
    T0 = (epsratio*(model_.TOXE));
    if ((((AGIDL_i<=0.0)||(BGIDL_t<=0.0))||(CGIDL_i<0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      T1 = ((((-Vgd_noswap)-EGIDL_i)+Vfbsdr)/T0);
      T1 = AnalogFunctions::hypsmooth<AdmsFadType>(T1,1.0E-2);
      T2 = (BGIDL_t/(T1+1.0E-3));
      if ((CGIDL_i!=0))
      {
        T3 = ((Vdb_noswap*Vdb_noswap)*Vdb_noswap);
        T4 = ((CGIDL_i+fabs(T3))+1.0E-9);
        T5 = (AnalogFunctions::hypsmooth<AdmsFadType>((T3/T4),1.0E-6)-1.0E-6);
      }
      else
      {
        T5 = 1.0;
      }
      T6 = ((((AGIDL_i*Weff)*T1)*AnalogFunctions::lexp<AdmsFadType>((-T2)))*T5);
    }
    igidl = T6;
    if ((((AGISL_i<=0.0)||(BGISL_t<=0.0))||(CGISL_i<0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      T1 = ((((-Vgs_noswap)-EGISL_i)+Vfbsdr)/T0);
      T1 = AnalogFunctions::hypsmooth<AdmsFadType>(T1,1.0E-2);
      T2 = (BGISL_t/(T1+1.0E-3));
      if ((CGISL_i!=0))
      {
        T3 = ((Vsb_noswap*Vsb_noswap)*Vsb_noswap);
        T4 = ((CGISL_i+fabs(T3))+1.0E-9);
        T5 = (AnalogFunctions::hypsmooth<AdmsFadType>((T3/T4),1.0E-6)-1.0E-6);
      }
      else
      {
        T5 = 1.0;
      }
      T6 = ((((AGISL_i*Weff)*T1)*AnalogFunctions::lexp<AdmsFadType>((-T2)))*T5);
    }
    igisl = T6;
  }
  IGIDL = ((devsign*NF)*igidl);
  IGISL = ((devsign*NF)*igisl);
  if ((Isbs>0.0))
  {
    if ((Vbs_jct<VjsmRev))
    {
      T0 = (Vbs_jct/Nvtms);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(T0)-1.0);
      T2 = (IVjsmRev+(SslpRev*(Vbs_jct-VjsmRev)));
      Ibs = (T1*T2);
    }
    else
    {
      if ((Vbs_jct<=VjsmFwd))
      {
        T0 = (Vbs_jct/Nvtms);
        T1 = (((model_.BVS)+Vbs_jct)/Nvtms);
        T2 = AnalogFunctions::lexp<AdmsFadType>((-T1));
        Ibs = (Isbs*(((AnalogFunctions::lexp<AdmsFadType>(T0)+XExpBVS)-1.0)-((model_.XJBVS)*T2)));
      }
      else
      {
        Ibs = (IVjsmFwd+(SslpFwd*(Vbs_jct-VjsmFwd)));
      }
    }
  }
  else
  {
    Ibs = 0.0;
  }
  if ((JTSS_t>0.0))
  {
    if ((((model_.VTSS)-Vbs_jct)<((model_.VTSS)*1.0e-3)))
    {
      T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e+3))-1.0);
      Ibs = (Ibs-((ASeff*JTSS_t)*T1));
    }
    else
    {
      T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)))-1.0);
      Ibs = (Ibs-((ASeff*JTSS_t)*T1));
    }
  }
  if ((JTSSWS_t>0.0))
  {
    if ((((model_.VTSSWS)-Vbs_jct)<((model_.VTSSWS)*1.0e-3)))
    {
      T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e+3))-1.0);
      Ibs = (Ibs-((PSeff*JTSSWS_t)*T1));
    }
    else
    {
      T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)))-1.0);
      Ibs = (Ibs-((PSeff*JTSSWS_t)*T1));
    }
  }
  if ((JTSSWGS_t>0.0))
  {
    if ((((model_.VTSSWGS)-Vbs_jct)<((model_.VTSSWGS)*1.0e-3)))
    {
      T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e+3))-1.0);
      Ibs = (Ibs-(((Weffcj*NF)*JTSSWGS_t)*T1));
    }
    else
    {
      T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)))-1.0);
      Ibs = (Ibs-(((Weffcj*NF)*JTSSWGS_t)*T1));
    }
  }
  if ((Isbd>0.0))
  {
    if ((Vbd_jct<VjdmRev))
    {
      T0 = (Vbd_jct/Nvtmd);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(T0)-1.0);
      T2 = (IVjdmRev+(DslpRev*(Vbd_jct-VjdmRev)));
      Ibd = (T1*T2);
    }
    else
    {
      if ((Vbd_jct<=VjdmFwd))
      {
        T0 = (Vbd_jct/Nvtmd);
        T1 = (((model_.BVD)+Vbd_jct)/Nvtmd);
        T2 = AnalogFunctions::lexp<AdmsFadType>((-T1));
        Ibd = (Isbd*(((AnalogFunctions::lexp<AdmsFadType>(T0)+XExpBVD)-1.0)-((model_.XJBVD)*T2)));
      }
      else
      {
        Ibd = (IVjdmFwd+(DslpFwd*(Vbd_jct-VjdmFwd)));
      }
    }
  }
  else
  {
    Ibd = 0.0;
  }
  if ((JTSD_t>0.0))
  {
    if ((((model_.VTSD)-Vbd_jct)<((model_.VTSD)*1.0e-3)))
    {
      T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e+3))-1.0);
      Ibd = (Ibd-((ADeff*JTSD_t)*T1));
    }
    else
    {
      T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)))-1.0);
      Ibd = (Ibd-((ADeff*JTSD_t)*T1));
    }
  }
  if ((JTSSWD_t>0.0))
  {
    if ((((model_.VTSSWD)-Vbd_jct)<((model_.VTSSWD)*1.0e-3)))
    {
      T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e+3))-1.0);
      Ibd = (Ibd-((PDeff*JTSSWD_t)*T1));
    }
    else
    {
      T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)))-1.0);
      Ibd = (Ibd-((PDeff*JTSSWD_t)*T1));
    }
  }
  if ((JTSSWGD_t>0.0))
  {
    if ((((model_.VTSSWGD)-Vbd_jct)<((model_.VTSSWGD)*1.0e-3)))
    {
      T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>((T0*1.0e+3))-1.0);
      Ibd = (Ibd-(((Weffcj*NF)*JTSSWGD_t)*T1));
    }
    else
    {
      T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
      T1 = (AnalogFunctions::lexp<AdmsFadType>(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)))-1.0);
      Ibd = (Ibd-(((Weffcj*NF)*JTSSWGD_t)*T1));
    }
  }
  if ((Czbs>0.0))
  {
    T1 = (Vbs_jct/PBS_t);
    if ((T1<0.9))
    {
      arg = (1.0-T1);
      if (((model_.MJS)==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJS))*AnalogFunctions::lln<AdmsFadType>(arg)));
      }
      Qbs = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
    }
    else
    {
      T2 = pow(0.1,(-(model_.MJS)));
      T3 = (1.0/(1.0-(model_.MJS)));
      T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
      T5 = (T3*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
      Qbs = ((PBS_t*Czbs)*(T4+T5));
    }
  }
  else
  {
    Qbs = 0.0;
  }
  if ((Czbssw>0.0))
  {
    T1 = (Vbs_jct/PBSWS_t);
    if ((T1<0.9))
    {
      arg = (1.0-T1);
      if (((model_.MJSWS)==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWS))*AnalogFunctions::lln<AdmsFadType>(arg)));
      }
      Qbs = (Qbs+(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS))));
    }
    else
    {
      T2 = pow(0.1,(-(model_.MJSWS)));
      T3 = (1.0/(1.0-(model_.MJSWS)));
      T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
      T5 = (T3*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
      Qbs = (Qbs+((PBSWS_t*Czbssw)*(T4+T5)));
    }
  }
  if ((Czbsswg>0.0))
  {
    T1 = (Vbs_jct/PBSWGS_t);
    if ((T1<0.9))
    {
      arg = (1.0-T1);
      if (((model_.MJSWGS)==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGS))*AnalogFunctions::lln<AdmsFadType>(arg)));
      }
      Qbs = (Qbs+(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS))));
    }
    else
    {
      T2 = pow(0.1,(-(model_.MJSWGS)));
      T3 = (1.0/(1.0-(model_.MJSWGS)));
      T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
      T5 = (T3*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
      Qbs = (Qbs+((PBSWGS_t*Czbsswg)*(T4+T5)));
    }
  }
  if ((Czbd>0.0))
  {
    T1 = (Vbd_jct/PBD_t);
    if ((T1<0.9))
    {
      arg = (1.0-T1);
      if (((model_.MJD)==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJD))*AnalogFunctions::lln<AdmsFadType>(arg)));
      }
      Qbd = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
    }
    else
    {
      T2 = pow(0.1,(-(model_.MJD)));
      T3 = (1.0/(1.0-(model_.MJD)));
      T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
      T5 = (T3*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
      Qbd = ((PBD_t*Czbd)*(T4+T5));
    }
  }
  else
  {
    Qbd = 0.0;
  }
  if ((Czbdsw>0.0))
  {
    T1 = (Vbd_jct/PBSWD_t);
    if ((T1<0.9))
    {
      arg = (1.0-T1);
      if (((model_.MJSWD)==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWD))*AnalogFunctions::lln<AdmsFadType>(arg)));
      }
      Qbd = (Qbd+(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD))));
    }
    else
    {
      T2 = pow(0.1,(-(model_.MJSWD)));
      T3 = (1.0/(1.0-(model_.MJSWD)));
      T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
      T5 = (T3*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
      Qbd = (Qbd+((PBSWD_t*Czbdsw)*(T4+T5)));
    }
  }
  if ((Czbdswg>0.0))
  {
    T1 = (Vbd_jct/PBSWGD_t);
    if ((T1<0.9))
    {
      arg = (1.0-T1);
      if (((model_.MJSWGD)==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsFadType>(((-(model_.MJSWGD))*AnalogFunctions::lln<AdmsFadType>(arg)));
      }
      Qbd = (Qbd+(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD))));
    }
    else
    {
      T2 = pow(0.1,(-(model_.MJSWGD)));
      T3 = (1.0/(1.0-(model_.MJSWGD)));
      T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
      T5 = (T3*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
      Qbd = (Qbd+((PBSWGD_t*Czbdswg)*(T4+T5)));
    }
  }
  Nt = ((4.0*Vt)*1.60219e-19);
  if (((model_.LINTNOI)>=(Leff/2.0)))
  {
    std::cerr  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << (model_.LINTNOI) <<  std::endl; 
    LINTNOI_i = 0;
  }
  else
  {
    LINTNOI_i = (model_.LINTNOI);
  }
  Esatnoi = ((2.0*VSAT_a)/ueff);
  if (((((model_.NOIA)>0)||((model_.NOIB)>0))||((model_.NOIC)>0)))
  {
    Leffnoi = (Leff-(2.0*LINTNOI_i));
    Leffnoisq = (Leffnoi*Leffnoi);
    if (((model_.EM)<=0.0))
    {
      DelClm = 0.0;
    }
    else
    {
      T0 = (((diffVds/litl)+(model_.EM))/Esatnoi);
      DelClm = (litl*AnalogFunctions::lln<AdmsFadType>(T0));
      if ((DelClm<0.0))
      {
        DelClm = 0.0;
      }
    }
    T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*fabs(ids))*ueff);
    T2 = ((1.0e10*Cox)*Leffnoisq);
    N0 = (((((2.0*nq)*Cox)*Vt)*qs)/1.60219e-19);
    Nl = (((((2.0*nq)*Cox)*Vt)*qdeff)/1.60219e-19);
    Nstar = ((Vt/1.60219e-19)*((Cox+Cdep)+(model_.CIT)));
    T3 = ((model_.NOIA)*AnalogFunctions::lln<AdmsFadType>(((N0+Nstar)/(Nl+Nstar))));
    T4 = ((model_.NOIB)*(N0-Nl));
    T5 = ((0.5*(model_.NOIC))*((N0*N0)-(Nl*Nl)));
    T6 = (((1.60219e-19*Vt)*ids)*ids);
    T7 = (((1.0e10*Leffnoisq)*Weff)*NF);
    T8 = (((model_.NOIA)+((model_.NOIB)*Nl))+(((model_.NOIC)*Nl)*Nl));
    T9 = ((Nl+Nstar)*(Nl+Nstar));
    Ssi = (((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
    T10 = (((model_.NOIA)*1.60219e-19)*Vt);
    T11 = (((((Weff*NF)*Leffnoi)*1.0e10)*Nstar)*Nstar);
    Swi = (((T10/T11)*ids)*ids);
    T1 = (Swi+Ssi);
    if ((T1>0.0))
    {
      FNPowerAt1Hz = ((Ssi*Swi)/T1);
    }
    else
    {
      FNPowerAt1Hz = 0.0;
    }
  }
  else
  {
    FNPowerAt1Hz = 0.0;
  }
  // I(di,si) <+ (flicker_noise(FNPowerAt1Hz,EF,"1overf"))
  if (getSolverState().noiseFlag)
  {
    noiseContribsPower[0]= FNPowerAt1Hz.val();
    noiseContribsExponent[0]= (model_.EF);
  }
  T0 = ((qia/Esatnoi)/Leff);
  T1 = (T0*T0);
  T3 = ((model_.RNOIA)*(1.0+(((model_.TNOIA)*Leff)*T1)));
  T4 = ((model_.RNOIB)*(1.0+(((model_.TNOIB)*Leff)*T1)));
  ctnoi = ((model_.RNOIC)*(1.0+(((model_.TNOIC)*Leff)*T1)));
  betanoisq = (T3*T3);
  thetanoisq = (T4*T4);
  cm_igid = 0;
  if ( (model_.TNOIMOD) == (0))
  {
    QSi = ((((((-NF)*Weff)*Leff)*Cox)*Vt)*Qs);
    QDi = ((((((-NF)*Weff)*Leff)*Cox)*Vt)*Qd);
    T0 = (ueff*fabs((QSi+QDi)));
    T1 = ((T0*Rdsi)+(Leff*Leff));
    Gtnoi = ((T0/T1)*(model_.NTNOI));
    sidn = (Nt*Gtnoi);
    // I(di,si) <+ (white_noise(sidn,"id"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[1]= sidn.val();
    }
  }
  else
    if ( (model_.TNOIMOD) == (1))
    {
      Vtn = ((2.0*nq)*nVt);
      T0 = ((((ueff*Dptwg)*Moc)*Cox)*Vtn);
      T1 = (0.5*(qs+qdeff));
      T3 = (T1+0.5);
      T4 = (T3*T3);
      T5 = (T4*T3);
      T6 = (qs-qdeff);
      T7 = (T6*T6);
      T8 = (T7*T6);
      T9 = (((6.0*T1)+0.5)*T7);
      Lvsat = (Leff*Dptwg);
      T10 = (Lvsat/Leff);
      mid = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*betanoisq);
      mig = (((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)/(((NF*Weff)*12.0)*T0));
      migid = (((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395);
      sqid = sqrt((Nt*mid));
      if ((mig==0))
      {
        sqig = 0.0;
        cm_igid = 0.0;
      }
      else
      {
        sqig = sqrt((Nt/mig));
        if ((sqid==0))
        {
          cm_igid = 0.0;
        }
        else
        {
          cm_igid = ((migid*sqig)/sqid);
        }
      }
      // I(N2,GND) <+ (white_noise(cm_igid,"corl"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[2]= cm_igid.val();
      }
      // I(N1,GND) <+ (white_noise(((sqig*sqig)*(1.0-cm_igid)),"corl"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[3]= ((sqig.val()*sqig.val())*(1.0-cm_igid.val()));
      }
      // I(N1,GND) <+ (((-sqig)*V(N2,GND)))
      staticContributions[admsNodeID_N1] += ((-sqig)*(probeVars[admsProbeID_V_N2_GND]));
      // I(N1,GND) <+ (ddt((((((mig*Cox)*Weff)*NF)*Leff)*V(N1,GND))))
      dynamicContributions[admsNodeID_N1] += ((((((mig*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND])));
      // I(di,si) <+ (white_noise(((sqid*sqid)*(1.0-cm_igid)),"id"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[4]= ((sqid.val()*sqid.val())*(1.0-cm_igid.val()));
      }
      // I(di,si) <+ ((sqid*V(N2,GND)))
      staticContributions[admsNodeID_di] += (sqid*(probeVars[admsProbeID_V_N2_GND]));
      staticContributions[admsNodeID_si] -= (sqid*(probeVars[admsProbeID_V_N2_GND]));
      // I(gi,si) <+ (ddt((0.5*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
      dynamicContributions[admsNodeID_gi] += ((0.5*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
      dynamicContributions[admsNodeID_si] -= ((0.5*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
      // I(gi,di) <+ (ddt((0.5*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
      dynamicContributions[admsNodeID_gi] += ((0.5*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
      dynamicContributions[admsNodeID_di] -= ((0.5*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
    }
    else
    {
      // no default
    }
  // I(N2,GND) <+ (V(N2,GND))
  staticContributions[admsNodeID_N2] += (probeVars[admsProbeID_V_N2_GND]);
  // I(N1,GND) <+ (V(N1,GND))
  staticContributions[admsNodeID_N1] += (probeVars[admsProbeID_V_N1_GND]);
  if (((model_.IGCMOD)!=0))
  {
    // I(gi,si) <+ (white_noise(((2.0*1.60219e-19)*abs((igcs+igs))),"igs"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[5]= ((2.0*1.60219e-19)*fabs((igcs.val()+igs.val())));
    }
    // I(gi,di) <+ (white_noise(((2.0*1.60219e-19)*abs((igcd+igd))),"igd"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[6]= ((2.0*1.60219e-19)*fabs((igcd.val()+igd.val())));
    }
  }
  if (((model_.IGBMOD)!=0))
  {
    // I(gi,bi) <+ (white_noise(((2.0*1.60219e-19)*abs(igb)),"igb"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[7]= ((2.0*1.60219e-19)*fabs(igb.val()));
    }
  }
  vgfbCV = vgfb;
  gamg2 = ((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt));
  invgamg2 = adms_ternary_op<AdmsFadType>((NGATE_i>0),(1.0/gamg2),0.0);
  if (((model_.CVMOD)==1))
  {
    VFBCV_i = (VFBCV_i+(model_.DELVT0));
    vg = (Vg*inv_Vt);
    vs = (Vs*inv_Vt);
    vfb = (VFBCV_i*inv_Vt);
    vgfbCV = (vg-vfb);
    phib = log((NDEPCV_i/ni));
    gam = (sqrt(((((2.0*1.60219e-19)*epssi)*NDEPCV_i)*inv_Vt))/Cox);
    inv_gam = (1.0/gam);
    gamg2 = ((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt));
    invgamg2 = adms_ternary_op<AdmsFadType>((NGATE_i>0),(1.0/gamg2),0.0);
    DPD = ((NGATE_i>0)?(NDEPCV_i/NGATE_i):0.0);
    T1 = (1.0+DPD);
    vgfbPD = (vgfbCV/T1);
    gammaPD = (gam/T1);
    T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
    T2 = (T1+sqrt(((T1*T1)+(6.0*vgfbPD))));
    if ((vgfbPD<0.0))
    {
      T3 = ((vgfbPD-T2)/gammaPD);
      psip = (-log(((1.0-T2)+(T3*T3))));
    }
    else
    {
      T3 = exp((-T2));
      T1 = (0.5*gammaPD);
      T2 = (sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))-T1);
      psip = (((T2*T2)+1.0)-T3);
    }
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    T1 = ((psip-(2.0*phib))-vs);
    T2 = (T1-log(((4.0*T0)*sqrtpsip)));
    T8 = (0.5*((T2-0.201491)-sqrt(((T2*(T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          T2 = ((T8-T4)/T5);
          T6 = (T2*T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qs = (T3*(((1.0+T1)-T8)-log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
      qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    psipclamp = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))));
    sqrtpsip = sqrt(psipclamp);
    psiavg = (psip-(2.0*qs));
    T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
    nq = (1.0+(gam/(sqrtpsip+sqrt(T0))));
    T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
    qbs = (0.5*((T0)+sqrt((((T0)*(T0))+((0.25*0.1)*0.1)))));
    qis = (((2.0*nq)*Vt)*qs);
    Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
    T3 = ((UA_a+(UC_a*Vbsx))*pow(Eeffs,EU_i));
    T4 = (1.0+T3);
    Dmobs = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
    LambdaC_by2 = (((U0_a/Dmobs)*Vt)/(VSATCV_t*Lact));
    qdsat = ((LambdaC_by2*((qs*qs)+qs))/(1.0+(LambdaC_by2*(1.0+qs))));
    vdsatcv = ((psip-(2.0*phib))-((2.0*qdsat)+log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
    VdsatCV = (vdsatcv*Vt);
    VdssatCV = (0.5*(((VdsatCV-Vs))+sqrt(((((VdsatCV-Vs))*((VdsatCV-Vs)))+((0.25*1e-3)*1e-3)))));
    T7 = pow((Vds/VdssatCV),(1.0/DELTA_t));
    T8 = pow((1.0+T7),(-DELTA_t));
    Vdseff = (Vds*T8);
    vdeff = ((Vdseff+Vs)*inv_Vt);
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    T1 = ((psip-(2.0*phib))-vdeff);
    T2 = (T1-log(((4.0*T0)*sqrtpsip)));
    T8 = (0.5*((T2-0.201491)-sqrt(((T2*(T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          T2 = ((T8-T4)/T5);
          T6 = (T2*T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qdeff = (T3*(((1.0+T1)-T8)-log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
      qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    psiavg = (((psip-qs)-qdeff)-1.0);
    T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
    T2 = sqrt(T0);
    T3 = ((1.0+DPD)+(gam/(sqrtpsip+T2)));
    T4 = (0.5+((DPD*T2)*inv_gam));
    T5 = sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)));
    nq = (T3/(T4+T5));
    T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
    qbs = (0.5*((T0)+sqrt((((T0)*(T0))+((0.25*0.1)*0.1)))));
    T1 = (Vt*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
    qbd = (0.5*((T1)+sqrt((((T1)*(T1))+((0.25*0.1)*0.1)))));
    qb = (0.5*(qbs+qbd));
    qia = ((nq*Vt)*(qs+qdeff));
    Eeffm = (EeffFactor*(qb+(eta_mu*qia)));
    T3 = ((UA_a+(UC_a*Vbsx))*pow(Eeffm,EU_i));
    T4 = (1.0+T3);
    Dmob = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
    LambdaC = (((2.0*(U0_a/Dmob))*Vt)/(VSATCV_t*Lact));
    dps = (qs-qdeff);
    T1 = ((2.0*(LambdaC*dps))*(LambdaC*dps));
    zsat = sqrt((1.0+T1));
    Dvsat = (0.5*(1.0+zsat));
    Esat = ((2.0*VSATCV_t)/(U0_a/Dmob));
    EsatL = (Esat*Lact);
    Vasat = (VdssatCV+EsatL);
    diffVds = (Vds-Vdseff);
  }
  if ((PCLMCV_i!=0))
  {
    MdL = (1.0+(PCLMCV_i*AnalogFunctions::lln<AdmsFadType>((1.0+((diffVds/PCLMCV_i)/Vasat)))));
  }
  else
  {
    MdL = 1.0;
  }
  MdL_2 = (MdL*MdL);
  inv_MdL = (1.0/MdL);
  inv_MdL_2 = (1.0/MdL_2);
  MdL_less_1 = (MdL-1.0);
  vgpqm = (vgfbCV-psip);
  DQSD = (qs-qdeff);
  DQSD2 = ((qs-qdeff)*(qs-qdeff));
  sis = (vgpqm+(2.0*qs));
  sid = (vgpqm+(2.0*qdeff));
  T1 = (0.5*((sis)+sqrt((((sis)*(sis))+((0.25*0.5)*0.5)))));
  T2 = (0.5*((sid)+sqrt((((sid)*(sid))+((0.25*0.5)*0.5)))));
  Temps = sqrt((0.25+(T1*invgamg2)));
  Tempd = sqrt((0.25+(T2*invgamg2)));
  T1 = (sis/(1.0+(2.0*Temps)));
  T2 = (sid/(1.0+(2.0*Tempd)));
  T3 = (Temps+Tempd);
  T4 = (0.33333333333333333*(DQSD2/((T3*T3)*T3)));
  T5 = ((Dvsat*inv_MdL)/((1.0+qs)+qdeff));
  T6 = ((0.8*((T3*T3)+(Temps*Tempd)))*T5);
  T7 = (T6+(2.0*invgamg2));
  T8 = ((0.33333333333333333*DQSD2)*T5);
  dqgeff = ((sid*((2.0*Tempd)-1.0))/((2.0*Tempd)+1.0));
  qbeff = ((vgpqm-((2.0*(nq-1.0))*qdeff))+dqgeff);
  Qb = ((inv_MdL*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*qbeff));
  T9 = (qs+qdeff);
  T10 = ((DQSD2*T5)*T5);
  Qi = (((nq*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*qdeff));
  Qd1 = ((nq*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
  Qd2 = ((nq*(MdL-inv_MdL))*qdeff);
  Qd = (Qd1+Qd2);
  Qs = (Qi-Qd);
  qbaCV = (0.5*(((Vt*Qb))+sqrt(((((Vt*Qb))*((Vt*Qb)))+((0.25*0.1)*0.1)))));
  qiaCV = (Vt*(Qs+Qd));
  T0 = ((qiaCV+((model_.ETAQM)*qbaCV))/(model_.QM0));
  T1 = (1.0+pow(T0,(0.7*(model_.BDOS))));
  XDCinv = (((model_.ADOS)*1.9e-9)/T1);
  Coxeffinv = ((3.9*8.85418e-12)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
  QBi = ((((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*Qb);
  WLCOXVtinv = ((((NF*Wact)*Lact)*Coxeffinv)*Vt);
  QSi = ((-WLCOXVtinv)*Qs);
  QDi = ((-WLCOXVtinv)*Qd);
  QGi = (-((QBi+QSi)+QDi));
  if ((!(model_.given("CF"))))
  {
    CF_i = ((((2.0*(model_.EPSROX))*8.85418e-12)/3.14159265358979323846)*log(((model_.CFRCOEFF)*(1.0+(0.4e-6/(model_.TOXE))))));
  }
  Cgsof = ((model_.CGSO)+CF_i);
  Cgdof = ((model_.CGDO)+CF_i);
  if (((model_.COVMOD)==0))
  {
    Qovs = ((((-Wact)*NF)*Cgsof)*Vgs_ov_noswap);
    Qovd = ((((-Wact)*NF)*Cgdof)*Vgd_ov_noswap);
  }
  else
  {
    T0 = sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
    Vgsov = (0.5*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0));
    T1 = sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)));
    Qovs = (((-Wact)*NF)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1))))));
    T0 = sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
    Vgdov = (0.5*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0));
    T2 = sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)));
    Qovd = (((-Wact)*NF)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2))))));
  }
  Qovb = (((((-devsign)*NF)*Lact)*(model_.CGBO))*(probeVars[admsProbeID_V_gm_bi]));
  Qovg = (-((Qovs+Qovd)+Qovb));
  if (((model_.EDGEFET)==1))
  {
    NFACTOREDGE_t = ((model_.NFACTOREDGE)*AnalogFunctions::hypsmooth<AdmsFadType>((1.0+((model_.TNFACTOREDGE)*(TRatio-1.0))),1e-3));
    ETA0EDGE_t = ((model_.ETA0EDGE)*(1.0+((model_.TETA0EDGE)*(TRatio-1.0))));
    cdsc = ((((model_.CITEDGE)+NFACTOREDGE_t)+((model_.CDSCDEDGE)*Vdsx))-((model_.CDSCBEDGE)*Vbsx));
    T1 = (1.0+(cdsc/Cox));
    n = (0.5*((T1+1.0)+sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)))));
    nVt = (n*Vt);
    inv_nVt = (1.0/nVt);
    vg = (Vg*inv_nVt);
    vs = (Vs*inv_nVt);
    vfb = (VFB_i*inv_nVt);
    dvth_dibl = ((-(ETA0EDGE_t+((model_.ETABEDGE)*Vbsx)))*Vdsx);
    dvth_temp = ((((model_.KT1EDGE)+((model_.KT1LEDGE)/Leff))+((model_.KT2EDGE)*Vbsx))*(pow(TRatio,(model_.KT1EXPEDGE))-1.0));
    litl_edge = (litl*(1.0+((model_.DVT2EDGE)*Vbsx)));
    theta_sce_edge = ((0.5*(model_.DVT0EDGE))/(cosh((((model_.DVT1EDGE)*Leff)/litl_edge))-1.0));
    dvth_sce = (theta_sce_edge*(Vbi-Phist));
    Vth_shift = (((dvth_dibl-dvth_temp)+dvth_sce)+(model_.DVTEDGE));
    vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
    DGAMMAEDGE_i = ((model_.DGAMMAEDGE)*(1.0+((model_.DGAMMAEDGEL)*pow(Leff,(-(model_.DGAMMAEDGELEXP))))));
    gam = (sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt))/Cox);
    gam = (gam*(1.0+DGAMMAEDGE_i));
    inv_gam = (1.0/gam);
    phib_n = (phib/n);
    T1 = (1.0);
    vgfbPD = (vgfb/T1);
    gammaPD = (gam/T1);
    T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
    T2 = (T1+sqrt(((T1*T1)+(6.0*vgfbPD))));
    if ((vgfbPD<0.0))
    {
      T3 = ((vgfbPD-T2)/gammaPD);
      psip = (-log(((1.0-T2)+(T3*T3))));
    }
    else
    {
      T3 = exp((-T2));
      T1 = (0.5*gammaPD);
      T2 = (sqrt((((vgfbPD-1.0)+T3)+(T1*T1)))-T1);
      psip = (((T2*T2)+1.0)-T3);
    }
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    T1 = ((psip-(2.0*phib_n))-vs);
    T2 = (T1-log(((4.0*T0)*sqrtpsip)));
    T8 = (0.5*((T2-0.201491)-sqrt(((T2*(T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          T2 = ((T8-T4)/T5);
          T6 = (T2*T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qs = (T3*(((1.0+T1)-T8)-log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
      qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    vdsatedge = (((2.0*nVt)*qs)+(2.0*nVt));
    Vdsatedge = vdsatedge;
    Vdsatedge = (Vdsatedge+Vs);
    Vdssate = (0.5*(((Vdsatedge-Vs))+sqrt(((((Vdsatedge-Vs))*((Vdsatedge-Vs)))+((0.25*1.0e-3)*1.0e-3)))));
    T7 = pow((Vds/Vdssate),(1.0/DELTA_t));
    T8 = pow((1.0+T7),(-DELTA_t));
    Vdseff = (Vds*T8);
    vdeff = ((Vdseff+Vs)*inv_nVt);
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    T1 = ((psip-(2.0*phib_n))-vdeff);
    T2 = (T1-log(((4.0*T0)*sqrtpsip)));
    T8 = (0.5*((T2-0.201491)-sqrt(((T2*(T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          T2 = ((T8-T4)/T5);
          T6 = (T2*T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qdeff = (T3*(((1.0+T1)-T8)-log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa)))))-T1);
      T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);
      qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    psipclamp = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))));
    sqrtpsip = sqrt(psipclamp);
    psiavg = (((psip-qs)-qdeff)-1.0);
    T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
    T2 = sqrt(T0);
    nq = (1.0+(gam/(sqrtpsip+T2)));
    ids_edge = ((((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
    ids = (ids_edge+ids);
  }
  QB = (devsign*(((QBi+Qovb)+Qbs)+Qbd));
  if ((sigvds>0))
  {
    QSI = (devsign*QSi);
    QDI = (devsign*QDi);
    QS = (devsign*((QSi+Qovs)-Qbs));
    QD = (devsign*((QDi+Qovd)-Qbd));
  }
  else
  {
    QSI = (devsign*QDi);
    QDI = (devsign*QSi);
    QS = (devsign*((QDi+Qovs)-Qbs));
    QD = (devsign*((QSi+Qovd)-Qbd));
  }
  QG = (devsign*(QGi+Qovg));
  QBI = (devsign*QBi);
  QGI = (devsign*QGi);
  // I(gi,bi) <+ (ddt(QGI))
  dynamicContributions[admsNodeID_gi] += (QGI);
  dynamicContributions[admsNodeID_bi] -= (QGI);
  // I(si,bi) <+ (ddt(QSI))
  dynamicContributions[admsNodeID_si] += (QSI);
  dynamicContributions[admsNodeID_bi] -= (QSI);
  // I(di,bi) <+ (ddt(QDI))
  dynamicContributions[admsNodeID_di] += (QDI);
  dynamicContributions[admsNodeID_bi] -= (QDI);
  // I(gm,si) <+ (ddt(((-devsign)*Qovs)))
  dynamicContributions[admsNodeID_gm] += (((-devsign)*Qovs));
  dynamicContributions[admsNodeID_si] -= (((-devsign)*Qovs));
  // I(gm,di) <+ (ddt(((-devsign)*Qovd)))
  dynamicContributions[admsNodeID_gm] += (((-devsign)*Qovd));
  dynamicContributions[admsNodeID_di] -= (((-devsign)*Qovd));
  // I(gm,bi) <+ (ddt(((-devsign)*Qovb)))
  dynamicContributions[admsNodeID_gm] += (((-devsign)*Qovb));
  dynamicContributions[admsNodeID_bi] -= (((-devsign)*Qovb));
  // I(di,si) <+ (((devsign*sigvds)*ids))
  staticContributions[admsNodeID_di] += ((devsign*sigvds)*ids);
  staticContributions[admsNodeID_si] -= ((devsign*sigvds)*ids);
  if (((model_.IGBMOD)!=0))
  {
    // I(gi,bi) <+ (IGB)
    staticContributions[admsNodeID_gi] += IGB;
    staticContributions[admsNodeID_bi] -= IGB;
  }
  if (((model_.IGCMOD)!=0))
  {
    // I(gi,si) <+ ((IGS+IGCS))
    staticContributions[admsNodeID_gi] += (IGS+IGCS);
    staticContributions[admsNodeID_si] -= (IGS+IGCS);
    // I(gi,di) <+ ((IGD+IGCD))
    staticContributions[admsNodeID_gi] += (IGD+IGCD);
    staticContributions[admsNodeID_di] -= (IGD+IGCD);
  }
  if ((sigvds>0))
  {
    // I(di,bi) <+ ((ISUB+IGIDL))
    staticContributions[admsNodeID_di] += (ISUB+IGIDL);
    staticContributions[admsNodeID_bi] -= (ISUB+IGIDL);
    // I(si,bi) <+ (IGISL)
    staticContributions[admsNodeID_si] += IGISL;
    staticContributions[admsNodeID_bi] -= IGISL;
  }
  else
  {
    // I(di,bi) <+ (IGIDL)
    staticContributions[admsNodeID_di] += IGIDL;
    staticContributions[admsNodeID_bi] -= IGIDL;
    // I(si,bi) <+ ((ISUB+IGISL))
    staticContributions[admsNodeID_si] += (ISUB+IGISL);
    staticContributions[admsNodeID_bi] -= (ISUB+IGISL);
  }
  if (((model_.RDSMOD)!=2))
  {
    gdpr = (1.0/Rdrain);
    gspr = (1.0/Rsource);
    // I(d,di) <+ ((V(d,di)*gdpr))
    staticContributions[admsNodeID_d] += ((probeVars[admsProbeID_V_d_di])*gdpr);
    staticContributions[admsNodeID_di] -= ((probeVars[admsProbeID_V_d_di])*gdpr);
    // I(s,si) <+ ((V(s,si)*gspr))
    staticContributions[admsNodeID_s] += ((probeVars[admsProbeID_V_s_si])*gspr);
    staticContributions[admsNodeID_si] -= ((probeVars[admsProbeID_V_s_si])*gspr);
    // I(d,di) <+ (white_noise((Nt*gdpr),"rd"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[8]= (Nt.val()*gdpr.val());
    }
    // I(s,si) <+ (white_noise((Nt*gspr),"rs"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[9]= (Nt.val()*gspr.val());
    }
  }
  else
  {
    // V(d,di) <+ (0)
    // do nothing at all
    // V(s,si) <+ (0)
    // do nothing at all
  }
  if ((RGATEMOD==0))
  {
    // V(g,gm) <+ (0)
    // do nothing at all
  }
  else
    //Begin block rgate
  {
    //Block-local variables for block rgate
    AdmsFadType Ggate;
    AdmsFadType Gnoise;
    //End of Block-local variables
    if ((RGATEMOD==2))
    {
      Ggate = Gcrg;
      Gnoise = ((Gcrg*Gcrg)/Grgeltd);
    }
    else
    {
      Ggate = Grgeltd;
      Gnoise = Grgeltd;
    }
    // I(g,gm) <+ ((V(g,gm)*Ggate))
    staticContributions[admsNodeID_g] += ((probeVars[admsProbeID_V_g_gm])*Ggate);
    staticContributions[admsNodeID_gm] -= ((probeVars[admsProbeID_V_g_gm])*Ggate);
    // I(g,gm) <+ (white_noise((Nt*Gnoise),"rg"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[10]= (Nt.val()*Gnoise.val());
    }
  }
  // End block rgate
  if ((RGATEMOD==3))
  {
    // I(gm,gi) <+ ((V(gm,gi)*Gcrg))
    staticContributions[admsNodeID_gm] += ((probeVars[admsProbeID_V_gm_gi])*Gcrg);
    staticContributions[admsNodeID_gi] -= ((probeVars[admsProbeID_V_gm_gi])*Gcrg);
  }
  else
  {
    // V(gm,gi) <+ (0)
    // do nothing at all
  }
  if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
  {
    if (((model_.RDSMOD)!=2))
    {
      // Pwr(t,GND) <+ (((-(((((devsign*sigvds)*ids)*V(di,si))+((V(d,di)*V(d,di))/Rdrain))+((V(s,si)*V(s,si))/Rsource)))+(delTemp1*gth)))
      staticContributions[admsNodeID_t] += ((-(((((devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si]))+(((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))/Rdrain))+(((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))/Rsource)))+(delTemp1*gth));
      // Pwr(t,GND) <+ (ddt((delTemp1*cth)))
      dynamicContributions[admsNodeID_t] += ((delTemp1*cth));
    }
    else
    {
      // Pwr(t,GND) <+ (((-(((devsign*sigvds)*ids)*V(di,si)))+(delTemp1*gth)))
      staticContributions[admsNodeID_t] += ((-(((devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si])))+(delTemp1*gth));
      // Pwr(t,GND) <+ (ddt((delTemp1*cth)))
      dynamicContributions[admsNodeID_t] += ((delTemp1*cth));
    }
  }
  else
  {
    // Temp(t,GND) <+ (0)
    // do nothing at all
  }
  if ((RBODYMOD!=0))
  {
    // I(bi,sbulk) <+ ((V(bi,sbulk)*Grbps))
    staticContributions[admsNodeID_bi] += ((probeVars[admsProbeID_V_bi_sbulk])*Grbps);
    staticContributions[admsNodeID_sbulk] -= ((probeVars[admsProbeID_V_bi_sbulk])*Grbps);
    // I(b,sbulk) <+ ((V(b,sbulk)*Grbsb))
    staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_sbulk])*Grbsb);
    staticContributions[admsNodeID_sbulk] -= ((probeVars[admsProbeID_V_b_sbulk])*Grbsb);
    // I(b,bi) <+ ((V(b,bi)*Grbpb))
    staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_bi])*Grbpb);
    staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_b_bi])*Grbpb);
    // I(b,dbulk) <+ ((V(b,dbulk)*Grbdb))
    staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_dbulk])*Grbdb);
    staticContributions[admsNodeID_dbulk] -= ((probeVars[admsProbeID_V_b_dbulk])*Grbdb);
    // I(bi,dbulk) <+ ((V(bi,dbulk)*Grbpd))
    staticContributions[admsNodeID_bi] += ((probeVars[admsProbeID_V_bi_dbulk])*Grbpd);
    staticContributions[admsNodeID_dbulk] -= ((probeVars[admsProbeID_V_bi_dbulk])*Grbpd);
    // I(sbulk,bi) <+ (white_noise((Nt*Grbps),"rbps"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[11]= (Nt.val()*Grbps);
    }
    // I(sbulk,b) <+ (white_noise((Nt*Grbsb),"rbsb"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[12]= (Nt.val()*Grbsb);
    }
    // I(b,bi) <+ (white_noise((Nt*Grbpb),"rbpb"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[13]= (Nt.val()*Grbpb);
    }
    // I(dbulk,bi) <+ (white_noise((Nt*Grbpd),"rbpd"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[14]= (Nt.val()*Grbpd);
    }
    // I(dbulk,b) <+ (white_noise((Nt*Grbdb),"rbdb"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[15]= (Nt.val()*Grbdb);
    }
  }
  else
  {
    // V(b,sbulk) <+ (0)
    // do nothing at all
    // V(b,bi) <+ (0)
    // do nothing at all
    // V(b,dbulk) <+ (0)
    // do nothing at all
  }
  if ((RBODYMOD!=0))
  {
    // I(sbulk,si) <+ ((devsign*Ibs))
    staticContributions[admsNodeID_sbulk] += (devsign*Ibs);
    staticContributions[admsNodeID_si] -= (devsign*Ibs);
    // I(dbulk,di) <+ ((devsign*Ibd))
    staticContributions[admsNodeID_dbulk] += (devsign*Ibd);
    staticContributions[admsNodeID_di] -= (devsign*Ibd);
    // I(sbulk,si) <+ ((devsign*ddt(Qbs)))
    dynamicContributions[admsNodeID_sbulk] += (devsign*(Qbs));
    dynamicContributions[admsNodeID_si] -= (devsign*(Qbs));
    // I(dbulk,di) <+ ((devsign*ddt(Qbd)))
    dynamicContributions[admsNodeID_dbulk] += (devsign*(Qbd));
    dynamicContributions[admsNodeID_di] -= (devsign*(Qbd));
  }
  else
  {
    // I(bi,si) <+ ((devsign*Ibs))
    staticContributions[admsNodeID_bi] += (devsign*Ibs);
    staticContributions[admsNodeID_si] -= (devsign*Ibs);
    // I(bi,di) <+ ((devsign*Ibd))
    staticContributions[admsNodeID_bi] += (devsign*Ibd);
    staticContributions[admsNodeID_di] -= (devsign*Ibd);
    // I(bi,si) <+ ((devsign*ddt(Qbs)))
    dynamicContributions[admsNodeID_bi] += (devsign*(Qbs));
    dynamicContributions[admsNodeID_si] -= (devsign*(Qbs));
    // I(bi,di) <+ ((devsign*ddt(Qbd)))
    dynamicContributions[admsNodeID_bi] += (devsign*(Qbd));
    dynamicContributions[admsNodeID_di] -= (devsign*(Qbd));
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_bi_dbulk] =  "
                 <<probeVars[admsProbeID_V_bi_dbulk].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_dbulk] =  "
                 <<probeVars[admsProbeID_V_b_dbulk].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bi] =  "
                 <<probeVars[admsProbeID_V_b_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_sbulk] =  "
                 <<probeVars[admsProbeID_V_b_sbulk].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_sbulk] =  "
                 <<probeVars[admsProbeID_V_bi_sbulk].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_si] =  "
                 <<probeVars[admsProbeID_V_di_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_gi] =  "
                 <<probeVars[admsProbeID_V_gm_gi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_gm] =  "
                 <<probeVars[admsProbeID_V_g_gm].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_si] =  "
                 <<probeVars[admsProbeID_V_s_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_di] =  "
                 <<probeVars[admsProbeID_V_d_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_bi] =  "
                 <<probeVars[admsProbeID_V_gm_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_N1_GND] =  "
                 <<probeVars[admsProbeID_V_N1_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_N2_GND] =  "
                 <<probeVars[admsProbeID_V_N2_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_si] =  "
                 <<probeVars[admsProbeID_V_gm_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_di] =  "
                 <<probeVars[admsProbeID_V_gm_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_dbulk_di] =  "
                 <<probeVars[admsProbeID_V_dbulk_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_sbulk_si] =  "
                 <<probeVars[admsProbeID_V_sbulk_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_bi] =  "
                 <<probeVars[admsProbeID_V_si_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_bi] =  "
                 <<probeVars[admsProbeID_V_di_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_bi] =  "
                 <<probeVars[admsProbeID_V_gi_bi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_t_GND] =  "
                 <<probeVars[admsProbeID_Temp_t_GND].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_d] =  "
                 <<staticContributions[admsNodeID_d].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_d] =  "
                 <<dynamicContributions[admsNodeID_d].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_g] =  "
                 <<staticContributions[admsNodeID_g].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_g] =  "
                 <<dynamicContributions[admsNodeID_g].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_di] =  "
                 <<staticContributions[admsNodeID_di].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_di] =  "
                 <<dynamicContributions[admsNodeID_di].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
                 <<staticContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
                 <<dynamicContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_gi] =  "
                 <<staticContributions[admsNodeID_gi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_gi] =  "
                 <<dynamicContributions[admsNodeID_gi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_gm] =  "
                 <<staticContributions[admsNodeID_gm].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_gm] =  "
                 <<dynamicContributions[admsNodeID_gm].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
                 <<staticContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
                 <<dynamicContributions[admsNodeID_bi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_sbulk] =  "
                 <<staticContributions[admsNodeID_sbulk].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_sbulk] =  "
                 <<dynamicContributions[admsNodeID_sbulk].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dbulk] =  "
                 <<staticContributions[admsNodeID_dbulk].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dbulk] =  "
                 <<dynamicContributions[admsNodeID_dbulk].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_N1] =  "
                 <<staticContributions[admsNodeID_N1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_N1] =  "
                 <<dynamicContributions[admsNodeID_N1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_N2] =  "
                 <<staticContributions[admsNodeID_N2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_N2] =  "
                 <<dynamicContributions[admsNodeID_N2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_t] =  "
                 <<staticContributions[admsNodeID_t].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_dbulk) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_dbulk) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_sbulk) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_sbulk) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_gi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_g_gm) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_N1_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_N2_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) =  " <<staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_t] =  "
                 <<dynamicContributions[admsNodeID_t].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_dbulk) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_dbulk) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_dbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_sbulk) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_sbulk) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_sbulk) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_gi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_gm) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_gm) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_s_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_s_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_di) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N1_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N2_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) =  " <<dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 14; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 16;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_di_si")+std::string("_")+std::string("1overf");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_di;
  noiseData.li_Neg[0]=li_si;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_di_si")+std::string("_")+std::string("id");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_di;
  noiseData.li_Neg[1]=li_si;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_N2_GND")+std::string("_")+std::string("corl");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_N2;
  noiseData.li_Neg[2]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_N1_GND")+std::string("_")+std::string("corl");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_N1;
  noiseData.li_Neg[3]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_di_si")+std::string("_")+std::string("id");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_di;
  noiseData.li_Neg[4]=li_si;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_gi_si")+std::string("_")+std::string("igs");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_gi;
  noiseData.li_Neg[5]=li_si;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_gi_di")+std::string("_")+std::string("igd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_gi;
  noiseData.li_Neg[6]=li_di;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_gi_bi")+std::string("_")+std::string("igb");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_gi;
  noiseData.li_Neg[7]=li_bi;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_d_di")+std::string("_")+std::string("rd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_d;
  noiseData.li_Neg[8]=li_di;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_s_si")+std::string("_")+std::string("rs");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_s;
  noiseData.li_Neg[9]=li_si;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_gm")+std::string("_")+std::string("rg");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_g;
  noiseData.li_Neg[10]=li_gm;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_sbulk_bi")+std::string("_")+std::string("rbps");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_sbulk;
  noiseData.li_Neg[11]=li_bi;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_sbulk_b")+std::string("_")+std::string("rbsb");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_sbulk;
  noiseData.li_Neg[12]=li_b;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_bi")+std::string("_")+std::string("rbpb");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_b;
  noiseData.li_Neg[13]=li_bi;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_dbulk_bi")+std::string("_")+std::string("rbpd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_dbulk;
  noiseData.li_Neg[14]=li_bi;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_dbulk_b")+std::string("_")+std::string("rbdb");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[15]=theNoiseName;
  noiseData.li_Pos[15]=li_dbulk;
  noiseData.li_Neg[15]=li_b;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];

  noiseData.noiseDens[0] /= pow(noiseData.freq,noiseContribsExponent[0]);noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];
  noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];
  noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];
  noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];
  noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];
  noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];
  noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
  noiseData.noiseDens[15] = noiseContribsPower[15];
  noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  if (!collapseNode_t)
  {
    (*f_di_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    (*f_si_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  }
  (*f_di_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi);
  (*f_di_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi);
  (*f_si_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi);
  (*f_si_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi);
  (*f_di_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi);
  (*f_si_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) -staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi);
  (*f_di_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi);
  (*f_si_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi);
  (*f_di_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si);
  (*f_si_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si);
  (*f_di_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di);
  (*f_si_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di);
  (*f_N2_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si);
  (*f_N2_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si);
  (*f_N2_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di);
  (*f_N2_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di);
  if (!collapseNode_t)
  {
    (*f_N2_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND);
  }
  (*f_N2_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi);
  (*f_N2_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi);
  (*f_N1_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  (*f_N1_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  (*f_N1_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  (*f_N1_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  (*f_N1_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi);
  (*f_N1_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    (*f_N1_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND);
  }
  (*f_N1_Equ_N2_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND);
  (*f_N1_Equ_N1_Node_Ptr) +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND);
  (*f_di_Equ_N2_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND);
  (*f_si_Equ_N2_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND);
  (*f_gi_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi);
  (*f_gi_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi);
  if (!collapseNode_t)
  {
    (*f_gi_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND);
  }
  (*f_gi_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi);
  (*f_gi_Equ_gi_Node_Ptr) +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi);
  (*f_N2_Equ_N2_Node_Ptr) +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND);
  if (!collapseNode_t)
  {
    (*f_bi_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND);
  }
  (*f_bi_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  (*f_bi_Equ_bi_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  (*f_bi_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi);
  (*f_bi_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi);
  (*f_bi_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk);
  (*f_bi_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk);
  (*f_gm_Equ_gm_Node_Ptr) +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) -staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm);
  (*f_gm_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi);
  (*f_si_Equ_gm_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di);
  (*f_gm_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi);
  (*f_gm_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi);
  (*f_gm_Equ_gi_Node_Ptr) +=  -staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) +staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    (*f_gm_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND);
  }
  (*f_di_Equ_gm_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di);
  (*f_d_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi);
  (*f_d_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi);
  (*f_d_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi);
  (*f_d_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    (*f_d_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND);
  }
  (*f_d_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di);
  (*f_di_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di);
  (*f_s_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi);
  (*f_s_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi);
  (*f_s_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi);
  (*f_s_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    (*f_s_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND);
  }
  (*f_s_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si);
  (*f_si_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si);
  if (!collapseNode_t)
  {
    (*f_g_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND);
  }
  (*f_g_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi);
  (*f_g_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi);
  (*f_g_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi);
  (*f_g_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi);
  (*f_g_Equ_g_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm);
  (*f_g_Equ_gm_Node_Ptr) +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm);
  (*f_gm_Equ_g_Node_Ptr) +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm);
  (*f_gi_Equ_gm_Node_Ptr) +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi);
  if (!collapseNode_t)
  {
    (*f_t_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di);
  }
  if (!collapseNode_t)
  {
    (*f_t_Equ_gm_Node_Ptr) +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di);
  }
  (*f_sbulk_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk);
  (*f_sbulk_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk);
  (*f_b_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk);
  (*f_b_Equ_sbulk_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk);
  (*f_sbulk_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk);
  (*f_b_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi);
  (*f_bi_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi);
  (*f_b_Equ_dbulk_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk);
  (*f_dbulk_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk);
  (*f_dbulk_Equ_dbulk_Node_Ptr) +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk);
  (*f_dbulk_Equ_bi_Node_Ptr) +=  -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk);
  if (!collapseNode_t)
  {
    (*f_sbulk_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    (*f_b_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    (*f_dbulk_Equ_t_Node_Ptr) +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND);
  }
  (*f_sbulk_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi);
  (*f_sbulk_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi);
  (*f_sbulk_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi);
  (*f_dbulk_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi);
  (*f_dbulk_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi);
  (*f_dbulk_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi);
  (*f_dbulk_Equ_sbulk_Node_Ptr) +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si);

#else
  //use the offsets instead of pointers
  if (!collapseNode_t)
  {
    dFdx[li_di][A_di_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    dFdx[li_si][A_si_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_di][A_di_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi);
  dFdx[li_di][A_di_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi);
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi);
  dFdx[li_si][A_si_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi);
  dFdx[li_di][A_di_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi);
  dFdx[li_si][A_si_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) -staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi);
  dFdx[li_di][A_di_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi);
  dFdx[li_si][A_si_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi);
  dFdx[li_di][A_di_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si);
  dFdx[li_si][A_si_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si);
  dFdx[li_di][A_di_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di);
  dFdx[li_si][A_si_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di);
  dFdx[li_N2][A_N2_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si);
  dFdx[li_N2][A_N2_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si);
  dFdx[li_N2][A_N2_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di);
  dFdx[li_N2][A_N2_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di);
  if (!collapseNode_t)
  {
    dFdx[li_N2][A_N2_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_N2][A_N2_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi);
  dFdx[li_N2][A_N2_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi);
  dFdx[li_N1][A_N1_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  dFdx[li_N1][A_N1_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  dFdx[li_N1][A_N1_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  dFdx[li_N1][A_N1_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  dFdx[li_N1][A_N1_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi);
  dFdx[li_N1][A_N1_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    dFdx[li_N1][A_N1_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_N1][A_N1_Equ_N2_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND);
  dFdx[li_N1][A_N1_Equ_N1_NodeOffset] +=  +staticContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND);
  dFdx[li_di][A_di_Equ_N2_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND);
  dFdx[li_si][A_si_Equ_N2_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND);
  dFdx[li_gi][A_gi_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi);
  dFdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi);
  if (!collapseNode_t)
  {
    dFdx[li_gi][A_gi_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_gi][A_gi_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi);
  dFdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi);
  dFdx[li_N2][A_N2_Equ_N2_NodeOffset] +=  +staticContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND);
  if (!collapseNode_t)
  {
    dFdx[li_bi][A_bi_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_bi][A_bi_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  dFdx[li_bi][A_bi_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi);
  dFdx[li_bi][A_bi_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi);
  dFdx[li_bi][A_bi_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk);
  dFdx[li_bi][A_bi_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) -staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk);
  dFdx[li_gm][A_gm_Equ_gm_NodeOffset] +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) -staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm);
  dFdx[li_gm][A_gm_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi);
  dFdx[li_si][A_si_Equ_gm_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di);
  dFdx[li_gm][A_gm_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi);
  dFdx[li_gm][A_gm_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi);
  dFdx[li_gm][A_gm_Equ_gi_NodeOffset] +=  -staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) +staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    dFdx[li_gm][A_gm_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_di][A_di_Equ_gm_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di);
  dFdx[li_d][A_d_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi);
  dFdx[li_d][A_d_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi);
  dFdx[li_d][A_d_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) +staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi);
  dFdx[li_d][A_d_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    dFdx[li_d][A_d_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_d][A_d_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di);
  dFdx[li_di][A_di_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di);
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) +staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi);
  dFdx[li_s][A_s_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi);
  dFdx[li_s][A_s_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi);
  dFdx[li_s][A_s_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    dFdx[li_s][A_s_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si);
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si);
  if (!collapseNode_t)
  {
    dFdx[li_g][A_g_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_g][A_g_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi);
  dFdx[li_g][A_g_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi);
  dFdx[li_g][A_g_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi);
  dFdx[li_g][A_g_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi);
  dFdx[li_g][A_g_Equ_g_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm);
  dFdx[li_g][A_g_Equ_gm_NodeOffset] +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm);
  dFdx[li_gm][A_gm_Equ_g_NodeOffset] +=  +staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm);
  dFdx[li_gi][A_gi_Equ_gm_NodeOffset] +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi);
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) -staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) +staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di);
  }
  if (!collapseNode_t)
  {
    dFdx[li_t][A_t_Equ_gm_NodeOffset] +=  +staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) +staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di);
  }
  dFdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk);
  dFdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk);
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk);
  dFdx[li_b][A_b_Equ_sbulk_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk);
  dFdx[li_sbulk][A_sbulk_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk);
  dFdx[li_b][A_b_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi);
  dFdx[li_bi][A_bi_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi);
  dFdx[li_b][A_b_Equ_dbulk_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk);
  dFdx[li_dbulk][A_dbulk_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk);
  dFdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset] +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk);
  dFdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset] +=  -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk);
  if (!collapseNode_t)
  {
    dFdx[li_sbulk][A_sbulk_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    dFdx[li_b][A_b_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    dFdx[li_dbulk][A_dbulk_Equ_t_NodeOffset] +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND);
  }
  dFdx[li_sbulk][A_sbulk_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi);
  dFdx[li_sbulk][A_sbulk_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi);
  dFdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi);
  dFdx[li_dbulk][A_dbulk_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi);
  dFdx[li_dbulk][A_dbulk_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi);
  dFdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi);
  dFdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset] +=  +staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si);

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  if (!collapseNode_t)
  {
    (*q_di_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    (*q_si_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  }
  (*q_di_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si);
  (*q_di_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi);
  (*q_si_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si);
  (*q_si_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi);
  (*q_di_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di);
  (*q_si_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di);
  (*q_di_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi);
  (*q_si_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi);
  (*q_di_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si);
  (*q_si_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si);
  (*q_di_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di);
  (*q_si_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di);
  (*q_N1_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  (*q_N1_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  (*q_N1_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  (*q_N1_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  (*q_N1_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi);
  (*q_N1_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    (*q_N1_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND);
  }
  (*q_N1_Equ_N1_Node_Ptr) +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND);
  (*q_gi_Equ_N1_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND);
  (*q_si_Equ_N1_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND);
  (*q_gi_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si);
  (*q_gi_Equ_si_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si);
  (*q_gi_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di);
  (*q_gi_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di);
  if (!collapseNode_t)
  {
    (*q_gi_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND);
  }
  (*q_gi_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi);
  (*q_gi_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi);
  (*q_di_Equ_N1_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND);
  if (!collapseNode_t)
  {
    (*q_bi_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND);
  }
  (*q_bi_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  (*q_bi_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  (*q_bi_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi);
  (*q_bi_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi);
  (*q_bi_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si);
  (*q_bi_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di);
  (*q_gm_Equ_gm_Node_Ptr) +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si);
  (*q_gm_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si);
  (*q_si_Equ_gm_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si);
  (*q_gm_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi);
  (*q_gm_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi);
  (*q_gm_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi);
  (*q_gm_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si);
  (*q_gm_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di);
  if (!collapseNode_t)
  {
    (*q_gm_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND);
  }
  (*q_di_Equ_gm_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di);
  (*q_bi_Equ_gm_Node_Ptr) +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi);
  if (!collapseNode_t)
  {
    (*q_t_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);
  }
  (*q_sbulk_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi);
  (*q_sbulk_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si);
  (*q_dbulk_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di);
  (*q_dbulk_Equ_bi_Node_Ptr) +=  -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi);
  if (!collapseNode_t)
  {
    (*q_sbulk_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    (*q_dbulk_Equ_t_Node_Ptr) +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND);
  }
  (*q_sbulk_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi);
  (*q_sbulk_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi);
  (*q_sbulk_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi);
  (*q_dbulk_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi);
  (*q_dbulk_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi);
  (*q_dbulk_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi);
  (*q_dbulk_Equ_sbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si);
  (*q_sbulk_Equ_dbulk_Node_Ptr) +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di);

#else
  //use the offsets instead of pointers
  if (!collapseNode_t)
  {
    dQdx[li_di][A_di_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    dQdx[li_si][A_si_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_di][A_di_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si);
  dQdx[li_di][A_di_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi);
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si);
  dQdx[li_si][A_si_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi);
  dQdx[li_di][A_di_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di);
  dQdx[li_si][A_si_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di);
  dQdx[li_di][A_di_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi);
  dQdx[li_si][A_si_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi);
  dQdx[li_di][A_di_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si);
  dQdx[li_si][A_si_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si);
  dQdx[li_di][A_di_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di);
  dQdx[li_si][A_si_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di);
  dQdx[li_N1][A_N1_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  dQdx[li_N1][A_N1_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si);
  dQdx[li_N1][A_N1_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  dQdx[li_N1][A_N1_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di);
  dQdx[li_N1][A_N1_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi);
  dQdx[li_N1][A_N1_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi);
  if (!collapseNode_t)
  {
    dQdx[li_N1][A_N1_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_N1][A_N1_Equ_N1_NodeOffset] +=  +dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND);
  dQdx[li_gi][A_gi_Equ_N1_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND);
  dQdx[li_si][A_si_Equ_N1_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND);
  dQdx[li_gi][A_gi_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si);
  dQdx[li_gi][A_gi_Equ_si_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si);
  dQdx[li_gi][A_gi_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di);
  dQdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di);
  if (!collapseNode_t)
  {
    dQdx[li_gi][A_gi_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_gi][A_gi_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi);
  dQdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi);
  dQdx[li_di][A_di_Equ_N1_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND);
  if (!collapseNode_t)
  {
    dQdx[li_bi][A_bi_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_bi][A_bi_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi);
  dQdx[li_bi][A_bi_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi);
  dQdx[li_bi][A_bi_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi);
  dQdx[li_bi][A_bi_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si);
  dQdx[li_bi][A_bi_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di);
  dQdx[li_gm][A_gm_Equ_gm_NodeOffset] +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si);
  dQdx[li_gm][A_gm_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si);
  dQdx[li_si][A_si_Equ_gm_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si);
  dQdx[li_gm][A_gm_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi);
  dQdx[li_gm][A_gm_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) -dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi);
  dQdx[li_gm][A_gm_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi);
  dQdx[li_gm][A_gm_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si);
  dQdx[li_gm][A_gm_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di);
  if (!collapseNode_t)
  {
    dQdx[li_gm][A_gm_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_di][A_di_Equ_gm_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di);
  dQdx[li_bi][A_bi_Equ_gm_NodeOffset] +=  +dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi);
  if (!collapseNode_t)
  {
    dQdx[li_t][A_t_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi);
  dQdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si);
  dQdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di);
  dQdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset] +=  -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi);
  if (!collapseNode_t)
  {
    dQdx[li_sbulk][A_sbulk_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND);
  }
  if (!collapseNode_t)
  {
    dQdx[li_dbulk][A_dbulk_Equ_t_NodeOffset] +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND);
  }
  dQdx[li_sbulk][A_sbulk_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi);
  dQdx[li_sbulk][A_sbulk_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi);
  dQdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi);
  dQdx[li_dbulk][A_dbulk_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi);
  dQdx[li_dbulk][A_dbulk_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi);
  dQdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi);
  dQdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si);
  dQdx[li_sbulk][A_sbulk_Equ_dbulk_NodeOffset] +=  +dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di);


#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;
  if (!given("TOXP"))
  {
    TOXP = TOXE;
  }
  if (!given("NDEPCV"))
  {
    NDEPCV = NDEP;
  }
  if (!given("NDEPCVL1"))
  {
    NDEPCVL1 = NDEPL1;
  }
  if (!given("NDEPCVLEXP1"))
  {
    NDEPCVLEXP1 = NDEPLEXP1;
  }
  if (!given("NDEPCVL2"))
  {
    NDEPCVL2 = NDEPL2;
  }
  if (!given("NDEPCVLEXP2"))
  {
    NDEPCVLEXP2 = NDEPLEXP2;
  }
  if (!given("NDEPCVW"))
  {
    NDEPCVW = NDEPW;
  }
  if (!given("NDEPCVWEXP"))
  {
    NDEPCVWEXP = NDEPWEXP;
  }
  if (!given("NDEPCVWL"))
  {
    NDEPCVWL = NDEPWL;
  }
  if (!given("NDEPCVWLEXP"))
  {
    NDEPCVWLEXP = NDEPWLEXP;
  }
  if (!given("LNDEPCV"))
  {
    LNDEPCV = LNDEP;
  }
  if (!given("WNDEPCV"))
  {
    WNDEPCV = WNDEP;
  }
  if (!given("PNDEPCV"))
  {
    PNDEPCV = PNDEP;
  }
  if (!given("VFBCV"))
  {
    VFBCV = VFB;
  }
  if (!given("LVFBCV"))
  {
    LVFBCV = LVFB;
  }
  if (!given("WVFBCV"))
  {
    WVFBCV = WVFB;
  }
  if (!given("PVFBCV"))
  {
    PVFBCV = PVFB;
  }
  if (!given("DWJ"))
  {
    DWJ = DWC;
  }
  if (!given("ETA0R"))
  {
    ETA0R = ETA0;
  }
  if (!given("LETA0R"))
  {
    LETA0R = LETA0;
  }
  if (!given("WETA0R"))
  {
    WETA0R = WETA0;
  }
  if (!given("PETA0R"))
  {
    PETA0R = PETA0;
  }
  if (!given("CDSCDR"))
  {
    CDSCDR = CDSCD;
  }
  if (!given("CDSCDLR"))
  {
    CDSCDLR = CDSCDL;
  }
  if (!given("LCDSCDR"))
  {
    LCDSCDR = LCDSCD;
  }
  if (!given("WCDSCDR"))
  {
    WCDSCDR = WCDSCD;
  }
  if (!given("PCDSCDR"))
  {
    PCDSCDR = PCDSCD;
  }
  if (!given("VSATR"))
  {
    VSATR = VSAT;
  }
  if (!given("LVSATR"))
  {
    LVSATR = LVSAT;
  }
  if (!given("WVSATR"))
  {
    WVSATR = WVSAT;
  }
  if (!given("PVSATR"))
  {
    PVSATR = PVSAT;
  }
  if (!given("VSATCV"))
  {
    VSATCV = VSAT;
  }
  if (!given("LVSATCV"))
  {
    LVSATCV = LVSAT;
  }
  if (!given("WVSATCV"))
  {
    WVSATCV = WVSAT;
  }
  if (!given("PVSATCV"))
  {
    PVSATCV = PVSAT;
  }
  if (!given("VSATCVL"))
  {
    VSATCVL = VSATL;
  }
  if (!given("VSATCVLEXP"))
  {
    VSATCVLEXP = VSATLEXP;
  }
  if (!given("VSATCVW"))
  {
    VSATCVW = VSATW;
  }
  if (!given("VSATCVWEXP"))
  {
    VSATCVWEXP = VSATWEXP;
  }
  if (!given("VSATCVWL"))
  {
    VSATCVWL = VSATWL;
  }
  if (!given("VSATCVWLEXP"))
  {
    VSATCVWLEXP = VSATWLEXP;
  }
  if (!given("U0R"))
  {
    U0R = U0;
  }
  if (!given("LU0R"))
  {
    LU0R = LU0;
  }
  if (!given("WU0R"))
  {
    WU0R = WU0;
  }
  if (!given("PU0R"))
  {
    PU0R = PU0;
  }
  if (!given("UAR"))
  {
    UAR = UA;
  }
  if (!given("LUAR"))
  {
    LUAR = LUA;
  }
  if (!given("WUAR"))
  {
    WUAR = WUA;
  }
  if (!given("PUAR"))
  {
    PUAR = PUA;
  }
  if (!given("UDR"))
  {
    UDR = UD;
  }
  if (!given("LUDR"))
  {
    LUDR = LUD;
  }
  if (!given("WUDR"))
  {
    WUDR = WUD;
  }
  if (!given("PUDR"))
  {
    PUDR = PUD;
  }
  if (!given("UCSR"))
  {
    UCSR = UCS;
  }
  if (!given("LUCSR"))
  {
    LUCSR = LUCS;
  }
  if (!given("WUCSR"))
  {
    WUCSR = WUCS;
  }
  if (!given("PUCSR"))
  {
    PUCSR = PUCS;
  }
  if (!given("UCR"))
  {
    UCR = UC;
  }
  if (!given("LUCR"))
  {
    LUCR = LUC;
  }
  if (!given("WUCR"))
  {
    WUCR = WUC;
  }
  if (!given("PUCR"))
  {
    PUCR = PUC;
  }
  if (!given("PCLMR"))
  {
    PCLMR = PCLM;
  }
  if (!given("LPCLMR"))
  {
    LPCLMR = LPCLM;
  }
  if (!given("WPCLMR"))
  {
    WPCLMR = WPCLM;
  }
  if (!given("PPCLMR"))
  {
    PPCLMR = PPCLM;
  }
  if (!given("PCLMCV"))
  {
    PCLMCV = PCLM;
  }
  if (!given("PCLMCVL"))
  {
    PCLMCVL = PCLML;
  }
  if (!given("PCLMCVLEXP"))
  {
    PCLMCVLEXP = PCLMLEXP;
  }
  if (!given("LPCLMCV"))
  {
    LPCLMCV = LPCLM;
  }
  if (!given("WPCLMCV"))
  {
    WPCLMCV = WPCLM;
  }
  if (!given("PPCLMCV"))
  {
    PPCLMCV = PPCLM;
  }
  if (!given("RDWMIN"))
  {
    RDWMIN = RSWMIN;
  }
  if (!given("LRDWMIN"))
  {
    LRDWMIN = LRSWMIN;
  }
  if (!given("WRDWMIN"))
  {
    WRDWMIN = WRSWMIN;
  }
  if (!given("PRDWMIN"))
  {
    PRDWMIN = PRSWMIN;
  }
  if (!given("RDW"))
  {
    RDW = RSW;
  }
  if (!given("LRDW"))
  {
    LRDW = LRSW;
  }
  if (!given("WRDW"))
  {
    WRDW = WRSW;
  }
  if (!given("PRDW"))
  {
    PRDW = PRSW;
  }
  if (!given("RDWL"))
  {
    RDWL = RSWL;
  }
  if (!given("RDWLEXP"))
  {
    RDWLEXP = RSWLEXP;
  }
  if (!given("PSATR"))
  {
    PSATR = PSAT;
  }
  if (!given("LPSATR"))
  {
    LPSATR = LPSAT;
  }
  if (!given("WPSATR"))
  {
    WPSATR = WPSAT;
  }
  if (!given("PPSATR"))
  {
    PPSATR = PPSAT;
  }
  if (!given("PTWGR"))
  {
    PTWGR = PTWG;
  }
  if (!given("LPTWGR"))
  {
    LPTWGR = LPTWG;
  }
  if (!given("WPTWGR"))
  {
    WPTWGR = WPTWG;
  }
  if (!given("PPTWGR"))
  {
    PPTWGR = PPTWG;
  }
  if (!given("PTWGLR"))
  {
    PTWGLR = PTWGL;
  }
  if (!given("PTWGLEXPR"))
  {
    PTWGLEXPR = PTWGLEXP;
  }
  if (!given("PDIBLCLR"))
  {
    PDIBLCLR = PDIBLCL;
  }
  if (!given("PDIBLCLEXPR"))
  {
    PDIBLCLEXPR = PDIBLCLEXP;
  }
  if (!given("LPDIBLCR"))
  {
    LPDIBLCR = LPDIBLC;
  }
  if (!given("WPDIBLCR"))
  {
    WPDIBLCR = WPDIBLC;
  }
  if (!given("PPDIBLCR"))
  {
    PPDIBLCR = PPDIBLC;
  }
  if (!given("AIGC"))
  {
    AIGC = ((TYPE==1)?1.36e-2:9.8e-3);
  }
  if (!given("BIGC"))
  {
    BIGC = ((TYPE==1)?1.71e-3:7.59e-4);
  }
  if (!given("CIGC"))
  {
    CIGC = ((TYPE==1)?0.075:0.03);
  }
  if (!given("AIGS"))
  {
    AIGS = ((TYPE==1)?1.36e-2:9.8e-3);
  }
  if (!given("BIGS"))
  {
    BIGS = ((TYPE==1)?1.71e-3:7.59e-4);
  }
  if (!given("CIGS"))
  {
    CIGS = ((TYPE==1)?0.075:0.03);
  }
  if (!given("AIGD"))
  {
    AIGD = ((TYPE==1)?1.36e-2:9.8e-3);
  }
  if (!given("BIGD"))
  {
    BIGD = ((TYPE==1)?1.71e-3:7.59e-4);
  }
  if (!given("CIGD"))
  {
    CIGD = ((TYPE==1)?0.075:0.03);
  }
  if (!given("DLCIG"))
  {
    DLCIG = LINT;
  }
  if (!given("DLCIGD"))
  {
    DLCIGD = DLCIG;
  }
  if (!given("AGISL"))
  {
    AGISL = AGIDL;
  }
  if (!given("AGISLL"))
  {
    AGISLL = AGIDLL;
  }
  if (!given("AGISLW"))
  {
    AGISLW = AGIDLW;
  }
  if (!given("LAGISL"))
  {
    LAGISL = LAGIDL;
  }
  if (!given("WAGISL"))
  {
    WAGISL = WAGIDL;
  }
  if (!given("PAGISL"))
  {
    PAGISL = PAGIDL;
  }
  if (!given("BGISL"))
  {
    BGISL = BGIDL;
  }
  if (!given("LBGISL"))
  {
    LBGISL = LBGIDL;
  }
  if (!given("WBGISL"))
  {
    WBGISL = WBGIDL;
  }
  if (!given("PBGISL"))
  {
    PBGISL = PBGIDL;
  }
  if (!given("CGISL"))
  {
    CGISL = CGIDL;
  }
  if (!given("LCGISL"))
  {
    LCGISL = LCGIDL;
  }
  if (!given("WCGISL"))
  {
    WCGISL = WCGIDL;
  }
  if (!given("PCGISL"))
  {
    PCGISL = PCGIDL;
  }
  if (!given("EGISL"))
  {
    EGISL = EGIDL;
  }
  if (!given("LEGISL"))
  {
    LEGISL = LEGIDL;
  }
  if (!given("WEGISL"))
  {
    WEGISL = WEGIDL;
  }
  if (!given("PEGISL"))
  {
    PEGISL = PEGIDL;
  }
  if (!given("DMCI"))
  {
    DMCI = DMCG;
  }
  if (!given("CJD"))
  {
    CJD = CJS;
  }
  if (!given("CJSWD"))
  {
    CJSWD = CJSWS;
  }
  if (!given("CJSWGD"))
  {
    CJSWGD = CJSWGS;
  }
  if (!given("PBD"))
  {
    PBD = PBS;
  }
  if (!given("PBSWD"))
  {
    PBSWD = PBSWS;
  }
  if (!given("PBSWGS"))
  {
    PBSWGS = PBSWS;
  }
  if (!given("PBSWGD"))
  {
    PBSWGD = PBSWGS;
  }
  if (!given("MJD"))
  {
    MJD = MJS;
  }
  if (!given("MJSWD"))
  {
    MJSWD = MJSWS;
  }
  if (!given("MJSWGS"))
  {
    MJSWGS = MJSWS;
  }
  if (!given("MJSWGD"))
  {
    MJSWGD = MJSWGS;
  }
  if (!given("JSD"))
  {
    JSD = JSS;
  }
  if (!given("JSWD"))
  {
    JSWD = JSWS;
  }
  if (!given("JSWGD"))
  {
    JSWGD = JSWGS;
  }
  if (!given("NJD"))
  {
    NJD = NJS;
  }
  if (!given("IJTHDFWD"))
  {
    IJTHDFWD = IJTHSFWD;
  }
  if (!given("IJTHDREV"))
  {
    IJTHDREV = IJTHSREV;
  }
  if (!given("BVD"))
  {
    BVD = BVS;
  }
  if (!given("XJBVD"))
  {
    XJBVD = XJBVS;
  }
  if (!given("JTSD"))
  {
    JTSD = JTSS;
  }
  if (!given("JTSSWD"))
  {
    JTSSWD = JTSSWS;
  }
  if (!given("JTSSWGD"))
  {
    JTSSWGD = JTSSWGS;
  }
  if (!given("NJTSD"))
  {
    NJTSD = NJTS;
  }
  if (!given("NJTSSWD"))
  {
    NJTSSWD = NJTSSW;
  }
  if (!given("NJTSSWGD"))
  {
    NJTSSWGD = NJTSSWG;
  }
  if (!given("VTSD"))
  {
    VTSD = VTSS;
  }
  if (!given("VTSSWD"))
  {
    VTSSWD = VTSSWS;
  }
  if (!given("VTSSWGD"))
  {
    VTSSWGD = VTSSWGS;
  }
  if (!given("XTID"))
  {
    XTID = XTIS;
  }
  if (!given("XTSD"))
  {
    XTSD = XTSS;
  }
  if (!given("XTSSWD"))
  {
    XTSSWD = XTSSWS;
  }
  if (!given("XTSSWGD"))
  {
    XTSSWGD = XTSSWGS;
  }
  if (!given("TNJTSD"))
  {
    TNJTSD = TNJTS;
  }
  if (!given("TNJTSSWD"))
  {
    TNJTSSWD = TNJTSSW;
  }
  if (!given("TNJTSSWGD"))
  {
    TNJTSSWGD = TNJTSSWG;
  }
  if (!given("NFACTOREDGE"))
  {
    NFACTOREDGE = NFACTOR;
  }
  if (!given("CITEDGE"))
  {
    CITEDGE = CIT;
  }
  if (!given("CDSCDEDGE"))
  {
    CDSCDEDGE = CDSCD;
  }
  if (!given("CDSCBEDGE"))
  {
    CDSCBEDGE = CDSCB;
  }
  if (!given("ETA0EDGE"))
  {
    ETA0EDGE = ETA0;
  }
  if (!given("ETABEDGE"))
  {
    ETABEDGE = ETAB;
  }
  if (!given("KT1EDGE"))
  {
    KT1EDGE = KT1;
  }
  if (!given("KT1LEDGE"))
  {
    KT1LEDGE = KT1L;
  }
  if (!given("KT2EDGE"))
  {
    KT2EDGE = KT2;
  }
  if (!given("KT1EXPEDGE"))
  {
    KT1EXPEDGE = KT1EXP;
  }
  if (!given("TNFACTOREDGE"))
  {
    TNFACTOREDGE = TNFACTOR;
  }
  if (!given("TETA0EDGE"))
  {
    TETA0EDGE = TETA0;
  }



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter L : ] 0,  (+inf) [
  if ( (!((L >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter L value " << L << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

  //    Parameter RGATEMOD : [ 0, 3 ]
  if ( (!((RGATEMOD >=0 && RGATEMOD <=3 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RGATEMOD value " << RGATEMOD << " out of range [ 0, 3 ]";
  }

  //    Parameter RBODYMOD : [ 0, 2 ]
  if ( (!((RBODYMOD >=0 && RBODYMOD <=2 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBODYMOD value " << RBODYMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter GEOMOD : [ 0, 10 ]
  if ( (!((GEOMOD >=0 && GEOMOD <=10 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter GEOMOD value " << GEOMOD << " out of range [ 0, 10 ]";
  }

  //    Parameter RGEOMOD : [ 0, 8 ]
  if ( (!((RGEOMOD >=0 && RGEOMOD <=8 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RGEOMOD value " << RGEOMOD << " out of range [ 0, 8 ]";
  }

  //    Parameter RBPB : [ 0,  (+inf) [
  if ( (!((RBPB >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPB value " << RBPB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPD : [ 0,  (+inf) [
  if ( (!((RBPD >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPD value " << RBPD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPS : [ 0,  (+inf) [
  if ( (!((RBPS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPS value " << RBPS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBDB : [ 0,  (+inf) [
  if ( (!((RBDB >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBDB value " << RBDB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSB : [ 0,  (+inf) [
  if ( (!((RBSB >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSB value " << RBSB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCA :  ] (-inf)  (+inf) [

  //    Parameter SCB :  ] (-inf)  (+inf) [

  //    Parameter SCC :  ] (-inf)  (+inf) [

  //    Parameter SC :  ] (-inf)  (+inf) [

  //    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserError(*this) << "ADMSbsim6: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter CVMOD : [ 0, 1 ]
  if ( (!((CVMOD >=0 && CVMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter CVMOD value " << CVMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter COVMOD : [ 0, 1 ]
  if ( (!((COVMOD >=0 && COVMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter COVMOD value " << COVMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter RDSMOD : [ 0, 2 ]
  if ( (!((RDSMOD >=0 && RDSMOD <=2 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RDSMOD value " << RDSMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter WPEMOD : [ 0, 1 ]
  if ( (!((WPEMOD >=0 && WPEMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter WPEMOD value " << WPEMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter ASYMMOD : [ 0, 1 ]
  if ( (!((ASYMMOD >=0 && ASYMMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter ASYMMOD value " << ASYMMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter GIDLMOD : [ 0, 1 ]
  if ( (!((GIDLMOD >=0 && GIDLMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter GIDLMOD value " << GIDLMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter IGCMOD : [ 0, 1 ]
  if ( (!((IGCMOD >=0 && IGCMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter IGCMOD value " << IGCMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter IGBMOD : [ 0, 1 ]
  if ( (!((IGBMOD >=0 && IGBMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter IGBMOD value " << IGBMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter TNOIMOD : [ 0, 1 ]
  if ( (!((TNOIMOD >=0 && TNOIMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter TNOIMOD value " << TNOIMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter SHMOD : [ 0, 1 ]
  if ( (!((SHMOD >=0 && SHMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter SHMOD value " << SHMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter MOBSCALE : [ 0, 1 ]
  if ( (!((MOBSCALE >=0 && MOBSCALE <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter MOBSCALE value " << MOBSCALE << " out of range [ 0, 1 ]";
  }

  //    Parameter LLONG : ] 0,  (+inf) [
  if ( (!((LLONG >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter LLONG value " << LLONG << " out of range ] 0,  (+inf) [";
  }

  //    Parameter LMLT : ] 0,  (+inf) [
  if ( (!((LMLT >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter LMLT value " << LMLT << " out of range ] 0,  (+inf) [";
  }

  //    Parameter WMLT : ] 0,  (+inf) [
  if ( (!((WMLT >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter WMLT value " << WMLT << " out of range ] 0,  (+inf) [";
  }

  //    Parameter WWIDE : ] 0,  (+inf) [
  if ( (!((WWIDE >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter WWIDE value " << WWIDE << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPLEXP1 : ] 0,  (+inf) [
  if ( (!((NDEPLEXP1 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPLEXP1 value " << NDEPLEXP1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPLEXP2 : ] 0,  (+inf) [
  if ( (!((NDEPLEXP2 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPLEXP2 value " << NDEPLEXP2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPWEXP : ] 0,  (+inf) [
  if ( (!((NDEPWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPWEXP value " << NDEPWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPWLEXP : ] 0,  (+inf) [
  if ( (!((NDEPWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPWLEXP value " << NDEPWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPCVLEXP1 : ] 0,  (+inf) [
  if ( (!((NDEPCVLEXP1 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPCVLEXP1 value " << NDEPCVLEXP1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPCVLEXP2 : ] 0,  (+inf) [
  if ( (!((NDEPCVLEXP2 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPCVLEXP2 value " << NDEPCVLEXP2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPCVWEXP : ] 0,  (+inf) [
  if ( (!((NDEPCVWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPCVWEXP value " << NDEPCVWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NDEPCVWLEXP : ] 0,  (+inf) [
  if ( (!((NDEPCVWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NDEPCVWLEXP value " << NDEPCVWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VFBCVLEXP : ] 0,  (+inf) [
  if ( (!((VFBCVLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VFBCVLEXP value " << VFBCVLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VFBCVWEXP : ] 0,  (+inf) [
  if ( (!((VFBCVWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VFBCVWEXP value " << VFBCVWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VFBCVWLEXP : ] 0,  (+inf) [
  if ( (!((VFBCVWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VFBCVWLEXP value " << VFBCVWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PERMOD : [ 0, 1 ]
  if ( (!((PERMOD >=0 && PERMOD <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PERMOD value " << PERMOD << " out of range [ 0, 1 ]";
  }

  //    Parameter ETABEXP : ] 0,  (+inf) [
  if ( (!((ETABEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter ETABEXP value " << ETABEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter K1LEXP : ] 0,  (+inf) [
  if ( (!((K1LEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter K1LEXP value " << K1LEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter K1WEXP : ] 0,  (+inf) [
  if ( (!((K1WEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter K1WEXP value " << K1WEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter K1WLEXP : ] 0,  (+inf) [
  if ( (!((K1WLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter K1WLEXP value " << K1WLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter K2LEXP : ] 0,  (+inf) [
  if ( (!((K2LEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter K2LEXP value " << K2LEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter K2WEXP : ] 0,  (+inf) [
  if ( (!((K2WEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter K2WEXP value " << K2WEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter K2WLEXP : ] 0,  (+inf) [
  if ( (!((K2WLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter K2WLEXP value " << K2WLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ADOS : [ 0,  (+inf) [
  if ( (!((ADOS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter ADOS value " << ADOS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BDOS : [ 0,  (+inf) [
  if ( (!((BDOS >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter BDOS value " << BDOS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter QM0 : ] 0,  (+inf) [
  if ( (!((QM0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter QM0 value " << QM0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ETAQM : [ 0,  (+inf) [
  if ( (!((ETAQM >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter ETAQM value " << ETAQM << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFACTORLEXP : ] 0,  (+inf) [
  if ( (!((NFACTORLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NFACTORLEXP value " << NFACTORLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NFACTORWEXP : ] 0,  (+inf) [
  if ( (!((NFACTORWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NFACTORWEXP value " << NFACTORWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter NFACTORWLEXP : ] 0,  (+inf) [
  if ( (!((NFACTORWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NFACTORWLEXP value " << NFACTORWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter CDSCDLEXP : ] 0,  (+inf) [
  if ( (!((CDSCDLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter CDSCDLEXP value " << CDSCDLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter CDSCBLEXP : ] 0,  (+inf) [
  if ( (!((CDSCBLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter CDSCBLEXP value " << CDSCBLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VSATLEXP : ] 0,  (+inf) [
  if ( (!((VSATLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VSATLEXP value " << VSATLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VSATWEXP : ] 0,  (+inf) [
  if ( (!((VSATWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VSATWEXP value " << VSATWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VSATWLEXP : ] 0,  (+inf) [
  if ( (!((VSATWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VSATWLEXP value " << VSATWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter DELTALEXP : ] 0,  (+inf) [
  if ( (!((DELTALEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter DELTALEXP value " << DELTALEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VSATCVLEXP : ] 0,  (+inf) [
  if ( (!((VSATCVLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VSATCVLEXP value " << VSATCVLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VSATCVWEXP : ] 0,  (+inf) [
  if ( (!((VSATCVWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VSATCVWEXP value " << VSATCVWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter VSATCVWLEXP : ] 0,  (+inf) [
  if ( (!((VSATCVWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter VSATCVWLEXP value " << VSATCVWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UP1 :  ] (-inf)  (+inf) [

  //    Parameter LP1 :  ] (-inf)  (+inf) [

  //    Parameter UP2 :  ] (-inf)  (+inf) [

  //    Parameter LP2 :  ] (-inf)  (+inf) [

  //    Parameter U0LEXP : ] 0,  (+inf) [
  if ( (!((U0LEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter U0LEXP value " << U0LEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UALEXP : ] 0,  (+inf) [
  if ( (!((UALEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UALEXP value " << UALEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UAWEXP : ] 0,  (+inf) [
  if ( (!((UAWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UAWEXP value " << UAWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UAWLEXP : ] 0,  (+inf) [
  if ( (!((UAWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UAWLEXP value " << UAWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter EULEXP : ] 0,  (+inf) [
  if ( (!((EULEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter EULEXP value " << EULEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter EUWEXP : ] 0,  (+inf) [
  if ( (!((EUWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter EUWEXP value " << EUWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter EUWLEXP : ] 0,  (+inf) [
  if ( (!((EUWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter EUWLEXP value " << EUWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UDLEXP : ] 0,  (+inf) [
  if ( (!((UDLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UDLEXP value " << UDLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UCLEXP : ] 0,  (+inf) [
  if ( (!((UCLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UCLEXP value " << UCLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UCWEXP : ] 0,  (+inf) [
  if ( (!((UCWEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UCWEXP value " << UCWEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter UCWLEXP : ] 0,  (+inf) [
  if ( (!((UCWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter UCWLEXP value " << UCWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PCLMLEXP : ] 0,  (+inf) [
  if ( (!((PCLMLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PCLMLEXP value " << PCLMLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PCLMCVLEXP : ] 0,  (+inf) [
  if ( (!((PCLMCVLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PCLMCVLEXP value " << PCLMCVLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PDITSL : [ 0,  (+inf) [
  if ( (!((PDITSL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PDITSL value " << PDITSL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RSH : [ 0,  (+inf) [
  if ( (!((RSH >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RSH value " << RSH << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PRWBLEXP : ] 0,  (+inf) [
  if ( (!((PRWBLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PRWBLEXP value " << PRWBLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RSWLEXP : ] 0,  (+inf) [
  if ( (!((RSWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RSWLEXP value " << RSWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RDWLEXP : ] 0,  (+inf) [
  if ( (!((RDWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RDWLEXP value " << RDWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RDSWLEXP : ] 0,  (+inf) [
  if ( (!((RDSWLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RDSWLEXP value " << RDSWLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PSATLEXP : ] 0,  (+inf) [
  if ( (!((PSATLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PSATLEXP value " << PSATLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PSATX : ] 0,  (+inf) [
  if ( (!((PSATX >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PSATX value " << PSATX << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PTWGLEXP : ] 0,  (+inf) [
  if ( (!((PTWGLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PTWGLEXP value " << PTWGLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PTWGLEXPR : ] 0,  (+inf) [
  if ( (!((PTWGLEXPR >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PTWGLEXPR value " << PTWGLEXPR << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PDIBLCLEXP : ] 0,  (+inf) [
  if ( (!((PDIBLCLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PDIBLCLEXP value " << PDIBLCLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PDIBLCLEXPR : ] 0,  (+inf) [
  if ( (!((PDIBLCLEXPR >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PDIBLCLEXPR value " << PDIBLCLEXPR << " out of range ] 0,  (+inf) [";
  }

  //    Parameter FPROUTLEXP : ] 0,  (+inf) [
  if ( (!((FPROUTLEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter FPROUTLEXP value " << FPROUTLEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ALPHA0LEXP : ] 0,  (+inf) [
  if ( (!((ALPHA0LEXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter ALPHA0LEXP value " << ALPHA0LEXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter TOXREF : ] 0,  (+inf) [
  if ( (!((TOXREF >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter TOXREF value " << TOXREF << " out of range ] 0,  (+inf) [";
  }

  //    Parameter PIGCD : [ (-50), 50 ]
  if ( (!((PIGCD >=(-50) && PIGCD <=50 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter PIGCD value " << PIGCD << " out of range [ (-50), 50 ]";
  }

  //    Parameter CFRCOEFF : [ 1.0,  (+inf) [
  if ( (!((CFRCOEFF >=1.0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter CFRCOEFF value " << CFRCOEFF << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter XGL :  ] (-inf) ((L*LMLT)+XL) [
  if ( (!((XGL <((L*LMLT)+XL) ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter XGL value " << XGL << " out of range  ] (-inf) ((L*LMLT)+XL) [";
  }

  //    Parameter RSHG : [ 0,  (+inf) [
  if ( (!((RSHG >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RSHG value " << RSHG << " out of range [ 0,  (+inf) [";
  }

  //    Parameter GBMIN : [ 0,  (+inf) [
  if ( (!((GBMIN >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter GBMIN value " << GBMIN << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPS0 : ] 0,  (+inf) [
  if ( (!((RBPS0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPS0 value " << RBPS0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBPSL : [ 0,  (+inf) [
  if ( (!((RBPSL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPSL value " << RBPSL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPSW : [ 0,  (+inf) [
  if ( (!((RBPSW >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPSW value " << RBPSW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPSNF : [ 0,  (+inf) [
  if ( (!((RBPSNF >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPSNF value " << RBPSNF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPD0 : ] 0,  (+inf) [
  if ( (!((RBPD0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPD0 value " << RBPD0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBPDL : [ 0,  (+inf) [
  if ( (!((RBPDL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPDL value " << RBPDL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPDW : [ 0,  (+inf) [
  if ( (!((RBPDW >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPDW value " << RBPDW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPDNF : [ 0,  (+inf) [
  if ( (!((RBPDNF >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPDNF value " << RBPDNF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPBX0 : ] 0,  (+inf) [
  if ( (!((RBPBX0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBX0 value " << RBPBX0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBPBXL : [ 0,  (+inf) [
  if ( (!((RBPBXL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBXL value " << RBPBXL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPBXW : [ 0,  (+inf) [
  if ( (!((RBPBXW >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBXW value " << RBPBXW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPBXNF : [ 0,  (+inf) [
  if ( (!((RBPBXNF >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBXNF value " << RBPBXNF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPBY0 : ] 0,  (+inf) [
  if ( (!((RBPBY0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBY0 value " << RBPBY0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBPBYL : [ 0,  (+inf) [
  if ( (!((RBPBYL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBYL value " << RBPBYL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPBYW : [ 0,  (+inf) [
  if ( (!((RBPBYW >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBYW value " << RBPBYW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBPBYNF : [ 0,  (+inf) [
  if ( (!((RBPBYNF >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBPBYNF value " << RBPBYNF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSBX0 : ] 0,  (+inf) [
  if ( (!((RBSBX0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSBX0 value " << RBSBX0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBSBY0 : ] 0,  (+inf) [
  if ( (!((RBSBY0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSBY0 value " << RBSBY0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBDBX0 : ] 0,  (+inf) [
  if ( (!((RBDBX0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBDBX0 value " << RBDBX0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBDBY0 : ] 0,  (+inf) [
  if ( (!((RBDBY0 >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBDBY0 value " << RBDBY0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter RBSDBXL : [ 0,  (+inf) [
  if ( (!((RBSDBXL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSDBXL value " << RBSDBXL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSDBXW : [ 0,  (+inf) [
  if ( (!((RBSDBXW >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSDBXW value " << RBSDBXW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSDBXNF : [ 0,  (+inf) [
  if ( (!((RBSDBXNF >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSDBXNF value " << RBSDBXNF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSDBYL : [ 0,  (+inf) [
  if ( (!((RBSDBYL >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSDBYL value " << RBSDBYL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSDBYW : [ 0,  (+inf) [
  if ( (!((RBSDBYW >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSDBYW value " << RBSDBYW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBSDBYNF : [ 0,  (+inf) [
  if ( (!((RBSDBYNF >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter RBSDBYNF value " << RBSDBYNF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter EF : ] 0, 2 ]
  if ( (!((EF >0 && EF <=2 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter EF value " << EF << " out of range ] 0, 2 ]";
  }

  //    Parameter NTNOI : [ 0,  (+inf) [
  if ( (!((NTNOI >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter NTNOI value " << NTNOI << " out of range [ 0,  (+inf) [";
  }

  //    Parameter TNOIA :  ] (-inf)  (+inf) [

  //    Parameter TNOIB :  ] (-inf)  (+inf) [

  //    Parameter TNOIC :  ] (-inf)  (+inf) [

  //    Parameter BINUNIT : [ 0, 1 ]
  if ( (!((BINUNIT >=0 && BINUNIT <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter BINUNIT value " << BINUNIT << " out of range [ 0, 1 ]";
  }

  //    Parameter KT1EXP : ] 0,  (+inf) [
  if ( (!((KT1EXP >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter KT1EXP value " << KT1EXP << " out of range ] 0,  (+inf) [";
  }

  //    Parameter SAREF : ] 0,  (+inf) [
  if ( (!((SAREF >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter SAREF value " << SAREF << " out of range ] 0,  (+inf) [";
  }

  //    Parameter SBREF : ] 0,  (+inf) [
  if ( (!((SBREF >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter SBREF value " << SBREF << " out of range ] 0,  (+inf) [";
  }

  //    Parameter WLOD : [ 0,  (+inf) [
  if ( (!((WLOD >=0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter WLOD value " << WLOD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCREF : ] 0,  (+inf) [
  if ( (!((SCREF >0))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter SCREF value " << SCREF << " out of range ] 0,  (+inf) [";
  }

  //    Parameter EDGEFET : [ 0, 1 ]
  if ( (!((EDGEFET >=0 && EDGEFET <=1 ))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter EDGEFET value " << EDGEFET << " out of range [ 0, 1 ]";
  }

  //    Parameter WEDGE : [ 1.0e-9,  (+inf) [
  if ( (!((WEDGE >=1.0e-9))) )
  {
    UserError(*this) << "ADMSbsim6: Parameter WEDGE value " << WEDGE << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter DGAMMAEDGE :  ] (-inf)  (+inf) [

  //    Parameter DGAMMAEDGEL :  ] (-inf)  (+inf) [

  //    Parameter DGAMMAEDGELEXP :  ] (-inf)  (+inf) [

  //    Parameter DVTEDGE :  ] (-inf)  (+inf) [

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    L(10*1.0e-6),
    VFBSDOFF(0.0),
    XGW(0.0),
    NGCON(1),
    RGATEMOD(0),
    RBODYMOD(0),
    GEOMOD(0),
    RGEOMOD(0),
    RBPB(50.0),
    RBPD(50.0),
    RBPS(50.0),
    RBDB(50.0),
    RBSB(50.0),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    TYPE(1),
    CVMOD(0),
    COVMOD(0),
    RDSMOD(0),
    WPEMOD(0),
    ASYMMOD(0),
    GIDLMOD(0),
    IGCMOD(0),
    IGBMOD(0),
    TNOIMOD(0),
    SHMOD(0),
    MOBSCALE(0),
    LLONG(10*1.0e-6),
    LMLT(1.0),
    WMLT(1.0),
    XL(0.0),
    WWIDE(10*1.0e-6),
    XW(0.0),
    LINT(0.0),
    LL(0.0),
    LW(0.0),
    LWL(0.0),
    LLN(1.0),
    LWN(1.0),
    WINT(0.0),
    WL(0.0),
    WW(0.0),
    WWL(0.0),
    WLN(1.0),
    WWN(1.0),
    DLC(0.0),
    LLC(0.0),
    LWC(0.0),
    LWLC(0.0),
    DWC(0.0),
    WLC(0.0),
    WWC(0.0),
    WWLC(0.0),
    TOXE(3.0e-9),
    TOXP(0.0),
    DTOX(0.0),
    NDEP(1e24),
    NDEPL1(0.0),
    NDEPLEXP1(1.0),
    NDEPL2(0.0),
    NDEPLEXP2(2.0),
    NDEPW(0.0),
    NDEPWEXP(1.0),
    NDEPWL(0.0),
    NDEPWLEXP(1.0),
    LNDEP(0.0),
    WNDEP(0.0),
    PNDEP(0.0),
    NDEPCV(0.0),
    NDEPCVL1(0.0),
    NDEPCVLEXP1(0.0),
    NDEPCVL2(0.0),
    NDEPCVLEXP2(0.0),
    NDEPCVW(0.0),
    NDEPCVWEXP(0.0),
    NDEPCVWL(0.0),
    NDEPCVWLEXP(0.0),
    LNDEPCV(0.0),
    WNDEPCV(0.0),
    PNDEPCV(0.0),
    NGATE(5e25),
    LNGATE(0.0),
    WNGATE(0.0),
    PNGATE(0.0),
    EASUB(4.05),
    NI0SUB(1.1e16),
    BG0SUB(1.17),
    EPSRSUB(11.9),
    EPSROX(3.9),
    XJ(1.5e-7),
    LXJ(0.0),
    WXJ(0.0),
    PXJ(0.0),
    LVFB(0.0),
    WVFB(0.0),
    PVFB(0.0),
    VFB((-0.5)),
    VFBCV(0.0),
    LVFBCV(0.0),
    WVFBCV(0.0),
    PVFBCV(0.0),
    VFBCVL(0.0),
    VFBCVLEXP(1.0),
    VFBCVW(0.0),
    VFBCVWEXP(1.0),
    VFBCVWL(0.0),
    VFBCVWLEXP(1.0),
    PERMOD(1),
    DWJ(0.0),
    NSD(1e26),
    LNSD(0.0),
    WNSD(0.0),
    PNSD(0.0),
    DELVT0(0.0),
    DVTP0(0.0),
    LDVTP0(0),
    WDVTP0(0),
    PDVTP0(0),
    DVTP1(0.0),
    LDVTP1(0),
    WDVTP1(0),
    PDVTP1(0),
    DVTP2(0.0),
    LDVTP2(0),
    WDVTP2(0),
    PDVTP2(0),
    DVTP3(0.0),
    LDVTP3(0),
    WDVTP3(0),
    PDVTP3(0),
    DVTP4(0.0),
    LDVTP4(0),
    WDVTP4(0),
    PDVTP4(0),
    DVTP5(0.0),
    LDVTP5(0),
    WDVTP5(0),
    PDVTP5(0),
    PHIN(0.045),
    LPHIN(0.0),
    WPHIN(0.0),
    PPHIN(0.0),
    ETA0(0.08),
    LETA0(0.0),
    WETA0(0.0),
    PETA0(0.0),
    ETA0R(0.0),
    LETA0R(0.0),
    WETA0R(0.0),
    PETA0R(0.0),
    DSUB(1.0),
    ETAB((-0.07)),
    ETABEXP(1.0),
    LETAB(0.0),
    WETAB(0.0),
    PETAB(0.0),
    K1(0.0),
    K1L(0.0),
    K1LEXP(1.0),
    K1W(0.0),
    K1WEXP(1.0),
    K1WL(0.0),
    K1WLEXP(1.0),
    LK1(0.0),
    WK1(0.0),
    PK1(0.0),
    K2(0.0),
    K2L(0.0),
    K2LEXP(1.0),
    K2W(0.0),
    K2WEXP(1.0),
    K2WL(0.0),
    K2WLEXP(1.0),
    LK2(0.0),
    WK2(0.0),
    PK2(0.0),
    ADOS(0.0),
    BDOS(1.0),
    QM0(1.0e-3),
    ETAQM(0.54),
    CIT(0.0),
    LCIT(0.0),
    WCIT(0.0),
    PCIT(0.0),
    NFACTOR(0.0),
    NFACTORL(0.0),
    NFACTORLEXP(1.0),
    NFACTORW(0.0),
    NFACTORWEXP(1.0),
    NFACTORWL(0.0),
    NFACTORWLEXP(1.0),
    LNFACTOR(0.0),
    WNFACTOR(0.0),
    PNFACTOR(0.0),
    CDSCD(1e-9),
    CDSCDL(0.0),
    CDSCDLEXP(1.0),
    LCDSCD(0.0),
    WCDSCD(0.0),
    PCDSCD(0.0),
    CDSCDR(0.0),
    CDSCDLR(0.0),
    LCDSCDR(0.0),
    WCDSCDR(0.0),
    PCDSCDR(0.0),
    CDSCB(0.0),
    CDSCBL(0.0),
    CDSCBLEXP(1.0),
    LCDSCB(0.0),
    WCDSCB(0.0),
    PCDSCB(0.0),
    VSAT(1e5),
    LVSAT(0.0),
    WVSAT(0.0),
    PVSAT(0.0),
    VSATL(0.0),
    VSATLEXP(1.0),
    VSATW(0.0),
    VSATWEXP(1.0),
    VSATWL(0.0),
    VSATWLEXP(1.0),
    VSATR(0.0),
    LVSATR(0.0),
    WVSATR(0.0),
    PVSATR(0.0),
    DELTA(0.125),
    LDELTA(0.0),
    WDELTA(0.0),
    PDELTA(0.0),
    DELTAL(0.0),
    DELTALEXP(1.0),
    VSATCV(0.0),
    LVSATCV(0.0),
    WVSATCV(0.0),
    PVSATCV(0.0),
    VSATCVL(0.0),
    VSATCVLEXP(0.0),
    VSATCVW(0.0),
    VSATCVWEXP(0.0),
    VSATCVWL(0.0),
    VSATCVWLEXP(0.0),
    UP1(0.0),
    LP1(1.0e-8),
    UP2(0.0),
    LP2(1.0e-8),
    MULU0(1.0),
    U0(67.0e-3),
    U0L(0.0),
    U0LEXP(1.0),
    LU0(0.0),
    WU0(0.0),
    PU0(0.0),
    U0R(0.0),
    LU0R(0.0),
    WU0R(0.0),
    PU0R(0.0),
    ETAMOB(1.0),
    UA(0.001),
    UAL(0.0),
    UALEXP(1.0),
    UAW(0.0),
    UAWEXP(1.0),
    UAWL(0.0),
    UAWLEXP(1.0),
    LUA(0.0),
    WUA(0.0),
    PUA(0.0),
    UAR(0.0),
    LUAR(0.0),
    WUAR(0.0),
    PUAR(0.0),
    EU(1.5),
    LEU(0.0),
    WEU(0.0),
    PEU(0.0),
    EUL(0.0),
    EULEXP(1.0),
    EUW(0.0),
    EUWEXP(1.0),
    EUWL(0.0),
    EUWLEXP(1.0),
    UD(0.001),
    UDL(0.0),
    UDLEXP(1.0),
    LUD(0.0),
    WUD(0.0),
    PUD(0.0),
    UDR(0.0),
    LUDR(0.0),
    WUDR(0.0),
    PUDR(0.0),
    UCS(2.0),
    LUCS(0.0),
    WUCS(0.0),
    PUCS(0.0),
    UCSR(0.0),
    LUCSR(0.0),
    WUCSR(0.0),
    PUCSR(0.0),
    UC(0.0),
    UCL(0.0),
    UCLEXP(1.0),
    UCW(0.0),
    UCWEXP(1.0),
    UCWL(0.0),
    UCWLEXP(1.0),
    LUC(0.0),
    WUC(0.0),
    PUC(0.0),
    UCR(0.0),
    LUCR(0.0),
    WUCR(0.0),
    PUCR(0.0),
    PCLM(0.0),
    PCLML(0.0),
    PCLMLEXP(1.0),
    LPCLM(0.0),
    WPCLM(0.0),
    PPCLM(0.0),
    PCLMR(0.0),
    LPCLMR(0.0),
    WPCLMR(0.0),
    PPCLMR(0.0),
    PCLMG(0.0),
    PCLMCV(0.0),
    PCLMCVL(0.0),
    PCLMCVLEXP(0.0),
    LPCLMCV(0.0),
    WPCLMCV(0.0),
    PPCLMCV(0.0),
    PSCBE1(4.24e8),
    LPSCBE1(0.0),
    WPSCBE1(0.0),
    PPSCBE1(0.0),
    PSCBE2(1.0e-8),
    LPSCBE2(0.0),
    WPSCBE2(0.0),
    PPSCBE2(0.0),
    PDITS(0.0),
    LPDITS(0.0),
    WPDITS(0.0),
    PPDITS(0.0),
    PDITSL(0.0),
    PDITSD(0.0),
    LPDITSD(0.0),
    WPDITSD(0.0),
    PPDITSD(0.0),
    RSH(0.0),
    PRWG(1.0),
    LPRWG(0.0),
    WPRWG(0.0),
    PPRWG(0.0),
    PRWB(0.0),
    LPRWB(0.0),
    WPRWB(0.0),
    PPRWB(0.0),
    PRWBL(0.0),
    PRWBLEXP(1.0),
    WR(1.0),
    LWR(0.0),
    WWR(0.0),
    PWR(0.0),
    RSWMIN(0.0),
    LRSWMIN(0.0),
    WRSWMIN(0.0),
    PRSWMIN(0.0),
    RSW(10.0),
    LRSW(0.0),
    WRSW(0.0),
    PRSW(0.0),
    RSWL(0.0),
    RSWLEXP(1.0),
    RDWMIN(0.0),
    LRDWMIN(0.0),
    WRDWMIN(0.0),
    PRDWMIN(0.0),
    RDW(0.0),
    LRDW(0.0),
    WRDW(0.0),
    PRDW(0.0),
    RDWL(0.0),
    RDWLEXP(0.0),
    RDSWMIN(0.0),
    LRDSWMIN(0.0),
    WRDSWMIN(0.0),
    PRDSWMIN(0.0),
    RDSW(20.0),
    RDSWL(0.0),
    RDSWLEXP(1.0),
    LRDSW(0.0),
    WRDSW(0.0),
    PRDSW(0.0),
    PSAT(1.0),
    LPSAT(0.0),
    WPSAT(0.0),
    PPSAT(0.0),
    PSATL(0.0),
    PSATLEXP(1.0),
    PSATB(0.0),
    PSATR(0.0),
    LPSATR(0.0),
    WPSATR(0.0),
    PPSATR(0.0),
    LPSATB(0.0),
    WPSATB(0.0),
    PPSATB(0.0),
    PSATX(1.0),
    PTWG(0.0),
    LPTWG(0.0),
    WPTWG(0.0),
    PPTWG(0.0),
    PTWGL(0.0),
    PTWGLEXP(1.0),
    PTWGR(0.0),
    LPTWGR(0.0),
    WPTWGR(0.0),
    PPTWGR(0.0),
    PTWGLR(0.0),
    PTWGLEXPR(0.0),
    A1(0.0),
    LA1(0.0),
    WA1(0.0),
    PA1(0.0),
    A11(0.0),
    LA11(0.0),
    WA11(0.0),
    PA11(0.0),
    A2(0.0),
    LA2(0.0),
    WA2(0.0),
    PA2(0.0),
    A21(0.0),
    LA21(0.0),
    WA21(0.0),
    PA21(0.0),
    PDIBLC(0.0),
    PDIBLCL(0.0),
    PDIBLCLEXP(1.0),
    LPDIBLC(0.0),
    WPDIBLC(0.0),
    PPDIBLC(0.0),
    PDIBLCR(0.0),
    PDIBLCLR(0.0),
    PDIBLCLEXPR(0.0),
    LPDIBLCR(0.0),
    WPDIBLCR(0.0),
    PPDIBLCR(0.0),
    PDIBLCB(0.0),
    LPDIBLCB(0.0),
    WPDIBLCB(0.0),
    PPDIBLCB(0.0),
    PVAG(1.0),
    LPVAG(0.0),
    WPVAG(0.0),
    PPVAG(0.0),
    FPROUT(0.0),
    FPROUTL(0.0),
    FPROUTLEXP(1.0),
    LFPROUT(0.0),
    WFPROUT(0.0),
    PFPROUT(0.0),
    ALPHA0(0.0),
    ALPHA0L(0.0),
    ALPHA0LEXP(1.0),
    LALPHA0(0.0),
    WALPHA0(0.0),
    PALPHA0(0.0),
    BETA0(0.0),
    LBETA0(0.0),
    WBETA0(0.0),
    PBETA0(0.0),
    AIGBACC(1.36e-2),
    BIGBACC(1.71e-3),
    CIGBACC(0.075),
    NIGBACC(1.0),
    AIGBINV(1.11e-2),
    BIGBINV(9.49e-4),
    CIGBINV(0.006),
    EIGBINV(1.1),
    NIGBINV(3.0),
    AIGC(0.0),
    BIGC(0.0),
    CIGC(0.0),
    AIGS(0.0),
    BIGS(0.0),
    CIGS(0.0),
    AIGD(0.0),
    BIGD(0.0),
    CIGD(0.0),
    DLCIG(0.0),
    DLCIGD(0.0),
    POXEDGE(1.0),
    NTOX(1.0),
    TOXREF(3.0e-9),
    PIGCD(1.0),
    AIGCL(0.0),
    AIGCW(0.0),
    AIGSL(0.0),
    AIGSW(0.0),
    AIGDL(0.0),
    AIGDW(0.0),
    PIGCDL(0.0),
    LAIGBINV(0.0),
    WAIGBINV(0.0),
    PAIGBINV(0.0),
    LBIGBINV(0.0),
    WBIGBINV(0.0),
    PBIGBINV(0.0),
    LCIGBINV(0.0),
    WCIGBINV(0.0),
    PCIGBINV(0.0),
    LEIGBINV(0.0),
    WEIGBINV(0.0),
    PEIGBINV(0.0),
    LNIGBINV(0.0),
    WNIGBINV(0.0),
    PNIGBINV(0.0),
    LAIGBACC(0.0),
    WAIGBACC(0.0),
    PAIGBACC(0.0),
    LBIGBACC(0.0),
    WBIGBACC(0.0),
    PBIGBACC(0.0),
    LCIGBACC(0.0),
    WCIGBACC(0.0),
    PCIGBACC(0.0),
    LNIGBACC(0.0),
    WNIGBACC(0.0),
    PNIGBACC(0.0),
    LAIGC(0.0),
    WAIGC(0.0),
    PAIGC(0.0),
    LBIGC(0.0),
    WBIGC(0.0),
    PBIGC(0.0),
    LCIGC(0.0),
    WCIGC(0.0),
    PCIGC(0.0),
    LAIGS(0.0),
    WAIGS(0.0),
    PAIGS(0.0),
    LBIGS(0.0),
    WBIGS(0.0),
    PBIGS(0.0),
    LCIGS(0.0),
    WCIGS(0.0),
    PCIGS(0.0),
    LAIGD(0.0),
    WAIGD(0.0),
    PAIGD(0.0),
    LBIGD(0.0),
    WBIGD(0.0),
    PBIGD(0.0),
    LCIGD(0.0),
    WCIGD(0.0),
    PCIGD(0.0),
    LPOXEDGE(0.0),
    WPOXEDGE(0.0),
    PPOXEDGE(0.0),
    LDLCIG(0.0),
    WDLCIG(0.0),
    PDLCIG(0.0),
    LDLCIGD(0.0),
    WDLCIGD(0.0),
    PDLCIGD(0.0),
    LNTOX(0.0),
    WNTOX(0.0),
    PNTOX(0.0),
    AGIDL(0.0),
    AGIDLL(0.0),
    AGIDLW(0.0),
    LAGIDL(0.0),
    WAGIDL(0.0),
    PAGIDL(0.0),
    BGIDL(2.3e9),
    LBGIDL(0.0),
    WBGIDL(0.0),
    PBGIDL(0.0),
    CGIDL(0.5),
    LCGIDL(0.0),
    WCGIDL(0.0),
    PCGIDL(0.0),
    EGIDL(0.8),
    LEGIDL(0.0),
    WEGIDL(0.0),
    PEGIDL(0.0),
    AGISL(0.0),
    AGISLL(0.0),
    AGISLW(0.0),
    LAGISL(0.0),
    WAGISL(0.0),
    PAGISL(0.0),
    BGISL(0.0),
    LBGISL(0.0),
    WBGISL(0.0),
    PBGISL(0.0),
    CGISL(0.0),
    LCGISL(0.0),
    WCGISL(0.0),
    PCGISL(0.0),
    EGISL(0.0),
    LEGISL(0.0),
    WEGISL(0.0),
    PEGISL(0.0),
    CF(0.0),
    LCF(0.0),
    WCF(0.0),
    PCF(0.0),
    CFRCOEFF(1.0),
    CGSO(0.0),
    CGDO(0.0),
    CGBO(0.0),
    CGSL(0.0),
    LCGSL(0.0),
    WCGSL(0.0),
    PCGSL(0.0),
    CGDL(0.0),
    LCGDL(0.0),
    WCGDL(0.0),
    PCGDL(0.0),
    CKAPPAS(0.6),
    LCKAPPAS(0.0),
    WCKAPPAS(0.0),
    PCKAPPAS(0.0),
    CKAPPAD(0.6),
    LCKAPPAD(0.0),
    WCKAPPAD(0.0),
    PCKAPPAD(0.0),
    DMCG(0.0),
    DMCI(0.0),
    DMDG(0.0),
    DMCGT(0.0),
    XGL(0.0),
    RSHG(0.1),
    CJS(5.0e-4),
    CJD(0.0),
    CJSWS(5.0e-10),
    CJSWD(0.0),
    CJSWGS(0.0),
    CJSWGD(0.0),
    PBS(1.0),
    PBD(0.0),
    PBSWS(1.0),
    PBSWD(0.0),
    PBSWGS(0.0),
    PBSWGD(0.0),
    MJS(0.5),
    MJD(0.0),
    MJSWS(0.33),
    MJSWD(0.0),
    MJSWGS(0.0),
    MJSWGD(0.0),
    JSS(1.0e-4),
    JSD(0.0),
    JSWS(0.0),
    JSWD(0.0),
    JSWGS(0.0),
    JSWGD(0.0),
    NJS(1.0),
    NJD(0.0),
    IJTHSFWD(0.1),
    IJTHDFWD(0.0),
    IJTHSREV(0.1),
    IJTHDREV(0.0),
    BVS(10.0),
    BVD(0.0),
    XJBVS(1.0),
    XJBVD(0.0),
    JTSS(0.0),
    JTSD(0.0),
    JTSSWS(0.0),
    JTSSWD(0.0),
    JTSSWGS(0.0),
    JTSSWGD(0.0),
    JTWEFF(0.0),
    NJTS(20.0),
    NJTSD(0.0),
    NJTSSW(20.0),
    NJTSSWD(0.0),
    NJTSSWG(20.0),
    NJTSSWGD(0.0),
    VTSS(10.0),
    VTSD(0.0),
    VTSSWS(10.0),
    VTSSWD(0.0),
    VTSSWGS(10.0),
    VTSSWGD(0.0),
    XRCRG1(12.0),
    XRCRG2(1.0),
    GBMIN(1.0e-12),
    RBPS0(50.0),
    RBPSL(0.0),
    RBPSW(0.0),
    RBPSNF(0.0),
    RBPD0(50.0),
    RBPDL(0.0),
    RBPDW(0.0),
    RBPDNF(0.0),
    RBPBX0(100.0),
    RBPBXL(0.0),
    RBPBXW(0.0),
    RBPBXNF(0.0),
    RBPBY0(100.0),
    RBPBYL(0.0),
    RBPBYW(0.0),
    RBPBYNF(0.0),
    RBSBX0(100.0),
    RBSBY0(100.0),
    RBDBX0(100.0),
    RBDBY0(100.0),
    RBSDBXL(0.0),
    RBSDBXW(0.0),
    RBSDBXNF(0.0),
    RBSDBYL(0.0),
    RBSDBYW(0.0),
    RBSDBYNF(0.0),
    EF(1.0),
    EM(4.1e7),
    NOIA(6.250e+40),
    NOIB(3.125e+25),
    NOIC(8.750e+8),
    LINTNOI(0.0),
    NTNOI(1.0),
    RNOIA(0.577),
    RNOIB(0.5164),
    RNOIC(0.395),
    TNOIA(0.0),
    TNOIB(0.0),
    TNOIC(0.0),
    BINUNIT(1),
    DLBIN(0.0),
    DWBIN(0.0),
    TNOM(27.0),
    DTEMP(0.0),
    TBGASUB(4.73e-4),
    TBGBSUB(636.0),
    TNFACTOR(0.0),
    UTE((-1.5)),
    LUTE(0.0),
    WUTE(0.0),
    PUTE(0.0),
    UTEL(0.0),
    UA1(1.0e-3),
    LUA1(0.0),
    WUA1(0.0),
    PUA1(0.0),
    UA1L(0.0),
    UC1(0.056e-9),
    LUC1(0.0),
    WUC1(0.0),
    PUC1(0.0),
    UD1(0.0),
    LUD1(0.0),
    WUD1(0.0),
    PUD1(0.0),
    UD1L(0.0),
    UCSTE((-4.775e-3)),
    LUCSTE(0.0),
    WUCSTE(0.0),
    PUCSTE(0.0),
    TETA0(0.0),
    PRT(0.0),
    LPRT(0.0),
    WPRT(0.0),
    PPRT(0.0),
    AT((-1.56e-3)),
    LAT(0.0),
    WAT(0.0),
    PAT(0.0),
    ATL(0.0),
    TDELTA(0.0),
    PTWGT(0.0),
    LPTWGT(0.0),
    WPTWGT(0.0),
    PPTWGT(0.0),
    PTWGTL(0.0),
    KT1((-0.11)),
    KT1EXP(1.0),
    KT1L(0.0),
    LKT1(0.0),
    WKT1(0.0),
    PKT1(0.0),
    KT2(0.022),
    LKT2(0.0),
    WKT2(0.0),
    PKT2(0.0),
    IIT(0.0),
    LIIT(0.0),
    WIIT(0.0),
    PIIT(0.0),
    IGT(2.5),
    LIGT(0.0),
    WIGT(0.0),
    PIGT(0.0),
    TGIDL(0.0),
    LTGIDL(0.0),
    WTGIDL(0.0),
    PTGIDL(0.0),
    TCJ(0.0),
    TCJSW(0.0),
    TCJSWG(0.0),
    TPB(0.0),
    TPBSW(0.0),
    TPBSWG(0.0),
    XTIS(3.0),
    XTID(0.0),
    XTSS(0.02),
    XTSD(0.0),
    XTSSWS(0.02),
    XTSSWD(0.0),
    XTSSWGS(0.02),
    XTSSWGD(0.0),
    TNJTS(0.0),
    TNJTSD(0.0),
    TNJTSSW(0.0),
    TNJTSSWD(0.0),
    TNJTSSWG(0.0),
    TNJTSSWGD(0.0),
    RTH0(0.0),
    CTH0(1.0E-05),
    WTH0(0.0),
    SAREF(1.0e-6),
    SBREF(1.0e-6),
    WLOD(0.0),
    KU0(0.0),
    KVSAT(0.0),
    TKU0(0.0),
    LKU0(0.0),
    WKU0(0.0),
    PKU0(0.0),
    LLODKU0(0.0),
    WLODKU0(0.0),
    KVTH0(0.0),
    LKVTH0(0.0),
    WKVTH0(0.0),
    PKVTH0(0.0),
    LLODVTH(0.0),
    WLODVTH(0.0),
    STK2(0.0),
    LODK2(0.0),
    STETA0(0.0),
    LODETA0(0.0),
    WEB(0.0),
    WEC(0.0),
    KVTH0WE(0.0),
    LKVTH0WE(0.0),
    WKVTH0WE(0.0),
    PKVTH0WE(0.0),
    K2WE(0.0),
    LK2WE(0.0),
    WK2WE(0.0),
    PK2WE(0.0),
    KU0WE(0.0),
    LKU0WE(0.0),
    WKU0WE(0.0),
    PKU0WE(0.0),
    SCREF(1.0e-6),
    EDGEFET(1),
    WEDGE(10.0e-9),
    DGAMMAEDGE(0.0),
    DGAMMAEDGEL(0.0),
    DGAMMAEDGELEXP(1.0),
    DVTEDGE(0.0),
    NFACTOREDGE(0.0),
    CITEDGE(0.0),
    CDSCDEDGE(0.0),
    CDSCBEDGE(0.0),
    ETA0EDGE(0.0),
    ETABEDGE(0.0),
    KT1EDGE(0.0),
    KT1LEDGE(0.0),
    KT2EDGE(0.0),
    KT1EXPEDGE(0.0),
    TNFACTOREDGE(0.0),
    TETA0EDGE(0.0),
    DVT0EDGE(2.2),
    DVT1EDGE(0.53),
    DVT2EDGE(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "L  =  " << (*iter)->L << std::endl;
    os << "W  =  " << (*iter)->W << std::endl;
    os << "NF  =  " << (*iter)->NF << std::endl;
    os << "NRS  =  " << (*iter)->NRS << std::endl;
    os << "NRD  =  " << (*iter)->NRD << std::endl;
    os << "VFBSDOFF  =  " << (*iter)->VFBSDOFF << std::endl;
    os << "MINZ  =  " << (*iter)->MINZ << std::endl;
    os << "XGW  =  " << (*iter)->XGW << std::endl;
    os << "NGCON  =  " << (*iter)->NGCON << std::endl;
    os << "RGATEMOD  =  " << (*iter)->RGATEMOD << std::endl;
    os << "RBODYMOD  =  " << (*iter)->RBODYMOD << std::endl;
    os << "GEOMOD  =  " << (*iter)->GEOMOD << std::endl;
    os << "RGEOMOD  =  " << (*iter)->RGEOMOD << std::endl;
    os << "RBPB  =  " << (*iter)->RBPB << std::endl;
    os << "RBPD  =  " << (*iter)->RBPD << std::endl;
    os << "RBPS  =  " << (*iter)->RBPS << std::endl;
    os << "RBDB  =  " << (*iter)->RBDB << std::endl;
    os << "RBSB  =  " << (*iter)->RBSB << std::endl;
    os << "SA  =  " << (*iter)->SA << std::endl;
    os << "SB  =  " << (*iter)->SB << std::endl;
    os << "SD  =  " << (*iter)->SD << std::endl;
    os << "SCA  =  " << (*iter)->SCA << std::endl;
    os << "SCB  =  " << (*iter)->SCB << std::endl;
    os << "SCC  =  " << (*iter)->SCC << std::endl;
    os << "SC  =  " << (*iter)->SC << std::endl;
    os << "AS  =  " << (*iter)->AS << std::endl;
    os << "AD  =  " << (*iter)->AD << std::endl;
    os << "PS  =  " << (*iter)->PS << std::endl;
    os << "PD  =  " << (*iter)->PD << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
  if (deviceMap.empty() ||
      ((deviceMap.find("M") != deviceMap.end() && (levelSet.find(77)!=levelSet.end()))))
  {
    MOSFET1::registerDevice();
    Config<Traits>::addConfiguration()
      .registerDevice("m", 77)
      .registerModelType("nmos", 77)
      .registerModelType("pmos", 77);
  }
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_VFBSDOFF,
   bool instancePar_given_VFBSDOFF,
   AdmsSensFadType & instancePar_XGW,
   bool instancePar_given_XGW,
   AdmsSensFadType & instancePar_RBPB,
   bool instancePar_given_RBPB,
   AdmsSensFadType & instancePar_RBPD,
   bool instancePar_given_RBPD,
   AdmsSensFadType & instancePar_RBPS,
   bool instancePar_given_RBPS,
   AdmsSensFadType & instancePar_RBDB,
   bool instancePar_given_RBDB,
   AdmsSensFadType & instancePar_RBSB,
   bool instancePar_given_RBSB,
   AdmsSensFadType & instancePar_SA,
   bool instancePar_given_SA,
   AdmsSensFadType & instancePar_SB,
   bool instancePar_given_SB,
   AdmsSensFadType & instancePar_SD,
   bool instancePar_given_SD,
   AdmsSensFadType & instancePar_AS,
   bool instancePar_given_AS,
   AdmsSensFadType & instancePar_AD,
   bool instancePar_given_AD,
   AdmsSensFadType & instancePar_PS,
   bool instancePar_given_PS,
   AdmsSensFadType & instancePar_PD,
   bool instancePar_given_PD,
   // non-reals(including hidden)
   int instancePar_NF,
   bool instancePar_given_NF,
   int instancePar_MINZ,
   bool instancePar_given_MINZ,
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   int instancePar_RGATEMOD,
   bool instancePar_given_RGATEMOD,
   int instancePar_RBODYMOD,
   bool instancePar_given_RBODYMOD,
   int instancePar_GEOMOD,
   bool instancePar_given_GEOMOD,
   int instancePar_RGEOMOD,
   bool instancePar_given_RGEOMOD,
   int instancePar_SCA,
   bool instancePar_given_SCA,
   int instancePar_SCB,
   bool instancePar_given_SCB,
   int instancePar_SCC,
   bool instancePar_given_SCC,
   int instancePar_SC,
   bool instancePar_given_SC,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_T0,
   AdmsSensFadType & instanceVar_T1,
   AdmsSensFadType & instanceVar_T2,
   AdmsSensFadType & instanceVar_epssi,
   AdmsSensFadType & instanceVar_epsox,
   AdmsSensFadType & instanceVar_Weff,
   AdmsSensFadType & instanceVar_Leff,
   AdmsSensFadType & instanceVar_Wact,
   AdmsSensFadType & instanceVar_Lact,
   AdmsSensFadType & instanceVar_Weffcj,
   AdmsSensFadType & instanceVar_Cox,
   AdmsSensFadType & instanceVar_epsratio,
   AdmsSensFadType & instanceVar_Lnew,
   AdmsSensFadType & instanceVar_L_mult,
   AdmsSensFadType & instanceVar_Wnew,
   AdmsSensFadType & instanceVar_DVTP0_i,
   AdmsSensFadType & instanceVar_DVTP1_i,
   AdmsSensFadType & instanceVar_DVTP2_i,
   AdmsSensFadType & instanceVar_DVTP3_i,
   AdmsSensFadType & instanceVar_DVTP4_i,
   AdmsSensFadType & instanceVar_DVTP5_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A11_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A21_i,
   AdmsSensFadType & instanceVar_PSAT_i,
   AdmsSensFadType & instanceVar_PSATR_i,
   AdmsSensFadType & instanceVar_BSIM6TOXP,
   AdmsSensFadType & instanceVar_DMCGeff,
   AdmsSensFadType & instanceVar_DMDGeff,
   AdmsSensFadType & instanceVar_DMCIeff,
   AdmsSensFadType & instanceVar_RSourceGeo,
   AdmsSensFadType & instanceVar_RDrainGeo,
   AdmsSensFadType & instanceVar_Grgeltd,
   AdmsSensFadType & instanceVar_Grbsb,
   AdmsSensFadType & instanceVar_Grbdb,
   AdmsSensFadType & instanceVar_Grbpb,
   AdmsSensFadType & instanceVar_Grbps,
   AdmsSensFadType & instanceVar_Grbpd,
   AdmsSensFadType & instanceVar_Aechvb,
   AdmsSensFadType & instanceVar_Bechvb,
   AdmsSensFadType & instanceVar_AechvbEdge,
   AdmsSensFadType & instanceVar_BechvbEdge,
   AdmsSensFadType & instanceVar_ToxRatio,
   AdmsSensFadType & instanceVar_U0R_t,
   AdmsSensFadType & instanceVar_UAR_t,
   AdmsSensFadType & instanceVar_UCR_t,
   AdmsSensFadType & instanceVar_UDR_t,
   AdmsSensFadType & instanceVar_UCSR_t,
   AdmsSensFadType & instanceVar_VSATR_t,
   AdmsSensFadType & instanceVar_PTWGR_t,
   AdmsSensFadType & instanceVar_ETA0R_t,
   AdmsSensFadType & instanceVar_PSATB_i,
   AdmsSensFadType & instanceVar_KT1_i,
   AdmsSensFadType & instanceVar_KT2_i,
   AdmsSensFadType & instanceVar_NGATE_i,
   AdmsSensFadType & instanceVar_NSD_i,
   AdmsSensFadType & instanceVar_NDEP_i,
   AdmsSensFadType & instanceVar_VFB_i,
   AdmsSensFadType & instanceVar_CIT_i,
   AdmsSensFadType & instanceVar_CDSCD_i,
   AdmsSensFadType & instanceVar_CDSCDR_i,
   AdmsSensFadType & instanceVar_CDSCB_i,
   AdmsSensFadType & instanceVar_NFACTOR_i,
   AdmsSensFadType & instanceVar_PHIN_i,
   AdmsSensFadType & instanceVar_ETA0_i,
   AdmsSensFadType & instanceVar_ETA0R_i,
   AdmsSensFadType & instanceVar_ETAB_i,
   AdmsSensFadType & instanceVar_K2_i,
   AdmsSensFadType & instanceVar_K1_i,
   AdmsSensFadType & instanceVar_DELTA_i,
   AdmsSensFadType & instanceVar_U0_i,
   AdmsSensFadType & instanceVar_U0R_i,
   AdmsSensFadType & instanceVar_VSAT_i,
   AdmsSensFadType & instanceVar_VSATR_i,
   AdmsSensFadType & instanceVar_VSATCV_i,
   AdmsSensFadType & instanceVar_UA_i,
   AdmsSensFadType & instanceVar_UAR_i,
   AdmsSensFadType & instanceVar_EU_i,
   AdmsSensFadType & instanceVar_UD_i,
   AdmsSensFadType & instanceVar_UDR_i,
   AdmsSensFadType & instanceVar_UD_a,
   AdmsSensFadType & instanceVar_UCS_i,
   AdmsSensFadType & instanceVar_UCSR_i,
   AdmsSensFadType & instanceVar_UC_i,
   AdmsSensFadType & instanceVar_UCR_i,
   AdmsSensFadType & instanceVar_PDIBLC_i,
   AdmsSensFadType & instanceVar_PDIBLCR_i,
   AdmsSensFadType & instanceVar_PDIBLCB_i,
   AdmsSensFadType & instanceVar_PSCBE1_i,
   AdmsSensFadType & instanceVar_PSCBE2_i,
   AdmsSensFadType & instanceVar_PDITS_i,
   AdmsSensFadType & instanceVar_PDITSD_i,
   AdmsSensFadType & instanceVar_FPROUT_i,
   AdmsSensFadType & instanceVar_PRWG_i,
   AdmsSensFadType & instanceVar_WR_i,
   AdmsSensFadType & instanceVar_RDWMIN_i,
   AdmsSensFadType & instanceVar_RSWMIN_i,
   AdmsSensFadType & instanceVar_RDW_i,
   AdmsSensFadType & instanceVar_RSW_i,
   AdmsSensFadType & instanceVar_RDSW_i,
   AdmsSensFadType & instanceVar_RDSWMIN_i,
   AdmsSensFadType & instanceVar_PTWG_i,
   AdmsSensFadType & instanceVar_PTWGR_i,
   AdmsSensFadType & instanceVar_PVAG_i,
   AdmsSensFadType & instanceVar_XJ_i,
   AdmsSensFadType & instanceVar_PCLM_i,
   AdmsSensFadType & instanceVar_PCLMR_i,
   AdmsSensFadType & instanceVar_PCLMCV_i,
   AdmsSensFadType & instanceVar_PRWB_i,
   AdmsSensFadType & instanceVar_CF_i,
   AdmsSensFadType & instanceVar_CGSL_i,
   AdmsSensFadType & instanceVar_CGDL_i,
   AdmsSensFadType & instanceVar_CKAPPAS_i,
   AdmsSensFadType & instanceVar_CKAPPAD_i,
   AdmsSensFadType & instanceVar_VFBCV_i,
   AdmsSensFadType & instanceVar_NDEPCV_i,
   AdmsSensFadType & instanceVar_ALPHA0_i,
   AdmsSensFadType & instanceVar_BETA0_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_BGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_EGIDL_i,
   AdmsSensFadType & instanceVar_AGISL_i,
   AdmsSensFadType & instanceVar_BGISL_i,
   AdmsSensFadType & instanceVar_CGISL_i,
   AdmsSensFadType & instanceVar_EGISL_i,
   AdmsSensFadType & instanceVar_UTE_i,
   AdmsSensFadType & instanceVar_UA1_i,
   AdmsSensFadType & instanceVar_UC1_i,
   AdmsSensFadType & instanceVar_UD1_i,
   AdmsSensFadType & instanceVar_UCSTE_i,
   AdmsSensFadType & instanceVar_PRT_i,
   AdmsSensFadType & instanceVar_AT_i,
   AdmsSensFadType & instanceVar_PTWGT_i,
   AdmsSensFadType & instanceVar_IIT_i,
   AdmsSensFadType & instanceVar_TGIDL_i,
   AdmsSensFadType & instanceVar_KVTH0WE_i,
   AdmsSensFadType & instanceVar_K2WE_i,
   AdmsSensFadType & instanceVar_KU0WE_i,
   AdmsSensFadType & instanceVar_AIGBINV_i,
   AdmsSensFadType & instanceVar_BIGBINV_i,
   AdmsSensFadType & instanceVar_CIGBINV_i,
   AdmsSensFadType & instanceVar_EIGBINV_i,
   AdmsSensFadType & instanceVar_NIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBACC_i,
   AdmsSensFadType & instanceVar_BIGBACC_i,
   AdmsSensFadType & instanceVar_CIGBACC_i,
   AdmsSensFadType & instanceVar_NIGBACC_i,
   AdmsSensFadType & instanceVar_AIGC_i,
   AdmsSensFadType & instanceVar_BIGC_i,
   AdmsSensFadType & instanceVar_CIGC_i,
   AdmsSensFadType & instanceVar_AIGS_i,
   AdmsSensFadType & instanceVar_BIGS_i,
   AdmsSensFadType & instanceVar_CIGS_i,
   AdmsSensFadType & instanceVar_AIGD_i,
   AdmsSensFadType & instanceVar_BIGD_i,
   AdmsSensFadType & instanceVar_CIGD_i,
   AdmsSensFadType & instanceVar_PIGCD_i,
   AdmsSensFadType & instanceVar_DLCIG_i,
   AdmsSensFadType & instanceVar_DLCIGD_i,
   AdmsSensFadType & instanceVar_IGT_i,
   AdmsSensFadType & instanceVar_nuIntD,
   AdmsSensFadType & instanceVar_nuEndD,
   AdmsSensFadType & instanceVar_nuIntS,
   AdmsSensFadType & instanceVar_nuEndS,
   AdmsSensFadType & instanceVar_gth,
   AdmsSensFadType & instanceVar_cth,
   // non-reals
   int instanceVar_devsign,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_VFBSDOFF,
   bool modelPar_given_VFBSDOFF,
   AdmsSensFadType & modelPar_XGW,
   bool modelPar_given_XGW,
   AdmsSensFadType & modelPar_RBPB,
   bool modelPar_given_RBPB,
   AdmsSensFadType & modelPar_RBPD,
   bool modelPar_given_RBPD,
   AdmsSensFadType & modelPar_RBPS,
   bool modelPar_given_RBPS,
   AdmsSensFadType & modelPar_RBDB,
   bool modelPar_given_RBDB,
   AdmsSensFadType & modelPar_RBSB,
   bool modelPar_given_RBSB,
   AdmsSensFadType & modelPar_SA,
   bool modelPar_given_SA,
   AdmsSensFadType & modelPar_SB,
   bool modelPar_given_SB,
   AdmsSensFadType & modelPar_SD,
   bool modelPar_given_SD,
   AdmsSensFadType & modelPar_LLONG,
   bool modelPar_given_LLONG,
   AdmsSensFadType & modelPar_LMLT,
   bool modelPar_given_LMLT,
   AdmsSensFadType & modelPar_WMLT,
   bool modelPar_given_WMLT,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_WWIDE,
   bool modelPar_given_WWIDE,
   AdmsSensFadType & modelPar_XW,
   bool modelPar_given_XW,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LW,
   bool modelPar_given_LW,
   AdmsSensFadType & modelPar_LWL,
   bool modelPar_given_LWL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_LWN,
   bool modelPar_given_LWN,
   AdmsSensFadType & modelPar_WINT,
   bool modelPar_given_WINT,
   AdmsSensFadType & modelPar_WL,
   bool modelPar_given_WL,
   AdmsSensFadType & modelPar_WW,
   bool modelPar_given_WW,
   AdmsSensFadType & modelPar_WWL,
   bool modelPar_given_WWL,
   AdmsSensFadType & modelPar_WLN,
   bool modelPar_given_WLN,
   AdmsSensFadType & modelPar_WWN,
   bool modelPar_given_WWN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_LWC,
   bool modelPar_given_LWC,
   AdmsSensFadType & modelPar_LWLC,
   bool modelPar_given_LWLC,
   AdmsSensFadType & modelPar_DWC,
   bool modelPar_given_DWC,
   AdmsSensFadType & modelPar_WLC,
   bool modelPar_given_WLC,
   AdmsSensFadType & modelPar_WWC,
   bool modelPar_given_WWC,
   AdmsSensFadType & modelPar_WWLC,
   bool modelPar_given_WWLC,
   AdmsSensFadType & modelPar_TOXE,
   bool modelPar_given_TOXE,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_DTOX,
   bool modelPar_given_DTOX,
   AdmsSensFadType & modelPar_NDEP,
   bool modelPar_given_NDEP,
   AdmsSensFadType & modelPar_NDEPL1,
   bool modelPar_given_NDEPL1,
   AdmsSensFadType & modelPar_NDEPLEXP1,
   bool modelPar_given_NDEPLEXP1,
   AdmsSensFadType & modelPar_NDEPL2,
   bool modelPar_given_NDEPL2,
   AdmsSensFadType & modelPar_NDEPLEXP2,
   bool modelPar_given_NDEPLEXP2,
   AdmsSensFadType & modelPar_NDEPW,
   bool modelPar_given_NDEPW,
   AdmsSensFadType & modelPar_NDEPWEXP,
   bool modelPar_given_NDEPWEXP,
   AdmsSensFadType & modelPar_NDEPWL,
   bool modelPar_given_NDEPWL,
   AdmsSensFadType & modelPar_NDEPWLEXP,
   bool modelPar_given_NDEPWLEXP,
   AdmsSensFadType & modelPar_LNDEP,
   bool modelPar_given_LNDEP,
   AdmsSensFadType & modelPar_WNDEP,
   bool modelPar_given_WNDEP,
   AdmsSensFadType & modelPar_PNDEP,
   bool modelPar_given_PNDEP,
   AdmsSensFadType & modelPar_NDEPCV,
   bool modelPar_given_NDEPCV,
   AdmsSensFadType & modelPar_NDEPCVL1,
   bool modelPar_given_NDEPCVL1,
   AdmsSensFadType & modelPar_NDEPCVLEXP1,
   bool modelPar_given_NDEPCVLEXP1,
   AdmsSensFadType & modelPar_NDEPCVL2,
   bool modelPar_given_NDEPCVL2,
   AdmsSensFadType & modelPar_NDEPCVLEXP2,
   bool modelPar_given_NDEPCVLEXP2,
   AdmsSensFadType & modelPar_NDEPCVW,
   bool modelPar_given_NDEPCVW,
   AdmsSensFadType & modelPar_NDEPCVWEXP,
   bool modelPar_given_NDEPCVWEXP,
   AdmsSensFadType & modelPar_NDEPCVWL,
   bool modelPar_given_NDEPCVWL,
   AdmsSensFadType & modelPar_NDEPCVWLEXP,
   bool modelPar_given_NDEPCVWLEXP,
   AdmsSensFadType & modelPar_LNDEPCV,
   bool modelPar_given_LNDEPCV,
   AdmsSensFadType & modelPar_WNDEPCV,
   bool modelPar_given_WNDEPCV,
   AdmsSensFadType & modelPar_PNDEPCV,
   bool modelPar_given_PNDEPCV,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_WNGATE,
   bool modelPar_given_WNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_XJ,
   bool modelPar_given_XJ,
   AdmsSensFadType & modelPar_LXJ,
   bool modelPar_given_LXJ,
   AdmsSensFadType & modelPar_WXJ,
   bool modelPar_given_WXJ,
   AdmsSensFadType & modelPar_PXJ,
   bool modelPar_given_PXJ,
   AdmsSensFadType & modelPar_LVFB,
   bool modelPar_given_LVFB,
   AdmsSensFadType & modelPar_WVFB,
   bool modelPar_given_WVFB,
   AdmsSensFadType & modelPar_PVFB,
   bool modelPar_given_PVFB,
   AdmsSensFadType & modelPar_VFB,
   bool modelPar_given_VFB,
   AdmsSensFadType & modelPar_VFBCV,
   bool modelPar_given_VFBCV,
   AdmsSensFadType & modelPar_LVFBCV,
   bool modelPar_given_LVFBCV,
   AdmsSensFadType & modelPar_WVFBCV,
   bool modelPar_given_WVFBCV,
   AdmsSensFadType & modelPar_PVFBCV,
   bool modelPar_given_PVFBCV,
   AdmsSensFadType & modelPar_VFBCVL,
   bool modelPar_given_VFBCVL,
   AdmsSensFadType & modelPar_VFBCVLEXP,
   bool modelPar_given_VFBCVLEXP,
   AdmsSensFadType & modelPar_VFBCVW,
   bool modelPar_given_VFBCVW,
   AdmsSensFadType & modelPar_VFBCVWEXP,
   bool modelPar_given_VFBCVWEXP,
   AdmsSensFadType & modelPar_VFBCVWL,
   bool modelPar_given_VFBCVWL,
   AdmsSensFadType & modelPar_VFBCVWLEXP,
   bool modelPar_given_VFBCVWLEXP,
   AdmsSensFadType & modelPar_DWJ,
   bool modelPar_given_DWJ,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_LNSD,
   bool modelPar_given_LNSD,
   AdmsSensFadType & modelPar_WNSD,
   bool modelPar_given_WNSD,
   AdmsSensFadType & modelPar_PNSD,
   bool modelPar_given_PNSD,
   AdmsSensFadType & modelPar_DELVT0,
   bool modelPar_given_DELVT0,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_LDVTP0,
   bool modelPar_given_LDVTP0,
   AdmsSensFadType & modelPar_WDVTP0,
   bool modelPar_given_WDVTP0,
   AdmsSensFadType & modelPar_PDVTP0,
   bool modelPar_given_PDVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_LDVTP1,
   bool modelPar_given_LDVTP1,
   AdmsSensFadType & modelPar_WDVTP1,
   bool modelPar_given_WDVTP1,
   AdmsSensFadType & modelPar_PDVTP1,
   bool modelPar_given_PDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_LDVTP2,
   bool modelPar_given_LDVTP2,
   AdmsSensFadType & modelPar_WDVTP2,
   bool modelPar_given_WDVTP2,
   AdmsSensFadType & modelPar_PDVTP2,
   bool modelPar_given_PDVTP2,
   AdmsSensFadType & modelPar_DVTP3,
   bool modelPar_given_DVTP3,
   AdmsSensFadType & modelPar_LDVTP3,
   bool modelPar_given_LDVTP3,
   AdmsSensFadType & modelPar_WDVTP3,
   bool modelPar_given_WDVTP3,
   AdmsSensFadType & modelPar_PDVTP3,
   bool modelPar_given_PDVTP3,
   AdmsSensFadType & modelPar_DVTP4,
   bool modelPar_given_DVTP4,
   AdmsSensFadType & modelPar_LDVTP4,
   bool modelPar_given_LDVTP4,
   AdmsSensFadType & modelPar_WDVTP4,
   bool modelPar_given_WDVTP4,
   AdmsSensFadType & modelPar_PDVTP4,
   bool modelPar_given_PDVTP4,
   AdmsSensFadType & modelPar_DVTP5,
   bool modelPar_given_DVTP5,
   AdmsSensFadType & modelPar_LDVTP5,
   bool modelPar_given_LDVTP5,
   AdmsSensFadType & modelPar_WDVTP5,
   bool modelPar_given_WDVTP5,
   AdmsSensFadType & modelPar_PDVTP5,
   bool modelPar_given_PDVTP5,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_WPHIN,
   bool modelPar_given_WPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_WETA0,
   bool modelPar_given_WETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_WETA0R,
   bool modelPar_given_WETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_ETAB,
   bool modelPar_given_ETAB,
   AdmsSensFadType & modelPar_ETABEXP,
   bool modelPar_given_ETABEXP,
   AdmsSensFadType & modelPar_LETAB,
   bool modelPar_given_LETAB,
   AdmsSensFadType & modelPar_WETAB,
   bool modelPar_given_WETAB,
   AdmsSensFadType & modelPar_PETAB,
   bool modelPar_given_PETAB,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K1L,
   bool modelPar_given_K1L,
   AdmsSensFadType & modelPar_K1LEXP,
   bool modelPar_given_K1LEXP,
   AdmsSensFadType & modelPar_K1W,
   bool modelPar_given_K1W,
   AdmsSensFadType & modelPar_K1WEXP,
   bool modelPar_given_K1WEXP,
   AdmsSensFadType & modelPar_K1WL,
   bool modelPar_given_K1WL,
   AdmsSensFadType & modelPar_K1WLEXP,
   bool modelPar_given_K1WLEXP,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_WK1,
   bool modelPar_given_WK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K2L,
   bool modelPar_given_K2L,
   AdmsSensFadType & modelPar_K2LEXP,
   bool modelPar_given_K2LEXP,
   AdmsSensFadType & modelPar_K2W,
   bool modelPar_given_K2W,
   AdmsSensFadType & modelPar_K2WEXP,
   bool modelPar_given_K2WEXP,
   AdmsSensFadType & modelPar_K2WL,
   bool modelPar_given_K2WL,
   AdmsSensFadType & modelPar_K2WLEXP,
   bool modelPar_given_K2WLEXP,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_WK2,
   bool modelPar_given_WK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_ADOS,
   bool modelPar_given_ADOS,
   AdmsSensFadType & modelPar_BDOS,
   bool modelPar_given_BDOS,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_WCIT,
   bool modelPar_given_WCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_NFACTOR,
   bool modelPar_given_NFACTOR,
   AdmsSensFadType & modelPar_NFACTORL,
   bool modelPar_given_NFACTORL,
   AdmsSensFadType & modelPar_NFACTORLEXP,
   bool modelPar_given_NFACTORLEXP,
   AdmsSensFadType & modelPar_NFACTORW,
   bool modelPar_given_NFACTORW,
   AdmsSensFadType & modelPar_NFACTORWEXP,
   bool modelPar_given_NFACTORWEXP,
   AdmsSensFadType & modelPar_NFACTORWL,
   bool modelPar_given_NFACTORWL,
   AdmsSensFadType & modelPar_NFACTORWLEXP,
   bool modelPar_given_NFACTORWLEXP,
   AdmsSensFadType & modelPar_LNFACTOR,
   bool modelPar_given_LNFACTOR,
   AdmsSensFadType & modelPar_WNFACTOR,
   bool modelPar_given_WNFACTOR,
   AdmsSensFadType & modelPar_PNFACTOR,
   bool modelPar_given_PNFACTOR,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDL,
   bool modelPar_given_CDSCDL,
   AdmsSensFadType & modelPar_CDSCDLEXP,
   bool modelPar_given_CDSCDLEXP,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_WCDSCD,
   bool modelPar_given_WCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDLR,
   bool modelPar_given_CDSCDLR,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_WCDSCDR,
   bool modelPar_given_WCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_CDSCB,
   bool modelPar_given_CDSCB,
   AdmsSensFadType & modelPar_CDSCBL,
   bool modelPar_given_CDSCBL,
   AdmsSensFadType & modelPar_CDSCBLEXP,
   bool modelPar_given_CDSCBLEXP,
   AdmsSensFadType & modelPar_LCDSCB,
   bool modelPar_given_LCDSCB,
   AdmsSensFadType & modelPar_WCDSCB,
   bool modelPar_given_WCDSCB,
   AdmsSensFadType & modelPar_PCDSCB,
   bool modelPar_given_PCDSCB,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_WVSAT,
   bool modelPar_given_WVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_VSATL,
   bool modelPar_given_VSATL,
   AdmsSensFadType & modelPar_VSATLEXP,
   bool modelPar_given_VSATLEXP,
   AdmsSensFadType & modelPar_VSATW,
   bool modelPar_given_VSATW,
   AdmsSensFadType & modelPar_VSATWEXP,
   bool modelPar_given_VSATWEXP,
   AdmsSensFadType & modelPar_VSATWL,
   bool modelPar_given_VSATWL,
   AdmsSensFadType & modelPar_VSATWLEXP,
   bool modelPar_given_VSATWLEXP,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_WVSATR,
   bool modelPar_given_WVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_DELTA,
   bool modelPar_given_DELTA,
   AdmsSensFadType & modelPar_LDELTA,
   bool modelPar_given_LDELTA,
   AdmsSensFadType & modelPar_WDELTA,
   bool modelPar_given_WDELTA,
   AdmsSensFadType & modelPar_PDELTA,
   bool modelPar_given_PDELTA,
   AdmsSensFadType & modelPar_DELTAL,
   bool modelPar_given_DELTAL,
   AdmsSensFadType & modelPar_DELTALEXP,
   bool modelPar_given_DELTALEXP,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_WVSATCV,
   bool modelPar_given_WVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_VSATCVL,
   bool modelPar_given_VSATCVL,
   AdmsSensFadType & modelPar_VSATCVLEXP,
   bool modelPar_given_VSATCVLEXP,
   AdmsSensFadType & modelPar_VSATCVW,
   bool modelPar_given_VSATCVW,
   AdmsSensFadType & modelPar_VSATCVWEXP,
   bool modelPar_given_VSATCVWEXP,
   AdmsSensFadType & modelPar_VSATCVWL,
   bool modelPar_given_VSATCVWL,
   AdmsSensFadType & modelPar_VSATCVWLEXP,
   bool modelPar_given_VSATCVWLEXP,
   AdmsSensFadType & modelPar_UP1,
   bool modelPar_given_UP1,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_UP2,
   bool modelPar_given_UP2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_MULU0,
   bool modelPar_given_MULU0,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0L,
   bool modelPar_given_U0L,
   AdmsSensFadType & modelPar_U0LEXP,
   bool modelPar_given_U0LEXP,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_WU0,
   bool modelPar_given_WU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_WU0R,
   bool modelPar_given_WU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAL,
   bool modelPar_given_UAL,
   AdmsSensFadType & modelPar_UALEXP,
   bool modelPar_given_UALEXP,
   AdmsSensFadType & modelPar_UAW,
   bool modelPar_given_UAW,
   AdmsSensFadType & modelPar_UAWEXP,
   bool modelPar_given_UAWEXP,
   AdmsSensFadType & modelPar_UAWL,
   bool modelPar_given_UAWL,
   AdmsSensFadType & modelPar_UAWLEXP,
   bool modelPar_given_UAWLEXP,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_WUA,
   bool modelPar_given_WUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_WUAR,
   bool modelPar_given_WUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_WEU,
   bool modelPar_given_WEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_EUL,
   bool modelPar_given_EUL,
   AdmsSensFadType & modelPar_EULEXP,
   bool modelPar_given_EULEXP,
   AdmsSensFadType & modelPar_EUW,
   bool modelPar_given_EUW,
   AdmsSensFadType & modelPar_EUWEXP,
   bool modelPar_given_EUWEXP,
   AdmsSensFadType & modelPar_EUWL,
   bool modelPar_given_EUWL,
   AdmsSensFadType & modelPar_EUWLEXP,
   bool modelPar_given_EUWLEXP,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDL,
   bool modelPar_given_UDL,
   AdmsSensFadType & modelPar_UDLEXP,
   bool modelPar_given_UDLEXP,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_WUD,
   bool modelPar_given_WUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_WUDR,
   bool modelPar_given_WUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_WUCS,
   bool modelPar_given_WUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_UCSR,
   bool modelPar_given_UCSR,
   AdmsSensFadType & modelPar_LUCSR,
   bool modelPar_given_LUCSR,
   AdmsSensFadType & modelPar_WUCSR,
   bool modelPar_given_WUCSR,
   AdmsSensFadType & modelPar_PUCSR,
   bool modelPar_given_PUCSR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCL,
   bool modelPar_given_UCL,
   AdmsSensFadType & modelPar_UCLEXP,
   bool modelPar_given_UCLEXP,
   AdmsSensFadType & modelPar_UCW,
   bool modelPar_given_UCW,
   AdmsSensFadType & modelPar_UCWEXP,
   bool modelPar_given_UCWEXP,
   AdmsSensFadType & modelPar_UCWL,
   bool modelPar_given_UCWL,
   AdmsSensFadType & modelPar_UCWLEXP,
   bool modelPar_given_UCWLEXP,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_WUC,
   bool modelPar_given_WUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_WUCR,
   bool modelPar_given_WUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLML,
   bool modelPar_given_PCLML,
   AdmsSensFadType & modelPar_PCLMLEXP,
   bool modelPar_given_PCLMLEXP,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_WPCLM,
   bool modelPar_given_WPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_WPCLMR,
   bool modelPar_given_WPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_PCLMCVL,
   bool modelPar_given_PCLMCVL,
   AdmsSensFadType & modelPar_PCLMCVLEXP,
   bool modelPar_given_PCLMCVLEXP,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_WPCLMCV,
   bool modelPar_given_WPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_PSCBE1,
   bool modelPar_given_PSCBE1,
   AdmsSensFadType & modelPar_LPSCBE1,
   bool modelPar_given_LPSCBE1,
   AdmsSensFadType & modelPar_WPSCBE1,
   bool modelPar_given_WPSCBE1,
   AdmsSensFadType & modelPar_PPSCBE1,
   bool modelPar_given_PPSCBE1,
   AdmsSensFadType & modelPar_PSCBE2,
   bool modelPar_given_PSCBE2,
   AdmsSensFadType & modelPar_LPSCBE2,
   bool modelPar_given_LPSCBE2,
   AdmsSensFadType & modelPar_WPSCBE2,
   bool modelPar_given_WPSCBE2,
   AdmsSensFadType & modelPar_PPSCBE2,
   bool modelPar_given_PPSCBE2,
   AdmsSensFadType & modelPar_PDITS,
   bool modelPar_given_PDITS,
   AdmsSensFadType & modelPar_LPDITS,
   bool modelPar_given_LPDITS,
   AdmsSensFadType & modelPar_WPDITS,
   bool modelPar_given_WPDITS,
   AdmsSensFadType & modelPar_PPDITS,
   bool modelPar_given_PPDITS,
   AdmsSensFadType & modelPar_PDITSL,
   bool modelPar_given_PDITSL,
   AdmsSensFadType & modelPar_PDITSD,
   bool modelPar_given_PDITSD,
   AdmsSensFadType & modelPar_LPDITSD,
   bool modelPar_given_LPDITSD,
   AdmsSensFadType & modelPar_WPDITSD,
   bool modelPar_given_WPDITSD,
   AdmsSensFadType & modelPar_PPDITSD,
   bool modelPar_given_PPDITSD,
   AdmsSensFadType & modelPar_RSH,
   bool modelPar_given_RSH,
   AdmsSensFadType & modelPar_PRWG,
   bool modelPar_given_PRWG,
   AdmsSensFadType & modelPar_LPRWG,
   bool modelPar_given_LPRWG,
   AdmsSensFadType & modelPar_WPRWG,
   bool modelPar_given_WPRWG,
   AdmsSensFadType & modelPar_PPRWG,
   bool modelPar_given_PPRWG,
   AdmsSensFadType & modelPar_PRWB,
   bool modelPar_given_PRWB,
   AdmsSensFadType & modelPar_LPRWB,
   bool modelPar_given_LPRWB,
   AdmsSensFadType & modelPar_WPRWB,
   bool modelPar_given_WPRWB,
   AdmsSensFadType & modelPar_PPRWB,
   bool modelPar_given_PPRWB,
   AdmsSensFadType & modelPar_PRWBL,
   bool modelPar_given_PRWBL,
   AdmsSensFadType & modelPar_PRWBLEXP,
   bool modelPar_given_PRWBLEXP,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_WWR,
   bool modelPar_given_WWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_LRSWMIN,
   bool modelPar_given_LRSWMIN,
   AdmsSensFadType & modelPar_WRSWMIN,
   bool modelPar_given_WRSWMIN,
   AdmsSensFadType & modelPar_PRSWMIN,
   bool modelPar_given_PRSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_WRSW,
   bool modelPar_given_WRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_RSWL,
   bool modelPar_given_RSWL,
   AdmsSensFadType & modelPar_RSWLEXP,
   bool modelPar_given_RSWLEXP,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_LRDWMIN,
   bool modelPar_given_LRDWMIN,
   AdmsSensFadType & modelPar_WRDWMIN,
   bool modelPar_given_WRDWMIN,
   AdmsSensFadType & modelPar_PRDWMIN,
   bool modelPar_given_PRDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_WRDW,
   bool modelPar_given_WRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_RDWL,
   bool modelPar_given_RDWL,
   AdmsSensFadType & modelPar_RDWLEXP,
   bool modelPar_given_RDWLEXP,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_LRDSWMIN,
   bool modelPar_given_LRDSWMIN,
   AdmsSensFadType & modelPar_WRDSWMIN,
   bool modelPar_given_WRDSWMIN,
   AdmsSensFadType & modelPar_PRDSWMIN,
   bool modelPar_given_PRDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_RDSWL,
   bool modelPar_given_RDSWL,
   AdmsSensFadType & modelPar_RDSWLEXP,
   bool modelPar_given_RDSWLEXP,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_WRDSW,
   bool modelPar_given_WRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_WPSAT,
   bool modelPar_given_WPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_PSATL,
   bool modelPar_given_PSATL,
   AdmsSensFadType & modelPar_PSATLEXP,
   bool modelPar_given_PSATLEXP,
   AdmsSensFadType & modelPar_PSATB,
   bool modelPar_given_PSATB,
   AdmsSensFadType & modelPar_PSATR,
   bool modelPar_given_PSATR,
   AdmsSensFadType & modelPar_LPSATR,
   bool modelPar_given_LPSATR,
   AdmsSensFadType & modelPar_WPSATR,
   bool modelPar_given_WPSATR,
   AdmsSensFadType & modelPar_PPSATR,
   bool modelPar_given_PPSATR,
   AdmsSensFadType & modelPar_LPSATB,
   bool modelPar_given_LPSATB,
   AdmsSensFadType & modelPar_WPSATB,
   bool modelPar_given_WPSATB,
   AdmsSensFadType & modelPar_PPSATB,
   bool modelPar_given_PPSATB,
   AdmsSensFadType & modelPar_PSATX,
   bool modelPar_given_PSATX,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_WPTWG,
   bool modelPar_given_WPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_PTWGL,
   bool modelPar_given_PTWGL,
   AdmsSensFadType & modelPar_PTWGLEXP,
   bool modelPar_given_PTWGLEXP,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_WPTWGR,
   bool modelPar_given_WPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_PTWGLR,
   bool modelPar_given_PTWGLR,
   AdmsSensFadType & modelPar_PTWGLEXPR,
   bool modelPar_given_PTWGLEXPR,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_WA1,
   bool modelPar_given_WA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_WA11,
   bool modelPar_given_WA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_WA2,
   bool modelPar_given_WA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_WA21,
   bool modelPar_given_WA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_PDIBLC,
   bool modelPar_given_PDIBLC,
   AdmsSensFadType & modelPar_PDIBLCL,
   bool modelPar_given_PDIBLCL,
   AdmsSensFadType & modelPar_PDIBLCLEXP,
   bool modelPar_given_PDIBLCLEXP,
   AdmsSensFadType & modelPar_LPDIBLC,
   bool modelPar_given_LPDIBLC,
   AdmsSensFadType & modelPar_WPDIBLC,
   bool modelPar_given_WPDIBLC,
   AdmsSensFadType & modelPar_PPDIBLC,
   bool modelPar_given_PPDIBLC,
   AdmsSensFadType & modelPar_PDIBLCR,
   bool modelPar_given_PDIBLCR,
   AdmsSensFadType & modelPar_PDIBLCLR,
   bool modelPar_given_PDIBLCLR,
   AdmsSensFadType & modelPar_PDIBLCLEXPR,
   bool modelPar_given_PDIBLCLEXPR,
   AdmsSensFadType & modelPar_LPDIBLCR,
   bool modelPar_given_LPDIBLCR,
   AdmsSensFadType & modelPar_WPDIBLCR,
   bool modelPar_given_WPDIBLCR,
   AdmsSensFadType & modelPar_PPDIBLCR,
   bool modelPar_given_PPDIBLCR,
   AdmsSensFadType & modelPar_PDIBLCB,
   bool modelPar_given_PDIBLCB,
   AdmsSensFadType & modelPar_LPDIBLCB,
   bool modelPar_given_LPDIBLCB,
   AdmsSensFadType & modelPar_WPDIBLCB,
   bool modelPar_given_WPDIBLCB,
   AdmsSensFadType & modelPar_PPDIBLCB,
   bool modelPar_given_PPDIBLCB,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_WPVAG,
   bool modelPar_given_WPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_FPROUT,
   bool modelPar_given_FPROUT,
   AdmsSensFadType & modelPar_FPROUTL,
   bool modelPar_given_FPROUTL,
   AdmsSensFadType & modelPar_FPROUTLEXP,
   bool modelPar_given_FPROUTLEXP,
   AdmsSensFadType & modelPar_LFPROUT,
   bool modelPar_given_LFPROUT,
   AdmsSensFadType & modelPar_WFPROUT,
   bool modelPar_given_WFPROUT,
   AdmsSensFadType & modelPar_PFPROUT,
   bool modelPar_given_PFPROUT,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA0L,
   bool modelPar_given_ALPHA0L,
   AdmsSensFadType & modelPar_ALPHA0LEXP,
   bool modelPar_given_ALPHA0LEXP,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_WALPHA0,
   bool modelPar_given_WALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_WBETA0,
   bool modelPar_given_WBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_DLCIG,
   bool modelPar_given_DLCIG,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_AIGCL,
   bool modelPar_given_AIGCL,
   AdmsSensFadType & modelPar_AIGCW,
   bool modelPar_given_AIGCW,
   AdmsSensFadType & modelPar_AIGSL,
   bool modelPar_given_AIGSL,
   AdmsSensFadType & modelPar_AIGSW,
   bool modelPar_given_AIGSW,
   AdmsSensFadType & modelPar_AIGDL,
   bool modelPar_given_AIGDL,
   AdmsSensFadType & modelPar_AIGDW,
   bool modelPar_given_AIGDW,
   AdmsSensFadType & modelPar_PIGCDL,
   bool modelPar_given_PIGCDL,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_WAIGBINV,
   bool modelPar_given_WAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_WBIGBINV,
   bool modelPar_given_WBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_WCIGBINV,
   bool modelPar_given_WCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_WEIGBINV,
   bool modelPar_given_WEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_WNIGBINV,
   bool modelPar_given_WNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_WAIGBACC,
   bool modelPar_given_WAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_WBIGBACC,
   bool modelPar_given_WBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_WCIGBACC,
   bool modelPar_given_WCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_WNIGBACC,
   bool modelPar_given_WNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_WAIGC,
   bool modelPar_given_WAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_WBIGC,
   bool modelPar_given_WBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_WCIGC,
   bool modelPar_given_WCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_WAIGS,
   bool modelPar_given_WAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_WBIGS,
   bool modelPar_given_WBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_WCIGS,
   bool modelPar_given_WCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_WAIGD,
   bool modelPar_given_WAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_WBIGD,
   bool modelPar_given_WBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_WCIGD,
   bool modelPar_given_WCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_WPOXEDGE,
   bool modelPar_given_WPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LDLCIG,
   bool modelPar_given_LDLCIG,
   AdmsSensFadType & modelPar_WDLCIG,
   bool modelPar_given_WDLCIG,
   AdmsSensFadType & modelPar_PDLCIG,
   bool modelPar_given_PDLCIG,
   AdmsSensFadType & modelPar_LDLCIGD,
   bool modelPar_given_LDLCIGD,
   AdmsSensFadType & modelPar_WDLCIGD,
   bool modelPar_given_WDLCIGD,
   AdmsSensFadType & modelPar_PDLCIGD,
   bool modelPar_given_PDLCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_WNTOX,
   bool modelPar_given_WNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_AGIDLL,
   bool modelPar_given_AGIDLL,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_WAGIDL,
   bool modelPar_given_WAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_WBGIDL,
   bool modelPar_given_WBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_WCGIDL,
   bool modelPar_given_WCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_WEGIDL,
   bool modelPar_given_WEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_AGISLL,
   bool modelPar_given_AGISLL,
   AdmsSensFadType & modelPar_AGISLW,
   bool modelPar_given_AGISLW,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_WAGISL,
   bool modelPar_given_WAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_WBGISL,
   bool modelPar_given_WBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_WCGISL,
   bool modelPar_given_WCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_WEGISL,
   bool modelPar_given_WEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_CF,
   bool modelPar_given_CF,
   AdmsSensFadType & modelPar_LCF,
   bool modelPar_given_LCF,
   AdmsSensFadType & modelPar_WCF,
   bool modelPar_given_WCF,
   AdmsSensFadType & modelPar_PCF,
   bool modelPar_given_PCF,
   AdmsSensFadType & modelPar_CFRCOEFF,
   bool modelPar_given_CFRCOEFF,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_WCGSL,
   bool modelPar_given_WCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_WCGDL,
   bool modelPar_given_WCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_WCKAPPAS,
   bool modelPar_given_WCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_WCKAPPAD,
   bool modelPar_given_WCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_DMCG,
   bool modelPar_given_DMCG,
   AdmsSensFadType & modelPar_DMCI,
   bool modelPar_given_DMCI,
   AdmsSensFadType & modelPar_DMDG,
   bool modelPar_given_DMDG,
   AdmsSensFadType & modelPar_DMCGT,
   bool modelPar_given_DMCGT,
   AdmsSensFadType & modelPar_XGL,
   bool modelPar_given_XGL,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_GBMIN,
   bool modelPar_given_GBMIN,
   AdmsSensFadType & modelPar_RBPS0,
   bool modelPar_given_RBPS0,
   AdmsSensFadType & modelPar_RBPSL,
   bool modelPar_given_RBPSL,
   AdmsSensFadType & modelPar_RBPSW,
   bool modelPar_given_RBPSW,
   AdmsSensFadType & modelPar_RBPSNF,
   bool modelPar_given_RBPSNF,
   AdmsSensFadType & modelPar_RBPD0,
   bool modelPar_given_RBPD0,
   AdmsSensFadType & modelPar_RBPDL,
   bool modelPar_given_RBPDL,
   AdmsSensFadType & modelPar_RBPDW,
   bool modelPar_given_RBPDW,
   AdmsSensFadType & modelPar_RBPDNF,
   bool modelPar_given_RBPDNF,
   AdmsSensFadType & modelPar_RBPBX0,
   bool modelPar_given_RBPBX0,
   AdmsSensFadType & modelPar_RBPBXL,
   bool modelPar_given_RBPBXL,
   AdmsSensFadType & modelPar_RBPBXW,
   bool modelPar_given_RBPBXW,
   AdmsSensFadType & modelPar_RBPBXNF,
   bool modelPar_given_RBPBXNF,
   AdmsSensFadType & modelPar_RBPBY0,
   bool modelPar_given_RBPBY0,
   AdmsSensFadType & modelPar_RBPBYL,
   bool modelPar_given_RBPBYL,
   AdmsSensFadType & modelPar_RBPBYW,
   bool modelPar_given_RBPBYW,
   AdmsSensFadType & modelPar_RBPBYNF,
   bool modelPar_given_RBPBYNF,
   AdmsSensFadType & modelPar_RBSBX0,
   bool modelPar_given_RBSBX0,
   AdmsSensFadType & modelPar_RBSBY0,
   bool modelPar_given_RBSBY0,
   AdmsSensFadType & modelPar_RBDBX0,
   bool modelPar_given_RBDBX0,
   AdmsSensFadType & modelPar_RBDBY0,
   bool modelPar_given_RBDBY0,
   AdmsSensFadType & modelPar_RBSDBXL,
   bool modelPar_given_RBSDBXL,
   AdmsSensFadType & modelPar_RBSDBXW,
   bool modelPar_given_RBSDBXW,
   AdmsSensFadType & modelPar_RBSDBXNF,
   bool modelPar_given_RBSDBXNF,
   AdmsSensFadType & modelPar_RBSDBYL,
   bool modelPar_given_RBSDBYL,
   AdmsSensFadType & modelPar_RBSDBYW,
   bool modelPar_given_RBSDBYW,
   AdmsSensFadType & modelPar_RBSDBYNF,
   bool modelPar_given_RBSDBYNF,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_DWBIN,
   bool modelPar_given_DWBIN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_TNFACTOR,
   bool modelPar_given_TNFACTOR,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_WUTE,
   bool modelPar_given_WUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_UTEL,
   bool modelPar_given_UTEL,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_WUA1,
   bool modelPar_given_WUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_UA1L,
   bool modelPar_given_UA1L,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_WUC1,
   bool modelPar_given_WUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_WUD1,
   bool modelPar_given_WUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_UD1L,
   bool modelPar_given_UD1L,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_WUCSTE,
   bool modelPar_given_WUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_WPRT,
   bool modelPar_given_WPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_WAT,
   bool modelPar_given_WAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_ATL,
   bool modelPar_given_ATL,
   AdmsSensFadType & modelPar_TDELTA,
   bool modelPar_given_TDELTA,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_WPTWGT,
   bool modelPar_given_WPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_PTWGTL,
   bool modelPar_given_PTWGTL,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1EXP,
   bool modelPar_given_KT1EXP,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_WKT1,
   bool modelPar_given_WKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_KT2,
   bool modelPar_given_KT2,
   AdmsSensFadType & modelPar_LKT2,
   bool modelPar_given_LKT2,
   AdmsSensFadType & modelPar_WKT2,
   bool modelPar_given_WKT2,
   AdmsSensFadType & modelPar_PKT2,
   bool modelPar_given_PKT2,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_WIIT,
   bool modelPar_given_WIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_WIGT,
   bool modelPar_given_WIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_WTGIDL,
   bool modelPar_given_WTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KU0,
   bool modelPar_given_KU0,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKU0,
   bool modelPar_given_TKU0,
   AdmsSensFadType & modelPar_LKU0,
   bool modelPar_given_LKU0,
   AdmsSensFadType & modelPar_WKU0,
   bool modelPar_given_WKU0,
   AdmsSensFadType & modelPar_PKU0,
   bool modelPar_given_PKU0,
   AdmsSensFadType & modelPar_LLODKU0,
   bool modelPar_given_LLODKU0,
   AdmsSensFadType & modelPar_WLODKU0,
   bool modelPar_given_WLODKU0,
   AdmsSensFadType & modelPar_KVTH0,
   bool modelPar_given_KVTH0,
   AdmsSensFadType & modelPar_LKVTH0,
   bool modelPar_given_LKVTH0,
   AdmsSensFadType & modelPar_WKVTH0,
   bool modelPar_given_WKVTH0,
   AdmsSensFadType & modelPar_PKVTH0,
   bool modelPar_given_PKVTH0,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STK2,
   bool modelPar_given_STK2,
   AdmsSensFadType & modelPar_LODK2,
   bool modelPar_given_LODK2,
   AdmsSensFadType & modelPar_STETA0,
   bool modelPar_given_STETA0,
   AdmsSensFadType & modelPar_LODETA0,
   bool modelPar_given_LODETA0,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_KVTH0WE,
   bool modelPar_given_KVTH0WE,
   AdmsSensFadType & modelPar_LKVTH0WE,
   bool modelPar_given_LKVTH0WE,
   AdmsSensFadType & modelPar_WKVTH0WE,
   bool modelPar_given_WKVTH0WE,
   AdmsSensFadType & modelPar_PKVTH0WE,
   bool modelPar_given_PKVTH0WE,
   AdmsSensFadType & modelPar_K2WE,
   bool modelPar_given_K2WE,
   AdmsSensFadType & modelPar_LK2WE,
   bool modelPar_given_LK2WE,
   AdmsSensFadType & modelPar_WK2WE,
   bool modelPar_given_WK2WE,
   AdmsSensFadType & modelPar_PK2WE,
   bool modelPar_given_PK2WE,
   AdmsSensFadType & modelPar_KU0WE,
   bool modelPar_given_KU0WE,
   AdmsSensFadType & modelPar_LKU0WE,
   bool modelPar_given_LKU0WE,
   AdmsSensFadType & modelPar_WKU0WE,
   bool modelPar_given_WKU0WE,
   AdmsSensFadType & modelPar_PKU0WE,
   bool modelPar_given_PKU0WE,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEDGE,
   bool modelPar_given_WEDGE,
   AdmsSensFadType & modelPar_DGAMMAEDGE,
   bool modelPar_given_DGAMMAEDGE,
   AdmsSensFadType & modelPar_DGAMMAEDGEL,
   bool modelPar_given_DGAMMAEDGEL,
   AdmsSensFadType & modelPar_DGAMMAEDGELEXP,
   bool modelPar_given_DGAMMAEDGELEXP,
   AdmsSensFadType & modelPar_DVTEDGE,
   bool modelPar_given_DVTEDGE,
   AdmsSensFadType & modelPar_NFACTOREDGE,
   bool modelPar_given_NFACTOREDGE,
   AdmsSensFadType & modelPar_CITEDGE,
   bool modelPar_given_CITEDGE,
   AdmsSensFadType & modelPar_CDSCDEDGE,
   bool modelPar_given_CDSCDEDGE,
   AdmsSensFadType & modelPar_CDSCBEDGE,
   bool modelPar_given_CDSCBEDGE,
   AdmsSensFadType & modelPar_ETA0EDGE,
   bool modelPar_given_ETA0EDGE,
   AdmsSensFadType & modelPar_ETABEDGE,
   bool modelPar_given_ETABEDGE,
   AdmsSensFadType & modelPar_KT1EDGE,
   bool modelPar_given_KT1EDGE,
   AdmsSensFadType & modelPar_KT1LEDGE,
   bool modelPar_given_KT1LEDGE,
   AdmsSensFadType & modelPar_KT2EDGE,
   bool modelPar_given_KT2EDGE,
   AdmsSensFadType & modelPar_KT1EXPEDGE,
   bool modelPar_given_KT1EXPEDGE,
   AdmsSensFadType & modelPar_TNFACTOREDGE,
   bool modelPar_given_TNFACTOREDGE,
   AdmsSensFadType & modelPar_TETA0EDGE,
   bool modelPar_given_TETA0EDGE,
   AdmsSensFadType & modelPar_DVT0EDGE,
   bool modelPar_given_DVT0EDGE,
   AdmsSensFadType & modelPar_DVT1EDGE,
   bool modelPar_given_DVT1EDGE,
   AdmsSensFadType & modelPar_DVT2EDGE,
   bool modelPar_given_DVT2EDGE,
   // non-reals (including hidden)
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RBODYMOD,
   bool modelPar_given_RBODYMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_SCA,
   bool modelPar_given_SCA,
   int modelPar_SCB,
   bool modelPar_given_SCB,
   int modelPar_SCC,
   bool modelPar_given_SCC,
   int modelPar_SC,
   bool modelPar_given_SC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_CVMOD,
   bool modelPar_given_CVMOD,
   int modelPar_COVMOD,
   bool modelPar_given_COVMOD,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_WPEMOD,
   bool modelPar_given_WPEMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_MOBSCALE,
   bool modelPar_given_MOBSCALE,
   int modelPar_PERMOD,
   bool modelPar_given_PERMOD,
   int modelPar_BINUNIT,
   bool modelPar_given_BINUNIT,
   int modelPar_EDGEFET,
   bool modelPar_given_EDGEFET,
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType ToxRatioEdge;
  AdmsSensFadType Rbpby;
  AdmsSensFadType Rbpbx;
  AdmsSensFadType Rbdby;
  AdmsSensFadType Rbdbx;
  AdmsSensFadType Rbsby;
  AdmsSensFadType Rbsbx;
  AdmsSensFadType Rbsb;
  AdmsSensFadType Rbdb;
  AdmsSensFadType Rbps;
  AdmsSensFadType Rbpd;
  AdmsSensFadType Rbpb;
  double Bodymode;
  AdmsSensFadType Lnnf;
  AdmsSensFadType Lnw;
  AdmsSensFadType Lnl;
  AdmsSensFadType Rtot;
  AdmsSensFadType Rint;
  AdmsSensFadType Rend;
  AdmsSensFadType NTOX_i;
  AdmsSensFadType POXEDGE_i;
  AdmsSensFadType BIN_WL;
  AdmsSensFadType BIN_W;
  AdmsSensFadType BIN_L;
  AdmsSensFadType Weff1;
  AdmsSensFadType Leff1;
  AdmsSensFadType dWB;
  AdmsSensFadType LW_WLN_WWN1;
  AdmsSensFadType dLB;
  AdmsSensFadType LW_LLN_LWN1;
  AdmsSensFadType Inv_WL;
  AdmsSensFadType Inv_Wwide;
  AdmsSensFadType Inv_Llong;
  AdmsSensFadType Inv_Wact;
  AdmsSensFadType Inv_Lact;
  AdmsSensFadType Inv_W;
  AdmsSensFadType Inv_L;
  AdmsSensFadType dWJ;
  AdmsSensFadType dWCV;
  AdmsSensFadType dLCV;
  AdmsSensFadType dWIV;
  AdmsSensFadType LW_WLN_WWN;
  AdmsSensFadType W_WWN;
  AdmsSensFadType L_WLN;
  AdmsSensFadType dLIV;
  AdmsSensFadType LW_LLN_LWN;
  AdmsSensFadType W_LWN;
  AdmsSensFadType L_LLN;
  AdmsSensFadType W_by_NF;
  AdmsSensFadType W_mult;
  AdmsSensFadType W_WWN1;
  AdmsSensFadType W_LWN1;
  AdmsSensFadType L_WLN1;
  AdmsSensFadType L_LLN1;
  //Begin block initial_instance
  {
    instanceVar_CDSCDR_i = 0;
    instanceVar_ETA0R_i = 0;
    instanceVar_ETA0R_t = 0;
    L_LLN1 = 0;
    L_WLN1 = 0;
    instanceVar_PCLMR_i = 0;
    instanceVar_PDIBLCR_i = 0;
    instanceVar_PSATR_i = 0;
    instanceVar_PTWGR_i = 0;
    instanceVar_PTWGR_t = 0;
    instanceVar_U0R_i = 0;
    instanceVar_U0R_t = 0;
    instanceVar_UAR_i = 0;
    instanceVar_UAR_t = 0;
    instanceVar_UCR_i = 0;
    instanceVar_UCR_t = 0;
    instanceVar_UCSR_i = 0;
    instanceVar_UCSR_t = 0;
    instanceVar_UDR_i = 0;
    instanceVar_UDR_t = 0;
    instanceVar_UD_a = 0;
    instanceVar_VSATR_i = 0;
    instanceVar_VSATR_t = 0;
    W_LWN1 = 0;
    W_WWN1 = 0;
    if ((modelPar_TYPE==1))
    {
      instanceVar_devsign = 1;
    }
    else
    {
      instanceVar_devsign = (-1);
    }
    instanceVar_epssi = (modelPar_EPSRSUB*8.85418e-12);
    instanceVar_epsox = (modelPar_EPSROX*8.85418e-12);
    instanceVar_Cox = ((modelPar_EPSROX*8.85418e-12)/modelPar_TOXE);
    instanceVar_epsratio = (modelPar_EPSRSUB/modelPar_EPSROX);
    if ((!modelPar_given_TOXP))
    {
      instanceVar_BSIM6TOXP = (((modelPar_TOXE*modelPar_EPSROX)/3.9)-modelPar_DTOX);
    }
    else
    {
      instanceVar_BSIM6TOXP = modelPar_TOXP;
    }
    instanceVar_L_mult = (instancePar_L*modelPar_LMLT);
    W_mult = (instancePar_W*modelPar_WMLT);
    instanceVar_Lnew = (instanceVar_L_mult+modelPar_XL);
    if ((instanceVar_Lnew<=0))
    {
      std::cerr  << "Fatal: Ldrawn*LMLT+XL = %e for  %M is non-positive" << instanceVar_Lnew <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    W_by_NF = (W_mult/instancePar_NF);
    instanceVar_Wnew = (W_by_NF+modelPar_XW);
    if ((instanceVar_Wnew<=0))
    {
      std::cerr  << "Fatal: W/NF*WMLT+XW = %e for  %M is non-positive" << instanceVar_Wnew <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    L_LLN = pow(instanceVar_Lnew,(-modelPar_LLN));
    W_LWN = pow(instanceVar_Wnew,(-modelPar_LWN));
    LW_LLN_LWN = (L_LLN*W_LWN);
    dLIV = (((modelPar_LINT+(modelPar_LL*L_LLN))+(modelPar_LW*W_LWN))+(modelPar_LWL*LW_LLN_LWN));
    L_WLN = pow(instanceVar_Lnew,(-modelPar_WLN));
    W_WWN = pow(instanceVar_Wnew,(-modelPar_WWN));
    LW_WLN_WWN = (L_WLN*W_WWN);
    dWIV = (((modelPar_WINT+(modelPar_WL*L_WLN))+(modelPar_WW*W_WWN))+(modelPar_WWL*LW_WLN_WWN));
    instanceVar_Leff = (instanceVar_Lnew-(2.0*dLIV));
    if ((instanceVar_Leff<=0))
    {
      std::cerr  << "Fatal: Effective channel length = %e for  %M is non-positive" << instanceVar_Leff <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((instanceVar_Leff<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel length = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << instanceVar_Leff <<  std::endl; 
      }
    }
    instanceVar_Weff = (instanceVar_Wnew-(2.0*dWIV));
    if ((instanceVar_Weff<=0))
    {
      std::cerr  << "Fatal: Effective channel Width = %e for  %M is non-positive" << instanceVar_Weff <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((instanceVar_Weff<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel width = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << instanceVar_Leff <<  std::endl; 
      }
    }
    dLCV = (((modelPar_DLC+(modelPar_LLC*L_LLN))+(modelPar_LWC*W_LWN))+(modelPar_LWLC*LW_LLN_LWN));
    dWCV = (((modelPar_DWC+(modelPar_WLC*L_WLN))+(modelPar_WWC*W_WWN))+(modelPar_WWLC*LW_WLN_WWN));
    instanceVar_Lact = (instanceVar_Lnew-(2.0*dLCV));
    if ((instanceVar_Lact<=0))
    {
      std::cerr  << "Fatal: Effective channel length for CV = %e for  %M is non-positive" << instanceVar_Lact <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((instanceVar_Lact<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel length for CV = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << instanceVar_Leff <<  std::endl; 
      }
    }
    instanceVar_Wact = (instanceVar_Wnew-(2.0*dWCV));
    if ((instanceVar_Wact<=0))
    {
      std::cerr  << "Fatal: Effective channel width for CV = %e for  %M is non-positive" << instanceVar_Wact <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    else
    {
      if ((instanceVar_Wact<=1.0e-9))
      {
        std::cerr  << "Warning: Effective channel width for CV = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << instanceVar_Leff <<  std::endl; 
      }
    }
    dWJ = (((modelPar_DWJ+(modelPar_WLC/pow(instanceVar_Lnew,modelPar_WLN)))+(modelPar_WWC/pow(instanceVar_Wnew,modelPar_WWN)))+((modelPar_WWLC/pow(instanceVar_Lnew,modelPar_WLN))/pow(instanceVar_Wnew,modelPar_WWN)));
    instanceVar_Weffcj = (instanceVar_Wnew-(2.0*dWJ));
    if ((instanceVar_Weffcj<=0))
    {
      std::cerr  << "Fatal: Effective channel width for S/D junctions = %e for  %M is non-positive" << instanceVar_Weffcj <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    Inv_L = (1.0e-6/instanceVar_Leff);
    Inv_W = (1.0e-6/instanceVar_Weff);
    Inv_Lact = (1.0e-6/instanceVar_Lact);
    Inv_Wact = (1.0e-6/instanceVar_Wact);
    Inv_Llong = (1.0e-6/modelPar_LLONG);
    Inv_Wwide = (1.0e-6/modelPar_WWIDE);
    Inv_WL = (Inv_L*Inv_W);
    L_LLN1 = L_LLN;
    L_WLN1 = L_WLN;
    if ((modelPar_DLBIN!=0))
    {
      if ((modelPar_DLBIN<=(-instanceVar_Lnew)))
      {
        std::cerr  << "Fatal: DLBIN for  %M = %e is <= -Ldrawn*LMLT" << modelPar_DLBIN <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
      else
      {
        L_LLN1 = pow((instanceVar_Lnew+modelPar_DLBIN),(-modelPar_LLN));
        L_WLN1 = pow((instanceVar_Lnew+modelPar_DLBIN),(-modelPar_WLN));
      }
    }
    W_LWN1 = W_LWN;
    W_WWN1 = W_WWN;
    if ((modelPar_DWBIN!=0))
    {
      if ((modelPar_DWBIN<=(-instanceVar_Wnew)))
      {
        std::cerr  << "Fatal: DWBIN for  %M = %e is <= -Wdrawn*WMLT" << modelPar_DWBIN <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
      else
      {
        W_LWN1 = pow((instanceVar_Wnew+modelPar_DWBIN),(-modelPar_LWN));
        W_WWN1 = pow((instanceVar_Wnew+modelPar_DWBIN),(-modelPar_WWN));
      }
    }
    LW_LLN_LWN1 = (L_LLN1*W_LWN1);
    dLB = (((modelPar_LINT+(modelPar_LL*L_LLN1))+(modelPar_LW*W_LWN1))+(modelPar_LWL*LW_LLN_LWN1));
    LW_WLN_WWN1 = (L_WLN1*W_WWN1);
    dWB = (((modelPar_WINT+(modelPar_WL*L_WLN1))+(modelPar_WW*W_WWN1))+(modelPar_WWL*LW_WLN_WWN1));
    Leff1 = ((instanceVar_Lnew-(2.0*dLB))+modelPar_DLBIN);
    if ((Leff1<=0))
    {
      std::cerr  << "Fatal: Effective channel length for binning = %e for  %M is non-positive" << Leff1 <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    Weff1 = ((instanceVar_Wnew-(2.0*dWB))+modelPar_DWBIN);
    if ((Weff1<=0))
    {
      std::cerr  << "Fatal: Effective channel width for binning = %e for  %M is non-positive" << Weff1 <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((modelPar_BINUNIT==1))
    {
      BIN_L = (1.0e-6/Leff1);
      BIN_W = (1.0e-6/Weff1);
    }
    else
    {
      BIN_L = (1.0/Leff1);
      BIN_W = (1.0/Weff1);
    }
    BIN_WL = (BIN_L*BIN_W);
    instanceVar_VFB_i = (((modelPar_VFB+(BIN_L*modelPar_LVFB))+(BIN_W*modelPar_WVFB))+(BIN_WL*modelPar_PVFB));
    instanceVar_VFBCV_i = (((modelPar_VFBCV+(BIN_L*modelPar_LVFBCV))+(BIN_W*modelPar_WVFBCV))+(BIN_WL*modelPar_PVFBCV));
    instanceVar_NSD_i = (((modelPar_NSD+(BIN_L*modelPar_LNSD))+(BIN_W*modelPar_WNSD))+(BIN_WL*modelPar_PNSD));
    instanceVar_NDEP_i = (((modelPar_NDEP+(BIN_L*modelPar_LNDEP))+(BIN_W*modelPar_WNDEP))+(BIN_WL*modelPar_PNDEP));
    instanceVar_NDEPCV_i = (((modelPar_NDEPCV+(BIN_L*modelPar_LNDEPCV))+(BIN_W*modelPar_WNDEPCV))+(BIN_WL*modelPar_PNDEPCV));
    instanceVar_NGATE_i = (((modelPar_NGATE+(BIN_L*modelPar_LNGATE))+(BIN_W*modelPar_WNGATE))+(BIN_WL*modelPar_PNGATE));
    instanceVar_CIT_i = (((modelPar_CIT+(BIN_L*modelPar_LCIT))+(BIN_W*modelPar_WCIT))+(BIN_WL*modelPar_PCIT));
    instanceVar_NFACTOR_i = (((modelPar_NFACTOR+(BIN_L*modelPar_LNFACTOR))+(BIN_W*modelPar_WNFACTOR))+(BIN_WL*modelPar_PNFACTOR));
    instanceVar_CDSCD_i = (((modelPar_CDSCD+(BIN_L*modelPar_LCDSCD))+(BIN_W*modelPar_WCDSCD))+(BIN_WL*modelPar_PCDSCD));
    instanceVar_CDSCB_i = (((modelPar_CDSCB+(BIN_L*modelPar_LCDSCB))+(BIN_W*modelPar_WCDSCB))+(BIN_WL*modelPar_PCDSCB));
    instanceVar_DVTP0_i = (((modelPar_DVTP0+(BIN_L*modelPar_LDVTP0))+(BIN_W*modelPar_WDVTP0))+(BIN_WL*modelPar_PDVTP0));
    instanceVar_DVTP1_i = (((modelPar_DVTP1+(BIN_L*modelPar_LDVTP1))+(BIN_W*modelPar_WDVTP1))+(BIN_WL*modelPar_PDVTP1));
    instanceVar_DVTP2_i = (((modelPar_DVTP2+(BIN_L*modelPar_LDVTP2))+(BIN_W*modelPar_WDVTP2))+(BIN_WL*modelPar_PDVTP2));
    instanceVar_DVTP3_i = (((modelPar_DVTP3+(BIN_L*modelPar_LDVTP3))+(BIN_W*modelPar_WDVTP3))+(BIN_WL*modelPar_PDVTP3));
    instanceVar_DVTP4_i = (((modelPar_DVTP4+(BIN_L*modelPar_LDVTP4))+(BIN_W*modelPar_WDVTP4))+(BIN_WL*modelPar_PDVTP4));
    instanceVar_DVTP5_i = (((modelPar_DVTP5+(BIN_L*modelPar_LDVTP5))+(BIN_W*modelPar_WDVTP5))+(BIN_WL*modelPar_PDVTP5));
    instanceVar_K2_i = (((modelPar_K2+(BIN_L*modelPar_LK2))+(BIN_W*modelPar_WK2))+(BIN_WL*modelPar_PK2));
    instanceVar_K1_i = (((modelPar_K1+(BIN_L*modelPar_LK1))+(BIN_W*modelPar_WK1))+(BIN_WL*modelPar_PK1));
    instanceVar_XJ_i = (((modelPar_XJ+(BIN_L*modelPar_LXJ))+(BIN_W*modelPar_WXJ))+(BIN_WL*modelPar_PXJ));
    instanceVar_PHIN_i = (((modelPar_PHIN+(BIN_L*modelPar_LPHIN))+(BIN_W*modelPar_WPHIN))+(BIN_WL*modelPar_PPHIN));
    instanceVar_ETA0_i = (((modelPar_ETA0+(BIN_L*modelPar_LETA0))+(BIN_W*modelPar_WETA0))+(BIN_WL*modelPar_PETA0));
    instanceVar_ETAB_i = (((modelPar_ETAB+(BIN_L*modelPar_LETAB))+(BIN_W*modelPar_WETAB))+(BIN_WL*modelPar_PETAB));
    instanceVar_DELTA_i = (((modelPar_DELTA+(BIN_L*modelPar_LDELTA))+(BIN_W*modelPar_WDELTA))+(BIN_WL*modelPar_PDELTA));
    instanceVar_U0_i = (((modelPar_U0+(BIN_L*modelPar_LU0))+(BIN_W*modelPar_WU0))+(BIN_WL*modelPar_PU0));
    instanceVar_UA_i = (((modelPar_UA+(BIN_L*modelPar_LUA))+(BIN_W*modelPar_WUA))+(BIN_WL*modelPar_PUA));
    instanceVar_UD_i = (((modelPar_UD+(BIN_L*modelPar_LUD))+(BIN_W*modelPar_WUD))+(BIN_WL*modelPar_PUD));
    instanceVar_EU_i = (((modelPar_EU+(BIN_L*modelPar_LEU))+(BIN_W*modelPar_WEU))+(BIN_WL*modelPar_PEU));
    instanceVar_UCS_i = (((modelPar_UCS+(BIN_L*modelPar_LUCS))+(BIN_W*modelPar_WUCS))+(BIN_WL*modelPar_PUCS));
    instanceVar_UC_i = (((modelPar_UC+(BIN_L*modelPar_LUC))+(BIN_W*modelPar_WUC))+(BIN_WL*modelPar_PUC));
    instanceVar_PCLM_i = (((modelPar_PCLM+(BIN_L*modelPar_LPCLM))+(BIN_W*modelPar_WPCLM))+(BIN_WL*modelPar_PPCLM));
    instanceVar_PCLMCV_i = (((modelPar_PCLMCV+(BIN_L*modelPar_LPCLMCV))+(BIN_W*modelPar_WPCLMCV))+(BIN_WL*modelPar_PPCLMCV));
    instanceVar_RSW_i = (((modelPar_RSW+(BIN_L*modelPar_LRSW))+(BIN_W*modelPar_WRSW))+(BIN_WL*modelPar_PRSW));
    instanceVar_RDW_i = (((modelPar_RDW+(BIN_L*modelPar_LRDW))+(BIN_W*modelPar_WRDW))+(BIN_WL*modelPar_PRDW));
    instanceVar_PRWG_i = (((modelPar_PRWG+(BIN_L*modelPar_LPRWG))+(BIN_W*modelPar_WPRWG))+(BIN_WL*modelPar_PPRWG));
    instanceVar_PRWB_i = (((modelPar_PRWB+(BIN_L*modelPar_LPRWB))+(BIN_W*modelPar_WPRWB))+(BIN_WL*modelPar_PPRWB));
    instanceVar_WR_i = (((modelPar_WR+(BIN_L*modelPar_LWR))+(BIN_W*modelPar_WWR))+(BIN_WL*modelPar_PWR));
    instanceVar_RSWMIN_i = (((modelPar_RSWMIN+(BIN_L*modelPar_LRSWMIN))+(BIN_W*modelPar_WRSWMIN))+(BIN_WL*modelPar_PRSWMIN));
    instanceVar_RDWMIN_i = (((modelPar_RDWMIN+(BIN_L*modelPar_LRDWMIN))+(BIN_W*modelPar_WRDWMIN))+(BIN_WL*modelPar_PRDWMIN));
    instanceVar_RDSW_i = (((modelPar_RDSW+(BIN_L*modelPar_LRDSW))+(BIN_W*modelPar_WRDSW))+(BIN_WL*modelPar_PRDSW));
    instanceVar_RDSWMIN_i = (((modelPar_RDSWMIN+(BIN_L*modelPar_LRDSWMIN))+(BIN_W*modelPar_WRDSWMIN))+(BIN_WL*modelPar_PRDSWMIN));
    instanceVar_PTWG_i = (((modelPar_PTWG+(BIN_L*modelPar_LPTWG))+(BIN_W*modelPar_WPTWG))+(BIN_WL*modelPar_PPTWG));
    instanceVar_PDIBLC_i = (((modelPar_PDIBLC+(BIN_L*modelPar_LPDIBLC))+(BIN_W*modelPar_WPDIBLC))+(BIN_WL*modelPar_PPDIBLC));
    instanceVar_PDIBLCB_i = (((modelPar_PDIBLCB+(BIN_L*modelPar_LPDIBLCB))+(BIN_W*modelPar_WPDIBLCB))+(BIN_WL*modelPar_PPDIBLCB));
    instanceVar_PSCBE1_i = (((modelPar_PSCBE1+(BIN_L*modelPar_LPSCBE1))+(BIN_W*modelPar_WPSCBE1))+(BIN_WL*modelPar_PPSCBE1));
    instanceVar_PSCBE2_i = (((modelPar_PSCBE2+(BIN_L*modelPar_LPSCBE2))+(BIN_W*modelPar_WPSCBE2))+(BIN_WL*modelPar_PPSCBE2));
    instanceVar_PDITS_i = (((modelPar_PDITS+(BIN_L*modelPar_LPDITS))+(BIN_W*modelPar_WPDITS))+(BIN_WL*modelPar_PPDITS));
    instanceVar_PDITSD_i = (((modelPar_PDITSD+(BIN_L*modelPar_LPDITSD))+(BIN_W*modelPar_WPDITSD))+(BIN_WL*modelPar_PPDITSD));
    instanceVar_FPROUT_i = (((modelPar_FPROUT+(BIN_L*modelPar_LFPROUT))+(BIN_W*modelPar_WFPROUT))+(BIN_WL*modelPar_PFPROUT));
    instanceVar_PVAG_i = (((modelPar_PVAG+(BIN_L*modelPar_LPVAG))+(BIN_W*modelPar_WPVAG))+(BIN_WL*modelPar_PPVAG));
    instanceVar_VSAT_i = (((modelPar_VSAT+(BIN_L*modelPar_LVSAT))+(BIN_W*modelPar_WVSAT))+(BIN_WL*modelPar_PVSAT));
    instanceVar_PSAT_i = (((modelPar_PSAT+(BIN_L*modelPar_LPSAT))+(BIN_W*modelPar_WPSAT))+(BIN_WL*modelPar_PPSAT));
    instanceVar_VSATCV_i = (((modelPar_VSATCV+(BIN_L*modelPar_LVSATCV))+(BIN_W*modelPar_WVSATCV))+(BIN_WL*modelPar_PVSATCV));
    instanceVar_CF_i = (((modelPar_CF+(BIN_L*modelPar_LCF))+(BIN_W*modelPar_WCF))+(BIN_WL*modelPar_PCF));
    instanceVar_CGSL_i = (((modelPar_CGSL+(BIN_L*modelPar_LCGSL))+(BIN_W*modelPar_WCGSL))+(BIN_WL*modelPar_PCGSL));
    instanceVar_CGDL_i = (((modelPar_CGDL+(BIN_L*modelPar_LCGDL))+(BIN_W*modelPar_WCGDL))+(BIN_WL*modelPar_PCGDL));
    instanceVar_CKAPPAS_i = (((modelPar_CKAPPAS+(BIN_L*modelPar_LCKAPPAS))+(BIN_W*modelPar_WCKAPPAS))+(BIN_WL*modelPar_PCKAPPAS));
    instanceVar_CKAPPAD_i = (((modelPar_CKAPPAD+(BIN_L*modelPar_LCKAPPAD))+(BIN_W*modelPar_WCKAPPAD))+(BIN_WL*modelPar_PCKAPPAD));
    instanceVar_ALPHA0_i = (((modelPar_ALPHA0+(BIN_L*modelPar_LALPHA0))+(BIN_W*modelPar_WALPHA0))+(BIN_WL*modelPar_PALPHA0));
    instanceVar_BETA0_i = (((modelPar_BETA0+(BIN_L*modelPar_LBETA0))+(BIN_W*modelPar_WBETA0))+(BIN_WL*modelPar_PBETA0));
    instanceVar_KVTH0WE_i = (((modelPar_KVTH0WE+(BIN_L*modelPar_LKVTH0WE))+(BIN_W*modelPar_WKVTH0WE))+(BIN_WL*modelPar_PKVTH0WE));
    instanceVar_K2WE_i = (((modelPar_K2WE+(BIN_L*modelPar_LK2WE))+(BIN_W*modelPar_WK2WE))+(BIN_WL*modelPar_PK2WE));
    instanceVar_KU0WE_i = (((modelPar_KU0WE+(BIN_L*modelPar_LKU0WE))+(BIN_W*modelPar_WKU0WE))+(BIN_WL*modelPar_PKU0WE));
    instanceVar_AGIDL_i = (((modelPar_AGIDL+(BIN_L*modelPar_LAGIDL))+(BIN_W*modelPar_WAGIDL))+(BIN_WL*modelPar_PAGIDL));
    instanceVar_BGIDL_i = (((modelPar_BGIDL+(BIN_L*modelPar_LBGIDL))+(BIN_W*modelPar_WBGIDL))+(BIN_WL*modelPar_PBGIDL));
    instanceVar_CGIDL_i = (((modelPar_CGIDL+(BIN_L*modelPar_LCGIDL))+(BIN_W*modelPar_WCGIDL))+(BIN_WL*modelPar_PCGIDL));
    instanceVar_EGIDL_i = (((modelPar_EGIDL+(BIN_L*modelPar_LEGIDL))+(BIN_W*modelPar_WEGIDL))+(BIN_WL*modelPar_PEGIDL));
    instanceVar_AGISL_i = (((modelPar_AGISL+(BIN_L*modelPar_LAGISL))+(BIN_W*modelPar_WAGISL))+(BIN_WL*modelPar_PAGISL));
    instanceVar_BGISL_i = (((modelPar_BGISL+(BIN_L*modelPar_LBGISL))+(BIN_W*modelPar_WBGISL))+(BIN_WL*modelPar_PBGISL));
    instanceVar_CGISL_i = (((modelPar_CGISL+(BIN_L*modelPar_LCGISL))+(BIN_W*modelPar_WCGISL))+(BIN_WL*modelPar_PCGISL));
    instanceVar_EGISL_i = (((modelPar_EGISL+(BIN_L*modelPar_LEGISL))+(BIN_W*modelPar_WEGISL))+(BIN_WL*modelPar_PEGISL));
    instanceVar_UTE_i = (((modelPar_UTE+(BIN_L*modelPar_LUTE))+(BIN_W*modelPar_WUTE))+(BIN_WL*modelPar_PUTE));
    instanceVar_UA1_i = (((modelPar_UA1+(BIN_L*modelPar_LUA1))+(BIN_W*modelPar_WUA1))+(BIN_WL*modelPar_PUA1));
    instanceVar_UC1_i = (((modelPar_UC1+(BIN_L*modelPar_LUC1))+(BIN_W*modelPar_WUC1))+(BIN_WL*modelPar_PUC1));
    instanceVar_UD1_i = (((modelPar_UD1+(BIN_L*modelPar_LUD1))+(BIN_W*modelPar_WUD1))+(BIN_WL*modelPar_PUD1));
    instanceVar_UCSTE_i = (((modelPar_UCSTE+(BIN_L*modelPar_LUCSTE))+(BIN_W*modelPar_WUCSTE))+(BIN_WL*modelPar_PUCSTE));
    instanceVar_PRT_i = (((modelPar_PRT+(BIN_L*modelPar_LPRT))+(BIN_W*modelPar_WPRT))+(BIN_WL*modelPar_PPRT));
    instanceVar_AT_i = (((modelPar_AT+(BIN_L*modelPar_LAT))+(BIN_W*modelPar_WAT))+(BIN_WL*modelPar_PAT));
    instanceVar_PTWGT_i = (((modelPar_PTWGT+(BIN_L*modelPar_LPTWGT))+(BIN_W*modelPar_WPTWGT))+(BIN_WL*modelPar_PPTWGT));
    instanceVar_IIT_i = (((modelPar_IIT+(BIN_L*modelPar_LIIT))+(BIN_W*modelPar_WIIT))+(BIN_WL*modelPar_PIIT));
    instanceVar_TGIDL_i = (((modelPar_TGIDL+(BIN_L*modelPar_LTGIDL))+(BIN_W*modelPar_WTGIDL))+(BIN_WL*modelPar_PTGIDL));
    instanceVar_IGT_i = (((modelPar_IGT+(BIN_L*modelPar_LIGT))+(BIN_W*modelPar_WIGT))+(BIN_WL*modelPar_PIGT));
    instanceVar_AIGBINV_i = (((modelPar_AIGBINV+(BIN_L*modelPar_LAIGBINV))+(BIN_W*modelPar_WAIGBINV))+(BIN_WL*modelPar_PAIGBINV));
    instanceVar_BIGBINV_i = (((modelPar_BIGBINV+(BIN_L*modelPar_LBIGBINV))+(BIN_W*modelPar_WBIGBINV))+(BIN_WL*modelPar_PBIGBINV));
    instanceVar_CIGBINV_i = (((modelPar_CIGBINV+(BIN_L*modelPar_LCIGBINV))+(BIN_W*modelPar_WCIGBINV))+(BIN_WL*modelPar_PCIGBINV));
    instanceVar_EIGBINV_i = (((modelPar_EIGBINV+(BIN_L*modelPar_LEIGBINV))+(BIN_W*modelPar_WEIGBINV))+(BIN_WL*modelPar_PEIGBINV));
    instanceVar_NIGBINV_i = (((modelPar_NIGBINV+(BIN_L*modelPar_LNIGBINV))+(BIN_W*modelPar_WNIGBINV))+(BIN_WL*modelPar_PNIGBINV));
    instanceVar_AIGBACC_i = (((modelPar_AIGBACC+(BIN_L*modelPar_LAIGBACC))+(BIN_W*modelPar_WAIGBACC))+(BIN_WL*modelPar_PAIGBACC));
    instanceVar_BIGBACC_i = (((modelPar_BIGBACC+(BIN_L*modelPar_LBIGBACC))+(BIN_W*modelPar_WBIGBACC))+(BIN_WL*modelPar_PBIGBACC));
    instanceVar_CIGBACC_i = (((modelPar_CIGBACC+(BIN_L*modelPar_LCIGBACC))+(BIN_W*modelPar_WCIGBACC))+(BIN_WL*modelPar_PCIGBACC));
    instanceVar_NIGBACC_i = (((modelPar_NIGBACC+(BIN_L*modelPar_LNIGBACC))+(BIN_W*modelPar_WNIGBACC))+(BIN_WL*modelPar_PNIGBACC));
    instanceVar_AIGC_i = (((modelPar_AIGC+(BIN_L*modelPar_LAIGC))+(BIN_W*modelPar_WAIGC))+(BIN_WL*modelPar_PAIGC));
    instanceVar_BIGC_i = (((modelPar_BIGC+(BIN_L*modelPar_LBIGC))+(BIN_W*modelPar_WBIGC))+(BIN_WL*modelPar_PBIGC));
    instanceVar_CIGC_i = (((modelPar_CIGC+(BIN_L*modelPar_LCIGC))+(BIN_W*modelPar_WCIGC))+(BIN_WL*modelPar_PCIGC));
    instanceVar_AIGS_i = (((modelPar_AIGS+(BIN_L*modelPar_LAIGS))+(BIN_W*modelPar_WAIGS))+(BIN_WL*modelPar_PAIGS));
    instanceVar_BIGS_i = (((modelPar_BIGS+(BIN_L*modelPar_LBIGS))+(BIN_W*modelPar_WBIGS))+(BIN_WL*modelPar_PBIGS));
    instanceVar_CIGS_i = (((modelPar_CIGS+(BIN_L*modelPar_LCIGS))+(BIN_W*modelPar_WCIGS))+(BIN_WL*modelPar_PCIGS));
    instanceVar_AIGD_i = (((modelPar_AIGD+(BIN_L*modelPar_LAIGD))+(BIN_W*modelPar_WAIGD))+(BIN_WL*modelPar_PAIGD));
    instanceVar_BIGD_i = (((modelPar_BIGD+(BIN_L*modelPar_LBIGD))+(BIN_W*modelPar_WBIGD))+(BIN_WL*modelPar_PBIGD));
    instanceVar_CIGD_i = (((modelPar_CIGD+(BIN_L*modelPar_LCIGD))+(BIN_W*modelPar_WCIGD))+(BIN_WL*modelPar_PCIGD));
    POXEDGE_i = (((modelPar_POXEDGE+(BIN_L*modelPar_LPOXEDGE))+(BIN_W*modelPar_WPOXEDGE))+(BIN_WL*modelPar_PPOXEDGE));
    instanceVar_DLCIG_i = (((modelPar_DLCIG+(BIN_L*modelPar_LDLCIG))+(BIN_W*modelPar_WDLCIG))+(BIN_WL*modelPar_PDLCIG));
    instanceVar_DLCIGD_i = (((modelPar_DLCIGD+(BIN_L*modelPar_LDLCIGD))+(BIN_W*modelPar_WDLCIGD))+(BIN_WL*modelPar_PDLCIGD));
    NTOX_i = (((modelPar_NTOX+(BIN_L*modelPar_LNTOX))+(BIN_W*modelPar_WNTOX))+(BIN_WL*modelPar_PNTOX));
    instanceVar_KT1_i = (((modelPar_KT1+(BIN_L*modelPar_LKT1))+(BIN_W*modelPar_WKT1))+(BIN_WL*modelPar_PKT1));
    instanceVar_KT2_i = (((modelPar_KT2+(BIN_L*modelPar_LKT2))+(BIN_W*modelPar_WKT2))+(BIN_WL*modelPar_PKT2));
    instanceVar_PSATB_i = (((modelPar_PSATB+(BIN_L*modelPar_LPSATB))+(BIN_W*modelPar_WPSATB))+(BIN_WL*modelPar_PPSATB));
    instanceVar_A1_i = (((modelPar_A1+(BIN_L*modelPar_LA1))+(BIN_W*modelPar_WA1))+(BIN_WL*modelPar_PA1));
    instanceVar_A11_i = (((modelPar_A11+(BIN_L*modelPar_LA11))+(BIN_W*modelPar_WA11))+(BIN_WL*modelPar_PA11));
    instanceVar_A2_i = (((modelPar_A2+(BIN_L*modelPar_LA2))+(BIN_W*modelPar_WA2))+(BIN_WL*modelPar_PA2));
    instanceVar_A21_i = (((modelPar_A21+(BIN_L*modelPar_LA21))+(BIN_W*modelPar_WA21))+(BIN_WL*modelPar_PA21));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_CDSCDR_i = (((modelPar_CDSCDR+(BIN_L*modelPar_LCDSCDR))+(BIN_W*modelPar_WCDSCDR))+(BIN_WL*modelPar_PCDSCDR));
      instanceVar_ETA0R_i = (((modelPar_ETA0R+(BIN_L*modelPar_LETA0R))+(BIN_W*modelPar_WETA0R))+(BIN_WL*modelPar_PETA0R));
      instanceVar_U0R_i = (((modelPar_U0R+(BIN_L*modelPar_LU0R))+(BIN_W*modelPar_WU0R))+(BIN_WL*modelPar_PU0R));
      instanceVar_UAR_i = (((modelPar_UAR+(BIN_L*modelPar_LUAR))+(BIN_W*modelPar_WUAR))+(BIN_WL*modelPar_PUAR));
      instanceVar_UDR_i = (((modelPar_UDR+(BIN_L*modelPar_LUDR))+(BIN_W*modelPar_WUDR))+(BIN_WL*modelPar_PUDR));
      instanceVar_UCSR_i = (((modelPar_UCSR+(BIN_L*modelPar_LUCSR))+(BIN_W*modelPar_WUCSR))+(BIN_WL*modelPar_PUCSR));
      instanceVar_UCR_i = (((modelPar_UCR+(BIN_L*modelPar_LUCR))+(BIN_W*modelPar_WUCR))+(BIN_WL*modelPar_PUCR));
      instanceVar_PCLMR_i = (((modelPar_PCLMR+(BIN_L*modelPar_LPCLMR))+(BIN_W*modelPar_WPCLMR))+(BIN_WL*modelPar_PPCLMR));
      instanceVar_PDIBLCR_i = (((modelPar_PDIBLCR+(BIN_L*modelPar_LPDIBLCR))+(BIN_W*modelPar_WPDIBLCR))+(BIN_WL*modelPar_PPDIBLCR));
      instanceVar_VSATR_i = (((modelPar_VSATR+(BIN_L*modelPar_LVSATR))+(BIN_W*modelPar_WVSATR))+(BIN_WL*modelPar_PVSATR));
      instanceVar_PSATR_i = (((modelPar_PSATR+(BIN_L*modelPar_LPSATR))+(BIN_W*modelPar_WPSATR))+(BIN_WL*modelPar_PPSATR));
      instanceVar_PTWGR_i = (((modelPar_PTWGR+(BIN_L*modelPar_LPTWGR))+(BIN_W*modelPar_WPTWGR))+(BIN_WL*modelPar_PPTWGR));
    }
    instanceVar_T0 = ((modelPar_NDEPL1*max((pow(Inv_L,modelPar_NDEPLEXP1)-pow(Inv_Llong,modelPar_NDEPLEXP1)),static_cast<double>(0)))+(modelPar_NDEPL2*max((pow(Inv_L,modelPar_NDEPLEXP2)-pow(Inv_Llong,modelPar_NDEPLEXP2)),static_cast<double>(0))));
    instanceVar_T1 = ((modelPar_NDEPW*max((pow(Inv_W,modelPar_NDEPWEXP)-pow(Inv_Wwide,modelPar_NDEPWEXP)),static_cast<double>(0)))+(modelPar_NDEPWL*pow((Inv_W*Inv_L),modelPar_NDEPWLEXP)));
    instanceVar_NDEP_i = (instanceVar_NDEP_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_T0 = (modelPar_NFACTORL*max((pow(Inv_L,modelPar_NFACTORLEXP)-pow(Inv_Llong,modelPar_NFACTORLEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_NFACTORW*max((pow(Inv_W,modelPar_NFACTORWEXP)-pow(Inv_Wwide,modelPar_NFACTORWEXP)),static_cast<double>(0)))+(modelPar_NFACTORWL*pow(Inv_WL,modelPar_NFACTORWLEXP)));
    instanceVar_NFACTOR_i = (instanceVar_NFACTOR_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_T0 = (1.0+(modelPar_CDSCDL*max((pow(Inv_L,modelPar_CDSCDLEXP)-pow(Inv_Llong,modelPar_CDSCDLEXP)),static_cast<double>(0))));
    instanceVar_CDSCD_i = (instanceVar_CDSCD_i*instanceVar_T0);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_CDSCDR_i = (instanceVar_CDSCDR_i*instanceVar_T0);
    }
    instanceVar_CDSCB_i = (instanceVar_CDSCB_i*(1.0+(modelPar_CDSCBL*max((pow(Inv_L,modelPar_CDSCBLEXP)-pow(Inv_Llong,modelPar_CDSCBLEXP)),static_cast<double>(0)))));
    instanceVar_U0_i = (modelPar_MULU0*instanceVar_U0_i);
    if ((modelPar_MOBSCALE!=1))
    {
      if ((modelPar_U0LEXP>0))
      {
        instanceVar_U0_i = (instanceVar_U0_i*(1.0-(modelPar_U0L*max((pow(Inv_L,modelPar_U0LEXP)-pow(Inv_Llong,modelPar_U0LEXP)),static_cast<double>(0)))));
        if ((modelPar_ASYMMOD!=0))
        {
          instanceVar_U0R_i = (instanceVar_U0R_i*(1.0-(modelPar_U0L*max((pow(Inv_L,modelPar_U0LEXP)-pow(Inv_Llong,modelPar_U0LEXP)),static_cast<double>(0)))));
        }
      }
      else
      {
        instanceVar_U0_i = (instanceVar_U0_i*(1.0-modelPar_U0L));
        if ((modelPar_ASYMMOD!=0))
        {
          instanceVar_U0R_i = (instanceVar_U0R_i*(1.0-modelPar_U0L));
        }
      }
    }
    else
    {
      instanceVar_U0_i = (instanceVar_U0_i*((1.0-(modelPar_UP1*exp(((-instanceVar_Leff)/modelPar_LP1))))-(modelPar_UP2*exp(((-instanceVar_Leff)/modelPar_LP2)))));
      if ((modelPar_ASYMMOD!=0))
      {
        instanceVar_U0R_i = (instanceVar_U0R_i*((1.0-(modelPar_UP1*exp(((-instanceVar_Leff)/modelPar_LP1))))-(modelPar_UP2*exp(((-instanceVar_Leff)/modelPar_LP2)))));
      }
    }
    instanceVar_T0 = (modelPar_UAL*max((pow(Inv_L,modelPar_UALEXP)-pow(Inv_Llong,modelPar_UALEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_UAW*max((pow(Inv_W,modelPar_UAWEXP)-pow(Inv_Wwide,modelPar_UAWEXP)),static_cast<double>(0)))+(modelPar_UAWL*pow(Inv_WL,modelPar_UAWLEXP)));
    instanceVar_UA_i = (instanceVar_UA_i*((1.0+instanceVar_T0)+instanceVar_T1));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_UAR_i = (instanceVar_UAR_i*((1.0+instanceVar_T0)+instanceVar_T1));
    }
    instanceVar_T0 = (modelPar_EUL*max((pow(Inv_L,modelPar_EULEXP)-pow(Inv_Llong,modelPar_EULEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_EUW*max((pow(Inv_W,modelPar_EUWEXP)-pow(Inv_Wwide,modelPar_EUWEXP)),static_cast<double>(0)))+(modelPar_EUWL*pow(Inv_WL,modelPar_EUWLEXP)));
    instanceVar_EU_i = (instanceVar_EU_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_T0 = (1.0+(modelPar_UDL*max((pow(Inv_L,modelPar_UDLEXP)-pow(Inv_Llong,modelPar_UDLEXP)),static_cast<double>(0))));
    instanceVar_UD_i = (instanceVar_UD_i*instanceVar_T0);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_UDR_i = (instanceVar_UDR_i*instanceVar_T0);
    }
    instanceVar_T0 = (modelPar_UCL*max((pow(Inv_L,modelPar_UCLEXP)-pow(Inv_Llong,modelPar_UCLEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_UCW*max((pow(Inv_W,modelPar_UCWEXP)-pow(Inv_Wwide,modelPar_UCWEXP)),static_cast<double>(0)))+(modelPar_UCWL*pow(Inv_WL,modelPar_UCWLEXP)));
    instanceVar_UC_i = (instanceVar_UC_i*((1.0+instanceVar_T0)+instanceVar_T1));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_UCR_i = (instanceVar_UCR_i*((1.0+instanceVar_T0)+instanceVar_T1));
    }
    instanceVar_T0 = max((pow(Inv_L,modelPar_DSUB)-pow(Inv_Llong,modelPar_DSUB)),static_cast<double>(0));
    instanceVar_ETA0_i = (instanceVar_ETA0_i*instanceVar_T0);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_ETA0R_i = (instanceVar_ETA0R_i*instanceVar_T0);
    }
    instanceVar_ETAB_i = (instanceVar_ETAB_i*max((pow(Inv_L,modelPar_ETABEXP)-pow(Inv_Llong,modelPar_ETABEXP)),static_cast<double>(0)));
    instanceVar_T0 = (1.0+(modelPar_PDIBLCL*max((pow(Inv_L,modelPar_PDIBLCLEXP)-pow(Inv_Llong,modelPar_PDIBLCLEXP)),static_cast<double>(0))));
    instanceVar_PDIBLC_i = (instanceVar_PDIBLC_i*instanceVar_T0);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PDIBLCR_i = (instanceVar_PDIBLCR_i*instanceVar_T0);
    }
    instanceVar_T0 = (instanceVar_DELTA_i*(1.0+(modelPar_DELTAL*max((pow(Inv_L,modelPar_DELTALEXP)-pow(Inv_Llong,modelPar_DELTALEXP)),static_cast<double>(0)))));
    instanceVar_DELTA_i = min(instanceVar_T0,static_cast<double>(0.5));
    instanceVar_FPROUT_i = (instanceVar_FPROUT_i*(1.0+(modelPar_FPROUTL*max((pow(Inv_L,modelPar_FPROUTLEXP)-pow(Inv_Llong,modelPar_FPROUTLEXP)),static_cast<double>(0)))));
    instanceVar_T0 = (1.0+(modelPar_PCLML*max((pow(Inv_L,modelPar_PCLMLEXP)-pow(Inv_Llong,modelPar_PCLMLEXP)),static_cast<double>(0))));
    instanceVar_PCLM_i = (instanceVar_PCLM_i*instanceVar_T0);
    instanceVar_PCLM_i = max(instanceVar_PCLM_i,static_cast<double>(0));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PCLMR_i = (instanceVar_PCLMR_i*instanceVar_T0);
      instanceVar_PCLMR_i = max(instanceVar_PCLMR_i,static_cast<double>(0));
    }
    instanceVar_T0 = (modelPar_VSATL*max((pow(Inv_L,modelPar_VSATLEXP)-pow(Inv_Llong,modelPar_VSATLEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_VSATW*max((pow(Inv_W,modelPar_VSATWEXP)-pow(Inv_Wwide,modelPar_VSATWEXP)),static_cast<double>(0)))+(modelPar_VSATWL*pow(Inv_WL,modelPar_VSATWLEXP)));
    instanceVar_VSAT_i = (instanceVar_VSAT_i*((1.0+instanceVar_T0)+instanceVar_T1));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_VSATR_i = (instanceVar_VSATR_i*((1.0+instanceVar_T0)+instanceVar_T1));
    }
    instanceVar_PSAT_i = max((instanceVar_PSAT_i*(1.0+(modelPar_PSATL*max((pow(Inv_L,modelPar_PSATLEXP)-pow(Inv_Llong,modelPar_PSATLEXP)),static_cast<double>(0))))),static_cast<double>(0.25));
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PSATR_i = max((instanceVar_PSATR_i*(1.0+(modelPar_PSATL*max((pow(Inv_L,modelPar_PSATLEXP)-pow(Inv_Llong,modelPar_PSATLEXP)),static_cast<double>(0))))),static_cast<double>(0.25));
    }
    instanceVar_T0 = (1.0+(modelPar_PTWGL*max((pow(Inv_L,modelPar_PTWGLEXP)-pow(Inv_Llong,modelPar_PTWGLEXP)),static_cast<double>(0))));
    instanceVar_PTWG_i = (instanceVar_PTWG_i*instanceVar_T0);
    if ((modelPar_ASYMMOD!=0))
    {
      instanceVar_PTWGR_i = (instanceVar_PTWGR_i*instanceVar_T0);
    }
    instanceVar_ALPHA0_i = (instanceVar_ALPHA0_i*(1.0+(modelPar_ALPHA0L*max((pow(Inv_L,modelPar_ALPHA0LEXP)-pow(Inv_Llong,modelPar_ALPHA0LEXP)),static_cast<double>(0)))));
    instanceVar_AGIDL_i = (instanceVar_AGIDL_i*((1.0+(modelPar_AGIDLL*Inv_L))+(modelPar_AGIDLW*Inv_W)));
    instanceVar_AGISL_i = (instanceVar_AGISL_i*((1.0+(modelPar_AGISLL*Inv_L))+(modelPar_AGISLW*Inv_W)));
    instanceVar_AIGC_i = (instanceVar_AIGC_i*((1.0+(modelPar_AIGCL*Inv_L))+(modelPar_AIGCW*Inv_W)));
    instanceVar_AIGS_i = (instanceVar_AIGS_i*((1.0+(modelPar_AIGSL*Inv_L))+(modelPar_AIGSW*Inv_W)));
    instanceVar_AIGD_i = (instanceVar_AIGD_i*((1.0+(modelPar_AIGDL*Inv_L))+(modelPar_AIGDW*Inv_W)));
    instanceVar_PIGCD_i = (modelPar_PIGCD*(1.0+(modelPar_PIGCDL*Inv_L)));
    instanceVar_T0 = ((modelPar_NDEPCVL1*max((pow(Inv_Lact,modelPar_NDEPCVLEXP1)-pow(Inv_Llong,modelPar_NDEPCVLEXP1)),static_cast<double>(0)))+(modelPar_NDEPCVL2*max((pow(Inv_Lact,modelPar_NDEPCVLEXP2)-pow(Inv_Llong,modelPar_NDEPCVLEXP2)),static_cast<double>(0))));
    instanceVar_T1 = ((modelPar_NDEPCVW*max((pow(Inv_Wact,modelPar_NDEPCVWEXP)-pow(Inv_Wwide,modelPar_NDEPCVWEXP)),static_cast<double>(0)))+(modelPar_NDEPCVWL*pow((Inv_Wact*Inv_Lact),modelPar_NDEPCVWLEXP)));
    instanceVar_NDEPCV_i = (instanceVar_NDEPCV_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_T0 = (modelPar_VFBCVL*max((pow(Inv_Lact,modelPar_VFBCVLEXP)-pow(Inv_Llong,modelPar_VFBCVLEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_VFBCVW*max((pow(Inv_Wact,modelPar_VFBCVWEXP)-pow(Inv_Wwide,modelPar_VFBCVWEXP)),static_cast<double>(0)))+(modelPar_VFBCVWL*pow(Inv_WL,modelPar_VFBCVWLEXP)));
    instanceVar_VFBCV_i = (instanceVar_VFBCV_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_T0 = (modelPar_VSATCVL*max((pow(Inv_Lact,modelPar_VSATCVLEXP)-pow(Inv_Llong,modelPar_VSATCVLEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_VSATCVW*max((pow(Inv_W,modelPar_VSATCVWEXP)-pow(Inv_Wwide,modelPar_VSATCVWEXP)),static_cast<double>(0)))+(modelPar_VSATCVWL*pow(Inv_WL,modelPar_VSATCVWLEXP)));
    instanceVar_VSATCV_i = (instanceVar_VSATCV_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_PCLMCV_i = (instanceVar_PCLMCV_i*(1.0+(modelPar_PCLMCVL*max((pow(Inv_Lact,modelPar_PCLMCVLEXP)-pow(Inv_Llong,modelPar_PCLMCVLEXP)),static_cast<double>(0)))));
    instanceVar_PCLMCV_i = max(instanceVar_PCLMCV_i,static_cast<double>(0));
    instanceVar_T0 = (modelPar_K1L*max((pow(Inv_L,modelPar_K1LEXP)-pow(Inv_Llong,modelPar_K1LEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_K1W*max((pow(Inv_W,modelPar_K1WEXP)-pow(Inv_Wwide,modelPar_K1WEXP)),static_cast<double>(0)))+(modelPar_K1WL*pow(Inv_WL,modelPar_K1WLEXP)));
    instanceVar_K1_i = (instanceVar_K1_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_T0 = (modelPar_K2L*max((pow(Inv_L,modelPar_K2LEXP)-pow(Inv_Llong,modelPar_K2LEXP)),static_cast<double>(0)));
    instanceVar_T1 = ((modelPar_K2W*max((pow(Inv_W,modelPar_K2WEXP)-pow(Inv_Wwide,modelPar_K2WEXP)),static_cast<double>(0)))+(modelPar_K2WL*pow(Inv_WL,modelPar_K2WLEXP)));
    instanceVar_K2_i = (instanceVar_K2_i*((1.0+instanceVar_T0)+instanceVar_T1));
    instanceVar_PRWB_i = (instanceVar_PRWB_i*(1.0+(modelPar_PRWBL*max((pow(Inv_L,modelPar_PRWBLEXP)-pow(Inv_Llong,modelPar_PRWBLEXP)),static_cast<double>(0)))));
    instanceVar_UTE_i = (instanceVar_UTE_i*(1.0+(Inv_L*modelPar_UTEL)));
    instanceVar_UA1_i = (instanceVar_UA1_i*(1.0+(Inv_L*modelPar_UA1L)));
    instanceVar_UD1_i = (instanceVar_UD1_i*(1.0+(Inv_L*modelPar_UD1L)));
    instanceVar_AT_i = (instanceVar_AT_i*(1.0+(Inv_L*modelPar_ATL)));
    instanceVar_PTWGT_i = (instanceVar_PTWGT_i*(1.0+(Inv_L*modelPar_PTWGTL)));
    if ((modelPar_RDSMOD==1))
    {
      instanceVar_RSW_i = (instanceVar_RSW_i*(1.0+(modelPar_RSWL*max((pow(Inv_L,modelPar_RSWLEXP)-pow(Inv_Llong,modelPar_RSWLEXP)),static_cast<double>(0)))));
      instanceVar_RDW_i = (instanceVar_RDW_i*(1.0+(modelPar_RDWL*max((pow(Inv_L,modelPar_RDWLEXP)-pow(Inv_Llong,modelPar_RDWLEXP)),static_cast<double>(0)))));
    }
    else
    {
      instanceVar_RDSW_i = (instanceVar_RDSW_i*(1.0+(modelPar_RDSWL*max((pow(Inv_L,modelPar_RDSWLEXP)-pow(Inv_Llong,modelPar_RDSWLEXP)),static_cast<double>(0)))));
    }
    if ((instanceVar_UCS_i<1.0))
    {
      instanceVar_UCS_i = 1.0;
    }
    else
    {
      if ((instanceVar_UCS_i>2.0))
      {
        instanceVar_UCS_i = 2.0;
      }
    }
    if ((modelPar_ASYMMOD!=0))
    {
      if ((instanceVar_UCSR_i<1.0))
      {
        instanceVar_UCSR_i = 1.0;
      }
      else
      {
        if ((instanceVar_UCSR_i>2.0))
        {
          instanceVar_UCSR_i = 2.0;
        }
      }
      if ((instanceVar_UCR_i<0))
      {
        std::cerr  << "Fatal: UCR_i = %e is negative." << instanceVar_UCR_i <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((instanceVar_CGIDL_i<0))
    {
      std::cerr  << "Fatal: CGIDL_i = %e is negative." << instanceVar_CGIDL_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_CGISL_i<0))
    {
      std::cerr  << "Fatal: CGISL_i = %e is negative." << instanceVar_CGISL_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_CKAPPAD_i<=0))
    {
      std::cerr  << "Fatal: CKAPPAD_i = %e is non-positive." << instanceVar_CKAPPAD_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_CKAPPAS_i<=0))
    {
      std::cerr  << "Fatal: CKAPPAS_i = %e is non-positive." << instanceVar_CKAPPAS_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_PDITS_i<0))
    {
      std::cerr  << "Fatal: PDITS_i = %e is negative." << instanceVar_PDITS_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_CIT_i<0))
    {
      std::cerr  << "Fatal: CIT_i = %e is negative." << instanceVar_CIT_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_NFACTOR_i<0))
    {
      std::cerr  << "Fatal: NFACTOR_i = %e is negative." << instanceVar_NFACTOR_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_K1_i<0))
    {
      std::cerr  << "Fatal: K1_i = %e is positive." << instanceVar_K1_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_NSD_i<=0))
    {
      std::cerr  << "Fatal: NSD_i = %e is non-positive." << instanceVar_NSD_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_NDEP_i<=0))
    {
      std::cerr  << "Fatal: NDEP_i = %e is non-positive." << instanceVar_NDEP_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((instanceVar_NDEPCV_i<=0))
    {
      std::cerr  << "Fatal: NDEPCV_i = %e is non-positive." << instanceVar_NDEPCV_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((modelPar_IGBMOD!=0))
    {
      if ((instanceVar_NIGBINV_i<=0))
      {
        std::cerr  << "Fatal: NIGBINV_i = %e is non-positive." << instanceVar_NIGBINV_i <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
      if ((instanceVar_NIGBACC_i<=0))
      {
        std::cerr  << "Fatal: NIGBACC_i = %e is non-positive." << instanceVar_NIGBACC_i <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((modelPar_IGCMOD!=0))
    {
      if ((POXEDGE_i<=0))
      {
        std::cerr  << "Fatal: POXEDGE_i = %e is non-positive." << POXEDGE_i <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
    }
    if ((instanceVar_CDSCD_i<0))
    {
      std::cerr  << "Fatal: CDSCD_i = %e is negative." << instanceVar_CDSCD_i <<  std::endl; 
      UserError(theInstance) << "$finish called." << std::endl; 
    }
    if ((modelPar_ASYMMOD!=0))
    {
      if ((instanceVar_CDSCDR_i<0))
      {
        std::cerr  << "Fatal: CDSCDR_i = %e is negative." << instanceVar_CDSCDR_i <<  std::endl; 
        UserError(theInstance) << "$finish called." << std::endl; 
      }
    }
    instanceVar_nuEndD = 0;
    instanceVar_nuEndS = 0;
    instanceVar_nuIntD = 0;
    instanceVar_nuIntS = 0;
    Rend = 0;
    Rint = 0;
    instanceVar_DMCGeff = (modelPar_DMCG-modelPar_DMCGT);
    instanceVar_DMCIeff = modelPar_DMCI;
    instanceVar_DMDGeff = (modelPar_DMDG-modelPar_DMCGT);
    if ((modelPar_RSH>0))
    {
      if (((!instancePar_given_NRD)&&(instancePar_RGEOMOD!=0)))
      {
        if ((instancePar_GEOMOD<9))
        {
          if (((instancePar_NF%2)!=0))
          {
            instanceVar_nuEndD = 1.0;
            instanceVar_nuEndS = 1.0;
            instanceVar_nuIntD = (2.0*std::max(((instancePar_NF-1.0)/2.0),static_cast<double>(0.0)));
            instanceVar_nuIntS = instanceVar_nuIntD;
          }
          else
          {
            if ((instancePar_MINZ==1))
            {
              instanceVar_nuEndD = 2.0;
              instanceVar_nuIntD = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
              instanceVar_nuEndS = 0.0;
              instanceVar_nuIntS = instancePar_NF;
            }
            else
            {
              instanceVar_nuEndD = 0.0;
              instanceVar_nuIntD = instancePar_NF;
              instanceVar_nuEndS = 2.0;
              instanceVar_nuIntS = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
            }
          }
          if ((0==1))
          {
            if ((instanceVar_nuIntS==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntS));
            }
          }
          else
          {
            if ((instanceVar_nuIntD==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntD));
            }
          }
        }
        if ( instancePar_GEOMOD == (0))
        {
          if ((0==1))
          {
            if ((1==1))
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
              {
                if ((instanceVar_nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                }
              }
              else
                if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
              {
                if ((instanceVar_nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                }
              }
              else
                if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
          else
          {
            if ((0==1))
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
              {
                if ((instanceVar_nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                }
              }
              else
                if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
              {
                if ((instanceVar_nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                }
              }
              else
                if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
        }
        else
          if ( instancePar_GEOMOD == (1))
          {
            if ((0==1))
            {
              if ((1==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if ((instanceVar_DMCGeff==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if ((instanceVar_DMCGeff==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( instancePar_GEOMOD == (2))
            {
              if ((0==1))
              {
                if ((1==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( instancePar_GEOMOD == (3))
              {
                if ((0==1))
                {
                  if ((1==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( instancePar_GEOMOD == (4))
                {
                  if ((0==1))
                  {
                    if ((1==1))
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                        {
                          if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                        {
                          if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                  }
                }
                else
                  if ( instancePar_GEOMOD == (5))
                  {
                    if ((0==1))
                    {
                      if ((1==1))
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                          {
                            if ((instanceVar_DMCGeff==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                          {
                            if ((instanceVar_DMCGeff==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      if ((instanceVar_nuEndD==0))
                      {
                        Rend = 0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                  }
                  else
                    if ( instancePar_GEOMOD == (6))
                    {
                      if ((0==1))
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                      }
                      else
                      {
                        if ((0==1))
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                          {
                            if ((instanceVar_nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                            {
                              if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                              {
                              }
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                          {
                            if ((instanceVar_nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                            {
                              if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                              {
                              }
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                    }
                    else
                      if ( instancePar_GEOMOD == (7))
                      {
                        if ((0==1))
                        {
                          if ((instanceVar_nuEndS==0))
                          {
                            Rend = 0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                              {
                                if ((instanceVar_DMCGeff==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                              {
                                if ((instanceVar_DMCGeff==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( instancePar_GEOMOD == (8))
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                        }
                        else
                          if ( instancePar_GEOMOD == (9))
                          {
                            if ((0==1))
                            {
                              Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                              if ((instancePar_NF==2.0))
                              {
                                Rint = 0.0;
                              }
                              else
                              {
                                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                              Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                            }
                          }
                          else
                            if ( instancePar_GEOMOD == (10))
                            {
                              if ((0==1))
                              {
                                Rend = 0.0;
                                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                              }
                              else
                              {
                                Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                                if ((instancePar_NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                                }
                              }
                            }
                            else
                            {
                              Rint = 0.0;
                            }
        if ((Rint<=0.0))
        {
          Rtot = Rend;
        }
        else
        {
          if ((Rend<=0.0))
          {
            Rtot = Rint;
          }
          else
          {
            Rtot = ((Rint*Rend)/(Rint+Rend));
          }
        }
        if ((Rtot==0.0))
        {
        }
      }
    }
    if ((modelPar_RSH>0))
    {
      if (((!instancePar_given_NRS)&&(instancePar_RGEOMOD!=0)))
      {
        if ((instancePar_GEOMOD<9))
        {
          if (((instancePar_NF%2)!=0))
          {
            instanceVar_nuEndD = 1.0;
            instanceVar_nuEndS = 1.0;
            instanceVar_nuIntD = (2.0*std::max(((instancePar_NF-1.0)/2.0),static_cast<double>(0.0)));
            instanceVar_nuIntS = instanceVar_nuIntD;
          }
          else
          {
            if ((instancePar_MINZ==1))
            {
              instanceVar_nuEndD = 2.0;
              instanceVar_nuIntD = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
              instanceVar_nuEndS = 0.0;
              instanceVar_nuIntS = instancePar_NF;
            }
            else
            {
              instanceVar_nuEndD = 0.0;
              instanceVar_nuIntD = instancePar_NF;
              instanceVar_nuEndS = 2.0;
              instanceVar_nuIntS = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
            }
          }
          if ((1==1))
          {
            if ((instanceVar_nuIntS==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntS));
            }
          }
          else
          {
            if ((instanceVar_nuIntD==0.0))
            {
              Rint = 0.0;
            }
            else
            {
              Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntD));
            }
          }
        }
        if ( instancePar_GEOMOD == (0))
        {
          if ((1==1))
          {
            if ((1==1))
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
              {
                if ((instanceVar_nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                }
              }
              else
                if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
              {
                if ((instanceVar_nuEndS==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                }
              }
              else
                if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
          else
          {
            if ((0==1))
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
              {
                if ((instanceVar_nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                }
              }
              else
                if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
            else
            {
              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
              {
                if ((instanceVar_nuEndD==0.0))
                {
                  Rend = 0.0;
                }
                else
                {
                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                }
              }
              else
                if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                {
                  if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                  {
                  }
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                  }
                }
                else
                {
                  Rend = 0.0;
                }
            }
          }
        }
        else
          if ( instancePar_GEOMOD == (1))
          {
            if ((1==1))
            {
              if ((1==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if ((instanceVar_DMCGeff==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if ((instanceVar_DMCGeff==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( instancePar_GEOMOD == (2))
            {
              if ((1==1))
              {
                if ((1==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( instancePar_GEOMOD == (3))
              {
                if ((1==1))
                {
                  if ((1==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( instancePar_GEOMOD == (4))
                {
                  if ((1==1))
                  {
                    if ((1==1))
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                        {
                          if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                        {
                          if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                  }
                }
                else
                  if ( instancePar_GEOMOD == (5))
                  {
                    if ((1==1))
                    {
                      if ((1==1))
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                          {
                            if ((instanceVar_DMCGeff==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                          {
                            if ((instanceVar_DMCGeff==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      if ((instanceVar_nuEndD==0))
                      {
                        Rend = 0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                  }
                  else
                    if ( instancePar_GEOMOD == (6))
                    {
                      if ((1==1))
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                      }
                      else
                      {
                        if ((0==1))
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                          {
                            if ((instanceVar_nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                            {
                              if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                              {
                              }
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                          {
                            if ((instanceVar_nuEndD==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                            {
                              if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                              {
                              }
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                    }
                    else
                      if ( instancePar_GEOMOD == (7))
                      {
                        if ((1==1))
                        {
                          if ((instanceVar_nuEndS==0))
                          {
                            Rend = 0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                              {
                                if ((instanceVar_DMCGeff==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                              {
                                if ((instanceVar_DMCGeff==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( instancePar_GEOMOD == (8))
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                        }
                        else
                          if ( instancePar_GEOMOD == (9))
                          {
                            if ((1==1))
                            {
                              Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                              if ((instancePar_NF==2.0))
                              {
                                Rint = 0.0;
                              }
                              else
                              {
                                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                              Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                            }
                          }
                          else
                            if ( instancePar_GEOMOD == (10))
                            {
                              if ((1==1))
                              {
                                Rend = 0.0;
                                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                              }
                              else
                              {
                                Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                                if ((instancePar_NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                                }
                              }
                            }
                            else
                            {
                              Rint = 0.0;
                            }
        if ((Rint<=0.0))
        {
          Rtot = Rend;
        }
        else
        {
          if ((Rend<=0.0))
          {
            Rtot = Rint;
          }
          else
          {
            Rtot = ((Rint*Rend)/(Rint+Rend));
          }
        }
        if ((Rtot==0.0))
        {
        }
      }
    }
    if (instancePar_given_NRS)
    {
      instanceVar_RSourceGeo = (modelPar_RSH*instancePar_NRS);
    }
    else
    {
      if ((instancePar_RGEOMOD>0))
      {
        {
          if ((instancePar_GEOMOD<9))
          {
            if (((instancePar_NF%2)!=0))
            {
              instanceVar_nuEndD = 1.0;
              instanceVar_nuEndS = 1.0;
              instanceVar_nuIntD = (2.0*std::max(((instancePar_NF-1.0)/2.0),static_cast<double>(0.0)));
              instanceVar_nuIntS = instanceVar_nuIntD;
            }
            else
            {
              if ((instancePar_MINZ==1))
              {
                instanceVar_nuEndD = 2.0;
                instanceVar_nuIntD = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
                instanceVar_nuEndS = 0.0;
                instanceVar_nuIntS = instancePar_NF;
              }
              else
              {
                instanceVar_nuEndD = 0.0;
                instanceVar_nuIntD = instancePar_NF;
                instanceVar_nuEndS = 2.0;
                instanceVar_nuIntS = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
              }
            }
            if ((1==1))
            {
              if ((instanceVar_nuIntS==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntS));
              }
            }
            else
            {
              if ((instanceVar_nuIntD==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntD));
              }
            }
          }
          if ( instancePar_GEOMOD == (0))
          {
            if ((1==1))
            {
              if ((1==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( instancePar_GEOMOD == (1))
            {
              if ((1==1))
              {
                if ((1==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( instancePar_GEOMOD == (2))
              {
                if ((1==1))
                {
                  if ((1==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( instancePar_GEOMOD == (3))
                {
                  if ((1==1))
                  {
                    if ((1==1))
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    if ((0==1))
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                      {
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                      {
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                }
                else
                  if ( instancePar_GEOMOD == (4))
                  {
                    if ((1==1))
                    {
                      if ((1==1))
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                          {
                            if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                          {
                            if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                    }
                  }
                  else
                    if ( instancePar_GEOMOD == (5))
                    {
                      if ((1==1))
                      {
                        if ((1==1))
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                          {
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                            {
                              if ((instanceVar_DMCGeff==0.0))
                              {
                              }
                              if ((instanceVar_nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                          {
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                            {
                              if ((instanceVar_DMCGeff==0.0))
                              {
                              }
                              if ((instanceVar_nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                      else
                      {
                        if ((instanceVar_nuEndD==0))
                        {
                          Rend = 0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                        }
                      }
                    }
                    else
                      if ( instancePar_GEOMOD == (6))
                      {
                        if ((1==1))
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                              {
                                if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                              {
                                if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( instancePar_GEOMOD == (7))
                        {
                          if ((1==1))
                          {
                            if ((instanceVar_nuEndS==0))
                            {
                              Rend = 0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                            }
                          }
                          else
                          {
                            if ((0==1))
                            {
                              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                              {
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                                }
                              }
                              else
                                if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                                {
                                  if ((instanceVar_DMCGeff==0.0))
                                  {
                                  }
                                  if ((instanceVar_nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                            else
                            {
                              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                              {
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                                }
                              }
                              else
                                if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                                {
                                  if ((instanceVar_DMCGeff==0.0))
                                  {
                                  }
                                  if ((instanceVar_nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                          }
                        }
                        else
                          if ( instancePar_GEOMOD == (8))
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                          }
                          else
                            if ( instancePar_GEOMOD == (9))
                            {
                              if ((1==1))
                              {
                                Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                                if ((instancePar_NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                              }
                            }
                            else
                              if ( instancePar_GEOMOD == (10))
                              {
                                if ((1==1))
                                {
                                  Rend = 0.0;
                                  Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                                }
                                else
                                {
                                  Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                                  if ((instancePar_NF==2.0))
                                  {
                                    Rint = 0.0;
                                  }
                                  else
                                  {
                                    Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                                  }
                                }
                              }
                              else
                              {
                                Rint = 0.0;
                              }
          if ((Rint<=0.0))
          {
            instanceVar_RSourceGeo = Rend;
          }
          else
          {
            if ((Rend<=0.0))
            {
              instanceVar_RSourceGeo = Rint;
            }
            else
            {
              instanceVar_RSourceGeo = ((Rint*Rend)/(Rint+Rend));
            }
          }
          if ((instanceVar_RSourceGeo==0.0))
          {
          }
        }
      }
      else
      {
        instanceVar_RSourceGeo = 0.0;
      }
    }
    if (instancePar_given_NRD)
    {
      instanceVar_RDrainGeo = (modelPar_RSH*instancePar_NRD);
    }
    else
    {
      if ((instancePar_RGEOMOD>0))
      {
        {
          if ((instancePar_GEOMOD<9))
          {
            if (((instancePar_NF%2)!=0))
            {
              instanceVar_nuEndD = 1.0;
              instanceVar_nuEndS = 1.0;
              instanceVar_nuIntD = (2.0*std::max(((instancePar_NF-1.0)/2.0),static_cast<double>(0.0)));
              instanceVar_nuIntS = instanceVar_nuIntD;
            }
            else
            {
              if ((instancePar_MINZ==1))
              {
                instanceVar_nuEndD = 2.0;
                instanceVar_nuIntD = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
                instanceVar_nuEndS = 0.0;
                instanceVar_nuIntS = instancePar_NF;
              }
              else
              {
                instanceVar_nuEndD = 0.0;
                instanceVar_nuIntD = instancePar_NF;
                instanceVar_nuEndS = 2.0;
                instanceVar_nuIntS = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
              }
            }
            if ((0==1))
            {
              if ((instanceVar_nuIntS==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntS));
              }
            }
            else
            {
              if ((instanceVar_nuIntD==0.0))
              {
                Rint = 0.0;
              }
              else
              {
                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuIntD));
              }
            }
          }
          if ( instancePar_GEOMOD == (0))
          {
            if ((0==1))
            {
              if ((1==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndS==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
            else
            {
              if ((0==1))
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
              else
              {
                if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                {
                  if ((instanceVar_nuEndD==0.0))
                  {
                    Rend = 0.0;
                  }
                  else
                  {
                    Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                  }
                }
                else
                  if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                  {
                    if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                    {
                    }
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                    }
                  }
                  else
                  {
                    Rend = 0.0;
                  }
              }
            }
          }
          else
            if ( instancePar_GEOMOD == (1))
            {
              if ((0==1))
              {
                if ((1==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndS==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                      {
                      }
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
              else
              {
                if ((0==1))
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
                else
                {
                  if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                  {
                    if ((instanceVar_nuEndD==0.0))
                    {
                      Rend = 0.0;
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                    }
                  }
                  else
                    if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                    {
                      if ((instanceVar_DMCGeff==0.0))
                      {
                      }
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                      }
                    }
                    else
                    {
                      Rend = 0.0;
                    }
                }
              }
            }
            else
              if ( instancePar_GEOMOD == (2))
              {
                if ((0==1))
                {
                  if ((1==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndS==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if ((instanceVar_DMCGeff==0.0))
                        {
                        }
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
                else
                {
                  if ((0==1))
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                      {
                        if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                  else
                  {
                    if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                    {
                      if ((instanceVar_nuEndD==0.0))
                      {
                        Rend = 0.0;
                      }
                      else
                      {
                        Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                      }
                    }
                    else
                      if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                      {
                        if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                        {
                        }
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                        }
                      }
                      else
                      {
                        Rend = 0.0;
                      }
                  }
                }
              }
              else
                if ( instancePar_GEOMOD == (3))
                {
                  if ((0==1))
                  {
                    if ((1==1))
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                      {
                        if ((instanceVar_nuEndS==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                  else
                  {
                    if ((0==1))
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                      {
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                    else
                    {
                      if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                      {
                        if ((instanceVar_nuEndD==0.0))
                        {
                          Rend = 0.0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                        }
                      }
                      else
                        if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                        {
                          if ((instanceVar_DMCGeff==0.0))
                          {
                          }
                          if ((instanceVar_nuEndD==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                          }
                        }
                        else
                        {
                          Rend = 0.0;
                        }
                    }
                  }
                }
                else
                  if ( instancePar_GEOMOD == (4))
                  {
                    if ((0==1))
                    {
                      if ((1==1))
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                          {
                            if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                      else
                      {
                        if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                        {
                          if ((instanceVar_nuEndS==0.0))
                          {
                            Rend = 0.0;
                          }
                          else
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                          }
                        }
                        else
                          if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                          {
                            if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                            {
                            }
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndS)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                            }
                          }
                          else
                          {
                            Rend = 0.0;
                          }
                      }
                    }
                    else
                    {
                      Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                    }
                  }
                  else
                    if ( instancePar_GEOMOD == (5))
                    {
                      if ((0==1))
                      {
                        if ((1==1))
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                          {
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                            {
                              if ((instanceVar_DMCGeff==0.0))
                              {
                              }
                              if ((instanceVar_nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                        else
                        {
                          if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                          {
                            if ((instanceVar_nuEndS==0.0))
                            {
                              Rend = 0.0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                            }
                          }
                          else
                            if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                            {
                              if ((instanceVar_DMCGeff==0.0))
                              {
                              }
                              if ((instanceVar_nuEndS==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndS)*instanceVar_DMCGeff));
                              }
                            }
                            else
                            {
                              Rend = 0.0;
                            }
                        }
                      }
                      else
                      {
                        if ((instanceVar_nuEndD==0))
                        {
                          Rend = 0;
                        }
                        else
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                        }
                      }
                    }
                    else
                      if ( instancePar_GEOMOD == (6))
                      {
                        if ((0==1))
                        {
                          Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                        }
                        else
                        {
                          if ((0==1))
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                              {
                                if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                          else
                          {
                            if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                            {
                              if ((instanceVar_nuEndD==0.0))
                              {
                                Rend = 0.0;
                              }
                              else
                              {
                                Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                              }
                            }
                            else
                              if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                              {
                                if (((instanceVar_DMCGeff+instanceVar_DMCIeff)==0.0))
                                {
                                }
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_Weff)/((3.0*instanceVar_nuEndD)*(instanceVar_DMCGeff+instanceVar_DMCIeff)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                              }
                          }
                        }
                      }
                      else
                        if ( instancePar_GEOMOD == (7))
                        {
                          if ((0==1))
                          {
                            if ((instanceVar_nuEndS==0))
                            {
                              Rend = 0;
                            }
                            else
                            {
                              Rend = ((modelPar_RSH*instanceVar_DMDGeff)/(instanceVar_Weff*instanceVar_nuEndS));
                            }
                          }
                          else
                          {
                            if ((0==1))
                            {
                              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (5))
                              {
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                                }
                              }
                              else
                                if ( instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (6))
                                {
                                  if ((instanceVar_DMCGeff==0.0))
                                  {
                                  }
                                  if ((instanceVar_nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                            else
                            {
                              if ( instancePar_RGEOMOD == (1)||instancePar_RGEOMOD == (3)||instancePar_RGEOMOD == (7))
                              {
                                if ((instanceVar_nuEndD==0.0))
                                {
                                  Rend = 0.0;
                                }
                                else
                                {
                                  Rend = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instanceVar_nuEndD));
                                }
                              }
                              else
                                if ( instancePar_RGEOMOD == (2)||instancePar_RGEOMOD == (4)||instancePar_RGEOMOD == (8))
                                {
                                  if ((instanceVar_DMCGeff==0.0))
                                  {
                                  }
                                  if ((instanceVar_nuEndD==0.0))
                                  {
                                    Rend = 0.0;
                                  }
                                  else
                                  {
                                    Rend = ((modelPar_RSH*instanceVar_Weff)/((6.0*instanceVar_nuEndD)*instanceVar_DMCGeff));
                                  }
                                }
                                else
                                {
                                  Rend = 0.0;
                                }
                            }
                          }
                        }
                        else
                          if ( instancePar_GEOMOD == (8))
                          {
                            Rend = ((modelPar_RSH*instanceVar_DMDGeff)/instanceVar_Weff);
                          }
                          else
                            if ( instancePar_GEOMOD == (9))
                            {
                              if ((0==1))
                              {
                                Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                                if ((instancePar_NF==2.0))
                                {
                                  Rint = 0.0;
                                }
                                else
                                {
                                  Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                                }
                              }
                              else
                              {
                                Rend = 0.0;
                                Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                              }
                            }
                            else
                              if ( instancePar_GEOMOD == (10))
                              {
                                if ((0==1))
                                {
                                  Rend = 0.0;
                                  Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*instancePar_NF));
                                }
                                else
                                {
                                  Rend = (((0.5*modelPar_RSH)*instanceVar_DMCGeff)/instanceVar_Weff);
                                  if ((instancePar_NF==2.0))
                                  {
                                    Rint = 0.0;
                                  }
                                  else
                                  {
                                    Rint = ((modelPar_RSH*instanceVar_DMCGeff)/(instanceVar_Weff*(instancePar_NF-2.0)));
                                  }
                                }
                              }
                              else
                              {
                                Rint = 0.0;
                              }
          if ((Rint<=0.0))
          {
            instanceVar_RDrainGeo = Rend;
          }
          else
          {
            if ((Rend<=0.0))
            {
              instanceVar_RDrainGeo = Rint;
            }
            else
            {
              instanceVar_RDrainGeo = ((Rint*Rend)/(Rint+Rend));
            }
          }
          if ((instanceVar_RDrainGeo==0.0))
          {
          }
        }
      }
      else
      {
        instanceVar_RDrainGeo = 0.0;
      }
    }
    if ((instanceVar_RSourceGeo<=1.0e-3))
    {
      instanceVar_RSourceGeo = 1.0e-3;
    }
    if ((instanceVar_RDrainGeo<=1.0e-3))
    {
      instanceVar_RDrainGeo = 1.0e-3;
    }
    if ((modelPar_RDSMOD==1))
    {
      if ((instanceVar_RSWMIN_i<=0))
      {
        instanceVar_RSWMIN_i = 0;
      }
      if ((instanceVar_RDWMIN_i<=0))
      {
        instanceVar_RDWMIN_i = 0;
      }
      if ((instanceVar_RSW_i<=0))
      {
        instanceVar_RSW_i = 0;
      }
      if ((instanceVar_RDW_i<=0))
      {
        instanceVar_RDW_i = 0;
      }
    }
    else
    {
      if ((instanceVar_RDSWMIN_i<=0))
      {
        instanceVar_RDSWMIN_i = 0;
      }
      if ((instanceVar_RDSW_i<=0))
      {
        instanceVar_RDSW_i = 0;
      }
    }
    instanceVar_Grbsb = 0.0;
    instanceVar_Grbdb = 0.0;
    instanceVar_Grbpb = 0.0;
    instanceVar_Grbps = 0.0;
    instanceVar_Grbpd = 0.0;
    if ((instancePar_RBODYMOD!=0))
    {
      Lnl = log((instanceVar_Leff*1.0e6));
      Lnw = log((instanceVar_Weff*1.0e6));
      Lnnf = log(static_cast<double>(instancePar_NF));
      Bodymode = 5;
      Rbpb = instancePar_RBPB;
      Rbpd = instancePar_RBPD;
      Rbps = instancePar_RBPS;
      Rbdb = instancePar_RBDB;
      Rbsb = instancePar_RBSB;
      if (((!modelPar_given_RBPS0)||(!modelPar_given_RBPD0)))
      {
        Bodymode = 1;
      }
      else
      {
        if ((((!modelPar_given_RBSBX0)&&(!modelPar_given_RBSBY0))||((!modelPar_given_RBDBX0)&&(!modelPar_given_RBDBY0))))
        {
          Bodymode = 3;
        }
      }
      if ((instancePar_RBODYMOD==2))
      {
        if ((Bodymode==5))
        {
          Rbsbx = (modelPar_RBSBX0*exp((((modelPar_RBSDBXL*Lnl)+(modelPar_RBSDBXW*Lnw))+(modelPar_RBSDBXNF*Lnnf))));
          Rbsby = (modelPar_RBSBY0*exp((((modelPar_RBSDBYL*Lnl)+(modelPar_RBSDBYW*Lnw))+(modelPar_RBSDBYNF*Lnnf))));
          Rbsb = ((Rbsbx*Rbsby)/(Rbsbx+Rbsby));
          Rbdbx = (modelPar_RBDBX0*exp((((modelPar_RBSDBXL*Lnl)+(modelPar_RBSDBXW*Lnw))+(modelPar_RBSDBXNF*Lnnf))));
          Rbdby = (modelPar_RBDBY0*exp((((modelPar_RBSDBYL*Lnl)+(modelPar_RBSDBYW*Lnw))+(modelPar_RBSDBYNF*Lnnf))));
          Rbdb = ((Rbdbx*Rbdby)/(Rbdbx+Rbdby));
        }
        if (((Bodymode==3)||(Bodymode==5)))
        {
          Rbps = (modelPar_RBPS0*exp((((modelPar_RBPSL*Lnl)+(modelPar_RBPSW*Lnw))+(modelPar_RBPSNF*Lnnf))));
          Rbpd = (modelPar_RBPD0*exp((((modelPar_RBPDL*Lnl)+(modelPar_RBPDW*Lnw))+(modelPar_RBPDNF*Lnnf))));
        }
        Rbpbx = (modelPar_RBPBX0*exp((((modelPar_RBPBXL*Lnl)+(modelPar_RBPBXW*Lnw))+(modelPar_RBPBXNF*Lnnf))));
        Rbpby = (modelPar_RBPBY0*exp((((modelPar_RBPBYL*Lnl)+(modelPar_RBPBYW*Lnw))+(modelPar_RBPBYNF*Lnnf))));
        Rbpb = ((Rbpbx*Rbpby)/(Rbpbx+Rbpby));
      }
      if (((instancePar_RBODYMOD==1)||((instancePar_RBODYMOD==2)&&(Bodymode==5))))
      {
        if ((Rbdb<1.0e-3))
        {
          instanceVar_Grbdb = 1.0e3;
        }
        else
        {
          instanceVar_Grbdb = (modelPar_GBMIN+(1.0/Rbdb));
        }
        if ((Rbpb<1.0e-3))
        {
          instanceVar_Grbpb = 1.0e3;
        }
        else
        {
          instanceVar_Grbpb = (modelPar_GBMIN+(1.0/Rbpb));
        }
        if ((Rbps<1.0e-3))
        {
          instanceVar_Grbps = 1.0e3;
        }
        else
        {
          instanceVar_Grbps = (modelPar_GBMIN+(1.0/Rbps));
        }
        if ((Rbsb<1.0e-3))
        {
          instanceVar_Grbsb = 1.0e3;
        }
        else
        {
          instanceVar_Grbsb = (modelPar_GBMIN+(1.0/Rbsb));
        }
        if ((Rbpd<1.0e-3))
        {
          instanceVar_Grbpd = 1.0e3;
        }
        else
        {
          instanceVar_Grbpd = (modelPar_GBMIN+(1.0/Rbpd));
        }
      }
      else
      {
        if (((instancePar_RBODYMOD==2)&&(Bodymode==3)))
        {
          instanceVar_Grbdb = modelPar_GBMIN;
          instanceVar_Grbsb = modelPar_GBMIN;
          if ((Rbpb<1.0e-3))
          {
            instanceVar_Grbpb = 1.0e3;
          }
          else
          {
            instanceVar_Grbpb = (modelPar_GBMIN+(1.0/Rbpb));
          }
          if ((Rbps<1.0e-3))
          {
            instanceVar_Grbps = 1.0e3;
          }
          else
          {
            instanceVar_Grbps = (modelPar_GBMIN+(1.0/Rbps));
          }
          if ((Rbpd<1.0e-3))
          {
            instanceVar_Grbpd = 1.0e3;
          }
          else
          {
            instanceVar_Grbpd = (modelPar_GBMIN+(1.0/Rbpd));
          }
        }
        else
        {
          if (((instancePar_RBODYMOD==2)&&(Bodymode==1)))
          {
            instanceVar_Grbdb = modelPar_GBMIN;
            instanceVar_Grbsb = modelPar_GBMIN;
            instanceVar_Grbps = 1.0e3;
            instanceVar_Grbpd = 1.0e3;
            if ((Rbpb<1.0e-3))
            {
              instanceVar_Grbpb = 1.0e3;
            }
            else
            {
              instanceVar_Grbpb = (modelPar_GBMIN+(1.0/Rbpb));
            }
          }
        }
      }
    }
    instanceVar_Grgeltd = ((modelPar_RSHG*(instancePar_XGW+((instanceVar_Weffcj/3.0)/instancePar_NGCON)))/((instancePar_NGCON*instancePar_NF)*(instanceVar_Lnew-modelPar_XGL)));
    if ((instanceVar_Grgeltd>0.0))
    {
      instanceVar_Grgeltd = (1.0/instanceVar_Grgeltd);
    }
    else
    {
      instanceVar_Grgeltd = 1.0e3;
      if ((instancePar_RGATEMOD!=0))
      {
      }
    }
    instanceVar_T0 = (modelPar_TOXE*modelPar_TOXE);
    instanceVar_T1 = (modelPar_TOXE*POXEDGE_i);
    instanceVar_T2 = (instanceVar_T1*instanceVar_T1);
    instanceVar_ToxRatio = (exp((NTOX_i*log((modelPar_TOXREF/modelPar_TOXE))))/instanceVar_T0);
    ToxRatioEdge = (exp((NTOX_i*log((modelPar_TOXREF/instanceVar_T1))))/instanceVar_T2);
    instanceVar_Aechvb = ((modelPar_TYPE==1)?4.97232e-7:3.42537e-7);
    instanceVar_Bechvb = ((modelPar_TYPE==1)?7.45669e11:1.16645e12);
    instanceVar_AechvbEdge = ((instanceVar_Aechvb*instanceVar_Weff)*ToxRatioEdge);
    instanceVar_BechvbEdge = (((-instanceVar_Bechvb)*modelPar_TOXE)*POXEDGE_i);
    instanceVar_Aechvb = (instanceVar_Aechvb*((instanceVar_Weff*instanceVar_Leff)*instanceVar_ToxRatio));
    instanceVar_Bechvb = (instanceVar_Bechvb*(-modelPar_TOXE));
    if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0)))
    {
      instanceVar_gth = (((modelPar_WTH0+instanceVar_Weff)*instancePar_NF)/modelPar_RTH0);
      instanceVar_cth = ((modelPar_CTH0*(modelPar_WTH0+instanceVar_Weff))*instancePar_NF);
    }
    else
    {
      instanceVar_gth = 1.0;
      instanceVar_cth = 0.0;
    }
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_VFBSDOFF,
   bool modelPar_given_VFBSDOFF,
   AdmsSensFadType & modelPar_XGW,
   bool modelPar_given_XGW,
   AdmsSensFadType & modelPar_RBPB,
   bool modelPar_given_RBPB,
   AdmsSensFadType & modelPar_RBPD,
   bool modelPar_given_RBPD,
   AdmsSensFadType & modelPar_RBPS,
   bool modelPar_given_RBPS,
   AdmsSensFadType & modelPar_RBDB,
   bool modelPar_given_RBDB,
   AdmsSensFadType & modelPar_RBSB,
   bool modelPar_given_RBSB,
   AdmsSensFadType & modelPar_SA,
   bool modelPar_given_SA,
   AdmsSensFadType & modelPar_SB,
   bool modelPar_given_SB,
   AdmsSensFadType & modelPar_SD,
   bool modelPar_given_SD,
   AdmsSensFadType & modelPar_LLONG,
   bool modelPar_given_LLONG,
   AdmsSensFadType & modelPar_LMLT,
   bool modelPar_given_LMLT,
   AdmsSensFadType & modelPar_WMLT,
   bool modelPar_given_WMLT,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_WWIDE,
   bool modelPar_given_WWIDE,
   AdmsSensFadType & modelPar_XW,
   bool modelPar_given_XW,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LW,
   bool modelPar_given_LW,
   AdmsSensFadType & modelPar_LWL,
   bool modelPar_given_LWL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_LWN,
   bool modelPar_given_LWN,
   AdmsSensFadType & modelPar_WINT,
   bool modelPar_given_WINT,
   AdmsSensFadType & modelPar_WL,
   bool modelPar_given_WL,
   AdmsSensFadType & modelPar_WW,
   bool modelPar_given_WW,
   AdmsSensFadType & modelPar_WWL,
   bool modelPar_given_WWL,
   AdmsSensFadType & modelPar_WLN,
   bool modelPar_given_WLN,
   AdmsSensFadType & modelPar_WWN,
   bool modelPar_given_WWN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_LWC,
   bool modelPar_given_LWC,
   AdmsSensFadType & modelPar_LWLC,
   bool modelPar_given_LWLC,
   AdmsSensFadType & modelPar_DWC,
   bool modelPar_given_DWC,
   AdmsSensFadType & modelPar_WLC,
   bool modelPar_given_WLC,
   AdmsSensFadType & modelPar_WWC,
   bool modelPar_given_WWC,
   AdmsSensFadType & modelPar_WWLC,
   bool modelPar_given_WWLC,
   AdmsSensFadType & modelPar_TOXE,
   bool modelPar_given_TOXE,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_DTOX,
   bool modelPar_given_DTOX,
   AdmsSensFadType & modelPar_NDEP,
   bool modelPar_given_NDEP,
   AdmsSensFadType & modelPar_NDEPL1,
   bool modelPar_given_NDEPL1,
   AdmsSensFadType & modelPar_NDEPLEXP1,
   bool modelPar_given_NDEPLEXP1,
   AdmsSensFadType & modelPar_NDEPL2,
   bool modelPar_given_NDEPL2,
   AdmsSensFadType & modelPar_NDEPLEXP2,
   bool modelPar_given_NDEPLEXP2,
   AdmsSensFadType & modelPar_NDEPW,
   bool modelPar_given_NDEPW,
   AdmsSensFadType & modelPar_NDEPWEXP,
   bool modelPar_given_NDEPWEXP,
   AdmsSensFadType & modelPar_NDEPWL,
   bool modelPar_given_NDEPWL,
   AdmsSensFadType & modelPar_NDEPWLEXP,
   bool modelPar_given_NDEPWLEXP,
   AdmsSensFadType & modelPar_LNDEP,
   bool modelPar_given_LNDEP,
   AdmsSensFadType & modelPar_WNDEP,
   bool modelPar_given_WNDEP,
   AdmsSensFadType & modelPar_PNDEP,
   bool modelPar_given_PNDEP,
   AdmsSensFadType & modelPar_NDEPCV,
   bool modelPar_given_NDEPCV,
   AdmsSensFadType & modelPar_NDEPCVL1,
   bool modelPar_given_NDEPCVL1,
   AdmsSensFadType & modelPar_NDEPCVLEXP1,
   bool modelPar_given_NDEPCVLEXP1,
   AdmsSensFadType & modelPar_NDEPCVL2,
   bool modelPar_given_NDEPCVL2,
   AdmsSensFadType & modelPar_NDEPCVLEXP2,
   bool modelPar_given_NDEPCVLEXP2,
   AdmsSensFadType & modelPar_NDEPCVW,
   bool modelPar_given_NDEPCVW,
   AdmsSensFadType & modelPar_NDEPCVWEXP,
   bool modelPar_given_NDEPCVWEXP,
   AdmsSensFadType & modelPar_NDEPCVWL,
   bool modelPar_given_NDEPCVWL,
   AdmsSensFadType & modelPar_NDEPCVWLEXP,
   bool modelPar_given_NDEPCVWLEXP,
   AdmsSensFadType & modelPar_LNDEPCV,
   bool modelPar_given_LNDEPCV,
   AdmsSensFadType & modelPar_WNDEPCV,
   bool modelPar_given_WNDEPCV,
   AdmsSensFadType & modelPar_PNDEPCV,
   bool modelPar_given_PNDEPCV,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_WNGATE,
   bool modelPar_given_WNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_XJ,
   bool modelPar_given_XJ,
   AdmsSensFadType & modelPar_LXJ,
   bool modelPar_given_LXJ,
   AdmsSensFadType & modelPar_WXJ,
   bool modelPar_given_WXJ,
   AdmsSensFadType & modelPar_PXJ,
   bool modelPar_given_PXJ,
   AdmsSensFadType & modelPar_LVFB,
   bool modelPar_given_LVFB,
   AdmsSensFadType & modelPar_WVFB,
   bool modelPar_given_WVFB,
   AdmsSensFadType & modelPar_PVFB,
   bool modelPar_given_PVFB,
   AdmsSensFadType & modelPar_VFB,
   bool modelPar_given_VFB,
   AdmsSensFadType & modelPar_VFBCV,
   bool modelPar_given_VFBCV,
   AdmsSensFadType & modelPar_LVFBCV,
   bool modelPar_given_LVFBCV,
   AdmsSensFadType & modelPar_WVFBCV,
   bool modelPar_given_WVFBCV,
   AdmsSensFadType & modelPar_PVFBCV,
   bool modelPar_given_PVFBCV,
   AdmsSensFadType & modelPar_VFBCVL,
   bool modelPar_given_VFBCVL,
   AdmsSensFadType & modelPar_VFBCVLEXP,
   bool modelPar_given_VFBCVLEXP,
   AdmsSensFadType & modelPar_VFBCVW,
   bool modelPar_given_VFBCVW,
   AdmsSensFadType & modelPar_VFBCVWEXP,
   bool modelPar_given_VFBCVWEXP,
   AdmsSensFadType & modelPar_VFBCVWL,
   bool modelPar_given_VFBCVWL,
   AdmsSensFadType & modelPar_VFBCVWLEXP,
   bool modelPar_given_VFBCVWLEXP,
   AdmsSensFadType & modelPar_DWJ,
   bool modelPar_given_DWJ,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_LNSD,
   bool modelPar_given_LNSD,
   AdmsSensFadType & modelPar_WNSD,
   bool modelPar_given_WNSD,
   AdmsSensFadType & modelPar_PNSD,
   bool modelPar_given_PNSD,
   AdmsSensFadType & modelPar_DELVT0,
   bool modelPar_given_DELVT0,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_LDVTP0,
   bool modelPar_given_LDVTP0,
   AdmsSensFadType & modelPar_WDVTP0,
   bool modelPar_given_WDVTP0,
   AdmsSensFadType & modelPar_PDVTP0,
   bool modelPar_given_PDVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_LDVTP1,
   bool modelPar_given_LDVTP1,
   AdmsSensFadType & modelPar_WDVTP1,
   bool modelPar_given_WDVTP1,
   AdmsSensFadType & modelPar_PDVTP1,
   bool modelPar_given_PDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_LDVTP2,
   bool modelPar_given_LDVTP2,
   AdmsSensFadType & modelPar_WDVTP2,
   bool modelPar_given_WDVTP2,
   AdmsSensFadType & modelPar_PDVTP2,
   bool modelPar_given_PDVTP2,
   AdmsSensFadType & modelPar_DVTP3,
   bool modelPar_given_DVTP3,
   AdmsSensFadType & modelPar_LDVTP3,
   bool modelPar_given_LDVTP3,
   AdmsSensFadType & modelPar_WDVTP3,
   bool modelPar_given_WDVTP3,
   AdmsSensFadType & modelPar_PDVTP3,
   bool modelPar_given_PDVTP3,
   AdmsSensFadType & modelPar_DVTP4,
   bool modelPar_given_DVTP4,
   AdmsSensFadType & modelPar_LDVTP4,
   bool modelPar_given_LDVTP4,
   AdmsSensFadType & modelPar_WDVTP4,
   bool modelPar_given_WDVTP4,
   AdmsSensFadType & modelPar_PDVTP4,
   bool modelPar_given_PDVTP4,
   AdmsSensFadType & modelPar_DVTP5,
   bool modelPar_given_DVTP5,
   AdmsSensFadType & modelPar_LDVTP5,
   bool modelPar_given_LDVTP5,
   AdmsSensFadType & modelPar_WDVTP5,
   bool modelPar_given_WDVTP5,
   AdmsSensFadType & modelPar_PDVTP5,
   bool modelPar_given_PDVTP5,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_WPHIN,
   bool modelPar_given_WPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_WETA0,
   bool modelPar_given_WETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_WETA0R,
   bool modelPar_given_WETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_ETAB,
   bool modelPar_given_ETAB,
   AdmsSensFadType & modelPar_ETABEXP,
   bool modelPar_given_ETABEXP,
   AdmsSensFadType & modelPar_LETAB,
   bool modelPar_given_LETAB,
   AdmsSensFadType & modelPar_WETAB,
   bool modelPar_given_WETAB,
   AdmsSensFadType & modelPar_PETAB,
   bool modelPar_given_PETAB,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K1L,
   bool modelPar_given_K1L,
   AdmsSensFadType & modelPar_K1LEXP,
   bool modelPar_given_K1LEXP,
   AdmsSensFadType & modelPar_K1W,
   bool modelPar_given_K1W,
   AdmsSensFadType & modelPar_K1WEXP,
   bool modelPar_given_K1WEXP,
   AdmsSensFadType & modelPar_K1WL,
   bool modelPar_given_K1WL,
   AdmsSensFadType & modelPar_K1WLEXP,
   bool modelPar_given_K1WLEXP,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_WK1,
   bool modelPar_given_WK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K2L,
   bool modelPar_given_K2L,
   AdmsSensFadType & modelPar_K2LEXP,
   bool modelPar_given_K2LEXP,
   AdmsSensFadType & modelPar_K2W,
   bool modelPar_given_K2W,
   AdmsSensFadType & modelPar_K2WEXP,
   bool modelPar_given_K2WEXP,
   AdmsSensFadType & modelPar_K2WL,
   bool modelPar_given_K2WL,
   AdmsSensFadType & modelPar_K2WLEXP,
   bool modelPar_given_K2WLEXP,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_WK2,
   bool modelPar_given_WK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_ADOS,
   bool modelPar_given_ADOS,
   AdmsSensFadType & modelPar_BDOS,
   bool modelPar_given_BDOS,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_WCIT,
   bool modelPar_given_WCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_NFACTOR,
   bool modelPar_given_NFACTOR,
   AdmsSensFadType & modelPar_NFACTORL,
   bool modelPar_given_NFACTORL,
   AdmsSensFadType & modelPar_NFACTORLEXP,
   bool modelPar_given_NFACTORLEXP,
   AdmsSensFadType & modelPar_NFACTORW,
   bool modelPar_given_NFACTORW,
   AdmsSensFadType & modelPar_NFACTORWEXP,
   bool modelPar_given_NFACTORWEXP,
   AdmsSensFadType & modelPar_NFACTORWL,
   bool modelPar_given_NFACTORWL,
   AdmsSensFadType & modelPar_NFACTORWLEXP,
   bool modelPar_given_NFACTORWLEXP,
   AdmsSensFadType & modelPar_LNFACTOR,
   bool modelPar_given_LNFACTOR,
   AdmsSensFadType & modelPar_WNFACTOR,
   bool modelPar_given_WNFACTOR,
   AdmsSensFadType & modelPar_PNFACTOR,
   bool modelPar_given_PNFACTOR,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDL,
   bool modelPar_given_CDSCDL,
   AdmsSensFadType & modelPar_CDSCDLEXP,
   bool modelPar_given_CDSCDLEXP,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_WCDSCD,
   bool modelPar_given_WCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDLR,
   bool modelPar_given_CDSCDLR,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_WCDSCDR,
   bool modelPar_given_WCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_CDSCB,
   bool modelPar_given_CDSCB,
   AdmsSensFadType & modelPar_CDSCBL,
   bool modelPar_given_CDSCBL,
   AdmsSensFadType & modelPar_CDSCBLEXP,
   bool modelPar_given_CDSCBLEXP,
   AdmsSensFadType & modelPar_LCDSCB,
   bool modelPar_given_LCDSCB,
   AdmsSensFadType & modelPar_WCDSCB,
   bool modelPar_given_WCDSCB,
   AdmsSensFadType & modelPar_PCDSCB,
   bool modelPar_given_PCDSCB,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_WVSAT,
   bool modelPar_given_WVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_VSATL,
   bool modelPar_given_VSATL,
   AdmsSensFadType & modelPar_VSATLEXP,
   bool modelPar_given_VSATLEXP,
   AdmsSensFadType & modelPar_VSATW,
   bool modelPar_given_VSATW,
   AdmsSensFadType & modelPar_VSATWEXP,
   bool modelPar_given_VSATWEXP,
   AdmsSensFadType & modelPar_VSATWL,
   bool modelPar_given_VSATWL,
   AdmsSensFadType & modelPar_VSATWLEXP,
   bool modelPar_given_VSATWLEXP,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_WVSATR,
   bool modelPar_given_WVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_DELTA,
   bool modelPar_given_DELTA,
   AdmsSensFadType & modelPar_LDELTA,
   bool modelPar_given_LDELTA,
   AdmsSensFadType & modelPar_WDELTA,
   bool modelPar_given_WDELTA,
   AdmsSensFadType & modelPar_PDELTA,
   bool modelPar_given_PDELTA,
   AdmsSensFadType & modelPar_DELTAL,
   bool modelPar_given_DELTAL,
   AdmsSensFadType & modelPar_DELTALEXP,
   bool modelPar_given_DELTALEXP,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_WVSATCV,
   bool modelPar_given_WVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_VSATCVL,
   bool modelPar_given_VSATCVL,
   AdmsSensFadType & modelPar_VSATCVLEXP,
   bool modelPar_given_VSATCVLEXP,
   AdmsSensFadType & modelPar_VSATCVW,
   bool modelPar_given_VSATCVW,
   AdmsSensFadType & modelPar_VSATCVWEXP,
   bool modelPar_given_VSATCVWEXP,
   AdmsSensFadType & modelPar_VSATCVWL,
   bool modelPar_given_VSATCVWL,
   AdmsSensFadType & modelPar_VSATCVWLEXP,
   bool modelPar_given_VSATCVWLEXP,
   AdmsSensFadType & modelPar_UP1,
   bool modelPar_given_UP1,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_UP2,
   bool modelPar_given_UP2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_MULU0,
   bool modelPar_given_MULU0,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0L,
   bool modelPar_given_U0L,
   AdmsSensFadType & modelPar_U0LEXP,
   bool modelPar_given_U0LEXP,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_WU0,
   bool modelPar_given_WU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_WU0R,
   bool modelPar_given_WU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAL,
   bool modelPar_given_UAL,
   AdmsSensFadType & modelPar_UALEXP,
   bool modelPar_given_UALEXP,
   AdmsSensFadType & modelPar_UAW,
   bool modelPar_given_UAW,
   AdmsSensFadType & modelPar_UAWEXP,
   bool modelPar_given_UAWEXP,
   AdmsSensFadType & modelPar_UAWL,
   bool modelPar_given_UAWL,
   AdmsSensFadType & modelPar_UAWLEXP,
   bool modelPar_given_UAWLEXP,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_WUA,
   bool modelPar_given_WUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_WUAR,
   bool modelPar_given_WUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_WEU,
   bool modelPar_given_WEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_EUL,
   bool modelPar_given_EUL,
   AdmsSensFadType & modelPar_EULEXP,
   bool modelPar_given_EULEXP,
   AdmsSensFadType & modelPar_EUW,
   bool modelPar_given_EUW,
   AdmsSensFadType & modelPar_EUWEXP,
   bool modelPar_given_EUWEXP,
   AdmsSensFadType & modelPar_EUWL,
   bool modelPar_given_EUWL,
   AdmsSensFadType & modelPar_EUWLEXP,
   bool modelPar_given_EUWLEXP,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDL,
   bool modelPar_given_UDL,
   AdmsSensFadType & modelPar_UDLEXP,
   bool modelPar_given_UDLEXP,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_WUD,
   bool modelPar_given_WUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_WUDR,
   bool modelPar_given_WUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_WUCS,
   bool modelPar_given_WUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_UCSR,
   bool modelPar_given_UCSR,
   AdmsSensFadType & modelPar_LUCSR,
   bool modelPar_given_LUCSR,
   AdmsSensFadType & modelPar_WUCSR,
   bool modelPar_given_WUCSR,
   AdmsSensFadType & modelPar_PUCSR,
   bool modelPar_given_PUCSR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCL,
   bool modelPar_given_UCL,
   AdmsSensFadType & modelPar_UCLEXP,
   bool modelPar_given_UCLEXP,
   AdmsSensFadType & modelPar_UCW,
   bool modelPar_given_UCW,
   AdmsSensFadType & modelPar_UCWEXP,
   bool modelPar_given_UCWEXP,
   AdmsSensFadType & modelPar_UCWL,
   bool modelPar_given_UCWL,
   AdmsSensFadType & modelPar_UCWLEXP,
   bool modelPar_given_UCWLEXP,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_WUC,
   bool modelPar_given_WUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_WUCR,
   bool modelPar_given_WUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLML,
   bool modelPar_given_PCLML,
   AdmsSensFadType & modelPar_PCLMLEXP,
   bool modelPar_given_PCLMLEXP,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_WPCLM,
   bool modelPar_given_WPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_WPCLMR,
   bool modelPar_given_WPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_PCLMCVL,
   bool modelPar_given_PCLMCVL,
   AdmsSensFadType & modelPar_PCLMCVLEXP,
   bool modelPar_given_PCLMCVLEXP,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_WPCLMCV,
   bool modelPar_given_WPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_PSCBE1,
   bool modelPar_given_PSCBE1,
   AdmsSensFadType & modelPar_LPSCBE1,
   bool modelPar_given_LPSCBE1,
   AdmsSensFadType & modelPar_WPSCBE1,
   bool modelPar_given_WPSCBE1,
   AdmsSensFadType & modelPar_PPSCBE1,
   bool modelPar_given_PPSCBE1,
   AdmsSensFadType & modelPar_PSCBE2,
   bool modelPar_given_PSCBE2,
   AdmsSensFadType & modelPar_LPSCBE2,
   bool modelPar_given_LPSCBE2,
   AdmsSensFadType & modelPar_WPSCBE2,
   bool modelPar_given_WPSCBE2,
   AdmsSensFadType & modelPar_PPSCBE2,
   bool modelPar_given_PPSCBE2,
   AdmsSensFadType & modelPar_PDITS,
   bool modelPar_given_PDITS,
   AdmsSensFadType & modelPar_LPDITS,
   bool modelPar_given_LPDITS,
   AdmsSensFadType & modelPar_WPDITS,
   bool modelPar_given_WPDITS,
   AdmsSensFadType & modelPar_PPDITS,
   bool modelPar_given_PPDITS,
   AdmsSensFadType & modelPar_PDITSL,
   bool modelPar_given_PDITSL,
   AdmsSensFadType & modelPar_PDITSD,
   bool modelPar_given_PDITSD,
   AdmsSensFadType & modelPar_LPDITSD,
   bool modelPar_given_LPDITSD,
   AdmsSensFadType & modelPar_WPDITSD,
   bool modelPar_given_WPDITSD,
   AdmsSensFadType & modelPar_PPDITSD,
   bool modelPar_given_PPDITSD,
   AdmsSensFadType & modelPar_RSH,
   bool modelPar_given_RSH,
   AdmsSensFadType & modelPar_PRWG,
   bool modelPar_given_PRWG,
   AdmsSensFadType & modelPar_LPRWG,
   bool modelPar_given_LPRWG,
   AdmsSensFadType & modelPar_WPRWG,
   bool modelPar_given_WPRWG,
   AdmsSensFadType & modelPar_PPRWG,
   bool modelPar_given_PPRWG,
   AdmsSensFadType & modelPar_PRWB,
   bool modelPar_given_PRWB,
   AdmsSensFadType & modelPar_LPRWB,
   bool modelPar_given_LPRWB,
   AdmsSensFadType & modelPar_WPRWB,
   bool modelPar_given_WPRWB,
   AdmsSensFadType & modelPar_PPRWB,
   bool modelPar_given_PPRWB,
   AdmsSensFadType & modelPar_PRWBL,
   bool modelPar_given_PRWBL,
   AdmsSensFadType & modelPar_PRWBLEXP,
   bool modelPar_given_PRWBLEXP,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_WWR,
   bool modelPar_given_WWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_LRSWMIN,
   bool modelPar_given_LRSWMIN,
   AdmsSensFadType & modelPar_WRSWMIN,
   bool modelPar_given_WRSWMIN,
   AdmsSensFadType & modelPar_PRSWMIN,
   bool modelPar_given_PRSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_WRSW,
   bool modelPar_given_WRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_RSWL,
   bool modelPar_given_RSWL,
   AdmsSensFadType & modelPar_RSWLEXP,
   bool modelPar_given_RSWLEXP,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_LRDWMIN,
   bool modelPar_given_LRDWMIN,
   AdmsSensFadType & modelPar_WRDWMIN,
   bool modelPar_given_WRDWMIN,
   AdmsSensFadType & modelPar_PRDWMIN,
   bool modelPar_given_PRDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_WRDW,
   bool modelPar_given_WRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_RDWL,
   bool modelPar_given_RDWL,
   AdmsSensFadType & modelPar_RDWLEXP,
   bool modelPar_given_RDWLEXP,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_LRDSWMIN,
   bool modelPar_given_LRDSWMIN,
   AdmsSensFadType & modelPar_WRDSWMIN,
   bool modelPar_given_WRDSWMIN,
   AdmsSensFadType & modelPar_PRDSWMIN,
   bool modelPar_given_PRDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_RDSWL,
   bool modelPar_given_RDSWL,
   AdmsSensFadType & modelPar_RDSWLEXP,
   bool modelPar_given_RDSWLEXP,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_WRDSW,
   bool modelPar_given_WRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_WPSAT,
   bool modelPar_given_WPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_PSATL,
   bool modelPar_given_PSATL,
   AdmsSensFadType & modelPar_PSATLEXP,
   bool modelPar_given_PSATLEXP,
   AdmsSensFadType & modelPar_PSATB,
   bool modelPar_given_PSATB,
   AdmsSensFadType & modelPar_PSATR,
   bool modelPar_given_PSATR,
   AdmsSensFadType & modelPar_LPSATR,
   bool modelPar_given_LPSATR,
   AdmsSensFadType & modelPar_WPSATR,
   bool modelPar_given_WPSATR,
   AdmsSensFadType & modelPar_PPSATR,
   bool modelPar_given_PPSATR,
   AdmsSensFadType & modelPar_LPSATB,
   bool modelPar_given_LPSATB,
   AdmsSensFadType & modelPar_WPSATB,
   bool modelPar_given_WPSATB,
   AdmsSensFadType & modelPar_PPSATB,
   bool modelPar_given_PPSATB,
   AdmsSensFadType & modelPar_PSATX,
   bool modelPar_given_PSATX,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_WPTWG,
   bool modelPar_given_WPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_PTWGL,
   bool modelPar_given_PTWGL,
   AdmsSensFadType & modelPar_PTWGLEXP,
   bool modelPar_given_PTWGLEXP,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_WPTWGR,
   bool modelPar_given_WPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_PTWGLR,
   bool modelPar_given_PTWGLR,
   AdmsSensFadType & modelPar_PTWGLEXPR,
   bool modelPar_given_PTWGLEXPR,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_WA1,
   bool modelPar_given_WA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_WA11,
   bool modelPar_given_WA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_WA2,
   bool modelPar_given_WA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_WA21,
   bool modelPar_given_WA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_PDIBLC,
   bool modelPar_given_PDIBLC,
   AdmsSensFadType & modelPar_PDIBLCL,
   bool modelPar_given_PDIBLCL,
   AdmsSensFadType & modelPar_PDIBLCLEXP,
   bool modelPar_given_PDIBLCLEXP,
   AdmsSensFadType & modelPar_LPDIBLC,
   bool modelPar_given_LPDIBLC,
   AdmsSensFadType & modelPar_WPDIBLC,
   bool modelPar_given_WPDIBLC,
   AdmsSensFadType & modelPar_PPDIBLC,
   bool modelPar_given_PPDIBLC,
   AdmsSensFadType & modelPar_PDIBLCR,
   bool modelPar_given_PDIBLCR,
   AdmsSensFadType & modelPar_PDIBLCLR,
   bool modelPar_given_PDIBLCLR,
   AdmsSensFadType & modelPar_PDIBLCLEXPR,
   bool modelPar_given_PDIBLCLEXPR,
   AdmsSensFadType & modelPar_LPDIBLCR,
   bool modelPar_given_LPDIBLCR,
   AdmsSensFadType & modelPar_WPDIBLCR,
   bool modelPar_given_WPDIBLCR,
   AdmsSensFadType & modelPar_PPDIBLCR,
   bool modelPar_given_PPDIBLCR,
   AdmsSensFadType & modelPar_PDIBLCB,
   bool modelPar_given_PDIBLCB,
   AdmsSensFadType & modelPar_LPDIBLCB,
   bool modelPar_given_LPDIBLCB,
   AdmsSensFadType & modelPar_WPDIBLCB,
   bool modelPar_given_WPDIBLCB,
   AdmsSensFadType & modelPar_PPDIBLCB,
   bool modelPar_given_PPDIBLCB,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_WPVAG,
   bool modelPar_given_WPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_FPROUT,
   bool modelPar_given_FPROUT,
   AdmsSensFadType & modelPar_FPROUTL,
   bool modelPar_given_FPROUTL,
   AdmsSensFadType & modelPar_FPROUTLEXP,
   bool modelPar_given_FPROUTLEXP,
   AdmsSensFadType & modelPar_LFPROUT,
   bool modelPar_given_LFPROUT,
   AdmsSensFadType & modelPar_WFPROUT,
   bool modelPar_given_WFPROUT,
   AdmsSensFadType & modelPar_PFPROUT,
   bool modelPar_given_PFPROUT,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA0L,
   bool modelPar_given_ALPHA0L,
   AdmsSensFadType & modelPar_ALPHA0LEXP,
   bool modelPar_given_ALPHA0LEXP,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_WALPHA0,
   bool modelPar_given_WALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_WBETA0,
   bool modelPar_given_WBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_DLCIG,
   bool modelPar_given_DLCIG,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_AIGCL,
   bool modelPar_given_AIGCL,
   AdmsSensFadType & modelPar_AIGCW,
   bool modelPar_given_AIGCW,
   AdmsSensFadType & modelPar_AIGSL,
   bool modelPar_given_AIGSL,
   AdmsSensFadType & modelPar_AIGSW,
   bool modelPar_given_AIGSW,
   AdmsSensFadType & modelPar_AIGDL,
   bool modelPar_given_AIGDL,
   AdmsSensFadType & modelPar_AIGDW,
   bool modelPar_given_AIGDW,
   AdmsSensFadType & modelPar_PIGCDL,
   bool modelPar_given_PIGCDL,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_WAIGBINV,
   bool modelPar_given_WAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_WBIGBINV,
   bool modelPar_given_WBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_WCIGBINV,
   bool modelPar_given_WCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_WEIGBINV,
   bool modelPar_given_WEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_WNIGBINV,
   bool modelPar_given_WNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_WAIGBACC,
   bool modelPar_given_WAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_WBIGBACC,
   bool modelPar_given_WBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_WCIGBACC,
   bool modelPar_given_WCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_WNIGBACC,
   bool modelPar_given_WNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_WAIGC,
   bool modelPar_given_WAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_WBIGC,
   bool modelPar_given_WBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_WCIGC,
   bool modelPar_given_WCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_WAIGS,
   bool modelPar_given_WAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_WBIGS,
   bool modelPar_given_WBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_WCIGS,
   bool modelPar_given_WCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_WAIGD,
   bool modelPar_given_WAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_WBIGD,
   bool modelPar_given_WBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_WCIGD,
   bool modelPar_given_WCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_WPOXEDGE,
   bool modelPar_given_WPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LDLCIG,
   bool modelPar_given_LDLCIG,
   AdmsSensFadType & modelPar_WDLCIG,
   bool modelPar_given_WDLCIG,
   AdmsSensFadType & modelPar_PDLCIG,
   bool modelPar_given_PDLCIG,
   AdmsSensFadType & modelPar_LDLCIGD,
   bool modelPar_given_LDLCIGD,
   AdmsSensFadType & modelPar_WDLCIGD,
   bool modelPar_given_WDLCIGD,
   AdmsSensFadType & modelPar_PDLCIGD,
   bool modelPar_given_PDLCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_WNTOX,
   bool modelPar_given_WNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_AGIDLL,
   bool modelPar_given_AGIDLL,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_WAGIDL,
   bool modelPar_given_WAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_WBGIDL,
   bool modelPar_given_WBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_WCGIDL,
   bool modelPar_given_WCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_WEGIDL,
   bool modelPar_given_WEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_AGISLL,
   bool modelPar_given_AGISLL,
   AdmsSensFadType & modelPar_AGISLW,
   bool modelPar_given_AGISLW,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_WAGISL,
   bool modelPar_given_WAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_WBGISL,
   bool modelPar_given_WBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_WCGISL,
   bool modelPar_given_WCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_WEGISL,
   bool modelPar_given_WEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_CF,
   bool modelPar_given_CF,
   AdmsSensFadType & modelPar_LCF,
   bool modelPar_given_LCF,
   AdmsSensFadType & modelPar_WCF,
   bool modelPar_given_WCF,
   AdmsSensFadType & modelPar_PCF,
   bool modelPar_given_PCF,
   AdmsSensFadType & modelPar_CFRCOEFF,
   bool modelPar_given_CFRCOEFF,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_WCGSL,
   bool modelPar_given_WCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_WCGDL,
   bool modelPar_given_WCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_WCKAPPAS,
   bool modelPar_given_WCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_WCKAPPAD,
   bool modelPar_given_WCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_DMCG,
   bool modelPar_given_DMCG,
   AdmsSensFadType & modelPar_DMCI,
   bool modelPar_given_DMCI,
   AdmsSensFadType & modelPar_DMDG,
   bool modelPar_given_DMDG,
   AdmsSensFadType & modelPar_DMCGT,
   bool modelPar_given_DMCGT,
   AdmsSensFadType & modelPar_XGL,
   bool modelPar_given_XGL,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_GBMIN,
   bool modelPar_given_GBMIN,
   AdmsSensFadType & modelPar_RBPS0,
   bool modelPar_given_RBPS0,
   AdmsSensFadType & modelPar_RBPSL,
   bool modelPar_given_RBPSL,
   AdmsSensFadType & modelPar_RBPSW,
   bool modelPar_given_RBPSW,
   AdmsSensFadType & modelPar_RBPSNF,
   bool modelPar_given_RBPSNF,
   AdmsSensFadType & modelPar_RBPD0,
   bool modelPar_given_RBPD0,
   AdmsSensFadType & modelPar_RBPDL,
   bool modelPar_given_RBPDL,
   AdmsSensFadType & modelPar_RBPDW,
   bool modelPar_given_RBPDW,
   AdmsSensFadType & modelPar_RBPDNF,
   bool modelPar_given_RBPDNF,
   AdmsSensFadType & modelPar_RBPBX0,
   bool modelPar_given_RBPBX0,
   AdmsSensFadType & modelPar_RBPBXL,
   bool modelPar_given_RBPBXL,
   AdmsSensFadType & modelPar_RBPBXW,
   bool modelPar_given_RBPBXW,
   AdmsSensFadType & modelPar_RBPBXNF,
   bool modelPar_given_RBPBXNF,
   AdmsSensFadType & modelPar_RBPBY0,
   bool modelPar_given_RBPBY0,
   AdmsSensFadType & modelPar_RBPBYL,
   bool modelPar_given_RBPBYL,
   AdmsSensFadType & modelPar_RBPBYW,
   bool modelPar_given_RBPBYW,
   AdmsSensFadType & modelPar_RBPBYNF,
   bool modelPar_given_RBPBYNF,
   AdmsSensFadType & modelPar_RBSBX0,
   bool modelPar_given_RBSBX0,
   AdmsSensFadType & modelPar_RBSBY0,
   bool modelPar_given_RBSBY0,
   AdmsSensFadType & modelPar_RBDBX0,
   bool modelPar_given_RBDBX0,
   AdmsSensFadType & modelPar_RBDBY0,
   bool modelPar_given_RBDBY0,
   AdmsSensFadType & modelPar_RBSDBXL,
   bool modelPar_given_RBSDBXL,
   AdmsSensFadType & modelPar_RBSDBXW,
   bool modelPar_given_RBSDBXW,
   AdmsSensFadType & modelPar_RBSDBXNF,
   bool modelPar_given_RBSDBXNF,
   AdmsSensFadType & modelPar_RBSDBYL,
   bool modelPar_given_RBSDBYL,
   AdmsSensFadType & modelPar_RBSDBYW,
   bool modelPar_given_RBSDBYW,
   AdmsSensFadType & modelPar_RBSDBYNF,
   bool modelPar_given_RBSDBYNF,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_DWBIN,
   bool modelPar_given_DWBIN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_TNFACTOR,
   bool modelPar_given_TNFACTOR,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_WUTE,
   bool modelPar_given_WUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_UTEL,
   bool modelPar_given_UTEL,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_WUA1,
   bool modelPar_given_WUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_UA1L,
   bool modelPar_given_UA1L,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_WUC1,
   bool modelPar_given_WUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_WUD1,
   bool modelPar_given_WUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_UD1L,
   bool modelPar_given_UD1L,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_WUCSTE,
   bool modelPar_given_WUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_WPRT,
   bool modelPar_given_WPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_WAT,
   bool modelPar_given_WAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_ATL,
   bool modelPar_given_ATL,
   AdmsSensFadType & modelPar_TDELTA,
   bool modelPar_given_TDELTA,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_WPTWGT,
   bool modelPar_given_WPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_PTWGTL,
   bool modelPar_given_PTWGTL,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1EXP,
   bool modelPar_given_KT1EXP,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_WKT1,
   bool modelPar_given_WKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_KT2,
   bool modelPar_given_KT2,
   AdmsSensFadType & modelPar_LKT2,
   bool modelPar_given_LKT2,
   AdmsSensFadType & modelPar_WKT2,
   bool modelPar_given_WKT2,
   AdmsSensFadType & modelPar_PKT2,
   bool modelPar_given_PKT2,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_WIIT,
   bool modelPar_given_WIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_WIGT,
   bool modelPar_given_WIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_WTGIDL,
   bool modelPar_given_WTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KU0,
   bool modelPar_given_KU0,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKU0,
   bool modelPar_given_TKU0,
   AdmsSensFadType & modelPar_LKU0,
   bool modelPar_given_LKU0,
   AdmsSensFadType & modelPar_WKU0,
   bool modelPar_given_WKU0,
   AdmsSensFadType & modelPar_PKU0,
   bool modelPar_given_PKU0,
   AdmsSensFadType & modelPar_LLODKU0,
   bool modelPar_given_LLODKU0,
   AdmsSensFadType & modelPar_WLODKU0,
   bool modelPar_given_WLODKU0,
   AdmsSensFadType & modelPar_KVTH0,
   bool modelPar_given_KVTH0,
   AdmsSensFadType & modelPar_LKVTH0,
   bool modelPar_given_LKVTH0,
   AdmsSensFadType & modelPar_WKVTH0,
   bool modelPar_given_WKVTH0,
   AdmsSensFadType & modelPar_PKVTH0,
   bool modelPar_given_PKVTH0,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STK2,
   bool modelPar_given_STK2,
   AdmsSensFadType & modelPar_LODK2,
   bool modelPar_given_LODK2,
   AdmsSensFadType & modelPar_STETA0,
   bool modelPar_given_STETA0,
   AdmsSensFadType & modelPar_LODETA0,
   bool modelPar_given_LODETA0,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_KVTH0WE,
   bool modelPar_given_KVTH0WE,
   AdmsSensFadType & modelPar_LKVTH0WE,
   bool modelPar_given_LKVTH0WE,
   AdmsSensFadType & modelPar_WKVTH0WE,
   bool modelPar_given_WKVTH0WE,
   AdmsSensFadType & modelPar_PKVTH0WE,
   bool modelPar_given_PKVTH0WE,
   AdmsSensFadType & modelPar_K2WE,
   bool modelPar_given_K2WE,
   AdmsSensFadType & modelPar_LK2WE,
   bool modelPar_given_LK2WE,
   AdmsSensFadType & modelPar_WK2WE,
   bool modelPar_given_WK2WE,
   AdmsSensFadType & modelPar_PK2WE,
   bool modelPar_given_PK2WE,
   AdmsSensFadType & modelPar_KU0WE,
   bool modelPar_given_KU0WE,
   AdmsSensFadType & modelPar_LKU0WE,
   bool modelPar_given_LKU0WE,
   AdmsSensFadType & modelPar_WKU0WE,
   bool modelPar_given_WKU0WE,
   AdmsSensFadType & modelPar_PKU0WE,
   bool modelPar_given_PKU0WE,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEDGE,
   bool modelPar_given_WEDGE,
   AdmsSensFadType & modelPar_DGAMMAEDGE,
   bool modelPar_given_DGAMMAEDGE,
   AdmsSensFadType & modelPar_DGAMMAEDGEL,
   bool modelPar_given_DGAMMAEDGEL,
   AdmsSensFadType & modelPar_DGAMMAEDGELEXP,
   bool modelPar_given_DGAMMAEDGELEXP,
   AdmsSensFadType & modelPar_DVTEDGE,
   bool modelPar_given_DVTEDGE,
   AdmsSensFadType & modelPar_NFACTOREDGE,
   bool modelPar_given_NFACTOREDGE,
   AdmsSensFadType & modelPar_CITEDGE,
   bool modelPar_given_CITEDGE,
   AdmsSensFadType & modelPar_CDSCDEDGE,
   bool modelPar_given_CDSCDEDGE,
   AdmsSensFadType & modelPar_CDSCBEDGE,
   bool modelPar_given_CDSCBEDGE,
   AdmsSensFadType & modelPar_ETA0EDGE,
   bool modelPar_given_ETA0EDGE,
   AdmsSensFadType & modelPar_ETABEDGE,
   bool modelPar_given_ETABEDGE,
   AdmsSensFadType & modelPar_KT1EDGE,
   bool modelPar_given_KT1EDGE,
   AdmsSensFadType & modelPar_KT1LEDGE,
   bool modelPar_given_KT1LEDGE,
   AdmsSensFadType & modelPar_KT2EDGE,
   bool modelPar_given_KT2EDGE,
   AdmsSensFadType & modelPar_KT1EXPEDGE,
   bool modelPar_given_KT1EXPEDGE,
   AdmsSensFadType & modelPar_TNFACTOREDGE,
   bool modelPar_given_TNFACTOREDGE,
   AdmsSensFadType & modelPar_TETA0EDGE,
   bool modelPar_given_TETA0EDGE,
   AdmsSensFadType & modelPar_DVT0EDGE,
   bool modelPar_given_DVT0EDGE,
   AdmsSensFadType & modelPar_DVT1EDGE,
   bool modelPar_given_DVT1EDGE,
   AdmsSensFadType & modelPar_DVT2EDGE,
   bool modelPar_given_DVT2EDGE,
   // non-reals (including hidden)
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RBODYMOD,
   bool modelPar_given_RBODYMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_SCA,
   bool modelPar_given_SCA,
   int modelPar_SCB,
   bool modelPar_given_SCB,
   int modelPar_SCC,
   bool modelPar_given_SCC,
   int modelPar_SC,
   bool modelPar_given_SC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_CVMOD,
   bool modelPar_given_CVMOD,
   int modelPar_COVMOD,
   bool modelPar_given_COVMOD,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_WPEMOD,
   bool modelPar_given_WPEMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_MOBSCALE,
   bool modelPar_given_MOBSCALE,
   int modelPar_PERMOD,
   bool modelPar_given_PERMOD,
   int modelPar_BINUNIT,
   bool modelPar_given_BINUNIT,
   int modelPar_EDGEFET,
   bool modelPar_given_EDGEFET,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_bi_dbulk,
   const int admsProbeID_V_b_dbulk,
   const int admsProbeID_V_b_bi,
   const int admsProbeID_V_b_sbulk,
   const int admsProbeID_V_bi_sbulk,
   const int admsProbeID_V_di_si,
   const int admsProbeID_V_gm_gi,
   const int admsProbeID_V_g_gm,
   const int admsProbeID_V_s_si,
   const int admsProbeID_V_d_di,
   const int admsProbeID_V_gm_bi,
   const int admsProbeID_V_N1_GND,
   const int admsProbeID_V_N2_GND,
   const int admsProbeID_V_gm_si,
   const int admsProbeID_V_gm_di,
   const int admsProbeID_V_dbulk_di,
   const int admsProbeID_V_sbulk_si,
   const int admsProbeID_V_si_bi,
   const int admsProbeID_V_di_bi,
   const int admsProbeID_V_gi_bi,
   const int admsProbeID_Temp_t_GND,
   // node constants
   const int admsNodeID_d,
   const int admsNodeID_g,
   const int admsNodeID_s,
   const int admsNodeID_b,
   const int admsNodeID_di,
   const int admsNodeID_si,
   const int admsNodeID_gi,
   const int admsNodeID_gm,
   const int admsNodeID_bi,
   const int admsNodeID_sbulk,
   const int admsNodeID_dbulk,
   const int admsNodeID_N1,
   const int admsNodeID_N2,
   const int admsNodeID_t,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_VFBSDOFF,
   bool instancePar_given_VFBSDOFF,
   AdmsSensFadType & instancePar_XGW,
   bool instancePar_given_XGW,
   AdmsSensFadType & instancePar_RBPB,
   bool instancePar_given_RBPB,
   AdmsSensFadType & instancePar_RBPD,
   bool instancePar_given_RBPD,
   AdmsSensFadType & instancePar_RBPS,
   bool instancePar_given_RBPS,
   AdmsSensFadType & instancePar_RBDB,
   bool instancePar_given_RBDB,
   AdmsSensFadType & instancePar_RBSB,
   bool instancePar_given_RBSB,
   AdmsSensFadType & instancePar_SA,
   bool instancePar_given_SA,
   AdmsSensFadType & instancePar_SB,
   bool instancePar_given_SB,
   AdmsSensFadType & instancePar_SD,
   bool instancePar_given_SD,
   AdmsSensFadType & instancePar_AS,
   bool instancePar_given_AS,
   AdmsSensFadType & instancePar_AD,
   bool instancePar_given_AD,
   AdmsSensFadType & instancePar_PS,
   bool instancePar_given_PS,
   AdmsSensFadType & instancePar_PD,
   bool instancePar_given_PD,
   // non-reals(including hidden)
   int instancePar_NF,
   bool instancePar_given_NF,
   int instancePar_MINZ,
   bool instancePar_given_MINZ,
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   int instancePar_RGATEMOD,
   bool instancePar_given_RGATEMOD,
   int instancePar_RBODYMOD,
   bool instancePar_given_RBODYMOD,
   int instancePar_GEOMOD,
   bool instancePar_given_GEOMOD,
   int instancePar_RGEOMOD,
   bool instancePar_given_RGEOMOD,
   int instancePar_SCA,
   bool instancePar_given_SCA,
   int instancePar_SCB,
   bool instancePar_given_SCB,
   int instancePar_SCC,
   bool instancePar_given_SCC,
   int instancePar_SC,
   bool instancePar_given_SC,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_T0,
   AdmsSensFadType & instanceVar_T1,
   AdmsSensFadType & instanceVar_T2,
   AdmsSensFadType & instanceVar_epssi,
   AdmsSensFadType & instanceVar_epsox,
   AdmsSensFadType & instanceVar_Weff,
   AdmsSensFadType & instanceVar_Leff,
   AdmsSensFadType & instanceVar_Wact,
   AdmsSensFadType & instanceVar_Lact,
   AdmsSensFadType & instanceVar_Weffcj,
   AdmsSensFadType & instanceVar_Cox,
   AdmsSensFadType & instanceVar_epsratio,
   AdmsSensFadType & instanceVar_Lnew,
   AdmsSensFadType & instanceVar_L_mult,
   AdmsSensFadType & instanceVar_Wnew,
   AdmsSensFadType & instanceVar_DVTP0_i,
   AdmsSensFadType & instanceVar_DVTP1_i,
   AdmsSensFadType & instanceVar_DVTP2_i,
   AdmsSensFadType & instanceVar_DVTP3_i,
   AdmsSensFadType & instanceVar_DVTP4_i,
   AdmsSensFadType & instanceVar_DVTP5_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A11_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A21_i,
   AdmsSensFadType & instanceVar_PSAT_i,
   AdmsSensFadType & instanceVar_PSATR_i,
   AdmsSensFadType & instanceVar_BSIM6TOXP,
   AdmsSensFadType & instanceVar_DMCGeff,
   AdmsSensFadType & instanceVar_DMDGeff,
   AdmsSensFadType & instanceVar_DMCIeff,
   AdmsSensFadType & instanceVar_RSourceGeo,
   AdmsSensFadType & instanceVar_RDrainGeo,
   AdmsSensFadType & instanceVar_Grgeltd,
   AdmsSensFadType & instanceVar_Grbsb,
   AdmsSensFadType & instanceVar_Grbdb,
   AdmsSensFadType & instanceVar_Grbpb,
   AdmsSensFadType & instanceVar_Grbps,
   AdmsSensFadType & instanceVar_Grbpd,
   AdmsSensFadType & instanceVar_Aechvb,
   AdmsSensFadType & instanceVar_Bechvb,
   AdmsSensFadType & instanceVar_AechvbEdge,
   AdmsSensFadType & instanceVar_BechvbEdge,
   AdmsSensFadType & instanceVar_ToxRatio,
   AdmsSensFadType & instanceVar_U0R_t,
   AdmsSensFadType & instanceVar_UAR_t,
   AdmsSensFadType & instanceVar_UCR_t,
   AdmsSensFadType & instanceVar_UDR_t,
   AdmsSensFadType & instanceVar_UCSR_t,
   AdmsSensFadType & instanceVar_VSATR_t,
   AdmsSensFadType & instanceVar_PTWGR_t,
   AdmsSensFadType & instanceVar_ETA0R_t,
   AdmsSensFadType & instanceVar_PSATB_i,
   AdmsSensFadType & instanceVar_KT1_i,
   AdmsSensFadType & instanceVar_KT2_i,
   AdmsSensFadType & instanceVar_NGATE_i,
   AdmsSensFadType & instanceVar_NSD_i,
   AdmsSensFadType & instanceVar_NDEP_i,
   AdmsSensFadType & instanceVar_VFB_i,
   AdmsSensFadType & instanceVar_CIT_i,
   AdmsSensFadType & instanceVar_CDSCD_i,
   AdmsSensFadType & instanceVar_CDSCDR_i,
   AdmsSensFadType & instanceVar_CDSCB_i,
   AdmsSensFadType & instanceVar_NFACTOR_i,
   AdmsSensFadType & instanceVar_PHIN_i,
   AdmsSensFadType & instanceVar_ETA0_i,
   AdmsSensFadType & instanceVar_ETA0R_i,
   AdmsSensFadType & instanceVar_ETAB_i,
   AdmsSensFadType & instanceVar_K2_i,
   AdmsSensFadType & instanceVar_K1_i,
   AdmsSensFadType & instanceVar_DELTA_i,
   AdmsSensFadType & instanceVar_U0_i,
   AdmsSensFadType & instanceVar_U0R_i,
   AdmsSensFadType & instanceVar_VSAT_i,
   AdmsSensFadType & instanceVar_VSATR_i,
   AdmsSensFadType & instanceVar_VSATCV_i,
   AdmsSensFadType & instanceVar_UA_i,
   AdmsSensFadType & instanceVar_UAR_i,
   AdmsSensFadType & instanceVar_EU_i,
   AdmsSensFadType & instanceVar_UD_i,
   AdmsSensFadType & instanceVar_UDR_i,
   AdmsSensFadType & instanceVar_UD_a,
   AdmsSensFadType & instanceVar_UCS_i,
   AdmsSensFadType & instanceVar_UCSR_i,
   AdmsSensFadType & instanceVar_UC_i,
   AdmsSensFadType & instanceVar_UCR_i,
   AdmsSensFadType & instanceVar_PDIBLC_i,
   AdmsSensFadType & instanceVar_PDIBLCR_i,
   AdmsSensFadType & instanceVar_PDIBLCB_i,
   AdmsSensFadType & instanceVar_PSCBE1_i,
   AdmsSensFadType & instanceVar_PSCBE2_i,
   AdmsSensFadType & instanceVar_PDITS_i,
   AdmsSensFadType & instanceVar_PDITSD_i,
   AdmsSensFadType & instanceVar_FPROUT_i,
   AdmsSensFadType & instanceVar_PRWG_i,
   AdmsSensFadType & instanceVar_WR_i,
   AdmsSensFadType & instanceVar_RDWMIN_i,
   AdmsSensFadType & instanceVar_RSWMIN_i,
   AdmsSensFadType & instanceVar_RDW_i,
   AdmsSensFadType & instanceVar_RSW_i,
   AdmsSensFadType & instanceVar_RDSW_i,
   AdmsSensFadType & instanceVar_RDSWMIN_i,
   AdmsSensFadType & instanceVar_PTWG_i,
   AdmsSensFadType & instanceVar_PTWGR_i,
   AdmsSensFadType & instanceVar_PVAG_i,
   AdmsSensFadType & instanceVar_XJ_i,
   AdmsSensFadType & instanceVar_PCLM_i,
   AdmsSensFadType & instanceVar_PCLMR_i,
   AdmsSensFadType & instanceVar_PCLMCV_i,
   AdmsSensFadType & instanceVar_PRWB_i,
   AdmsSensFadType & instanceVar_CF_i,
   AdmsSensFadType & instanceVar_CGSL_i,
   AdmsSensFadType & instanceVar_CGDL_i,
   AdmsSensFadType & instanceVar_CKAPPAS_i,
   AdmsSensFadType & instanceVar_CKAPPAD_i,
   AdmsSensFadType & instanceVar_VFBCV_i,
   AdmsSensFadType & instanceVar_NDEPCV_i,
   AdmsSensFadType & instanceVar_ALPHA0_i,
   AdmsSensFadType & instanceVar_BETA0_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_BGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_EGIDL_i,
   AdmsSensFadType & instanceVar_AGISL_i,
   AdmsSensFadType & instanceVar_BGISL_i,
   AdmsSensFadType & instanceVar_CGISL_i,
   AdmsSensFadType & instanceVar_EGISL_i,
   AdmsSensFadType & instanceVar_UTE_i,
   AdmsSensFadType & instanceVar_UA1_i,
   AdmsSensFadType & instanceVar_UC1_i,
   AdmsSensFadType & instanceVar_UD1_i,
   AdmsSensFadType & instanceVar_UCSTE_i,
   AdmsSensFadType & instanceVar_PRT_i,
   AdmsSensFadType & instanceVar_AT_i,
   AdmsSensFadType & instanceVar_PTWGT_i,
   AdmsSensFadType & instanceVar_IIT_i,
   AdmsSensFadType & instanceVar_TGIDL_i,
   AdmsSensFadType & instanceVar_KVTH0WE_i,
   AdmsSensFadType & instanceVar_K2WE_i,
   AdmsSensFadType & instanceVar_KU0WE_i,
   AdmsSensFadType & instanceVar_AIGBINV_i,
   AdmsSensFadType & instanceVar_BIGBINV_i,
   AdmsSensFadType & instanceVar_CIGBINV_i,
   AdmsSensFadType & instanceVar_EIGBINV_i,
   AdmsSensFadType & instanceVar_NIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBACC_i,
   AdmsSensFadType & instanceVar_BIGBACC_i,
   AdmsSensFadType & instanceVar_CIGBACC_i,
   AdmsSensFadType & instanceVar_NIGBACC_i,
   AdmsSensFadType & instanceVar_AIGC_i,
   AdmsSensFadType & instanceVar_BIGC_i,
   AdmsSensFadType & instanceVar_CIGC_i,
   AdmsSensFadType & instanceVar_AIGS_i,
   AdmsSensFadType & instanceVar_BIGS_i,
   AdmsSensFadType & instanceVar_CIGS_i,
   AdmsSensFadType & instanceVar_AIGD_i,
   AdmsSensFadType & instanceVar_BIGD_i,
   AdmsSensFadType & instanceVar_CIGD_i,
   AdmsSensFadType & instanceVar_PIGCD_i,
   AdmsSensFadType & instanceVar_DLCIG_i,
   AdmsSensFadType & instanceVar_DLCIGD_i,
   AdmsSensFadType & instanceVar_IGT_i,
   AdmsSensFadType & instanceVar_nuIntD,
   AdmsSensFadType & instanceVar_nuEndD,
   AdmsSensFadType & instanceVar_nuIntS,
   AdmsSensFadType & instanceVar_nuEndS,
   AdmsSensFadType & instanceVar_gth,
   AdmsSensFadType & instanceVar_cth,
   // non-reals
   int instanceVar_devsign,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_VFBSDOFF,
   bool modelPar_given_VFBSDOFF,
   AdmsSensFadType & modelPar_XGW,
   bool modelPar_given_XGW,
   AdmsSensFadType & modelPar_RBPB,
   bool modelPar_given_RBPB,
   AdmsSensFadType & modelPar_RBPD,
   bool modelPar_given_RBPD,
   AdmsSensFadType & modelPar_RBPS,
   bool modelPar_given_RBPS,
   AdmsSensFadType & modelPar_RBDB,
   bool modelPar_given_RBDB,
   AdmsSensFadType & modelPar_RBSB,
   bool modelPar_given_RBSB,
   AdmsSensFadType & modelPar_SA,
   bool modelPar_given_SA,
   AdmsSensFadType & modelPar_SB,
   bool modelPar_given_SB,
   AdmsSensFadType & modelPar_SD,
   bool modelPar_given_SD,
   AdmsSensFadType & modelPar_LLONG,
   bool modelPar_given_LLONG,
   AdmsSensFadType & modelPar_LMLT,
   bool modelPar_given_LMLT,
   AdmsSensFadType & modelPar_WMLT,
   bool modelPar_given_WMLT,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_WWIDE,
   bool modelPar_given_WWIDE,
   AdmsSensFadType & modelPar_XW,
   bool modelPar_given_XW,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LW,
   bool modelPar_given_LW,
   AdmsSensFadType & modelPar_LWL,
   bool modelPar_given_LWL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_LWN,
   bool modelPar_given_LWN,
   AdmsSensFadType & modelPar_WINT,
   bool modelPar_given_WINT,
   AdmsSensFadType & modelPar_WL,
   bool modelPar_given_WL,
   AdmsSensFadType & modelPar_WW,
   bool modelPar_given_WW,
   AdmsSensFadType & modelPar_WWL,
   bool modelPar_given_WWL,
   AdmsSensFadType & modelPar_WLN,
   bool modelPar_given_WLN,
   AdmsSensFadType & modelPar_WWN,
   bool modelPar_given_WWN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_LWC,
   bool modelPar_given_LWC,
   AdmsSensFadType & modelPar_LWLC,
   bool modelPar_given_LWLC,
   AdmsSensFadType & modelPar_DWC,
   bool modelPar_given_DWC,
   AdmsSensFadType & modelPar_WLC,
   bool modelPar_given_WLC,
   AdmsSensFadType & modelPar_WWC,
   bool modelPar_given_WWC,
   AdmsSensFadType & modelPar_WWLC,
   bool modelPar_given_WWLC,
   AdmsSensFadType & modelPar_TOXE,
   bool modelPar_given_TOXE,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_DTOX,
   bool modelPar_given_DTOX,
   AdmsSensFadType & modelPar_NDEP,
   bool modelPar_given_NDEP,
   AdmsSensFadType & modelPar_NDEPL1,
   bool modelPar_given_NDEPL1,
   AdmsSensFadType & modelPar_NDEPLEXP1,
   bool modelPar_given_NDEPLEXP1,
   AdmsSensFadType & modelPar_NDEPL2,
   bool modelPar_given_NDEPL2,
   AdmsSensFadType & modelPar_NDEPLEXP2,
   bool modelPar_given_NDEPLEXP2,
   AdmsSensFadType & modelPar_NDEPW,
   bool modelPar_given_NDEPW,
   AdmsSensFadType & modelPar_NDEPWEXP,
   bool modelPar_given_NDEPWEXP,
   AdmsSensFadType & modelPar_NDEPWL,
   bool modelPar_given_NDEPWL,
   AdmsSensFadType & modelPar_NDEPWLEXP,
   bool modelPar_given_NDEPWLEXP,
   AdmsSensFadType & modelPar_LNDEP,
   bool modelPar_given_LNDEP,
   AdmsSensFadType & modelPar_WNDEP,
   bool modelPar_given_WNDEP,
   AdmsSensFadType & modelPar_PNDEP,
   bool modelPar_given_PNDEP,
   AdmsSensFadType & modelPar_NDEPCV,
   bool modelPar_given_NDEPCV,
   AdmsSensFadType & modelPar_NDEPCVL1,
   bool modelPar_given_NDEPCVL1,
   AdmsSensFadType & modelPar_NDEPCVLEXP1,
   bool modelPar_given_NDEPCVLEXP1,
   AdmsSensFadType & modelPar_NDEPCVL2,
   bool modelPar_given_NDEPCVL2,
   AdmsSensFadType & modelPar_NDEPCVLEXP2,
   bool modelPar_given_NDEPCVLEXP2,
   AdmsSensFadType & modelPar_NDEPCVW,
   bool modelPar_given_NDEPCVW,
   AdmsSensFadType & modelPar_NDEPCVWEXP,
   bool modelPar_given_NDEPCVWEXP,
   AdmsSensFadType & modelPar_NDEPCVWL,
   bool modelPar_given_NDEPCVWL,
   AdmsSensFadType & modelPar_NDEPCVWLEXP,
   bool modelPar_given_NDEPCVWLEXP,
   AdmsSensFadType & modelPar_LNDEPCV,
   bool modelPar_given_LNDEPCV,
   AdmsSensFadType & modelPar_WNDEPCV,
   bool modelPar_given_WNDEPCV,
   AdmsSensFadType & modelPar_PNDEPCV,
   bool modelPar_given_PNDEPCV,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_WNGATE,
   bool modelPar_given_WNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_XJ,
   bool modelPar_given_XJ,
   AdmsSensFadType & modelPar_LXJ,
   bool modelPar_given_LXJ,
   AdmsSensFadType & modelPar_WXJ,
   bool modelPar_given_WXJ,
   AdmsSensFadType & modelPar_PXJ,
   bool modelPar_given_PXJ,
   AdmsSensFadType & modelPar_LVFB,
   bool modelPar_given_LVFB,
   AdmsSensFadType & modelPar_WVFB,
   bool modelPar_given_WVFB,
   AdmsSensFadType & modelPar_PVFB,
   bool modelPar_given_PVFB,
   AdmsSensFadType & modelPar_VFB,
   bool modelPar_given_VFB,
   AdmsSensFadType & modelPar_VFBCV,
   bool modelPar_given_VFBCV,
   AdmsSensFadType & modelPar_LVFBCV,
   bool modelPar_given_LVFBCV,
   AdmsSensFadType & modelPar_WVFBCV,
   bool modelPar_given_WVFBCV,
   AdmsSensFadType & modelPar_PVFBCV,
   bool modelPar_given_PVFBCV,
   AdmsSensFadType & modelPar_VFBCVL,
   bool modelPar_given_VFBCVL,
   AdmsSensFadType & modelPar_VFBCVLEXP,
   bool modelPar_given_VFBCVLEXP,
   AdmsSensFadType & modelPar_VFBCVW,
   bool modelPar_given_VFBCVW,
   AdmsSensFadType & modelPar_VFBCVWEXP,
   bool modelPar_given_VFBCVWEXP,
   AdmsSensFadType & modelPar_VFBCVWL,
   bool modelPar_given_VFBCVWL,
   AdmsSensFadType & modelPar_VFBCVWLEXP,
   bool modelPar_given_VFBCVWLEXP,
   AdmsSensFadType & modelPar_DWJ,
   bool modelPar_given_DWJ,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_LNSD,
   bool modelPar_given_LNSD,
   AdmsSensFadType & modelPar_WNSD,
   bool modelPar_given_WNSD,
   AdmsSensFadType & modelPar_PNSD,
   bool modelPar_given_PNSD,
   AdmsSensFadType & modelPar_DELVT0,
   bool modelPar_given_DELVT0,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_LDVTP0,
   bool modelPar_given_LDVTP0,
   AdmsSensFadType & modelPar_WDVTP0,
   bool modelPar_given_WDVTP0,
   AdmsSensFadType & modelPar_PDVTP0,
   bool modelPar_given_PDVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_LDVTP1,
   bool modelPar_given_LDVTP1,
   AdmsSensFadType & modelPar_WDVTP1,
   bool modelPar_given_WDVTP1,
   AdmsSensFadType & modelPar_PDVTP1,
   bool modelPar_given_PDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_LDVTP2,
   bool modelPar_given_LDVTP2,
   AdmsSensFadType & modelPar_WDVTP2,
   bool modelPar_given_WDVTP2,
   AdmsSensFadType & modelPar_PDVTP2,
   bool modelPar_given_PDVTP2,
   AdmsSensFadType & modelPar_DVTP3,
   bool modelPar_given_DVTP3,
   AdmsSensFadType & modelPar_LDVTP3,
   bool modelPar_given_LDVTP3,
   AdmsSensFadType & modelPar_WDVTP3,
   bool modelPar_given_WDVTP3,
   AdmsSensFadType & modelPar_PDVTP3,
   bool modelPar_given_PDVTP3,
   AdmsSensFadType & modelPar_DVTP4,
   bool modelPar_given_DVTP4,
   AdmsSensFadType & modelPar_LDVTP4,
   bool modelPar_given_LDVTP4,
   AdmsSensFadType & modelPar_WDVTP4,
   bool modelPar_given_WDVTP4,
   AdmsSensFadType & modelPar_PDVTP4,
   bool modelPar_given_PDVTP4,
   AdmsSensFadType & modelPar_DVTP5,
   bool modelPar_given_DVTP5,
   AdmsSensFadType & modelPar_LDVTP5,
   bool modelPar_given_LDVTP5,
   AdmsSensFadType & modelPar_WDVTP5,
   bool modelPar_given_WDVTP5,
   AdmsSensFadType & modelPar_PDVTP5,
   bool modelPar_given_PDVTP5,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_WPHIN,
   bool modelPar_given_WPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_WETA0,
   bool modelPar_given_WETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_WETA0R,
   bool modelPar_given_WETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_ETAB,
   bool modelPar_given_ETAB,
   AdmsSensFadType & modelPar_ETABEXP,
   bool modelPar_given_ETABEXP,
   AdmsSensFadType & modelPar_LETAB,
   bool modelPar_given_LETAB,
   AdmsSensFadType & modelPar_WETAB,
   bool modelPar_given_WETAB,
   AdmsSensFadType & modelPar_PETAB,
   bool modelPar_given_PETAB,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K1L,
   bool modelPar_given_K1L,
   AdmsSensFadType & modelPar_K1LEXP,
   bool modelPar_given_K1LEXP,
   AdmsSensFadType & modelPar_K1W,
   bool modelPar_given_K1W,
   AdmsSensFadType & modelPar_K1WEXP,
   bool modelPar_given_K1WEXP,
   AdmsSensFadType & modelPar_K1WL,
   bool modelPar_given_K1WL,
   AdmsSensFadType & modelPar_K1WLEXP,
   bool modelPar_given_K1WLEXP,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_WK1,
   bool modelPar_given_WK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K2L,
   bool modelPar_given_K2L,
   AdmsSensFadType & modelPar_K2LEXP,
   bool modelPar_given_K2LEXP,
   AdmsSensFadType & modelPar_K2W,
   bool modelPar_given_K2W,
   AdmsSensFadType & modelPar_K2WEXP,
   bool modelPar_given_K2WEXP,
   AdmsSensFadType & modelPar_K2WL,
   bool modelPar_given_K2WL,
   AdmsSensFadType & modelPar_K2WLEXP,
   bool modelPar_given_K2WLEXP,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_WK2,
   bool modelPar_given_WK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_ADOS,
   bool modelPar_given_ADOS,
   AdmsSensFadType & modelPar_BDOS,
   bool modelPar_given_BDOS,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_WCIT,
   bool modelPar_given_WCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_NFACTOR,
   bool modelPar_given_NFACTOR,
   AdmsSensFadType & modelPar_NFACTORL,
   bool modelPar_given_NFACTORL,
   AdmsSensFadType & modelPar_NFACTORLEXP,
   bool modelPar_given_NFACTORLEXP,
   AdmsSensFadType & modelPar_NFACTORW,
   bool modelPar_given_NFACTORW,
   AdmsSensFadType & modelPar_NFACTORWEXP,
   bool modelPar_given_NFACTORWEXP,
   AdmsSensFadType & modelPar_NFACTORWL,
   bool modelPar_given_NFACTORWL,
   AdmsSensFadType & modelPar_NFACTORWLEXP,
   bool modelPar_given_NFACTORWLEXP,
   AdmsSensFadType & modelPar_LNFACTOR,
   bool modelPar_given_LNFACTOR,
   AdmsSensFadType & modelPar_WNFACTOR,
   bool modelPar_given_WNFACTOR,
   AdmsSensFadType & modelPar_PNFACTOR,
   bool modelPar_given_PNFACTOR,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDL,
   bool modelPar_given_CDSCDL,
   AdmsSensFadType & modelPar_CDSCDLEXP,
   bool modelPar_given_CDSCDLEXP,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_WCDSCD,
   bool modelPar_given_WCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDLR,
   bool modelPar_given_CDSCDLR,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_WCDSCDR,
   bool modelPar_given_WCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_CDSCB,
   bool modelPar_given_CDSCB,
   AdmsSensFadType & modelPar_CDSCBL,
   bool modelPar_given_CDSCBL,
   AdmsSensFadType & modelPar_CDSCBLEXP,
   bool modelPar_given_CDSCBLEXP,
   AdmsSensFadType & modelPar_LCDSCB,
   bool modelPar_given_LCDSCB,
   AdmsSensFadType & modelPar_WCDSCB,
   bool modelPar_given_WCDSCB,
   AdmsSensFadType & modelPar_PCDSCB,
   bool modelPar_given_PCDSCB,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_WVSAT,
   bool modelPar_given_WVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_VSATL,
   bool modelPar_given_VSATL,
   AdmsSensFadType & modelPar_VSATLEXP,
   bool modelPar_given_VSATLEXP,
   AdmsSensFadType & modelPar_VSATW,
   bool modelPar_given_VSATW,
   AdmsSensFadType & modelPar_VSATWEXP,
   bool modelPar_given_VSATWEXP,
   AdmsSensFadType & modelPar_VSATWL,
   bool modelPar_given_VSATWL,
   AdmsSensFadType & modelPar_VSATWLEXP,
   bool modelPar_given_VSATWLEXP,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_WVSATR,
   bool modelPar_given_WVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_DELTA,
   bool modelPar_given_DELTA,
   AdmsSensFadType & modelPar_LDELTA,
   bool modelPar_given_LDELTA,
   AdmsSensFadType & modelPar_WDELTA,
   bool modelPar_given_WDELTA,
   AdmsSensFadType & modelPar_PDELTA,
   bool modelPar_given_PDELTA,
   AdmsSensFadType & modelPar_DELTAL,
   bool modelPar_given_DELTAL,
   AdmsSensFadType & modelPar_DELTALEXP,
   bool modelPar_given_DELTALEXP,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_WVSATCV,
   bool modelPar_given_WVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_VSATCVL,
   bool modelPar_given_VSATCVL,
   AdmsSensFadType & modelPar_VSATCVLEXP,
   bool modelPar_given_VSATCVLEXP,
   AdmsSensFadType & modelPar_VSATCVW,
   bool modelPar_given_VSATCVW,
   AdmsSensFadType & modelPar_VSATCVWEXP,
   bool modelPar_given_VSATCVWEXP,
   AdmsSensFadType & modelPar_VSATCVWL,
   bool modelPar_given_VSATCVWL,
   AdmsSensFadType & modelPar_VSATCVWLEXP,
   bool modelPar_given_VSATCVWLEXP,
   AdmsSensFadType & modelPar_UP1,
   bool modelPar_given_UP1,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_UP2,
   bool modelPar_given_UP2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_MULU0,
   bool modelPar_given_MULU0,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0L,
   bool modelPar_given_U0L,
   AdmsSensFadType & modelPar_U0LEXP,
   bool modelPar_given_U0LEXP,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_WU0,
   bool modelPar_given_WU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_WU0R,
   bool modelPar_given_WU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAL,
   bool modelPar_given_UAL,
   AdmsSensFadType & modelPar_UALEXP,
   bool modelPar_given_UALEXP,
   AdmsSensFadType & modelPar_UAW,
   bool modelPar_given_UAW,
   AdmsSensFadType & modelPar_UAWEXP,
   bool modelPar_given_UAWEXP,
   AdmsSensFadType & modelPar_UAWL,
   bool modelPar_given_UAWL,
   AdmsSensFadType & modelPar_UAWLEXP,
   bool modelPar_given_UAWLEXP,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_WUA,
   bool modelPar_given_WUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_WUAR,
   bool modelPar_given_WUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_WEU,
   bool modelPar_given_WEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_EUL,
   bool modelPar_given_EUL,
   AdmsSensFadType & modelPar_EULEXP,
   bool modelPar_given_EULEXP,
   AdmsSensFadType & modelPar_EUW,
   bool modelPar_given_EUW,
   AdmsSensFadType & modelPar_EUWEXP,
   bool modelPar_given_EUWEXP,
   AdmsSensFadType & modelPar_EUWL,
   bool modelPar_given_EUWL,
   AdmsSensFadType & modelPar_EUWLEXP,
   bool modelPar_given_EUWLEXP,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDL,
   bool modelPar_given_UDL,
   AdmsSensFadType & modelPar_UDLEXP,
   bool modelPar_given_UDLEXP,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_WUD,
   bool modelPar_given_WUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_WUDR,
   bool modelPar_given_WUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_WUCS,
   bool modelPar_given_WUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_UCSR,
   bool modelPar_given_UCSR,
   AdmsSensFadType & modelPar_LUCSR,
   bool modelPar_given_LUCSR,
   AdmsSensFadType & modelPar_WUCSR,
   bool modelPar_given_WUCSR,
   AdmsSensFadType & modelPar_PUCSR,
   bool modelPar_given_PUCSR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCL,
   bool modelPar_given_UCL,
   AdmsSensFadType & modelPar_UCLEXP,
   bool modelPar_given_UCLEXP,
   AdmsSensFadType & modelPar_UCW,
   bool modelPar_given_UCW,
   AdmsSensFadType & modelPar_UCWEXP,
   bool modelPar_given_UCWEXP,
   AdmsSensFadType & modelPar_UCWL,
   bool modelPar_given_UCWL,
   AdmsSensFadType & modelPar_UCWLEXP,
   bool modelPar_given_UCWLEXP,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_WUC,
   bool modelPar_given_WUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_WUCR,
   bool modelPar_given_WUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLML,
   bool modelPar_given_PCLML,
   AdmsSensFadType & modelPar_PCLMLEXP,
   bool modelPar_given_PCLMLEXP,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_WPCLM,
   bool modelPar_given_WPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_WPCLMR,
   bool modelPar_given_WPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_PCLMCVL,
   bool modelPar_given_PCLMCVL,
   AdmsSensFadType & modelPar_PCLMCVLEXP,
   bool modelPar_given_PCLMCVLEXP,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_WPCLMCV,
   bool modelPar_given_WPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_PSCBE1,
   bool modelPar_given_PSCBE1,
   AdmsSensFadType & modelPar_LPSCBE1,
   bool modelPar_given_LPSCBE1,
   AdmsSensFadType & modelPar_WPSCBE1,
   bool modelPar_given_WPSCBE1,
   AdmsSensFadType & modelPar_PPSCBE1,
   bool modelPar_given_PPSCBE1,
   AdmsSensFadType & modelPar_PSCBE2,
   bool modelPar_given_PSCBE2,
   AdmsSensFadType & modelPar_LPSCBE2,
   bool modelPar_given_LPSCBE2,
   AdmsSensFadType & modelPar_WPSCBE2,
   bool modelPar_given_WPSCBE2,
   AdmsSensFadType & modelPar_PPSCBE2,
   bool modelPar_given_PPSCBE2,
   AdmsSensFadType & modelPar_PDITS,
   bool modelPar_given_PDITS,
   AdmsSensFadType & modelPar_LPDITS,
   bool modelPar_given_LPDITS,
   AdmsSensFadType & modelPar_WPDITS,
   bool modelPar_given_WPDITS,
   AdmsSensFadType & modelPar_PPDITS,
   bool modelPar_given_PPDITS,
   AdmsSensFadType & modelPar_PDITSL,
   bool modelPar_given_PDITSL,
   AdmsSensFadType & modelPar_PDITSD,
   bool modelPar_given_PDITSD,
   AdmsSensFadType & modelPar_LPDITSD,
   bool modelPar_given_LPDITSD,
   AdmsSensFadType & modelPar_WPDITSD,
   bool modelPar_given_WPDITSD,
   AdmsSensFadType & modelPar_PPDITSD,
   bool modelPar_given_PPDITSD,
   AdmsSensFadType & modelPar_RSH,
   bool modelPar_given_RSH,
   AdmsSensFadType & modelPar_PRWG,
   bool modelPar_given_PRWG,
   AdmsSensFadType & modelPar_LPRWG,
   bool modelPar_given_LPRWG,
   AdmsSensFadType & modelPar_WPRWG,
   bool modelPar_given_WPRWG,
   AdmsSensFadType & modelPar_PPRWG,
   bool modelPar_given_PPRWG,
   AdmsSensFadType & modelPar_PRWB,
   bool modelPar_given_PRWB,
   AdmsSensFadType & modelPar_LPRWB,
   bool modelPar_given_LPRWB,
   AdmsSensFadType & modelPar_WPRWB,
   bool modelPar_given_WPRWB,
   AdmsSensFadType & modelPar_PPRWB,
   bool modelPar_given_PPRWB,
   AdmsSensFadType & modelPar_PRWBL,
   bool modelPar_given_PRWBL,
   AdmsSensFadType & modelPar_PRWBLEXP,
   bool modelPar_given_PRWBLEXP,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_WWR,
   bool modelPar_given_WWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_LRSWMIN,
   bool modelPar_given_LRSWMIN,
   AdmsSensFadType & modelPar_WRSWMIN,
   bool modelPar_given_WRSWMIN,
   AdmsSensFadType & modelPar_PRSWMIN,
   bool modelPar_given_PRSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_WRSW,
   bool modelPar_given_WRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_RSWL,
   bool modelPar_given_RSWL,
   AdmsSensFadType & modelPar_RSWLEXP,
   bool modelPar_given_RSWLEXP,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_LRDWMIN,
   bool modelPar_given_LRDWMIN,
   AdmsSensFadType & modelPar_WRDWMIN,
   bool modelPar_given_WRDWMIN,
   AdmsSensFadType & modelPar_PRDWMIN,
   bool modelPar_given_PRDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_WRDW,
   bool modelPar_given_WRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_RDWL,
   bool modelPar_given_RDWL,
   AdmsSensFadType & modelPar_RDWLEXP,
   bool modelPar_given_RDWLEXP,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_LRDSWMIN,
   bool modelPar_given_LRDSWMIN,
   AdmsSensFadType & modelPar_WRDSWMIN,
   bool modelPar_given_WRDSWMIN,
   AdmsSensFadType & modelPar_PRDSWMIN,
   bool modelPar_given_PRDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_RDSWL,
   bool modelPar_given_RDSWL,
   AdmsSensFadType & modelPar_RDSWLEXP,
   bool modelPar_given_RDSWLEXP,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_WRDSW,
   bool modelPar_given_WRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_WPSAT,
   bool modelPar_given_WPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_PSATL,
   bool modelPar_given_PSATL,
   AdmsSensFadType & modelPar_PSATLEXP,
   bool modelPar_given_PSATLEXP,
   AdmsSensFadType & modelPar_PSATB,
   bool modelPar_given_PSATB,
   AdmsSensFadType & modelPar_PSATR,
   bool modelPar_given_PSATR,
   AdmsSensFadType & modelPar_LPSATR,
   bool modelPar_given_LPSATR,
   AdmsSensFadType & modelPar_WPSATR,
   bool modelPar_given_WPSATR,
   AdmsSensFadType & modelPar_PPSATR,
   bool modelPar_given_PPSATR,
   AdmsSensFadType & modelPar_LPSATB,
   bool modelPar_given_LPSATB,
   AdmsSensFadType & modelPar_WPSATB,
   bool modelPar_given_WPSATB,
   AdmsSensFadType & modelPar_PPSATB,
   bool modelPar_given_PPSATB,
   AdmsSensFadType & modelPar_PSATX,
   bool modelPar_given_PSATX,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_WPTWG,
   bool modelPar_given_WPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_PTWGL,
   bool modelPar_given_PTWGL,
   AdmsSensFadType & modelPar_PTWGLEXP,
   bool modelPar_given_PTWGLEXP,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_WPTWGR,
   bool modelPar_given_WPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_PTWGLR,
   bool modelPar_given_PTWGLR,
   AdmsSensFadType & modelPar_PTWGLEXPR,
   bool modelPar_given_PTWGLEXPR,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_WA1,
   bool modelPar_given_WA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_WA11,
   bool modelPar_given_WA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_WA2,
   bool modelPar_given_WA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_WA21,
   bool modelPar_given_WA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_PDIBLC,
   bool modelPar_given_PDIBLC,
   AdmsSensFadType & modelPar_PDIBLCL,
   bool modelPar_given_PDIBLCL,
   AdmsSensFadType & modelPar_PDIBLCLEXP,
   bool modelPar_given_PDIBLCLEXP,
   AdmsSensFadType & modelPar_LPDIBLC,
   bool modelPar_given_LPDIBLC,
   AdmsSensFadType & modelPar_WPDIBLC,
   bool modelPar_given_WPDIBLC,
   AdmsSensFadType & modelPar_PPDIBLC,
   bool modelPar_given_PPDIBLC,
   AdmsSensFadType & modelPar_PDIBLCR,
   bool modelPar_given_PDIBLCR,
   AdmsSensFadType & modelPar_PDIBLCLR,
   bool modelPar_given_PDIBLCLR,
   AdmsSensFadType & modelPar_PDIBLCLEXPR,
   bool modelPar_given_PDIBLCLEXPR,
   AdmsSensFadType & modelPar_LPDIBLCR,
   bool modelPar_given_LPDIBLCR,
   AdmsSensFadType & modelPar_WPDIBLCR,
   bool modelPar_given_WPDIBLCR,
   AdmsSensFadType & modelPar_PPDIBLCR,
   bool modelPar_given_PPDIBLCR,
   AdmsSensFadType & modelPar_PDIBLCB,
   bool modelPar_given_PDIBLCB,
   AdmsSensFadType & modelPar_LPDIBLCB,
   bool modelPar_given_LPDIBLCB,
   AdmsSensFadType & modelPar_WPDIBLCB,
   bool modelPar_given_WPDIBLCB,
   AdmsSensFadType & modelPar_PPDIBLCB,
   bool modelPar_given_PPDIBLCB,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_WPVAG,
   bool modelPar_given_WPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_FPROUT,
   bool modelPar_given_FPROUT,
   AdmsSensFadType & modelPar_FPROUTL,
   bool modelPar_given_FPROUTL,
   AdmsSensFadType & modelPar_FPROUTLEXP,
   bool modelPar_given_FPROUTLEXP,
   AdmsSensFadType & modelPar_LFPROUT,
   bool modelPar_given_LFPROUT,
   AdmsSensFadType & modelPar_WFPROUT,
   bool modelPar_given_WFPROUT,
   AdmsSensFadType & modelPar_PFPROUT,
   bool modelPar_given_PFPROUT,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA0L,
   bool modelPar_given_ALPHA0L,
   AdmsSensFadType & modelPar_ALPHA0LEXP,
   bool modelPar_given_ALPHA0LEXP,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_WALPHA0,
   bool modelPar_given_WALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_WBETA0,
   bool modelPar_given_WBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_DLCIG,
   bool modelPar_given_DLCIG,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_AIGCL,
   bool modelPar_given_AIGCL,
   AdmsSensFadType & modelPar_AIGCW,
   bool modelPar_given_AIGCW,
   AdmsSensFadType & modelPar_AIGSL,
   bool modelPar_given_AIGSL,
   AdmsSensFadType & modelPar_AIGSW,
   bool modelPar_given_AIGSW,
   AdmsSensFadType & modelPar_AIGDL,
   bool modelPar_given_AIGDL,
   AdmsSensFadType & modelPar_AIGDW,
   bool modelPar_given_AIGDW,
   AdmsSensFadType & modelPar_PIGCDL,
   bool modelPar_given_PIGCDL,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_WAIGBINV,
   bool modelPar_given_WAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_WBIGBINV,
   bool modelPar_given_WBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_WCIGBINV,
   bool modelPar_given_WCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_WEIGBINV,
   bool modelPar_given_WEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_WNIGBINV,
   bool modelPar_given_WNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_WAIGBACC,
   bool modelPar_given_WAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_WBIGBACC,
   bool modelPar_given_WBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_WCIGBACC,
   bool modelPar_given_WCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_WNIGBACC,
   bool modelPar_given_WNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_WAIGC,
   bool modelPar_given_WAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_WBIGC,
   bool modelPar_given_WBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_WCIGC,
   bool modelPar_given_WCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_WAIGS,
   bool modelPar_given_WAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_WBIGS,
   bool modelPar_given_WBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_WCIGS,
   bool modelPar_given_WCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_WAIGD,
   bool modelPar_given_WAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_WBIGD,
   bool modelPar_given_WBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_WCIGD,
   bool modelPar_given_WCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_WPOXEDGE,
   bool modelPar_given_WPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LDLCIG,
   bool modelPar_given_LDLCIG,
   AdmsSensFadType & modelPar_WDLCIG,
   bool modelPar_given_WDLCIG,
   AdmsSensFadType & modelPar_PDLCIG,
   bool modelPar_given_PDLCIG,
   AdmsSensFadType & modelPar_LDLCIGD,
   bool modelPar_given_LDLCIGD,
   AdmsSensFadType & modelPar_WDLCIGD,
   bool modelPar_given_WDLCIGD,
   AdmsSensFadType & modelPar_PDLCIGD,
   bool modelPar_given_PDLCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_WNTOX,
   bool modelPar_given_WNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_AGIDLL,
   bool modelPar_given_AGIDLL,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_WAGIDL,
   bool modelPar_given_WAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_WBGIDL,
   bool modelPar_given_WBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_WCGIDL,
   bool modelPar_given_WCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_WEGIDL,
   bool modelPar_given_WEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_AGISLL,
   bool modelPar_given_AGISLL,
   AdmsSensFadType & modelPar_AGISLW,
   bool modelPar_given_AGISLW,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_WAGISL,
   bool modelPar_given_WAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_WBGISL,
   bool modelPar_given_WBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_WCGISL,
   bool modelPar_given_WCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_WEGISL,
   bool modelPar_given_WEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_CF,
   bool modelPar_given_CF,
   AdmsSensFadType & modelPar_LCF,
   bool modelPar_given_LCF,
   AdmsSensFadType & modelPar_WCF,
   bool modelPar_given_WCF,
   AdmsSensFadType & modelPar_PCF,
   bool modelPar_given_PCF,
   AdmsSensFadType & modelPar_CFRCOEFF,
   bool modelPar_given_CFRCOEFF,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_WCGSL,
   bool modelPar_given_WCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_WCGDL,
   bool modelPar_given_WCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_WCKAPPAS,
   bool modelPar_given_WCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_WCKAPPAD,
   bool modelPar_given_WCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_DMCG,
   bool modelPar_given_DMCG,
   AdmsSensFadType & modelPar_DMCI,
   bool modelPar_given_DMCI,
   AdmsSensFadType & modelPar_DMDG,
   bool modelPar_given_DMDG,
   AdmsSensFadType & modelPar_DMCGT,
   bool modelPar_given_DMCGT,
   AdmsSensFadType & modelPar_XGL,
   bool modelPar_given_XGL,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_GBMIN,
   bool modelPar_given_GBMIN,
   AdmsSensFadType & modelPar_RBPS0,
   bool modelPar_given_RBPS0,
   AdmsSensFadType & modelPar_RBPSL,
   bool modelPar_given_RBPSL,
   AdmsSensFadType & modelPar_RBPSW,
   bool modelPar_given_RBPSW,
   AdmsSensFadType & modelPar_RBPSNF,
   bool modelPar_given_RBPSNF,
   AdmsSensFadType & modelPar_RBPD0,
   bool modelPar_given_RBPD0,
   AdmsSensFadType & modelPar_RBPDL,
   bool modelPar_given_RBPDL,
   AdmsSensFadType & modelPar_RBPDW,
   bool modelPar_given_RBPDW,
   AdmsSensFadType & modelPar_RBPDNF,
   bool modelPar_given_RBPDNF,
   AdmsSensFadType & modelPar_RBPBX0,
   bool modelPar_given_RBPBX0,
   AdmsSensFadType & modelPar_RBPBXL,
   bool modelPar_given_RBPBXL,
   AdmsSensFadType & modelPar_RBPBXW,
   bool modelPar_given_RBPBXW,
   AdmsSensFadType & modelPar_RBPBXNF,
   bool modelPar_given_RBPBXNF,
   AdmsSensFadType & modelPar_RBPBY0,
   bool modelPar_given_RBPBY0,
   AdmsSensFadType & modelPar_RBPBYL,
   bool modelPar_given_RBPBYL,
   AdmsSensFadType & modelPar_RBPBYW,
   bool modelPar_given_RBPBYW,
   AdmsSensFadType & modelPar_RBPBYNF,
   bool modelPar_given_RBPBYNF,
   AdmsSensFadType & modelPar_RBSBX0,
   bool modelPar_given_RBSBX0,
   AdmsSensFadType & modelPar_RBSBY0,
   bool modelPar_given_RBSBY0,
   AdmsSensFadType & modelPar_RBDBX0,
   bool modelPar_given_RBDBX0,
   AdmsSensFadType & modelPar_RBDBY0,
   bool modelPar_given_RBDBY0,
   AdmsSensFadType & modelPar_RBSDBXL,
   bool modelPar_given_RBSDBXL,
   AdmsSensFadType & modelPar_RBSDBXW,
   bool modelPar_given_RBSDBXW,
   AdmsSensFadType & modelPar_RBSDBXNF,
   bool modelPar_given_RBSDBXNF,
   AdmsSensFadType & modelPar_RBSDBYL,
   bool modelPar_given_RBSDBYL,
   AdmsSensFadType & modelPar_RBSDBYW,
   bool modelPar_given_RBSDBYW,
   AdmsSensFadType & modelPar_RBSDBYNF,
   bool modelPar_given_RBSDBYNF,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_DWBIN,
   bool modelPar_given_DWBIN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_TNFACTOR,
   bool modelPar_given_TNFACTOR,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_WUTE,
   bool modelPar_given_WUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_UTEL,
   bool modelPar_given_UTEL,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_WUA1,
   bool modelPar_given_WUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_UA1L,
   bool modelPar_given_UA1L,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_WUC1,
   bool modelPar_given_WUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_WUD1,
   bool modelPar_given_WUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_UD1L,
   bool modelPar_given_UD1L,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_WUCSTE,
   bool modelPar_given_WUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_WPRT,
   bool modelPar_given_WPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_WAT,
   bool modelPar_given_WAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_ATL,
   bool modelPar_given_ATL,
   AdmsSensFadType & modelPar_TDELTA,
   bool modelPar_given_TDELTA,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_WPTWGT,
   bool modelPar_given_WPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_PTWGTL,
   bool modelPar_given_PTWGTL,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1EXP,
   bool modelPar_given_KT1EXP,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_WKT1,
   bool modelPar_given_WKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_KT2,
   bool modelPar_given_KT2,
   AdmsSensFadType & modelPar_LKT2,
   bool modelPar_given_LKT2,
   AdmsSensFadType & modelPar_WKT2,
   bool modelPar_given_WKT2,
   AdmsSensFadType & modelPar_PKT2,
   bool modelPar_given_PKT2,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_WIIT,
   bool modelPar_given_WIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_WIGT,
   bool modelPar_given_WIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_WTGIDL,
   bool modelPar_given_WTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KU0,
   bool modelPar_given_KU0,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKU0,
   bool modelPar_given_TKU0,
   AdmsSensFadType & modelPar_LKU0,
   bool modelPar_given_LKU0,
   AdmsSensFadType & modelPar_WKU0,
   bool modelPar_given_WKU0,
   AdmsSensFadType & modelPar_PKU0,
   bool modelPar_given_PKU0,
   AdmsSensFadType & modelPar_LLODKU0,
   bool modelPar_given_LLODKU0,
   AdmsSensFadType & modelPar_WLODKU0,
   bool modelPar_given_WLODKU0,
   AdmsSensFadType & modelPar_KVTH0,
   bool modelPar_given_KVTH0,
   AdmsSensFadType & modelPar_LKVTH0,
   bool modelPar_given_LKVTH0,
   AdmsSensFadType & modelPar_WKVTH0,
   bool modelPar_given_WKVTH0,
   AdmsSensFadType & modelPar_PKVTH0,
   bool modelPar_given_PKVTH0,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STK2,
   bool modelPar_given_STK2,
   AdmsSensFadType & modelPar_LODK2,
   bool modelPar_given_LODK2,
   AdmsSensFadType & modelPar_STETA0,
   bool modelPar_given_STETA0,
   AdmsSensFadType & modelPar_LODETA0,
   bool modelPar_given_LODETA0,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_KVTH0WE,
   bool modelPar_given_KVTH0WE,
   AdmsSensFadType & modelPar_LKVTH0WE,
   bool modelPar_given_LKVTH0WE,
   AdmsSensFadType & modelPar_WKVTH0WE,
   bool modelPar_given_WKVTH0WE,
   AdmsSensFadType & modelPar_PKVTH0WE,
   bool modelPar_given_PKVTH0WE,
   AdmsSensFadType & modelPar_K2WE,
   bool modelPar_given_K2WE,
   AdmsSensFadType & modelPar_LK2WE,
   bool modelPar_given_LK2WE,
   AdmsSensFadType & modelPar_WK2WE,
   bool modelPar_given_WK2WE,
   AdmsSensFadType & modelPar_PK2WE,
   bool modelPar_given_PK2WE,
   AdmsSensFadType & modelPar_KU0WE,
   bool modelPar_given_KU0WE,
   AdmsSensFadType & modelPar_LKU0WE,
   bool modelPar_given_LKU0WE,
   AdmsSensFadType & modelPar_WKU0WE,
   bool modelPar_given_WKU0WE,
   AdmsSensFadType & modelPar_PKU0WE,
   bool modelPar_given_PKU0WE,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEDGE,
   bool modelPar_given_WEDGE,
   AdmsSensFadType & modelPar_DGAMMAEDGE,
   bool modelPar_given_DGAMMAEDGE,
   AdmsSensFadType & modelPar_DGAMMAEDGEL,
   bool modelPar_given_DGAMMAEDGEL,
   AdmsSensFadType & modelPar_DGAMMAEDGELEXP,
   bool modelPar_given_DGAMMAEDGELEXP,
   AdmsSensFadType & modelPar_DVTEDGE,
   bool modelPar_given_DVTEDGE,
   AdmsSensFadType & modelPar_NFACTOREDGE,
   bool modelPar_given_NFACTOREDGE,
   AdmsSensFadType & modelPar_CITEDGE,
   bool modelPar_given_CITEDGE,
   AdmsSensFadType & modelPar_CDSCDEDGE,
   bool modelPar_given_CDSCDEDGE,
   AdmsSensFadType & modelPar_CDSCBEDGE,
   bool modelPar_given_CDSCBEDGE,
   AdmsSensFadType & modelPar_ETA0EDGE,
   bool modelPar_given_ETA0EDGE,
   AdmsSensFadType & modelPar_ETABEDGE,
   bool modelPar_given_ETABEDGE,
   AdmsSensFadType & modelPar_KT1EDGE,
   bool modelPar_given_KT1EDGE,
   AdmsSensFadType & modelPar_KT1LEDGE,
   bool modelPar_given_KT1LEDGE,
   AdmsSensFadType & modelPar_KT2EDGE,
   bool modelPar_given_KT2EDGE,
   AdmsSensFadType & modelPar_KT1EXPEDGE,
   bool modelPar_given_KT1EXPEDGE,
   AdmsSensFadType & modelPar_TNFACTOREDGE,
   bool modelPar_given_TNFACTOREDGE,
   AdmsSensFadType & modelPar_TETA0EDGE,
   bool modelPar_given_TETA0EDGE,
   AdmsSensFadType & modelPar_DVT0EDGE,
   bool modelPar_given_DVT0EDGE,
   AdmsSensFadType & modelPar_DVT1EDGE,
   bool modelPar_given_DVT1EDGE,
   AdmsSensFadType & modelPar_DVT2EDGE,
   bool modelPar_given_DVT2EDGE,
   // non-reals (including hidden)
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RBODYMOD,
   bool modelPar_given_RBODYMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_SCA,
   bool modelPar_given_SCA,
   int modelPar_SCB,
   bool modelPar_given_SCB,
   int modelPar_SCC,
   bool modelPar_given_SCC,
   int modelPar_SC,
   bool modelPar_given_SC,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_CVMOD,
   bool modelPar_given_CVMOD,
   int modelPar_COVMOD,
   bool modelPar_given_COVMOD,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_WPEMOD,
   bool modelPar_given_WPEMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_MOBSCALE,
   bool modelPar_given_MOBSCALE,
   int modelPar_PERMOD,
   bool modelPar_given_PERMOD,
   int modelPar_BINUNIT,
   bool modelPar_given_BINUNIT,
   int modelPar_EDGEFET,
   bool modelPar_given_EDGEFET,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType gspr;
  AdmsSensFadType gdpr;
  AdmsSensFadType QGI;
  AdmsSensFadType QBI;
  AdmsSensFadType QG;
  AdmsSensFadType QD;
  AdmsSensFadType QS;
  AdmsSensFadType QDI;
  AdmsSensFadType QSI;
  AdmsSensFadType QB;
  AdmsSensFadType ids_edge;
  AdmsSensFadType Vdssate;
  AdmsSensFadType Vdsatedge;
  AdmsSensFadType vdsatedge;
  AdmsSensFadType DGAMMAEDGE_i;
  AdmsSensFadType dvth_sce;
  AdmsSensFadType theta_sce_edge;
  AdmsSensFadType litl_edge;
  AdmsSensFadType dvth_dibl;
  AdmsSensFadType ETA0EDGE_t;
  AdmsSensFadType NFACTOREDGE_t;
  AdmsSensFadType Qovg;
  AdmsSensFadType Qovb;
  AdmsSensFadType Qovd;
  AdmsSensFadType Qovs;
  AdmsSensFadType Vgdov;
  AdmsSensFadType Vgsov;
  AdmsSensFadType Cgdof;
  AdmsSensFadType Cgsof;
  AdmsSensFadType QGi;
  AdmsSensFadType WLCOXVtinv;
  AdmsSensFadType QBi;
  AdmsSensFadType Coxeffinv;
  AdmsSensFadType XDCinv;
  AdmsSensFadType qiaCV;
  AdmsSensFadType qbaCV;
  AdmsSensFadType Qd2;
  AdmsSensFadType Qd1;
  AdmsSensFadType Qi;
  AdmsSensFadType qbeff;
  AdmsSensFadType dqgeff;
  AdmsSensFadType Tempd;
  AdmsSensFadType Temps;
  AdmsSensFadType sid;
  AdmsSensFadType sis;
  AdmsSensFadType vgpqm;
  AdmsSensFadType MdL_less_1;
  AdmsSensFadType inv_MdL_2;
  AdmsSensFadType inv_MdL;
  AdmsSensFadType MdL_2;
  AdmsSensFadType zsat;
  AdmsSensFadType dps;
  AdmsSensFadType qb;
  AdmsSensFadType qbd;
  AdmsSensFadType VdssatCV;
  AdmsSensFadType VdsatCV;
  AdmsSensFadType vdsatcv;
  AdmsSensFadType LambdaC_by2;
  AdmsSensFadType DPD;
  AdmsSensFadType invgamg2;
  AdmsSensFadType gamg2;
  AdmsSensFadType vgfbCV;
  AdmsSensFadType QSi;
  AdmsSensFadType QDi;
  AdmsSensFadType Gtnoi;
  AdmsSensFadType sidn;
  AdmsSensFadType Vtn;
  AdmsSensFadType Lvsat;
  AdmsSensFadType mid;
  AdmsSensFadType mig;
  AdmsSensFadType migid;
  AdmsSensFadType sqid;
  AdmsSensFadType sqig;
  AdmsSensFadType cm_igid;
  AdmsSensFadType thetanoisq;
  AdmsSensFadType betanoisq;
  AdmsSensFadType ctnoi;
  AdmsSensFadType FNPowerAt1Hz;
  AdmsSensFadType Swi;
  AdmsSensFadType T10;
  AdmsSensFadType Ssi;
  AdmsSensFadType Nstar;
  AdmsSensFadType Nl;
  AdmsSensFadType N0;
  AdmsSensFadType DelClm;
  AdmsSensFadType Leffnoisq;
  AdmsSensFadType Leffnoi;
  AdmsSensFadType Esatnoi;
  AdmsSensFadType LINTNOI_i;
  AdmsSensFadType Nt;
  AdmsSensFadType Qbd;
  AdmsSensFadType Qbs;
  AdmsSensFadType sarg;
  AdmsSensFadType arg;
  AdmsSensFadType Ibd;
  AdmsSensFadType Ibs;
  AdmsSensFadType IGISL;
  AdmsSensFadType IGIDL;
  AdmsSensFadType igidl;
  AdmsSensFadType igisl;
  AdmsSensFadType IGCD;
  AdmsSensFadType IGCS;
  AdmsSensFadType IGB;
  AdmsSensFadType IGD;
  AdmsSensFadType IGS;
  AdmsSensFadType igd_mult;
  AdmsSensFadType igs_mult;
  AdmsSensFadType T1_exp;
  AdmsSensFadType Vdseffx;
  AdmsSensFadType igc0;
  AdmsSensFadType Vaux_Igbinv;
  AdmsSensFadType Vaux_Igbacc;
  AdmsSensFadType Voxminv;
  AdmsSensFadType Voxmacc;
  AdmsSensFadType Voxm;
  AdmsSensFadType igd;
  AdmsSensFadType igs;
  AdmsSensFadType igcd;
  AdmsSensFadType igcs;
  AdmsSensFadType igb;
  AdmsSensFadType igbacc;
  AdmsSensFadType igbinv;
  AdmsSensFadType ISUB;
  AdmsSensFadType Iii;
  AdmsSensFadType idsovvds;
  AdmsSensFadType Gcrg;
  AdmsSensFadType ids;
  AdmsSensFadType ueff;
  AdmsSensFadType Dtot;
  AdmsSensFadType Nsat;
  AdmsSensFadType DQSD;
  AdmsSensFadType Vgd_eff;
  AdmsSensFadType Vgs_eff;
  AdmsSensFadType Dr;
  AdmsSensFadType Rdsi;
  AdmsSensFadType Rdrain;
  AdmsSensFadType Rsource;
  AdmsSensFadType Dptwg;
  AdmsSensFadType Dvsat;
  AdmsSensFadType Mscbe;
  AdmsSensFadType VaSCBE;
  AdmsSensFadType VaDITS;
  AdmsSensFadType MdL;
  AdmsSensFadType Vasat;
  AdmsSensFadType Fp;
  AdmsSensFadType Moc;
  AdmsSensFadType VaDIBL;
  AdmsSensFadType Vgst2Vtm;
  AdmsSensFadType diffVds;
  AdmsSensFadType DIBLfactor;
  AdmsSensFadType PVAGfactor;
  AdmsSensFadType EsatL;
  AdmsSensFadType Esat;
  AdmsSensFadType Dmob;
  AdmsSensFadType Eeffm;
  AdmsSensFadType qia;
  AdmsSensFadType qba;
  AdmsSensFadType Qd;
  AdmsSensFadType Qs;
  AdmsSensFadType Qb;
  AdmsSensFadType DQSD2;
  AdmsSensFadType qdeff;
  AdmsSensFadType vdeff;
  AdmsSensFadType Vdseff;
  AdmsSensFadType Vdssat;
  AdmsSensFadType Vdsat;
  AdmsSensFadType vdsat;
  AdmsSensFadType qdsat;
  AdmsSensFadType ln_T1_T2;
  AdmsSensFadType T12;
  AdmsSensFadType T11;
  AdmsSensFadType LambdaC;
  AdmsSensFadType Rdss;
  AdmsSensFadType WeffWRFactor;
  AdmsSensFadType Dmobs;
  AdmsSensFadType Eeffs;
  AdmsSensFadType qis;
  AdmsSensFadType qbs;
  AdmsSensFadType EeffFactor;
  AdmsSensFadType psiavg;
  AdmsSensFadType psipclamp;
  AdmsSensFadType qs;
  AdmsSensFadType T6;
  AdmsSensFadType T5;
  AdmsSensFadType T7;
  AdmsSensFadType sqrtpsisainv;
  AdmsSensFadType sqrtpsisa;
  AdmsSensFadType T9;
  AdmsSensFadType sqrtpsip;
  AdmsSensFadType T8;
  AdmsSensFadType psip;
  AdmsSensFadType gammaPD;
  AdmsSensFadType vgfbPD;
  AdmsSensFadType phib_n;
  AdmsSensFadType inv_gam;
  AdmsSensFadType VTH;
  AdmsSensFadType psip_th;
  AdmsSensFadType nq;
  double q_vth;
  AdmsSensFadType gam;
  AdmsSensFadType vgfb;
  AdmsSensFadType Vth_shift;
  AdmsSensFadType dVth_VNUD;
  AdmsSensFadType vfb;
  AdmsSensFadType vs;
  AdmsSensFadType vg;
  AdmsSensFadType T4;
  AdmsSensFadType dVth_ldop;
  AdmsSensFadType dvth_temp;
  AdmsSensFadType dVth_dibl;
  AdmsSensFadType inv_nVt;
  AdmsSensFadType nVt;
  AdmsSensFadType n;
  AdmsSensFadType cdsc;
  AdmsSensFadType Cdep;
  AdmsSensFadType Xdep;
  AdmsSensFadType sqrtPhistVbs;
  AdmsSensFadType PhistVbs;
  AdmsSensFadType UCS_a;
  AdmsSensFadType UC_a;
  AdmsSensFadType UA_a;
  AdmsSensFadType U0_a;
  AdmsSensFadType PTWG_a;
  AdmsSensFadType VSAT_a;
  AdmsSensFadType PSAT_a;
  AdmsSensFadType PCLM_a;
  AdmsSensFadType PDIBLC_a;
  AdmsSensFadType ETA0_a;
  AdmsSensFadType CDSCD_a;
  AdmsSensFadType wr;
  AdmsSensFadType wf;
  double Vbsx;
  double Vdsx;
  double sigvds;
  double Vgs_ov_noswap;
  double Vgd_ov_noswap;
  double Vgs_noswap;
  double Vgd_noswap;
  double Vbd_jct;
  double Vbs_jct;
  double Vdb_noswap;
  double Vsb_noswap;
  double Vds_noswap;
  double Vds;
  double Vs;
  double Vd;
  double Vg;
  AdmsSensFadType mu_well;
  AdmsSensFadType k2_well;
  AdmsSensFadType vth0_well;
  AdmsSensFadType local_scc;
  AdmsSensFadType local_scb;
  AdmsSensFadType local_sca;
  AdmsSensFadType Wdrn;
  AdmsSensFadType eta_stress;
  AdmsSensFadType k2_stress;
  AdmsSensFadType vth0_stress;
  AdmsSensFadType vsat_mult;
  AdmsSensFadType mu0_mult;
  AdmsSensFadType rho;
  AdmsSensFadType Inv_od;
  AdmsSensFadType rho_ref;
  AdmsSensFadType Inv_odref;
  AdmsSensFadType Inv_sbref;
  AdmsSensFadType Inv_saref;
  int i;
  AdmsSensFadType Inv_sb;
  AdmsSensFadType Inv_sa;
  AdmsSensFadType ku0_temp;
  AdmsSensFadType kstress_vth0;
  AdmsSensFadType tmp1_stress_vth;
  AdmsSensFadType kstress_u0;
  AdmsSensFadType tmp1_stress;
  AdmsSensFadType W_tmp_stress;
  AdmsSensFadType Czbdswg;
  AdmsSensFadType Czbdsw;
  AdmsSensFadType Czbd;
  AdmsSensFadType Czbsswg;
  AdmsSensFadType Czbssw;
  AdmsSensFadType Czbs;
  AdmsSensFadType DslpRev;
  AdmsSensFadType IVjdmRev;
  AdmsSensFadType VjdmRev;
  AdmsSensFadType DslpFwd;
  AdmsSensFadType IVjdmFwd;
  AdmsSensFadType VjdmFwd;
  AdmsSensFadType XExpBVD;
  AdmsSensFadType Nvtmd;
  AdmsSensFadType Isbd;
  AdmsSensFadType SslpRev;
  AdmsSensFadType IVjsmRev;
  AdmsSensFadType VjsmRev;
  AdmsSensFadType SslpFwd;
  AdmsSensFadType IVjsmFwd;
  AdmsSensFadType VjsmFwd;
  AdmsSensFadType Tb;
  AdmsSensFadType XExpBVS;
  AdmsSensFadType Nvtms;
  AdmsSensFadType Isbs;
  AdmsSensFadType PDeff;
  AdmsSensFadType PSeff;
  AdmsSensFadType ADeff;
  AdmsSensFadType ASeff;
  AdmsSensFadType PSiso;
  AdmsSensFadType PDiso;
  AdmsSensFadType PSsha;
  AdmsSensFadType PDsha;
  AdmsSensFadType PSmer;
  AdmsSensFadType PDmer;
  AdmsSensFadType ASiso;
  AdmsSensFadType ADiso;
  AdmsSensFadType ASsha;
  AdmsSensFadType ADsha;
  AdmsSensFadType ASmer;
  AdmsSensFadType ADmer;
  AdmsSensFadType temp_ADeff;
  AdmsSensFadType temp_ASeff;
  AdmsSensFadType temp_PDeff;
  AdmsSensFadType temp_PSeff;
  AdmsSensFadType NJTSSWGD_t;
  AdmsSensFadType NJTSSWD_t;
  AdmsSensFadType NJTSD_t;
  AdmsSensFadType NJTSSWG_t;
  AdmsSensFadType NJTSSW_t;
  AdmsSensFadType NJTS_t;
  AdmsSensFadType JTSSWGD_t;
  AdmsSensFadType JTSSWD_t;
  AdmsSensFadType JTSD_t;
  AdmsSensFadType JTSSWGS_t;
  AdmsSensFadType JTSSWS_t;
  AdmsSensFadType JTSS_t;
  AdmsSensFadType JSWGD_t;
  AdmsSensFadType JSWD_t;
  AdmsSensFadType JSD_t;
  AdmsSensFadType JSWGS_t;
  AdmsSensFadType JSWS_t;
  AdmsSensFadType JSS_t;
  AdmsSensFadType T3;
  AdmsSensFadType PBSWGD_t;
  AdmsSensFadType PBSWGS_t;
  AdmsSensFadType PBSWD_t;
  AdmsSensFadType PBSWS_t;
  AdmsSensFadType PBD_t;
  AdmsSensFadType PBS_t;
  AdmsSensFadType CJSWGD_t;
  AdmsSensFadType CJSWGS_t;
  AdmsSensFadType CJSWD_t;
  AdmsSensFadType CJSWS_t;
  AdmsSensFadType CJD_t;
  AdmsSensFadType CJS_t;
  AdmsSensFadType igtemp;
  AdmsSensFadType BGISL_t;
  AdmsSensFadType BGIDL_t;
  AdmsSensFadType BETA0_t;
  AdmsSensFadType A2_t;
  AdmsSensFadType A1_t;
  AdmsSensFadType PTWG_t;
  AdmsSensFadType DELTA_t;
  AdmsSensFadType VSATCV_t;
  AdmsSensFadType VSAT_t;
  AdmsSensFadType rdstemp;
  AdmsSensFadType UCS_t;
  AdmsSensFadType UD_t;
  AdmsSensFadType UC_t;
  AdmsSensFadType UA_t;
  AdmsSensFadType U0_t;
  AdmsSensFadType eta_mu;
  AdmsSensFadType ETA0_t;
  AdmsSensFadType NFACTOR_t;
  AdmsSensFadType litl;
  AdmsSensFadType T1DEP;
  AdmsSensFadType sqrtPhist;
  AdmsSensFadType Phist;
  AdmsSensFadType Vfbsdr;
  AdmsSensFadType Vbi;
  AdmsSensFadType phib;
  AdmsSensFadType ni;
  AdmsSensFadType Eg0;
  AdmsSensFadType Eg;
  AdmsSensFadType Vtm0;
  AdmsSensFadType Vtm;
  AdmsSensFadType delTemp;
  AdmsSensFadType TRatio;
  AdmsSensFadType inv_Vt;
  AdmsSensFadType Vt;
  AdmsSensFadType TK;
  double delTemp1;
  AdmsSensFadType DevTemp;
  AdmsSensFadType Tnom;


  // -- code converted from analog/code block
  if ((modelPar_TNOM<=(-273.15)))
  {
    instanceVar_T0 = (300.15-273.15);
    std::cerr  << "Warning: TNOM = %e C <= %e C. Setting TNOM to %e C." << modelPar_TNOM << (-273.15) << instanceVar_T0 <<  std::endl; 
    Tnom = 300.15;
  }
  else
  {
    Tnom = (modelPar_TNOM+273.15);
  }
  DevTemp = (admsTemperature+modelPar_DTEMP);
  if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0)))
  {
    delTemp1 = (probeVars[admsProbeID_Temp_t_GND]);
  }
  else
  {
    delTemp1 = 0;
  }
  DevTemp = (delTemp1+DevTemp);
  TK = DevTemp;
  Vt = adms_vt(DevTemp);
  inv_Vt = (1.0/Vt);
  TRatio = (DevTemp/Tnom);
  delTemp = (DevTemp-Tnom);
  Vtm = (8.617087e-5*DevTemp);
  Vtm0 = (8.617087e-5*Tnom);
  Eg = (modelPar_BG0SUB-(((modelPar_TBGASUB*DevTemp)*DevTemp)/(DevTemp+modelPar_TBGBSUB)));
  Eg0 = (modelPar_BG0SUB-(((modelPar_TBGASUB*Tnom)*Tnom)/(Tnom+modelPar_TBGBSUB)));
  instanceVar_T1 = ((DevTemp/Tnom)*sqrt((DevTemp/Tnom)));
  ni = ((modelPar_NI0SUB*instanceVar_T1)*AnalogFunctions::lexp<AdmsSensFadType>(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
  if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0)))
  {
    instanceVar_T0 = AnalogFunctions::lln<AdmsSensFadType>((instanceVar_NDEP_i/ni));
    phib = sqrt(((instanceVar_T0*instanceVar_T0)+1.0E-6));
  }
  else
  {
    phib = AnalogFunctions::lln<AdmsSensFadType>((instanceVar_NDEP_i/ni));
  }
  if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0)))
  {
    instanceVar_T0 = AnalogFunctions::lln<AdmsSensFadType>((((instanceVar_NDEP_i*modelPar_NSD)/ni)*ni));
    Vbi = sqrt(((instanceVar_T0*instanceVar_T0)+1.0E-6));
  }
  else
  {
    Vbi = AnalogFunctions::lln<AdmsSensFadType>((((instanceVar_NDEP_i*modelPar_NSD)/ni)*ni));
  }
  if ((instanceVar_NGATE_i>0))
  {
    Vfbsdr = ((((-instanceVar_devsign)*Vt)*AnalogFunctions::lln<AdmsSensFadType>((instanceVar_NGATE_i/instanceVar_NSD_i)))+instancePar_VFBSDOFF);
  }
  else
  {
    Vfbsdr = 0.0;
  }
  Phist = max(((0.4+(Vt*phib))+instanceVar_PHIN_i),static_cast<double>(0.4));
  sqrtPhist = sqrt(Phist);
  T1DEP = sqrt(((2.0*instanceVar_epssi)/(1.60219e-19*instanceVar_NDEP_i)));
  litl = sqrt((((instanceVar_epssi/instanceVar_epsox)*modelPar_TOXE)*instanceVar_XJ_i));
  NFACTOR_t = (instanceVar_NFACTOR_i*AnalogFunctions::hypsmooth<AdmsSensFadType>((1.0+(modelPar_TNFACTOR*(TRatio-1.0))),1e-3));
  ETA0_t = (instanceVar_ETA0_i*(1.0+(modelPar_TETA0*(TRatio-1.0))));
  if ((modelPar_ASYMMOD!=0))
  {
    instanceVar_ETA0R_t = (instanceVar_ETA0R_i*(1.0+(modelPar_TETA0*(TRatio-1.0))));
  }
  eta_mu = adms_ternary_op<AdmsSensFadType>((modelPar_TYPE!=1),(0.33333333333333333*modelPar_ETAMOB),(0.5*modelPar_ETAMOB));
  U0_t = (instanceVar_U0_i*pow(TRatio,instanceVar_UTE_i));
  UA_t = (instanceVar_UA_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3));
  UC_t = (instanceVar_UC_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3));
  UD_t = (instanceVar_UD_i*pow(TRatio,instanceVar_UD1_i));
  UCS_t = (instanceVar_UCS_i*pow(TRatio,instanceVar_UCSTE_i));
  if ((modelPar_ASYMMOD!=0))
  {
    instanceVar_U0R_t = (instanceVar_U0R_i*pow(TRatio,instanceVar_UTE_i));
    instanceVar_UAR_t = (instanceVar_UAR_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3));
    instanceVar_UCR_t = (instanceVar_UCR_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3));
    instanceVar_UDR_t = (instanceVar_UDR_i*pow(TRatio,instanceVar_UD1_i));
    instanceVar_UCSR_t = (instanceVar_UCSR_i*pow(TRatio,instanceVar_UCSTE_i));
  }
  rdstemp = pow(TRatio,instanceVar_PRT_i);
  VSAT_t = (instanceVar_VSAT_i*pow(TRatio,(-instanceVar_AT_i)));
  if ((VSAT_t<100.0))
  {
    std::cerr  << "Warning: VSAT(%f) = %e is less than 100, setting it to 100." << DevTemp << VSAT_t <<  std::endl; 
    VSAT_t = 100.0;
  }
  if ((modelPar_ASYMMOD!=0))
  {
    instanceVar_VSATR_t = (instanceVar_VSATR_i*pow(TRatio,(-instanceVar_AT_i)));
    if ((instanceVar_VSATR_t<100.0))
    {
      std::cerr  << "Warning: VSATR(%f) = %e is less than 100, setting it to 100." << DevTemp << instanceVar_VSATR_t <<  std::endl; 
      instanceVar_VSATR_t = 100.0;
    }
  }
  VSATCV_t = (instanceVar_VSATCV_i*pow(TRatio,(-instanceVar_AT_i)));
  if ((VSATCV_t<100.0))
  {
    std::cerr  << "Warning: VSATCV(%f) = %e is less than 100, setting it to 100." << DevTemp << VSATCV_t <<  std::endl; 
    VSATCV_t = 100.0;
  }
  DELTA_t = (1.0/(AnalogFunctions::hypsmooth<AdmsSensFadType>((((1.0/instanceVar_DELTA_i)*(1.0+(modelPar_TDELTA*delTemp)))-2.0),1.0E-3)+2.0));
  PTWG_t = (instanceVar_PTWG_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0-(instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3));
  if ((modelPar_ASYMMOD!=0))
  {
    instanceVar_PTWGR_t = (instanceVar_PTWGR_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0-(instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3));
  }
  A1_t = (instanceVar_A1_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_A11_i*delTemp))-1.0E-6),1.0E-3));
  A2_t = (instanceVar_A2_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_A21_i*delTemp))-1.0E-6),1.0E-3));
  BETA0_t = (instanceVar_BETA0_i*pow(TRatio,instanceVar_IIT_i));
  BGIDL_t = (instanceVar_BGIDL_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3));
  BGISL_t = (instanceVar_BGISL_i*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3));
  igtemp = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_IGT_i*AnalogFunctions::lln<AdmsSensFadType>(TRatio)));
  CJS_t = (modelPar_CJS*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
  CJD_t = (modelPar_CJD*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
  CJSWS_t = (modelPar_CJSWS*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
  CJSWD_t = (modelPar_CJSWD*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
  CJSWGS_t = (modelPar_CJSWGS*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
  CJSWGD_t = (modelPar_CJSWGD*AnalogFunctions::hypsmooth<AdmsSensFadType>(((1.0+(modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
  PBS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBS-(modelPar_TPB*delTemp))-0.01),1.0E-3)+0.01);
  PBD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBD-(modelPar_TPB*delTemp))-0.01),1.0E-3)+0.01);
  PBSWS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWS-(modelPar_TPBSW*delTemp))-0.01),1.0E-3)+0.01);
  PBSWD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWD-(modelPar_TPBSW*delTemp))-0.01),1.0E-3)+0.01);
  PBSWGS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWGS-(modelPar_TPBSWG*delTemp))-0.01),1.0E-3)+0.01);
  PBSWGD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_PBSWGD-(modelPar_TPBSWG*delTemp))-0.01),1.0E-3)+0.01);
  instanceVar_T0 = ((Eg0/Vtm0)-(Eg/Vtm));
  instanceVar_T1 = AnalogFunctions::lln<AdmsSensFadType>(TRatio);
  T3 = AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0+(modelPar_XTIS*instanceVar_T1))/modelPar_NJS));
  JSS_t = (modelPar_JSS*T3);
  JSWS_t = (modelPar_JSWS*T3);
  JSWGS_t = (modelPar_JSWGS*T3);
  T3 = AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0+(modelPar_XTID*instanceVar_T1))/modelPar_NJD));
  JSD_t = (modelPar_JSD*T3);
  JSWD_t = (modelPar_JSWD*T3);
  JSWGD_t = (modelPar_JSWGD*T3);
  JTSS_t = (modelPar_JTSS*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSS)*(TRatio-1.0))/Vtm)));
  JTSSWS_t = (modelPar_JTSSWS*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWS)*(TRatio-1.0))/Vtm)));
  JTSSWGS_t = ((modelPar_JTSSWGS*(sqrt((modelPar_JTWEFF/instanceVar_Weffcj))+1.0))*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWGS)*(TRatio-1))/Vtm)));
  JTSD_t = (modelPar_JTSD*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSD)*(TRatio-1.0))/Vtm)));
  JTSSWD_t = (modelPar_JTSSWD*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWD)*(TRatio-1.0))/Vtm)));
  JTSSWGD_t = ((modelPar_JTSSWGD*(sqrt((modelPar_JTWEFF/instanceVar_Weffcj))+1.0))*AnalogFunctions::lexp<AdmsSensFadType>((((Eg0*modelPar_XTSSWGD)*(TRatio-1))/Vtm)));
  NJTS_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTS*(1.0+(modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSW_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSW*(1.0+(modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSWG_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSWG*(1.0+(modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSD*(1.0+(modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSWD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSWD*(1.0+(modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  NJTSSWGD_t = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_NJTSSWGD*(1.0+(modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
  {
    if ((instancePar_GEOMOD<9))
    {
      if (((instancePar_NF%2)!=0))
      {
        instanceVar_nuEndD = 1.0;
        instanceVar_nuEndS = 1.0;
        instanceVar_nuIntD = (2.0*std::max(((instancePar_NF-1.0)/2.0),static_cast<double>(0.0)));
        instanceVar_nuIntS = instanceVar_nuIntD;
      }
      else
      {
        if ((instancePar_MINZ==1))
        {
          instanceVar_nuEndD = 2.0;
          instanceVar_nuIntD = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
          instanceVar_nuEndS = 0.0;
          instanceVar_nuIntS = instancePar_NF;
        }
        else
        {
          instanceVar_nuEndD = 0.0;
          instanceVar_nuIntD = instancePar_NF;
          instanceVar_nuEndS = 2.0;
          instanceVar_nuIntS = (2.0*std::max(((instancePar_NF/2.0)-1.0),static_cast<double>(0.0)));
        }
      }
    }
    instanceVar_T0 = (instanceVar_DMCGeff+instanceVar_DMCIeff);
    instanceVar_T1 = (instanceVar_DMCGeff+instanceVar_DMCGeff);
    instanceVar_T2 = (instanceVar_DMDGeff+instanceVar_DMDGeff);
    PSiso = ((instanceVar_T0+instanceVar_T0)+instanceVar_Weffcj);
    PDiso = ((instanceVar_T0+instanceVar_T0)+instanceVar_Weffcj);
    PSsha = instanceVar_T1;
    PDsha = instanceVar_T1;
    PSmer = instanceVar_T2;
    PDmer = instanceVar_T2;
    ASiso = (instanceVar_T0*instanceVar_Weffcj);
    ADiso = (instanceVar_T0*instanceVar_Weffcj);
    ASsha = (instanceVar_DMCGeff*instanceVar_Weffcj);
    ADsha = (instanceVar_DMCGeff*instanceVar_Weffcj);
    ASmer = (instanceVar_DMDGeff*instanceVar_Weffcj);
    ADmer = (instanceVar_DMDGeff*instanceVar_Weffcj);
    if ( instancePar_GEOMOD == (0))
    {
      temp_PSeff = ((instanceVar_nuEndS*PSiso)+(instanceVar_nuIntS*PSsha));
      temp_PDeff = ((instanceVar_nuEndD*PDiso)+(instanceVar_nuIntD*PDsha));
      temp_ASeff = ((instanceVar_nuEndS*ASiso)+(instanceVar_nuIntS*ASsha));
      temp_ADeff = ((instanceVar_nuEndD*ADiso)+(instanceVar_nuIntD*ADsha));
    }
    else
      if ( instancePar_GEOMOD == (1))
      {
        temp_PSeff = ((instanceVar_nuEndS*PSiso)+(instanceVar_nuIntS*PSsha));
        temp_PDeff = ((instanceVar_nuEndD+instanceVar_nuIntD)*PDsha);
        temp_ASeff = ((instanceVar_nuEndS*ASiso)+(instanceVar_nuIntS*ASsha));
        temp_ADeff = ((instanceVar_nuEndD+instanceVar_nuIntD)*ADsha);
      }
      else
        if ( instancePar_GEOMOD == (2))
        {
          temp_PSeff = ((instanceVar_nuEndS+instanceVar_nuIntS)*PSsha);
          temp_PDeff = ((instanceVar_nuEndD*PDiso)+(instanceVar_nuIntD*PDsha));
          temp_ASeff = ((instanceVar_nuEndS+instanceVar_nuIntS)*ASsha);
          temp_ADeff = ((instanceVar_nuEndD*ADiso)+(instanceVar_nuIntD*ADsha));
        }
        else
          if ( instancePar_GEOMOD == (3))
          {
            temp_PSeff = ((instanceVar_nuEndS+instanceVar_nuIntS)*PSsha);
            temp_PDeff = ((instanceVar_nuEndD+instanceVar_nuIntD)*PDsha);
            temp_ASeff = ((instanceVar_nuEndS+instanceVar_nuIntS)*ASsha);
            temp_ADeff = ((instanceVar_nuEndD+instanceVar_nuIntD)*ADsha);
          }
          else
            if ( instancePar_GEOMOD == (4))
            {
              temp_PSeff = ((instanceVar_nuEndS*PSiso)+(instanceVar_nuIntS*PSsha));
              temp_PDeff = ((instanceVar_nuEndD*PDmer)+(instanceVar_nuIntD*PDsha));
              temp_ASeff = ((instanceVar_nuEndS*ASiso)+(instanceVar_nuIntS*ASsha));
              temp_ADeff = ((instanceVar_nuEndD*ADmer)+(instanceVar_nuIntD*ADsha));
            }
            else
              if ( instancePar_GEOMOD == (5))
              {
                temp_PSeff = ((instanceVar_nuEndS+instanceVar_nuIntS)*PSsha);
                temp_PDeff = ((instanceVar_nuEndD*PDmer)+(instanceVar_nuIntD*PDsha));
                temp_ASeff = ((instanceVar_nuEndS+instanceVar_nuIntS)*ASsha);
                temp_ADeff = ((instanceVar_nuEndD*ADmer)+(instanceVar_nuIntD*ADsha));
              }
              else
                if ( instancePar_GEOMOD == (6))
                {
                  temp_PSeff = ((instanceVar_nuEndS*PSmer)+(instanceVar_nuIntS*PSsha));
                  temp_PDeff = ((instanceVar_nuEndD*PDiso)+(instanceVar_nuIntD*PDsha));
                  temp_ASeff = ((instanceVar_nuEndS*ASmer)+(instanceVar_nuIntS*ASsha));
                  temp_ADeff = ((instanceVar_nuEndD*ADiso)+(instanceVar_nuIntD*ADsha));
                }
                else
                  if ( instancePar_GEOMOD == (7))
                  {
                    temp_PSeff = ((instanceVar_nuEndS*PSmer)+(instanceVar_nuIntS*PSsha));
                    temp_PDeff = ((instanceVar_nuEndD+instanceVar_nuIntD)*PDsha);
                    temp_ASeff = ((instanceVar_nuEndS*ASmer)+(instanceVar_nuIntS*ASsha));
                    temp_ADeff = ((instanceVar_nuEndD+instanceVar_nuIntD)*ADsha);
                  }
                  else
                    if ( instancePar_GEOMOD == (8))
                    {
                      temp_PSeff = ((instanceVar_nuEndS*PSmer)+(instanceVar_nuIntS*PSsha));
                      temp_PDeff = ((instanceVar_nuEndD*PDmer)+(instanceVar_nuIntD*PDsha));
                      temp_ASeff = ((instanceVar_nuEndS*ASmer)+(instanceVar_nuIntS*ASsha));
                      temp_ADeff = ((instanceVar_nuEndD*ADmer)+(instanceVar_nuIntD*ADsha));
                    }
                    else
                      if ( instancePar_GEOMOD == (9))
                      {
                        temp_PSeff = (PSiso+((instancePar_NF-1.0)*PSsha));
                        temp_PDeff = (instancePar_NF*PDsha);
                        temp_ASeff = (ASiso+((instancePar_NF-1.0)*ASsha));
                        temp_ADeff = (instancePar_NF*ADsha);
                      }
                      else
                        if ( instancePar_GEOMOD == (10))
                        {
                          temp_PSeff = (instancePar_NF*PSsha);
                          temp_PDeff = (PDiso+((instancePar_NF-1.0)*PDsha));
                          temp_ASeff = (instancePar_NF*ASsha);
                          temp_ADeff = (ADiso+((instancePar_NF-1.0)*ADsha));
                        }
                        else
                        {
                          temp_PSeff = 0;
                          temp_PDeff = 0;
                          temp_ASeff = 0;
                          temp_ADeff = 0;
                        }
  }
  if (instancePar_given_AS)
  {
    ASeff = ((instancePar_AS*modelPar_WMLT)*modelPar_LMLT);
  }
  else
  {
    ASeff = temp_ASeff;
  }
  if ((ASeff<0.0))
  {
    std::cerr  << "Warning: (instance %M) ASeff = %e is negative, set to zero." << ASeff <<  std::endl; 
    ASeff = 0.0;
  }
  if (instancePar_given_AD)
  {
    ADeff = ((instancePar_AD*modelPar_WMLT)*modelPar_LMLT);
  }
  else
  {
    ADeff = temp_ADeff;
  }
  if ((ADeff<0.0))
  {
    std::cerr  << "Warning: (instance %M) ADeff = %e is negative, set to zero." << ADeff <<  std::endl; 
    ADeff = 0.0;
  }
  if (instancePar_given_PS)
  {
    if ((modelPar_PERMOD==0))
    {
      PSeff = (instancePar_PS*modelPar_WMLT);
    }
    else
    {
      PSeff = max(((instancePar_PS*modelPar_WMLT)-(instanceVar_Weffcj*instancePar_NF)),static_cast<double>(0.0));
    }
  }
  else
  {
    PSeff = temp_PSeff;
    if ((PSeff<0.0))
    {
      std::cerr  << "Warning: (instance %M) PSeff = %e is negative.Set to 0.0" << PSeff <<  std::endl; 
      PSeff = 0.0;
    }
  }
  if (instancePar_given_PD)
  {
    if ((modelPar_PERMOD==0))
    {
      PDeff = (instancePar_PD*modelPar_WMLT);
    }
    else
    {
      PDeff = max(((instancePar_PD*modelPar_WMLT)-(instanceVar_Weffcj*instancePar_NF)),static_cast<double>(0.0));
    }
  }
  else
  {
    PDeff = temp_PDeff;
    if ((PDeff<0.0))
    {
      std::cerr  << "Warning: (instance %M) PDeff = %e is negative.Set to 0.0" << PDeff <<  std::endl; 
      PDeff = 0.0;
    }
  }
  Isbs = (((ASeff*JSS_t)+(PSeff*JSWS_t))+((instanceVar_Weffcj*instancePar_NF)*JSWGS_t));
  if ((Isbs>0.0))
  {
    Nvtms = (Vtm*modelPar_NJS);
    XExpBVS = (AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_BVS)/Nvtms))*modelPar_XJBVS);
    instanceVar_T2 = max((modelPar_IJTHSFWD/Isbs),static_cast<double>(10.0));
    Tb = ((1.0+instanceVar_T2)-XExpBVS);
    VjsmFwd = (Nvtms*AnalogFunctions::lln<AdmsSensFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4*XExpBVS)))))));
    instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((VjsmFwd/Nvtms));
    IVjsmFwd = (Isbs*(((instanceVar_T0-(XExpBVS/instanceVar_T0))+XExpBVS)-1.0));
    SslpFwd = ((Isbs*(instanceVar_T0+(XExpBVS/instanceVar_T0)))/Nvtms);
    instanceVar_T2 = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_IJTHSREV/Isbs)-10.0),1.0E-3)+10.0);
    VjsmRev = ((-modelPar_BVS)-(Nvtms*AnalogFunctions::lln<AdmsSensFadType>(((instanceVar_T2-1.0)/modelPar_XJBVS))));
    instanceVar_T1 = (modelPar_XJBVS*AnalogFunctions::lexp<AdmsSensFadType>(((-(modelPar_BVS+VjsmRev))/Nvtms)));
    IVjsmRev = (Isbs*(1.0+instanceVar_T1));
    SslpRev = (((-Isbs)*instanceVar_T1)/Nvtms);
  }
  else
  {
    Nvtms = 0;
    XExpBVS = 0;
    VjsmFwd = 0;
    IVjsmFwd = 0;
    SslpFwd = 0;
    VjsmRev = 0;
    IVjsmRev = 0;
    SslpRev = 0;
  }
  Isbd = (((ADeff*JSD_t)+(PDeff*JSWD_t))+((instanceVar_Weffcj*instancePar_NF)*JSWGD_t));
  if ((Isbd>0.0))
  {
    Nvtmd = (Vtm*modelPar_NJD);
    XExpBVD = (AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_BVD)/Nvtmd))*modelPar_XJBVD);
    instanceVar_T2 = max((modelPar_IJTHDFWD/Isbd),static_cast<double>(10.0));
    Tb = ((1.0+instanceVar_T2)-XExpBVD);
    VjdmFwd = (Nvtmd*AnalogFunctions::lln<AdmsSensFadType>((0.5*(Tb+sqrt(((Tb*Tb)+(4*XExpBVD)))))));
    instanceVar_T0 = AnalogFunctions::lexp<AdmsSensFadType>((VjdmFwd/Nvtmd));
    IVjdmFwd = (Isbd*(((instanceVar_T0-(XExpBVD/instanceVar_T0))+XExpBVD)-1.0));
    DslpFwd = ((Isbd*(instanceVar_T0+(XExpBVD/instanceVar_T0)))/Nvtmd);
    instanceVar_T2 = (AnalogFunctions::hypsmooth<AdmsSensFadType>(((modelPar_IJTHDREV/Isbd)-10.0),1.0E-3)+10.0);
    VjdmRev = ((-modelPar_BVD)-(Nvtmd*AnalogFunctions::lln<AdmsSensFadType>(((instanceVar_T2-1.0)/modelPar_XJBVD))));
    instanceVar_T1 = (modelPar_XJBVD*AnalogFunctions::lexp<AdmsSensFadType>(((-(modelPar_BVD+VjdmRev))/Nvtmd)));
    IVjdmRev = (Isbd*(1.0+instanceVar_T1));
    DslpRev = (((-Isbd)*instanceVar_T1)/Nvtmd);
  }
  else
  {
    Nvtmd = 0;
    XExpBVD = 0;
    VjdmFwd = 0;
    IVjdmFwd = 0;
    DslpFwd = 0;
    VjdmRev = 0;
    IVjdmRev = 0;
    DslpRev = 0;
  }
  Czbs = (CJS_t*ASeff);
  Czbssw = (CJSWS_t*PSeff);
  Czbsswg = ((CJSWGS_t*instanceVar_Weffcj)*instancePar_NF);
  Czbd = (CJD_t*ADeff);
  Czbdsw = (CJSWD_t*PDeff);
  Czbdswg = ((CJSWGD_t*instanceVar_Weffcj)*instancePar_NF);
  if ((((((modelPar_KU0!=0)||(modelPar_KVSAT!=0))||(modelPar_KVTH0!=0))||(modelPar_STK2!=0))||(modelPar_STETA0!=0)))
  {
    instanceVar_T0 = pow(instanceVar_Lnew,modelPar_LLODKU0);
    W_tmp_stress = (instanceVar_Wnew+modelPar_WLOD);
    instanceVar_T1 = pow(W_tmp_stress,modelPar_WLODKU0);
    tmp1_stress = (((modelPar_LKU0/instanceVar_T0)+(modelPar_WKU0/instanceVar_T1))+(modelPar_PKU0/(instanceVar_T0*instanceVar_T1)));
    kstress_u0 = (1.0+tmp1_stress);
    instanceVar_T0 = pow(instanceVar_Lnew,modelPar_LLODVTH);
    instanceVar_T1 = pow(W_tmp_stress,modelPar_WLODVTH);
    tmp1_stress_vth = (((modelPar_LKVTH0/instanceVar_T0)+(modelPar_WKVTH0/instanceVar_T1))+(modelPar_PKVTH0/(instanceVar_T0*instanceVar_T1)));
    kstress_vth0 = (1.0+tmp1_stress_vth);
    instanceVar_T0 = (TRatio-1.0);
    ku0_temp = ((kstress_u0*(1.0+(modelPar_TKU0*instanceVar_T0)))+1.0e-9);
    Inv_sa = 0;
    Inv_sb = 0;
    for (i=0;(i<instancePar_NF);i=(i+1) )//Begin block forloop
    {
      instanceVar_T0 = ((1.0/instancePar_NF)/((instancePar_SA+(0.5*instanceVar_L_mult))+(i*(instancePar_SD+instanceVar_L_mult))));
      instanceVar_T1 = ((1.0/instancePar_NF)/((instancePar_SB+(0.5*instanceVar_L_mult))+(i*(instancePar_SD+instanceVar_L_mult))));
      Inv_sa = (Inv_sa+instanceVar_T0);
      Inv_sb = (Inv_sb+instanceVar_T1);
    }
    // End block forloop
    Inv_saref = (1.0/(modelPar_SAREF+(0.5*instanceVar_L_mult)));
    Inv_sbref = (1.0/(modelPar_SBREF+(0.5*instanceVar_L_mult)));
    Inv_odref = (Inv_saref+Inv_sbref);
    rho_ref = ((modelPar_KU0/ku0_temp)*Inv_odref);
    Inv_od = (Inv_sa+Inv_sb);
    rho = ((modelPar_KU0/ku0_temp)*Inv_od);
    mu0_mult = ((1.0+rho)/(1.0+rho_ref));
    vsat_mult = ((1.0+(rho*modelPar_KVSAT))/(1.0+(rho_ref*modelPar_KVSAT)));
    vth0_stress = ((modelPar_KVTH0/kstress_vth0)*(Inv_od-Inv_odref));
    k2_stress = ((modelPar_STK2/pow(kstress_vth0,modelPar_LODK2))*(Inv_od-Inv_odref));
    eta_stress = ((modelPar_STETA0/pow(kstress_vth0,modelPar_LODETA0))*(Inv_od-Inv_odref));
    U0_t = (U0_t*mu0_mult);
    VSAT_t = (VSAT_t*vsat_mult);
    instanceVar_K2_i = (instanceVar_K2_i+k2_stress);
    ETA0_t = (ETA0_t+eta_stress);
  }
  else
  {
    vth0_stress = 0;
  }
  if (modelPar_WPEMOD)
  {
    Wdrn = (instancePar_W/instancePar_NF);
    local_sca = instancePar_SCA;
    local_scb = instancePar_SCB;
    local_scc = instancePar_SCC;
    if ((((!instancePar_given_SCA)&&(!instancePar_given_SCB))&&(!instancePar_given_SCC)))
    {
      if ((instancePar_given_SC&&(instancePar_SC>0.0)))
      {
        instanceVar_T1 = (instancePar_SC+Wdrn);
        instanceVar_T2 = (1.0/modelPar_SCREF);
        local_sca = ((modelPar_SCREF*modelPar_SCREF)/(instancePar_SC*instanceVar_T1));
        local_scb = (((((0.1*instancePar_SC)+(0.01*modelPar_SCREF))*exp((((-10.0)*instancePar_SC)*instanceVar_T2)))-(((0.1*instanceVar_T1)+(0.01*modelPar_SCREF))*exp((((-10.0)*instanceVar_T1)*instanceVar_T2))))/Wdrn);
        local_scc = (((((0.05*instancePar_SC)+(0.0025*modelPar_SCREF))*exp((((-20.0)*instancePar_SC)*instanceVar_T2)))-(((0.05*instanceVar_T1)+(0.0025*modelPar_SCREF))*exp((((-20.0)*instanceVar_T1)*instanceVar_T2))))/Wdrn);
      }
      else
      {
      }
    }
  }
  vth0_well = (instanceVar_KVTH0WE_i*((local_sca+(modelPar_WEB*local_scb))+(modelPar_WEC*local_scc)));
  k2_well = (instanceVar_K2WE_i*((local_sca+(modelPar_WEB*local_scb))+(modelPar_WEC*local_scc)));
  mu_well = (1.0+(instanceVar_KU0WE_i*((local_sca+(modelPar_WEB*local_scb))+(modelPar_WEC*local_scc))));
  U0_t = (U0_t*mu_well);
  instanceVar_K2_i = (instanceVar_K2_i+k2_well);
  Vg = (instanceVar_devsign*(probeVars[admsProbeID_V_gi_bi]));
  Vd = (instanceVar_devsign*(probeVars[admsProbeID_V_di_bi]));
  Vs = (instanceVar_devsign*(probeVars[admsProbeID_V_si_bi]));
  Vds = (Vd-Vs);
  Vds_noswap = Vds;
  Vsb_noswap = Vs;
  Vdb_noswap = Vd;
  Vbs_jct = (instanceVar_devsign*(probeVars[admsProbeID_V_sbulk_si]));
  Vbd_jct = (instanceVar_devsign*(probeVars[admsProbeID_V_dbulk_di]));
  Vgd_noswap = (Vg-Vd);
  Vgs_noswap = (Vg-Vs);
  Vgd_ov_noswap = (instanceVar_devsign*(probeVars[admsProbeID_V_gm_di]));
  Vgs_ov_noswap = (instanceVar_devsign*(probeVars[admsProbeID_V_gm_si]));
  sigvds = 1.0;
  if ((Vds<0.0))
  {
    sigvds = (-1.0);
    Vd = (instanceVar_devsign*(probeVars[admsProbeID_V_si_bi]));
    Vs = (instanceVar_devsign*(probeVars[admsProbeID_V_di_bi]));
  }
  Vds = (Vd-Vs);
  Vdsx = (sqrt(((Vds*Vds)+0.01))-0.1);
  Vbsx = (-(Vs+(0.5*(Vds-Vdsx))));
  instanceVar_T0 = tanh(((0.6*Vds_noswap)/Vtm));
  wf = (0.5+(0.5*instanceVar_T0));
  wr = (1.0-wf);
  if ((modelPar_ASYMMOD!=0))
  {
    CDSCD_a = ((instanceVar_CDSCDR_i*wr)+(instanceVar_CDSCD_i*wf));
    ETA0_a = ((instanceVar_ETA0R_t*wr)+(ETA0_t*wf));
    PDIBLC_a = ((instanceVar_PDIBLCR_i*wr)+(instanceVar_PDIBLC_i*wf));
    PCLM_a = ((instanceVar_PCLMR_i*wr)+(instanceVar_PCLM_i*wf));
    PSAT_a = ((instanceVar_PSATR_i*wr)+(instanceVar_PSAT_i*wf));
    VSAT_a = ((instanceVar_VSATR_t*wr)+(VSAT_t*wf));
    PTWG_a = ((instanceVar_PTWGR_t*wr)+(PTWG_t*wf));
    U0_a = ((instanceVar_U0R_t*wr)+(U0_t*wf));
    UA_a = ((instanceVar_UAR_t*wr)+(UA_t*wf));
    UC_a = ((instanceVar_UCR_t*wr)+(UC_t*wf));
    instanceVar_UD_a = ((instanceVar_UDR_t*wr)+(UD_t*wf));
    UCS_a = ((instanceVar_UCSR_t*wr)+(UCS_t*wf));
  }
  else
  {
    CDSCD_a = instanceVar_CDSCD_i;
    ETA0_a = instanceVar_ETA0_i;
    PDIBLC_a = instanceVar_PDIBLC_i;
    PCLM_a = instanceVar_PCLM_i;
    PSAT_a = instanceVar_PSAT_i;
    VSAT_a = VSAT_t;
    PTWG_a = PTWG_t;
    U0_a = U0_t;
    UA_a = UA_t;
    UC_a = UC_t;
    instanceVar_UD_a = UD_t;
    UCS_a = UCS_t;
  }
  PhistVbs = (0.5*(((Phist-Vbsx)+0.05)+sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)))));
  sqrtPhistVbs = sqrt(PhistVbs);
  Xdep = (T1DEP*sqrtPhistVbs);
  Cdep = (instanceVar_epssi/Xdep);
  cdsc = (((instanceVar_CIT_i+NFACTOR_t)+(CDSCD_a*Vdsx))-(instanceVar_CDSCB_i*Vbsx));
  instanceVar_T1 = (1.0+(cdsc/instanceVar_Cox));
  n = (0.5*((instanceVar_T1+1)+sqrt((((instanceVar_T1-1)*(instanceVar_T1-1))+((0.25*0.05)*0.05)))));
  nVt = (n*Vt);
  inv_nVt = (1.0/nVt);
  dVth_dibl = ((-(ETA0_a+(instanceVar_ETAB_i*Vbsx)))*Vdsx);
  dvth_temp = (((instanceVar_KT1_i+(modelPar_KT1L/instanceVar_Leff))+(instanceVar_KT2_i*Vbsx))*(pow(TRatio,modelPar_KT1EXP)-1.0));
  dVth_dibl = ((0.5*((dVth_dibl)-sqrt((((dVth_dibl)*(dVth_dibl))+((0.25*5.0e-5)*5.0e-5)))))+(0.25*5.0e-5));
  if ((instanceVar_DVTP0_i>0.0))
  {
    instanceVar_T0 = ((-instanceVar_DVTP1_i)*Vdsx);
    if ((instanceVar_T0<(-80.0)))
    {
      instanceVar_T2 = 1.804851387e-35;
    }
    else
    {
      instanceVar_T2 = exp(instanceVar_T0);
    }
    T3 = (instanceVar_Leff+(instanceVar_DVTP0_i*(1.0+instanceVar_T2)));
    dVth_ldop = ((-nVt)*AnalogFunctions::lln<AdmsSensFadType>((instanceVar_Leff/T3)));
  }
  else
  {
    dVth_ldop = 0;
  }
  T4 = (instanceVar_DVTP5_i+(instanceVar_DVTP2_i/pow(instanceVar_Leff,instanceVar_DVTP3_i)));
  dVth_ldop = (dVth_ldop-(T4*tanh((instanceVar_DVTP4_i*Vdsx))));
  instanceVar_VFB_i = (instanceVar_VFB_i+modelPar_DELVT0);
  vg = (Vg*inv_nVt);
  vs = (Vs*inv_nVt);
  vfb = (instanceVar_VFB_i*inv_nVt);
  dVth_VNUD = ((instanceVar_K1_i*(sqrtPhistVbs-sqrtPhist))-(instanceVar_K2_i*Vbsx));
  Vth_shift = (((((dVth_dibl+dVth_ldop)+dVth_VNUD)-dvth_temp)+vth0_stress)+vth0_well);
  vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
  gam = (sqrt(((((2.0*1.60219e-19)*instanceVar_epssi)*instanceVar_NDEP_i)*inv_Vt))/instanceVar_Cox);
  q_vth = 0.5;
  instanceVar_T0 = AnalogFunctions::hypsmooth<AdmsSensFadType>(((2*phib)+(Vs*inv_Vt)),1e-3);
  nq = (1.0+(gam/(2.0*sqrt(instanceVar_T0))));
  psip_th = AnalogFunctions::hypsmooth<AdmsSensFadType>((((((Vs*inv_Vt)+(2*phib))+log(q_vth))+(2*q_vth))+log((((2*nq)/gam)*((((2*q_vth)*nq)/gam)+(2*sqrt(instanceVar_T0)))))),1e-3);
  VTH = (((instanceVar_VFB_i+((psip_th-(Vs*inv_Vt))*Vt))+((Vt*gam)*sqrt(psip_th)))+Vth_shift);
  gam = (sqrt(((((2.0*1.60219e-19)*instanceVar_epssi)*instanceVar_NDEP_i)*inv_nVt))/instanceVar_Cox);
  inv_gam = (1.0/gam);
  phib_n = (phib/n);
  instanceVar_T1 = (1.0);
  vgfbPD = (vgfb/instanceVar_T1);
  gammaPD = (gam/instanceVar_T1);
  instanceVar_T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
  instanceVar_T2 = (instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+(6.0*vgfbPD))));
  if ((vgfbPD<0.0))
  {
    T3 = ((vgfbPD-instanceVar_T2)/gammaPD);
    psip = (-log(((1.0-instanceVar_T2)+(T3*T3))));
  }
  else
  {
    T3 = exp((-instanceVar_T2));
    instanceVar_T1 = (0.5*gammaPD);
    instanceVar_T2 = (sqrt((((vgfbPD-1.0)+T3)+(instanceVar_T1*instanceVar_T1)))-instanceVar_T1);
    psip = (((instanceVar_T2*instanceVar_T2)+1.0)-T3);
  }
  T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
  sqrtpsip = sqrt(T8);
  T9 = (1.0+(gam/(2.0*sqrtpsip)));
  instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
  instanceVar_T1 = ((psip-(2.0*phib_n))-vs);
  instanceVar_T2 = (instanceVar_T1-log(((4.0*instanceVar_T0)*sqrtpsip)));
  T8 = (0.5*((instanceVar_T2-0.201491)-sqrt(((instanceVar_T2*(instanceVar_T2+0.402982))+2.446562))));
  sqrtpsisa = sqrtpsip;
  if ((T8<=(-68.0)))
  {
    T4 = (-100.0);
    T5 = 20.0;
    if ((T8<(T4-(0.5*T5))))
    {
      T3 = exp(T4);
    }
    else
    {
      if ((T8>(T4+(0.5*T5))))
      {
        T3 = exp(T8);
      }
      else
      {
        instanceVar_T2 = ((T8-T4)/T5);
        T6 = (instanceVar_T2*instanceVar_T2);
        T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
      }
    }
    qs = (T3*(((1.0+instanceVar_T1)-T8)-log(((2.0*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa))))));
  }
  else
  {
    T3 = exp(T8);
    sqrtpsisainv = (1.0/sqrtpsisa);
    T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
    T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
    T3 = (T3-(T4/T5));
    T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
    T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
    T6 = (((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa))*((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
    T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceVar_T0*T3)+sqrtpsisa))))-T6);
    qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
  }
  psipclamp = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))));
  sqrtpsip = sqrt(psipclamp);
  psiavg = (psip-(2.0*qs));
  instanceVar_T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
  nq = (1.0+(gam/(sqrtpsip+sqrt(instanceVar_T0))));
  EeffFactor = (1.0e-8/(instanceVar_epsratio*modelPar_TOXE));
  instanceVar_T0 = (nVt*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
  qbs = (0.5*((instanceVar_T0)+sqrt((((instanceVar_T0)*(instanceVar_T0))+((0.25*0.1)*0.1)))));
  qis = (((2.0*nq)*nVt)*qs);
  Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
  instanceVar_T2 = pow((0.5*(1.0+(qis/qbs))),UCS_a);
  T3 = (((UA_a+(UC_a*Vbsx))*pow(Eeffs,instanceVar_EU_i))+(instanceVar_UD_a/instanceVar_T2));
  T4 = (1.0+T3);
  Dmobs = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
  WeffWRFactor = (1.0/(pow((instanceVar_Weff*1.0e6),instanceVar_WR_i)*instancePar_NF));
  if ((modelPar_RDSMOD==1))
  {
    Rdss = 0.0;
  }
  else
  {
    instanceVar_T0 = (1.0+(instanceVar_PRWG_i*qis));
    instanceVar_T1 = (instanceVar_PRWB_i*(sqrtPhistVbs-sqrtPhist));
    instanceVar_T2 = ((1.0/instanceVar_T0)+instanceVar_T1);
    T3 = (instanceVar_T2+sqrt(((instanceVar_T2*instanceVar_T2)+0.01)));
    Rdss = ((((instanceVar_RDSWMIN_i+(instanceVar_RDSW_i*T3))*WeffWRFactor)*instancePar_NF)*rdstemp);
    if ((modelPar_RDSMOD==2))
    {
      Rdss = (((instanceVar_RSourceGeo+(((instanceVar_RDSWMIN_i+(instanceVar_RDSW_i*T3))*WeffWRFactor)*instancePar_NF))+instanceVar_RDrainGeo)*rdstemp);
    }
  }
  instanceVar_T0 = pow(Dmobs,(1.0/PSAT_a));
  if ((instanceVar_PSATB_i<0))
  {
    instanceVar_T1 = (1.0/(1.0+(instanceVar_PSATB_i*Vbsx)));
  }
  else
  {
    instanceVar_T1 = (1.0-(instanceVar_PSATB_i*Vbsx));
  }
  instanceVar_T2 = ((((10.0*modelPar_PSATX)*qs)*instanceVar_T1)/((10.0*modelPar_PSATX)+(qs*instanceVar_T1)));
  if ((PTWG_a<0))
  {
    LambdaC = ((2.0*(((U0_a/instanceVar_T0)*nVt)/(VSAT_a*instanceVar_Leff)))*(1.0/(1.0-(PTWG_a*instanceVar_T2))));
  }
  else
  {
    LambdaC = ((2.0*(((U0_a/instanceVar_T0)*nVt)/(VSAT_a*instanceVar_Leff)))*(1.0+(PTWG_a*instanceVar_T2)));
  }
  if ((Rdss==0))
  {
    instanceVar_T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
    instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceVar_T0));
    instanceVar_T2 = sqrt((1.0+(instanceVar_T1*instanceVar_T1)));
    ln_T1_T2 = asinh(instanceVar_T1);
    if ((instanceVar_T1!=0))
    {
      T3 = (instanceVar_T2+((1.0/instanceVar_T1)*ln_T1_T2));
    }
    else
    {
      T3 = (instanceVar_T2+(1.0/instanceVar_T2));
    }
    T4 = ((instanceVar_T0*T3)-(LambdaC*(((qs*qs)+qs)-((instanceVar_T0*instanceVar_T0)+instanceVar_T0))));
    if ((instanceVar_T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((instanceVar_T1*instanceVar_T2)-ln_T1_T2))/(instanceVar_T1*instanceVar_T1));
    }
    else
    {
      T5 = (((((-2.0)*LambdaC)*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2));
    }
    T6 = (((instanceVar_T0*T5)+T3)+(LambdaC*((2.0*instanceVar_T0)+1.0)));
    instanceVar_T0 = (instanceVar_T0-(T4/T6));
    instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceVar_T0));
    instanceVar_T2 = sqrt((1.0+(instanceVar_T1*instanceVar_T1)));
    ln_T1_T2 = asinh(instanceVar_T1);
    if ((instanceVar_T1!=0))
    {
      T3 = (instanceVar_T2+((1.0/instanceVar_T1)*ln_T1_T2));
    }
    else
    {
      T3 = (instanceVar_T2+(1.0/instanceVar_T2));
    }
    T4 = ((instanceVar_T0*T3)-(LambdaC*(((qs*qs)+qs)-((instanceVar_T0*instanceVar_T0)+instanceVar_T0))));
    if ((instanceVar_T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((instanceVar_T1*instanceVar_T2)-ln_T1_T2))/(instanceVar_T1*instanceVar_T1));
    }
    else
    {
      T5 = (((instanceVar_T1/instanceVar_T2)*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2));
    }
    T6 = (((instanceVar_T0*T5)+T3)+(LambdaC*((2.0*instanceVar_T0)+1.0)));
    qdsat = (instanceVar_T0-(T4/T6));
  }
  else
  {
    T11 = (((((instanceVar_Weff*2.0)*nq)*instanceVar_Cox)*nVt)*VSAT_a);
    T12 = (((T11*LambdaC)*Rdss)/(2.0*nVt));
    instanceVar_T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
    instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceVar_T0));
    instanceVar_T2 = sqrt((1.0+(instanceVar_T1*instanceVar_T1)));
    ln_T1_T2 = asinh(instanceVar_T1);
    if ((instanceVar_T1!=0))
    {
      T3 = (instanceVar_T2+((1.0/instanceVar_T1)*ln_T1_T2));
    }
    else
    {
      T3 = (instanceVar_T2+(1.0/instanceVar_T2));
    }
    T4 = (((instanceVar_T0*T3)+((T12*instanceVar_T0)*((qs+instanceVar_T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((instanceVar_T0*instanceVar_T0)+instanceVar_T0))));
    if ((instanceVar_T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((instanceVar_T1*instanceVar_T2)-ln_T1_T2))/(instanceVar_T1*instanceVar_T1));
    }
    else
    {
      T5 = (((((-2.0)*LambdaC)*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2));
    }
    T6 = ((((instanceVar_T0*T5)+T3)+(T12*((qs+(2.0*instanceVar_T0))+1.0)))+(LambdaC*((2.0*instanceVar_T0)+1.0)));
    instanceVar_T0 = (instanceVar_T0-(T4/T6));
    instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceVar_T0));
    instanceVar_T2 = sqrt((1.0+(instanceVar_T1*instanceVar_T1)));
    ln_T1_T2 = asinh(instanceVar_T1);
    if ((instanceVar_T1!=0))
    {
      T3 = (instanceVar_T2+((1.0/instanceVar_T1)*ln_T1_T2));
    }
    else
    {
      T3 = (instanceVar_T2+(1.0/instanceVar_T2));
    }
    T4 = (((instanceVar_T0*T3)+((T12*instanceVar_T0)*((qs+instanceVar_T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((instanceVar_T0*instanceVar_T0)+instanceVar_T0))));
    if ((instanceVar_T1!=0))
    {
      T5 = ((((-2.0)*LambdaC)*((instanceVar_T1*instanceVar_T2)-ln_T1_T2))/(instanceVar_T1*instanceVar_T1));
    }
    else
    {
      T5 = (((((-2.0)*LambdaC)*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2))*(instanceVar_T1/instanceVar_T2));
    }
    T6 = ((((instanceVar_T0*T5)+T3)+(T12*((qs+(2.0*instanceVar_T0))+1.0)))+(LambdaC*((2.0*instanceVar_T0)+1.0)));
    qdsat = (instanceVar_T0-(T4/T6));
  }
  vdsat = ((psip-(2.0*phib_n))-((2.0*qdsat)+log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
  Vdsat = (vdsat*nVt);
  Vdssat = (0.5*(((Vdsat-Vs))+sqrt(((((Vdsat-Vs))*((Vdsat-Vs)))+((0.25*1e-3)*1e-3)))));
  T7 = pow((Vds/Vdssat),(1.0/DELTA_t));
  T8 = pow((1.0+T7),(-DELTA_t));
  Vdseff = (Vds*T8);
  vdeff = ((Vdseff+Vs)*inv_nVt);
  T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
  sqrtpsip = sqrt(T8);
  T9 = (1.0+(gam/(2.0*sqrtpsip)));
  instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
  instanceVar_T1 = ((psip-(2.0*phib_n))-vdeff);
  instanceVar_T2 = (instanceVar_T1-log(((4.0*instanceVar_T0)*sqrtpsip)));
  T8 = (0.5*((instanceVar_T2-0.201491)-sqrt(((instanceVar_T2*(instanceVar_T2+0.402982))+2.446562))));
  sqrtpsisa = sqrtpsip;
  if ((T8<=(-68.0)))
  {
    T4 = (-100.0);
    T5 = 20.0;
    if ((T8<(T4-(0.5*T5))))
    {
      T3 = exp(T4);
    }
    else
    {
      if ((T8>(T4+(0.5*T5))))
      {
        T3 = exp(T8);
      }
      else
      {
        instanceVar_T2 = ((T8-T4)/T5);
        T6 = (instanceVar_T2*instanceVar_T2);
        T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
      }
    }
    qdeff = (T3*(((1.0+instanceVar_T1)-T8)-log(((2.0*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa))))));
  }
  else
  {
    T3 = exp(T8);
    sqrtpsisainv = (1.0/sqrtpsisa);
    T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
    T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
    T3 = (T3-(T4/T5));
    T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
    T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
    T6 = (((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa))*((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
    T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceVar_T0*T3)+sqrtpsisa))))-T6);
    qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
  }
  psiavg = (((psip-qs)-qdeff)-1.0);
  instanceVar_T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
  instanceVar_T2 = sqrt(instanceVar_T0);
  nq = (1.0+(gam/(sqrtpsip+instanceVar_T2)));
  DQSD2 = ((qs-qdeff)*(qs-qdeff));
  instanceVar_T0 = (1.0/((1.0+qs)+qdeff));
  instanceVar_T1 = (DQSD2*instanceVar_T0);
  Qb = ((vgfb-psip)-((nq-1.0)*((qs+qdeff)+(0.33333333333333333*instanceVar_T1))));
  instanceVar_T2 = (0.33333333333333333*nq);
  T3 = (instanceVar_T1*instanceVar_T0);
  Qs = (instanceVar_T2*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
  Qd = (instanceVar_T2*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
  qba = (0.5*(((nVt*Qb))+sqrt(((((nVt*Qb))*((nVt*Qb)))+((0.25*0.1)*0.1)))));
  qia = (nVt*(Qs+Qd));
  Eeffm = (EeffFactor*(qba+(eta_mu*qia)));
  instanceVar_T2 = pow((0.5*(1.0+(qia/qba))),UCS_a);
  T3 = (((UA_a+(UC_a*Vbsx))*pow(Eeffm,instanceVar_EU_i))+(instanceVar_UD_a/instanceVar_T2));
  T4 = (1.0+T3);
  Dmob = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
  Esat = ((2.0*VSAT_a)/(U0_a/Dmob));
  EsatL = (Esat*instanceVar_Leff);
  if ((instanceVar_PVAG_i>0))
  {
    PVAGfactor = (1.0+((instanceVar_PVAG_i*qia)/EsatL));
  }
  else
  {
    PVAGfactor = (1.0/(1.0-((instanceVar_PVAG_i*qia)/EsatL)));
  }
  DIBLfactor = PDIBLC_a;
  diffVds = (Vds-Vdseff);
  Vgst2Vtm = (qia+(2.0*nVt));
  if ((DIBLfactor>0))
  {
    T3 = (Vgst2Vtm/(Vdssat+Vgst2Vtm));
    T4 = AnalogFunctions::hypsmooth<AdmsSensFadType>((1.0+(instanceVar_PDIBLCB_i*Vbsx)),1e-3);
    T5 = (1/T4);
    VaDIBL = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5);
    Moc = (1.0+(diffVds/VaDIBL));
  }
  else
  {
    Moc = 1.0;
  }
  if ((instanceVar_FPROUT_i<=0.0))
  {
    Fp = 1.0;
  }
  else
  {
    T9 = ((instanceVar_FPROUT_i*sqrt(instanceVar_Leff))/Vgst2Vtm);
    Fp = (1.0/(1.0+T9));
  }
  Vasat = (Vdssat+EsatL);
  if ((PCLM_a!=0))
  {
    if ((modelPar_PCLMG<0.0))
    {
      instanceVar_T1 = ((PCLM_a/(1.0-((modelPar_PCLMG*qia)/EsatL)))/Fp);
    }
    else
    {
      instanceVar_T1 = ((PCLM_a*(1.0+((modelPar_PCLMG*qia)/EsatL)))/Fp);
    }
    MdL = (1.0+(instanceVar_T1*AnalogFunctions::lln<AdmsSensFadType>((1.0+((diffVds/instanceVar_T1)/Vasat)))));
  }
  else
  {
    MdL = 1.0;
  }
  Moc = (Moc*MdL);
  instanceVar_T1 = AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_PDITSD_i*Vds));
  if ((instanceVar_PDITS_i>0.0))
  {
    instanceVar_T2 = (1.0+(modelPar_PDITSL*instanceVar_Leff));
    VaDITS = ((1.0+(instanceVar_T2*instanceVar_T1))/instanceVar_PDITS_i);
    VaDITS = (VaDITS*Fp);
  }
  else
  {
    VaDITS = 5.540622384e+34;
  }
  T4 = (diffVds/VaDITS);
  instanceVar_T0 = (1.0+T4);
  Moc = (Moc*instanceVar_T0);
  if ((instanceVar_PSCBE2_i>0.0))
  {
    if ((diffVds>((instanceVar_PSCBE1_i*litl)/80.0)))
    {
      instanceVar_T0 = ((instanceVar_PSCBE1_i*litl)/diffVds);
      VaSCBE = ((instanceVar_Leff*exp(instanceVar_T0))/instanceVar_PSCBE2_i);
    }
    else
    {
      VaSCBE = ((5.540622384e+34*instanceVar_Leff)/instanceVar_PSCBE2_i);
    }
  }
  else
  {
    VaSCBE = 5.540622384e+34;
  }
  Mscbe = (1.0+(diffVds/VaSCBE));
  Moc = (Moc*Mscbe);
  instanceVar_T0 = pow(Dmob,(1.0/PSAT_a));
  if ((instanceVar_PSATB_i<0))
  {
    instanceVar_T1 = (1.0/(1.0+(instanceVar_PSATB_i*Vbsx)));
  }
  else
  {
    instanceVar_T1 = (1.0-(instanceVar_PSATB_i*Vbsx));
  }
  instanceVar_T2 = ((((10.0*modelPar_PSATX)*qia)*instanceVar_T1)/((10.0*modelPar_PSATX)+(qia*instanceVar_T1)));
  if ((PTWG_a<0))
  {
    LambdaC = ((2.0*(((U0_a/instanceVar_T0)*nVt)/(VSAT_a*instanceVar_Leff)))*(1.0/(1.0-(PTWG_a*instanceVar_T2))));
  }
  else
  {
    LambdaC = ((2.0*(((U0_a/instanceVar_T0)*nVt)/(VSAT_a*instanceVar_Leff)))*(1.0+(PTWG_a*instanceVar_T2)));
  }
  instanceVar_T1 = ((2.0*LambdaC)*(qs-qdeff));
  instanceVar_T2 = sqrt((1.0+(instanceVar_T1*instanceVar_T1)));
  if ((instanceVar_T1!=0))
  {
    Dvsat = (0.5*(instanceVar_T2+((1.0/instanceVar_T1)*asinh(instanceVar_T1))));
  }
  else
  {
    Dvsat = (0.5*(instanceVar_T2+(1.0/instanceVar_T2)));
  }
  Dptwg = Dvsat;
  Rsource = 0.0;
  Rdrain = 0.0;
  if ((modelPar_RDSMOD==1))
  {
    Rdsi = 0.0;
    Dr = 1.0;
    instanceVar_T2 = (Vgs_noswap-Vfbsdr);
    T3 = sqrt(((instanceVar_T2*instanceVar_T2)+0.01));
    Vgs_eff = (0.5*(instanceVar_T2+T3));
    T5 = (1.0+(instanceVar_PRWG_i*Vgs_eff));
    T6 = ((1.0/T5)+(instanceVar_PRWB_i*Vsb_noswap));
    T4 = (0.5*(T6+sqrt(((T6*T6)+0.01))));
    Rsource = (rdstemp*(instanceVar_RSourceGeo+((instanceVar_RSWMIN_i+(instanceVar_RSW_i*T4))*WeffWRFactor)));
    instanceVar_T2 = (Vgd_noswap-Vfbsdr);
    T3 = sqrt(((instanceVar_T2*instanceVar_T2)+0.01));
    Vgd_eff = (0.5*(instanceVar_T2+T3));
    T5 = (1.0+(instanceVar_PRWG_i*Vgd_eff));
    T6 = ((1.0/T5)+(instanceVar_PRWB_i*Vdb_noswap));
    T4 = (0.5*(T6+sqrt(((T6*T6)+0.01))));
    Rdrain = (rdstemp*(instanceVar_RDrainGeo+((instanceVar_RDWMIN_i+(instanceVar_RDW_i*T4))*WeffWRFactor)));
  }
  else
  {
    instanceVar_T0 = (1.0+(instanceVar_PRWG_i*qia));
    instanceVar_T1 = (instanceVar_PRWB_i*(sqrtPhistVbs-sqrtPhist));
    instanceVar_T2 = ((1.0/instanceVar_T0)+instanceVar_T1);
    T3 = (0.5*(instanceVar_T2+sqrt(((instanceVar_T2*instanceVar_T2)+0.01))));
    Rdsi = (((rdstemp*(instanceVar_RDSWMIN_i+(instanceVar_RDSW_i*T3)))*WeffWRFactor)*instancePar_NF);
    Rdrain = instanceVar_RDrainGeo;
    Rsource = instanceVar_RSourceGeo;
    Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*instanceVar_Cox)*instanceVar_Weff)/instanceVar_Leff)*qia)*Rdsi));
    if ((modelPar_RDSMOD==2))
    {
      Rdsi = (rdstemp*((instanceVar_RSourceGeo+(((instanceVar_RDSWMIN_i+(instanceVar_RDSW_i*T3))*WeffWRFactor)*instancePar_NF))+instanceVar_RDrainGeo));
      Rdrain = 0;
      Rsource = 0;
      Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*instanceVar_Cox)*instanceVar_Weff)/instanceVar_Leff)*qia)*Rdsi));
    }
  }
  instanceVar_T0 = (A1_t+(A2_t/(qia+((2.0*n)*Vtm))));
  DQSD = (qs-qdeff);
  instanceVar_T1 = ((instanceVar_T0*DQSD)*DQSD);
  instanceVar_T2 = ((instanceVar_T1+1.0)-0.001);
  T3 = ((-1.0)+(0.5*(instanceVar_T2+sqrt(((instanceVar_T2*instanceVar_T2)+0.004)))));
  Nsat = (0.5*(1.0+sqrt((1.0+T3))));
  Dtot = ((Dmob*Dvsat)*Dr);
  ueff = (U0_a/Dtot);
  ids = (((((((((((2.0*instancePar_NF)*nq)*ueff)*instanceVar_Weff)/instanceVar_Leff)*instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat);
  Gcrg = 0.0;
  if ((instancePar_RGATEMOD>1))
  {
    idsovvds = ((((ueff*instanceVar_Weff)/instanceVar_Leff)*instanceVar_Cox)*qia);
    T9 = (modelPar_XRCRG2*Vt);
    instanceVar_T0 = ((((T9*ueff)*instanceVar_Weff)/instanceVar_Leff)*instanceVar_Cox);
    Gcrg = ((modelPar_XRCRG1*instancePar_NF)*(instanceVar_T0+idsovvds));
    if ((instancePar_RGATEMOD==2))
    {
      T11 = (instanceVar_Grgeltd+Gcrg);
      Gcrg = ((instanceVar_Grgeltd*Gcrg)/T11);
    }
  }
  if (((instanceVar_ALPHA0_i<=0.0)||(BETA0_t<=0.0)))
  {
    Iii = 0.0;
  }
  else
  {
    if ((diffVds>(BETA0_t/80.0)))
    {
      instanceVar_T1 = ((-BETA0_t)/diffVds);
      Iii = ((((instanceVar_ALPHA0_i*diffVds)*ids)*AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T1))/Mscbe);
    }
    else
    {
      Iii = ((((instanceVar_ALPHA0_i*diffVds)*ids)*1.804851387e-35)/Mscbe);
    }
  }
  ISUB = (Iii*instanceVar_devsign);
  igbinv = 0.0;
  igbacc = 0.0;
  igb = 0.0;
  igcs = 0.0;
  igcd = 0.0;
  igs = 0.0;
  igd = 0.0;
  if (((modelPar_IGCMOD!=0)||(modelPar_IGBMOD!=0)))
  {
    Voxm = (nVt*(((vgfb-psip)+qs)+qdeff));
    instanceVar_T1 = sqrt(((Voxm*Voxm)+1.0E-4));
    Voxmacc = (0.5*((-Voxm)+instanceVar_T1));
    Voxminv = (0.5*(Voxm+instanceVar_T1));
    if ((modelPar_IGBMOD!=0))
    {
      instanceVar_T1 = ((Voxmacc/instanceVar_NIGBACC_i)/Vt);
      Vaux_Igbacc = ((instanceVar_NIGBACC_i*Vt)*AnalogFunctions::lln<AdmsSensFadType>((1+AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1)))));
      instanceVar_T2 = (instanceVar_AIGBACC_i-(instanceVar_BIGBACC_i*Voxmacc));
      T3 = (1.0+(instanceVar_CIGBACC_i*Voxmacc));
      T4 = ((((-7.45669e11)*modelPar_TOXE)*instanceVar_T2)*T3);
      T5 = AnalogFunctions::lexp<AdmsSensFadType>(T4);
      T6 = 4.97232e-7;
      igbacc = (((((((instancePar_NF*instanceVar_Weff)*instanceVar_Leff)*T6)*instanceVar_ToxRatio)*Vg)*Vaux_Igbacc)*T5);
      igbacc = (igbacc*igtemp);
      instanceVar_T1 = (((Voxminv-instanceVar_EIGBINV_i)/instanceVar_NIGBINV_i)/Vt);
      Vaux_Igbinv = ((instanceVar_NIGBINV_i*Vt)*AnalogFunctions::lln<AdmsSensFadType>((1.0+AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T1))));
      instanceVar_T2 = (instanceVar_AIGBINV_i-(instanceVar_BIGBINV_i*Voxminv));
      T3 = (1.0+(instanceVar_CIGBINV_i*Voxminv));
      T4 = ((((-9.82222e11)*modelPar_TOXE)*instanceVar_T2)*T3);
      T5 = AnalogFunctions::lexp<AdmsSensFadType>(T4);
      T6 = 3.75956e-7;
      igbinv = (((((((instancePar_NF*instanceVar_Weff)*instanceVar_Leff)*T6)*instanceVar_ToxRatio)*Vg)*Vaux_Igbinv)*T5);
      igbinv = (igbinv*igtemp);
      igb = (igbacc+igbinv);
    }
    if ((modelPar_IGCMOD!=0))
    {
      instanceVar_T1 = (instanceVar_AIGC_i-(instanceVar_BIGC_i*Voxminv));
      instanceVar_T2 = (1.0+(instanceVar_CIGC_i*Voxminv));
      T3 = ((instanceVar_Bechvb*instanceVar_T1)*instanceVar_T2);
      T4 = (((nq*nVt)*(qs+qdeff))*AnalogFunctions::lexp<AdmsSensFadType>(T3));
      igc0 = ((((instancePar_NF*instanceVar_Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp);
      Vdseffx = (sqrt(((Vdseff*Vdseff)+0.01))-0.1);
      instanceVar_T1 = (instanceVar_PIGCD_i*Vdseffx);
      T1_exp = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
      T3 = (((instanceVar_T1+T1_exp)-1.0)+1.0E-4);
      T4 = ((1.0-((instanceVar_T1+1.0)*T1_exp))+1.0E-4);
      T5 = ((instanceVar_T1*instanceVar_T1)+2.0E-4);
      if ((sigvds>0))
      {
        igcd = ((igc0*T4)/T5);
        igcs = ((igc0*T3)/T5);
      }
      else
      {
        igcs = ((igc0*T4)/T5);
        igcd = ((igc0*T3)/T5);
      }
      instanceVar_T2 = (Vgs_noswap-Vfbsdr);
      Vgs_eff = sqrt(((instanceVar_T2*instanceVar_T2)+1.0e-4));
      instanceVar_T1 = (instanceVar_AIGS_i-(instanceVar_BIGS_i*Vgs_eff));
      instanceVar_T2 = (1.0+(instanceVar_CIGS_i*Vgs_eff));
      T3 = ((instanceVar_BechvbEdge*instanceVar_T1)*instanceVar_T2);
      T4 = AnalogFunctions::lexp<AdmsSensFadType>(T3);
      igs_mult = (((igtemp*instancePar_NF)*instanceVar_AechvbEdge)*instanceVar_DLCIG_i);
      igs = (((igs_mult*Vgs_noswap)*Vgs_eff)*T4);
      instanceVar_T2 = (Vgd_noswap-Vfbsdr);
      Vgd_eff = sqrt(((instanceVar_T2*instanceVar_T2)+1.0e-4));
      instanceVar_T1 = (instanceVar_AIGD_i-(instanceVar_BIGD_i*Vgd_eff));
      instanceVar_T2 = (1.0+(instanceVar_CIGD_i*Vgd_eff));
      T3 = ((instanceVar_BechvbEdge*instanceVar_T1)*instanceVar_T2);
      T4 = AnalogFunctions::lexp<AdmsSensFadType>(T3);
      igd_mult = (((igtemp*instancePar_NF)*instanceVar_AechvbEdge)*instanceVar_DLCIGD_i);
      igd = (((igd_mult*Vgd_noswap)*Vgd_eff)*T4);
    }
  }
  IGS = (instanceVar_devsign*igs);
  IGD = (instanceVar_devsign*igd);
  IGB = (instanceVar_devsign*igb);
  IGCS = (instanceVar_devsign*igcs);
  IGCD = (instanceVar_devsign*igcd);
  igisl = 0.0;
  igidl = 0.0;
  if ((modelPar_GIDLMOD!=0))
  {
    instanceVar_T0 = (instanceVar_epsratio*modelPar_TOXE);
    if ((((instanceVar_AGIDL_i<=0.0)||(BGIDL_t<=0.0))||(instanceVar_CGIDL_i<0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      instanceVar_T1 = ((((-Vgd_noswap)-instanceVar_EGIDL_i)+Vfbsdr)/instanceVar_T0);
      instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>(instanceVar_T1,1.0E-2);
      instanceVar_T2 = (BGIDL_t/(instanceVar_T1+1.0E-3));
      if ((instanceVar_CGIDL_i!=0))
      {
        T3 = ((Vdb_noswap*Vdb_noswap)*Vdb_noswap);
        T4 = ((instanceVar_CGIDL_i+fabs(T3))+1.0E-9);
        T5 = (AnalogFunctions::hypsmooth<AdmsSensFadType>((T3/T4),1.0E-6)-1.0E-6);
      }
      else
      {
        T5 = 1.0;
      }
      T6 = ((((instanceVar_AGIDL_i*instanceVar_Weff)*instanceVar_T1)*AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T2)))*T5);
    }
    igidl = T6;
    if ((((instanceVar_AGISL_i<=0.0)||(BGISL_t<=0.0))||(instanceVar_CGISL_i<0.0)))
    {
      T6 = 0.0;
    }
    else
    {
      instanceVar_T1 = ((((-Vgs_noswap)-instanceVar_EGISL_i)+Vfbsdr)/instanceVar_T0);
      instanceVar_T1 = AnalogFunctions::hypsmooth<AdmsSensFadType>(instanceVar_T1,1.0E-2);
      instanceVar_T2 = (BGISL_t/(instanceVar_T1+1.0E-3));
      if ((instanceVar_CGISL_i!=0))
      {
        T3 = ((Vsb_noswap*Vsb_noswap)*Vsb_noswap);
        T4 = ((instanceVar_CGISL_i+fabs(T3))+1.0E-9);
        T5 = (AnalogFunctions::hypsmooth<AdmsSensFadType>((T3/T4),1.0E-6)-1.0E-6);
      }
      else
      {
        T5 = 1.0;
      }
      T6 = ((((instanceVar_AGISL_i*instanceVar_Weff)*instanceVar_T1)*AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T2)))*T5);
    }
    igisl = T6;
  }
  IGIDL = ((instanceVar_devsign*instancePar_NF)*igidl);
  IGISL = ((instanceVar_devsign*instancePar_NF)*igisl);
  if ((Isbs>0.0))
  {
    if ((Vbs_jct<VjsmRev))
    {
      instanceVar_T0 = (Vbs_jct/Nvtms);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)-1.0);
      instanceVar_T2 = (IVjsmRev+(SslpRev*(Vbs_jct-VjsmRev)));
      Ibs = (instanceVar_T1*instanceVar_T2);
    }
    else
    {
      if ((Vbs_jct<=VjsmFwd))
      {
        instanceVar_T0 = (Vbs_jct/Nvtms);
        instanceVar_T1 = ((modelPar_BVS+Vbs_jct)/Nvtms);
        instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
        Ibs = (Isbs*(((AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)+XExpBVS)-1.0)-(modelPar_XJBVS*instanceVar_T2)));
      }
      else
      {
        Ibs = (IVjsmFwd+(SslpFwd*(Vbs_jct-VjsmFwd)));
      }
    }
  }
  else
  {
    Ibs = 0.0;
  }
  if ((JTSS_t>0.0))
  {
    if (((modelPar_VTSS-Vbs_jct)<(modelPar_VTSS*1.0e-3)))
    {
      instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e+3))-1.0);
      Ibs = (Ibs-((ASeff*JTSS_t)*instanceVar_T1));
    }
    else
    {
      instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSS)/(modelPar_VTSS-Vbs_jct)))-1.0);
      Ibs = (Ibs-((ASeff*JTSS_t)*instanceVar_T1));
    }
  }
  if ((JTSSWS_t>0.0))
  {
    if (((modelPar_VTSSWS-Vbs_jct)<(modelPar_VTSSWS*1.0e-3)))
    {
      instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e+3))-1.0);
      Ibs = (Ibs-((PSeff*JTSSWS_t)*instanceVar_T1));
    }
    else
    {
      instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWS)/(modelPar_VTSSWS-Vbs_jct)))-1.0);
      Ibs = (Ibs-((PSeff*JTSSWS_t)*instanceVar_T1));
    }
  }
  if ((JTSSWGS_t>0.0))
  {
    if (((modelPar_VTSSWGS-Vbs_jct)<(modelPar_VTSSWGS*1.0e-3)))
    {
      instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e+3))-1.0);
      Ibs = (Ibs-(((instanceVar_Weffcj*instancePar_NF)*JTSSWGS_t)*instanceVar_T1));
    }
    else
    {
      instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWGS)/(modelPar_VTSSWGS-Vbs_jct)))-1.0);
      Ibs = (Ibs-(((instanceVar_Weffcj*instancePar_NF)*JTSSWGS_t)*instanceVar_T1));
    }
  }
  if ((Isbd>0.0))
  {
    if ((Vbd_jct<VjdmRev))
    {
      instanceVar_T0 = (Vbd_jct/Nvtmd);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)-1.0);
      instanceVar_T2 = (IVjdmRev+(DslpRev*(Vbd_jct-VjdmRev)));
      Ibd = (instanceVar_T1*instanceVar_T2);
    }
    else
    {
      if ((Vbd_jct<=VjdmFwd))
      {
        instanceVar_T0 = (Vbd_jct/Nvtmd);
        instanceVar_T1 = ((modelPar_BVD+Vbd_jct)/Nvtmd);
        instanceVar_T2 = AnalogFunctions::lexp<AdmsSensFadType>((-instanceVar_T1));
        Ibd = (Isbd*(((AnalogFunctions::lexp<AdmsSensFadType>(instanceVar_T0)+XExpBVD)-1.0)-(modelPar_XJBVD*instanceVar_T2)));
      }
      else
      {
        Ibd = (IVjdmFwd+(DslpFwd*(Vbd_jct-VjdmFwd)));
      }
    }
  }
  else
  {
    Ibd = 0.0;
  }
  if ((JTSD_t>0.0))
  {
    if (((modelPar_VTSD-Vbd_jct)<(modelPar_VTSD*1.0e-3)))
    {
      instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e+3))-1.0);
      Ibd = (Ibd-((ADeff*JTSD_t)*instanceVar_T1));
    }
    else
    {
      instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSD)/(modelPar_VTSD-Vbd_jct)))-1.0);
      Ibd = (Ibd-((ADeff*JTSD_t)*instanceVar_T1));
    }
  }
  if ((JTSSWD_t>0.0))
  {
    if (((modelPar_VTSSWD-Vbd_jct)<(modelPar_VTSSWD*1.0e-3)))
    {
      instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e+3))-1.0);
      Ibd = (Ibd-((PDeff*JTSSWD_t)*instanceVar_T1));
    }
    else
    {
      instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWD)/(modelPar_VTSSWD-Vbd_jct)))-1.0);
      Ibd = (Ibd-((PDeff*JTSSWD_t)*instanceVar_T1));
    }
  }
  if ((JTSSWGD_t>0.0))
  {
    if (((modelPar_VTSSWGD-Vbd_jct)<(modelPar_VTSSWGD*1.0e-3)))
    {
      instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>((instanceVar_T0*1.0e+3))-1.0);
      Ibd = (Ibd-(((instanceVar_Weffcj*instancePar_NF)*JTSSWGD_t)*instanceVar_T1));
    }
    else
    {
      instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
      instanceVar_T1 = (AnalogFunctions::lexp<AdmsSensFadType>(((instanceVar_T0*modelPar_VTSSWGD)/(modelPar_VTSSWGD-Vbd_jct)))-1.0);
      Ibd = (Ibd-(((instanceVar_Weffcj*instancePar_NF)*JTSSWGD_t)*instanceVar_T1));
    }
  }
  if ((Czbs>0.0))
  {
    instanceVar_T1 = (Vbs_jct/PBS_t);
    if ((instanceVar_T1<0.9))
    {
      arg = (1.0-instanceVar_T1);
      if ((modelPar_MJS==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
      }
      Qbs = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-modelPar_MJS));
    }
    else
    {
      instanceVar_T2 = pow(0.1,(-modelPar_MJS));
      T3 = (1.0/(1.0-modelPar_MJS));
      T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJS)*(instanceVar_T1-1.0))+(1.0+modelPar_MJS)));
      T5 = (T3*(1.0-(((0.05*modelPar_MJS)*(1.0+modelPar_MJS))*instanceVar_T2)));
      Qbs = ((PBS_t*Czbs)*(T4+T5));
    }
  }
  else
  {
    Qbs = 0.0;
  }
  if ((Czbssw>0.0))
  {
    instanceVar_T1 = (Vbs_jct/PBSWS_t);
    if ((instanceVar_T1<0.9))
    {
      arg = (1.0-instanceVar_T1);
      if ((modelPar_MJSWS==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
      }
      Qbs = (Qbs+(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWS)));
    }
    else
    {
      instanceVar_T2 = pow(0.1,(-modelPar_MJSWS));
      T3 = (1.0/(1.0-modelPar_MJSWS));
      T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWS)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWS)));
      T5 = (T3*(1.0-(((0.05*modelPar_MJSWS)*(1.0+modelPar_MJSWS))*instanceVar_T2)));
      Qbs = (Qbs+((PBSWS_t*Czbssw)*(T4+T5)));
    }
  }
  if ((Czbsswg>0.0))
  {
    instanceVar_T1 = (Vbs_jct/PBSWGS_t);
    if ((instanceVar_T1<0.9))
    {
      arg = (1.0-instanceVar_T1);
      if ((modelPar_MJSWGS==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGS)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
      }
      Qbs = (Qbs+(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGS)));
    }
    else
    {
      instanceVar_T2 = pow(0.1,(-modelPar_MJSWGS));
      T3 = (1.0/(1.0-modelPar_MJSWGS));
      T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWGS)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWGS)));
      T5 = (T3*(1.0-(((0.05*modelPar_MJSWGS)*(1.0+modelPar_MJSWGS))*instanceVar_T2)));
      Qbs = (Qbs+((PBSWGS_t*Czbsswg)*(T4+T5)));
    }
  }
  if ((Czbd>0.0))
  {
    instanceVar_T1 = (Vbd_jct/PBD_t);
    if ((instanceVar_T1<0.9))
    {
      arg = (1.0-instanceVar_T1);
      if ((modelPar_MJD==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
      }
      Qbd = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-modelPar_MJD));
    }
    else
    {
      instanceVar_T2 = pow(0.1,(-modelPar_MJD));
      T3 = (1.0/(1.0-modelPar_MJD));
      T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJD)*(instanceVar_T1-1.0))+(1.0+modelPar_MJD)));
      T5 = (T3*(1.0-(((0.05*modelPar_MJD)*(1.0+modelPar_MJD))*instanceVar_T2)));
      Qbd = ((PBD_t*Czbd)*(T4+T5));
    }
  }
  else
  {
    Qbd = 0.0;
  }
  if ((Czbdsw>0.0))
  {
    instanceVar_T1 = (Vbd_jct/PBSWD_t);
    if ((instanceVar_T1<0.9))
    {
      arg = (1.0-instanceVar_T1);
      if ((modelPar_MJSWD==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
      }
      Qbd = (Qbd+(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWD)));
    }
    else
    {
      instanceVar_T2 = pow(0.1,(-modelPar_MJSWD));
      T3 = (1.0/(1.0-modelPar_MJSWD));
      T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWD)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWD)));
      T5 = (T3*(1.0-(((0.05*modelPar_MJSWD)*(1.0+modelPar_MJSWD))*instanceVar_T2)));
      Qbd = (Qbd+((PBSWD_t*Czbdsw)*(T4+T5)));
    }
  }
  if ((Czbdswg>0.0))
  {
    instanceVar_T1 = (Vbd_jct/PBSWGD_t);
    if ((instanceVar_T1<0.9))
    {
      arg = (1.0-instanceVar_T1);
      if ((modelPar_MJSWGD==0.5))
      {
        sarg = (1.0/sqrt(arg));
      }
      else
      {
        sarg = AnalogFunctions::lexp<AdmsSensFadType>(((-modelPar_MJSWGD)*AnalogFunctions::lln<AdmsSensFadType>(arg)));
      }
      Qbd = (Qbd+(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelPar_MJSWGD)));
    }
    else
    {
      instanceVar_T2 = pow(0.1,(-modelPar_MJSWGD));
      T3 = (1.0/(1.0-modelPar_MJSWGD));
      T4 = ((instanceVar_T2*(instanceVar_T1-1.0))*(((5.0*modelPar_MJSWGD)*(instanceVar_T1-1.0))+(1.0+modelPar_MJSWGD)));
      T5 = (T3*(1.0-(((0.05*modelPar_MJSWGD)*(1.0+modelPar_MJSWGD))*instanceVar_T2)));
      Qbd = (Qbd+((PBSWGD_t*Czbdswg)*(T4+T5)));
    }
  }
  Nt = ((4.0*Vt)*1.60219e-19);
  if ((modelPar_LINTNOI>=(instanceVar_Leff/2.0)))
  {
    std::cerr  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << modelPar_LINTNOI <<  std::endl; 
    LINTNOI_i = 0;
  }
  else
  {
    LINTNOI_i = modelPar_LINTNOI;
  }
  Esatnoi = ((2.0*VSAT_a)/ueff);
  if ((((modelPar_NOIA>0)||(modelPar_NOIB>0))||(modelPar_NOIC>0)))
  {
    Leffnoi = (instanceVar_Leff-(2.0*LINTNOI_i));
    Leffnoisq = (Leffnoi*Leffnoi);
    if ((modelPar_EM<=0.0))
    {
      DelClm = 0.0;
    }
    else
    {
      instanceVar_T0 = (((diffVds/litl)+modelPar_EM)/Esatnoi);
      DelClm = (litl*AnalogFunctions::lln<AdmsSensFadType>(instanceVar_T0));
      if ((DelClm<0.0))
      {
        DelClm = 0.0;
      }
    }
    instanceVar_T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*fabs(ids))*ueff);
    instanceVar_T2 = ((1.0e10*instanceVar_Cox)*Leffnoisq);
    N0 = (((((2.0*nq)*instanceVar_Cox)*Vt)*qs)/1.60219e-19);
    Nl = (((((2.0*nq)*instanceVar_Cox)*Vt)*qdeff)/1.60219e-19);
    Nstar = ((Vt/1.60219e-19)*((instanceVar_Cox+Cdep)+modelPar_CIT));
    T3 = (modelPar_NOIA*AnalogFunctions::lln<AdmsSensFadType>(((N0+Nstar)/(Nl+Nstar))));
    T4 = (modelPar_NOIB*(N0-Nl));
    T5 = ((0.5*modelPar_NOIC)*((N0*N0)-(Nl*Nl)));
    T6 = (((1.60219e-19*Vt)*ids)*ids);
    T7 = (((1.0e10*Leffnoisq)*instanceVar_Weff)*instancePar_NF);
    T8 = ((modelPar_NOIA+(modelPar_NOIB*Nl))+((modelPar_NOIC*Nl)*Nl));
    T9 = ((Nl+Nstar)*(Nl+Nstar));
    Ssi = (((instanceVar_T1/instanceVar_T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
    T10 = ((modelPar_NOIA*1.60219e-19)*Vt);
    T11 = (((((instanceVar_Weff*instancePar_NF)*Leffnoi)*1.0e10)*Nstar)*Nstar);
    Swi = (((T10/T11)*ids)*ids);
    instanceVar_T1 = (Swi+Ssi);
    if ((instanceVar_T1>0.0))
    {
      FNPowerAt1Hz = ((Ssi*Swi)/instanceVar_T1);
    }
    else
    {
      FNPowerAt1Hz = 0.0;
    }
  }
  else
  {
    FNPowerAt1Hz = 0.0;
  }
  // I(di,si) <+ (flicker_noise(FNPowerAt1Hz,EF,"1overf"))
  instanceVar_T0 = ((qia/Esatnoi)/instanceVar_Leff);
  instanceVar_T1 = (instanceVar_T0*instanceVar_T0);
  T3 = (modelPar_RNOIA*(1.0+((modelPar_TNOIA*instanceVar_Leff)*instanceVar_T1)));
  T4 = (modelPar_RNOIB*(1.0+((modelPar_TNOIB*instanceVar_Leff)*instanceVar_T1)));
  ctnoi = (modelPar_RNOIC*(1.0+((modelPar_TNOIC*instanceVar_Leff)*instanceVar_T1)));
  betanoisq = (T3*T3);
  thetanoisq = (T4*T4);
  cm_igid = 0;
  if ( modelPar_TNOIMOD == (0))
  {
    QSi = ((((((-instancePar_NF)*instanceVar_Weff)*instanceVar_Leff)*instanceVar_Cox)*Vt)*Qs);
    QDi = ((((((-instancePar_NF)*instanceVar_Weff)*instanceVar_Leff)*instanceVar_Cox)*Vt)*Qd);
    instanceVar_T0 = (ueff*fabs((QSi+QDi)));
    instanceVar_T1 = ((instanceVar_T0*Rdsi)+(instanceVar_Leff*instanceVar_Leff));
    Gtnoi = ((instanceVar_T0/instanceVar_T1)*modelPar_NTNOI);
    sidn = (Nt*Gtnoi);
    // I(di,si) <+ (white_noise(sidn,"id"))
  }
  else
    if ( modelPar_TNOIMOD == (1))
    {
      Vtn = ((2.0*nq)*nVt);
      instanceVar_T0 = ((((ueff*Dptwg)*Moc)*instanceVar_Cox)*Vtn);
      instanceVar_T1 = (0.5*(qs+qdeff));
      T3 = (instanceVar_T1+0.5);
      T4 = (T3*T3);
      T5 = (T4*T3);
      T6 = (qs-qdeff);
      T7 = (T6*T6);
      T8 = (T7*T6);
      T9 = (((6.0*instanceVar_T1)+0.5)*T7);
      Lvsat = (instanceVar_Leff*Dptwg);
      T10 = (Lvsat/instanceVar_Leff);
      mid = ((((((instanceVar_T0*instancePar_NF)*instanceVar_Weff)/Lvsat)*(instanceVar_T1+(T7/(12.0*T3))))*3.0)*betanoisq);
      mig = (((((((Lvsat*T10)*T10)*(((instanceVar_T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)/(((instancePar_NF*instanceVar_Weff)*12.0)*instanceVar_T0));
      migid = (((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395);
      sqid = sqrt((Nt*mid));
      if ((mig==0))
      {
        sqig = 0.0;
        cm_igid = 0.0;
      }
      else
      {
        sqig = sqrt((Nt/mig));
        if ((sqid==0))
        {
          cm_igid = 0.0;
        }
        else
        {
          cm_igid = ((migid*sqig)/sqid);
        }
      }
      // I(N2,GND) <+ (white_noise(cm_igid,"corl"))
      // I(N1,GND) <+ (white_noise(((sqig*sqig)*(1.0-cm_igid)),"corl"))
      // I(N1,GND) <+ (((-sqig)*V(N2,GND)))
      staticContributions[admsNodeID_N1] += ((-sqig)*(probeVars[admsProbeID_V_N2_GND]));
      // I(N1,GND) <+ (ddt((((((mig*Cox)*Weff)*NF)*Leff)*V(N1,GND))))
      dynamicContributions[admsNodeID_N1] += ((((((mig*instanceVar_Cox)*instanceVar_Weff)*instancePar_NF)*instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND])));
      // I(di,si) <+ (white_noise(((sqid*sqid)*(1.0-cm_igid)),"id"))
      // I(di,si) <+ ((sqid*V(N2,GND)))
      staticContributions[admsNodeID_di] += (sqid*(probeVars[admsProbeID_V_N2_GND]));
      staticContributions[admsNodeID_si] -= (sqid*(probeVars[admsProbeID_V_N2_GND]));
      // I(gi,si) <+ (ddt((0.5*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
      dynamicContributions[admsNodeID_gi] += ((0.5*(((((((1.0+sigvds)*mig)*instanceVar_Cox)*instanceVar_Weff)*instancePar_NF)*instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
      dynamicContributions[admsNodeID_si] -= ((0.5*(((((((1.0+sigvds)*mig)*instanceVar_Cox)*instanceVar_Weff)*instancePar_NF)*instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
      // I(gi,di) <+ (ddt((0.5*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
      dynamicContributions[admsNodeID_gi] += ((0.5*(((((((1.0-sigvds)*mig)*instanceVar_Cox)*instanceVar_Weff)*instancePar_NF)*instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
      dynamicContributions[admsNodeID_di] -= ((0.5*(((((((1.0-sigvds)*mig)*instanceVar_Cox)*instanceVar_Weff)*instancePar_NF)*instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
    }
    else
    {
      // no default
    }
  // I(N2,GND) <+ (V(N2,GND))
  staticContributions[admsNodeID_N2] += (probeVars[admsProbeID_V_N2_GND]);
  // I(N1,GND) <+ (V(N1,GND))
  staticContributions[admsNodeID_N1] += (probeVars[admsProbeID_V_N1_GND]);
  if ((modelPar_IGCMOD!=0))
  {
    // I(gi,si) <+ (white_noise(((2.0*1.60219e-19)*abs((igcs+igs))),"igs"))
    // I(gi,di) <+ (white_noise(((2.0*1.60219e-19)*abs((igcd+igd))),"igd"))
  }
  if ((modelPar_IGBMOD!=0))
  {
    // I(gi,bi) <+ (white_noise(((2.0*1.60219e-19)*abs(igb)),"igb"))
  }
  vgfbCV = vgfb;
  gamg2 = ((((2.0*1.60219e-19)*instanceVar_epssi)*instanceVar_NGATE_i)/((instanceVar_Cox*instanceVar_Cox)*Vt));
  invgamg2 = adms_ternary_op<AdmsSensFadType>((instanceVar_NGATE_i>0),(1.0/gamg2),0.0);
  if ((modelPar_CVMOD==1))
  {
    instanceVar_VFBCV_i = (instanceVar_VFBCV_i+modelPar_DELVT0);
    vg = (Vg*inv_Vt);
    vs = (Vs*inv_Vt);
    vfb = (instanceVar_VFBCV_i*inv_Vt);
    vgfbCV = (vg-vfb);
    phib = log((instanceVar_NDEPCV_i/ni));
    gam = (sqrt(((((2.0*1.60219e-19)*instanceVar_epssi)*instanceVar_NDEPCV_i)*inv_Vt))/instanceVar_Cox);
    inv_gam = (1.0/gam);
    gamg2 = ((((2.0*1.60219e-19)*instanceVar_epssi)*instanceVar_NGATE_i)/((instanceVar_Cox*instanceVar_Cox)*Vt));
    invgamg2 = adms_ternary_op<AdmsSensFadType>((instanceVar_NGATE_i>0),(1.0/gamg2),0.0);
    DPD = adms_ternary_op<AdmsSensFadType>((instanceVar_NGATE_i>0),(instanceVar_NDEPCV_i/instanceVar_NGATE_i),0.0);
    instanceVar_T1 = (1.0+DPD);
    vgfbPD = (vgfbCV/instanceVar_T1);
    gammaPD = (gam/instanceVar_T1);
    instanceVar_T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
    instanceVar_T2 = (instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+(6.0*vgfbPD))));
    if ((vgfbPD<0.0))
    {
      T3 = ((vgfbPD-instanceVar_T2)/gammaPD);
      psip = (-log(((1.0-instanceVar_T2)+(T3*T3))));
    }
    else
    {
      T3 = exp((-instanceVar_T2));
      instanceVar_T1 = (0.5*gammaPD);
      instanceVar_T2 = (sqrt((((vgfbPD-1.0)+T3)+(instanceVar_T1*instanceVar_T1)))-instanceVar_T1);
      psip = (((instanceVar_T2*instanceVar_T2)+1.0)-T3);
    }
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    instanceVar_T1 = ((psip-(2.0*phib))-vs);
    instanceVar_T2 = (instanceVar_T1-log(((4.0*instanceVar_T0)*sqrtpsip)));
    T8 = (0.5*((instanceVar_T2-0.201491)-sqrt(((instanceVar_T2*(instanceVar_T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          instanceVar_T2 = ((T8-T4)/T5);
          T6 = (instanceVar_T2*instanceVar_T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qs = (T3*(((1.0+instanceVar_T1)-T8)-log(((2.0*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T6 = (((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa))*((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceVar_T0*T3)+sqrtpsisa))))-T6);
      qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    psipclamp = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))));
    sqrtpsip = sqrt(psipclamp);
    psiavg = (psip-(2.0*qs));
    instanceVar_T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
    nq = (1.0+(gam/(sqrtpsip+sqrt(instanceVar_T0))));
    instanceVar_T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
    qbs = (0.5*((instanceVar_T0)+sqrt((((instanceVar_T0)*(instanceVar_T0))+((0.25*0.1)*0.1)))));
    qis = (((2.0*nq)*Vt)*qs);
    Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
    T3 = ((UA_a+(UC_a*Vbsx))*pow(Eeffs,instanceVar_EU_i));
    T4 = (1.0+T3);
    Dmobs = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
    LambdaC_by2 = (((U0_a/Dmobs)*Vt)/(VSATCV_t*instanceVar_Lact));
    qdsat = ((LambdaC_by2*((qs*qs)+qs))/(1.0+(LambdaC_by2*(1.0+qs))));
    vdsatcv = ((psip-(2.0*phib))-((2.0*qdsat)+log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
    VdsatCV = (vdsatcv*Vt);
    VdssatCV = (0.5*(((VdsatCV-Vs))+sqrt(((((VdsatCV-Vs))*((VdsatCV-Vs)))+((0.25*1e-3)*1e-3)))));
    T7 = pow((Vds/VdssatCV),(1.0/DELTA_t));
    T8 = pow((1.0+T7),(-DELTA_t));
    Vdseff = (Vds*T8);
    vdeff = ((Vdseff+Vs)*inv_Vt);
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    instanceVar_T1 = ((psip-(2.0*phib))-vdeff);
    instanceVar_T2 = (instanceVar_T1-log(((4.0*instanceVar_T0)*sqrtpsip)));
    T8 = (0.5*((instanceVar_T2-0.201491)-sqrt(((instanceVar_T2*(instanceVar_T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          instanceVar_T2 = ((T8-T4)/T5);
          T6 = (instanceVar_T2*instanceVar_T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qdeff = (T3*(((1.0+instanceVar_T1)-T8)-log(((2.0*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T6 = (((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa))*((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceVar_T0*T3)+sqrtpsisa))))-T6);
      qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    psiavg = (((psip-qs)-qdeff)-1.0);
    instanceVar_T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
    instanceVar_T2 = sqrt(instanceVar_T0);
    T3 = ((1.0+DPD)+(gam/(sqrtpsip+instanceVar_T2)));
    T4 = (0.5+((DPD*instanceVar_T2)*inv_gam));
    T5 = sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)));
    nq = (T3/(T4+T5));
    instanceVar_T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
    qbs = (0.5*((instanceVar_T0)+sqrt((((instanceVar_T0)*(instanceVar_T0))+((0.25*0.1)*0.1)))));
    instanceVar_T1 = (Vt*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
    qbd = (0.5*((instanceVar_T1)+sqrt((((instanceVar_T1)*(instanceVar_T1))+((0.25*0.1)*0.1)))));
    qb = (0.5*(qbs+qbd));
    qia = ((nq*Vt)*(qs+qdeff));
    Eeffm = (EeffFactor*(qb+(eta_mu*qia)));
    T3 = ((UA_a+(UC_a*Vbsx))*pow(Eeffm,instanceVar_EU_i));
    T4 = (1.0+T3);
    Dmob = (0.5*((T4+1.0)+sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)))));
    LambdaC = (((2.0*(U0_a/Dmob))*Vt)/(VSATCV_t*instanceVar_Lact));
    dps = (qs-qdeff);
    instanceVar_T1 = ((2.0*(LambdaC*dps))*(LambdaC*dps));
    zsat = sqrt((1.0+instanceVar_T1));
    Dvsat = (0.5*(1.0+zsat));
    Esat = ((2.0*VSATCV_t)/(U0_a/Dmob));
    EsatL = (Esat*instanceVar_Lact);
    Vasat = (VdssatCV+EsatL);
    diffVds = (Vds-Vdseff);
  }
  if ((instanceVar_PCLMCV_i!=0))
  {
    MdL = (1.0+(instanceVar_PCLMCV_i*AnalogFunctions::lln<AdmsSensFadType>((1.0+((diffVds/instanceVar_PCLMCV_i)/Vasat)))));
  }
  else
  {
    MdL = 1.0;
  }
  MdL_2 = (MdL*MdL);
  inv_MdL = (1.0/MdL);
  inv_MdL_2 = (1.0/MdL_2);
  MdL_less_1 = (MdL-1.0);
  vgpqm = (vgfbCV-psip);
  DQSD = (qs-qdeff);
  DQSD2 = ((qs-qdeff)*(qs-qdeff));
  sis = (vgpqm+(2.0*qs));
  sid = (vgpqm+(2.0*qdeff));
  instanceVar_T1 = (0.5*((sis)+sqrt((((sis)*(sis))+((0.25*0.5)*0.5)))));
  instanceVar_T2 = (0.5*((sid)+sqrt((((sid)*(sid))+((0.25*0.5)*0.5)))));
  Temps = sqrt((0.25+(instanceVar_T1*invgamg2)));
  Tempd = sqrt((0.25+(instanceVar_T2*invgamg2)));
  instanceVar_T1 = (sis/(1.0+(2.0*Temps)));
  instanceVar_T2 = (sid/(1.0+(2.0*Tempd)));
  T3 = (Temps+Tempd);
  T4 = (0.33333333333333333*(DQSD2/((T3*T3)*T3)));
  T5 = ((Dvsat*inv_MdL)/((1.0+qs)+qdeff));
  T6 = ((0.8*((T3*T3)+(Temps*Tempd)))*T5);
  T7 = (T6+(2.0*invgamg2));
  T8 = ((0.33333333333333333*DQSD2)*T5);
  dqgeff = ((sid*((2.0*Tempd)-1.0))/((2.0*Tempd)+1.0));
  qbeff = ((vgpqm-((2.0*(nq-1.0))*qdeff))+dqgeff);
  Qb = ((inv_MdL*((instanceVar_T1+instanceVar_T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*qbeff));
  T9 = (qs+qdeff);
  T10 = ((DQSD2*T5)*T5);
  Qi = (((nq*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*qdeff));
  Qd1 = ((nq*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
  Qd2 = ((nq*(MdL-inv_MdL))*qdeff);
  Qd = (Qd1+Qd2);
  Qs = (Qi-Qd);
  qbaCV = (0.5*(((Vt*Qb))+sqrt(((((Vt*Qb))*((Vt*Qb)))+((0.25*0.1)*0.1)))));
  qiaCV = (Vt*(Qs+Qd));
  instanceVar_T0 = ((qiaCV+(modelPar_ETAQM*qbaCV))/modelPar_QM0);
  instanceVar_T1 = (1.0+pow(instanceVar_T0,(0.7*modelPar_BDOS)));
  XDCinv = ((modelPar_ADOS*1.9e-9)/instanceVar_T1);
  Coxeffinv = ((3.9*8.85418e-12)/(((instanceVar_BSIM6TOXP*3.9)/modelPar_EPSROX)+(XDCinv/instanceVar_epsratio)));
  QBi = ((((((-instancePar_NF)*instanceVar_Wact)*instanceVar_Lact)*((8.85418e-12*modelPar_EPSROX)/instanceVar_BSIM6TOXP))*Vt)*Qb);
  WLCOXVtinv = ((((instancePar_NF*instanceVar_Wact)*instanceVar_Lact)*Coxeffinv)*Vt);
  QSi = ((-WLCOXVtinv)*Qs);
  QDi = ((-WLCOXVtinv)*Qd);
  QGi = (-((QBi+QSi)+QDi));
  if ((!modelPar_given_CF))
  {
    instanceVar_CF_i = ((((2.0*modelPar_EPSROX)*8.85418e-12)/3.14159265358979323846)*log((modelPar_CFRCOEFF*(1.0+(0.4e-6/modelPar_TOXE)))));
  }
  Cgsof = (modelPar_CGSO+instanceVar_CF_i);
  Cgdof = (modelPar_CGDO+instanceVar_CF_i);
  if ((modelPar_COVMOD==0))
  {
    Qovs = ((((-instanceVar_Wact)*instancePar_NF)*Cgsof)*Vgs_ov_noswap);
    Qovd = ((((-instanceVar_Wact)*instancePar_NF)*Cgdof)*Vgd_ov_noswap);
  }
  else
  {
    instanceVar_T0 = sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
    Vgsov = (0.5*(((Vgs_ov_noswap-Vfbsdr)+0.02)-instanceVar_T0));
    instanceVar_T1 = sqrt((1.0-((4.0*Vgsov)/instanceVar_CKAPPAS_i)));
    Qovs = (((-instanceVar_Wact)*instancePar_NF)*((Cgsof*Vgs_ov_noswap)+(instanceVar_CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*instanceVar_CKAPPAS_i)*((-1.0)+instanceVar_T1))))));
    instanceVar_T0 = sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
    Vgdov = (0.5*(((Vgd_ov_noswap-Vfbsdr)+0.02)-instanceVar_T0));
    instanceVar_T2 = sqrt((1.0-((4.0*Vgdov)/instanceVar_CKAPPAD_i)));
    Qovd = (((-instanceVar_Wact)*instancePar_NF)*((Cgdof*Vgd_ov_noswap)+(instanceVar_CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*instanceVar_CKAPPAD_i)*((-1.0)+instanceVar_T2))))));
  }
  Qovb = (((((-instanceVar_devsign)*instancePar_NF)*instanceVar_Lact)*modelPar_CGBO)*(probeVars[admsProbeID_V_gm_bi]));
  Qovg = (-((Qovs+Qovd)+Qovb));
  if ((modelPar_EDGEFET==1))
  {
    NFACTOREDGE_t = (modelPar_NFACTOREDGE*AnalogFunctions::hypsmooth<AdmsSensFadType>((1.0+(modelPar_TNFACTOREDGE*(TRatio-1.0))),1e-3));
    ETA0EDGE_t = (modelPar_ETA0EDGE*(1.0+(modelPar_TETA0EDGE*(TRatio-1.0))));
    cdsc = (((modelPar_CITEDGE+NFACTOREDGE_t)+(modelPar_CDSCDEDGE*Vdsx))-(modelPar_CDSCBEDGE*Vbsx));
    instanceVar_T1 = (1.0+(cdsc/instanceVar_Cox));
    n = (0.5*((instanceVar_T1+1.0)+sqrt((((instanceVar_T1-1.0)*(instanceVar_T1-1.0))+((0.25*0.05)*0.05)))));
    nVt = (n*Vt);
    inv_nVt = (1.0/nVt);
    vg = (Vg*inv_nVt);
    vs = (Vs*inv_nVt);
    vfb = (instanceVar_VFB_i*inv_nVt);
    dvth_dibl = ((-(ETA0EDGE_t+(modelPar_ETABEDGE*Vbsx)))*Vdsx);
    dvth_temp = (((modelPar_KT1EDGE+(modelPar_KT1LEDGE/instanceVar_Leff))+(modelPar_KT2EDGE*Vbsx))*(pow(TRatio,modelPar_KT1EXPEDGE)-1.0));
    litl_edge = (litl*(1.0+(modelPar_DVT2EDGE*Vbsx)));
    theta_sce_edge = ((0.5*modelPar_DVT0EDGE)/(cosh(((modelPar_DVT1EDGE*instanceVar_Leff)/litl_edge))-1.0));
    dvth_sce = (theta_sce_edge*(Vbi-Phist));
    Vth_shift = (((dvth_dibl-dvth_temp)+dvth_sce)+modelPar_DVTEDGE);
    vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
    DGAMMAEDGE_i = (modelPar_DGAMMAEDGE*(1.0+(modelPar_DGAMMAEDGEL*pow(instanceVar_Leff,(-modelPar_DGAMMAEDGELEXP)))));
    gam = (sqrt(((((2.0*1.60219e-19)*instanceVar_epssi)*instanceVar_NDEP_i)*inv_nVt))/instanceVar_Cox);
    gam = (gam*(1.0+DGAMMAEDGE_i));
    inv_gam = (1.0/gam);
    phib_n = (phib/n);
    instanceVar_T1 = (1.0);
    vgfbPD = (vgfb/instanceVar_T1);
    gammaPD = (gam/instanceVar_T1);
    instanceVar_T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
    instanceVar_T2 = (instanceVar_T1+sqrt(((instanceVar_T1*instanceVar_T1)+(6.0*vgfbPD))));
    if ((vgfbPD<0.0))
    {
      T3 = ((vgfbPD-instanceVar_T2)/gammaPD);
      psip = (-log(((1.0-instanceVar_T2)+(T3*T3))));
    }
    else
    {
      T3 = exp((-instanceVar_T2));
      instanceVar_T1 = (0.5*gammaPD);
      instanceVar_T2 = (sqrt((((vgfbPD-1.0)+T3)+(instanceVar_T1*instanceVar_T1)))-instanceVar_T1);
      psip = (((instanceVar_T2*instanceVar_T2)+1.0)-T3);
    }
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    instanceVar_T1 = ((psip-(2.0*phib_n))-vs);
    instanceVar_T2 = (instanceVar_T1-log(((4.0*instanceVar_T0)*sqrtpsip)));
    T8 = (0.5*((instanceVar_T2-0.201491)-sqrt(((instanceVar_T2*(instanceVar_T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          instanceVar_T2 = ((T8-T4)/T5);
          T6 = (instanceVar_T2*instanceVar_T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qs = (T3*(((1.0+instanceVar_T1)-T8)-log(((2.0*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T6 = (((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa))*((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceVar_T0*T3)+sqrtpsisa))))-T6);
      qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    vdsatedge = (((2.0*nVt)*qs)+(2.0*nVt));
    Vdsatedge = vdsatedge;
    Vdsatedge = (Vdsatedge+Vs);
    Vdssate = (0.5*(((Vdsatedge-Vs))+sqrt(((((Vdsatedge-Vs))*((Vdsatedge-Vs)))+((0.25*1.0e-3)*1.0e-3)))));
    T7 = pow((Vds/Vdssate),(1.0/DELTA_t));
    T8 = pow((1.0+T7),(-DELTA_t));
    Vdseff = (Vds*T8);
    vdeff = ((Vdseff+Vs)*inv_nVt);
    T8 = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)))));
    sqrtpsip = sqrt(T8);
    T9 = (1.0+(gam/(2.0*sqrtpsip)));
    instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
    instanceVar_T1 = ((psip-(2.0*phib_n))-vdeff);
    instanceVar_T2 = (instanceVar_T1-log(((4.0*instanceVar_T0)*sqrtpsip)));
    T8 = (0.5*((instanceVar_T2-0.201491)-sqrt(((instanceVar_T2*(instanceVar_T2+0.402982))+2.446562))));
    sqrtpsisa = sqrtpsip;
    if ((T8<=(-68.0)))
    {
      T4 = (-100.0);
      T5 = 20.0;
      if ((T8<(T4-(0.5*T5))))
      {
        T3 = exp(T4);
      }
      else
      {
        if ((T8>(T4+(0.5*T5))))
        {
          T3 = exp(T8);
        }
        else
        {
          instanceVar_T2 = ((T8-T4)/T5);
          T6 = (instanceVar_T2*instanceVar_T2);
          T3 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
        }
      }
      qdeff = (T3*(((1.0+instanceVar_T1)-T8)-log(((2.0*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa))))));
    }
    else
    {
      T3 = exp(T8);
      sqrtpsisainv = (1.0/sqrtpsisa);
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T3 = (T3-(T4/T5));
      T4 = (((2.0*T3)+log((((T3*2.0)*instanceVar_T0)*(((T3*2.0)*instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceVar_T1);
      T5 = ((2.0+(1.0/T3))+((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T6 = (((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa))*((instanceVar_T0-sqrtpsisainv)/((instanceVar_T0*T3)+sqrtpsisa)));
      T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceVar_T0*T3)+sqrtpsisa))))-T6);
      qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
    }
    psipclamp = (0.5*((psip+1.0)+sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)))));
    sqrtpsip = sqrt(psipclamp);
    psiavg = (((psip-qs)-qdeff)-1.0);
    instanceVar_T0 = (0.5*((psiavg+1.0)+sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)))));
    instanceVar_T2 = sqrt(instanceVar_T0);
    nq = (1.0+(gam/(sqrtpsip+instanceVar_T2)));
    ids_edge = ((((((((((2.0*instancePar_NF)*nq)*ueff)*modelPar_WEDGE)/instanceVar_Leff)*instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
    ids = (ids_edge+ids);
  }
  QB = (instanceVar_devsign*(((QBi+Qovb)+Qbs)+Qbd));
  if ((sigvds>0))
  {
    QSI = (instanceVar_devsign*QSi);
    QDI = (instanceVar_devsign*QDi);
    QS = (instanceVar_devsign*((QSi+Qovs)-Qbs));
    QD = (instanceVar_devsign*((QDi+Qovd)-Qbd));
  }
  else
  {
    QSI = (instanceVar_devsign*QDi);
    QDI = (instanceVar_devsign*QSi);
    QS = (instanceVar_devsign*((QDi+Qovs)-Qbs));
    QD = (instanceVar_devsign*((QSi+Qovd)-Qbd));
  }
  QG = (instanceVar_devsign*(QGi+Qovg));
  QBI = (instanceVar_devsign*QBi);
  QGI = (instanceVar_devsign*QGi);
  // I(gi,bi) <+ (ddt(QGI))
  dynamicContributions[admsNodeID_gi] += (QGI);
  dynamicContributions[admsNodeID_bi] -= (QGI);
  // I(si,bi) <+ (ddt(QSI))
  dynamicContributions[admsNodeID_si] += (QSI);
  dynamicContributions[admsNodeID_bi] -= (QSI);
  // I(di,bi) <+ (ddt(QDI))
  dynamicContributions[admsNodeID_di] += (QDI);
  dynamicContributions[admsNodeID_bi] -= (QDI);
  // I(gm,si) <+ (ddt(((-devsign)*Qovs)))
  dynamicContributions[admsNodeID_gm] += (((-instanceVar_devsign)*Qovs));
  dynamicContributions[admsNodeID_si] -= (((-instanceVar_devsign)*Qovs));
  // I(gm,di) <+ (ddt(((-devsign)*Qovd)))
  dynamicContributions[admsNodeID_gm] += (((-instanceVar_devsign)*Qovd));
  dynamicContributions[admsNodeID_di] -= (((-instanceVar_devsign)*Qovd));
  // I(gm,bi) <+ (ddt(((-devsign)*Qovb)))
  dynamicContributions[admsNodeID_gm] += (((-instanceVar_devsign)*Qovb));
  dynamicContributions[admsNodeID_bi] -= (((-instanceVar_devsign)*Qovb));
  // I(di,si) <+ (((devsign*sigvds)*ids))
  staticContributions[admsNodeID_di] += ((instanceVar_devsign*sigvds)*ids);
  staticContributions[admsNodeID_si] -= ((instanceVar_devsign*sigvds)*ids);
  if ((modelPar_IGBMOD!=0))
  {
    // I(gi,bi) <+ (IGB)
    staticContributions[admsNodeID_gi] += IGB;
    staticContributions[admsNodeID_bi] -= IGB;
  }
  if ((modelPar_IGCMOD!=0))
  {
    // I(gi,si) <+ ((IGS+IGCS))
    staticContributions[admsNodeID_gi] += (IGS+IGCS);
    staticContributions[admsNodeID_si] -= (IGS+IGCS);
    // I(gi,di) <+ ((IGD+IGCD))
    staticContributions[admsNodeID_gi] += (IGD+IGCD);
    staticContributions[admsNodeID_di] -= (IGD+IGCD);
  }
  if ((sigvds>0))
  {
    // I(di,bi) <+ ((ISUB+IGIDL))
    staticContributions[admsNodeID_di] += (ISUB+IGIDL);
    staticContributions[admsNodeID_bi] -= (ISUB+IGIDL);
    // I(si,bi) <+ (IGISL)
    staticContributions[admsNodeID_si] += IGISL;
    staticContributions[admsNodeID_bi] -= IGISL;
  }
  else
  {
    // I(di,bi) <+ (IGIDL)
    staticContributions[admsNodeID_di] += IGIDL;
    staticContributions[admsNodeID_bi] -= IGIDL;
    // I(si,bi) <+ ((ISUB+IGISL))
    staticContributions[admsNodeID_si] += (ISUB+IGISL);
    staticContributions[admsNodeID_bi] -= (ISUB+IGISL);
  }
  if ((modelPar_RDSMOD!=2))
  {
    gdpr = (1.0/Rdrain);
    gspr = (1.0/Rsource);
    // I(d,di) <+ ((V(d,di)*gdpr))
    staticContributions[admsNodeID_d] += ((probeVars[admsProbeID_V_d_di])*gdpr);
    staticContributions[admsNodeID_di] -= ((probeVars[admsProbeID_V_d_di])*gdpr);
    // I(s,si) <+ ((V(s,si)*gspr))
    staticContributions[admsNodeID_s] += ((probeVars[admsProbeID_V_s_si])*gspr);
    staticContributions[admsNodeID_si] -= ((probeVars[admsProbeID_V_s_si])*gspr);
    // I(d,di) <+ (white_noise((Nt*gdpr),"rd"))
    // I(s,si) <+ (white_noise((Nt*gspr),"rs"))
  }
  else
  {
    // V(d,di) <+ (0)
    // do nothing at all
    // V(s,si) <+ (0)
    // do nothing at all
  }
  if ((instancePar_RGATEMOD==0))
  {
    // V(g,gm) <+ (0)
    // do nothing at all
  }
  else
    //Begin block rgate
  {
    //Block-local variables for block rgate
    AdmsSensFadType Ggate;
    AdmsSensFadType Gnoise;
    //End of Block-local variables
    if ((instancePar_RGATEMOD==2))
    {
      Ggate = Gcrg;
      Gnoise = ((Gcrg*Gcrg)/instanceVar_Grgeltd);
    }
    else
    {
      Ggate = instanceVar_Grgeltd;
      Gnoise = instanceVar_Grgeltd;
    }
    // I(g,gm) <+ ((V(g,gm)*Ggate))
    staticContributions[admsNodeID_g] += ((probeVars[admsProbeID_V_g_gm])*Ggate);
    staticContributions[admsNodeID_gm] -= ((probeVars[admsProbeID_V_g_gm])*Ggate);
    // I(g,gm) <+ (white_noise((Nt*Gnoise),"rg"))
  }
  // End block rgate
  if ((instancePar_RGATEMOD==3))
  {
    // I(gm,gi) <+ ((V(gm,gi)*Gcrg))
    staticContributions[admsNodeID_gm] += ((probeVars[admsProbeID_V_gm_gi])*Gcrg);
    staticContributions[admsNodeID_gi] -= ((probeVars[admsProbeID_V_gm_gi])*Gcrg);
  }
  else
  {
    // V(gm,gi) <+ (0)
    // do nothing at all
  }
  if (((modelPar_SHMOD!=0)&&(modelPar_RTH0>0)))
  {
    if ((modelPar_RDSMOD!=2))
    {
      // Pwr(t,GND) <+ (((-(((((devsign*sigvds)*ids)*V(di,si))+((V(d,di)*V(d,di))/Rdrain))+((V(s,si)*V(s,si))/Rsource)))+(delTemp1*gth)))
      staticContributions[admsNodeID_t] += ((-(((((instanceVar_devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si]))+(((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))/Rdrain))+(((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))/Rsource)))+(delTemp1*instanceVar_gth));
      // Pwr(t,GND) <+ (ddt((delTemp1*cth)))
      dynamicContributions[admsNodeID_t] += ((delTemp1*instanceVar_cth));
    }
    else
    {
      // Pwr(t,GND) <+ (((-(((devsign*sigvds)*ids)*V(di,si)))+(delTemp1*gth)))
      staticContributions[admsNodeID_t] += ((-(((instanceVar_devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si])))+(delTemp1*instanceVar_gth));
      // Pwr(t,GND) <+ (ddt((delTemp1*cth)))
      dynamicContributions[admsNodeID_t] += ((delTemp1*instanceVar_cth));
    }
  }
  else
  {
    // Temp(t,GND) <+ (0)
    // do nothing at all
  }
  if ((instancePar_RBODYMOD!=0))
  {
    // I(bi,sbulk) <+ ((V(bi,sbulk)*Grbps))
    staticContributions[admsNodeID_bi] += ((probeVars[admsProbeID_V_bi_sbulk])*instanceVar_Grbps);
    staticContributions[admsNodeID_sbulk] -= ((probeVars[admsProbeID_V_bi_sbulk])*instanceVar_Grbps);
    // I(b,sbulk) <+ ((V(b,sbulk)*Grbsb))
    staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_sbulk])*instanceVar_Grbsb);
    staticContributions[admsNodeID_sbulk] -= ((probeVars[admsProbeID_V_b_sbulk])*instanceVar_Grbsb);
    // I(b,bi) <+ ((V(b,bi)*Grbpb))
    staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_bi])*instanceVar_Grbpb);
    staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_b_bi])*instanceVar_Grbpb);
    // I(b,dbulk) <+ ((V(b,dbulk)*Grbdb))
    staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_dbulk])*instanceVar_Grbdb);
    staticContributions[admsNodeID_dbulk] -= ((probeVars[admsProbeID_V_b_dbulk])*instanceVar_Grbdb);
    // I(bi,dbulk) <+ ((V(bi,dbulk)*Grbpd))
    staticContributions[admsNodeID_bi] += ((probeVars[admsProbeID_V_bi_dbulk])*instanceVar_Grbpd);
    staticContributions[admsNodeID_dbulk] -= ((probeVars[admsProbeID_V_bi_dbulk])*instanceVar_Grbpd);
    // I(sbulk,bi) <+ (white_noise((Nt*Grbps),"rbps"))
    // I(sbulk,b) <+ (white_noise((Nt*Grbsb),"rbsb"))
    // I(b,bi) <+ (white_noise((Nt*Grbpb),"rbpb"))
    // I(dbulk,bi) <+ (white_noise((Nt*Grbpd),"rbpd"))
    // I(dbulk,b) <+ (white_noise((Nt*Grbdb),"rbdb"))
  }
  else
  {
    // V(b,sbulk) <+ (0)
    // do nothing at all
    // V(b,bi) <+ (0)
    // do nothing at all
    // V(b,dbulk) <+ (0)
    // do nothing at all
  }
  if ((instancePar_RBODYMOD!=0))
  {
    // I(sbulk,si) <+ ((devsign*Ibs))
    staticContributions[admsNodeID_sbulk] += (instanceVar_devsign*Ibs);
    staticContributions[admsNodeID_si] -= (instanceVar_devsign*Ibs);
    // I(dbulk,di) <+ ((devsign*Ibd))
    staticContributions[admsNodeID_dbulk] += (instanceVar_devsign*Ibd);
    staticContributions[admsNodeID_di] -= (instanceVar_devsign*Ibd);
    // I(sbulk,si) <+ ((devsign*ddt(Qbs)))
    dynamicContributions[admsNodeID_sbulk] += (instanceVar_devsign*(Qbs));
    dynamicContributions[admsNodeID_si] -= (instanceVar_devsign*(Qbs));
    // I(dbulk,di) <+ ((devsign*ddt(Qbd)))
    dynamicContributions[admsNodeID_dbulk] += (instanceVar_devsign*(Qbd));
    dynamicContributions[admsNodeID_di] -= (instanceVar_devsign*(Qbd));
  }
  else
  {
    // I(bi,si) <+ ((devsign*Ibs))
    staticContributions[admsNodeID_bi] += (instanceVar_devsign*Ibs);
    staticContributions[admsNodeID_si] -= (instanceVar_devsign*Ibs);
    // I(bi,di) <+ ((devsign*Ibd))
    staticContributions[admsNodeID_bi] += (instanceVar_devsign*Ibd);
    staticContributions[admsNodeID_di] -= (instanceVar_devsign*Ibd);
    // I(bi,si) <+ ((devsign*ddt(Qbs)))
    dynamicContributions[admsNodeID_bi] += (instanceVar_devsign*(Qbs));
    dynamicContributions[admsNodeID_si] -= (instanceVar_devsign*(Qbs));
    // I(bi,di) <+ ((devsign*ddt(Qbd)))
    dynamicContributions[admsNodeID_bi] += (instanceVar_devsign*(Qbd));
    dynamicContributions[admsNodeID_di] -= (instanceVar_devsign*(Qbd));
  }
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(14+0);
  dqdp.resize(14+0);
  Findices.resize(14+0);
  Qindices.resize(14+0);

  std::vector <double> probeVars(21);
  std::vector <AdmsSensFadType> staticContributions(14+0);
  std::vector <AdmsSensFadType> dynamicContributions(14+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 14+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_L=mod.L;
  bool modelPar_given_L=mod.given("L");
  AdmsSensFadType modelPar_VFBSDOFF=mod.VFBSDOFF;
  bool modelPar_given_VFBSDOFF=mod.given("VFBSDOFF");
  AdmsSensFadType modelPar_XGW=mod.XGW;
  bool modelPar_given_XGW=mod.given("XGW");
  AdmsSensFadType modelPar_RBPB=mod.RBPB;
  bool modelPar_given_RBPB=mod.given("RBPB");
  AdmsSensFadType modelPar_RBPD=mod.RBPD;
  bool modelPar_given_RBPD=mod.given("RBPD");
  AdmsSensFadType modelPar_RBPS=mod.RBPS;
  bool modelPar_given_RBPS=mod.given("RBPS");
  AdmsSensFadType modelPar_RBDB=mod.RBDB;
  bool modelPar_given_RBDB=mod.given("RBDB");
  AdmsSensFadType modelPar_RBSB=mod.RBSB;
  bool modelPar_given_RBSB=mod.given("RBSB");
  AdmsSensFadType modelPar_SA=mod.SA;
  bool modelPar_given_SA=mod.given("SA");
  AdmsSensFadType modelPar_SB=mod.SB;
  bool modelPar_given_SB=mod.given("SB");
  AdmsSensFadType modelPar_SD=mod.SD;
  bool modelPar_given_SD=mod.given("SD");
  AdmsSensFadType modelPar_LLONG=mod.LLONG;
  bool modelPar_given_LLONG=mod.given("LLONG");
  AdmsSensFadType modelPar_LMLT=mod.LMLT;
  bool modelPar_given_LMLT=mod.given("LMLT");
  AdmsSensFadType modelPar_WMLT=mod.WMLT;
  bool modelPar_given_WMLT=mod.given("WMLT");
  AdmsSensFadType modelPar_XL=mod.XL;
  bool modelPar_given_XL=mod.given("XL");
  AdmsSensFadType modelPar_WWIDE=mod.WWIDE;
  bool modelPar_given_WWIDE=mod.given("WWIDE");
  AdmsSensFadType modelPar_XW=mod.XW;
  bool modelPar_given_XW=mod.given("XW");
  AdmsSensFadType modelPar_LINT=mod.LINT;
  bool modelPar_given_LINT=mod.given("LINT");
  AdmsSensFadType modelPar_LL=mod.LL;
  bool modelPar_given_LL=mod.given("LL");
  AdmsSensFadType modelPar_LW=mod.LW;
  bool modelPar_given_LW=mod.given("LW");
  AdmsSensFadType modelPar_LWL=mod.LWL;
  bool modelPar_given_LWL=mod.given("LWL");
  AdmsSensFadType modelPar_LLN=mod.LLN;
  bool modelPar_given_LLN=mod.given("LLN");
  AdmsSensFadType modelPar_LWN=mod.LWN;
  bool modelPar_given_LWN=mod.given("LWN");
  AdmsSensFadType modelPar_WINT=mod.WINT;
  bool modelPar_given_WINT=mod.given("WINT");
  AdmsSensFadType modelPar_WL=mod.WL;
  bool modelPar_given_WL=mod.given("WL");
  AdmsSensFadType modelPar_WW=mod.WW;
  bool modelPar_given_WW=mod.given("WW");
  AdmsSensFadType modelPar_WWL=mod.WWL;
  bool modelPar_given_WWL=mod.given("WWL");
  AdmsSensFadType modelPar_WLN=mod.WLN;
  bool modelPar_given_WLN=mod.given("WLN");
  AdmsSensFadType modelPar_WWN=mod.WWN;
  bool modelPar_given_WWN=mod.given("WWN");
  AdmsSensFadType modelPar_DLC=mod.DLC;
  bool modelPar_given_DLC=mod.given("DLC");
  AdmsSensFadType modelPar_LLC=mod.LLC;
  bool modelPar_given_LLC=mod.given("LLC");
  AdmsSensFadType modelPar_LWC=mod.LWC;
  bool modelPar_given_LWC=mod.given("LWC");
  AdmsSensFadType modelPar_LWLC=mod.LWLC;
  bool modelPar_given_LWLC=mod.given("LWLC");
  AdmsSensFadType modelPar_DWC=mod.DWC;
  bool modelPar_given_DWC=mod.given("DWC");
  AdmsSensFadType modelPar_WLC=mod.WLC;
  bool modelPar_given_WLC=mod.given("WLC");
  AdmsSensFadType modelPar_WWC=mod.WWC;
  bool modelPar_given_WWC=mod.given("WWC");
  AdmsSensFadType modelPar_WWLC=mod.WWLC;
  bool modelPar_given_WWLC=mod.given("WWLC");
  AdmsSensFadType modelPar_TOXE=mod.TOXE;
  bool modelPar_given_TOXE=mod.given("TOXE");
  AdmsSensFadType modelPar_TOXP=mod.TOXP;
  bool modelPar_given_TOXP=mod.given("TOXP");
  AdmsSensFadType modelPar_DTOX=mod.DTOX;
  bool modelPar_given_DTOX=mod.given("DTOX");
  AdmsSensFadType modelPar_NDEP=mod.NDEP;
  bool modelPar_given_NDEP=mod.given("NDEP");
  AdmsSensFadType modelPar_NDEPL1=mod.NDEPL1;
  bool modelPar_given_NDEPL1=mod.given("NDEPL1");
  AdmsSensFadType modelPar_NDEPLEXP1=mod.NDEPLEXP1;
  bool modelPar_given_NDEPLEXP1=mod.given("NDEPLEXP1");
  AdmsSensFadType modelPar_NDEPL2=mod.NDEPL2;
  bool modelPar_given_NDEPL2=mod.given("NDEPL2");
  AdmsSensFadType modelPar_NDEPLEXP2=mod.NDEPLEXP2;
  bool modelPar_given_NDEPLEXP2=mod.given("NDEPLEXP2");
  AdmsSensFadType modelPar_NDEPW=mod.NDEPW;
  bool modelPar_given_NDEPW=mod.given("NDEPW");
  AdmsSensFadType modelPar_NDEPWEXP=mod.NDEPWEXP;
  bool modelPar_given_NDEPWEXP=mod.given("NDEPWEXP");
  AdmsSensFadType modelPar_NDEPWL=mod.NDEPWL;
  bool modelPar_given_NDEPWL=mod.given("NDEPWL");
  AdmsSensFadType modelPar_NDEPWLEXP=mod.NDEPWLEXP;
  bool modelPar_given_NDEPWLEXP=mod.given("NDEPWLEXP");
  AdmsSensFadType modelPar_LNDEP=mod.LNDEP;
  bool modelPar_given_LNDEP=mod.given("LNDEP");
  AdmsSensFadType modelPar_WNDEP=mod.WNDEP;
  bool modelPar_given_WNDEP=mod.given("WNDEP");
  AdmsSensFadType modelPar_PNDEP=mod.PNDEP;
  bool modelPar_given_PNDEP=mod.given("PNDEP");
  AdmsSensFadType modelPar_NDEPCV=mod.NDEPCV;
  bool modelPar_given_NDEPCV=mod.given("NDEPCV");
  AdmsSensFadType modelPar_NDEPCVL1=mod.NDEPCVL1;
  bool modelPar_given_NDEPCVL1=mod.given("NDEPCVL1");
  AdmsSensFadType modelPar_NDEPCVLEXP1=mod.NDEPCVLEXP1;
  bool modelPar_given_NDEPCVLEXP1=mod.given("NDEPCVLEXP1");
  AdmsSensFadType modelPar_NDEPCVL2=mod.NDEPCVL2;
  bool modelPar_given_NDEPCVL2=mod.given("NDEPCVL2");
  AdmsSensFadType modelPar_NDEPCVLEXP2=mod.NDEPCVLEXP2;
  bool modelPar_given_NDEPCVLEXP2=mod.given("NDEPCVLEXP2");
  AdmsSensFadType modelPar_NDEPCVW=mod.NDEPCVW;
  bool modelPar_given_NDEPCVW=mod.given("NDEPCVW");
  AdmsSensFadType modelPar_NDEPCVWEXP=mod.NDEPCVWEXP;
  bool modelPar_given_NDEPCVWEXP=mod.given("NDEPCVWEXP");
  AdmsSensFadType modelPar_NDEPCVWL=mod.NDEPCVWL;
  bool modelPar_given_NDEPCVWL=mod.given("NDEPCVWL");
  AdmsSensFadType modelPar_NDEPCVWLEXP=mod.NDEPCVWLEXP;
  bool modelPar_given_NDEPCVWLEXP=mod.given("NDEPCVWLEXP");
  AdmsSensFadType modelPar_LNDEPCV=mod.LNDEPCV;
  bool modelPar_given_LNDEPCV=mod.given("LNDEPCV");
  AdmsSensFadType modelPar_WNDEPCV=mod.WNDEPCV;
  bool modelPar_given_WNDEPCV=mod.given("WNDEPCV");
  AdmsSensFadType modelPar_PNDEPCV=mod.PNDEPCV;
  bool modelPar_given_PNDEPCV=mod.given("PNDEPCV");
  AdmsSensFadType modelPar_NGATE=mod.NGATE;
  bool modelPar_given_NGATE=mod.given("NGATE");
  AdmsSensFadType modelPar_LNGATE=mod.LNGATE;
  bool modelPar_given_LNGATE=mod.given("LNGATE");
  AdmsSensFadType modelPar_WNGATE=mod.WNGATE;
  bool modelPar_given_WNGATE=mod.given("WNGATE");
  AdmsSensFadType modelPar_PNGATE=mod.PNGATE;
  bool modelPar_given_PNGATE=mod.given("PNGATE");
  AdmsSensFadType modelPar_EASUB=mod.EASUB;
  bool modelPar_given_EASUB=mod.given("EASUB");
  AdmsSensFadType modelPar_NI0SUB=mod.NI0SUB;
  bool modelPar_given_NI0SUB=mod.given("NI0SUB");
  AdmsSensFadType modelPar_BG0SUB=mod.BG0SUB;
  bool modelPar_given_BG0SUB=mod.given("BG0SUB");
  AdmsSensFadType modelPar_EPSRSUB=mod.EPSRSUB;
  bool modelPar_given_EPSRSUB=mod.given("EPSRSUB");
  AdmsSensFadType modelPar_EPSROX=mod.EPSROX;
  bool modelPar_given_EPSROX=mod.given("EPSROX");
  AdmsSensFadType modelPar_XJ=mod.XJ;
  bool modelPar_given_XJ=mod.given("XJ");
  AdmsSensFadType modelPar_LXJ=mod.LXJ;
  bool modelPar_given_LXJ=mod.given("LXJ");
  AdmsSensFadType modelPar_WXJ=mod.WXJ;
  bool modelPar_given_WXJ=mod.given("WXJ");
  AdmsSensFadType modelPar_PXJ=mod.PXJ;
  bool modelPar_given_PXJ=mod.given("PXJ");
  AdmsSensFadType modelPar_LVFB=mod.LVFB;
  bool modelPar_given_LVFB=mod.given("LVFB");
  AdmsSensFadType modelPar_WVFB=mod.WVFB;
  bool modelPar_given_WVFB=mod.given("WVFB");
  AdmsSensFadType modelPar_PVFB=mod.PVFB;
  bool modelPar_given_PVFB=mod.given("PVFB");
  AdmsSensFadType modelPar_VFB=mod.VFB;
  bool modelPar_given_VFB=mod.given("VFB");
  AdmsSensFadType modelPar_VFBCV=mod.VFBCV;
  bool modelPar_given_VFBCV=mod.given("VFBCV");
  AdmsSensFadType modelPar_LVFBCV=mod.LVFBCV;
  bool modelPar_given_LVFBCV=mod.given("LVFBCV");
  AdmsSensFadType modelPar_WVFBCV=mod.WVFBCV;
  bool modelPar_given_WVFBCV=mod.given("WVFBCV");
  AdmsSensFadType modelPar_PVFBCV=mod.PVFBCV;
  bool modelPar_given_PVFBCV=mod.given("PVFBCV");
  AdmsSensFadType modelPar_VFBCVL=mod.VFBCVL;
  bool modelPar_given_VFBCVL=mod.given("VFBCVL");
  AdmsSensFadType modelPar_VFBCVLEXP=mod.VFBCVLEXP;
  bool modelPar_given_VFBCVLEXP=mod.given("VFBCVLEXP");
  AdmsSensFadType modelPar_VFBCVW=mod.VFBCVW;
  bool modelPar_given_VFBCVW=mod.given("VFBCVW");
  AdmsSensFadType modelPar_VFBCVWEXP=mod.VFBCVWEXP;
  bool modelPar_given_VFBCVWEXP=mod.given("VFBCVWEXP");
  AdmsSensFadType modelPar_VFBCVWL=mod.VFBCVWL;
  bool modelPar_given_VFBCVWL=mod.given("VFBCVWL");
  AdmsSensFadType modelPar_VFBCVWLEXP=mod.VFBCVWLEXP;
  bool modelPar_given_VFBCVWLEXP=mod.given("VFBCVWLEXP");
  AdmsSensFadType modelPar_DWJ=mod.DWJ;
  bool modelPar_given_DWJ=mod.given("DWJ");
  AdmsSensFadType modelPar_NSD=mod.NSD;
  bool modelPar_given_NSD=mod.given("NSD");
  AdmsSensFadType modelPar_LNSD=mod.LNSD;
  bool modelPar_given_LNSD=mod.given("LNSD");
  AdmsSensFadType modelPar_WNSD=mod.WNSD;
  bool modelPar_given_WNSD=mod.given("WNSD");
  AdmsSensFadType modelPar_PNSD=mod.PNSD;
  bool modelPar_given_PNSD=mod.given("PNSD");
  AdmsSensFadType modelPar_DELVT0=mod.DELVT0;
  bool modelPar_given_DELVT0=mod.given("DELVT0");
  AdmsSensFadType modelPar_DVTP0=mod.DVTP0;
  bool modelPar_given_DVTP0=mod.given("DVTP0");
  AdmsSensFadType modelPar_LDVTP0=mod.LDVTP0;
  bool modelPar_given_LDVTP0=mod.given("LDVTP0");
  AdmsSensFadType modelPar_WDVTP0=mod.WDVTP0;
  bool modelPar_given_WDVTP0=mod.given("WDVTP0");
  AdmsSensFadType modelPar_PDVTP0=mod.PDVTP0;
  bool modelPar_given_PDVTP0=mod.given("PDVTP0");
  AdmsSensFadType modelPar_DVTP1=mod.DVTP1;
  bool modelPar_given_DVTP1=mod.given("DVTP1");
  AdmsSensFadType modelPar_LDVTP1=mod.LDVTP1;
  bool modelPar_given_LDVTP1=mod.given("LDVTP1");
  AdmsSensFadType modelPar_WDVTP1=mod.WDVTP1;
  bool modelPar_given_WDVTP1=mod.given("WDVTP1");
  AdmsSensFadType modelPar_PDVTP1=mod.PDVTP1;
  bool modelPar_given_PDVTP1=mod.given("PDVTP1");
  AdmsSensFadType modelPar_DVTP2=mod.DVTP2;
  bool modelPar_given_DVTP2=mod.given("DVTP2");
  AdmsSensFadType modelPar_LDVTP2=mod.LDVTP2;
  bool modelPar_given_LDVTP2=mod.given("LDVTP2");
  AdmsSensFadType modelPar_WDVTP2=mod.WDVTP2;
  bool modelPar_given_WDVTP2=mod.given("WDVTP2");
  AdmsSensFadType modelPar_PDVTP2=mod.PDVTP2;
  bool modelPar_given_PDVTP2=mod.given("PDVTP2");
  AdmsSensFadType modelPar_DVTP3=mod.DVTP3;
  bool modelPar_given_DVTP3=mod.given("DVTP3");
  AdmsSensFadType modelPar_LDVTP3=mod.LDVTP3;
  bool modelPar_given_LDVTP3=mod.given("LDVTP3");
  AdmsSensFadType modelPar_WDVTP3=mod.WDVTP3;
  bool modelPar_given_WDVTP3=mod.given("WDVTP3");
  AdmsSensFadType modelPar_PDVTP3=mod.PDVTP3;
  bool modelPar_given_PDVTP3=mod.given("PDVTP3");
  AdmsSensFadType modelPar_DVTP4=mod.DVTP4;
  bool modelPar_given_DVTP4=mod.given("DVTP4");
  AdmsSensFadType modelPar_LDVTP4=mod.LDVTP4;
  bool modelPar_given_LDVTP4=mod.given("LDVTP4");
  AdmsSensFadType modelPar_WDVTP4=mod.WDVTP4;
  bool modelPar_given_WDVTP4=mod.given("WDVTP4");
  AdmsSensFadType modelPar_PDVTP4=mod.PDVTP4;
  bool modelPar_given_PDVTP4=mod.given("PDVTP4");
  AdmsSensFadType modelPar_DVTP5=mod.DVTP5;
  bool modelPar_given_DVTP5=mod.given("DVTP5");
  AdmsSensFadType modelPar_LDVTP5=mod.LDVTP5;
  bool modelPar_given_LDVTP5=mod.given("LDVTP5");
  AdmsSensFadType modelPar_WDVTP5=mod.WDVTP5;
  bool modelPar_given_WDVTP5=mod.given("WDVTP5");
  AdmsSensFadType modelPar_PDVTP5=mod.PDVTP5;
  bool modelPar_given_PDVTP5=mod.given("PDVTP5");
  AdmsSensFadType modelPar_PHIN=mod.PHIN;
  bool modelPar_given_PHIN=mod.given("PHIN");
  AdmsSensFadType modelPar_LPHIN=mod.LPHIN;
  bool modelPar_given_LPHIN=mod.given("LPHIN");
  AdmsSensFadType modelPar_WPHIN=mod.WPHIN;
  bool modelPar_given_WPHIN=mod.given("WPHIN");
  AdmsSensFadType modelPar_PPHIN=mod.PPHIN;
  bool modelPar_given_PPHIN=mod.given("PPHIN");
  AdmsSensFadType modelPar_ETA0=mod.ETA0;
  bool modelPar_given_ETA0=mod.given("ETA0");
  AdmsSensFadType modelPar_LETA0=mod.LETA0;
  bool modelPar_given_LETA0=mod.given("LETA0");
  AdmsSensFadType modelPar_WETA0=mod.WETA0;
  bool modelPar_given_WETA0=mod.given("WETA0");
  AdmsSensFadType modelPar_PETA0=mod.PETA0;
  bool modelPar_given_PETA0=mod.given("PETA0");
  AdmsSensFadType modelPar_ETA0R=mod.ETA0R;
  bool modelPar_given_ETA0R=mod.given("ETA0R");
  AdmsSensFadType modelPar_LETA0R=mod.LETA0R;
  bool modelPar_given_LETA0R=mod.given("LETA0R");
  AdmsSensFadType modelPar_WETA0R=mod.WETA0R;
  bool modelPar_given_WETA0R=mod.given("WETA0R");
  AdmsSensFadType modelPar_PETA0R=mod.PETA0R;
  bool modelPar_given_PETA0R=mod.given("PETA0R");
  AdmsSensFadType modelPar_DSUB=mod.DSUB;
  bool modelPar_given_DSUB=mod.given("DSUB");
  AdmsSensFadType modelPar_ETAB=mod.ETAB;
  bool modelPar_given_ETAB=mod.given("ETAB");
  AdmsSensFadType modelPar_ETABEXP=mod.ETABEXP;
  bool modelPar_given_ETABEXP=mod.given("ETABEXP");
  AdmsSensFadType modelPar_LETAB=mod.LETAB;
  bool modelPar_given_LETAB=mod.given("LETAB");
  AdmsSensFadType modelPar_WETAB=mod.WETAB;
  bool modelPar_given_WETAB=mod.given("WETAB");
  AdmsSensFadType modelPar_PETAB=mod.PETAB;
  bool modelPar_given_PETAB=mod.given("PETAB");
  AdmsSensFadType modelPar_K1=mod.K1;
  bool modelPar_given_K1=mod.given("K1");
  AdmsSensFadType modelPar_K1L=mod.K1L;
  bool modelPar_given_K1L=mod.given("K1L");
  AdmsSensFadType modelPar_K1LEXP=mod.K1LEXP;
  bool modelPar_given_K1LEXP=mod.given("K1LEXP");
  AdmsSensFadType modelPar_K1W=mod.K1W;
  bool modelPar_given_K1W=mod.given("K1W");
  AdmsSensFadType modelPar_K1WEXP=mod.K1WEXP;
  bool modelPar_given_K1WEXP=mod.given("K1WEXP");
  AdmsSensFadType modelPar_K1WL=mod.K1WL;
  bool modelPar_given_K1WL=mod.given("K1WL");
  AdmsSensFadType modelPar_K1WLEXP=mod.K1WLEXP;
  bool modelPar_given_K1WLEXP=mod.given("K1WLEXP");
  AdmsSensFadType modelPar_LK1=mod.LK1;
  bool modelPar_given_LK1=mod.given("LK1");
  AdmsSensFadType modelPar_WK1=mod.WK1;
  bool modelPar_given_WK1=mod.given("WK1");
  AdmsSensFadType modelPar_PK1=mod.PK1;
  bool modelPar_given_PK1=mod.given("PK1");
  AdmsSensFadType modelPar_K2=mod.K2;
  bool modelPar_given_K2=mod.given("K2");
  AdmsSensFadType modelPar_K2L=mod.K2L;
  bool modelPar_given_K2L=mod.given("K2L");
  AdmsSensFadType modelPar_K2LEXP=mod.K2LEXP;
  bool modelPar_given_K2LEXP=mod.given("K2LEXP");
  AdmsSensFadType modelPar_K2W=mod.K2W;
  bool modelPar_given_K2W=mod.given("K2W");
  AdmsSensFadType modelPar_K2WEXP=mod.K2WEXP;
  bool modelPar_given_K2WEXP=mod.given("K2WEXP");
  AdmsSensFadType modelPar_K2WL=mod.K2WL;
  bool modelPar_given_K2WL=mod.given("K2WL");
  AdmsSensFadType modelPar_K2WLEXP=mod.K2WLEXP;
  bool modelPar_given_K2WLEXP=mod.given("K2WLEXP");
  AdmsSensFadType modelPar_LK2=mod.LK2;
  bool modelPar_given_LK2=mod.given("LK2");
  AdmsSensFadType modelPar_WK2=mod.WK2;
  bool modelPar_given_WK2=mod.given("WK2");
  AdmsSensFadType modelPar_PK2=mod.PK2;
  bool modelPar_given_PK2=mod.given("PK2");
  AdmsSensFadType modelPar_ADOS=mod.ADOS;
  bool modelPar_given_ADOS=mod.given("ADOS");
  AdmsSensFadType modelPar_BDOS=mod.BDOS;
  bool modelPar_given_BDOS=mod.given("BDOS");
  AdmsSensFadType modelPar_QM0=mod.QM0;
  bool modelPar_given_QM0=mod.given("QM0");
  AdmsSensFadType modelPar_ETAQM=mod.ETAQM;
  bool modelPar_given_ETAQM=mod.given("ETAQM");
  AdmsSensFadType modelPar_CIT=mod.CIT;
  bool modelPar_given_CIT=mod.given("CIT");
  AdmsSensFadType modelPar_LCIT=mod.LCIT;
  bool modelPar_given_LCIT=mod.given("LCIT");
  AdmsSensFadType modelPar_WCIT=mod.WCIT;
  bool modelPar_given_WCIT=mod.given("WCIT");
  AdmsSensFadType modelPar_PCIT=mod.PCIT;
  bool modelPar_given_PCIT=mod.given("PCIT");
  AdmsSensFadType modelPar_NFACTOR=mod.NFACTOR;
  bool modelPar_given_NFACTOR=mod.given("NFACTOR");
  AdmsSensFadType modelPar_NFACTORL=mod.NFACTORL;
  bool modelPar_given_NFACTORL=mod.given("NFACTORL");
  AdmsSensFadType modelPar_NFACTORLEXP=mod.NFACTORLEXP;
  bool modelPar_given_NFACTORLEXP=mod.given("NFACTORLEXP");
  AdmsSensFadType modelPar_NFACTORW=mod.NFACTORW;
  bool modelPar_given_NFACTORW=mod.given("NFACTORW");
  AdmsSensFadType modelPar_NFACTORWEXP=mod.NFACTORWEXP;
  bool modelPar_given_NFACTORWEXP=mod.given("NFACTORWEXP");
  AdmsSensFadType modelPar_NFACTORWL=mod.NFACTORWL;
  bool modelPar_given_NFACTORWL=mod.given("NFACTORWL");
  AdmsSensFadType modelPar_NFACTORWLEXP=mod.NFACTORWLEXP;
  bool modelPar_given_NFACTORWLEXP=mod.given("NFACTORWLEXP");
  AdmsSensFadType modelPar_LNFACTOR=mod.LNFACTOR;
  bool modelPar_given_LNFACTOR=mod.given("LNFACTOR");
  AdmsSensFadType modelPar_WNFACTOR=mod.WNFACTOR;
  bool modelPar_given_WNFACTOR=mod.given("WNFACTOR");
  AdmsSensFadType modelPar_PNFACTOR=mod.PNFACTOR;
  bool modelPar_given_PNFACTOR=mod.given("PNFACTOR");
  AdmsSensFadType modelPar_CDSCD=mod.CDSCD;
  bool modelPar_given_CDSCD=mod.given("CDSCD");
  AdmsSensFadType modelPar_CDSCDL=mod.CDSCDL;
  bool modelPar_given_CDSCDL=mod.given("CDSCDL");
  AdmsSensFadType modelPar_CDSCDLEXP=mod.CDSCDLEXP;
  bool modelPar_given_CDSCDLEXP=mod.given("CDSCDLEXP");
  AdmsSensFadType modelPar_LCDSCD=mod.LCDSCD;
  bool modelPar_given_LCDSCD=mod.given("LCDSCD");
  AdmsSensFadType modelPar_WCDSCD=mod.WCDSCD;
  bool modelPar_given_WCDSCD=mod.given("WCDSCD");
  AdmsSensFadType modelPar_PCDSCD=mod.PCDSCD;
  bool modelPar_given_PCDSCD=mod.given("PCDSCD");
  AdmsSensFadType modelPar_CDSCDR=mod.CDSCDR;
  bool modelPar_given_CDSCDR=mod.given("CDSCDR");
  AdmsSensFadType modelPar_CDSCDLR=mod.CDSCDLR;
  bool modelPar_given_CDSCDLR=mod.given("CDSCDLR");
  AdmsSensFadType modelPar_LCDSCDR=mod.LCDSCDR;
  bool modelPar_given_LCDSCDR=mod.given("LCDSCDR");
  AdmsSensFadType modelPar_WCDSCDR=mod.WCDSCDR;
  bool modelPar_given_WCDSCDR=mod.given("WCDSCDR");
  AdmsSensFadType modelPar_PCDSCDR=mod.PCDSCDR;
  bool modelPar_given_PCDSCDR=mod.given("PCDSCDR");
  AdmsSensFadType modelPar_CDSCB=mod.CDSCB;
  bool modelPar_given_CDSCB=mod.given("CDSCB");
  AdmsSensFadType modelPar_CDSCBL=mod.CDSCBL;
  bool modelPar_given_CDSCBL=mod.given("CDSCBL");
  AdmsSensFadType modelPar_CDSCBLEXP=mod.CDSCBLEXP;
  bool modelPar_given_CDSCBLEXP=mod.given("CDSCBLEXP");
  AdmsSensFadType modelPar_LCDSCB=mod.LCDSCB;
  bool modelPar_given_LCDSCB=mod.given("LCDSCB");
  AdmsSensFadType modelPar_WCDSCB=mod.WCDSCB;
  bool modelPar_given_WCDSCB=mod.given("WCDSCB");
  AdmsSensFadType modelPar_PCDSCB=mod.PCDSCB;
  bool modelPar_given_PCDSCB=mod.given("PCDSCB");
  AdmsSensFadType modelPar_VSAT=mod.VSAT;
  bool modelPar_given_VSAT=mod.given("VSAT");
  AdmsSensFadType modelPar_LVSAT=mod.LVSAT;
  bool modelPar_given_LVSAT=mod.given("LVSAT");
  AdmsSensFadType modelPar_WVSAT=mod.WVSAT;
  bool modelPar_given_WVSAT=mod.given("WVSAT");
  AdmsSensFadType modelPar_PVSAT=mod.PVSAT;
  bool modelPar_given_PVSAT=mod.given("PVSAT");
  AdmsSensFadType modelPar_VSATL=mod.VSATL;
  bool modelPar_given_VSATL=mod.given("VSATL");
  AdmsSensFadType modelPar_VSATLEXP=mod.VSATLEXP;
  bool modelPar_given_VSATLEXP=mod.given("VSATLEXP");
  AdmsSensFadType modelPar_VSATW=mod.VSATW;
  bool modelPar_given_VSATW=mod.given("VSATW");
  AdmsSensFadType modelPar_VSATWEXP=mod.VSATWEXP;
  bool modelPar_given_VSATWEXP=mod.given("VSATWEXP");
  AdmsSensFadType modelPar_VSATWL=mod.VSATWL;
  bool modelPar_given_VSATWL=mod.given("VSATWL");
  AdmsSensFadType modelPar_VSATWLEXP=mod.VSATWLEXP;
  bool modelPar_given_VSATWLEXP=mod.given("VSATWLEXP");
  AdmsSensFadType modelPar_VSATR=mod.VSATR;
  bool modelPar_given_VSATR=mod.given("VSATR");
  AdmsSensFadType modelPar_LVSATR=mod.LVSATR;
  bool modelPar_given_LVSATR=mod.given("LVSATR");
  AdmsSensFadType modelPar_WVSATR=mod.WVSATR;
  bool modelPar_given_WVSATR=mod.given("WVSATR");
  AdmsSensFadType modelPar_PVSATR=mod.PVSATR;
  bool modelPar_given_PVSATR=mod.given("PVSATR");
  AdmsSensFadType modelPar_DELTA=mod.DELTA;
  bool modelPar_given_DELTA=mod.given("DELTA");
  AdmsSensFadType modelPar_LDELTA=mod.LDELTA;
  bool modelPar_given_LDELTA=mod.given("LDELTA");
  AdmsSensFadType modelPar_WDELTA=mod.WDELTA;
  bool modelPar_given_WDELTA=mod.given("WDELTA");
  AdmsSensFadType modelPar_PDELTA=mod.PDELTA;
  bool modelPar_given_PDELTA=mod.given("PDELTA");
  AdmsSensFadType modelPar_DELTAL=mod.DELTAL;
  bool modelPar_given_DELTAL=mod.given("DELTAL");
  AdmsSensFadType modelPar_DELTALEXP=mod.DELTALEXP;
  bool modelPar_given_DELTALEXP=mod.given("DELTALEXP");
  AdmsSensFadType modelPar_VSATCV=mod.VSATCV;
  bool modelPar_given_VSATCV=mod.given("VSATCV");
  AdmsSensFadType modelPar_LVSATCV=mod.LVSATCV;
  bool modelPar_given_LVSATCV=mod.given("LVSATCV");
  AdmsSensFadType modelPar_WVSATCV=mod.WVSATCV;
  bool modelPar_given_WVSATCV=mod.given("WVSATCV");
  AdmsSensFadType modelPar_PVSATCV=mod.PVSATCV;
  bool modelPar_given_PVSATCV=mod.given("PVSATCV");
  AdmsSensFadType modelPar_VSATCVL=mod.VSATCVL;
  bool modelPar_given_VSATCVL=mod.given("VSATCVL");
  AdmsSensFadType modelPar_VSATCVLEXP=mod.VSATCVLEXP;
  bool modelPar_given_VSATCVLEXP=mod.given("VSATCVLEXP");
  AdmsSensFadType modelPar_VSATCVW=mod.VSATCVW;
  bool modelPar_given_VSATCVW=mod.given("VSATCVW");
  AdmsSensFadType modelPar_VSATCVWEXP=mod.VSATCVWEXP;
  bool modelPar_given_VSATCVWEXP=mod.given("VSATCVWEXP");
  AdmsSensFadType modelPar_VSATCVWL=mod.VSATCVWL;
  bool modelPar_given_VSATCVWL=mod.given("VSATCVWL");
  AdmsSensFadType modelPar_VSATCVWLEXP=mod.VSATCVWLEXP;
  bool modelPar_given_VSATCVWLEXP=mod.given("VSATCVWLEXP");
  AdmsSensFadType modelPar_UP1=mod.UP1;
  bool modelPar_given_UP1=mod.given("UP1");
  AdmsSensFadType modelPar_LP1=mod.LP1;
  bool modelPar_given_LP1=mod.given("LP1");
  AdmsSensFadType modelPar_UP2=mod.UP2;
  bool modelPar_given_UP2=mod.given("UP2");
  AdmsSensFadType modelPar_LP2=mod.LP2;
  bool modelPar_given_LP2=mod.given("LP2");
  AdmsSensFadType modelPar_MULU0=mod.MULU0;
  bool modelPar_given_MULU0=mod.given("MULU0");
  AdmsSensFadType modelPar_U0=mod.U0;
  bool modelPar_given_U0=mod.given("U0");
  AdmsSensFadType modelPar_U0L=mod.U0L;
  bool modelPar_given_U0L=mod.given("U0L");
  AdmsSensFadType modelPar_U0LEXP=mod.U0LEXP;
  bool modelPar_given_U0LEXP=mod.given("U0LEXP");
  AdmsSensFadType modelPar_LU0=mod.LU0;
  bool modelPar_given_LU0=mod.given("LU0");
  AdmsSensFadType modelPar_WU0=mod.WU0;
  bool modelPar_given_WU0=mod.given("WU0");
  AdmsSensFadType modelPar_PU0=mod.PU0;
  bool modelPar_given_PU0=mod.given("PU0");
  AdmsSensFadType modelPar_U0R=mod.U0R;
  bool modelPar_given_U0R=mod.given("U0R");
  AdmsSensFadType modelPar_LU0R=mod.LU0R;
  bool modelPar_given_LU0R=mod.given("LU0R");
  AdmsSensFadType modelPar_WU0R=mod.WU0R;
  bool modelPar_given_WU0R=mod.given("WU0R");
  AdmsSensFadType modelPar_PU0R=mod.PU0R;
  bool modelPar_given_PU0R=mod.given("PU0R");
  AdmsSensFadType modelPar_ETAMOB=mod.ETAMOB;
  bool modelPar_given_ETAMOB=mod.given("ETAMOB");
  AdmsSensFadType modelPar_UA=mod.UA;
  bool modelPar_given_UA=mod.given("UA");
  AdmsSensFadType modelPar_UAL=mod.UAL;
  bool modelPar_given_UAL=mod.given("UAL");
  AdmsSensFadType modelPar_UALEXP=mod.UALEXP;
  bool modelPar_given_UALEXP=mod.given("UALEXP");
  AdmsSensFadType modelPar_UAW=mod.UAW;
  bool modelPar_given_UAW=mod.given("UAW");
  AdmsSensFadType modelPar_UAWEXP=mod.UAWEXP;
  bool modelPar_given_UAWEXP=mod.given("UAWEXP");
  AdmsSensFadType modelPar_UAWL=mod.UAWL;
  bool modelPar_given_UAWL=mod.given("UAWL");
  AdmsSensFadType modelPar_UAWLEXP=mod.UAWLEXP;
  bool modelPar_given_UAWLEXP=mod.given("UAWLEXP");
  AdmsSensFadType modelPar_LUA=mod.LUA;
  bool modelPar_given_LUA=mod.given("LUA");
  AdmsSensFadType modelPar_WUA=mod.WUA;
  bool modelPar_given_WUA=mod.given("WUA");
  AdmsSensFadType modelPar_PUA=mod.PUA;
  bool modelPar_given_PUA=mod.given("PUA");
  AdmsSensFadType modelPar_UAR=mod.UAR;
  bool modelPar_given_UAR=mod.given("UAR");
  AdmsSensFadType modelPar_LUAR=mod.LUAR;
  bool modelPar_given_LUAR=mod.given("LUAR");
  AdmsSensFadType modelPar_WUAR=mod.WUAR;
  bool modelPar_given_WUAR=mod.given("WUAR");
  AdmsSensFadType modelPar_PUAR=mod.PUAR;
  bool modelPar_given_PUAR=mod.given("PUAR");
  AdmsSensFadType modelPar_EU=mod.EU;
  bool modelPar_given_EU=mod.given("EU");
  AdmsSensFadType modelPar_LEU=mod.LEU;
  bool modelPar_given_LEU=mod.given("LEU");
  AdmsSensFadType modelPar_WEU=mod.WEU;
  bool modelPar_given_WEU=mod.given("WEU");
  AdmsSensFadType modelPar_PEU=mod.PEU;
  bool modelPar_given_PEU=mod.given("PEU");
  AdmsSensFadType modelPar_EUL=mod.EUL;
  bool modelPar_given_EUL=mod.given("EUL");
  AdmsSensFadType modelPar_EULEXP=mod.EULEXP;
  bool modelPar_given_EULEXP=mod.given("EULEXP");
  AdmsSensFadType modelPar_EUW=mod.EUW;
  bool modelPar_given_EUW=mod.given("EUW");
  AdmsSensFadType modelPar_EUWEXP=mod.EUWEXP;
  bool modelPar_given_EUWEXP=mod.given("EUWEXP");
  AdmsSensFadType modelPar_EUWL=mod.EUWL;
  bool modelPar_given_EUWL=mod.given("EUWL");
  AdmsSensFadType modelPar_EUWLEXP=mod.EUWLEXP;
  bool modelPar_given_EUWLEXP=mod.given("EUWLEXP");
  AdmsSensFadType modelPar_UD=mod.UD;
  bool modelPar_given_UD=mod.given("UD");
  AdmsSensFadType modelPar_UDL=mod.UDL;
  bool modelPar_given_UDL=mod.given("UDL");
  AdmsSensFadType modelPar_UDLEXP=mod.UDLEXP;
  bool modelPar_given_UDLEXP=mod.given("UDLEXP");
  AdmsSensFadType modelPar_LUD=mod.LUD;
  bool modelPar_given_LUD=mod.given("LUD");
  AdmsSensFadType modelPar_WUD=mod.WUD;
  bool modelPar_given_WUD=mod.given("WUD");
  AdmsSensFadType modelPar_PUD=mod.PUD;
  bool modelPar_given_PUD=mod.given("PUD");
  AdmsSensFadType modelPar_UDR=mod.UDR;
  bool modelPar_given_UDR=mod.given("UDR");
  AdmsSensFadType modelPar_LUDR=mod.LUDR;
  bool modelPar_given_LUDR=mod.given("LUDR");
  AdmsSensFadType modelPar_WUDR=mod.WUDR;
  bool modelPar_given_WUDR=mod.given("WUDR");
  AdmsSensFadType modelPar_PUDR=mod.PUDR;
  bool modelPar_given_PUDR=mod.given("PUDR");
  AdmsSensFadType modelPar_UCS=mod.UCS;
  bool modelPar_given_UCS=mod.given("UCS");
  AdmsSensFadType modelPar_LUCS=mod.LUCS;
  bool modelPar_given_LUCS=mod.given("LUCS");
  AdmsSensFadType modelPar_WUCS=mod.WUCS;
  bool modelPar_given_WUCS=mod.given("WUCS");
  AdmsSensFadType modelPar_PUCS=mod.PUCS;
  bool modelPar_given_PUCS=mod.given("PUCS");
  AdmsSensFadType modelPar_UCSR=mod.UCSR;
  bool modelPar_given_UCSR=mod.given("UCSR");
  AdmsSensFadType modelPar_LUCSR=mod.LUCSR;
  bool modelPar_given_LUCSR=mod.given("LUCSR");
  AdmsSensFadType modelPar_WUCSR=mod.WUCSR;
  bool modelPar_given_WUCSR=mod.given("WUCSR");
  AdmsSensFadType modelPar_PUCSR=mod.PUCSR;
  bool modelPar_given_PUCSR=mod.given("PUCSR");
  AdmsSensFadType modelPar_UC=mod.UC;
  bool modelPar_given_UC=mod.given("UC");
  AdmsSensFadType modelPar_UCL=mod.UCL;
  bool modelPar_given_UCL=mod.given("UCL");
  AdmsSensFadType modelPar_UCLEXP=mod.UCLEXP;
  bool modelPar_given_UCLEXP=mod.given("UCLEXP");
  AdmsSensFadType modelPar_UCW=mod.UCW;
  bool modelPar_given_UCW=mod.given("UCW");
  AdmsSensFadType modelPar_UCWEXP=mod.UCWEXP;
  bool modelPar_given_UCWEXP=mod.given("UCWEXP");
  AdmsSensFadType modelPar_UCWL=mod.UCWL;
  bool modelPar_given_UCWL=mod.given("UCWL");
  AdmsSensFadType modelPar_UCWLEXP=mod.UCWLEXP;
  bool modelPar_given_UCWLEXP=mod.given("UCWLEXP");
  AdmsSensFadType modelPar_LUC=mod.LUC;
  bool modelPar_given_LUC=mod.given("LUC");
  AdmsSensFadType modelPar_WUC=mod.WUC;
  bool modelPar_given_WUC=mod.given("WUC");
  AdmsSensFadType modelPar_PUC=mod.PUC;
  bool modelPar_given_PUC=mod.given("PUC");
  AdmsSensFadType modelPar_UCR=mod.UCR;
  bool modelPar_given_UCR=mod.given("UCR");
  AdmsSensFadType modelPar_LUCR=mod.LUCR;
  bool modelPar_given_LUCR=mod.given("LUCR");
  AdmsSensFadType modelPar_WUCR=mod.WUCR;
  bool modelPar_given_WUCR=mod.given("WUCR");
  AdmsSensFadType modelPar_PUCR=mod.PUCR;
  bool modelPar_given_PUCR=mod.given("PUCR");
  AdmsSensFadType modelPar_PCLM=mod.PCLM;
  bool modelPar_given_PCLM=mod.given("PCLM");
  AdmsSensFadType modelPar_PCLML=mod.PCLML;
  bool modelPar_given_PCLML=mod.given("PCLML");
  AdmsSensFadType modelPar_PCLMLEXP=mod.PCLMLEXP;
  bool modelPar_given_PCLMLEXP=mod.given("PCLMLEXP");
  AdmsSensFadType modelPar_LPCLM=mod.LPCLM;
  bool modelPar_given_LPCLM=mod.given("LPCLM");
  AdmsSensFadType modelPar_WPCLM=mod.WPCLM;
  bool modelPar_given_WPCLM=mod.given("WPCLM");
  AdmsSensFadType modelPar_PPCLM=mod.PPCLM;
  bool modelPar_given_PPCLM=mod.given("PPCLM");
  AdmsSensFadType modelPar_PCLMR=mod.PCLMR;
  bool modelPar_given_PCLMR=mod.given("PCLMR");
  AdmsSensFadType modelPar_LPCLMR=mod.LPCLMR;
  bool modelPar_given_LPCLMR=mod.given("LPCLMR");
  AdmsSensFadType modelPar_WPCLMR=mod.WPCLMR;
  bool modelPar_given_WPCLMR=mod.given("WPCLMR");
  AdmsSensFadType modelPar_PPCLMR=mod.PPCLMR;
  bool modelPar_given_PPCLMR=mod.given("PPCLMR");
  AdmsSensFadType modelPar_PCLMG=mod.PCLMG;
  bool modelPar_given_PCLMG=mod.given("PCLMG");
  AdmsSensFadType modelPar_PCLMCV=mod.PCLMCV;
  bool modelPar_given_PCLMCV=mod.given("PCLMCV");
  AdmsSensFadType modelPar_PCLMCVL=mod.PCLMCVL;
  bool modelPar_given_PCLMCVL=mod.given("PCLMCVL");
  AdmsSensFadType modelPar_PCLMCVLEXP=mod.PCLMCVLEXP;
  bool modelPar_given_PCLMCVLEXP=mod.given("PCLMCVLEXP");
  AdmsSensFadType modelPar_LPCLMCV=mod.LPCLMCV;
  bool modelPar_given_LPCLMCV=mod.given("LPCLMCV");
  AdmsSensFadType modelPar_WPCLMCV=mod.WPCLMCV;
  bool modelPar_given_WPCLMCV=mod.given("WPCLMCV");
  AdmsSensFadType modelPar_PPCLMCV=mod.PPCLMCV;
  bool modelPar_given_PPCLMCV=mod.given("PPCLMCV");
  AdmsSensFadType modelPar_PSCBE1=mod.PSCBE1;
  bool modelPar_given_PSCBE1=mod.given("PSCBE1");
  AdmsSensFadType modelPar_LPSCBE1=mod.LPSCBE1;
  bool modelPar_given_LPSCBE1=mod.given("LPSCBE1");
  AdmsSensFadType modelPar_WPSCBE1=mod.WPSCBE1;
  bool modelPar_given_WPSCBE1=mod.given("WPSCBE1");
  AdmsSensFadType modelPar_PPSCBE1=mod.PPSCBE1;
  bool modelPar_given_PPSCBE1=mod.given("PPSCBE1");
  AdmsSensFadType modelPar_PSCBE2=mod.PSCBE2;
  bool modelPar_given_PSCBE2=mod.given("PSCBE2");
  AdmsSensFadType modelPar_LPSCBE2=mod.LPSCBE2;
  bool modelPar_given_LPSCBE2=mod.given("LPSCBE2");
  AdmsSensFadType modelPar_WPSCBE2=mod.WPSCBE2;
  bool modelPar_given_WPSCBE2=mod.given("WPSCBE2");
  AdmsSensFadType modelPar_PPSCBE2=mod.PPSCBE2;
  bool modelPar_given_PPSCBE2=mod.given("PPSCBE2");
  AdmsSensFadType modelPar_PDITS=mod.PDITS;
  bool modelPar_given_PDITS=mod.given("PDITS");
  AdmsSensFadType modelPar_LPDITS=mod.LPDITS;
  bool modelPar_given_LPDITS=mod.given("LPDITS");
  AdmsSensFadType modelPar_WPDITS=mod.WPDITS;
  bool modelPar_given_WPDITS=mod.given("WPDITS");
  AdmsSensFadType modelPar_PPDITS=mod.PPDITS;
  bool modelPar_given_PPDITS=mod.given("PPDITS");
  AdmsSensFadType modelPar_PDITSL=mod.PDITSL;
  bool modelPar_given_PDITSL=mod.given("PDITSL");
  AdmsSensFadType modelPar_PDITSD=mod.PDITSD;
  bool modelPar_given_PDITSD=mod.given("PDITSD");
  AdmsSensFadType modelPar_LPDITSD=mod.LPDITSD;
  bool modelPar_given_LPDITSD=mod.given("LPDITSD");
  AdmsSensFadType modelPar_WPDITSD=mod.WPDITSD;
  bool modelPar_given_WPDITSD=mod.given("WPDITSD");
  AdmsSensFadType modelPar_PPDITSD=mod.PPDITSD;
  bool modelPar_given_PPDITSD=mod.given("PPDITSD");
  AdmsSensFadType modelPar_RSH=mod.RSH;
  bool modelPar_given_RSH=mod.given("RSH");
  AdmsSensFadType modelPar_PRWG=mod.PRWG;
  bool modelPar_given_PRWG=mod.given("PRWG");
  AdmsSensFadType modelPar_LPRWG=mod.LPRWG;
  bool modelPar_given_LPRWG=mod.given("LPRWG");
  AdmsSensFadType modelPar_WPRWG=mod.WPRWG;
  bool modelPar_given_WPRWG=mod.given("WPRWG");
  AdmsSensFadType modelPar_PPRWG=mod.PPRWG;
  bool modelPar_given_PPRWG=mod.given("PPRWG");
  AdmsSensFadType modelPar_PRWB=mod.PRWB;
  bool modelPar_given_PRWB=mod.given("PRWB");
  AdmsSensFadType modelPar_LPRWB=mod.LPRWB;
  bool modelPar_given_LPRWB=mod.given("LPRWB");
  AdmsSensFadType modelPar_WPRWB=mod.WPRWB;
  bool modelPar_given_WPRWB=mod.given("WPRWB");
  AdmsSensFadType modelPar_PPRWB=mod.PPRWB;
  bool modelPar_given_PPRWB=mod.given("PPRWB");
  AdmsSensFadType modelPar_PRWBL=mod.PRWBL;
  bool modelPar_given_PRWBL=mod.given("PRWBL");
  AdmsSensFadType modelPar_PRWBLEXP=mod.PRWBLEXP;
  bool modelPar_given_PRWBLEXP=mod.given("PRWBLEXP");
  AdmsSensFadType modelPar_WR=mod.WR;
  bool modelPar_given_WR=mod.given("WR");
  AdmsSensFadType modelPar_LWR=mod.LWR;
  bool modelPar_given_LWR=mod.given("LWR");
  AdmsSensFadType modelPar_WWR=mod.WWR;
  bool modelPar_given_WWR=mod.given("WWR");
  AdmsSensFadType modelPar_PWR=mod.PWR;
  bool modelPar_given_PWR=mod.given("PWR");
  AdmsSensFadType modelPar_RSWMIN=mod.RSWMIN;
  bool modelPar_given_RSWMIN=mod.given("RSWMIN");
  AdmsSensFadType modelPar_LRSWMIN=mod.LRSWMIN;
  bool modelPar_given_LRSWMIN=mod.given("LRSWMIN");
  AdmsSensFadType modelPar_WRSWMIN=mod.WRSWMIN;
  bool modelPar_given_WRSWMIN=mod.given("WRSWMIN");
  AdmsSensFadType modelPar_PRSWMIN=mod.PRSWMIN;
  bool modelPar_given_PRSWMIN=mod.given("PRSWMIN");
  AdmsSensFadType modelPar_RSW=mod.RSW;
  bool modelPar_given_RSW=mod.given("RSW");
  AdmsSensFadType modelPar_LRSW=mod.LRSW;
  bool modelPar_given_LRSW=mod.given("LRSW");
  AdmsSensFadType modelPar_WRSW=mod.WRSW;
  bool modelPar_given_WRSW=mod.given("WRSW");
  AdmsSensFadType modelPar_PRSW=mod.PRSW;
  bool modelPar_given_PRSW=mod.given("PRSW");
  AdmsSensFadType modelPar_RSWL=mod.RSWL;
  bool modelPar_given_RSWL=mod.given("RSWL");
  AdmsSensFadType modelPar_RSWLEXP=mod.RSWLEXP;
  bool modelPar_given_RSWLEXP=mod.given("RSWLEXP");
  AdmsSensFadType modelPar_RDWMIN=mod.RDWMIN;
  bool modelPar_given_RDWMIN=mod.given("RDWMIN");
  AdmsSensFadType modelPar_LRDWMIN=mod.LRDWMIN;
  bool modelPar_given_LRDWMIN=mod.given("LRDWMIN");
  AdmsSensFadType modelPar_WRDWMIN=mod.WRDWMIN;
  bool modelPar_given_WRDWMIN=mod.given("WRDWMIN");
  AdmsSensFadType modelPar_PRDWMIN=mod.PRDWMIN;
  bool modelPar_given_PRDWMIN=mod.given("PRDWMIN");
  AdmsSensFadType modelPar_RDW=mod.RDW;
  bool modelPar_given_RDW=mod.given("RDW");
  AdmsSensFadType modelPar_LRDW=mod.LRDW;
  bool modelPar_given_LRDW=mod.given("LRDW");
  AdmsSensFadType modelPar_WRDW=mod.WRDW;
  bool modelPar_given_WRDW=mod.given("WRDW");
  AdmsSensFadType modelPar_PRDW=mod.PRDW;
  bool modelPar_given_PRDW=mod.given("PRDW");
  AdmsSensFadType modelPar_RDWL=mod.RDWL;
  bool modelPar_given_RDWL=mod.given("RDWL");
  AdmsSensFadType modelPar_RDWLEXP=mod.RDWLEXP;
  bool modelPar_given_RDWLEXP=mod.given("RDWLEXP");
  AdmsSensFadType modelPar_RDSWMIN=mod.RDSWMIN;
  bool modelPar_given_RDSWMIN=mod.given("RDSWMIN");
  AdmsSensFadType modelPar_LRDSWMIN=mod.LRDSWMIN;
  bool modelPar_given_LRDSWMIN=mod.given("LRDSWMIN");
  AdmsSensFadType modelPar_WRDSWMIN=mod.WRDSWMIN;
  bool modelPar_given_WRDSWMIN=mod.given("WRDSWMIN");
  AdmsSensFadType modelPar_PRDSWMIN=mod.PRDSWMIN;
  bool modelPar_given_PRDSWMIN=mod.given("PRDSWMIN");
  AdmsSensFadType modelPar_RDSW=mod.RDSW;
  bool modelPar_given_RDSW=mod.given("RDSW");
  AdmsSensFadType modelPar_RDSWL=mod.RDSWL;
  bool modelPar_given_RDSWL=mod.given("RDSWL");
  AdmsSensFadType modelPar_RDSWLEXP=mod.RDSWLEXP;
  bool modelPar_given_RDSWLEXP=mod.given("RDSWLEXP");
  AdmsSensFadType modelPar_LRDSW=mod.LRDSW;
  bool modelPar_given_LRDSW=mod.given("LRDSW");
  AdmsSensFadType modelPar_WRDSW=mod.WRDSW;
  bool modelPar_given_WRDSW=mod.given("WRDSW");
  AdmsSensFadType modelPar_PRDSW=mod.PRDSW;
  bool modelPar_given_PRDSW=mod.given("PRDSW");
  AdmsSensFadType modelPar_PSAT=mod.PSAT;
  bool modelPar_given_PSAT=mod.given("PSAT");
  AdmsSensFadType modelPar_LPSAT=mod.LPSAT;
  bool modelPar_given_LPSAT=mod.given("LPSAT");
  AdmsSensFadType modelPar_WPSAT=mod.WPSAT;
  bool modelPar_given_WPSAT=mod.given("WPSAT");
  AdmsSensFadType modelPar_PPSAT=mod.PPSAT;
  bool modelPar_given_PPSAT=mod.given("PPSAT");
  AdmsSensFadType modelPar_PSATL=mod.PSATL;
  bool modelPar_given_PSATL=mod.given("PSATL");
  AdmsSensFadType modelPar_PSATLEXP=mod.PSATLEXP;
  bool modelPar_given_PSATLEXP=mod.given("PSATLEXP");
  AdmsSensFadType modelPar_PSATB=mod.PSATB;
  bool modelPar_given_PSATB=mod.given("PSATB");
  AdmsSensFadType modelPar_PSATR=mod.PSATR;
  bool modelPar_given_PSATR=mod.given("PSATR");
  AdmsSensFadType modelPar_LPSATR=mod.LPSATR;
  bool modelPar_given_LPSATR=mod.given("LPSATR");
  AdmsSensFadType modelPar_WPSATR=mod.WPSATR;
  bool modelPar_given_WPSATR=mod.given("WPSATR");
  AdmsSensFadType modelPar_PPSATR=mod.PPSATR;
  bool modelPar_given_PPSATR=mod.given("PPSATR");
  AdmsSensFadType modelPar_LPSATB=mod.LPSATB;
  bool modelPar_given_LPSATB=mod.given("LPSATB");
  AdmsSensFadType modelPar_WPSATB=mod.WPSATB;
  bool modelPar_given_WPSATB=mod.given("WPSATB");
  AdmsSensFadType modelPar_PPSATB=mod.PPSATB;
  bool modelPar_given_PPSATB=mod.given("PPSATB");
  AdmsSensFadType modelPar_PSATX=mod.PSATX;
  bool modelPar_given_PSATX=mod.given("PSATX");
  AdmsSensFadType modelPar_PTWG=mod.PTWG;
  bool modelPar_given_PTWG=mod.given("PTWG");
  AdmsSensFadType modelPar_LPTWG=mod.LPTWG;
  bool modelPar_given_LPTWG=mod.given("LPTWG");
  AdmsSensFadType modelPar_WPTWG=mod.WPTWG;
  bool modelPar_given_WPTWG=mod.given("WPTWG");
  AdmsSensFadType modelPar_PPTWG=mod.PPTWG;
  bool modelPar_given_PPTWG=mod.given("PPTWG");
  AdmsSensFadType modelPar_PTWGL=mod.PTWGL;
  bool modelPar_given_PTWGL=mod.given("PTWGL");
  AdmsSensFadType modelPar_PTWGLEXP=mod.PTWGLEXP;
  bool modelPar_given_PTWGLEXP=mod.given("PTWGLEXP");
  AdmsSensFadType modelPar_PTWGR=mod.PTWGR;
  bool modelPar_given_PTWGR=mod.given("PTWGR");
  AdmsSensFadType modelPar_LPTWGR=mod.LPTWGR;
  bool modelPar_given_LPTWGR=mod.given("LPTWGR");
  AdmsSensFadType modelPar_WPTWGR=mod.WPTWGR;
  bool modelPar_given_WPTWGR=mod.given("WPTWGR");
  AdmsSensFadType modelPar_PPTWGR=mod.PPTWGR;
  bool modelPar_given_PPTWGR=mod.given("PPTWGR");
  AdmsSensFadType modelPar_PTWGLR=mod.PTWGLR;
  bool modelPar_given_PTWGLR=mod.given("PTWGLR");
  AdmsSensFadType modelPar_PTWGLEXPR=mod.PTWGLEXPR;
  bool modelPar_given_PTWGLEXPR=mod.given("PTWGLEXPR");
  AdmsSensFadType modelPar_A1=mod.A1;
  bool modelPar_given_A1=mod.given("A1");
  AdmsSensFadType modelPar_LA1=mod.LA1;
  bool modelPar_given_LA1=mod.given("LA1");
  AdmsSensFadType modelPar_WA1=mod.WA1;
  bool modelPar_given_WA1=mod.given("WA1");
  AdmsSensFadType modelPar_PA1=mod.PA1;
  bool modelPar_given_PA1=mod.given("PA1");
  AdmsSensFadType modelPar_A11=mod.A11;
  bool modelPar_given_A11=mod.given("A11");
  AdmsSensFadType modelPar_LA11=mod.LA11;
  bool modelPar_given_LA11=mod.given("LA11");
  AdmsSensFadType modelPar_WA11=mod.WA11;
  bool modelPar_given_WA11=mod.given("WA11");
  AdmsSensFadType modelPar_PA11=mod.PA11;
  bool modelPar_given_PA11=mod.given("PA11");
  AdmsSensFadType modelPar_A2=mod.A2;
  bool modelPar_given_A2=mod.given("A2");
  AdmsSensFadType modelPar_LA2=mod.LA2;
  bool modelPar_given_LA2=mod.given("LA2");
  AdmsSensFadType modelPar_WA2=mod.WA2;
  bool modelPar_given_WA2=mod.given("WA2");
  AdmsSensFadType modelPar_PA2=mod.PA2;
  bool modelPar_given_PA2=mod.given("PA2");
  AdmsSensFadType modelPar_A21=mod.A21;
  bool modelPar_given_A21=mod.given("A21");
  AdmsSensFadType modelPar_LA21=mod.LA21;
  bool modelPar_given_LA21=mod.given("LA21");
  AdmsSensFadType modelPar_WA21=mod.WA21;
  bool modelPar_given_WA21=mod.given("WA21");
  AdmsSensFadType modelPar_PA21=mod.PA21;
  bool modelPar_given_PA21=mod.given("PA21");
  AdmsSensFadType modelPar_PDIBLC=mod.PDIBLC;
  bool modelPar_given_PDIBLC=mod.given("PDIBLC");
  AdmsSensFadType modelPar_PDIBLCL=mod.PDIBLCL;
  bool modelPar_given_PDIBLCL=mod.given("PDIBLCL");
  AdmsSensFadType modelPar_PDIBLCLEXP=mod.PDIBLCLEXP;
  bool modelPar_given_PDIBLCLEXP=mod.given("PDIBLCLEXP");
  AdmsSensFadType modelPar_LPDIBLC=mod.LPDIBLC;
  bool modelPar_given_LPDIBLC=mod.given("LPDIBLC");
  AdmsSensFadType modelPar_WPDIBLC=mod.WPDIBLC;
  bool modelPar_given_WPDIBLC=mod.given("WPDIBLC");
  AdmsSensFadType modelPar_PPDIBLC=mod.PPDIBLC;
  bool modelPar_given_PPDIBLC=mod.given("PPDIBLC");
  AdmsSensFadType modelPar_PDIBLCR=mod.PDIBLCR;
  bool modelPar_given_PDIBLCR=mod.given("PDIBLCR");
  AdmsSensFadType modelPar_PDIBLCLR=mod.PDIBLCLR;
  bool modelPar_given_PDIBLCLR=mod.given("PDIBLCLR");
  AdmsSensFadType modelPar_PDIBLCLEXPR=mod.PDIBLCLEXPR;
  bool modelPar_given_PDIBLCLEXPR=mod.given("PDIBLCLEXPR");
  AdmsSensFadType modelPar_LPDIBLCR=mod.LPDIBLCR;
  bool modelPar_given_LPDIBLCR=mod.given("LPDIBLCR");
  AdmsSensFadType modelPar_WPDIBLCR=mod.WPDIBLCR;
  bool modelPar_given_WPDIBLCR=mod.given("WPDIBLCR");
  AdmsSensFadType modelPar_PPDIBLCR=mod.PPDIBLCR;
  bool modelPar_given_PPDIBLCR=mod.given("PPDIBLCR");
  AdmsSensFadType modelPar_PDIBLCB=mod.PDIBLCB;
  bool modelPar_given_PDIBLCB=mod.given("PDIBLCB");
  AdmsSensFadType modelPar_LPDIBLCB=mod.LPDIBLCB;
  bool modelPar_given_LPDIBLCB=mod.given("LPDIBLCB");
  AdmsSensFadType modelPar_WPDIBLCB=mod.WPDIBLCB;
  bool modelPar_given_WPDIBLCB=mod.given("WPDIBLCB");
  AdmsSensFadType modelPar_PPDIBLCB=mod.PPDIBLCB;
  bool modelPar_given_PPDIBLCB=mod.given("PPDIBLCB");
  AdmsSensFadType modelPar_PVAG=mod.PVAG;
  bool modelPar_given_PVAG=mod.given("PVAG");
  AdmsSensFadType modelPar_LPVAG=mod.LPVAG;
  bool modelPar_given_LPVAG=mod.given("LPVAG");
  AdmsSensFadType modelPar_WPVAG=mod.WPVAG;
  bool modelPar_given_WPVAG=mod.given("WPVAG");
  AdmsSensFadType modelPar_PPVAG=mod.PPVAG;
  bool modelPar_given_PPVAG=mod.given("PPVAG");
  AdmsSensFadType modelPar_FPROUT=mod.FPROUT;
  bool modelPar_given_FPROUT=mod.given("FPROUT");
  AdmsSensFadType modelPar_FPROUTL=mod.FPROUTL;
  bool modelPar_given_FPROUTL=mod.given("FPROUTL");
  AdmsSensFadType modelPar_FPROUTLEXP=mod.FPROUTLEXP;
  bool modelPar_given_FPROUTLEXP=mod.given("FPROUTLEXP");
  AdmsSensFadType modelPar_LFPROUT=mod.LFPROUT;
  bool modelPar_given_LFPROUT=mod.given("LFPROUT");
  AdmsSensFadType modelPar_WFPROUT=mod.WFPROUT;
  bool modelPar_given_WFPROUT=mod.given("WFPROUT");
  AdmsSensFadType modelPar_PFPROUT=mod.PFPROUT;
  bool modelPar_given_PFPROUT=mod.given("PFPROUT");
  AdmsSensFadType modelPar_ALPHA0=mod.ALPHA0;
  bool modelPar_given_ALPHA0=mod.given("ALPHA0");
  AdmsSensFadType modelPar_ALPHA0L=mod.ALPHA0L;
  bool modelPar_given_ALPHA0L=mod.given("ALPHA0L");
  AdmsSensFadType modelPar_ALPHA0LEXP=mod.ALPHA0LEXP;
  bool modelPar_given_ALPHA0LEXP=mod.given("ALPHA0LEXP");
  AdmsSensFadType modelPar_LALPHA0=mod.LALPHA0;
  bool modelPar_given_LALPHA0=mod.given("LALPHA0");
  AdmsSensFadType modelPar_WALPHA0=mod.WALPHA0;
  bool modelPar_given_WALPHA0=mod.given("WALPHA0");
  AdmsSensFadType modelPar_PALPHA0=mod.PALPHA0;
  bool modelPar_given_PALPHA0=mod.given("PALPHA0");
  AdmsSensFadType modelPar_BETA0=mod.BETA0;
  bool modelPar_given_BETA0=mod.given("BETA0");
  AdmsSensFadType modelPar_LBETA0=mod.LBETA0;
  bool modelPar_given_LBETA0=mod.given("LBETA0");
  AdmsSensFadType modelPar_WBETA0=mod.WBETA0;
  bool modelPar_given_WBETA0=mod.given("WBETA0");
  AdmsSensFadType modelPar_PBETA0=mod.PBETA0;
  bool modelPar_given_PBETA0=mod.given("PBETA0");
  AdmsSensFadType modelPar_AIGBACC=mod.AIGBACC;
  bool modelPar_given_AIGBACC=mod.given("AIGBACC");
  AdmsSensFadType modelPar_BIGBACC=mod.BIGBACC;
  bool modelPar_given_BIGBACC=mod.given("BIGBACC");
  AdmsSensFadType modelPar_CIGBACC=mod.CIGBACC;
  bool modelPar_given_CIGBACC=mod.given("CIGBACC");
  AdmsSensFadType modelPar_NIGBACC=mod.NIGBACC;
  bool modelPar_given_NIGBACC=mod.given("NIGBACC");
  AdmsSensFadType modelPar_AIGBINV=mod.AIGBINV;
  bool modelPar_given_AIGBINV=mod.given("AIGBINV");
  AdmsSensFadType modelPar_BIGBINV=mod.BIGBINV;
  bool modelPar_given_BIGBINV=mod.given("BIGBINV");
  AdmsSensFadType modelPar_CIGBINV=mod.CIGBINV;
  bool modelPar_given_CIGBINV=mod.given("CIGBINV");
  AdmsSensFadType modelPar_EIGBINV=mod.EIGBINV;
  bool modelPar_given_EIGBINV=mod.given("EIGBINV");
  AdmsSensFadType modelPar_NIGBINV=mod.NIGBINV;
  bool modelPar_given_NIGBINV=mod.given("NIGBINV");
  AdmsSensFadType modelPar_AIGC=mod.AIGC;
  bool modelPar_given_AIGC=mod.given("AIGC");
  AdmsSensFadType modelPar_BIGC=mod.BIGC;
  bool modelPar_given_BIGC=mod.given("BIGC");
  AdmsSensFadType modelPar_CIGC=mod.CIGC;
  bool modelPar_given_CIGC=mod.given("CIGC");
  AdmsSensFadType modelPar_AIGS=mod.AIGS;
  bool modelPar_given_AIGS=mod.given("AIGS");
  AdmsSensFadType modelPar_BIGS=mod.BIGS;
  bool modelPar_given_BIGS=mod.given("BIGS");
  AdmsSensFadType modelPar_CIGS=mod.CIGS;
  bool modelPar_given_CIGS=mod.given("CIGS");
  AdmsSensFadType modelPar_AIGD=mod.AIGD;
  bool modelPar_given_AIGD=mod.given("AIGD");
  AdmsSensFadType modelPar_BIGD=mod.BIGD;
  bool modelPar_given_BIGD=mod.given("BIGD");
  AdmsSensFadType modelPar_CIGD=mod.CIGD;
  bool modelPar_given_CIGD=mod.given("CIGD");
  AdmsSensFadType modelPar_DLCIG=mod.DLCIG;
  bool modelPar_given_DLCIG=mod.given("DLCIG");
  AdmsSensFadType modelPar_DLCIGD=mod.DLCIGD;
  bool modelPar_given_DLCIGD=mod.given("DLCIGD");
  AdmsSensFadType modelPar_POXEDGE=mod.POXEDGE;
  bool modelPar_given_POXEDGE=mod.given("POXEDGE");
  AdmsSensFadType modelPar_NTOX=mod.NTOX;
  bool modelPar_given_NTOX=mod.given("NTOX");
  AdmsSensFadType modelPar_TOXREF=mod.TOXREF;
  bool modelPar_given_TOXREF=mod.given("TOXREF");
  AdmsSensFadType modelPar_PIGCD=mod.PIGCD;
  bool modelPar_given_PIGCD=mod.given("PIGCD");
  AdmsSensFadType modelPar_AIGCL=mod.AIGCL;
  bool modelPar_given_AIGCL=mod.given("AIGCL");
  AdmsSensFadType modelPar_AIGCW=mod.AIGCW;
  bool modelPar_given_AIGCW=mod.given("AIGCW");
  AdmsSensFadType modelPar_AIGSL=mod.AIGSL;
  bool modelPar_given_AIGSL=mod.given("AIGSL");
  AdmsSensFadType modelPar_AIGSW=mod.AIGSW;
  bool modelPar_given_AIGSW=mod.given("AIGSW");
  AdmsSensFadType modelPar_AIGDL=mod.AIGDL;
  bool modelPar_given_AIGDL=mod.given("AIGDL");
  AdmsSensFadType modelPar_AIGDW=mod.AIGDW;
  bool modelPar_given_AIGDW=mod.given("AIGDW");
  AdmsSensFadType modelPar_PIGCDL=mod.PIGCDL;
  bool modelPar_given_PIGCDL=mod.given("PIGCDL");
  AdmsSensFadType modelPar_LAIGBINV=mod.LAIGBINV;
  bool modelPar_given_LAIGBINV=mod.given("LAIGBINV");
  AdmsSensFadType modelPar_WAIGBINV=mod.WAIGBINV;
  bool modelPar_given_WAIGBINV=mod.given("WAIGBINV");
  AdmsSensFadType modelPar_PAIGBINV=mod.PAIGBINV;
  bool modelPar_given_PAIGBINV=mod.given("PAIGBINV");
  AdmsSensFadType modelPar_LBIGBINV=mod.LBIGBINV;
  bool modelPar_given_LBIGBINV=mod.given("LBIGBINV");
  AdmsSensFadType modelPar_WBIGBINV=mod.WBIGBINV;
  bool modelPar_given_WBIGBINV=mod.given("WBIGBINV");
  AdmsSensFadType modelPar_PBIGBINV=mod.PBIGBINV;
  bool modelPar_given_PBIGBINV=mod.given("PBIGBINV");
  AdmsSensFadType modelPar_LCIGBINV=mod.LCIGBINV;
  bool modelPar_given_LCIGBINV=mod.given("LCIGBINV");
  AdmsSensFadType modelPar_WCIGBINV=mod.WCIGBINV;
  bool modelPar_given_WCIGBINV=mod.given("WCIGBINV");
  AdmsSensFadType modelPar_PCIGBINV=mod.PCIGBINV;
  bool modelPar_given_PCIGBINV=mod.given("PCIGBINV");
  AdmsSensFadType modelPar_LEIGBINV=mod.LEIGBINV;
  bool modelPar_given_LEIGBINV=mod.given("LEIGBINV");
  AdmsSensFadType modelPar_WEIGBINV=mod.WEIGBINV;
  bool modelPar_given_WEIGBINV=mod.given("WEIGBINV");
  AdmsSensFadType modelPar_PEIGBINV=mod.PEIGBINV;
  bool modelPar_given_PEIGBINV=mod.given("PEIGBINV");
  AdmsSensFadType modelPar_LNIGBINV=mod.LNIGBINV;
  bool modelPar_given_LNIGBINV=mod.given("LNIGBINV");
  AdmsSensFadType modelPar_WNIGBINV=mod.WNIGBINV;
  bool modelPar_given_WNIGBINV=mod.given("WNIGBINV");
  AdmsSensFadType modelPar_PNIGBINV=mod.PNIGBINV;
  bool modelPar_given_PNIGBINV=mod.given("PNIGBINV");
  AdmsSensFadType modelPar_LAIGBACC=mod.LAIGBACC;
  bool modelPar_given_LAIGBACC=mod.given("LAIGBACC");
  AdmsSensFadType modelPar_WAIGBACC=mod.WAIGBACC;
  bool modelPar_given_WAIGBACC=mod.given("WAIGBACC");
  AdmsSensFadType modelPar_PAIGBACC=mod.PAIGBACC;
  bool modelPar_given_PAIGBACC=mod.given("PAIGBACC");
  AdmsSensFadType modelPar_LBIGBACC=mod.LBIGBACC;
  bool modelPar_given_LBIGBACC=mod.given("LBIGBACC");
  AdmsSensFadType modelPar_WBIGBACC=mod.WBIGBACC;
  bool modelPar_given_WBIGBACC=mod.given("WBIGBACC");
  AdmsSensFadType modelPar_PBIGBACC=mod.PBIGBACC;
  bool modelPar_given_PBIGBACC=mod.given("PBIGBACC");
  AdmsSensFadType modelPar_LCIGBACC=mod.LCIGBACC;
  bool modelPar_given_LCIGBACC=mod.given("LCIGBACC");
  AdmsSensFadType modelPar_WCIGBACC=mod.WCIGBACC;
  bool modelPar_given_WCIGBACC=mod.given("WCIGBACC");
  AdmsSensFadType modelPar_PCIGBACC=mod.PCIGBACC;
  bool modelPar_given_PCIGBACC=mod.given("PCIGBACC");
  AdmsSensFadType modelPar_LNIGBACC=mod.LNIGBACC;
  bool modelPar_given_LNIGBACC=mod.given("LNIGBACC");
  AdmsSensFadType modelPar_WNIGBACC=mod.WNIGBACC;
  bool modelPar_given_WNIGBACC=mod.given("WNIGBACC");
  AdmsSensFadType modelPar_PNIGBACC=mod.PNIGBACC;
  bool modelPar_given_PNIGBACC=mod.given("PNIGBACC");
  AdmsSensFadType modelPar_LAIGC=mod.LAIGC;
  bool modelPar_given_LAIGC=mod.given("LAIGC");
  AdmsSensFadType modelPar_WAIGC=mod.WAIGC;
  bool modelPar_given_WAIGC=mod.given("WAIGC");
  AdmsSensFadType modelPar_PAIGC=mod.PAIGC;
  bool modelPar_given_PAIGC=mod.given("PAIGC");
  AdmsSensFadType modelPar_LBIGC=mod.LBIGC;
  bool modelPar_given_LBIGC=mod.given("LBIGC");
  AdmsSensFadType modelPar_WBIGC=mod.WBIGC;
  bool modelPar_given_WBIGC=mod.given("WBIGC");
  AdmsSensFadType modelPar_PBIGC=mod.PBIGC;
  bool modelPar_given_PBIGC=mod.given("PBIGC");
  AdmsSensFadType modelPar_LCIGC=mod.LCIGC;
  bool modelPar_given_LCIGC=mod.given("LCIGC");
  AdmsSensFadType modelPar_WCIGC=mod.WCIGC;
  bool modelPar_given_WCIGC=mod.given("WCIGC");
  AdmsSensFadType modelPar_PCIGC=mod.PCIGC;
  bool modelPar_given_PCIGC=mod.given("PCIGC");
  AdmsSensFadType modelPar_LAIGS=mod.LAIGS;
  bool modelPar_given_LAIGS=mod.given("LAIGS");
  AdmsSensFadType modelPar_WAIGS=mod.WAIGS;
  bool modelPar_given_WAIGS=mod.given("WAIGS");
  AdmsSensFadType modelPar_PAIGS=mod.PAIGS;
  bool modelPar_given_PAIGS=mod.given("PAIGS");
  AdmsSensFadType modelPar_LBIGS=mod.LBIGS;
  bool modelPar_given_LBIGS=mod.given("LBIGS");
  AdmsSensFadType modelPar_WBIGS=mod.WBIGS;
  bool modelPar_given_WBIGS=mod.given("WBIGS");
  AdmsSensFadType modelPar_PBIGS=mod.PBIGS;
  bool modelPar_given_PBIGS=mod.given("PBIGS");
  AdmsSensFadType modelPar_LCIGS=mod.LCIGS;
  bool modelPar_given_LCIGS=mod.given("LCIGS");
  AdmsSensFadType modelPar_WCIGS=mod.WCIGS;
  bool modelPar_given_WCIGS=mod.given("WCIGS");
  AdmsSensFadType modelPar_PCIGS=mod.PCIGS;
  bool modelPar_given_PCIGS=mod.given("PCIGS");
  AdmsSensFadType modelPar_LAIGD=mod.LAIGD;
  bool modelPar_given_LAIGD=mod.given("LAIGD");
  AdmsSensFadType modelPar_WAIGD=mod.WAIGD;
  bool modelPar_given_WAIGD=mod.given("WAIGD");
  AdmsSensFadType modelPar_PAIGD=mod.PAIGD;
  bool modelPar_given_PAIGD=mod.given("PAIGD");
  AdmsSensFadType modelPar_LBIGD=mod.LBIGD;
  bool modelPar_given_LBIGD=mod.given("LBIGD");
  AdmsSensFadType modelPar_WBIGD=mod.WBIGD;
  bool modelPar_given_WBIGD=mod.given("WBIGD");
  AdmsSensFadType modelPar_PBIGD=mod.PBIGD;
  bool modelPar_given_PBIGD=mod.given("PBIGD");
  AdmsSensFadType modelPar_LCIGD=mod.LCIGD;
  bool modelPar_given_LCIGD=mod.given("LCIGD");
  AdmsSensFadType modelPar_WCIGD=mod.WCIGD;
  bool modelPar_given_WCIGD=mod.given("WCIGD");
  AdmsSensFadType modelPar_PCIGD=mod.PCIGD;
  bool modelPar_given_PCIGD=mod.given("PCIGD");
  AdmsSensFadType modelPar_LPOXEDGE=mod.LPOXEDGE;
  bool modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
  AdmsSensFadType modelPar_WPOXEDGE=mod.WPOXEDGE;
  bool modelPar_given_WPOXEDGE=mod.given("WPOXEDGE");
  AdmsSensFadType modelPar_PPOXEDGE=mod.PPOXEDGE;
  bool modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
  AdmsSensFadType modelPar_LDLCIG=mod.LDLCIG;
  bool modelPar_given_LDLCIG=mod.given("LDLCIG");
  AdmsSensFadType modelPar_WDLCIG=mod.WDLCIG;
  bool modelPar_given_WDLCIG=mod.given("WDLCIG");
  AdmsSensFadType modelPar_PDLCIG=mod.PDLCIG;
  bool modelPar_given_PDLCIG=mod.given("PDLCIG");
  AdmsSensFadType modelPar_LDLCIGD=mod.LDLCIGD;
  bool modelPar_given_LDLCIGD=mod.given("LDLCIGD");
  AdmsSensFadType modelPar_WDLCIGD=mod.WDLCIGD;
  bool modelPar_given_WDLCIGD=mod.given("WDLCIGD");
  AdmsSensFadType modelPar_PDLCIGD=mod.PDLCIGD;
  bool modelPar_given_PDLCIGD=mod.given("PDLCIGD");
  AdmsSensFadType modelPar_LNTOX=mod.LNTOX;
  bool modelPar_given_LNTOX=mod.given("LNTOX");
  AdmsSensFadType modelPar_WNTOX=mod.WNTOX;
  bool modelPar_given_WNTOX=mod.given("WNTOX");
  AdmsSensFadType modelPar_PNTOX=mod.PNTOX;
  bool modelPar_given_PNTOX=mod.given("PNTOX");
  AdmsSensFadType modelPar_AGIDL=mod.AGIDL;
  bool modelPar_given_AGIDL=mod.given("AGIDL");
  AdmsSensFadType modelPar_AGIDLL=mod.AGIDLL;
  bool modelPar_given_AGIDLL=mod.given("AGIDLL");
  AdmsSensFadType modelPar_AGIDLW=mod.AGIDLW;
  bool modelPar_given_AGIDLW=mod.given("AGIDLW");
  AdmsSensFadType modelPar_LAGIDL=mod.LAGIDL;
  bool modelPar_given_LAGIDL=mod.given("LAGIDL");
  AdmsSensFadType modelPar_WAGIDL=mod.WAGIDL;
  bool modelPar_given_WAGIDL=mod.given("WAGIDL");
  AdmsSensFadType modelPar_PAGIDL=mod.PAGIDL;
  bool modelPar_given_PAGIDL=mod.given("PAGIDL");
  AdmsSensFadType modelPar_BGIDL=mod.BGIDL;
  bool modelPar_given_BGIDL=mod.given("BGIDL");
  AdmsSensFadType modelPar_LBGIDL=mod.LBGIDL;
  bool modelPar_given_LBGIDL=mod.given("LBGIDL");
  AdmsSensFadType modelPar_WBGIDL=mod.WBGIDL;
  bool modelPar_given_WBGIDL=mod.given("WBGIDL");
  AdmsSensFadType modelPar_PBGIDL=mod.PBGIDL;
  bool modelPar_given_PBGIDL=mod.given("PBGIDL");
  AdmsSensFadType modelPar_CGIDL=mod.CGIDL;
  bool modelPar_given_CGIDL=mod.given("CGIDL");
  AdmsSensFadType modelPar_LCGIDL=mod.LCGIDL;
  bool modelPar_given_LCGIDL=mod.given("LCGIDL");
  AdmsSensFadType modelPar_WCGIDL=mod.WCGIDL;
  bool modelPar_given_WCGIDL=mod.given("WCGIDL");
  AdmsSensFadType modelPar_PCGIDL=mod.PCGIDL;
  bool modelPar_given_PCGIDL=mod.given("PCGIDL");
  AdmsSensFadType modelPar_EGIDL=mod.EGIDL;
  bool modelPar_given_EGIDL=mod.given("EGIDL");
  AdmsSensFadType modelPar_LEGIDL=mod.LEGIDL;
  bool modelPar_given_LEGIDL=mod.given("LEGIDL");
  AdmsSensFadType modelPar_WEGIDL=mod.WEGIDL;
  bool modelPar_given_WEGIDL=mod.given("WEGIDL");
  AdmsSensFadType modelPar_PEGIDL=mod.PEGIDL;
  bool modelPar_given_PEGIDL=mod.given("PEGIDL");
  AdmsSensFadType modelPar_AGISL=mod.AGISL;
  bool modelPar_given_AGISL=mod.given("AGISL");
  AdmsSensFadType modelPar_AGISLL=mod.AGISLL;
  bool modelPar_given_AGISLL=mod.given("AGISLL");
  AdmsSensFadType modelPar_AGISLW=mod.AGISLW;
  bool modelPar_given_AGISLW=mod.given("AGISLW");
  AdmsSensFadType modelPar_LAGISL=mod.LAGISL;
  bool modelPar_given_LAGISL=mod.given("LAGISL");
  AdmsSensFadType modelPar_WAGISL=mod.WAGISL;
  bool modelPar_given_WAGISL=mod.given("WAGISL");
  AdmsSensFadType modelPar_PAGISL=mod.PAGISL;
  bool modelPar_given_PAGISL=mod.given("PAGISL");
  AdmsSensFadType modelPar_BGISL=mod.BGISL;
  bool modelPar_given_BGISL=mod.given("BGISL");
  AdmsSensFadType modelPar_LBGISL=mod.LBGISL;
  bool modelPar_given_LBGISL=mod.given("LBGISL");
  AdmsSensFadType modelPar_WBGISL=mod.WBGISL;
  bool modelPar_given_WBGISL=mod.given("WBGISL");
  AdmsSensFadType modelPar_PBGISL=mod.PBGISL;
  bool modelPar_given_PBGISL=mod.given("PBGISL");
  AdmsSensFadType modelPar_CGISL=mod.CGISL;
  bool modelPar_given_CGISL=mod.given("CGISL");
  AdmsSensFadType modelPar_LCGISL=mod.LCGISL;
  bool modelPar_given_LCGISL=mod.given("LCGISL");
  AdmsSensFadType modelPar_WCGISL=mod.WCGISL;
  bool modelPar_given_WCGISL=mod.given("WCGISL");
  AdmsSensFadType modelPar_PCGISL=mod.PCGISL;
  bool modelPar_given_PCGISL=mod.given("PCGISL");
  AdmsSensFadType modelPar_EGISL=mod.EGISL;
  bool modelPar_given_EGISL=mod.given("EGISL");
  AdmsSensFadType modelPar_LEGISL=mod.LEGISL;
  bool modelPar_given_LEGISL=mod.given("LEGISL");
  AdmsSensFadType modelPar_WEGISL=mod.WEGISL;
  bool modelPar_given_WEGISL=mod.given("WEGISL");
  AdmsSensFadType modelPar_PEGISL=mod.PEGISL;
  bool modelPar_given_PEGISL=mod.given("PEGISL");
  AdmsSensFadType modelPar_CF=mod.CF;
  bool modelPar_given_CF=mod.given("CF");
  AdmsSensFadType modelPar_LCF=mod.LCF;
  bool modelPar_given_LCF=mod.given("LCF");
  AdmsSensFadType modelPar_WCF=mod.WCF;
  bool modelPar_given_WCF=mod.given("WCF");
  AdmsSensFadType modelPar_PCF=mod.PCF;
  bool modelPar_given_PCF=mod.given("PCF");
  AdmsSensFadType modelPar_CFRCOEFF=mod.CFRCOEFF;
  bool modelPar_given_CFRCOEFF=mod.given("CFRCOEFF");
  AdmsSensFadType modelPar_CGSO=mod.CGSO;
  bool modelPar_given_CGSO=mod.given("CGSO");
  AdmsSensFadType modelPar_CGDO=mod.CGDO;
  bool modelPar_given_CGDO=mod.given("CGDO");
  AdmsSensFadType modelPar_CGBO=mod.CGBO;
  bool modelPar_given_CGBO=mod.given("CGBO");
  AdmsSensFadType modelPar_CGSL=mod.CGSL;
  bool modelPar_given_CGSL=mod.given("CGSL");
  AdmsSensFadType modelPar_LCGSL=mod.LCGSL;
  bool modelPar_given_LCGSL=mod.given("LCGSL");
  AdmsSensFadType modelPar_WCGSL=mod.WCGSL;
  bool modelPar_given_WCGSL=mod.given("WCGSL");
  AdmsSensFadType modelPar_PCGSL=mod.PCGSL;
  bool modelPar_given_PCGSL=mod.given("PCGSL");
  AdmsSensFadType modelPar_CGDL=mod.CGDL;
  bool modelPar_given_CGDL=mod.given("CGDL");
  AdmsSensFadType modelPar_LCGDL=mod.LCGDL;
  bool modelPar_given_LCGDL=mod.given("LCGDL");
  AdmsSensFadType modelPar_WCGDL=mod.WCGDL;
  bool modelPar_given_WCGDL=mod.given("WCGDL");
  AdmsSensFadType modelPar_PCGDL=mod.PCGDL;
  bool modelPar_given_PCGDL=mod.given("PCGDL");
  AdmsSensFadType modelPar_CKAPPAS=mod.CKAPPAS;
  bool modelPar_given_CKAPPAS=mod.given("CKAPPAS");
  AdmsSensFadType modelPar_LCKAPPAS=mod.LCKAPPAS;
  bool modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
  AdmsSensFadType modelPar_WCKAPPAS=mod.WCKAPPAS;
  bool modelPar_given_WCKAPPAS=mod.given("WCKAPPAS");
  AdmsSensFadType modelPar_PCKAPPAS=mod.PCKAPPAS;
  bool modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
  AdmsSensFadType modelPar_CKAPPAD=mod.CKAPPAD;
  bool modelPar_given_CKAPPAD=mod.given("CKAPPAD");
  AdmsSensFadType modelPar_LCKAPPAD=mod.LCKAPPAD;
  bool modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
  AdmsSensFadType modelPar_WCKAPPAD=mod.WCKAPPAD;
  bool modelPar_given_WCKAPPAD=mod.given("WCKAPPAD");
  AdmsSensFadType modelPar_PCKAPPAD=mod.PCKAPPAD;
  bool modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
  AdmsSensFadType modelPar_DMCG=mod.DMCG;
  bool modelPar_given_DMCG=mod.given("DMCG");
  AdmsSensFadType modelPar_DMCI=mod.DMCI;
  bool modelPar_given_DMCI=mod.given("DMCI");
  AdmsSensFadType modelPar_DMDG=mod.DMDG;
  bool modelPar_given_DMDG=mod.given("DMDG");
  AdmsSensFadType modelPar_DMCGT=mod.DMCGT;
  bool modelPar_given_DMCGT=mod.given("DMCGT");
  AdmsSensFadType modelPar_XGL=mod.XGL;
  bool modelPar_given_XGL=mod.given("XGL");
  AdmsSensFadType modelPar_RSHG=mod.RSHG;
  bool modelPar_given_RSHG=mod.given("RSHG");
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  AdmsSensFadType modelPar_CJD=mod.CJD;
  bool modelPar_given_CJD=mod.given("CJD");
  AdmsSensFadType modelPar_CJSWS=mod.CJSWS;
  bool modelPar_given_CJSWS=mod.given("CJSWS");
  AdmsSensFadType modelPar_CJSWD=mod.CJSWD;
  bool modelPar_given_CJSWD=mod.given("CJSWD");
  AdmsSensFadType modelPar_CJSWGS=mod.CJSWGS;
  bool modelPar_given_CJSWGS=mod.given("CJSWGS");
  AdmsSensFadType modelPar_CJSWGD=mod.CJSWGD;
  bool modelPar_given_CJSWGD=mod.given("CJSWGD");
  AdmsSensFadType modelPar_PBS=mod.PBS;
  bool modelPar_given_PBS=mod.given("PBS");
  AdmsSensFadType modelPar_PBD=mod.PBD;
  bool modelPar_given_PBD=mod.given("PBD");
  AdmsSensFadType modelPar_PBSWS=mod.PBSWS;
  bool modelPar_given_PBSWS=mod.given("PBSWS");
  AdmsSensFadType modelPar_PBSWD=mod.PBSWD;
  bool modelPar_given_PBSWD=mod.given("PBSWD");
  AdmsSensFadType modelPar_PBSWGS=mod.PBSWGS;
  bool modelPar_given_PBSWGS=mod.given("PBSWGS");
  AdmsSensFadType modelPar_PBSWGD=mod.PBSWGD;
  bool modelPar_given_PBSWGD=mod.given("PBSWGD");
  AdmsSensFadType modelPar_MJS=mod.MJS;
  bool modelPar_given_MJS=mod.given("MJS");
  AdmsSensFadType modelPar_MJD=mod.MJD;
  bool modelPar_given_MJD=mod.given("MJD");
  AdmsSensFadType modelPar_MJSWS=mod.MJSWS;
  bool modelPar_given_MJSWS=mod.given("MJSWS");
  AdmsSensFadType modelPar_MJSWD=mod.MJSWD;
  bool modelPar_given_MJSWD=mod.given("MJSWD");
  AdmsSensFadType modelPar_MJSWGS=mod.MJSWGS;
  bool modelPar_given_MJSWGS=mod.given("MJSWGS");
  AdmsSensFadType modelPar_MJSWGD=mod.MJSWGD;
  bool modelPar_given_MJSWGD=mod.given("MJSWGD");
  AdmsSensFadType modelPar_JSS=mod.JSS;
  bool modelPar_given_JSS=mod.given("JSS");
  AdmsSensFadType modelPar_JSD=mod.JSD;
  bool modelPar_given_JSD=mod.given("JSD");
  AdmsSensFadType modelPar_JSWS=mod.JSWS;
  bool modelPar_given_JSWS=mod.given("JSWS");
  AdmsSensFadType modelPar_JSWD=mod.JSWD;
  bool modelPar_given_JSWD=mod.given("JSWD");
  AdmsSensFadType modelPar_JSWGS=mod.JSWGS;
  bool modelPar_given_JSWGS=mod.given("JSWGS");
  AdmsSensFadType modelPar_JSWGD=mod.JSWGD;
  bool modelPar_given_JSWGD=mod.given("JSWGD");
  AdmsSensFadType modelPar_NJS=mod.NJS;
  bool modelPar_given_NJS=mod.given("NJS");
  AdmsSensFadType modelPar_NJD=mod.NJD;
  bool modelPar_given_NJD=mod.given("NJD");
  AdmsSensFadType modelPar_IJTHSFWD=mod.IJTHSFWD;
  bool modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
  AdmsSensFadType modelPar_IJTHDFWD=mod.IJTHDFWD;
  bool modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
  AdmsSensFadType modelPar_IJTHSREV=mod.IJTHSREV;
  bool modelPar_given_IJTHSREV=mod.given("IJTHSREV");
  AdmsSensFadType modelPar_IJTHDREV=mod.IJTHDREV;
  bool modelPar_given_IJTHDREV=mod.given("IJTHDREV");
  AdmsSensFadType modelPar_BVS=mod.BVS;
  bool modelPar_given_BVS=mod.given("BVS");
  AdmsSensFadType modelPar_BVD=mod.BVD;
  bool modelPar_given_BVD=mod.given("BVD");
  AdmsSensFadType modelPar_XJBVS=mod.XJBVS;
  bool modelPar_given_XJBVS=mod.given("XJBVS");
  AdmsSensFadType modelPar_XJBVD=mod.XJBVD;
  bool modelPar_given_XJBVD=mod.given("XJBVD");
  AdmsSensFadType modelPar_JTSS=mod.JTSS;
  bool modelPar_given_JTSS=mod.given("JTSS");
  AdmsSensFadType modelPar_JTSD=mod.JTSD;
  bool modelPar_given_JTSD=mod.given("JTSD");
  AdmsSensFadType modelPar_JTSSWS=mod.JTSSWS;
  bool modelPar_given_JTSSWS=mod.given("JTSSWS");
  AdmsSensFadType modelPar_JTSSWD=mod.JTSSWD;
  bool modelPar_given_JTSSWD=mod.given("JTSSWD");
  AdmsSensFadType modelPar_JTSSWGS=mod.JTSSWGS;
  bool modelPar_given_JTSSWGS=mod.given("JTSSWGS");
  AdmsSensFadType modelPar_JTSSWGD=mod.JTSSWGD;
  bool modelPar_given_JTSSWGD=mod.given("JTSSWGD");
  AdmsSensFadType modelPar_JTWEFF=mod.JTWEFF;
  bool modelPar_given_JTWEFF=mod.given("JTWEFF");
  AdmsSensFadType modelPar_NJTS=mod.NJTS;
  bool modelPar_given_NJTS=mod.given("NJTS");
  AdmsSensFadType modelPar_NJTSD=mod.NJTSD;
  bool modelPar_given_NJTSD=mod.given("NJTSD");
  AdmsSensFadType modelPar_NJTSSW=mod.NJTSSW;
  bool modelPar_given_NJTSSW=mod.given("NJTSSW");
  AdmsSensFadType modelPar_NJTSSWD=mod.NJTSSWD;
  bool modelPar_given_NJTSSWD=mod.given("NJTSSWD");
  AdmsSensFadType modelPar_NJTSSWG=mod.NJTSSWG;
  bool modelPar_given_NJTSSWG=mod.given("NJTSSWG");
  AdmsSensFadType modelPar_NJTSSWGD=mod.NJTSSWGD;
  bool modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
  AdmsSensFadType modelPar_VTSS=mod.VTSS;
  bool modelPar_given_VTSS=mod.given("VTSS");
  AdmsSensFadType modelPar_VTSD=mod.VTSD;
  bool modelPar_given_VTSD=mod.given("VTSD");
  AdmsSensFadType modelPar_VTSSWS=mod.VTSSWS;
  bool modelPar_given_VTSSWS=mod.given("VTSSWS");
  AdmsSensFadType modelPar_VTSSWD=mod.VTSSWD;
  bool modelPar_given_VTSSWD=mod.given("VTSSWD");
  AdmsSensFadType modelPar_VTSSWGS=mod.VTSSWGS;
  bool modelPar_given_VTSSWGS=mod.given("VTSSWGS");
  AdmsSensFadType modelPar_VTSSWGD=mod.VTSSWGD;
  bool modelPar_given_VTSSWGD=mod.given("VTSSWGD");
  AdmsSensFadType modelPar_XRCRG1=mod.XRCRG1;
  bool modelPar_given_XRCRG1=mod.given("XRCRG1");
  AdmsSensFadType modelPar_XRCRG2=mod.XRCRG2;
  bool modelPar_given_XRCRG2=mod.given("XRCRG2");
  AdmsSensFadType modelPar_GBMIN=mod.GBMIN;
  bool modelPar_given_GBMIN=mod.given("GBMIN");
  AdmsSensFadType modelPar_RBPS0=mod.RBPS0;
  bool modelPar_given_RBPS0=mod.given("RBPS0");
  AdmsSensFadType modelPar_RBPSL=mod.RBPSL;
  bool modelPar_given_RBPSL=mod.given("RBPSL");
  AdmsSensFadType modelPar_RBPSW=mod.RBPSW;
  bool modelPar_given_RBPSW=mod.given("RBPSW");
  AdmsSensFadType modelPar_RBPSNF=mod.RBPSNF;
  bool modelPar_given_RBPSNF=mod.given("RBPSNF");
  AdmsSensFadType modelPar_RBPD0=mod.RBPD0;
  bool modelPar_given_RBPD0=mod.given("RBPD0");
  AdmsSensFadType modelPar_RBPDL=mod.RBPDL;
  bool modelPar_given_RBPDL=mod.given("RBPDL");
  AdmsSensFadType modelPar_RBPDW=mod.RBPDW;
  bool modelPar_given_RBPDW=mod.given("RBPDW");
  AdmsSensFadType modelPar_RBPDNF=mod.RBPDNF;
  bool modelPar_given_RBPDNF=mod.given("RBPDNF");
  AdmsSensFadType modelPar_RBPBX0=mod.RBPBX0;
  bool modelPar_given_RBPBX0=mod.given("RBPBX0");
  AdmsSensFadType modelPar_RBPBXL=mod.RBPBXL;
  bool modelPar_given_RBPBXL=mod.given("RBPBXL");
  AdmsSensFadType modelPar_RBPBXW=mod.RBPBXW;
  bool modelPar_given_RBPBXW=mod.given("RBPBXW");
  AdmsSensFadType modelPar_RBPBXNF=mod.RBPBXNF;
  bool modelPar_given_RBPBXNF=mod.given("RBPBXNF");
  AdmsSensFadType modelPar_RBPBY0=mod.RBPBY0;
  bool modelPar_given_RBPBY0=mod.given("RBPBY0");
  AdmsSensFadType modelPar_RBPBYL=mod.RBPBYL;
  bool modelPar_given_RBPBYL=mod.given("RBPBYL");
  AdmsSensFadType modelPar_RBPBYW=mod.RBPBYW;
  bool modelPar_given_RBPBYW=mod.given("RBPBYW");
  AdmsSensFadType modelPar_RBPBYNF=mod.RBPBYNF;
  bool modelPar_given_RBPBYNF=mod.given("RBPBYNF");
  AdmsSensFadType modelPar_RBSBX0=mod.RBSBX0;
  bool modelPar_given_RBSBX0=mod.given("RBSBX0");
  AdmsSensFadType modelPar_RBSBY0=mod.RBSBY0;
  bool modelPar_given_RBSBY0=mod.given("RBSBY0");
  AdmsSensFadType modelPar_RBDBX0=mod.RBDBX0;
  bool modelPar_given_RBDBX0=mod.given("RBDBX0");
  AdmsSensFadType modelPar_RBDBY0=mod.RBDBY0;
  bool modelPar_given_RBDBY0=mod.given("RBDBY0");
  AdmsSensFadType modelPar_RBSDBXL=mod.RBSDBXL;
  bool modelPar_given_RBSDBXL=mod.given("RBSDBXL");
  AdmsSensFadType modelPar_RBSDBXW=mod.RBSDBXW;
  bool modelPar_given_RBSDBXW=mod.given("RBSDBXW");
  AdmsSensFadType modelPar_RBSDBXNF=mod.RBSDBXNF;
  bool modelPar_given_RBSDBXNF=mod.given("RBSDBXNF");
  AdmsSensFadType modelPar_RBSDBYL=mod.RBSDBYL;
  bool modelPar_given_RBSDBYL=mod.given("RBSDBYL");
  AdmsSensFadType modelPar_RBSDBYW=mod.RBSDBYW;
  bool modelPar_given_RBSDBYW=mod.given("RBSDBYW");
  AdmsSensFadType modelPar_RBSDBYNF=mod.RBSDBYNF;
  bool modelPar_given_RBSDBYNF=mod.given("RBSDBYNF");
  AdmsSensFadType modelPar_EF=mod.EF;
  bool modelPar_given_EF=mod.given("EF");
  AdmsSensFadType modelPar_EM=mod.EM;
  bool modelPar_given_EM=mod.given("EM");
  AdmsSensFadType modelPar_NOIA=mod.NOIA;
  bool modelPar_given_NOIA=mod.given("NOIA");
  AdmsSensFadType modelPar_NOIB=mod.NOIB;
  bool modelPar_given_NOIB=mod.given("NOIB");
  AdmsSensFadType modelPar_NOIC=mod.NOIC;
  bool modelPar_given_NOIC=mod.given("NOIC");
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  AdmsSensFadType modelPar_NTNOI=mod.NTNOI;
  bool modelPar_given_NTNOI=mod.given("NTNOI");
  AdmsSensFadType modelPar_RNOIA=mod.RNOIA;
  bool modelPar_given_RNOIA=mod.given("RNOIA");
  AdmsSensFadType modelPar_RNOIB=mod.RNOIB;
  bool modelPar_given_RNOIB=mod.given("RNOIB");
  AdmsSensFadType modelPar_RNOIC=mod.RNOIC;
  bool modelPar_given_RNOIC=mod.given("RNOIC");
  AdmsSensFadType modelPar_TNOIA=mod.TNOIA;
  bool modelPar_given_TNOIA=mod.given("TNOIA");
  AdmsSensFadType modelPar_TNOIB=mod.TNOIB;
  bool modelPar_given_TNOIB=mod.given("TNOIB");
  AdmsSensFadType modelPar_TNOIC=mod.TNOIC;
  bool modelPar_given_TNOIC=mod.given("TNOIC");
  AdmsSensFadType modelPar_DLBIN=mod.DLBIN;
  bool modelPar_given_DLBIN=mod.given("DLBIN");
  AdmsSensFadType modelPar_DWBIN=mod.DWBIN;
  bool modelPar_given_DWBIN=mod.given("DWBIN");
  AdmsSensFadType modelPar_TNOM=mod.TNOM;
  bool modelPar_given_TNOM=mod.given("TNOM");
  AdmsSensFadType modelPar_DTEMP=mod.DTEMP;
  bool modelPar_given_DTEMP=mod.given("DTEMP");
  AdmsSensFadType modelPar_TBGASUB=mod.TBGASUB;
  bool modelPar_given_TBGASUB=mod.given("TBGASUB");
  AdmsSensFadType modelPar_TBGBSUB=mod.TBGBSUB;
  bool modelPar_given_TBGBSUB=mod.given("TBGBSUB");
  AdmsSensFadType modelPar_TNFACTOR=mod.TNFACTOR;
  bool modelPar_given_TNFACTOR=mod.given("TNFACTOR");
  AdmsSensFadType modelPar_UTE=mod.UTE;
  bool modelPar_given_UTE=mod.given("UTE");
  AdmsSensFadType modelPar_LUTE=mod.LUTE;
  bool modelPar_given_LUTE=mod.given("LUTE");
  AdmsSensFadType modelPar_WUTE=mod.WUTE;
  bool modelPar_given_WUTE=mod.given("WUTE");
  AdmsSensFadType modelPar_PUTE=mod.PUTE;
  bool modelPar_given_PUTE=mod.given("PUTE");
  AdmsSensFadType modelPar_UTEL=mod.UTEL;
  bool modelPar_given_UTEL=mod.given("UTEL");
  AdmsSensFadType modelPar_UA1=mod.UA1;
  bool modelPar_given_UA1=mod.given("UA1");
  AdmsSensFadType modelPar_LUA1=mod.LUA1;
  bool modelPar_given_LUA1=mod.given("LUA1");
  AdmsSensFadType modelPar_WUA1=mod.WUA1;
  bool modelPar_given_WUA1=mod.given("WUA1");
  AdmsSensFadType modelPar_PUA1=mod.PUA1;
  bool modelPar_given_PUA1=mod.given("PUA1");
  AdmsSensFadType modelPar_UA1L=mod.UA1L;
  bool modelPar_given_UA1L=mod.given("UA1L");
  AdmsSensFadType modelPar_UC1=mod.UC1;
  bool modelPar_given_UC1=mod.given("UC1");
  AdmsSensFadType modelPar_LUC1=mod.LUC1;
  bool modelPar_given_LUC1=mod.given("LUC1");
  AdmsSensFadType modelPar_WUC1=mod.WUC1;
  bool modelPar_given_WUC1=mod.given("WUC1");
  AdmsSensFadType modelPar_PUC1=mod.PUC1;
  bool modelPar_given_PUC1=mod.given("PUC1");
  AdmsSensFadType modelPar_UD1=mod.UD1;
  bool modelPar_given_UD1=mod.given("UD1");
  AdmsSensFadType modelPar_LUD1=mod.LUD1;
  bool modelPar_given_LUD1=mod.given("LUD1");
  AdmsSensFadType modelPar_WUD1=mod.WUD1;
  bool modelPar_given_WUD1=mod.given("WUD1");
  AdmsSensFadType modelPar_PUD1=mod.PUD1;
  bool modelPar_given_PUD1=mod.given("PUD1");
  AdmsSensFadType modelPar_UD1L=mod.UD1L;
  bool modelPar_given_UD1L=mod.given("UD1L");
  AdmsSensFadType modelPar_UCSTE=mod.UCSTE;
  bool modelPar_given_UCSTE=mod.given("UCSTE");
  AdmsSensFadType modelPar_LUCSTE=mod.LUCSTE;
  bool modelPar_given_LUCSTE=mod.given("LUCSTE");
  AdmsSensFadType modelPar_WUCSTE=mod.WUCSTE;
  bool modelPar_given_WUCSTE=mod.given("WUCSTE");
  AdmsSensFadType modelPar_PUCSTE=mod.PUCSTE;
  bool modelPar_given_PUCSTE=mod.given("PUCSTE");
  AdmsSensFadType modelPar_TETA0=mod.TETA0;
  bool modelPar_given_TETA0=mod.given("TETA0");
  AdmsSensFadType modelPar_PRT=mod.PRT;
  bool modelPar_given_PRT=mod.given("PRT");
  AdmsSensFadType modelPar_LPRT=mod.LPRT;
  bool modelPar_given_LPRT=mod.given("LPRT");
  AdmsSensFadType modelPar_WPRT=mod.WPRT;
  bool modelPar_given_WPRT=mod.given("WPRT");
  AdmsSensFadType modelPar_PPRT=mod.PPRT;
  bool modelPar_given_PPRT=mod.given("PPRT");
  AdmsSensFadType modelPar_AT=mod.AT;
  bool modelPar_given_AT=mod.given("AT");
  AdmsSensFadType modelPar_LAT=mod.LAT;
  bool modelPar_given_LAT=mod.given("LAT");
  AdmsSensFadType modelPar_WAT=mod.WAT;
  bool modelPar_given_WAT=mod.given("WAT");
  AdmsSensFadType modelPar_PAT=mod.PAT;
  bool modelPar_given_PAT=mod.given("PAT");
  AdmsSensFadType modelPar_ATL=mod.ATL;
  bool modelPar_given_ATL=mod.given("ATL");
  AdmsSensFadType modelPar_TDELTA=mod.TDELTA;
  bool modelPar_given_TDELTA=mod.given("TDELTA");
  AdmsSensFadType modelPar_PTWGT=mod.PTWGT;
  bool modelPar_given_PTWGT=mod.given("PTWGT");
  AdmsSensFadType modelPar_LPTWGT=mod.LPTWGT;
  bool modelPar_given_LPTWGT=mod.given("LPTWGT");
  AdmsSensFadType modelPar_WPTWGT=mod.WPTWGT;
  bool modelPar_given_WPTWGT=mod.given("WPTWGT");
  AdmsSensFadType modelPar_PPTWGT=mod.PPTWGT;
  bool modelPar_given_PPTWGT=mod.given("PPTWGT");
  AdmsSensFadType modelPar_PTWGTL=mod.PTWGTL;
  bool modelPar_given_PTWGTL=mod.given("PTWGTL");
  AdmsSensFadType modelPar_KT1=mod.KT1;
  bool modelPar_given_KT1=mod.given("KT1");
  AdmsSensFadType modelPar_KT1EXP=mod.KT1EXP;
  bool modelPar_given_KT1EXP=mod.given("KT1EXP");
  AdmsSensFadType modelPar_KT1L=mod.KT1L;
  bool modelPar_given_KT1L=mod.given("KT1L");
  AdmsSensFadType modelPar_LKT1=mod.LKT1;
  bool modelPar_given_LKT1=mod.given("LKT1");
  AdmsSensFadType modelPar_WKT1=mod.WKT1;
  bool modelPar_given_WKT1=mod.given("WKT1");
  AdmsSensFadType modelPar_PKT1=mod.PKT1;
  bool modelPar_given_PKT1=mod.given("PKT1");
  AdmsSensFadType modelPar_KT2=mod.KT2;
  bool modelPar_given_KT2=mod.given("KT2");
  AdmsSensFadType modelPar_LKT2=mod.LKT2;
  bool modelPar_given_LKT2=mod.given("LKT2");
  AdmsSensFadType modelPar_WKT2=mod.WKT2;
  bool modelPar_given_WKT2=mod.given("WKT2");
  AdmsSensFadType modelPar_PKT2=mod.PKT2;
  bool modelPar_given_PKT2=mod.given("PKT2");
  AdmsSensFadType modelPar_IIT=mod.IIT;
  bool modelPar_given_IIT=mod.given("IIT");
  AdmsSensFadType modelPar_LIIT=mod.LIIT;
  bool modelPar_given_LIIT=mod.given("LIIT");
  AdmsSensFadType modelPar_WIIT=mod.WIIT;
  bool modelPar_given_WIIT=mod.given("WIIT");
  AdmsSensFadType modelPar_PIIT=mod.PIIT;
  bool modelPar_given_PIIT=mod.given("PIIT");
  AdmsSensFadType modelPar_IGT=mod.IGT;
  bool modelPar_given_IGT=mod.given("IGT");
  AdmsSensFadType modelPar_LIGT=mod.LIGT;
  bool modelPar_given_LIGT=mod.given("LIGT");
  AdmsSensFadType modelPar_WIGT=mod.WIGT;
  bool modelPar_given_WIGT=mod.given("WIGT");
  AdmsSensFadType modelPar_PIGT=mod.PIGT;
  bool modelPar_given_PIGT=mod.given("PIGT");
  AdmsSensFadType modelPar_TGIDL=mod.TGIDL;
  bool modelPar_given_TGIDL=mod.given("TGIDL");
  AdmsSensFadType modelPar_LTGIDL=mod.LTGIDL;
  bool modelPar_given_LTGIDL=mod.given("LTGIDL");
  AdmsSensFadType modelPar_WTGIDL=mod.WTGIDL;
  bool modelPar_given_WTGIDL=mod.given("WTGIDL");
  AdmsSensFadType modelPar_PTGIDL=mod.PTGIDL;
  bool modelPar_given_PTGIDL=mod.given("PTGIDL");
  AdmsSensFadType modelPar_TCJ=mod.TCJ;
  bool modelPar_given_TCJ=mod.given("TCJ");
  AdmsSensFadType modelPar_TCJSW=mod.TCJSW;
  bool modelPar_given_TCJSW=mod.given("TCJSW");
  AdmsSensFadType modelPar_TCJSWG=mod.TCJSWG;
  bool modelPar_given_TCJSWG=mod.given("TCJSWG");
  AdmsSensFadType modelPar_TPB=mod.TPB;
  bool modelPar_given_TPB=mod.given("TPB");
  AdmsSensFadType modelPar_TPBSW=mod.TPBSW;
  bool modelPar_given_TPBSW=mod.given("TPBSW");
  AdmsSensFadType modelPar_TPBSWG=mod.TPBSWG;
  bool modelPar_given_TPBSWG=mod.given("TPBSWG");
  AdmsSensFadType modelPar_XTIS=mod.XTIS;
  bool modelPar_given_XTIS=mod.given("XTIS");
  AdmsSensFadType modelPar_XTID=mod.XTID;
  bool modelPar_given_XTID=mod.given("XTID");
  AdmsSensFadType modelPar_XTSS=mod.XTSS;
  bool modelPar_given_XTSS=mod.given("XTSS");
  AdmsSensFadType modelPar_XTSD=mod.XTSD;
  bool modelPar_given_XTSD=mod.given("XTSD");
  AdmsSensFadType modelPar_XTSSWS=mod.XTSSWS;
  bool modelPar_given_XTSSWS=mod.given("XTSSWS");
  AdmsSensFadType modelPar_XTSSWD=mod.XTSSWD;
  bool modelPar_given_XTSSWD=mod.given("XTSSWD");
  AdmsSensFadType modelPar_XTSSWGS=mod.XTSSWGS;
  bool modelPar_given_XTSSWGS=mod.given("XTSSWGS");
  AdmsSensFadType modelPar_XTSSWGD=mod.XTSSWGD;
  bool modelPar_given_XTSSWGD=mod.given("XTSSWGD");
  AdmsSensFadType modelPar_TNJTS=mod.TNJTS;
  bool modelPar_given_TNJTS=mod.given("TNJTS");
  AdmsSensFadType modelPar_TNJTSD=mod.TNJTSD;
  bool modelPar_given_TNJTSD=mod.given("TNJTSD");
  AdmsSensFadType modelPar_TNJTSSW=mod.TNJTSSW;
  bool modelPar_given_TNJTSSW=mod.given("TNJTSSW");
  AdmsSensFadType modelPar_TNJTSSWD=mod.TNJTSSWD;
  bool modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
  AdmsSensFadType modelPar_TNJTSSWG=mod.TNJTSSWG;
  bool modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
  AdmsSensFadType modelPar_TNJTSSWGD=mod.TNJTSSWGD;
  bool modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
  AdmsSensFadType modelPar_RTH0=mod.RTH0;
  bool modelPar_given_RTH0=mod.given("RTH0");
  AdmsSensFadType modelPar_CTH0=mod.CTH0;
  bool modelPar_given_CTH0=mod.given("CTH0");
  AdmsSensFadType modelPar_WTH0=mod.WTH0;
  bool modelPar_given_WTH0=mod.given("WTH0");
  AdmsSensFadType modelPar_SAREF=mod.SAREF;
  bool modelPar_given_SAREF=mod.given("SAREF");
  AdmsSensFadType modelPar_SBREF=mod.SBREF;
  bool modelPar_given_SBREF=mod.given("SBREF");
  AdmsSensFadType modelPar_WLOD=mod.WLOD;
  bool modelPar_given_WLOD=mod.given("WLOD");
  AdmsSensFadType modelPar_KU0=mod.KU0;
  bool modelPar_given_KU0=mod.given("KU0");
  AdmsSensFadType modelPar_KVSAT=mod.KVSAT;
  bool modelPar_given_KVSAT=mod.given("KVSAT");
  AdmsSensFadType modelPar_TKU0=mod.TKU0;
  bool modelPar_given_TKU0=mod.given("TKU0");
  AdmsSensFadType modelPar_LKU0=mod.LKU0;
  bool modelPar_given_LKU0=mod.given("LKU0");
  AdmsSensFadType modelPar_WKU0=mod.WKU0;
  bool modelPar_given_WKU0=mod.given("WKU0");
  AdmsSensFadType modelPar_PKU0=mod.PKU0;
  bool modelPar_given_PKU0=mod.given("PKU0");
  AdmsSensFadType modelPar_LLODKU0=mod.LLODKU0;
  bool modelPar_given_LLODKU0=mod.given("LLODKU0");
  AdmsSensFadType modelPar_WLODKU0=mod.WLODKU0;
  bool modelPar_given_WLODKU0=mod.given("WLODKU0");
  AdmsSensFadType modelPar_KVTH0=mod.KVTH0;
  bool modelPar_given_KVTH0=mod.given("KVTH0");
  AdmsSensFadType modelPar_LKVTH0=mod.LKVTH0;
  bool modelPar_given_LKVTH0=mod.given("LKVTH0");
  AdmsSensFadType modelPar_WKVTH0=mod.WKVTH0;
  bool modelPar_given_WKVTH0=mod.given("WKVTH0");
  AdmsSensFadType modelPar_PKVTH0=mod.PKVTH0;
  bool modelPar_given_PKVTH0=mod.given("PKVTH0");
  AdmsSensFadType modelPar_LLODVTH=mod.LLODVTH;
  bool modelPar_given_LLODVTH=mod.given("LLODVTH");
  AdmsSensFadType modelPar_WLODVTH=mod.WLODVTH;
  bool modelPar_given_WLODVTH=mod.given("WLODVTH");
  AdmsSensFadType modelPar_STK2=mod.STK2;
  bool modelPar_given_STK2=mod.given("STK2");
  AdmsSensFadType modelPar_LODK2=mod.LODK2;
  bool modelPar_given_LODK2=mod.given("LODK2");
  AdmsSensFadType modelPar_STETA0=mod.STETA0;
  bool modelPar_given_STETA0=mod.given("STETA0");
  AdmsSensFadType modelPar_LODETA0=mod.LODETA0;
  bool modelPar_given_LODETA0=mod.given("LODETA0");
  AdmsSensFadType modelPar_WEB=mod.WEB;
  bool modelPar_given_WEB=mod.given("WEB");
  AdmsSensFadType modelPar_WEC=mod.WEC;
  bool modelPar_given_WEC=mod.given("WEC");
  AdmsSensFadType modelPar_KVTH0WE=mod.KVTH0WE;
  bool modelPar_given_KVTH0WE=mod.given("KVTH0WE");
  AdmsSensFadType modelPar_LKVTH0WE=mod.LKVTH0WE;
  bool modelPar_given_LKVTH0WE=mod.given("LKVTH0WE");
  AdmsSensFadType modelPar_WKVTH0WE=mod.WKVTH0WE;
  bool modelPar_given_WKVTH0WE=mod.given("WKVTH0WE");
  AdmsSensFadType modelPar_PKVTH0WE=mod.PKVTH0WE;
  bool modelPar_given_PKVTH0WE=mod.given("PKVTH0WE");
  AdmsSensFadType modelPar_K2WE=mod.K2WE;
  bool modelPar_given_K2WE=mod.given("K2WE");
  AdmsSensFadType modelPar_LK2WE=mod.LK2WE;
  bool modelPar_given_LK2WE=mod.given("LK2WE");
  AdmsSensFadType modelPar_WK2WE=mod.WK2WE;
  bool modelPar_given_WK2WE=mod.given("WK2WE");
  AdmsSensFadType modelPar_PK2WE=mod.PK2WE;
  bool modelPar_given_PK2WE=mod.given("PK2WE");
  AdmsSensFadType modelPar_KU0WE=mod.KU0WE;
  bool modelPar_given_KU0WE=mod.given("KU0WE");
  AdmsSensFadType modelPar_LKU0WE=mod.LKU0WE;
  bool modelPar_given_LKU0WE=mod.given("LKU0WE");
  AdmsSensFadType modelPar_WKU0WE=mod.WKU0WE;
  bool modelPar_given_WKU0WE=mod.given("WKU0WE");
  AdmsSensFadType modelPar_PKU0WE=mod.PKU0WE;
  bool modelPar_given_PKU0WE=mod.given("PKU0WE");
  AdmsSensFadType modelPar_SCREF=mod.SCREF;
  bool modelPar_given_SCREF=mod.given("SCREF");
  AdmsSensFadType modelPar_WEDGE=mod.WEDGE;
  bool modelPar_given_WEDGE=mod.given("WEDGE");
  AdmsSensFadType modelPar_DGAMMAEDGE=mod.DGAMMAEDGE;
  bool modelPar_given_DGAMMAEDGE=mod.given("DGAMMAEDGE");
  AdmsSensFadType modelPar_DGAMMAEDGEL=mod.DGAMMAEDGEL;
  bool modelPar_given_DGAMMAEDGEL=mod.given("DGAMMAEDGEL");
  AdmsSensFadType modelPar_DGAMMAEDGELEXP=mod.DGAMMAEDGELEXP;
  bool modelPar_given_DGAMMAEDGELEXP=mod.given("DGAMMAEDGELEXP");
  AdmsSensFadType modelPar_DVTEDGE=mod.DVTEDGE;
  bool modelPar_given_DVTEDGE=mod.given("DVTEDGE");
  AdmsSensFadType modelPar_NFACTOREDGE=mod.NFACTOREDGE;
  bool modelPar_given_NFACTOREDGE=mod.given("NFACTOREDGE");
  AdmsSensFadType modelPar_CITEDGE=mod.CITEDGE;
  bool modelPar_given_CITEDGE=mod.given("CITEDGE");
  AdmsSensFadType modelPar_CDSCDEDGE=mod.CDSCDEDGE;
  bool modelPar_given_CDSCDEDGE=mod.given("CDSCDEDGE");
  AdmsSensFadType modelPar_CDSCBEDGE=mod.CDSCBEDGE;
  bool modelPar_given_CDSCBEDGE=mod.given("CDSCBEDGE");
  AdmsSensFadType modelPar_ETA0EDGE=mod.ETA0EDGE;
  bool modelPar_given_ETA0EDGE=mod.given("ETA0EDGE");
  AdmsSensFadType modelPar_ETABEDGE=mod.ETABEDGE;
  bool modelPar_given_ETABEDGE=mod.given("ETABEDGE");
  AdmsSensFadType modelPar_KT1EDGE=mod.KT1EDGE;
  bool modelPar_given_KT1EDGE=mod.given("KT1EDGE");
  AdmsSensFadType modelPar_KT1LEDGE=mod.KT1LEDGE;
  bool modelPar_given_KT1LEDGE=mod.given("KT1LEDGE");
  AdmsSensFadType modelPar_KT2EDGE=mod.KT2EDGE;
  bool modelPar_given_KT2EDGE=mod.given("KT2EDGE");
  AdmsSensFadType modelPar_KT1EXPEDGE=mod.KT1EXPEDGE;
  bool modelPar_given_KT1EXPEDGE=mod.given("KT1EXPEDGE");
  AdmsSensFadType modelPar_TNFACTOREDGE=mod.TNFACTOREDGE;
  bool modelPar_given_TNFACTOREDGE=mod.given("TNFACTOREDGE");
  AdmsSensFadType modelPar_TETA0EDGE=mod.TETA0EDGE;
  bool modelPar_given_TETA0EDGE=mod.given("TETA0EDGE");
  AdmsSensFadType modelPar_DVT0EDGE=mod.DVT0EDGE;
  bool modelPar_given_DVT0EDGE=mod.given("DVT0EDGE");
  AdmsSensFadType modelPar_DVT1EDGE=mod.DVT1EDGE;
  bool modelPar_given_DVT1EDGE=mod.given("DVT1EDGE");
  AdmsSensFadType modelPar_DVT2EDGE=mod.DVT2EDGE;
  bool modelPar_given_DVT2EDGE=mod.given("DVT2EDGE");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_NGCON=mod.NGCON;
  bool modelPar_given_NGCON=mod.given("NGCON");
  int modelPar_RGATEMOD=mod.RGATEMOD;
  bool modelPar_given_RGATEMOD=mod.given("RGATEMOD");
  int modelPar_RBODYMOD=mod.RBODYMOD;
  bool modelPar_given_RBODYMOD=mod.given("RBODYMOD");
  int modelPar_GEOMOD=mod.GEOMOD;
  bool modelPar_given_GEOMOD=mod.given("GEOMOD");
  int modelPar_RGEOMOD=mod.RGEOMOD;
  bool modelPar_given_RGEOMOD=mod.given("RGEOMOD");
  int modelPar_SCA=mod.SCA;
  bool modelPar_given_SCA=mod.given("SCA");
  int modelPar_SCB=mod.SCB;
  bool modelPar_given_SCB=mod.given("SCB");
  int modelPar_SCC=mod.SCC;
  bool modelPar_given_SCC=mod.given("SCC");
  int modelPar_SC=mod.SC;
  bool modelPar_given_SC=mod.given("SC");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  int modelPar_CVMOD=mod.CVMOD;
  bool modelPar_given_CVMOD=mod.given("CVMOD");
  int modelPar_COVMOD=mod.COVMOD;
  bool modelPar_given_COVMOD=mod.given("COVMOD");
  int modelPar_RDSMOD=mod.RDSMOD;
  bool modelPar_given_RDSMOD=mod.given("RDSMOD");
  int modelPar_WPEMOD=mod.WPEMOD;
  bool modelPar_given_WPEMOD=mod.given("WPEMOD");
  int modelPar_ASYMMOD=mod.ASYMMOD;
  bool modelPar_given_ASYMMOD=mod.given("ASYMMOD");
  int modelPar_GIDLMOD=mod.GIDLMOD;
  bool modelPar_given_GIDLMOD=mod.given("GIDLMOD");
  int modelPar_IGCMOD=mod.IGCMOD;
  bool modelPar_given_IGCMOD=mod.given("IGCMOD");
  int modelPar_IGBMOD=mod.IGBMOD;
  bool modelPar_given_IGBMOD=mod.given("IGBMOD");
  int modelPar_TNOIMOD=mod.TNOIMOD;
  bool modelPar_given_TNOIMOD=mod.given("TNOIMOD");
  int modelPar_SHMOD=mod.SHMOD;
  bool modelPar_given_SHMOD=mod.given("SHMOD");
  int modelPar_MOBSCALE=mod.MOBSCALE;
  bool modelPar_given_MOBSCALE=mod.given("MOBSCALE");
  int modelPar_PERMOD=mod.PERMOD;
  bool modelPar_given_PERMOD=mod.given("PERMOD");
  int modelPar_BINUNIT=mod.BINUNIT;
  bool modelPar_given_BINUNIT=mod.given("BINUNIT");
  int modelPar_EDGEFET=mod.EDGEFET;
  bool modelPar_given_EDGEFET=mod.given("EDGEFET");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_L=in.L;
  bool instancePar_given_L=in.given("L");
  inParamMap["L"] = &instancePar_L;
  AdmsSensFadType instancePar_W=in.W;
  bool instancePar_given_W=in.given("W");
  inParamMap["W"] = &instancePar_W;
  AdmsSensFadType instancePar_NRS=in.NRS;
  bool instancePar_given_NRS=in.given("NRS");
  inParamMap["NRS"] = &instancePar_NRS;
  AdmsSensFadType instancePar_NRD=in.NRD;
  bool instancePar_given_NRD=in.given("NRD");
  inParamMap["NRD"] = &instancePar_NRD;
  AdmsSensFadType instancePar_VFBSDOFF=in.VFBSDOFF;
  bool instancePar_given_VFBSDOFF=in.given("VFBSDOFF");
  inParamMap["VFBSDOFF"] = &instancePar_VFBSDOFF;
  AdmsSensFadType instancePar_XGW=in.XGW;
  bool instancePar_given_XGW=in.given("XGW");
  inParamMap["XGW"] = &instancePar_XGW;
  AdmsSensFadType instancePar_RBPB=in.RBPB;
  bool instancePar_given_RBPB=in.given("RBPB");
  inParamMap["RBPB"] = &instancePar_RBPB;
  AdmsSensFadType instancePar_RBPD=in.RBPD;
  bool instancePar_given_RBPD=in.given("RBPD");
  inParamMap["RBPD"] = &instancePar_RBPD;
  AdmsSensFadType instancePar_RBPS=in.RBPS;
  bool instancePar_given_RBPS=in.given("RBPS");
  inParamMap["RBPS"] = &instancePar_RBPS;
  AdmsSensFadType instancePar_RBDB=in.RBDB;
  bool instancePar_given_RBDB=in.given("RBDB");
  inParamMap["RBDB"] = &instancePar_RBDB;
  AdmsSensFadType instancePar_RBSB=in.RBSB;
  bool instancePar_given_RBSB=in.given("RBSB");
  inParamMap["RBSB"] = &instancePar_RBSB;
  AdmsSensFadType instancePar_SA=in.SA;
  bool instancePar_given_SA=in.given("SA");
  inParamMap["SA"] = &instancePar_SA;
  AdmsSensFadType instancePar_SB=in.SB;
  bool instancePar_given_SB=in.given("SB");
  inParamMap["SB"] = &instancePar_SB;
  AdmsSensFadType instancePar_SD=in.SD;
  bool instancePar_given_SD=in.given("SD");
  inParamMap["SD"] = &instancePar_SD;
  AdmsSensFadType instancePar_AS=in.AS;
  bool instancePar_given_AS=in.given("AS");
  inParamMap["AS"] = &instancePar_AS;
  AdmsSensFadType instancePar_AD=in.AD;
  bool instancePar_given_AD=in.given("AD");
  inParamMap["AD"] = &instancePar_AD;
  AdmsSensFadType instancePar_PS=in.PS;
  bool instancePar_given_PS=in.given("PS");
  inParamMap["PS"] = &instancePar_PS;
  AdmsSensFadType instancePar_PD=in.PD;
  bool instancePar_given_PD=in.given("PD");
  inParamMap["PD"] = &instancePar_PD;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:
  int instancePar_NF=in.NF;
  bool instancePar_given_NF=in.given("NF");
  int instancePar_MINZ=in.MINZ;
  bool instancePar_given_MINZ=in.given("MINZ");
  int instancePar_NGCON=in.NGCON;
  bool instancePar_given_NGCON=in.given("NGCON");
  int instancePar_RGATEMOD=in.RGATEMOD;
  bool instancePar_given_RGATEMOD=in.given("RGATEMOD");
  int instancePar_RBODYMOD=in.RBODYMOD;
  bool instancePar_given_RBODYMOD=in.given("RBODYMOD");
  int instancePar_GEOMOD=in.GEOMOD;
  bool instancePar_given_GEOMOD=in.given("GEOMOD");
  int instancePar_RGEOMOD=in.RGEOMOD;
  bool instancePar_given_RGEOMOD=in.given("RGEOMOD");
  int instancePar_SCA=in.SCA;
  bool instancePar_given_SCA=in.given("SCA");
  int instancePar_SCB=in.SCB;
  bool instancePar_given_SCB=in.given("SCB");
  int instancePar_SCC=in.SCC;
  bool instancePar_given_SCC=in.given("SCC");
  int instancePar_SC=in.SC;
  bool instancePar_given_SC=in.given("SC");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_T0=in.T0;
  AdmsSensFadType instanceVar_T1=in.T1;
  AdmsSensFadType instanceVar_T2=in.T2;
  AdmsSensFadType instanceVar_epssi=in.epssi;
  AdmsSensFadType instanceVar_epsox=in.epsox;
  AdmsSensFadType instanceVar_Weff=in.Weff;
  AdmsSensFadType instanceVar_Leff=in.Leff;
  AdmsSensFadType instanceVar_Wact=in.Wact;
  AdmsSensFadType instanceVar_Lact=in.Lact;
  AdmsSensFadType instanceVar_Weffcj=in.Weffcj;
  AdmsSensFadType instanceVar_Cox=in.Cox;
  AdmsSensFadType instanceVar_epsratio=in.epsratio;
  AdmsSensFadType instanceVar_Lnew=in.Lnew;
  AdmsSensFadType instanceVar_L_mult=in.L_mult;
  AdmsSensFadType instanceVar_Wnew=in.Wnew;
  AdmsSensFadType instanceVar_DVTP0_i=in.DVTP0_i;
  AdmsSensFadType instanceVar_DVTP1_i=in.DVTP1_i;
  AdmsSensFadType instanceVar_DVTP2_i=in.DVTP2_i;
  AdmsSensFadType instanceVar_DVTP3_i=in.DVTP3_i;
  AdmsSensFadType instanceVar_DVTP4_i=in.DVTP4_i;
  AdmsSensFadType instanceVar_DVTP5_i=in.DVTP5_i;
  AdmsSensFadType instanceVar_A1_i=in.A1_i;
  AdmsSensFadType instanceVar_A11_i=in.A11_i;
  AdmsSensFadType instanceVar_A2_i=in.A2_i;
  AdmsSensFadType instanceVar_A21_i=in.A21_i;
  AdmsSensFadType instanceVar_PSAT_i=in.PSAT_i;
  AdmsSensFadType instanceVar_PSATR_i=in.PSATR_i;
  AdmsSensFadType instanceVar_BSIM6TOXP=in.BSIM6TOXP;
  AdmsSensFadType instanceVar_DMCGeff=in.DMCGeff;
  AdmsSensFadType instanceVar_DMDGeff=in.DMDGeff;
  AdmsSensFadType instanceVar_DMCIeff=in.DMCIeff;
  AdmsSensFadType instanceVar_RSourceGeo=in.RSourceGeo;
  AdmsSensFadType instanceVar_RDrainGeo=in.RDrainGeo;
  AdmsSensFadType instanceVar_Grgeltd=in.Grgeltd;
  AdmsSensFadType instanceVar_Grbsb=in.Grbsb;
  AdmsSensFadType instanceVar_Grbdb=in.Grbdb;
  AdmsSensFadType instanceVar_Grbpb=in.Grbpb;
  AdmsSensFadType instanceVar_Grbps=in.Grbps;
  AdmsSensFadType instanceVar_Grbpd=in.Grbpd;
  AdmsSensFadType instanceVar_Aechvb=in.Aechvb;
  AdmsSensFadType instanceVar_Bechvb=in.Bechvb;
  AdmsSensFadType instanceVar_AechvbEdge=in.AechvbEdge;
  AdmsSensFadType instanceVar_BechvbEdge=in.BechvbEdge;
  AdmsSensFadType instanceVar_ToxRatio=in.ToxRatio;
  AdmsSensFadType instanceVar_U0R_t=in.U0R_t;
  AdmsSensFadType instanceVar_UAR_t=in.UAR_t;
  AdmsSensFadType instanceVar_UCR_t=in.UCR_t;
  AdmsSensFadType instanceVar_UDR_t=in.UDR_t;
  AdmsSensFadType instanceVar_UCSR_t=in.UCSR_t;
  AdmsSensFadType instanceVar_VSATR_t=in.VSATR_t;
  AdmsSensFadType instanceVar_PTWGR_t=in.PTWGR_t;
  AdmsSensFadType instanceVar_ETA0R_t=in.ETA0R_t;
  AdmsSensFadType instanceVar_PSATB_i=in.PSATB_i;
  AdmsSensFadType instanceVar_KT1_i=in.KT1_i;
  AdmsSensFadType instanceVar_KT2_i=in.KT2_i;
  AdmsSensFadType instanceVar_NGATE_i=in.NGATE_i;
  AdmsSensFadType instanceVar_NSD_i=in.NSD_i;
  AdmsSensFadType instanceVar_NDEP_i=in.NDEP_i;
  AdmsSensFadType instanceVar_VFB_i=in.VFB_i;
  AdmsSensFadType instanceVar_CIT_i=in.CIT_i;
  AdmsSensFadType instanceVar_CDSCD_i=in.CDSCD_i;
  AdmsSensFadType instanceVar_CDSCDR_i=in.CDSCDR_i;
  AdmsSensFadType instanceVar_CDSCB_i=in.CDSCB_i;
  AdmsSensFadType instanceVar_NFACTOR_i=in.NFACTOR_i;
  AdmsSensFadType instanceVar_PHIN_i=in.PHIN_i;
  AdmsSensFadType instanceVar_ETA0_i=in.ETA0_i;
  AdmsSensFadType instanceVar_ETA0R_i=in.ETA0R_i;
  AdmsSensFadType instanceVar_ETAB_i=in.ETAB_i;
  AdmsSensFadType instanceVar_K2_i=in.K2_i;
  AdmsSensFadType instanceVar_K1_i=in.K1_i;
  AdmsSensFadType instanceVar_DELTA_i=in.DELTA_i;
  AdmsSensFadType instanceVar_U0_i=in.U0_i;
  AdmsSensFadType instanceVar_U0R_i=in.U0R_i;
  AdmsSensFadType instanceVar_VSAT_i=in.VSAT_i;
  AdmsSensFadType instanceVar_VSATR_i=in.VSATR_i;
  AdmsSensFadType instanceVar_VSATCV_i=in.VSATCV_i;
  AdmsSensFadType instanceVar_UA_i=in.UA_i;
  AdmsSensFadType instanceVar_UAR_i=in.UAR_i;
  AdmsSensFadType instanceVar_EU_i=in.EU_i;
  AdmsSensFadType instanceVar_UD_i=in.UD_i;
  AdmsSensFadType instanceVar_UDR_i=in.UDR_i;
  AdmsSensFadType instanceVar_UD_a=in.UD_a;
  AdmsSensFadType instanceVar_UCS_i=in.UCS_i;
  AdmsSensFadType instanceVar_UCSR_i=in.UCSR_i;
  AdmsSensFadType instanceVar_UC_i=in.UC_i;
  AdmsSensFadType instanceVar_UCR_i=in.UCR_i;
  AdmsSensFadType instanceVar_PDIBLC_i=in.PDIBLC_i;
  AdmsSensFadType instanceVar_PDIBLCR_i=in.PDIBLCR_i;
  AdmsSensFadType instanceVar_PDIBLCB_i=in.PDIBLCB_i;
  AdmsSensFadType instanceVar_PSCBE1_i=in.PSCBE1_i;
  AdmsSensFadType instanceVar_PSCBE2_i=in.PSCBE2_i;
  AdmsSensFadType instanceVar_PDITS_i=in.PDITS_i;
  AdmsSensFadType instanceVar_PDITSD_i=in.PDITSD_i;
  AdmsSensFadType instanceVar_FPROUT_i=in.FPROUT_i;
  AdmsSensFadType instanceVar_PRWG_i=in.PRWG_i;
  AdmsSensFadType instanceVar_WR_i=in.WR_i;
  AdmsSensFadType instanceVar_RDWMIN_i=in.RDWMIN_i;
  AdmsSensFadType instanceVar_RSWMIN_i=in.RSWMIN_i;
  AdmsSensFadType instanceVar_RDW_i=in.RDW_i;
  AdmsSensFadType instanceVar_RSW_i=in.RSW_i;
  AdmsSensFadType instanceVar_RDSW_i=in.RDSW_i;
  AdmsSensFadType instanceVar_RDSWMIN_i=in.RDSWMIN_i;
  AdmsSensFadType instanceVar_PTWG_i=in.PTWG_i;
  AdmsSensFadType instanceVar_PTWGR_i=in.PTWGR_i;
  AdmsSensFadType instanceVar_PVAG_i=in.PVAG_i;
  AdmsSensFadType instanceVar_XJ_i=in.XJ_i;
  AdmsSensFadType instanceVar_PCLM_i=in.PCLM_i;
  AdmsSensFadType instanceVar_PCLMR_i=in.PCLMR_i;
  AdmsSensFadType instanceVar_PCLMCV_i=in.PCLMCV_i;
  AdmsSensFadType instanceVar_PRWB_i=in.PRWB_i;
  AdmsSensFadType instanceVar_CF_i=in.CF_i;
  AdmsSensFadType instanceVar_CGSL_i=in.CGSL_i;
  AdmsSensFadType instanceVar_CGDL_i=in.CGDL_i;
  AdmsSensFadType instanceVar_CKAPPAS_i=in.CKAPPAS_i;
  AdmsSensFadType instanceVar_CKAPPAD_i=in.CKAPPAD_i;
  AdmsSensFadType instanceVar_VFBCV_i=in.VFBCV_i;
  AdmsSensFadType instanceVar_NDEPCV_i=in.NDEPCV_i;
  AdmsSensFadType instanceVar_ALPHA0_i=in.ALPHA0_i;
  AdmsSensFadType instanceVar_BETA0_i=in.BETA0_i;
  AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
  AdmsSensFadType instanceVar_BGIDL_i=in.BGIDL_i;
  AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
  AdmsSensFadType instanceVar_EGIDL_i=in.EGIDL_i;
  AdmsSensFadType instanceVar_AGISL_i=in.AGISL_i;
  AdmsSensFadType instanceVar_BGISL_i=in.BGISL_i;
  AdmsSensFadType instanceVar_CGISL_i=in.CGISL_i;
  AdmsSensFadType instanceVar_EGISL_i=in.EGISL_i;
  AdmsSensFadType instanceVar_UTE_i=in.UTE_i;
  AdmsSensFadType instanceVar_UA1_i=in.UA1_i;
  AdmsSensFadType instanceVar_UC1_i=in.UC1_i;
  AdmsSensFadType instanceVar_UD1_i=in.UD1_i;
  AdmsSensFadType instanceVar_UCSTE_i=in.UCSTE_i;
  AdmsSensFadType instanceVar_PRT_i=in.PRT_i;
  AdmsSensFadType instanceVar_AT_i=in.AT_i;
  AdmsSensFadType instanceVar_PTWGT_i=in.PTWGT_i;
  AdmsSensFadType instanceVar_IIT_i=in.IIT_i;
  AdmsSensFadType instanceVar_TGIDL_i=in.TGIDL_i;
  AdmsSensFadType instanceVar_KVTH0WE_i=in.KVTH0WE_i;
  AdmsSensFadType instanceVar_K2WE_i=in.K2WE_i;
  AdmsSensFadType instanceVar_KU0WE_i=in.KU0WE_i;
  AdmsSensFadType instanceVar_AIGBINV_i=in.AIGBINV_i;
  AdmsSensFadType instanceVar_BIGBINV_i=in.BIGBINV_i;
  AdmsSensFadType instanceVar_CIGBINV_i=in.CIGBINV_i;
  AdmsSensFadType instanceVar_EIGBINV_i=in.EIGBINV_i;
  AdmsSensFadType instanceVar_NIGBINV_i=in.NIGBINV_i;
  AdmsSensFadType instanceVar_AIGBACC_i=in.AIGBACC_i;
  AdmsSensFadType instanceVar_BIGBACC_i=in.BIGBACC_i;
  AdmsSensFadType instanceVar_CIGBACC_i=in.CIGBACC_i;
  AdmsSensFadType instanceVar_NIGBACC_i=in.NIGBACC_i;
  AdmsSensFadType instanceVar_AIGC_i=in.AIGC_i;
  AdmsSensFadType instanceVar_BIGC_i=in.BIGC_i;
  AdmsSensFadType instanceVar_CIGC_i=in.CIGC_i;
  AdmsSensFadType instanceVar_AIGS_i=in.AIGS_i;
  AdmsSensFadType instanceVar_BIGS_i=in.BIGS_i;
  AdmsSensFadType instanceVar_CIGS_i=in.CIGS_i;
  AdmsSensFadType instanceVar_AIGD_i=in.AIGD_i;
  AdmsSensFadType instanceVar_BIGD_i=in.BIGD_i;
  AdmsSensFadType instanceVar_CIGD_i=in.CIGD_i;
  AdmsSensFadType instanceVar_PIGCD_i=in.PIGCD_i;
  AdmsSensFadType instanceVar_DLCIG_i=in.DLCIG_i;
  AdmsSensFadType instanceVar_DLCIGD_i=in.DLCIGD_i;
  AdmsSensFadType instanceVar_IGT_i=in.IGT_i;
  AdmsSensFadType instanceVar_nuIntD=in.nuIntD;
  AdmsSensFadType instanceVar_nuEndD=in.nuEndD;
  AdmsSensFadType instanceVar_nuIntS=in.nuIntS;
  AdmsSensFadType instanceVar_nuEndS=in.nuEndS;
  AdmsSensFadType instanceVar_gth=in.gth;
  AdmsSensFadType instanceVar_cth=in.cth;


  //non-reals
  int instanceVar_devsign=in.devsign;


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_bi_dbulk] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_dbulk];
  probeVars[in.admsProbeID_V_b_dbulk] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_dbulk];
  probeVars[in.admsProbeID_V_b_bi] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_b_sbulk] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_sbulk];
  probeVars[in.admsProbeID_V_bi_sbulk] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_sbulk];
  probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_gm_gi] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_gi];
  probeVars[in.admsProbeID_V_g_gm] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_gm];
  probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_gm_bi] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_N1_GND] = (*solVectorPtr)[in.li_N1];
  probeVars[in.admsProbeID_V_N2_GND] = (*solVectorPtr)[in.li_N2];
  probeVars[in.admsProbeID_V_gm_si] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_gm_di] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_dbulk_di] = (*solVectorPtr)[in.li_dbulk]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_sbulk_si] = (*solVectorPtr)[in.li_sbulk]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_si_bi] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_di_bi] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_gi_bi] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_Temp_t_GND] = (in.collapseNode_t)?(0):((*solVectorPtr)[in.li_t]);


  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     instancePar_NRS,
     instancePar_given_NRS,
     instancePar_NRD,
     instancePar_given_NRD,
     instancePar_VFBSDOFF,
     instancePar_given_VFBSDOFF,
     instancePar_XGW,
     instancePar_given_XGW,
     instancePar_RBPB,
     instancePar_given_RBPB,
     instancePar_RBPD,
     instancePar_given_RBPD,
     instancePar_RBPS,
     instancePar_given_RBPS,
     instancePar_RBDB,
     instancePar_given_RBDB,
     instancePar_RBSB,
     instancePar_given_RBSB,
     instancePar_SA,
     instancePar_given_SA,
     instancePar_SB,
     instancePar_given_SB,
     instancePar_SD,
     instancePar_given_SD,
     instancePar_AS,
     instancePar_given_AS,
     instancePar_AD,
     instancePar_given_AD,
     instancePar_PS,
     instancePar_given_PS,
     instancePar_PD,
     instancePar_given_PD,
     // non-reals(including hidden)
     instancePar_NF,
     instancePar_given_NF,
     instancePar_MINZ,
     instancePar_given_MINZ,
     instancePar_NGCON,
     instancePar_given_NGCON,
     instancePar_RGATEMOD,
     instancePar_given_RGATEMOD,
     instancePar_RBODYMOD,
     instancePar_given_RBODYMOD,
     instancePar_GEOMOD,
     instancePar_given_GEOMOD,
     instancePar_RGEOMOD,
     instancePar_given_RGEOMOD,
     instancePar_SCA,
     instancePar_given_SCA,
     instancePar_SCB,
     instancePar_given_SCB,
     instancePar_SCC,
     instancePar_given_SCC,
     instancePar_SC,
     instancePar_given_SC,
     // instance variables
     // reals
     instanceVar_T0,
     instanceVar_T1,
     instanceVar_T2,
     instanceVar_epssi,
     instanceVar_epsox,
     instanceVar_Weff,
     instanceVar_Leff,
     instanceVar_Wact,
     instanceVar_Lact,
     instanceVar_Weffcj,
     instanceVar_Cox,
     instanceVar_epsratio,
     instanceVar_Lnew,
     instanceVar_L_mult,
     instanceVar_Wnew,
     instanceVar_DVTP0_i,
     instanceVar_DVTP1_i,
     instanceVar_DVTP2_i,
     instanceVar_DVTP3_i,
     instanceVar_DVTP4_i,
     instanceVar_DVTP5_i,
     instanceVar_A1_i,
     instanceVar_A11_i,
     instanceVar_A2_i,
     instanceVar_A21_i,
     instanceVar_PSAT_i,
     instanceVar_PSATR_i,
     instanceVar_BSIM6TOXP,
     instanceVar_DMCGeff,
     instanceVar_DMDGeff,
     instanceVar_DMCIeff,
     instanceVar_RSourceGeo,
     instanceVar_RDrainGeo,
     instanceVar_Grgeltd,
     instanceVar_Grbsb,
     instanceVar_Grbdb,
     instanceVar_Grbpb,
     instanceVar_Grbps,
     instanceVar_Grbpd,
     instanceVar_Aechvb,
     instanceVar_Bechvb,
     instanceVar_AechvbEdge,
     instanceVar_BechvbEdge,
     instanceVar_ToxRatio,
     instanceVar_U0R_t,
     instanceVar_UAR_t,
     instanceVar_UCR_t,
     instanceVar_UDR_t,
     instanceVar_UCSR_t,
     instanceVar_VSATR_t,
     instanceVar_PTWGR_t,
     instanceVar_ETA0R_t,
     instanceVar_PSATB_i,
     instanceVar_KT1_i,
     instanceVar_KT2_i,
     instanceVar_NGATE_i,
     instanceVar_NSD_i,
     instanceVar_NDEP_i,
     instanceVar_VFB_i,
     instanceVar_CIT_i,
     instanceVar_CDSCD_i,
     instanceVar_CDSCDR_i,
     instanceVar_CDSCB_i,
     instanceVar_NFACTOR_i,
     instanceVar_PHIN_i,
     instanceVar_ETA0_i,
     instanceVar_ETA0R_i,
     instanceVar_ETAB_i,
     instanceVar_K2_i,
     instanceVar_K1_i,
     instanceVar_DELTA_i,
     instanceVar_U0_i,
     instanceVar_U0R_i,
     instanceVar_VSAT_i,
     instanceVar_VSATR_i,
     instanceVar_VSATCV_i,
     instanceVar_UA_i,
     instanceVar_UAR_i,
     instanceVar_EU_i,
     instanceVar_UD_i,
     instanceVar_UDR_i,
     instanceVar_UD_a,
     instanceVar_UCS_i,
     instanceVar_UCSR_i,
     instanceVar_UC_i,
     instanceVar_UCR_i,
     instanceVar_PDIBLC_i,
     instanceVar_PDIBLCR_i,
     instanceVar_PDIBLCB_i,
     instanceVar_PSCBE1_i,
     instanceVar_PSCBE2_i,
     instanceVar_PDITS_i,
     instanceVar_PDITSD_i,
     instanceVar_FPROUT_i,
     instanceVar_PRWG_i,
     instanceVar_WR_i,
     instanceVar_RDWMIN_i,
     instanceVar_RSWMIN_i,
     instanceVar_RDW_i,
     instanceVar_RSW_i,
     instanceVar_RDSW_i,
     instanceVar_RDSWMIN_i,
     instanceVar_PTWG_i,
     instanceVar_PTWGR_i,
     instanceVar_PVAG_i,
     instanceVar_XJ_i,
     instanceVar_PCLM_i,
     instanceVar_PCLMR_i,
     instanceVar_PCLMCV_i,
     instanceVar_PRWB_i,
     instanceVar_CF_i,
     instanceVar_CGSL_i,
     instanceVar_CGDL_i,
     instanceVar_CKAPPAS_i,
     instanceVar_CKAPPAD_i,
     instanceVar_VFBCV_i,
     instanceVar_NDEPCV_i,
     instanceVar_ALPHA0_i,
     instanceVar_BETA0_i,
     instanceVar_AGIDL_i,
     instanceVar_BGIDL_i,
     instanceVar_CGIDL_i,
     instanceVar_EGIDL_i,
     instanceVar_AGISL_i,
     instanceVar_BGISL_i,
     instanceVar_CGISL_i,
     instanceVar_EGISL_i,
     instanceVar_UTE_i,
     instanceVar_UA1_i,
     instanceVar_UC1_i,
     instanceVar_UD1_i,
     instanceVar_UCSTE_i,
     instanceVar_PRT_i,
     instanceVar_AT_i,
     instanceVar_PTWGT_i,
     instanceVar_IIT_i,
     instanceVar_TGIDL_i,
     instanceVar_KVTH0WE_i,
     instanceVar_K2WE_i,
     instanceVar_KU0WE_i,
     instanceVar_AIGBINV_i,
     instanceVar_BIGBINV_i,
     instanceVar_CIGBINV_i,
     instanceVar_EIGBINV_i,
     instanceVar_NIGBINV_i,
     instanceVar_AIGBACC_i,
     instanceVar_BIGBACC_i,
     instanceVar_CIGBACC_i,
     instanceVar_NIGBACC_i,
     instanceVar_AIGC_i,
     instanceVar_BIGC_i,
     instanceVar_CIGC_i,
     instanceVar_AIGS_i,
     instanceVar_BIGS_i,
     instanceVar_CIGS_i,
     instanceVar_AIGD_i,
     instanceVar_BIGD_i,
     instanceVar_CIGD_i,
     instanceVar_PIGCD_i,
     instanceVar_DLCIG_i,
     instanceVar_DLCIGD_i,
     instanceVar_IGT_i,
     instanceVar_nuIntD,
     instanceVar_nuEndD,
     instanceVar_nuIntS,
     instanceVar_nuEndS,
     instanceVar_gth,
     instanceVar_cth,
     // non-reals
     instanceVar_devsign,
     // model parameters
     // reals
     modelPar_L,
     modelPar_given_L,
     modelPar_VFBSDOFF,
     modelPar_given_VFBSDOFF,
     modelPar_XGW,
     modelPar_given_XGW,
     modelPar_RBPB,
     modelPar_given_RBPB,
     modelPar_RBPD,
     modelPar_given_RBPD,
     modelPar_RBPS,
     modelPar_given_RBPS,
     modelPar_RBDB,
     modelPar_given_RBDB,
     modelPar_RBSB,
     modelPar_given_RBSB,
     modelPar_SA,
     modelPar_given_SA,
     modelPar_SB,
     modelPar_given_SB,
     modelPar_SD,
     modelPar_given_SD,
     modelPar_LLONG,
     modelPar_given_LLONG,
     modelPar_LMLT,
     modelPar_given_LMLT,
     modelPar_WMLT,
     modelPar_given_WMLT,
     modelPar_XL,
     modelPar_given_XL,
     modelPar_WWIDE,
     modelPar_given_WWIDE,
     modelPar_XW,
     modelPar_given_XW,
     modelPar_LINT,
     modelPar_given_LINT,
     modelPar_LL,
     modelPar_given_LL,
     modelPar_LW,
     modelPar_given_LW,
     modelPar_LWL,
     modelPar_given_LWL,
     modelPar_LLN,
     modelPar_given_LLN,
     modelPar_LWN,
     modelPar_given_LWN,
     modelPar_WINT,
     modelPar_given_WINT,
     modelPar_WL,
     modelPar_given_WL,
     modelPar_WW,
     modelPar_given_WW,
     modelPar_WWL,
     modelPar_given_WWL,
     modelPar_WLN,
     modelPar_given_WLN,
     modelPar_WWN,
     modelPar_given_WWN,
     modelPar_DLC,
     modelPar_given_DLC,
     modelPar_LLC,
     modelPar_given_LLC,
     modelPar_LWC,
     modelPar_given_LWC,
     modelPar_LWLC,
     modelPar_given_LWLC,
     modelPar_DWC,
     modelPar_given_DWC,
     modelPar_WLC,
     modelPar_given_WLC,
     modelPar_WWC,
     modelPar_given_WWC,
     modelPar_WWLC,
     modelPar_given_WWLC,
     modelPar_TOXE,
     modelPar_given_TOXE,
     modelPar_TOXP,
     modelPar_given_TOXP,
     modelPar_DTOX,
     modelPar_given_DTOX,
     modelPar_NDEP,
     modelPar_given_NDEP,
     modelPar_NDEPL1,
     modelPar_given_NDEPL1,
     modelPar_NDEPLEXP1,
     modelPar_given_NDEPLEXP1,
     modelPar_NDEPL2,
     modelPar_given_NDEPL2,
     modelPar_NDEPLEXP2,
     modelPar_given_NDEPLEXP2,
     modelPar_NDEPW,
     modelPar_given_NDEPW,
     modelPar_NDEPWEXP,
     modelPar_given_NDEPWEXP,
     modelPar_NDEPWL,
     modelPar_given_NDEPWL,
     modelPar_NDEPWLEXP,
     modelPar_given_NDEPWLEXP,
     modelPar_LNDEP,
     modelPar_given_LNDEP,
     modelPar_WNDEP,
     modelPar_given_WNDEP,
     modelPar_PNDEP,
     modelPar_given_PNDEP,
     modelPar_NDEPCV,
     modelPar_given_NDEPCV,
     modelPar_NDEPCVL1,
     modelPar_given_NDEPCVL1,
     modelPar_NDEPCVLEXP1,
     modelPar_given_NDEPCVLEXP1,
     modelPar_NDEPCVL2,
     modelPar_given_NDEPCVL2,
     modelPar_NDEPCVLEXP2,
     modelPar_given_NDEPCVLEXP2,
     modelPar_NDEPCVW,
     modelPar_given_NDEPCVW,
     modelPar_NDEPCVWEXP,
     modelPar_given_NDEPCVWEXP,
     modelPar_NDEPCVWL,
     modelPar_given_NDEPCVWL,
     modelPar_NDEPCVWLEXP,
     modelPar_given_NDEPCVWLEXP,
     modelPar_LNDEPCV,
     modelPar_given_LNDEPCV,
     modelPar_WNDEPCV,
     modelPar_given_WNDEPCV,
     modelPar_PNDEPCV,
     modelPar_given_PNDEPCV,
     modelPar_NGATE,
     modelPar_given_NGATE,
     modelPar_LNGATE,
     modelPar_given_LNGATE,
     modelPar_WNGATE,
     modelPar_given_WNGATE,
     modelPar_PNGATE,
     modelPar_given_PNGATE,
     modelPar_EASUB,
     modelPar_given_EASUB,
     modelPar_NI0SUB,
     modelPar_given_NI0SUB,
     modelPar_BG0SUB,
     modelPar_given_BG0SUB,
     modelPar_EPSRSUB,
     modelPar_given_EPSRSUB,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_XJ,
     modelPar_given_XJ,
     modelPar_LXJ,
     modelPar_given_LXJ,
     modelPar_WXJ,
     modelPar_given_WXJ,
     modelPar_PXJ,
     modelPar_given_PXJ,
     modelPar_LVFB,
     modelPar_given_LVFB,
     modelPar_WVFB,
     modelPar_given_WVFB,
     modelPar_PVFB,
     modelPar_given_PVFB,
     modelPar_VFB,
     modelPar_given_VFB,
     modelPar_VFBCV,
     modelPar_given_VFBCV,
     modelPar_LVFBCV,
     modelPar_given_LVFBCV,
     modelPar_WVFBCV,
     modelPar_given_WVFBCV,
     modelPar_PVFBCV,
     modelPar_given_PVFBCV,
     modelPar_VFBCVL,
     modelPar_given_VFBCVL,
     modelPar_VFBCVLEXP,
     modelPar_given_VFBCVLEXP,
     modelPar_VFBCVW,
     modelPar_given_VFBCVW,
     modelPar_VFBCVWEXP,
     modelPar_given_VFBCVWEXP,
     modelPar_VFBCVWL,
     modelPar_given_VFBCVWL,
     modelPar_VFBCVWLEXP,
     modelPar_given_VFBCVWLEXP,
     modelPar_DWJ,
     modelPar_given_DWJ,
     modelPar_NSD,
     modelPar_given_NSD,
     modelPar_LNSD,
     modelPar_given_LNSD,
     modelPar_WNSD,
     modelPar_given_WNSD,
     modelPar_PNSD,
     modelPar_given_PNSD,
     modelPar_DELVT0,
     modelPar_given_DELVT0,
     modelPar_DVTP0,
     modelPar_given_DVTP0,
     modelPar_LDVTP0,
     modelPar_given_LDVTP0,
     modelPar_WDVTP0,
     modelPar_given_WDVTP0,
     modelPar_PDVTP0,
     modelPar_given_PDVTP0,
     modelPar_DVTP1,
     modelPar_given_DVTP1,
     modelPar_LDVTP1,
     modelPar_given_LDVTP1,
     modelPar_WDVTP1,
     modelPar_given_WDVTP1,
     modelPar_PDVTP1,
     modelPar_given_PDVTP1,
     modelPar_DVTP2,
     modelPar_given_DVTP2,
     modelPar_LDVTP2,
     modelPar_given_LDVTP2,
     modelPar_WDVTP2,
     modelPar_given_WDVTP2,
     modelPar_PDVTP2,
     modelPar_given_PDVTP2,
     modelPar_DVTP3,
     modelPar_given_DVTP3,
     modelPar_LDVTP3,
     modelPar_given_LDVTP3,
     modelPar_WDVTP3,
     modelPar_given_WDVTP3,
     modelPar_PDVTP3,
     modelPar_given_PDVTP3,
     modelPar_DVTP4,
     modelPar_given_DVTP4,
     modelPar_LDVTP4,
     modelPar_given_LDVTP4,
     modelPar_WDVTP4,
     modelPar_given_WDVTP4,
     modelPar_PDVTP4,
     modelPar_given_PDVTP4,
     modelPar_DVTP5,
     modelPar_given_DVTP5,
     modelPar_LDVTP5,
     modelPar_given_LDVTP5,
     modelPar_WDVTP5,
     modelPar_given_WDVTP5,
     modelPar_PDVTP5,
     modelPar_given_PDVTP5,
     modelPar_PHIN,
     modelPar_given_PHIN,
     modelPar_LPHIN,
     modelPar_given_LPHIN,
     modelPar_WPHIN,
     modelPar_given_WPHIN,
     modelPar_PPHIN,
     modelPar_given_PPHIN,
     modelPar_ETA0,
     modelPar_given_ETA0,
     modelPar_LETA0,
     modelPar_given_LETA0,
     modelPar_WETA0,
     modelPar_given_WETA0,
     modelPar_PETA0,
     modelPar_given_PETA0,
     modelPar_ETA0R,
     modelPar_given_ETA0R,
     modelPar_LETA0R,
     modelPar_given_LETA0R,
     modelPar_WETA0R,
     modelPar_given_WETA0R,
     modelPar_PETA0R,
     modelPar_given_PETA0R,
     modelPar_DSUB,
     modelPar_given_DSUB,
     modelPar_ETAB,
     modelPar_given_ETAB,
     modelPar_ETABEXP,
     modelPar_given_ETABEXP,
     modelPar_LETAB,
     modelPar_given_LETAB,
     modelPar_WETAB,
     modelPar_given_WETAB,
     modelPar_PETAB,
     modelPar_given_PETAB,
     modelPar_K1,
     modelPar_given_K1,
     modelPar_K1L,
     modelPar_given_K1L,
     modelPar_K1LEXP,
     modelPar_given_K1LEXP,
     modelPar_K1W,
     modelPar_given_K1W,
     modelPar_K1WEXP,
     modelPar_given_K1WEXP,
     modelPar_K1WL,
     modelPar_given_K1WL,
     modelPar_K1WLEXP,
     modelPar_given_K1WLEXP,
     modelPar_LK1,
     modelPar_given_LK1,
     modelPar_WK1,
     modelPar_given_WK1,
     modelPar_PK1,
     modelPar_given_PK1,
     modelPar_K2,
     modelPar_given_K2,
     modelPar_K2L,
     modelPar_given_K2L,
     modelPar_K2LEXP,
     modelPar_given_K2LEXP,
     modelPar_K2W,
     modelPar_given_K2W,
     modelPar_K2WEXP,
     modelPar_given_K2WEXP,
     modelPar_K2WL,
     modelPar_given_K2WL,
     modelPar_K2WLEXP,
     modelPar_given_K2WLEXP,
     modelPar_LK2,
     modelPar_given_LK2,
     modelPar_WK2,
     modelPar_given_WK2,
     modelPar_PK2,
     modelPar_given_PK2,
     modelPar_ADOS,
     modelPar_given_ADOS,
     modelPar_BDOS,
     modelPar_given_BDOS,
     modelPar_QM0,
     modelPar_given_QM0,
     modelPar_ETAQM,
     modelPar_given_ETAQM,
     modelPar_CIT,
     modelPar_given_CIT,
     modelPar_LCIT,
     modelPar_given_LCIT,
     modelPar_WCIT,
     modelPar_given_WCIT,
     modelPar_PCIT,
     modelPar_given_PCIT,
     modelPar_NFACTOR,
     modelPar_given_NFACTOR,
     modelPar_NFACTORL,
     modelPar_given_NFACTORL,
     modelPar_NFACTORLEXP,
     modelPar_given_NFACTORLEXP,
     modelPar_NFACTORW,
     modelPar_given_NFACTORW,
     modelPar_NFACTORWEXP,
     modelPar_given_NFACTORWEXP,
     modelPar_NFACTORWL,
     modelPar_given_NFACTORWL,
     modelPar_NFACTORWLEXP,
     modelPar_given_NFACTORWLEXP,
     modelPar_LNFACTOR,
     modelPar_given_LNFACTOR,
     modelPar_WNFACTOR,
     modelPar_given_WNFACTOR,
     modelPar_PNFACTOR,
     modelPar_given_PNFACTOR,
     modelPar_CDSCD,
     modelPar_given_CDSCD,
     modelPar_CDSCDL,
     modelPar_given_CDSCDL,
     modelPar_CDSCDLEXP,
     modelPar_given_CDSCDLEXP,
     modelPar_LCDSCD,
     modelPar_given_LCDSCD,
     modelPar_WCDSCD,
     modelPar_given_WCDSCD,
     modelPar_PCDSCD,
     modelPar_given_PCDSCD,
     modelPar_CDSCDR,
     modelPar_given_CDSCDR,
     modelPar_CDSCDLR,
     modelPar_given_CDSCDLR,
     modelPar_LCDSCDR,
     modelPar_given_LCDSCDR,
     modelPar_WCDSCDR,
     modelPar_given_WCDSCDR,
     modelPar_PCDSCDR,
     modelPar_given_PCDSCDR,
     modelPar_CDSCB,
     modelPar_given_CDSCB,
     modelPar_CDSCBL,
     modelPar_given_CDSCBL,
     modelPar_CDSCBLEXP,
     modelPar_given_CDSCBLEXP,
     modelPar_LCDSCB,
     modelPar_given_LCDSCB,
     modelPar_WCDSCB,
     modelPar_given_WCDSCB,
     modelPar_PCDSCB,
     modelPar_given_PCDSCB,
     modelPar_VSAT,
     modelPar_given_VSAT,
     modelPar_LVSAT,
     modelPar_given_LVSAT,
     modelPar_WVSAT,
     modelPar_given_WVSAT,
     modelPar_PVSAT,
     modelPar_given_PVSAT,
     modelPar_VSATL,
     modelPar_given_VSATL,
     modelPar_VSATLEXP,
     modelPar_given_VSATLEXP,
     modelPar_VSATW,
     modelPar_given_VSATW,
     modelPar_VSATWEXP,
     modelPar_given_VSATWEXP,
     modelPar_VSATWL,
     modelPar_given_VSATWL,
     modelPar_VSATWLEXP,
     modelPar_given_VSATWLEXP,
     modelPar_VSATR,
     modelPar_given_VSATR,
     modelPar_LVSATR,
     modelPar_given_LVSATR,
     modelPar_WVSATR,
     modelPar_given_WVSATR,
     modelPar_PVSATR,
     modelPar_given_PVSATR,
     modelPar_DELTA,
     modelPar_given_DELTA,
     modelPar_LDELTA,
     modelPar_given_LDELTA,
     modelPar_WDELTA,
     modelPar_given_WDELTA,
     modelPar_PDELTA,
     modelPar_given_PDELTA,
     modelPar_DELTAL,
     modelPar_given_DELTAL,
     modelPar_DELTALEXP,
     modelPar_given_DELTALEXP,
     modelPar_VSATCV,
     modelPar_given_VSATCV,
     modelPar_LVSATCV,
     modelPar_given_LVSATCV,
     modelPar_WVSATCV,
     modelPar_given_WVSATCV,
     modelPar_PVSATCV,
     modelPar_given_PVSATCV,
     modelPar_VSATCVL,
     modelPar_given_VSATCVL,
     modelPar_VSATCVLEXP,
     modelPar_given_VSATCVLEXP,
     modelPar_VSATCVW,
     modelPar_given_VSATCVW,
     modelPar_VSATCVWEXP,
     modelPar_given_VSATCVWEXP,
     modelPar_VSATCVWL,
     modelPar_given_VSATCVWL,
     modelPar_VSATCVWLEXP,
     modelPar_given_VSATCVWLEXP,
     modelPar_UP1,
     modelPar_given_UP1,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_UP2,
     modelPar_given_UP2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_MULU0,
     modelPar_given_MULU0,
     modelPar_U0,
     modelPar_given_U0,
     modelPar_U0L,
     modelPar_given_U0L,
     modelPar_U0LEXP,
     modelPar_given_U0LEXP,
     modelPar_LU0,
     modelPar_given_LU0,
     modelPar_WU0,
     modelPar_given_WU0,
     modelPar_PU0,
     modelPar_given_PU0,
     modelPar_U0R,
     modelPar_given_U0R,
     modelPar_LU0R,
     modelPar_given_LU0R,
     modelPar_WU0R,
     modelPar_given_WU0R,
     modelPar_PU0R,
     modelPar_given_PU0R,
     modelPar_ETAMOB,
     modelPar_given_ETAMOB,
     modelPar_UA,
     modelPar_given_UA,
     modelPar_UAL,
     modelPar_given_UAL,
     modelPar_UALEXP,
     modelPar_given_UALEXP,
     modelPar_UAW,
     modelPar_given_UAW,
     modelPar_UAWEXP,
     modelPar_given_UAWEXP,
     modelPar_UAWL,
     modelPar_given_UAWL,
     modelPar_UAWLEXP,
     modelPar_given_UAWLEXP,
     modelPar_LUA,
     modelPar_given_LUA,
     modelPar_WUA,
     modelPar_given_WUA,
     modelPar_PUA,
     modelPar_given_PUA,
     modelPar_UAR,
     modelPar_given_UAR,
     modelPar_LUAR,
     modelPar_given_LUAR,
     modelPar_WUAR,
     modelPar_given_WUAR,
     modelPar_PUAR,
     modelPar_given_PUAR,
     modelPar_EU,
     modelPar_given_EU,
     modelPar_LEU,
     modelPar_given_LEU,
     modelPar_WEU,
     modelPar_given_WEU,
     modelPar_PEU,
     modelPar_given_PEU,
     modelPar_EUL,
     modelPar_given_EUL,
     modelPar_EULEXP,
     modelPar_given_EULEXP,
     modelPar_EUW,
     modelPar_given_EUW,
     modelPar_EUWEXP,
     modelPar_given_EUWEXP,
     modelPar_EUWL,
     modelPar_given_EUWL,
     modelPar_EUWLEXP,
     modelPar_given_EUWLEXP,
     modelPar_UD,
     modelPar_given_UD,
     modelPar_UDL,
     modelPar_given_UDL,
     modelPar_UDLEXP,
     modelPar_given_UDLEXP,
     modelPar_LUD,
     modelPar_given_LUD,
     modelPar_WUD,
     modelPar_given_WUD,
     modelPar_PUD,
     modelPar_given_PUD,
     modelPar_UDR,
     modelPar_given_UDR,
     modelPar_LUDR,
     modelPar_given_LUDR,
     modelPar_WUDR,
     modelPar_given_WUDR,
     modelPar_PUDR,
     modelPar_given_PUDR,
     modelPar_UCS,
     modelPar_given_UCS,
     modelPar_LUCS,
     modelPar_given_LUCS,
     modelPar_WUCS,
     modelPar_given_WUCS,
     modelPar_PUCS,
     modelPar_given_PUCS,
     modelPar_UCSR,
     modelPar_given_UCSR,
     modelPar_LUCSR,
     modelPar_given_LUCSR,
     modelPar_WUCSR,
     modelPar_given_WUCSR,
     modelPar_PUCSR,
     modelPar_given_PUCSR,
     modelPar_UC,
     modelPar_given_UC,
     modelPar_UCL,
     modelPar_given_UCL,
     modelPar_UCLEXP,
     modelPar_given_UCLEXP,
     modelPar_UCW,
     modelPar_given_UCW,
     modelPar_UCWEXP,
     modelPar_given_UCWEXP,
     modelPar_UCWL,
     modelPar_given_UCWL,
     modelPar_UCWLEXP,
     modelPar_given_UCWLEXP,
     modelPar_LUC,
     modelPar_given_LUC,
     modelPar_WUC,
     modelPar_given_WUC,
     modelPar_PUC,
     modelPar_given_PUC,
     modelPar_UCR,
     modelPar_given_UCR,
     modelPar_LUCR,
     modelPar_given_LUCR,
     modelPar_WUCR,
     modelPar_given_WUCR,
     modelPar_PUCR,
     modelPar_given_PUCR,
     modelPar_PCLM,
     modelPar_given_PCLM,
     modelPar_PCLML,
     modelPar_given_PCLML,
     modelPar_PCLMLEXP,
     modelPar_given_PCLMLEXP,
     modelPar_LPCLM,
     modelPar_given_LPCLM,
     modelPar_WPCLM,
     modelPar_given_WPCLM,
     modelPar_PPCLM,
     modelPar_given_PPCLM,
     modelPar_PCLMR,
     modelPar_given_PCLMR,
     modelPar_LPCLMR,
     modelPar_given_LPCLMR,
     modelPar_WPCLMR,
     modelPar_given_WPCLMR,
     modelPar_PPCLMR,
     modelPar_given_PPCLMR,
     modelPar_PCLMG,
     modelPar_given_PCLMG,
     modelPar_PCLMCV,
     modelPar_given_PCLMCV,
     modelPar_PCLMCVL,
     modelPar_given_PCLMCVL,
     modelPar_PCLMCVLEXP,
     modelPar_given_PCLMCVLEXP,
     modelPar_LPCLMCV,
     modelPar_given_LPCLMCV,
     modelPar_WPCLMCV,
     modelPar_given_WPCLMCV,
     modelPar_PPCLMCV,
     modelPar_given_PPCLMCV,
     modelPar_PSCBE1,
     modelPar_given_PSCBE1,
     modelPar_LPSCBE1,
     modelPar_given_LPSCBE1,
     modelPar_WPSCBE1,
     modelPar_given_WPSCBE1,
     modelPar_PPSCBE1,
     modelPar_given_PPSCBE1,
     modelPar_PSCBE2,
     modelPar_given_PSCBE2,
     modelPar_LPSCBE2,
     modelPar_given_LPSCBE2,
     modelPar_WPSCBE2,
     modelPar_given_WPSCBE2,
     modelPar_PPSCBE2,
     modelPar_given_PPSCBE2,
     modelPar_PDITS,
     modelPar_given_PDITS,
     modelPar_LPDITS,
     modelPar_given_LPDITS,
     modelPar_WPDITS,
     modelPar_given_WPDITS,
     modelPar_PPDITS,
     modelPar_given_PPDITS,
     modelPar_PDITSL,
     modelPar_given_PDITSL,
     modelPar_PDITSD,
     modelPar_given_PDITSD,
     modelPar_LPDITSD,
     modelPar_given_LPDITSD,
     modelPar_WPDITSD,
     modelPar_given_WPDITSD,
     modelPar_PPDITSD,
     modelPar_given_PPDITSD,
     modelPar_RSH,
     modelPar_given_RSH,
     modelPar_PRWG,
     modelPar_given_PRWG,
     modelPar_LPRWG,
     modelPar_given_LPRWG,
     modelPar_WPRWG,
     modelPar_given_WPRWG,
     modelPar_PPRWG,
     modelPar_given_PPRWG,
     modelPar_PRWB,
     modelPar_given_PRWB,
     modelPar_LPRWB,
     modelPar_given_LPRWB,
     modelPar_WPRWB,
     modelPar_given_WPRWB,
     modelPar_PPRWB,
     modelPar_given_PPRWB,
     modelPar_PRWBL,
     modelPar_given_PRWBL,
     modelPar_PRWBLEXP,
     modelPar_given_PRWBLEXP,
     modelPar_WR,
     modelPar_given_WR,
     modelPar_LWR,
     modelPar_given_LWR,
     modelPar_WWR,
     modelPar_given_WWR,
     modelPar_PWR,
     modelPar_given_PWR,
     modelPar_RSWMIN,
     modelPar_given_RSWMIN,
     modelPar_LRSWMIN,
     modelPar_given_LRSWMIN,
     modelPar_WRSWMIN,
     modelPar_given_WRSWMIN,
     modelPar_PRSWMIN,
     modelPar_given_PRSWMIN,
     modelPar_RSW,
     modelPar_given_RSW,
     modelPar_LRSW,
     modelPar_given_LRSW,
     modelPar_WRSW,
     modelPar_given_WRSW,
     modelPar_PRSW,
     modelPar_given_PRSW,
     modelPar_RSWL,
     modelPar_given_RSWL,
     modelPar_RSWLEXP,
     modelPar_given_RSWLEXP,
     modelPar_RDWMIN,
     modelPar_given_RDWMIN,
     modelPar_LRDWMIN,
     modelPar_given_LRDWMIN,
     modelPar_WRDWMIN,
     modelPar_given_WRDWMIN,
     modelPar_PRDWMIN,
     modelPar_given_PRDWMIN,
     modelPar_RDW,
     modelPar_given_RDW,
     modelPar_LRDW,
     modelPar_given_LRDW,
     modelPar_WRDW,
     modelPar_given_WRDW,
     modelPar_PRDW,
     modelPar_given_PRDW,
     modelPar_RDWL,
     modelPar_given_RDWL,
     modelPar_RDWLEXP,
     modelPar_given_RDWLEXP,
     modelPar_RDSWMIN,
     modelPar_given_RDSWMIN,
     modelPar_LRDSWMIN,
     modelPar_given_LRDSWMIN,
     modelPar_WRDSWMIN,
     modelPar_given_WRDSWMIN,
     modelPar_PRDSWMIN,
     modelPar_given_PRDSWMIN,
     modelPar_RDSW,
     modelPar_given_RDSW,
     modelPar_RDSWL,
     modelPar_given_RDSWL,
     modelPar_RDSWLEXP,
     modelPar_given_RDSWLEXP,
     modelPar_LRDSW,
     modelPar_given_LRDSW,
     modelPar_WRDSW,
     modelPar_given_WRDSW,
     modelPar_PRDSW,
     modelPar_given_PRDSW,
     modelPar_PSAT,
     modelPar_given_PSAT,
     modelPar_LPSAT,
     modelPar_given_LPSAT,
     modelPar_WPSAT,
     modelPar_given_WPSAT,
     modelPar_PPSAT,
     modelPar_given_PPSAT,
     modelPar_PSATL,
     modelPar_given_PSATL,
     modelPar_PSATLEXP,
     modelPar_given_PSATLEXP,
     modelPar_PSATB,
     modelPar_given_PSATB,
     modelPar_PSATR,
     modelPar_given_PSATR,
     modelPar_LPSATR,
     modelPar_given_LPSATR,
     modelPar_WPSATR,
     modelPar_given_WPSATR,
     modelPar_PPSATR,
     modelPar_given_PPSATR,
     modelPar_LPSATB,
     modelPar_given_LPSATB,
     modelPar_WPSATB,
     modelPar_given_WPSATB,
     modelPar_PPSATB,
     modelPar_given_PPSATB,
     modelPar_PSATX,
     modelPar_given_PSATX,
     modelPar_PTWG,
     modelPar_given_PTWG,
     modelPar_LPTWG,
     modelPar_given_LPTWG,
     modelPar_WPTWG,
     modelPar_given_WPTWG,
     modelPar_PPTWG,
     modelPar_given_PPTWG,
     modelPar_PTWGL,
     modelPar_given_PTWGL,
     modelPar_PTWGLEXP,
     modelPar_given_PTWGLEXP,
     modelPar_PTWGR,
     modelPar_given_PTWGR,
     modelPar_LPTWGR,
     modelPar_given_LPTWGR,
     modelPar_WPTWGR,
     modelPar_given_WPTWGR,
     modelPar_PPTWGR,
     modelPar_given_PPTWGR,
     modelPar_PTWGLR,
     modelPar_given_PTWGLR,
     modelPar_PTWGLEXPR,
     modelPar_given_PTWGLEXPR,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_LA1,
     modelPar_given_LA1,
     modelPar_WA1,
     modelPar_given_WA1,
     modelPar_PA1,
     modelPar_given_PA1,
     modelPar_A11,
     modelPar_given_A11,
     modelPar_LA11,
     modelPar_given_LA11,
     modelPar_WA11,
     modelPar_given_WA11,
     modelPar_PA11,
     modelPar_given_PA11,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_LA2,
     modelPar_given_LA2,
     modelPar_WA2,
     modelPar_given_WA2,
     modelPar_PA2,
     modelPar_given_PA2,
     modelPar_A21,
     modelPar_given_A21,
     modelPar_LA21,
     modelPar_given_LA21,
     modelPar_WA21,
     modelPar_given_WA21,
     modelPar_PA21,
     modelPar_given_PA21,
     modelPar_PDIBLC,
     modelPar_given_PDIBLC,
     modelPar_PDIBLCL,
     modelPar_given_PDIBLCL,
     modelPar_PDIBLCLEXP,
     modelPar_given_PDIBLCLEXP,
     modelPar_LPDIBLC,
     modelPar_given_LPDIBLC,
     modelPar_WPDIBLC,
     modelPar_given_WPDIBLC,
     modelPar_PPDIBLC,
     modelPar_given_PPDIBLC,
     modelPar_PDIBLCR,
     modelPar_given_PDIBLCR,
     modelPar_PDIBLCLR,
     modelPar_given_PDIBLCLR,
     modelPar_PDIBLCLEXPR,
     modelPar_given_PDIBLCLEXPR,
     modelPar_LPDIBLCR,
     modelPar_given_LPDIBLCR,
     modelPar_WPDIBLCR,
     modelPar_given_WPDIBLCR,
     modelPar_PPDIBLCR,
     modelPar_given_PPDIBLCR,
     modelPar_PDIBLCB,
     modelPar_given_PDIBLCB,
     modelPar_LPDIBLCB,
     modelPar_given_LPDIBLCB,
     modelPar_WPDIBLCB,
     modelPar_given_WPDIBLCB,
     modelPar_PPDIBLCB,
     modelPar_given_PPDIBLCB,
     modelPar_PVAG,
     modelPar_given_PVAG,
     modelPar_LPVAG,
     modelPar_given_LPVAG,
     modelPar_WPVAG,
     modelPar_given_WPVAG,
     modelPar_PPVAG,
     modelPar_given_PPVAG,
     modelPar_FPROUT,
     modelPar_given_FPROUT,
     modelPar_FPROUTL,
     modelPar_given_FPROUTL,
     modelPar_FPROUTLEXP,
     modelPar_given_FPROUTLEXP,
     modelPar_LFPROUT,
     modelPar_given_LFPROUT,
     modelPar_WFPROUT,
     modelPar_given_WFPROUT,
     modelPar_PFPROUT,
     modelPar_given_PFPROUT,
     modelPar_ALPHA0,
     modelPar_given_ALPHA0,
     modelPar_ALPHA0L,
     modelPar_given_ALPHA0L,
     modelPar_ALPHA0LEXP,
     modelPar_given_ALPHA0LEXP,
     modelPar_LALPHA0,
     modelPar_given_LALPHA0,
     modelPar_WALPHA0,
     modelPar_given_WALPHA0,
     modelPar_PALPHA0,
     modelPar_given_PALPHA0,
     modelPar_BETA0,
     modelPar_given_BETA0,
     modelPar_LBETA0,
     modelPar_given_LBETA0,
     modelPar_WBETA0,
     modelPar_given_WBETA0,
     modelPar_PBETA0,
     modelPar_given_PBETA0,
     modelPar_AIGBACC,
     modelPar_given_AIGBACC,
     modelPar_BIGBACC,
     modelPar_given_BIGBACC,
     modelPar_CIGBACC,
     modelPar_given_CIGBACC,
     modelPar_NIGBACC,
     modelPar_given_NIGBACC,
     modelPar_AIGBINV,
     modelPar_given_AIGBINV,
     modelPar_BIGBINV,
     modelPar_given_BIGBINV,
     modelPar_CIGBINV,
     modelPar_given_CIGBINV,
     modelPar_EIGBINV,
     modelPar_given_EIGBINV,
     modelPar_NIGBINV,
     modelPar_given_NIGBINV,
     modelPar_AIGC,
     modelPar_given_AIGC,
     modelPar_BIGC,
     modelPar_given_BIGC,
     modelPar_CIGC,
     modelPar_given_CIGC,
     modelPar_AIGS,
     modelPar_given_AIGS,
     modelPar_BIGS,
     modelPar_given_BIGS,
     modelPar_CIGS,
     modelPar_given_CIGS,
     modelPar_AIGD,
     modelPar_given_AIGD,
     modelPar_BIGD,
     modelPar_given_BIGD,
     modelPar_CIGD,
     modelPar_given_CIGD,
     modelPar_DLCIG,
     modelPar_given_DLCIG,
     modelPar_DLCIGD,
     modelPar_given_DLCIGD,
     modelPar_POXEDGE,
     modelPar_given_POXEDGE,
     modelPar_NTOX,
     modelPar_given_NTOX,
     modelPar_TOXREF,
     modelPar_given_TOXREF,
     modelPar_PIGCD,
     modelPar_given_PIGCD,
     modelPar_AIGCL,
     modelPar_given_AIGCL,
     modelPar_AIGCW,
     modelPar_given_AIGCW,
     modelPar_AIGSL,
     modelPar_given_AIGSL,
     modelPar_AIGSW,
     modelPar_given_AIGSW,
     modelPar_AIGDL,
     modelPar_given_AIGDL,
     modelPar_AIGDW,
     modelPar_given_AIGDW,
     modelPar_PIGCDL,
     modelPar_given_PIGCDL,
     modelPar_LAIGBINV,
     modelPar_given_LAIGBINV,
     modelPar_WAIGBINV,
     modelPar_given_WAIGBINV,
     modelPar_PAIGBINV,
     modelPar_given_PAIGBINV,
     modelPar_LBIGBINV,
     modelPar_given_LBIGBINV,
     modelPar_WBIGBINV,
     modelPar_given_WBIGBINV,
     modelPar_PBIGBINV,
     modelPar_given_PBIGBINV,
     modelPar_LCIGBINV,
     modelPar_given_LCIGBINV,
     modelPar_WCIGBINV,
     modelPar_given_WCIGBINV,
     modelPar_PCIGBINV,
     modelPar_given_PCIGBINV,
     modelPar_LEIGBINV,
     modelPar_given_LEIGBINV,
     modelPar_WEIGBINV,
     modelPar_given_WEIGBINV,
     modelPar_PEIGBINV,
     modelPar_given_PEIGBINV,
     modelPar_LNIGBINV,
     modelPar_given_LNIGBINV,
     modelPar_WNIGBINV,
     modelPar_given_WNIGBINV,
     modelPar_PNIGBINV,
     modelPar_given_PNIGBINV,
     modelPar_LAIGBACC,
     modelPar_given_LAIGBACC,
     modelPar_WAIGBACC,
     modelPar_given_WAIGBACC,
     modelPar_PAIGBACC,
     modelPar_given_PAIGBACC,
     modelPar_LBIGBACC,
     modelPar_given_LBIGBACC,
     modelPar_WBIGBACC,
     modelPar_given_WBIGBACC,
     modelPar_PBIGBACC,
     modelPar_given_PBIGBACC,
     modelPar_LCIGBACC,
     modelPar_given_LCIGBACC,
     modelPar_WCIGBACC,
     modelPar_given_WCIGBACC,
     modelPar_PCIGBACC,
     modelPar_given_PCIGBACC,
     modelPar_LNIGBACC,
     modelPar_given_LNIGBACC,
     modelPar_WNIGBACC,
     modelPar_given_WNIGBACC,
     modelPar_PNIGBACC,
     modelPar_given_PNIGBACC,
     modelPar_LAIGC,
     modelPar_given_LAIGC,
     modelPar_WAIGC,
     modelPar_given_WAIGC,
     modelPar_PAIGC,
     modelPar_given_PAIGC,
     modelPar_LBIGC,
     modelPar_given_LBIGC,
     modelPar_WBIGC,
     modelPar_given_WBIGC,
     modelPar_PBIGC,
     modelPar_given_PBIGC,
     modelPar_LCIGC,
     modelPar_given_LCIGC,
     modelPar_WCIGC,
     modelPar_given_WCIGC,
     modelPar_PCIGC,
     modelPar_given_PCIGC,
     modelPar_LAIGS,
     modelPar_given_LAIGS,
     modelPar_WAIGS,
     modelPar_given_WAIGS,
     modelPar_PAIGS,
     modelPar_given_PAIGS,
     modelPar_LBIGS,
     modelPar_given_LBIGS,
     modelPar_WBIGS,
     modelPar_given_WBIGS,
     modelPar_PBIGS,
     modelPar_given_PBIGS,
     modelPar_LCIGS,
     modelPar_given_LCIGS,
     modelPar_WCIGS,
     modelPar_given_WCIGS,
     modelPar_PCIGS,
     modelPar_given_PCIGS,
     modelPar_LAIGD,
     modelPar_given_LAIGD,
     modelPar_WAIGD,
     modelPar_given_WAIGD,
     modelPar_PAIGD,
     modelPar_given_PAIGD,
     modelPar_LBIGD,
     modelPar_given_LBIGD,
     modelPar_WBIGD,
     modelPar_given_WBIGD,
     modelPar_PBIGD,
     modelPar_given_PBIGD,
     modelPar_LCIGD,
     modelPar_given_LCIGD,
     modelPar_WCIGD,
     modelPar_given_WCIGD,
     modelPar_PCIGD,
     modelPar_given_PCIGD,
     modelPar_LPOXEDGE,
     modelPar_given_LPOXEDGE,
     modelPar_WPOXEDGE,
     modelPar_given_WPOXEDGE,
     modelPar_PPOXEDGE,
     modelPar_given_PPOXEDGE,
     modelPar_LDLCIG,
     modelPar_given_LDLCIG,
     modelPar_WDLCIG,
     modelPar_given_WDLCIG,
     modelPar_PDLCIG,
     modelPar_given_PDLCIG,
     modelPar_LDLCIGD,
     modelPar_given_LDLCIGD,
     modelPar_WDLCIGD,
     modelPar_given_WDLCIGD,
     modelPar_PDLCIGD,
     modelPar_given_PDLCIGD,
     modelPar_LNTOX,
     modelPar_given_LNTOX,
     modelPar_WNTOX,
     modelPar_given_WNTOX,
     modelPar_PNTOX,
     modelPar_given_PNTOX,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_AGIDLL,
     modelPar_given_AGIDLL,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_LAGIDL,
     modelPar_given_LAGIDL,
     modelPar_WAGIDL,
     modelPar_given_WAGIDL,
     modelPar_PAGIDL,
     modelPar_given_PAGIDL,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_LBGIDL,
     modelPar_given_LBGIDL,
     modelPar_WBGIDL,
     modelPar_given_WBGIDL,
     modelPar_PBGIDL,
     modelPar_given_PBGIDL,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_LCGIDL,
     modelPar_given_LCGIDL,
     modelPar_WCGIDL,
     modelPar_given_WCGIDL,
     modelPar_PCGIDL,
     modelPar_given_PCGIDL,
     modelPar_EGIDL,
     modelPar_given_EGIDL,
     modelPar_LEGIDL,
     modelPar_given_LEGIDL,
     modelPar_WEGIDL,
     modelPar_given_WEGIDL,
     modelPar_PEGIDL,
     modelPar_given_PEGIDL,
     modelPar_AGISL,
     modelPar_given_AGISL,
     modelPar_AGISLL,
     modelPar_given_AGISLL,
     modelPar_AGISLW,
     modelPar_given_AGISLW,
     modelPar_LAGISL,
     modelPar_given_LAGISL,
     modelPar_WAGISL,
     modelPar_given_WAGISL,
     modelPar_PAGISL,
     modelPar_given_PAGISL,
     modelPar_BGISL,
     modelPar_given_BGISL,
     modelPar_LBGISL,
     modelPar_given_LBGISL,
     modelPar_WBGISL,
     modelPar_given_WBGISL,
     modelPar_PBGISL,
     modelPar_given_PBGISL,
     modelPar_CGISL,
     modelPar_given_CGISL,
     modelPar_LCGISL,
     modelPar_given_LCGISL,
     modelPar_WCGISL,
     modelPar_given_WCGISL,
     modelPar_PCGISL,
     modelPar_given_PCGISL,
     modelPar_EGISL,
     modelPar_given_EGISL,
     modelPar_LEGISL,
     modelPar_given_LEGISL,
     modelPar_WEGISL,
     modelPar_given_WEGISL,
     modelPar_PEGISL,
     modelPar_given_PEGISL,
     modelPar_CF,
     modelPar_given_CF,
     modelPar_LCF,
     modelPar_given_LCF,
     modelPar_WCF,
     modelPar_given_WCF,
     modelPar_PCF,
     modelPar_given_PCF,
     modelPar_CFRCOEFF,
     modelPar_given_CFRCOEFF,
     modelPar_CGSO,
     modelPar_given_CGSO,
     modelPar_CGDO,
     modelPar_given_CGDO,
     modelPar_CGBO,
     modelPar_given_CGBO,
     modelPar_CGSL,
     modelPar_given_CGSL,
     modelPar_LCGSL,
     modelPar_given_LCGSL,
     modelPar_WCGSL,
     modelPar_given_WCGSL,
     modelPar_PCGSL,
     modelPar_given_PCGSL,
     modelPar_CGDL,
     modelPar_given_CGDL,
     modelPar_LCGDL,
     modelPar_given_LCGDL,
     modelPar_WCGDL,
     modelPar_given_WCGDL,
     modelPar_PCGDL,
     modelPar_given_PCGDL,
     modelPar_CKAPPAS,
     modelPar_given_CKAPPAS,
     modelPar_LCKAPPAS,
     modelPar_given_LCKAPPAS,
     modelPar_WCKAPPAS,
     modelPar_given_WCKAPPAS,
     modelPar_PCKAPPAS,
     modelPar_given_PCKAPPAS,
     modelPar_CKAPPAD,
     modelPar_given_CKAPPAD,
     modelPar_LCKAPPAD,
     modelPar_given_LCKAPPAD,
     modelPar_WCKAPPAD,
     modelPar_given_WCKAPPAD,
     modelPar_PCKAPPAD,
     modelPar_given_PCKAPPAD,
     modelPar_DMCG,
     modelPar_given_DMCG,
     modelPar_DMCI,
     modelPar_given_DMCI,
     modelPar_DMDG,
     modelPar_given_DMDG,
     modelPar_DMCGT,
     modelPar_given_DMCGT,
     modelPar_XGL,
     modelPar_given_XGL,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_CJD,
     modelPar_given_CJD,
     modelPar_CJSWS,
     modelPar_given_CJSWS,
     modelPar_CJSWD,
     modelPar_given_CJSWD,
     modelPar_CJSWGS,
     modelPar_given_CJSWGS,
     modelPar_CJSWGD,
     modelPar_given_CJSWGD,
     modelPar_PBS,
     modelPar_given_PBS,
     modelPar_PBD,
     modelPar_given_PBD,
     modelPar_PBSWS,
     modelPar_given_PBSWS,
     modelPar_PBSWD,
     modelPar_given_PBSWD,
     modelPar_PBSWGS,
     modelPar_given_PBSWGS,
     modelPar_PBSWGD,
     modelPar_given_PBSWGD,
     modelPar_MJS,
     modelPar_given_MJS,
     modelPar_MJD,
     modelPar_given_MJD,
     modelPar_MJSWS,
     modelPar_given_MJSWS,
     modelPar_MJSWD,
     modelPar_given_MJSWD,
     modelPar_MJSWGS,
     modelPar_given_MJSWGS,
     modelPar_MJSWGD,
     modelPar_given_MJSWGD,
     modelPar_JSS,
     modelPar_given_JSS,
     modelPar_JSD,
     modelPar_given_JSD,
     modelPar_JSWS,
     modelPar_given_JSWS,
     modelPar_JSWD,
     modelPar_given_JSWD,
     modelPar_JSWGS,
     modelPar_given_JSWGS,
     modelPar_JSWGD,
     modelPar_given_JSWGD,
     modelPar_NJS,
     modelPar_given_NJS,
     modelPar_NJD,
     modelPar_given_NJD,
     modelPar_IJTHSFWD,
     modelPar_given_IJTHSFWD,
     modelPar_IJTHDFWD,
     modelPar_given_IJTHDFWD,
     modelPar_IJTHSREV,
     modelPar_given_IJTHSREV,
     modelPar_IJTHDREV,
     modelPar_given_IJTHDREV,
     modelPar_BVS,
     modelPar_given_BVS,
     modelPar_BVD,
     modelPar_given_BVD,
     modelPar_XJBVS,
     modelPar_given_XJBVS,
     modelPar_XJBVD,
     modelPar_given_XJBVD,
     modelPar_JTSS,
     modelPar_given_JTSS,
     modelPar_JTSD,
     modelPar_given_JTSD,
     modelPar_JTSSWS,
     modelPar_given_JTSSWS,
     modelPar_JTSSWD,
     modelPar_given_JTSSWD,
     modelPar_JTSSWGS,
     modelPar_given_JTSSWGS,
     modelPar_JTSSWGD,
     modelPar_given_JTSSWGD,
     modelPar_JTWEFF,
     modelPar_given_JTWEFF,
     modelPar_NJTS,
     modelPar_given_NJTS,
     modelPar_NJTSD,
     modelPar_given_NJTSD,
     modelPar_NJTSSW,
     modelPar_given_NJTSSW,
     modelPar_NJTSSWD,
     modelPar_given_NJTSSWD,
     modelPar_NJTSSWG,
     modelPar_given_NJTSSWG,
     modelPar_NJTSSWGD,
     modelPar_given_NJTSSWGD,
     modelPar_VTSS,
     modelPar_given_VTSS,
     modelPar_VTSD,
     modelPar_given_VTSD,
     modelPar_VTSSWS,
     modelPar_given_VTSSWS,
     modelPar_VTSSWD,
     modelPar_given_VTSSWD,
     modelPar_VTSSWGS,
     modelPar_given_VTSSWGS,
     modelPar_VTSSWGD,
     modelPar_given_VTSSWGD,
     modelPar_XRCRG1,
     modelPar_given_XRCRG1,
     modelPar_XRCRG2,
     modelPar_given_XRCRG2,
     modelPar_GBMIN,
     modelPar_given_GBMIN,
     modelPar_RBPS0,
     modelPar_given_RBPS0,
     modelPar_RBPSL,
     modelPar_given_RBPSL,
     modelPar_RBPSW,
     modelPar_given_RBPSW,
     modelPar_RBPSNF,
     modelPar_given_RBPSNF,
     modelPar_RBPD0,
     modelPar_given_RBPD0,
     modelPar_RBPDL,
     modelPar_given_RBPDL,
     modelPar_RBPDW,
     modelPar_given_RBPDW,
     modelPar_RBPDNF,
     modelPar_given_RBPDNF,
     modelPar_RBPBX0,
     modelPar_given_RBPBX0,
     modelPar_RBPBXL,
     modelPar_given_RBPBXL,
     modelPar_RBPBXW,
     modelPar_given_RBPBXW,
     modelPar_RBPBXNF,
     modelPar_given_RBPBXNF,
     modelPar_RBPBY0,
     modelPar_given_RBPBY0,
     modelPar_RBPBYL,
     modelPar_given_RBPBYL,
     modelPar_RBPBYW,
     modelPar_given_RBPBYW,
     modelPar_RBPBYNF,
     modelPar_given_RBPBYNF,
     modelPar_RBSBX0,
     modelPar_given_RBSBX0,
     modelPar_RBSBY0,
     modelPar_given_RBSBY0,
     modelPar_RBDBX0,
     modelPar_given_RBDBX0,
     modelPar_RBDBY0,
     modelPar_given_RBDBY0,
     modelPar_RBSDBXL,
     modelPar_given_RBSDBXL,
     modelPar_RBSDBXW,
     modelPar_given_RBSDBXW,
     modelPar_RBSDBXNF,
     modelPar_given_RBSDBXNF,
     modelPar_RBSDBYL,
     modelPar_given_RBSDBYL,
     modelPar_RBSDBYW,
     modelPar_given_RBSDBYW,
     modelPar_RBSDBYNF,
     modelPar_given_RBSDBYNF,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_EM,
     modelPar_given_EM,
     modelPar_NOIA,
     modelPar_given_NOIA,
     modelPar_NOIB,
     modelPar_given_NOIB,
     modelPar_NOIC,
     modelPar_given_NOIC,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_NTNOI,
     modelPar_given_NTNOI,
     modelPar_RNOIA,
     modelPar_given_RNOIA,
     modelPar_RNOIB,
     modelPar_given_RNOIB,
     modelPar_RNOIC,
     modelPar_given_RNOIC,
     modelPar_TNOIA,
     modelPar_given_TNOIA,
     modelPar_TNOIB,
     modelPar_given_TNOIB,
     modelPar_TNOIC,
     modelPar_given_TNOIC,
     modelPar_DLBIN,
     modelPar_given_DLBIN,
     modelPar_DWBIN,
     modelPar_given_DWBIN,
     modelPar_TNOM,
     modelPar_given_TNOM,
     modelPar_DTEMP,
     modelPar_given_DTEMP,
     modelPar_TBGASUB,
     modelPar_given_TBGASUB,
     modelPar_TBGBSUB,
     modelPar_given_TBGBSUB,
     modelPar_TNFACTOR,
     modelPar_given_TNFACTOR,
     modelPar_UTE,
     modelPar_given_UTE,
     modelPar_LUTE,
     modelPar_given_LUTE,
     modelPar_WUTE,
     modelPar_given_WUTE,
     modelPar_PUTE,
     modelPar_given_PUTE,
     modelPar_UTEL,
     modelPar_given_UTEL,
     modelPar_UA1,
     modelPar_given_UA1,
     modelPar_LUA1,
     modelPar_given_LUA1,
     modelPar_WUA1,
     modelPar_given_WUA1,
     modelPar_PUA1,
     modelPar_given_PUA1,
     modelPar_UA1L,
     modelPar_given_UA1L,
     modelPar_UC1,
     modelPar_given_UC1,
     modelPar_LUC1,
     modelPar_given_LUC1,
     modelPar_WUC1,
     modelPar_given_WUC1,
     modelPar_PUC1,
     modelPar_given_PUC1,
     modelPar_UD1,
     modelPar_given_UD1,
     modelPar_LUD1,
     modelPar_given_LUD1,
     modelPar_WUD1,
     modelPar_given_WUD1,
     modelPar_PUD1,
     modelPar_given_PUD1,
     modelPar_UD1L,
     modelPar_given_UD1L,
     modelPar_UCSTE,
     modelPar_given_UCSTE,
     modelPar_LUCSTE,
     modelPar_given_LUCSTE,
     modelPar_WUCSTE,
     modelPar_given_WUCSTE,
     modelPar_PUCSTE,
     modelPar_given_PUCSTE,
     modelPar_TETA0,
     modelPar_given_TETA0,
     modelPar_PRT,
     modelPar_given_PRT,
     modelPar_LPRT,
     modelPar_given_LPRT,
     modelPar_WPRT,
     modelPar_given_WPRT,
     modelPar_PPRT,
     modelPar_given_PPRT,
     modelPar_AT,
     modelPar_given_AT,
     modelPar_LAT,
     modelPar_given_LAT,
     modelPar_WAT,
     modelPar_given_WAT,
     modelPar_PAT,
     modelPar_given_PAT,
     modelPar_ATL,
     modelPar_given_ATL,
     modelPar_TDELTA,
     modelPar_given_TDELTA,
     modelPar_PTWGT,
     modelPar_given_PTWGT,
     modelPar_LPTWGT,
     modelPar_given_LPTWGT,
     modelPar_WPTWGT,
     modelPar_given_WPTWGT,
     modelPar_PPTWGT,
     modelPar_given_PPTWGT,
     modelPar_PTWGTL,
     modelPar_given_PTWGTL,
     modelPar_KT1,
     modelPar_given_KT1,
     modelPar_KT1EXP,
     modelPar_given_KT1EXP,
     modelPar_KT1L,
     modelPar_given_KT1L,
     modelPar_LKT1,
     modelPar_given_LKT1,
     modelPar_WKT1,
     modelPar_given_WKT1,
     modelPar_PKT1,
     modelPar_given_PKT1,
     modelPar_KT2,
     modelPar_given_KT2,
     modelPar_LKT2,
     modelPar_given_LKT2,
     modelPar_WKT2,
     modelPar_given_WKT2,
     modelPar_PKT2,
     modelPar_given_PKT2,
     modelPar_IIT,
     modelPar_given_IIT,
     modelPar_LIIT,
     modelPar_given_LIIT,
     modelPar_WIIT,
     modelPar_given_WIIT,
     modelPar_PIIT,
     modelPar_given_PIIT,
     modelPar_IGT,
     modelPar_given_IGT,
     modelPar_LIGT,
     modelPar_given_LIGT,
     modelPar_WIGT,
     modelPar_given_WIGT,
     modelPar_PIGT,
     modelPar_given_PIGT,
     modelPar_TGIDL,
     modelPar_given_TGIDL,
     modelPar_LTGIDL,
     modelPar_given_LTGIDL,
     modelPar_WTGIDL,
     modelPar_given_WTGIDL,
     modelPar_PTGIDL,
     modelPar_given_PTGIDL,
     modelPar_TCJ,
     modelPar_given_TCJ,
     modelPar_TCJSW,
     modelPar_given_TCJSW,
     modelPar_TCJSWG,
     modelPar_given_TCJSWG,
     modelPar_TPB,
     modelPar_given_TPB,
     modelPar_TPBSW,
     modelPar_given_TPBSW,
     modelPar_TPBSWG,
     modelPar_given_TPBSWG,
     modelPar_XTIS,
     modelPar_given_XTIS,
     modelPar_XTID,
     modelPar_given_XTID,
     modelPar_XTSS,
     modelPar_given_XTSS,
     modelPar_XTSD,
     modelPar_given_XTSD,
     modelPar_XTSSWS,
     modelPar_given_XTSSWS,
     modelPar_XTSSWD,
     modelPar_given_XTSSWD,
     modelPar_XTSSWGS,
     modelPar_given_XTSSWGS,
     modelPar_XTSSWGD,
     modelPar_given_XTSSWGD,
     modelPar_TNJTS,
     modelPar_given_TNJTS,
     modelPar_TNJTSD,
     modelPar_given_TNJTSD,
     modelPar_TNJTSSW,
     modelPar_given_TNJTSSW,
     modelPar_TNJTSSWD,
     modelPar_given_TNJTSSWD,
     modelPar_TNJTSSWG,
     modelPar_given_TNJTSSWG,
     modelPar_TNJTSSWGD,
     modelPar_given_TNJTSSWGD,
     modelPar_RTH0,
     modelPar_given_RTH0,
     modelPar_CTH0,
     modelPar_given_CTH0,
     modelPar_WTH0,
     modelPar_given_WTH0,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KU0,
     modelPar_given_KU0,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKU0,
     modelPar_given_TKU0,
     modelPar_LKU0,
     modelPar_given_LKU0,
     modelPar_WKU0,
     modelPar_given_WKU0,
     modelPar_PKU0,
     modelPar_given_PKU0,
     modelPar_LLODKU0,
     modelPar_given_LLODKU0,
     modelPar_WLODKU0,
     modelPar_given_WLODKU0,
     modelPar_KVTH0,
     modelPar_given_KVTH0,
     modelPar_LKVTH0,
     modelPar_given_LKVTH0,
     modelPar_WKVTH0,
     modelPar_given_WKVTH0,
     modelPar_PKVTH0,
     modelPar_given_PKVTH0,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STK2,
     modelPar_given_STK2,
     modelPar_LODK2,
     modelPar_given_LODK2,
     modelPar_STETA0,
     modelPar_given_STETA0,
     modelPar_LODETA0,
     modelPar_given_LODETA0,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_KVTH0WE,
     modelPar_given_KVTH0WE,
     modelPar_LKVTH0WE,
     modelPar_given_LKVTH0WE,
     modelPar_WKVTH0WE,
     modelPar_given_WKVTH0WE,
     modelPar_PKVTH0WE,
     modelPar_given_PKVTH0WE,
     modelPar_K2WE,
     modelPar_given_K2WE,
     modelPar_LK2WE,
     modelPar_given_LK2WE,
     modelPar_WK2WE,
     modelPar_given_WK2WE,
     modelPar_PK2WE,
     modelPar_given_PK2WE,
     modelPar_KU0WE,
     modelPar_given_KU0WE,
     modelPar_LKU0WE,
     modelPar_given_LKU0WE,
     modelPar_WKU0WE,
     modelPar_given_WKU0WE,
     modelPar_PKU0WE,
     modelPar_given_PKU0WE,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEDGE,
     modelPar_given_WEDGE,
     modelPar_DGAMMAEDGE,
     modelPar_given_DGAMMAEDGE,
     modelPar_DGAMMAEDGEL,
     modelPar_given_DGAMMAEDGEL,
     modelPar_DGAMMAEDGELEXP,
     modelPar_given_DGAMMAEDGELEXP,
     modelPar_DVTEDGE,
     modelPar_given_DVTEDGE,
     modelPar_NFACTOREDGE,
     modelPar_given_NFACTOREDGE,
     modelPar_CITEDGE,
     modelPar_given_CITEDGE,
     modelPar_CDSCDEDGE,
     modelPar_given_CDSCDEDGE,
     modelPar_CDSCBEDGE,
     modelPar_given_CDSCBEDGE,
     modelPar_ETA0EDGE,
     modelPar_given_ETA0EDGE,
     modelPar_ETABEDGE,
     modelPar_given_ETABEDGE,
     modelPar_KT1EDGE,
     modelPar_given_KT1EDGE,
     modelPar_KT1LEDGE,
     modelPar_given_KT1LEDGE,
     modelPar_KT2EDGE,
     modelPar_given_KT2EDGE,
     modelPar_KT1EXPEDGE,
     modelPar_given_KT1EXPEDGE,
     modelPar_TNFACTOREDGE,
     modelPar_given_TNFACTOREDGE,
     modelPar_TETA0EDGE,
     modelPar_given_TETA0EDGE,
     modelPar_DVT0EDGE,
     modelPar_given_DVT0EDGE,
     modelPar_DVT1EDGE,
     modelPar_given_DVT1EDGE,
     modelPar_DVT2EDGE,
     modelPar_given_DVT2EDGE,
     // non-reals (including hidden)
     modelPar_NGCON,
     modelPar_given_NGCON,
     modelPar_RGATEMOD,
     modelPar_given_RGATEMOD,
     modelPar_RBODYMOD,
     modelPar_given_RBODYMOD,
     modelPar_GEOMOD,
     modelPar_given_GEOMOD,
     modelPar_RGEOMOD,
     modelPar_given_RGEOMOD,
     modelPar_SCA,
     modelPar_given_SCA,
     modelPar_SCB,
     modelPar_given_SCB,
     modelPar_SCC,
     modelPar_given_SCC,
     modelPar_SC,
     modelPar_given_SC,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_CVMOD,
     modelPar_given_CVMOD,
     modelPar_COVMOD,
     modelPar_given_COVMOD,
     modelPar_RDSMOD,
     modelPar_given_RDSMOD,
     modelPar_WPEMOD,
     modelPar_given_WPEMOD,
     modelPar_ASYMMOD,
     modelPar_given_ASYMMOD,
     modelPar_GIDLMOD,
     modelPar_given_GIDLMOD,
     modelPar_IGCMOD,
     modelPar_given_IGCMOD,
     modelPar_IGBMOD,
     modelPar_given_IGBMOD,
     modelPar_TNOIMOD,
     modelPar_given_TNOIMOD,
     modelPar_SHMOD,
     modelPar_given_SHMOD,
     modelPar_MOBSCALE,
     modelPar_given_MOBSCALE,
     modelPar_PERMOD,
     modelPar_given_PERMOD,
     modelPar_BINUNIT,
     modelPar_given_BINUNIT,
     modelPar_EDGEFET,
     modelPar_given_EDGEFET,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_bi_dbulk,
     in.admsProbeID_V_b_dbulk,
     in.admsProbeID_V_b_bi,
     in.admsProbeID_V_b_sbulk,
     in.admsProbeID_V_bi_sbulk,
     in.admsProbeID_V_di_si,
     in.admsProbeID_V_gm_gi,
     in.admsProbeID_V_g_gm,
     in.admsProbeID_V_s_si,
     in.admsProbeID_V_d_di,
     in.admsProbeID_V_gm_bi,
     in.admsProbeID_V_N1_GND,
     in.admsProbeID_V_N2_GND,
     in.admsProbeID_V_gm_si,
     in.admsProbeID_V_gm_di,
     in.admsProbeID_V_dbulk_di,
     in.admsProbeID_V_sbulk_si,
     in.admsProbeID_V_si_bi,
     in.admsProbeID_V_di_bi,
     in.admsProbeID_V_gi_bi,
     in.admsProbeID_Temp_t_GND,

     // node constants
     in.admsNodeID_d,
     in.admsNodeID_g,
     in.admsNodeID_s,
     in.admsNodeID_b,
     in.admsNodeID_di,
     in.admsNodeID_si,
     in.admsNodeID_gi,
     in.admsNodeID_gm,
     in.admsNodeID_bi,
     in.admsNodeID_sbulk,
     in.admsNodeID_dbulk,
     in.admsNodeID_N1,
     in.admsNodeID_N2,
     in.admsNodeID_t,
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     instancePar_NRS,
     instancePar_given_NRS,
     instancePar_NRD,
     instancePar_given_NRD,
     instancePar_VFBSDOFF,
     instancePar_given_VFBSDOFF,
     instancePar_XGW,
     instancePar_given_XGW,
     instancePar_RBPB,
     instancePar_given_RBPB,
     instancePar_RBPD,
     instancePar_given_RBPD,
     instancePar_RBPS,
     instancePar_given_RBPS,
     instancePar_RBDB,
     instancePar_given_RBDB,
     instancePar_RBSB,
     instancePar_given_RBSB,
     instancePar_SA,
     instancePar_given_SA,
     instancePar_SB,
     instancePar_given_SB,
     instancePar_SD,
     instancePar_given_SD,
     instancePar_AS,
     instancePar_given_AS,
     instancePar_AD,
     instancePar_given_AD,
     instancePar_PS,
     instancePar_given_PS,
     instancePar_PD,
     instancePar_given_PD,
     // non-reals(including hidden)
     instancePar_NF,
     instancePar_given_NF,
     instancePar_MINZ,
     instancePar_given_MINZ,
     instancePar_NGCON,
     instancePar_given_NGCON,
     instancePar_RGATEMOD,
     instancePar_given_RGATEMOD,
     instancePar_RBODYMOD,
     instancePar_given_RBODYMOD,
     instancePar_GEOMOD,
     instancePar_given_GEOMOD,
     instancePar_RGEOMOD,
     instancePar_given_RGEOMOD,
     instancePar_SCA,
     instancePar_given_SCA,
     instancePar_SCB,
     instancePar_given_SCB,
     instancePar_SCC,
     instancePar_given_SCC,
     instancePar_SC,
     instancePar_given_SC,
     // instance variables
     // reals
     instanceVar_T0,
     instanceVar_T1,
     instanceVar_T2,
     instanceVar_epssi,
     instanceVar_epsox,
     instanceVar_Weff,
     instanceVar_Leff,
     instanceVar_Wact,
     instanceVar_Lact,
     instanceVar_Weffcj,
     instanceVar_Cox,
     instanceVar_epsratio,
     instanceVar_Lnew,
     instanceVar_L_mult,
     instanceVar_Wnew,
     instanceVar_DVTP0_i,
     instanceVar_DVTP1_i,
     instanceVar_DVTP2_i,
     instanceVar_DVTP3_i,
     instanceVar_DVTP4_i,
     instanceVar_DVTP5_i,
     instanceVar_A1_i,
     instanceVar_A11_i,
     instanceVar_A2_i,
     instanceVar_A21_i,
     instanceVar_PSAT_i,
     instanceVar_PSATR_i,
     instanceVar_BSIM6TOXP,
     instanceVar_DMCGeff,
     instanceVar_DMDGeff,
     instanceVar_DMCIeff,
     instanceVar_RSourceGeo,
     instanceVar_RDrainGeo,
     instanceVar_Grgeltd,
     instanceVar_Grbsb,
     instanceVar_Grbdb,
     instanceVar_Grbpb,
     instanceVar_Grbps,
     instanceVar_Grbpd,
     instanceVar_Aechvb,
     instanceVar_Bechvb,
     instanceVar_AechvbEdge,
     instanceVar_BechvbEdge,
     instanceVar_ToxRatio,
     instanceVar_U0R_t,
     instanceVar_UAR_t,
     instanceVar_UCR_t,
     instanceVar_UDR_t,
     instanceVar_UCSR_t,
     instanceVar_VSATR_t,
     instanceVar_PTWGR_t,
     instanceVar_ETA0R_t,
     instanceVar_PSATB_i,
     instanceVar_KT1_i,
     instanceVar_KT2_i,
     instanceVar_NGATE_i,
     instanceVar_NSD_i,
     instanceVar_NDEP_i,
     instanceVar_VFB_i,
     instanceVar_CIT_i,
     instanceVar_CDSCD_i,
     instanceVar_CDSCDR_i,
     instanceVar_CDSCB_i,
     instanceVar_NFACTOR_i,
     instanceVar_PHIN_i,
     instanceVar_ETA0_i,
     instanceVar_ETA0R_i,
     instanceVar_ETAB_i,
     instanceVar_K2_i,
     instanceVar_K1_i,
     instanceVar_DELTA_i,
     instanceVar_U0_i,
     instanceVar_U0R_i,
     instanceVar_VSAT_i,
     instanceVar_VSATR_i,
     instanceVar_VSATCV_i,
     instanceVar_UA_i,
     instanceVar_UAR_i,
     instanceVar_EU_i,
     instanceVar_UD_i,
     instanceVar_UDR_i,
     instanceVar_UD_a,
     instanceVar_UCS_i,
     instanceVar_UCSR_i,
     instanceVar_UC_i,
     instanceVar_UCR_i,
     instanceVar_PDIBLC_i,
     instanceVar_PDIBLCR_i,
     instanceVar_PDIBLCB_i,
     instanceVar_PSCBE1_i,
     instanceVar_PSCBE2_i,
     instanceVar_PDITS_i,
     instanceVar_PDITSD_i,
     instanceVar_FPROUT_i,
     instanceVar_PRWG_i,
     instanceVar_WR_i,
     instanceVar_RDWMIN_i,
     instanceVar_RSWMIN_i,
     instanceVar_RDW_i,
     instanceVar_RSW_i,
     instanceVar_RDSW_i,
     instanceVar_RDSWMIN_i,
     instanceVar_PTWG_i,
     instanceVar_PTWGR_i,
     instanceVar_PVAG_i,
     instanceVar_XJ_i,
     instanceVar_PCLM_i,
     instanceVar_PCLMR_i,
     instanceVar_PCLMCV_i,
     instanceVar_PRWB_i,
     instanceVar_CF_i,
     instanceVar_CGSL_i,
     instanceVar_CGDL_i,
     instanceVar_CKAPPAS_i,
     instanceVar_CKAPPAD_i,
     instanceVar_VFBCV_i,
     instanceVar_NDEPCV_i,
     instanceVar_ALPHA0_i,
     instanceVar_BETA0_i,
     instanceVar_AGIDL_i,
     instanceVar_BGIDL_i,
     instanceVar_CGIDL_i,
     instanceVar_EGIDL_i,
     instanceVar_AGISL_i,
     instanceVar_BGISL_i,
     instanceVar_CGISL_i,
     instanceVar_EGISL_i,
     instanceVar_UTE_i,
     instanceVar_UA1_i,
     instanceVar_UC1_i,
     instanceVar_UD1_i,
     instanceVar_UCSTE_i,
     instanceVar_PRT_i,
     instanceVar_AT_i,
     instanceVar_PTWGT_i,
     instanceVar_IIT_i,
     instanceVar_TGIDL_i,
     instanceVar_KVTH0WE_i,
     instanceVar_K2WE_i,
     instanceVar_KU0WE_i,
     instanceVar_AIGBINV_i,
     instanceVar_BIGBINV_i,
     instanceVar_CIGBINV_i,
     instanceVar_EIGBINV_i,
     instanceVar_NIGBINV_i,
     instanceVar_AIGBACC_i,
     instanceVar_BIGBACC_i,
     instanceVar_CIGBACC_i,
     instanceVar_NIGBACC_i,
     instanceVar_AIGC_i,
     instanceVar_BIGC_i,
     instanceVar_CIGC_i,
     instanceVar_AIGS_i,
     instanceVar_BIGS_i,
     instanceVar_CIGS_i,
     instanceVar_AIGD_i,
     instanceVar_BIGD_i,
     instanceVar_CIGD_i,
     instanceVar_PIGCD_i,
     instanceVar_DLCIG_i,
     instanceVar_DLCIGD_i,
     instanceVar_IGT_i,
     instanceVar_nuIntD,
     instanceVar_nuEndD,
     instanceVar_nuIntS,
     instanceVar_nuEndS,
     instanceVar_gth,
     instanceVar_cth,
     // non-reals
     instanceVar_devsign,
     // model parameters
     // reals
     modelPar_L,
     modelPar_given_L,
     modelPar_VFBSDOFF,
     modelPar_given_VFBSDOFF,
     modelPar_XGW,
     modelPar_given_XGW,
     modelPar_RBPB,
     modelPar_given_RBPB,
     modelPar_RBPD,
     modelPar_given_RBPD,
     modelPar_RBPS,
     modelPar_given_RBPS,
     modelPar_RBDB,
     modelPar_given_RBDB,
     modelPar_RBSB,
     modelPar_given_RBSB,
     modelPar_SA,
     modelPar_given_SA,
     modelPar_SB,
     modelPar_given_SB,
     modelPar_SD,
     modelPar_given_SD,
     modelPar_LLONG,
     modelPar_given_LLONG,
     modelPar_LMLT,
     modelPar_given_LMLT,
     modelPar_WMLT,
     modelPar_given_WMLT,
     modelPar_XL,
     modelPar_given_XL,
     modelPar_WWIDE,
     modelPar_given_WWIDE,
     modelPar_XW,
     modelPar_given_XW,
     modelPar_LINT,
     modelPar_given_LINT,
     modelPar_LL,
     modelPar_given_LL,
     modelPar_LW,
     modelPar_given_LW,
     modelPar_LWL,
     modelPar_given_LWL,
     modelPar_LLN,
     modelPar_given_LLN,
     modelPar_LWN,
     modelPar_given_LWN,
     modelPar_WINT,
     modelPar_given_WINT,
     modelPar_WL,
     modelPar_given_WL,
     modelPar_WW,
     modelPar_given_WW,
     modelPar_WWL,
     modelPar_given_WWL,
     modelPar_WLN,
     modelPar_given_WLN,
     modelPar_WWN,
     modelPar_given_WWN,
     modelPar_DLC,
     modelPar_given_DLC,
     modelPar_LLC,
     modelPar_given_LLC,
     modelPar_LWC,
     modelPar_given_LWC,
     modelPar_LWLC,
     modelPar_given_LWLC,
     modelPar_DWC,
     modelPar_given_DWC,
     modelPar_WLC,
     modelPar_given_WLC,
     modelPar_WWC,
     modelPar_given_WWC,
     modelPar_WWLC,
     modelPar_given_WWLC,
     modelPar_TOXE,
     modelPar_given_TOXE,
     modelPar_TOXP,
     modelPar_given_TOXP,
     modelPar_DTOX,
     modelPar_given_DTOX,
     modelPar_NDEP,
     modelPar_given_NDEP,
     modelPar_NDEPL1,
     modelPar_given_NDEPL1,
     modelPar_NDEPLEXP1,
     modelPar_given_NDEPLEXP1,
     modelPar_NDEPL2,
     modelPar_given_NDEPL2,
     modelPar_NDEPLEXP2,
     modelPar_given_NDEPLEXP2,
     modelPar_NDEPW,
     modelPar_given_NDEPW,
     modelPar_NDEPWEXP,
     modelPar_given_NDEPWEXP,
     modelPar_NDEPWL,
     modelPar_given_NDEPWL,
     modelPar_NDEPWLEXP,
     modelPar_given_NDEPWLEXP,
     modelPar_LNDEP,
     modelPar_given_LNDEP,
     modelPar_WNDEP,
     modelPar_given_WNDEP,
     modelPar_PNDEP,
     modelPar_given_PNDEP,
     modelPar_NDEPCV,
     modelPar_given_NDEPCV,
     modelPar_NDEPCVL1,
     modelPar_given_NDEPCVL1,
     modelPar_NDEPCVLEXP1,
     modelPar_given_NDEPCVLEXP1,
     modelPar_NDEPCVL2,
     modelPar_given_NDEPCVL2,
     modelPar_NDEPCVLEXP2,
     modelPar_given_NDEPCVLEXP2,
     modelPar_NDEPCVW,
     modelPar_given_NDEPCVW,
     modelPar_NDEPCVWEXP,
     modelPar_given_NDEPCVWEXP,
     modelPar_NDEPCVWL,
     modelPar_given_NDEPCVWL,
     modelPar_NDEPCVWLEXP,
     modelPar_given_NDEPCVWLEXP,
     modelPar_LNDEPCV,
     modelPar_given_LNDEPCV,
     modelPar_WNDEPCV,
     modelPar_given_WNDEPCV,
     modelPar_PNDEPCV,
     modelPar_given_PNDEPCV,
     modelPar_NGATE,
     modelPar_given_NGATE,
     modelPar_LNGATE,
     modelPar_given_LNGATE,
     modelPar_WNGATE,
     modelPar_given_WNGATE,
     modelPar_PNGATE,
     modelPar_given_PNGATE,
     modelPar_EASUB,
     modelPar_given_EASUB,
     modelPar_NI0SUB,
     modelPar_given_NI0SUB,
     modelPar_BG0SUB,
     modelPar_given_BG0SUB,
     modelPar_EPSRSUB,
     modelPar_given_EPSRSUB,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_XJ,
     modelPar_given_XJ,
     modelPar_LXJ,
     modelPar_given_LXJ,
     modelPar_WXJ,
     modelPar_given_WXJ,
     modelPar_PXJ,
     modelPar_given_PXJ,
     modelPar_LVFB,
     modelPar_given_LVFB,
     modelPar_WVFB,
     modelPar_given_WVFB,
     modelPar_PVFB,
     modelPar_given_PVFB,
     modelPar_VFB,
     modelPar_given_VFB,
     modelPar_VFBCV,
     modelPar_given_VFBCV,
     modelPar_LVFBCV,
     modelPar_given_LVFBCV,
     modelPar_WVFBCV,
     modelPar_given_WVFBCV,
     modelPar_PVFBCV,
     modelPar_given_PVFBCV,
     modelPar_VFBCVL,
     modelPar_given_VFBCVL,
     modelPar_VFBCVLEXP,
     modelPar_given_VFBCVLEXP,
     modelPar_VFBCVW,
     modelPar_given_VFBCVW,
     modelPar_VFBCVWEXP,
     modelPar_given_VFBCVWEXP,
     modelPar_VFBCVWL,
     modelPar_given_VFBCVWL,
     modelPar_VFBCVWLEXP,
     modelPar_given_VFBCVWLEXP,
     modelPar_DWJ,
     modelPar_given_DWJ,
     modelPar_NSD,
     modelPar_given_NSD,
     modelPar_LNSD,
     modelPar_given_LNSD,
     modelPar_WNSD,
     modelPar_given_WNSD,
     modelPar_PNSD,
     modelPar_given_PNSD,
     modelPar_DELVT0,
     modelPar_given_DELVT0,
     modelPar_DVTP0,
     modelPar_given_DVTP0,
     modelPar_LDVTP0,
     modelPar_given_LDVTP0,
     modelPar_WDVTP0,
     modelPar_given_WDVTP0,
     modelPar_PDVTP0,
     modelPar_given_PDVTP0,
     modelPar_DVTP1,
     modelPar_given_DVTP1,
     modelPar_LDVTP1,
     modelPar_given_LDVTP1,
     modelPar_WDVTP1,
     modelPar_given_WDVTP1,
     modelPar_PDVTP1,
     modelPar_given_PDVTP1,
     modelPar_DVTP2,
     modelPar_given_DVTP2,
     modelPar_LDVTP2,
     modelPar_given_LDVTP2,
     modelPar_WDVTP2,
     modelPar_given_WDVTP2,
     modelPar_PDVTP2,
     modelPar_given_PDVTP2,
     modelPar_DVTP3,
     modelPar_given_DVTP3,
     modelPar_LDVTP3,
     modelPar_given_LDVTP3,
     modelPar_WDVTP3,
     modelPar_given_WDVTP3,
     modelPar_PDVTP3,
     modelPar_given_PDVTP3,
     modelPar_DVTP4,
     modelPar_given_DVTP4,
     modelPar_LDVTP4,
     modelPar_given_LDVTP4,
     modelPar_WDVTP4,
     modelPar_given_WDVTP4,
     modelPar_PDVTP4,
     modelPar_given_PDVTP4,
     modelPar_DVTP5,
     modelPar_given_DVTP5,
     modelPar_LDVTP5,
     modelPar_given_LDVTP5,
     modelPar_WDVTP5,
     modelPar_given_WDVTP5,
     modelPar_PDVTP5,
     modelPar_given_PDVTP5,
     modelPar_PHIN,
     modelPar_given_PHIN,
     modelPar_LPHIN,
     modelPar_given_LPHIN,
     modelPar_WPHIN,
     modelPar_given_WPHIN,
     modelPar_PPHIN,
     modelPar_given_PPHIN,
     modelPar_ETA0,
     modelPar_given_ETA0,
     modelPar_LETA0,
     modelPar_given_LETA0,
     modelPar_WETA0,
     modelPar_given_WETA0,
     modelPar_PETA0,
     modelPar_given_PETA0,
     modelPar_ETA0R,
     modelPar_given_ETA0R,
     modelPar_LETA0R,
     modelPar_given_LETA0R,
     modelPar_WETA0R,
     modelPar_given_WETA0R,
     modelPar_PETA0R,
     modelPar_given_PETA0R,
     modelPar_DSUB,
     modelPar_given_DSUB,
     modelPar_ETAB,
     modelPar_given_ETAB,
     modelPar_ETABEXP,
     modelPar_given_ETABEXP,
     modelPar_LETAB,
     modelPar_given_LETAB,
     modelPar_WETAB,
     modelPar_given_WETAB,
     modelPar_PETAB,
     modelPar_given_PETAB,
     modelPar_K1,
     modelPar_given_K1,
     modelPar_K1L,
     modelPar_given_K1L,
     modelPar_K1LEXP,
     modelPar_given_K1LEXP,
     modelPar_K1W,
     modelPar_given_K1W,
     modelPar_K1WEXP,
     modelPar_given_K1WEXP,
     modelPar_K1WL,
     modelPar_given_K1WL,
     modelPar_K1WLEXP,
     modelPar_given_K1WLEXP,
     modelPar_LK1,
     modelPar_given_LK1,
     modelPar_WK1,
     modelPar_given_WK1,
     modelPar_PK1,
     modelPar_given_PK1,
     modelPar_K2,
     modelPar_given_K2,
     modelPar_K2L,
     modelPar_given_K2L,
     modelPar_K2LEXP,
     modelPar_given_K2LEXP,
     modelPar_K2W,
     modelPar_given_K2W,
     modelPar_K2WEXP,
     modelPar_given_K2WEXP,
     modelPar_K2WL,
     modelPar_given_K2WL,
     modelPar_K2WLEXP,
     modelPar_given_K2WLEXP,
     modelPar_LK2,
     modelPar_given_LK2,
     modelPar_WK2,
     modelPar_given_WK2,
     modelPar_PK2,
     modelPar_given_PK2,
     modelPar_ADOS,
     modelPar_given_ADOS,
     modelPar_BDOS,
     modelPar_given_BDOS,
     modelPar_QM0,
     modelPar_given_QM0,
     modelPar_ETAQM,
     modelPar_given_ETAQM,
     modelPar_CIT,
     modelPar_given_CIT,
     modelPar_LCIT,
     modelPar_given_LCIT,
     modelPar_WCIT,
     modelPar_given_WCIT,
     modelPar_PCIT,
     modelPar_given_PCIT,
     modelPar_NFACTOR,
     modelPar_given_NFACTOR,
     modelPar_NFACTORL,
     modelPar_given_NFACTORL,
     modelPar_NFACTORLEXP,
     modelPar_given_NFACTORLEXP,
     modelPar_NFACTORW,
     modelPar_given_NFACTORW,
     modelPar_NFACTORWEXP,
     modelPar_given_NFACTORWEXP,
     modelPar_NFACTORWL,
     modelPar_given_NFACTORWL,
     modelPar_NFACTORWLEXP,
     modelPar_given_NFACTORWLEXP,
     modelPar_LNFACTOR,
     modelPar_given_LNFACTOR,
     modelPar_WNFACTOR,
     modelPar_given_WNFACTOR,
     modelPar_PNFACTOR,
     modelPar_given_PNFACTOR,
     modelPar_CDSCD,
     modelPar_given_CDSCD,
     modelPar_CDSCDL,
     modelPar_given_CDSCDL,
     modelPar_CDSCDLEXP,
     modelPar_given_CDSCDLEXP,
     modelPar_LCDSCD,
     modelPar_given_LCDSCD,
     modelPar_WCDSCD,
     modelPar_given_WCDSCD,
     modelPar_PCDSCD,
     modelPar_given_PCDSCD,
     modelPar_CDSCDR,
     modelPar_given_CDSCDR,
     modelPar_CDSCDLR,
     modelPar_given_CDSCDLR,
     modelPar_LCDSCDR,
     modelPar_given_LCDSCDR,
     modelPar_WCDSCDR,
     modelPar_given_WCDSCDR,
     modelPar_PCDSCDR,
     modelPar_given_PCDSCDR,
     modelPar_CDSCB,
     modelPar_given_CDSCB,
     modelPar_CDSCBL,
     modelPar_given_CDSCBL,
     modelPar_CDSCBLEXP,
     modelPar_given_CDSCBLEXP,
     modelPar_LCDSCB,
     modelPar_given_LCDSCB,
     modelPar_WCDSCB,
     modelPar_given_WCDSCB,
     modelPar_PCDSCB,
     modelPar_given_PCDSCB,
     modelPar_VSAT,
     modelPar_given_VSAT,
     modelPar_LVSAT,
     modelPar_given_LVSAT,
     modelPar_WVSAT,
     modelPar_given_WVSAT,
     modelPar_PVSAT,
     modelPar_given_PVSAT,
     modelPar_VSATL,
     modelPar_given_VSATL,
     modelPar_VSATLEXP,
     modelPar_given_VSATLEXP,
     modelPar_VSATW,
     modelPar_given_VSATW,
     modelPar_VSATWEXP,
     modelPar_given_VSATWEXP,
     modelPar_VSATWL,
     modelPar_given_VSATWL,
     modelPar_VSATWLEXP,
     modelPar_given_VSATWLEXP,
     modelPar_VSATR,
     modelPar_given_VSATR,
     modelPar_LVSATR,
     modelPar_given_LVSATR,
     modelPar_WVSATR,
     modelPar_given_WVSATR,
     modelPar_PVSATR,
     modelPar_given_PVSATR,
     modelPar_DELTA,
     modelPar_given_DELTA,
     modelPar_LDELTA,
     modelPar_given_LDELTA,
     modelPar_WDELTA,
     modelPar_given_WDELTA,
     modelPar_PDELTA,
     modelPar_given_PDELTA,
     modelPar_DELTAL,
     modelPar_given_DELTAL,
     modelPar_DELTALEXP,
     modelPar_given_DELTALEXP,
     modelPar_VSATCV,
     modelPar_given_VSATCV,
     modelPar_LVSATCV,
     modelPar_given_LVSATCV,
     modelPar_WVSATCV,
     modelPar_given_WVSATCV,
     modelPar_PVSATCV,
     modelPar_given_PVSATCV,
     modelPar_VSATCVL,
     modelPar_given_VSATCVL,
     modelPar_VSATCVLEXP,
     modelPar_given_VSATCVLEXP,
     modelPar_VSATCVW,
     modelPar_given_VSATCVW,
     modelPar_VSATCVWEXP,
     modelPar_given_VSATCVWEXP,
     modelPar_VSATCVWL,
     modelPar_given_VSATCVWL,
     modelPar_VSATCVWLEXP,
     modelPar_given_VSATCVWLEXP,
     modelPar_UP1,
     modelPar_given_UP1,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_UP2,
     modelPar_given_UP2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_MULU0,
     modelPar_given_MULU0,
     modelPar_U0,
     modelPar_given_U0,
     modelPar_U0L,
     modelPar_given_U0L,
     modelPar_U0LEXP,
     modelPar_given_U0LEXP,
     modelPar_LU0,
     modelPar_given_LU0,
     modelPar_WU0,
     modelPar_given_WU0,
     modelPar_PU0,
     modelPar_given_PU0,
     modelPar_U0R,
     modelPar_given_U0R,
     modelPar_LU0R,
     modelPar_given_LU0R,
     modelPar_WU0R,
     modelPar_given_WU0R,
     modelPar_PU0R,
     modelPar_given_PU0R,
     modelPar_ETAMOB,
     modelPar_given_ETAMOB,
     modelPar_UA,
     modelPar_given_UA,
     modelPar_UAL,
     modelPar_given_UAL,
     modelPar_UALEXP,
     modelPar_given_UALEXP,
     modelPar_UAW,
     modelPar_given_UAW,
     modelPar_UAWEXP,
     modelPar_given_UAWEXP,
     modelPar_UAWL,
     modelPar_given_UAWL,
     modelPar_UAWLEXP,
     modelPar_given_UAWLEXP,
     modelPar_LUA,
     modelPar_given_LUA,
     modelPar_WUA,
     modelPar_given_WUA,
     modelPar_PUA,
     modelPar_given_PUA,
     modelPar_UAR,
     modelPar_given_UAR,
     modelPar_LUAR,
     modelPar_given_LUAR,
     modelPar_WUAR,
     modelPar_given_WUAR,
     modelPar_PUAR,
     modelPar_given_PUAR,
     modelPar_EU,
     modelPar_given_EU,
     modelPar_LEU,
     modelPar_given_LEU,
     modelPar_WEU,
     modelPar_given_WEU,
     modelPar_PEU,
     modelPar_given_PEU,
     modelPar_EUL,
     modelPar_given_EUL,
     modelPar_EULEXP,
     modelPar_given_EULEXP,
     modelPar_EUW,
     modelPar_given_EUW,
     modelPar_EUWEXP,
     modelPar_given_EUWEXP,
     modelPar_EUWL,
     modelPar_given_EUWL,
     modelPar_EUWLEXP,
     modelPar_given_EUWLEXP,
     modelPar_UD,
     modelPar_given_UD,
     modelPar_UDL,
     modelPar_given_UDL,
     modelPar_UDLEXP,
     modelPar_given_UDLEXP,
     modelPar_LUD,
     modelPar_given_LUD,
     modelPar_WUD,
     modelPar_given_WUD,
     modelPar_PUD,
     modelPar_given_PUD,
     modelPar_UDR,
     modelPar_given_UDR,
     modelPar_LUDR,
     modelPar_given_LUDR,
     modelPar_WUDR,
     modelPar_given_WUDR,
     modelPar_PUDR,
     modelPar_given_PUDR,
     modelPar_UCS,
     modelPar_given_UCS,
     modelPar_LUCS,
     modelPar_given_LUCS,
     modelPar_WUCS,
     modelPar_given_WUCS,
     modelPar_PUCS,
     modelPar_given_PUCS,
     modelPar_UCSR,
     modelPar_given_UCSR,
     modelPar_LUCSR,
     modelPar_given_LUCSR,
     modelPar_WUCSR,
     modelPar_given_WUCSR,
     modelPar_PUCSR,
     modelPar_given_PUCSR,
     modelPar_UC,
     modelPar_given_UC,
     modelPar_UCL,
     modelPar_given_UCL,
     modelPar_UCLEXP,
     modelPar_given_UCLEXP,
     modelPar_UCW,
     modelPar_given_UCW,
     modelPar_UCWEXP,
     modelPar_given_UCWEXP,
     modelPar_UCWL,
     modelPar_given_UCWL,
     modelPar_UCWLEXP,
     modelPar_given_UCWLEXP,
     modelPar_LUC,
     modelPar_given_LUC,
     modelPar_WUC,
     modelPar_given_WUC,
     modelPar_PUC,
     modelPar_given_PUC,
     modelPar_UCR,
     modelPar_given_UCR,
     modelPar_LUCR,
     modelPar_given_LUCR,
     modelPar_WUCR,
     modelPar_given_WUCR,
     modelPar_PUCR,
     modelPar_given_PUCR,
     modelPar_PCLM,
     modelPar_given_PCLM,
     modelPar_PCLML,
     modelPar_given_PCLML,
     modelPar_PCLMLEXP,
     modelPar_given_PCLMLEXP,
     modelPar_LPCLM,
     modelPar_given_LPCLM,
     modelPar_WPCLM,
     modelPar_given_WPCLM,
     modelPar_PPCLM,
     modelPar_given_PPCLM,
     modelPar_PCLMR,
     modelPar_given_PCLMR,
     modelPar_LPCLMR,
     modelPar_given_LPCLMR,
     modelPar_WPCLMR,
     modelPar_given_WPCLMR,
     modelPar_PPCLMR,
     modelPar_given_PPCLMR,
     modelPar_PCLMG,
     modelPar_given_PCLMG,
     modelPar_PCLMCV,
     modelPar_given_PCLMCV,
     modelPar_PCLMCVL,
     modelPar_given_PCLMCVL,
     modelPar_PCLMCVLEXP,
     modelPar_given_PCLMCVLEXP,
     modelPar_LPCLMCV,
     modelPar_given_LPCLMCV,
     modelPar_WPCLMCV,
     modelPar_given_WPCLMCV,
     modelPar_PPCLMCV,
     modelPar_given_PPCLMCV,
     modelPar_PSCBE1,
     modelPar_given_PSCBE1,
     modelPar_LPSCBE1,
     modelPar_given_LPSCBE1,
     modelPar_WPSCBE1,
     modelPar_given_WPSCBE1,
     modelPar_PPSCBE1,
     modelPar_given_PPSCBE1,
     modelPar_PSCBE2,
     modelPar_given_PSCBE2,
     modelPar_LPSCBE2,
     modelPar_given_LPSCBE2,
     modelPar_WPSCBE2,
     modelPar_given_WPSCBE2,
     modelPar_PPSCBE2,
     modelPar_given_PPSCBE2,
     modelPar_PDITS,
     modelPar_given_PDITS,
     modelPar_LPDITS,
     modelPar_given_LPDITS,
     modelPar_WPDITS,
     modelPar_given_WPDITS,
     modelPar_PPDITS,
     modelPar_given_PPDITS,
     modelPar_PDITSL,
     modelPar_given_PDITSL,
     modelPar_PDITSD,
     modelPar_given_PDITSD,
     modelPar_LPDITSD,
     modelPar_given_LPDITSD,
     modelPar_WPDITSD,
     modelPar_given_WPDITSD,
     modelPar_PPDITSD,
     modelPar_given_PPDITSD,
     modelPar_RSH,
     modelPar_given_RSH,
     modelPar_PRWG,
     modelPar_given_PRWG,
     modelPar_LPRWG,
     modelPar_given_LPRWG,
     modelPar_WPRWG,
     modelPar_given_WPRWG,
     modelPar_PPRWG,
     modelPar_given_PPRWG,
     modelPar_PRWB,
     modelPar_given_PRWB,
     modelPar_LPRWB,
     modelPar_given_LPRWB,
     modelPar_WPRWB,
     modelPar_given_WPRWB,
     modelPar_PPRWB,
     modelPar_given_PPRWB,
     modelPar_PRWBL,
     modelPar_given_PRWBL,
     modelPar_PRWBLEXP,
     modelPar_given_PRWBLEXP,
     modelPar_WR,
     modelPar_given_WR,
     modelPar_LWR,
     modelPar_given_LWR,
     modelPar_WWR,
     modelPar_given_WWR,
     modelPar_PWR,
     modelPar_given_PWR,
     modelPar_RSWMIN,
     modelPar_given_RSWMIN,
     modelPar_LRSWMIN,
     modelPar_given_LRSWMIN,
     modelPar_WRSWMIN,
     modelPar_given_WRSWMIN,
     modelPar_PRSWMIN,
     modelPar_given_PRSWMIN,
     modelPar_RSW,
     modelPar_given_RSW,
     modelPar_LRSW,
     modelPar_given_LRSW,
     modelPar_WRSW,
     modelPar_given_WRSW,
     modelPar_PRSW,
     modelPar_given_PRSW,
     modelPar_RSWL,
     modelPar_given_RSWL,
     modelPar_RSWLEXP,
     modelPar_given_RSWLEXP,
     modelPar_RDWMIN,
     modelPar_given_RDWMIN,
     modelPar_LRDWMIN,
     modelPar_given_LRDWMIN,
     modelPar_WRDWMIN,
     modelPar_given_WRDWMIN,
     modelPar_PRDWMIN,
     modelPar_given_PRDWMIN,
     modelPar_RDW,
     modelPar_given_RDW,
     modelPar_LRDW,
     modelPar_given_LRDW,
     modelPar_WRDW,
     modelPar_given_WRDW,
     modelPar_PRDW,
     modelPar_given_PRDW,
     modelPar_RDWL,
     modelPar_given_RDWL,
     modelPar_RDWLEXP,
     modelPar_given_RDWLEXP,
     modelPar_RDSWMIN,
     modelPar_given_RDSWMIN,
     modelPar_LRDSWMIN,
     modelPar_given_LRDSWMIN,
     modelPar_WRDSWMIN,
     modelPar_given_WRDSWMIN,
     modelPar_PRDSWMIN,
     modelPar_given_PRDSWMIN,
     modelPar_RDSW,
     modelPar_given_RDSW,
     modelPar_RDSWL,
     modelPar_given_RDSWL,
     modelPar_RDSWLEXP,
     modelPar_given_RDSWLEXP,
     modelPar_LRDSW,
     modelPar_given_LRDSW,
     modelPar_WRDSW,
     modelPar_given_WRDSW,
     modelPar_PRDSW,
     modelPar_given_PRDSW,
     modelPar_PSAT,
     modelPar_given_PSAT,
     modelPar_LPSAT,
     modelPar_given_LPSAT,
     modelPar_WPSAT,
     modelPar_given_WPSAT,
     modelPar_PPSAT,
     modelPar_given_PPSAT,
     modelPar_PSATL,
     modelPar_given_PSATL,
     modelPar_PSATLEXP,
     modelPar_given_PSATLEXP,
     modelPar_PSATB,
     modelPar_given_PSATB,
     modelPar_PSATR,
     modelPar_given_PSATR,
     modelPar_LPSATR,
     modelPar_given_LPSATR,
     modelPar_WPSATR,
     modelPar_given_WPSATR,
     modelPar_PPSATR,
     modelPar_given_PPSATR,
     modelPar_LPSATB,
     modelPar_given_LPSATB,
     modelPar_WPSATB,
     modelPar_given_WPSATB,
     modelPar_PPSATB,
     modelPar_given_PPSATB,
     modelPar_PSATX,
     modelPar_given_PSATX,
     modelPar_PTWG,
     modelPar_given_PTWG,
     modelPar_LPTWG,
     modelPar_given_LPTWG,
     modelPar_WPTWG,
     modelPar_given_WPTWG,
     modelPar_PPTWG,
     modelPar_given_PPTWG,
     modelPar_PTWGL,
     modelPar_given_PTWGL,
     modelPar_PTWGLEXP,
     modelPar_given_PTWGLEXP,
     modelPar_PTWGR,
     modelPar_given_PTWGR,
     modelPar_LPTWGR,
     modelPar_given_LPTWGR,
     modelPar_WPTWGR,
     modelPar_given_WPTWGR,
     modelPar_PPTWGR,
     modelPar_given_PPTWGR,
     modelPar_PTWGLR,
     modelPar_given_PTWGLR,
     modelPar_PTWGLEXPR,
     modelPar_given_PTWGLEXPR,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_LA1,
     modelPar_given_LA1,
     modelPar_WA1,
     modelPar_given_WA1,
     modelPar_PA1,
     modelPar_given_PA1,
     modelPar_A11,
     modelPar_given_A11,
     modelPar_LA11,
     modelPar_given_LA11,
     modelPar_WA11,
     modelPar_given_WA11,
     modelPar_PA11,
     modelPar_given_PA11,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_LA2,
     modelPar_given_LA2,
     modelPar_WA2,
     modelPar_given_WA2,
     modelPar_PA2,
     modelPar_given_PA2,
     modelPar_A21,
     modelPar_given_A21,
     modelPar_LA21,
     modelPar_given_LA21,
     modelPar_WA21,
     modelPar_given_WA21,
     modelPar_PA21,
     modelPar_given_PA21,
     modelPar_PDIBLC,
     modelPar_given_PDIBLC,
     modelPar_PDIBLCL,
     modelPar_given_PDIBLCL,
     modelPar_PDIBLCLEXP,
     modelPar_given_PDIBLCLEXP,
     modelPar_LPDIBLC,
     modelPar_given_LPDIBLC,
     modelPar_WPDIBLC,
     modelPar_given_WPDIBLC,
     modelPar_PPDIBLC,
     modelPar_given_PPDIBLC,
     modelPar_PDIBLCR,
     modelPar_given_PDIBLCR,
     modelPar_PDIBLCLR,
     modelPar_given_PDIBLCLR,
     modelPar_PDIBLCLEXPR,
     modelPar_given_PDIBLCLEXPR,
     modelPar_LPDIBLCR,
     modelPar_given_LPDIBLCR,
     modelPar_WPDIBLCR,
     modelPar_given_WPDIBLCR,
     modelPar_PPDIBLCR,
     modelPar_given_PPDIBLCR,
     modelPar_PDIBLCB,
     modelPar_given_PDIBLCB,
     modelPar_LPDIBLCB,
     modelPar_given_LPDIBLCB,
     modelPar_WPDIBLCB,
     modelPar_given_WPDIBLCB,
     modelPar_PPDIBLCB,
     modelPar_given_PPDIBLCB,
     modelPar_PVAG,
     modelPar_given_PVAG,
     modelPar_LPVAG,
     modelPar_given_LPVAG,
     modelPar_WPVAG,
     modelPar_given_WPVAG,
     modelPar_PPVAG,
     modelPar_given_PPVAG,
     modelPar_FPROUT,
     modelPar_given_FPROUT,
     modelPar_FPROUTL,
     modelPar_given_FPROUTL,
     modelPar_FPROUTLEXP,
     modelPar_given_FPROUTLEXP,
     modelPar_LFPROUT,
     modelPar_given_LFPROUT,
     modelPar_WFPROUT,
     modelPar_given_WFPROUT,
     modelPar_PFPROUT,
     modelPar_given_PFPROUT,
     modelPar_ALPHA0,
     modelPar_given_ALPHA0,
     modelPar_ALPHA0L,
     modelPar_given_ALPHA0L,
     modelPar_ALPHA0LEXP,
     modelPar_given_ALPHA0LEXP,
     modelPar_LALPHA0,
     modelPar_given_LALPHA0,
     modelPar_WALPHA0,
     modelPar_given_WALPHA0,
     modelPar_PALPHA0,
     modelPar_given_PALPHA0,
     modelPar_BETA0,
     modelPar_given_BETA0,
     modelPar_LBETA0,
     modelPar_given_LBETA0,
     modelPar_WBETA0,
     modelPar_given_WBETA0,
     modelPar_PBETA0,
     modelPar_given_PBETA0,
     modelPar_AIGBACC,
     modelPar_given_AIGBACC,
     modelPar_BIGBACC,
     modelPar_given_BIGBACC,
     modelPar_CIGBACC,
     modelPar_given_CIGBACC,
     modelPar_NIGBACC,
     modelPar_given_NIGBACC,
     modelPar_AIGBINV,
     modelPar_given_AIGBINV,
     modelPar_BIGBINV,
     modelPar_given_BIGBINV,
     modelPar_CIGBINV,
     modelPar_given_CIGBINV,
     modelPar_EIGBINV,
     modelPar_given_EIGBINV,
     modelPar_NIGBINV,
     modelPar_given_NIGBINV,
     modelPar_AIGC,
     modelPar_given_AIGC,
     modelPar_BIGC,
     modelPar_given_BIGC,
     modelPar_CIGC,
     modelPar_given_CIGC,
     modelPar_AIGS,
     modelPar_given_AIGS,
     modelPar_BIGS,
     modelPar_given_BIGS,
     modelPar_CIGS,
     modelPar_given_CIGS,
     modelPar_AIGD,
     modelPar_given_AIGD,
     modelPar_BIGD,
     modelPar_given_BIGD,
     modelPar_CIGD,
     modelPar_given_CIGD,
     modelPar_DLCIG,
     modelPar_given_DLCIG,
     modelPar_DLCIGD,
     modelPar_given_DLCIGD,
     modelPar_POXEDGE,
     modelPar_given_POXEDGE,
     modelPar_NTOX,
     modelPar_given_NTOX,
     modelPar_TOXREF,
     modelPar_given_TOXREF,
     modelPar_PIGCD,
     modelPar_given_PIGCD,
     modelPar_AIGCL,
     modelPar_given_AIGCL,
     modelPar_AIGCW,
     modelPar_given_AIGCW,
     modelPar_AIGSL,
     modelPar_given_AIGSL,
     modelPar_AIGSW,
     modelPar_given_AIGSW,
     modelPar_AIGDL,
     modelPar_given_AIGDL,
     modelPar_AIGDW,
     modelPar_given_AIGDW,
     modelPar_PIGCDL,
     modelPar_given_PIGCDL,
     modelPar_LAIGBINV,
     modelPar_given_LAIGBINV,
     modelPar_WAIGBINV,
     modelPar_given_WAIGBINV,
     modelPar_PAIGBINV,
     modelPar_given_PAIGBINV,
     modelPar_LBIGBINV,
     modelPar_given_LBIGBINV,
     modelPar_WBIGBINV,
     modelPar_given_WBIGBINV,
     modelPar_PBIGBINV,
     modelPar_given_PBIGBINV,
     modelPar_LCIGBINV,
     modelPar_given_LCIGBINV,
     modelPar_WCIGBINV,
     modelPar_given_WCIGBINV,
     modelPar_PCIGBINV,
     modelPar_given_PCIGBINV,
     modelPar_LEIGBINV,
     modelPar_given_LEIGBINV,
     modelPar_WEIGBINV,
     modelPar_given_WEIGBINV,
     modelPar_PEIGBINV,
     modelPar_given_PEIGBINV,
     modelPar_LNIGBINV,
     modelPar_given_LNIGBINV,
     modelPar_WNIGBINV,
     modelPar_given_WNIGBINV,
     modelPar_PNIGBINV,
     modelPar_given_PNIGBINV,
     modelPar_LAIGBACC,
     modelPar_given_LAIGBACC,
     modelPar_WAIGBACC,
     modelPar_given_WAIGBACC,
     modelPar_PAIGBACC,
     modelPar_given_PAIGBACC,
     modelPar_LBIGBACC,
     modelPar_given_LBIGBACC,
     modelPar_WBIGBACC,
     modelPar_given_WBIGBACC,
     modelPar_PBIGBACC,
     modelPar_given_PBIGBACC,
     modelPar_LCIGBACC,
     modelPar_given_LCIGBACC,
     modelPar_WCIGBACC,
     modelPar_given_WCIGBACC,
     modelPar_PCIGBACC,
     modelPar_given_PCIGBACC,
     modelPar_LNIGBACC,
     modelPar_given_LNIGBACC,
     modelPar_WNIGBACC,
     modelPar_given_WNIGBACC,
     modelPar_PNIGBACC,
     modelPar_given_PNIGBACC,
     modelPar_LAIGC,
     modelPar_given_LAIGC,
     modelPar_WAIGC,
     modelPar_given_WAIGC,
     modelPar_PAIGC,
     modelPar_given_PAIGC,
     modelPar_LBIGC,
     modelPar_given_LBIGC,
     modelPar_WBIGC,
     modelPar_given_WBIGC,
     modelPar_PBIGC,
     modelPar_given_PBIGC,
     modelPar_LCIGC,
     modelPar_given_LCIGC,
     modelPar_WCIGC,
     modelPar_given_WCIGC,
     modelPar_PCIGC,
     modelPar_given_PCIGC,
     modelPar_LAIGS,
     modelPar_given_LAIGS,
     modelPar_WAIGS,
     modelPar_given_WAIGS,
     modelPar_PAIGS,
     modelPar_given_PAIGS,
     modelPar_LBIGS,
     modelPar_given_LBIGS,
     modelPar_WBIGS,
     modelPar_given_WBIGS,
     modelPar_PBIGS,
     modelPar_given_PBIGS,
     modelPar_LCIGS,
     modelPar_given_LCIGS,
     modelPar_WCIGS,
     modelPar_given_WCIGS,
     modelPar_PCIGS,
     modelPar_given_PCIGS,
     modelPar_LAIGD,
     modelPar_given_LAIGD,
     modelPar_WAIGD,
     modelPar_given_WAIGD,
     modelPar_PAIGD,
     modelPar_given_PAIGD,
     modelPar_LBIGD,
     modelPar_given_LBIGD,
     modelPar_WBIGD,
     modelPar_given_WBIGD,
     modelPar_PBIGD,
     modelPar_given_PBIGD,
     modelPar_LCIGD,
     modelPar_given_LCIGD,
     modelPar_WCIGD,
     modelPar_given_WCIGD,
     modelPar_PCIGD,
     modelPar_given_PCIGD,
     modelPar_LPOXEDGE,
     modelPar_given_LPOXEDGE,
     modelPar_WPOXEDGE,
     modelPar_given_WPOXEDGE,
     modelPar_PPOXEDGE,
     modelPar_given_PPOXEDGE,
     modelPar_LDLCIG,
     modelPar_given_LDLCIG,
     modelPar_WDLCIG,
     modelPar_given_WDLCIG,
     modelPar_PDLCIG,
     modelPar_given_PDLCIG,
     modelPar_LDLCIGD,
     modelPar_given_LDLCIGD,
     modelPar_WDLCIGD,
     modelPar_given_WDLCIGD,
     modelPar_PDLCIGD,
     modelPar_given_PDLCIGD,
     modelPar_LNTOX,
     modelPar_given_LNTOX,
     modelPar_WNTOX,
     modelPar_given_WNTOX,
     modelPar_PNTOX,
     modelPar_given_PNTOX,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_AGIDLL,
     modelPar_given_AGIDLL,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_LAGIDL,
     modelPar_given_LAGIDL,
     modelPar_WAGIDL,
     modelPar_given_WAGIDL,
     modelPar_PAGIDL,
     modelPar_given_PAGIDL,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_LBGIDL,
     modelPar_given_LBGIDL,
     modelPar_WBGIDL,
     modelPar_given_WBGIDL,
     modelPar_PBGIDL,
     modelPar_given_PBGIDL,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_LCGIDL,
     modelPar_given_LCGIDL,
     modelPar_WCGIDL,
     modelPar_given_WCGIDL,
     modelPar_PCGIDL,
     modelPar_given_PCGIDL,
     modelPar_EGIDL,
     modelPar_given_EGIDL,
     modelPar_LEGIDL,
     modelPar_given_LEGIDL,
     modelPar_WEGIDL,
     modelPar_given_WEGIDL,
     modelPar_PEGIDL,
     modelPar_given_PEGIDL,
     modelPar_AGISL,
     modelPar_given_AGISL,
     modelPar_AGISLL,
     modelPar_given_AGISLL,
     modelPar_AGISLW,
     modelPar_given_AGISLW,
     modelPar_LAGISL,
     modelPar_given_LAGISL,
     modelPar_WAGISL,
     modelPar_given_WAGISL,
     modelPar_PAGISL,
     modelPar_given_PAGISL,
     modelPar_BGISL,
     modelPar_given_BGISL,
     modelPar_LBGISL,
     modelPar_given_LBGISL,
     modelPar_WBGISL,
     modelPar_given_WBGISL,
     modelPar_PBGISL,
     modelPar_given_PBGISL,
     modelPar_CGISL,
     modelPar_given_CGISL,
     modelPar_LCGISL,
     modelPar_given_LCGISL,
     modelPar_WCGISL,
     modelPar_given_WCGISL,
     modelPar_PCGISL,
     modelPar_given_PCGISL,
     modelPar_EGISL,
     modelPar_given_EGISL,
     modelPar_LEGISL,
     modelPar_given_LEGISL,
     modelPar_WEGISL,
     modelPar_given_WEGISL,
     modelPar_PEGISL,
     modelPar_given_PEGISL,
     modelPar_CF,
     modelPar_given_CF,
     modelPar_LCF,
     modelPar_given_LCF,
     modelPar_WCF,
     modelPar_given_WCF,
     modelPar_PCF,
     modelPar_given_PCF,
     modelPar_CFRCOEFF,
     modelPar_given_CFRCOEFF,
     modelPar_CGSO,
     modelPar_given_CGSO,
     modelPar_CGDO,
     modelPar_given_CGDO,
     modelPar_CGBO,
     modelPar_given_CGBO,
     modelPar_CGSL,
     modelPar_given_CGSL,
     modelPar_LCGSL,
     modelPar_given_LCGSL,
     modelPar_WCGSL,
     modelPar_given_WCGSL,
     modelPar_PCGSL,
     modelPar_given_PCGSL,
     modelPar_CGDL,
     modelPar_given_CGDL,
     modelPar_LCGDL,
     modelPar_given_LCGDL,
     modelPar_WCGDL,
     modelPar_given_WCGDL,
     modelPar_PCGDL,
     modelPar_given_PCGDL,
     modelPar_CKAPPAS,
     modelPar_given_CKAPPAS,
     modelPar_LCKAPPAS,
     modelPar_given_LCKAPPAS,
     modelPar_WCKAPPAS,
     modelPar_given_WCKAPPAS,
     modelPar_PCKAPPAS,
     modelPar_given_PCKAPPAS,
     modelPar_CKAPPAD,
     modelPar_given_CKAPPAD,
     modelPar_LCKAPPAD,
     modelPar_given_LCKAPPAD,
     modelPar_WCKAPPAD,
     modelPar_given_WCKAPPAD,
     modelPar_PCKAPPAD,
     modelPar_given_PCKAPPAD,
     modelPar_DMCG,
     modelPar_given_DMCG,
     modelPar_DMCI,
     modelPar_given_DMCI,
     modelPar_DMDG,
     modelPar_given_DMDG,
     modelPar_DMCGT,
     modelPar_given_DMCGT,
     modelPar_XGL,
     modelPar_given_XGL,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_CJD,
     modelPar_given_CJD,
     modelPar_CJSWS,
     modelPar_given_CJSWS,
     modelPar_CJSWD,
     modelPar_given_CJSWD,
     modelPar_CJSWGS,
     modelPar_given_CJSWGS,
     modelPar_CJSWGD,
     modelPar_given_CJSWGD,
     modelPar_PBS,
     modelPar_given_PBS,
     modelPar_PBD,
     modelPar_given_PBD,
     modelPar_PBSWS,
     modelPar_given_PBSWS,
     modelPar_PBSWD,
     modelPar_given_PBSWD,
     modelPar_PBSWGS,
     modelPar_given_PBSWGS,
     modelPar_PBSWGD,
     modelPar_given_PBSWGD,
     modelPar_MJS,
     modelPar_given_MJS,
     modelPar_MJD,
     modelPar_given_MJD,
     modelPar_MJSWS,
     modelPar_given_MJSWS,
     modelPar_MJSWD,
     modelPar_given_MJSWD,
     modelPar_MJSWGS,
     modelPar_given_MJSWGS,
     modelPar_MJSWGD,
     modelPar_given_MJSWGD,
     modelPar_JSS,
     modelPar_given_JSS,
     modelPar_JSD,
     modelPar_given_JSD,
     modelPar_JSWS,
     modelPar_given_JSWS,
     modelPar_JSWD,
     modelPar_given_JSWD,
     modelPar_JSWGS,
     modelPar_given_JSWGS,
     modelPar_JSWGD,
     modelPar_given_JSWGD,
     modelPar_NJS,
     modelPar_given_NJS,
     modelPar_NJD,
     modelPar_given_NJD,
     modelPar_IJTHSFWD,
     modelPar_given_IJTHSFWD,
     modelPar_IJTHDFWD,
     modelPar_given_IJTHDFWD,
     modelPar_IJTHSREV,
     modelPar_given_IJTHSREV,
     modelPar_IJTHDREV,
     modelPar_given_IJTHDREV,
     modelPar_BVS,
     modelPar_given_BVS,
     modelPar_BVD,
     modelPar_given_BVD,
     modelPar_XJBVS,
     modelPar_given_XJBVS,
     modelPar_XJBVD,
     modelPar_given_XJBVD,
     modelPar_JTSS,
     modelPar_given_JTSS,
     modelPar_JTSD,
     modelPar_given_JTSD,
     modelPar_JTSSWS,
     modelPar_given_JTSSWS,
     modelPar_JTSSWD,
     modelPar_given_JTSSWD,
     modelPar_JTSSWGS,
     modelPar_given_JTSSWGS,
     modelPar_JTSSWGD,
     modelPar_given_JTSSWGD,
     modelPar_JTWEFF,
     modelPar_given_JTWEFF,
     modelPar_NJTS,
     modelPar_given_NJTS,
     modelPar_NJTSD,
     modelPar_given_NJTSD,
     modelPar_NJTSSW,
     modelPar_given_NJTSSW,
     modelPar_NJTSSWD,
     modelPar_given_NJTSSWD,
     modelPar_NJTSSWG,
     modelPar_given_NJTSSWG,
     modelPar_NJTSSWGD,
     modelPar_given_NJTSSWGD,
     modelPar_VTSS,
     modelPar_given_VTSS,
     modelPar_VTSD,
     modelPar_given_VTSD,
     modelPar_VTSSWS,
     modelPar_given_VTSSWS,
     modelPar_VTSSWD,
     modelPar_given_VTSSWD,
     modelPar_VTSSWGS,
     modelPar_given_VTSSWGS,
     modelPar_VTSSWGD,
     modelPar_given_VTSSWGD,
     modelPar_XRCRG1,
     modelPar_given_XRCRG1,
     modelPar_XRCRG2,
     modelPar_given_XRCRG2,
     modelPar_GBMIN,
     modelPar_given_GBMIN,
     modelPar_RBPS0,
     modelPar_given_RBPS0,
     modelPar_RBPSL,
     modelPar_given_RBPSL,
     modelPar_RBPSW,
     modelPar_given_RBPSW,
     modelPar_RBPSNF,
     modelPar_given_RBPSNF,
     modelPar_RBPD0,
     modelPar_given_RBPD0,
     modelPar_RBPDL,
     modelPar_given_RBPDL,
     modelPar_RBPDW,
     modelPar_given_RBPDW,
     modelPar_RBPDNF,
     modelPar_given_RBPDNF,
     modelPar_RBPBX0,
     modelPar_given_RBPBX0,
     modelPar_RBPBXL,
     modelPar_given_RBPBXL,
     modelPar_RBPBXW,
     modelPar_given_RBPBXW,
     modelPar_RBPBXNF,
     modelPar_given_RBPBXNF,
     modelPar_RBPBY0,
     modelPar_given_RBPBY0,
     modelPar_RBPBYL,
     modelPar_given_RBPBYL,
     modelPar_RBPBYW,
     modelPar_given_RBPBYW,
     modelPar_RBPBYNF,
     modelPar_given_RBPBYNF,
     modelPar_RBSBX0,
     modelPar_given_RBSBX0,
     modelPar_RBSBY0,
     modelPar_given_RBSBY0,
     modelPar_RBDBX0,
     modelPar_given_RBDBX0,
     modelPar_RBDBY0,
     modelPar_given_RBDBY0,
     modelPar_RBSDBXL,
     modelPar_given_RBSDBXL,
     modelPar_RBSDBXW,
     modelPar_given_RBSDBXW,
     modelPar_RBSDBXNF,
     modelPar_given_RBSDBXNF,
     modelPar_RBSDBYL,
     modelPar_given_RBSDBYL,
     modelPar_RBSDBYW,
     modelPar_given_RBSDBYW,
     modelPar_RBSDBYNF,
     modelPar_given_RBSDBYNF,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_EM,
     modelPar_given_EM,
     modelPar_NOIA,
     modelPar_given_NOIA,
     modelPar_NOIB,
     modelPar_given_NOIB,
     modelPar_NOIC,
     modelPar_given_NOIC,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_NTNOI,
     modelPar_given_NTNOI,
     modelPar_RNOIA,
     modelPar_given_RNOIA,
     modelPar_RNOIB,
     modelPar_given_RNOIB,
     modelPar_RNOIC,
     modelPar_given_RNOIC,
     modelPar_TNOIA,
     modelPar_given_TNOIA,
     modelPar_TNOIB,
     modelPar_given_TNOIB,
     modelPar_TNOIC,
     modelPar_given_TNOIC,
     modelPar_DLBIN,
     modelPar_given_DLBIN,
     modelPar_DWBIN,
     modelPar_given_DWBIN,
     modelPar_TNOM,
     modelPar_given_TNOM,
     modelPar_DTEMP,
     modelPar_given_DTEMP,
     modelPar_TBGASUB,
     modelPar_given_TBGASUB,
     modelPar_TBGBSUB,
     modelPar_given_TBGBSUB,
     modelPar_TNFACTOR,
     modelPar_given_TNFACTOR,
     modelPar_UTE,
     modelPar_given_UTE,
     modelPar_LUTE,
     modelPar_given_LUTE,
     modelPar_WUTE,
     modelPar_given_WUTE,
     modelPar_PUTE,
     modelPar_given_PUTE,
     modelPar_UTEL,
     modelPar_given_UTEL,
     modelPar_UA1,
     modelPar_given_UA1,
     modelPar_LUA1,
     modelPar_given_LUA1,
     modelPar_WUA1,
     modelPar_given_WUA1,
     modelPar_PUA1,
     modelPar_given_PUA1,
     modelPar_UA1L,
     modelPar_given_UA1L,
     modelPar_UC1,
     modelPar_given_UC1,
     modelPar_LUC1,
     modelPar_given_LUC1,
     modelPar_WUC1,
     modelPar_given_WUC1,
     modelPar_PUC1,
     modelPar_given_PUC1,
     modelPar_UD1,
     modelPar_given_UD1,
     modelPar_LUD1,
     modelPar_given_LUD1,
     modelPar_WUD1,
     modelPar_given_WUD1,
     modelPar_PUD1,
     modelPar_given_PUD1,
     modelPar_UD1L,
     modelPar_given_UD1L,
     modelPar_UCSTE,
     modelPar_given_UCSTE,
     modelPar_LUCSTE,
     modelPar_given_LUCSTE,
     modelPar_WUCSTE,
     modelPar_given_WUCSTE,
     modelPar_PUCSTE,
     modelPar_given_PUCSTE,
     modelPar_TETA0,
     modelPar_given_TETA0,
     modelPar_PRT,
     modelPar_given_PRT,
     modelPar_LPRT,
     modelPar_given_LPRT,
     modelPar_WPRT,
     modelPar_given_WPRT,
     modelPar_PPRT,
     modelPar_given_PPRT,
     modelPar_AT,
     modelPar_given_AT,
     modelPar_LAT,
     modelPar_given_LAT,
     modelPar_WAT,
     modelPar_given_WAT,
     modelPar_PAT,
     modelPar_given_PAT,
     modelPar_ATL,
     modelPar_given_ATL,
     modelPar_TDELTA,
     modelPar_given_TDELTA,
     modelPar_PTWGT,
     modelPar_given_PTWGT,
     modelPar_LPTWGT,
     modelPar_given_LPTWGT,
     modelPar_WPTWGT,
     modelPar_given_WPTWGT,
     modelPar_PPTWGT,
     modelPar_given_PPTWGT,
     modelPar_PTWGTL,
     modelPar_given_PTWGTL,
     modelPar_KT1,
     modelPar_given_KT1,
     modelPar_KT1EXP,
     modelPar_given_KT1EXP,
     modelPar_KT1L,
     modelPar_given_KT1L,
     modelPar_LKT1,
     modelPar_given_LKT1,
     modelPar_WKT1,
     modelPar_given_WKT1,
     modelPar_PKT1,
     modelPar_given_PKT1,
     modelPar_KT2,
     modelPar_given_KT2,
     modelPar_LKT2,
     modelPar_given_LKT2,
     modelPar_WKT2,
     modelPar_given_WKT2,
     modelPar_PKT2,
     modelPar_given_PKT2,
     modelPar_IIT,
     modelPar_given_IIT,
     modelPar_LIIT,
     modelPar_given_LIIT,
     modelPar_WIIT,
     modelPar_given_WIIT,
     modelPar_PIIT,
     modelPar_given_PIIT,
     modelPar_IGT,
     modelPar_given_IGT,
     modelPar_LIGT,
     modelPar_given_LIGT,
     modelPar_WIGT,
     modelPar_given_WIGT,
     modelPar_PIGT,
     modelPar_given_PIGT,
     modelPar_TGIDL,
     modelPar_given_TGIDL,
     modelPar_LTGIDL,
     modelPar_given_LTGIDL,
     modelPar_WTGIDL,
     modelPar_given_WTGIDL,
     modelPar_PTGIDL,
     modelPar_given_PTGIDL,
     modelPar_TCJ,
     modelPar_given_TCJ,
     modelPar_TCJSW,
     modelPar_given_TCJSW,
     modelPar_TCJSWG,
     modelPar_given_TCJSWG,
     modelPar_TPB,
     modelPar_given_TPB,
     modelPar_TPBSW,
     modelPar_given_TPBSW,
     modelPar_TPBSWG,
     modelPar_given_TPBSWG,
     modelPar_XTIS,
     modelPar_given_XTIS,
     modelPar_XTID,
     modelPar_given_XTID,
     modelPar_XTSS,
     modelPar_given_XTSS,
     modelPar_XTSD,
     modelPar_given_XTSD,
     modelPar_XTSSWS,
     modelPar_given_XTSSWS,
     modelPar_XTSSWD,
     modelPar_given_XTSSWD,
     modelPar_XTSSWGS,
     modelPar_given_XTSSWGS,
     modelPar_XTSSWGD,
     modelPar_given_XTSSWGD,
     modelPar_TNJTS,
     modelPar_given_TNJTS,
     modelPar_TNJTSD,
     modelPar_given_TNJTSD,
     modelPar_TNJTSSW,
     modelPar_given_TNJTSSW,
     modelPar_TNJTSSWD,
     modelPar_given_TNJTSSWD,
     modelPar_TNJTSSWG,
     modelPar_given_TNJTSSWG,
     modelPar_TNJTSSWGD,
     modelPar_given_TNJTSSWGD,
     modelPar_RTH0,
     modelPar_given_RTH0,
     modelPar_CTH0,
     modelPar_given_CTH0,
     modelPar_WTH0,
     modelPar_given_WTH0,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KU0,
     modelPar_given_KU0,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKU0,
     modelPar_given_TKU0,
     modelPar_LKU0,
     modelPar_given_LKU0,
     modelPar_WKU0,
     modelPar_given_WKU0,
     modelPar_PKU0,
     modelPar_given_PKU0,
     modelPar_LLODKU0,
     modelPar_given_LLODKU0,
     modelPar_WLODKU0,
     modelPar_given_WLODKU0,
     modelPar_KVTH0,
     modelPar_given_KVTH0,
     modelPar_LKVTH0,
     modelPar_given_LKVTH0,
     modelPar_WKVTH0,
     modelPar_given_WKVTH0,
     modelPar_PKVTH0,
     modelPar_given_PKVTH0,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STK2,
     modelPar_given_STK2,
     modelPar_LODK2,
     modelPar_given_LODK2,
     modelPar_STETA0,
     modelPar_given_STETA0,
     modelPar_LODETA0,
     modelPar_given_LODETA0,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_KVTH0WE,
     modelPar_given_KVTH0WE,
     modelPar_LKVTH0WE,
     modelPar_given_LKVTH0WE,
     modelPar_WKVTH0WE,
     modelPar_given_WKVTH0WE,
     modelPar_PKVTH0WE,
     modelPar_given_PKVTH0WE,
     modelPar_K2WE,
     modelPar_given_K2WE,
     modelPar_LK2WE,
     modelPar_given_LK2WE,
     modelPar_WK2WE,
     modelPar_given_WK2WE,
     modelPar_PK2WE,
     modelPar_given_PK2WE,
     modelPar_KU0WE,
     modelPar_given_KU0WE,
     modelPar_LKU0WE,
     modelPar_given_LKU0WE,
     modelPar_WKU0WE,
     modelPar_given_WKU0WE,
     modelPar_PKU0WE,
     modelPar_given_PKU0WE,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEDGE,
     modelPar_given_WEDGE,
     modelPar_DGAMMAEDGE,
     modelPar_given_DGAMMAEDGE,
     modelPar_DGAMMAEDGEL,
     modelPar_given_DGAMMAEDGEL,
     modelPar_DGAMMAEDGELEXP,
     modelPar_given_DGAMMAEDGELEXP,
     modelPar_DVTEDGE,
     modelPar_given_DVTEDGE,
     modelPar_NFACTOREDGE,
     modelPar_given_NFACTOREDGE,
     modelPar_CITEDGE,
     modelPar_given_CITEDGE,
     modelPar_CDSCDEDGE,
     modelPar_given_CDSCDEDGE,
     modelPar_CDSCBEDGE,
     modelPar_given_CDSCBEDGE,
     modelPar_ETA0EDGE,
     modelPar_given_ETA0EDGE,
     modelPar_ETABEDGE,
     modelPar_given_ETABEDGE,
     modelPar_KT1EDGE,
     modelPar_given_KT1EDGE,
     modelPar_KT1LEDGE,
     modelPar_given_KT1LEDGE,
     modelPar_KT2EDGE,
     modelPar_given_KT2EDGE,
     modelPar_KT1EXPEDGE,
     modelPar_given_KT1EXPEDGE,
     modelPar_TNFACTOREDGE,
     modelPar_given_TNFACTOREDGE,
     modelPar_TETA0EDGE,
     modelPar_given_TETA0EDGE,
     modelPar_DVT0EDGE,
     modelPar_given_DVT0EDGE,
     modelPar_DVT1EDGE,
     modelPar_given_DVT1EDGE,
     modelPar_DVT2EDGE,
     modelPar_given_DVT2EDGE,
     // non-reals (including hidden)
     modelPar_NGCON,
     modelPar_given_NGCON,
     modelPar_RGATEMOD,
     modelPar_given_RGATEMOD,
     modelPar_RBODYMOD,
     modelPar_given_RBODYMOD,
     modelPar_GEOMOD,
     modelPar_given_GEOMOD,
     modelPar_RGEOMOD,
     modelPar_given_RGEOMOD,
     modelPar_SCA,
     modelPar_given_SCA,
     modelPar_SCB,
     modelPar_given_SCB,
     modelPar_SCC,
     modelPar_given_SCC,
     modelPar_SC,
     modelPar_given_SC,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_CVMOD,
     modelPar_given_CVMOD,
     modelPar_COVMOD,
     modelPar_given_COVMOD,
     modelPar_RDSMOD,
     modelPar_given_RDSMOD,
     modelPar_WPEMOD,
     modelPar_given_WPEMOD,
     modelPar_ASYMMOD,
     modelPar_given_ASYMMOD,
     modelPar_GIDLMOD,
     modelPar_given_GIDLMOD,
     modelPar_IGCMOD,
     modelPar_given_IGCMOD,
     modelPar_IGBMOD,
     modelPar_given_IGBMOD,
     modelPar_TNOIMOD,
     modelPar_given_TNOIMOD,
     modelPar_SHMOD,
     modelPar_given_SHMOD,
     modelPar_MOBSCALE,
     modelPar_given_MOBSCALE,
     modelPar_PERMOD,
     modelPar_given_PERMOD,
     modelPar_BINUNIT,
     modelPar_given_BINUNIT,
     modelPar_EDGEFET,
     modelPar_given_EDGEFET,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_d] += staticContributions[in.admsNodeID_d].dx(0);
  dqdp[in.admsNodeID_d] += dynamicContributions[in.admsNodeID_d].dx(0);
  Findices[in.admsNodeID_d] = in.li_d;
  Qindices[in.admsNodeID_d] = in.li_d;
  dfdp[in.admsNodeID_g] += staticContributions[in.admsNodeID_g].dx(0);
  dqdp[in.admsNodeID_g] += dynamicContributions[in.admsNodeID_g].dx(0);
  Findices[in.admsNodeID_g] = in.li_g;
  Qindices[in.admsNodeID_g] = in.li_g;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_di] += staticContributions[in.admsNodeID_di].dx(0);
  dqdp[in.admsNodeID_di] += dynamicContributions[in.admsNodeID_di].dx(0);
  Findices[in.admsNodeID_di] = in.li_di;
  Qindices[in.admsNodeID_di] = in.li_di;
  dfdp[in.admsNodeID_si] += staticContributions[in.admsNodeID_si].dx(0);
  dqdp[in.admsNodeID_si] += dynamicContributions[in.admsNodeID_si].dx(0);
  Findices[in.admsNodeID_si] = in.li_si;
  Qindices[in.admsNodeID_si] = in.li_si;
  dfdp[in.admsNodeID_gi] += staticContributions[in.admsNodeID_gi].dx(0);
  dqdp[in.admsNodeID_gi] += dynamicContributions[in.admsNodeID_gi].dx(0);
  Findices[in.admsNodeID_gi] = in.li_gi;
  Qindices[in.admsNodeID_gi] = in.li_gi;
  dfdp[in.admsNodeID_gm] += staticContributions[in.admsNodeID_gm].dx(0);
  dqdp[in.admsNodeID_gm] += dynamicContributions[in.admsNodeID_gm].dx(0);
  Findices[in.admsNodeID_gm] = in.li_gm;
  Qindices[in.admsNodeID_gm] = in.li_gm;
  dfdp[in.admsNodeID_bi] += staticContributions[in.admsNodeID_bi].dx(0);
  dqdp[in.admsNodeID_bi] += dynamicContributions[in.admsNodeID_bi].dx(0);
  Findices[in.admsNodeID_bi] = in.li_bi;
  Qindices[in.admsNodeID_bi] = in.li_bi;
  dfdp[in.admsNodeID_sbulk] += staticContributions[in.admsNodeID_sbulk].dx(0);
  dqdp[in.admsNodeID_sbulk] += dynamicContributions[in.admsNodeID_sbulk].dx(0);
  Findices[in.admsNodeID_sbulk] = in.li_sbulk;
  Qindices[in.admsNodeID_sbulk] = in.li_sbulk;
  dfdp[in.admsNodeID_dbulk] += staticContributions[in.admsNodeID_dbulk].dx(0);
  dqdp[in.admsNodeID_dbulk] += dynamicContributions[in.admsNodeID_dbulk].dx(0);
  Findices[in.admsNodeID_dbulk] = in.li_dbulk;
  Qindices[in.admsNodeID_dbulk] = in.li_dbulk;
  dfdp[in.admsNodeID_N1] += staticContributions[in.admsNodeID_N1].dx(0);
  dqdp[in.admsNodeID_N1] += dynamicContributions[in.admsNodeID_N1].dx(0);
  Findices[in.admsNodeID_N1] = in.li_N1;
  Qindices[in.admsNodeID_N1] = in.li_N1;
  dfdp[in.admsNodeID_N2] += staticContributions[in.admsNodeID_N2].dx(0);
  dqdp[in.admsNodeID_N2] += dynamicContributions[in.admsNodeID_N2].dx(0);
  Findices[in.admsNodeID_N2] = in.li_N2;
  Qindices[in.admsNodeID_N2] = in.li_N2;
  dfdp[in.admsNodeID_t] += staticContributions[in.admsNodeID_t].dx(0);
  dqdp[in.admsNodeID_t] += dynamicContributions[in.admsNodeID_t].dx(0);
  Findices[in.admsNodeID_t] = in.li_t;
  Qindices[in.admsNodeID_t] = in.li_t;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((14+0)*sizeInstance);
  dqdp.resize((14+0)*sizeInstance);
  Findices.resize((14+0)*sizeInstance);
  Qindices.resize((14+0)*sizeInstance);

  std::vector <double> probeVars(21);
  std::vector <AdmsSensFadType> staticContributions(14+0);
  std::vector <AdmsSensFadType> dynamicContributions(14+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_L=mod.L;
  bool modelPar_given_L=mod.given("L");
  modParamMap["L"] = &modelPar_L;
  AdmsSensFadType modelPar_VFBSDOFF=mod.VFBSDOFF;
  bool modelPar_given_VFBSDOFF=mod.given("VFBSDOFF");
  modParamMap["VFBSDOFF"] = &modelPar_VFBSDOFF;
  AdmsSensFadType modelPar_XGW=mod.XGW;
  bool modelPar_given_XGW=mod.given("XGW");
  modParamMap["XGW"] = &modelPar_XGW;
  AdmsSensFadType modelPar_RBPB=mod.RBPB;
  bool modelPar_given_RBPB=mod.given("RBPB");
  modParamMap["RBPB"] = &modelPar_RBPB;
  AdmsSensFadType modelPar_RBPD=mod.RBPD;
  bool modelPar_given_RBPD=mod.given("RBPD");
  modParamMap["RBPD"] = &modelPar_RBPD;
  AdmsSensFadType modelPar_RBPS=mod.RBPS;
  bool modelPar_given_RBPS=mod.given("RBPS");
  modParamMap["RBPS"] = &modelPar_RBPS;
  AdmsSensFadType modelPar_RBDB=mod.RBDB;
  bool modelPar_given_RBDB=mod.given("RBDB");
  modParamMap["RBDB"] = &modelPar_RBDB;
  AdmsSensFadType modelPar_RBSB=mod.RBSB;
  bool modelPar_given_RBSB=mod.given("RBSB");
  modParamMap["RBSB"] = &modelPar_RBSB;
  AdmsSensFadType modelPar_SA=mod.SA;
  bool modelPar_given_SA=mod.given("SA");
  modParamMap["SA"] = &modelPar_SA;
  AdmsSensFadType modelPar_SB=mod.SB;
  bool modelPar_given_SB=mod.given("SB");
  modParamMap["SB"] = &modelPar_SB;
  AdmsSensFadType modelPar_SD=mod.SD;
  bool modelPar_given_SD=mod.given("SD");
  modParamMap["SD"] = &modelPar_SD;
  AdmsSensFadType modelPar_LLONG=mod.LLONG;
  bool modelPar_given_LLONG=mod.given("LLONG");
  modParamMap["LLONG"] = &modelPar_LLONG;
  AdmsSensFadType modelPar_LMLT=mod.LMLT;
  bool modelPar_given_LMLT=mod.given("LMLT");
  modParamMap["LMLT"] = &modelPar_LMLT;
  AdmsSensFadType modelPar_WMLT=mod.WMLT;
  bool modelPar_given_WMLT=mod.given("WMLT");
  modParamMap["WMLT"] = &modelPar_WMLT;
  AdmsSensFadType modelPar_XL=mod.XL;
  bool modelPar_given_XL=mod.given("XL");
  modParamMap["XL"] = &modelPar_XL;
  AdmsSensFadType modelPar_WWIDE=mod.WWIDE;
  bool modelPar_given_WWIDE=mod.given("WWIDE");
  modParamMap["WWIDE"] = &modelPar_WWIDE;
  AdmsSensFadType modelPar_XW=mod.XW;
  bool modelPar_given_XW=mod.given("XW");
  modParamMap["XW"] = &modelPar_XW;
  AdmsSensFadType modelPar_LINT=mod.LINT;
  bool modelPar_given_LINT=mod.given("LINT");
  modParamMap["LINT"] = &modelPar_LINT;
  AdmsSensFadType modelPar_LL=mod.LL;
  bool modelPar_given_LL=mod.given("LL");
  modParamMap["LL"] = &modelPar_LL;
  AdmsSensFadType modelPar_LW=mod.LW;
  bool modelPar_given_LW=mod.given("LW");
  modParamMap["LW"] = &modelPar_LW;
  AdmsSensFadType modelPar_LWL=mod.LWL;
  bool modelPar_given_LWL=mod.given("LWL");
  modParamMap["LWL"] = &modelPar_LWL;
  AdmsSensFadType modelPar_LLN=mod.LLN;
  bool modelPar_given_LLN=mod.given("LLN");
  modParamMap["LLN"] = &modelPar_LLN;
  AdmsSensFadType modelPar_LWN=mod.LWN;
  bool modelPar_given_LWN=mod.given("LWN");
  modParamMap["LWN"] = &modelPar_LWN;
  AdmsSensFadType modelPar_WINT=mod.WINT;
  bool modelPar_given_WINT=mod.given("WINT");
  modParamMap["WINT"] = &modelPar_WINT;
  AdmsSensFadType modelPar_WL=mod.WL;
  bool modelPar_given_WL=mod.given("WL");
  modParamMap["WL"] = &modelPar_WL;
  AdmsSensFadType modelPar_WW=mod.WW;
  bool modelPar_given_WW=mod.given("WW");
  modParamMap["WW"] = &modelPar_WW;
  AdmsSensFadType modelPar_WWL=mod.WWL;
  bool modelPar_given_WWL=mod.given("WWL");
  modParamMap["WWL"] = &modelPar_WWL;
  AdmsSensFadType modelPar_WLN=mod.WLN;
  bool modelPar_given_WLN=mod.given("WLN");
  modParamMap["WLN"] = &modelPar_WLN;
  AdmsSensFadType modelPar_WWN=mod.WWN;
  bool modelPar_given_WWN=mod.given("WWN");
  modParamMap["WWN"] = &modelPar_WWN;
  AdmsSensFadType modelPar_DLC=mod.DLC;
  bool modelPar_given_DLC=mod.given("DLC");
  modParamMap["DLC"] = &modelPar_DLC;
  AdmsSensFadType modelPar_LLC=mod.LLC;
  bool modelPar_given_LLC=mod.given("LLC");
  modParamMap["LLC"] = &modelPar_LLC;
  AdmsSensFadType modelPar_LWC=mod.LWC;
  bool modelPar_given_LWC=mod.given("LWC");
  modParamMap["LWC"] = &modelPar_LWC;
  AdmsSensFadType modelPar_LWLC=mod.LWLC;
  bool modelPar_given_LWLC=mod.given("LWLC");
  modParamMap["LWLC"] = &modelPar_LWLC;
  AdmsSensFadType modelPar_DWC=mod.DWC;
  bool modelPar_given_DWC=mod.given("DWC");
  modParamMap["DWC"] = &modelPar_DWC;
  AdmsSensFadType modelPar_WLC=mod.WLC;
  bool modelPar_given_WLC=mod.given("WLC");
  modParamMap["WLC"] = &modelPar_WLC;
  AdmsSensFadType modelPar_WWC=mod.WWC;
  bool modelPar_given_WWC=mod.given("WWC");
  modParamMap["WWC"] = &modelPar_WWC;
  AdmsSensFadType modelPar_WWLC=mod.WWLC;
  bool modelPar_given_WWLC=mod.given("WWLC");
  modParamMap["WWLC"] = &modelPar_WWLC;
  AdmsSensFadType modelPar_TOXE=mod.TOXE;
  bool modelPar_given_TOXE=mod.given("TOXE");
  modParamMap["TOXE"] = &modelPar_TOXE;
  AdmsSensFadType modelPar_TOXP=mod.TOXP;
  bool modelPar_given_TOXP=mod.given("TOXP");
  modParamMap["TOXP"] = &modelPar_TOXP;
  AdmsSensFadType modelPar_DTOX=mod.DTOX;
  bool modelPar_given_DTOX=mod.given("DTOX");
  modParamMap["DTOX"] = &modelPar_DTOX;
  AdmsSensFadType modelPar_NDEP=mod.NDEP;
  bool modelPar_given_NDEP=mod.given("NDEP");
  modParamMap["NDEP"] = &modelPar_NDEP;
  AdmsSensFadType modelPar_NDEPL1=mod.NDEPL1;
  bool modelPar_given_NDEPL1=mod.given("NDEPL1");
  modParamMap["NDEPL1"] = &modelPar_NDEPL1;
  AdmsSensFadType modelPar_NDEPLEXP1=mod.NDEPLEXP1;
  bool modelPar_given_NDEPLEXP1=mod.given("NDEPLEXP1");
  modParamMap["NDEPLEXP1"] = &modelPar_NDEPLEXP1;
  AdmsSensFadType modelPar_NDEPL2=mod.NDEPL2;
  bool modelPar_given_NDEPL2=mod.given("NDEPL2");
  modParamMap["NDEPL2"] = &modelPar_NDEPL2;
  AdmsSensFadType modelPar_NDEPLEXP2=mod.NDEPLEXP2;
  bool modelPar_given_NDEPLEXP2=mod.given("NDEPLEXP2");
  modParamMap["NDEPLEXP2"] = &modelPar_NDEPLEXP2;
  AdmsSensFadType modelPar_NDEPW=mod.NDEPW;
  bool modelPar_given_NDEPW=mod.given("NDEPW");
  modParamMap["NDEPW"] = &modelPar_NDEPW;
  AdmsSensFadType modelPar_NDEPWEXP=mod.NDEPWEXP;
  bool modelPar_given_NDEPWEXP=mod.given("NDEPWEXP");
  modParamMap["NDEPWEXP"] = &modelPar_NDEPWEXP;
  AdmsSensFadType modelPar_NDEPWL=mod.NDEPWL;
  bool modelPar_given_NDEPWL=mod.given("NDEPWL");
  modParamMap["NDEPWL"] = &modelPar_NDEPWL;
  AdmsSensFadType modelPar_NDEPWLEXP=mod.NDEPWLEXP;
  bool modelPar_given_NDEPWLEXP=mod.given("NDEPWLEXP");
  modParamMap["NDEPWLEXP"] = &modelPar_NDEPWLEXP;
  AdmsSensFadType modelPar_LNDEP=mod.LNDEP;
  bool modelPar_given_LNDEP=mod.given("LNDEP");
  modParamMap["LNDEP"] = &modelPar_LNDEP;
  AdmsSensFadType modelPar_WNDEP=mod.WNDEP;
  bool modelPar_given_WNDEP=mod.given("WNDEP");
  modParamMap["WNDEP"] = &modelPar_WNDEP;
  AdmsSensFadType modelPar_PNDEP=mod.PNDEP;
  bool modelPar_given_PNDEP=mod.given("PNDEP");
  modParamMap["PNDEP"] = &modelPar_PNDEP;
  AdmsSensFadType modelPar_NDEPCV=mod.NDEPCV;
  bool modelPar_given_NDEPCV=mod.given("NDEPCV");
  modParamMap["NDEPCV"] = &modelPar_NDEPCV;
  AdmsSensFadType modelPar_NDEPCVL1=mod.NDEPCVL1;
  bool modelPar_given_NDEPCVL1=mod.given("NDEPCVL1");
  modParamMap["NDEPCVL1"] = &modelPar_NDEPCVL1;
  AdmsSensFadType modelPar_NDEPCVLEXP1=mod.NDEPCVLEXP1;
  bool modelPar_given_NDEPCVLEXP1=mod.given("NDEPCVLEXP1");
  modParamMap["NDEPCVLEXP1"] = &modelPar_NDEPCVLEXP1;
  AdmsSensFadType modelPar_NDEPCVL2=mod.NDEPCVL2;
  bool modelPar_given_NDEPCVL2=mod.given("NDEPCVL2");
  modParamMap["NDEPCVL2"] = &modelPar_NDEPCVL2;
  AdmsSensFadType modelPar_NDEPCVLEXP2=mod.NDEPCVLEXP2;
  bool modelPar_given_NDEPCVLEXP2=mod.given("NDEPCVLEXP2");
  modParamMap["NDEPCVLEXP2"] = &modelPar_NDEPCVLEXP2;
  AdmsSensFadType modelPar_NDEPCVW=mod.NDEPCVW;
  bool modelPar_given_NDEPCVW=mod.given("NDEPCVW");
  modParamMap["NDEPCVW"] = &modelPar_NDEPCVW;
  AdmsSensFadType modelPar_NDEPCVWEXP=mod.NDEPCVWEXP;
  bool modelPar_given_NDEPCVWEXP=mod.given("NDEPCVWEXP");
  modParamMap["NDEPCVWEXP"] = &modelPar_NDEPCVWEXP;
  AdmsSensFadType modelPar_NDEPCVWL=mod.NDEPCVWL;
  bool modelPar_given_NDEPCVWL=mod.given("NDEPCVWL");
  modParamMap["NDEPCVWL"] = &modelPar_NDEPCVWL;
  AdmsSensFadType modelPar_NDEPCVWLEXP=mod.NDEPCVWLEXP;
  bool modelPar_given_NDEPCVWLEXP=mod.given("NDEPCVWLEXP");
  modParamMap["NDEPCVWLEXP"] = &modelPar_NDEPCVWLEXP;
  AdmsSensFadType modelPar_LNDEPCV=mod.LNDEPCV;
  bool modelPar_given_LNDEPCV=mod.given("LNDEPCV");
  modParamMap["LNDEPCV"] = &modelPar_LNDEPCV;
  AdmsSensFadType modelPar_WNDEPCV=mod.WNDEPCV;
  bool modelPar_given_WNDEPCV=mod.given("WNDEPCV");
  modParamMap["WNDEPCV"] = &modelPar_WNDEPCV;
  AdmsSensFadType modelPar_PNDEPCV=mod.PNDEPCV;
  bool modelPar_given_PNDEPCV=mod.given("PNDEPCV");
  modParamMap["PNDEPCV"] = &modelPar_PNDEPCV;
  AdmsSensFadType modelPar_NGATE=mod.NGATE;
  bool modelPar_given_NGATE=mod.given("NGATE");
  modParamMap["NGATE"] = &modelPar_NGATE;
  AdmsSensFadType modelPar_LNGATE=mod.LNGATE;
  bool modelPar_given_LNGATE=mod.given("LNGATE");
  modParamMap["LNGATE"] = &modelPar_LNGATE;
  AdmsSensFadType modelPar_WNGATE=mod.WNGATE;
  bool modelPar_given_WNGATE=mod.given("WNGATE");
  modParamMap["WNGATE"] = &modelPar_WNGATE;
  AdmsSensFadType modelPar_PNGATE=mod.PNGATE;
  bool modelPar_given_PNGATE=mod.given("PNGATE");
  modParamMap["PNGATE"] = &modelPar_PNGATE;
  AdmsSensFadType modelPar_EASUB=mod.EASUB;
  bool modelPar_given_EASUB=mod.given("EASUB");
  modParamMap["EASUB"] = &modelPar_EASUB;
  AdmsSensFadType modelPar_NI0SUB=mod.NI0SUB;
  bool modelPar_given_NI0SUB=mod.given("NI0SUB");
  modParamMap["NI0SUB"] = &modelPar_NI0SUB;
  AdmsSensFadType modelPar_BG0SUB=mod.BG0SUB;
  bool modelPar_given_BG0SUB=mod.given("BG0SUB");
  modParamMap["BG0SUB"] = &modelPar_BG0SUB;
  AdmsSensFadType modelPar_EPSRSUB=mod.EPSRSUB;
  bool modelPar_given_EPSRSUB=mod.given("EPSRSUB");
  modParamMap["EPSRSUB"] = &modelPar_EPSRSUB;
  AdmsSensFadType modelPar_EPSROX=mod.EPSROX;
  bool modelPar_given_EPSROX=mod.given("EPSROX");
  modParamMap["EPSROX"] = &modelPar_EPSROX;
  AdmsSensFadType modelPar_XJ=mod.XJ;
  bool modelPar_given_XJ=mod.given("XJ");
  modParamMap["XJ"] = &modelPar_XJ;
  AdmsSensFadType modelPar_LXJ=mod.LXJ;
  bool modelPar_given_LXJ=mod.given("LXJ");
  modParamMap["LXJ"] = &modelPar_LXJ;
  AdmsSensFadType modelPar_WXJ=mod.WXJ;
  bool modelPar_given_WXJ=mod.given("WXJ");
  modParamMap["WXJ"] = &modelPar_WXJ;
  AdmsSensFadType modelPar_PXJ=mod.PXJ;
  bool modelPar_given_PXJ=mod.given("PXJ");
  modParamMap["PXJ"] = &modelPar_PXJ;
  AdmsSensFadType modelPar_LVFB=mod.LVFB;
  bool modelPar_given_LVFB=mod.given("LVFB");
  modParamMap["LVFB"] = &modelPar_LVFB;
  AdmsSensFadType modelPar_WVFB=mod.WVFB;
  bool modelPar_given_WVFB=mod.given("WVFB");
  modParamMap["WVFB"] = &modelPar_WVFB;
  AdmsSensFadType modelPar_PVFB=mod.PVFB;
  bool modelPar_given_PVFB=mod.given("PVFB");
  modParamMap["PVFB"] = &modelPar_PVFB;
  AdmsSensFadType modelPar_VFB=mod.VFB;
  bool modelPar_given_VFB=mod.given("VFB");
  modParamMap["VFB"] = &modelPar_VFB;
  AdmsSensFadType modelPar_VFBCV=mod.VFBCV;
  bool modelPar_given_VFBCV=mod.given("VFBCV");
  modParamMap["VFBCV"] = &modelPar_VFBCV;
  AdmsSensFadType modelPar_LVFBCV=mod.LVFBCV;
  bool modelPar_given_LVFBCV=mod.given("LVFBCV");
  modParamMap["LVFBCV"] = &modelPar_LVFBCV;
  AdmsSensFadType modelPar_WVFBCV=mod.WVFBCV;
  bool modelPar_given_WVFBCV=mod.given("WVFBCV");
  modParamMap["WVFBCV"] = &modelPar_WVFBCV;
  AdmsSensFadType modelPar_PVFBCV=mod.PVFBCV;
  bool modelPar_given_PVFBCV=mod.given("PVFBCV");
  modParamMap["PVFBCV"] = &modelPar_PVFBCV;
  AdmsSensFadType modelPar_VFBCVL=mod.VFBCVL;
  bool modelPar_given_VFBCVL=mod.given("VFBCVL");
  modParamMap["VFBCVL"] = &modelPar_VFBCVL;
  AdmsSensFadType modelPar_VFBCVLEXP=mod.VFBCVLEXP;
  bool modelPar_given_VFBCVLEXP=mod.given("VFBCVLEXP");
  modParamMap["VFBCVLEXP"] = &modelPar_VFBCVLEXP;
  AdmsSensFadType modelPar_VFBCVW=mod.VFBCVW;
  bool modelPar_given_VFBCVW=mod.given("VFBCVW");
  modParamMap["VFBCVW"] = &modelPar_VFBCVW;
  AdmsSensFadType modelPar_VFBCVWEXP=mod.VFBCVWEXP;
  bool modelPar_given_VFBCVWEXP=mod.given("VFBCVWEXP");
  modParamMap["VFBCVWEXP"] = &modelPar_VFBCVWEXP;
  AdmsSensFadType modelPar_VFBCVWL=mod.VFBCVWL;
  bool modelPar_given_VFBCVWL=mod.given("VFBCVWL");
  modParamMap["VFBCVWL"] = &modelPar_VFBCVWL;
  AdmsSensFadType modelPar_VFBCVWLEXP=mod.VFBCVWLEXP;
  bool modelPar_given_VFBCVWLEXP=mod.given("VFBCVWLEXP");
  modParamMap["VFBCVWLEXP"] = &modelPar_VFBCVWLEXP;
  AdmsSensFadType modelPar_DWJ=mod.DWJ;
  bool modelPar_given_DWJ=mod.given("DWJ");
  modParamMap["DWJ"] = &modelPar_DWJ;
  AdmsSensFadType modelPar_NSD=mod.NSD;
  bool modelPar_given_NSD=mod.given("NSD");
  modParamMap["NSD"] = &modelPar_NSD;
  AdmsSensFadType modelPar_LNSD=mod.LNSD;
  bool modelPar_given_LNSD=mod.given("LNSD");
  modParamMap["LNSD"] = &modelPar_LNSD;
  AdmsSensFadType modelPar_WNSD=mod.WNSD;
  bool modelPar_given_WNSD=mod.given("WNSD");
  modParamMap["WNSD"] = &modelPar_WNSD;
  AdmsSensFadType modelPar_PNSD=mod.PNSD;
  bool modelPar_given_PNSD=mod.given("PNSD");
  modParamMap["PNSD"] = &modelPar_PNSD;
  AdmsSensFadType modelPar_DELVT0=mod.DELVT0;
  bool modelPar_given_DELVT0=mod.given("DELVT0");
  modParamMap["DELVT0"] = &modelPar_DELVT0;
  AdmsSensFadType modelPar_DVTP0=mod.DVTP0;
  bool modelPar_given_DVTP0=mod.given("DVTP0");
  modParamMap["DVTP0"] = &modelPar_DVTP0;
  AdmsSensFadType modelPar_LDVTP0=mod.LDVTP0;
  bool modelPar_given_LDVTP0=mod.given("LDVTP0");
  modParamMap["LDVTP0"] = &modelPar_LDVTP0;
  AdmsSensFadType modelPar_WDVTP0=mod.WDVTP0;
  bool modelPar_given_WDVTP0=mod.given("WDVTP0");
  modParamMap["WDVTP0"] = &modelPar_WDVTP0;
  AdmsSensFadType modelPar_PDVTP0=mod.PDVTP0;
  bool modelPar_given_PDVTP0=mod.given("PDVTP0");
  modParamMap["PDVTP0"] = &modelPar_PDVTP0;
  AdmsSensFadType modelPar_DVTP1=mod.DVTP1;
  bool modelPar_given_DVTP1=mod.given("DVTP1");
  modParamMap["DVTP1"] = &modelPar_DVTP1;
  AdmsSensFadType modelPar_LDVTP1=mod.LDVTP1;
  bool modelPar_given_LDVTP1=mod.given("LDVTP1");
  modParamMap["LDVTP1"] = &modelPar_LDVTP1;
  AdmsSensFadType modelPar_WDVTP1=mod.WDVTP1;
  bool modelPar_given_WDVTP1=mod.given("WDVTP1");
  modParamMap["WDVTP1"] = &modelPar_WDVTP1;
  AdmsSensFadType modelPar_PDVTP1=mod.PDVTP1;
  bool modelPar_given_PDVTP1=mod.given("PDVTP1");
  modParamMap["PDVTP1"] = &modelPar_PDVTP1;
  AdmsSensFadType modelPar_DVTP2=mod.DVTP2;
  bool modelPar_given_DVTP2=mod.given("DVTP2");
  modParamMap["DVTP2"] = &modelPar_DVTP2;
  AdmsSensFadType modelPar_LDVTP2=mod.LDVTP2;
  bool modelPar_given_LDVTP2=mod.given("LDVTP2");
  modParamMap["LDVTP2"] = &modelPar_LDVTP2;
  AdmsSensFadType modelPar_WDVTP2=mod.WDVTP2;
  bool modelPar_given_WDVTP2=mod.given("WDVTP2");
  modParamMap["WDVTP2"] = &modelPar_WDVTP2;
  AdmsSensFadType modelPar_PDVTP2=mod.PDVTP2;
  bool modelPar_given_PDVTP2=mod.given("PDVTP2");
  modParamMap["PDVTP2"] = &modelPar_PDVTP2;
  AdmsSensFadType modelPar_DVTP3=mod.DVTP3;
  bool modelPar_given_DVTP3=mod.given("DVTP3");
  modParamMap["DVTP3"] = &modelPar_DVTP3;
  AdmsSensFadType modelPar_LDVTP3=mod.LDVTP3;
  bool modelPar_given_LDVTP3=mod.given("LDVTP3");
  modParamMap["LDVTP3"] = &modelPar_LDVTP3;
  AdmsSensFadType modelPar_WDVTP3=mod.WDVTP3;
  bool modelPar_given_WDVTP3=mod.given("WDVTP3");
  modParamMap["WDVTP3"] = &modelPar_WDVTP3;
  AdmsSensFadType modelPar_PDVTP3=mod.PDVTP3;
  bool modelPar_given_PDVTP3=mod.given("PDVTP3");
  modParamMap["PDVTP3"] = &modelPar_PDVTP3;
  AdmsSensFadType modelPar_DVTP4=mod.DVTP4;
  bool modelPar_given_DVTP4=mod.given("DVTP4");
  modParamMap["DVTP4"] = &modelPar_DVTP4;
  AdmsSensFadType modelPar_LDVTP4=mod.LDVTP4;
  bool modelPar_given_LDVTP4=mod.given("LDVTP4");
  modParamMap["LDVTP4"] = &modelPar_LDVTP4;
  AdmsSensFadType modelPar_WDVTP4=mod.WDVTP4;
  bool modelPar_given_WDVTP4=mod.given("WDVTP4");
  modParamMap["WDVTP4"] = &modelPar_WDVTP4;
  AdmsSensFadType modelPar_PDVTP4=mod.PDVTP4;
  bool modelPar_given_PDVTP4=mod.given("PDVTP4");
  modParamMap["PDVTP4"] = &modelPar_PDVTP4;
  AdmsSensFadType modelPar_DVTP5=mod.DVTP5;
  bool modelPar_given_DVTP5=mod.given("DVTP5");
  modParamMap["DVTP5"] = &modelPar_DVTP5;
  AdmsSensFadType modelPar_LDVTP5=mod.LDVTP5;
  bool modelPar_given_LDVTP5=mod.given("LDVTP5");
  modParamMap["LDVTP5"] = &modelPar_LDVTP5;
  AdmsSensFadType modelPar_WDVTP5=mod.WDVTP5;
  bool modelPar_given_WDVTP5=mod.given("WDVTP5");
  modParamMap["WDVTP5"] = &modelPar_WDVTP5;
  AdmsSensFadType modelPar_PDVTP5=mod.PDVTP5;
  bool modelPar_given_PDVTP5=mod.given("PDVTP5");
  modParamMap["PDVTP5"] = &modelPar_PDVTP5;
  AdmsSensFadType modelPar_PHIN=mod.PHIN;
  bool modelPar_given_PHIN=mod.given("PHIN");
  modParamMap["PHIN"] = &modelPar_PHIN;
  AdmsSensFadType modelPar_LPHIN=mod.LPHIN;
  bool modelPar_given_LPHIN=mod.given("LPHIN");
  modParamMap["LPHIN"] = &modelPar_LPHIN;
  AdmsSensFadType modelPar_WPHIN=mod.WPHIN;
  bool modelPar_given_WPHIN=mod.given("WPHIN");
  modParamMap["WPHIN"] = &modelPar_WPHIN;
  AdmsSensFadType modelPar_PPHIN=mod.PPHIN;
  bool modelPar_given_PPHIN=mod.given("PPHIN");
  modParamMap["PPHIN"] = &modelPar_PPHIN;
  AdmsSensFadType modelPar_ETA0=mod.ETA0;
  bool modelPar_given_ETA0=mod.given("ETA0");
  modParamMap["ETA0"] = &modelPar_ETA0;
  AdmsSensFadType modelPar_LETA0=mod.LETA0;
  bool modelPar_given_LETA0=mod.given("LETA0");
  modParamMap["LETA0"] = &modelPar_LETA0;
  AdmsSensFadType modelPar_WETA0=mod.WETA0;
  bool modelPar_given_WETA0=mod.given("WETA0");
  modParamMap["WETA0"] = &modelPar_WETA0;
  AdmsSensFadType modelPar_PETA0=mod.PETA0;
  bool modelPar_given_PETA0=mod.given("PETA0");
  modParamMap["PETA0"] = &modelPar_PETA0;
  AdmsSensFadType modelPar_ETA0R=mod.ETA0R;
  bool modelPar_given_ETA0R=mod.given("ETA0R");
  modParamMap["ETA0R"] = &modelPar_ETA0R;
  AdmsSensFadType modelPar_LETA0R=mod.LETA0R;
  bool modelPar_given_LETA0R=mod.given("LETA0R");
  modParamMap["LETA0R"] = &modelPar_LETA0R;
  AdmsSensFadType modelPar_WETA0R=mod.WETA0R;
  bool modelPar_given_WETA0R=mod.given("WETA0R");
  modParamMap["WETA0R"] = &modelPar_WETA0R;
  AdmsSensFadType modelPar_PETA0R=mod.PETA0R;
  bool modelPar_given_PETA0R=mod.given("PETA0R");
  modParamMap["PETA0R"] = &modelPar_PETA0R;
  AdmsSensFadType modelPar_DSUB=mod.DSUB;
  bool modelPar_given_DSUB=mod.given("DSUB");
  modParamMap["DSUB"] = &modelPar_DSUB;
  AdmsSensFadType modelPar_ETAB=mod.ETAB;
  bool modelPar_given_ETAB=mod.given("ETAB");
  modParamMap["ETAB"] = &modelPar_ETAB;
  AdmsSensFadType modelPar_ETABEXP=mod.ETABEXP;
  bool modelPar_given_ETABEXP=mod.given("ETABEXP");
  modParamMap["ETABEXP"] = &modelPar_ETABEXP;
  AdmsSensFadType modelPar_LETAB=mod.LETAB;
  bool modelPar_given_LETAB=mod.given("LETAB");
  modParamMap["LETAB"] = &modelPar_LETAB;
  AdmsSensFadType modelPar_WETAB=mod.WETAB;
  bool modelPar_given_WETAB=mod.given("WETAB");
  modParamMap["WETAB"] = &modelPar_WETAB;
  AdmsSensFadType modelPar_PETAB=mod.PETAB;
  bool modelPar_given_PETAB=mod.given("PETAB");
  modParamMap["PETAB"] = &modelPar_PETAB;
  AdmsSensFadType modelPar_K1=mod.K1;
  bool modelPar_given_K1=mod.given("K1");
  modParamMap["K1"] = &modelPar_K1;
  AdmsSensFadType modelPar_K1L=mod.K1L;
  bool modelPar_given_K1L=mod.given("K1L");
  modParamMap["K1L"] = &modelPar_K1L;
  AdmsSensFadType modelPar_K1LEXP=mod.K1LEXP;
  bool modelPar_given_K1LEXP=mod.given("K1LEXP");
  modParamMap["K1LEXP"] = &modelPar_K1LEXP;
  AdmsSensFadType modelPar_K1W=mod.K1W;
  bool modelPar_given_K1W=mod.given("K1W");
  modParamMap["K1W"] = &modelPar_K1W;
  AdmsSensFadType modelPar_K1WEXP=mod.K1WEXP;
  bool modelPar_given_K1WEXP=mod.given("K1WEXP");
  modParamMap["K1WEXP"] = &modelPar_K1WEXP;
  AdmsSensFadType modelPar_K1WL=mod.K1WL;
  bool modelPar_given_K1WL=mod.given("K1WL");
  modParamMap["K1WL"] = &modelPar_K1WL;
  AdmsSensFadType modelPar_K1WLEXP=mod.K1WLEXP;
  bool modelPar_given_K1WLEXP=mod.given("K1WLEXP");
  modParamMap["K1WLEXP"] = &modelPar_K1WLEXP;
  AdmsSensFadType modelPar_LK1=mod.LK1;
  bool modelPar_given_LK1=mod.given("LK1");
  modParamMap["LK1"] = &modelPar_LK1;
  AdmsSensFadType modelPar_WK1=mod.WK1;
  bool modelPar_given_WK1=mod.given("WK1");
  modParamMap["WK1"] = &modelPar_WK1;
  AdmsSensFadType modelPar_PK1=mod.PK1;
  bool modelPar_given_PK1=mod.given("PK1");
  modParamMap["PK1"] = &modelPar_PK1;
  AdmsSensFadType modelPar_K2=mod.K2;
  bool modelPar_given_K2=mod.given("K2");
  modParamMap["K2"] = &modelPar_K2;
  AdmsSensFadType modelPar_K2L=mod.K2L;
  bool modelPar_given_K2L=mod.given("K2L");
  modParamMap["K2L"] = &modelPar_K2L;
  AdmsSensFadType modelPar_K2LEXP=mod.K2LEXP;
  bool modelPar_given_K2LEXP=mod.given("K2LEXP");
  modParamMap["K2LEXP"] = &modelPar_K2LEXP;
  AdmsSensFadType modelPar_K2W=mod.K2W;
  bool modelPar_given_K2W=mod.given("K2W");
  modParamMap["K2W"] = &modelPar_K2W;
  AdmsSensFadType modelPar_K2WEXP=mod.K2WEXP;
  bool modelPar_given_K2WEXP=mod.given("K2WEXP");
  modParamMap["K2WEXP"] = &modelPar_K2WEXP;
  AdmsSensFadType modelPar_K2WL=mod.K2WL;
  bool modelPar_given_K2WL=mod.given("K2WL");
  modParamMap["K2WL"] = &modelPar_K2WL;
  AdmsSensFadType modelPar_K2WLEXP=mod.K2WLEXP;
  bool modelPar_given_K2WLEXP=mod.given("K2WLEXP");
  modParamMap["K2WLEXP"] = &modelPar_K2WLEXP;
  AdmsSensFadType modelPar_LK2=mod.LK2;
  bool modelPar_given_LK2=mod.given("LK2");
  modParamMap["LK2"] = &modelPar_LK2;
  AdmsSensFadType modelPar_WK2=mod.WK2;
  bool modelPar_given_WK2=mod.given("WK2");
  modParamMap["WK2"] = &modelPar_WK2;
  AdmsSensFadType modelPar_PK2=mod.PK2;
  bool modelPar_given_PK2=mod.given("PK2");
  modParamMap["PK2"] = &modelPar_PK2;
  AdmsSensFadType modelPar_ADOS=mod.ADOS;
  bool modelPar_given_ADOS=mod.given("ADOS");
  modParamMap["ADOS"] = &modelPar_ADOS;
  AdmsSensFadType modelPar_BDOS=mod.BDOS;
  bool modelPar_given_BDOS=mod.given("BDOS");
  modParamMap["BDOS"] = &modelPar_BDOS;
  AdmsSensFadType modelPar_QM0=mod.QM0;
  bool modelPar_given_QM0=mod.given("QM0");
  modParamMap["QM0"] = &modelPar_QM0;
  AdmsSensFadType modelPar_ETAQM=mod.ETAQM;
  bool modelPar_given_ETAQM=mod.given("ETAQM");
  modParamMap["ETAQM"] = &modelPar_ETAQM;
  AdmsSensFadType modelPar_CIT=mod.CIT;
  bool modelPar_given_CIT=mod.given("CIT");
  modParamMap["CIT"] = &modelPar_CIT;
  AdmsSensFadType modelPar_LCIT=mod.LCIT;
  bool modelPar_given_LCIT=mod.given("LCIT");
  modParamMap["LCIT"] = &modelPar_LCIT;
  AdmsSensFadType modelPar_WCIT=mod.WCIT;
  bool modelPar_given_WCIT=mod.given("WCIT");
  modParamMap["WCIT"] = &modelPar_WCIT;
  AdmsSensFadType modelPar_PCIT=mod.PCIT;
  bool modelPar_given_PCIT=mod.given("PCIT");
  modParamMap["PCIT"] = &modelPar_PCIT;
  AdmsSensFadType modelPar_NFACTOR=mod.NFACTOR;
  bool modelPar_given_NFACTOR=mod.given("NFACTOR");
  modParamMap["NFACTOR"] = &modelPar_NFACTOR;
  AdmsSensFadType modelPar_NFACTORL=mod.NFACTORL;
  bool modelPar_given_NFACTORL=mod.given("NFACTORL");
  modParamMap["NFACTORL"] = &modelPar_NFACTORL;
  AdmsSensFadType modelPar_NFACTORLEXP=mod.NFACTORLEXP;
  bool modelPar_given_NFACTORLEXP=mod.given("NFACTORLEXP");
  modParamMap["NFACTORLEXP"] = &modelPar_NFACTORLEXP;
  AdmsSensFadType modelPar_NFACTORW=mod.NFACTORW;
  bool modelPar_given_NFACTORW=mod.given("NFACTORW");
  modParamMap["NFACTORW"] = &modelPar_NFACTORW;
  AdmsSensFadType modelPar_NFACTORWEXP=mod.NFACTORWEXP;
  bool modelPar_given_NFACTORWEXP=mod.given("NFACTORWEXP");
  modParamMap["NFACTORWEXP"] = &modelPar_NFACTORWEXP;
  AdmsSensFadType modelPar_NFACTORWL=mod.NFACTORWL;
  bool modelPar_given_NFACTORWL=mod.given("NFACTORWL");
  modParamMap["NFACTORWL"] = &modelPar_NFACTORWL;
  AdmsSensFadType modelPar_NFACTORWLEXP=mod.NFACTORWLEXP;
  bool modelPar_given_NFACTORWLEXP=mod.given("NFACTORWLEXP");
  modParamMap["NFACTORWLEXP"] = &modelPar_NFACTORWLEXP;
  AdmsSensFadType modelPar_LNFACTOR=mod.LNFACTOR;
  bool modelPar_given_LNFACTOR=mod.given("LNFACTOR");
  modParamMap["LNFACTOR"] = &modelPar_LNFACTOR;
  AdmsSensFadType modelPar_WNFACTOR=mod.WNFACTOR;
  bool modelPar_given_WNFACTOR=mod.given("WNFACTOR");
  modParamMap["WNFACTOR"] = &modelPar_WNFACTOR;
  AdmsSensFadType modelPar_PNFACTOR=mod.PNFACTOR;
  bool modelPar_given_PNFACTOR=mod.given("PNFACTOR");
  modParamMap["PNFACTOR"] = &modelPar_PNFACTOR;
  AdmsSensFadType modelPar_CDSCD=mod.CDSCD;
  bool modelPar_given_CDSCD=mod.given("CDSCD");
  modParamMap["CDSCD"] = &modelPar_CDSCD;
  AdmsSensFadType modelPar_CDSCDL=mod.CDSCDL;
  bool modelPar_given_CDSCDL=mod.given("CDSCDL");
  modParamMap["CDSCDL"] = &modelPar_CDSCDL;
  AdmsSensFadType modelPar_CDSCDLEXP=mod.CDSCDLEXP;
  bool modelPar_given_CDSCDLEXP=mod.given("CDSCDLEXP");
  modParamMap["CDSCDLEXP"] = &modelPar_CDSCDLEXP;
  AdmsSensFadType modelPar_LCDSCD=mod.LCDSCD;
  bool modelPar_given_LCDSCD=mod.given("LCDSCD");
  modParamMap["LCDSCD"] = &modelPar_LCDSCD;
  AdmsSensFadType modelPar_WCDSCD=mod.WCDSCD;
  bool modelPar_given_WCDSCD=mod.given("WCDSCD");
  modParamMap["WCDSCD"] = &modelPar_WCDSCD;
  AdmsSensFadType modelPar_PCDSCD=mod.PCDSCD;
  bool modelPar_given_PCDSCD=mod.given("PCDSCD");
  modParamMap["PCDSCD"] = &modelPar_PCDSCD;
  AdmsSensFadType modelPar_CDSCDR=mod.CDSCDR;
  bool modelPar_given_CDSCDR=mod.given("CDSCDR");
  modParamMap["CDSCDR"] = &modelPar_CDSCDR;
  AdmsSensFadType modelPar_CDSCDLR=mod.CDSCDLR;
  bool modelPar_given_CDSCDLR=mod.given("CDSCDLR");
  modParamMap["CDSCDLR"] = &modelPar_CDSCDLR;
  AdmsSensFadType modelPar_LCDSCDR=mod.LCDSCDR;
  bool modelPar_given_LCDSCDR=mod.given("LCDSCDR");
  modParamMap["LCDSCDR"] = &modelPar_LCDSCDR;
  AdmsSensFadType modelPar_WCDSCDR=mod.WCDSCDR;
  bool modelPar_given_WCDSCDR=mod.given("WCDSCDR");
  modParamMap["WCDSCDR"] = &modelPar_WCDSCDR;
  AdmsSensFadType modelPar_PCDSCDR=mod.PCDSCDR;
  bool modelPar_given_PCDSCDR=mod.given("PCDSCDR");
  modParamMap["PCDSCDR"] = &modelPar_PCDSCDR;
  AdmsSensFadType modelPar_CDSCB=mod.CDSCB;
  bool modelPar_given_CDSCB=mod.given("CDSCB");
  modParamMap["CDSCB"] = &modelPar_CDSCB;
  AdmsSensFadType modelPar_CDSCBL=mod.CDSCBL;
  bool modelPar_given_CDSCBL=mod.given("CDSCBL");
  modParamMap["CDSCBL"] = &modelPar_CDSCBL;
  AdmsSensFadType modelPar_CDSCBLEXP=mod.CDSCBLEXP;
  bool modelPar_given_CDSCBLEXP=mod.given("CDSCBLEXP");
  modParamMap["CDSCBLEXP"] = &modelPar_CDSCBLEXP;
  AdmsSensFadType modelPar_LCDSCB=mod.LCDSCB;
  bool modelPar_given_LCDSCB=mod.given("LCDSCB");
  modParamMap["LCDSCB"] = &modelPar_LCDSCB;
  AdmsSensFadType modelPar_WCDSCB=mod.WCDSCB;
  bool modelPar_given_WCDSCB=mod.given("WCDSCB");
  modParamMap["WCDSCB"] = &modelPar_WCDSCB;
  AdmsSensFadType modelPar_PCDSCB=mod.PCDSCB;
  bool modelPar_given_PCDSCB=mod.given("PCDSCB");
  modParamMap["PCDSCB"] = &modelPar_PCDSCB;
  AdmsSensFadType modelPar_VSAT=mod.VSAT;
  bool modelPar_given_VSAT=mod.given("VSAT");
  modParamMap["VSAT"] = &modelPar_VSAT;
  AdmsSensFadType modelPar_LVSAT=mod.LVSAT;
  bool modelPar_given_LVSAT=mod.given("LVSAT");
  modParamMap["LVSAT"] = &modelPar_LVSAT;
  AdmsSensFadType modelPar_WVSAT=mod.WVSAT;
  bool modelPar_given_WVSAT=mod.given("WVSAT");
  modParamMap["WVSAT"] = &modelPar_WVSAT;
  AdmsSensFadType modelPar_PVSAT=mod.PVSAT;
  bool modelPar_given_PVSAT=mod.given("PVSAT");
  modParamMap["PVSAT"] = &modelPar_PVSAT;
  AdmsSensFadType modelPar_VSATL=mod.VSATL;
  bool modelPar_given_VSATL=mod.given("VSATL");
  modParamMap["VSATL"] = &modelPar_VSATL;
  AdmsSensFadType modelPar_VSATLEXP=mod.VSATLEXP;
  bool modelPar_given_VSATLEXP=mod.given("VSATLEXP");
  modParamMap["VSATLEXP"] = &modelPar_VSATLEXP;
  AdmsSensFadType modelPar_VSATW=mod.VSATW;
  bool modelPar_given_VSATW=mod.given("VSATW");
  modParamMap["VSATW"] = &modelPar_VSATW;
  AdmsSensFadType modelPar_VSATWEXP=mod.VSATWEXP;
  bool modelPar_given_VSATWEXP=mod.given("VSATWEXP");
  modParamMap["VSATWEXP"] = &modelPar_VSATWEXP;
  AdmsSensFadType modelPar_VSATWL=mod.VSATWL;
  bool modelPar_given_VSATWL=mod.given("VSATWL");
  modParamMap["VSATWL"] = &modelPar_VSATWL;
  AdmsSensFadType modelPar_VSATWLEXP=mod.VSATWLEXP;
  bool modelPar_given_VSATWLEXP=mod.given("VSATWLEXP");
  modParamMap["VSATWLEXP"] = &modelPar_VSATWLEXP;
  AdmsSensFadType modelPar_VSATR=mod.VSATR;
  bool modelPar_given_VSATR=mod.given("VSATR");
  modParamMap["VSATR"] = &modelPar_VSATR;
  AdmsSensFadType modelPar_LVSATR=mod.LVSATR;
  bool modelPar_given_LVSATR=mod.given("LVSATR");
  modParamMap["LVSATR"] = &modelPar_LVSATR;
  AdmsSensFadType modelPar_WVSATR=mod.WVSATR;
  bool modelPar_given_WVSATR=mod.given("WVSATR");
  modParamMap["WVSATR"] = &modelPar_WVSATR;
  AdmsSensFadType modelPar_PVSATR=mod.PVSATR;
  bool modelPar_given_PVSATR=mod.given("PVSATR");
  modParamMap["PVSATR"] = &modelPar_PVSATR;
  AdmsSensFadType modelPar_DELTA=mod.DELTA;
  bool modelPar_given_DELTA=mod.given("DELTA");
  modParamMap["DELTA"] = &modelPar_DELTA;
  AdmsSensFadType modelPar_LDELTA=mod.LDELTA;
  bool modelPar_given_LDELTA=mod.given("LDELTA");
  modParamMap["LDELTA"] = &modelPar_LDELTA;
  AdmsSensFadType modelPar_WDELTA=mod.WDELTA;
  bool modelPar_given_WDELTA=mod.given("WDELTA");
  modParamMap["WDELTA"] = &modelPar_WDELTA;
  AdmsSensFadType modelPar_PDELTA=mod.PDELTA;
  bool modelPar_given_PDELTA=mod.given("PDELTA");
  modParamMap["PDELTA"] = &modelPar_PDELTA;
  AdmsSensFadType modelPar_DELTAL=mod.DELTAL;
  bool modelPar_given_DELTAL=mod.given("DELTAL");
  modParamMap["DELTAL"] = &modelPar_DELTAL;
  AdmsSensFadType modelPar_DELTALEXP=mod.DELTALEXP;
  bool modelPar_given_DELTALEXP=mod.given("DELTALEXP");
  modParamMap["DELTALEXP"] = &modelPar_DELTALEXP;
  AdmsSensFadType modelPar_VSATCV=mod.VSATCV;
  bool modelPar_given_VSATCV=mod.given("VSATCV");
  modParamMap["VSATCV"] = &modelPar_VSATCV;
  AdmsSensFadType modelPar_LVSATCV=mod.LVSATCV;
  bool modelPar_given_LVSATCV=mod.given("LVSATCV");
  modParamMap["LVSATCV"] = &modelPar_LVSATCV;
  AdmsSensFadType modelPar_WVSATCV=mod.WVSATCV;
  bool modelPar_given_WVSATCV=mod.given("WVSATCV");
  modParamMap["WVSATCV"] = &modelPar_WVSATCV;
  AdmsSensFadType modelPar_PVSATCV=mod.PVSATCV;
  bool modelPar_given_PVSATCV=mod.given("PVSATCV");
  modParamMap["PVSATCV"] = &modelPar_PVSATCV;
  AdmsSensFadType modelPar_VSATCVL=mod.VSATCVL;
  bool modelPar_given_VSATCVL=mod.given("VSATCVL");
  modParamMap["VSATCVL"] = &modelPar_VSATCVL;
  AdmsSensFadType modelPar_VSATCVLEXP=mod.VSATCVLEXP;
  bool modelPar_given_VSATCVLEXP=mod.given("VSATCVLEXP");
  modParamMap["VSATCVLEXP"] = &modelPar_VSATCVLEXP;
  AdmsSensFadType modelPar_VSATCVW=mod.VSATCVW;
  bool modelPar_given_VSATCVW=mod.given("VSATCVW");
  modParamMap["VSATCVW"] = &modelPar_VSATCVW;
  AdmsSensFadType modelPar_VSATCVWEXP=mod.VSATCVWEXP;
  bool modelPar_given_VSATCVWEXP=mod.given("VSATCVWEXP");
  modParamMap["VSATCVWEXP"] = &modelPar_VSATCVWEXP;
  AdmsSensFadType modelPar_VSATCVWL=mod.VSATCVWL;
  bool modelPar_given_VSATCVWL=mod.given("VSATCVWL");
  modParamMap["VSATCVWL"] = &modelPar_VSATCVWL;
  AdmsSensFadType modelPar_VSATCVWLEXP=mod.VSATCVWLEXP;
  bool modelPar_given_VSATCVWLEXP=mod.given("VSATCVWLEXP");
  modParamMap["VSATCVWLEXP"] = &modelPar_VSATCVWLEXP;
  AdmsSensFadType modelPar_UP1=mod.UP1;
  bool modelPar_given_UP1=mod.given("UP1");
  modParamMap["UP1"] = &modelPar_UP1;
  AdmsSensFadType modelPar_LP1=mod.LP1;
  bool modelPar_given_LP1=mod.given("LP1");
  modParamMap["LP1"] = &modelPar_LP1;
  AdmsSensFadType modelPar_UP2=mod.UP2;
  bool modelPar_given_UP2=mod.given("UP2");
  modParamMap["UP2"] = &modelPar_UP2;
  AdmsSensFadType modelPar_LP2=mod.LP2;
  bool modelPar_given_LP2=mod.given("LP2");
  modParamMap["LP2"] = &modelPar_LP2;
  AdmsSensFadType modelPar_MULU0=mod.MULU0;
  bool modelPar_given_MULU0=mod.given("MULU0");
  modParamMap["MULU0"] = &modelPar_MULU0;
  AdmsSensFadType modelPar_U0=mod.U0;
  bool modelPar_given_U0=mod.given("U0");
  modParamMap["U0"] = &modelPar_U0;
  AdmsSensFadType modelPar_U0L=mod.U0L;
  bool modelPar_given_U0L=mod.given("U0L");
  modParamMap["U0L"] = &modelPar_U0L;
  AdmsSensFadType modelPar_U0LEXP=mod.U0LEXP;
  bool modelPar_given_U0LEXP=mod.given("U0LEXP");
  modParamMap["U0LEXP"] = &modelPar_U0LEXP;
  AdmsSensFadType modelPar_LU0=mod.LU0;
  bool modelPar_given_LU0=mod.given("LU0");
  modParamMap["LU0"] = &modelPar_LU0;
  AdmsSensFadType modelPar_WU0=mod.WU0;
  bool modelPar_given_WU0=mod.given("WU0");
  modParamMap["WU0"] = &modelPar_WU0;
  AdmsSensFadType modelPar_PU0=mod.PU0;
  bool modelPar_given_PU0=mod.given("PU0");
  modParamMap["PU0"] = &modelPar_PU0;
  AdmsSensFadType modelPar_U0R=mod.U0R;
  bool modelPar_given_U0R=mod.given("U0R");
  modParamMap["U0R"] = &modelPar_U0R;
  AdmsSensFadType modelPar_LU0R=mod.LU0R;
  bool modelPar_given_LU0R=mod.given("LU0R");
  modParamMap["LU0R"] = &modelPar_LU0R;
  AdmsSensFadType modelPar_WU0R=mod.WU0R;
  bool modelPar_given_WU0R=mod.given("WU0R");
  modParamMap["WU0R"] = &modelPar_WU0R;
  AdmsSensFadType modelPar_PU0R=mod.PU0R;
  bool modelPar_given_PU0R=mod.given("PU0R");
  modParamMap["PU0R"] = &modelPar_PU0R;
  AdmsSensFadType modelPar_ETAMOB=mod.ETAMOB;
  bool modelPar_given_ETAMOB=mod.given("ETAMOB");
  modParamMap["ETAMOB"] = &modelPar_ETAMOB;
  AdmsSensFadType modelPar_UA=mod.UA;
  bool modelPar_given_UA=mod.given("UA");
  modParamMap["UA"] = &modelPar_UA;
  AdmsSensFadType modelPar_UAL=mod.UAL;
  bool modelPar_given_UAL=mod.given("UAL");
  modParamMap["UAL"] = &modelPar_UAL;
  AdmsSensFadType modelPar_UALEXP=mod.UALEXP;
  bool modelPar_given_UALEXP=mod.given("UALEXP");
  modParamMap["UALEXP"] = &modelPar_UALEXP;
  AdmsSensFadType modelPar_UAW=mod.UAW;
  bool modelPar_given_UAW=mod.given("UAW");
  modParamMap["UAW"] = &modelPar_UAW;
  AdmsSensFadType modelPar_UAWEXP=mod.UAWEXP;
  bool modelPar_given_UAWEXP=mod.given("UAWEXP");
  modParamMap["UAWEXP"] = &modelPar_UAWEXP;
  AdmsSensFadType modelPar_UAWL=mod.UAWL;
  bool modelPar_given_UAWL=mod.given("UAWL");
  modParamMap["UAWL"] = &modelPar_UAWL;
  AdmsSensFadType modelPar_UAWLEXP=mod.UAWLEXP;
  bool modelPar_given_UAWLEXP=mod.given("UAWLEXP");
  modParamMap["UAWLEXP"] = &modelPar_UAWLEXP;
  AdmsSensFadType modelPar_LUA=mod.LUA;
  bool modelPar_given_LUA=mod.given("LUA");
  modParamMap["LUA"] = &modelPar_LUA;
  AdmsSensFadType modelPar_WUA=mod.WUA;
  bool modelPar_given_WUA=mod.given("WUA");
  modParamMap["WUA"] = &modelPar_WUA;
  AdmsSensFadType modelPar_PUA=mod.PUA;
  bool modelPar_given_PUA=mod.given("PUA");
  modParamMap["PUA"] = &modelPar_PUA;
  AdmsSensFadType modelPar_UAR=mod.UAR;
  bool modelPar_given_UAR=mod.given("UAR");
  modParamMap["UAR"] = &modelPar_UAR;
  AdmsSensFadType modelPar_LUAR=mod.LUAR;
  bool modelPar_given_LUAR=mod.given("LUAR");
  modParamMap["LUAR"] = &modelPar_LUAR;
  AdmsSensFadType modelPar_WUAR=mod.WUAR;
  bool modelPar_given_WUAR=mod.given("WUAR");
  modParamMap["WUAR"] = &modelPar_WUAR;
  AdmsSensFadType modelPar_PUAR=mod.PUAR;
  bool modelPar_given_PUAR=mod.given("PUAR");
  modParamMap["PUAR"] = &modelPar_PUAR;
  AdmsSensFadType modelPar_EU=mod.EU;
  bool modelPar_given_EU=mod.given("EU");
  modParamMap["EU"] = &modelPar_EU;
  AdmsSensFadType modelPar_LEU=mod.LEU;
  bool modelPar_given_LEU=mod.given("LEU");
  modParamMap["LEU"] = &modelPar_LEU;
  AdmsSensFadType modelPar_WEU=mod.WEU;
  bool modelPar_given_WEU=mod.given("WEU");
  modParamMap["WEU"] = &modelPar_WEU;
  AdmsSensFadType modelPar_PEU=mod.PEU;
  bool modelPar_given_PEU=mod.given("PEU");
  modParamMap["PEU"] = &modelPar_PEU;
  AdmsSensFadType modelPar_EUL=mod.EUL;
  bool modelPar_given_EUL=mod.given("EUL");
  modParamMap["EUL"] = &modelPar_EUL;
  AdmsSensFadType modelPar_EULEXP=mod.EULEXP;
  bool modelPar_given_EULEXP=mod.given("EULEXP");
  modParamMap["EULEXP"] = &modelPar_EULEXP;
  AdmsSensFadType modelPar_EUW=mod.EUW;
  bool modelPar_given_EUW=mod.given("EUW");
  modParamMap["EUW"] = &modelPar_EUW;
  AdmsSensFadType modelPar_EUWEXP=mod.EUWEXP;
  bool modelPar_given_EUWEXP=mod.given("EUWEXP");
  modParamMap["EUWEXP"] = &modelPar_EUWEXP;
  AdmsSensFadType modelPar_EUWL=mod.EUWL;
  bool modelPar_given_EUWL=mod.given("EUWL");
  modParamMap["EUWL"] = &modelPar_EUWL;
  AdmsSensFadType modelPar_EUWLEXP=mod.EUWLEXP;
  bool modelPar_given_EUWLEXP=mod.given("EUWLEXP");
  modParamMap["EUWLEXP"] = &modelPar_EUWLEXP;
  AdmsSensFadType modelPar_UD=mod.UD;
  bool modelPar_given_UD=mod.given("UD");
  modParamMap["UD"] = &modelPar_UD;
  AdmsSensFadType modelPar_UDL=mod.UDL;
  bool modelPar_given_UDL=mod.given("UDL");
  modParamMap["UDL"] = &modelPar_UDL;
  AdmsSensFadType modelPar_UDLEXP=mod.UDLEXP;
  bool modelPar_given_UDLEXP=mod.given("UDLEXP");
  modParamMap["UDLEXP"] = &modelPar_UDLEXP;
  AdmsSensFadType modelPar_LUD=mod.LUD;
  bool modelPar_given_LUD=mod.given("LUD");
  modParamMap["LUD"] = &modelPar_LUD;
  AdmsSensFadType modelPar_WUD=mod.WUD;
  bool modelPar_given_WUD=mod.given("WUD");
  modParamMap["WUD"] = &modelPar_WUD;
  AdmsSensFadType modelPar_PUD=mod.PUD;
  bool modelPar_given_PUD=mod.given("PUD");
  modParamMap["PUD"] = &modelPar_PUD;
  AdmsSensFadType modelPar_UDR=mod.UDR;
  bool modelPar_given_UDR=mod.given("UDR");
  modParamMap["UDR"] = &modelPar_UDR;
  AdmsSensFadType modelPar_LUDR=mod.LUDR;
  bool modelPar_given_LUDR=mod.given("LUDR");
  modParamMap["LUDR"] = &modelPar_LUDR;
  AdmsSensFadType modelPar_WUDR=mod.WUDR;
  bool modelPar_given_WUDR=mod.given("WUDR");
  modParamMap["WUDR"] = &modelPar_WUDR;
  AdmsSensFadType modelPar_PUDR=mod.PUDR;
  bool modelPar_given_PUDR=mod.given("PUDR");
  modParamMap["PUDR"] = &modelPar_PUDR;
  AdmsSensFadType modelPar_UCS=mod.UCS;
  bool modelPar_given_UCS=mod.given("UCS");
  modParamMap["UCS"] = &modelPar_UCS;
  AdmsSensFadType modelPar_LUCS=mod.LUCS;
  bool modelPar_given_LUCS=mod.given("LUCS");
  modParamMap["LUCS"] = &modelPar_LUCS;
  AdmsSensFadType modelPar_WUCS=mod.WUCS;
  bool modelPar_given_WUCS=mod.given("WUCS");
  modParamMap["WUCS"] = &modelPar_WUCS;
  AdmsSensFadType modelPar_PUCS=mod.PUCS;
  bool modelPar_given_PUCS=mod.given("PUCS");
  modParamMap["PUCS"] = &modelPar_PUCS;
  AdmsSensFadType modelPar_UCSR=mod.UCSR;
  bool modelPar_given_UCSR=mod.given("UCSR");
  modParamMap["UCSR"] = &modelPar_UCSR;
  AdmsSensFadType modelPar_LUCSR=mod.LUCSR;
  bool modelPar_given_LUCSR=mod.given("LUCSR");
  modParamMap["LUCSR"] = &modelPar_LUCSR;
  AdmsSensFadType modelPar_WUCSR=mod.WUCSR;
  bool modelPar_given_WUCSR=mod.given("WUCSR");
  modParamMap["WUCSR"] = &modelPar_WUCSR;
  AdmsSensFadType modelPar_PUCSR=mod.PUCSR;
  bool modelPar_given_PUCSR=mod.given("PUCSR");
  modParamMap["PUCSR"] = &modelPar_PUCSR;
  AdmsSensFadType modelPar_UC=mod.UC;
  bool modelPar_given_UC=mod.given("UC");
  modParamMap["UC"] = &modelPar_UC;
  AdmsSensFadType modelPar_UCL=mod.UCL;
  bool modelPar_given_UCL=mod.given("UCL");
  modParamMap["UCL"] = &modelPar_UCL;
  AdmsSensFadType modelPar_UCLEXP=mod.UCLEXP;
  bool modelPar_given_UCLEXP=mod.given("UCLEXP");
  modParamMap["UCLEXP"] = &modelPar_UCLEXP;
  AdmsSensFadType modelPar_UCW=mod.UCW;
  bool modelPar_given_UCW=mod.given("UCW");
  modParamMap["UCW"] = &modelPar_UCW;
  AdmsSensFadType modelPar_UCWEXP=mod.UCWEXP;
  bool modelPar_given_UCWEXP=mod.given("UCWEXP");
  modParamMap["UCWEXP"] = &modelPar_UCWEXP;
  AdmsSensFadType modelPar_UCWL=mod.UCWL;
  bool modelPar_given_UCWL=mod.given("UCWL");
  modParamMap["UCWL"] = &modelPar_UCWL;
  AdmsSensFadType modelPar_UCWLEXP=mod.UCWLEXP;
  bool modelPar_given_UCWLEXP=mod.given("UCWLEXP");
  modParamMap["UCWLEXP"] = &modelPar_UCWLEXP;
  AdmsSensFadType modelPar_LUC=mod.LUC;
  bool modelPar_given_LUC=mod.given("LUC");
  modParamMap["LUC"] = &modelPar_LUC;
  AdmsSensFadType modelPar_WUC=mod.WUC;
  bool modelPar_given_WUC=mod.given("WUC");
  modParamMap["WUC"] = &modelPar_WUC;
  AdmsSensFadType modelPar_PUC=mod.PUC;
  bool modelPar_given_PUC=mod.given("PUC");
  modParamMap["PUC"] = &modelPar_PUC;
  AdmsSensFadType modelPar_UCR=mod.UCR;
  bool modelPar_given_UCR=mod.given("UCR");
  modParamMap["UCR"] = &modelPar_UCR;
  AdmsSensFadType modelPar_LUCR=mod.LUCR;
  bool modelPar_given_LUCR=mod.given("LUCR");
  modParamMap["LUCR"] = &modelPar_LUCR;
  AdmsSensFadType modelPar_WUCR=mod.WUCR;
  bool modelPar_given_WUCR=mod.given("WUCR");
  modParamMap["WUCR"] = &modelPar_WUCR;
  AdmsSensFadType modelPar_PUCR=mod.PUCR;
  bool modelPar_given_PUCR=mod.given("PUCR");
  modParamMap["PUCR"] = &modelPar_PUCR;
  AdmsSensFadType modelPar_PCLM=mod.PCLM;
  bool modelPar_given_PCLM=mod.given("PCLM");
  modParamMap["PCLM"] = &modelPar_PCLM;
  AdmsSensFadType modelPar_PCLML=mod.PCLML;
  bool modelPar_given_PCLML=mod.given("PCLML");
  modParamMap["PCLML"] = &modelPar_PCLML;
  AdmsSensFadType modelPar_PCLMLEXP=mod.PCLMLEXP;
  bool modelPar_given_PCLMLEXP=mod.given("PCLMLEXP");
  modParamMap["PCLMLEXP"] = &modelPar_PCLMLEXP;
  AdmsSensFadType modelPar_LPCLM=mod.LPCLM;
  bool modelPar_given_LPCLM=mod.given("LPCLM");
  modParamMap["LPCLM"] = &modelPar_LPCLM;
  AdmsSensFadType modelPar_WPCLM=mod.WPCLM;
  bool modelPar_given_WPCLM=mod.given("WPCLM");
  modParamMap["WPCLM"] = &modelPar_WPCLM;
  AdmsSensFadType modelPar_PPCLM=mod.PPCLM;
  bool modelPar_given_PPCLM=mod.given("PPCLM");
  modParamMap["PPCLM"] = &modelPar_PPCLM;
  AdmsSensFadType modelPar_PCLMR=mod.PCLMR;
  bool modelPar_given_PCLMR=mod.given("PCLMR");
  modParamMap["PCLMR"] = &modelPar_PCLMR;
  AdmsSensFadType modelPar_LPCLMR=mod.LPCLMR;
  bool modelPar_given_LPCLMR=mod.given("LPCLMR");
  modParamMap["LPCLMR"] = &modelPar_LPCLMR;
  AdmsSensFadType modelPar_WPCLMR=mod.WPCLMR;
  bool modelPar_given_WPCLMR=mod.given("WPCLMR");
  modParamMap["WPCLMR"] = &modelPar_WPCLMR;
  AdmsSensFadType modelPar_PPCLMR=mod.PPCLMR;
  bool modelPar_given_PPCLMR=mod.given("PPCLMR");
  modParamMap["PPCLMR"] = &modelPar_PPCLMR;
  AdmsSensFadType modelPar_PCLMG=mod.PCLMG;
  bool modelPar_given_PCLMG=mod.given("PCLMG");
  modParamMap["PCLMG"] = &modelPar_PCLMG;
  AdmsSensFadType modelPar_PCLMCV=mod.PCLMCV;
  bool modelPar_given_PCLMCV=mod.given("PCLMCV");
  modParamMap["PCLMCV"] = &modelPar_PCLMCV;
  AdmsSensFadType modelPar_PCLMCVL=mod.PCLMCVL;
  bool modelPar_given_PCLMCVL=mod.given("PCLMCVL");
  modParamMap["PCLMCVL"] = &modelPar_PCLMCVL;
  AdmsSensFadType modelPar_PCLMCVLEXP=mod.PCLMCVLEXP;
  bool modelPar_given_PCLMCVLEXP=mod.given("PCLMCVLEXP");
  modParamMap["PCLMCVLEXP"] = &modelPar_PCLMCVLEXP;
  AdmsSensFadType modelPar_LPCLMCV=mod.LPCLMCV;
  bool modelPar_given_LPCLMCV=mod.given("LPCLMCV");
  modParamMap["LPCLMCV"] = &modelPar_LPCLMCV;
  AdmsSensFadType modelPar_WPCLMCV=mod.WPCLMCV;
  bool modelPar_given_WPCLMCV=mod.given("WPCLMCV");
  modParamMap["WPCLMCV"] = &modelPar_WPCLMCV;
  AdmsSensFadType modelPar_PPCLMCV=mod.PPCLMCV;
  bool modelPar_given_PPCLMCV=mod.given("PPCLMCV");
  modParamMap["PPCLMCV"] = &modelPar_PPCLMCV;
  AdmsSensFadType modelPar_PSCBE1=mod.PSCBE1;
  bool modelPar_given_PSCBE1=mod.given("PSCBE1");
  modParamMap["PSCBE1"] = &modelPar_PSCBE1;
  AdmsSensFadType modelPar_LPSCBE1=mod.LPSCBE1;
  bool modelPar_given_LPSCBE1=mod.given("LPSCBE1");
  modParamMap["LPSCBE1"] = &modelPar_LPSCBE1;
  AdmsSensFadType modelPar_WPSCBE1=mod.WPSCBE1;
  bool modelPar_given_WPSCBE1=mod.given("WPSCBE1");
  modParamMap["WPSCBE1"] = &modelPar_WPSCBE1;
  AdmsSensFadType modelPar_PPSCBE1=mod.PPSCBE1;
  bool modelPar_given_PPSCBE1=mod.given("PPSCBE1");
  modParamMap["PPSCBE1"] = &modelPar_PPSCBE1;
  AdmsSensFadType modelPar_PSCBE2=mod.PSCBE2;
  bool modelPar_given_PSCBE2=mod.given("PSCBE2");
  modParamMap["PSCBE2"] = &modelPar_PSCBE2;
  AdmsSensFadType modelPar_LPSCBE2=mod.LPSCBE2;
  bool modelPar_given_LPSCBE2=mod.given("LPSCBE2");
  modParamMap["LPSCBE2"] = &modelPar_LPSCBE2;
  AdmsSensFadType modelPar_WPSCBE2=mod.WPSCBE2;
  bool modelPar_given_WPSCBE2=mod.given("WPSCBE2");
  modParamMap["WPSCBE2"] = &modelPar_WPSCBE2;
  AdmsSensFadType modelPar_PPSCBE2=mod.PPSCBE2;
  bool modelPar_given_PPSCBE2=mod.given("PPSCBE2");
  modParamMap["PPSCBE2"] = &modelPar_PPSCBE2;
  AdmsSensFadType modelPar_PDITS=mod.PDITS;
  bool modelPar_given_PDITS=mod.given("PDITS");
  modParamMap["PDITS"] = &modelPar_PDITS;
  AdmsSensFadType modelPar_LPDITS=mod.LPDITS;
  bool modelPar_given_LPDITS=mod.given("LPDITS");
  modParamMap["LPDITS"] = &modelPar_LPDITS;
  AdmsSensFadType modelPar_WPDITS=mod.WPDITS;
  bool modelPar_given_WPDITS=mod.given("WPDITS");
  modParamMap["WPDITS"] = &modelPar_WPDITS;
  AdmsSensFadType modelPar_PPDITS=mod.PPDITS;
  bool modelPar_given_PPDITS=mod.given("PPDITS");
  modParamMap["PPDITS"] = &modelPar_PPDITS;
  AdmsSensFadType modelPar_PDITSL=mod.PDITSL;
  bool modelPar_given_PDITSL=mod.given("PDITSL");
  modParamMap["PDITSL"] = &modelPar_PDITSL;
  AdmsSensFadType modelPar_PDITSD=mod.PDITSD;
  bool modelPar_given_PDITSD=mod.given("PDITSD");
  modParamMap["PDITSD"] = &modelPar_PDITSD;
  AdmsSensFadType modelPar_LPDITSD=mod.LPDITSD;
  bool modelPar_given_LPDITSD=mod.given("LPDITSD");
  modParamMap["LPDITSD"] = &modelPar_LPDITSD;
  AdmsSensFadType modelPar_WPDITSD=mod.WPDITSD;
  bool modelPar_given_WPDITSD=mod.given("WPDITSD");
  modParamMap["WPDITSD"] = &modelPar_WPDITSD;
  AdmsSensFadType modelPar_PPDITSD=mod.PPDITSD;
  bool modelPar_given_PPDITSD=mod.given("PPDITSD");
  modParamMap["PPDITSD"] = &modelPar_PPDITSD;
  AdmsSensFadType modelPar_RSH=mod.RSH;
  bool modelPar_given_RSH=mod.given("RSH");
  modParamMap["RSH"] = &modelPar_RSH;
  AdmsSensFadType modelPar_PRWG=mod.PRWG;
  bool modelPar_given_PRWG=mod.given("PRWG");
  modParamMap["PRWG"] = &modelPar_PRWG;
  AdmsSensFadType modelPar_LPRWG=mod.LPRWG;
  bool modelPar_given_LPRWG=mod.given("LPRWG");
  modParamMap["LPRWG"] = &modelPar_LPRWG;
  AdmsSensFadType modelPar_WPRWG=mod.WPRWG;
  bool modelPar_given_WPRWG=mod.given("WPRWG");
  modParamMap["WPRWG"] = &modelPar_WPRWG;
  AdmsSensFadType modelPar_PPRWG=mod.PPRWG;
  bool modelPar_given_PPRWG=mod.given("PPRWG");
  modParamMap["PPRWG"] = &modelPar_PPRWG;
  AdmsSensFadType modelPar_PRWB=mod.PRWB;
  bool modelPar_given_PRWB=mod.given("PRWB");
  modParamMap["PRWB"] = &modelPar_PRWB;
  AdmsSensFadType modelPar_LPRWB=mod.LPRWB;
  bool modelPar_given_LPRWB=mod.given("LPRWB");
  modParamMap["LPRWB"] = &modelPar_LPRWB;
  AdmsSensFadType modelPar_WPRWB=mod.WPRWB;
  bool modelPar_given_WPRWB=mod.given("WPRWB");
  modParamMap["WPRWB"] = &modelPar_WPRWB;
  AdmsSensFadType modelPar_PPRWB=mod.PPRWB;
  bool modelPar_given_PPRWB=mod.given("PPRWB");
  modParamMap["PPRWB"] = &modelPar_PPRWB;
  AdmsSensFadType modelPar_PRWBL=mod.PRWBL;
  bool modelPar_given_PRWBL=mod.given("PRWBL");
  modParamMap["PRWBL"] = &modelPar_PRWBL;
  AdmsSensFadType modelPar_PRWBLEXP=mod.PRWBLEXP;
  bool modelPar_given_PRWBLEXP=mod.given("PRWBLEXP");
  modParamMap["PRWBLEXP"] = &modelPar_PRWBLEXP;
  AdmsSensFadType modelPar_WR=mod.WR;
  bool modelPar_given_WR=mod.given("WR");
  modParamMap["WR"] = &modelPar_WR;
  AdmsSensFadType modelPar_LWR=mod.LWR;
  bool modelPar_given_LWR=mod.given("LWR");
  modParamMap["LWR"] = &modelPar_LWR;
  AdmsSensFadType modelPar_WWR=mod.WWR;
  bool modelPar_given_WWR=mod.given("WWR");
  modParamMap["WWR"] = &modelPar_WWR;
  AdmsSensFadType modelPar_PWR=mod.PWR;
  bool modelPar_given_PWR=mod.given("PWR");
  modParamMap["PWR"] = &modelPar_PWR;
  AdmsSensFadType modelPar_RSWMIN=mod.RSWMIN;
  bool modelPar_given_RSWMIN=mod.given("RSWMIN");
  modParamMap["RSWMIN"] = &modelPar_RSWMIN;
  AdmsSensFadType modelPar_LRSWMIN=mod.LRSWMIN;
  bool modelPar_given_LRSWMIN=mod.given("LRSWMIN");
  modParamMap["LRSWMIN"] = &modelPar_LRSWMIN;
  AdmsSensFadType modelPar_WRSWMIN=mod.WRSWMIN;
  bool modelPar_given_WRSWMIN=mod.given("WRSWMIN");
  modParamMap["WRSWMIN"] = &modelPar_WRSWMIN;
  AdmsSensFadType modelPar_PRSWMIN=mod.PRSWMIN;
  bool modelPar_given_PRSWMIN=mod.given("PRSWMIN");
  modParamMap["PRSWMIN"] = &modelPar_PRSWMIN;
  AdmsSensFadType modelPar_RSW=mod.RSW;
  bool modelPar_given_RSW=mod.given("RSW");
  modParamMap["RSW"] = &modelPar_RSW;
  AdmsSensFadType modelPar_LRSW=mod.LRSW;
  bool modelPar_given_LRSW=mod.given("LRSW");
  modParamMap["LRSW"] = &modelPar_LRSW;
  AdmsSensFadType modelPar_WRSW=mod.WRSW;
  bool modelPar_given_WRSW=mod.given("WRSW");
  modParamMap["WRSW"] = &modelPar_WRSW;
  AdmsSensFadType modelPar_PRSW=mod.PRSW;
  bool modelPar_given_PRSW=mod.given("PRSW");
  modParamMap["PRSW"] = &modelPar_PRSW;
  AdmsSensFadType modelPar_RSWL=mod.RSWL;
  bool modelPar_given_RSWL=mod.given("RSWL");
  modParamMap["RSWL"] = &modelPar_RSWL;
  AdmsSensFadType modelPar_RSWLEXP=mod.RSWLEXP;
  bool modelPar_given_RSWLEXP=mod.given("RSWLEXP");
  modParamMap["RSWLEXP"] = &modelPar_RSWLEXP;
  AdmsSensFadType modelPar_RDWMIN=mod.RDWMIN;
  bool modelPar_given_RDWMIN=mod.given("RDWMIN");
  modParamMap["RDWMIN"] = &modelPar_RDWMIN;
  AdmsSensFadType modelPar_LRDWMIN=mod.LRDWMIN;
  bool modelPar_given_LRDWMIN=mod.given("LRDWMIN");
  modParamMap["LRDWMIN"] = &modelPar_LRDWMIN;
  AdmsSensFadType modelPar_WRDWMIN=mod.WRDWMIN;
  bool modelPar_given_WRDWMIN=mod.given("WRDWMIN");
  modParamMap["WRDWMIN"] = &modelPar_WRDWMIN;
  AdmsSensFadType modelPar_PRDWMIN=mod.PRDWMIN;
  bool modelPar_given_PRDWMIN=mod.given("PRDWMIN");
  modParamMap["PRDWMIN"] = &modelPar_PRDWMIN;
  AdmsSensFadType modelPar_RDW=mod.RDW;
  bool modelPar_given_RDW=mod.given("RDW");
  modParamMap["RDW"] = &modelPar_RDW;
  AdmsSensFadType modelPar_LRDW=mod.LRDW;
  bool modelPar_given_LRDW=mod.given("LRDW");
  modParamMap["LRDW"] = &modelPar_LRDW;
  AdmsSensFadType modelPar_WRDW=mod.WRDW;
  bool modelPar_given_WRDW=mod.given("WRDW");
  modParamMap["WRDW"] = &modelPar_WRDW;
  AdmsSensFadType modelPar_PRDW=mod.PRDW;
  bool modelPar_given_PRDW=mod.given("PRDW");
  modParamMap["PRDW"] = &modelPar_PRDW;
  AdmsSensFadType modelPar_RDWL=mod.RDWL;
  bool modelPar_given_RDWL=mod.given("RDWL");
  modParamMap["RDWL"] = &modelPar_RDWL;
  AdmsSensFadType modelPar_RDWLEXP=mod.RDWLEXP;
  bool modelPar_given_RDWLEXP=mod.given("RDWLEXP");
  modParamMap["RDWLEXP"] = &modelPar_RDWLEXP;
  AdmsSensFadType modelPar_RDSWMIN=mod.RDSWMIN;
  bool modelPar_given_RDSWMIN=mod.given("RDSWMIN");
  modParamMap["RDSWMIN"] = &modelPar_RDSWMIN;
  AdmsSensFadType modelPar_LRDSWMIN=mod.LRDSWMIN;
  bool modelPar_given_LRDSWMIN=mod.given("LRDSWMIN");
  modParamMap["LRDSWMIN"] = &modelPar_LRDSWMIN;
  AdmsSensFadType modelPar_WRDSWMIN=mod.WRDSWMIN;
  bool modelPar_given_WRDSWMIN=mod.given("WRDSWMIN");
  modParamMap["WRDSWMIN"] = &modelPar_WRDSWMIN;
  AdmsSensFadType modelPar_PRDSWMIN=mod.PRDSWMIN;
  bool modelPar_given_PRDSWMIN=mod.given("PRDSWMIN");
  modParamMap["PRDSWMIN"] = &modelPar_PRDSWMIN;
  AdmsSensFadType modelPar_RDSW=mod.RDSW;
  bool modelPar_given_RDSW=mod.given("RDSW");
  modParamMap["RDSW"] = &modelPar_RDSW;
  AdmsSensFadType modelPar_RDSWL=mod.RDSWL;
  bool modelPar_given_RDSWL=mod.given("RDSWL");
  modParamMap["RDSWL"] = &modelPar_RDSWL;
  AdmsSensFadType modelPar_RDSWLEXP=mod.RDSWLEXP;
  bool modelPar_given_RDSWLEXP=mod.given("RDSWLEXP");
  modParamMap["RDSWLEXP"] = &modelPar_RDSWLEXP;
  AdmsSensFadType modelPar_LRDSW=mod.LRDSW;
  bool modelPar_given_LRDSW=mod.given("LRDSW");
  modParamMap["LRDSW"] = &modelPar_LRDSW;
  AdmsSensFadType modelPar_WRDSW=mod.WRDSW;
  bool modelPar_given_WRDSW=mod.given("WRDSW");
  modParamMap["WRDSW"] = &modelPar_WRDSW;
  AdmsSensFadType modelPar_PRDSW=mod.PRDSW;
  bool modelPar_given_PRDSW=mod.given("PRDSW");
  modParamMap["PRDSW"] = &modelPar_PRDSW;
  AdmsSensFadType modelPar_PSAT=mod.PSAT;
  bool modelPar_given_PSAT=mod.given("PSAT");
  modParamMap["PSAT"] = &modelPar_PSAT;
  AdmsSensFadType modelPar_LPSAT=mod.LPSAT;
  bool modelPar_given_LPSAT=mod.given("LPSAT");
  modParamMap["LPSAT"] = &modelPar_LPSAT;
  AdmsSensFadType modelPar_WPSAT=mod.WPSAT;
  bool modelPar_given_WPSAT=mod.given("WPSAT");
  modParamMap["WPSAT"] = &modelPar_WPSAT;
  AdmsSensFadType modelPar_PPSAT=mod.PPSAT;
  bool modelPar_given_PPSAT=mod.given("PPSAT");
  modParamMap["PPSAT"] = &modelPar_PPSAT;
  AdmsSensFadType modelPar_PSATL=mod.PSATL;
  bool modelPar_given_PSATL=mod.given("PSATL");
  modParamMap["PSATL"] = &modelPar_PSATL;
  AdmsSensFadType modelPar_PSATLEXP=mod.PSATLEXP;
  bool modelPar_given_PSATLEXP=mod.given("PSATLEXP");
  modParamMap["PSATLEXP"] = &modelPar_PSATLEXP;
  AdmsSensFadType modelPar_PSATB=mod.PSATB;
  bool modelPar_given_PSATB=mod.given("PSATB");
  modParamMap["PSATB"] = &modelPar_PSATB;
  AdmsSensFadType modelPar_PSATR=mod.PSATR;
  bool modelPar_given_PSATR=mod.given("PSATR");
  modParamMap["PSATR"] = &modelPar_PSATR;
  AdmsSensFadType modelPar_LPSATR=mod.LPSATR;
  bool modelPar_given_LPSATR=mod.given("LPSATR");
  modParamMap["LPSATR"] = &modelPar_LPSATR;
  AdmsSensFadType modelPar_WPSATR=mod.WPSATR;
  bool modelPar_given_WPSATR=mod.given("WPSATR");
  modParamMap["WPSATR"] = &modelPar_WPSATR;
  AdmsSensFadType modelPar_PPSATR=mod.PPSATR;
  bool modelPar_given_PPSATR=mod.given("PPSATR");
  modParamMap["PPSATR"] = &modelPar_PPSATR;
  AdmsSensFadType modelPar_LPSATB=mod.LPSATB;
  bool modelPar_given_LPSATB=mod.given("LPSATB");
  modParamMap["LPSATB"] = &modelPar_LPSATB;
  AdmsSensFadType modelPar_WPSATB=mod.WPSATB;
  bool modelPar_given_WPSATB=mod.given("WPSATB");
  modParamMap["WPSATB"] = &modelPar_WPSATB;
  AdmsSensFadType modelPar_PPSATB=mod.PPSATB;
  bool modelPar_given_PPSATB=mod.given("PPSATB");
  modParamMap["PPSATB"] = &modelPar_PPSATB;
  AdmsSensFadType modelPar_PSATX=mod.PSATX;
  bool modelPar_given_PSATX=mod.given("PSATX");
  modParamMap["PSATX"] = &modelPar_PSATX;
  AdmsSensFadType modelPar_PTWG=mod.PTWG;
  bool modelPar_given_PTWG=mod.given("PTWG");
  modParamMap["PTWG"] = &modelPar_PTWG;
  AdmsSensFadType modelPar_LPTWG=mod.LPTWG;
  bool modelPar_given_LPTWG=mod.given("LPTWG");
  modParamMap["LPTWG"] = &modelPar_LPTWG;
  AdmsSensFadType modelPar_WPTWG=mod.WPTWG;
  bool modelPar_given_WPTWG=mod.given("WPTWG");
  modParamMap["WPTWG"] = &modelPar_WPTWG;
  AdmsSensFadType modelPar_PPTWG=mod.PPTWG;
  bool modelPar_given_PPTWG=mod.given("PPTWG");
  modParamMap["PPTWG"] = &modelPar_PPTWG;
  AdmsSensFadType modelPar_PTWGL=mod.PTWGL;
  bool modelPar_given_PTWGL=mod.given("PTWGL");
  modParamMap["PTWGL"] = &modelPar_PTWGL;
  AdmsSensFadType modelPar_PTWGLEXP=mod.PTWGLEXP;
  bool modelPar_given_PTWGLEXP=mod.given("PTWGLEXP");
  modParamMap["PTWGLEXP"] = &modelPar_PTWGLEXP;
  AdmsSensFadType modelPar_PTWGR=mod.PTWGR;
  bool modelPar_given_PTWGR=mod.given("PTWGR");
  modParamMap["PTWGR"] = &modelPar_PTWGR;
  AdmsSensFadType modelPar_LPTWGR=mod.LPTWGR;
  bool modelPar_given_LPTWGR=mod.given("LPTWGR");
  modParamMap["LPTWGR"] = &modelPar_LPTWGR;
  AdmsSensFadType modelPar_WPTWGR=mod.WPTWGR;
  bool modelPar_given_WPTWGR=mod.given("WPTWGR");
  modParamMap["WPTWGR"] = &modelPar_WPTWGR;
  AdmsSensFadType modelPar_PPTWGR=mod.PPTWGR;
  bool modelPar_given_PPTWGR=mod.given("PPTWGR");
  modParamMap["PPTWGR"] = &modelPar_PPTWGR;
  AdmsSensFadType modelPar_PTWGLR=mod.PTWGLR;
  bool modelPar_given_PTWGLR=mod.given("PTWGLR");
  modParamMap["PTWGLR"] = &modelPar_PTWGLR;
  AdmsSensFadType modelPar_PTWGLEXPR=mod.PTWGLEXPR;
  bool modelPar_given_PTWGLEXPR=mod.given("PTWGLEXPR");
  modParamMap["PTWGLEXPR"] = &modelPar_PTWGLEXPR;
  AdmsSensFadType modelPar_A1=mod.A1;
  bool modelPar_given_A1=mod.given("A1");
  modParamMap["A1"] = &modelPar_A1;
  AdmsSensFadType modelPar_LA1=mod.LA1;
  bool modelPar_given_LA1=mod.given("LA1");
  modParamMap["LA1"] = &modelPar_LA1;
  AdmsSensFadType modelPar_WA1=mod.WA1;
  bool modelPar_given_WA1=mod.given("WA1");
  modParamMap["WA1"] = &modelPar_WA1;
  AdmsSensFadType modelPar_PA1=mod.PA1;
  bool modelPar_given_PA1=mod.given("PA1");
  modParamMap["PA1"] = &modelPar_PA1;
  AdmsSensFadType modelPar_A11=mod.A11;
  bool modelPar_given_A11=mod.given("A11");
  modParamMap["A11"] = &modelPar_A11;
  AdmsSensFadType modelPar_LA11=mod.LA11;
  bool modelPar_given_LA11=mod.given("LA11");
  modParamMap["LA11"] = &modelPar_LA11;
  AdmsSensFadType modelPar_WA11=mod.WA11;
  bool modelPar_given_WA11=mod.given("WA11");
  modParamMap["WA11"] = &modelPar_WA11;
  AdmsSensFadType modelPar_PA11=mod.PA11;
  bool modelPar_given_PA11=mod.given("PA11");
  modParamMap["PA11"] = &modelPar_PA11;
  AdmsSensFadType modelPar_A2=mod.A2;
  bool modelPar_given_A2=mod.given("A2");
  modParamMap["A2"] = &modelPar_A2;
  AdmsSensFadType modelPar_LA2=mod.LA2;
  bool modelPar_given_LA2=mod.given("LA2");
  modParamMap["LA2"] = &modelPar_LA2;
  AdmsSensFadType modelPar_WA2=mod.WA2;
  bool modelPar_given_WA2=mod.given("WA2");
  modParamMap["WA2"] = &modelPar_WA2;
  AdmsSensFadType modelPar_PA2=mod.PA2;
  bool modelPar_given_PA2=mod.given("PA2");
  modParamMap["PA2"] = &modelPar_PA2;
  AdmsSensFadType modelPar_A21=mod.A21;
  bool modelPar_given_A21=mod.given("A21");
  modParamMap["A21"] = &modelPar_A21;
  AdmsSensFadType modelPar_LA21=mod.LA21;
  bool modelPar_given_LA21=mod.given("LA21");
  modParamMap["LA21"] = &modelPar_LA21;
  AdmsSensFadType modelPar_WA21=mod.WA21;
  bool modelPar_given_WA21=mod.given("WA21");
  modParamMap["WA21"] = &modelPar_WA21;
  AdmsSensFadType modelPar_PA21=mod.PA21;
  bool modelPar_given_PA21=mod.given("PA21");
  modParamMap["PA21"] = &modelPar_PA21;
  AdmsSensFadType modelPar_PDIBLC=mod.PDIBLC;
  bool modelPar_given_PDIBLC=mod.given("PDIBLC");
  modParamMap["PDIBLC"] = &modelPar_PDIBLC;
  AdmsSensFadType modelPar_PDIBLCL=mod.PDIBLCL;
  bool modelPar_given_PDIBLCL=mod.given("PDIBLCL");
  modParamMap["PDIBLCL"] = &modelPar_PDIBLCL;
  AdmsSensFadType modelPar_PDIBLCLEXP=mod.PDIBLCLEXP;
  bool modelPar_given_PDIBLCLEXP=mod.given("PDIBLCLEXP");
  modParamMap["PDIBLCLEXP"] = &modelPar_PDIBLCLEXP;
  AdmsSensFadType modelPar_LPDIBLC=mod.LPDIBLC;
  bool modelPar_given_LPDIBLC=mod.given("LPDIBLC");
  modParamMap["LPDIBLC"] = &modelPar_LPDIBLC;
  AdmsSensFadType modelPar_WPDIBLC=mod.WPDIBLC;
  bool modelPar_given_WPDIBLC=mod.given("WPDIBLC");
  modParamMap["WPDIBLC"] = &modelPar_WPDIBLC;
  AdmsSensFadType modelPar_PPDIBLC=mod.PPDIBLC;
  bool modelPar_given_PPDIBLC=mod.given("PPDIBLC");
  modParamMap["PPDIBLC"] = &modelPar_PPDIBLC;
  AdmsSensFadType modelPar_PDIBLCR=mod.PDIBLCR;
  bool modelPar_given_PDIBLCR=mod.given("PDIBLCR");
  modParamMap["PDIBLCR"] = &modelPar_PDIBLCR;
  AdmsSensFadType modelPar_PDIBLCLR=mod.PDIBLCLR;
  bool modelPar_given_PDIBLCLR=mod.given("PDIBLCLR");
  modParamMap["PDIBLCLR"] = &modelPar_PDIBLCLR;
  AdmsSensFadType modelPar_PDIBLCLEXPR=mod.PDIBLCLEXPR;
  bool modelPar_given_PDIBLCLEXPR=mod.given("PDIBLCLEXPR");
  modParamMap["PDIBLCLEXPR"] = &modelPar_PDIBLCLEXPR;
  AdmsSensFadType modelPar_LPDIBLCR=mod.LPDIBLCR;
  bool modelPar_given_LPDIBLCR=mod.given("LPDIBLCR");
  modParamMap["LPDIBLCR"] = &modelPar_LPDIBLCR;
  AdmsSensFadType modelPar_WPDIBLCR=mod.WPDIBLCR;
  bool modelPar_given_WPDIBLCR=mod.given("WPDIBLCR");
  modParamMap["WPDIBLCR"] = &modelPar_WPDIBLCR;
  AdmsSensFadType modelPar_PPDIBLCR=mod.PPDIBLCR;
  bool modelPar_given_PPDIBLCR=mod.given("PPDIBLCR");
  modParamMap["PPDIBLCR"] = &modelPar_PPDIBLCR;
  AdmsSensFadType modelPar_PDIBLCB=mod.PDIBLCB;
  bool modelPar_given_PDIBLCB=mod.given("PDIBLCB");
  modParamMap["PDIBLCB"] = &modelPar_PDIBLCB;
  AdmsSensFadType modelPar_LPDIBLCB=mod.LPDIBLCB;
  bool modelPar_given_LPDIBLCB=mod.given("LPDIBLCB");
  modParamMap["LPDIBLCB"] = &modelPar_LPDIBLCB;
  AdmsSensFadType modelPar_WPDIBLCB=mod.WPDIBLCB;
  bool modelPar_given_WPDIBLCB=mod.given("WPDIBLCB");
  modParamMap["WPDIBLCB"] = &modelPar_WPDIBLCB;
  AdmsSensFadType modelPar_PPDIBLCB=mod.PPDIBLCB;
  bool modelPar_given_PPDIBLCB=mod.given("PPDIBLCB");
  modParamMap["PPDIBLCB"] = &modelPar_PPDIBLCB;
  AdmsSensFadType modelPar_PVAG=mod.PVAG;
  bool modelPar_given_PVAG=mod.given("PVAG");
  modParamMap["PVAG"] = &modelPar_PVAG;
  AdmsSensFadType modelPar_LPVAG=mod.LPVAG;
  bool modelPar_given_LPVAG=mod.given("LPVAG");
  modParamMap["LPVAG"] = &modelPar_LPVAG;
  AdmsSensFadType modelPar_WPVAG=mod.WPVAG;
  bool modelPar_given_WPVAG=mod.given("WPVAG");
  modParamMap["WPVAG"] = &modelPar_WPVAG;
  AdmsSensFadType modelPar_PPVAG=mod.PPVAG;
  bool modelPar_given_PPVAG=mod.given("PPVAG");
  modParamMap["PPVAG"] = &modelPar_PPVAG;
  AdmsSensFadType modelPar_FPROUT=mod.FPROUT;
  bool modelPar_given_FPROUT=mod.given("FPROUT");
  modParamMap["FPROUT"] = &modelPar_FPROUT;
  AdmsSensFadType modelPar_FPROUTL=mod.FPROUTL;
  bool modelPar_given_FPROUTL=mod.given("FPROUTL");
  modParamMap["FPROUTL"] = &modelPar_FPROUTL;
  AdmsSensFadType modelPar_FPROUTLEXP=mod.FPROUTLEXP;
  bool modelPar_given_FPROUTLEXP=mod.given("FPROUTLEXP");
  modParamMap["FPROUTLEXP"] = &modelPar_FPROUTLEXP;
  AdmsSensFadType modelPar_LFPROUT=mod.LFPROUT;
  bool modelPar_given_LFPROUT=mod.given("LFPROUT");
  modParamMap["LFPROUT"] = &modelPar_LFPROUT;
  AdmsSensFadType modelPar_WFPROUT=mod.WFPROUT;
  bool modelPar_given_WFPROUT=mod.given("WFPROUT");
  modParamMap["WFPROUT"] = &modelPar_WFPROUT;
  AdmsSensFadType modelPar_PFPROUT=mod.PFPROUT;
  bool modelPar_given_PFPROUT=mod.given("PFPROUT");
  modParamMap["PFPROUT"] = &modelPar_PFPROUT;
  AdmsSensFadType modelPar_ALPHA0=mod.ALPHA0;
  bool modelPar_given_ALPHA0=mod.given("ALPHA0");
  modParamMap["ALPHA0"] = &modelPar_ALPHA0;
  AdmsSensFadType modelPar_ALPHA0L=mod.ALPHA0L;
  bool modelPar_given_ALPHA0L=mod.given("ALPHA0L");
  modParamMap["ALPHA0L"] = &modelPar_ALPHA0L;
  AdmsSensFadType modelPar_ALPHA0LEXP=mod.ALPHA0LEXP;
  bool modelPar_given_ALPHA0LEXP=mod.given("ALPHA0LEXP");
  modParamMap["ALPHA0LEXP"] = &modelPar_ALPHA0LEXP;
  AdmsSensFadType modelPar_LALPHA0=mod.LALPHA0;
  bool modelPar_given_LALPHA0=mod.given("LALPHA0");
  modParamMap["LALPHA0"] = &modelPar_LALPHA0;
  AdmsSensFadType modelPar_WALPHA0=mod.WALPHA0;
  bool modelPar_given_WALPHA0=mod.given("WALPHA0");
  modParamMap["WALPHA0"] = &modelPar_WALPHA0;
  AdmsSensFadType modelPar_PALPHA0=mod.PALPHA0;
  bool modelPar_given_PALPHA0=mod.given("PALPHA0");
  modParamMap["PALPHA0"] = &modelPar_PALPHA0;
  AdmsSensFadType modelPar_BETA0=mod.BETA0;
  bool modelPar_given_BETA0=mod.given("BETA0");
  modParamMap["BETA0"] = &modelPar_BETA0;
  AdmsSensFadType modelPar_LBETA0=mod.LBETA0;
  bool modelPar_given_LBETA0=mod.given("LBETA0");
  modParamMap["LBETA0"] = &modelPar_LBETA0;
  AdmsSensFadType modelPar_WBETA0=mod.WBETA0;
  bool modelPar_given_WBETA0=mod.given("WBETA0");
  modParamMap["WBETA0"] = &modelPar_WBETA0;
  AdmsSensFadType modelPar_PBETA0=mod.PBETA0;
  bool modelPar_given_PBETA0=mod.given("PBETA0");
  modParamMap["PBETA0"] = &modelPar_PBETA0;
  AdmsSensFadType modelPar_AIGBACC=mod.AIGBACC;
  bool modelPar_given_AIGBACC=mod.given("AIGBACC");
  modParamMap["AIGBACC"] = &modelPar_AIGBACC;
  AdmsSensFadType modelPar_BIGBACC=mod.BIGBACC;
  bool modelPar_given_BIGBACC=mod.given("BIGBACC");
  modParamMap["BIGBACC"] = &modelPar_BIGBACC;
  AdmsSensFadType modelPar_CIGBACC=mod.CIGBACC;
  bool modelPar_given_CIGBACC=mod.given("CIGBACC");
  modParamMap["CIGBACC"] = &modelPar_CIGBACC;
  AdmsSensFadType modelPar_NIGBACC=mod.NIGBACC;
  bool modelPar_given_NIGBACC=mod.given("NIGBACC");
  modParamMap["NIGBACC"] = &modelPar_NIGBACC;
  AdmsSensFadType modelPar_AIGBINV=mod.AIGBINV;
  bool modelPar_given_AIGBINV=mod.given("AIGBINV");
  modParamMap["AIGBINV"] = &modelPar_AIGBINV;
  AdmsSensFadType modelPar_BIGBINV=mod.BIGBINV;
  bool modelPar_given_BIGBINV=mod.given("BIGBINV");
  modParamMap["BIGBINV"] = &modelPar_BIGBINV;
  AdmsSensFadType modelPar_CIGBINV=mod.CIGBINV;
  bool modelPar_given_CIGBINV=mod.given("CIGBINV");
  modParamMap["CIGBINV"] = &modelPar_CIGBINV;
  AdmsSensFadType modelPar_EIGBINV=mod.EIGBINV;
  bool modelPar_given_EIGBINV=mod.given("EIGBINV");
  modParamMap["EIGBINV"] = &modelPar_EIGBINV;
  AdmsSensFadType modelPar_NIGBINV=mod.NIGBINV;
  bool modelPar_given_NIGBINV=mod.given("NIGBINV");
  modParamMap["NIGBINV"] = &modelPar_NIGBINV;
  AdmsSensFadType modelPar_AIGC=mod.AIGC;
  bool modelPar_given_AIGC=mod.given("AIGC");
  modParamMap["AIGC"] = &modelPar_AIGC;
  AdmsSensFadType modelPar_BIGC=mod.BIGC;
  bool modelPar_given_BIGC=mod.given("BIGC");
  modParamMap["BIGC"] = &modelPar_BIGC;
  AdmsSensFadType modelPar_CIGC=mod.CIGC;
  bool modelPar_given_CIGC=mod.given("CIGC");
  modParamMap["CIGC"] = &modelPar_CIGC;
  AdmsSensFadType modelPar_AIGS=mod.AIGS;
  bool modelPar_given_AIGS=mod.given("AIGS");
  modParamMap["AIGS"] = &modelPar_AIGS;
  AdmsSensFadType modelPar_BIGS=mod.BIGS;
  bool modelPar_given_BIGS=mod.given("BIGS");
  modParamMap["BIGS"] = &modelPar_BIGS;
  AdmsSensFadType modelPar_CIGS=mod.CIGS;
  bool modelPar_given_CIGS=mod.given("CIGS");
  modParamMap["CIGS"] = &modelPar_CIGS;
  AdmsSensFadType modelPar_AIGD=mod.AIGD;
  bool modelPar_given_AIGD=mod.given("AIGD");
  modParamMap["AIGD"] = &modelPar_AIGD;
  AdmsSensFadType modelPar_BIGD=mod.BIGD;
  bool modelPar_given_BIGD=mod.given("BIGD");
  modParamMap["BIGD"] = &modelPar_BIGD;
  AdmsSensFadType modelPar_CIGD=mod.CIGD;
  bool modelPar_given_CIGD=mod.given("CIGD");
  modParamMap["CIGD"] = &modelPar_CIGD;
  AdmsSensFadType modelPar_DLCIG=mod.DLCIG;
  bool modelPar_given_DLCIG=mod.given("DLCIG");
  modParamMap["DLCIG"] = &modelPar_DLCIG;
  AdmsSensFadType modelPar_DLCIGD=mod.DLCIGD;
  bool modelPar_given_DLCIGD=mod.given("DLCIGD");
  modParamMap["DLCIGD"] = &modelPar_DLCIGD;
  AdmsSensFadType modelPar_POXEDGE=mod.POXEDGE;
  bool modelPar_given_POXEDGE=mod.given("POXEDGE");
  modParamMap["POXEDGE"] = &modelPar_POXEDGE;
  AdmsSensFadType modelPar_NTOX=mod.NTOX;
  bool modelPar_given_NTOX=mod.given("NTOX");
  modParamMap["NTOX"] = &modelPar_NTOX;
  AdmsSensFadType modelPar_TOXREF=mod.TOXREF;
  bool modelPar_given_TOXREF=mod.given("TOXREF");
  modParamMap["TOXREF"] = &modelPar_TOXREF;
  AdmsSensFadType modelPar_PIGCD=mod.PIGCD;
  bool modelPar_given_PIGCD=mod.given("PIGCD");
  modParamMap["PIGCD"] = &modelPar_PIGCD;
  AdmsSensFadType modelPar_AIGCL=mod.AIGCL;
  bool modelPar_given_AIGCL=mod.given("AIGCL");
  modParamMap["AIGCL"] = &modelPar_AIGCL;
  AdmsSensFadType modelPar_AIGCW=mod.AIGCW;
  bool modelPar_given_AIGCW=mod.given("AIGCW");
  modParamMap["AIGCW"] = &modelPar_AIGCW;
  AdmsSensFadType modelPar_AIGSL=mod.AIGSL;
  bool modelPar_given_AIGSL=mod.given("AIGSL");
  modParamMap["AIGSL"] = &modelPar_AIGSL;
  AdmsSensFadType modelPar_AIGSW=mod.AIGSW;
  bool modelPar_given_AIGSW=mod.given("AIGSW");
  modParamMap["AIGSW"] = &modelPar_AIGSW;
  AdmsSensFadType modelPar_AIGDL=mod.AIGDL;
  bool modelPar_given_AIGDL=mod.given("AIGDL");
  modParamMap["AIGDL"] = &modelPar_AIGDL;
  AdmsSensFadType modelPar_AIGDW=mod.AIGDW;
  bool modelPar_given_AIGDW=mod.given("AIGDW");
  modParamMap["AIGDW"] = &modelPar_AIGDW;
  AdmsSensFadType modelPar_PIGCDL=mod.PIGCDL;
  bool modelPar_given_PIGCDL=mod.given("PIGCDL");
  modParamMap["PIGCDL"] = &modelPar_PIGCDL;
  AdmsSensFadType modelPar_LAIGBINV=mod.LAIGBINV;
  bool modelPar_given_LAIGBINV=mod.given("LAIGBINV");
  modParamMap["LAIGBINV"] = &modelPar_LAIGBINV;
  AdmsSensFadType modelPar_WAIGBINV=mod.WAIGBINV;
  bool modelPar_given_WAIGBINV=mod.given("WAIGBINV");
  modParamMap["WAIGBINV"] = &modelPar_WAIGBINV;
  AdmsSensFadType modelPar_PAIGBINV=mod.PAIGBINV;
  bool modelPar_given_PAIGBINV=mod.given("PAIGBINV");
  modParamMap["PAIGBINV"] = &modelPar_PAIGBINV;
  AdmsSensFadType modelPar_LBIGBINV=mod.LBIGBINV;
  bool modelPar_given_LBIGBINV=mod.given("LBIGBINV");
  modParamMap["LBIGBINV"] = &modelPar_LBIGBINV;
  AdmsSensFadType modelPar_WBIGBINV=mod.WBIGBINV;
  bool modelPar_given_WBIGBINV=mod.given("WBIGBINV");
  modParamMap["WBIGBINV"] = &modelPar_WBIGBINV;
  AdmsSensFadType modelPar_PBIGBINV=mod.PBIGBINV;
  bool modelPar_given_PBIGBINV=mod.given("PBIGBINV");
  modParamMap["PBIGBINV"] = &modelPar_PBIGBINV;
  AdmsSensFadType modelPar_LCIGBINV=mod.LCIGBINV;
  bool modelPar_given_LCIGBINV=mod.given("LCIGBINV");
  modParamMap["LCIGBINV"] = &modelPar_LCIGBINV;
  AdmsSensFadType modelPar_WCIGBINV=mod.WCIGBINV;
  bool modelPar_given_WCIGBINV=mod.given("WCIGBINV");
  modParamMap["WCIGBINV"] = &modelPar_WCIGBINV;
  AdmsSensFadType modelPar_PCIGBINV=mod.PCIGBINV;
  bool modelPar_given_PCIGBINV=mod.given("PCIGBINV");
  modParamMap["PCIGBINV"] = &modelPar_PCIGBINV;
  AdmsSensFadType modelPar_LEIGBINV=mod.LEIGBINV;
  bool modelPar_given_LEIGBINV=mod.given("LEIGBINV");
  modParamMap["LEIGBINV"] = &modelPar_LEIGBINV;
  AdmsSensFadType modelPar_WEIGBINV=mod.WEIGBINV;
  bool modelPar_given_WEIGBINV=mod.given("WEIGBINV");
  modParamMap["WEIGBINV"] = &modelPar_WEIGBINV;
  AdmsSensFadType modelPar_PEIGBINV=mod.PEIGBINV;
  bool modelPar_given_PEIGBINV=mod.given("PEIGBINV");
  modParamMap["PEIGBINV"] = &modelPar_PEIGBINV;
  AdmsSensFadType modelPar_LNIGBINV=mod.LNIGBINV;
  bool modelPar_given_LNIGBINV=mod.given("LNIGBINV");
  modParamMap["LNIGBINV"] = &modelPar_LNIGBINV;
  AdmsSensFadType modelPar_WNIGBINV=mod.WNIGBINV;
  bool modelPar_given_WNIGBINV=mod.given("WNIGBINV");
  modParamMap["WNIGBINV"] = &modelPar_WNIGBINV;
  AdmsSensFadType modelPar_PNIGBINV=mod.PNIGBINV;
  bool modelPar_given_PNIGBINV=mod.given("PNIGBINV");
  modParamMap["PNIGBINV"] = &modelPar_PNIGBINV;
  AdmsSensFadType modelPar_LAIGBACC=mod.LAIGBACC;
  bool modelPar_given_LAIGBACC=mod.given("LAIGBACC");
  modParamMap["LAIGBACC"] = &modelPar_LAIGBACC;
  AdmsSensFadType modelPar_WAIGBACC=mod.WAIGBACC;
  bool modelPar_given_WAIGBACC=mod.given("WAIGBACC");
  modParamMap["WAIGBACC"] = &modelPar_WAIGBACC;
  AdmsSensFadType modelPar_PAIGBACC=mod.PAIGBACC;
  bool modelPar_given_PAIGBACC=mod.given("PAIGBACC");
  modParamMap["PAIGBACC"] = &modelPar_PAIGBACC;
  AdmsSensFadType modelPar_LBIGBACC=mod.LBIGBACC;
  bool modelPar_given_LBIGBACC=mod.given("LBIGBACC");
  modParamMap["LBIGBACC"] = &modelPar_LBIGBACC;
  AdmsSensFadType modelPar_WBIGBACC=mod.WBIGBACC;
  bool modelPar_given_WBIGBACC=mod.given("WBIGBACC");
  modParamMap["WBIGBACC"] = &modelPar_WBIGBACC;
  AdmsSensFadType modelPar_PBIGBACC=mod.PBIGBACC;
  bool modelPar_given_PBIGBACC=mod.given("PBIGBACC");
  modParamMap["PBIGBACC"] = &modelPar_PBIGBACC;
  AdmsSensFadType modelPar_LCIGBACC=mod.LCIGBACC;
  bool modelPar_given_LCIGBACC=mod.given("LCIGBACC");
  modParamMap["LCIGBACC"] = &modelPar_LCIGBACC;
  AdmsSensFadType modelPar_WCIGBACC=mod.WCIGBACC;
  bool modelPar_given_WCIGBACC=mod.given("WCIGBACC");
  modParamMap["WCIGBACC"] = &modelPar_WCIGBACC;
  AdmsSensFadType modelPar_PCIGBACC=mod.PCIGBACC;
  bool modelPar_given_PCIGBACC=mod.given("PCIGBACC");
  modParamMap["PCIGBACC"] = &modelPar_PCIGBACC;
  AdmsSensFadType modelPar_LNIGBACC=mod.LNIGBACC;
  bool modelPar_given_LNIGBACC=mod.given("LNIGBACC");
  modParamMap["LNIGBACC"] = &modelPar_LNIGBACC;
  AdmsSensFadType modelPar_WNIGBACC=mod.WNIGBACC;
  bool modelPar_given_WNIGBACC=mod.given("WNIGBACC");
  modParamMap["WNIGBACC"] = &modelPar_WNIGBACC;
  AdmsSensFadType modelPar_PNIGBACC=mod.PNIGBACC;
  bool modelPar_given_PNIGBACC=mod.given("PNIGBACC");
  modParamMap["PNIGBACC"] = &modelPar_PNIGBACC;
  AdmsSensFadType modelPar_LAIGC=mod.LAIGC;
  bool modelPar_given_LAIGC=mod.given("LAIGC");
  modParamMap["LAIGC"] = &modelPar_LAIGC;
  AdmsSensFadType modelPar_WAIGC=mod.WAIGC;
  bool modelPar_given_WAIGC=mod.given("WAIGC");
  modParamMap["WAIGC"] = &modelPar_WAIGC;
  AdmsSensFadType modelPar_PAIGC=mod.PAIGC;
  bool modelPar_given_PAIGC=mod.given("PAIGC");
  modParamMap["PAIGC"] = &modelPar_PAIGC;
  AdmsSensFadType modelPar_LBIGC=mod.LBIGC;
  bool modelPar_given_LBIGC=mod.given("LBIGC");
  modParamMap["LBIGC"] = &modelPar_LBIGC;
  AdmsSensFadType modelPar_WBIGC=mod.WBIGC;
  bool modelPar_given_WBIGC=mod.given("WBIGC");
  modParamMap["WBIGC"] = &modelPar_WBIGC;
  AdmsSensFadType modelPar_PBIGC=mod.PBIGC;
  bool modelPar_given_PBIGC=mod.given("PBIGC");
  modParamMap["PBIGC"] = &modelPar_PBIGC;
  AdmsSensFadType modelPar_LCIGC=mod.LCIGC;
  bool modelPar_given_LCIGC=mod.given("LCIGC");
  modParamMap["LCIGC"] = &modelPar_LCIGC;
  AdmsSensFadType modelPar_WCIGC=mod.WCIGC;
  bool modelPar_given_WCIGC=mod.given("WCIGC");
  modParamMap["WCIGC"] = &modelPar_WCIGC;
  AdmsSensFadType modelPar_PCIGC=mod.PCIGC;
  bool modelPar_given_PCIGC=mod.given("PCIGC");
  modParamMap["PCIGC"] = &modelPar_PCIGC;
  AdmsSensFadType modelPar_LAIGS=mod.LAIGS;
  bool modelPar_given_LAIGS=mod.given("LAIGS");
  modParamMap["LAIGS"] = &modelPar_LAIGS;
  AdmsSensFadType modelPar_WAIGS=mod.WAIGS;
  bool modelPar_given_WAIGS=mod.given("WAIGS");
  modParamMap["WAIGS"] = &modelPar_WAIGS;
  AdmsSensFadType modelPar_PAIGS=mod.PAIGS;
  bool modelPar_given_PAIGS=mod.given("PAIGS");
  modParamMap["PAIGS"] = &modelPar_PAIGS;
  AdmsSensFadType modelPar_LBIGS=mod.LBIGS;
  bool modelPar_given_LBIGS=mod.given("LBIGS");
  modParamMap["LBIGS"] = &modelPar_LBIGS;
  AdmsSensFadType modelPar_WBIGS=mod.WBIGS;
  bool modelPar_given_WBIGS=mod.given("WBIGS");
  modParamMap["WBIGS"] = &modelPar_WBIGS;
  AdmsSensFadType modelPar_PBIGS=mod.PBIGS;
  bool modelPar_given_PBIGS=mod.given("PBIGS");
  modParamMap["PBIGS"] = &modelPar_PBIGS;
  AdmsSensFadType modelPar_LCIGS=mod.LCIGS;
  bool modelPar_given_LCIGS=mod.given("LCIGS");
  modParamMap["LCIGS"] = &modelPar_LCIGS;
  AdmsSensFadType modelPar_WCIGS=mod.WCIGS;
  bool modelPar_given_WCIGS=mod.given("WCIGS");
  modParamMap["WCIGS"] = &modelPar_WCIGS;
  AdmsSensFadType modelPar_PCIGS=mod.PCIGS;
  bool modelPar_given_PCIGS=mod.given("PCIGS");
  modParamMap["PCIGS"] = &modelPar_PCIGS;
  AdmsSensFadType modelPar_LAIGD=mod.LAIGD;
  bool modelPar_given_LAIGD=mod.given("LAIGD");
  modParamMap["LAIGD"] = &modelPar_LAIGD;
  AdmsSensFadType modelPar_WAIGD=mod.WAIGD;
  bool modelPar_given_WAIGD=mod.given("WAIGD");
  modParamMap["WAIGD"] = &modelPar_WAIGD;
  AdmsSensFadType modelPar_PAIGD=mod.PAIGD;
  bool modelPar_given_PAIGD=mod.given("PAIGD");
  modParamMap["PAIGD"] = &modelPar_PAIGD;
  AdmsSensFadType modelPar_LBIGD=mod.LBIGD;
  bool modelPar_given_LBIGD=mod.given("LBIGD");
  modParamMap["LBIGD"] = &modelPar_LBIGD;
  AdmsSensFadType modelPar_WBIGD=mod.WBIGD;
  bool modelPar_given_WBIGD=mod.given("WBIGD");
  modParamMap["WBIGD"] = &modelPar_WBIGD;
  AdmsSensFadType modelPar_PBIGD=mod.PBIGD;
  bool modelPar_given_PBIGD=mod.given("PBIGD");
  modParamMap["PBIGD"] = &modelPar_PBIGD;
  AdmsSensFadType modelPar_LCIGD=mod.LCIGD;
  bool modelPar_given_LCIGD=mod.given("LCIGD");
  modParamMap["LCIGD"] = &modelPar_LCIGD;
  AdmsSensFadType modelPar_WCIGD=mod.WCIGD;
  bool modelPar_given_WCIGD=mod.given("WCIGD");
  modParamMap["WCIGD"] = &modelPar_WCIGD;
  AdmsSensFadType modelPar_PCIGD=mod.PCIGD;
  bool modelPar_given_PCIGD=mod.given("PCIGD");
  modParamMap["PCIGD"] = &modelPar_PCIGD;
  AdmsSensFadType modelPar_LPOXEDGE=mod.LPOXEDGE;
  bool modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
  modParamMap["LPOXEDGE"] = &modelPar_LPOXEDGE;
  AdmsSensFadType modelPar_WPOXEDGE=mod.WPOXEDGE;
  bool modelPar_given_WPOXEDGE=mod.given("WPOXEDGE");
  modParamMap["WPOXEDGE"] = &modelPar_WPOXEDGE;
  AdmsSensFadType modelPar_PPOXEDGE=mod.PPOXEDGE;
  bool modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
  modParamMap["PPOXEDGE"] = &modelPar_PPOXEDGE;
  AdmsSensFadType modelPar_LDLCIG=mod.LDLCIG;
  bool modelPar_given_LDLCIG=mod.given("LDLCIG");
  modParamMap["LDLCIG"] = &modelPar_LDLCIG;
  AdmsSensFadType modelPar_WDLCIG=mod.WDLCIG;
  bool modelPar_given_WDLCIG=mod.given("WDLCIG");
  modParamMap["WDLCIG"] = &modelPar_WDLCIG;
  AdmsSensFadType modelPar_PDLCIG=mod.PDLCIG;
  bool modelPar_given_PDLCIG=mod.given("PDLCIG");
  modParamMap["PDLCIG"] = &modelPar_PDLCIG;
  AdmsSensFadType modelPar_LDLCIGD=mod.LDLCIGD;
  bool modelPar_given_LDLCIGD=mod.given("LDLCIGD");
  modParamMap["LDLCIGD"] = &modelPar_LDLCIGD;
  AdmsSensFadType modelPar_WDLCIGD=mod.WDLCIGD;
  bool modelPar_given_WDLCIGD=mod.given("WDLCIGD");
  modParamMap["WDLCIGD"] = &modelPar_WDLCIGD;
  AdmsSensFadType modelPar_PDLCIGD=mod.PDLCIGD;
  bool modelPar_given_PDLCIGD=mod.given("PDLCIGD");
  modParamMap["PDLCIGD"] = &modelPar_PDLCIGD;
  AdmsSensFadType modelPar_LNTOX=mod.LNTOX;
  bool modelPar_given_LNTOX=mod.given("LNTOX");
  modParamMap["LNTOX"] = &modelPar_LNTOX;
  AdmsSensFadType modelPar_WNTOX=mod.WNTOX;
  bool modelPar_given_WNTOX=mod.given("WNTOX");
  modParamMap["WNTOX"] = &modelPar_WNTOX;
  AdmsSensFadType modelPar_PNTOX=mod.PNTOX;
  bool modelPar_given_PNTOX=mod.given("PNTOX");
  modParamMap["PNTOX"] = &modelPar_PNTOX;
  AdmsSensFadType modelPar_AGIDL=mod.AGIDL;
  bool modelPar_given_AGIDL=mod.given("AGIDL");
  modParamMap["AGIDL"] = &modelPar_AGIDL;
  AdmsSensFadType modelPar_AGIDLL=mod.AGIDLL;
  bool modelPar_given_AGIDLL=mod.given("AGIDLL");
  modParamMap["AGIDLL"] = &modelPar_AGIDLL;
  AdmsSensFadType modelPar_AGIDLW=mod.AGIDLW;
  bool modelPar_given_AGIDLW=mod.given("AGIDLW");
  modParamMap["AGIDLW"] = &modelPar_AGIDLW;
  AdmsSensFadType modelPar_LAGIDL=mod.LAGIDL;
  bool modelPar_given_LAGIDL=mod.given("LAGIDL");
  modParamMap["LAGIDL"] = &modelPar_LAGIDL;
  AdmsSensFadType modelPar_WAGIDL=mod.WAGIDL;
  bool modelPar_given_WAGIDL=mod.given("WAGIDL");
  modParamMap["WAGIDL"] = &modelPar_WAGIDL;
  AdmsSensFadType modelPar_PAGIDL=mod.PAGIDL;
  bool modelPar_given_PAGIDL=mod.given("PAGIDL");
  modParamMap["PAGIDL"] = &modelPar_PAGIDL;
  AdmsSensFadType modelPar_BGIDL=mod.BGIDL;
  bool modelPar_given_BGIDL=mod.given("BGIDL");
  modParamMap["BGIDL"] = &modelPar_BGIDL;
  AdmsSensFadType modelPar_LBGIDL=mod.LBGIDL;
  bool modelPar_given_LBGIDL=mod.given("LBGIDL");
  modParamMap["LBGIDL"] = &modelPar_LBGIDL;
  AdmsSensFadType modelPar_WBGIDL=mod.WBGIDL;
  bool modelPar_given_WBGIDL=mod.given("WBGIDL");
  modParamMap["WBGIDL"] = &modelPar_WBGIDL;
  AdmsSensFadType modelPar_PBGIDL=mod.PBGIDL;
  bool modelPar_given_PBGIDL=mod.given("PBGIDL");
  modParamMap["PBGIDL"] = &modelPar_PBGIDL;
  AdmsSensFadType modelPar_CGIDL=mod.CGIDL;
  bool modelPar_given_CGIDL=mod.given("CGIDL");
  modParamMap["CGIDL"] = &modelPar_CGIDL;
  AdmsSensFadType modelPar_LCGIDL=mod.LCGIDL;
  bool modelPar_given_LCGIDL=mod.given("LCGIDL");
  modParamMap["LCGIDL"] = &modelPar_LCGIDL;
  AdmsSensFadType modelPar_WCGIDL=mod.WCGIDL;
  bool modelPar_given_WCGIDL=mod.given("WCGIDL");
  modParamMap["WCGIDL"] = &modelPar_WCGIDL;
  AdmsSensFadType modelPar_PCGIDL=mod.PCGIDL;
  bool modelPar_given_PCGIDL=mod.given("PCGIDL");
  modParamMap["PCGIDL"] = &modelPar_PCGIDL;
  AdmsSensFadType modelPar_EGIDL=mod.EGIDL;
  bool modelPar_given_EGIDL=mod.given("EGIDL");
  modParamMap["EGIDL"] = &modelPar_EGIDL;
  AdmsSensFadType modelPar_LEGIDL=mod.LEGIDL;
  bool modelPar_given_LEGIDL=mod.given("LEGIDL");
  modParamMap["LEGIDL"] = &modelPar_LEGIDL;
  AdmsSensFadType modelPar_WEGIDL=mod.WEGIDL;
  bool modelPar_given_WEGIDL=mod.given("WEGIDL");
  modParamMap["WEGIDL"] = &modelPar_WEGIDL;
  AdmsSensFadType modelPar_PEGIDL=mod.PEGIDL;
  bool modelPar_given_PEGIDL=mod.given("PEGIDL");
  modParamMap["PEGIDL"] = &modelPar_PEGIDL;
  AdmsSensFadType modelPar_AGISL=mod.AGISL;
  bool modelPar_given_AGISL=mod.given("AGISL");
  modParamMap["AGISL"] = &modelPar_AGISL;
  AdmsSensFadType modelPar_AGISLL=mod.AGISLL;
  bool modelPar_given_AGISLL=mod.given("AGISLL");
  modParamMap["AGISLL"] = &modelPar_AGISLL;
  AdmsSensFadType modelPar_AGISLW=mod.AGISLW;
  bool modelPar_given_AGISLW=mod.given("AGISLW");
  modParamMap["AGISLW"] = &modelPar_AGISLW;
  AdmsSensFadType modelPar_LAGISL=mod.LAGISL;
  bool modelPar_given_LAGISL=mod.given("LAGISL");
  modParamMap["LAGISL"] = &modelPar_LAGISL;
  AdmsSensFadType modelPar_WAGISL=mod.WAGISL;
  bool modelPar_given_WAGISL=mod.given("WAGISL");
  modParamMap["WAGISL"] = &modelPar_WAGISL;
  AdmsSensFadType modelPar_PAGISL=mod.PAGISL;
  bool modelPar_given_PAGISL=mod.given("PAGISL");
  modParamMap["PAGISL"] = &modelPar_PAGISL;
  AdmsSensFadType modelPar_BGISL=mod.BGISL;
  bool modelPar_given_BGISL=mod.given("BGISL");
  modParamMap["BGISL"] = &modelPar_BGISL;
  AdmsSensFadType modelPar_LBGISL=mod.LBGISL;
  bool modelPar_given_LBGISL=mod.given("LBGISL");
  modParamMap["LBGISL"] = &modelPar_LBGISL;
  AdmsSensFadType modelPar_WBGISL=mod.WBGISL;
  bool modelPar_given_WBGISL=mod.given("WBGISL");
  modParamMap["WBGISL"] = &modelPar_WBGISL;
  AdmsSensFadType modelPar_PBGISL=mod.PBGISL;
  bool modelPar_given_PBGISL=mod.given("PBGISL");
  modParamMap["PBGISL"] = &modelPar_PBGISL;
  AdmsSensFadType modelPar_CGISL=mod.CGISL;
  bool modelPar_given_CGISL=mod.given("CGISL");
  modParamMap["CGISL"] = &modelPar_CGISL;
  AdmsSensFadType modelPar_LCGISL=mod.LCGISL;
  bool modelPar_given_LCGISL=mod.given("LCGISL");
  modParamMap["LCGISL"] = &modelPar_LCGISL;
  AdmsSensFadType modelPar_WCGISL=mod.WCGISL;
  bool modelPar_given_WCGISL=mod.given("WCGISL");
  modParamMap["WCGISL"] = &modelPar_WCGISL;
  AdmsSensFadType modelPar_PCGISL=mod.PCGISL;
  bool modelPar_given_PCGISL=mod.given("PCGISL");
  modParamMap["PCGISL"] = &modelPar_PCGISL;
  AdmsSensFadType modelPar_EGISL=mod.EGISL;
  bool modelPar_given_EGISL=mod.given("EGISL");
  modParamMap["EGISL"] = &modelPar_EGISL;
  AdmsSensFadType modelPar_LEGISL=mod.LEGISL;
  bool modelPar_given_LEGISL=mod.given("LEGISL");
  modParamMap["LEGISL"] = &modelPar_LEGISL;
  AdmsSensFadType modelPar_WEGISL=mod.WEGISL;
  bool modelPar_given_WEGISL=mod.given("WEGISL");
  modParamMap["WEGISL"] = &modelPar_WEGISL;
  AdmsSensFadType modelPar_PEGISL=mod.PEGISL;
  bool modelPar_given_PEGISL=mod.given("PEGISL");
  modParamMap["PEGISL"] = &modelPar_PEGISL;
  AdmsSensFadType modelPar_CF=mod.CF;
  bool modelPar_given_CF=mod.given("CF");
  modParamMap["CF"] = &modelPar_CF;
  AdmsSensFadType modelPar_LCF=mod.LCF;
  bool modelPar_given_LCF=mod.given("LCF");
  modParamMap["LCF"] = &modelPar_LCF;
  AdmsSensFadType modelPar_WCF=mod.WCF;
  bool modelPar_given_WCF=mod.given("WCF");
  modParamMap["WCF"] = &modelPar_WCF;
  AdmsSensFadType modelPar_PCF=mod.PCF;
  bool modelPar_given_PCF=mod.given("PCF");
  modParamMap["PCF"] = &modelPar_PCF;
  AdmsSensFadType modelPar_CFRCOEFF=mod.CFRCOEFF;
  bool modelPar_given_CFRCOEFF=mod.given("CFRCOEFF");
  modParamMap["CFRCOEFF"] = &modelPar_CFRCOEFF;
  AdmsSensFadType modelPar_CGSO=mod.CGSO;
  bool modelPar_given_CGSO=mod.given("CGSO");
  modParamMap["CGSO"] = &modelPar_CGSO;
  AdmsSensFadType modelPar_CGDO=mod.CGDO;
  bool modelPar_given_CGDO=mod.given("CGDO");
  modParamMap["CGDO"] = &modelPar_CGDO;
  AdmsSensFadType modelPar_CGBO=mod.CGBO;
  bool modelPar_given_CGBO=mod.given("CGBO");
  modParamMap["CGBO"] = &modelPar_CGBO;
  AdmsSensFadType modelPar_CGSL=mod.CGSL;
  bool modelPar_given_CGSL=mod.given("CGSL");
  modParamMap["CGSL"] = &modelPar_CGSL;
  AdmsSensFadType modelPar_LCGSL=mod.LCGSL;
  bool modelPar_given_LCGSL=mod.given("LCGSL");
  modParamMap["LCGSL"] = &modelPar_LCGSL;
  AdmsSensFadType modelPar_WCGSL=mod.WCGSL;
  bool modelPar_given_WCGSL=mod.given("WCGSL");
  modParamMap["WCGSL"] = &modelPar_WCGSL;
  AdmsSensFadType modelPar_PCGSL=mod.PCGSL;
  bool modelPar_given_PCGSL=mod.given("PCGSL");
  modParamMap["PCGSL"] = &modelPar_PCGSL;
  AdmsSensFadType modelPar_CGDL=mod.CGDL;
  bool modelPar_given_CGDL=mod.given("CGDL");
  modParamMap["CGDL"] = &modelPar_CGDL;
  AdmsSensFadType modelPar_LCGDL=mod.LCGDL;
  bool modelPar_given_LCGDL=mod.given("LCGDL");
  modParamMap["LCGDL"] = &modelPar_LCGDL;
  AdmsSensFadType modelPar_WCGDL=mod.WCGDL;
  bool modelPar_given_WCGDL=mod.given("WCGDL");
  modParamMap["WCGDL"] = &modelPar_WCGDL;
  AdmsSensFadType modelPar_PCGDL=mod.PCGDL;
  bool modelPar_given_PCGDL=mod.given("PCGDL");
  modParamMap["PCGDL"] = &modelPar_PCGDL;
  AdmsSensFadType modelPar_CKAPPAS=mod.CKAPPAS;
  bool modelPar_given_CKAPPAS=mod.given("CKAPPAS");
  modParamMap["CKAPPAS"] = &modelPar_CKAPPAS;
  AdmsSensFadType modelPar_LCKAPPAS=mod.LCKAPPAS;
  bool modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
  modParamMap["LCKAPPAS"] = &modelPar_LCKAPPAS;
  AdmsSensFadType modelPar_WCKAPPAS=mod.WCKAPPAS;
  bool modelPar_given_WCKAPPAS=mod.given("WCKAPPAS");
  modParamMap["WCKAPPAS"] = &modelPar_WCKAPPAS;
  AdmsSensFadType modelPar_PCKAPPAS=mod.PCKAPPAS;
  bool modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
  modParamMap["PCKAPPAS"] = &modelPar_PCKAPPAS;
  AdmsSensFadType modelPar_CKAPPAD=mod.CKAPPAD;
  bool modelPar_given_CKAPPAD=mod.given("CKAPPAD");
  modParamMap["CKAPPAD"] = &modelPar_CKAPPAD;
  AdmsSensFadType modelPar_LCKAPPAD=mod.LCKAPPAD;
  bool modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
  modParamMap["LCKAPPAD"] = &modelPar_LCKAPPAD;
  AdmsSensFadType modelPar_WCKAPPAD=mod.WCKAPPAD;
  bool modelPar_given_WCKAPPAD=mod.given("WCKAPPAD");
  modParamMap["WCKAPPAD"] = &modelPar_WCKAPPAD;
  AdmsSensFadType modelPar_PCKAPPAD=mod.PCKAPPAD;
  bool modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
  modParamMap["PCKAPPAD"] = &modelPar_PCKAPPAD;
  AdmsSensFadType modelPar_DMCG=mod.DMCG;
  bool modelPar_given_DMCG=mod.given("DMCG");
  modParamMap["DMCG"] = &modelPar_DMCG;
  AdmsSensFadType modelPar_DMCI=mod.DMCI;
  bool modelPar_given_DMCI=mod.given("DMCI");
  modParamMap["DMCI"] = &modelPar_DMCI;
  AdmsSensFadType modelPar_DMDG=mod.DMDG;
  bool modelPar_given_DMDG=mod.given("DMDG");
  modParamMap["DMDG"] = &modelPar_DMDG;
  AdmsSensFadType modelPar_DMCGT=mod.DMCGT;
  bool modelPar_given_DMCGT=mod.given("DMCGT");
  modParamMap["DMCGT"] = &modelPar_DMCGT;
  AdmsSensFadType modelPar_XGL=mod.XGL;
  bool modelPar_given_XGL=mod.given("XGL");
  modParamMap["XGL"] = &modelPar_XGL;
  AdmsSensFadType modelPar_RSHG=mod.RSHG;
  bool modelPar_given_RSHG=mod.given("RSHG");
  modParamMap["RSHG"] = &modelPar_RSHG;
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  modParamMap["CJS"] = &modelPar_CJS;
  AdmsSensFadType modelPar_CJD=mod.CJD;
  bool modelPar_given_CJD=mod.given("CJD");
  modParamMap["CJD"] = &modelPar_CJD;
  AdmsSensFadType modelPar_CJSWS=mod.CJSWS;
  bool modelPar_given_CJSWS=mod.given("CJSWS");
  modParamMap["CJSWS"] = &modelPar_CJSWS;
  AdmsSensFadType modelPar_CJSWD=mod.CJSWD;
  bool modelPar_given_CJSWD=mod.given("CJSWD");
  modParamMap["CJSWD"] = &modelPar_CJSWD;
  AdmsSensFadType modelPar_CJSWGS=mod.CJSWGS;
  bool modelPar_given_CJSWGS=mod.given("CJSWGS");
  modParamMap["CJSWGS"] = &modelPar_CJSWGS;
  AdmsSensFadType modelPar_CJSWGD=mod.CJSWGD;
  bool modelPar_given_CJSWGD=mod.given("CJSWGD");
  modParamMap["CJSWGD"] = &modelPar_CJSWGD;
  AdmsSensFadType modelPar_PBS=mod.PBS;
  bool modelPar_given_PBS=mod.given("PBS");
  modParamMap["PBS"] = &modelPar_PBS;
  AdmsSensFadType modelPar_PBD=mod.PBD;
  bool modelPar_given_PBD=mod.given("PBD");
  modParamMap["PBD"] = &modelPar_PBD;
  AdmsSensFadType modelPar_PBSWS=mod.PBSWS;
  bool modelPar_given_PBSWS=mod.given("PBSWS");
  modParamMap["PBSWS"] = &modelPar_PBSWS;
  AdmsSensFadType modelPar_PBSWD=mod.PBSWD;
  bool modelPar_given_PBSWD=mod.given("PBSWD");
  modParamMap["PBSWD"] = &modelPar_PBSWD;
  AdmsSensFadType modelPar_PBSWGS=mod.PBSWGS;
  bool modelPar_given_PBSWGS=mod.given("PBSWGS");
  modParamMap["PBSWGS"] = &modelPar_PBSWGS;
  AdmsSensFadType modelPar_PBSWGD=mod.PBSWGD;
  bool modelPar_given_PBSWGD=mod.given("PBSWGD");
  modParamMap["PBSWGD"] = &modelPar_PBSWGD;
  AdmsSensFadType modelPar_MJS=mod.MJS;
  bool modelPar_given_MJS=mod.given("MJS");
  modParamMap["MJS"] = &modelPar_MJS;
  AdmsSensFadType modelPar_MJD=mod.MJD;
  bool modelPar_given_MJD=mod.given("MJD");
  modParamMap["MJD"] = &modelPar_MJD;
  AdmsSensFadType modelPar_MJSWS=mod.MJSWS;
  bool modelPar_given_MJSWS=mod.given("MJSWS");
  modParamMap["MJSWS"] = &modelPar_MJSWS;
  AdmsSensFadType modelPar_MJSWD=mod.MJSWD;
  bool modelPar_given_MJSWD=mod.given("MJSWD");
  modParamMap["MJSWD"] = &modelPar_MJSWD;
  AdmsSensFadType modelPar_MJSWGS=mod.MJSWGS;
  bool modelPar_given_MJSWGS=mod.given("MJSWGS");
  modParamMap["MJSWGS"] = &modelPar_MJSWGS;
  AdmsSensFadType modelPar_MJSWGD=mod.MJSWGD;
  bool modelPar_given_MJSWGD=mod.given("MJSWGD");
  modParamMap["MJSWGD"] = &modelPar_MJSWGD;
  AdmsSensFadType modelPar_JSS=mod.JSS;
  bool modelPar_given_JSS=mod.given("JSS");
  modParamMap["JSS"] = &modelPar_JSS;
  AdmsSensFadType modelPar_JSD=mod.JSD;
  bool modelPar_given_JSD=mod.given("JSD");
  modParamMap["JSD"] = &modelPar_JSD;
  AdmsSensFadType modelPar_JSWS=mod.JSWS;
  bool modelPar_given_JSWS=mod.given("JSWS");
  modParamMap["JSWS"] = &modelPar_JSWS;
  AdmsSensFadType modelPar_JSWD=mod.JSWD;
  bool modelPar_given_JSWD=mod.given("JSWD");
  modParamMap["JSWD"] = &modelPar_JSWD;
  AdmsSensFadType modelPar_JSWGS=mod.JSWGS;
  bool modelPar_given_JSWGS=mod.given("JSWGS");
  modParamMap["JSWGS"] = &modelPar_JSWGS;
  AdmsSensFadType modelPar_JSWGD=mod.JSWGD;
  bool modelPar_given_JSWGD=mod.given("JSWGD");
  modParamMap["JSWGD"] = &modelPar_JSWGD;
  AdmsSensFadType modelPar_NJS=mod.NJS;
  bool modelPar_given_NJS=mod.given("NJS");
  modParamMap["NJS"] = &modelPar_NJS;
  AdmsSensFadType modelPar_NJD=mod.NJD;
  bool modelPar_given_NJD=mod.given("NJD");
  modParamMap["NJD"] = &modelPar_NJD;
  AdmsSensFadType modelPar_IJTHSFWD=mod.IJTHSFWD;
  bool modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
  modParamMap["IJTHSFWD"] = &modelPar_IJTHSFWD;
  AdmsSensFadType modelPar_IJTHDFWD=mod.IJTHDFWD;
  bool modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
  modParamMap["IJTHDFWD"] = &modelPar_IJTHDFWD;
  AdmsSensFadType modelPar_IJTHSREV=mod.IJTHSREV;
  bool modelPar_given_IJTHSREV=mod.given("IJTHSREV");
  modParamMap["IJTHSREV"] = &modelPar_IJTHSREV;
  AdmsSensFadType modelPar_IJTHDREV=mod.IJTHDREV;
  bool modelPar_given_IJTHDREV=mod.given("IJTHDREV");
  modParamMap["IJTHDREV"] = &modelPar_IJTHDREV;
  AdmsSensFadType modelPar_BVS=mod.BVS;
  bool modelPar_given_BVS=mod.given("BVS");
  modParamMap["BVS"] = &modelPar_BVS;
  AdmsSensFadType modelPar_BVD=mod.BVD;
  bool modelPar_given_BVD=mod.given("BVD");
  modParamMap["BVD"] = &modelPar_BVD;
  AdmsSensFadType modelPar_XJBVS=mod.XJBVS;
  bool modelPar_given_XJBVS=mod.given("XJBVS");
  modParamMap["XJBVS"] = &modelPar_XJBVS;
  AdmsSensFadType modelPar_XJBVD=mod.XJBVD;
  bool modelPar_given_XJBVD=mod.given("XJBVD");
  modParamMap["XJBVD"] = &modelPar_XJBVD;
  AdmsSensFadType modelPar_JTSS=mod.JTSS;
  bool modelPar_given_JTSS=mod.given("JTSS");
  modParamMap["JTSS"] = &modelPar_JTSS;
  AdmsSensFadType modelPar_JTSD=mod.JTSD;
  bool modelPar_given_JTSD=mod.given("JTSD");
  modParamMap["JTSD"] = &modelPar_JTSD;
  AdmsSensFadType modelPar_JTSSWS=mod.JTSSWS;
  bool modelPar_given_JTSSWS=mod.given("JTSSWS");
  modParamMap["JTSSWS"] = &modelPar_JTSSWS;
  AdmsSensFadType modelPar_JTSSWD=mod.JTSSWD;
  bool modelPar_given_JTSSWD=mod.given("JTSSWD");
  modParamMap["JTSSWD"] = &modelPar_JTSSWD;
  AdmsSensFadType modelPar_JTSSWGS=mod.JTSSWGS;
  bool modelPar_given_JTSSWGS=mod.given("JTSSWGS");
  modParamMap["JTSSWGS"] = &modelPar_JTSSWGS;
  AdmsSensFadType modelPar_JTSSWGD=mod.JTSSWGD;
  bool modelPar_given_JTSSWGD=mod.given("JTSSWGD");
  modParamMap["JTSSWGD"] = &modelPar_JTSSWGD;
  AdmsSensFadType modelPar_JTWEFF=mod.JTWEFF;
  bool modelPar_given_JTWEFF=mod.given("JTWEFF");
  modParamMap["JTWEFF"] = &modelPar_JTWEFF;
  AdmsSensFadType modelPar_NJTS=mod.NJTS;
  bool modelPar_given_NJTS=mod.given("NJTS");
  modParamMap["NJTS"] = &modelPar_NJTS;
  AdmsSensFadType modelPar_NJTSD=mod.NJTSD;
  bool modelPar_given_NJTSD=mod.given("NJTSD");
  modParamMap["NJTSD"] = &modelPar_NJTSD;
  AdmsSensFadType modelPar_NJTSSW=mod.NJTSSW;
  bool modelPar_given_NJTSSW=mod.given("NJTSSW");
  modParamMap["NJTSSW"] = &modelPar_NJTSSW;
  AdmsSensFadType modelPar_NJTSSWD=mod.NJTSSWD;
  bool modelPar_given_NJTSSWD=mod.given("NJTSSWD");
  modParamMap["NJTSSWD"] = &modelPar_NJTSSWD;
  AdmsSensFadType modelPar_NJTSSWG=mod.NJTSSWG;
  bool modelPar_given_NJTSSWG=mod.given("NJTSSWG");
  modParamMap["NJTSSWG"] = &modelPar_NJTSSWG;
  AdmsSensFadType modelPar_NJTSSWGD=mod.NJTSSWGD;
  bool modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
  modParamMap["NJTSSWGD"] = &modelPar_NJTSSWGD;
  AdmsSensFadType modelPar_VTSS=mod.VTSS;
  bool modelPar_given_VTSS=mod.given("VTSS");
  modParamMap["VTSS"] = &modelPar_VTSS;
  AdmsSensFadType modelPar_VTSD=mod.VTSD;
  bool modelPar_given_VTSD=mod.given("VTSD");
  modParamMap["VTSD"] = &modelPar_VTSD;
  AdmsSensFadType modelPar_VTSSWS=mod.VTSSWS;
  bool modelPar_given_VTSSWS=mod.given("VTSSWS");
  modParamMap["VTSSWS"] = &modelPar_VTSSWS;
  AdmsSensFadType modelPar_VTSSWD=mod.VTSSWD;
  bool modelPar_given_VTSSWD=mod.given("VTSSWD");
  modParamMap["VTSSWD"] = &modelPar_VTSSWD;
  AdmsSensFadType modelPar_VTSSWGS=mod.VTSSWGS;
  bool modelPar_given_VTSSWGS=mod.given("VTSSWGS");
  modParamMap["VTSSWGS"] = &modelPar_VTSSWGS;
  AdmsSensFadType modelPar_VTSSWGD=mod.VTSSWGD;
  bool modelPar_given_VTSSWGD=mod.given("VTSSWGD");
  modParamMap["VTSSWGD"] = &modelPar_VTSSWGD;
  AdmsSensFadType modelPar_XRCRG1=mod.XRCRG1;
  bool modelPar_given_XRCRG1=mod.given("XRCRG1");
  modParamMap["XRCRG1"] = &modelPar_XRCRG1;
  AdmsSensFadType modelPar_XRCRG2=mod.XRCRG2;
  bool modelPar_given_XRCRG2=mod.given("XRCRG2");
  modParamMap["XRCRG2"] = &modelPar_XRCRG2;
  AdmsSensFadType modelPar_GBMIN=mod.GBMIN;
  bool modelPar_given_GBMIN=mod.given("GBMIN");
  modParamMap["GBMIN"] = &modelPar_GBMIN;
  AdmsSensFadType modelPar_RBPS0=mod.RBPS0;
  bool modelPar_given_RBPS0=mod.given("RBPS0");
  modParamMap["RBPS0"] = &modelPar_RBPS0;
  AdmsSensFadType modelPar_RBPSL=mod.RBPSL;
  bool modelPar_given_RBPSL=mod.given("RBPSL");
  modParamMap["RBPSL"] = &modelPar_RBPSL;
  AdmsSensFadType modelPar_RBPSW=mod.RBPSW;
  bool modelPar_given_RBPSW=mod.given("RBPSW");
  modParamMap["RBPSW"] = &modelPar_RBPSW;
  AdmsSensFadType modelPar_RBPSNF=mod.RBPSNF;
  bool modelPar_given_RBPSNF=mod.given("RBPSNF");
  modParamMap["RBPSNF"] = &modelPar_RBPSNF;
  AdmsSensFadType modelPar_RBPD0=mod.RBPD0;
  bool modelPar_given_RBPD0=mod.given("RBPD0");
  modParamMap["RBPD0"] = &modelPar_RBPD0;
  AdmsSensFadType modelPar_RBPDL=mod.RBPDL;
  bool modelPar_given_RBPDL=mod.given("RBPDL");
  modParamMap["RBPDL"] = &modelPar_RBPDL;
  AdmsSensFadType modelPar_RBPDW=mod.RBPDW;
  bool modelPar_given_RBPDW=mod.given("RBPDW");
  modParamMap["RBPDW"] = &modelPar_RBPDW;
  AdmsSensFadType modelPar_RBPDNF=mod.RBPDNF;
  bool modelPar_given_RBPDNF=mod.given("RBPDNF");
  modParamMap["RBPDNF"] = &modelPar_RBPDNF;
  AdmsSensFadType modelPar_RBPBX0=mod.RBPBX0;
  bool modelPar_given_RBPBX0=mod.given("RBPBX0");
  modParamMap["RBPBX0"] = &modelPar_RBPBX0;
  AdmsSensFadType modelPar_RBPBXL=mod.RBPBXL;
  bool modelPar_given_RBPBXL=mod.given("RBPBXL");
  modParamMap["RBPBXL"] = &modelPar_RBPBXL;
  AdmsSensFadType modelPar_RBPBXW=mod.RBPBXW;
  bool modelPar_given_RBPBXW=mod.given("RBPBXW");
  modParamMap["RBPBXW"] = &modelPar_RBPBXW;
  AdmsSensFadType modelPar_RBPBXNF=mod.RBPBXNF;
  bool modelPar_given_RBPBXNF=mod.given("RBPBXNF");
  modParamMap["RBPBXNF"] = &modelPar_RBPBXNF;
  AdmsSensFadType modelPar_RBPBY0=mod.RBPBY0;
  bool modelPar_given_RBPBY0=mod.given("RBPBY0");
  modParamMap["RBPBY0"] = &modelPar_RBPBY0;
  AdmsSensFadType modelPar_RBPBYL=mod.RBPBYL;
  bool modelPar_given_RBPBYL=mod.given("RBPBYL");
  modParamMap["RBPBYL"] = &modelPar_RBPBYL;
  AdmsSensFadType modelPar_RBPBYW=mod.RBPBYW;
  bool modelPar_given_RBPBYW=mod.given("RBPBYW");
  modParamMap["RBPBYW"] = &modelPar_RBPBYW;
  AdmsSensFadType modelPar_RBPBYNF=mod.RBPBYNF;
  bool modelPar_given_RBPBYNF=mod.given("RBPBYNF");
  modParamMap["RBPBYNF"] = &modelPar_RBPBYNF;
  AdmsSensFadType modelPar_RBSBX0=mod.RBSBX0;
  bool modelPar_given_RBSBX0=mod.given("RBSBX0");
  modParamMap["RBSBX0"] = &modelPar_RBSBX0;
  AdmsSensFadType modelPar_RBSBY0=mod.RBSBY0;
  bool modelPar_given_RBSBY0=mod.given("RBSBY0");
  modParamMap["RBSBY0"] = &modelPar_RBSBY0;
  AdmsSensFadType modelPar_RBDBX0=mod.RBDBX0;
  bool modelPar_given_RBDBX0=mod.given("RBDBX0");
  modParamMap["RBDBX0"] = &modelPar_RBDBX0;
  AdmsSensFadType modelPar_RBDBY0=mod.RBDBY0;
  bool modelPar_given_RBDBY0=mod.given("RBDBY0");
  modParamMap["RBDBY0"] = &modelPar_RBDBY0;
  AdmsSensFadType modelPar_RBSDBXL=mod.RBSDBXL;
  bool modelPar_given_RBSDBXL=mod.given("RBSDBXL");
  modParamMap["RBSDBXL"] = &modelPar_RBSDBXL;
  AdmsSensFadType modelPar_RBSDBXW=mod.RBSDBXW;
  bool modelPar_given_RBSDBXW=mod.given("RBSDBXW");
  modParamMap["RBSDBXW"] = &modelPar_RBSDBXW;
  AdmsSensFadType modelPar_RBSDBXNF=mod.RBSDBXNF;
  bool modelPar_given_RBSDBXNF=mod.given("RBSDBXNF");
  modParamMap["RBSDBXNF"] = &modelPar_RBSDBXNF;
  AdmsSensFadType modelPar_RBSDBYL=mod.RBSDBYL;
  bool modelPar_given_RBSDBYL=mod.given("RBSDBYL");
  modParamMap["RBSDBYL"] = &modelPar_RBSDBYL;
  AdmsSensFadType modelPar_RBSDBYW=mod.RBSDBYW;
  bool modelPar_given_RBSDBYW=mod.given("RBSDBYW");
  modParamMap["RBSDBYW"] = &modelPar_RBSDBYW;
  AdmsSensFadType modelPar_RBSDBYNF=mod.RBSDBYNF;
  bool modelPar_given_RBSDBYNF=mod.given("RBSDBYNF");
  modParamMap["RBSDBYNF"] = &modelPar_RBSDBYNF;
  AdmsSensFadType modelPar_EF=mod.EF;
  bool modelPar_given_EF=mod.given("EF");
  modParamMap["EF"] = &modelPar_EF;
  AdmsSensFadType modelPar_EM=mod.EM;
  bool modelPar_given_EM=mod.given("EM");
  modParamMap["EM"] = &modelPar_EM;
  AdmsSensFadType modelPar_NOIA=mod.NOIA;
  bool modelPar_given_NOIA=mod.given("NOIA");
  modParamMap["NOIA"] = &modelPar_NOIA;
  AdmsSensFadType modelPar_NOIB=mod.NOIB;
  bool modelPar_given_NOIB=mod.given("NOIB");
  modParamMap["NOIB"] = &modelPar_NOIB;
  AdmsSensFadType modelPar_NOIC=mod.NOIC;
  bool modelPar_given_NOIC=mod.given("NOIC");
  modParamMap["NOIC"] = &modelPar_NOIC;
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  modParamMap["LINTNOI"] = &modelPar_LINTNOI;
  AdmsSensFadType modelPar_NTNOI=mod.NTNOI;
  bool modelPar_given_NTNOI=mod.given("NTNOI");
  modParamMap["NTNOI"] = &modelPar_NTNOI;
  AdmsSensFadType modelPar_RNOIA=mod.RNOIA;
  bool modelPar_given_RNOIA=mod.given("RNOIA");
  modParamMap["RNOIA"] = &modelPar_RNOIA;
  AdmsSensFadType modelPar_RNOIB=mod.RNOIB;
  bool modelPar_given_RNOIB=mod.given("RNOIB");
  modParamMap["RNOIB"] = &modelPar_RNOIB;
  AdmsSensFadType modelPar_RNOIC=mod.RNOIC;
  bool modelPar_given_RNOIC=mod.given("RNOIC");
  modParamMap["RNOIC"] = &modelPar_RNOIC;
  AdmsSensFadType modelPar_TNOIA=mod.TNOIA;
  bool modelPar_given_TNOIA=mod.given("TNOIA");
  modParamMap["TNOIA"] = &modelPar_TNOIA;
  AdmsSensFadType modelPar_TNOIB=mod.TNOIB;
  bool modelPar_given_TNOIB=mod.given("TNOIB");
  modParamMap["TNOIB"] = &modelPar_TNOIB;
  AdmsSensFadType modelPar_TNOIC=mod.TNOIC;
  bool modelPar_given_TNOIC=mod.given("TNOIC");
  modParamMap["TNOIC"] = &modelPar_TNOIC;
  AdmsSensFadType modelPar_DLBIN=mod.DLBIN;
  bool modelPar_given_DLBIN=mod.given("DLBIN");
  modParamMap["DLBIN"] = &modelPar_DLBIN;
  AdmsSensFadType modelPar_DWBIN=mod.DWBIN;
  bool modelPar_given_DWBIN=mod.given("DWBIN");
  modParamMap["DWBIN"] = &modelPar_DWBIN;
  AdmsSensFadType modelPar_TNOM=mod.TNOM;
  bool modelPar_given_TNOM=mod.given("TNOM");
  modParamMap["TNOM"] = &modelPar_TNOM;
  AdmsSensFadType modelPar_DTEMP=mod.DTEMP;
  bool modelPar_given_DTEMP=mod.given("DTEMP");
  modParamMap["DTEMP"] = &modelPar_DTEMP;
  AdmsSensFadType modelPar_TBGASUB=mod.TBGASUB;
  bool modelPar_given_TBGASUB=mod.given("TBGASUB");
  modParamMap["TBGASUB"] = &modelPar_TBGASUB;
  AdmsSensFadType modelPar_TBGBSUB=mod.TBGBSUB;
  bool modelPar_given_TBGBSUB=mod.given("TBGBSUB");
  modParamMap["TBGBSUB"] = &modelPar_TBGBSUB;
  AdmsSensFadType modelPar_TNFACTOR=mod.TNFACTOR;
  bool modelPar_given_TNFACTOR=mod.given("TNFACTOR");
  modParamMap["TNFACTOR"] = &modelPar_TNFACTOR;
  AdmsSensFadType modelPar_UTE=mod.UTE;
  bool modelPar_given_UTE=mod.given("UTE");
  modParamMap["UTE"] = &modelPar_UTE;
  AdmsSensFadType modelPar_LUTE=mod.LUTE;
  bool modelPar_given_LUTE=mod.given("LUTE");
  modParamMap["LUTE"] = &modelPar_LUTE;
  AdmsSensFadType modelPar_WUTE=mod.WUTE;
  bool modelPar_given_WUTE=mod.given("WUTE");
  modParamMap["WUTE"] = &modelPar_WUTE;
  AdmsSensFadType modelPar_PUTE=mod.PUTE;
  bool modelPar_given_PUTE=mod.given("PUTE");
  modParamMap["PUTE"] = &modelPar_PUTE;
  AdmsSensFadType modelPar_UTEL=mod.UTEL;
  bool modelPar_given_UTEL=mod.given("UTEL");
  modParamMap["UTEL"] = &modelPar_UTEL;
  AdmsSensFadType modelPar_UA1=mod.UA1;
  bool modelPar_given_UA1=mod.given("UA1");
  modParamMap["UA1"] = &modelPar_UA1;
  AdmsSensFadType modelPar_LUA1=mod.LUA1;
  bool modelPar_given_LUA1=mod.given("LUA1");
  modParamMap["LUA1"] = &modelPar_LUA1;
  AdmsSensFadType modelPar_WUA1=mod.WUA1;
  bool modelPar_given_WUA1=mod.given("WUA1");
  modParamMap["WUA1"] = &modelPar_WUA1;
  AdmsSensFadType modelPar_PUA1=mod.PUA1;
  bool modelPar_given_PUA1=mod.given("PUA1");
  modParamMap["PUA1"] = &modelPar_PUA1;
  AdmsSensFadType modelPar_UA1L=mod.UA1L;
  bool modelPar_given_UA1L=mod.given("UA1L");
  modParamMap["UA1L"] = &modelPar_UA1L;
  AdmsSensFadType modelPar_UC1=mod.UC1;
  bool modelPar_given_UC1=mod.given("UC1");
  modParamMap["UC1"] = &modelPar_UC1;
  AdmsSensFadType modelPar_LUC1=mod.LUC1;
  bool modelPar_given_LUC1=mod.given("LUC1");
  modParamMap["LUC1"] = &modelPar_LUC1;
  AdmsSensFadType modelPar_WUC1=mod.WUC1;
  bool modelPar_given_WUC1=mod.given("WUC1");
  modParamMap["WUC1"] = &modelPar_WUC1;
  AdmsSensFadType modelPar_PUC1=mod.PUC1;
  bool modelPar_given_PUC1=mod.given("PUC1");
  modParamMap["PUC1"] = &modelPar_PUC1;
  AdmsSensFadType modelPar_UD1=mod.UD1;
  bool modelPar_given_UD1=mod.given("UD1");
  modParamMap["UD1"] = &modelPar_UD1;
  AdmsSensFadType modelPar_LUD1=mod.LUD1;
  bool modelPar_given_LUD1=mod.given("LUD1");
  modParamMap["LUD1"] = &modelPar_LUD1;
  AdmsSensFadType modelPar_WUD1=mod.WUD1;
  bool modelPar_given_WUD1=mod.given("WUD1");
  modParamMap["WUD1"] = &modelPar_WUD1;
  AdmsSensFadType modelPar_PUD1=mod.PUD1;
  bool modelPar_given_PUD1=mod.given("PUD1");
  modParamMap["PUD1"] = &modelPar_PUD1;
  AdmsSensFadType modelPar_UD1L=mod.UD1L;
  bool modelPar_given_UD1L=mod.given("UD1L");
  modParamMap["UD1L"] = &modelPar_UD1L;
  AdmsSensFadType modelPar_UCSTE=mod.UCSTE;
  bool modelPar_given_UCSTE=mod.given("UCSTE");
  modParamMap["UCSTE"] = &modelPar_UCSTE;
  AdmsSensFadType modelPar_LUCSTE=mod.LUCSTE;
  bool modelPar_given_LUCSTE=mod.given("LUCSTE");
  modParamMap["LUCSTE"] = &modelPar_LUCSTE;
  AdmsSensFadType modelPar_WUCSTE=mod.WUCSTE;
  bool modelPar_given_WUCSTE=mod.given("WUCSTE");
  modParamMap["WUCSTE"] = &modelPar_WUCSTE;
  AdmsSensFadType modelPar_PUCSTE=mod.PUCSTE;
  bool modelPar_given_PUCSTE=mod.given("PUCSTE");
  modParamMap["PUCSTE"] = &modelPar_PUCSTE;
  AdmsSensFadType modelPar_TETA0=mod.TETA0;
  bool modelPar_given_TETA0=mod.given("TETA0");
  modParamMap["TETA0"] = &modelPar_TETA0;
  AdmsSensFadType modelPar_PRT=mod.PRT;
  bool modelPar_given_PRT=mod.given("PRT");
  modParamMap["PRT"] = &modelPar_PRT;
  AdmsSensFadType modelPar_LPRT=mod.LPRT;
  bool modelPar_given_LPRT=mod.given("LPRT");
  modParamMap["LPRT"] = &modelPar_LPRT;
  AdmsSensFadType modelPar_WPRT=mod.WPRT;
  bool modelPar_given_WPRT=mod.given("WPRT");
  modParamMap["WPRT"] = &modelPar_WPRT;
  AdmsSensFadType modelPar_PPRT=mod.PPRT;
  bool modelPar_given_PPRT=mod.given("PPRT");
  modParamMap["PPRT"] = &modelPar_PPRT;
  AdmsSensFadType modelPar_AT=mod.AT;
  bool modelPar_given_AT=mod.given("AT");
  modParamMap["AT"] = &modelPar_AT;
  AdmsSensFadType modelPar_LAT=mod.LAT;
  bool modelPar_given_LAT=mod.given("LAT");
  modParamMap["LAT"] = &modelPar_LAT;
  AdmsSensFadType modelPar_WAT=mod.WAT;
  bool modelPar_given_WAT=mod.given("WAT");
  modParamMap["WAT"] = &modelPar_WAT;
  AdmsSensFadType modelPar_PAT=mod.PAT;
  bool modelPar_given_PAT=mod.given("PAT");
  modParamMap["PAT"] = &modelPar_PAT;
  AdmsSensFadType modelPar_ATL=mod.ATL;
  bool modelPar_given_ATL=mod.given("ATL");
  modParamMap["ATL"] = &modelPar_ATL;
  AdmsSensFadType modelPar_TDELTA=mod.TDELTA;
  bool modelPar_given_TDELTA=mod.given("TDELTA");
  modParamMap["TDELTA"] = &modelPar_TDELTA;
  AdmsSensFadType modelPar_PTWGT=mod.PTWGT;
  bool modelPar_given_PTWGT=mod.given("PTWGT");
  modParamMap["PTWGT"] = &modelPar_PTWGT;
  AdmsSensFadType modelPar_LPTWGT=mod.LPTWGT;
  bool modelPar_given_LPTWGT=mod.given("LPTWGT");
  modParamMap["LPTWGT"] = &modelPar_LPTWGT;
  AdmsSensFadType modelPar_WPTWGT=mod.WPTWGT;
  bool modelPar_given_WPTWGT=mod.given("WPTWGT");
  modParamMap["WPTWGT"] = &modelPar_WPTWGT;
  AdmsSensFadType modelPar_PPTWGT=mod.PPTWGT;
  bool modelPar_given_PPTWGT=mod.given("PPTWGT");
  modParamMap["PPTWGT"] = &modelPar_PPTWGT;
  AdmsSensFadType modelPar_PTWGTL=mod.PTWGTL;
  bool modelPar_given_PTWGTL=mod.given("PTWGTL");
  modParamMap["PTWGTL"] = &modelPar_PTWGTL;
  AdmsSensFadType modelPar_KT1=mod.KT1;
  bool modelPar_given_KT1=mod.given("KT1");
  modParamMap["KT1"] = &modelPar_KT1;
  AdmsSensFadType modelPar_KT1EXP=mod.KT1EXP;
  bool modelPar_given_KT1EXP=mod.given("KT1EXP");
  modParamMap["KT1EXP"] = &modelPar_KT1EXP;
  AdmsSensFadType modelPar_KT1L=mod.KT1L;
  bool modelPar_given_KT1L=mod.given("KT1L");
  modParamMap["KT1L"] = &modelPar_KT1L;
  AdmsSensFadType modelPar_LKT1=mod.LKT1;
  bool modelPar_given_LKT1=mod.given("LKT1");
  modParamMap["LKT1"] = &modelPar_LKT1;
  AdmsSensFadType modelPar_WKT1=mod.WKT1;
  bool modelPar_given_WKT1=mod.given("WKT1");
  modParamMap["WKT1"] = &modelPar_WKT1;
  AdmsSensFadType modelPar_PKT1=mod.PKT1;
  bool modelPar_given_PKT1=mod.given("PKT1");
  modParamMap["PKT1"] = &modelPar_PKT1;
  AdmsSensFadType modelPar_KT2=mod.KT2;
  bool modelPar_given_KT2=mod.given("KT2");
  modParamMap["KT2"] = &modelPar_KT2;
  AdmsSensFadType modelPar_LKT2=mod.LKT2;
  bool modelPar_given_LKT2=mod.given("LKT2");
  modParamMap["LKT2"] = &modelPar_LKT2;
  AdmsSensFadType modelPar_WKT2=mod.WKT2;
  bool modelPar_given_WKT2=mod.given("WKT2");
  modParamMap["WKT2"] = &modelPar_WKT2;
  AdmsSensFadType modelPar_PKT2=mod.PKT2;
  bool modelPar_given_PKT2=mod.given("PKT2");
  modParamMap["PKT2"] = &modelPar_PKT2;
  AdmsSensFadType modelPar_IIT=mod.IIT;
  bool modelPar_given_IIT=mod.given("IIT");
  modParamMap["IIT"] = &modelPar_IIT;
  AdmsSensFadType modelPar_LIIT=mod.LIIT;
  bool modelPar_given_LIIT=mod.given("LIIT");
  modParamMap["LIIT"] = &modelPar_LIIT;
  AdmsSensFadType modelPar_WIIT=mod.WIIT;
  bool modelPar_given_WIIT=mod.given("WIIT");
  modParamMap["WIIT"] = &modelPar_WIIT;
  AdmsSensFadType modelPar_PIIT=mod.PIIT;
  bool modelPar_given_PIIT=mod.given("PIIT");
  modParamMap["PIIT"] = &modelPar_PIIT;
  AdmsSensFadType modelPar_IGT=mod.IGT;
  bool modelPar_given_IGT=mod.given("IGT");
  modParamMap["IGT"] = &modelPar_IGT;
  AdmsSensFadType modelPar_LIGT=mod.LIGT;
  bool modelPar_given_LIGT=mod.given("LIGT");
  modParamMap["LIGT"] = &modelPar_LIGT;
  AdmsSensFadType modelPar_WIGT=mod.WIGT;
  bool modelPar_given_WIGT=mod.given("WIGT");
  modParamMap["WIGT"] = &modelPar_WIGT;
  AdmsSensFadType modelPar_PIGT=mod.PIGT;
  bool modelPar_given_PIGT=mod.given("PIGT");
  modParamMap["PIGT"] = &modelPar_PIGT;
  AdmsSensFadType modelPar_TGIDL=mod.TGIDL;
  bool modelPar_given_TGIDL=mod.given("TGIDL");
  modParamMap["TGIDL"] = &modelPar_TGIDL;
  AdmsSensFadType modelPar_LTGIDL=mod.LTGIDL;
  bool modelPar_given_LTGIDL=mod.given("LTGIDL");
  modParamMap["LTGIDL"] = &modelPar_LTGIDL;
  AdmsSensFadType modelPar_WTGIDL=mod.WTGIDL;
  bool modelPar_given_WTGIDL=mod.given("WTGIDL");
  modParamMap["WTGIDL"] = &modelPar_WTGIDL;
  AdmsSensFadType modelPar_PTGIDL=mod.PTGIDL;
  bool modelPar_given_PTGIDL=mod.given("PTGIDL");
  modParamMap["PTGIDL"] = &modelPar_PTGIDL;
  AdmsSensFadType modelPar_TCJ=mod.TCJ;
  bool modelPar_given_TCJ=mod.given("TCJ");
  modParamMap["TCJ"] = &modelPar_TCJ;
  AdmsSensFadType modelPar_TCJSW=mod.TCJSW;
  bool modelPar_given_TCJSW=mod.given("TCJSW");
  modParamMap["TCJSW"] = &modelPar_TCJSW;
  AdmsSensFadType modelPar_TCJSWG=mod.TCJSWG;
  bool modelPar_given_TCJSWG=mod.given("TCJSWG");
  modParamMap["TCJSWG"] = &modelPar_TCJSWG;
  AdmsSensFadType modelPar_TPB=mod.TPB;
  bool modelPar_given_TPB=mod.given("TPB");
  modParamMap["TPB"] = &modelPar_TPB;
  AdmsSensFadType modelPar_TPBSW=mod.TPBSW;
  bool modelPar_given_TPBSW=mod.given("TPBSW");
  modParamMap["TPBSW"] = &modelPar_TPBSW;
  AdmsSensFadType modelPar_TPBSWG=mod.TPBSWG;
  bool modelPar_given_TPBSWG=mod.given("TPBSWG");
  modParamMap["TPBSWG"] = &modelPar_TPBSWG;
  AdmsSensFadType modelPar_XTIS=mod.XTIS;
  bool modelPar_given_XTIS=mod.given("XTIS");
  modParamMap["XTIS"] = &modelPar_XTIS;
  AdmsSensFadType modelPar_XTID=mod.XTID;
  bool modelPar_given_XTID=mod.given("XTID");
  modParamMap["XTID"] = &modelPar_XTID;
  AdmsSensFadType modelPar_XTSS=mod.XTSS;
  bool modelPar_given_XTSS=mod.given("XTSS");
  modParamMap["XTSS"] = &modelPar_XTSS;
  AdmsSensFadType modelPar_XTSD=mod.XTSD;
  bool modelPar_given_XTSD=mod.given("XTSD");
  modParamMap["XTSD"] = &modelPar_XTSD;
  AdmsSensFadType modelPar_XTSSWS=mod.XTSSWS;
  bool modelPar_given_XTSSWS=mod.given("XTSSWS");
  modParamMap["XTSSWS"] = &modelPar_XTSSWS;
  AdmsSensFadType modelPar_XTSSWD=mod.XTSSWD;
  bool modelPar_given_XTSSWD=mod.given("XTSSWD");
  modParamMap["XTSSWD"] = &modelPar_XTSSWD;
  AdmsSensFadType modelPar_XTSSWGS=mod.XTSSWGS;
  bool modelPar_given_XTSSWGS=mod.given("XTSSWGS");
  modParamMap["XTSSWGS"] = &modelPar_XTSSWGS;
  AdmsSensFadType modelPar_XTSSWGD=mod.XTSSWGD;
  bool modelPar_given_XTSSWGD=mod.given("XTSSWGD");
  modParamMap["XTSSWGD"] = &modelPar_XTSSWGD;
  AdmsSensFadType modelPar_TNJTS=mod.TNJTS;
  bool modelPar_given_TNJTS=mod.given("TNJTS");
  modParamMap["TNJTS"] = &modelPar_TNJTS;
  AdmsSensFadType modelPar_TNJTSD=mod.TNJTSD;
  bool modelPar_given_TNJTSD=mod.given("TNJTSD");
  modParamMap["TNJTSD"] = &modelPar_TNJTSD;
  AdmsSensFadType modelPar_TNJTSSW=mod.TNJTSSW;
  bool modelPar_given_TNJTSSW=mod.given("TNJTSSW");
  modParamMap["TNJTSSW"] = &modelPar_TNJTSSW;
  AdmsSensFadType modelPar_TNJTSSWD=mod.TNJTSSWD;
  bool modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
  modParamMap["TNJTSSWD"] = &modelPar_TNJTSSWD;
  AdmsSensFadType modelPar_TNJTSSWG=mod.TNJTSSWG;
  bool modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
  modParamMap["TNJTSSWG"] = &modelPar_TNJTSSWG;
  AdmsSensFadType modelPar_TNJTSSWGD=mod.TNJTSSWGD;
  bool modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
  modParamMap["TNJTSSWGD"] = &modelPar_TNJTSSWGD;
  AdmsSensFadType modelPar_RTH0=mod.RTH0;
  bool modelPar_given_RTH0=mod.given("RTH0");
  modParamMap["RTH0"] = &modelPar_RTH0;
  AdmsSensFadType modelPar_CTH0=mod.CTH0;
  bool modelPar_given_CTH0=mod.given("CTH0");
  modParamMap["CTH0"] = &modelPar_CTH0;
  AdmsSensFadType modelPar_WTH0=mod.WTH0;
  bool modelPar_given_WTH0=mod.given("WTH0");
  modParamMap["WTH0"] = &modelPar_WTH0;
  AdmsSensFadType modelPar_SAREF=mod.SAREF;
  bool modelPar_given_SAREF=mod.given("SAREF");
  modParamMap["SAREF"] = &modelPar_SAREF;
  AdmsSensFadType modelPar_SBREF=mod.SBREF;
  bool modelPar_given_SBREF=mod.given("SBREF");
  modParamMap["SBREF"] = &modelPar_SBREF;
  AdmsSensFadType modelPar_WLOD=mod.WLOD;
  bool modelPar_given_WLOD=mod.given("WLOD");
  modParamMap["WLOD"] = &modelPar_WLOD;
  AdmsSensFadType modelPar_KU0=mod.KU0;
  bool modelPar_given_KU0=mod.given("KU0");
  modParamMap["KU0"] = &modelPar_KU0;
  AdmsSensFadType modelPar_KVSAT=mod.KVSAT;
  bool modelPar_given_KVSAT=mod.given("KVSAT");
  modParamMap["KVSAT"] = &modelPar_KVSAT;
  AdmsSensFadType modelPar_TKU0=mod.TKU0;
  bool modelPar_given_TKU0=mod.given("TKU0");
  modParamMap["TKU0"] = &modelPar_TKU0;
  AdmsSensFadType modelPar_LKU0=mod.LKU0;
  bool modelPar_given_LKU0=mod.given("LKU0");
  modParamMap["LKU0"] = &modelPar_LKU0;
  AdmsSensFadType modelPar_WKU0=mod.WKU0;
  bool modelPar_given_WKU0=mod.given("WKU0");
  modParamMap["WKU0"] = &modelPar_WKU0;
  AdmsSensFadType modelPar_PKU0=mod.PKU0;
  bool modelPar_given_PKU0=mod.given("PKU0");
  modParamMap["PKU0"] = &modelPar_PKU0;
  AdmsSensFadType modelPar_LLODKU0=mod.LLODKU0;
  bool modelPar_given_LLODKU0=mod.given("LLODKU0");
  modParamMap["LLODKU0"] = &modelPar_LLODKU0;
  AdmsSensFadType modelPar_WLODKU0=mod.WLODKU0;
  bool modelPar_given_WLODKU0=mod.given("WLODKU0");
  modParamMap["WLODKU0"] = &modelPar_WLODKU0;
  AdmsSensFadType modelPar_KVTH0=mod.KVTH0;
  bool modelPar_given_KVTH0=mod.given("KVTH0");
  modParamMap["KVTH0"] = &modelPar_KVTH0;
  AdmsSensFadType modelPar_LKVTH0=mod.LKVTH0;
  bool modelPar_given_LKVTH0=mod.given("LKVTH0");
  modParamMap["LKVTH0"] = &modelPar_LKVTH0;
  AdmsSensFadType modelPar_WKVTH0=mod.WKVTH0;
  bool modelPar_given_WKVTH0=mod.given("WKVTH0");
  modParamMap["WKVTH0"] = &modelPar_WKVTH0;
  AdmsSensFadType modelPar_PKVTH0=mod.PKVTH0;
  bool modelPar_given_PKVTH0=mod.given("PKVTH0");
  modParamMap["PKVTH0"] = &modelPar_PKVTH0;
  AdmsSensFadType modelPar_LLODVTH=mod.LLODVTH;
  bool modelPar_given_LLODVTH=mod.given("LLODVTH");
  modParamMap["LLODVTH"] = &modelPar_LLODVTH;
  AdmsSensFadType modelPar_WLODVTH=mod.WLODVTH;
  bool modelPar_given_WLODVTH=mod.given("WLODVTH");
  modParamMap["WLODVTH"] = &modelPar_WLODVTH;
  AdmsSensFadType modelPar_STK2=mod.STK2;
  bool modelPar_given_STK2=mod.given("STK2");
  modParamMap["STK2"] = &modelPar_STK2;
  AdmsSensFadType modelPar_LODK2=mod.LODK2;
  bool modelPar_given_LODK2=mod.given("LODK2");
  modParamMap["LODK2"] = &modelPar_LODK2;
  AdmsSensFadType modelPar_STETA0=mod.STETA0;
  bool modelPar_given_STETA0=mod.given("STETA0");
  modParamMap["STETA0"] = &modelPar_STETA0;
  AdmsSensFadType modelPar_LODETA0=mod.LODETA0;
  bool modelPar_given_LODETA0=mod.given("LODETA0");
  modParamMap["LODETA0"] = &modelPar_LODETA0;
  AdmsSensFadType modelPar_WEB=mod.WEB;
  bool modelPar_given_WEB=mod.given("WEB");
  modParamMap["WEB"] = &modelPar_WEB;
  AdmsSensFadType modelPar_WEC=mod.WEC;
  bool modelPar_given_WEC=mod.given("WEC");
  modParamMap["WEC"] = &modelPar_WEC;
  AdmsSensFadType modelPar_KVTH0WE=mod.KVTH0WE;
  bool modelPar_given_KVTH0WE=mod.given("KVTH0WE");
  modParamMap["KVTH0WE"] = &modelPar_KVTH0WE;
  AdmsSensFadType modelPar_LKVTH0WE=mod.LKVTH0WE;
  bool modelPar_given_LKVTH0WE=mod.given("LKVTH0WE");
  modParamMap["LKVTH0WE"] = &modelPar_LKVTH0WE;
  AdmsSensFadType modelPar_WKVTH0WE=mod.WKVTH0WE;
  bool modelPar_given_WKVTH0WE=mod.given("WKVTH0WE");
  modParamMap["WKVTH0WE"] = &modelPar_WKVTH0WE;
  AdmsSensFadType modelPar_PKVTH0WE=mod.PKVTH0WE;
  bool modelPar_given_PKVTH0WE=mod.given("PKVTH0WE");
  modParamMap["PKVTH0WE"] = &modelPar_PKVTH0WE;
  AdmsSensFadType modelPar_K2WE=mod.K2WE;
  bool modelPar_given_K2WE=mod.given("K2WE");
  modParamMap["K2WE"] = &modelPar_K2WE;
  AdmsSensFadType modelPar_LK2WE=mod.LK2WE;
  bool modelPar_given_LK2WE=mod.given("LK2WE");
  modParamMap["LK2WE"] = &modelPar_LK2WE;
  AdmsSensFadType modelPar_WK2WE=mod.WK2WE;
  bool modelPar_given_WK2WE=mod.given("WK2WE");
  modParamMap["WK2WE"] = &modelPar_WK2WE;
  AdmsSensFadType modelPar_PK2WE=mod.PK2WE;
  bool modelPar_given_PK2WE=mod.given("PK2WE");
  modParamMap["PK2WE"] = &modelPar_PK2WE;
  AdmsSensFadType modelPar_KU0WE=mod.KU0WE;
  bool modelPar_given_KU0WE=mod.given("KU0WE");
  modParamMap["KU0WE"] = &modelPar_KU0WE;
  AdmsSensFadType modelPar_LKU0WE=mod.LKU0WE;
  bool modelPar_given_LKU0WE=mod.given("LKU0WE");
  modParamMap["LKU0WE"] = &modelPar_LKU0WE;
  AdmsSensFadType modelPar_WKU0WE=mod.WKU0WE;
  bool modelPar_given_WKU0WE=mod.given("WKU0WE");
  modParamMap["WKU0WE"] = &modelPar_WKU0WE;
  AdmsSensFadType modelPar_PKU0WE=mod.PKU0WE;
  bool modelPar_given_PKU0WE=mod.given("PKU0WE");
  modParamMap["PKU0WE"] = &modelPar_PKU0WE;
  AdmsSensFadType modelPar_SCREF=mod.SCREF;
  bool modelPar_given_SCREF=mod.given("SCREF");
  modParamMap["SCREF"] = &modelPar_SCREF;
  AdmsSensFadType modelPar_WEDGE=mod.WEDGE;
  bool modelPar_given_WEDGE=mod.given("WEDGE");
  modParamMap["WEDGE"] = &modelPar_WEDGE;
  AdmsSensFadType modelPar_DGAMMAEDGE=mod.DGAMMAEDGE;
  bool modelPar_given_DGAMMAEDGE=mod.given("DGAMMAEDGE");
  modParamMap["DGAMMAEDGE"] = &modelPar_DGAMMAEDGE;
  AdmsSensFadType modelPar_DGAMMAEDGEL=mod.DGAMMAEDGEL;
  bool modelPar_given_DGAMMAEDGEL=mod.given("DGAMMAEDGEL");
  modParamMap["DGAMMAEDGEL"] = &modelPar_DGAMMAEDGEL;
  AdmsSensFadType modelPar_DGAMMAEDGELEXP=mod.DGAMMAEDGELEXP;
  bool modelPar_given_DGAMMAEDGELEXP=mod.given("DGAMMAEDGELEXP");
  modParamMap["DGAMMAEDGELEXP"] = &modelPar_DGAMMAEDGELEXP;
  AdmsSensFadType modelPar_DVTEDGE=mod.DVTEDGE;
  bool modelPar_given_DVTEDGE=mod.given("DVTEDGE");
  modParamMap["DVTEDGE"] = &modelPar_DVTEDGE;
  AdmsSensFadType modelPar_NFACTOREDGE=mod.NFACTOREDGE;
  bool modelPar_given_NFACTOREDGE=mod.given("NFACTOREDGE");
  modParamMap["NFACTOREDGE"] = &modelPar_NFACTOREDGE;
  AdmsSensFadType modelPar_CITEDGE=mod.CITEDGE;
  bool modelPar_given_CITEDGE=mod.given("CITEDGE");
  modParamMap["CITEDGE"] = &modelPar_CITEDGE;
  AdmsSensFadType modelPar_CDSCDEDGE=mod.CDSCDEDGE;
  bool modelPar_given_CDSCDEDGE=mod.given("CDSCDEDGE");
  modParamMap["CDSCDEDGE"] = &modelPar_CDSCDEDGE;
  AdmsSensFadType modelPar_CDSCBEDGE=mod.CDSCBEDGE;
  bool modelPar_given_CDSCBEDGE=mod.given("CDSCBEDGE");
  modParamMap["CDSCBEDGE"] = &modelPar_CDSCBEDGE;
  AdmsSensFadType modelPar_ETA0EDGE=mod.ETA0EDGE;
  bool modelPar_given_ETA0EDGE=mod.given("ETA0EDGE");
  modParamMap["ETA0EDGE"] = &modelPar_ETA0EDGE;
  AdmsSensFadType modelPar_ETABEDGE=mod.ETABEDGE;
  bool modelPar_given_ETABEDGE=mod.given("ETABEDGE");
  modParamMap["ETABEDGE"] = &modelPar_ETABEDGE;
  AdmsSensFadType modelPar_KT1EDGE=mod.KT1EDGE;
  bool modelPar_given_KT1EDGE=mod.given("KT1EDGE");
  modParamMap["KT1EDGE"] = &modelPar_KT1EDGE;
  AdmsSensFadType modelPar_KT1LEDGE=mod.KT1LEDGE;
  bool modelPar_given_KT1LEDGE=mod.given("KT1LEDGE");
  modParamMap["KT1LEDGE"] = &modelPar_KT1LEDGE;
  AdmsSensFadType modelPar_KT2EDGE=mod.KT2EDGE;
  bool modelPar_given_KT2EDGE=mod.given("KT2EDGE");
  modParamMap["KT2EDGE"] = &modelPar_KT2EDGE;
  AdmsSensFadType modelPar_KT1EXPEDGE=mod.KT1EXPEDGE;
  bool modelPar_given_KT1EXPEDGE=mod.given("KT1EXPEDGE");
  modParamMap["KT1EXPEDGE"] = &modelPar_KT1EXPEDGE;
  AdmsSensFadType modelPar_TNFACTOREDGE=mod.TNFACTOREDGE;
  bool modelPar_given_TNFACTOREDGE=mod.given("TNFACTOREDGE");
  modParamMap["TNFACTOREDGE"] = &modelPar_TNFACTOREDGE;
  AdmsSensFadType modelPar_TETA0EDGE=mod.TETA0EDGE;
  bool modelPar_given_TETA0EDGE=mod.given("TETA0EDGE");
  modParamMap["TETA0EDGE"] = &modelPar_TETA0EDGE;
  AdmsSensFadType modelPar_DVT0EDGE=mod.DVT0EDGE;
  bool modelPar_given_DVT0EDGE=mod.given("DVT0EDGE");
  modParamMap["DVT0EDGE"] = &modelPar_DVT0EDGE;
  AdmsSensFadType modelPar_DVT1EDGE=mod.DVT1EDGE;
  bool modelPar_given_DVT1EDGE=mod.given("DVT1EDGE");
  modParamMap["DVT1EDGE"] = &modelPar_DVT1EDGE;
  AdmsSensFadType modelPar_DVT2EDGE=mod.DVT2EDGE;
  bool modelPar_given_DVT2EDGE=mod.given("DVT2EDGE");
  modParamMap["DVT2EDGE"] = &modelPar_DVT2EDGE;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_NGCON=mod.NGCON;
  bool modelPar_given_NGCON=mod.given("NGCON");
  int modelPar_RGATEMOD=mod.RGATEMOD;
  bool modelPar_given_RGATEMOD=mod.given("RGATEMOD");
  int modelPar_RBODYMOD=mod.RBODYMOD;
  bool modelPar_given_RBODYMOD=mod.given("RBODYMOD");
  int modelPar_GEOMOD=mod.GEOMOD;
  bool modelPar_given_GEOMOD=mod.given("GEOMOD");
  int modelPar_RGEOMOD=mod.RGEOMOD;
  bool modelPar_given_RGEOMOD=mod.given("RGEOMOD");
  int modelPar_SCA=mod.SCA;
  bool modelPar_given_SCA=mod.given("SCA");
  int modelPar_SCB=mod.SCB;
  bool modelPar_given_SCB=mod.given("SCB");
  int modelPar_SCC=mod.SCC;
  bool modelPar_given_SCC=mod.given("SCC");
  int modelPar_SC=mod.SC;
  bool modelPar_given_SC=mod.given("SC");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  int modelPar_CVMOD=mod.CVMOD;
  bool modelPar_given_CVMOD=mod.given("CVMOD");
  int modelPar_COVMOD=mod.COVMOD;
  bool modelPar_given_COVMOD=mod.given("COVMOD");
  int modelPar_RDSMOD=mod.RDSMOD;
  bool modelPar_given_RDSMOD=mod.given("RDSMOD");
  int modelPar_WPEMOD=mod.WPEMOD;
  bool modelPar_given_WPEMOD=mod.given("WPEMOD");
  int modelPar_ASYMMOD=mod.ASYMMOD;
  bool modelPar_given_ASYMMOD=mod.given("ASYMMOD");
  int modelPar_GIDLMOD=mod.GIDLMOD;
  bool modelPar_given_GIDLMOD=mod.given("GIDLMOD");
  int modelPar_IGCMOD=mod.IGCMOD;
  bool modelPar_given_IGCMOD=mod.given("IGCMOD");
  int modelPar_IGBMOD=mod.IGBMOD;
  bool modelPar_given_IGBMOD=mod.given("IGBMOD");
  int modelPar_TNOIMOD=mod.TNOIMOD;
  bool modelPar_given_TNOIMOD=mod.given("TNOIMOD");
  int modelPar_SHMOD=mod.SHMOD;
  bool modelPar_given_SHMOD=mod.given("SHMOD");
  int modelPar_MOBSCALE=mod.MOBSCALE;
  bool modelPar_given_MOBSCALE=mod.given("MOBSCALE");
  int modelPar_PERMOD=mod.PERMOD;
  bool modelPar_given_PERMOD=mod.given("PERMOD");
  int modelPar_BINUNIT=mod.BINUNIT;
  bool modelPar_given_BINUNIT=mod.given("BINUNIT");
  int modelPar_EDGEFET=mod.EDGEFET;
  bool modelPar_given_EDGEFET=mod.given("EDGEFET");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 14+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_L=in.L;
    bool instancePar_given_L=in.given("L");
    AdmsSensFadType instancePar_W=in.W;
    bool instancePar_given_W=in.given("W");
    AdmsSensFadType instancePar_NRS=in.NRS;
    bool instancePar_given_NRS=in.given("NRS");
    AdmsSensFadType instancePar_NRD=in.NRD;
    bool instancePar_given_NRD=in.given("NRD");
    AdmsSensFadType instancePar_VFBSDOFF=in.VFBSDOFF;
    bool instancePar_given_VFBSDOFF=in.given("VFBSDOFF");
    AdmsSensFadType instancePar_XGW=in.XGW;
    bool instancePar_given_XGW=in.given("XGW");
    AdmsSensFadType instancePar_RBPB=in.RBPB;
    bool instancePar_given_RBPB=in.given("RBPB");
    AdmsSensFadType instancePar_RBPD=in.RBPD;
    bool instancePar_given_RBPD=in.given("RBPD");
    AdmsSensFadType instancePar_RBPS=in.RBPS;
    bool instancePar_given_RBPS=in.given("RBPS");
    AdmsSensFadType instancePar_RBDB=in.RBDB;
    bool instancePar_given_RBDB=in.given("RBDB");
    AdmsSensFadType instancePar_RBSB=in.RBSB;
    bool instancePar_given_RBSB=in.given("RBSB");
    AdmsSensFadType instancePar_SA=in.SA;
    bool instancePar_given_SA=in.given("SA");
    AdmsSensFadType instancePar_SB=in.SB;
    bool instancePar_given_SB=in.given("SB");
    AdmsSensFadType instancePar_SD=in.SD;
    bool instancePar_given_SD=in.given("SD");
    AdmsSensFadType instancePar_AS=in.AS;
    bool instancePar_given_AS=in.given("AS");
    AdmsSensFadType instancePar_AD=in.AD;
    bool instancePar_given_AD=in.given("AD");
    AdmsSensFadType instancePar_PS=in.PS;
    bool instancePar_given_PS=in.given("PS");
    AdmsSensFadType instancePar_PD=in.PD;
    bool instancePar_given_PD=in.given("PD");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:
    int instancePar_NF=in.NF;
    bool instancePar_given_NF=in.given("NF");
    int instancePar_MINZ=in.MINZ;
    bool instancePar_given_MINZ=in.given("MINZ");
    int instancePar_NGCON=in.NGCON;
    bool instancePar_given_NGCON=in.given("NGCON");
    int instancePar_RGATEMOD=in.RGATEMOD;
    bool instancePar_given_RGATEMOD=in.given("RGATEMOD");
    int instancePar_RBODYMOD=in.RBODYMOD;
    bool instancePar_given_RBODYMOD=in.given("RBODYMOD");
    int instancePar_GEOMOD=in.GEOMOD;
    bool instancePar_given_GEOMOD=in.given("GEOMOD");
    int instancePar_RGEOMOD=in.RGEOMOD;
    bool instancePar_given_RGEOMOD=in.given("RGEOMOD");
    int instancePar_SCA=in.SCA;
    bool instancePar_given_SCA=in.given("SCA");
    int instancePar_SCB=in.SCB;
    bool instancePar_given_SCB=in.given("SCB");
    int instancePar_SCC=in.SCC;
    bool instancePar_given_SCC=in.given("SCC");
    int instancePar_SC=in.SC;
    bool instancePar_given_SC=in.given("SC");




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("L")))
    {
      instancePar_L = modelPar_L;
    }
    if (!(in.given("VFBSDOFF")))
    {
      instancePar_VFBSDOFF = modelPar_VFBSDOFF;
    }
    if (!(in.given("XGW")))
    {
      instancePar_XGW = modelPar_XGW;
    }
    if (!(in.given("NGCON")))
    {
      instancePar_NGCON = modelPar_NGCON;
    }
    if (!(in.given("RGATEMOD")))
    {
      instancePar_RGATEMOD = modelPar_RGATEMOD;
    }
    if (!(in.given("RBODYMOD")))
    {
      instancePar_RBODYMOD = modelPar_RBODYMOD;
    }
    if (!(in.given("GEOMOD")))
    {
      instancePar_GEOMOD = modelPar_GEOMOD;
    }
    if (!(in.given("RGEOMOD")))
    {
      instancePar_RGEOMOD = modelPar_RGEOMOD;
    }
    if (!(in.given("RBPB")))
    {
      instancePar_RBPB = modelPar_RBPB;
    }
    if (!(in.given("RBPD")))
    {
      instancePar_RBPD = modelPar_RBPD;
    }
    if (!(in.given("RBPS")))
    {
      instancePar_RBPS = modelPar_RBPS;
    }
    if (!(in.given("RBDB")))
    {
      instancePar_RBDB = modelPar_RBDB;
    }
    if (!(in.given("RBSB")))
    {
      instancePar_RBSB = modelPar_RBSB;
    }
    if (!(in.given("SA")))
    {
      instancePar_SA = modelPar_SA;
    }
    if (!(in.given("SB")))
    {
      instancePar_SB = modelPar_SB;
    }
    if (!(in.given("SD")))
    {
      instancePar_SD = modelPar_SD;
    }
    if (!(in.given("SCA")))
    {
      instancePar_SCA = modelPar_SCA;
    }
    if (!(in.given("SCB")))
    {
      instancePar_SCB = modelPar_SCB;
    }
    if (!(in.given("SCC")))
    {
      instancePar_SCC = modelPar_SCC;
    }
    if (!(in.given("SC")))
    {
      instancePar_SC = modelPar_SC;
    }


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_T0=in.T0;
    AdmsSensFadType instanceVar_T1=in.T1;
    AdmsSensFadType instanceVar_T2=in.T2;
    AdmsSensFadType instanceVar_epssi=in.epssi;
    AdmsSensFadType instanceVar_epsox=in.epsox;
    AdmsSensFadType instanceVar_Weff=in.Weff;
    AdmsSensFadType instanceVar_Leff=in.Leff;
    AdmsSensFadType instanceVar_Wact=in.Wact;
    AdmsSensFadType instanceVar_Lact=in.Lact;
    AdmsSensFadType instanceVar_Weffcj=in.Weffcj;
    AdmsSensFadType instanceVar_Cox=in.Cox;
    AdmsSensFadType instanceVar_epsratio=in.epsratio;
    AdmsSensFadType instanceVar_Lnew=in.Lnew;
    AdmsSensFadType instanceVar_L_mult=in.L_mult;
    AdmsSensFadType instanceVar_Wnew=in.Wnew;
    AdmsSensFadType instanceVar_DVTP0_i=in.DVTP0_i;
    AdmsSensFadType instanceVar_DVTP1_i=in.DVTP1_i;
    AdmsSensFadType instanceVar_DVTP2_i=in.DVTP2_i;
    AdmsSensFadType instanceVar_DVTP3_i=in.DVTP3_i;
    AdmsSensFadType instanceVar_DVTP4_i=in.DVTP4_i;
    AdmsSensFadType instanceVar_DVTP5_i=in.DVTP5_i;
    AdmsSensFadType instanceVar_A1_i=in.A1_i;
    AdmsSensFadType instanceVar_A11_i=in.A11_i;
    AdmsSensFadType instanceVar_A2_i=in.A2_i;
    AdmsSensFadType instanceVar_A21_i=in.A21_i;
    AdmsSensFadType instanceVar_PSAT_i=in.PSAT_i;
    AdmsSensFadType instanceVar_PSATR_i=in.PSATR_i;
    AdmsSensFadType instanceVar_BSIM6TOXP=in.BSIM6TOXP;
    AdmsSensFadType instanceVar_DMCGeff=in.DMCGeff;
    AdmsSensFadType instanceVar_DMDGeff=in.DMDGeff;
    AdmsSensFadType instanceVar_DMCIeff=in.DMCIeff;
    AdmsSensFadType instanceVar_RSourceGeo=in.RSourceGeo;
    AdmsSensFadType instanceVar_RDrainGeo=in.RDrainGeo;
    AdmsSensFadType instanceVar_Grgeltd=in.Grgeltd;
    AdmsSensFadType instanceVar_Grbsb=in.Grbsb;
    AdmsSensFadType instanceVar_Grbdb=in.Grbdb;
    AdmsSensFadType instanceVar_Grbpb=in.Grbpb;
    AdmsSensFadType instanceVar_Grbps=in.Grbps;
    AdmsSensFadType instanceVar_Grbpd=in.Grbpd;
    AdmsSensFadType instanceVar_Aechvb=in.Aechvb;
    AdmsSensFadType instanceVar_Bechvb=in.Bechvb;
    AdmsSensFadType instanceVar_AechvbEdge=in.AechvbEdge;
    AdmsSensFadType instanceVar_BechvbEdge=in.BechvbEdge;
    AdmsSensFadType instanceVar_ToxRatio=in.ToxRatio;
    AdmsSensFadType instanceVar_U0R_t=in.U0R_t;
    AdmsSensFadType instanceVar_UAR_t=in.UAR_t;
    AdmsSensFadType instanceVar_UCR_t=in.UCR_t;
    AdmsSensFadType instanceVar_UDR_t=in.UDR_t;
    AdmsSensFadType instanceVar_UCSR_t=in.UCSR_t;
    AdmsSensFadType instanceVar_VSATR_t=in.VSATR_t;
    AdmsSensFadType instanceVar_PTWGR_t=in.PTWGR_t;
    AdmsSensFadType instanceVar_ETA0R_t=in.ETA0R_t;
    AdmsSensFadType instanceVar_PSATB_i=in.PSATB_i;
    AdmsSensFadType instanceVar_KT1_i=in.KT1_i;
    AdmsSensFadType instanceVar_KT2_i=in.KT2_i;
    AdmsSensFadType instanceVar_NGATE_i=in.NGATE_i;
    AdmsSensFadType instanceVar_NSD_i=in.NSD_i;
    AdmsSensFadType instanceVar_NDEP_i=in.NDEP_i;
    AdmsSensFadType instanceVar_VFB_i=in.VFB_i;
    AdmsSensFadType instanceVar_CIT_i=in.CIT_i;
    AdmsSensFadType instanceVar_CDSCD_i=in.CDSCD_i;
    AdmsSensFadType instanceVar_CDSCDR_i=in.CDSCDR_i;
    AdmsSensFadType instanceVar_CDSCB_i=in.CDSCB_i;
    AdmsSensFadType instanceVar_NFACTOR_i=in.NFACTOR_i;
    AdmsSensFadType instanceVar_PHIN_i=in.PHIN_i;
    AdmsSensFadType instanceVar_ETA0_i=in.ETA0_i;
    AdmsSensFadType instanceVar_ETA0R_i=in.ETA0R_i;
    AdmsSensFadType instanceVar_ETAB_i=in.ETAB_i;
    AdmsSensFadType instanceVar_K2_i=in.K2_i;
    AdmsSensFadType instanceVar_K1_i=in.K1_i;
    AdmsSensFadType instanceVar_DELTA_i=in.DELTA_i;
    AdmsSensFadType instanceVar_U0_i=in.U0_i;
    AdmsSensFadType instanceVar_U0R_i=in.U0R_i;
    AdmsSensFadType instanceVar_VSAT_i=in.VSAT_i;
    AdmsSensFadType instanceVar_VSATR_i=in.VSATR_i;
    AdmsSensFadType instanceVar_VSATCV_i=in.VSATCV_i;
    AdmsSensFadType instanceVar_UA_i=in.UA_i;
    AdmsSensFadType instanceVar_UAR_i=in.UAR_i;
    AdmsSensFadType instanceVar_EU_i=in.EU_i;
    AdmsSensFadType instanceVar_UD_i=in.UD_i;
    AdmsSensFadType instanceVar_UDR_i=in.UDR_i;
    AdmsSensFadType instanceVar_UD_a=in.UD_a;
    AdmsSensFadType instanceVar_UCS_i=in.UCS_i;
    AdmsSensFadType instanceVar_UCSR_i=in.UCSR_i;
    AdmsSensFadType instanceVar_UC_i=in.UC_i;
    AdmsSensFadType instanceVar_UCR_i=in.UCR_i;
    AdmsSensFadType instanceVar_PDIBLC_i=in.PDIBLC_i;
    AdmsSensFadType instanceVar_PDIBLCR_i=in.PDIBLCR_i;
    AdmsSensFadType instanceVar_PDIBLCB_i=in.PDIBLCB_i;
    AdmsSensFadType instanceVar_PSCBE1_i=in.PSCBE1_i;
    AdmsSensFadType instanceVar_PSCBE2_i=in.PSCBE2_i;
    AdmsSensFadType instanceVar_PDITS_i=in.PDITS_i;
    AdmsSensFadType instanceVar_PDITSD_i=in.PDITSD_i;
    AdmsSensFadType instanceVar_FPROUT_i=in.FPROUT_i;
    AdmsSensFadType instanceVar_PRWG_i=in.PRWG_i;
    AdmsSensFadType instanceVar_WR_i=in.WR_i;
    AdmsSensFadType instanceVar_RDWMIN_i=in.RDWMIN_i;
    AdmsSensFadType instanceVar_RSWMIN_i=in.RSWMIN_i;
    AdmsSensFadType instanceVar_RDW_i=in.RDW_i;
    AdmsSensFadType instanceVar_RSW_i=in.RSW_i;
    AdmsSensFadType instanceVar_RDSW_i=in.RDSW_i;
    AdmsSensFadType instanceVar_RDSWMIN_i=in.RDSWMIN_i;
    AdmsSensFadType instanceVar_PTWG_i=in.PTWG_i;
    AdmsSensFadType instanceVar_PTWGR_i=in.PTWGR_i;
    AdmsSensFadType instanceVar_PVAG_i=in.PVAG_i;
    AdmsSensFadType instanceVar_XJ_i=in.XJ_i;
    AdmsSensFadType instanceVar_PCLM_i=in.PCLM_i;
    AdmsSensFadType instanceVar_PCLMR_i=in.PCLMR_i;
    AdmsSensFadType instanceVar_PCLMCV_i=in.PCLMCV_i;
    AdmsSensFadType instanceVar_PRWB_i=in.PRWB_i;
    AdmsSensFadType instanceVar_CF_i=in.CF_i;
    AdmsSensFadType instanceVar_CGSL_i=in.CGSL_i;
    AdmsSensFadType instanceVar_CGDL_i=in.CGDL_i;
    AdmsSensFadType instanceVar_CKAPPAS_i=in.CKAPPAS_i;
    AdmsSensFadType instanceVar_CKAPPAD_i=in.CKAPPAD_i;
    AdmsSensFadType instanceVar_VFBCV_i=in.VFBCV_i;
    AdmsSensFadType instanceVar_NDEPCV_i=in.NDEPCV_i;
    AdmsSensFadType instanceVar_ALPHA0_i=in.ALPHA0_i;
    AdmsSensFadType instanceVar_BETA0_i=in.BETA0_i;
    AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
    AdmsSensFadType instanceVar_BGIDL_i=in.BGIDL_i;
    AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
    AdmsSensFadType instanceVar_EGIDL_i=in.EGIDL_i;
    AdmsSensFadType instanceVar_AGISL_i=in.AGISL_i;
    AdmsSensFadType instanceVar_BGISL_i=in.BGISL_i;
    AdmsSensFadType instanceVar_CGISL_i=in.CGISL_i;
    AdmsSensFadType instanceVar_EGISL_i=in.EGISL_i;
    AdmsSensFadType instanceVar_UTE_i=in.UTE_i;
    AdmsSensFadType instanceVar_UA1_i=in.UA1_i;
    AdmsSensFadType instanceVar_UC1_i=in.UC1_i;
    AdmsSensFadType instanceVar_UD1_i=in.UD1_i;
    AdmsSensFadType instanceVar_UCSTE_i=in.UCSTE_i;
    AdmsSensFadType instanceVar_PRT_i=in.PRT_i;
    AdmsSensFadType instanceVar_AT_i=in.AT_i;
    AdmsSensFadType instanceVar_PTWGT_i=in.PTWGT_i;
    AdmsSensFadType instanceVar_IIT_i=in.IIT_i;
    AdmsSensFadType instanceVar_TGIDL_i=in.TGIDL_i;
    AdmsSensFadType instanceVar_KVTH0WE_i=in.KVTH0WE_i;
    AdmsSensFadType instanceVar_K2WE_i=in.K2WE_i;
    AdmsSensFadType instanceVar_KU0WE_i=in.KU0WE_i;
    AdmsSensFadType instanceVar_AIGBINV_i=in.AIGBINV_i;
    AdmsSensFadType instanceVar_BIGBINV_i=in.BIGBINV_i;
    AdmsSensFadType instanceVar_CIGBINV_i=in.CIGBINV_i;
    AdmsSensFadType instanceVar_EIGBINV_i=in.EIGBINV_i;
    AdmsSensFadType instanceVar_NIGBINV_i=in.NIGBINV_i;
    AdmsSensFadType instanceVar_AIGBACC_i=in.AIGBACC_i;
    AdmsSensFadType instanceVar_BIGBACC_i=in.BIGBACC_i;
    AdmsSensFadType instanceVar_CIGBACC_i=in.CIGBACC_i;
    AdmsSensFadType instanceVar_NIGBACC_i=in.NIGBACC_i;
    AdmsSensFadType instanceVar_AIGC_i=in.AIGC_i;
    AdmsSensFadType instanceVar_BIGC_i=in.BIGC_i;
    AdmsSensFadType instanceVar_CIGC_i=in.CIGC_i;
    AdmsSensFadType instanceVar_AIGS_i=in.AIGS_i;
    AdmsSensFadType instanceVar_BIGS_i=in.BIGS_i;
    AdmsSensFadType instanceVar_CIGS_i=in.CIGS_i;
    AdmsSensFadType instanceVar_AIGD_i=in.AIGD_i;
    AdmsSensFadType instanceVar_BIGD_i=in.BIGD_i;
    AdmsSensFadType instanceVar_CIGD_i=in.CIGD_i;
    AdmsSensFadType instanceVar_PIGCD_i=in.PIGCD_i;
    AdmsSensFadType instanceVar_DLCIG_i=in.DLCIG_i;
    AdmsSensFadType instanceVar_DLCIGD_i=in.DLCIGD_i;
    AdmsSensFadType instanceVar_IGT_i=in.IGT_i;
    AdmsSensFadType instanceVar_nuIntD=in.nuIntD;
    AdmsSensFadType instanceVar_nuEndD=in.nuEndD;
    AdmsSensFadType instanceVar_nuIntS=in.nuIntS;
    AdmsSensFadType instanceVar_nuEndS=in.nuEndS;
    AdmsSensFadType instanceVar_gth=in.gth;
    AdmsSensFadType instanceVar_cth=in.cth;


    //non-reals
    int instanceVar_devsign=in.devsign;



    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_bi_dbulk] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_dbulk];
    probeVars[in.admsProbeID_V_b_dbulk] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_dbulk];
    probeVars[in.admsProbeID_V_b_bi] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_b_sbulk] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_sbulk];
    probeVars[in.admsProbeID_V_bi_sbulk] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_sbulk];
    probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_gm_gi] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_gi];
    probeVars[in.admsProbeID_V_g_gm] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_gm];
    probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_gm_bi] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_N1_GND] = (*solVectorPtr)[in.li_N1];
    probeVars[in.admsProbeID_V_N2_GND] = (*solVectorPtr)[in.li_N2];
    probeVars[in.admsProbeID_V_gm_si] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_gm_di] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_dbulk_di] = (*solVectorPtr)[in.li_dbulk] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_sbulk_si] = (*solVectorPtr)[in.li_sbulk] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_si_bi] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_di_bi] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_gi_bi] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_Temp_t_GND] = (in.collapseNode_t)?(0):((*solVectorPtr)[in.li_t]);


    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       instancePar_NRS,
       instancePar_given_NRS,
       instancePar_NRD,
       instancePar_given_NRD,
       instancePar_VFBSDOFF,
       instancePar_given_VFBSDOFF,
       instancePar_XGW,
       instancePar_given_XGW,
       instancePar_RBPB,
       instancePar_given_RBPB,
       instancePar_RBPD,
       instancePar_given_RBPD,
       instancePar_RBPS,
       instancePar_given_RBPS,
       instancePar_RBDB,
       instancePar_given_RBDB,
       instancePar_RBSB,
       instancePar_given_RBSB,
       instancePar_SA,
       instancePar_given_SA,
       instancePar_SB,
       instancePar_given_SB,
       instancePar_SD,
       instancePar_given_SD,
       instancePar_AS,
       instancePar_given_AS,
       instancePar_AD,
       instancePar_given_AD,
       instancePar_PS,
       instancePar_given_PS,
       instancePar_PD,
       instancePar_given_PD,
       // non-reals(including hidden)
       instancePar_NF,
       instancePar_given_NF,
       instancePar_MINZ,
       instancePar_given_MINZ,
       instancePar_NGCON,
       instancePar_given_NGCON,
       instancePar_RGATEMOD,
       instancePar_given_RGATEMOD,
       instancePar_RBODYMOD,
       instancePar_given_RBODYMOD,
       instancePar_GEOMOD,
       instancePar_given_GEOMOD,
       instancePar_RGEOMOD,
       instancePar_given_RGEOMOD,
       instancePar_SCA,
       instancePar_given_SCA,
       instancePar_SCB,
       instancePar_given_SCB,
       instancePar_SCC,
       instancePar_given_SCC,
       instancePar_SC,
       instancePar_given_SC,
       // instance variables
       // reals
       instanceVar_T0,
       instanceVar_T1,
       instanceVar_T2,
       instanceVar_epssi,
       instanceVar_epsox,
       instanceVar_Weff,
       instanceVar_Leff,
       instanceVar_Wact,
       instanceVar_Lact,
       instanceVar_Weffcj,
       instanceVar_Cox,
       instanceVar_epsratio,
       instanceVar_Lnew,
       instanceVar_L_mult,
       instanceVar_Wnew,
       instanceVar_DVTP0_i,
       instanceVar_DVTP1_i,
       instanceVar_DVTP2_i,
       instanceVar_DVTP3_i,
       instanceVar_DVTP4_i,
       instanceVar_DVTP5_i,
       instanceVar_A1_i,
       instanceVar_A11_i,
       instanceVar_A2_i,
       instanceVar_A21_i,
       instanceVar_PSAT_i,
       instanceVar_PSATR_i,
       instanceVar_BSIM6TOXP,
       instanceVar_DMCGeff,
       instanceVar_DMDGeff,
       instanceVar_DMCIeff,
       instanceVar_RSourceGeo,
       instanceVar_RDrainGeo,
       instanceVar_Grgeltd,
       instanceVar_Grbsb,
       instanceVar_Grbdb,
       instanceVar_Grbpb,
       instanceVar_Grbps,
       instanceVar_Grbpd,
       instanceVar_Aechvb,
       instanceVar_Bechvb,
       instanceVar_AechvbEdge,
       instanceVar_BechvbEdge,
       instanceVar_ToxRatio,
       instanceVar_U0R_t,
       instanceVar_UAR_t,
       instanceVar_UCR_t,
       instanceVar_UDR_t,
       instanceVar_UCSR_t,
       instanceVar_VSATR_t,
       instanceVar_PTWGR_t,
       instanceVar_ETA0R_t,
       instanceVar_PSATB_i,
       instanceVar_KT1_i,
       instanceVar_KT2_i,
       instanceVar_NGATE_i,
       instanceVar_NSD_i,
       instanceVar_NDEP_i,
       instanceVar_VFB_i,
       instanceVar_CIT_i,
       instanceVar_CDSCD_i,
       instanceVar_CDSCDR_i,
       instanceVar_CDSCB_i,
       instanceVar_NFACTOR_i,
       instanceVar_PHIN_i,
       instanceVar_ETA0_i,
       instanceVar_ETA0R_i,
       instanceVar_ETAB_i,
       instanceVar_K2_i,
       instanceVar_K1_i,
       instanceVar_DELTA_i,
       instanceVar_U0_i,
       instanceVar_U0R_i,
       instanceVar_VSAT_i,
       instanceVar_VSATR_i,
       instanceVar_VSATCV_i,
       instanceVar_UA_i,
       instanceVar_UAR_i,
       instanceVar_EU_i,
       instanceVar_UD_i,
       instanceVar_UDR_i,
       instanceVar_UD_a,
       instanceVar_UCS_i,
       instanceVar_UCSR_i,
       instanceVar_UC_i,
       instanceVar_UCR_i,
       instanceVar_PDIBLC_i,
       instanceVar_PDIBLCR_i,
       instanceVar_PDIBLCB_i,
       instanceVar_PSCBE1_i,
       instanceVar_PSCBE2_i,
       instanceVar_PDITS_i,
       instanceVar_PDITSD_i,
       instanceVar_FPROUT_i,
       instanceVar_PRWG_i,
       instanceVar_WR_i,
       instanceVar_RDWMIN_i,
       instanceVar_RSWMIN_i,
       instanceVar_RDW_i,
       instanceVar_RSW_i,
       instanceVar_RDSW_i,
       instanceVar_RDSWMIN_i,
       instanceVar_PTWG_i,
       instanceVar_PTWGR_i,
       instanceVar_PVAG_i,
       instanceVar_XJ_i,
       instanceVar_PCLM_i,
       instanceVar_PCLMR_i,
       instanceVar_PCLMCV_i,
       instanceVar_PRWB_i,
       instanceVar_CF_i,
       instanceVar_CGSL_i,
       instanceVar_CGDL_i,
       instanceVar_CKAPPAS_i,
       instanceVar_CKAPPAD_i,
       instanceVar_VFBCV_i,
       instanceVar_NDEPCV_i,
       instanceVar_ALPHA0_i,
       instanceVar_BETA0_i,
       instanceVar_AGIDL_i,
       instanceVar_BGIDL_i,
       instanceVar_CGIDL_i,
       instanceVar_EGIDL_i,
       instanceVar_AGISL_i,
       instanceVar_BGISL_i,
       instanceVar_CGISL_i,
       instanceVar_EGISL_i,
       instanceVar_UTE_i,
       instanceVar_UA1_i,
       instanceVar_UC1_i,
       instanceVar_UD1_i,
       instanceVar_UCSTE_i,
       instanceVar_PRT_i,
       instanceVar_AT_i,
       instanceVar_PTWGT_i,
       instanceVar_IIT_i,
       instanceVar_TGIDL_i,
       instanceVar_KVTH0WE_i,
       instanceVar_K2WE_i,
       instanceVar_KU0WE_i,
       instanceVar_AIGBINV_i,
       instanceVar_BIGBINV_i,
       instanceVar_CIGBINV_i,
       instanceVar_EIGBINV_i,
       instanceVar_NIGBINV_i,
       instanceVar_AIGBACC_i,
       instanceVar_BIGBACC_i,
       instanceVar_CIGBACC_i,
       instanceVar_NIGBACC_i,
       instanceVar_AIGC_i,
       instanceVar_BIGC_i,
       instanceVar_CIGC_i,
       instanceVar_AIGS_i,
       instanceVar_BIGS_i,
       instanceVar_CIGS_i,
       instanceVar_AIGD_i,
       instanceVar_BIGD_i,
       instanceVar_CIGD_i,
       instanceVar_PIGCD_i,
       instanceVar_DLCIG_i,
       instanceVar_DLCIGD_i,
       instanceVar_IGT_i,
       instanceVar_nuIntD,
       instanceVar_nuEndD,
       instanceVar_nuIntS,
       instanceVar_nuEndS,
       instanceVar_gth,
       instanceVar_cth,
       // non-reals
       instanceVar_devsign,
       // model parameters
       // reals
       modelPar_L,
       modelPar_given_L,
       modelPar_VFBSDOFF,
       modelPar_given_VFBSDOFF,
       modelPar_XGW,
       modelPar_given_XGW,
       modelPar_RBPB,
       modelPar_given_RBPB,
       modelPar_RBPD,
       modelPar_given_RBPD,
       modelPar_RBPS,
       modelPar_given_RBPS,
       modelPar_RBDB,
       modelPar_given_RBDB,
       modelPar_RBSB,
       modelPar_given_RBSB,
       modelPar_SA,
       modelPar_given_SA,
       modelPar_SB,
       modelPar_given_SB,
       modelPar_SD,
       modelPar_given_SD,
       modelPar_LLONG,
       modelPar_given_LLONG,
       modelPar_LMLT,
       modelPar_given_LMLT,
       modelPar_WMLT,
       modelPar_given_WMLT,
       modelPar_XL,
       modelPar_given_XL,
       modelPar_WWIDE,
       modelPar_given_WWIDE,
       modelPar_XW,
       modelPar_given_XW,
       modelPar_LINT,
       modelPar_given_LINT,
       modelPar_LL,
       modelPar_given_LL,
       modelPar_LW,
       modelPar_given_LW,
       modelPar_LWL,
       modelPar_given_LWL,
       modelPar_LLN,
       modelPar_given_LLN,
       modelPar_LWN,
       modelPar_given_LWN,
       modelPar_WINT,
       modelPar_given_WINT,
       modelPar_WL,
       modelPar_given_WL,
       modelPar_WW,
       modelPar_given_WW,
       modelPar_WWL,
       modelPar_given_WWL,
       modelPar_WLN,
       modelPar_given_WLN,
       modelPar_WWN,
       modelPar_given_WWN,
       modelPar_DLC,
       modelPar_given_DLC,
       modelPar_LLC,
       modelPar_given_LLC,
       modelPar_LWC,
       modelPar_given_LWC,
       modelPar_LWLC,
       modelPar_given_LWLC,
       modelPar_DWC,
       modelPar_given_DWC,
       modelPar_WLC,
       modelPar_given_WLC,
       modelPar_WWC,
       modelPar_given_WWC,
       modelPar_WWLC,
       modelPar_given_WWLC,
       modelPar_TOXE,
       modelPar_given_TOXE,
       modelPar_TOXP,
       modelPar_given_TOXP,
       modelPar_DTOX,
       modelPar_given_DTOX,
       modelPar_NDEP,
       modelPar_given_NDEP,
       modelPar_NDEPL1,
       modelPar_given_NDEPL1,
       modelPar_NDEPLEXP1,
       modelPar_given_NDEPLEXP1,
       modelPar_NDEPL2,
       modelPar_given_NDEPL2,
       modelPar_NDEPLEXP2,
       modelPar_given_NDEPLEXP2,
       modelPar_NDEPW,
       modelPar_given_NDEPW,
       modelPar_NDEPWEXP,
       modelPar_given_NDEPWEXP,
       modelPar_NDEPWL,
       modelPar_given_NDEPWL,
       modelPar_NDEPWLEXP,
       modelPar_given_NDEPWLEXP,
       modelPar_LNDEP,
       modelPar_given_LNDEP,
       modelPar_WNDEP,
       modelPar_given_WNDEP,
       modelPar_PNDEP,
       modelPar_given_PNDEP,
       modelPar_NDEPCV,
       modelPar_given_NDEPCV,
       modelPar_NDEPCVL1,
       modelPar_given_NDEPCVL1,
       modelPar_NDEPCVLEXP1,
       modelPar_given_NDEPCVLEXP1,
       modelPar_NDEPCVL2,
       modelPar_given_NDEPCVL2,
       modelPar_NDEPCVLEXP2,
       modelPar_given_NDEPCVLEXP2,
       modelPar_NDEPCVW,
       modelPar_given_NDEPCVW,
       modelPar_NDEPCVWEXP,
       modelPar_given_NDEPCVWEXP,
       modelPar_NDEPCVWL,
       modelPar_given_NDEPCVWL,
       modelPar_NDEPCVWLEXP,
       modelPar_given_NDEPCVWLEXP,
       modelPar_LNDEPCV,
       modelPar_given_LNDEPCV,
       modelPar_WNDEPCV,
       modelPar_given_WNDEPCV,
       modelPar_PNDEPCV,
       modelPar_given_PNDEPCV,
       modelPar_NGATE,
       modelPar_given_NGATE,
       modelPar_LNGATE,
       modelPar_given_LNGATE,
       modelPar_WNGATE,
       modelPar_given_WNGATE,
       modelPar_PNGATE,
       modelPar_given_PNGATE,
       modelPar_EASUB,
       modelPar_given_EASUB,
       modelPar_NI0SUB,
       modelPar_given_NI0SUB,
       modelPar_BG0SUB,
       modelPar_given_BG0SUB,
       modelPar_EPSRSUB,
       modelPar_given_EPSRSUB,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_XJ,
       modelPar_given_XJ,
       modelPar_LXJ,
       modelPar_given_LXJ,
       modelPar_WXJ,
       modelPar_given_WXJ,
       modelPar_PXJ,
       modelPar_given_PXJ,
       modelPar_LVFB,
       modelPar_given_LVFB,
       modelPar_WVFB,
       modelPar_given_WVFB,
       modelPar_PVFB,
       modelPar_given_PVFB,
       modelPar_VFB,
       modelPar_given_VFB,
       modelPar_VFBCV,
       modelPar_given_VFBCV,
       modelPar_LVFBCV,
       modelPar_given_LVFBCV,
       modelPar_WVFBCV,
       modelPar_given_WVFBCV,
       modelPar_PVFBCV,
       modelPar_given_PVFBCV,
       modelPar_VFBCVL,
       modelPar_given_VFBCVL,
       modelPar_VFBCVLEXP,
       modelPar_given_VFBCVLEXP,
       modelPar_VFBCVW,
       modelPar_given_VFBCVW,
       modelPar_VFBCVWEXP,
       modelPar_given_VFBCVWEXP,
       modelPar_VFBCVWL,
       modelPar_given_VFBCVWL,
       modelPar_VFBCVWLEXP,
       modelPar_given_VFBCVWLEXP,
       modelPar_DWJ,
       modelPar_given_DWJ,
       modelPar_NSD,
       modelPar_given_NSD,
       modelPar_LNSD,
       modelPar_given_LNSD,
       modelPar_WNSD,
       modelPar_given_WNSD,
       modelPar_PNSD,
       modelPar_given_PNSD,
       modelPar_DELVT0,
       modelPar_given_DELVT0,
       modelPar_DVTP0,
       modelPar_given_DVTP0,
       modelPar_LDVTP0,
       modelPar_given_LDVTP0,
       modelPar_WDVTP0,
       modelPar_given_WDVTP0,
       modelPar_PDVTP0,
       modelPar_given_PDVTP0,
       modelPar_DVTP1,
       modelPar_given_DVTP1,
       modelPar_LDVTP1,
       modelPar_given_LDVTP1,
       modelPar_WDVTP1,
       modelPar_given_WDVTP1,
       modelPar_PDVTP1,
       modelPar_given_PDVTP1,
       modelPar_DVTP2,
       modelPar_given_DVTP2,
       modelPar_LDVTP2,
       modelPar_given_LDVTP2,
       modelPar_WDVTP2,
       modelPar_given_WDVTP2,
       modelPar_PDVTP2,
       modelPar_given_PDVTP2,
       modelPar_DVTP3,
       modelPar_given_DVTP3,
       modelPar_LDVTP3,
       modelPar_given_LDVTP3,
       modelPar_WDVTP3,
       modelPar_given_WDVTP3,
       modelPar_PDVTP3,
       modelPar_given_PDVTP3,
       modelPar_DVTP4,
       modelPar_given_DVTP4,
       modelPar_LDVTP4,
       modelPar_given_LDVTP4,
       modelPar_WDVTP4,
       modelPar_given_WDVTP4,
       modelPar_PDVTP4,
       modelPar_given_PDVTP4,
       modelPar_DVTP5,
       modelPar_given_DVTP5,
       modelPar_LDVTP5,
       modelPar_given_LDVTP5,
       modelPar_WDVTP5,
       modelPar_given_WDVTP5,
       modelPar_PDVTP5,
       modelPar_given_PDVTP5,
       modelPar_PHIN,
       modelPar_given_PHIN,
       modelPar_LPHIN,
       modelPar_given_LPHIN,
       modelPar_WPHIN,
       modelPar_given_WPHIN,
       modelPar_PPHIN,
       modelPar_given_PPHIN,
       modelPar_ETA0,
       modelPar_given_ETA0,
       modelPar_LETA0,
       modelPar_given_LETA0,
       modelPar_WETA0,
       modelPar_given_WETA0,
       modelPar_PETA0,
       modelPar_given_PETA0,
       modelPar_ETA0R,
       modelPar_given_ETA0R,
       modelPar_LETA0R,
       modelPar_given_LETA0R,
       modelPar_WETA0R,
       modelPar_given_WETA0R,
       modelPar_PETA0R,
       modelPar_given_PETA0R,
       modelPar_DSUB,
       modelPar_given_DSUB,
       modelPar_ETAB,
       modelPar_given_ETAB,
       modelPar_ETABEXP,
       modelPar_given_ETABEXP,
       modelPar_LETAB,
       modelPar_given_LETAB,
       modelPar_WETAB,
       modelPar_given_WETAB,
       modelPar_PETAB,
       modelPar_given_PETAB,
       modelPar_K1,
       modelPar_given_K1,
       modelPar_K1L,
       modelPar_given_K1L,
       modelPar_K1LEXP,
       modelPar_given_K1LEXP,
       modelPar_K1W,
       modelPar_given_K1W,
       modelPar_K1WEXP,
       modelPar_given_K1WEXP,
       modelPar_K1WL,
       modelPar_given_K1WL,
       modelPar_K1WLEXP,
       modelPar_given_K1WLEXP,
       modelPar_LK1,
       modelPar_given_LK1,
       modelPar_WK1,
       modelPar_given_WK1,
       modelPar_PK1,
       modelPar_given_PK1,
       modelPar_K2,
       modelPar_given_K2,
       modelPar_K2L,
       modelPar_given_K2L,
       modelPar_K2LEXP,
       modelPar_given_K2LEXP,
       modelPar_K2W,
       modelPar_given_K2W,
       modelPar_K2WEXP,
       modelPar_given_K2WEXP,
       modelPar_K2WL,
       modelPar_given_K2WL,
       modelPar_K2WLEXP,
       modelPar_given_K2WLEXP,
       modelPar_LK2,
       modelPar_given_LK2,
       modelPar_WK2,
       modelPar_given_WK2,
       modelPar_PK2,
       modelPar_given_PK2,
       modelPar_ADOS,
       modelPar_given_ADOS,
       modelPar_BDOS,
       modelPar_given_BDOS,
       modelPar_QM0,
       modelPar_given_QM0,
       modelPar_ETAQM,
       modelPar_given_ETAQM,
       modelPar_CIT,
       modelPar_given_CIT,
       modelPar_LCIT,
       modelPar_given_LCIT,
       modelPar_WCIT,
       modelPar_given_WCIT,
       modelPar_PCIT,
       modelPar_given_PCIT,
       modelPar_NFACTOR,
       modelPar_given_NFACTOR,
       modelPar_NFACTORL,
       modelPar_given_NFACTORL,
       modelPar_NFACTORLEXP,
       modelPar_given_NFACTORLEXP,
       modelPar_NFACTORW,
       modelPar_given_NFACTORW,
       modelPar_NFACTORWEXP,
       modelPar_given_NFACTORWEXP,
       modelPar_NFACTORWL,
       modelPar_given_NFACTORWL,
       modelPar_NFACTORWLEXP,
       modelPar_given_NFACTORWLEXP,
       modelPar_LNFACTOR,
       modelPar_given_LNFACTOR,
       modelPar_WNFACTOR,
       modelPar_given_WNFACTOR,
       modelPar_PNFACTOR,
       modelPar_given_PNFACTOR,
       modelPar_CDSCD,
       modelPar_given_CDSCD,
       modelPar_CDSCDL,
       modelPar_given_CDSCDL,
       modelPar_CDSCDLEXP,
       modelPar_given_CDSCDLEXP,
       modelPar_LCDSCD,
       modelPar_given_LCDSCD,
       modelPar_WCDSCD,
       modelPar_given_WCDSCD,
       modelPar_PCDSCD,
       modelPar_given_PCDSCD,
       modelPar_CDSCDR,
       modelPar_given_CDSCDR,
       modelPar_CDSCDLR,
       modelPar_given_CDSCDLR,
       modelPar_LCDSCDR,
       modelPar_given_LCDSCDR,
       modelPar_WCDSCDR,
       modelPar_given_WCDSCDR,
       modelPar_PCDSCDR,
       modelPar_given_PCDSCDR,
       modelPar_CDSCB,
       modelPar_given_CDSCB,
       modelPar_CDSCBL,
       modelPar_given_CDSCBL,
       modelPar_CDSCBLEXP,
       modelPar_given_CDSCBLEXP,
       modelPar_LCDSCB,
       modelPar_given_LCDSCB,
       modelPar_WCDSCB,
       modelPar_given_WCDSCB,
       modelPar_PCDSCB,
       modelPar_given_PCDSCB,
       modelPar_VSAT,
       modelPar_given_VSAT,
       modelPar_LVSAT,
       modelPar_given_LVSAT,
       modelPar_WVSAT,
       modelPar_given_WVSAT,
       modelPar_PVSAT,
       modelPar_given_PVSAT,
       modelPar_VSATL,
       modelPar_given_VSATL,
       modelPar_VSATLEXP,
       modelPar_given_VSATLEXP,
       modelPar_VSATW,
       modelPar_given_VSATW,
       modelPar_VSATWEXP,
       modelPar_given_VSATWEXP,
       modelPar_VSATWL,
       modelPar_given_VSATWL,
       modelPar_VSATWLEXP,
       modelPar_given_VSATWLEXP,
       modelPar_VSATR,
       modelPar_given_VSATR,
       modelPar_LVSATR,
       modelPar_given_LVSATR,
       modelPar_WVSATR,
       modelPar_given_WVSATR,
       modelPar_PVSATR,
       modelPar_given_PVSATR,
       modelPar_DELTA,
       modelPar_given_DELTA,
       modelPar_LDELTA,
       modelPar_given_LDELTA,
       modelPar_WDELTA,
       modelPar_given_WDELTA,
       modelPar_PDELTA,
       modelPar_given_PDELTA,
       modelPar_DELTAL,
       modelPar_given_DELTAL,
       modelPar_DELTALEXP,
       modelPar_given_DELTALEXP,
       modelPar_VSATCV,
       modelPar_given_VSATCV,
       modelPar_LVSATCV,
       modelPar_given_LVSATCV,
       modelPar_WVSATCV,
       modelPar_given_WVSATCV,
       modelPar_PVSATCV,
       modelPar_given_PVSATCV,
       modelPar_VSATCVL,
       modelPar_given_VSATCVL,
       modelPar_VSATCVLEXP,
       modelPar_given_VSATCVLEXP,
       modelPar_VSATCVW,
       modelPar_given_VSATCVW,
       modelPar_VSATCVWEXP,
       modelPar_given_VSATCVWEXP,
       modelPar_VSATCVWL,
       modelPar_given_VSATCVWL,
       modelPar_VSATCVWLEXP,
       modelPar_given_VSATCVWLEXP,
       modelPar_UP1,
       modelPar_given_UP1,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_UP2,
       modelPar_given_UP2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_MULU0,
       modelPar_given_MULU0,
       modelPar_U0,
       modelPar_given_U0,
       modelPar_U0L,
       modelPar_given_U0L,
       modelPar_U0LEXP,
       modelPar_given_U0LEXP,
       modelPar_LU0,
       modelPar_given_LU0,
       modelPar_WU0,
       modelPar_given_WU0,
       modelPar_PU0,
       modelPar_given_PU0,
       modelPar_U0R,
       modelPar_given_U0R,
       modelPar_LU0R,
       modelPar_given_LU0R,
       modelPar_WU0R,
       modelPar_given_WU0R,
       modelPar_PU0R,
       modelPar_given_PU0R,
       modelPar_ETAMOB,
       modelPar_given_ETAMOB,
       modelPar_UA,
       modelPar_given_UA,
       modelPar_UAL,
       modelPar_given_UAL,
       modelPar_UALEXP,
       modelPar_given_UALEXP,
       modelPar_UAW,
       modelPar_given_UAW,
       modelPar_UAWEXP,
       modelPar_given_UAWEXP,
       modelPar_UAWL,
       modelPar_given_UAWL,
       modelPar_UAWLEXP,
       modelPar_given_UAWLEXP,
       modelPar_LUA,
       modelPar_given_LUA,
       modelPar_WUA,
       modelPar_given_WUA,
       modelPar_PUA,
       modelPar_given_PUA,
       modelPar_UAR,
       modelPar_given_UAR,
       modelPar_LUAR,
       modelPar_given_LUAR,
       modelPar_WUAR,
       modelPar_given_WUAR,
       modelPar_PUAR,
       modelPar_given_PUAR,
       modelPar_EU,
       modelPar_given_EU,
       modelPar_LEU,
       modelPar_given_LEU,
       modelPar_WEU,
       modelPar_given_WEU,
       modelPar_PEU,
       modelPar_given_PEU,
       modelPar_EUL,
       modelPar_given_EUL,
       modelPar_EULEXP,
       modelPar_given_EULEXP,
       modelPar_EUW,
       modelPar_given_EUW,
       modelPar_EUWEXP,
       modelPar_given_EUWEXP,
       modelPar_EUWL,
       modelPar_given_EUWL,
       modelPar_EUWLEXP,
       modelPar_given_EUWLEXP,
       modelPar_UD,
       modelPar_given_UD,
       modelPar_UDL,
       modelPar_given_UDL,
       modelPar_UDLEXP,
       modelPar_given_UDLEXP,
       modelPar_LUD,
       modelPar_given_LUD,
       modelPar_WUD,
       modelPar_given_WUD,
       modelPar_PUD,
       modelPar_given_PUD,
       modelPar_UDR,
       modelPar_given_UDR,
       modelPar_LUDR,
       modelPar_given_LUDR,
       modelPar_WUDR,
       modelPar_given_WUDR,
       modelPar_PUDR,
       modelPar_given_PUDR,
       modelPar_UCS,
       modelPar_given_UCS,
       modelPar_LUCS,
       modelPar_given_LUCS,
       modelPar_WUCS,
       modelPar_given_WUCS,
       modelPar_PUCS,
       modelPar_given_PUCS,
       modelPar_UCSR,
       modelPar_given_UCSR,
       modelPar_LUCSR,
       modelPar_given_LUCSR,
       modelPar_WUCSR,
       modelPar_given_WUCSR,
       modelPar_PUCSR,
       modelPar_given_PUCSR,
       modelPar_UC,
       modelPar_given_UC,
       modelPar_UCL,
       modelPar_given_UCL,
       modelPar_UCLEXP,
       modelPar_given_UCLEXP,
       modelPar_UCW,
       modelPar_given_UCW,
       modelPar_UCWEXP,
       modelPar_given_UCWEXP,
       modelPar_UCWL,
       modelPar_given_UCWL,
       modelPar_UCWLEXP,
       modelPar_given_UCWLEXP,
       modelPar_LUC,
       modelPar_given_LUC,
       modelPar_WUC,
       modelPar_given_WUC,
       modelPar_PUC,
       modelPar_given_PUC,
       modelPar_UCR,
       modelPar_given_UCR,
       modelPar_LUCR,
       modelPar_given_LUCR,
       modelPar_WUCR,
       modelPar_given_WUCR,
       modelPar_PUCR,
       modelPar_given_PUCR,
       modelPar_PCLM,
       modelPar_given_PCLM,
       modelPar_PCLML,
       modelPar_given_PCLML,
       modelPar_PCLMLEXP,
       modelPar_given_PCLMLEXP,
       modelPar_LPCLM,
       modelPar_given_LPCLM,
       modelPar_WPCLM,
       modelPar_given_WPCLM,
       modelPar_PPCLM,
       modelPar_given_PPCLM,
       modelPar_PCLMR,
       modelPar_given_PCLMR,
       modelPar_LPCLMR,
       modelPar_given_LPCLMR,
       modelPar_WPCLMR,
       modelPar_given_WPCLMR,
       modelPar_PPCLMR,
       modelPar_given_PPCLMR,
       modelPar_PCLMG,
       modelPar_given_PCLMG,
       modelPar_PCLMCV,
       modelPar_given_PCLMCV,
       modelPar_PCLMCVL,
       modelPar_given_PCLMCVL,
       modelPar_PCLMCVLEXP,
       modelPar_given_PCLMCVLEXP,
       modelPar_LPCLMCV,
       modelPar_given_LPCLMCV,
       modelPar_WPCLMCV,
       modelPar_given_WPCLMCV,
       modelPar_PPCLMCV,
       modelPar_given_PPCLMCV,
       modelPar_PSCBE1,
       modelPar_given_PSCBE1,
       modelPar_LPSCBE1,
       modelPar_given_LPSCBE1,
       modelPar_WPSCBE1,
       modelPar_given_WPSCBE1,
       modelPar_PPSCBE1,
       modelPar_given_PPSCBE1,
       modelPar_PSCBE2,
       modelPar_given_PSCBE2,
       modelPar_LPSCBE2,
       modelPar_given_LPSCBE2,
       modelPar_WPSCBE2,
       modelPar_given_WPSCBE2,
       modelPar_PPSCBE2,
       modelPar_given_PPSCBE2,
       modelPar_PDITS,
       modelPar_given_PDITS,
       modelPar_LPDITS,
       modelPar_given_LPDITS,
       modelPar_WPDITS,
       modelPar_given_WPDITS,
       modelPar_PPDITS,
       modelPar_given_PPDITS,
       modelPar_PDITSL,
       modelPar_given_PDITSL,
       modelPar_PDITSD,
       modelPar_given_PDITSD,
       modelPar_LPDITSD,
       modelPar_given_LPDITSD,
       modelPar_WPDITSD,
       modelPar_given_WPDITSD,
       modelPar_PPDITSD,
       modelPar_given_PPDITSD,
       modelPar_RSH,
       modelPar_given_RSH,
       modelPar_PRWG,
       modelPar_given_PRWG,
       modelPar_LPRWG,
       modelPar_given_LPRWG,
       modelPar_WPRWG,
       modelPar_given_WPRWG,
       modelPar_PPRWG,
       modelPar_given_PPRWG,
       modelPar_PRWB,
       modelPar_given_PRWB,
       modelPar_LPRWB,
       modelPar_given_LPRWB,
       modelPar_WPRWB,
       modelPar_given_WPRWB,
       modelPar_PPRWB,
       modelPar_given_PPRWB,
       modelPar_PRWBL,
       modelPar_given_PRWBL,
       modelPar_PRWBLEXP,
       modelPar_given_PRWBLEXP,
       modelPar_WR,
       modelPar_given_WR,
       modelPar_LWR,
       modelPar_given_LWR,
       modelPar_WWR,
       modelPar_given_WWR,
       modelPar_PWR,
       modelPar_given_PWR,
       modelPar_RSWMIN,
       modelPar_given_RSWMIN,
       modelPar_LRSWMIN,
       modelPar_given_LRSWMIN,
       modelPar_WRSWMIN,
       modelPar_given_WRSWMIN,
       modelPar_PRSWMIN,
       modelPar_given_PRSWMIN,
       modelPar_RSW,
       modelPar_given_RSW,
       modelPar_LRSW,
       modelPar_given_LRSW,
       modelPar_WRSW,
       modelPar_given_WRSW,
       modelPar_PRSW,
       modelPar_given_PRSW,
       modelPar_RSWL,
       modelPar_given_RSWL,
       modelPar_RSWLEXP,
       modelPar_given_RSWLEXP,
       modelPar_RDWMIN,
       modelPar_given_RDWMIN,
       modelPar_LRDWMIN,
       modelPar_given_LRDWMIN,
       modelPar_WRDWMIN,
       modelPar_given_WRDWMIN,
       modelPar_PRDWMIN,
       modelPar_given_PRDWMIN,
       modelPar_RDW,
       modelPar_given_RDW,
       modelPar_LRDW,
       modelPar_given_LRDW,
       modelPar_WRDW,
       modelPar_given_WRDW,
       modelPar_PRDW,
       modelPar_given_PRDW,
       modelPar_RDWL,
       modelPar_given_RDWL,
       modelPar_RDWLEXP,
       modelPar_given_RDWLEXP,
       modelPar_RDSWMIN,
       modelPar_given_RDSWMIN,
       modelPar_LRDSWMIN,
       modelPar_given_LRDSWMIN,
       modelPar_WRDSWMIN,
       modelPar_given_WRDSWMIN,
       modelPar_PRDSWMIN,
       modelPar_given_PRDSWMIN,
       modelPar_RDSW,
       modelPar_given_RDSW,
       modelPar_RDSWL,
       modelPar_given_RDSWL,
       modelPar_RDSWLEXP,
       modelPar_given_RDSWLEXP,
       modelPar_LRDSW,
       modelPar_given_LRDSW,
       modelPar_WRDSW,
       modelPar_given_WRDSW,
       modelPar_PRDSW,
       modelPar_given_PRDSW,
       modelPar_PSAT,
       modelPar_given_PSAT,
       modelPar_LPSAT,
       modelPar_given_LPSAT,
       modelPar_WPSAT,
       modelPar_given_WPSAT,
       modelPar_PPSAT,
       modelPar_given_PPSAT,
       modelPar_PSATL,
       modelPar_given_PSATL,
       modelPar_PSATLEXP,
       modelPar_given_PSATLEXP,
       modelPar_PSATB,
       modelPar_given_PSATB,
       modelPar_PSATR,
       modelPar_given_PSATR,
       modelPar_LPSATR,
       modelPar_given_LPSATR,
       modelPar_WPSATR,
       modelPar_given_WPSATR,
       modelPar_PPSATR,
       modelPar_given_PPSATR,
       modelPar_LPSATB,
       modelPar_given_LPSATB,
       modelPar_WPSATB,
       modelPar_given_WPSATB,
       modelPar_PPSATB,
       modelPar_given_PPSATB,
       modelPar_PSATX,
       modelPar_given_PSATX,
       modelPar_PTWG,
       modelPar_given_PTWG,
       modelPar_LPTWG,
       modelPar_given_LPTWG,
       modelPar_WPTWG,
       modelPar_given_WPTWG,
       modelPar_PPTWG,
       modelPar_given_PPTWG,
       modelPar_PTWGL,
       modelPar_given_PTWGL,
       modelPar_PTWGLEXP,
       modelPar_given_PTWGLEXP,
       modelPar_PTWGR,
       modelPar_given_PTWGR,
       modelPar_LPTWGR,
       modelPar_given_LPTWGR,
       modelPar_WPTWGR,
       modelPar_given_WPTWGR,
       modelPar_PPTWGR,
       modelPar_given_PPTWGR,
       modelPar_PTWGLR,
       modelPar_given_PTWGLR,
       modelPar_PTWGLEXPR,
       modelPar_given_PTWGLEXPR,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_LA1,
       modelPar_given_LA1,
       modelPar_WA1,
       modelPar_given_WA1,
       modelPar_PA1,
       modelPar_given_PA1,
       modelPar_A11,
       modelPar_given_A11,
       modelPar_LA11,
       modelPar_given_LA11,
       modelPar_WA11,
       modelPar_given_WA11,
       modelPar_PA11,
       modelPar_given_PA11,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_LA2,
       modelPar_given_LA2,
       modelPar_WA2,
       modelPar_given_WA2,
       modelPar_PA2,
       modelPar_given_PA2,
       modelPar_A21,
       modelPar_given_A21,
       modelPar_LA21,
       modelPar_given_LA21,
       modelPar_WA21,
       modelPar_given_WA21,
       modelPar_PA21,
       modelPar_given_PA21,
       modelPar_PDIBLC,
       modelPar_given_PDIBLC,
       modelPar_PDIBLCL,
       modelPar_given_PDIBLCL,
       modelPar_PDIBLCLEXP,
       modelPar_given_PDIBLCLEXP,
       modelPar_LPDIBLC,
       modelPar_given_LPDIBLC,
       modelPar_WPDIBLC,
       modelPar_given_WPDIBLC,
       modelPar_PPDIBLC,
       modelPar_given_PPDIBLC,
       modelPar_PDIBLCR,
       modelPar_given_PDIBLCR,
       modelPar_PDIBLCLR,
       modelPar_given_PDIBLCLR,
       modelPar_PDIBLCLEXPR,
       modelPar_given_PDIBLCLEXPR,
       modelPar_LPDIBLCR,
       modelPar_given_LPDIBLCR,
       modelPar_WPDIBLCR,
       modelPar_given_WPDIBLCR,
       modelPar_PPDIBLCR,
       modelPar_given_PPDIBLCR,
       modelPar_PDIBLCB,
       modelPar_given_PDIBLCB,
       modelPar_LPDIBLCB,
       modelPar_given_LPDIBLCB,
       modelPar_WPDIBLCB,
       modelPar_given_WPDIBLCB,
       modelPar_PPDIBLCB,
       modelPar_given_PPDIBLCB,
       modelPar_PVAG,
       modelPar_given_PVAG,
       modelPar_LPVAG,
       modelPar_given_LPVAG,
       modelPar_WPVAG,
       modelPar_given_WPVAG,
       modelPar_PPVAG,
       modelPar_given_PPVAG,
       modelPar_FPROUT,
       modelPar_given_FPROUT,
       modelPar_FPROUTL,
       modelPar_given_FPROUTL,
       modelPar_FPROUTLEXP,
       modelPar_given_FPROUTLEXP,
       modelPar_LFPROUT,
       modelPar_given_LFPROUT,
       modelPar_WFPROUT,
       modelPar_given_WFPROUT,
       modelPar_PFPROUT,
       modelPar_given_PFPROUT,
       modelPar_ALPHA0,
       modelPar_given_ALPHA0,
       modelPar_ALPHA0L,
       modelPar_given_ALPHA0L,
       modelPar_ALPHA0LEXP,
       modelPar_given_ALPHA0LEXP,
       modelPar_LALPHA0,
       modelPar_given_LALPHA0,
       modelPar_WALPHA0,
       modelPar_given_WALPHA0,
       modelPar_PALPHA0,
       modelPar_given_PALPHA0,
       modelPar_BETA0,
       modelPar_given_BETA0,
       modelPar_LBETA0,
       modelPar_given_LBETA0,
       modelPar_WBETA0,
       modelPar_given_WBETA0,
       modelPar_PBETA0,
       modelPar_given_PBETA0,
       modelPar_AIGBACC,
       modelPar_given_AIGBACC,
       modelPar_BIGBACC,
       modelPar_given_BIGBACC,
       modelPar_CIGBACC,
       modelPar_given_CIGBACC,
       modelPar_NIGBACC,
       modelPar_given_NIGBACC,
       modelPar_AIGBINV,
       modelPar_given_AIGBINV,
       modelPar_BIGBINV,
       modelPar_given_BIGBINV,
       modelPar_CIGBINV,
       modelPar_given_CIGBINV,
       modelPar_EIGBINV,
       modelPar_given_EIGBINV,
       modelPar_NIGBINV,
       modelPar_given_NIGBINV,
       modelPar_AIGC,
       modelPar_given_AIGC,
       modelPar_BIGC,
       modelPar_given_BIGC,
       modelPar_CIGC,
       modelPar_given_CIGC,
       modelPar_AIGS,
       modelPar_given_AIGS,
       modelPar_BIGS,
       modelPar_given_BIGS,
       modelPar_CIGS,
       modelPar_given_CIGS,
       modelPar_AIGD,
       modelPar_given_AIGD,
       modelPar_BIGD,
       modelPar_given_BIGD,
       modelPar_CIGD,
       modelPar_given_CIGD,
       modelPar_DLCIG,
       modelPar_given_DLCIG,
       modelPar_DLCIGD,
       modelPar_given_DLCIGD,
       modelPar_POXEDGE,
       modelPar_given_POXEDGE,
       modelPar_NTOX,
       modelPar_given_NTOX,
       modelPar_TOXREF,
       modelPar_given_TOXREF,
       modelPar_PIGCD,
       modelPar_given_PIGCD,
       modelPar_AIGCL,
       modelPar_given_AIGCL,
       modelPar_AIGCW,
       modelPar_given_AIGCW,
       modelPar_AIGSL,
       modelPar_given_AIGSL,
       modelPar_AIGSW,
       modelPar_given_AIGSW,
       modelPar_AIGDL,
       modelPar_given_AIGDL,
       modelPar_AIGDW,
       modelPar_given_AIGDW,
       modelPar_PIGCDL,
       modelPar_given_PIGCDL,
       modelPar_LAIGBINV,
       modelPar_given_LAIGBINV,
       modelPar_WAIGBINV,
       modelPar_given_WAIGBINV,
       modelPar_PAIGBINV,
       modelPar_given_PAIGBINV,
       modelPar_LBIGBINV,
       modelPar_given_LBIGBINV,
       modelPar_WBIGBINV,
       modelPar_given_WBIGBINV,
       modelPar_PBIGBINV,
       modelPar_given_PBIGBINV,
       modelPar_LCIGBINV,
       modelPar_given_LCIGBINV,
       modelPar_WCIGBINV,
       modelPar_given_WCIGBINV,
       modelPar_PCIGBINV,
       modelPar_given_PCIGBINV,
       modelPar_LEIGBINV,
       modelPar_given_LEIGBINV,
       modelPar_WEIGBINV,
       modelPar_given_WEIGBINV,
       modelPar_PEIGBINV,
       modelPar_given_PEIGBINV,
       modelPar_LNIGBINV,
       modelPar_given_LNIGBINV,
       modelPar_WNIGBINV,
       modelPar_given_WNIGBINV,
       modelPar_PNIGBINV,
       modelPar_given_PNIGBINV,
       modelPar_LAIGBACC,
       modelPar_given_LAIGBACC,
       modelPar_WAIGBACC,
       modelPar_given_WAIGBACC,
       modelPar_PAIGBACC,
       modelPar_given_PAIGBACC,
       modelPar_LBIGBACC,
       modelPar_given_LBIGBACC,
       modelPar_WBIGBACC,
       modelPar_given_WBIGBACC,
       modelPar_PBIGBACC,
       modelPar_given_PBIGBACC,
       modelPar_LCIGBACC,
       modelPar_given_LCIGBACC,
       modelPar_WCIGBACC,
       modelPar_given_WCIGBACC,
       modelPar_PCIGBACC,
       modelPar_given_PCIGBACC,
       modelPar_LNIGBACC,
       modelPar_given_LNIGBACC,
       modelPar_WNIGBACC,
       modelPar_given_WNIGBACC,
       modelPar_PNIGBACC,
       modelPar_given_PNIGBACC,
       modelPar_LAIGC,
       modelPar_given_LAIGC,
       modelPar_WAIGC,
       modelPar_given_WAIGC,
       modelPar_PAIGC,
       modelPar_given_PAIGC,
       modelPar_LBIGC,
       modelPar_given_LBIGC,
       modelPar_WBIGC,
       modelPar_given_WBIGC,
       modelPar_PBIGC,
       modelPar_given_PBIGC,
       modelPar_LCIGC,
       modelPar_given_LCIGC,
       modelPar_WCIGC,
       modelPar_given_WCIGC,
       modelPar_PCIGC,
       modelPar_given_PCIGC,
       modelPar_LAIGS,
       modelPar_given_LAIGS,
       modelPar_WAIGS,
       modelPar_given_WAIGS,
       modelPar_PAIGS,
       modelPar_given_PAIGS,
       modelPar_LBIGS,
       modelPar_given_LBIGS,
       modelPar_WBIGS,
       modelPar_given_WBIGS,
       modelPar_PBIGS,
       modelPar_given_PBIGS,
       modelPar_LCIGS,
       modelPar_given_LCIGS,
       modelPar_WCIGS,
       modelPar_given_WCIGS,
       modelPar_PCIGS,
       modelPar_given_PCIGS,
       modelPar_LAIGD,
       modelPar_given_LAIGD,
       modelPar_WAIGD,
       modelPar_given_WAIGD,
       modelPar_PAIGD,
       modelPar_given_PAIGD,
       modelPar_LBIGD,
       modelPar_given_LBIGD,
       modelPar_WBIGD,
       modelPar_given_WBIGD,
       modelPar_PBIGD,
       modelPar_given_PBIGD,
       modelPar_LCIGD,
       modelPar_given_LCIGD,
       modelPar_WCIGD,
       modelPar_given_WCIGD,
       modelPar_PCIGD,
       modelPar_given_PCIGD,
       modelPar_LPOXEDGE,
       modelPar_given_LPOXEDGE,
       modelPar_WPOXEDGE,
       modelPar_given_WPOXEDGE,
       modelPar_PPOXEDGE,
       modelPar_given_PPOXEDGE,
       modelPar_LDLCIG,
       modelPar_given_LDLCIG,
       modelPar_WDLCIG,
       modelPar_given_WDLCIG,
       modelPar_PDLCIG,
       modelPar_given_PDLCIG,
       modelPar_LDLCIGD,
       modelPar_given_LDLCIGD,
       modelPar_WDLCIGD,
       modelPar_given_WDLCIGD,
       modelPar_PDLCIGD,
       modelPar_given_PDLCIGD,
       modelPar_LNTOX,
       modelPar_given_LNTOX,
       modelPar_WNTOX,
       modelPar_given_WNTOX,
       modelPar_PNTOX,
       modelPar_given_PNTOX,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_AGIDLL,
       modelPar_given_AGIDLL,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_LAGIDL,
       modelPar_given_LAGIDL,
       modelPar_WAGIDL,
       modelPar_given_WAGIDL,
       modelPar_PAGIDL,
       modelPar_given_PAGIDL,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_LBGIDL,
       modelPar_given_LBGIDL,
       modelPar_WBGIDL,
       modelPar_given_WBGIDL,
       modelPar_PBGIDL,
       modelPar_given_PBGIDL,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_LCGIDL,
       modelPar_given_LCGIDL,
       modelPar_WCGIDL,
       modelPar_given_WCGIDL,
       modelPar_PCGIDL,
       modelPar_given_PCGIDL,
       modelPar_EGIDL,
       modelPar_given_EGIDL,
       modelPar_LEGIDL,
       modelPar_given_LEGIDL,
       modelPar_WEGIDL,
       modelPar_given_WEGIDL,
       modelPar_PEGIDL,
       modelPar_given_PEGIDL,
       modelPar_AGISL,
       modelPar_given_AGISL,
       modelPar_AGISLL,
       modelPar_given_AGISLL,
       modelPar_AGISLW,
       modelPar_given_AGISLW,
       modelPar_LAGISL,
       modelPar_given_LAGISL,
       modelPar_WAGISL,
       modelPar_given_WAGISL,
       modelPar_PAGISL,
       modelPar_given_PAGISL,
       modelPar_BGISL,
       modelPar_given_BGISL,
       modelPar_LBGISL,
       modelPar_given_LBGISL,
       modelPar_WBGISL,
       modelPar_given_WBGISL,
       modelPar_PBGISL,
       modelPar_given_PBGISL,
       modelPar_CGISL,
       modelPar_given_CGISL,
       modelPar_LCGISL,
       modelPar_given_LCGISL,
       modelPar_WCGISL,
       modelPar_given_WCGISL,
       modelPar_PCGISL,
       modelPar_given_PCGISL,
       modelPar_EGISL,
       modelPar_given_EGISL,
       modelPar_LEGISL,
       modelPar_given_LEGISL,
       modelPar_WEGISL,
       modelPar_given_WEGISL,
       modelPar_PEGISL,
       modelPar_given_PEGISL,
       modelPar_CF,
       modelPar_given_CF,
       modelPar_LCF,
       modelPar_given_LCF,
       modelPar_WCF,
       modelPar_given_WCF,
       modelPar_PCF,
       modelPar_given_PCF,
       modelPar_CFRCOEFF,
       modelPar_given_CFRCOEFF,
       modelPar_CGSO,
       modelPar_given_CGSO,
       modelPar_CGDO,
       modelPar_given_CGDO,
       modelPar_CGBO,
       modelPar_given_CGBO,
       modelPar_CGSL,
       modelPar_given_CGSL,
       modelPar_LCGSL,
       modelPar_given_LCGSL,
       modelPar_WCGSL,
       modelPar_given_WCGSL,
       modelPar_PCGSL,
       modelPar_given_PCGSL,
       modelPar_CGDL,
       modelPar_given_CGDL,
       modelPar_LCGDL,
       modelPar_given_LCGDL,
       modelPar_WCGDL,
       modelPar_given_WCGDL,
       modelPar_PCGDL,
       modelPar_given_PCGDL,
       modelPar_CKAPPAS,
       modelPar_given_CKAPPAS,
       modelPar_LCKAPPAS,
       modelPar_given_LCKAPPAS,
       modelPar_WCKAPPAS,
       modelPar_given_WCKAPPAS,
       modelPar_PCKAPPAS,
       modelPar_given_PCKAPPAS,
       modelPar_CKAPPAD,
       modelPar_given_CKAPPAD,
       modelPar_LCKAPPAD,
       modelPar_given_LCKAPPAD,
       modelPar_WCKAPPAD,
       modelPar_given_WCKAPPAD,
       modelPar_PCKAPPAD,
       modelPar_given_PCKAPPAD,
       modelPar_DMCG,
       modelPar_given_DMCG,
       modelPar_DMCI,
       modelPar_given_DMCI,
       modelPar_DMDG,
       modelPar_given_DMDG,
       modelPar_DMCGT,
       modelPar_given_DMCGT,
       modelPar_XGL,
       modelPar_given_XGL,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_CJD,
       modelPar_given_CJD,
       modelPar_CJSWS,
       modelPar_given_CJSWS,
       modelPar_CJSWD,
       modelPar_given_CJSWD,
       modelPar_CJSWGS,
       modelPar_given_CJSWGS,
       modelPar_CJSWGD,
       modelPar_given_CJSWGD,
       modelPar_PBS,
       modelPar_given_PBS,
       modelPar_PBD,
       modelPar_given_PBD,
       modelPar_PBSWS,
       modelPar_given_PBSWS,
       modelPar_PBSWD,
       modelPar_given_PBSWD,
       modelPar_PBSWGS,
       modelPar_given_PBSWGS,
       modelPar_PBSWGD,
       modelPar_given_PBSWGD,
       modelPar_MJS,
       modelPar_given_MJS,
       modelPar_MJD,
       modelPar_given_MJD,
       modelPar_MJSWS,
       modelPar_given_MJSWS,
       modelPar_MJSWD,
       modelPar_given_MJSWD,
       modelPar_MJSWGS,
       modelPar_given_MJSWGS,
       modelPar_MJSWGD,
       modelPar_given_MJSWGD,
       modelPar_JSS,
       modelPar_given_JSS,
       modelPar_JSD,
       modelPar_given_JSD,
       modelPar_JSWS,
       modelPar_given_JSWS,
       modelPar_JSWD,
       modelPar_given_JSWD,
       modelPar_JSWGS,
       modelPar_given_JSWGS,
       modelPar_JSWGD,
       modelPar_given_JSWGD,
       modelPar_NJS,
       modelPar_given_NJS,
       modelPar_NJD,
       modelPar_given_NJD,
       modelPar_IJTHSFWD,
       modelPar_given_IJTHSFWD,
       modelPar_IJTHDFWD,
       modelPar_given_IJTHDFWD,
       modelPar_IJTHSREV,
       modelPar_given_IJTHSREV,
       modelPar_IJTHDREV,
       modelPar_given_IJTHDREV,
       modelPar_BVS,
       modelPar_given_BVS,
       modelPar_BVD,
       modelPar_given_BVD,
       modelPar_XJBVS,
       modelPar_given_XJBVS,
       modelPar_XJBVD,
       modelPar_given_XJBVD,
       modelPar_JTSS,
       modelPar_given_JTSS,
       modelPar_JTSD,
       modelPar_given_JTSD,
       modelPar_JTSSWS,
       modelPar_given_JTSSWS,
       modelPar_JTSSWD,
       modelPar_given_JTSSWD,
       modelPar_JTSSWGS,
       modelPar_given_JTSSWGS,
       modelPar_JTSSWGD,
       modelPar_given_JTSSWGD,
       modelPar_JTWEFF,
       modelPar_given_JTWEFF,
       modelPar_NJTS,
       modelPar_given_NJTS,
       modelPar_NJTSD,
       modelPar_given_NJTSD,
       modelPar_NJTSSW,
       modelPar_given_NJTSSW,
       modelPar_NJTSSWD,
       modelPar_given_NJTSSWD,
       modelPar_NJTSSWG,
       modelPar_given_NJTSSWG,
       modelPar_NJTSSWGD,
       modelPar_given_NJTSSWGD,
       modelPar_VTSS,
       modelPar_given_VTSS,
       modelPar_VTSD,
       modelPar_given_VTSD,
       modelPar_VTSSWS,
       modelPar_given_VTSSWS,
       modelPar_VTSSWD,
       modelPar_given_VTSSWD,
       modelPar_VTSSWGS,
       modelPar_given_VTSSWGS,
       modelPar_VTSSWGD,
       modelPar_given_VTSSWGD,
       modelPar_XRCRG1,
       modelPar_given_XRCRG1,
       modelPar_XRCRG2,
       modelPar_given_XRCRG2,
       modelPar_GBMIN,
       modelPar_given_GBMIN,
       modelPar_RBPS0,
       modelPar_given_RBPS0,
       modelPar_RBPSL,
       modelPar_given_RBPSL,
       modelPar_RBPSW,
       modelPar_given_RBPSW,
       modelPar_RBPSNF,
       modelPar_given_RBPSNF,
       modelPar_RBPD0,
       modelPar_given_RBPD0,
       modelPar_RBPDL,
       modelPar_given_RBPDL,
       modelPar_RBPDW,
       modelPar_given_RBPDW,
       modelPar_RBPDNF,
       modelPar_given_RBPDNF,
       modelPar_RBPBX0,
       modelPar_given_RBPBX0,
       modelPar_RBPBXL,
       modelPar_given_RBPBXL,
       modelPar_RBPBXW,
       modelPar_given_RBPBXW,
       modelPar_RBPBXNF,
       modelPar_given_RBPBXNF,
       modelPar_RBPBY0,
       modelPar_given_RBPBY0,
       modelPar_RBPBYL,
       modelPar_given_RBPBYL,
       modelPar_RBPBYW,
       modelPar_given_RBPBYW,
       modelPar_RBPBYNF,
       modelPar_given_RBPBYNF,
       modelPar_RBSBX0,
       modelPar_given_RBSBX0,
       modelPar_RBSBY0,
       modelPar_given_RBSBY0,
       modelPar_RBDBX0,
       modelPar_given_RBDBX0,
       modelPar_RBDBY0,
       modelPar_given_RBDBY0,
       modelPar_RBSDBXL,
       modelPar_given_RBSDBXL,
       modelPar_RBSDBXW,
       modelPar_given_RBSDBXW,
       modelPar_RBSDBXNF,
       modelPar_given_RBSDBXNF,
       modelPar_RBSDBYL,
       modelPar_given_RBSDBYL,
       modelPar_RBSDBYW,
       modelPar_given_RBSDBYW,
       modelPar_RBSDBYNF,
       modelPar_given_RBSDBYNF,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_EM,
       modelPar_given_EM,
       modelPar_NOIA,
       modelPar_given_NOIA,
       modelPar_NOIB,
       modelPar_given_NOIB,
       modelPar_NOIC,
       modelPar_given_NOIC,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_NTNOI,
       modelPar_given_NTNOI,
       modelPar_RNOIA,
       modelPar_given_RNOIA,
       modelPar_RNOIB,
       modelPar_given_RNOIB,
       modelPar_RNOIC,
       modelPar_given_RNOIC,
       modelPar_TNOIA,
       modelPar_given_TNOIA,
       modelPar_TNOIB,
       modelPar_given_TNOIB,
       modelPar_TNOIC,
       modelPar_given_TNOIC,
       modelPar_DLBIN,
       modelPar_given_DLBIN,
       modelPar_DWBIN,
       modelPar_given_DWBIN,
       modelPar_TNOM,
       modelPar_given_TNOM,
       modelPar_DTEMP,
       modelPar_given_DTEMP,
       modelPar_TBGASUB,
       modelPar_given_TBGASUB,
       modelPar_TBGBSUB,
       modelPar_given_TBGBSUB,
       modelPar_TNFACTOR,
       modelPar_given_TNFACTOR,
       modelPar_UTE,
       modelPar_given_UTE,
       modelPar_LUTE,
       modelPar_given_LUTE,
       modelPar_WUTE,
       modelPar_given_WUTE,
       modelPar_PUTE,
       modelPar_given_PUTE,
       modelPar_UTEL,
       modelPar_given_UTEL,
       modelPar_UA1,
       modelPar_given_UA1,
       modelPar_LUA1,
       modelPar_given_LUA1,
       modelPar_WUA1,
       modelPar_given_WUA1,
       modelPar_PUA1,
       modelPar_given_PUA1,
       modelPar_UA1L,
       modelPar_given_UA1L,
       modelPar_UC1,
       modelPar_given_UC1,
       modelPar_LUC1,
       modelPar_given_LUC1,
       modelPar_WUC1,
       modelPar_given_WUC1,
       modelPar_PUC1,
       modelPar_given_PUC1,
       modelPar_UD1,
       modelPar_given_UD1,
       modelPar_LUD1,
       modelPar_given_LUD1,
       modelPar_WUD1,
       modelPar_given_WUD1,
       modelPar_PUD1,
       modelPar_given_PUD1,
       modelPar_UD1L,
       modelPar_given_UD1L,
       modelPar_UCSTE,
       modelPar_given_UCSTE,
       modelPar_LUCSTE,
       modelPar_given_LUCSTE,
       modelPar_WUCSTE,
       modelPar_given_WUCSTE,
       modelPar_PUCSTE,
       modelPar_given_PUCSTE,
       modelPar_TETA0,
       modelPar_given_TETA0,
       modelPar_PRT,
       modelPar_given_PRT,
       modelPar_LPRT,
       modelPar_given_LPRT,
       modelPar_WPRT,
       modelPar_given_WPRT,
       modelPar_PPRT,
       modelPar_given_PPRT,
       modelPar_AT,
       modelPar_given_AT,
       modelPar_LAT,
       modelPar_given_LAT,
       modelPar_WAT,
       modelPar_given_WAT,
       modelPar_PAT,
       modelPar_given_PAT,
       modelPar_ATL,
       modelPar_given_ATL,
       modelPar_TDELTA,
       modelPar_given_TDELTA,
       modelPar_PTWGT,
       modelPar_given_PTWGT,
       modelPar_LPTWGT,
       modelPar_given_LPTWGT,
       modelPar_WPTWGT,
       modelPar_given_WPTWGT,
       modelPar_PPTWGT,
       modelPar_given_PPTWGT,
       modelPar_PTWGTL,
       modelPar_given_PTWGTL,
       modelPar_KT1,
       modelPar_given_KT1,
       modelPar_KT1EXP,
       modelPar_given_KT1EXP,
       modelPar_KT1L,
       modelPar_given_KT1L,
       modelPar_LKT1,
       modelPar_given_LKT1,
       modelPar_WKT1,
       modelPar_given_WKT1,
       modelPar_PKT1,
       modelPar_given_PKT1,
       modelPar_KT2,
       modelPar_given_KT2,
       modelPar_LKT2,
       modelPar_given_LKT2,
       modelPar_WKT2,
       modelPar_given_WKT2,
       modelPar_PKT2,
       modelPar_given_PKT2,
       modelPar_IIT,
       modelPar_given_IIT,
       modelPar_LIIT,
       modelPar_given_LIIT,
       modelPar_WIIT,
       modelPar_given_WIIT,
       modelPar_PIIT,
       modelPar_given_PIIT,
       modelPar_IGT,
       modelPar_given_IGT,
       modelPar_LIGT,
       modelPar_given_LIGT,
       modelPar_WIGT,
       modelPar_given_WIGT,
       modelPar_PIGT,
       modelPar_given_PIGT,
       modelPar_TGIDL,
       modelPar_given_TGIDL,
       modelPar_LTGIDL,
       modelPar_given_LTGIDL,
       modelPar_WTGIDL,
       modelPar_given_WTGIDL,
       modelPar_PTGIDL,
       modelPar_given_PTGIDL,
       modelPar_TCJ,
       modelPar_given_TCJ,
       modelPar_TCJSW,
       modelPar_given_TCJSW,
       modelPar_TCJSWG,
       modelPar_given_TCJSWG,
       modelPar_TPB,
       modelPar_given_TPB,
       modelPar_TPBSW,
       modelPar_given_TPBSW,
       modelPar_TPBSWG,
       modelPar_given_TPBSWG,
       modelPar_XTIS,
       modelPar_given_XTIS,
       modelPar_XTID,
       modelPar_given_XTID,
       modelPar_XTSS,
       modelPar_given_XTSS,
       modelPar_XTSD,
       modelPar_given_XTSD,
       modelPar_XTSSWS,
       modelPar_given_XTSSWS,
       modelPar_XTSSWD,
       modelPar_given_XTSSWD,
       modelPar_XTSSWGS,
       modelPar_given_XTSSWGS,
       modelPar_XTSSWGD,
       modelPar_given_XTSSWGD,
       modelPar_TNJTS,
       modelPar_given_TNJTS,
       modelPar_TNJTSD,
       modelPar_given_TNJTSD,
       modelPar_TNJTSSW,
       modelPar_given_TNJTSSW,
       modelPar_TNJTSSWD,
       modelPar_given_TNJTSSWD,
       modelPar_TNJTSSWG,
       modelPar_given_TNJTSSWG,
       modelPar_TNJTSSWGD,
       modelPar_given_TNJTSSWGD,
       modelPar_RTH0,
       modelPar_given_RTH0,
       modelPar_CTH0,
       modelPar_given_CTH0,
       modelPar_WTH0,
       modelPar_given_WTH0,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KU0,
       modelPar_given_KU0,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKU0,
       modelPar_given_TKU0,
       modelPar_LKU0,
       modelPar_given_LKU0,
       modelPar_WKU0,
       modelPar_given_WKU0,
       modelPar_PKU0,
       modelPar_given_PKU0,
       modelPar_LLODKU0,
       modelPar_given_LLODKU0,
       modelPar_WLODKU0,
       modelPar_given_WLODKU0,
       modelPar_KVTH0,
       modelPar_given_KVTH0,
       modelPar_LKVTH0,
       modelPar_given_LKVTH0,
       modelPar_WKVTH0,
       modelPar_given_WKVTH0,
       modelPar_PKVTH0,
       modelPar_given_PKVTH0,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STK2,
       modelPar_given_STK2,
       modelPar_LODK2,
       modelPar_given_LODK2,
       modelPar_STETA0,
       modelPar_given_STETA0,
       modelPar_LODETA0,
       modelPar_given_LODETA0,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_KVTH0WE,
       modelPar_given_KVTH0WE,
       modelPar_LKVTH0WE,
       modelPar_given_LKVTH0WE,
       modelPar_WKVTH0WE,
       modelPar_given_WKVTH0WE,
       modelPar_PKVTH0WE,
       modelPar_given_PKVTH0WE,
       modelPar_K2WE,
       modelPar_given_K2WE,
       modelPar_LK2WE,
       modelPar_given_LK2WE,
       modelPar_WK2WE,
       modelPar_given_WK2WE,
       modelPar_PK2WE,
       modelPar_given_PK2WE,
       modelPar_KU0WE,
       modelPar_given_KU0WE,
       modelPar_LKU0WE,
       modelPar_given_LKU0WE,
       modelPar_WKU0WE,
       modelPar_given_WKU0WE,
       modelPar_PKU0WE,
       modelPar_given_PKU0WE,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEDGE,
       modelPar_given_WEDGE,
       modelPar_DGAMMAEDGE,
       modelPar_given_DGAMMAEDGE,
       modelPar_DGAMMAEDGEL,
       modelPar_given_DGAMMAEDGEL,
       modelPar_DGAMMAEDGELEXP,
       modelPar_given_DGAMMAEDGELEXP,
       modelPar_DVTEDGE,
       modelPar_given_DVTEDGE,
       modelPar_NFACTOREDGE,
       modelPar_given_NFACTOREDGE,
       modelPar_CITEDGE,
       modelPar_given_CITEDGE,
       modelPar_CDSCDEDGE,
       modelPar_given_CDSCDEDGE,
       modelPar_CDSCBEDGE,
       modelPar_given_CDSCBEDGE,
       modelPar_ETA0EDGE,
       modelPar_given_ETA0EDGE,
       modelPar_ETABEDGE,
       modelPar_given_ETABEDGE,
       modelPar_KT1EDGE,
       modelPar_given_KT1EDGE,
       modelPar_KT1LEDGE,
       modelPar_given_KT1LEDGE,
       modelPar_KT2EDGE,
       modelPar_given_KT2EDGE,
       modelPar_KT1EXPEDGE,
       modelPar_given_KT1EXPEDGE,
       modelPar_TNFACTOREDGE,
       modelPar_given_TNFACTOREDGE,
       modelPar_TETA0EDGE,
       modelPar_given_TETA0EDGE,
       modelPar_DVT0EDGE,
       modelPar_given_DVT0EDGE,
       modelPar_DVT1EDGE,
       modelPar_given_DVT1EDGE,
       modelPar_DVT2EDGE,
       modelPar_given_DVT2EDGE,
       // non-reals (including hidden)
       modelPar_NGCON,
       modelPar_given_NGCON,
       modelPar_RGATEMOD,
       modelPar_given_RGATEMOD,
       modelPar_RBODYMOD,
       modelPar_given_RBODYMOD,
       modelPar_GEOMOD,
       modelPar_given_GEOMOD,
       modelPar_RGEOMOD,
       modelPar_given_RGEOMOD,
       modelPar_SCA,
       modelPar_given_SCA,
       modelPar_SCB,
       modelPar_given_SCB,
       modelPar_SCC,
       modelPar_given_SCC,
       modelPar_SC,
       modelPar_given_SC,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_CVMOD,
       modelPar_given_CVMOD,
       modelPar_COVMOD,
       modelPar_given_COVMOD,
       modelPar_RDSMOD,
       modelPar_given_RDSMOD,
       modelPar_WPEMOD,
       modelPar_given_WPEMOD,
       modelPar_ASYMMOD,
       modelPar_given_ASYMMOD,
       modelPar_GIDLMOD,
       modelPar_given_GIDLMOD,
       modelPar_IGCMOD,
       modelPar_given_IGCMOD,
       modelPar_IGBMOD,
       modelPar_given_IGBMOD,
       modelPar_TNOIMOD,
       modelPar_given_TNOIMOD,
       modelPar_SHMOD,
       modelPar_given_SHMOD,
       modelPar_MOBSCALE,
       modelPar_given_MOBSCALE,
       modelPar_PERMOD,
       modelPar_given_PERMOD,
       modelPar_BINUNIT,
       modelPar_given_BINUNIT,
       modelPar_EDGEFET,
       modelPar_given_EDGEFET,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_bi_dbulk,
       in.admsProbeID_V_b_dbulk,
       in.admsProbeID_V_b_bi,
       in.admsProbeID_V_b_sbulk,
       in.admsProbeID_V_bi_sbulk,
       in.admsProbeID_V_di_si,
       in.admsProbeID_V_gm_gi,
       in.admsProbeID_V_g_gm,
       in.admsProbeID_V_s_si,
       in.admsProbeID_V_d_di,
       in.admsProbeID_V_gm_bi,
       in.admsProbeID_V_N1_GND,
       in.admsProbeID_V_N2_GND,
       in.admsProbeID_V_gm_si,
       in.admsProbeID_V_gm_di,
       in.admsProbeID_V_dbulk_di,
       in.admsProbeID_V_sbulk_si,
       in.admsProbeID_V_si_bi,
       in.admsProbeID_V_di_bi,
       in.admsProbeID_V_gi_bi,
       in.admsProbeID_Temp_t_GND,

       // node constants
       in.admsNodeID_d,
       in.admsNodeID_g,
       in.admsNodeID_s,
       in.admsNodeID_b,
       in.admsNodeID_di,
       in.admsNodeID_si,
       in.admsNodeID_gi,
       in.admsNodeID_gm,
       in.admsNodeID_bi,
       in.admsNodeID_sbulk,
       in.admsNodeID_dbulk,
       in.admsNodeID_N1,
       in.admsNodeID_N2,
       in.admsNodeID_t,
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       instancePar_NRS,
       instancePar_given_NRS,
       instancePar_NRD,
       instancePar_given_NRD,
       instancePar_VFBSDOFF,
       instancePar_given_VFBSDOFF,
       instancePar_XGW,
       instancePar_given_XGW,
       instancePar_RBPB,
       instancePar_given_RBPB,
       instancePar_RBPD,
       instancePar_given_RBPD,
       instancePar_RBPS,
       instancePar_given_RBPS,
       instancePar_RBDB,
       instancePar_given_RBDB,
       instancePar_RBSB,
       instancePar_given_RBSB,
       instancePar_SA,
       instancePar_given_SA,
       instancePar_SB,
       instancePar_given_SB,
       instancePar_SD,
       instancePar_given_SD,
       instancePar_AS,
       instancePar_given_AS,
       instancePar_AD,
       instancePar_given_AD,
       instancePar_PS,
       instancePar_given_PS,
       instancePar_PD,
       instancePar_given_PD,
       // non-reals(including hidden)
       instancePar_NF,
       instancePar_given_NF,
       instancePar_MINZ,
       instancePar_given_MINZ,
       instancePar_NGCON,
       instancePar_given_NGCON,
       instancePar_RGATEMOD,
       instancePar_given_RGATEMOD,
       instancePar_RBODYMOD,
       instancePar_given_RBODYMOD,
       instancePar_GEOMOD,
       instancePar_given_GEOMOD,
       instancePar_RGEOMOD,
       instancePar_given_RGEOMOD,
       instancePar_SCA,
       instancePar_given_SCA,
       instancePar_SCB,
       instancePar_given_SCB,
       instancePar_SCC,
       instancePar_given_SCC,
       instancePar_SC,
       instancePar_given_SC,
       // instance variables
       // reals
       instanceVar_T0,
       instanceVar_T1,
       instanceVar_T2,
       instanceVar_epssi,
       instanceVar_epsox,
       instanceVar_Weff,
       instanceVar_Leff,
       instanceVar_Wact,
       instanceVar_Lact,
       instanceVar_Weffcj,
       instanceVar_Cox,
       instanceVar_epsratio,
       instanceVar_Lnew,
       instanceVar_L_mult,
       instanceVar_Wnew,
       instanceVar_DVTP0_i,
       instanceVar_DVTP1_i,
       instanceVar_DVTP2_i,
       instanceVar_DVTP3_i,
       instanceVar_DVTP4_i,
       instanceVar_DVTP5_i,
       instanceVar_A1_i,
       instanceVar_A11_i,
       instanceVar_A2_i,
       instanceVar_A21_i,
       instanceVar_PSAT_i,
       instanceVar_PSATR_i,
       instanceVar_BSIM6TOXP,
       instanceVar_DMCGeff,
       instanceVar_DMDGeff,
       instanceVar_DMCIeff,
       instanceVar_RSourceGeo,
       instanceVar_RDrainGeo,
       instanceVar_Grgeltd,
       instanceVar_Grbsb,
       instanceVar_Grbdb,
       instanceVar_Grbpb,
       instanceVar_Grbps,
       instanceVar_Grbpd,
       instanceVar_Aechvb,
       instanceVar_Bechvb,
       instanceVar_AechvbEdge,
       instanceVar_BechvbEdge,
       instanceVar_ToxRatio,
       instanceVar_U0R_t,
       instanceVar_UAR_t,
       instanceVar_UCR_t,
       instanceVar_UDR_t,
       instanceVar_UCSR_t,
       instanceVar_VSATR_t,
       instanceVar_PTWGR_t,
       instanceVar_ETA0R_t,
       instanceVar_PSATB_i,
       instanceVar_KT1_i,
       instanceVar_KT2_i,
       instanceVar_NGATE_i,
       instanceVar_NSD_i,
       instanceVar_NDEP_i,
       instanceVar_VFB_i,
       instanceVar_CIT_i,
       instanceVar_CDSCD_i,
       instanceVar_CDSCDR_i,
       instanceVar_CDSCB_i,
       instanceVar_NFACTOR_i,
       instanceVar_PHIN_i,
       instanceVar_ETA0_i,
       instanceVar_ETA0R_i,
       instanceVar_ETAB_i,
       instanceVar_K2_i,
       instanceVar_K1_i,
       instanceVar_DELTA_i,
       instanceVar_U0_i,
       instanceVar_U0R_i,
       instanceVar_VSAT_i,
       instanceVar_VSATR_i,
       instanceVar_VSATCV_i,
       instanceVar_UA_i,
       instanceVar_UAR_i,
       instanceVar_EU_i,
       instanceVar_UD_i,
       instanceVar_UDR_i,
       instanceVar_UD_a,
       instanceVar_UCS_i,
       instanceVar_UCSR_i,
       instanceVar_UC_i,
       instanceVar_UCR_i,
       instanceVar_PDIBLC_i,
       instanceVar_PDIBLCR_i,
       instanceVar_PDIBLCB_i,
       instanceVar_PSCBE1_i,
       instanceVar_PSCBE2_i,
       instanceVar_PDITS_i,
       instanceVar_PDITSD_i,
       instanceVar_FPROUT_i,
       instanceVar_PRWG_i,
       instanceVar_WR_i,
       instanceVar_RDWMIN_i,
       instanceVar_RSWMIN_i,
       instanceVar_RDW_i,
       instanceVar_RSW_i,
       instanceVar_RDSW_i,
       instanceVar_RDSWMIN_i,
       instanceVar_PTWG_i,
       instanceVar_PTWGR_i,
       instanceVar_PVAG_i,
       instanceVar_XJ_i,
       instanceVar_PCLM_i,
       instanceVar_PCLMR_i,
       instanceVar_PCLMCV_i,
       instanceVar_PRWB_i,
       instanceVar_CF_i,
       instanceVar_CGSL_i,
       instanceVar_CGDL_i,
       instanceVar_CKAPPAS_i,
       instanceVar_CKAPPAD_i,
       instanceVar_VFBCV_i,
       instanceVar_NDEPCV_i,
       instanceVar_ALPHA0_i,
       instanceVar_BETA0_i,
       instanceVar_AGIDL_i,
       instanceVar_BGIDL_i,
       instanceVar_CGIDL_i,
       instanceVar_EGIDL_i,
       instanceVar_AGISL_i,
       instanceVar_BGISL_i,
       instanceVar_CGISL_i,
       instanceVar_EGISL_i,
       instanceVar_UTE_i,
       instanceVar_UA1_i,
       instanceVar_UC1_i,
       instanceVar_UD1_i,
       instanceVar_UCSTE_i,
       instanceVar_PRT_i,
       instanceVar_AT_i,
       instanceVar_PTWGT_i,
       instanceVar_IIT_i,
       instanceVar_TGIDL_i,
       instanceVar_KVTH0WE_i,
       instanceVar_K2WE_i,
       instanceVar_KU0WE_i,
       instanceVar_AIGBINV_i,
       instanceVar_BIGBINV_i,
       instanceVar_CIGBINV_i,
       instanceVar_EIGBINV_i,
       instanceVar_NIGBINV_i,
       instanceVar_AIGBACC_i,
       instanceVar_BIGBACC_i,
       instanceVar_CIGBACC_i,
       instanceVar_NIGBACC_i,
       instanceVar_AIGC_i,
       instanceVar_BIGC_i,
       instanceVar_CIGC_i,
       instanceVar_AIGS_i,
       instanceVar_BIGS_i,
       instanceVar_CIGS_i,
       instanceVar_AIGD_i,
       instanceVar_BIGD_i,
       instanceVar_CIGD_i,
       instanceVar_PIGCD_i,
       instanceVar_DLCIG_i,
       instanceVar_DLCIGD_i,
       instanceVar_IGT_i,
       instanceVar_nuIntD,
       instanceVar_nuEndD,
       instanceVar_nuIntS,
       instanceVar_nuEndS,
       instanceVar_gth,
       instanceVar_cth,
       // non-reals
       instanceVar_devsign,
       // model parameters
       // reals
       modelPar_L,
       modelPar_given_L,
       modelPar_VFBSDOFF,
       modelPar_given_VFBSDOFF,
       modelPar_XGW,
       modelPar_given_XGW,
       modelPar_RBPB,
       modelPar_given_RBPB,
       modelPar_RBPD,
       modelPar_given_RBPD,
       modelPar_RBPS,
       modelPar_given_RBPS,
       modelPar_RBDB,
       modelPar_given_RBDB,
       modelPar_RBSB,
       modelPar_given_RBSB,
       modelPar_SA,
       modelPar_given_SA,
       modelPar_SB,
       modelPar_given_SB,
       modelPar_SD,
       modelPar_given_SD,
       modelPar_LLONG,
       modelPar_given_LLONG,
       modelPar_LMLT,
       modelPar_given_LMLT,
       modelPar_WMLT,
       modelPar_given_WMLT,
       modelPar_XL,
       modelPar_given_XL,
       modelPar_WWIDE,
       modelPar_given_WWIDE,
       modelPar_XW,
       modelPar_given_XW,
       modelPar_LINT,
       modelPar_given_LINT,
       modelPar_LL,
       modelPar_given_LL,
       modelPar_LW,
       modelPar_given_LW,
       modelPar_LWL,
       modelPar_given_LWL,
       modelPar_LLN,
       modelPar_given_LLN,
       modelPar_LWN,
       modelPar_given_LWN,
       modelPar_WINT,
       modelPar_given_WINT,
       modelPar_WL,
       modelPar_given_WL,
       modelPar_WW,
       modelPar_given_WW,
       modelPar_WWL,
       modelPar_given_WWL,
       modelPar_WLN,
       modelPar_given_WLN,
       modelPar_WWN,
       modelPar_given_WWN,
       modelPar_DLC,
       modelPar_given_DLC,
       modelPar_LLC,
       modelPar_given_LLC,
       modelPar_LWC,
       modelPar_given_LWC,
       modelPar_LWLC,
       modelPar_given_LWLC,
       modelPar_DWC,
       modelPar_given_DWC,
       modelPar_WLC,
       modelPar_given_WLC,
       modelPar_WWC,
       modelPar_given_WWC,
       modelPar_WWLC,
       modelPar_given_WWLC,
       modelPar_TOXE,
       modelPar_given_TOXE,
       modelPar_TOXP,
       modelPar_given_TOXP,
       modelPar_DTOX,
       modelPar_given_DTOX,
       modelPar_NDEP,
       modelPar_given_NDEP,
       modelPar_NDEPL1,
       modelPar_given_NDEPL1,
       modelPar_NDEPLEXP1,
       modelPar_given_NDEPLEXP1,
       modelPar_NDEPL2,
       modelPar_given_NDEPL2,
       modelPar_NDEPLEXP2,
       modelPar_given_NDEPLEXP2,
       modelPar_NDEPW,
       modelPar_given_NDEPW,
       modelPar_NDEPWEXP,
       modelPar_given_NDEPWEXP,
       modelPar_NDEPWL,
       modelPar_given_NDEPWL,
       modelPar_NDEPWLEXP,
       modelPar_given_NDEPWLEXP,
       modelPar_LNDEP,
       modelPar_given_LNDEP,
       modelPar_WNDEP,
       modelPar_given_WNDEP,
       modelPar_PNDEP,
       modelPar_given_PNDEP,
       modelPar_NDEPCV,
       modelPar_given_NDEPCV,
       modelPar_NDEPCVL1,
       modelPar_given_NDEPCVL1,
       modelPar_NDEPCVLEXP1,
       modelPar_given_NDEPCVLEXP1,
       modelPar_NDEPCVL2,
       modelPar_given_NDEPCVL2,
       modelPar_NDEPCVLEXP2,
       modelPar_given_NDEPCVLEXP2,
       modelPar_NDEPCVW,
       modelPar_given_NDEPCVW,
       modelPar_NDEPCVWEXP,
       modelPar_given_NDEPCVWEXP,
       modelPar_NDEPCVWL,
       modelPar_given_NDEPCVWL,
       modelPar_NDEPCVWLEXP,
       modelPar_given_NDEPCVWLEXP,
       modelPar_LNDEPCV,
       modelPar_given_LNDEPCV,
       modelPar_WNDEPCV,
       modelPar_given_WNDEPCV,
       modelPar_PNDEPCV,
       modelPar_given_PNDEPCV,
       modelPar_NGATE,
       modelPar_given_NGATE,
       modelPar_LNGATE,
       modelPar_given_LNGATE,
       modelPar_WNGATE,
       modelPar_given_WNGATE,
       modelPar_PNGATE,
       modelPar_given_PNGATE,
       modelPar_EASUB,
       modelPar_given_EASUB,
       modelPar_NI0SUB,
       modelPar_given_NI0SUB,
       modelPar_BG0SUB,
       modelPar_given_BG0SUB,
       modelPar_EPSRSUB,
       modelPar_given_EPSRSUB,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_XJ,
       modelPar_given_XJ,
       modelPar_LXJ,
       modelPar_given_LXJ,
       modelPar_WXJ,
       modelPar_given_WXJ,
       modelPar_PXJ,
       modelPar_given_PXJ,
       modelPar_LVFB,
       modelPar_given_LVFB,
       modelPar_WVFB,
       modelPar_given_WVFB,
       modelPar_PVFB,
       modelPar_given_PVFB,
       modelPar_VFB,
       modelPar_given_VFB,
       modelPar_VFBCV,
       modelPar_given_VFBCV,
       modelPar_LVFBCV,
       modelPar_given_LVFBCV,
       modelPar_WVFBCV,
       modelPar_given_WVFBCV,
       modelPar_PVFBCV,
       modelPar_given_PVFBCV,
       modelPar_VFBCVL,
       modelPar_given_VFBCVL,
       modelPar_VFBCVLEXP,
       modelPar_given_VFBCVLEXP,
       modelPar_VFBCVW,
       modelPar_given_VFBCVW,
       modelPar_VFBCVWEXP,
       modelPar_given_VFBCVWEXP,
       modelPar_VFBCVWL,
       modelPar_given_VFBCVWL,
       modelPar_VFBCVWLEXP,
       modelPar_given_VFBCVWLEXP,
       modelPar_DWJ,
       modelPar_given_DWJ,
       modelPar_NSD,
       modelPar_given_NSD,
       modelPar_LNSD,
       modelPar_given_LNSD,
       modelPar_WNSD,
       modelPar_given_WNSD,
       modelPar_PNSD,
       modelPar_given_PNSD,
       modelPar_DELVT0,
       modelPar_given_DELVT0,
       modelPar_DVTP0,
       modelPar_given_DVTP0,
       modelPar_LDVTP0,
       modelPar_given_LDVTP0,
       modelPar_WDVTP0,
       modelPar_given_WDVTP0,
       modelPar_PDVTP0,
       modelPar_given_PDVTP0,
       modelPar_DVTP1,
       modelPar_given_DVTP1,
       modelPar_LDVTP1,
       modelPar_given_LDVTP1,
       modelPar_WDVTP1,
       modelPar_given_WDVTP1,
       modelPar_PDVTP1,
       modelPar_given_PDVTP1,
       modelPar_DVTP2,
       modelPar_given_DVTP2,
       modelPar_LDVTP2,
       modelPar_given_LDVTP2,
       modelPar_WDVTP2,
       modelPar_given_WDVTP2,
       modelPar_PDVTP2,
       modelPar_given_PDVTP2,
       modelPar_DVTP3,
       modelPar_given_DVTP3,
       modelPar_LDVTP3,
       modelPar_given_LDVTP3,
       modelPar_WDVTP3,
       modelPar_given_WDVTP3,
       modelPar_PDVTP3,
       modelPar_given_PDVTP3,
       modelPar_DVTP4,
       modelPar_given_DVTP4,
       modelPar_LDVTP4,
       modelPar_given_LDVTP4,
       modelPar_WDVTP4,
       modelPar_given_WDVTP4,
       modelPar_PDVTP4,
       modelPar_given_PDVTP4,
       modelPar_DVTP5,
       modelPar_given_DVTP5,
       modelPar_LDVTP5,
       modelPar_given_LDVTP5,
       modelPar_WDVTP5,
       modelPar_given_WDVTP5,
       modelPar_PDVTP5,
       modelPar_given_PDVTP5,
       modelPar_PHIN,
       modelPar_given_PHIN,
       modelPar_LPHIN,
       modelPar_given_LPHIN,
       modelPar_WPHIN,
       modelPar_given_WPHIN,
       modelPar_PPHIN,
       modelPar_given_PPHIN,
       modelPar_ETA0,
       modelPar_given_ETA0,
       modelPar_LETA0,
       modelPar_given_LETA0,
       modelPar_WETA0,
       modelPar_given_WETA0,
       modelPar_PETA0,
       modelPar_given_PETA0,
       modelPar_ETA0R,
       modelPar_given_ETA0R,
       modelPar_LETA0R,
       modelPar_given_LETA0R,
       modelPar_WETA0R,
       modelPar_given_WETA0R,
       modelPar_PETA0R,
       modelPar_given_PETA0R,
       modelPar_DSUB,
       modelPar_given_DSUB,
       modelPar_ETAB,
       modelPar_given_ETAB,
       modelPar_ETABEXP,
       modelPar_given_ETABEXP,
       modelPar_LETAB,
       modelPar_given_LETAB,
       modelPar_WETAB,
       modelPar_given_WETAB,
       modelPar_PETAB,
       modelPar_given_PETAB,
       modelPar_K1,
       modelPar_given_K1,
       modelPar_K1L,
       modelPar_given_K1L,
       modelPar_K1LEXP,
       modelPar_given_K1LEXP,
       modelPar_K1W,
       modelPar_given_K1W,
       modelPar_K1WEXP,
       modelPar_given_K1WEXP,
       modelPar_K1WL,
       modelPar_given_K1WL,
       modelPar_K1WLEXP,
       modelPar_given_K1WLEXP,
       modelPar_LK1,
       modelPar_given_LK1,
       modelPar_WK1,
       modelPar_given_WK1,
       modelPar_PK1,
       modelPar_given_PK1,
       modelPar_K2,
       modelPar_given_K2,
       modelPar_K2L,
       modelPar_given_K2L,
       modelPar_K2LEXP,
       modelPar_given_K2LEXP,
       modelPar_K2W,
       modelPar_given_K2W,
       modelPar_K2WEXP,
       modelPar_given_K2WEXP,
       modelPar_K2WL,
       modelPar_given_K2WL,
       modelPar_K2WLEXP,
       modelPar_given_K2WLEXP,
       modelPar_LK2,
       modelPar_given_LK2,
       modelPar_WK2,
       modelPar_given_WK2,
       modelPar_PK2,
       modelPar_given_PK2,
       modelPar_ADOS,
       modelPar_given_ADOS,
       modelPar_BDOS,
       modelPar_given_BDOS,
       modelPar_QM0,
       modelPar_given_QM0,
       modelPar_ETAQM,
       modelPar_given_ETAQM,
       modelPar_CIT,
       modelPar_given_CIT,
       modelPar_LCIT,
       modelPar_given_LCIT,
       modelPar_WCIT,
       modelPar_given_WCIT,
       modelPar_PCIT,
       modelPar_given_PCIT,
       modelPar_NFACTOR,
       modelPar_given_NFACTOR,
       modelPar_NFACTORL,
       modelPar_given_NFACTORL,
       modelPar_NFACTORLEXP,
       modelPar_given_NFACTORLEXP,
       modelPar_NFACTORW,
       modelPar_given_NFACTORW,
       modelPar_NFACTORWEXP,
       modelPar_given_NFACTORWEXP,
       modelPar_NFACTORWL,
       modelPar_given_NFACTORWL,
       modelPar_NFACTORWLEXP,
       modelPar_given_NFACTORWLEXP,
       modelPar_LNFACTOR,
       modelPar_given_LNFACTOR,
       modelPar_WNFACTOR,
       modelPar_given_WNFACTOR,
       modelPar_PNFACTOR,
       modelPar_given_PNFACTOR,
       modelPar_CDSCD,
       modelPar_given_CDSCD,
       modelPar_CDSCDL,
       modelPar_given_CDSCDL,
       modelPar_CDSCDLEXP,
       modelPar_given_CDSCDLEXP,
       modelPar_LCDSCD,
       modelPar_given_LCDSCD,
       modelPar_WCDSCD,
       modelPar_given_WCDSCD,
       modelPar_PCDSCD,
       modelPar_given_PCDSCD,
       modelPar_CDSCDR,
       modelPar_given_CDSCDR,
       modelPar_CDSCDLR,
       modelPar_given_CDSCDLR,
       modelPar_LCDSCDR,
       modelPar_given_LCDSCDR,
       modelPar_WCDSCDR,
       modelPar_given_WCDSCDR,
       modelPar_PCDSCDR,
       modelPar_given_PCDSCDR,
       modelPar_CDSCB,
       modelPar_given_CDSCB,
       modelPar_CDSCBL,
       modelPar_given_CDSCBL,
       modelPar_CDSCBLEXP,
       modelPar_given_CDSCBLEXP,
       modelPar_LCDSCB,
       modelPar_given_LCDSCB,
       modelPar_WCDSCB,
       modelPar_given_WCDSCB,
       modelPar_PCDSCB,
       modelPar_given_PCDSCB,
       modelPar_VSAT,
       modelPar_given_VSAT,
       modelPar_LVSAT,
       modelPar_given_LVSAT,
       modelPar_WVSAT,
       modelPar_given_WVSAT,
       modelPar_PVSAT,
       modelPar_given_PVSAT,
       modelPar_VSATL,
       modelPar_given_VSATL,
       modelPar_VSATLEXP,
       modelPar_given_VSATLEXP,
       modelPar_VSATW,
       modelPar_given_VSATW,
       modelPar_VSATWEXP,
       modelPar_given_VSATWEXP,
       modelPar_VSATWL,
       modelPar_given_VSATWL,
       modelPar_VSATWLEXP,
       modelPar_given_VSATWLEXP,
       modelPar_VSATR,
       modelPar_given_VSATR,
       modelPar_LVSATR,
       modelPar_given_LVSATR,
       modelPar_WVSATR,
       modelPar_given_WVSATR,
       modelPar_PVSATR,
       modelPar_given_PVSATR,
       modelPar_DELTA,
       modelPar_given_DELTA,
       modelPar_LDELTA,
       modelPar_given_LDELTA,
       modelPar_WDELTA,
       modelPar_given_WDELTA,
       modelPar_PDELTA,
       modelPar_given_PDELTA,
       modelPar_DELTAL,
       modelPar_given_DELTAL,
       modelPar_DELTALEXP,
       modelPar_given_DELTALEXP,
       modelPar_VSATCV,
       modelPar_given_VSATCV,
       modelPar_LVSATCV,
       modelPar_given_LVSATCV,
       modelPar_WVSATCV,
       modelPar_given_WVSATCV,
       modelPar_PVSATCV,
       modelPar_given_PVSATCV,
       modelPar_VSATCVL,
       modelPar_given_VSATCVL,
       modelPar_VSATCVLEXP,
       modelPar_given_VSATCVLEXP,
       modelPar_VSATCVW,
       modelPar_given_VSATCVW,
       modelPar_VSATCVWEXP,
       modelPar_given_VSATCVWEXP,
       modelPar_VSATCVWL,
       modelPar_given_VSATCVWL,
       modelPar_VSATCVWLEXP,
       modelPar_given_VSATCVWLEXP,
       modelPar_UP1,
       modelPar_given_UP1,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_UP2,
       modelPar_given_UP2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_MULU0,
       modelPar_given_MULU0,
       modelPar_U0,
       modelPar_given_U0,
       modelPar_U0L,
       modelPar_given_U0L,
       modelPar_U0LEXP,
       modelPar_given_U0LEXP,
       modelPar_LU0,
       modelPar_given_LU0,
       modelPar_WU0,
       modelPar_given_WU0,
       modelPar_PU0,
       modelPar_given_PU0,
       modelPar_U0R,
       modelPar_given_U0R,
       modelPar_LU0R,
       modelPar_given_LU0R,
       modelPar_WU0R,
       modelPar_given_WU0R,
       modelPar_PU0R,
       modelPar_given_PU0R,
       modelPar_ETAMOB,
       modelPar_given_ETAMOB,
       modelPar_UA,
       modelPar_given_UA,
       modelPar_UAL,
       modelPar_given_UAL,
       modelPar_UALEXP,
       modelPar_given_UALEXP,
       modelPar_UAW,
       modelPar_given_UAW,
       modelPar_UAWEXP,
       modelPar_given_UAWEXP,
       modelPar_UAWL,
       modelPar_given_UAWL,
       modelPar_UAWLEXP,
       modelPar_given_UAWLEXP,
       modelPar_LUA,
       modelPar_given_LUA,
       modelPar_WUA,
       modelPar_given_WUA,
       modelPar_PUA,
       modelPar_given_PUA,
       modelPar_UAR,
       modelPar_given_UAR,
       modelPar_LUAR,
       modelPar_given_LUAR,
       modelPar_WUAR,
       modelPar_given_WUAR,
       modelPar_PUAR,
       modelPar_given_PUAR,
       modelPar_EU,
       modelPar_given_EU,
       modelPar_LEU,
       modelPar_given_LEU,
       modelPar_WEU,
       modelPar_given_WEU,
       modelPar_PEU,
       modelPar_given_PEU,
       modelPar_EUL,
       modelPar_given_EUL,
       modelPar_EULEXP,
       modelPar_given_EULEXP,
       modelPar_EUW,
       modelPar_given_EUW,
       modelPar_EUWEXP,
       modelPar_given_EUWEXP,
       modelPar_EUWL,
       modelPar_given_EUWL,
       modelPar_EUWLEXP,
       modelPar_given_EUWLEXP,
       modelPar_UD,
       modelPar_given_UD,
       modelPar_UDL,
       modelPar_given_UDL,
       modelPar_UDLEXP,
       modelPar_given_UDLEXP,
       modelPar_LUD,
       modelPar_given_LUD,
       modelPar_WUD,
       modelPar_given_WUD,
       modelPar_PUD,
       modelPar_given_PUD,
       modelPar_UDR,
       modelPar_given_UDR,
       modelPar_LUDR,
       modelPar_given_LUDR,
       modelPar_WUDR,
       modelPar_given_WUDR,
       modelPar_PUDR,
       modelPar_given_PUDR,
       modelPar_UCS,
       modelPar_given_UCS,
       modelPar_LUCS,
       modelPar_given_LUCS,
       modelPar_WUCS,
       modelPar_given_WUCS,
       modelPar_PUCS,
       modelPar_given_PUCS,
       modelPar_UCSR,
       modelPar_given_UCSR,
       modelPar_LUCSR,
       modelPar_given_LUCSR,
       modelPar_WUCSR,
       modelPar_given_WUCSR,
       modelPar_PUCSR,
       modelPar_given_PUCSR,
       modelPar_UC,
       modelPar_given_UC,
       modelPar_UCL,
       modelPar_given_UCL,
       modelPar_UCLEXP,
       modelPar_given_UCLEXP,
       modelPar_UCW,
       modelPar_given_UCW,
       modelPar_UCWEXP,
       modelPar_given_UCWEXP,
       modelPar_UCWL,
       modelPar_given_UCWL,
       modelPar_UCWLEXP,
       modelPar_given_UCWLEXP,
       modelPar_LUC,
       modelPar_given_LUC,
       modelPar_WUC,
       modelPar_given_WUC,
       modelPar_PUC,
       modelPar_given_PUC,
       modelPar_UCR,
       modelPar_given_UCR,
       modelPar_LUCR,
       modelPar_given_LUCR,
       modelPar_WUCR,
       modelPar_given_WUCR,
       modelPar_PUCR,
       modelPar_given_PUCR,
       modelPar_PCLM,
       modelPar_given_PCLM,
       modelPar_PCLML,
       modelPar_given_PCLML,
       modelPar_PCLMLEXP,
       modelPar_given_PCLMLEXP,
       modelPar_LPCLM,
       modelPar_given_LPCLM,
       modelPar_WPCLM,
       modelPar_given_WPCLM,
       modelPar_PPCLM,
       modelPar_given_PPCLM,
       modelPar_PCLMR,
       modelPar_given_PCLMR,
       modelPar_LPCLMR,
       modelPar_given_LPCLMR,
       modelPar_WPCLMR,
       modelPar_given_WPCLMR,
       modelPar_PPCLMR,
       modelPar_given_PPCLMR,
       modelPar_PCLMG,
       modelPar_given_PCLMG,
       modelPar_PCLMCV,
       modelPar_given_PCLMCV,
       modelPar_PCLMCVL,
       modelPar_given_PCLMCVL,
       modelPar_PCLMCVLEXP,
       modelPar_given_PCLMCVLEXP,
       modelPar_LPCLMCV,
       modelPar_given_LPCLMCV,
       modelPar_WPCLMCV,
       modelPar_given_WPCLMCV,
       modelPar_PPCLMCV,
       modelPar_given_PPCLMCV,
       modelPar_PSCBE1,
       modelPar_given_PSCBE1,
       modelPar_LPSCBE1,
       modelPar_given_LPSCBE1,
       modelPar_WPSCBE1,
       modelPar_given_WPSCBE1,
       modelPar_PPSCBE1,
       modelPar_given_PPSCBE1,
       modelPar_PSCBE2,
       modelPar_given_PSCBE2,
       modelPar_LPSCBE2,
       modelPar_given_LPSCBE2,
       modelPar_WPSCBE2,
       modelPar_given_WPSCBE2,
       modelPar_PPSCBE2,
       modelPar_given_PPSCBE2,
       modelPar_PDITS,
       modelPar_given_PDITS,
       modelPar_LPDITS,
       modelPar_given_LPDITS,
       modelPar_WPDITS,
       modelPar_given_WPDITS,
       modelPar_PPDITS,
       modelPar_given_PPDITS,
       modelPar_PDITSL,
       modelPar_given_PDITSL,
       modelPar_PDITSD,
       modelPar_given_PDITSD,
       modelPar_LPDITSD,
       modelPar_given_LPDITSD,
       modelPar_WPDITSD,
       modelPar_given_WPDITSD,
       modelPar_PPDITSD,
       modelPar_given_PPDITSD,
       modelPar_RSH,
       modelPar_given_RSH,
       modelPar_PRWG,
       modelPar_given_PRWG,
       modelPar_LPRWG,
       modelPar_given_LPRWG,
       modelPar_WPRWG,
       modelPar_given_WPRWG,
       modelPar_PPRWG,
       modelPar_given_PPRWG,
       modelPar_PRWB,
       modelPar_given_PRWB,
       modelPar_LPRWB,
       modelPar_given_LPRWB,
       modelPar_WPRWB,
       modelPar_given_WPRWB,
       modelPar_PPRWB,
       modelPar_given_PPRWB,
       modelPar_PRWBL,
       modelPar_given_PRWBL,
       modelPar_PRWBLEXP,
       modelPar_given_PRWBLEXP,
       modelPar_WR,
       modelPar_given_WR,
       modelPar_LWR,
       modelPar_given_LWR,
       modelPar_WWR,
       modelPar_given_WWR,
       modelPar_PWR,
       modelPar_given_PWR,
       modelPar_RSWMIN,
       modelPar_given_RSWMIN,
       modelPar_LRSWMIN,
       modelPar_given_LRSWMIN,
       modelPar_WRSWMIN,
       modelPar_given_WRSWMIN,
       modelPar_PRSWMIN,
       modelPar_given_PRSWMIN,
       modelPar_RSW,
       modelPar_given_RSW,
       modelPar_LRSW,
       modelPar_given_LRSW,
       modelPar_WRSW,
       modelPar_given_WRSW,
       modelPar_PRSW,
       modelPar_given_PRSW,
       modelPar_RSWL,
       modelPar_given_RSWL,
       modelPar_RSWLEXP,
       modelPar_given_RSWLEXP,
       modelPar_RDWMIN,
       modelPar_given_RDWMIN,
       modelPar_LRDWMIN,
       modelPar_given_LRDWMIN,
       modelPar_WRDWMIN,
       modelPar_given_WRDWMIN,
       modelPar_PRDWMIN,
       modelPar_given_PRDWMIN,
       modelPar_RDW,
       modelPar_given_RDW,
       modelPar_LRDW,
       modelPar_given_LRDW,
       modelPar_WRDW,
       modelPar_given_WRDW,
       modelPar_PRDW,
       modelPar_given_PRDW,
       modelPar_RDWL,
       modelPar_given_RDWL,
       modelPar_RDWLEXP,
       modelPar_given_RDWLEXP,
       modelPar_RDSWMIN,
       modelPar_given_RDSWMIN,
       modelPar_LRDSWMIN,
       modelPar_given_LRDSWMIN,
       modelPar_WRDSWMIN,
       modelPar_given_WRDSWMIN,
       modelPar_PRDSWMIN,
       modelPar_given_PRDSWMIN,
       modelPar_RDSW,
       modelPar_given_RDSW,
       modelPar_RDSWL,
       modelPar_given_RDSWL,
       modelPar_RDSWLEXP,
       modelPar_given_RDSWLEXP,
       modelPar_LRDSW,
       modelPar_given_LRDSW,
       modelPar_WRDSW,
       modelPar_given_WRDSW,
       modelPar_PRDSW,
       modelPar_given_PRDSW,
       modelPar_PSAT,
       modelPar_given_PSAT,
       modelPar_LPSAT,
       modelPar_given_LPSAT,
       modelPar_WPSAT,
       modelPar_given_WPSAT,
       modelPar_PPSAT,
       modelPar_given_PPSAT,
       modelPar_PSATL,
       modelPar_given_PSATL,
       modelPar_PSATLEXP,
       modelPar_given_PSATLEXP,
       modelPar_PSATB,
       modelPar_given_PSATB,
       modelPar_PSATR,
       modelPar_given_PSATR,
       modelPar_LPSATR,
       modelPar_given_LPSATR,
       modelPar_WPSATR,
       modelPar_given_WPSATR,
       modelPar_PPSATR,
       modelPar_given_PPSATR,
       modelPar_LPSATB,
       modelPar_given_LPSATB,
       modelPar_WPSATB,
       modelPar_given_WPSATB,
       modelPar_PPSATB,
       modelPar_given_PPSATB,
       modelPar_PSATX,
       modelPar_given_PSATX,
       modelPar_PTWG,
       modelPar_given_PTWG,
       modelPar_LPTWG,
       modelPar_given_LPTWG,
       modelPar_WPTWG,
       modelPar_given_WPTWG,
       modelPar_PPTWG,
       modelPar_given_PPTWG,
       modelPar_PTWGL,
       modelPar_given_PTWGL,
       modelPar_PTWGLEXP,
       modelPar_given_PTWGLEXP,
       modelPar_PTWGR,
       modelPar_given_PTWGR,
       modelPar_LPTWGR,
       modelPar_given_LPTWGR,
       modelPar_WPTWGR,
       modelPar_given_WPTWGR,
       modelPar_PPTWGR,
       modelPar_given_PPTWGR,
       modelPar_PTWGLR,
       modelPar_given_PTWGLR,
       modelPar_PTWGLEXPR,
       modelPar_given_PTWGLEXPR,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_LA1,
       modelPar_given_LA1,
       modelPar_WA1,
       modelPar_given_WA1,
       modelPar_PA1,
       modelPar_given_PA1,
       modelPar_A11,
       modelPar_given_A11,
       modelPar_LA11,
       modelPar_given_LA11,
       modelPar_WA11,
       modelPar_given_WA11,
       modelPar_PA11,
       modelPar_given_PA11,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_LA2,
       modelPar_given_LA2,
       modelPar_WA2,
       modelPar_given_WA2,
       modelPar_PA2,
       modelPar_given_PA2,
       modelPar_A21,
       modelPar_given_A21,
       modelPar_LA21,
       modelPar_given_LA21,
       modelPar_WA21,
       modelPar_given_WA21,
       modelPar_PA21,
       modelPar_given_PA21,
       modelPar_PDIBLC,
       modelPar_given_PDIBLC,
       modelPar_PDIBLCL,
       modelPar_given_PDIBLCL,
       modelPar_PDIBLCLEXP,
       modelPar_given_PDIBLCLEXP,
       modelPar_LPDIBLC,
       modelPar_given_LPDIBLC,
       modelPar_WPDIBLC,
       modelPar_given_WPDIBLC,
       modelPar_PPDIBLC,
       modelPar_given_PPDIBLC,
       modelPar_PDIBLCR,
       modelPar_given_PDIBLCR,
       modelPar_PDIBLCLR,
       modelPar_given_PDIBLCLR,
       modelPar_PDIBLCLEXPR,
       modelPar_given_PDIBLCLEXPR,
       modelPar_LPDIBLCR,
       modelPar_given_LPDIBLCR,
       modelPar_WPDIBLCR,
       modelPar_given_WPDIBLCR,
       modelPar_PPDIBLCR,
       modelPar_given_PPDIBLCR,
       modelPar_PDIBLCB,
       modelPar_given_PDIBLCB,
       modelPar_LPDIBLCB,
       modelPar_given_LPDIBLCB,
       modelPar_WPDIBLCB,
       modelPar_given_WPDIBLCB,
       modelPar_PPDIBLCB,
       modelPar_given_PPDIBLCB,
       modelPar_PVAG,
       modelPar_given_PVAG,
       modelPar_LPVAG,
       modelPar_given_LPVAG,
       modelPar_WPVAG,
       modelPar_given_WPVAG,
       modelPar_PPVAG,
       modelPar_given_PPVAG,
       modelPar_FPROUT,
       modelPar_given_FPROUT,
       modelPar_FPROUTL,
       modelPar_given_FPROUTL,
       modelPar_FPROUTLEXP,
       modelPar_given_FPROUTLEXP,
       modelPar_LFPROUT,
       modelPar_given_LFPROUT,
       modelPar_WFPROUT,
       modelPar_given_WFPROUT,
       modelPar_PFPROUT,
       modelPar_given_PFPROUT,
       modelPar_ALPHA0,
       modelPar_given_ALPHA0,
       modelPar_ALPHA0L,
       modelPar_given_ALPHA0L,
       modelPar_ALPHA0LEXP,
       modelPar_given_ALPHA0LEXP,
       modelPar_LALPHA0,
       modelPar_given_LALPHA0,
       modelPar_WALPHA0,
       modelPar_given_WALPHA0,
       modelPar_PALPHA0,
       modelPar_given_PALPHA0,
       modelPar_BETA0,
       modelPar_given_BETA0,
       modelPar_LBETA0,
       modelPar_given_LBETA0,
       modelPar_WBETA0,
       modelPar_given_WBETA0,
       modelPar_PBETA0,
       modelPar_given_PBETA0,
       modelPar_AIGBACC,
       modelPar_given_AIGBACC,
       modelPar_BIGBACC,
       modelPar_given_BIGBACC,
       modelPar_CIGBACC,
       modelPar_given_CIGBACC,
       modelPar_NIGBACC,
       modelPar_given_NIGBACC,
       modelPar_AIGBINV,
       modelPar_given_AIGBINV,
       modelPar_BIGBINV,
       modelPar_given_BIGBINV,
       modelPar_CIGBINV,
       modelPar_given_CIGBINV,
       modelPar_EIGBINV,
       modelPar_given_EIGBINV,
       modelPar_NIGBINV,
       modelPar_given_NIGBINV,
       modelPar_AIGC,
       modelPar_given_AIGC,
       modelPar_BIGC,
       modelPar_given_BIGC,
       modelPar_CIGC,
       modelPar_given_CIGC,
       modelPar_AIGS,
       modelPar_given_AIGS,
       modelPar_BIGS,
       modelPar_given_BIGS,
       modelPar_CIGS,
       modelPar_given_CIGS,
       modelPar_AIGD,
       modelPar_given_AIGD,
       modelPar_BIGD,
       modelPar_given_BIGD,
       modelPar_CIGD,
       modelPar_given_CIGD,
       modelPar_DLCIG,
       modelPar_given_DLCIG,
       modelPar_DLCIGD,
       modelPar_given_DLCIGD,
       modelPar_POXEDGE,
       modelPar_given_POXEDGE,
       modelPar_NTOX,
       modelPar_given_NTOX,
       modelPar_TOXREF,
       modelPar_given_TOXREF,
       modelPar_PIGCD,
       modelPar_given_PIGCD,
       modelPar_AIGCL,
       modelPar_given_AIGCL,
       modelPar_AIGCW,
       modelPar_given_AIGCW,
       modelPar_AIGSL,
       modelPar_given_AIGSL,
       modelPar_AIGSW,
       modelPar_given_AIGSW,
       modelPar_AIGDL,
       modelPar_given_AIGDL,
       modelPar_AIGDW,
       modelPar_given_AIGDW,
       modelPar_PIGCDL,
       modelPar_given_PIGCDL,
       modelPar_LAIGBINV,
       modelPar_given_LAIGBINV,
       modelPar_WAIGBINV,
       modelPar_given_WAIGBINV,
       modelPar_PAIGBINV,
       modelPar_given_PAIGBINV,
       modelPar_LBIGBINV,
       modelPar_given_LBIGBINV,
       modelPar_WBIGBINV,
       modelPar_given_WBIGBINV,
       modelPar_PBIGBINV,
       modelPar_given_PBIGBINV,
       modelPar_LCIGBINV,
       modelPar_given_LCIGBINV,
       modelPar_WCIGBINV,
       modelPar_given_WCIGBINV,
       modelPar_PCIGBINV,
       modelPar_given_PCIGBINV,
       modelPar_LEIGBINV,
       modelPar_given_LEIGBINV,
       modelPar_WEIGBINV,
       modelPar_given_WEIGBINV,
       modelPar_PEIGBINV,
       modelPar_given_PEIGBINV,
       modelPar_LNIGBINV,
       modelPar_given_LNIGBINV,
       modelPar_WNIGBINV,
       modelPar_given_WNIGBINV,
       modelPar_PNIGBINV,
       modelPar_given_PNIGBINV,
       modelPar_LAIGBACC,
       modelPar_given_LAIGBACC,
       modelPar_WAIGBACC,
       modelPar_given_WAIGBACC,
       modelPar_PAIGBACC,
       modelPar_given_PAIGBACC,
       modelPar_LBIGBACC,
       modelPar_given_LBIGBACC,
       modelPar_WBIGBACC,
       modelPar_given_WBIGBACC,
       modelPar_PBIGBACC,
       modelPar_given_PBIGBACC,
       modelPar_LCIGBACC,
       modelPar_given_LCIGBACC,
       modelPar_WCIGBACC,
       modelPar_given_WCIGBACC,
       modelPar_PCIGBACC,
       modelPar_given_PCIGBACC,
       modelPar_LNIGBACC,
       modelPar_given_LNIGBACC,
       modelPar_WNIGBACC,
       modelPar_given_WNIGBACC,
       modelPar_PNIGBACC,
       modelPar_given_PNIGBACC,
       modelPar_LAIGC,
       modelPar_given_LAIGC,
       modelPar_WAIGC,
       modelPar_given_WAIGC,
       modelPar_PAIGC,
       modelPar_given_PAIGC,
       modelPar_LBIGC,
       modelPar_given_LBIGC,
       modelPar_WBIGC,
       modelPar_given_WBIGC,
       modelPar_PBIGC,
       modelPar_given_PBIGC,
       modelPar_LCIGC,
       modelPar_given_LCIGC,
       modelPar_WCIGC,
       modelPar_given_WCIGC,
       modelPar_PCIGC,
       modelPar_given_PCIGC,
       modelPar_LAIGS,
       modelPar_given_LAIGS,
       modelPar_WAIGS,
       modelPar_given_WAIGS,
       modelPar_PAIGS,
       modelPar_given_PAIGS,
       modelPar_LBIGS,
       modelPar_given_LBIGS,
       modelPar_WBIGS,
       modelPar_given_WBIGS,
       modelPar_PBIGS,
       modelPar_given_PBIGS,
       modelPar_LCIGS,
       modelPar_given_LCIGS,
       modelPar_WCIGS,
       modelPar_given_WCIGS,
       modelPar_PCIGS,
       modelPar_given_PCIGS,
       modelPar_LAIGD,
       modelPar_given_LAIGD,
       modelPar_WAIGD,
       modelPar_given_WAIGD,
       modelPar_PAIGD,
       modelPar_given_PAIGD,
       modelPar_LBIGD,
       modelPar_given_LBIGD,
       modelPar_WBIGD,
       modelPar_given_WBIGD,
       modelPar_PBIGD,
       modelPar_given_PBIGD,
       modelPar_LCIGD,
       modelPar_given_LCIGD,
       modelPar_WCIGD,
       modelPar_given_WCIGD,
       modelPar_PCIGD,
       modelPar_given_PCIGD,
       modelPar_LPOXEDGE,
       modelPar_given_LPOXEDGE,
       modelPar_WPOXEDGE,
       modelPar_given_WPOXEDGE,
       modelPar_PPOXEDGE,
       modelPar_given_PPOXEDGE,
       modelPar_LDLCIG,
       modelPar_given_LDLCIG,
       modelPar_WDLCIG,
       modelPar_given_WDLCIG,
       modelPar_PDLCIG,
       modelPar_given_PDLCIG,
       modelPar_LDLCIGD,
       modelPar_given_LDLCIGD,
       modelPar_WDLCIGD,
       modelPar_given_WDLCIGD,
       modelPar_PDLCIGD,
       modelPar_given_PDLCIGD,
       modelPar_LNTOX,
       modelPar_given_LNTOX,
       modelPar_WNTOX,
       modelPar_given_WNTOX,
       modelPar_PNTOX,
       modelPar_given_PNTOX,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_AGIDLL,
       modelPar_given_AGIDLL,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_LAGIDL,
       modelPar_given_LAGIDL,
       modelPar_WAGIDL,
       modelPar_given_WAGIDL,
       modelPar_PAGIDL,
       modelPar_given_PAGIDL,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_LBGIDL,
       modelPar_given_LBGIDL,
       modelPar_WBGIDL,
       modelPar_given_WBGIDL,
       modelPar_PBGIDL,
       modelPar_given_PBGIDL,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_LCGIDL,
       modelPar_given_LCGIDL,
       modelPar_WCGIDL,
       modelPar_given_WCGIDL,
       modelPar_PCGIDL,
       modelPar_given_PCGIDL,
       modelPar_EGIDL,
       modelPar_given_EGIDL,
       modelPar_LEGIDL,
       modelPar_given_LEGIDL,
       modelPar_WEGIDL,
       modelPar_given_WEGIDL,
       modelPar_PEGIDL,
       modelPar_given_PEGIDL,
       modelPar_AGISL,
       modelPar_given_AGISL,
       modelPar_AGISLL,
       modelPar_given_AGISLL,
       modelPar_AGISLW,
       modelPar_given_AGISLW,
       modelPar_LAGISL,
       modelPar_given_LAGISL,
       modelPar_WAGISL,
       modelPar_given_WAGISL,
       modelPar_PAGISL,
       modelPar_given_PAGISL,
       modelPar_BGISL,
       modelPar_given_BGISL,
       modelPar_LBGISL,
       modelPar_given_LBGISL,
       modelPar_WBGISL,
       modelPar_given_WBGISL,
       modelPar_PBGISL,
       modelPar_given_PBGISL,
       modelPar_CGISL,
       modelPar_given_CGISL,
       modelPar_LCGISL,
       modelPar_given_LCGISL,
       modelPar_WCGISL,
       modelPar_given_WCGISL,
       modelPar_PCGISL,
       modelPar_given_PCGISL,
       modelPar_EGISL,
       modelPar_given_EGISL,
       modelPar_LEGISL,
       modelPar_given_LEGISL,
       modelPar_WEGISL,
       modelPar_given_WEGISL,
       modelPar_PEGISL,
       modelPar_given_PEGISL,
       modelPar_CF,
       modelPar_given_CF,
       modelPar_LCF,
       modelPar_given_LCF,
       modelPar_WCF,
       modelPar_given_WCF,
       modelPar_PCF,
       modelPar_given_PCF,
       modelPar_CFRCOEFF,
       modelPar_given_CFRCOEFF,
       modelPar_CGSO,
       modelPar_given_CGSO,
       modelPar_CGDO,
       modelPar_given_CGDO,
       modelPar_CGBO,
       modelPar_given_CGBO,
       modelPar_CGSL,
       modelPar_given_CGSL,
       modelPar_LCGSL,
       modelPar_given_LCGSL,
       modelPar_WCGSL,
       modelPar_given_WCGSL,
       modelPar_PCGSL,
       modelPar_given_PCGSL,
       modelPar_CGDL,
       modelPar_given_CGDL,
       modelPar_LCGDL,
       modelPar_given_LCGDL,
       modelPar_WCGDL,
       modelPar_given_WCGDL,
       modelPar_PCGDL,
       modelPar_given_PCGDL,
       modelPar_CKAPPAS,
       modelPar_given_CKAPPAS,
       modelPar_LCKAPPAS,
       modelPar_given_LCKAPPAS,
       modelPar_WCKAPPAS,
       modelPar_given_WCKAPPAS,
       modelPar_PCKAPPAS,
       modelPar_given_PCKAPPAS,
       modelPar_CKAPPAD,
       modelPar_given_CKAPPAD,
       modelPar_LCKAPPAD,
       modelPar_given_LCKAPPAD,
       modelPar_WCKAPPAD,
       modelPar_given_WCKAPPAD,
       modelPar_PCKAPPAD,
       modelPar_given_PCKAPPAD,
       modelPar_DMCG,
       modelPar_given_DMCG,
       modelPar_DMCI,
       modelPar_given_DMCI,
       modelPar_DMDG,
       modelPar_given_DMDG,
       modelPar_DMCGT,
       modelPar_given_DMCGT,
       modelPar_XGL,
       modelPar_given_XGL,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_CJD,
       modelPar_given_CJD,
       modelPar_CJSWS,
       modelPar_given_CJSWS,
       modelPar_CJSWD,
       modelPar_given_CJSWD,
       modelPar_CJSWGS,
       modelPar_given_CJSWGS,
       modelPar_CJSWGD,
       modelPar_given_CJSWGD,
       modelPar_PBS,
       modelPar_given_PBS,
       modelPar_PBD,
       modelPar_given_PBD,
       modelPar_PBSWS,
       modelPar_given_PBSWS,
       modelPar_PBSWD,
       modelPar_given_PBSWD,
       modelPar_PBSWGS,
       modelPar_given_PBSWGS,
       modelPar_PBSWGD,
       modelPar_given_PBSWGD,
       modelPar_MJS,
       modelPar_given_MJS,
       modelPar_MJD,
       modelPar_given_MJD,
       modelPar_MJSWS,
       modelPar_given_MJSWS,
       modelPar_MJSWD,
       modelPar_given_MJSWD,
       modelPar_MJSWGS,
       modelPar_given_MJSWGS,
       modelPar_MJSWGD,
       modelPar_given_MJSWGD,
       modelPar_JSS,
       modelPar_given_JSS,
       modelPar_JSD,
       modelPar_given_JSD,
       modelPar_JSWS,
       modelPar_given_JSWS,
       modelPar_JSWD,
       modelPar_given_JSWD,
       modelPar_JSWGS,
       modelPar_given_JSWGS,
       modelPar_JSWGD,
       modelPar_given_JSWGD,
       modelPar_NJS,
       modelPar_given_NJS,
       modelPar_NJD,
       modelPar_given_NJD,
       modelPar_IJTHSFWD,
       modelPar_given_IJTHSFWD,
       modelPar_IJTHDFWD,
       modelPar_given_IJTHDFWD,
       modelPar_IJTHSREV,
       modelPar_given_IJTHSREV,
       modelPar_IJTHDREV,
       modelPar_given_IJTHDREV,
       modelPar_BVS,
       modelPar_given_BVS,
       modelPar_BVD,
       modelPar_given_BVD,
       modelPar_XJBVS,
       modelPar_given_XJBVS,
       modelPar_XJBVD,
       modelPar_given_XJBVD,
       modelPar_JTSS,
       modelPar_given_JTSS,
       modelPar_JTSD,
       modelPar_given_JTSD,
       modelPar_JTSSWS,
       modelPar_given_JTSSWS,
       modelPar_JTSSWD,
       modelPar_given_JTSSWD,
       modelPar_JTSSWGS,
       modelPar_given_JTSSWGS,
       modelPar_JTSSWGD,
       modelPar_given_JTSSWGD,
       modelPar_JTWEFF,
       modelPar_given_JTWEFF,
       modelPar_NJTS,
       modelPar_given_NJTS,
       modelPar_NJTSD,
       modelPar_given_NJTSD,
       modelPar_NJTSSW,
       modelPar_given_NJTSSW,
       modelPar_NJTSSWD,
       modelPar_given_NJTSSWD,
       modelPar_NJTSSWG,
       modelPar_given_NJTSSWG,
       modelPar_NJTSSWGD,
       modelPar_given_NJTSSWGD,
       modelPar_VTSS,
       modelPar_given_VTSS,
       modelPar_VTSD,
       modelPar_given_VTSD,
       modelPar_VTSSWS,
       modelPar_given_VTSSWS,
       modelPar_VTSSWD,
       modelPar_given_VTSSWD,
       modelPar_VTSSWGS,
       modelPar_given_VTSSWGS,
       modelPar_VTSSWGD,
       modelPar_given_VTSSWGD,
       modelPar_XRCRG1,
       modelPar_given_XRCRG1,
       modelPar_XRCRG2,
       modelPar_given_XRCRG2,
       modelPar_GBMIN,
       modelPar_given_GBMIN,
       modelPar_RBPS0,
       modelPar_given_RBPS0,
       modelPar_RBPSL,
       modelPar_given_RBPSL,
       modelPar_RBPSW,
       modelPar_given_RBPSW,
       modelPar_RBPSNF,
       modelPar_given_RBPSNF,
       modelPar_RBPD0,
       modelPar_given_RBPD0,
       modelPar_RBPDL,
       modelPar_given_RBPDL,
       modelPar_RBPDW,
       modelPar_given_RBPDW,
       modelPar_RBPDNF,
       modelPar_given_RBPDNF,
       modelPar_RBPBX0,
       modelPar_given_RBPBX0,
       modelPar_RBPBXL,
       modelPar_given_RBPBXL,
       modelPar_RBPBXW,
       modelPar_given_RBPBXW,
       modelPar_RBPBXNF,
       modelPar_given_RBPBXNF,
       modelPar_RBPBY0,
       modelPar_given_RBPBY0,
       modelPar_RBPBYL,
       modelPar_given_RBPBYL,
       modelPar_RBPBYW,
       modelPar_given_RBPBYW,
       modelPar_RBPBYNF,
       modelPar_given_RBPBYNF,
       modelPar_RBSBX0,
       modelPar_given_RBSBX0,
       modelPar_RBSBY0,
       modelPar_given_RBSBY0,
       modelPar_RBDBX0,
       modelPar_given_RBDBX0,
       modelPar_RBDBY0,
       modelPar_given_RBDBY0,
       modelPar_RBSDBXL,
       modelPar_given_RBSDBXL,
       modelPar_RBSDBXW,
       modelPar_given_RBSDBXW,
       modelPar_RBSDBXNF,
       modelPar_given_RBSDBXNF,
       modelPar_RBSDBYL,
       modelPar_given_RBSDBYL,
       modelPar_RBSDBYW,
       modelPar_given_RBSDBYW,
       modelPar_RBSDBYNF,
       modelPar_given_RBSDBYNF,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_EM,
       modelPar_given_EM,
       modelPar_NOIA,
       modelPar_given_NOIA,
       modelPar_NOIB,
       modelPar_given_NOIB,
       modelPar_NOIC,
       modelPar_given_NOIC,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_NTNOI,
       modelPar_given_NTNOI,
       modelPar_RNOIA,
       modelPar_given_RNOIA,
       modelPar_RNOIB,
       modelPar_given_RNOIB,
       modelPar_RNOIC,
       modelPar_given_RNOIC,
       modelPar_TNOIA,
       modelPar_given_TNOIA,
       modelPar_TNOIB,
       modelPar_given_TNOIB,
       modelPar_TNOIC,
       modelPar_given_TNOIC,
       modelPar_DLBIN,
       modelPar_given_DLBIN,
       modelPar_DWBIN,
       modelPar_given_DWBIN,
       modelPar_TNOM,
       modelPar_given_TNOM,
       modelPar_DTEMP,
       modelPar_given_DTEMP,
       modelPar_TBGASUB,
       modelPar_given_TBGASUB,
       modelPar_TBGBSUB,
       modelPar_given_TBGBSUB,
       modelPar_TNFACTOR,
       modelPar_given_TNFACTOR,
       modelPar_UTE,
       modelPar_given_UTE,
       modelPar_LUTE,
       modelPar_given_LUTE,
       modelPar_WUTE,
       modelPar_given_WUTE,
       modelPar_PUTE,
       modelPar_given_PUTE,
       modelPar_UTEL,
       modelPar_given_UTEL,
       modelPar_UA1,
       modelPar_given_UA1,
       modelPar_LUA1,
       modelPar_given_LUA1,
       modelPar_WUA1,
       modelPar_given_WUA1,
       modelPar_PUA1,
       modelPar_given_PUA1,
       modelPar_UA1L,
       modelPar_given_UA1L,
       modelPar_UC1,
       modelPar_given_UC1,
       modelPar_LUC1,
       modelPar_given_LUC1,
       modelPar_WUC1,
       modelPar_given_WUC1,
       modelPar_PUC1,
       modelPar_given_PUC1,
       modelPar_UD1,
       modelPar_given_UD1,
       modelPar_LUD1,
       modelPar_given_LUD1,
       modelPar_WUD1,
       modelPar_given_WUD1,
       modelPar_PUD1,
       modelPar_given_PUD1,
       modelPar_UD1L,
       modelPar_given_UD1L,
       modelPar_UCSTE,
       modelPar_given_UCSTE,
       modelPar_LUCSTE,
       modelPar_given_LUCSTE,
       modelPar_WUCSTE,
       modelPar_given_WUCSTE,
       modelPar_PUCSTE,
       modelPar_given_PUCSTE,
       modelPar_TETA0,
       modelPar_given_TETA0,
       modelPar_PRT,
       modelPar_given_PRT,
       modelPar_LPRT,
       modelPar_given_LPRT,
       modelPar_WPRT,
       modelPar_given_WPRT,
       modelPar_PPRT,
       modelPar_given_PPRT,
       modelPar_AT,
       modelPar_given_AT,
       modelPar_LAT,
       modelPar_given_LAT,
       modelPar_WAT,
       modelPar_given_WAT,
       modelPar_PAT,
       modelPar_given_PAT,
       modelPar_ATL,
       modelPar_given_ATL,
       modelPar_TDELTA,
       modelPar_given_TDELTA,
       modelPar_PTWGT,
       modelPar_given_PTWGT,
       modelPar_LPTWGT,
       modelPar_given_LPTWGT,
       modelPar_WPTWGT,
       modelPar_given_WPTWGT,
       modelPar_PPTWGT,
       modelPar_given_PPTWGT,
       modelPar_PTWGTL,
       modelPar_given_PTWGTL,
       modelPar_KT1,
       modelPar_given_KT1,
       modelPar_KT1EXP,
       modelPar_given_KT1EXP,
       modelPar_KT1L,
       modelPar_given_KT1L,
       modelPar_LKT1,
       modelPar_given_LKT1,
       modelPar_WKT1,
       modelPar_given_WKT1,
       modelPar_PKT1,
       modelPar_given_PKT1,
       modelPar_KT2,
       modelPar_given_KT2,
       modelPar_LKT2,
       modelPar_given_LKT2,
       modelPar_WKT2,
       modelPar_given_WKT2,
       modelPar_PKT2,
       modelPar_given_PKT2,
       modelPar_IIT,
       modelPar_given_IIT,
       modelPar_LIIT,
       modelPar_given_LIIT,
       modelPar_WIIT,
       modelPar_given_WIIT,
       modelPar_PIIT,
       modelPar_given_PIIT,
       modelPar_IGT,
       modelPar_given_IGT,
       modelPar_LIGT,
       modelPar_given_LIGT,
       modelPar_WIGT,
       modelPar_given_WIGT,
       modelPar_PIGT,
       modelPar_given_PIGT,
       modelPar_TGIDL,
       modelPar_given_TGIDL,
       modelPar_LTGIDL,
       modelPar_given_LTGIDL,
       modelPar_WTGIDL,
       modelPar_given_WTGIDL,
       modelPar_PTGIDL,
       modelPar_given_PTGIDL,
       modelPar_TCJ,
       modelPar_given_TCJ,
       modelPar_TCJSW,
       modelPar_given_TCJSW,
       modelPar_TCJSWG,
       modelPar_given_TCJSWG,
       modelPar_TPB,
       modelPar_given_TPB,
       modelPar_TPBSW,
       modelPar_given_TPBSW,
       modelPar_TPBSWG,
       modelPar_given_TPBSWG,
       modelPar_XTIS,
       modelPar_given_XTIS,
       modelPar_XTID,
       modelPar_given_XTID,
       modelPar_XTSS,
       modelPar_given_XTSS,
       modelPar_XTSD,
       modelPar_given_XTSD,
       modelPar_XTSSWS,
       modelPar_given_XTSSWS,
       modelPar_XTSSWD,
       modelPar_given_XTSSWD,
       modelPar_XTSSWGS,
       modelPar_given_XTSSWGS,
       modelPar_XTSSWGD,
       modelPar_given_XTSSWGD,
       modelPar_TNJTS,
       modelPar_given_TNJTS,
       modelPar_TNJTSD,
       modelPar_given_TNJTSD,
       modelPar_TNJTSSW,
       modelPar_given_TNJTSSW,
       modelPar_TNJTSSWD,
       modelPar_given_TNJTSSWD,
       modelPar_TNJTSSWG,
       modelPar_given_TNJTSSWG,
       modelPar_TNJTSSWGD,
       modelPar_given_TNJTSSWGD,
       modelPar_RTH0,
       modelPar_given_RTH0,
       modelPar_CTH0,
       modelPar_given_CTH0,
       modelPar_WTH0,
       modelPar_given_WTH0,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KU0,
       modelPar_given_KU0,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKU0,
       modelPar_given_TKU0,
       modelPar_LKU0,
       modelPar_given_LKU0,
       modelPar_WKU0,
       modelPar_given_WKU0,
       modelPar_PKU0,
       modelPar_given_PKU0,
       modelPar_LLODKU0,
       modelPar_given_LLODKU0,
       modelPar_WLODKU0,
       modelPar_given_WLODKU0,
       modelPar_KVTH0,
       modelPar_given_KVTH0,
       modelPar_LKVTH0,
       modelPar_given_LKVTH0,
       modelPar_WKVTH0,
       modelPar_given_WKVTH0,
       modelPar_PKVTH0,
       modelPar_given_PKVTH0,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STK2,
       modelPar_given_STK2,
       modelPar_LODK2,
       modelPar_given_LODK2,
       modelPar_STETA0,
       modelPar_given_STETA0,
       modelPar_LODETA0,
       modelPar_given_LODETA0,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_KVTH0WE,
       modelPar_given_KVTH0WE,
       modelPar_LKVTH0WE,
       modelPar_given_LKVTH0WE,
       modelPar_WKVTH0WE,
       modelPar_given_WKVTH0WE,
       modelPar_PKVTH0WE,
       modelPar_given_PKVTH0WE,
       modelPar_K2WE,
       modelPar_given_K2WE,
       modelPar_LK2WE,
       modelPar_given_LK2WE,
       modelPar_WK2WE,
       modelPar_given_WK2WE,
       modelPar_PK2WE,
       modelPar_given_PK2WE,
       modelPar_KU0WE,
       modelPar_given_KU0WE,
       modelPar_LKU0WE,
       modelPar_given_LKU0WE,
       modelPar_WKU0WE,
       modelPar_given_WKU0WE,
       modelPar_PKU0WE,
       modelPar_given_PKU0WE,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEDGE,
       modelPar_given_WEDGE,
       modelPar_DGAMMAEDGE,
       modelPar_given_DGAMMAEDGE,
       modelPar_DGAMMAEDGEL,
       modelPar_given_DGAMMAEDGEL,
       modelPar_DGAMMAEDGELEXP,
       modelPar_given_DGAMMAEDGELEXP,
       modelPar_DVTEDGE,
       modelPar_given_DVTEDGE,
       modelPar_NFACTOREDGE,
       modelPar_given_NFACTOREDGE,
       modelPar_CITEDGE,
       modelPar_given_CITEDGE,
       modelPar_CDSCDEDGE,
       modelPar_given_CDSCDEDGE,
       modelPar_CDSCBEDGE,
       modelPar_given_CDSCBEDGE,
       modelPar_ETA0EDGE,
       modelPar_given_ETA0EDGE,
       modelPar_ETABEDGE,
       modelPar_given_ETABEDGE,
       modelPar_KT1EDGE,
       modelPar_given_KT1EDGE,
       modelPar_KT1LEDGE,
       modelPar_given_KT1LEDGE,
       modelPar_KT2EDGE,
       modelPar_given_KT2EDGE,
       modelPar_KT1EXPEDGE,
       modelPar_given_KT1EXPEDGE,
       modelPar_TNFACTOREDGE,
       modelPar_given_TNFACTOREDGE,
       modelPar_TETA0EDGE,
       modelPar_given_TETA0EDGE,
       modelPar_DVT0EDGE,
       modelPar_given_DVT0EDGE,
       modelPar_DVT1EDGE,
       modelPar_given_DVT1EDGE,
       modelPar_DVT2EDGE,
       modelPar_given_DVT2EDGE,
       // non-reals (including hidden)
       modelPar_NGCON,
       modelPar_given_NGCON,
       modelPar_RGATEMOD,
       modelPar_given_RGATEMOD,
       modelPar_RBODYMOD,
       modelPar_given_RBODYMOD,
       modelPar_GEOMOD,
       modelPar_given_GEOMOD,
       modelPar_RGEOMOD,
       modelPar_given_RGEOMOD,
       modelPar_SCA,
       modelPar_given_SCA,
       modelPar_SCB,
       modelPar_given_SCB,
       modelPar_SCC,
       modelPar_given_SCC,
       modelPar_SC,
       modelPar_given_SC,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_CVMOD,
       modelPar_given_CVMOD,
       modelPar_COVMOD,
       modelPar_given_COVMOD,
       modelPar_RDSMOD,
       modelPar_given_RDSMOD,
       modelPar_WPEMOD,
       modelPar_given_WPEMOD,
       modelPar_ASYMMOD,
       modelPar_given_ASYMMOD,
       modelPar_GIDLMOD,
       modelPar_given_GIDLMOD,
       modelPar_IGCMOD,
       modelPar_given_IGCMOD,
       modelPar_IGBMOD,
       modelPar_given_IGBMOD,
       modelPar_TNOIMOD,
       modelPar_given_TNOIMOD,
       modelPar_SHMOD,
       modelPar_given_SHMOD,
       modelPar_MOBSCALE,
       modelPar_given_MOBSCALE,
       modelPar_PERMOD,
       modelPar_given_PERMOD,
       modelPar_BINUNIT,
       modelPar_given_BINUNIT,
       modelPar_EDGEFET,
       modelPar_given_EDGEFET,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);


    // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d+inst*(14+0)] += staticContributions[in.admsNodeID_d].dx(0);
    dqdp[in.admsNodeID_d+inst*(14+0)] += dynamicContributions[in.admsNodeID_d].dx(0);
    Findices[in.admsNodeID_d+inst*(14+0)] = in.li_d;
    Qindices[in.admsNodeID_d+inst*(14+0)] = in.li_d;
    dfdp[in.admsNodeID_g+inst*(14+0)] += staticContributions[in.admsNodeID_g].dx(0);
    dqdp[in.admsNodeID_g+inst*(14+0)] += dynamicContributions[in.admsNodeID_g].dx(0);
    Findices[in.admsNodeID_g+inst*(14+0)] = in.li_g;
    Qindices[in.admsNodeID_g+inst*(14+0)] = in.li_g;
    dfdp[in.admsNodeID_s+inst*(14+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(14+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(14+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(14+0)] = in.li_s;
    dfdp[in.admsNodeID_b+inst*(14+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(14+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(14+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(14+0)] = in.li_b;
    dfdp[in.admsNodeID_di+inst*(14+0)] += staticContributions[in.admsNodeID_di].dx(0);
    dqdp[in.admsNodeID_di+inst*(14+0)] += dynamicContributions[in.admsNodeID_di].dx(0);
    Findices[in.admsNodeID_di+inst*(14+0)] = in.li_di;
    Qindices[in.admsNodeID_di+inst*(14+0)] = in.li_di;
    dfdp[in.admsNodeID_si+inst*(14+0)] += staticContributions[in.admsNodeID_si].dx(0);
    dqdp[in.admsNodeID_si+inst*(14+0)] += dynamicContributions[in.admsNodeID_si].dx(0);
    Findices[in.admsNodeID_si+inst*(14+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(14+0)] = in.li_si;
    dfdp[in.admsNodeID_gi+inst*(14+0)] += staticContributions[in.admsNodeID_gi].dx(0);
    dqdp[in.admsNodeID_gi+inst*(14+0)] += dynamicContributions[in.admsNodeID_gi].dx(0);
    Findices[in.admsNodeID_gi+inst*(14+0)] = in.li_gi;
    Qindices[in.admsNodeID_gi+inst*(14+0)] = in.li_gi;
    dfdp[in.admsNodeID_gm+inst*(14+0)] += staticContributions[in.admsNodeID_gm].dx(0);
    dqdp[in.admsNodeID_gm+inst*(14+0)] += dynamicContributions[in.admsNodeID_gm].dx(0);
    Findices[in.admsNodeID_gm+inst*(14+0)] = in.li_gm;
    Qindices[in.admsNodeID_gm+inst*(14+0)] = in.li_gm;
    dfdp[in.admsNodeID_bi+inst*(14+0)] += staticContributions[in.admsNodeID_bi].dx(0);
    dqdp[in.admsNodeID_bi+inst*(14+0)] += dynamicContributions[in.admsNodeID_bi].dx(0);
    Findices[in.admsNodeID_bi+inst*(14+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(14+0)] = in.li_bi;
    dfdp[in.admsNodeID_sbulk+inst*(14+0)] += staticContributions[in.admsNodeID_sbulk].dx(0);
    dqdp[in.admsNodeID_sbulk+inst*(14+0)] += dynamicContributions[in.admsNodeID_sbulk].dx(0);
    Findices[in.admsNodeID_sbulk+inst*(14+0)] = in.li_sbulk;
    Qindices[in.admsNodeID_sbulk+inst*(14+0)] = in.li_sbulk;
    dfdp[in.admsNodeID_dbulk+inst*(14+0)] += staticContributions[in.admsNodeID_dbulk].dx(0);
    dqdp[in.admsNodeID_dbulk+inst*(14+0)] += dynamicContributions[in.admsNodeID_dbulk].dx(0);
    Findices[in.admsNodeID_dbulk+inst*(14+0)] = in.li_dbulk;
    Qindices[in.admsNodeID_dbulk+inst*(14+0)] = in.li_dbulk;
    dfdp[in.admsNodeID_N1+inst*(14+0)] += staticContributions[in.admsNodeID_N1].dx(0);
    dqdp[in.admsNodeID_N1+inst*(14+0)] += dynamicContributions[in.admsNodeID_N1].dx(0);
    Findices[in.admsNodeID_N1+inst*(14+0)] = in.li_N1;
    Qindices[in.admsNodeID_N1+inst*(14+0)] = in.li_N1;
    dfdp[in.admsNodeID_N2+inst*(14+0)] += staticContributions[in.admsNodeID_N2].dx(0);
    dqdp[in.admsNodeID_N2+inst*(14+0)] += dynamicContributions[in.admsNodeID_N2].dx(0);
    Findices[in.admsNodeID_N2+inst*(14+0)] = in.li_N2;
    Qindices[in.admsNodeID_N2+inst*(14+0)] = in.li_N2;
    dfdp[in.admsNodeID_t+inst*(14+0)] += staticContributions[in.admsNodeID_t].dx(0);
    dqdp[in.admsNodeID_t+inst*(14+0)] += dynamicContributions[in.admsNodeID_t].dx(0);
    Findices[in.admsNodeID_t+inst*(14+0)] = in.li_t;
    Qindices[in.admsNodeID_t+inst*(14+0)] = in.li_t;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbsim6
} // namespace Device
} // namespace Xyce
