
//-------------------------------------------------------------------------
//   Copyright 2002-2019 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file mvsg_cmc_1.1.0.va with ADMS
//                  interface for Xyce 6.11.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Tue, 02 Apr 2019 10:14:13
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSmvsg_cmc.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>


#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

#include <algorithm>

namespace Xyce {
namespace Device {
namespace ADMSmvsg_cmc {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_d;
const int Instance::admsNodeID_g;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_di;
const int Instance::admsNodeID_gi;
const int Instance::admsNodeID_si;
const int Instance::admsNodeID_fp1;
const int Instance::admsNodeID_fp2;
const int Instance::admsNodeID_fp3;
const int Instance::admsNodeID_fp4;
const int Instance::admsNodeID_drc;
const int Instance::admsNodeID_src;
const int Instance::admsNodeID_tr;
const int Instance::admsNodeID_tr1;
const int Instance::admsNodeID_xt1;
const int Instance::admsNodeID_xt2;
const int Instance::admsNodeID_dt;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSmvsg_cmc::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSmvsg_cmc::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("W", static_cast<double>(180.0e-6), &ADMSmvsg_cmc::Instance::w)
    .setUnit(U_METER)
    .setDescription("Width per Finger")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("L", static_cast<double>(250.0e-9), &ADMSmvsg_cmc::Instance::l)
    .setUnit(U_METER)
    .setDescription("Effective gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGF", static_cast<int>(2), &ADMSmvsg_cmc::Instance::ngf)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of Fingers");
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSmvsg_cmc::Instance::dtemp)
    .setUnit(U_DEGK)
    .setDescription("Device temperature offset from ambient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSmvsg_cmc::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSmvsg_cmc::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("VERSION", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::version)
    .setUnit(U_UNKNOWN)
    .setDescription("Version number")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSmvsg_cmc::Model::tnom)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference temperature for the model")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>(1), &ADMSmvsg_cmc::Model::type)
    .setUnit(U_UNKNOWN)
    .setDescription("nFET=1 pFET=-1");
  p.addPar("CG", static_cast<double>(4.00e-03), &ADMSmvsg_cmc::Model::cg)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COFSM", static_cast<double>(1.0e-9), &ADMSmvsg_cmc::Model::cofsm)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Source outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COFDM", static_cast<double>(1.0e-10), &ADMSmvsg_cmc::Model::cofdm)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Drain outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COFDSM", static_cast<double>(1.0e-10), &ADMSmvsg_cmc::Model::cofdsm)
    .setUnit(U_UNKNOWN)
    .setDescription("Source - Drain outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COFDSUBM", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cofdsubm)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub - Drain outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COFSSUBM", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cofssubm)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub - Source outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COFGSUBM", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cofgsubm)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub - Gate outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSH", static_cast<double>(150.0), &ADMSmvsg_cmc::Model::rsh)
    .setUnit(U_UNKNOWN)
    .setDescription("2-DEG Sheet Resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCS", static_cast<double>(800e-6), &ADMSmvsg_cmc::Model::rcs)
    .setUnit(U_UNKNOWN)
    .setDescription("Source contact resistance * Width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCD", static_cast<double>(800e-6), &ADMSmvsg_cmc::Model::rcd)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain contact resistance * Width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0", static_cast<double>(3.0e5), &ADMSmvsg_cmc::Model::vx0)
    .setUnit(U_UNKNOWN)
    .setDescription("Source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0", static_cast<double>(0.135), &ADMSmvsg_cmc::Model::mu0)
    .setUnit(U_UNKNOWN)
    .setDescription("Low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETA", static_cast<double>(1.50), &ADMSmvsg_cmc::Model::beta)
    .setUnit(U_UNKNOWN)
    .setDescription("Linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTO", static_cast<double>((-2.72)), &ADMSmvsg_cmc::Model::vto)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SS", static_cast<double>(0.120), &ADMSmvsg_cmc::Model::ss)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1", static_cast<double>(16e-3), &ADMSmvsg_cmc::Model::delta1)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL Coefficient 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta2)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL Coefficient 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DIBSAT", static_cast<double>(10.0), &ADMSmvsg_cmc::Model::dibsat)
    .setUnit(U_VOLT)
    .setDescription("DIBL saturation Voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ND", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::nd)
    .setUnit(U_UNKNOWN)
    .setDescription("Punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHA", static_cast<double>(3.5), &ADMSmvsg_cmc::Model::alpha)
    .setUnit(U_UNKNOWN)
    .setDescription("Weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAMBDA", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lambda)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETA", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vtheta)
    .setUnit(U_UNKNOWN)
    .setDescription("Scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETA", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mtheta)
    .setUnit(U_UNKNOWN)
    .setDescription("Scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VZETA", static_cast<double>(150e3), &ADMSmvsg_cmc::Model::vzeta)
    .setUnit(U_DEGKM1)
    .setDescription("vx0 dependence on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTZETA", static_cast<double>((-0.4e-3)), &ADMSmvsg_cmc::Model::vtzeta)
    .setUnit(U_VKM1)
    .setDescription("vto dependence on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSILON", static_cast<double>(2.3), &ADMSmvsg_cmc::Model::epsilon)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility dependence on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCT1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::rct1)
    .setUnit(U_DEGKM1)
    .setDescription("Linear Rsh and Rc temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCT2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::rct2)
    .setUnit(U_UNKNOWN)
    .setDescription("Quadratic Rsh and Rc temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGRES", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagres)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter for resistor: resistor is chosen if flagres=1 or implicit transitor is chosen if flagres=0");
  p.addPar("LGS", static_cast<double>(3.0e-6), &ADMSmvsg_cmc::Model::lgs)
    .setUnit(U_METER)
    .setDescription("Source access region (SAR) length parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTORS", static_cast<double>((-650)), &ADMSmvsg_cmc::Model::vtors)
    .setUnit(U_VOLT)
    .setDescription("SAR threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGRS", static_cast<double>(5.0e-3), &ADMSmvsg_cmc::Model::cgrs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0RS", static_cast<double>(100e3), &ADMSmvsg_cmc::Model::vx0rs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0RS", static_cast<double>(100e-3), &ADMSmvsg_cmc::Model::mu0rs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETARS", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1RS", static_cast<double>(100e-3), &ADMSmvsg_cmc::Model::delta1rs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SRS", static_cast<double>(0.100), &ADMSmvsg_cmc::Model::srs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDRS", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndrs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETARS", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETARS", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHARS", static_cast<double>(3.5), &ADMSmvsg_cmc::Model::alphars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LGD", static_cast<double>(4.85e-6), &ADMSmvsg_cmc::Model::lgd)
    .setUnit(U_METER)
    .setDescription("Drain access region (DAR) length parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTORD", static_cast<double>((-650)), &ADMSmvsg_cmc::Model::vtord)
    .setUnit(U_VOLT)
    .setDescription("DAR threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGRD", static_cast<double>(4.3e-3), &ADMSmvsg_cmc::Model::cgrd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0RD", static_cast<double>(100e3), &ADMSmvsg_cmc::Model::vx0rd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0RD", static_cast<double>(100e-3), &ADMSmvsg_cmc::Model::mu0rd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETARD", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1RD", static_cast<double>(0.35), &ADMSmvsg_cmc::Model::delta1rd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SRD", static_cast<double>(0.3), &ADMSmvsg_cmc::Model::srd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDRD", static_cast<double>(3.8), &ADMSmvsg_cmc::Model::ndrd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETARD", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETARD", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHARD", static_cast<double>(3.5), &ADMSmvsg_cmc::Model::alphard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP1", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp1)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTOFP1", static_cast<double>((-44.5)), &ADMSmvsg_cmc::Model::vtofp1)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGFP1", static_cast<double>(2.0e-4), &ADMSmvsg_cmc::Model::cgfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP1S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp1s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP1S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp1s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CCFP1", static_cast<double>(0.9e-10), &ADMSmvsg_cmc::Model::ccfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0FP1", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0FP1", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAFP1", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1FP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFP1", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETAFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETAFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAFP1", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP2", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp2)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTOFP2", static_cast<double>((-74.5)), &ADMSmvsg_cmc::Model::vtofp2)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGFP2", static_cast<double>(1.0e-4), &ADMSmvsg_cmc::Model::cgfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP2S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp2s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP2S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp2s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CCFP2", static_cast<double>(0.3e-10), &ADMSmvsg_cmc::Model::ccfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0FP2", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0FP2", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAFP2", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1FP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFP2", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETAFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETAFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAFP2", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP3", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp3)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTOFP3", static_cast<double>((-44.5)), &ADMSmvsg_cmc::Model::vtofp3)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGFP3", static_cast<double>(2.0e-4), &ADMSmvsg_cmc::Model::cgfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP3S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp3s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP3S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp3s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CCFP3", static_cast<double>(0.9e-10), &ADMSmvsg_cmc::Model::ccfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0FP3", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0FP3", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAFP3", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1FP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFP3", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETAFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETAFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAFP3", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP4", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp4)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTOFP4", static_cast<double>((-44.5)), &ADMSmvsg_cmc::Model::vtofp4)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGFP4", static_cast<double>(2.0e-4), &ADMSmvsg_cmc::Model::cgfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLAGFP4S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp4s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP4S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp4s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CCFP4", static_cast<double>(0.9e-10), &ADMSmvsg_cmc::Model::ccfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VX0FP4", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MU0FP4", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETAFP4", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELTA1FP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFP4", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NDFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTHETAFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTHETAFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAFP4", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGMOD", static_cast<int>(1), &ADMSmvsg_cmc::Model::igmod)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter for gate leakage 0=off, 1=on");
  p.addPar("RGSP", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::rgsp)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate resistance * Width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJG", static_cast<double>(1.1), &ADMSmvsg_cmc::Model::vjg)
    .setUnit(U_VOLT)
    .setDescription("Gate diode cut in voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PG_PARAM1", static_cast<double>(820e-3), &ADMSmvsg_cmc::Model::pg_param1)
    .setUnit(U_UNKNOWN)
    .setDescription("Something like 1/eta")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PG_PARAMS", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::pg_params)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJS", static_cast<double>(1.00e-12), &ADMSmvsg_cmc::Model::ijs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGSATS", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::vgsats)
    .setUnit(U_VOLT)
    .setDescription("G-S high injection effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FRACS", static_cast<double>(0.5), &ADMSmvsg_cmc::Model::fracs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S fractional change in ideality factor due to high injection")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAGS", static_cast<double>(10.0), &ADMSmvsg_cmc::Model::alphags)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S high injection smoothing parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PG_PARAMD", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::pg_paramd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IJD", static_cast<double>(1.00e-12), &ADMSmvsg_cmc::Model::ijd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGSATD", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::vgsatd)
    .setUnit(U_VOLT)
    .setDescription("G-D high injection effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FRACD", static_cast<double>(0.5), &ADMSmvsg_cmc::Model::fracd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D fractional change in ideality factor due to high injection")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAGD", static_cast<double>(10.0), &ADMSmvsg_cmc::Model::alphagd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D high injection smoothing parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGSRECS", static_cast<double>(0.5), &ADMSmvsg_cmc::Model::pgsrecs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S something like 1/eta for reverse recombination")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IRECS", static_cast<double>(1.0e-18), &ADMSmvsg_cmc::Model::irecs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGSATQS", static_cast<double>(2.00), &ADMSmvsg_cmc::Model::vgsatqs)
    .setUnit(U_VOLT)
    .setDescription("G-S mimics depletion saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBDGS", static_cast<double>(600), &ADMSmvsg_cmc::Model::vbdgs)
    .setUnit(U_VOLT)
    .setDescription("G-S soft breakdown voltage of G-S diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBDGS", static_cast<double>(4.00), &ADMSmvsg_cmc::Model::pbdgs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S fitting parameter for breakdown: Something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETARECS", static_cast<double>(2.00), &ADMSmvsg_cmc::Model::betarecs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KBDGATES", static_cast<double>(00), &ADMSmvsg_cmc::Model::kbdgates)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S fitting parameter to turn on the breakdown of G-S diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGSRECD", static_cast<double>(0.8), &ADMSmvsg_cmc::Model::pgsrecd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D something like 1/eta for reverse recombination")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IRECD", static_cast<double>(2e-5), &ADMSmvsg_cmc::Model::irecd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGSATQD", static_cast<double>(0.8), &ADMSmvsg_cmc::Model::vgsatqd)
    .setUnit(U_VOLT)
    .setDescription("G-D mimics depletion saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBDGD", static_cast<double>(600), &ADMSmvsg_cmc::Model::vbdgd)
    .setUnit(U_VOLT)
    .setDescription("G-D soft breakdown voltage of G-D diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBDGD", static_cast<double>(4.00), &ADMSmvsg_cmc::Model::pbdgd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D fitting parameter for breakdown: Something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETARECD", static_cast<double>(0.25), &ADMSmvsg_cmc::Model::betarecd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KBDGATED", static_cast<double>(00), &ADMSmvsg_cmc::Model::kbdgated)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D fitting parameter to turn on the breakdown of G-D diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RTH", static_cast<double>(25), &ADMSmvsg_cmc::Model::rth)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(1e-4), &ADMSmvsg_cmc::Model::cth)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GMDISP", static_cast<int>(0), &ADMSmvsg_cmc::Model::gmdisp)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter for gm-dispersion 0=off, 1=on");
  p.addPar("TAUGMRF", static_cast<double>(1e-3), &ADMSmvsg_cmc::Model::taugmrf)
    .setUnit(U_SECOND)
    .setDescription("gm-dispersion time constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRAPSELECT", static_cast<int>(0), &ADMSmvsg_cmc::Model::trapselect)
    .setUnit(U_UNKNOWN)
    .setDescription("Select knob for charge trapping 0=off, 1=on");
  p.addPar("CTRAP", static_cast<double>(1e-3), &ADMSmvsg_cmc::Model::ctrap)
    .setUnit(U_FARAD)
    .setDescription("DC-block capacitor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VTTRAP", static_cast<double>(230), &ADMSmvsg_cmc::Model::vttrap)
    .setUnit(U_VOLT)
    .setDescription("Trapping stress threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUT", static_cast<double>(3e-5), &ADMSmvsg_cmc::Model::taut)
    .setUnit(U_SECOND)
    .setDescription("Trap time constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAT1", static_cast<double>(1e-4), &ADMSmvsg_cmc::Model::alphat1)
    .setUnit(U_UNKNOWN)
    .setDescription("Trap coefficient 1 on bias stress")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPHAT2", static_cast<double>(21), &ADMSmvsg_cmc::Model::alphat2)
    .setUnit(U_VOLT)
    .setDescription("Trap coefficient 2 on bias stress")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEMPT", static_cast<double>(1e-4), &ADMSmvsg_cmc::Model::tempt)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature coefficient for trapping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOISEMOD", static_cast<int>(0), &ADMSmvsg_cmc::Model::noisemod)
    .setUnit(U_UNKNOWN)
    .setDescription("Select knob for noise model 0=off, 1=on");
  p.addPar("SHS", static_cast<double>(3.0), &ADMSmvsg_cmc::Model::shs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S shot noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SHD", static_cast<double>(3.0), &ADMSmvsg_cmc::Model::shd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D shot noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KF", static_cast<double>(1.0e-4), &ADMSmvsg_cmc::Model::kf)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AF", static_cast<double>(2.0), &ADMSmvsg_cmc::Model::af)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FFE", static_cast<double>(1.2), &ADMSmvsg_cmc::Model::ffe)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise exponent for frequency")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MINR", static_cast<double>(1.0e-3), &ADMSmvsg_cmc::Model::minr)
    .setUnit(U_OHM)
    .setDescription("Minimum resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MINL", static_cast<double>(1.0e-9), &ADMSmvsg_cmc::Model::minl)
    .setUnit(U_METER)
    .setDescription("Minimum length of access or FP regions for modeling them as transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MINC", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::minc)
    .setUnit(U_FARAD)
    .setDescription("Minimum capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter w : ] 0,  (+inf) [
  if ( (!((w >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter w value " << w << " out of range ] 0,  (+inf) [";
  }

  //    Parameter l : ] 0,  (+inf) [
  if ( (!((l >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter l value " << l << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ngf : [ 1,  (+inf) [
  if ( (!((ngf >=1))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ngf value " << ngf << " out of range [ 1,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  //Begin block initial_instance
  {
    if (((model_.flagres)==0))
    {
      rcs_w = (((model_.rcs)/w)/ngf);
      rcd_w = (((model_.rcd)/w)/ngf);
    }
    else
    {
      rcs_w = ((((model_.rcs)/w)+(((model_.rsh)*(model_.lgs))/w))/ngf);
      rcd_w = ((((model_.rcd)/w)+(((model_.rsh)*(model_.lgd))/w))/ngf);
    }
    rg = (((model_.rgsp)/w)/ngf);
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    w(180.0e-6),
    l(250.0e-9),
    ngf(2),
    dtemp(0.0),
    rcs_w(0.0),
    rcd_w(0.0),
    rg(0.0),
    vtdibli(0.0),
    vdsat1i(0.0),
    vtdiblrs(0.0),
    vdsatrs(0.0),
    vtdiblrd(0.0),
    vdsatrd(0.0),
    vtdiblfp1(0.0),
    vdsatfp1(0.0),
    vtdiblfp2(0.0),
    vdsatfp2(0.0),
    vtdiblfp3(0.0),
    vdsatfp3(0.0),
    vtdiblfp4(0.0),
    vdsatfp4(0.0),
    qgs(0.0),
    qgd(0.0),
    qc(0.0),
    qb(0.0),
    qs(0.0),
    igssdio(0.0),
    igdsdio(0.0),
    igsrec(0.0),
    igdrec(0.0),
    qgsrs(0.0),
    qgdrs(0.0),
    qcrs(0.0),
    qbrs(0.0),
    qsrs(0.0),
    qgsrd(0.0),
    qgdrd(0.0),
    qcrd(0.0),
    qbrd(0.0),
    qsrd(0.0),
    qgsfp1(0.0),
    qgdfp1(0.0),
    qcfp1(0.0),
    qbfp1(0.0),
    qsfp1(0.0),
    qgsfp2(0.0),
    qgdfp2(0.0),
    qcfp2(0.0),
    qbfp2(0.0),
    qsfp2(0.0),
    qgsfp3(0.0),
    qgdfp3(0.0),
    qcfp3(0.0),
    qbfp3(0.0),
    qsfp3(0.0),
    qgsfp4(0.0),
    qgdfp4(0.0),
    qcfp4(0.0),
    qbfp4(0.0),
    qsfp4(0.0),
    li_d(-1),
    li_g(-1),
    li_s(-1),
    li_b(-1),
    li_di(-1),
    li_gi(-1),
    li_si(-1),
    li_fp1(-1),
    li_fp2(-1),
    li_fp3(-1),
    li_fp4(-1),
    li_drc(-1),
    li_src(-1),
    li_tr(-1),
    li_tr1(-1),
    li_xt1(-1),
    li_xt2(-1),
    li_dt(-1),
    li_branch_id(-1),
    li_branch_ig(-1),
    li_branch_is(-1),
    li_branch_ib(-1),
    f_tr1_Equ_d_Node_Ptr(0),
    f_tr1_Equ_g_Node_Ptr(0),
    f_tr1_Equ_tr1_Node_Ptr(0),
    f_tr1_Equ_tr_Node_Ptr(0),
    f_tr_Equ_tr1_Node_Ptr(0),
    f_tr_Equ_tr_Node_Ptr(0),
    f_fp4_Equ_dt_Node_Ptr(0),
    f_fp3_Equ_dt_Node_Ptr(0),
    f_fp4_Equ_fp4_Node_Ptr(0),
    f_fp4_Equ_fp3_Node_Ptr(0),
    f_fp3_Equ_fp4_Node_Ptr(0),
    f_fp3_Equ_fp3_Node_Ptr(0),
    f_fp4_Equ_gi_Node_Ptr(0),
    f_fp3_Equ_gi_Node_Ptr(0),
    f_fp4_Equ_s_Node_Ptr(0),
    f_fp3_Equ_s_Node_Ptr(0),
    f_fp4_Equ_b_Node_Ptr(0),
    f_fp3_Equ_b_Node_Ptr(0),
    f_gi_Equ_dt_Node_Ptr(0),
    f_gi_Equ_fp4_Node_Ptr(0),
    f_gi_Equ_fp3_Node_Ptr(0),
    f_gi_Equ_gi_Node_Ptr(0),
    f_gi_Equ_s_Node_Ptr(0),
    f_gi_Equ_b_Node_Ptr(0),
    f_s_Equ_dt_Node_Ptr(0),
    f_s_Equ_fp4_Node_Ptr(0),
    f_s_Equ_fp3_Node_Ptr(0),
    f_s_Equ_gi_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_gi_Equ_si_Node_Ptr(0),
    f_si_Equ_gi_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_dt_Node_Ptr(0),
    f_si_Equ_fp4_Node_Ptr(0),
    f_si_Equ_fp3_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_si_Equ_b_Node_Ptr(0),
    f_b_Equ_dt_Node_Ptr(0),
    f_b_Equ_fp4_Node_Ptr(0),
    f_b_Equ_fp3_Node_Ptr(0),
    f_b_Equ_gi_Node_Ptr(0),
    f_b_Equ_s_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_fp2_Equ_dt_Node_Ptr(0),
    f_fp3_Equ_fp2_Node_Ptr(0),
    f_fp2_Equ_fp3_Node_Ptr(0),
    f_fp2_Equ_fp2_Node_Ptr(0),
    f_fp2_Equ_gi_Node_Ptr(0),
    f_fp2_Equ_s_Node_Ptr(0),
    f_fp2_Equ_b_Node_Ptr(0),
    f_gi_Equ_fp2_Node_Ptr(0),
    f_s_Equ_fp2_Node_Ptr(0),
    f_si_Equ_fp2_Node_Ptr(0),
    f_b_Equ_fp2_Node_Ptr(0),
    f_fp1_Equ_dt_Node_Ptr(0),
    f_fp2_Equ_fp1_Node_Ptr(0),
    f_fp1_Equ_fp2_Node_Ptr(0),
    f_fp1_Equ_fp1_Node_Ptr(0),
    f_fp1_Equ_gi_Node_Ptr(0),
    f_fp1_Equ_s_Node_Ptr(0),
    f_fp1_Equ_b_Node_Ptr(0),
    f_gi_Equ_fp1_Node_Ptr(0),
    f_s_Equ_fp1_Node_Ptr(0),
    f_si_Equ_fp1_Node_Ptr(0),
    f_b_Equ_fp1_Node_Ptr(0),
    f_di_Equ_dt_Node_Ptr(0),
    f_fp1_Equ_di_Node_Ptr(0),
    f_di_Equ_fp1_Node_Ptr(0),
    f_di_Equ_di_Node_Ptr(0),
    f_di_Equ_gi_Node_Ptr(0),
    f_di_Equ_s_Node_Ptr(0),
    f_di_Equ_b_Node_Ptr(0),
    f_gi_Equ_di_Node_Ptr(0),
    f_s_Equ_di_Node_Ptr(0),
    f_si_Equ_di_Node_Ptr(0),
    f_b_Equ_di_Node_Ptr(0),
    f_si_Equ_src_Node_Ptr(0),
    f_src_Equ_src_Node_Ptr(0),
    f_src_Equ_s_Node_Ptr(0),
    f_si_Equ_d_Node_Ptr(0),
    f_src_Equ_d_Node_Ptr(0),
    f_src_Equ_dt_Node_Ptr(0),
    f_src_Equ_si_Node_Ptr(0),
    f_drc_Equ_fp4_Node_Ptr(0),
    f_drc_Equ_s_Node_Ptr(0),
    f_drc_Equ_d_Node_Ptr(0),
    f_fp4_Equ_d_Node_Ptr(0),
    f_drc_Equ_tr_Node_Ptr(0),
    f_fp4_Equ_tr_Node_Ptr(0),
    f_drc_Equ_dt_Node_Ptr(0),
    f_drc_Equ_drc_Node_Ptr(0),
    f_fp4_Equ_drc_Node_Ptr(0),
    f_di_Equ_si_Node_Ptr(0),
    f_xt1_Equ_xt2_Node_Ptr(0),
    f_xt1_Equ_dt_Node_Ptr(0),
    f_xt1_Equ_di_Node_Ptr(0),
    f_xt1_Equ_si_Node_Ptr(0),
    f_xt1_Equ_gi_Node_Ptr(0),
    f_xt1_Equ_xt1_Node_Ptr(0),
    f_xt2_Equ_xt2_Node_Ptr(0),
    f_xt2_Equ_xt1_Node_Ptr(0),
    f_di_Equ_xt2_Node_Ptr(0),
    f_si_Equ_xt2_Node_Ptr(0),
    f_d_Equ_dt_Node_Ptr(0),
    f_d_Equ_d_Node_Ptr(0),
    f_d_Equ_drc_Node_Ptr(0),
    f_s_Equ_src_Node_Ptr(0),
    f_g_Equ_g_Node_Ptr(0),
    f_g_Equ_gi_Node_Ptr(0),
    f_gi_Equ_g_Node_Ptr(0),
    f_gi_Equ_d_Node_Ptr(0),
    f_d_Equ_gi_Node_Ptr(0),
    f_d_Equ_s_Node_Ptr(0),
    f_s_Equ_d_Node_Ptr(0),
    f_d_Equ_b_Node_Ptr(0),
    f_b_Equ_d_Node_Ptr(0),
    f_dt_Equ_dt_Node_Ptr(0),
    f_dt_Equ_fp4_Node_Ptr(0),
    f_dt_Equ_fp3_Node_Ptr(0),
    f_dt_Equ_gi_Node_Ptr(0),
    f_dt_Equ_s_Node_Ptr(0),
    f_dt_Equ_b_Node_Ptr(0),
    f_dt_Equ_fp2_Node_Ptr(0),
    f_dt_Equ_fp1_Node_Ptr(0),
    f_dt_Equ_di_Node_Ptr(0),
    f_dt_Equ_src_Node_Ptr(0),
    f_dt_Equ_d_Node_Ptr(0),
    f_dt_Equ_si_Node_Ptr(0),
    f_dt_Equ_tr_Node_Ptr(0),
    f_dt_Equ_drc_Node_Ptr(0),
    q_tr1_Equ_d_Node_Ptr(0),
    q_tr1_Equ_g_Node_Ptr(0),
    q_tr1_Equ_tr1_Node_Ptr(0),
    q_tr1_Equ_tr_Node_Ptr(0),
    q_tr_Equ_tr1_Node_Ptr(0),
    q_tr_Equ_tr_Node_Ptr(0),
    q_fp4_Equ_dt_Node_Ptr(0),
    q_fp3_Equ_dt_Node_Ptr(0),
    q_fp4_Equ_fp4_Node_Ptr(0),
    q_fp4_Equ_fp3_Node_Ptr(0),
    q_fp3_Equ_fp4_Node_Ptr(0),
    q_fp3_Equ_fp3_Node_Ptr(0),
    q_fp4_Equ_gi_Node_Ptr(0),
    q_fp3_Equ_gi_Node_Ptr(0),
    q_fp4_Equ_s_Node_Ptr(0),
    q_fp3_Equ_s_Node_Ptr(0),
    q_fp4_Equ_b_Node_Ptr(0),
    q_fp3_Equ_b_Node_Ptr(0),
    q_gi_Equ_dt_Node_Ptr(0),
    q_gi_Equ_fp4_Node_Ptr(0),
    q_gi_Equ_fp3_Node_Ptr(0),
    q_gi_Equ_gi_Node_Ptr(0),
    q_gi_Equ_s_Node_Ptr(0),
    q_gi_Equ_b_Node_Ptr(0),
    q_s_Equ_dt_Node_Ptr(0),
    q_s_Equ_fp4_Node_Ptr(0),
    q_s_Equ_fp3_Node_Ptr(0),
    q_s_Equ_gi_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_gi_Equ_si_Node_Ptr(0),
    q_si_Equ_gi_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_dt_Node_Ptr(0),
    q_si_Equ_fp4_Node_Ptr(0),
    q_si_Equ_fp3_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_si_Equ_b_Node_Ptr(0),
    q_b_Equ_dt_Node_Ptr(0),
    q_b_Equ_fp4_Node_Ptr(0),
    q_b_Equ_fp3_Node_Ptr(0),
    q_b_Equ_gi_Node_Ptr(0),
    q_b_Equ_s_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_fp2_Equ_dt_Node_Ptr(0),
    q_fp3_Equ_fp2_Node_Ptr(0),
    q_fp2_Equ_fp3_Node_Ptr(0),
    q_fp2_Equ_fp2_Node_Ptr(0),
    q_fp2_Equ_gi_Node_Ptr(0),
    q_fp2_Equ_s_Node_Ptr(0),
    q_fp2_Equ_b_Node_Ptr(0),
    q_gi_Equ_fp2_Node_Ptr(0),
    q_s_Equ_fp2_Node_Ptr(0),
    q_si_Equ_fp2_Node_Ptr(0),
    q_b_Equ_fp2_Node_Ptr(0),
    q_fp1_Equ_dt_Node_Ptr(0),
    q_fp2_Equ_fp1_Node_Ptr(0),
    q_fp1_Equ_fp2_Node_Ptr(0),
    q_fp1_Equ_fp1_Node_Ptr(0),
    q_fp1_Equ_gi_Node_Ptr(0),
    q_fp1_Equ_s_Node_Ptr(0),
    q_fp1_Equ_b_Node_Ptr(0),
    q_gi_Equ_fp1_Node_Ptr(0),
    q_s_Equ_fp1_Node_Ptr(0),
    q_si_Equ_fp1_Node_Ptr(0),
    q_b_Equ_fp1_Node_Ptr(0),
    q_di_Equ_dt_Node_Ptr(0),
    q_fp1_Equ_di_Node_Ptr(0),
    q_di_Equ_fp1_Node_Ptr(0),
    q_di_Equ_di_Node_Ptr(0),
    q_di_Equ_gi_Node_Ptr(0),
    q_di_Equ_s_Node_Ptr(0),
    q_di_Equ_b_Node_Ptr(0),
    q_gi_Equ_di_Node_Ptr(0),
    q_s_Equ_di_Node_Ptr(0),
    q_si_Equ_di_Node_Ptr(0),
    q_b_Equ_di_Node_Ptr(0),
    q_si_Equ_src_Node_Ptr(0),
    q_src_Equ_src_Node_Ptr(0),
    q_src_Equ_s_Node_Ptr(0),
    q_si_Equ_d_Node_Ptr(0),
    q_src_Equ_d_Node_Ptr(0),
    q_src_Equ_dt_Node_Ptr(0),
    q_src_Equ_si_Node_Ptr(0),
    q_drc_Equ_fp4_Node_Ptr(0),
    q_drc_Equ_s_Node_Ptr(0),
    q_drc_Equ_d_Node_Ptr(0),
    q_fp4_Equ_d_Node_Ptr(0),
    q_drc_Equ_tr_Node_Ptr(0),
    q_fp4_Equ_tr_Node_Ptr(0),
    q_drc_Equ_dt_Node_Ptr(0),
    q_drc_Equ_drc_Node_Ptr(0),
    q_fp4_Equ_drc_Node_Ptr(0),
    q_di_Equ_si_Node_Ptr(0),
    q_xt1_Equ_xt2_Node_Ptr(0),
    q_xt1_Equ_dt_Node_Ptr(0),
    q_xt1_Equ_di_Node_Ptr(0),
    q_xt1_Equ_si_Node_Ptr(0),
    q_xt1_Equ_gi_Node_Ptr(0),
    q_xt1_Equ_xt1_Node_Ptr(0),
    q_xt2_Equ_xt2_Node_Ptr(0),
    q_xt2_Equ_xt1_Node_Ptr(0),
    q_di_Equ_xt2_Node_Ptr(0),
    q_si_Equ_xt2_Node_Ptr(0),
    q_d_Equ_dt_Node_Ptr(0),
    q_d_Equ_d_Node_Ptr(0),
    q_d_Equ_drc_Node_Ptr(0),
    q_s_Equ_src_Node_Ptr(0),
    q_g_Equ_g_Node_Ptr(0),
    q_g_Equ_gi_Node_Ptr(0),
    q_gi_Equ_g_Node_Ptr(0),
    q_gi_Equ_d_Node_Ptr(0),
    q_d_Equ_gi_Node_Ptr(0),
    q_d_Equ_s_Node_Ptr(0),
    q_s_Equ_d_Node_Ptr(0),
    q_d_Equ_b_Node_Ptr(0),
    q_b_Equ_d_Node_Ptr(0),
    q_dt_Equ_dt_Node_Ptr(0),
    q_dt_Equ_fp4_Node_Ptr(0),
    q_dt_Equ_fp3_Node_Ptr(0),
    q_dt_Equ_gi_Node_Ptr(0),
    q_dt_Equ_s_Node_Ptr(0),
    q_dt_Equ_b_Node_Ptr(0),
    q_dt_Equ_fp2_Node_Ptr(0),
    q_dt_Equ_fp1_Node_Ptr(0),
    q_dt_Equ_di_Node_Ptr(0),
    q_dt_Equ_src_Node_Ptr(0),
    q_dt_Equ_d_Node_Ptr(0),
    q_dt_Equ_si_Node_Ptr(0),
    q_dt_Equ_tr_Node_Ptr(0),
    q_dt_Equ_drc_Node_Ptr(0),
    A_tr1_Equ_d_NodeOffset(-1),
    A_tr1_Equ_g_NodeOffset(-1),
    A_tr1_Equ_tr1_NodeOffset(-1),
    A_tr1_Equ_tr_NodeOffset(-1),
    A_tr_Equ_tr1_NodeOffset(-1),
    A_tr_Equ_tr_NodeOffset(-1),
    A_fp4_Equ_dt_NodeOffset(-1),
    A_fp3_Equ_dt_NodeOffset(-1),
    A_fp4_Equ_fp4_NodeOffset(-1),
    A_fp4_Equ_fp3_NodeOffset(-1),
    A_fp3_Equ_fp4_NodeOffset(-1),
    A_fp3_Equ_fp3_NodeOffset(-1),
    A_fp4_Equ_gi_NodeOffset(-1),
    A_fp3_Equ_gi_NodeOffset(-1),
    A_fp4_Equ_s_NodeOffset(-1),
    A_fp3_Equ_s_NodeOffset(-1),
    A_fp4_Equ_b_NodeOffset(-1),
    A_fp3_Equ_b_NodeOffset(-1),
    A_gi_Equ_dt_NodeOffset(-1),
    A_gi_Equ_fp4_NodeOffset(-1),
    A_gi_Equ_fp3_NodeOffset(-1),
    A_gi_Equ_gi_NodeOffset(-1),
    A_gi_Equ_s_NodeOffset(-1),
    A_gi_Equ_b_NodeOffset(-1),
    A_s_Equ_dt_NodeOffset(-1),
    A_s_Equ_fp4_NodeOffset(-1),
    A_s_Equ_fp3_NodeOffset(-1),
    A_s_Equ_gi_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_gi_Equ_si_NodeOffset(-1),
    A_si_Equ_gi_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_dt_NodeOffset(-1),
    A_si_Equ_fp4_NodeOffset(-1),
    A_si_Equ_fp3_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_si_Equ_b_NodeOffset(-1),
    A_b_Equ_dt_NodeOffset(-1),
    A_b_Equ_fp4_NodeOffset(-1),
    A_b_Equ_fp3_NodeOffset(-1),
    A_b_Equ_gi_NodeOffset(-1),
    A_b_Equ_s_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_fp2_Equ_dt_NodeOffset(-1),
    A_fp3_Equ_fp2_NodeOffset(-1),
    A_fp2_Equ_fp3_NodeOffset(-1),
    A_fp2_Equ_fp2_NodeOffset(-1),
    A_fp2_Equ_gi_NodeOffset(-1),
    A_fp2_Equ_s_NodeOffset(-1),
    A_fp2_Equ_b_NodeOffset(-1),
    A_gi_Equ_fp2_NodeOffset(-1),
    A_s_Equ_fp2_NodeOffset(-1),
    A_si_Equ_fp2_NodeOffset(-1),
    A_b_Equ_fp2_NodeOffset(-1),
    A_fp1_Equ_dt_NodeOffset(-1),
    A_fp2_Equ_fp1_NodeOffset(-1),
    A_fp1_Equ_fp2_NodeOffset(-1),
    A_fp1_Equ_fp1_NodeOffset(-1),
    A_fp1_Equ_gi_NodeOffset(-1),
    A_fp1_Equ_s_NodeOffset(-1),
    A_fp1_Equ_b_NodeOffset(-1),
    A_gi_Equ_fp1_NodeOffset(-1),
    A_s_Equ_fp1_NodeOffset(-1),
    A_si_Equ_fp1_NodeOffset(-1),
    A_b_Equ_fp1_NodeOffset(-1),
    A_di_Equ_dt_NodeOffset(-1),
    A_fp1_Equ_di_NodeOffset(-1),
    A_di_Equ_fp1_NodeOffset(-1),
    A_di_Equ_di_NodeOffset(-1),
    A_di_Equ_gi_NodeOffset(-1),
    A_di_Equ_s_NodeOffset(-1),
    A_di_Equ_b_NodeOffset(-1),
    A_gi_Equ_di_NodeOffset(-1),
    A_s_Equ_di_NodeOffset(-1),
    A_si_Equ_di_NodeOffset(-1),
    A_b_Equ_di_NodeOffset(-1),
    A_si_Equ_src_NodeOffset(-1),
    A_src_Equ_src_NodeOffset(-1),
    A_src_Equ_s_NodeOffset(-1),
    A_si_Equ_d_NodeOffset(-1),
    A_src_Equ_d_NodeOffset(-1),
    A_src_Equ_dt_NodeOffset(-1),
    A_src_Equ_si_NodeOffset(-1),
    A_drc_Equ_fp4_NodeOffset(-1),
    A_drc_Equ_s_NodeOffset(-1),
    A_drc_Equ_d_NodeOffset(-1),
    A_fp4_Equ_d_NodeOffset(-1),
    A_drc_Equ_tr_NodeOffset(-1),
    A_fp4_Equ_tr_NodeOffset(-1),
    A_drc_Equ_dt_NodeOffset(-1),
    A_drc_Equ_drc_NodeOffset(-1),
    A_fp4_Equ_drc_NodeOffset(-1),
    A_di_Equ_si_NodeOffset(-1),
    A_xt1_Equ_xt2_NodeOffset(-1),
    A_xt1_Equ_dt_NodeOffset(-1),
    A_xt1_Equ_di_NodeOffset(-1),
    A_xt1_Equ_si_NodeOffset(-1),
    A_xt1_Equ_gi_NodeOffset(-1),
    A_xt1_Equ_xt1_NodeOffset(-1),
    A_xt2_Equ_xt2_NodeOffset(-1),
    A_xt2_Equ_xt1_NodeOffset(-1),
    A_di_Equ_xt2_NodeOffset(-1),
    A_si_Equ_xt2_NodeOffset(-1),
    A_d_Equ_dt_NodeOffset(-1),
    A_d_Equ_d_NodeOffset(-1),
    A_d_Equ_drc_NodeOffset(-1),
    A_s_Equ_src_NodeOffset(-1),
    A_g_Equ_g_NodeOffset(-1),
    A_g_Equ_gi_NodeOffset(-1),
    A_gi_Equ_g_NodeOffset(-1),
    A_gi_Equ_d_NodeOffset(-1),
    A_d_Equ_gi_NodeOffset(-1),
    A_d_Equ_s_NodeOffset(-1),
    A_s_Equ_d_NodeOffset(-1),
    A_d_Equ_b_NodeOffset(-1),
    A_b_Equ_d_NodeOffset(-1),
    A_dt_Equ_dt_NodeOffset(-1),
    A_dt_Equ_fp4_NodeOffset(-1),
    A_dt_Equ_fp3_NodeOffset(-1),
    A_dt_Equ_gi_NodeOffset(-1),
    A_dt_Equ_s_NodeOffset(-1),
    A_dt_Equ_b_NodeOffset(-1),
    A_dt_Equ_fp2_NodeOffset(-1),
    A_dt_Equ_fp1_NodeOffset(-1),
    A_dt_Equ_di_NodeOffset(-1),
    A_dt_Equ_src_NodeOffset(-1),
    A_dt_Equ_d_NodeOffset(-1),
    A_dt_Equ_si_NodeOffset(-1),
    A_dt_Equ_tr_NodeOffset(-1),
    A_dt_Equ_drc_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 14 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_drc));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_src));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_xt2));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_src));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_xt2));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_tr));
  jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_drc));
  jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_tr));
  jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_drc));
  jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_src));
  jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_tr,admsNodeID_tr1));
  jacobianElements.push_back(IntPair(admsNodeID_tr,admsNodeID_tr));
  jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_g));
  jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_tr1));
  jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_tr));
  jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_xt2));
  jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_xt1));
  jacobianElements.push_back(IntPair(admsNodeID_xt2,admsNodeID_xt2));
  jacobianElements.push_back(IntPair(admsNodeID_xt2,admsNodeID_xt1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_dt));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp4));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp3));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_gi));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp2));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp1));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_di));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_src));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_d));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_tr));
  jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_drc));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_di)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_di,admsNodeID_fp1));
  }
  if (collapseNode_gi)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_gi,admsNodeID_g));
  }
  if (collapseNode_si)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_src));
  }
  if (collapseNode_fp1)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_fp1,admsNodeID_fp2));
  }
  if (collapseNode_fp2)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp3));
  }
  if (collapseNode_fp3)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp4));
  }
  if (collapseNode_fp4)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_fp4,admsNodeID_drc));
  }
  if (collapseNode_drc)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_drc,admsNodeID_d));
  }
  if (collapseNode_src)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_src,admsNodeID_s));
  }
  if (collapseNode_tr)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_tr,admsNodeID_GND));
  }
  if (collapseNode_tr1)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_tr1,admsNodeID_GND));
  }
  if (collapseNode_xt1)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_xt1,admsNodeID_GND));
  }
  if (collapseNode_xt2)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_xt2,admsNodeID_GND));
  }
  if (collapseNode_dt)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_dt,admsNodeID_GND));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 18+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_di = false;
  collapseNode_gi = false;
  collapseNode_si = false;
  collapseNode_fp1 = false;
  collapseNode_fp2 = false;
  collapseNode_fp3 = false;
  collapseNode_fp4 = false;
  collapseNode_drc = false;
  collapseNode_src = false;
  collapseNode_tr = false;
  collapseNode_tr1 = false;
  collapseNode_xt1 = false;
  collapseNode_xt2 = false;
  collapseNode_dt = false;
  if (!(((model_.trapselect)!=0)))
  {

    collapseNode_tr1 = true;

    collapseNode_tr = true;

  }

  if (!(((model_.lgfp4)>(model_.minl))))
  {

    collapseNode_fp3 = true;

  }

  if (!(((model_.lgfp3)>(model_.minl))))
  {

    collapseNode_fp2 = true;

  }

  if (!(((model_.lgfp2)>(model_.minl))))
  {

    collapseNode_fp1 = true;

  }

  if (!(((model_.lgfp1)>(model_.minl))))
  {

    collapseNode_di = true;

  }

  if (!((((model_.flagres)==0)&&((model_.lgs)>(model_.minl)))))
  {

    collapseNode_si = true;

  }

  if (!((((model_.flagres)==0)&&((model_.lgd)>(model_.minl)))))
  {

    collapseNode_fp4 = true;

  }

  if (((model_.gmdisp)==0))
  {

    collapseNode_xt1 = true;

    collapseNode_xt2 = true;

  }

  if ((rcd_w<=(model_.minr)))
  {

    collapseNode_drc = true;

  }

  if ((rcs_w<=(model_.minr)))
  {

    collapseNode_src = true;

  }

  if ((rg<=(model_.minr)))
  {

    collapseNode_gi = true;

  }

  if (!(((model_.rth)>0)))
  {
    collapseNode_dt = true;

  }


  if (collapseNode_di)
  {
    numIntVars--;
  }
  if (collapseNode_gi)
  {
    numIntVars--;
  }
  if (collapseNode_si)
  {
    numIntVars--;
  }
  if (collapseNode_fp1)
  {
    numIntVars--;
  }
  if (collapseNode_fp2)
  {
    numIntVars--;
  }
  if (collapseNode_fp3)
  {
    numIntVars--;
  }
  if (collapseNode_fp4)
  {
    numIntVars--;
  }
  if (collapseNode_drc)
  {
    numIntVars--;
  }
  if (collapseNode_src)
  {
    numIntVars--;
  }
  if (collapseNode_tr)
  {
    numIntVars--;
  }
  if (collapseNode_tr1)
  {
    numIntVars--;
  }
  if (collapseNode_xt1)
  {
    numIntVars--;
  }
  if (collapseNode_xt2)
  {
    numIntVars--;
  }
  if (collapseNode_dt)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSmvsg_cmc::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_d = localLIDVec[nodeMap[admsNodeID_d]];
  li_g = localLIDVec[nodeMap[admsNodeID_g]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_di = localLIDVec[nodeMap[admsNodeID_di]];
  li_gi = localLIDVec[nodeMap[admsNodeID_gi]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_fp1 = localLIDVec[nodeMap[admsNodeID_fp1]];
  li_fp2 = localLIDVec[nodeMap[admsNodeID_fp2]];
  li_fp3 = localLIDVec[nodeMap[admsNodeID_fp3]];
  li_fp4 = localLIDVec[nodeMap[admsNodeID_fp4]];
  li_drc = localLIDVec[nodeMap[admsNodeID_drc]];
  li_src = localLIDVec[nodeMap[admsNodeID_src]];
  if (collapseNode_tr)
  {
    li_tr = -1;
  }
  else
  {
    li_tr = localLIDVec[nodeMap[admsNodeID_tr]];
  }
  if (collapseNode_tr1)
  {
    li_tr1 = -1;
  }
  else
  {
    li_tr1 = localLIDVec[nodeMap[admsNodeID_tr1]];
  }
  if (collapseNode_xt1)
  {
    li_xt1 = -1;
  }
  else
  {
    li_xt1 = localLIDVec[nodeMap[admsNodeID_xt1]];
  }
  if (collapseNode_xt2)
  {
    li_xt2 = -1;
  }
  else
  {
    li_xt2 = localLIDVec[nodeMap[admsNodeID_xt2]];
  }
  if (collapseNode_dt)
  {
    li_dt = -1;
  }
  else
  {
    li_dt = localLIDVec[nodeMap[admsNodeID_dt]];
  }


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_d = " << li_d << std::endl;
    Xyce::dout() << "\nli_g = " << li_g << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_di = " << li_di << std::endl;
    Xyce::dout() << "\nli_gi = " << li_gi << std::endl;
    Xyce::dout() << "\nli_si = " << li_si << std::endl;
    Xyce::dout() << "\nli_fp1 = " << li_fp1 << std::endl;
    Xyce::dout() << "\nli_fp2 = " << li_fp2 << std::endl;
    Xyce::dout() << "\nli_fp3 = " << li_fp3 << std::endl;
    Xyce::dout() << "\nli_fp4 = " << li_fp4 << std::endl;
    Xyce::dout() << "\nli_drc = " << li_drc << std::endl;
    Xyce::dout() << "\nli_src = " << li_src << std::endl;
    Xyce::dout() << "\nli_tr = " << li_tr << std::endl;
    Xyce::dout() << "\nli_tr1 = " << li_tr1 << std::endl;
    Xyce::dout() << "\nli_xt1 = " << li_xt1 << std::endl;
    Xyce::dout() << "\nli_xt2 = " << li_xt2 << std::endl;
    Xyce::dout() << "\nli_dt = " << li_dt << std::endl;

    Xyce::dout() << "\nEnd of ADMSmvsg_cmc::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  if (!collapseNode_di)
  {
    addInternalNode(symbol_table, li_di, getName(), "di");
  }
  if (!collapseNode_gi)
  {
    addInternalNode(symbol_table, li_gi, getName(), "gi");
  }
  if (!collapseNode_si)
  {
    addInternalNode(symbol_table, li_si, getName(), "si");
  }
  if (!collapseNode_fp1)
  {
    addInternalNode(symbol_table, li_fp1, getName(), "fp1");
  }
  if (!collapseNode_fp2)
  {
    addInternalNode(symbol_table, li_fp2, getName(), "fp2");
  }
  if (!collapseNode_fp3)
  {
    addInternalNode(symbol_table, li_fp3, getName(), "fp3");
  }
  if (!collapseNode_fp4)
  {
    addInternalNode(symbol_table, li_fp4, getName(), "fp4");
  }
  if (!collapseNode_drc)
  {
    addInternalNode(symbol_table, li_drc, getName(), "drc");
  }
  if (!collapseNode_src)
  {
    addInternalNode(symbol_table, li_src, getName(), "src");
  }
  if (!collapseNode_tr)
  {
    addInternalNode(symbol_table, li_tr, getName(), "tr");
  }
  if (!collapseNode_tr1)
  {
    addInternalNode(symbol_table, li_tr1, getName(), "tr1");
  }
  if (!collapseNode_xt1)
  {
    addInternalNode(symbol_table, li_xt1, getName(), "xt1");
  }
  if (!collapseNode_xt2)
  {
    addInternalNode(symbol_table, li_xt2, getName(), "xt2");
  }
  if (!collapseNode_dt)
  {
    addInternalNode(symbol_table, li_dt, getName(), "dt");
  }

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_id, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_ig, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_D4");
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_id = branchLIDVecRef[i++];
    li_branch_ig = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_dt)];
    A_d_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_d)];
  A_d_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_drc)];
  A_d_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_gi)];
  A_d_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_s)];
  A_d_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_b)];
  A_d_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_g)];
  A_g_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_gi)];
  A_g_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_dt)];
    A_s_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp4)];
  A_s_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp3)];
  A_s_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_gi)];
  A_s_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
  A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp2)];
  A_s_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp1)];
  A_s_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_di)];
  A_s_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_src)];
  A_s_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_d)];
  A_s_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dt)];
    A_b_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp4)];
  A_b_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp3)];
  A_b_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_gi)];
  A_b_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_s)];
  A_b_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp2)];
  A_b_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp1)];
  A_b_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_di)];
  A_b_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_d)];
  A_b_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_dt)];
    A_di_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_fp1)];
  A_di_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_di)];
  A_di_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_gi)];
  A_di_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_s)];
  A_di_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_b)];
  A_di_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_si)];
  A_di_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_xt2)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_xt2)];
    A_di_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_dt)];
    A_gi_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp4)];
  A_gi_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp3)];
  A_gi_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_gi)];
  A_gi_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_s)];
  A_gi_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_b)];
  A_gi_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_si)];
  A_gi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp2)];
  A_gi_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp1)];
  A_gi_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_di)];
  A_gi_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_g)];
  A_gi_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_d)];
  A_gi_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_gi)];
  A_si_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
  A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_dt)];
    A_si_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp4)];
  A_si_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp3)];
  A_si_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
  A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_b)];
  A_si_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp2)];
  A_si_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp1)];
  A_si_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_di)];
  A_si_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_src)];
  A_si_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_d)];
  A_si_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_xt2)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_xt2)];
    A_si_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_dt)];
    A_fp1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_fp2)];
  A_fp1_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_fp1)];
  A_fp1_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_gi)];
  A_fp1_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_s)];
  A_fp1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_b)];
  A_fp1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_di)];
  A_fp1_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_dt)];
    A_fp2_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_fp3)];
  A_fp2_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_fp2)];
  A_fp2_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_gi)];
  A_fp2_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_s)];
  A_fp2_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_b)];
  A_fp2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_fp1)];
  A_fp2_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_dt)];
    A_fp3_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_fp4)];
  A_fp3_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_fp3)];
  A_fp3_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_gi)];
  A_fp3_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_s)];
  A_fp3_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_b)];
  A_fp3_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_fp2)];
  A_fp3_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_dt)];
    A_fp4_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_fp4)];
  A_fp4_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_fp3)];
  A_fp4_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_gi)];
  A_fp4_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_s)];
  A_fp4_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_b)];
  A_fp4_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_d)];
  A_fp4_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_tr)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_tr)];
    A_fp4_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_drc)];
  A_fp4_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_fp4)];
  A_drc_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_s)];
  A_drc_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_d)];
  A_drc_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_tr)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_tr)];
    A_drc_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_dt)];
    A_drc_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_drc)];
  A_drc_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_src)];
  A_src_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_s)];
  A_src_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_d)];
  A_src_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_dt)];
    A_src_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_si)];
  A_src_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  if (!collapseNode_tr)
  {
    if (!collapseNode_tr1)
    {
      jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr,admsNodeID_tr1)];
      A_tr_Equ_tr1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    }
  }
  if (!collapseNode_tr)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr,admsNodeID_tr)];
    A_tr_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_tr1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_d)];
    A_tr1_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_tr1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_g)];
    A_tr1_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_tr1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_tr1)];
    A_tr1_Equ_tr1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_tr1)
  {
    if (!collapseNode_tr)
    {
      jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_tr)];
      A_tr1_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    }
  }
  if (!collapseNode_xt1)
  {
    if (!collapseNode_xt2)
    {
      jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_xt2)];
      A_xt1_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    }
  }
  if (!collapseNode_xt1)
  {
    if (!collapseNode_dt)
    {
      jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_dt)];
      A_xt1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    }
  }
  if (!collapseNode_xt1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_di)];
    A_xt1_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_xt1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_si)];
    A_xt1_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_xt1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_gi)];
    A_xt1_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_xt1)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_xt1)];
    A_xt1_Equ_xt1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_xt2)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt2,admsNodeID_xt2)];
    A_xt2_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_xt2)
  {
    if (!collapseNode_xt1)
    {
      jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt2,admsNodeID_xt1)];
      A_xt2_Equ_xt1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    }
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_dt)];
    A_dt_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp4)];
    A_dt_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp3)];
    A_dt_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_gi)];
    A_dt_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_s)];
    A_dt_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b)];
    A_dt_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp2)];
    A_dt_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp1)];
    A_dt_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_di)];
    A_dt_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_src)];
    A_dt_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_d)];
    A_dt_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_si)];
    A_dt_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }
  if (!collapseNode_dt)
  {
    if (!collapseNode_tr)
    {
      jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_tr)];
      A_dt_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    }
  }
  if (!collapseNode_dt)
  {
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_drc)];
    A_dt_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  }


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
  if (!collapseNode_dt)
  {
    f_d_Equ_dt_Node_Ptr = &(dFdx[li_d][A_d_Equ_dt_NodeOffset]);
    q_d_Equ_dt_Node_Ptr = &(dQdx[li_d][A_d_Equ_dt_NodeOffset]);
  }
  f_d_Equ_d_Node_Ptr = &(dFdx[li_d][A_d_Equ_d_NodeOffset]);
  q_d_Equ_d_Node_Ptr = &(dQdx[li_d][A_d_Equ_d_NodeOffset]);
  f_d_Equ_drc_Node_Ptr = &(dFdx[li_d][A_d_Equ_drc_NodeOffset]);
  q_d_Equ_drc_Node_Ptr = &(dQdx[li_d][A_d_Equ_drc_NodeOffset]);
  f_d_Equ_gi_Node_Ptr = &(dFdx[li_d][A_d_Equ_gi_NodeOffset]);
  q_d_Equ_gi_Node_Ptr = &(dQdx[li_d][A_d_Equ_gi_NodeOffset]);
  f_d_Equ_s_Node_Ptr = &(dFdx[li_d][A_d_Equ_s_NodeOffset]);
  q_d_Equ_s_Node_Ptr = &(dQdx[li_d][A_d_Equ_s_NodeOffset]);
  f_d_Equ_b_Node_Ptr = &(dFdx[li_d][A_d_Equ_b_NodeOffset]);
  q_d_Equ_b_Node_Ptr = &(dQdx[li_d][A_d_Equ_b_NodeOffset]);
  f_g_Equ_g_Node_Ptr = &(dFdx[li_g][A_g_Equ_g_NodeOffset]);
  q_g_Equ_g_Node_Ptr = &(dQdx[li_g][A_g_Equ_g_NodeOffset]);
  f_g_Equ_gi_Node_Ptr = &(dFdx[li_g][A_g_Equ_gi_NodeOffset]);
  q_g_Equ_gi_Node_Ptr = &(dQdx[li_g][A_g_Equ_gi_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_s_Equ_dt_Node_Ptr = &(dFdx[li_s][A_s_Equ_dt_NodeOffset]);
    q_s_Equ_dt_Node_Ptr = &(dQdx[li_s][A_s_Equ_dt_NodeOffset]);
  }
  f_s_Equ_fp4_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp4_NodeOffset]);
  q_s_Equ_fp4_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp4_NodeOffset]);
  f_s_Equ_fp3_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp3_NodeOffset]);
  q_s_Equ_fp3_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp3_NodeOffset]);
  f_s_Equ_gi_Node_Ptr = &(dFdx[li_s][A_s_Equ_gi_NodeOffset]);
  q_s_Equ_gi_Node_Ptr = &(dQdx[li_s][A_s_Equ_gi_NodeOffset]);
  f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
  q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
  f_s_Equ_b_Node_Ptr = &(dFdx[li_s][A_s_Equ_b_NodeOffset]);
  q_s_Equ_b_Node_Ptr = &(dQdx[li_s][A_s_Equ_b_NodeOffset]);
  f_s_Equ_fp2_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp2_NodeOffset]);
  q_s_Equ_fp2_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp2_NodeOffset]);
  f_s_Equ_fp1_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp1_NodeOffset]);
  q_s_Equ_fp1_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp1_NodeOffset]);
  f_s_Equ_di_Node_Ptr = &(dFdx[li_s][A_s_Equ_di_NodeOffset]);
  q_s_Equ_di_Node_Ptr = &(dQdx[li_s][A_s_Equ_di_NodeOffset]);
  f_s_Equ_src_Node_Ptr = &(dFdx[li_s][A_s_Equ_src_NodeOffset]);
  q_s_Equ_src_Node_Ptr = &(dQdx[li_s][A_s_Equ_src_NodeOffset]);
  f_s_Equ_d_Node_Ptr = &(dFdx[li_s][A_s_Equ_d_NodeOffset]);
  q_s_Equ_d_Node_Ptr = &(dQdx[li_s][A_s_Equ_d_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_b_Equ_dt_Node_Ptr = &(dFdx[li_b][A_b_Equ_dt_NodeOffset]);
    q_b_Equ_dt_Node_Ptr = &(dQdx[li_b][A_b_Equ_dt_NodeOffset]);
  }
  f_b_Equ_fp4_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp4_NodeOffset]);
  q_b_Equ_fp4_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp4_NodeOffset]);
  f_b_Equ_fp3_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp3_NodeOffset]);
  q_b_Equ_fp3_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp3_NodeOffset]);
  f_b_Equ_gi_Node_Ptr = &(dFdx[li_b][A_b_Equ_gi_NodeOffset]);
  q_b_Equ_gi_Node_Ptr = &(dQdx[li_b][A_b_Equ_gi_NodeOffset]);
  f_b_Equ_s_Node_Ptr = &(dFdx[li_b][A_b_Equ_s_NodeOffset]);
  q_b_Equ_s_Node_Ptr = &(dQdx[li_b][A_b_Equ_s_NodeOffset]);
  f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
  q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
  f_b_Equ_fp2_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp2_NodeOffset]);
  q_b_Equ_fp2_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp2_NodeOffset]);
  f_b_Equ_fp1_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp1_NodeOffset]);
  q_b_Equ_fp1_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp1_NodeOffset]);
  f_b_Equ_di_Node_Ptr = &(dFdx[li_b][A_b_Equ_di_NodeOffset]);
  q_b_Equ_di_Node_Ptr = &(dQdx[li_b][A_b_Equ_di_NodeOffset]);
  f_b_Equ_d_Node_Ptr = &(dFdx[li_b][A_b_Equ_d_NodeOffset]);
  q_b_Equ_d_Node_Ptr = &(dQdx[li_b][A_b_Equ_d_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_di_Equ_dt_Node_Ptr = &(dFdx[li_di][A_di_Equ_dt_NodeOffset]);
    q_di_Equ_dt_Node_Ptr = &(dQdx[li_di][A_di_Equ_dt_NodeOffset]);
  }
  f_di_Equ_fp1_Node_Ptr = &(dFdx[li_di][A_di_Equ_fp1_NodeOffset]);
  q_di_Equ_fp1_Node_Ptr = &(dQdx[li_di][A_di_Equ_fp1_NodeOffset]);
  f_di_Equ_di_Node_Ptr = &(dFdx[li_di][A_di_Equ_di_NodeOffset]);
  q_di_Equ_di_Node_Ptr = &(dQdx[li_di][A_di_Equ_di_NodeOffset]);
  f_di_Equ_gi_Node_Ptr = &(dFdx[li_di][A_di_Equ_gi_NodeOffset]);
  q_di_Equ_gi_Node_Ptr = &(dQdx[li_di][A_di_Equ_gi_NodeOffset]);
  f_di_Equ_s_Node_Ptr = &(dFdx[li_di][A_di_Equ_s_NodeOffset]);
  q_di_Equ_s_Node_Ptr = &(dQdx[li_di][A_di_Equ_s_NodeOffset]);
  f_di_Equ_b_Node_Ptr = &(dFdx[li_di][A_di_Equ_b_NodeOffset]);
  q_di_Equ_b_Node_Ptr = &(dQdx[li_di][A_di_Equ_b_NodeOffset]);
  f_di_Equ_si_Node_Ptr = &(dFdx[li_di][A_di_Equ_si_NodeOffset]);
  q_di_Equ_si_Node_Ptr = &(dQdx[li_di][A_di_Equ_si_NodeOffset]);
  if (!collapseNode_xt2)
  {
    f_di_Equ_xt2_Node_Ptr = &(dFdx[li_di][A_di_Equ_xt2_NodeOffset]);
    q_di_Equ_xt2_Node_Ptr = &(dQdx[li_di][A_di_Equ_xt2_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_gi_Equ_dt_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_dt_NodeOffset]);
    q_gi_Equ_dt_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_dt_NodeOffset]);
  }
  f_gi_Equ_fp4_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp4_NodeOffset]);
  q_gi_Equ_fp4_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp4_NodeOffset]);
  f_gi_Equ_fp3_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp3_NodeOffset]);
  q_gi_Equ_fp3_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp3_NodeOffset]);
  f_gi_Equ_gi_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_gi_NodeOffset]);
  q_gi_Equ_gi_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_gi_NodeOffset]);
  f_gi_Equ_s_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_s_NodeOffset]);
  q_gi_Equ_s_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_s_NodeOffset]);
  f_gi_Equ_b_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_b_NodeOffset]);
  q_gi_Equ_b_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_b_NodeOffset]);
  f_gi_Equ_si_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_si_NodeOffset]);
  q_gi_Equ_si_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_si_NodeOffset]);
  f_gi_Equ_fp2_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp2_NodeOffset]);
  q_gi_Equ_fp2_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp2_NodeOffset]);
  f_gi_Equ_fp1_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp1_NodeOffset]);
  q_gi_Equ_fp1_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp1_NodeOffset]);
  f_gi_Equ_di_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_di_NodeOffset]);
  q_gi_Equ_di_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_di_NodeOffset]);
  f_gi_Equ_g_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_g_NodeOffset]);
  q_gi_Equ_g_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_g_NodeOffset]);
  f_gi_Equ_d_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_d_NodeOffset]);
  q_gi_Equ_d_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_d_NodeOffset]);
  f_si_Equ_gi_Node_Ptr = &(dFdx[li_si][A_si_Equ_gi_NodeOffset]);
  q_si_Equ_gi_Node_Ptr = &(dQdx[li_si][A_si_Equ_gi_NodeOffset]);
  f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
  q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_si_Equ_dt_Node_Ptr = &(dFdx[li_si][A_si_Equ_dt_NodeOffset]);
    q_si_Equ_dt_Node_Ptr = &(dQdx[li_si][A_si_Equ_dt_NodeOffset]);
  }
  f_si_Equ_fp4_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp4_NodeOffset]);
  q_si_Equ_fp4_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp4_NodeOffset]);
  f_si_Equ_fp3_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp3_NodeOffset]);
  q_si_Equ_fp3_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp3_NodeOffset]);
  f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
  q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
  f_si_Equ_b_Node_Ptr = &(dFdx[li_si][A_si_Equ_b_NodeOffset]);
  q_si_Equ_b_Node_Ptr = &(dQdx[li_si][A_si_Equ_b_NodeOffset]);
  f_si_Equ_fp2_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp2_NodeOffset]);
  q_si_Equ_fp2_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp2_NodeOffset]);
  f_si_Equ_fp1_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp1_NodeOffset]);
  q_si_Equ_fp1_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp1_NodeOffset]);
  f_si_Equ_di_Node_Ptr = &(dFdx[li_si][A_si_Equ_di_NodeOffset]);
  q_si_Equ_di_Node_Ptr = &(dQdx[li_si][A_si_Equ_di_NodeOffset]);
  f_si_Equ_src_Node_Ptr = &(dFdx[li_si][A_si_Equ_src_NodeOffset]);
  q_si_Equ_src_Node_Ptr = &(dQdx[li_si][A_si_Equ_src_NodeOffset]);
  f_si_Equ_d_Node_Ptr = &(dFdx[li_si][A_si_Equ_d_NodeOffset]);
  q_si_Equ_d_Node_Ptr = &(dQdx[li_si][A_si_Equ_d_NodeOffset]);
  if (!collapseNode_xt2)
  {
    f_si_Equ_xt2_Node_Ptr = &(dFdx[li_si][A_si_Equ_xt2_NodeOffset]);
    q_si_Equ_xt2_Node_Ptr = &(dQdx[li_si][A_si_Equ_xt2_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_fp1_Equ_dt_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_dt_NodeOffset]);
    q_fp1_Equ_dt_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_dt_NodeOffset]);
  }
  f_fp1_Equ_fp2_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_fp2_NodeOffset]);
  q_fp1_Equ_fp2_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_fp2_NodeOffset]);
  f_fp1_Equ_fp1_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_fp1_NodeOffset]);
  q_fp1_Equ_fp1_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_fp1_NodeOffset]);
  f_fp1_Equ_gi_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_gi_NodeOffset]);
  q_fp1_Equ_gi_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_gi_NodeOffset]);
  f_fp1_Equ_s_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_s_NodeOffset]);
  q_fp1_Equ_s_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_s_NodeOffset]);
  f_fp1_Equ_b_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_b_NodeOffset]);
  q_fp1_Equ_b_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_b_NodeOffset]);
  f_fp1_Equ_di_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_di_NodeOffset]);
  q_fp1_Equ_di_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_di_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_fp2_Equ_dt_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_dt_NodeOffset]);
    q_fp2_Equ_dt_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_dt_NodeOffset]);
  }
  f_fp2_Equ_fp3_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_fp3_NodeOffset]);
  q_fp2_Equ_fp3_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_fp3_NodeOffset]);
  f_fp2_Equ_fp2_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_fp2_NodeOffset]);
  q_fp2_Equ_fp2_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_fp2_NodeOffset]);
  f_fp2_Equ_gi_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_gi_NodeOffset]);
  q_fp2_Equ_gi_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_gi_NodeOffset]);
  f_fp2_Equ_s_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_s_NodeOffset]);
  q_fp2_Equ_s_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_s_NodeOffset]);
  f_fp2_Equ_b_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_b_NodeOffset]);
  q_fp2_Equ_b_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_b_NodeOffset]);
  f_fp2_Equ_fp1_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_fp1_NodeOffset]);
  q_fp2_Equ_fp1_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_fp1_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_fp3_Equ_dt_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_dt_NodeOffset]);
    q_fp3_Equ_dt_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_dt_NodeOffset]);
  }
  f_fp3_Equ_fp4_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_fp4_NodeOffset]);
  q_fp3_Equ_fp4_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_fp4_NodeOffset]);
  f_fp3_Equ_fp3_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_fp3_NodeOffset]);
  q_fp3_Equ_fp3_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_fp3_NodeOffset]);
  f_fp3_Equ_gi_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_gi_NodeOffset]);
  q_fp3_Equ_gi_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_gi_NodeOffset]);
  f_fp3_Equ_s_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_s_NodeOffset]);
  q_fp3_Equ_s_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_s_NodeOffset]);
  f_fp3_Equ_b_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_b_NodeOffset]);
  q_fp3_Equ_b_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_b_NodeOffset]);
  f_fp3_Equ_fp2_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_fp2_NodeOffset]);
  q_fp3_Equ_fp2_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_fp2_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_fp4_Equ_dt_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_dt_NodeOffset]);
    q_fp4_Equ_dt_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_dt_NodeOffset]);
  }
  f_fp4_Equ_fp4_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_fp4_NodeOffset]);
  q_fp4_Equ_fp4_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_fp4_NodeOffset]);
  f_fp4_Equ_fp3_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_fp3_NodeOffset]);
  q_fp4_Equ_fp3_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_fp3_NodeOffset]);
  f_fp4_Equ_gi_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_gi_NodeOffset]);
  q_fp4_Equ_gi_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_gi_NodeOffset]);
  f_fp4_Equ_s_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_s_NodeOffset]);
  q_fp4_Equ_s_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_s_NodeOffset]);
  f_fp4_Equ_b_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_b_NodeOffset]);
  q_fp4_Equ_b_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_b_NodeOffset]);
  f_fp4_Equ_d_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_d_NodeOffset]);
  q_fp4_Equ_d_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_d_NodeOffset]);
  if (!collapseNode_tr)
  {
    f_fp4_Equ_tr_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_tr_NodeOffset]);
    q_fp4_Equ_tr_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_tr_NodeOffset]);
  }
  f_fp4_Equ_drc_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_drc_NodeOffset]);
  q_fp4_Equ_drc_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_drc_NodeOffset]);
  f_drc_Equ_fp4_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_fp4_NodeOffset]);
  q_drc_Equ_fp4_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_fp4_NodeOffset]);
  f_drc_Equ_s_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_s_NodeOffset]);
  q_drc_Equ_s_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_s_NodeOffset]);
  f_drc_Equ_d_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_d_NodeOffset]);
  q_drc_Equ_d_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_d_NodeOffset]);
  if (!collapseNode_tr)
  {
    f_drc_Equ_tr_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_tr_NodeOffset]);
    q_drc_Equ_tr_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_tr_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_drc_Equ_dt_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_dt_NodeOffset]);
    q_drc_Equ_dt_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_dt_NodeOffset]);
  }
  f_drc_Equ_drc_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_drc_NodeOffset]);
  q_drc_Equ_drc_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_drc_NodeOffset]);
  f_src_Equ_src_Node_Ptr = &(dFdx[li_src][A_src_Equ_src_NodeOffset]);
  q_src_Equ_src_Node_Ptr = &(dQdx[li_src][A_src_Equ_src_NodeOffset]);
  f_src_Equ_s_Node_Ptr = &(dFdx[li_src][A_src_Equ_s_NodeOffset]);
  q_src_Equ_s_Node_Ptr = &(dQdx[li_src][A_src_Equ_s_NodeOffset]);
  f_src_Equ_d_Node_Ptr = &(dFdx[li_src][A_src_Equ_d_NodeOffset]);
  q_src_Equ_d_Node_Ptr = &(dQdx[li_src][A_src_Equ_d_NodeOffset]);
  if (!collapseNode_dt)
  {
    f_src_Equ_dt_Node_Ptr = &(dFdx[li_src][A_src_Equ_dt_NodeOffset]);
    q_src_Equ_dt_Node_Ptr = &(dQdx[li_src][A_src_Equ_dt_NodeOffset]);
  }
  f_src_Equ_si_Node_Ptr = &(dFdx[li_src][A_src_Equ_si_NodeOffset]);
  q_src_Equ_si_Node_Ptr = &(dQdx[li_src][A_src_Equ_si_NodeOffset]);
  if (!collapseNode_tr)
  {
    if (!collapseNode_tr1)
    {
      f_tr_Equ_tr1_Node_Ptr = &(dFdx[li_tr][A_tr_Equ_tr1_NodeOffset]);
      q_tr_Equ_tr1_Node_Ptr = &(dQdx[li_tr][A_tr_Equ_tr1_NodeOffset]);
    }
  }
  if (!collapseNode_tr)
  {
    f_tr_Equ_tr_Node_Ptr = &(dFdx[li_tr][A_tr_Equ_tr_NodeOffset]);
    q_tr_Equ_tr_Node_Ptr = &(dQdx[li_tr][A_tr_Equ_tr_NodeOffset]);
  }
  if (!collapseNode_tr1)
  {
    f_tr1_Equ_d_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_d_NodeOffset]);
    q_tr1_Equ_d_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_d_NodeOffset]);
  }
  if (!collapseNode_tr1)
  {
    f_tr1_Equ_g_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_g_NodeOffset]);
    q_tr1_Equ_g_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_g_NodeOffset]);
  }
  if (!collapseNode_tr1)
  {
    f_tr1_Equ_tr1_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_tr1_NodeOffset]);
    q_tr1_Equ_tr1_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_tr1_NodeOffset]);
  }
  if (!collapseNode_tr1)
  {
    if (!collapseNode_tr)
    {
      f_tr1_Equ_tr_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_tr_NodeOffset]);
      q_tr1_Equ_tr_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_tr_NodeOffset]);
    }
  }
  if (!collapseNode_xt1)
  {
    if (!collapseNode_xt2)
    {
      f_xt1_Equ_xt2_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_xt2_NodeOffset]);
      q_xt1_Equ_xt2_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_xt2_NodeOffset]);
    }
  }
  if (!collapseNode_xt1)
  {
    if (!collapseNode_dt)
    {
      f_xt1_Equ_dt_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_dt_NodeOffset]);
      q_xt1_Equ_dt_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_dt_NodeOffset]);
    }
  }
  if (!collapseNode_xt1)
  {
    f_xt1_Equ_di_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_di_NodeOffset]);
    q_xt1_Equ_di_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_di_NodeOffset]);
  }
  if (!collapseNode_xt1)
  {
    f_xt1_Equ_si_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_si_NodeOffset]);
    q_xt1_Equ_si_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_si_NodeOffset]);
  }
  if (!collapseNode_xt1)
  {
    f_xt1_Equ_gi_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_gi_NodeOffset]);
    q_xt1_Equ_gi_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_gi_NodeOffset]);
  }
  if (!collapseNode_xt1)
  {
    f_xt1_Equ_xt1_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_xt1_NodeOffset]);
    q_xt1_Equ_xt1_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_xt1_NodeOffset]);
  }
  if (!collapseNode_xt2)
  {
    f_xt2_Equ_xt2_Node_Ptr = &(dFdx[li_xt2][A_xt2_Equ_xt2_NodeOffset]);
    q_xt2_Equ_xt2_Node_Ptr = &(dQdx[li_xt2][A_xt2_Equ_xt2_NodeOffset]);
  }
  if (!collapseNode_xt2)
  {
    if (!collapseNode_xt1)
    {
      f_xt2_Equ_xt1_Node_Ptr = &(dFdx[li_xt2][A_xt2_Equ_xt1_NodeOffset]);
      q_xt2_Equ_xt1_Node_Ptr = &(dQdx[li_xt2][A_xt2_Equ_xt1_NodeOffset]);
    }
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_dt_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_dt_NodeOffset]);
    q_dt_Equ_dt_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_dt_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_fp4_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp4_NodeOffset]);
    q_dt_Equ_fp4_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp4_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_fp3_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp3_NodeOffset]);
    q_dt_Equ_fp3_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp3_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_gi_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_gi_NodeOffset]);
    q_dt_Equ_gi_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_gi_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_s_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_s_NodeOffset]);
    q_dt_Equ_s_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_s_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_b_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_b_NodeOffset]);
    q_dt_Equ_b_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_b_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_fp2_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp2_NodeOffset]);
    q_dt_Equ_fp2_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp2_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_fp1_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp1_NodeOffset]);
    q_dt_Equ_fp1_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp1_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_di_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_di_NodeOffset]);
    q_dt_Equ_di_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_di_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_src_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_src_NodeOffset]);
    q_dt_Equ_src_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_src_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_d_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_d_NodeOffset]);
    q_dt_Equ_d_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_d_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_si_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_si_NodeOffset]);
    q_dt_Equ_si_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_si_NodeOffset]);
  }
  if (!collapseNode_dt)
  {
    if (!collapseNode_tr)
    {
      f_dt_Equ_tr_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_tr_NodeOffset]);
      q_dt_Equ_tr_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_tr_NodeOffset]);
    }
  }
  if (!collapseNode_dt)
  {
    f_dt_Equ_drc_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_drc_NodeOffset]);
    q_dt_Equ_drc_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_drc_NodeOffset]);
  }


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_d] += staticContributions[admsNodeID_d].val();
  (*extData.daeFVectorPtr)[li_g] += staticContributions[admsNodeID_g].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_di] += staticContributions[admsNodeID_di].val();
  (*extData.daeFVectorPtr)[li_gi] += staticContributions[admsNodeID_gi].val();
  (*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si].val();
  (*extData.daeFVectorPtr)[li_fp1] += staticContributions[admsNodeID_fp1].val();
  (*extData.daeFVectorPtr)[li_fp2] += staticContributions[admsNodeID_fp2].val();
  (*extData.daeFVectorPtr)[li_fp3] += staticContributions[admsNodeID_fp3].val();
  (*extData.daeFVectorPtr)[li_fp4] += staticContributions[admsNodeID_fp4].val();
  (*extData.daeFVectorPtr)[li_drc] += staticContributions[admsNodeID_drc].val();
  (*extData.daeFVectorPtr)[li_src] += staticContributions[admsNodeID_src].val();
  if (!collapseNode_tr)
    (*extData.daeFVectorPtr)[li_tr] += staticContributions[admsNodeID_tr].val();
  if (!collapseNode_tr1)
    (*extData.daeFVectorPtr)[li_tr1] += staticContributions[admsNodeID_tr1].val();
  if (!collapseNode_xt1)
    (*extData.daeFVectorPtr)[li_xt1] += staticContributions[admsNodeID_xt1].val();
  if (!collapseNode_xt2)
    (*extData.daeFVectorPtr)[li_xt2] += staticContributions[admsNodeID_xt2].val();
  if (!collapseNode_dt)
    (*extData.daeFVectorPtr)[li_dt] += staticContributions[admsNodeID_dt].val();


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_id] = leadCurrentF[admsNodeID_d];
    leadF[li_branch_ig] = leadCurrentF[admsNodeID_g];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_id] = solVec[li_d] - solVec[li_s];
    junctionV[li_branch_ig] = solVec[li_g] - solVec[li_s];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_d] += dynamicContributions[admsNodeID_d].val();
  (*extData.daeQVectorPtr)[li_g] += dynamicContributions[admsNodeID_g].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_di] += dynamicContributions[admsNodeID_di].val();
  (*extData.daeQVectorPtr)[li_gi] += dynamicContributions[admsNodeID_gi].val();
  (*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si].val();
  (*extData.daeQVectorPtr)[li_fp1] += dynamicContributions[admsNodeID_fp1].val();
  (*extData.daeQVectorPtr)[li_fp2] += dynamicContributions[admsNodeID_fp2].val();
  (*extData.daeQVectorPtr)[li_fp3] += dynamicContributions[admsNodeID_fp3].val();
  (*extData.daeQVectorPtr)[li_fp4] += dynamicContributions[admsNodeID_fp4].val();
  (*extData.daeQVectorPtr)[li_drc] += dynamicContributions[admsNodeID_drc].val();
  (*extData.daeQVectorPtr)[li_src] += dynamicContributions[admsNodeID_src].val();
  if (!collapseNode_tr)
    (*extData.daeQVectorPtr)[li_tr] += dynamicContributions[admsNodeID_tr].val();
  if (!collapseNode_tr1)
    (*extData.daeQVectorPtr)[li_tr1] += dynamicContributions[admsNodeID_tr1].val();
  if (!collapseNode_xt1)
    (*extData.daeQVectorPtr)[li_xt1] += dynamicContributions[admsNodeID_xt1].val();
  if (!collapseNode_xt2)
    (*extData.daeQVectorPtr)[li_xt2] += dynamicContributions[admsNodeID_xt2].val();
  if (!collapseNode_dt)
    (*extData.daeQVectorPtr)[li_dt] += dynamicContributions[admsNodeID_dt].val();


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_id] = leadCurrentQ[admsNodeID_d];
    leadQ[li_branch_ig] = leadCurrentQ[admsNodeID_g];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one mvsg_cmc instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSmvsg_cmc::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  AdmsFadType pdiss;
  double svc;
  double gm;
  AdmsFadType qofgsub;
  AdmsFadType qofssub;
  AdmsFadType qofdsub;
  AdmsFadType qofds;
  AdmsFadType qofd;
  AdmsFadType qofs;
  AdmsFadType igdi;
  AdmsFadType igsi;
  AdmsFadType idsrf;
  AdmsFadType ids;
  AdmsFadType idsrd;
  AdmsFadType idsrs;
  AdmsFadType idsfp1;
  AdmsFadType idsfp2;
  AdmsFadType idsfp3;
  AdmsFadType idsfp4;
  AdmsFadType vbfp4;
  AdmsFadType vdsfp4;
  AdmsFadType vcfp4;
  AdmsFadType vgsfp4;
  AdmsFadType vbfp3;
  AdmsFadType vdsfp3;
  AdmsFadType vcfp3;
  AdmsFadType vgsfp3;
  AdmsFadType vbfp2;
  AdmsFadType vdsfp2;
  AdmsFadType vcfp2;
  AdmsFadType vgsfp2;
  AdmsFadType vbfp1;
  AdmsFadType vdsfp1;
  AdmsFadType vcfp1;
  AdmsFadType vgsfp1;
  AdmsFadType vgsrd;
  AdmsFadType vdsrd;
  AdmsFadType vigd;
  AdmsFadType vdars;
  AdmsFadType drsht;
  AdmsFadType vtcollapse;
  AdmsFadType vtcollapse0;
  AdmsFadType vgsrs;
  AdmsFadType vdsrs;
  double vigs;
  AdmsFadType vsars;
  AdmsFadType vgsi;
  AdmsFadType vdsi;
  AdmsFadType ttrapfac;
  AdmsFadType phit;
  AdmsFadType rdi;
  AdmsFadType rsi;
  AdmsFadType tdut;
  AdmsFadType tsh;
  double tambk;
  double tnomk;
  double gmin;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (47))
  {
    probeVars.resize(47);
    staticContributions.resize(18+0);
    dynamicContributions.resize(18+0);
  }


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 18+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_drc_d] = (*solVectorPtr)[li_drc] - (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_drc_d].diff(admsProbeID_V_drc_d,47);
  probeVars[admsProbeID_V_gi_b] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_b];
  probeVars[admsProbeID_V_gi_b].diff(admsProbeID_V_gi_b,47);
  probeVars[admsProbeID_V_s_b] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_b];
  probeVars[admsProbeID_V_s_b].diff(admsProbeID_V_s_b,47);
  probeVars[admsProbeID_V_d_b] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_b];
  probeVars[admsProbeID_V_d_b].diff(admsProbeID_V_d_b,47);
  probeVars[admsProbeID_V_d_s] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_d_s].diff(admsProbeID_V_d_s,47);
  probeVars[admsProbeID_V_gi_d] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_gi_d].diff(admsProbeID_V_gi_d,47);
  probeVars[admsProbeID_V_gi_s] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_gi_s].diff(admsProbeID_V_gi_s,47);
  probeVars[admsProbeID_V_g_gi] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_gi];
  probeVars[admsProbeID_V_g_gi].diff(admsProbeID_V_g_gi,47);
  probeVars[admsProbeID_V_d_drc] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_drc];
  probeVars[admsProbeID_V_d_drc].diff(admsProbeID_V_d_drc,47);
  probeVars[admsProbeID_V_xt1_GND] = ((collapseNode_xt1)?(0):((*solVectorPtr)[li_xt1]));
  probeVars[admsProbeID_V_xt1_GND].diff(admsProbeID_V_xt1_GND,47);
  probeVars[admsProbeID_V_xt2_GND] = ((collapseNode_xt2)?(0):((*solVectorPtr)[li_xt2]));
  probeVars[admsProbeID_V_xt2_GND].diff(admsProbeID_V_xt2_GND,47);
  probeVars[admsProbeID_V_fp4_s] = (*solVectorPtr)[li_fp4] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_fp4_s].diff(admsProbeID_V_fp4_s,47);
  probeVars[admsProbeID_V_fp4_d] = (*solVectorPtr)[li_fp4] - (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_fp4_d].diff(admsProbeID_V_fp4_d,47);
  probeVars[admsProbeID_V_tr_GND] = ((collapseNode_tr)?(0):((*solVectorPtr)[li_tr]));
  probeVars[admsProbeID_V_tr_GND].diff(admsProbeID_V_tr_GND,47);
  probeVars[admsProbeID_V_tr1_tr] = (collapseNode_tr1)?(0):((*solVectorPtr)[li_tr1]) - ((collapseNode_tr)?(0):((*solVectorPtr)[li_tr]));
  probeVars[admsProbeID_V_tr1_tr].diff(admsProbeID_V_tr1_tr,47);
  probeVars[admsProbeID_V_d_g] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_g];
  probeVars[admsProbeID_V_d_g].diff(admsProbeID_V_d_g,47);
  probeVars[admsProbeID_V_src_s] = (*solVectorPtr)[li_src] - (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_src_s].diff(admsProbeID_V_src_s,47);
  probeVars[admsProbeID_V_src_d] = (*solVectorPtr)[li_src] - (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_src_d].diff(admsProbeID_V_src_d,47);
  probeVars[admsProbeID_V_di_si] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_di_si].diff(admsProbeID_V_di_si,47);
  probeVars[admsProbeID_V_gi_si] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_gi_si].diff(admsProbeID_V_gi_si,47);
  probeVars[admsProbeID_V_drc_fp4] = (*solVectorPtr)[li_drc] - (*solVectorPtr)[li_fp4];
  probeVars[admsProbeID_V_drc_fp4].diff(admsProbeID_V_drc_fp4,47);
  probeVars[admsProbeID_V_drc_GND] = (*solVectorPtr)[li_drc];
  probeVars[admsProbeID_V_drc_GND].diff(admsProbeID_V_drc_GND,47);
  probeVars[admsProbeID_V_fp4_GND] = (*solVectorPtr)[li_fp4];
  probeVars[admsProbeID_V_fp4_GND].diff(admsProbeID_V_fp4_GND,47);
  probeVars[admsProbeID_V_si_src] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_src];
  probeVars[admsProbeID_V_si_src].diff(admsProbeID_V_si_src,47);
  probeVars[admsProbeID_V_si_GND] = (*solVectorPtr)[li_si];
  probeVars[admsProbeID_V_si_GND].diff(admsProbeID_V_si_GND,47);
  probeVars[admsProbeID_V_src_GND] = (*solVectorPtr)[li_src];
  probeVars[admsProbeID_V_src_GND].diff(admsProbeID_V_src_GND,47);
  probeVars[admsProbeID_V_s_GND] = (*solVectorPtr)[li_s];
  probeVars[admsProbeID_V_s_GND].diff(admsProbeID_V_s_GND,47);
  probeVars[admsProbeID_V_d_GND] = (*solVectorPtr)[li_d];
  probeVars[admsProbeID_V_d_GND].diff(admsProbeID_V_d_GND,47);
  probeVars[admsProbeID_V_fp1_di] = (*solVectorPtr)[li_fp1] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_fp1_di].diff(admsProbeID_V_fp1_di,47);
  probeVars[admsProbeID_V_b_di] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_b_di].diff(admsProbeID_V_b_di,47);
  probeVars[admsProbeID_V_s_di] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_s_di].diff(admsProbeID_V_s_di,47);
  probeVars[admsProbeID_V_gi_di] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_di];
  probeVars[admsProbeID_V_gi_di].diff(admsProbeID_V_gi_di,47);
  probeVars[admsProbeID_V_fp2_fp1] = (*solVectorPtr)[li_fp2] - (*solVectorPtr)[li_fp1];
  probeVars[admsProbeID_V_fp2_fp1].diff(admsProbeID_V_fp2_fp1,47);
  probeVars[admsProbeID_V_b_fp1] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_fp1];
  probeVars[admsProbeID_V_b_fp1].diff(admsProbeID_V_b_fp1,47);
  probeVars[admsProbeID_V_s_fp1] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp1];
  probeVars[admsProbeID_V_s_fp1].diff(admsProbeID_V_s_fp1,47);
  probeVars[admsProbeID_V_gi_fp1] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp1];
  probeVars[admsProbeID_V_gi_fp1].diff(admsProbeID_V_gi_fp1,47);
  probeVars[admsProbeID_V_fp3_fp2] = (*solVectorPtr)[li_fp3] - (*solVectorPtr)[li_fp2];
  probeVars[admsProbeID_V_fp3_fp2].diff(admsProbeID_V_fp3_fp2,47);
  probeVars[admsProbeID_V_b_fp2] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_fp2];
  probeVars[admsProbeID_V_b_fp2].diff(admsProbeID_V_b_fp2,47);
  probeVars[admsProbeID_V_s_fp2] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp2];
  probeVars[admsProbeID_V_s_fp2].diff(admsProbeID_V_s_fp2,47);
  probeVars[admsProbeID_V_gi_fp2] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp2];
  probeVars[admsProbeID_V_gi_fp2].diff(admsProbeID_V_gi_fp2,47);
  probeVars[admsProbeID_Temp_dt_GND] = ((collapseNode_dt)?(0):((*solVectorPtr)[li_dt]));
  probeVars[admsProbeID_Temp_dt_GND].diff(admsProbeID_Temp_dt_GND,47);
  probeVars[admsProbeID_V_fp4_fp3] = (*solVectorPtr)[li_fp4] - (*solVectorPtr)[li_fp3];
  probeVars[admsProbeID_V_fp4_fp3].diff(admsProbeID_V_fp4_fp3,47);
  probeVars[admsProbeID_V_gi_fp4] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp4];
  probeVars[admsProbeID_V_gi_fp4].diff(admsProbeID_V_gi_fp4,47);
  probeVars[admsProbeID_V_s_fp4] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp4];
  probeVars[admsProbeID_V_s_fp4].diff(admsProbeID_V_s_fp4,47);
  probeVars[admsProbeID_V_b_fp3] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_fp3];
  probeVars[admsProbeID_V_b_fp3].diff(admsProbeID_V_b_fp3,47);
  probeVars[admsProbeID_V_s_fp3] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp3];
  probeVars[admsProbeID_V_s_fp3].diff(admsProbeID_V_s_fp3,47);
  probeVars[admsProbeID_V_gi_fp3] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp3];
  probeVars[admsProbeID_V_gi_fp3].diff(admsProbeID_V_gi_fp3,47);
  if (getSolverState().dcopFlag)
  {
    //Begin block initial_step
    {
      if ((0==1))
      {
        qgsfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgdfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qcfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qbfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qsfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdiblfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsatfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgsfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgdfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qcfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qbfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qsfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdiblfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsatfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgsfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgdfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qcfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qbfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qsfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdiblfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsatfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgsfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgdfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qcfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qbfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qsfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdiblfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsatfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgsrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgdrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qcrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qbrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qsrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdiblrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsatrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgsrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgdrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qcrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qbrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qsrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdiblrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsatrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgs = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qgd = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qc = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qb = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        qs = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vtdibli = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        vdsat1i = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        igssdio = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        igsrec = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        igdsdio = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
        igdrec = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+(model_.type));
      }
    }
    // End block initial_step
  }
  // -- code converted from analog/code block
  gmin = getDeviceOptions().gmin;
  tnomk = ((model_.tnom)+273.15);
  tambk = admsTemperature;
  tsh = (probeVars[admsProbeID_Temp_dt_GND]);
  tdut = ((tambk+dtemp)+tsh);
  if ((tdut<((-270.0)+273.15)))
  {
    tdut = ((-270.0)+273.15);
  }
  else
  {
    if ((tdut>(1500+273.15)))
    {
      tdut = (1500+273.15);
    }
  }
  rsi = 0;
  rdi = 0;
  if ((rcs_w>=(model_.minr)))
  {
    rsi = (rcs_w*((1.0+((model_.rct1)*(tdut-tnomk)))+(((model_.rct2)*(tdut-tnomk))*(tdut-tnomk))));
    if ((rsi<(0.1*rcs_w)))
    {
      rsi = (0.1*rcs_w);
    }
  }
  else
  {
    rsi = 0;
  }
  if ((rcd_w>=(model_.minr)))
  {
    rdi = (rcd_w*((1.0+((model_.rct1)*(tdut-tnomk)))+(((model_.rct2)*(tdut-tnomk))*(tdut-tnomk))));
    if ((rdi<(0.1*rcd_w)))
    {
      rdi = (0.1*rcd_w);
    }
  }
  else
  {
    rdi = 0;
  }
  phit = ((1.38062e-23*tdut)/1.60219e-19);
  ttrapfac = (1.0+((model_.tempt)*(tdut-tnomk)));
  vdsi = ((model_.type)*(probeVars[admsProbeID_V_di_si]));
  vgsi = ((model_.type)*(probeVars[admsProbeID_V_gi_si]));
  if ((((model_.type)*(probeVars[admsProbeID_V_src_d]))<=((model_.type)*(probeVars[admsProbeID_V_src_s]))))
  {
    vsars = ((model_.type)*(probeVars[admsProbeID_V_src_s]));
  }
  else
  {
    vsars = ((model_.type)*(probeVars[admsProbeID_V_src_d]));
  }
  vigs = ((model_.vtors)+(1.0/(((model_.rsh)*(model_.cgrs))*(model_.mu0))));
  vdsrs = ((model_.type)*(probeVars[admsProbeID_V_si_src]));
  vgsrs = (vigs-vsars);
  if (((model_.trapselect)!=0))
  {
    vtcollapse0 = (((model_.alphat1)*fabs((probeVars[admsProbeID_V_d_g])))+AnalogFunctions::explim<AdmsFadType>((((probeVars[admsProbeID_V_d_g])-(model_.vttrap))/(model_.alphat2))));
    // I(tr1,GND) <+ ((-vtcollapse0))
    staticContributions[admsNodeID_tr1] += (-vtcollapse0);
    // I(tr1,tr) <+ (ddt((ctrap*V(tr1,tr))))
    dynamicContributions[admsNodeID_tr1] += (((model_.ctrap)*(probeVars[admsProbeID_V_tr1_tr])));
    dynamicContributions[admsNodeID_tr] -= (((model_.ctrap)*(probeVars[admsProbeID_V_tr1_tr])));
    // I(tr,GND) <+ (ddt((taut*V(tr,GND))))
    dynamicContributions[admsNodeID_tr] += (((model_.taut)*(probeVars[admsProbeID_V_tr_GND])));
    // I(tr,GND) <+ (V(tr,GND))
    staticContributions[admsNodeID_tr] += (probeVars[admsProbeID_V_tr_GND]);
    vtcollapse = (probeVars[admsProbeID_V_tr_GND]);
    drsht = (1.0+(vtcollapse*ttrapfac));
  }
  else
  {
    vtcollapse0 = 0;
    vtcollapse = 0;
    // V(tr1,GND) <+ (0)
    // do nothing at all
    // V(tr,GND) <+ (0)
    // do nothing at all
    drsht = 1.0;
  }
  if ((((model_.type)*(probeVars[admsProbeID_V_fp4_d]))<=((model_.type)*(probeVars[admsProbeID_V_fp4_s]))))
  {
    vdars = ((model_.type)*(probeVars[admsProbeID_V_fp4_s]));
  }
  else
  {
    vdars = ((model_.type)*(probeVars[admsProbeID_V_fp4_d]));
  }
  vigd = ((model_.vtord)+(1.0/(((drsht*(model_.rsh))*(model_.cgrd))*(model_.mu0))));
  vdsrd = ((model_.type)*(probeVars[admsProbeID_V_drc_fp4]));
  vgsrd = (vigd-vdars);
  if (((model_.flagfp1)==1))
  {
    vgsfp1 = ((model_.type)*(probeVars[admsProbeID_V_gi_di]));
    vcfp1 = ((model_.type)*(probeVars[admsProbeID_V_s_di]));
  }
  else
  {
    vgsfp1 = ((model_.type)*(probeVars[admsProbeID_V_s_di]));
    vcfp1 = ((model_.type)*(probeVars[admsProbeID_V_gi_di]));
  }
  vdsfp1 = ((model_.type)*(probeVars[admsProbeID_V_fp1_di]));
  vbfp1 = ((model_.type)*(probeVars[admsProbeID_V_b_di]));
  if (((model_.flagfp2)==1))
  {
    vgsfp2 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp1]));
    vcfp2 = ((model_.type)*(probeVars[admsProbeID_V_s_fp1]));
  }
  else
  {
    vgsfp2 = ((model_.type)*(probeVars[admsProbeID_V_s_fp1]));
    vcfp2 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp1]));
  }
  vdsfp2 = ((model_.type)*(probeVars[admsProbeID_V_fp2_fp1]));
  vbfp2 = ((model_.type)*(probeVars[admsProbeID_V_b_fp1]));
  if (((model_.flagfp3)==1))
  {
    vgsfp3 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp2]));
    vcfp3 = ((model_.type)*(probeVars[admsProbeID_V_s_fp2]));
  }
  else
  {
    vgsfp3 = ((model_.type)*(probeVars[admsProbeID_V_s_fp2]));
    vcfp3 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp2]));
  }
  vdsfp3 = ((model_.type)*(probeVars[admsProbeID_V_fp3_fp2]));
  vbfp3 = ((model_.type)*(probeVars[admsProbeID_V_b_fp2]));
  if (((model_.flagfp4)==1))
  {
    vgsfp4 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp3]));
    vcfp4 = ((model_.type)*(probeVars[admsProbeID_V_s_fp3]));
  }
  else
  {
    vgsfp4 = ((model_.type)*(probeVars[admsProbeID_V_s_fp3]));
    vcfp4 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp3]));
  }
  vdsfp4 = ((model_.type)*(probeVars[admsProbeID_V_fp4_fp3]));
  vbfp4 = ((model_.type)*(probeVars[admsProbeID_V_b_fp3]));
  idsfp4 = 0;
  qgsfp4 = 0;
  qgdfp4 = 0;
  qcfp4 = 0;
  qbfp4 = 0;
  qsfp4 = 0;
  vtdiblfp4 = 0;
  vdsatfp4 = 0;
  if (((model_.lgfp4)>(model_.minl)))
  {
    idsfp4 = AnalogFunctions::calc_iq<AdmsFadType>(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
    // I(fp4,fp3) <+ ((idsfp4+(gmin*V(fp4,fp3))))
    staticContributions[admsNodeID_fp4] += (idsfp4+(gmin*(probeVars[admsProbeID_V_fp4_fp3])));
    staticContributions[admsNodeID_fp3] -= (idsfp4+(gmin*(probeVars[admsProbeID_V_fp4_fp3])));
  }
  else
  {
    // V(fp4,fp3) <+ (0)
    // do nothing at all
  }
  if (((model_.flagfp4)==1))
  {
    // I(gi,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(gi,fp3)))))
    dynamicContributions[admsNodeID_gi] += ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
    // I(gi,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(gi,fp4)))))
    dynamicContributions[admsNodeID_gi] += ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp4]))));
    dynamicContributions[admsNodeID_fp4] -= ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp4]))));
    // I(s,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(s,fp3)))))
    dynamicContributions[admsNodeID_s] += ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
    // I(s,fp4) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp4] -= 0;
    // I(gi,si) <+ ((ddt(qsfp4)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((qsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((qsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(s,fp3)))))
    dynamicContributions[admsNodeID_s] += ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
    // I(s,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(s,fp4)))))
    dynamicContributions[admsNodeID_s] += ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp4]))));
    dynamicContributions[admsNodeID_fp4] -= ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp4]))));
    // I(gi,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(gi,fp3)))))
    dynamicContributions[admsNodeID_gi] += ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
    // I(gi,fp4) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp4] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,fp3) <+ ((ddt(qbfp4)+ddt((minc*V(b,fp3)))))
  dynamicContributions[admsNodeID_b] += ((qbfp4)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp3]))));
  dynamicContributions[admsNodeID_fp3] -= ((qbfp4)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp3]))));
  idsfp3 = 0;
  qgsfp3 = 0;
  qgdfp3 = 0;
  qcfp3 = 0;
  qbfp3 = 0;
  qsfp3 = 0;
  vtdiblfp3 = 0;
  vdsatfp3 = 0;
  if (((model_.lgfp3)>(model_.minl)))
  {
    idsfp3 = AnalogFunctions::calc_iq<AdmsFadType>(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
    // I(fp3,fp2) <+ ((idsfp3+(gmin*V(fp3,fp2))))
    staticContributions[admsNodeID_fp3] += (idsfp3+(gmin*(probeVars[admsProbeID_V_fp3_fp2])));
    staticContributions[admsNodeID_fp2] -= (idsfp3+(gmin*(probeVars[admsProbeID_V_fp3_fp2])));
  }
  else
  {
    // V(fp3,fp2) <+ (0)
    // do nothing at all
  }
  if (((model_.flagfp3)==1))
  {
    // I(gi,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(gi,fp2)))))
    dynamicContributions[admsNodeID_gi] += ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
    // I(gi,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(gi,fp3)))))
    dynamicContributions[admsNodeID_gi] += ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
    // I(s,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(s,fp2)))))
    dynamicContributions[admsNodeID_s] += ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
    // I(s,fp3) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp3] -= 0;
    // I(gi,si) <+ ((ddt(qsfp3)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((qsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((qsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(s,fp2)))))
    dynamicContributions[admsNodeID_s] += ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
    // I(s,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(s,fp3)))))
    dynamicContributions[admsNodeID_s] += ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
    // I(gi,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(gi,fp2)))))
    dynamicContributions[admsNodeID_gi] += ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
    // I(gi,fp3) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp3] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,fp2) <+ ((ddt(qbfp3)+ddt((minc*V(b,fp2)))))
  dynamicContributions[admsNodeID_b] += ((qbfp3)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp2]))));
  dynamicContributions[admsNodeID_fp2] -= ((qbfp3)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp2]))));
  idsfp2 = 0;
  qgsfp2 = 0;
  qgdfp2 = 0;
  qcfp2 = 0;
  qbfp2 = 0;
  qsfp2 = 0;
  vtdiblfp2 = 0;
  vdsatfp2 = 0;
  if (((model_.lgfp2)>(model_.minl)))
  {
    idsfp2 = AnalogFunctions::calc_iq<AdmsFadType>(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
    // I(fp2,fp1) <+ ((idsfp2+(gmin*V(fp2,fp1))))
    staticContributions[admsNodeID_fp2] += (idsfp2+(gmin*(probeVars[admsProbeID_V_fp2_fp1])));
    staticContributions[admsNodeID_fp1] -= (idsfp2+(gmin*(probeVars[admsProbeID_V_fp2_fp1])));
  }
  else
  {
    // V(fp2,fp1) <+ (0)
    // do nothing at all
  }
  if (((model_.flagfp2)==1))
  {
    // I(gi,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(gi,fp1)))))
    dynamicContributions[admsNodeID_gi] += ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
    // I(gi,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(gi,fp2)))))
    dynamicContributions[admsNodeID_gi] += ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
    // I(s,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(s,fp1)))))
    dynamicContributions[admsNodeID_s] += ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
    // I(s,fp2) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp2] -= 0;
    // I(gi,si) <+ ((ddt(qsfp2)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((qsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((qsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(s,fp1)))))
    dynamicContributions[admsNodeID_s] += ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
    // I(s,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(s,fp2)))))
    dynamicContributions[admsNodeID_s] += ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
    // I(gi,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(gi,fp1)))))
    dynamicContributions[admsNodeID_gi] += ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
    // I(gi,fp2) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp2] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,fp1) <+ ((ddt(qbfp2)+ddt((minc*V(b,fp1)))))
  dynamicContributions[admsNodeID_b] += ((qbfp2)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp1]))));
  dynamicContributions[admsNodeID_fp1] -= ((qbfp2)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp1]))));
  idsfp1 = 0;
  qgsfp1 = 0;
  qgdfp1 = 0;
  qcfp1 = 0;
  qbfp1 = 0;
  qsfp1 = 0;
  vtdiblfp1 = 0;
  vdsatfp1 = 0;
  if (((model_.lgfp1)>(model_.minl)))
  {
    idsfp1 = AnalogFunctions::calc_iq<AdmsFadType>(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
    // I(fp1,di) <+ ((idsfp1+(gmin*V(fp1,di))))
    staticContributions[admsNodeID_fp1] += (idsfp1+(gmin*(probeVars[admsProbeID_V_fp1_di])));
    staticContributions[admsNodeID_di] -= (idsfp1+(gmin*(probeVars[admsProbeID_V_fp1_di])));
  }
  else
  {
    // V(fp1,di) <+ (0)
    // do nothing at all
  }
  if (((model_.flagfp1)==1))
  {
    // I(gi,di) <+ ((ddt(qgsfp1)+ddt((minc*V(gi,di)))))
    dynamicContributions[admsNodeID_gi] += ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
    dynamicContributions[admsNodeID_di] -= ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
    // I(gi,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(gi,fp1)))))
    dynamicContributions[admsNodeID_gi] += ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
    // I(s,di) <+ ((ddt(qcfp1)+ddt((minc*V(s,di)))))
    dynamicContributions[admsNodeID_s] += ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
    dynamicContributions[admsNodeID_di] -= ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
    // I(s,fp1) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp1] -= 0;
    // I(gi,si) <+ ((ddt(qsfp1)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((qsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((qsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,di) <+ ((ddt(qgsfp1)+ddt((minc*V(s,di)))))
    dynamicContributions[admsNodeID_s] += ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
    dynamicContributions[admsNodeID_di] -= ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
    // I(s,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(s,fp1)))))
    dynamicContributions[admsNodeID_s] += ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
    // I(gi,di) <+ ((ddt(qcfp1)+ddt((minc*V(gi,di)))))
    dynamicContributions[admsNodeID_gi] += ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
    dynamicContributions[admsNodeID_di] -= ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
    // I(gi,fp1) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp1] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,di) <+ ((ddt(qbfp1)+ddt((minc*V(b,di)))))
  dynamicContributions[admsNodeID_b] += ((qbfp1)+(((model_.minc)*(probeVars[admsProbeID_V_b_di]))));
  dynamicContributions[admsNodeID_di] -= ((qbfp1)+(((model_.minc)*(probeVars[admsProbeID_V_b_di]))));
  idsrs = 0;
  if ((((model_.flagres)==0)&&((model_.lgs)>(model_.minl))))
  {
    idsrs = AnalogFunctions::calc_iq<AdmsFadType>(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
    // I(si,src) <+ ((idsrs+(gmin*V(si,src))))
    staticContributions[admsNodeID_si] += (idsrs+(gmin*(probeVars[admsProbeID_V_si_src])));
    staticContributions[admsNodeID_src] -= (idsrs+(gmin*(probeVars[admsProbeID_V_si_src])));
  }
  else
  {
    // V(src,si) <+ (0)
    // do nothing at all
  }
  idsrd = 0;
  if ((((model_.flagres)==0)&&((model_.lgd)>(model_.minl))))
  {
    idsrd = AnalogFunctions::calc_iq<AdmsFadType>(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
    // I(drc,fp4) <+ ((idsrd+(gmin*V(drc,fp4))))
    staticContributions[admsNodeID_drc] += (idsrd+(gmin*(probeVars[admsProbeID_V_drc_fp4])));
    staticContributions[admsNodeID_fp4] -= (idsrd+(gmin*(probeVars[admsProbeID_V_drc_fp4])));
  }
  else
  {
    // V(drc,fp4) <+ (0)
    // do nothing at all
  }
  ids = AnalogFunctions::calc_iq<AdmsFadType>(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,w,l,(model_.cg),0,0,0,(model_.vto),(model_.ss),(model_.delta1),(model_.delta2),(model_.nd),(model_.alpha),(model_.vx0),(model_.mu0),(model_.beta),(model_.mtheta),(model_.vtheta),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
  idsrf = (probeVars[admsProbeID_V_xt2_GND]);
  if (((model_.gmdisp)==0))
  {
    // V(xt1,GND) <+ (0)
    // do nothing at all
    // V(xt2,GND) <+ (0)
    // do nothing at all
    // I(di,si) <+ ((ids+(gmin*V(di,si))))
    staticContributions[admsNodeID_di] += (ids+(gmin*(probeVars[admsProbeID_V_di_si])));
    staticContributions[admsNodeID_si] -= (ids+(gmin*(probeVars[admsProbeID_V_di_si])));
  }
  else
  {
    // I(xt1,GND) <+ ((ids-V(xt2,GND)))
    staticContributions[admsNodeID_xt1] += (ids-(probeVars[admsProbeID_V_xt2_GND]));
    // I(xt1,GND) <+ ((-ddt((taugmrf*V(xt1,GND)))))
    dynamicContributions[admsNodeID_xt1] += (-(((model_.taugmrf)*(probeVars[admsProbeID_V_xt1_GND]))));
    // I(xt2,GND) <+ ((V(xt1,GND)-V(xt2,GND)))
    staticContributions[admsNodeID_xt2] += ((probeVars[admsProbeID_V_xt1_GND])-(probeVars[admsProbeID_V_xt2_GND]));
    // I(xt2,GND) <+ ((-ddt(((taugmrf/3.0)*V(xt2,GND)))))
    dynamicContributions[admsNodeID_xt2] += (-((((model_.taugmrf)/3.0)*(probeVars[admsProbeID_V_xt2_GND]))));
    // I(di,si) <+ ((idsrf+(gmin*V(di,si))))
    staticContributions[admsNodeID_di] += (idsrf+(gmin*(probeVars[admsProbeID_V_di_si])));
    staticContributions[admsNodeID_si] -= (idsrf+(gmin*(probeVars[admsProbeID_V_di_si])));
  }
  // I(gi,si) <+ ((ddt(qgs)+ddt((minc*V(gi,si)))))
  dynamicContributions[admsNodeID_gi] += ((qgs)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
  dynamicContributions[admsNodeID_si] -= ((qgs)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
  // I(gi,di) <+ ((ddt(qgd)+ddt((minc*V(gi,di)))))
  dynamicContributions[admsNodeID_gi] += ((qgd)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
  dynamicContributions[admsNodeID_di] -= ((qgd)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
  igsi = 0;
  igdi = 0;
  igssdio = 0;
  igdsdio = 0;
  igsrec = 0;
  igdrec = 0;
  if (((model_.igmod)==1))
  {
    igsi = AnalogFunctions::calc_ig<AdmsFadType>(igssdio,igsrec,vgsi,phit,(model_.vgsats),(model_.alphags),(model_.fracs),(model_.pg_params),(model_.pbdgs),(model_.vbdgs),tdut,tnomk,w,ngf,(model_.ijs),(model_.kbdgates),(model_.vgsatqs),(model_.betarecs),(model_.irecs),(model_.pgsrecs),(model_.pg_param1),(model_.vjg),(model_.type));
    igdi = AnalogFunctions::calc_ig<AdmsFadType>(igdsdio,igdrec,(vgsi-vdsi),phit,(model_.vgsatd),(model_.alphagd),(model_.fracd),(model_.pg_paramd),(model_.pbdgd),(model_.vbdgd),tdut,tnomk,w,ngf,(model_.ijd),(model_.kbdgated),(model_.vgsatqd),(model_.betarecd),(model_.irecd),(model_.pgsrecd),(model_.pg_param1),(model_.vjg),(model_.type));
    // I(gi,si) <+ ((igsi+(gmin*V(gi,si))))
    staticContributions[admsNodeID_gi] += (igsi+(gmin*(probeVars[admsProbeID_V_gi_si])));
    staticContributions[admsNodeID_si] -= (igsi+(gmin*(probeVars[admsProbeID_V_gi_si])));
    // I(gi,di) <+ ((igdi+(gmin*V(gi,di))))
    staticContributions[admsNodeID_gi] += (igdi+(gmin*(probeVars[admsProbeID_V_gi_di])));
    staticContributions[admsNodeID_di] -= (igdi+(gmin*(probeVars[admsProbeID_V_gi_di])));
  }
  if ((rcd_w<=(model_.minr)))
  {
    // V(d,drc) <+ (0)
    // do nothing at all
  }
  else
  {
    // I(d,drc) <+ ((V(d,drc)/rdi))
    staticContributions[admsNodeID_d] += ((probeVars[admsProbeID_V_d_drc])/rdi);
    staticContributions[admsNodeID_drc] -= ((probeVars[admsProbeID_V_d_drc])/rdi);
  }
  if ((rcs_w<=(model_.minr)))
  {
    // V(src,s) <+ (0)
    // do nothing at all
  }
  else
  {
    // I(src,s) <+ ((V(src,s)/rsi))
    staticContributions[admsNodeID_src] += ((probeVars[admsProbeID_V_src_s])/rsi);
    staticContributions[admsNodeID_s] -= ((probeVars[admsProbeID_V_src_s])/rsi);
  }
  if ((rg<=(model_.minr)))
  {
    // V(g,gi) <+ (0)
    // do nothing at all
  }
  else
  {
    // I(g,gi) <+ ((V(g,gi)/rg))
    staticContributions[admsNodeID_g] += ((probeVars[admsProbeID_V_g_gi])/rg);
    staticContributions[admsNodeID_gi] -= ((probeVars[admsProbeID_V_g_gi])/rg);
  }
  qofs = (((w*ngf)*(model_.cofsm))*(probeVars[admsProbeID_V_gi_s]));
  // I(gi,s) <+ (ddt(qofs))
  dynamicContributions[admsNodeID_gi] += (qofs);
  dynamicContributions[admsNodeID_s] -= (qofs);
  qofd = (((w*ngf)*(model_.cofdm))*(probeVars[admsProbeID_V_gi_d]));
  // I(gi,d) <+ (ddt(qofd))
  dynamicContributions[admsNodeID_gi] += (qofd);
  dynamicContributions[admsNodeID_d] -= (qofd);
  qofds = (((w*ngf)*(model_.cofdsm))*(probeVars[admsProbeID_V_d_s]));
  // I(d,s) <+ (ddt(qofds))
  dynamicContributions[admsNodeID_d] += (qofds);
  dynamicContributions[admsNodeID_s] -= (qofds);
  qofdsub = (((w*ngf)*(model_.cofdsubm))*(probeVars[admsProbeID_V_d_b]));
  // I(d,b) <+ (ddt(qofdsub))
  dynamicContributions[admsNodeID_d] += (qofdsub);
  dynamicContributions[admsNodeID_b] -= (qofdsub);
  qofssub = (((w*ngf)*(model_.cofssubm))*(probeVars[admsProbeID_V_s_b]));
  // I(s,b) <+ (ddt(qofssub))
  dynamicContributions[admsNodeID_s] += (qofssub);
  dynamicContributions[admsNodeID_b] -= (qofssub);
  qofgsub = (((w*ngf)*(model_.cofgsubm))*(probeVars[admsProbeID_V_gi_b]));
  // I(gi,b) <+ (ddt(qofgsub))
  dynamicContributions[admsNodeID_gi] += (qofgsub);
  dynamicContributions[admsNodeID_b] -= (qofgsub);
  gm = 0;
  svc = 0;
  if (((model_.noisemod)==1))
  {
    UserError(*this) << "$finish called." << std::endl; 
  }
  pdiss = (((((((ids*(probeVars[admsProbeID_V_di_si]))+(idsrd*(probeVars[admsProbeID_V_drc_fp4])))+(idsrs*(probeVars[admsProbeID_V_si_src])))+(idsfp1*(probeVars[admsProbeID_V_fp1_di])))+(idsfp2*(probeVars[admsProbeID_V_fp2_fp1])))+(idsfp3*(probeVars[admsProbeID_V_fp3_fp2])))+(idsfp4*(probeVars[admsProbeID_V_fp4_fp3])));
  if ((rdi!=0))
  {
    pdiss = (pdiss+(((probeVars[admsProbeID_V_drc_d])*(probeVars[admsProbeID_V_drc_d]))/rdi));
  }
  if ((rsi!=0))
  {
    pdiss = (pdiss+(((probeVars[admsProbeID_V_src_s])*(probeVars[admsProbeID_V_src_s]))/rsi));
  }
  if (((model_.rth)>0))
  {
    // Pwr(dt,GND) <+ (ddt((cth*Temp(dt,GND))))
    dynamicContributions[admsNodeID_dt] += (((model_.cth)*(probeVars[admsProbeID_Temp_dt_GND])));
    // Pwr(dt,GND) <+ ((-pdiss))
    staticContributions[admsNodeID_dt] += (-pdiss);
    // Pwr(dt,GND) <+ ((Temp(dt,GND)/rth))
    staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_Temp_dt_GND])/(model_.rth));
  }
  else
  {
    // Temp(dt,GND) <+ (0.0)
    // do nothing at all
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_drc_d] =  "
                 <<probeVars[admsProbeID_V_drc_d].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_b] =  "
                 <<probeVars[admsProbeID_V_gi_b].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_b] =  "
                 <<probeVars[admsProbeID_V_s_b].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_b] =  "
                 <<probeVars[admsProbeID_V_d_b].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_s] =  "
                 <<probeVars[admsProbeID_V_d_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_d] =  "
                 <<probeVars[admsProbeID_V_gi_d].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_s] =  "
                 <<probeVars[admsProbeID_V_gi_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_gi] =  "
                 <<probeVars[admsProbeID_V_g_gi].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_drc] =  "
                 <<probeVars[admsProbeID_V_d_drc].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xt1_GND] =  "
                 <<probeVars[admsProbeID_V_xt1_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xt2_GND] =  "
                 <<probeVars[admsProbeID_V_xt2_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_s] =  "
                 <<probeVars[admsProbeID_V_fp4_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_d] =  "
                 <<probeVars[admsProbeID_V_fp4_d].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tr_GND] =  "
                 <<probeVars[admsProbeID_V_tr_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tr1_tr] =  "
                 <<probeVars[admsProbeID_V_tr1_tr].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_g] =  "
                 <<probeVars[admsProbeID_V_d_g].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_src_s] =  "
                 <<probeVars[admsProbeID_V_src_s].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_src_d] =  "
                 <<probeVars[admsProbeID_V_src_d].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_si] =  "
                 <<probeVars[admsProbeID_V_di_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_si] =  "
                 <<probeVars[admsProbeID_V_gi_si].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_drc_fp4] =  "
                 <<probeVars[admsProbeID_V_drc_fp4].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_drc_GND] =  "
                 <<probeVars[admsProbeID_V_drc_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_GND] =  "
                 <<probeVars[admsProbeID_V_fp4_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_src] =  "
                 <<probeVars[admsProbeID_V_si_src].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_GND] =  "
                 <<probeVars[admsProbeID_V_si_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_src_GND] =  "
                 <<probeVars[admsProbeID_V_src_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_GND] =  "
                 <<probeVars[admsProbeID_V_s_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_GND] =  "
                 <<probeVars[admsProbeID_V_d_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp1_di] =  "
                 <<probeVars[admsProbeID_V_fp1_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_di] =  "
                 <<probeVars[admsProbeID_V_b_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_di] =  "
                 <<probeVars[admsProbeID_V_s_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_di] =  "
                 <<probeVars[admsProbeID_V_gi_di].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp2_fp1] =  "
                 <<probeVars[admsProbeID_V_fp2_fp1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_fp1] =  "
                 <<probeVars[admsProbeID_V_b_fp1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp1] =  "
                 <<probeVars[admsProbeID_V_s_fp1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp1] =  "
                 <<probeVars[admsProbeID_V_gi_fp1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp3_fp2] =  "
                 <<probeVars[admsProbeID_V_fp3_fp2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_fp2] =  "
                 <<probeVars[admsProbeID_V_b_fp2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp2] =  "
                 <<probeVars[admsProbeID_V_s_fp2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp2] =  "
                 <<probeVars[admsProbeID_V_gi_fp2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_dt_GND] =  "
                 <<probeVars[admsProbeID_Temp_dt_GND].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_fp3] =  "
                 <<probeVars[admsProbeID_V_fp4_fp3].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp4] =  "
                 <<probeVars[admsProbeID_V_gi_fp4].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp4] =  "
                 <<probeVars[admsProbeID_V_s_fp4].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_fp3] =  "
                 <<probeVars[admsProbeID_V_b_fp3].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp3] =  "
                 <<probeVars[admsProbeID_V_s_fp3].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp3] =  "
                 <<probeVars[admsProbeID_V_gi_fp3].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_d] =  "
                 <<staticContributions[admsNodeID_d].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_d] =  "
                 <<dynamicContributions[admsNodeID_d].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_g] =  "
                 <<staticContributions[admsNodeID_g].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_g] =  "
                 <<dynamicContributions[admsNodeID_g].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_di] =  "
                 <<staticContributions[admsNodeID_di].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_di] =  "
                 <<dynamicContributions[admsNodeID_di].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_gi] =  "
                 <<staticContributions[admsNodeID_gi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_gi] =  "
                 <<dynamicContributions[admsNodeID_gi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
                 <<staticContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
                 <<dynamicContributions[admsNodeID_si].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp1] =  "
                 <<staticContributions[admsNodeID_fp1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp1] =  "
                 <<dynamicContributions[admsNodeID_fp1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp2] =  "
                 <<staticContributions[admsNodeID_fp2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp2] =  "
                 <<dynamicContributions[admsNodeID_fp2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp3] =  "
                 <<staticContributions[admsNodeID_fp3].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp3] =  "
                 <<dynamicContributions[admsNodeID_fp3].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp4] =  "
                 <<staticContributions[admsNodeID_fp4].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp4] =  "
                 <<dynamicContributions[admsNodeID_fp4].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_drc] =  "
                 <<staticContributions[admsNodeID_drc].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_drc] =  "
                 <<dynamicContributions[admsNodeID_drc].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_src] =  "
                 <<staticContributions[admsNodeID_src].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_src] =  "
                 <<dynamicContributions[admsNodeID_src].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tr] =  "
                 <<staticContributions[admsNodeID_tr].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tr] =  "
                 <<dynamicContributions[admsNodeID_tr].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tr1] =  "
                 <<staticContributions[admsNodeID_tr1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tr1] =  "
                 <<dynamicContributions[admsNodeID_tr1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xt1] =  "
                 <<staticContributions[admsNodeID_xt1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xt1] =  "
                 <<dynamicContributions[admsNodeID_xt1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xt2] =  "
                 <<staticContributions[admsNodeID_xt2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xt2] =  "
                 <<dynamicContributions[admsNodeID_xt2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dt] =  "
                 <<staticContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_b) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_b) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_b) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_s) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_d) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_s) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_g_gi) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_drc) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_xt1_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_xt2_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr1_tr) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_g) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) =  " <<staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dt] =  "
                 <<dynamicContributions[admsNodeID_dt].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_b) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_b) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_b) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_b) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_s) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_d) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_s) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_g_gi) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_g_gi) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_drc) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_drc) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xt1_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xt1_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xt2_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xt2_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_tr1_tr) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_tr1_tr) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_g) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_g) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) =  " <<dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 18; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  if (!collapseNode_tr1)
  {
    (*f_tr1_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g);
  }
  if (!collapseNode_tr1)
  {
    (*f_tr1_Equ_g_Node_Ptr) +=  -staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g);
  }
  if (!collapseNode_tr)
  {
    (*f_tr_Equ_tr_Node_Ptr) +=  +staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND);
  }
  if (!collapseNode_dt)
  {
    (*f_fp4_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND);
  }
  if (!collapseNode_dt)
  {
    (*f_fp3_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_fp4_Equ_fp4_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_GND) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  (*f_fp4_Equ_fp3_Node_Ptr) +=  -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  (*f_fp3_Equ_fp4_Node_Ptr) +=  -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  (*f_fp3_Equ_fp3_Node_Ptr) +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  (*f_fp4_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4);
  (*f_fp3_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4);
  (*f_fp4_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4);
  (*f_fp3_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4);
  (*f_fp4_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3);
  (*f_fp3_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    (*f_gi_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_gi_Equ_gi_Node_Ptr) +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si);
  if (!collapseNode_dt)
  {
    (*f_s_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_s_Equ_s_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s);
  (*f_gi_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si);
  (*f_si_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di);
  (*f_si_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src);
  if (!collapseNode_dt)
  {
    (*f_si_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_si_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s);
  if (!collapseNode_dt)
  {
    (*f_fp2_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_fp3_Equ_fp2_Node_Ptr) +=  -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2);
  (*f_fp2_Equ_fp3_Node_Ptr) +=  -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  (*f_fp2_Equ_fp2_Node_Ptr) +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  (*f_fp2_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3);
  (*f_fp2_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3);
  (*f_fp2_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2);
  if (!collapseNode_dt)
  {
    (*f_fp1_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_fp2_Equ_fp1_Node_Ptr) +=  -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1);
  (*f_fp1_Equ_fp2_Node_Ptr) +=  -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  (*f_fp1_Equ_fp1_Node_Ptr) +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  (*f_fp1_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2);
  (*f_fp1_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2);
  (*f_fp1_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1);
  if (!collapseNode_dt)
  {
    (*f_di_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_fp1_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di);
  (*f_di_Equ_fp1_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  (*f_di_Equ_di_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  (*f_di_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1);
  (*f_di_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1);
  (*f_di_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di);
  (*f_gi_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si);
  (*f_si_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si);
  (*f_si_Equ_src_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_src_GND) -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src) +staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d) +staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s);
  (*f_src_Equ_src_Node_Ptr) +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_src_GND) -staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src) +staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d) +staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s);
  (*f_src_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s);
  (*f_si_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d);
  (*f_src_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d);
  if (!collapseNode_dt)
  {
    (*f_src_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_src_Equ_si_Node_Ptr) +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) +staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src);
  (*f_drc_Equ_fp4_Node_Ptr) +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_GND) -staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s);
  (*f_drc_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s);
  (*f_drc_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d);
  (*f_fp4_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d);
  if (!collapseNode_tr)
  {
    (*f_drc_Equ_tr_Node_Ptr) +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND);
  }
  if (!collapseNode_tr)
  {
    (*f_fp4_Equ_tr_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND);
  }
  if (!collapseNode_dt)
  {
    (*f_drc_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_drc_Equ_drc_Node_Ptr) +=  -staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_GND) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4);
  (*f_fp4_Equ_drc_Node_Ptr) +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_GND) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4);
  (*f_di_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si);
  if (!collapseNode_xt1)
  {
    if (!collapseNode_xt2)
    {
      (*f_xt1_Equ_xt2_Node_Ptr) +=  +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND);
    }
  }
  if (!collapseNode_xt1)
  {
    if (!collapseNode_dt)
    {
      (*f_xt1_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND);
    }
  }
  if (!collapseNode_xt1)
  {
    (*f_xt1_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si);
  }
  if (!collapseNode_xt1)
  {
    (*f_xt1_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si);
  }
  if (!collapseNode_xt1)
  {
    (*f_xt1_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di);
  }
  if (!collapseNode_xt2)
  {
    (*f_xt2_Equ_xt2_Node_Ptr) +=  +staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND);
  }
  if (!collapseNode_xt2)
  {
    if (!collapseNode_xt1)
    {
      (*f_xt2_Equ_xt1_Node_Ptr) +=  +staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND);
    }
  }
  if (!collapseNode_xt2)
  {
    (*f_di_Equ_xt2_Node_Ptr) +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND);
  }
  if (!collapseNode_xt2)
  {
    (*f_si_Equ_xt2_Node_Ptr) +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND);
  }
  if (!collapseNode_dt)
  {
    (*f_d_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND);
  }
  (*f_d_Equ_d_Node_Ptr) +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc);
  (*f_d_Equ_drc_Node_Ptr) +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc);
  (*f_s_Equ_src_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s);
  (*f_g_Equ_g_Node_Ptr) +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi);
  (*f_g_Equ_gi_Node_Ptr) +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi);
  (*f_gi_Equ_g_Node_Ptr) +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi);
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_dt_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_fp4_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_fp3_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_gi_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_fp2_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_fp1_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_di_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_src_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_d_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d);
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_si_Node_Ptr) +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src);
  }
  if (!collapseNode_dt)
  {
    if (!collapseNode_tr)
    {
      (*f_dt_Equ_tr_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND);
    }
  }
  if (!collapseNode_dt)
  {
    (*f_dt_Equ_drc_Node_Ptr) +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_GND) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4);
  }

#else
  //use the offsets instead of pointers
  if (!collapseNode_tr1)
  {
    dFdx[li_tr1][A_tr1_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g);
  }
  if (!collapseNode_tr1)
  {
    dFdx[li_tr1][A_tr1_Equ_g_NodeOffset] +=  -staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g);
  }
  if (!collapseNode_tr)
  {
    dFdx[li_tr][A_tr_Equ_tr_NodeOffset] +=  +staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_fp4][A_fp4_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_fp3][A_fp3_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_fp4][A_fp4_Equ_fp4_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_GND) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  dFdx[li_fp4][A_fp4_Equ_fp3_NodeOffset] +=  -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  dFdx[li_fp3][A_fp3_Equ_fp4_NodeOffset] +=  -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  dFdx[li_fp3][A_fp3_Equ_fp3_NodeOffset] +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  dFdx[li_fp4][A_fp4_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4);
  dFdx[li_fp3][A_fp3_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4);
  dFdx[li_fp4][A_fp4_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4);
  dFdx[li_fp3][A_fp3_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4);
  dFdx[li_fp4][A_fp4_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3);
  dFdx[li_fp3][A_fp3_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) +staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    dFdx[li_gi][A_gi_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si);
  if (!collapseNode_dt)
  {
    dFdx[li_s][A_s_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s);
  dFdx[li_gi][A_gi_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si);
  dFdx[li_si][A_si_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di);
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) +staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src);
  if (!collapseNode_dt)
  {
    dFdx[li_si][A_si_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s);
  if (!collapseNode_dt)
  {
    dFdx[li_fp2][A_fp2_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_fp3][A_fp3_Equ_fp2_NodeOffset] +=  -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) -staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2);
  dFdx[li_fp2][A_fp2_Equ_fp3_NodeOffset] +=  -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  dFdx[li_fp2][A_fp2_Equ_fp2_NodeOffset] +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  dFdx[li_fp2][A_fp2_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3);
  dFdx[li_fp2][A_fp2_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3);
  dFdx[li_fp2][A_fp2_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) +staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2);
  if (!collapseNode_dt)
  {
    dFdx[li_fp1][A_fp1_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_fp2][A_fp2_Equ_fp1_NodeOffset] +=  -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) -staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1);
  dFdx[li_fp1][A_fp1_Equ_fp2_NodeOffset] +=  -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  dFdx[li_fp1][A_fp1_Equ_fp1_NodeOffset] +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  dFdx[li_fp1][A_fp1_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2);
  dFdx[li_fp1][A_fp1_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2);
  dFdx[li_fp1][A_fp1_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) +staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1);
  if (!collapseNode_dt)
  {
    dFdx[li_di][A_di_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_fp1][A_fp1_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) -staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di);
  dFdx[li_di][A_di_Equ_fp1_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  dFdx[li_di][A_di_Equ_di_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di) -staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  dFdx[li_di][A_di_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1);
  dFdx[li_di][A_di_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) +staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1);
  dFdx[li_di][A_di_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di);
  dFdx[li_gi][A_gi_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si);
  dFdx[li_si][A_si_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si);
  dFdx[li_si][A_si_Equ_src_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_src_GND) -staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src) +staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d) +staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s);
  dFdx[li_src][A_src_Equ_src_NodeOffset] +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_src_GND) -staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src) +staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d) +staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s);
  dFdx[li_src][A_src_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s);
  dFdx[li_si][A_si_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d);
  dFdx[li_src][A_src_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d);
  if (!collapseNode_dt)
  {
    dFdx[li_src][A_src_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_src][A_src_Equ_si_NodeOffset] +=  +staticContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) +staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src);
  dFdx[li_drc][A_drc_Equ_fp4_NodeOffset] +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_GND) -staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s);
  dFdx[li_drc][A_drc_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s);
  dFdx[li_drc][A_drc_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d);
  dFdx[li_fp4][A_fp4_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d);
  if (!collapseNode_tr)
  {
    dFdx[li_drc][A_drc_Equ_tr_NodeOffset] +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND);
  }
  if (!collapseNode_tr)
  {
    dFdx[li_fp4][A_fp4_Equ_tr_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_drc][A_drc_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_drc][A_drc_Equ_drc_NodeOffset] +=  -staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_GND) +staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4);
  dFdx[li_fp4][A_fp4_Equ_drc_NodeOffset] +=  +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_GND) +staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4);
  dFdx[li_di][A_di_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si);
  if (!collapseNode_xt1)
  {
    if (!collapseNode_xt2)
    {
      dFdx[li_xt1][A_xt1_Equ_xt2_NodeOffset] +=  +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND);
    }
  }
  if (!collapseNode_xt1)
  {
    if (!collapseNode_dt)
    {
      dFdx[li_xt1][A_xt1_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND);
    }
  }
  if (!collapseNode_xt1)
  {
    dFdx[li_xt1][A_xt1_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si);
  }
  if (!collapseNode_xt1)
  {
    dFdx[li_xt1][A_xt1_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si);
  }
  if (!collapseNode_xt1)
  {
    dFdx[li_xt1][A_xt1_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di);
  }
  if (!collapseNode_xt2)
  {
    dFdx[li_xt2][A_xt2_Equ_xt2_NodeOffset] +=  +staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND);
  }
  if (!collapseNode_xt2)
  {
    if (!collapseNode_xt1)
    {
      dFdx[li_xt2][A_xt2_Equ_xt1_NodeOffset] +=  +staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND);
    }
  }
  if (!collapseNode_xt2)
  {
    dFdx[li_di][A_di_Equ_xt2_NodeOffset] +=  +staticContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND);
  }
  if (!collapseNode_xt2)
  {
    dFdx[li_si][A_si_Equ_xt2_NodeOffset] +=  +staticContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_d][A_d_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND);
  }
  dFdx[li_d][A_d_Equ_d_NodeOffset] +=  +staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc);
  dFdx[li_d][A_d_Equ_drc_NodeOffset] +=  -staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc);
  dFdx[li_s][A_s_Equ_src_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s);
  dFdx[li_g][A_g_Equ_g_NodeOffset] +=  +staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi);
  dFdx[li_g][A_g_Equ_gi_NodeOffset] +=  -staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi);
  dFdx[li_gi][A_gi_Equ_g_NodeOffset] +=  +staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi);
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_fp4_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_fp3_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_gi_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_fp2_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_fp1_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_di_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_src_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_d_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_GND) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d);
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_si_NodeOffset] +=  -staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) -staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src);
  }
  if (!collapseNode_dt)
  {
    if (!collapseNode_tr)
    {
      dFdx[li_dt][A_dt_Equ_tr_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND);
    }
  }
  if (!collapseNode_dt)
  {
    dFdx[li_dt][A_dt_Equ_drc_NodeOffset] +=  +staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_GND) +staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4);
  }

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  if (!collapseNode_tr1)
  {
    (*q_tr1_Equ_tr1_Node_Ptr) +=  +dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr);
  }
  if (!collapseNode_tr1)
  {
    if (!collapseNode_tr)
    {
      (*q_tr1_Equ_tr_Node_Ptr) +=  -dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr);
    }
  }
  if (!collapseNode_tr)
  {
    if (!collapseNode_tr1)
    {
      (*q_tr_Equ_tr1_Node_Ptr) +=  +dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr);
    }
  }
  if (!collapseNode_tr)
  {
    (*q_tr_Equ_tr_Node_Ptr) +=  +dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) -dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr);
  }
  if (!collapseNode_dt)
  {
    (*q_fp4_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND);
  }
  if (!collapseNode_dt)
  {
    (*q_fp3_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_fp4_Equ_fp4_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  (*q_fp4_Equ_fp3_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  (*q_fp3_Equ_fp4_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  (*q_fp3_Equ_fp3_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  (*q_fp4_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4);
  (*q_fp3_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4);
  (*q_fp4_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4);
  (*q_fp3_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4);
  (*q_fp4_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3);
  (*q_fp3_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    (*q_gi_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_gi_Equ_fp4_Node_Ptr) +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3);
  (*q_gi_Equ_fp3_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3);
  (*q_gi_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4);
  (*q_gi_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4);
  (*q_gi_Equ_b_Node_Ptr) +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    (*q_s_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_s_Equ_fp4_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3);
  (*q_s_Equ_fp3_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3);
  (*q_s_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4);
  (*q_s_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4);
  (*q_s_Equ_b_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3);
  (*q_gi_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si);
  (*q_si_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si);
  (*q_si_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si);
  if (!collapseNode_dt)
  {
    (*q_si_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_si_Equ_fp4_Node_Ptr) +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3);
  (*q_si_Equ_fp3_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3);
  (*q_si_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4);
  (*q_si_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    (*q_b_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_b_Equ_fp4_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3);
  (*q_b_Equ_fp3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3);
  (*q_b_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4);
  (*q_b_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4);
  (*q_b_Equ_b_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    (*q_fp2_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_fp3_Equ_fp2_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2);
  (*q_fp2_Equ_fp3_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  (*q_fp2_Equ_fp2_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  (*q_fp2_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3);
  (*q_fp2_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3);
  (*q_fp2_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2);
  (*q_gi_Equ_fp2_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2);
  (*q_s_Equ_fp2_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2);
  (*q_si_Equ_fp2_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2);
  (*q_b_Equ_fp2_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2);
  if (!collapseNode_dt)
  {
    (*q_fp1_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_fp2_Equ_fp1_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1);
  (*q_fp1_Equ_fp2_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  (*q_fp1_Equ_fp1_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  (*q_fp1_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2);
  (*q_fp1_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2);
  (*q_fp1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1);
  (*q_gi_Equ_fp1_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1);
  (*q_s_Equ_fp1_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1);
  (*q_si_Equ_fp1_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1);
  (*q_b_Equ_fp1_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1);
  if (!collapseNode_dt)
  {
    (*q_di_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND);
  }
  (*q_fp1_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di);
  (*q_di_Equ_fp1_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  (*q_di_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  (*q_di_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1);
  (*q_di_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1);
  (*q_di_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di);
  (*q_gi_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di);
  (*q_s_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di);
  (*q_si_Equ_di_Node_Ptr) +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di);
  (*q_b_Equ_di_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di);
  (*q_di_Equ_si_Node_Ptr) +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si);
  if (!collapseNode_xt1)
  {
    (*q_xt1_Equ_xt1_Node_Ptr) +=  +dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND);
  }
  if (!collapseNode_xt2)
  {
    (*q_xt2_Equ_xt2_Node_Ptr) +=  +dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND);
  }
  (*q_d_Equ_d_Node_Ptr) +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d);
  (*q_gi_Equ_d_Node_Ptr) +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d);
  (*q_d_Equ_gi_Node_Ptr) +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d);
  (*q_d_Equ_s_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s);
  (*q_s_Equ_d_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s);
  (*q_d_Equ_b_Node_Ptr) +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b);
  (*q_b_Equ_d_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b);
  if (!collapseNode_dt)
  {
    (*q_dt_Equ_dt_Node_Ptr) +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  }

#else
  //use the offsets instead of pointers
  if (!collapseNode_tr1)
  {
    dQdx[li_tr1][A_tr1_Equ_tr1_NodeOffset] +=  +dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr);
  }
  if (!collapseNode_tr1)
  {
    if (!collapseNode_tr)
    {
      dQdx[li_tr1][A_tr1_Equ_tr_NodeOffset] +=  -dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr);
    }
  }
  if (!collapseNode_tr)
  {
    if (!collapseNode_tr1)
    {
      dQdx[li_tr][A_tr_Equ_tr1_NodeOffset] +=  +dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr);
    }
  }
  if (!collapseNode_tr)
  {
    dQdx[li_tr][A_tr_Equ_tr_NodeOffset] +=  +dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) -dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr);
  }
  if (!collapseNode_dt)
  {
    dQdx[li_fp4][A_fp4_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND);
  }
  if (!collapseNode_dt)
  {
    dQdx[li_fp3][A_fp3_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_fp4][A_fp4_Equ_fp4_NodeOffset] +=  -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_fp4][A_fp4_Equ_fp3_NodeOffset] +=  -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_fp3][A_fp3_Equ_fp4_NodeOffset] +=  -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_fp3][A_fp3_Equ_fp3_NodeOffset] +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_fp4][A_fp4_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4);
  dQdx[li_fp3][A_fp3_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4);
  dQdx[li_fp4][A_fp4_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4);
  dQdx[li_fp3][A_fp3_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4);
  dQdx[li_fp4][A_fp4_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3);
  dQdx[li_fp3][A_fp3_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    dQdx[li_gi][A_gi_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_gi][A_gi_Equ_fp4_NodeOffset] +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_gi][A_gi_Equ_fp3_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4);
  dQdx[li_gi][A_gi_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4);
  dQdx[li_gi][A_gi_Equ_b_NodeOffset] +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    dQdx[li_s][A_s_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_s][A_s_Equ_fp4_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_s][A_s_Equ_fp3_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_s][A_s_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4);
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4);
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3);
  dQdx[li_gi][A_gi_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si);
  dQdx[li_si][A_si_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si);
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si);
  if (!collapseNode_dt)
  {
    dQdx[li_si][A_si_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_si][A_si_Equ_fp4_NodeOffset] +=  -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_si][A_si_Equ_fp3_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_si][A_si_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4);
  dQdx[li_si][A_si_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    dQdx[li_b][A_b_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_b][A_b_Equ_fp4_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_b][A_b_Equ_fp3_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3);
  dQdx[li_b][A_b_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4);
  dQdx[li_b][A_b_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3);
  if (!collapseNode_dt)
  {
    dQdx[li_fp2][A_fp2_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_fp3][A_fp3_Equ_fp2_NodeOffset] +=  -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2);
  dQdx[li_fp2][A_fp2_Equ_fp3_NodeOffset] +=  -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  dQdx[li_fp2][A_fp2_Equ_fp2_NodeOffset] +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2);
  dQdx[li_fp2][A_fp2_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3);
  dQdx[li_fp2][A_fp2_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3);
  dQdx[li_fp2][A_fp2_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) +dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2);
  dQdx[li_gi][A_gi_Equ_fp2_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2);
  dQdx[li_s][A_s_Equ_fp2_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2);
  dQdx[li_si][A_si_Equ_fp2_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2);
  dQdx[li_b][A_b_Equ_fp2_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2);
  if (!collapseNode_dt)
  {
    dQdx[li_fp1][A_fp1_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_fp2][A_fp2_Equ_fp1_NodeOffset] +=  -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1);
  dQdx[li_fp1][A_fp1_Equ_fp2_NodeOffset] +=  -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  dQdx[li_fp1][A_fp1_Equ_fp1_NodeOffset] +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1);
  dQdx[li_fp1][A_fp1_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2);
  dQdx[li_fp1][A_fp1_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2);
  dQdx[li_fp1][A_fp1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) +dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1);
  dQdx[li_gi][A_gi_Equ_fp1_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1);
  dQdx[li_s][A_s_Equ_fp1_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1);
  dQdx[li_si][A_si_Equ_fp1_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1);
  dQdx[li_b][A_b_Equ_fp1_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1);
  if (!collapseNode_dt)
  {
    dQdx[li_di][A_di_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND);
  }
  dQdx[li_fp1][A_fp1_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di);
  dQdx[li_di][A_di_Equ_fp1_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  dQdx[li_di][A_di_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di);
  dQdx[li_di][A_di_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1);
  dQdx[li_di][A_di_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1);
  dQdx[li_di][A_di_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di);
  dQdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di);
  dQdx[li_s][A_s_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di);
  dQdx[li_si][A_si_Equ_di_NodeOffset] +=  +dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di);
  dQdx[li_b][A_b_Equ_di_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di);
  dQdx[li_di][A_di_Equ_si_NodeOffset] +=  -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) -dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si);
  if (!collapseNode_xt1)
  {
    dQdx[li_xt1][A_xt1_Equ_xt1_NodeOffset] +=  +dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND);
  }
  if (!collapseNode_xt2)
  {
    dQdx[li_xt2][A_xt2_Equ_xt2_NodeOffset] +=  +dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND);
  }
  dQdx[li_d][A_d_Equ_d_NodeOffset] +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b) +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d);
  dQdx[li_gi][A_gi_Equ_d_NodeOffset] +=  -dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d);
  dQdx[li_d][A_d_Equ_gi_NodeOffset] +=  +dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d);
  dQdx[li_d][A_d_Equ_s_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s);
  dQdx[li_s][A_s_Equ_d_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s);
  dQdx[li_d][A_d_Equ_b_NodeOffset] +=  -dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b);
  dQdx[li_b][A_b_Equ_d_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b);
  if (!collapseNode_dt)
  {
    dQdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND);
  }


#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pmos" || getType() == "PMOS")
    type = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter version : [ 0,  (+inf) [
  if ( (!((version >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter version value " << version << " out of range [ 0,  (+inf) [";
  }

  //    Parameter tnom : [ (-273.15),  (+inf) [
  if ( (!((tnom >=(-273.15)))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter tnom value " << tnom << " out of range [ (-273.15),  (+inf) [";
  }

  //    Parameter type : [ (-1), 1 ]] 0, 0 [
  if ( (!((type >=(-1) && type <=1 )) || (type >0 && type <0 )) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter type value " << type << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter cg : ] 0,  (+inf) [
  if ( (!((cg >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cg value " << cg << " out of range ] 0,  (+inf) [";
  }

  //    Parameter cofsm : [ 0,  (+inf) [
  if ( (!((cofsm >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cofsm value " << cofsm << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cofdm : [ 0,  (+inf) [
  if ( (!((cofdm >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cofdm value " << cofdm << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cofdsm : [ 0,  (+inf) [
  if ( (!((cofdsm >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cofdsm value " << cofdsm << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cofdsubm : [ 0,  (+inf) [
  if ( (!((cofdsubm >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cofdsubm value " << cofdsubm << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cofssubm : [ 0,  (+inf) [
  if ( (!((cofssubm >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cofssubm value " << cofssubm << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cofgsubm : [ 0,  (+inf) [
  if ( (!((cofgsubm >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cofgsubm value " << cofgsubm << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rsh : [ 0,  (+inf) [
  if ( (!((rsh >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter rsh value " << rsh << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rcs : [ 0,  (+inf) [
  if ( (!((rcs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter rcs value " << rcs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rcd : [ 0,  (+inf) [
  if ( (!((rcd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter rcd value " << rcd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vx0 : ] 0,  (+inf) [
  if ( (!((vx0 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0 value " << vx0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0 : ] 0,  (+inf) [
  if ( (!((mu0 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0 value " << mu0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter beta : ] 0,  (+inf) [
  if ( (!((beta >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter beta value " << beta << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ss : ] 0,  (+inf) [
  if ( (!((ss >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ss value " << ss << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1 : [ 0,  (+inf) [
  if ( (!((delta1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1 value " << delta1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter delta2 : [ 0,  (+inf) [
  if ( (!((delta2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta2 value " << delta2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter dibsat : [ 0,  (+inf) [
  if ( (!((dibsat >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter dibsat value " << dibsat << " out of range [ 0,  (+inf) [";
  }

  //    Parameter nd : [ 0,  (+inf) [
  if ( (!((nd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter nd value " << nd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alpha : ] 0,  (+inf) [
  if ( (!((alpha >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alpha value " << alpha << " out of range ] 0,  (+inf) [";
  }

  //    Parameter lambda : [ 0,  (+inf) [
  if ( (!((lambda >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lambda value " << lambda << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vtheta : [ 0,  (+inf) [
  if ( (!((vtheta >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vtheta value " << vtheta << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mtheta : [ 0,  (+inf) [
  if ( (!((mtheta >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mtheta value " << mtheta << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vzeta : [ 0,  (+inf) [
  if ( (!((vzeta >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vzeta value " << vzeta << " out of range [ 0,  (+inf) [";
  }

  //    Parameter epsilon : [ 0,  (+inf) [
  if ( (!((epsilon >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter epsilon value " << epsilon << " out of range [ 0,  (+inf) [";
  }

  //    Parameter flagres : [ 0, 1 ]
  if ( (!((flagres >=0 && flagres <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagres value " << flagres << " out of range [ 0, 1 ]";
  }

  //    Parameter lgs : [ 0,  (+inf) [
  if ( (!((lgs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lgs value " << lgs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cgrs : ] 0,  (+inf) [
  if ( (!((cgrs >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cgrs value " << cgrs << " out of range ] 0,  (+inf) [";
  }

  //    Parameter vx0rs : ] 0,  (+inf) [
  if ( (!((vx0rs >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0rs value " << vx0rs << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0rs : ] 0,  (+inf) [
  if ( (!((mu0rs >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0rs value " << mu0rs << " out of range ] 0,  (+inf) [";
  }

  //    Parameter betars : ] 0,  (+inf) [
  if ( (!((betars >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betars value " << betars << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1rs : [ 0,  (+inf) [
  if ( (!((delta1rs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1rs value " << delta1rs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter srs : ] 0,  (+inf) [
  if ( (!((srs >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter srs value " << srs << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ndrs : [ 0,  (+inf) [
  if ( (!((ndrs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ndrs value " << ndrs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vthetars : [ 0,  (+inf) [
  if ( (!((vthetars >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vthetars value " << vthetars << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mthetars : [ 0,  (+inf) [
  if ( (!((mthetars >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mthetars value " << mthetars << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphars : ] 0,  (+inf) [
  if ( (!((alphars >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphars value " << alphars << " out of range ] 0,  (+inf) [";
  }

  //    Parameter lgd : [ 0,  (+inf) [
  if ( (!((lgd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lgd value " << lgd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cgrd : ] 0,  (+inf) [
  if ( (!((cgrd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cgrd value " << cgrd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter vx0rd : ] 0,  (+inf) [
  if ( (!((vx0rd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0rd value " << vx0rd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0rd : ] 0,  (+inf) [
  if ( (!((mu0rd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0rd value " << mu0rd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter betard : ] 0,  (+inf) [
  if ( (!((betard >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betard value " << betard << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1rd : [ 0,  (+inf) [
  if ( (!((delta1rd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1rd value " << delta1rd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter srd : ] 0,  (+inf) [
  if ( (!((srd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter srd value " << srd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ndrd : [ 0,  (+inf) [
  if ( (!((ndrd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ndrd value " << ndrd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vthetard : [ 0,  (+inf) [
  if ( (!((vthetard >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vthetard value " << vthetard << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mthetard : [ 0,  (+inf) [
  if ( (!((mthetard >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mthetard value " << mthetard << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphard : ] 0,  (+inf) [
  if ( (!((alphard >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphard value " << alphard << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp1 : [ 0, 1 ]
  if ( (!((flagfp1 >=0 && flagfp1 <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp1 value " << flagfp1 << " out of range [ 0, 1 ]";
  }

  //    Parameter lgfp1 : [ 0,  (+inf) [
  if ( (!((lgfp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lgfp1 value " << lgfp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cgfp1 : ] 0,  (+inf) [
  if ( (!((cgfp1 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cgfp1 value " << cgfp1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp1s : [ 0, 1 ]
  if ( (!((flagfp1s >=0 && flagfp1s <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp1s value " << flagfp1s << " out of range [ 0, 1 ]";
  }

  //    Parameter cfp1s : [ 0,  (+inf) [
  if ( (!((cfp1s >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cfp1s value " << cfp1s << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ccfp1 : [ 0,  (+inf) [
  if ( (!((ccfp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ccfp1 value " << ccfp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cbfp1 : [ 0,  (+inf) [
  if ( (!((cbfp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cbfp1 value " << cbfp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vx0fp1 : ] 0,  (+inf) [
  if ( (!((vx0fp1 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0fp1 value " << vx0fp1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0fp1 : ] 0,  (+inf) [
  if ( (!((mu0fp1 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0fp1 value " << mu0fp1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter betafp1 : ] 0,  (+inf) [
  if ( (!((betafp1 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betafp1 value " << betafp1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1fp1 : [ 0,  (+inf) [
  if ( (!((delta1fp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1fp1 value " << delta1fp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter sfp1 : ] 0,  (+inf) [
  if ( (!((sfp1 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter sfp1 value " << sfp1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ndfp1 : [ 0,  (+inf) [
  if ( (!((ndfp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ndfp1 value " << ndfp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vthetafp1 : [ 0,  (+inf) [
  if ( (!((vthetafp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vthetafp1 value " << vthetafp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mthetafp1 : [ 0,  (+inf) [
  if ( (!((mthetafp1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mthetafp1 value " << mthetafp1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphafp1 : ] 0,  (+inf) [
  if ( (!((alphafp1 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphafp1 value " << alphafp1 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp2 : [ 0, 1 ]
  if ( (!((flagfp2 >=0 && flagfp2 <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp2 value " << flagfp2 << " out of range [ 0, 1 ]";
  }

  //    Parameter lgfp2 : [ 0,  (+inf) [
  if ( (!((lgfp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lgfp2 value " << lgfp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cgfp2 : ] 0,  (+inf) [
  if ( (!((cgfp2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cgfp2 value " << cgfp2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp2s : [ 0, 1 ]
  if ( (!((flagfp2s >=0 && flagfp2s <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp2s value " << flagfp2s << " out of range [ 0, 1 ]";
  }

  //    Parameter cfp2s : [ 0,  (+inf) [
  if ( (!((cfp2s >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cfp2s value " << cfp2s << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ccfp2 : [ 0,  (+inf) [
  if ( (!((ccfp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ccfp2 value " << ccfp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cbfp2 : [ 0,  (+inf) [
  if ( (!((cbfp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cbfp2 value " << cbfp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vx0fp2 : ] 0,  (+inf) [
  if ( (!((vx0fp2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0fp2 value " << vx0fp2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0fp2 : ] 0,  (+inf) [
  if ( (!((mu0fp2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0fp2 value " << mu0fp2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter betafp2 : ] 0,  (+inf) [
  if ( (!((betafp2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betafp2 value " << betafp2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1fp2 : [ 0,  (+inf) [
  if ( (!((delta1fp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1fp2 value " << delta1fp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter sfp2 : ] 0,  (+inf) [
  if ( (!((sfp2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter sfp2 value " << sfp2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ndfp2 : [ 0,  (+inf) [
  if ( (!((ndfp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ndfp2 value " << ndfp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vthetafp2 : [ 0,  (+inf) [
  if ( (!((vthetafp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vthetafp2 value " << vthetafp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mthetafp2 : [ 0,  (+inf) [
  if ( (!((mthetafp2 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mthetafp2 value " << mthetafp2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphafp2 : ] 0,  (+inf) [
  if ( (!((alphafp2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphafp2 value " << alphafp2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp3 : [ 0, 1 ]
  if ( (!((flagfp3 >=0 && flagfp3 <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp3 value " << flagfp3 << " out of range [ 0, 1 ]";
  }

  //    Parameter lgfp3 : [ 0,  (+inf) [
  if ( (!((lgfp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lgfp3 value " << lgfp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cgfp3 : ] 0,  (+inf) [
  if ( (!((cgfp3 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cgfp3 value " << cgfp3 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp3s : [ 0, 1 ]
  if ( (!((flagfp3s >=0 && flagfp3s <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp3s value " << flagfp3s << " out of range [ 0, 1 ]";
  }

  //    Parameter cfp3s : [ 0,  (+inf) [
  if ( (!((cfp3s >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cfp3s value " << cfp3s << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ccfp3 : [ 0,  (+inf) [
  if ( (!((ccfp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ccfp3 value " << ccfp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cbfp3 : [ 0,  (+inf) [
  if ( (!((cbfp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cbfp3 value " << cbfp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vx0fp3 : ] 0,  (+inf) [
  if ( (!((vx0fp3 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0fp3 value " << vx0fp3 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0fp3 : ] 0,  (+inf) [
  if ( (!((mu0fp3 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0fp3 value " << mu0fp3 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter betafp3 : ] 0,  (+inf) [
  if ( (!((betafp3 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betafp3 value " << betafp3 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1fp3 : [ 0,  (+inf) [
  if ( (!((delta1fp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1fp3 value " << delta1fp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter sfp3 : ] 0,  (+inf) [
  if ( (!((sfp3 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter sfp3 value " << sfp3 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ndfp3 : [ 0,  (+inf) [
  if ( (!((ndfp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ndfp3 value " << ndfp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vthetafp3 : [ 0,  (+inf) [
  if ( (!((vthetafp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vthetafp3 value " << vthetafp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mthetafp3 : [ 0,  (+inf) [
  if ( (!((mthetafp3 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mthetafp3 value " << mthetafp3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphafp3 : ] 0,  (+inf) [
  if ( (!((alphafp3 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphafp3 value " << alphafp3 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp4 : [ 0, 1 ]
  if ( (!((flagfp4 >=0 && flagfp4 <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp4 value " << flagfp4 << " out of range [ 0, 1 ]";
  }

  //    Parameter lgfp4 : [ 0,  (+inf) [
  if ( (!((lgfp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter lgfp4 value " << lgfp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cgfp4 : ] 0,  (+inf) [
  if ( (!((cgfp4 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cgfp4 value " << cgfp4 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter flagfp4s : [ 0, 1 ]
  if ( (!((flagfp4s >=0 && flagfp4s <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter flagfp4s value " << flagfp4s << " out of range [ 0, 1 ]";
  }

  //    Parameter cfp4s : [ 0,  (+inf) [
  if ( (!((cfp4s >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cfp4s value " << cfp4s << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ccfp4 : [ 0,  (+inf) [
  if ( (!((ccfp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ccfp4 value " << ccfp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cbfp4 : [ 0,  (+inf) [
  if ( (!((cbfp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cbfp4 value " << cbfp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vx0fp4 : ] 0,  (+inf) [
  if ( (!((vx0fp4 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vx0fp4 value " << vx0fp4 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter mu0fp4 : ] 0,  (+inf) [
  if ( (!((mu0fp4 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mu0fp4 value " << mu0fp4 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter betafp4 : ] 0,  (+inf) [
  if ( (!((betafp4 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betafp4 value " << betafp4 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter delta1fp4 : [ 0,  (+inf) [
  if ( (!((delta1fp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter delta1fp4 value " << delta1fp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter sfp4 : ] 0,  (+inf) [
  if ( (!((sfp4 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter sfp4 value " << sfp4 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter ndfp4 : [ 0,  (+inf) [
  if ( (!((ndfp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ndfp4 value " << ndfp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vthetafp4 : [ 0,  (+inf) [
  if ( (!((vthetafp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vthetafp4 value " << vthetafp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter mthetafp4 : [ 0,  (+inf) [
  if ( (!((mthetafp4 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter mthetafp4 value " << mthetafp4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphafp4 : ] 0,  (+inf) [
  if ( (!((alphafp4 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphafp4 value " << alphafp4 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter igmod : [ 0, 1 ]
  if ( (!((igmod >=0 && igmod <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter igmod value " << igmod << " out of range [ 0, 1 ]";
  }

  //    Parameter rgsp : [ 0,  (+inf) [
  if ( (!((rgsp >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter rgsp value " << rgsp << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vjg : ] 0,  (+inf) [
  if ( (!((vjg >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vjg value " << vjg << " out of range ] 0,  (+inf) [";
  }

  //    Parameter pg_param1 : [ 0,  (+inf) [
  if ( (!((pg_param1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pg_param1 value " << pg_param1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter pg_params : [ 0,  (+inf) [
  if ( (!((pg_params >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pg_params value " << pg_params << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ijs : [ 0,  (+inf) [
  if ( (!((ijs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ijs value " << ijs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vgsats : [ 0,  (+inf) [
  if ( (!((vgsats >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vgsats value " << vgsats << " out of range [ 0,  (+inf) [";
  }

  //    Parameter fracs : [ 0,  (+inf) [
  if ( (!((fracs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter fracs value " << fracs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphags : ] 0,  (+inf) [
  if ( (!((alphags >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphags value " << alphags << " out of range ] 0,  (+inf) [";
  }

  //    Parameter pg_paramd : [ 0,  (+inf) [
  if ( (!((pg_paramd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pg_paramd value " << pg_paramd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ijd : [ 0,  (+inf) [
  if ( (!((ijd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ijd value " << ijd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vgsatd : [ 0,  (+inf) [
  if ( (!((vgsatd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vgsatd value " << vgsatd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter fracd : [ 0,  (+inf) [
  if ( (!((fracd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter fracd value " << fracd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphagd : ] 0,  (+inf) [
  if ( (!((alphagd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphagd value " << alphagd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter pgsrecs : [ 0,  (+inf) [
  if ( (!((pgsrecs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pgsrecs value " << pgsrecs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter irecs : [ 0,  (+inf) [
  if ( (!((irecs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter irecs value " << irecs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vgsatqs : ] 0,  (+inf) [
  if ( (!((vgsatqs >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vgsatqs value " << vgsatqs << " out of range ] 0,  (+inf) [";
  }

  //    Parameter vbdgs : [ 0,  (+inf) [
  if ( (!((vbdgs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vbdgs value " << vbdgs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter pbdgs : [ 0,  (+inf) [
  if ( (!((pbdgs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pbdgs value " << pbdgs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter betarecs : ] 0,  (+inf) [
  if ( (!((betarecs >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betarecs value " << betarecs << " out of range ] 0,  (+inf) [";
  }

  //    Parameter kbdgates : [ 0,  (+inf) [
  if ( (!((kbdgates >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter kbdgates value " << kbdgates << " out of range [ 0,  (+inf) [";
  }

  //    Parameter pgsrecd : [ 0,  (+inf) [
  if ( (!((pgsrecd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pgsrecd value " << pgsrecd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter irecd : [ 0,  (+inf) [
  if ( (!((irecd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter irecd value " << irecd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vgsatqd : ] 0,  (+inf) [
  if ( (!((vgsatqd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vgsatqd value " << vgsatqd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter vbdgd : [ 0,  (+inf) [
  if ( (!((vbdgd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vbdgd value " << vbdgd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter pbdgd : [ 0,  (+inf) [
  if ( (!((pbdgd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter pbdgd value " << pbdgd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter betarecd : ] 0,  (+inf) [
  if ( (!((betarecd >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter betarecd value " << betarecd << " out of range ] 0,  (+inf) [";
  }

  //    Parameter kbdgated : [ 0,  (+inf) [
  if ( (!((kbdgated >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter kbdgated value " << kbdgated << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rth : [ 0,  (+inf) [
  if ( (!((rth >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter rth value " << rth << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cth : [ 0,  (+inf) [
  if ( (!((cth >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter cth value " << cth << " out of range [ 0,  (+inf) [";
  }

  //    Parameter gmdisp : [ 0, 1 ]
  if ( (!((gmdisp >=0 && gmdisp <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter gmdisp value " << gmdisp << " out of range [ 0, 1 ]";
  }

  //    Parameter taugmrf : [ 0,  (+inf) [
  if ( (!((taugmrf >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter taugmrf value " << taugmrf << " out of range [ 0,  (+inf) [";
  }

  //    Parameter trapselect : [ 0, 1 ]
  if ( (!((trapselect >=0 && trapselect <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter trapselect value " << trapselect << " out of range [ 0, 1 ]";
  }

  //    Parameter ctrap : [ 0,  (+inf) [
  if ( (!((ctrap >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ctrap value " << ctrap << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vttrap : [ 0,  (+inf) [
  if ( (!((vttrap >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter vttrap value " << vttrap << " out of range [ 0,  (+inf) [";
  }

  //    Parameter taut : [ 0,  (+inf) [
  if ( (!((taut >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter taut value " << taut << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphat1 : [ 0,  (+inf) [
  if ( (!((alphat1 >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphat1 value " << alphat1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alphat2 : ] 0,  (+inf) [
  if ( (!((alphat2 >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter alphat2 value " << alphat2 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter tempt : [ 0,  (+inf) [
  if ( (!((tempt >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter tempt value " << tempt << " out of range [ 0,  (+inf) [";
  }

  //    Parameter noisemod : [ 0, 1 ]
  if ( (!((noisemod >=0 && noisemod <=1 ))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter noisemod value " << noisemod << " out of range [ 0, 1 ]";
  }

  //    Parameter shs : [ 0,  (+inf) [
  if ( (!((shs >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter shs value " << shs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter shd : [ 0,  (+inf) [
  if ( (!((shd >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter shd value " << shd << " out of range [ 0,  (+inf) [";
  }

  //    Parameter kf : [ 0,  (+inf) [
  if ( (!((kf >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter kf value " << kf << " out of range [ 0,  (+inf) [";
  }

  //    Parameter af : [ 0,  (+inf) [
  if ( (!((af >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter af value " << af << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ffe : ] 0,  (+inf) [
  if ( (!((ffe >0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter ffe value " << ffe << " out of range ] 0,  (+inf) [";
  }

  //    Parameter minr : [ 0,  (+inf) [
  if ( (!((minr >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter minr value " << minr << " out of range [ 0,  (+inf) [";
  }

  //    Parameter minl : [ 0,  (+inf) [
  if ( (!((minl >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter minl value " << minl << " out of range [ 0,  (+inf) [";
  }

  //    Parameter minc : [ 0,  (+inf) [
  if ( (!((minc >=0))) )
  {
    UserError(*this) << "ADMSmvsg_cmc: Parameter minc value " << minc << " out of range [ 0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    version(1.00),
    tnom(27.0),
    type(1),
    cg(4.00e-03),
    cofsm(1.0e-9),
    cofdm(1.0e-10),
    cofdsm(1.0e-10),
    cofdsubm(0.0),
    cofssubm(0.0),
    cofgsubm(0.0),
    rsh(150.0),
    rcs(800e-6),
    rcd(800e-6),
    vx0(3.0e5),
    mu0(0.135),
    beta(1.50),
    vto((-2.72)),
    ss(0.120),
    delta1(16e-3),
    delta2(0.0),
    dibsat(10.0),
    nd(0.0),
    alpha(3.5),
    lambda(0.0),
    vtheta(0.0),
    mtheta(0.0),
    vzeta(150e3),
    vtzeta((-0.4e-3)),
    epsilon(2.3),
    rct1(0.0),
    rct2(0.0),
    flagres(0),
    lgs(3.0e-6),
    vtors((-650)),
    cgrs(5.0e-3),
    vx0rs(100e3),
    mu0rs(100e-3),
    betars(1.00),
    delta1rs(100e-3),
    srs(0.100),
    ndrs(0.0),
    vthetars(0.0),
    mthetars(0.0),
    alphars(3.5),
    lgd(4.85e-6),
    vtord((-650)),
    cgrd(4.3e-3),
    vx0rd(100e3),
    mu0rd(100e-3),
    betard(1.00),
    delta1rd(0.35),
    srd(0.3),
    ndrd(3.8),
    vthetard(0.0),
    mthetard(0.0),
    alphard(3.5),
    flagfp1(1),
    lgfp1(0.0),
    vtofp1((-44.5)),
    cgfp1(2.0e-4),
    flagfp1s(1),
    cfp1s(1e-19),
    ccfp1(0.9e-10),
    cbfp1(0.0),
    vx0fp1(1.2e5),
    mu0fp1(0.2),
    betafp1(1.00),
    delta1fp1(0.0),
    sfp1(3.2),
    ndfp1(0.0),
    vthetafp1(0.0),
    mthetafp1(0.0),
    alphafp1(1e-2),
    flagfp2(0),
    lgfp2(0.0),
    vtofp2((-74.5)),
    cgfp2(1.0e-4),
    flagfp2s(1),
    cfp2s(1e-19),
    ccfp2(0.3e-10),
    cbfp2(0.0),
    vx0fp2(1.2e5),
    mu0fp2(0.2),
    betafp2(1.00),
    delta1fp2(0.0),
    sfp2(3.2),
    ndfp2(0.0),
    vthetafp2(0.0),
    mthetafp2(0.0),
    alphafp2(1e-2),
    flagfp3(0),
    lgfp3(0.0),
    vtofp3((-44.5)),
    cgfp3(2.0e-4),
    flagfp3s(1),
    cfp3s(1e-19),
    ccfp3(0.9e-10),
    cbfp3(0.0),
    vx0fp3(1.2e5),
    mu0fp3(0.2),
    betafp3(1.00),
    delta1fp3(0.0),
    sfp3(3.2),
    ndfp3(0.0),
    vthetafp3(0.0),
    mthetafp3(0.0),
    alphafp3(1e-2),
    flagfp4(0),
    lgfp4(0.0),
    vtofp4((-44.5)),
    cgfp4(2.0e-4),
    flagfp4s(1),
    cfp4s(1e-19),
    ccfp4(0.9e-10),
    cbfp4(0.0),
    vx0fp4(1.2e5),
    mu0fp4(0.2),
    betafp4(1.00),
    delta1fp4(0.0),
    sfp4(3.2),
    ndfp4(0.0),
    vthetafp4(0.0),
    mthetafp4(0.0),
    alphafp4(1e-2),
    igmod(1),
    rgsp(0.0),
    vjg(1.1),
    pg_param1(820e-3),
    pg_params(1.00),
    ijs(1.00e-12),
    vgsats(1.00),
    fracs(0.5),
    alphags(10.0),
    pg_paramd(1.00),
    ijd(1.00e-12),
    vgsatd(1.00),
    fracd(0.5),
    alphagd(10.0),
    pgsrecs(0.5),
    irecs(1.0e-18),
    vgsatqs(2.00),
    vbdgs(600),
    pbdgs(4.00),
    betarecs(2.00),
    kbdgates(00),
    pgsrecd(0.8),
    irecd(2e-5),
    vgsatqd(0.8),
    vbdgd(600),
    pbdgd(4.00),
    betarecd(0.25),
    kbdgated(00),
    rth(25),
    cth(1e-4),
    gmdisp(0),
    taugmrf(1e-3),
    trapselect(0),
    ctrap(1e-3),
    vttrap(230),
    taut(3e-5),
    alphat1(1e-4),
    alphat2(21),
    tempt(1e-4),
    noisemod(0),
    shs(3.0),
    shd(3.0),
    kf(1.0e-4),
    af(2.0),
    ffe(1.2),
    minr(1.0e-3),
    minl(1.0e-9),
    minc(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "W  =  " << (*iter)->w << std::endl;
    os << "L  =  " << (*iter)->l << std::endl;
    os << "NGF  =  " << (*iter)->ngf << std::endl;
    os << "DTEMP  =  " << (*iter)->dtemp << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
  if (deviceMap.empty() ||
      ((deviceMap.find("M") != deviceMap.end() && (levelSet.find(2002)!=levelSet.end()))))
  {
    MOSFET1::registerDevice();
    Config<Traits>::addConfiguration()
      .registerDevice("m", 2002)
      .registerModelType("nmos", 2002)
      .registerModelType("pmos", 2002);
  }
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_w,
   bool instancePar_given_w,
   AdmsSensFadType & instancePar_l,
   bool instancePar_given_l,
   AdmsSensFadType & instancePar_dtemp,
   bool instancePar_given_dtemp,
   // non-reals(including hidden)
   int instancePar_ngf,
   bool instancePar_given_ngf,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_rcs_w,
   AdmsSensFadType & instanceVar_rcd_w,
   AdmsSensFadType & instanceVar_rg,
   AdmsSensFadType & instanceVar_vtdibli,
   AdmsSensFadType & instanceVar_vdsat1i,
   AdmsSensFadType & instanceVar_vtdiblrs,
   AdmsSensFadType & instanceVar_vdsatrs,
   AdmsSensFadType & instanceVar_vtdiblrd,
   AdmsSensFadType & instanceVar_vdsatrd,
   AdmsSensFadType & instanceVar_vtdiblfp1,
   AdmsSensFadType & instanceVar_vdsatfp1,
   AdmsSensFadType & instanceVar_vtdiblfp2,
   AdmsSensFadType & instanceVar_vdsatfp2,
   AdmsSensFadType & instanceVar_vtdiblfp3,
   AdmsSensFadType & instanceVar_vdsatfp3,
   AdmsSensFadType & instanceVar_vtdiblfp4,
   AdmsSensFadType & instanceVar_vdsatfp4,
   AdmsSensFadType & instanceVar_qgs,
   AdmsSensFadType & instanceVar_qgd,
   AdmsSensFadType & instanceVar_qc,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_qs,
   AdmsSensFadType & instanceVar_igssdio,
   AdmsSensFadType & instanceVar_igdsdio,
   AdmsSensFadType & instanceVar_igsrec,
   AdmsSensFadType & instanceVar_igdrec,
   AdmsSensFadType & instanceVar_qgsrs,
   AdmsSensFadType & instanceVar_qgdrs,
   AdmsSensFadType & instanceVar_qcrs,
   AdmsSensFadType & instanceVar_qbrs,
   AdmsSensFadType & instanceVar_qsrs,
   AdmsSensFadType & instanceVar_qgsrd,
   AdmsSensFadType & instanceVar_qgdrd,
   AdmsSensFadType & instanceVar_qcrd,
   AdmsSensFadType & instanceVar_qbrd,
   AdmsSensFadType & instanceVar_qsrd,
   AdmsSensFadType & instanceVar_qgsfp1,
   AdmsSensFadType & instanceVar_qgdfp1,
   AdmsSensFadType & instanceVar_qcfp1,
   AdmsSensFadType & instanceVar_qbfp1,
   AdmsSensFadType & instanceVar_qsfp1,
   AdmsSensFadType & instanceVar_qgsfp2,
   AdmsSensFadType & instanceVar_qgdfp2,
   AdmsSensFadType & instanceVar_qcfp2,
   AdmsSensFadType & instanceVar_qbfp2,
   AdmsSensFadType & instanceVar_qsfp2,
   AdmsSensFadType & instanceVar_qgsfp3,
   AdmsSensFadType & instanceVar_qgdfp3,
   AdmsSensFadType & instanceVar_qcfp3,
   AdmsSensFadType & instanceVar_qbfp3,
   AdmsSensFadType & instanceVar_qsfp3,
   AdmsSensFadType & instanceVar_qgsfp4,
   AdmsSensFadType & instanceVar_qgdfp4,
   AdmsSensFadType & instanceVar_qcfp4,
   AdmsSensFadType & instanceVar_qbfp4,
   AdmsSensFadType & instanceVar_qsfp4,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_version,
   bool modelPar_given_version,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_cg,
   bool modelPar_given_cg,
   AdmsSensFadType & modelPar_cofsm,
   bool modelPar_given_cofsm,
   AdmsSensFadType & modelPar_cofdm,
   bool modelPar_given_cofdm,
   AdmsSensFadType & modelPar_cofdsm,
   bool modelPar_given_cofdsm,
   AdmsSensFadType & modelPar_cofdsubm,
   bool modelPar_given_cofdsubm,
   AdmsSensFadType & modelPar_cofssubm,
   bool modelPar_given_cofssubm,
   AdmsSensFadType & modelPar_cofgsubm,
   bool modelPar_given_cofgsubm,
   AdmsSensFadType & modelPar_rsh,
   bool modelPar_given_rsh,
   AdmsSensFadType & modelPar_rcs,
   bool modelPar_given_rcs,
   AdmsSensFadType & modelPar_rcd,
   bool modelPar_given_rcd,
   AdmsSensFadType & modelPar_vx0,
   bool modelPar_given_vx0,
   AdmsSensFadType & modelPar_mu0,
   bool modelPar_given_mu0,
   AdmsSensFadType & modelPar_beta,
   bool modelPar_given_beta,
   AdmsSensFadType & modelPar_vto,
   bool modelPar_given_vto,
   AdmsSensFadType & modelPar_ss,
   bool modelPar_given_ss,
   AdmsSensFadType & modelPar_delta1,
   bool modelPar_given_delta1,
   AdmsSensFadType & modelPar_delta2,
   bool modelPar_given_delta2,
   AdmsSensFadType & modelPar_dibsat,
   bool modelPar_given_dibsat,
   AdmsSensFadType & modelPar_nd,
   bool modelPar_given_nd,
   AdmsSensFadType & modelPar_alpha,
   bool modelPar_given_alpha,
   AdmsSensFadType & modelPar_lambda,
   bool modelPar_given_lambda,
   AdmsSensFadType & modelPar_vtheta,
   bool modelPar_given_vtheta,
   AdmsSensFadType & modelPar_mtheta,
   bool modelPar_given_mtheta,
   AdmsSensFadType & modelPar_vzeta,
   bool modelPar_given_vzeta,
   AdmsSensFadType & modelPar_vtzeta,
   bool modelPar_given_vtzeta,
   AdmsSensFadType & modelPar_epsilon,
   bool modelPar_given_epsilon,
   AdmsSensFadType & modelPar_rct1,
   bool modelPar_given_rct1,
   AdmsSensFadType & modelPar_rct2,
   bool modelPar_given_rct2,
   AdmsSensFadType & modelPar_lgs,
   bool modelPar_given_lgs,
   AdmsSensFadType & modelPar_vtors,
   bool modelPar_given_vtors,
   AdmsSensFadType & modelPar_cgrs,
   bool modelPar_given_cgrs,
   AdmsSensFadType & modelPar_vx0rs,
   bool modelPar_given_vx0rs,
   AdmsSensFadType & modelPar_mu0rs,
   bool modelPar_given_mu0rs,
   AdmsSensFadType & modelPar_betars,
   bool modelPar_given_betars,
   AdmsSensFadType & modelPar_delta1rs,
   bool modelPar_given_delta1rs,
   AdmsSensFadType & modelPar_srs,
   bool modelPar_given_srs,
   AdmsSensFadType & modelPar_ndrs,
   bool modelPar_given_ndrs,
   AdmsSensFadType & modelPar_vthetars,
   bool modelPar_given_vthetars,
   AdmsSensFadType & modelPar_mthetars,
   bool modelPar_given_mthetars,
   AdmsSensFadType & modelPar_alphars,
   bool modelPar_given_alphars,
   AdmsSensFadType & modelPar_lgd,
   bool modelPar_given_lgd,
   AdmsSensFadType & modelPar_vtord,
   bool modelPar_given_vtord,
   AdmsSensFadType & modelPar_cgrd,
   bool modelPar_given_cgrd,
   AdmsSensFadType & modelPar_vx0rd,
   bool modelPar_given_vx0rd,
   AdmsSensFadType & modelPar_mu0rd,
   bool modelPar_given_mu0rd,
   AdmsSensFadType & modelPar_betard,
   bool modelPar_given_betard,
   AdmsSensFadType & modelPar_delta1rd,
   bool modelPar_given_delta1rd,
   AdmsSensFadType & modelPar_srd,
   bool modelPar_given_srd,
   AdmsSensFadType & modelPar_ndrd,
   bool modelPar_given_ndrd,
   AdmsSensFadType & modelPar_vthetard,
   bool modelPar_given_vthetard,
   AdmsSensFadType & modelPar_mthetard,
   bool modelPar_given_mthetard,
   AdmsSensFadType & modelPar_alphard,
   bool modelPar_given_alphard,
   AdmsSensFadType & modelPar_lgfp1,
   bool modelPar_given_lgfp1,
   AdmsSensFadType & modelPar_vtofp1,
   bool modelPar_given_vtofp1,
   AdmsSensFadType & modelPar_cgfp1,
   bool modelPar_given_cgfp1,
   AdmsSensFadType & modelPar_cfp1s,
   bool modelPar_given_cfp1s,
   AdmsSensFadType & modelPar_ccfp1,
   bool modelPar_given_ccfp1,
   AdmsSensFadType & modelPar_cbfp1,
   bool modelPar_given_cbfp1,
   AdmsSensFadType & modelPar_vx0fp1,
   bool modelPar_given_vx0fp1,
   AdmsSensFadType & modelPar_mu0fp1,
   bool modelPar_given_mu0fp1,
   AdmsSensFadType & modelPar_betafp1,
   bool modelPar_given_betafp1,
   AdmsSensFadType & modelPar_delta1fp1,
   bool modelPar_given_delta1fp1,
   AdmsSensFadType & modelPar_sfp1,
   bool modelPar_given_sfp1,
   AdmsSensFadType & modelPar_ndfp1,
   bool modelPar_given_ndfp1,
   AdmsSensFadType & modelPar_vthetafp1,
   bool modelPar_given_vthetafp1,
   AdmsSensFadType & modelPar_mthetafp1,
   bool modelPar_given_mthetafp1,
   AdmsSensFadType & modelPar_alphafp1,
   bool modelPar_given_alphafp1,
   AdmsSensFadType & modelPar_lgfp2,
   bool modelPar_given_lgfp2,
   AdmsSensFadType & modelPar_vtofp2,
   bool modelPar_given_vtofp2,
   AdmsSensFadType & modelPar_cgfp2,
   bool modelPar_given_cgfp2,
   AdmsSensFadType & modelPar_cfp2s,
   bool modelPar_given_cfp2s,
   AdmsSensFadType & modelPar_ccfp2,
   bool modelPar_given_ccfp2,
   AdmsSensFadType & modelPar_cbfp2,
   bool modelPar_given_cbfp2,
   AdmsSensFadType & modelPar_vx0fp2,
   bool modelPar_given_vx0fp2,
   AdmsSensFadType & modelPar_mu0fp2,
   bool modelPar_given_mu0fp2,
   AdmsSensFadType & modelPar_betafp2,
   bool modelPar_given_betafp2,
   AdmsSensFadType & modelPar_delta1fp2,
   bool modelPar_given_delta1fp2,
   AdmsSensFadType & modelPar_sfp2,
   bool modelPar_given_sfp2,
   AdmsSensFadType & modelPar_ndfp2,
   bool modelPar_given_ndfp2,
   AdmsSensFadType & modelPar_vthetafp2,
   bool modelPar_given_vthetafp2,
   AdmsSensFadType & modelPar_mthetafp2,
   bool modelPar_given_mthetafp2,
   AdmsSensFadType & modelPar_alphafp2,
   bool modelPar_given_alphafp2,
   AdmsSensFadType & modelPar_lgfp3,
   bool modelPar_given_lgfp3,
   AdmsSensFadType & modelPar_vtofp3,
   bool modelPar_given_vtofp3,
   AdmsSensFadType & modelPar_cgfp3,
   bool modelPar_given_cgfp3,
   AdmsSensFadType & modelPar_cfp3s,
   bool modelPar_given_cfp3s,
   AdmsSensFadType & modelPar_ccfp3,
   bool modelPar_given_ccfp3,
   AdmsSensFadType & modelPar_cbfp3,
   bool modelPar_given_cbfp3,
   AdmsSensFadType & modelPar_vx0fp3,
   bool modelPar_given_vx0fp3,
   AdmsSensFadType & modelPar_mu0fp3,
   bool modelPar_given_mu0fp3,
   AdmsSensFadType & modelPar_betafp3,
   bool modelPar_given_betafp3,
   AdmsSensFadType & modelPar_delta1fp3,
   bool modelPar_given_delta1fp3,
   AdmsSensFadType & modelPar_sfp3,
   bool modelPar_given_sfp3,
   AdmsSensFadType & modelPar_ndfp3,
   bool modelPar_given_ndfp3,
   AdmsSensFadType & modelPar_vthetafp3,
   bool modelPar_given_vthetafp3,
   AdmsSensFadType & modelPar_mthetafp3,
   bool modelPar_given_mthetafp3,
   AdmsSensFadType & modelPar_alphafp3,
   bool modelPar_given_alphafp3,
   AdmsSensFadType & modelPar_lgfp4,
   bool modelPar_given_lgfp4,
   AdmsSensFadType & modelPar_vtofp4,
   bool modelPar_given_vtofp4,
   AdmsSensFadType & modelPar_cgfp4,
   bool modelPar_given_cgfp4,
   AdmsSensFadType & modelPar_cfp4s,
   bool modelPar_given_cfp4s,
   AdmsSensFadType & modelPar_ccfp4,
   bool modelPar_given_ccfp4,
   AdmsSensFadType & modelPar_cbfp4,
   bool modelPar_given_cbfp4,
   AdmsSensFadType & modelPar_vx0fp4,
   bool modelPar_given_vx0fp4,
   AdmsSensFadType & modelPar_mu0fp4,
   bool modelPar_given_mu0fp4,
   AdmsSensFadType & modelPar_betafp4,
   bool modelPar_given_betafp4,
   AdmsSensFadType & modelPar_delta1fp4,
   bool modelPar_given_delta1fp4,
   AdmsSensFadType & modelPar_sfp4,
   bool modelPar_given_sfp4,
   AdmsSensFadType & modelPar_ndfp4,
   bool modelPar_given_ndfp4,
   AdmsSensFadType & modelPar_vthetafp4,
   bool modelPar_given_vthetafp4,
   AdmsSensFadType & modelPar_mthetafp4,
   bool modelPar_given_mthetafp4,
   AdmsSensFadType & modelPar_alphafp4,
   bool modelPar_given_alphafp4,
   AdmsSensFadType & modelPar_rgsp,
   bool modelPar_given_rgsp,
   AdmsSensFadType & modelPar_vjg,
   bool modelPar_given_vjg,
   AdmsSensFadType & modelPar_pg_param1,
   bool modelPar_given_pg_param1,
   AdmsSensFadType & modelPar_pg_params,
   bool modelPar_given_pg_params,
   AdmsSensFadType & modelPar_ijs,
   bool modelPar_given_ijs,
   AdmsSensFadType & modelPar_vgsats,
   bool modelPar_given_vgsats,
   AdmsSensFadType & modelPar_fracs,
   bool modelPar_given_fracs,
   AdmsSensFadType & modelPar_alphags,
   bool modelPar_given_alphags,
   AdmsSensFadType & modelPar_pg_paramd,
   bool modelPar_given_pg_paramd,
   AdmsSensFadType & modelPar_ijd,
   bool modelPar_given_ijd,
   AdmsSensFadType & modelPar_vgsatd,
   bool modelPar_given_vgsatd,
   AdmsSensFadType & modelPar_fracd,
   bool modelPar_given_fracd,
   AdmsSensFadType & modelPar_alphagd,
   bool modelPar_given_alphagd,
   AdmsSensFadType & modelPar_pgsrecs,
   bool modelPar_given_pgsrecs,
   AdmsSensFadType & modelPar_irecs,
   bool modelPar_given_irecs,
   AdmsSensFadType & modelPar_vgsatqs,
   bool modelPar_given_vgsatqs,
   AdmsSensFadType & modelPar_vbdgs,
   bool modelPar_given_vbdgs,
   AdmsSensFadType & modelPar_pbdgs,
   bool modelPar_given_pbdgs,
   AdmsSensFadType & modelPar_betarecs,
   bool modelPar_given_betarecs,
   AdmsSensFadType & modelPar_kbdgates,
   bool modelPar_given_kbdgates,
   AdmsSensFadType & modelPar_pgsrecd,
   bool modelPar_given_pgsrecd,
   AdmsSensFadType & modelPar_irecd,
   bool modelPar_given_irecd,
   AdmsSensFadType & modelPar_vgsatqd,
   bool modelPar_given_vgsatqd,
   AdmsSensFadType & modelPar_vbdgd,
   bool modelPar_given_vbdgd,
   AdmsSensFadType & modelPar_pbdgd,
   bool modelPar_given_pbdgd,
   AdmsSensFadType & modelPar_betarecd,
   bool modelPar_given_betarecd,
   AdmsSensFadType & modelPar_kbdgated,
   bool modelPar_given_kbdgated,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_taugmrf,
   bool modelPar_given_taugmrf,
   AdmsSensFadType & modelPar_ctrap,
   bool modelPar_given_ctrap,
   AdmsSensFadType & modelPar_vttrap,
   bool modelPar_given_vttrap,
   AdmsSensFadType & modelPar_taut,
   bool modelPar_given_taut,
   AdmsSensFadType & modelPar_alphat1,
   bool modelPar_given_alphat1,
   AdmsSensFadType & modelPar_alphat2,
   bool modelPar_given_alphat2,
   AdmsSensFadType & modelPar_tempt,
   bool modelPar_given_tempt,
   AdmsSensFadType & modelPar_shs,
   bool modelPar_given_shs,
   AdmsSensFadType & modelPar_shd,
   bool modelPar_given_shd,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_ffe,
   bool modelPar_given_ffe,
   AdmsSensFadType & modelPar_minr,
   bool modelPar_given_minr,
   AdmsSensFadType & modelPar_minl,
   bool modelPar_given_minl,
   AdmsSensFadType & modelPar_minc,
   bool modelPar_given_minc,
   // non-reals (including hidden)
   int modelPar_type,
   bool modelPar_given_type,
   int modelPar_flagres,
   bool modelPar_given_flagres,
   int modelPar_flagfp1,
   bool modelPar_given_flagfp1,
   int modelPar_flagfp1s,
   bool modelPar_given_flagfp1s,
   int modelPar_flagfp2,
   bool modelPar_given_flagfp2,
   int modelPar_flagfp2s,
   bool modelPar_given_flagfp2s,
   int modelPar_flagfp3,
   bool modelPar_given_flagfp3,
   int modelPar_flagfp3s,
   bool modelPar_given_flagfp3s,
   int modelPar_flagfp4,
   bool modelPar_given_flagfp4,
   int modelPar_flagfp4s,
   bool modelPar_given_flagfp4s,
   int modelPar_igmod,
   bool modelPar_given_igmod,
   int modelPar_gmdisp,
   bool modelPar_given_gmdisp,
   int modelPar_trapselect,
   bool modelPar_given_trapselect,
   int modelPar_noisemod,
   bool modelPar_given_noisemod,
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  //Begin block initial_instance
  {
    if ((modelPar_flagres==0))
    {
      instanceVar_rcs_w = ((modelPar_rcs/instancePar_w)/instancePar_ngf);
      instanceVar_rcd_w = ((modelPar_rcd/instancePar_w)/instancePar_ngf);
    }
    else
    {
      instanceVar_rcs_w = (((modelPar_rcs/instancePar_w)+((modelPar_rsh*modelPar_lgs)/instancePar_w))/instancePar_ngf);
      instanceVar_rcd_w = (((modelPar_rcd/instancePar_w)+((modelPar_rsh*modelPar_lgd)/instancePar_w))/instancePar_ngf);
    }
    instanceVar_rg = ((modelPar_rgsp/instancePar_w)/instancePar_ngf);
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_version,
   bool modelPar_given_version,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_cg,
   bool modelPar_given_cg,
   AdmsSensFadType & modelPar_cofsm,
   bool modelPar_given_cofsm,
   AdmsSensFadType & modelPar_cofdm,
   bool modelPar_given_cofdm,
   AdmsSensFadType & modelPar_cofdsm,
   bool modelPar_given_cofdsm,
   AdmsSensFadType & modelPar_cofdsubm,
   bool modelPar_given_cofdsubm,
   AdmsSensFadType & modelPar_cofssubm,
   bool modelPar_given_cofssubm,
   AdmsSensFadType & modelPar_cofgsubm,
   bool modelPar_given_cofgsubm,
   AdmsSensFadType & modelPar_rsh,
   bool modelPar_given_rsh,
   AdmsSensFadType & modelPar_rcs,
   bool modelPar_given_rcs,
   AdmsSensFadType & modelPar_rcd,
   bool modelPar_given_rcd,
   AdmsSensFadType & modelPar_vx0,
   bool modelPar_given_vx0,
   AdmsSensFadType & modelPar_mu0,
   bool modelPar_given_mu0,
   AdmsSensFadType & modelPar_beta,
   bool modelPar_given_beta,
   AdmsSensFadType & modelPar_vto,
   bool modelPar_given_vto,
   AdmsSensFadType & modelPar_ss,
   bool modelPar_given_ss,
   AdmsSensFadType & modelPar_delta1,
   bool modelPar_given_delta1,
   AdmsSensFadType & modelPar_delta2,
   bool modelPar_given_delta2,
   AdmsSensFadType & modelPar_dibsat,
   bool modelPar_given_dibsat,
   AdmsSensFadType & modelPar_nd,
   bool modelPar_given_nd,
   AdmsSensFadType & modelPar_alpha,
   bool modelPar_given_alpha,
   AdmsSensFadType & modelPar_lambda,
   bool modelPar_given_lambda,
   AdmsSensFadType & modelPar_vtheta,
   bool modelPar_given_vtheta,
   AdmsSensFadType & modelPar_mtheta,
   bool modelPar_given_mtheta,
   AdmsSensFadType & modelPar_vzeta,
   bool modelPar_given_vzeta,
   AdmsSensFadType & modelPar_vtzeta,
   bool modelPar_given_vtzeta,
   AdmsSensFadType & modelPar_epsilon,
   bool modelPar_given_epsilon,
   AdmsSensFadType & modelPar_rct1,
   bool modelPar_given_rct1,
   AdmsSensFadType & modelPar_rct2,
   bool modelPar_given_rct2,
   AdmsSensFadType & modelPar_lgs,
   bool modelPar_given_lgs,
   AdmsSensFadType & modelPar_vtors,
   bool modelPar_given_vtors,
   AdmsSensFadType & modelPar_cgrs,
   bool modelPar_given_cgrs,
   AdmsSensFadType & modelPar_vx0rs,
   bool modelPar_given_vx0rs,
   AdmsSensFadType & modelPar_mu0rs,
   bool modelPar_given_mu0rs,
   AdmsSensFadType & modelPar_betars,
   bool modelPar_given_betars,
   AdmsSensFadType & modelPar_delta1rs,
   bool modelPar_given_delta1rs,
   AdmsSensFadType & modelPar_srs,
   bool modelPar_given_srs,
   AdmsSensFadType & modelPar_ndrs,
   bool modelPar_given_ndrs,
   AdmsSensFadType & modelPar_vthetars,
   bool modelPar_given_vthetars,
   AdmsSensFadType & modelPar_mthetars,
   bool modelPar_given_mthetars,
   AdmsSensFadType & modelPar_alphars,
   bool modelPar_given_alphars,
   AdmsSensFadType & modelPar_lgd,
   bool modelPar_given_lgd,
   AdmsSensFadType & modelPar_vtord,
   bool modelPar_given_vtord,
   AdmsSensFadType & modelPar_cgrd,
   bool modelPar_given_cgrd,
   AdmsSensFadType & modelPar_vx0rd,
   bool modelPar_given_vx0rd,
   AdmsSensFadType & modelPar_mu0rd,
   bool modelPar_given_mu0rd,
   AdmsSensFadType & modelPar_betard,
   bool modelPar_given_betard,
   AdmsSensFadType & modelPar_delta1rd,
   bool modelPar_given_delta1rd,
   AdmsSensFadType & modelPar_srd,
   bool modelPar_given_srd,
   AdmsSensFadType & modelPar_ndrd,
   bool modelPar_given_ndrd,
   AdmsSensFadType & modelPar_vthetard,
   bool modelPar_given_vthetard,
   AdmsSensFadType & modelPar_mthetard,
   bool modelPar_given_mthetard,
   AdmsSensFadType & modelPar_alphard,
   bool modelPar_given_alphard,
   AdmsSensFadType & modelPar_lgfp1,
   bool modelPar_given_lgfp1,
   AdmsSensFadType & modelPar_vtofp1,
   bool modelPar_given_vtofp1,
   AdmsSensFadType & modelPar_cgfp1,
   bool modelPar_given_cgfp1,
   AdmsSensFadType & modelPar_cfp1s,
   bool modelPar_given_cfp1s,
   AdmsSensFadType & modelPar_ccfp1,
   bool modelPar_given_ccfp1,
   AdmsSensFadType & modelPar_cbfp1,
   bool modelPar_given_cbfp1,
   AdmsSensFadType & modelPar_vx0fp1,
   bool modelPar_given_vx0fp1,
   AdmsSensFadType & modelPar_mu0fp1,
   bool modelPar_given_mu0fp1,
   AdmsSensFadType & modelPar_betafp1,
   bool modelPar_given_betafp1,
   AdmsSensFadType & modelPar_delta1fp1,
   bool modelPar_given_delta1fp1,
   AdmsSensFadType & modelPar_sfp1,
   bool modelPar_given_sfp1,
   AdmsSensFadType & modelPar_ndfp1,
   bool modelPar_given_ndfp1,
   AdmsSensFadType & modelPar_vthetafp1,
   bool modelPar_given_vthetafp1,
   AdmsSensFadType & modelPar_mthetafp1,
   bool modelPar_given_mthetafp1,
   AdmsSensFadType & modelPar_alphafp1,
   bool modelPar_given_alphafp1,
   AdmsSensFadType & modelPar_lgfp2,
   bool modelPar_given_lgfp2,
   AdmsSensFadType & modelPar_vtofp2,
   bool modelPar_given_vtofp2,
   AdmsSensFadType & modelPar_cgfp2,
   bool modelPar_given_cgfp2,
   AdmsSensFadType & modelPar_cfp2s,
   bool modelPar_given_cfp2s,
   AdmsSensFadType & modelPar_ccfp2,
   bool modelPar_given_ccfp2,
   AdmsSensFadType & modelPar_cbfp2,
   bool modelPar_given_cbfp2,
   AdmsSensFadType & modelPar_vx0fp2,
   bool modelPar_given_vx0fp2,
   AdmsSensFadType & modelPar_mu0fp2,
   bool modelPar_given_mu0fp2,
   AdmsSensFadType & modelPar_betafp2,
   bool modelPar_given_betafp2,
   AdmsSensFadType & modelPar_delta1fp2,
   bool modelPar_given_delta1fp2,
   AdmsSensFadType & modelPar_sfp2,
   bool modelPar_given_sfp2,
   AdmsSensFadType & modelPar_ndfp2,
   bool modelPar_given_ndfp2,
   AdmsSensFadType & modelPar_vthetafp2,
   bool modelPar_given_vthetafp2,
   AdmsSensFadType & modelPar_mthetafp2,
   bool modelPar_given_mthetafp2,
   AdmsSensFadType & modelPar_alphafp2,
   bool modelPar_given_alphafp2,
   AdmsSensFadType & modelPar_lgfp3,
   bool modelPar_given_lgfp3,
   AdmsSensFadType & modelPar_vtofp3,
   bool modelPar_given_vtofp3,
   AdmsSensFadType & modelPar_cgfp3,
   bool modelPar_given_cgfp3,
   AdmsSensFadType & modelPar_cfp3s,
   bool modelPar_given_cfp3s,
   AdmsSensFadType & modelPar_ccfp3,
   bool modelPar_given_ccfp3,
   AdmsSensFadType & modelPar_cbfp3,
   bool modelPar_given_cbfp3,
   AdmsSensFadType & modelPar_vx0fp3,
   bool modelPar_given_vx0fp3,
   AdmsSensFadType & modelPar_mu0fp3,
   bool modelPar_given_mu0fp3,
   AdmsSensFadType & modelPar_betafp3,
   bool modelPar_given_betafp3,
   AdmsSensFadType & modelPar_delta1fp3,
   bool modelPar_given_delta1fp3,
   AdmsSensFadType & modelPar_sfp3,
   bool modelPar_given_sfp3,
   AdmsSensFadType & modelPar_ndfp3,
   bool modelPar_given_ndfp3,
   AdmsSensFadType & modelPar_vthetafp3,
   bool modelPar_given_vthetafp3,
   AdmsSensFadType & modelPar_mthetafp3,
   bool modelPar_given_mthetafp3,
   AdmsSensFadType & modelPar_alphafp3,
   bool modelPar_given_alphafp3,
   AdmsSensFadType & modelPar_lgfp4,
   bool modelPar_given_lgfp4,
   AdmsSensFadType & modelPar_vtofp4,
   bool modelPar_given_vtofp4,
   AdmsSensFadType & modelPar_cgfp4,
   bool modelPar_given_cgfp4,
   AdmsSensFadType & modelPar_cfp4s,
   bool modelPar_given_cfp4s,
   AdmsSensFadType & modelPar_ccfp4,
   bool modelPar_given_ccfp4,
   AdmsSensFadType & modelPar_cbfp4,
   bool modelPar_given_cbfp4,
   AdmsSensFadType & modelPar_vx0fp4,
   bool modelPar_given_vx0fp4,
   AdmsSensFadType & modelPar_mu0fp4,
   bool modelPar_given_mu0fp4,
   AdmsSensFadType & modelPar_betafp4,
   bool modelPar_given_betafp4,
   AdmsSensFadType & modelPar_delta1fp4,
   bool modelPar_given_delta1fp4,
   AdmsSensFadType & modelPar_sfp4,
   bool modelPar_given_sfp4,
   AdmsSensFadType & modelPar_ndfp4,
   bool modelPar_given_ndfp4,
   AdmsSensFadType & modelPar_vthetafp4,
   bool modelPar_given_vthetafp4,
   AdmsSensFadType & modelPar_mthetafp4,
   bool modelPar_given_mthetafp4,
   AdmsSensFadType & modelPar_alphafp4,
   bool modelPar_given_alphafp4,
   AdmsSensFadType & modelPar_rgsp,
   bool modelPar_given_rgsp,
   AdmsSensFadType & modelPar_vjg,
   bool modelPar_given_vjg,
   AdmsSensFadType & modelPar_pg_param1,
   bool modelPar_given_pg_param1,
   AdmsSensFadType & modelPar_pg_params,
   bool modelPar_given_pg_params,
   AdmsSensFadType & modelPar_ijs,
   bool modelPar_given_ijs,
   AdmsSensFadType & modelPar_vgsats,
   bool modelPar_given_vgsats,
   AdmsSensFadType & modelPar_fracs,
   bool modelPar_given_fracs,
   AdmsSensFadType & modelPar_alphags,
   bool modelPar_given_alphags,
   AdmsSensFadType & modelPar_pg_paramd,
   bool modelPar_given_pg_paramd,
   AdmsSensFadType & modelPar_ijd,
   bool modelPar_given_ijd,
   AdmsSensFadType & modelPar_vgsatd,
   bool modelPar_given_vgsatd,
   AdmsSensFadType & modelPar_fracd,
   bool modelPar_given_fracd,
   AdmsSensFadType & modelPar_alphagd,
   bool modelPar_given_alphagd,
   AdmsSensFadType & modelPar_pgsrecs,
   bool modelPar_given_pgsrecs,
   AdmsSensFadType & modelPar_irecs,
   bool modelPar_given_irecs,
   AdmsSensFadType & modelPar_vgsatqs,
   bool modelPar_given_vgsatqs,
   AdmsSensFadType & modelPar_vbdgs,
   bool modelPar_given_vbdgs,
   AdmsSensFadType & modelPar_pbdgs,
   bool modelPar_given_pbdgs,
   AdmsSensFadType & modelPar_betarecs,
   bool modelPar_given_betarecs,
   AdmsSensFadType & modelPar_kbdgates,
   bool modelPar_given_kbdgates,
   AdmsSensFadType & modelPar_pgsrecd,
   bool modelPar_given_pgsrecd,
   AdmsSensFadType & modelPar_irecd,
   bool modelPar_given_irecd,
   AdmsSensFadType & modelPar_vgsatqd,
   bool modelPar_given_vgsatqd,
   AdmsSensFadType & modelPar_vbdgd,
   bool modelPar_given_vbdgd,
   AdmsSensFadType & modelPar_pbdgd,
   bool modelPar_given_pbdgd,
   AdmsSensFadType & modelPar_betarecd,
   bool modelPar_given_betarecd,
   AdmsSensFadType & modelPar_kbdgated,
   bool modelPar_given_kbdgated,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_taugmrf,
   bool modelPar_given_taugmrf,
   AdmsSensFadType & modelPar_ctrap,
   bool modelPar_given_ctrap,
   AdmsSensFadType & modelPar_vttrap,
   bool modelPar_given_vttrap,
   AdmsSensFadType & modelPar_taut,
   bool modelPar_given_taut,
   AdmsSensFadType & modelPar_alphat1,
   bool modelPar_given_alphat1,
   AdmsSensFadType & modelPar_alphat2,
   bool modelPar_given_alphat2,
   AdmsSensFadType & modelPar_tempt,
   bool modelPar_given_tempt,
   AdmsSensFadType & modelPar_shs,
   bool modelPar_given_shs,
   AdmsSensFadType & modelPar_shd,
   bool modelPar_given_shd,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_ffe,
   bool modelPar_given_ffe,
   AdmsSensFadType & modelPar_minr,
   bool modelPar_given_minr,
   AdmsSensFadType & modelPar_minl,
   bool modelPar_given_minl,
   AdmsSensFadType & modelPar_minc,
   bool modelPar_given_minc,
   // non-reals (including hidden)
   int modelPar_type,
   bool modelPar_given_type,
   int modelPar_flagres,
   bool modelPar_given_flagres,
   int modelPar_flagfp1,
   bool modelPar_given_flagfp1,
   int modelPar_flagfp1s,
   bool modelPar_given_flagfp1s,
   int modelPar_flagfp2,
   bool modelPar_given_flagfp2,
   int modelPar_flagfp2s,
   bool modelPar_given_flagfp2s,
   int modelPar_flagfp3,
   bool modelPar_given_flagfp3,
   int modelPar_flagfp3s,
   bool modelPar_given_flagfp3s,
   int modelPar_flagfp4,
   bool modelPar_given_flagfp4,
   int modelPar_flagfp4s,
   bool modelPar_given_flagfp4s,
   int modelPar_igmod,
   bool modelPar_given_igmod,
   int modelPar_gmdisp,
   bool modelPar_given_gmdisp,
   int modelPar_trapselect,
   bool modelPar_given_trapselect,
   int modelPar_noisemod,
   bool modelPar_given_noisemod,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_drc_d,
   const int admsProbeID_V_gi_b,
   const int admsProbeID_V_s_b,
   const int admsProbeID_V_d_b,
   const int admsProbeID_V_d_s,
   const int admsProbeID_V_gi_d,
   const int admsProbeID_V_gi_s,
   const int admsProbeID_V_g_gi,
   const int admsProbeID_V_d_drc,
   const int admsProbeID_V_xt1_GND,
   const int admsProbeID_V_xt2_GND,
   const int admsProbeID_V_fp4_s,
   const int admsProbeID_V_fp4_d,
   const int admsProbeID_V_tr_GND,
   const int admsProbeID_V_tr1_tr,
   const int admsProbeID_V_d_g,
   const int admsProbeID_V_src_s,
   const int admsProbeID_V_src_d,
   const int admsProbeID_V_di_si,
   const int admsProbeID_V_gi_si,
   const int admsProbeID_V_drc_fp4,
   const int admsProbeID_V_drc_GND,
   const int admsProbeID_V_fp4_GND,
   const int admsProbeID_V_si_src,
   const int admsProbeID_V_si_GND,
   const int admsProbeID_V_src_GND,
   const int admsProbeID_V_s_GND,
   const int admsProbeID_V_d_GND,
   const int admsProbeID_V_fp1_di,
   const int admsProbeID_V_b_di,
   const int admsProbeID_V_s_di,
   const int admsProbeID_V_gi_di,
   const int admsProbeID_V_fp2_fp1,
   const int admsProbeID_V_b_fp1,
   const int admsProbeID_V_s_fp1,
   const int admsProbeID_V_gi_fp1,
   const int admsProbeID_V_fp3_fp2,
   const int admsProbeID_V_b_fp2,
   const int admsProbeID_V_s_fp2,
   const int admsProbeID_V_gi_fp2,
   const int admsProbeID_Temp_dt_GND,
   const int admsProbeID_V_fp4_fp3,
   const int admsProbeID_V_gi_fp4,
   const int admsProbeID_V_s_fp4,
   const int admsProbeID_V_b_fp3,
   const int admsProbeID_V_s_fp3,
   const int admsProbeID_V_gi_fp3,
   // node constants
   const int admsNodeID_d,
   const int admsNodeID_g,
   const int admsNodeID_s,
   const int admsNodeID_b,
   const int admsNodeID_di,
   const int admsNodeID_gi,
   const int admsNodeID_si,
   const int admsNodeID_fp1,
   const int admsNodeID_fp2,
   const int admsNodeID_fp3,
   const int admsNodeID_fp4,
   const int admsNodeID_drc,
   const int admsNodeID_src,
   const int admsNodeID_tr,
   const int admsNodeID_tr1,
   const int admsNodeID_xt1,
   const int admsNodeID_xt2,
   const int admsNodeID_dt,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_w,
   bool instancePar_given_w,
   AdmsSensFadType & instancePar_l,
   bool instancePar_given_l,
   AdmsSensFadType & instancePar_dtemp,
   bool instancePar_given_dtemp,
   // non-reals(including hidden)
   int instancePar_ngf,
   bool instancePar_given_ngf,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_rcs_w,
   AdmsSensFadType & instanceVar_rcd_w,
   AdmsSensFadType & instanceVar_rg,
   AdmsSensFadType & instanceVar_vtdibli,
   AdmsSensFadType & instanceVar_vdsat1i,
   AdmsSensFadType & instanceVar_vtdiblrs,
   AdmsSensFadType & instanceVar_vdsatrs,
   AdmsSensFadType & instanceVar_vtdiblrd,
   AdmsSensFadType & instanceVar_vdsatrd,
   AdmsSensFadType & instanceVar_vtdiblfp1,
   AdmsSensFadType & instanceVar_vdsatfp1,
   AdmsSensFadType & instanceVar_vtdiblfp2,
   AdmsSensFadType & instanceVar_vdsatfp2,
   AdmsSensFadType & instanceVar_vtdiblfp3,
   AdmsSensFadType & instanceVar_vdsatfp3,
   AdmsSensFadType & instanceVar_vtdiblfp4,
   AdmsSensFadType & instanceVar_vdsatfp4,
   AdmsSensFadType & instanceVar_qgs,
   AdmsSensFadType & instanceVar_qgd,
   AdmsSensFadType & instanceVar_qc,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_qs,
   AdmsSensFadType & instanceVar_igssdio,
   AdmsSensFadType & instanceVar_igdsdio,
   AdmsSensFadType & instanceVar_igsrec,
   AdmsSensFadType & instanceVar_igdrec,
   AdmsSensFadType & instanceVar_qgsrs,
   AdmsSensFadType & instanceVar_qgdrs,
   AdmsSensFadType & instanceVar_qcrs,
   AdmsSensFadType & instanceVar_qbrs,
   AdmsSensFadType & instanceVar_qsrs,
   AdmsSensFadType & instanceVar_qgsrd,
   AdmsSensFadType & instanceVar_qgdrd,
   AdmsSensFadType & instanceVar_qcrd,
   AdmsSensFadType & instanceVar_qbrd,
   AdmsSensFadType & instanceVar_qsrd,
   AdmsSensFadType & instanceVar_qgsfp1,
   AdmsSensFadType & instanceVar_qgdfp1,
   AdmsSensFadType & instanceVar_qcfp1,
   AdmsSensFadType & instanceVar_qbfp1,
   AdmsSensFadType & instanceVar_qsfp1,
   AdmsSensFadType & instanceVar_qgsfp2,
   AdmsSensFadType & instanceVar_qgdfp2,
   AdmsSensFadType & instanceVar_qcfp2,
   AdmsSensFadType & instanceVar_qbfp2,
   AdmsSensFadType & instanceVar_qsfp2,
   AdmsSensFadType & instanceVar_qgsfp3,
   AdmsSensFadType & instanceVar_qgdfp3,
   AdmsSensFadType & instanceVar_qcfp3,
   AdmsSensFadType & instanceVar_qbfp3,
   AdmsSensFadType & instanceVar_qsfp3,
   AdmsSensFadType & instanceVar_qgsfp4,
   AdmsSensFadType & instanceVar_qgdfp4,
   AdmsSensFadType & instanceVar_qcfp4,
   AdmsSensFadType & instanceVar_qbfp4,
   AdmsSensFadType & instanceVar_qsfp4,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_version,
   bool modelPar_given_version,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_cg,
   bool modelPar_given_cg,
   AdmsSensFadType & modelPar_cofsm,
   bool modelPar_given_cofsm,
   AdmsSensFadType & modelPar_cofdm,
   bool modelPar_given_cofdm,
   AdmsSensFadType & modelPar_cofdsm,
   bool modelPar_given_cofdsm,
   AdmsSensFadType & modelPar_cofdsubm,
   bool modelPar_given_cofdsubm,
   AdmsSensFadType & modelPar_cofssubm,
   bool modelPar_given_cofssubm,
   AdmsSensFadType & modelPar_cofgsubm,
   bool modelPar_given_cofgsubm,
   AdmsSensFadType & modelPar_rsh,
   bool modelPar_given_rsh,
   AdmsSensFadType & modelPar_rcs,
   bool modelPar_given_rcs,
   AdmsSensFadType & modelPar_rcd,
   bool modelPar_given_rcd,
   AdmsSensFadType & modelPar_vx0,
   bool modelPar_given_vx0,
   AdmsSensFadType & modelPar_mu0,
   bool modelPar_given_mu0,
   AdmsSensFadType & modelPar_beta,
   bool modelPar_given_beta,
   AdmsSensFadType & modelPar_vto,
   bool modelPar_given_vto,
   AdmsSensFadType & modelPar_ss,
   bool modelPar_given_ss,
   AdmsSensFadType & modelPar_delta1,
   bool modelPar_given_delta1,
   AdmsSensFadType & modelPar_delta2,
   bool modelPar_given_delta2,
   AdmsSensFadType & modelPar_dibsat,
   bool modelPar_given_dibsat,
   AdmsSensFadType & modelPar_nd,
   bool modelPar_given_nd,
   AdmsSensFadType & modelPar_alpha,
   bool modelPar_given_alpha,
   AdmsSensFadType & modelPar_lambda,
   bool modelPar_given_lambda,
   AdmsSensFadType & modelPar_vtheta,
   bool modelPar_given_vtheta,
   AdmsSensFadType & modelPar_mtheta,
   bool modelPar_given_mtheta,
   AdmsSensFadType & modelPar_vzeta,
   bool modelPar_given_vzeta,
   AdmsSensFadType & modelPar_vtzeta,
   bool modelPar_given_vtzeta,
   AdmsSensFadType & modelPar_epsilon,
   bool modelPar_given_epsilon,
   AdmsSensFadType & modelPar_rct1,
   bool modelPar_given_rct1,
   AdmsSensFadType & modelPar_rct2,
   bool modelPar_given_rct2,
   AdmsSensFadType & modelPar_lgs,
   bool modelPar_given_lgs,
   AdmsSensFadType & modelPar_vtors,
   bool modelPar_given_vtors,
   AdmsSensFadType & modelPar_cgrs,
   bool modelPar_given_cgrs,
   AdmsSensFadType & modelPar_vx0rs,
   bool modelPar_given_vx0rs,
   AdmsSensFadType & modelPar_mu0rs,
   bool modelPar_given_mu0rs,
   AdmsSensFadType & modelPar_betars,
   bool modelPar_given_betars,
   AdmsSensFadType & modelPar_delta1rs,
   bool modelPar_given_delta1rs,
   AdmsSensFadType & modelPar_srs,
   bool modelPar_given_srs,
   AdmsSensFadType & modelPar_ndrs,
   bool modelPar_given_ndrs,
   AdmsSensFadType & modelPar_vthetars,
   bool modelPar_given_vthetars,
   AdmsSensFadType & modelPar_mthetars,
   bool modelPar_given_mthetars,
   AdmsSensFadType & modelPar_alphars,
   bool modelPar_given_alphars,
   AdmsSensFadType & modelPar_lgd,
   bool modelPar_given_lgd,
   AdmsSensFadType & modelPar_vtord,
   bool modelPar_given_vtord,
   AdmsSensFadType & modelPar_cgrd,
   bool modelPar_given_cgrd,
   AdmsSensFadType & modelPar_vx0rd,
   bool modelPar_given_vx0rd,
   AdmsSensFadType & modelPar_mu0rd,
   bool modelPar_given_mu0rd,
   AdmsSensFadType & modelPar_betard,
   bool modelPar_given_betard,
   AdmsSensFadType & modelPar_delta1rd,
   bool modelPar_given_delta1rd,
   AdmsSensFadType & modelPar_srd,
   bool modelPar_given_srd,
   AdmsSensFadType & modelPar_ndrd,
   bool modelPar_given_ndrd,
   AdmsSensFadType & modelPar_vthetard,
   bool modelPar_given_vthetard,
   AdmsSensFadType & modelPar_mthetard,
   bool modelPar_given_mthetard,
   AdmsSensFadType & modelPar_alphard,
   bool modelPar_given_alphard,
   AdmsSensFadType & modelPar_lgfp1,
   bool modelPar_given_lgfp1,
   AdmsSensFadType & modelPar_vtofp1,
   bool modelPar_given_vtofp1,
   AdmsSensFadType & modelPar_cgfp1,
   bool modelPar_given_cgfp1,
   AdmsSensFadType & modelPar_cfp1s,
   bool modelPar_given_cfp1s,
   AdmsSensFadType & modelPar_ccfp1,
   bool modelPar_given_ccfp1,
   AdmsSensFadType & modelPar_cbfp1,
   bool modelPar_given_cbfp1,
   AdmsSensFadType & modelPar_vx0fp1,
   bool modelPar_given_vx0fp1,
   AdmsSensFadType & modelPar_mu0fp1,
   bool modelPar_given_mu0fp1,
   AdmsSensFadType & modelPar_betafp1,
   bool modelPar_given_betafp1,
   AdmsSensFadType & modelPar_delta1fp1,
   bool modelPar_given_delta1fp1,
   AdmsSensFadType & modelPar_sfp1,
   bool modelPar_given_sfp1,
   AdmsSensFadType & modelPar_ndfp1,
   bool modelPar_given_ndfp1,
   AdmsSensFadType & modelPar_vthetafp1,
   bool modelPar_given_vthetafp1,
   AdmsSensFadType & modelPar_mthetafp1,
   bool modelPar_given_mthetafp1,
   AdmsSensFadType & modelPar_alphafp1,
   bool modelPar_given_alphafp1,
   AdmsSensFadType & modelPar_lgfp2,
   bool modelPar_given_lgfp2,
   AdmsSensFadType & modelPar_vtofp2,
   bool modelPar_given_vtofp2,
   AdmsSensFadType & modelPar_cgfp2,
   bool modelPar_given_cgfp2,
   AdmsSensFadType & modelPar_cfp2s,
   bool modelPar_given_cfp2s,
   AdmsSensFadType & modelPar_ccfp2,
   bool modelPar_given_ccfp2,
   AdmsSensFadType & modelPar_cbfp2,
   bool modelPar_given_cbfp2,
   AdmsSensFadType & modelPar_vx0fp2,
   bool modelPar_given_vx0fp2,
   AdmsSensFadType & modelPar_mu0fp2,
   bool modelPar_given_mu0fp2,
   AdmsSensFadType & modelPar_betafp2,
   bool modelPar_given_betafp2,
   AdmsSensFadType & modelPar_delta1fp2,
   bool modelPar_given_delta1fp2,
   AdmsSensFadType & modelPar_sfp2,
   bool modelPar_given_sfp2,
   AdmsSensFadType & modelPar_ndfp2,
   bool modelPar_given_ndfp2,
   AdmsSensFadType & modelPar_vthetafp2,
   bool modelPar_given_vthetafp2,
   AdmsSensFadType & modelPar_mthetafp2,
   bool modelPar_given_mthetafp2,
   AdmsSensFadType & modelPar_alphafp2,
   bool modelPar_given_alphafp2,
   AdmsSensFadType & modelPar_lgfp3,
   bool modelPar_given_lgfp3,
   AdmsSensFadType & modelPar_vtofp3,
   bool modelPar_given_vtofp3,
   AdmsSensFadType & modelPar_cgfp3,
   bool modelPar_given_cgfp3,
   AdmsSensFadType & modelPar_cfp3s,
   bool modelPar_given_cfp3s,
   AdmsSensFadType & modelPar_ccfp3,
   bool modelPar_given_ccfp3,
   AdmsSensFadType & modelPar_cbfp3,
   bool modelPar_given_cbfp3,
   AdmsSensFadType & modelPar_vx0fp3,
   bool modelPar_given_vx0fp3,
   AdmsSensFadType & modelPar_mu0fp3,
   bool modelPar_given_mu0fp3,
   AdmsSensFadType & modelPar_betafp3,
   bool modelPar_given_betafp3,
   AdmsSensFadType & modelPar_delta1fp3,
   bool modelPar_given_delta1fp3,
   AdmsSensFadType & modelPar_sfp3,
   bool modelPar_given_sfp3,
   AdmsSensFadType & modelPar_ndfp3,
   bool modelPar_given_ndfp3,
   AdmsSensFadType & modelPar_vthetafp3,
   bool modelPar_given_vthetafp3,
   AdmsSensFadType & modelPar_mthetafp3,
   bool modelPar_given_mthetafp3,
   AdmsSensFadType & modelPar_alphafp3,
   bool modelPar_given_alphafp3,
   AdmsSensFadType & modelPar_lgfp4,
   bool modelPar_given_lgfp4,
   AdmsSensFadType & modelPar_vtofp4,
   bool modelPar_given_vtofp4,
   AdmsSensFadType & modelPar_cgfp4,
   bool modelPar_given_cgfp4,
   AdmsSensFadType & modelPar_cfp4s,
   bool modelPar_given_cfp4s,
   AdmsSensFadType & modelPar_ccfp4,
   bool modelPar_given_ccfp4,
   AdmsSensFadType & modelPar_cbfp4,
   bool modelPar_given_cbfp4,
   AdmsSensFadType & modelPar_vx0fp4,
   bool modelPar_given_vx0fp4,
   AdmsSensFadType & modelPar_mu0fp4,
   bool modelPar_given_mu0fp4,
   AdmsSensFadType & modelPar_betafp4,
   bool modelPar_given_betafp4,
   AdmsSensFadType & modelPar_delta1fp4,
   bool modelPar_given_delta1fp4,
   AdmsSensFadType & modelPar_sfp4,
   bool modelPar_given_sfp4,
   AdmsSensFadType & modelPar_ndfp4,
   bool modelPar_given_ndfp4,
   AdmsSensFadType & modelPar_vthetafp4,
   bool modelPar_given_vthetafp4,
   AdmsSensFadType & modelPar_mthetafp4,
   bool modelPar_given_mthetafp4,
   AdmsSensFadType & modelPar_alphafp4,
   bool modelPar_given_alphafp4,
   AdmsSensFadType & modelPar_rgsp,
   bool modelPar_given_rgsp,
   AdmsSensFadType & modelPar_vjg,
   bool modelPar_given_vjg,
   AdmsSensFadType & modelPar_pg_param1,
   bool modelPar_given_pg_param1,
   AdmsSensFadType & modelPar_pg_params,
   bool modelPar_given_pg_params,
   AdmsSensFadType & modelPar_ijs,
   bool modelPar_given_ijs,
   AdmsSensFadType & modelPar_vgsats,
   bool modelPar_given_vgsats,
   AdmsSensFadType & modelPar_fracs,
   bool modelPar_given_fracs,
   AdmsSensFadType & modelPar_alphags,
   bool modelPar_given_alphags,
   AdmsSensFadType & modelPar_pg_paramd,
   bool modelPar_given_pg_paramd,
   AdmsSensFadType & modelPar_ijd,
   bool modelPar_given_ijd,
   AdmsSensFadType & modelPar_vgsatd,
   bool modelPar_given_vgsatd,
   AdmsSensFadType & modelPar_fracd,
   bool modelPar_given_fracd,
   AdmsSensFadType & modelPar_alphagd,
   bool modelPar_given_alphagd,
   AdmsSensFadType & modelPar_pgsrecs,
   bool modelPar_given_pgsrecs,
   AdmsSensFadType & modelPar_irecs,
   bool modelPar_given_irecs,
   AdmsSensFadType & modelPar_vgsatqs,
   bool modelPar_given_vgsatqs,
   AdmsSensFadType & modelPar_vbdgs,
   bool modelPar_given_vbdgs,
   AdmsSensFadType & modelPar_pbdgs,
   bool modelPar_given_pbdgs,
   AdmsSensFadType & modelPar_betarecs,
   bool modelPar_given_betarecs,
   AdmsSensFadType & modelPar_kbdgates,
   bool modelPar_given_kbdgates,
   AdmsSensFadType & modelPar_pgsrecd,
   bool modelPar_given_pgsrecd,
   AdmsSensFadType & modelPar_irecd,
   bool modelPar_given_irecd,
   AdmsSensFadType & modelPar_vgsatqd,
   bool modelPar_given_vgsatqd,
   AdmsSensFadType & modelPar_vbdgd,
   bool modelPar_given_vbdgd,
   AdmsSensFadType & modelPar_pbdgd,
   bool modelPar_given_pbdgd,
   AdmsSensFadType & modelPar_betarecd,
   bool modelPar_given_betarecd,
   AdmsSensFadType & modelPar_kbdgated,
   bool modelPar_given_kbdgated,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_taugmrf,
   bool modelPar_given_taugmrf,
   AdmsSensFadType & modelPar_ctrap,
   bool modelPar_given_ctrap,
   AdmsSensFadType & modelPar_vttrap,
   bool modelPar_given_vttrap,
   AdmsSensFadType & modelPar_taut,
   bool modelPar_given_taut,
   AdmsSensFadType & modelPar_alphat1,
   bool modelPar_given_alphat1,
   AdmsSensFadType & modelPar_alphat2,
   bool modelPar_given_alphat2,
   AdmsSensFadType & modelPar_tempt,
   bool modelPar_given_tempt,
   AdmsSensFadType & modelPar_shs,
   bool modelPar_given_shs,
   AdmsSensFadType & modelPar_shd,
   bool modelPar_given_shd,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_ffe,
   bool modelPar_given_ffe,
   AdmsSensFadType & modelPar_minr,
   bool modelPar_given_minr,
   AdmsSensFadType & modelPar_minl,
   bool modelPar_given_minl,
   AdmsSensFadType & modelPar_minc,
   bool modelPar_given_minc,
   // non-reals (including hidden)
   int modelPar_type,
   bool modelPar_given_type,
   int modelPar_flagres,
   bool modelPar_given_flagres,
   int modelPar_flagfp1,
   bool modelPar_given_flagfp1,
   int modelPar_flagfp1s,
   bool modelPar_given_flagfp1s,
   int modelPar_flagfp2,
   bool modelPar_given_flagfp2,
   int modelPar_flagfp2s,
   bool modelPar_given_flagfp2s,
   int modelPar_flagfp3,
   bool modelPar_given_flagfp3,
   int modelPar_flagfp3s,
   bool modelPar_given_flagfp3s,
   int modelPar_flagfp4,
   bool modelPar_given_flagfp4,
   int modelPar_flagfp4s,
   bool modelPar_given_flagfp4s,
   int modelPar_igmod,
   bool modelPar_given_igmod,
   int modelPar_gmdisp,
   bool modelPar_given_gmdisp,
   int modelPar_trapselect,
   bool modelPar_given_trapselect,
   int modelPar_noisemod,
   bool modelPar_given_noisemod,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType pdiss;
  double svc;
  double gm;
  AdmsSensFadType qofgsub;
  AdmsSensFadType qofssub;
  AdmsSensFadType qofdsub;
  AdmsSensFadType qofds;
  AdmsSensFadType qofd;
  AdmsSensFadType qofs;
  AdmsSensFadType igdi;
  AdmsSensFadType igsi;
  double idsrf;
  AdmsSensFadType ids;
  AdmsSensFadType idsrd;
  AdmsSensFadType idsrs;
  AdmsSensFadType idsfp1;
  AdmsSensFadType idsfp2;
  AdmsSensFadType idsfp3;
  AdmsSensFadType idsfp4;
  AdmsSensFadType vbfp4;
  AdmsSensFadType vdsfp4;
  AdmsSensFadType vcfp4;
  AdmsSensFadType vgsfp4;
  AdmsSensFadType vbfp3;
  AdmsSensFadType vdsfp3;
  AdmsSensFadType vcfp3;
  AdmsSensFadType vgsfp3;
  AdmsSensFadType vbfp2;
  AdmsSensFadType vdsfp2;
  AdmsSensFadType vcfp2;
  AdmsSensFadType vgsfp2;
  AdmsSensFadType vbfp1;
  AdmsSensFadType vdsfp1;
  AdmsSensFadType vcfp1;
  AdmsSensFadType vgsfp1;
  AdmsSensFadType vgsrd;
  AdmsSensFadType vdsrd;
  AdmsSensFadType vigd;
  AdmsSensFadType vdars;
  AdmsSensFadType drsht;
  double vtcollapse;
  AdmsSensFadType vtcollapse0;
  AdmsSensFadType vgsrs;
  AdmsSensFadType vdsrs;
  AdmsSensFadType vigs;
  AdmsSensFadType vsars;
  AdmsSensFadType vgsi;
  AdmsSensFadType vdsi;
  AdmsSensFadType ttrapfac;
  AdmsSensFadType phit;
  AdmsSensFadType rdi;
  AdmsSensFadType rsi;
  AdmsSensFadType tdut;
  double tsh;
  double tambk;
  AdmsSensFadType tnomk;
  double gmin;


  // -- code converted from analog/code block
  //Begin block initial_step
  {
    if ((0==1))
    {
      instanceVar_qgsfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgdfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qcfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qbfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qsfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdiblfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsatfp4 = ((((((((probeVars[admsProbeID_V_gi_fp3])+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_b_fp3]))+(probeVars[admsProbeID_V_s_fp4]))+(probeVars[admsProbeID_V_gi_fp4]))+(probeVars[admsProbeID_V_fp4_fp3]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgsfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgdfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qcfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qbfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qsfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdiblfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsatfp3 = ((((((((probeVars[admsProbeID_V_gi_fp2])+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_b_fp2]))+(probeVars[admsProbeID_V_s_fp3]))+(probeVars[admsProbeID_V_gi_fp3]))+(probeVars[admsProbeID_V_fp3_fp2]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgsfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgdfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qcfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qbfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qsfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdiblfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsatfp2 = ((((((((probeVars[admsProbeID_V_gi_fp1])+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_b_fp1]))+(probeVars[admsProbeID_V_s_fp2]))+(probeVars[admsProbeID_V_gi_fp2]))+(probeVars[admsProbeID_V_fp2_fp1]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgsfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgdfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qcfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qbfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qsfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdiblfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsatfp1 = ((((((((probeVars[admsProbeID_V_gi_di])+(probeVars[admsProbeID_V_s_di]))+(probeVars[admsProbeID_V_b_di]))+(probeVars[admsProbeID_V_s_fp1]))+(probeVars[admsProbeID_V_gi_fp1]))+(probeVars[admsProbeID_V_fp1_di]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgsrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgdrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qcrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qbrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qsrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdiblrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsatrs = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_src_GND]))+(probeVars[admsProbeID_V_si_GND]))+(probeVars[admsProbeID_V_si_src]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgsrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgdrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qcrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qbrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qsrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdiblrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsatrd = (((((((probeVars[admsProbeID_V_d_GND])+(probeVars[admsProbeID_V_s_GND]))+(probeVars[admsProbeID_V_fp4_GND]))+(probeVars[admsProbeID_V_drc_GND]))+(probeVars[admsProbeID_V_drc_fp4]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgs = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qgd = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qc = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qb = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_qs = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vtdibli = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_vdsat1i = (((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_gi_di]))+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_igssdio = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_igsrec = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_igdsdio = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
      instanceVar_igdrec = ((((probeVars[admsProbeID_V_gi_si])+(probeVars[admsProbeID_V_di_si]))+(probeVars[admsProbeID_Temp_dt_GND]))+modelPar_type);
    }
  }
  // End block initial_step
  gmin = ADMSgmin_arg;
  tnomk = (modelPar_tnom+273.15);
  tambk = admsTemperature;
  tsh = (probeVars[admsProbeID_Temp_dt_GND]);
  tdut = ((tambk+instancePar_dtemp)+tsh);
  if ((tdut<((-270.0)+273.15)))
  {
    tdut = ((-270.0)+273.15);
  }
  else
  {
    if ((tdut>(1500+273.15)))
    {
      tdut = (1500+273.15);
    }
  }
  rsi = 0;
  rdi = 0;
  if ((instanceVar_rcs_w>=modelPar_minr))
  {
    rsi = (instanceVar_rcs_w*((1.0+(modelPar_rct1*(tdut-tnomk)))+((modelPar_rct2*(tdut-tnomk))*(tdut-tnomk))));
    if ((rsi<(0.1*instanceVar_rcs_w)))
    {
      rsi = (0.1*instanceVar_rcs_w);
    }
  }
  else
  {
    rsi = 0;
  }
  if ((instanceVar_rcd_w>=modelPar_minr))
  {
    rdi = (instanceVar_rcd_w*((1.0+(modelPar_rct1*(tdut-tnomk)))+((modelPar_rct2*(tdut-tnomk))*(tdut-tnomk))));
    if ((rdi<(0.1*instanceVar_rcd_w)))
    {
      rdi = (0.1*instanceVar_rcd_w);
    }
  }
  else
  {
    rdi = 0;
  }
  phit = ((1.38062e-23*tdut)/1.60219e-19);
  ttrapfac = (1.0+(modelPar_tempt*(tdut-tnomk)));
  vdsi = (modelPar_type*(probeVars[admsProbeID_V_di_si]));
  vgsi = (modelPar_type*(probeVars[admsProbeID_V_gi_si]));
  if (((modelPar_type*(probeVars[admsProbeID_V_src_d]))<=(modelPar_type*(probeVars[admsProbeID_V_src_s]))))
  {
    vsars = (modelPar_type*(probeVars[admsProbeID_V_src_s]));
  }
  else
  {
    vsars = (modelPar_type*(probeVars[admsProbeID_V_src_d]));
  }
  vigs = (modelPar_vtors+(1.0/((modelPar_rsh*modelPar_cgrs)*modelPar_mu0)));
  vdsrs = (modelPar_type*(probeVars[admsProbeID_V_si_src]));
  vgsrs = (vigs-vsars);
  if ((modelPar_trapselect!=0))
  {
    vtcollapse0 = ((modelPar_alphat1*fabs((probeVars[admsProbeID_V_d_g])))+AnalogFunctions::explim<AdmsSensFadType>((((probeVars[admsProbeID_V_d_g])-modelPar_vttrap)/modelPar_alphat2)));
    // I(tr1,GND) <+ ((-vtcollapse0))
    staticContributions[admsNodeID_tr1] += (-vtcollapse0);
    // I(tr1,tr) <+ (ddt((ctrap*V(tr1,tr))))
    dynamicContributions[admsNodeID_tr1] += ((modelPar_ctrap*(probeVars[admsProbeID_V_tr1_tr])));
    dynamicContributions[admsNodeID_tr] -= ((modelPar_ctrap*(probeVars[admsProbeID_V_tr1_tr])));
    // I(tr,GND) <+ (ddt((taut*V(tr,GND))))
    dynamicContributions[admsNodeID_tr] += ((modelPar_taut*(probeVars[admsProbeID_V_tr_GND])));
    // I(tr,GND) <+ (V(tr,GND))
    staticContributions[admsNodeID_tr] += (probeVars[admsProbeID_V_tr_GND]);
    vtcollapse = (probeVars[admsProbeID_V_tr_GND]);
    drsht = (1.0+(vtcollapse*ttrapfac));
  }
  else
  {
    vtcollapse0 = 0;
    vtcollapse = 0;
    // V(tr1,GND) <+ (0)
    // do nothing at all
    // V(tr,GND) <+ (0)
    // do nothing at all
    drsht = 1.0;
  }
  if (((modelPar_type*(probeVars[admsProbeID_V_fp4_d]))<=(modelPar_type*(probeVars[admsProbeID_V_fp4_s]))))
  {
    vdars = (modelPar_type*(probeVars[admsProbeID_V_fp4_s]));
  }
  else
  {
    vdars = (modelPar_type*(probeVars[admsProbeID_V_fp4_d]));
  }
  vigd = (modelPar_vtord+(1.0/(((drsht*modelPar_rsh)*modelPar_cgrd)*modelPar_mu0)));
  vdsrd = (modelPar_type*(probeVars[admsProbeID_V_drc_fp4]));
  vgsrd = (vigd-vdars);
  if ((modelPar_flagfp1==1))
  {
    vgsfp1 = (modelPar_type*(probeVars[admsProbeID_V_gi_di]));
    vcfp1 = (modelPar_type*(probeVars[admsProbeID_V_s_di]));
  }
  else
  {
    vgsfp1 = (modelPar_type*(probeVars[admsProbeID_V_s_di]));
    vcfp1 = (modelPar_type*(probeVars[admsProbeID_V_gi_di]));
  }
  vdsfp1 = (modelPar_type*(probeVars[admsProbeID_V_fp1_di]));
  vbfp1 = (modelPar_type*(probeVars[admsProbeID_V_b_di]));
  if ((modelPar_flagfp2==1))
  {
    vgsfp2 = (modelPar_type*(probeVars[admsProbeID_V_gi_fp1]));
    vcfp2 = (modelPar_type*(probeVars[admsProbeID_V_s_fp1]));
  }
  else
  {
    vgsfp2 = (modelPar_type*(probeVars[admsProbeID_V_s_fp1]));
    vcfp2 = (modelPar_type*(probeVars[admsProbeID_V_gi_fp1]));
  }
  vdsfp2 = (modelPar_type*(probeVars[admsProbeID_V_fp2_fp1]));
  vbfp2 = (modelPar_type*(probeVars[admsProbeID_V_b_fp1]));
  if ((modelPar_flagfp3==1))
  {
    vgsfp3 = (modelPar_type*(probeVars[admsProbeID_V_gi_fp2]));
    vcfp3 = (modelPar_type*(probeVars[admsProbeID_V_s_fp2]));
  }
  else
  {
    vgsfp3 = (modelPar_type*(probeVars[admsProbeID_V_s_fp2]));
    vcfp3 = (modelPar_type*(probeVars[admsProbeID_V_gi_fp2]));
  }
  vdsfp3 = (modelPar_type*(probeVars[admsProbeID_V_fp3_fp2]));
  vbfp3 = (modelPar_type*(probeVars[admsProbeID_V_b_fp2]));
  if ((modelPar_flagfp4==1))
  {
    vgsfp4 = (modelPar_type*(probeVars[admsProbeID_V_gi_fp3]));
    vcfp4 = (modelPar_type*(probeVars[admsProbeID_V_s_fp3]));
  }
  else
  {
    vgsfp4 = (modelPar_type*(probeVars[admsProbeID_V_s_fp3]));
    vcfp4 = (modelPar_type*(probeVars[admsProbeID_V_gi_fp3]));
  }
  vdsfp4 = (modelPar_type*(probeVars[admsProbeID_V_fp4_fp3]));
  vbfp4 = (modelPar_type*(probeVars[admsProbeID_V_b_fp3]));
  idsfp4 = 0;
  instanceVar_qgsfp4 = 0;
  instanceVar_qgdfp4 = 0;
  instanceVar_qcfp4 = 0;
  instanceVar_qbfp4 = 0;
  instanceVar_qsfp4 = 0;
  instanceVar_vtdiblfp4 = 0;
  instanceVar_vdsatfp4 = 0;
  if ((modelPar_lgfp4>modelPar_minl))
  {
    idsfp4 = AnalogFunctions::calc_iq<AdmsSensFadType>(idsfp4,instanceVar_qgsfp4,instanceVar_qgdfp4,instanceVar_qcfp4,instanceVar_qbfp4,instanceVar_qsfp4,instanceVar_vtdiblfp4,instanceVar_vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,modelPar_flagfp4s,tdut,tnomk,phit,instancePar_w,modelPar_lgfp4,modelPar_cgfp4,modelPar_cfp4s,modelPar_ccfp4,modelPar_cbfp4,modelPar_vtofp4,modelPar_sfp4,modelPar_delta1fp4,0.0,modelPar_ndfp4,modelPar_alphafp4,modelPar_vx0fp4,modelPar_mu0fp4,modelPar_betafp4,modelPar_mthetafp4,modelPar_vthetafp4,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
    // I(fp4,fp3) <+ ((idsfp4+(gmin*V(fp4,fp3))))
    staticContributions[admsNodeID_fp4] += (idsfp4+(gmin*(probeVars[admsProbeID_V_fp4_fp3])));
    staticContributions[admsNodeID_fp3] -= (idsfp4+(gmin*(probeVars[admsProbeID_V_fp4_fp3])));
  }
  else
  {
    // V(fp4,fp3) <+ (0)
    // do nothing at all
  }
  if ((modelPar_flagfp4==1))
  {
    // I(gi,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(gi,fp3)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgsfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qgsfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp3]))));
    // I(gi,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(gi,fp4)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgdfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp4]))));
    dynamicContributions[admsNodeID_fp4] -= ((instanceVar_qgdfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp4]))));
    // I(s,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(s,fp3)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qcfp4)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qcfp4)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp3]))));
    // I(s,fp4) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp4] -= 0;
    // I(gi,si) <+ ((ddt(qsfp4)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qsfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((instanceVar_qsfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(s,fp3)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgsfp4)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qgsfp4)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp3]))));
    // I(s,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(s,fp4)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgdfp4)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp4]))));
    dynamicContributions[admsNodeID_fp4] -= ((instanceVar_qgdfp4)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp4]))));
    // I(gi,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(gi,fp3)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qcfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qcfp4)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp3]))));
    // I(gi,fp4) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp4] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,fp3) <+ ((ddt(qbfp4)+ddt((minc*V(b,fp3)))))
  dynamicContributions[admsNodeID_b] += ((instanceVar_qbfp4)+((modelPar_minc*(probeVars[admsProbeID_V_b_fp3]))));
  dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qbfp4)+((modelPar_minc*(probeVars[admsProbeID_V_b_fp3]))));
  idsfp3 = 0;
  instanceVar_qgsfp3 = 0;
  instanceVar_qgdfp3 = 0;
  instanceVar_qcfp3 = 0;
  instanceVar_qbfp3 = 0;
  instanceVar_qsfp3 = 0;
  instanceVar_vtdiblfp3 = 0;
  instanceVar_vdsatfp3 = 0;
  if ((modelPar_lgfp3>modelPar_minl))
  {
    idsfp3 = AnalogFunctions::calc_iq<AdmsSensFadType>(idsfp3,instanceVar_qgsfp3,instanceVar_qgdfp3,instanceVar_qcfp3,instanceVar_qbfp3,instanceVar_qsfp3,instanceVar_vtdiblfp3,instanceVar_vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,modelPar_flagfp3s,tdut,tnomk,phit,instancePar_w,modelPar_lgfp3,modelPar_cgfp3,modelPar_cfp3s,modelPar_ccfp3,modelPar_cbfp3,modelPar_vtofp3,modelPar_sfp3,modelPar_delta1fp3,0.0,modelPar_ndfp3,modelPar_alphafp3,modelPar_vx0fp3,modelPar_mu0fp3,modelPar_betafp3,modelPar_mthetafp3,modelPar_vthetafp3,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
    // I(fp3,fp2) <+ ((idsfp3+(gmin*V(fp3,fp2))))
    staticContributions[admsNodeID_fp3] += (idsfp3+(gmin*(probeVars[admsProbeID_V_fp3_fp2])));
    staticContributions[admsNodeID_fp2] -= (idsfp3+(gmin*(probeVars[admsProbeID_V_fp3_fp2])));
  }
  else
  {
    // V(fp3,fp2) <+ (0)
    // do nothing at all
  }
  if ((modelPar_flagfp3==1))
  {
    // I(gi,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(gi,fp2)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgsfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qgsfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp2]))));
    // I(gi,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(gi,fp3)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgdfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qgdfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp3]))));
    // I(s,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(s,fp2)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qcfp3)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qcfp3)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp2]))));
    // I(s,fp3) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp3] -= 0;
    // I(gi,si) <+ ((ddt(qsfp3)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qsfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((instanceVar_qsfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(s,fp2)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgsfp3)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qgsfp3)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp2]))));
    // I(s,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(s,fp3)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgdfp3)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp3]))));
    dynamicContributions[admsNodeID_fp3] -= ((instanceVar_qgdfp3)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp3]))));
    // I(gi,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(gi,fp2)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qcfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qcfp3)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp2]))));
    // I(gi,fp3) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp3] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,fp2) <+ ((ddt(qbfp3)+ddt((minc*V(b,fp2)))))
  dynamicContributions[admsNodeID_b] += ((instanceVar_qbfp3)+((modelPar_minc*(probeVars[admsProbeID_V_b_fp2]))));
  dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qbfp3)+((modelPar_minc*(probeVars[admsProbeID_V_b_fp2]))));
  idsfp2 = 0;
  instanceVar_qgsfp2 = 0;
  instanceVar_qgdfp2 = 0;
  instanceVar_qcfp2 = 0;
  instanceVar_qbfp2 = 0;
  instanceVar_qsfp2 = 0;
  instanceVar_vtdiblfp2 = 0;
  instanceVar_vdsatfp2 = 0;
  if ((modelPar_lgfp2>modelPar_minl))
  {
    idsfp2 = AnalogFunctions::calc_iq<AdmsSensFadType>(idsfp2,instanceVar_qgsfp2,instanceVar_qgdfp2,instanceVar_qcfp2,instanceVar_qbfp2,instanceVar_qsfp2,instanceVar_vtdiblfp2,instanceVar_vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,modelPar_flagfp2s,tdut,tnomk,phit,instancePar_w,modelPar_lgfp2,modelPar_cgfp2,modelPar_cfp2s,modelPar_ccfp2,modelPar_cbfp2,modelPar_vtofp2,modelPar_sfp2,modelPar_delta1fp2,0.0,modelPar_ndfp2,modelPar_alphafp2,modelPar_vx0fp2,modelPar_mu0fp2,modelPar_betafp2,modelPar_mthetafp2,modelPar_vthetafp2,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
    // I(fp2,fp1) <+ ((idsfp2+(gmin*V(fp2,fp1))))
    staticContributions[admsNodeID_fp2] += (idsfp2+(gmin*(probeVars[admsProbeID_V_fp2_fp1])));
    staticContributions[admsNodeID_fp1] -= (idsfp2+(gmin*(probeVars[admsProbeID_V_fp2_fp1])));
  }
  else
  {
    // V(fp2,fp1) <+ (0)
    // do nothing at all
  }
  if ((modelPar_flagfp2==1))
  {
    // I(gi,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(gi,fp1)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgsfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qgsfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp1]))));
    // I(gi,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(gi,fp2)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgdfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qgdfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp2]))));
    // I(s,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(s,fp1)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qcfp2)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qcfp2)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp1]))));
    // I(s,fp2) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp2] -= 0;
    // I(gi,si) <+ ((ddt(qsfp2)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qsfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((instanceVar_qsfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(s,fp1)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgsfp2)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qgsfp2)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp1]))));
    // I(s,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(s,fp2)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgdfp2)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp2]))));
    dynamicContributions[admsNodeID_fp2] -= ((instanceVar_qgdfp2)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp2]))));
    // I(gi,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(gi,fp1)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qcfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qcfp2)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp1]))));
    // I(gi,fp2) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp2] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,fp1) <+ ((ddt(qbfp2)+ddt((minc*V(b,fp1)))))
  dynamicContributions[admsNodeID_b] += ((instanceVar_qbfp2)+((modelPar_minc*(probeVars[admsProbeID_V_b_fp1]))));
  dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qbfp2)+((modelPar_minc*(probeVars[admsProbeID_V_b_fp1]))));
  idsfp1 = 0;
  instanceVar_qgsfp1 = 0;
  instanceVar_qgdfp1 = 0;
  instanceVar_qcfp1 = 0;
  instanceVar_qbfp1 = 0;
  instanceVar_qsfp1 = 0;
  instanceVar_vtdiblfp1 = 0;
  instanceVar_vdsatfp1 = 0;
  if ((modelPar_lgfp1>modelPar_minl))
  {
    idsfp1 = AnalogFunctions::calc_iq<AdmsSensFadType>(idsfp1,instanceVar_qgsfp1,instanceVar_qgdfp1,instanceVar_qcfp1,instanceVar_qbfp1,instanceVar_qsfp1,instanceVar_vtdiblfp1,instanceVar_vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,modelPar_flagfp1s,tdut,tnomk,phit,instancePar_w,modelPar_lgfp1,modelPar_cgfp1,modelPar_cfp1s,modelPar_ccfp1,modelPar_cbfp1,modelPar_vtofp1,modelPar_sfp1,modelPar_delta1fp1,0.0,modelPar_ndfp1,modelPar_alphafp1,modelPar_vx0fp1,modelPar_mu0fp1,modelPar_betafp1,modelPar_mthetafp1,modelPar_vthetafp1,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
    // I(fp1,di) <+ ((idsfp1+(gmin*V(fp1,di))))
    staticContributions[admsNodeID_fp1] += (idsfp1+(gmin*(probeVars[admsProbeID_V_fp1_di])));
    staticContributions[admsNodeID_di] -= (idsfp1+(gmin*(probeVars[admsProbeID_V_fp1_di])));
  }
  else
  {
    // V(fp1,di) <+ (0)
    // do nothing at all
  }
  if ((modelPar_flagfp1==1))
  {
    // I(gi,di) <+ ((ddt(qgsfp1)+ddt((minc*V(gi,di)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgsfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_di]))));
    dynamicContributions[admsNodeID_di] -= ((instanceVar_qgsfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_di]))));
    // I(gi,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(gi,fp1)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qgdfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qgdfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_fp1]))));
    // I(s,di) <+ ((ddt(qcfp1)+ddt((minc*V(s,di)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qcfp1)+((modelPar_minc*(probeVars[admsProbeID_V_s_di]))));
    dynamicContributions[admsNodeID_di] -= ((instanceVar_qcfp1)+((modelPar_minc*(probeVars[admsProbeID_V_s_di]))));
    // I(s,fp1) <+ (0)
    staticContributions[admsNodeID_s] += 0;
    staticContributions[admsNodeID_fp1] -= 0;
    // I(gi,si) <+ ((ddt(qsfp1)+ddt((minc*V(gi,si)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qsfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
    dynamicContributions[admsNodeID_si] -= ((instanceVar_qsfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
  }
  else
  {
    // I(s,di) <+ ((ddt(qgsfp1)+ddt((minc*V(s,di)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgsfp1)+((modelPar_minc*(probeVars[admsProbeID_V_s_di]))));
    dynamicContributions[admsNodeID_di] -= ((instanceVar_qgsfp1)+((modelPar_minc*(probeVars[admsProbeID_V_s_di]))));
    // I(s,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(s,fp1)))))
    dynamicContributions[admsNodeID_s] += ((instanceVar_qgdfp1)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp1]))));
    dynamicContributions[admsNodeID_fp1] -= ((instanceVar_qgdfp1)+((modelPar_minc*(probeVars[admsProbeID_V_s_fp1]))));
    // I(gi,di) <+ ((ddt(qcfp1)+ddt((minc*V(gi,di)))))
    dynamicContributions[admsNodeID_gi] += ((instanceVar_qcfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_di]))));
    dynamicContributions[admsNodeID_di] -= ((instanceVar_qcfp1)+((modelPar_minc*(probeVars[admsProbeID_V_gi_di]))));
    // I(gi,fp1) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_fp1] -= 0;
    // I(gi,si) <+ (0)
    staticContributions[admsNodeID_gi] += 0;
    staticContributions[admsNodeID_si] -= 0;
  }
  // I(b,di) <+ ((ddt(qbfp1)+ddt((minc*V(b,di)))))
  dynamicContributions[admsNodeID_b] += ((instanceVar_qbfp1)+((modelPar_minc*(probeVars[admsProbeID_V_b_di]))));
  dynamicContributions[admsNodeID_di] -= ((instanceVar_qbfp1)+((modelPar_minc*(probeVars[admsProbeID_V_b_di]))));
  idsrs = 0;
  if (((modelPar_flagres==0)&&(modelPar_lgs>modelPar_minl)))
  {
    idsrs = AnalogFunctions::calc_iq<AdmsSensFadType>(idsrs,instanceVar_qgsrs,instanceVar_qgdrs,instanceVar_qcrs,instanceVar_qbrs,instanceVar_qsrs,instanceVar_vtdiblrs,instanceVar_vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,instancePar_w,modelPar_lgs,modelPar_cgrs,0,0,0,modelPar_vtors,modelPar_srs,modelPar_delta1rs,0.0,modelPar_ndrs,modelPar_alphars,modelPar_vx0rs,modelPar_mu0rs,modelPar_betars,modelPar_mthetars,modelPar_vthetars,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
    // I(si,src) <+ ((idsrs+(gmin*V(si,src))))
    staticContributions[admsNodeID_si] += (idsrs+(gmin*(probeVars[admsProbeID_V_si_src])));
    staticContributions[admsNodeID_src] -= (idsrs+(gmin*(probeVars[admsProbeID_V_si_src])));
  }
  else
  {
    // V(src,si) <+ (0)
    // do nothing at all
  }
  idsrd = 0;
  if (((modelPar_flagres==0)&&(modelPar_lgd>modelPar_minl)))
  {
    idsrd = AnalogFunctions::calc_iq<AdmsSensFadType>(idsrd,instanceVar_qgsrd,instanceVar_qgdrd,instanceVar_qcrd,instanceVar_qbrd,instanceVar_qsrd,instanceVar_vtdiblrd,instanceVar_vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,instancePar_w,modelPar_lgd,modelPar_cgrd,0,0,0,modelPar_vtord,modelPar_srd,modelPar_delta1rd,0.0,modelPar_ndrd,modelPar_alphard,modelPar_vx0rd,modelPar_mu0rd,modelPar_betard,modelPar_mthetard,modelPar_vthetard,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
    // I(drc,fp4) <+ ((idsrd+(gmin*V(drc,fp4))))
    staticContributions[admsNodeID_drc] += (idsrd+(gmin*(probeVars[admsProbeID_V_drc_fp4])));
    staticContributions[admsNodeID_fp4] -= (idsrd+(gmin*(probeVars[admsProbeID_V_drc_fp4])));
  }
  else
  {
    // V(drc,fp4) <+ (0)
    // do nothing at all
  }
  ids = AnalogFunctions::calc_iq<AdmsSensFadType>(ids,instanceVar_qgs,instanceVar_qgd,instanceVar_qc,instanceVar_qb,instanceVar_qs,instanceVar_vtdibli,instanceVar_vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,instancePar_w,instancePar_l,modelPar_cg,0,0,0,modelPar_vto,modelPar_ss,modelPar_delta1,modelPar_delta2,modelPar_nd,modelPar_alpha,modelPar_vx0,modelPar_mu0,modelPar_beta,modelPar_mtheta,modelPar_vtheta,modelPar_vtzeta,modelPar_dibsat,modelPar_epsilon,modelPar_vzeta,modelPar_lambda,instancePar_ngf,modelPar_type);
  idsrf = (probeVars[admsProbeID_V_xt2_GND]);
  if ((modelPar_gmdisp==0))
  {
    // V(xt1,GND) <+ (0)
    // do nothing at all
    // V(xt2,GND) <+ (0)
    // do nothing at all
    // I(di,si) <+ ((ids+(gmin*V(di,si))))
    staticContributions[admsNodeID_di] += (ids+(gmin*(probeVars[admsProbeID_V_di_si])));
    staticContributions[admsNodeID_si] -= (ids+(gmin*(probeVars[admsProbeID_V_di_si])));
  }
  else
  {
    // I(xt1,GND) <+ ((ids-V(xt2,GND)))
    staticContributions[admsNodeID_xt1] += (ids-(probeVars[admsProbeID_V_xt2_GND]));
    // I(xt1,GND) <+ ((-ddt((taugmrf*V(xt1,GND)))))
    dynamicContributions[admsNodeID_xt1] += (-((modelPar_taugmrf*(probeVars[admsProbeID_V_xt1_GND]))));
    // I(xt2,GND) <+ ((V(xt1,GND)-V(xt2,GND)))
    staticContributions[admsNodeID_xt2] += ((probeVars[admsProbeID_V_xt1_GND])-(probeVars[admsProbeID_V_xt2_GND]));
    // I(xt2,GND) <+ ((-ddt(((taugmrf/3.0)*V(xt2,GND)))))
    dynamicContributions[admsNodeID_xt2] += (-(((modelPar_taugmrf/3.0)*(probeVars[admsProbeID_V_xt2_GND]))));
    // I(di,si) <+ ((idsrf+(gmin*V(di,si))))
    staticContributions[admsNodeID_di] += (idsrf+(gmin*(probeVars[admsProbeID_V_di_si])));
    staticContributions[admsNodeID_si] -= (idsrf+(gmin*(probeVars[admsProbeID_V_di_si])));
  }
  // I(gi,si) <+ ((ddt(qgs)+ddt((minc*V(gi,si)))))
  dynamicContributions[admsNodeID_gi] += ((instanceVar_qgs)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
  dynamicContributions[admsNodeID_si] -= ((instanceVar_qgs)+((modelPar_minc*(probeVars[admsProbeID_V_gi_si]))));
  // I(gi,di) <+ ((ddt(qgd)+ddt((minc*V(gi,di)))))
  dynamicContributions[admsNodeID_gi] += ((instanceVar_qgd)+((modelPar_minc*(probeVars[admsProbeID_V_gi_di]))));
  dynamicContributions[admsNodeID_di] -= ((instanceVar_qgd)+((modelPar_minc*(probeVars[admsProbeID_V_gi_di]))));
  igsi = 0;
  igdi = 0;
  instanceVar_igssdio = 0;
  instanceVar_igdsdio = 0;
  instanceVar_igsrec = 0;
  instanceVar_igdrec = 0;
  if ((modelPar_igmod==1))
  {
    igsi = AnalogFunctions::calc_ig<AdmsSensFadType>(instanceVar_igssdio,instanceVar_igsrec,vgsi,phit,modelPar_vgsats,modelPar_alphags,modelPar_fracs,modelPar_pg_params,modelPar_pbdgs,modelPar_vbdgs,tdut,tnomk,instancePar_w,instancePar_ngf,modelPar_ijs,modelPar_kbdgates,modelPar_vgsatqs,modelPar_betarecs,modelPar_irecs,modelPar_pgsrecs,modelPar_pg_param1,modelPar_vjg,modelPar_type);
    igdi = AnalogFunctions::calc_ig<AdmsSensFadType>(instanceVar_igdsdio,instanceVar_igdrec,(vgsi-vdsi),phit,modelPar_vgsatd,modelPar_alphagd,modelPar_fracd,modelPar_pg_paramd,modelPar_pbdgd,modelPar_vbdgd,tdut,tnomk,instancePar_w,instancePar_ngf,modelPar_ijd,modelPar_kbdgated,modelPar_vgsatqd,modelPar_betarecd,modelPar_irecd,modelPar_pgsrecd,modelPar_pg_param1,modelPar_vjg,modelPar_type);
    // I(gi,si) <+ ((igsi+(gmin*V(gi,si))))
    staticContributions[admsNodeID_gi] += (igsi+(gmin*(probeVars[admsProbeID_V_gi_si])));
    staticContributions[admsNodeID_si] -= (igsi+(gmin*(probeVars[admsProbeID_V_gi_si])));
    // I(gi,di) <+ ((igdi+(gmin*V(gi,di))))
    staticContributions[admsNodeID_gi] += (igdi+(gmin*(probeVars[admsProbeID_V_gi_di])));
    staticContributions[admsNodeID_di] -= (igdi+(gmin*(probeVars[admsProbeID_V_gi_di])));
  }
  if ((instanceVar_rcd_w<=modelPar_minr))
  {
    // V(d,drc) <+ (0)
    // do nothing at all
  }
  else
  {
    // I(d,drc) <+ ((V(d,drc)/rdi))
    staticContributions[admsNodeID_d] += ((probeVars[admsProbeID_V_d_drc])/rdi);
    staticContributions[admsNodeID_drc] -= ((probeVars[admsProbeID_V_d_drc])/rdi);
  }
  if ((instanceVar_rcs_w<=modelPar_minr))
  {
    // V(src,s) <+ (0)
    // do nothing at all
  }
  else
  {
    // I(src,s) <+ ((V(src,s)/rsi))
    staticContributions[admsNodeID_src] += ((probeVars[admsProbeID_V_src_s])/rsi);
    staticContributions[admsNodeID_s] -= ((probeVars[admsProbeID_V_src_s])/rsi);
  }
  if ((instanceVar_rg<=modelPar_minr))
  {
    // V(g,gi) <+ (0)
    // do nothing at all
  }
  else
  {
    // I(g,gi) <+ ((V(g,gi)/rg))
    staticContributions[admsNodeID_g] += ((probeVars[admsProbeID_V_g_gi])/instanceVar_rg);
    staticContributions[admsNodeID_gi] -= ((probeVars[admsProbeID_V_g_gi])/instanceVar_rg);
  }
  qofs = (((instancePar_w*instancePar_ngf)*modelPar_cofsm)*(probeVars[admsProbeID_V_gi_s]));
  // I(gi,s) <+ (ddt(qofs))
  dynamicContributions[admsNodeID_gi] += (qofs);
  dynamicContributions[admsNodeID_s] -= (qofs);
  qofd = (((instancePar_w*instancePar_ngf)*modelPar_cofdm)*(probeVars[admsProbeID_V_gi_d]));
  // I(gi,d) <+ (ddt(qofd))
  dynamicContributions[admsNodeID_gi] += (qofd);
  dynamicContributions[admsNodeID_d] -= (qofd);
  qofds = (((instancePar_w*instancePar_ngf)*modelPar_cofdsm)*(probeVars[admsProbeID_V_d_s]));
  // I(d,s) <+ (ddt(qofds))
  dynamicContributions[admsNodeID_d] += (qofds);
  dynamicContributions[admsNodeID_s] -= (qofds);
  qofdsub = (((instancePar_w*instancePar_ngf)*modelPar_cofdsubm)*(probeVars[admsProbeID_V_d_b]));
  // I(d,b) <+ (ddt(qofdsub))
  dynamicContributions[admsNodeID_d] += (qofdsub);
  dynamicContributions[admsNodeID_b] -= (qofdsub);
  qofssub = (((instancePar_w*instancePar_ngf)*modelPar_cofssubm)*(probeVars[admsProbeID_V_s_b]));
  // I(s,b) <+ (ddt(qofssub))
  dynamicContributions[admsNodeID_s] += (qofssub);
  dynamicContributions[admsNodeID_b] -= (qofssub);
  qofgsub = (((instancePar_w*instancePar_ngf)*modelPar_cofgsubm)*(probeVars[admsProbeID_V_gi_b]));
  // I(gi,b) <+ (ddt(qofgsub))
  dynamicContributions[admsNodeID_gi] += (qofgsub);
  dynamicContributions[admsNodeID_b] -= (qofgsub);
  gm = 0;
  svc = 0;
  if ((modelPar_noisemod==1))
  {
    UserError(theInstance) << "$finish called." << std::endl; 
  }
  pdiss = (((((((ids*(probeVars[admsProbeID_V_di_si]))+(idsrd*(probeVars[admsProbeID_V_drc_fp4])))+(idsrs*(probeVars[admsProbeID_V_si_src])))+(idsfp1*(probeVars[admsProbeID_V_fp1_di])))+(idsfp2*(probeVars[admsProbeID_V_fp2_fp1])))+(idsfp3*(probeVars[admsProbeID_V_fp3_fp2])))+(idsfp4*(probeVars[admsProbeID_V_fp4_fp3])));
  if ((rdi!=0))
  {
    pdiss = (pdiss+(((probeVars[admsProbeID_V_drc_d])*(probeVars[admsProbeID_V_drc_d]))/rdi));
  }
  if ((rsi!=0))
  {
    pdiss = (pdiss+(((probeVars[admsProbeID_V_src_s])*(probeVars[admsProbeID_V_src_s]))/rsi));
  }
  if ((modelPar_rth>0))
  {
    // Pwr(dt,GND) <+ (ddt((cth*Temp(dt,GND))))
    dynamicContributions[admsNodeID_dt] += ((modelPar_cth*(probeVars[admsProbeID_Temp_dt_GND])));
    // Pwr(dt,GND) <+ ((-pdiss))
    staticContributions[admsNodeID_dt] += (-pdiss);
    // Pwr(dt,GND) <+ ((Temp(dt,GND)/rth))
    staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_Temp_dt_GND])/modelPar_rth);
  }
  else
  {
    // Temp(dt,GND) <+ (0.0)
    // do nothing at all
  }
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(18+0);
  dqdp.resize(18+0);
  Findices.resize(18+0);
  Qindices.resize(18+0);

  std::vector <double> probeVars(47);
  std::vector <AdmsSensFadType> staticContributions(18+0);
  std::vector <AdmsSensFadType> dynamicContributions(18+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 18+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_version=mod.version;
  bool modelPar_given_version=mod.given("version");
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  AdmsSensFadType modelPar_cg=mod.cg;
  bool modelPar_given_cg=mod.given("cg");
  AdmsSensFadType modelPar_cofsm=mod.cofsm;
  bool modelPar_given_cofsm=mod.given("cofsm");
  AdmsSensFadType modelPar_cofdm=mod.cofdm;
  bool modelPar_given_cofdm=mod.given("cofdm");
  AdmsSensFadType modelPar_cofdsm=mod.cofdsm;
  bool modelPar_given_cofdsm=mod.given("cofdsm");
  AdmsSensFadType modelPar_cofdsubm=mod.cofdsubm;
  bool modelPar_given_cofdsubm=mod.given("cofdsubm");
  AdmsSensFadType modelPar_cofssubm=mod.cofssubm;
  bool modelPar_given_cofssubm=mod.given("cofssubm");
  AdmsSensFadType modelPar_cofgsubm=mod.cofgsubm;
  bool modelPar_given_cofgsubm=mod.given("cofgsubm");
  AdmsSensFadType modelPar_rsh=mod.rsh;
  bool modelPar_given_rsh=mod.given("rsh");
  AdmsSensFadType modelPar_rcs=mod.rcs;
  bool modelPar_given_rcs=mod.given("rcs");
  AdmsSensFadType modelPar_rcd=mod.rcd;
  bool modelPar_given_rcd=mod.given("rcd");
  AdmsSensFadType modelPar_vx0=mod.vx0;
  bool modelPar_given_vx0=mod.given("vx0");
  AdmsSensFadType modelPar_mu0=mod.mu0;
  bool modelPar_given_mu0=mod.given("mu0");
  AdmsSensFadType modelPar_beta=mod.beta;
  bool modelPar_given_beta=mod.given("beta");
  AdmsSensFadType modelPar_vto=mod.vto;
  bool modelPar_given_vto=mod.given("vto");
  AdmsSensFadType modelPar_ss=mod.ss;
  bool modelPar_given_ss=mod.given("ss");
  AdmsSensFadType modelPar_delta1=mod.delta1;
  bool modelPar_given_delta1=mod.given("delta1");
  AdmsSensFadType modelPar_delta2=mod.delta2;
  bool modelPar_given_delta2=mod.given("delta2");
  AdmsSensFadType modelPar_dibsat=mod.dibsat;
  bool modelPar_given_dibsat=mod.given("dibsat");
  AdmsSensFadType modelPar_nd=mod.nd;
  bool modelPar_given_nd=mod.given("nd");
  AdmsSensFadType modelPar_alpha=mod.alpha;
  bool modelPar_given_alpha=mod.given("alpha");
  AdmsSensFadType modelPar_lambda=mod.lambda;
  bool modelPar_given_lambda=mod.given("lambda");
  AdmsSensFadType modelPar_vtheta=mod.vtheta;
  bool modelPar_given_vtheta=mod.given("vtheta");
  AdmsSensFadType modelPar_mtheta=mod.mtheta;
  bool modelPar_given_mtheta=mod.given("mtheta");
  AdmsSensFadType modelPar_vzeta=mod.vzeta;
  bool modelPar_given_vzeta=mod.given("vzeta");
  AdmsSensFadType modelPar_vtzeta=mod.vtzeta;
  bool modelPar_given_vtzeta=mod.given("vtzeta");
  AdmsSensFadType modelPar_epsilon=mod.epsilon;
  bool modelPar_given_epsilon=mod.given("epsilon");
  AdmsSensFadType modelPar_rct1=mod.rct1;
  bool modelPar_given_rct1=mod.given("rct1");
  AdmsSensFadType modelPar_rct2=mod.rct2;
  bool modelPar_given_rct2=mod.given("rct2");
  AdmsSensFadType modelPar_lgs=mod.lgs;
  bool modelPar_given_lgs=mod.given("lgs");
  AdmsSensFadType modelPar_vtors=mod.vtors;
  bool modelPar_given_vtors=mod.given("vtors");
  AdmsSensFadType modelPar_cgrs=mod.cgrs;
  bool modelPar_given_cgrs=mod.given("cgrs");
  AdmsSensFadType modelPar_vx0rs=mod.vx0rs;
  bool modelPar_given_vx0rs=mod.given("vx0rs");
  AdmsSensFadType modelPar_mu0rs=mod.mu0rs;
  bool modelPar_given_mu0rs=mod.given("mu0rs");
  AdmsSensFadType modelPar_betars=mod.betars;
  bool modelPar_given_betars=mod.given("betars");
  AdmsSensFadType modelPar_delta1rs=mod.delta1rs;
  bool modelPar_given_delta1rs=mod.given("delta1rs");
  AdmsSensFadType modelPar_srs=mod.srs;
  bool modelPar_given_srs=mod.given("srs");
  AdmsSensFadType modelPar_ndrs=mod.ndrs;
  bool modelPar_given_ndrs=mod.given("ndrs");
  AdmsSensFadType modelPar_vthetars=mod.vthetars;
  bool modelPar_given_vthetars=mod.given("vthetars");
  AdmsSensFadType modelPar_mthetars=mod.mthetars;
  bool modelPar_given_mthetars=mod.given("mthetars");
  AdmsSensFadType modelPar_alphars=mod.alphars;
  bool modelPar_given_alphars=mod.given("alphars");
  AdmsSensFadType modelPar_lgd=mod.lgd;
  bool modelPar_given_lgd=mod.given("lgd");
  AdmsSensFadType modelPar_vtord=mod.vtord;
  bool modelPar_given_vtord=mod.given("vtord");
  AdmsSensFadType modelPar_cgrd=mod.cgrd;
  bool modelPar_given_cgrd=mod.given("cgrd");
  AdmsSensFadType modelPar_vx0rd=mod.vx0rd;
  bool modelPar_given_vx0rd=mod.given("vx0rd");
  AdmsSensFadType modelPar_mu0rd=mod.mu0rd;
  bool modelPar_given_mu0rd=mod.given("mu0rd");
  AdmsSensFadType modelPar_betard=mod.betard;
  bool modelPar_given_betard=mod.given("betard");
  AdmsSensFadType modelPar_delta1rd=mod.delta1rd;
  bool modelPar_given_delta1rd=mod.given("delta1rd");
  AdmsSensFadType modelPar_srd=mod.srd;
  bool modelPar_given_srd=mod.given("srd");
  AdmsSensFadType modelPar_ndrd=mod.ndrd;
  bool modelPar_given_ndrd=mod.given("ndrd");
  AdmsSensFadType modelPar_vthetard=mod.vthetard;
  bool modelPar_given_vthetard=mod.given("vthetard");
  AdmsSensFadType modelPar_mthetard=mod.mthetard;
  bool modelPar_given_mthetard=mod.given("mthetard");
  AdmsSensFadType modelPar_alphard=mod.alphard;
  bool modelPar_given_alphard=mod.given("alphard");
  AdmsSensFadType modelPar_lgfp1=mod.lgfp1;
  bool modelPar_given_lgfp1=mod.given("lgfp1");
  AdmsSensFadType modelPar_vtofp1=mod.vtofp1;
  bool modelPar_given_vtofp1=mod.given("vtofp1");
  AdmsSensFadType modelPar_cgfp1=mod.cgfp1;
  bool modelPar_given_cgfp1=mod.given("cgfp1");
  AdmsSensFadType modelPar_cfp1s=mod.cfp1s;
  bool modelPar_given_cfp1s=mod.given("cfp1s");
  AdmsSensFadType modelPar_ccfp1=mod.ccfp1;
  bool modelPar_given_ccfp1=mod.given("ccfp1");
  AdmsSensFadType modelPar_cbfp1=mod.cbfp1;
  bool modelPar_given_cbfp1=mod.given("cbfp1");
  AdmsSensFadType modelPar_vx0fp1=mod.vx0fp1;
  bool modelPar_given_vx0fp1=mod.given("vx0fp1");
  AdmsSensFadType modelPar_mu0fp1=mod.mu0fp1;
  bool modelPar_given_mu0fp1=mod.given("mu0fp1");
  AdmsSensFadType modelPar_betafp1=mod.betafp1;
  bool modelPar_given_betafp1=mod.given("betafp1");
  AdmsSensFadType modelPar_delta1fp1=mod.delta1fp1;
  bool modelPar_given_delta1fp1=mod.given("delta1fp1");
  AdmsSensFadType modelPar_sfp1=mod.sfp1;
  bool modelPar_given_sfp1=mod.given("sfp1");
  AdmsSensFadType modelPar_ndfp1=mod.ndfp1;
  bool modelPar_given_ndfp1=mod.given("ndfp1");
  AdmsSensFadType modelPar_vthetafp1=mod.vthetafp1;
  bool modelPar_given_vthetafp1=mod.given("vthetafp1");
  AdmsSensFadType modelPar_mthetafp1=mod.mthetafp1;
  bool modelPar_given_mthetafp1=mod.given("mthetafp1");
  AdmsSensFadType modelPar_alphafp1=mod.alphafp1;
  bool modelPar_given_alphafp1=mod.given("alphafp1");
  AdmsSensFadType modelPar_lgfp2=mod.lgfp2;
  bool modelPar_given_lgfp2=mod.given("lgfp2");
  AdmsSensFadType modelPar_vtofp2=mod.vtofp2;
  bool modelPar_given_vtofp2=mod.given("vtofp2");
  AdmsSensFadType modelPar_cgfp2=mod.cgfp2;
  bool modelPar_given_cgfp2=mod.given("cgfp2");
  AdmsSensFadType modelPar_cfp2s=mod.cfp2s;
  bool modelPar_given_cfp2s=mod.given("cfp2s");
  AdmsSensFadType modelPar_ccfp2=mod.ccfp2;
  bool modelPar_given_ccfp2=mod.given("ccfp2");
  AdmsSensFadType modelPar_cbfp2=mod.cbfp2;
  bool modelPar_given_cbfp2=mod.given("cbfp2");
  AdmsSensFadType modelPar_vx0fp2=mod.vx0fp2;
  bool modelPar_given_vx0fp2=mod.given("vx0fp2");
  AdmsSensFadType modelPar_mu0fp2=mod.mu0fp2;
  bool modelPar_given_mu0fp2=mod.given("mu0fp2");
  AdmsSensFadType modelPar_betafp2=mod.betafp2;
  bool modelPar_given_betafp2=mod.given("betafp2");
  AdmsSensFadType modelPar_delta1fp2=mod.delta1fp2;
  bool modelPar_given_delta1fp2=mod.given("delta1fp2");
  AdmsSensFadType modelPar_sfp2=mod.sfp2;
  bool modelPar_given_sfp2=mod.given("sfp2");
  AdmsSensFadType modelPar_ndfp2=mod.ndfp2;
  bool modelPar_given_ndfp2=mod.given("ndfp2");
  AdmsSensFadType modelPar_vthetafp2=mod.vthetafp2;
  bool modelPar_given_vthetafp2=mod.given("vthetafp2");
  AdmsSensFadType modelPar_mthetafp2=mod.mthetafp2;
  bool modelPar_given_mthetafp2=mod.given("mthetafp2");
  AdmsSensFadType modelPar_alphafp2=mod.alphafp2;
  bool modelPar_given_alphafp2=mod.given("alphafp2");
  AdmsSensFadType modelPar_lgfp3=mod.lgfp3;
  bool modelPar_given_lgfp3=mod.given("lgfp3");
  AdmsSensFadType modelPar_vtofp3=mod.vtofp3;
  bool modelPar_given_vtofp3=mod.given("vtofp3");
  AdmsSensFadType modelPar_cgfp3=mod.cgfp3;
  bool modelPar_given_cgfp3=mod.given("cgfp3");
  AdmsSensFadType modelPar_cfp3s=mod.cfp3s;
  bool modelPar_given_cfp3s=mod.given("cfp3s");
  AdmsSensFadType modelPar_ccfp3=mod.ccfp3;
  bool modelPar_given_ccfp3=mod.given("ccfp3");
  AdmsSensFadType modelPar_cbfp3=mod.cbfp3;
  bool modelPar_given_cbfp3=mod.given("cbfp3");
  AdmsSensFadType modelPar_vx0fp3=mod.vx0fp3;
  bool modelPar_given_vx0fp3=mod.given("vx0fp3");
  AdmsSensFadType modelPar_mu0fp3=mod.mu0fp3;
  bool modelPar_given_mu0fp3=mod.given("mu0fp3");
  AdmsSensFadType modelPar_betafp3=mod.betafp3;
  bool modelPar_given_betafp3=mod.given("betafp3");
  AdmsSensFadType modelPar_delta1fp3=mod.delta1fp3;
  bool modelPar_given_delta1fp3=mod.given("delta1fp3");
  AdmsSensFadType modelPar_sfp3=mod.sfp3;
  bool modelPar_given_sfp3=mod.given("sfp3");
  AdmsSensFadType modelPar_ndfp3=mod.ndfp3;
  bool modelPar_given_ndfp3=mod.given("ndfp3");
  AdmsSensFadType modelPar_vthetafp3=mod.vthetafp3;
  bool modelPar_given_vthetafp3=mod.given("vthetafp3");
  AdmsSensFadType modelPar_mthetafp3=mod.mthetafp3;
  bool modelPar_given_mthetafp3=mod.given("mthetafp3");
  AdmsSensFadType modelPar_alphafp3=mod.alphafp3;
  bool modelPar_given_alphafp3=mod.given("alphafp3");
  AdmsSensFadType modelPar_lgfp4=mod.lgfp4;
  bool modelPar_given_lgfp4=mod.given("lgfp4");
  AdmsSensFadType modelPar_vtofp4=mod.vtofp4;
  bool modelPar_given_vtofp4=mod.given("vtofp4");
  AdmsSensFadType modelPar_cgfp4=mod.cgfp4;
  bool modelPar_given_cgfp4=mod.given("cgfp4");
  AdmsSensFadType modelPar_cfp4s=mod.cfp4s;
  bool modelPar_given_cfp4s=mod.given("cfp4s");
  AdmsSensFadType modelPar_ccfp4=mod.ccfp4;
  bool modelPar_given_ccfp4=mod.given("ccfp4");
  AdmsSensFadType modelPar_cbfp4=mod.cbfp4;
  bool modelPar_given_cbfp4=mod.given("cbfp4");
  AdmsSensFadType modelPar_vx0fp4=mod.vx0fp4;
  bool modelPar_given_vx0fp4=mod.given("vx0fp4");
  AdmsSensFadType modelPar_mu0fp4=mod.mu0fp4;
  bool modelPar_given_mu0fp4=mod.given("mu0fp4");
  AdmsSensFadType modelPar_betafp4=mod.betafp4;
  bool modelPar_given_betafp4=mod.given("betafp4");
  AdmsSensFadType modelPar_delta1fp4=mod.delta1fp4;
  bool modelPar_given_delta1fp4=mod.given("delta1fp4");
  AdmsSensFadType modelPar_sfp4=mod.sfp4;
  bool modelPar_given_sfp4=mod.given("sfp4");
  AdmsSensFadType modelPar_ndfp4=mod.ndfp4;
  bool modelPar_given_ndfp4=mod.given("ndfp4");
  AdmsSensFadType modelPar_vthetafp4=mod.vthetafp4;
  bool modelPar_given_vthetafp4=mod.given("vthetafp4");
  AdmsSensFadType modelPar_mthetafp4=mod.mthetafp4;
  bool modelPar_given_mthetafp4=mod.given("mthetafp4");
  AdmsSensFadType modelPar_alphafp4=mod.alphafp4;
  bool modelPar_given_alphafp4=mod.given("alphafp4");
  AdmsSensFadType modelPar_rgsp=mod.rgsp;
  bool modelPar_given_rgsp=mod.given("rgsp");
  AdmsSensFadType modelPar_vjg=mod.vjg;
  bool modelPar_given_vjg=mod.given("vjg");
  AdmsSensFadType modelPar_pg_param1=mod.pg_param1;
  bool modelPar_given_pg_param1=mod.given("pg_param1");
  AdmsSensFadType modelPar_pg_params=mod.pg_params;
  bool modelPar_given_pg_params=mod.given("pg_params");
  AdmsSensFadType modelPar_ijs=mod.ijs;
  bool modelPar_given_ijs=mod.given("ijs");
  AdmsSensFadType modelPar_vgsats=mod.vgsats;
  bool modelPar_given_vgsats=mod.given("vgsats");
  AdmsSensFadType modelPar_fracs=mod.fracs;
  bool modelPar_given_fracs=mod.given("fracs");
  AdmsSensFadType modelPar_alphags=mod.alphags;
  bool modelPar_given_alphags=mod.given("alphags");
  AdmsSensFadType modelPar_pg_paramd=mod.pg_paramd;
  bool modelPar_given_pg_paramd=mod.given("pg_paramd");
  AdmsSensFadType modelPar_ijd=mod.ijd;
  bool modelPar_given_ijd=mod.given("ijd");
  AdmsSensFadType modelPar_vgsatd=mod.vgsatd;
  bool modelPar_given_vgsatd=mod.given("vgsatd");
  AdmsSensFadType modelPar_fracd=mod.fracd;
  bool modelPar_given_fracd=mod.given("fracd");
  AdmsSensFadType modelPar_alphagd=mod.alphagd;
  bool modelPar_given_alphagd=mod.given("alphagd");
  AdmsSensFadType modelPar_pgsrecs=mod.pgsrecs;
  bool modelPar_given_pgsrecs=mod.given("pgsrecs");
  AdmsSensFadType modelPar_irecs=mod.irecs;
  bool modelPar_given_irecs=mod.given("irecs");
  AdmsSensFadType modelPar_vgsatqs=mod.vgsatqs;
  bool modelPar_given_vgsatqs=mod.given("vgsatqs");
  AdmsSensFadType modelPar_vbdgs=mod.vbdgs;
  bool modelPar_given_vbdgs=mod.given("vbdgs");
  AdmsSensFadType modelPar_pbdgs=mod.pbdgs;
  bool modelPar_given_pbdgs=mod.given("pbdgs");
  AdmsSensFadType modelPar_betarecs=mod.betarecs;
  bool modelPar_given_betarecs=mod.given("betarecs");
  AdmsSensFadType modelPar_kbdgates=mod.kbdgates;
  bool modelPar_given_kbdgates=mod.given("kbdgates");
  AdmsSensFadType modelPar_pgsrecd=mod.pgsrecd;
  bool modelPar_given_pgsrecd=mod.given("pgsrecd");
  AdmsSensFadType modelPar_irecd=mod.irecd;
  bool modelPar_given_irecd=mod.given("irecd");
  AdmsSensFadType modelPar_vgsatqd=mod.vgsatqd;
  bool modelPar_given_vgsatqd=mod.given("vgsatqd");
  AdmsSensFadType modelPar_vbdgd=mod.vbdgd;
  bool modelPar_given_vbdgd=mod.given("vbdgd");
  AdmsSensFadType modelPar_pbdgd=mod.pbdgd;
  bool modelPar_given_pbdgd=mod.given("pbdgd");
  AdmsSensFadType modelPar_betarecd=mod.betarecd;
  bool modelPar_given_betarecd=mod.given("betarecd");
  AdmsSensFadType modelPar_kbdgated=mod.kbdgated;
  bool modelPar_given_kbdgated=mod.given("kbdgated");
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  AdmsSensFadType modelPar_taugmrf=mod.taugmrf;
  bool modelPar_given_taugmrf=mod.given("taugmrf");
  AdmsSensFadType modelPar_ctrap=mod.ctrap;
  bool modelPar_given_ctrap=mod.given("ctrap");
  AdmsSensFadType modelPar_vttrap=mod.vttrap;
  bool modelPar_given_vttrap=mod.given("vttrap");
  AdmsSensFadType modelPar_taut=mod.taut;
  bool modelPar_given_taut=mod.given("taut");
  AdmsSensFadType modelPar_alphat1=mod.alphat1;
  bool modelPar_given_alphat1=mod.given("alphat1");
  AdmsSensFadType modelPar_alphat2=mod.alphat2;
  bool modelPar_given_alphat2=mod.given("alphat2");
  AdmsSensFadType modelPar_tempt=mod.tempt;
  bool modelPar_given_tempt=mod.given("tempt");
  AdmsSensFadType modelPar_shs=mod.shs;
  bool modelPar_given_shs=mod.given("shs");
  AdmsSensFadType modelPar_shd=mod.shd;
  bool modelPar_given_shd=mod.given("shd");
  AdmsSensFadType modelPar_kf=mod.kf;
  bool modelPar_given_kf=mod.given("kf");
  AdmsSensFadType modelPar_af=mod.af;
  bool modelPar_given_af=mod.given("af");
  AdmsSensFadType modelPar_ffe=mod.ffe;
  bool modelPar_given_ffe=mod.given("ffe");
  AdmsSensFadType modelPar_minr=mod.minr;
  bool modelPar_given_minr=mod.given("minr");
  AdmsSensFadType modelPar_minl=mod.minl;
  bool modelPar_given_minl=mod.given("minl");
  AdmsSensFadType modelPar_minc=mod.minc;
  bool modelPar_given_minc=mod.given("minc");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");
  int modelPar_flagres=mod.flagres;
  bool modelPar_given_flagres=mod.given("flagres");
  int modelPar_flagfp1=mod.flagfp1;
  bool modelPar_given_flagfp1=mod.given("flagfp1");
  int modelPar_flagfp1s=mod.flagfp1s;
  bool modelPar_given_flagfp1s=mod.given("flagfp1s");
  int modelPar_flagfp2=mod.flagfp2;
  bool modelPar_given_flagfp2=mod.given("flagfp2");
  int modelPar_flagfp2s=mod.flagfp2s;
  bool modelPar_given_flagfp2s=mod.given("flagfp2s");
  int modelPar_flagfp3=mod.flagfp3;
  bool modelPar_given_flagfp3=mod.given("flagfp3");
  int modelPar_flagfp3s=mod.flagfp3s;
  bool modelPar_given_flagfp3s=mod.given("flagfp3s");
  int modelPar_flagfp4=mod.flagfp4;
  bool modelPar_given_flagfp4=mod.given("flagfp4");
  int modelPar_flagfp4s=mod.flagfp4s;
  bool modelPar_given_flagfp4s=mod.given("flagfp4s");
  int modelPar_igmod=mod.igmod;
  bool modelPar_given_igmod=mod.given("igmod");
  int modelPar_gmdisp=mod.gmdisp;
  bool modelPar_given_gmdisp=mod.given("gmdisp");
  int modelPar_trapselect=mod.trapselect;
  bool modelPar_given_trapselect=mod.given("trapselect");
  int modelPar_noisemod=mod.noisemod;
  bool modelPar_given_noisemod=mod.given("noisemod");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_w=in.w;
  bool instancePar_given_w=in.given("w");
  inParamMap["w"] = &instancePar_w;
  AdmsSensFadType instancePar_l=in.l;
  bool instancePar_given_l=in.given("l");
  inParamMap["l"] = &instancePar_l;
  AdmsSensFadType instancePar_dtemp=in.dtemp;
  bool instancePar_given_dtemp=in.given("dtemp");
  inParamMap["dtemp"] = &instancePar_dtemp;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:
  int instancePar_ngf=in.ngf;
  bool instancePar_given_ngf=in.given("ngf");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_rcs_w=in.rcs_w;
  AdmsSensFadType instanceVar_rcd_w=in.rcd_w;
  AdmsSensFadType instanceVar_rg=in.rg;
  AdmsSensFadType instanceVar_vtdibli=in.vtdibli;
  AdmsSensFadType instanceVar_vdsat1i=in.vdsat1i;
  AdmsSensFadType instanceVar_vtdiblrs=in.vtdiblrs;
  AdmsSensFadType instanceVar_vdsatrs=in.vdsatrs;
  AdmsSensFadType instanceVar_vtdiblrd=in.vtdiblrd;
  AdmsSensFadType instanceVar_vdsatrd=in.vdsatrd;
  AdmsSensFadType instanceVar_vtdiblfp1=in.vtdiblfp1;
  AdmsSensFadType instanceVar_vdsatfp1=in.vdsatfp1;
  AdmsSensFadType instanceVar_vtdiblfp2=in.vtdiblfp2;
  AdmsSensFadType instanceVar_vdsatfp2=in.vdsatfp2;
  AdmsSensFadType instanceVar_vtdiblfp3=in.vtdiblfp3;
  AdmsSensFadType instanceVar_vdsatfp3=in.vdsatfp3;
  AdmsSensFadType instanceVar_vtdiblfp4=in.vtdiblfp4;
  AdmsSensFadType instanceVar_vdsatfp4=in.vdsatfp4;
  AdmsSensFadType instanceVar_qgs=in.qgs;
  AdmsSensFadType instanceVar_qgd=in.qgd;
  AdmsSensFadType instanceVar_qc=in.qc;
  AdmsSensFadType instanceVar_qb=in.qb;
  AdmsSensFadType instanceVar_qs=in.qs;
  AdmsSensFadType instanceVar_igssdio=in.igssdio;
  AdmsSensFadType instanceVar_igdsdio=in.igdsdio;
  AdmsSensFadType instanceVar_igsrec=in.igsrec;
  AdmsSensFadType instanceVar_igdrec=in.igdrec;
  AdmsSensFadType instanceVar_qgsrs=in.qgsrs;
  AdmsSensFadType instanceVar_qgdrs=in.qgdrs;
  AdmsSensFadType instanceVar_qcrs=in.qcrs;
  AdmsSensFadType instanceVar_qbrs=in.qbrs;
  AdmsSensFadType instanceVar_qsrs=in.qsrs;
  AdmsSensFadType instanceVar_qgsrd=in.qgsrd;
  AdmsSensFadType instanceVar_qgdrd=in.qgdrd;
  AdmsSensFadType instanceVar_qcrd=in.qcrd;
  AdmsSensFadType instanceVar_qbrd=in.qbrd;
  AdmsSensFadType instanceVar_qsrd=in.qsrd;
  AdmsSensFadType instanceVar_qgsfp1=in.qgsfp1;
  AdmsSensFadType instanceVar_qgdfp1=in.qgdfp1;
  AdmsSensFadType instanceVar_qcfp1=in.qcfp1;
  AdmsSensFadType instanceVar_qbfp1=in.qbfp1;
  AdmsSensFadType instanceVar_qsfp1=in.qsfp1;
  AdmsSensFadType instanceVar_qgsfp2=in.qgsfp2;
  AdmsSensFadType instanceVar_qgdfp2=in.qgdfp2;
  AdmsSensFadType instanceVar_qcfp2=in.qcfp2;
  AdmsSensFadType instanceVar_qbfp2=in.qbfp2;
  AdmsSensFadType instanceVar_qsfp2=in.qsfp2;
  AdmsSensFadType instanceVar_qgsfp3=in.qgsfp3;
  AdmsSensFadType instanceVar_qgdfp3=in.qgdfp3;
  AdmsSensFadType instanceVar_qcfp3=in.qcfp3;
  AdmsSensFadType instanceVar_qbfp3=in.qbfp3;
  AdmsSensFadType instanceVar_qsfp3=in.qsfp3;
  AdmsSensFadType instanceVar_qgsfp4=in.qgsfp4;
  AdmsSensFadType instanceVar_qgdfp4=in.qgdfp4;
  AdmsSensFadType instanceVar_qcfp4=in.qcfp4;
  AdmsSensFadType instanceVar_qbfp4=in.qbfp4;
  AdmsSensFadType instanceVar_qsfp4=in.qsfp4;


  //non-reals


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_drc_d] = (*solVectorPtr)[in.li_drc]- (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_gi_b] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_b];
  probeVars[in.admsProbeID_V_s_b] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_b];
  probeVars[in.admsProbeID_V_d_b] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_b];
  probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_gi_d] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_gi_s] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_g_gi] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_gi];
  probeVars[in.admsProbeID_V_d_drc] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_drc];
  probeVars[in.admsProbeID_V_xt1_GND] = (in.collapseNode_xt1)?(0):((*solVectorPtr)[in.li_xt1]);
  probeVars[in.admsProbeID_V_xt2_GND] = (in.collapseNode_xt2)?(0):((*solVectorPtr)[in.li_xt2]);
  probeVars[in.admsProbeID_V_fp4_s] = (*solVectorPtr)[in.li_fp4]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_fp4_d] = (*solVectorPtr)[in.li_fp4]- (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_tr_GND] = (in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]);
  probeVars[in.admsProbeID_V_tr1_tr] = (in.collapseNode_tr1)?(0):((*solVectorPtr)[in.li_tr1]) - ((in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]));
  probeVars[in.admsProbeID_V_d_g] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_g];
  probeVars[in.admsProbeID_V_src_s] = (*solVectorPtr)[in.li_src]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_src_d] = (*solVectorPtr)[in.li_src]- (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_gi_si] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_drc_fp4] = (*solVectorPtr)[in.li_drc]- (*solVectorPtr)[in.li_fp4];
  probeVars[in.admsProbeID_V_drc_GND] = (*solVectorPtr)[in.li_drc];
  probeVars[in.admsProbeID_V_fp4_GND] = (*solVectorPtr)[in.li_fp4];
  probeVars[in.admsProbeID_V_si_src] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_src];
  probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
  probeVars[in.admsProbeID_V_src_GND] = (*solVectorPtr)[in.li_src];
  probeVars[in.admsProbeID_V_s_GND] = (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_d_GND] = (*solVectorPtr)[in.li_d];
  probeVars[in.admsProbeID_V_fp1_di] = (*solVectorPtr)[in.li_fp1]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_b_di] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_s_di] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_gi_di] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_di];
  probeVars[in.admsProbeID_V_fp2_fp1] = (*solVectorPtr)[in.li_fp2]- (*solVectorPtr)[in.li_fp1];
  probeVars[in.admsProbeID_V_b_fp1] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_fp1];
  probeVars[in.admsProbeID_V_s_fp1] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp1];
  probeVars[in.admsProbeID_V_gi_fp1] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp1];
  probeVars[in.admsProbeID_V_fp3_fp2] = (*solVectorPtr)[in.li_fp3]- (*solVectorPtr)[in.li_fp2];
  probeVars[in.admsProbeID_V_b_fp2] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_fp2];
  probeVars[in.admsProbeID_V_s_fp2] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp2];
  probeVars[in.admsProbeID_V_gi_fp2] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp2];
  probeVars[in.admsProbeID_Temp_dt_GND] = (in.collapseNode_dt)?(0):((*solVectorPtr)[in.li_dt]);
  probeVars[in.admsProbeID_V_fp4_fp3] = (*solVectorPtr)[in.li_fp4]- (*solVectorPtr)[in.li_fp3];
  probeVars[in.admsProbeID_V_gi_fp4] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp4];
  probeVars[in.admsProbeID_V_s_fp4] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp4];
  probeVars[in.admsProbeID_V_b_fp3] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_fp3];
  probeVars[in.admsProbeID_V_s_fp3] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp3];
  probeVars[in.admsProbeID_V_gi_fp3] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp3];


  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_w,
     instancePar_given_w,
     instancePar_l,
     instancePar_given_l,
     instancePar_dtemp,
     instancePar_given_dtemp,
     // non-reals(including hidden)
     instancePar_ngf,
     instancePar_given_ngf,
     // instance variables
     // reals
     instanceVar_rcs_w,
     instanceVar_rcd_w,
     instanceVar_rg,
     instanceVar_vtdibli,
     instanceVar_vdsat1i,
     instanceVar_vtdiblrs,
     instanceVar_vdsatrs,
     instanceVar_vtdiblrd,
     instanceVar_vdsatrd,
     instanceVar_vtdiblfp1,
     instanceVar_vdsatfp1,
     instanceVar_vtdiblfp2,
     instanceVar_vdsatfp2,
     instanceVar_vtdiblfp3,
     instanceVar_vdsatfp3,
     instanceVar_vtdiblfp4,
     instanceVar_vdsatfp4,
     instanceVar_qgs,
     instanceVar_qgd,
     instanceVar_qc,
     instanceVar_qb,
     instanceVar_qs,
     instanceVar_igssdio,
     instanceVar_igdsdio,
     instanceVar_igsrec,
     instanceVar_igdrec,
     instanceVar_qgsrs,
     instanceVar_qgdrs,
     instanceVar_qcrs,
     instanceVar_qbrs,
     instanceVar_qsrs,
     instanceVar_qgsrd,
     instanceVar_qgdrd,
     instanceVar_qcrd,
     instanceVar_qbrd,
     instanceVar_qsrd,
     instanceVar_qgsfp1,
     instanceVar_qgdfp1,
     instanceVar_qcfp1,
     instanceVar_qbfp1,
     instanceVar_qsfp1,
     instanceVar_qgsfp2,
     instanceVar_qgdfp2,
     instanceVar_qcfp2,
     instanceVar_qbfp2,
     instanceVar_qsfp2,
     instanceVar_qgsfp3,
     instanceVar_qgdfp3,
     instanceVar_qcfp3,
     instanceVar_qbfp3,
     instanceVar_qsfp3,
     instanceVar_qgsfp4,
     instanceVar_qgdfp4,
     instanceVar_qcfp4,
     instanceVar_qbfp4,
     instanceVar_qsfp4,
     // model parameters
     // reals
     modelPar_version,
     modelPar_given_version,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_cg,
     modelPar_given_cg,
     modelPar_cofsm,
     modelPar_given_cofsm,
     modelPar_cofdm,
     modelPar_given_cofdm,
     modelPar_cofdsm,
     modelPar_given_cofdsm,
     modelPar_cofdsubm,
     modelPar_given_cofdsubm,
     modelPar_cofssubm,
     modelPar_given_cofssubm,
     modelPar_cofgsubm,
     modelPar_given_cofgsubm,
     modelPar_rsh,
     modelPar_given_rsh,
     modelPar_rcs,
     modelPar_given_rcs,
     modelPar_rcd,
     modelPar_given_rcd,
     modelPar_vx0,
     modelPar_given_vx0,
     modelPar_mu0,
     modelPar_given_mu0,
     modelPar_beta,
     modelPar_given_beta,
     modelPar_vto,
     modelPar_given_vto,
     modelPar_ss,
     modelPar_given_ss,
     modelPar_delta1,
     modelPar_given_delta1,
     modelPar_delta2,
     modelPar_given_delta2,
     modelPar_dibsat,
     modelPar_given_dibsat,
     modelPar_nd,
     modelPar_given_nd,
     modelPar_alpha,
     modelPar_given_alpha,
     modelPar_lambda,
     modelPar_given_lambda,
     modelPar_vtheta,
     modelPar_given_vtheta,
     modelPar_mtheta,
     modelPar_given_mtheta,
     modelPar_vzeta,
     modelPar_given_vzeta,
     modelPar_vtzeta,
     modelPar_given_vtzeta,
     modelPar_epsilon,
     modelPar_given_epsilon,
     modelPar_rct1,
     modelPar_given_rct1,
     modelPar_rct2,
     modelPar_given_rct2,
     modelPar_lgs,
     modelPar_given_lgs,
     modelPar_vtors,
     modelPar_given_vtors,
     modelPar_cgrs,
     modelPar_given_cgrs,
     modelPar_vx0rs,
     modelPar_given_vx0rs,
     modelPar_mu0rs,
     modelPar_given_mu0rs,
     modelPar_betars,
     modelPar_given_betars,
     modelPar_delta1rs,
     modelPar_given_delta1rs,
     modelPar_srs,
     modelPar_given_srs,
     modelPar_ndrs,
     modelPar_given_ndrs,
     modelPar_vthetars,
     modelPar_given_vthetars,
     modelPar_mthetars,
     modelPar_given_mthetars,
     modelPar_alphars,
     modelPar_given_alphars,
     modelPar_lgd,
     modelPar_given_lgd,
     modelPar_vtord,
     modelPar_given_vtord,
     modelPar_cgrd,
     modelPar_given_cgrd,
     modelPar_vx0rd,
     modelPar_given_vx0rd,
     modelPar_mu0rd,
     modelPar_given_mu0rd,
     modelPar_betard,
     modelPar_given_betard,
     modelPar_delta1rd,
     modelPar_given_delta1rd,
     modelPar_srd,
     modelPar_given_srd,
     modelPar_ndrd,
     modelPar_given_ndrd,
     modelPar_vthetard,
     modelPar_given_vthetard,
     modelPar_mthetard,
     modelPar_given_mthetard,
     modelPar_alphard,
     modelPar_given_alphard,
     modelPar_lgfp1,
     modelPar_given_lgfp1,
     modelPar_vtofp1,
     modelPar_given_vtofp1,
     modelPar_cgfp1,
     modelPar_given_cgfp1,
     modelPar_cfp1s,
     modelPar_given_cfp1s,
     modelPar_ccfp1,
     modelPar_given_ccfp1,
     modelPar_cbfp1,
     modelPar_given_cbfp1,
     modelPar_vx0fp1,
     modelPar_given_vx0fp1,
     modelPar_mu0fp1,
     modelPar_given_mu0fp1,
     modelPar_betafp1,
     modelPar_given_betafp1,
     modelPar_delta1fp1,
     modelPar_given_delta1fp1,
     modelPar_sfp1,
     modelPar_given_sfp1,
     modelPar_ndfp1,
     modelPar_given_ndfp1,
     modelPar_vthetafp1,
     modelPar_given_vthetafp1,
     modelPar_mthetafp1,
     modelPar_given_mthetafp1,
     modelPar_alphafp1,
     modelPar_given_alphafp1,
     modelPar_lgfp2,
     modelPar_given_lgfp2,
     modelPar_vtofp2,
     modelPar_given_vtofp2,
     modelPar_cgfp2,
     modelPar_given_cgfp2,
     modelPar_cfp2s,
     modelPar_given_cfp2s,
     modelPar_ccfp2,
     modelPar_given_ccfp2,
     modelPar_cbfp2,
     modelPar_given_cbfp2,
     modelPar_vx0fp2,
     modelPar_given_vx0fp2,
     modelPar_mu0fp2,
     modelPar_given_mu0fp2,
     modelPar_betafp2,
     modelPar_given_betafp2,
     modelPar_delta1fp2,
     modelPar_given_delta1fp2,
     modelPar_sfp2,
     modelPar_given_sfp2,
     modelPar_ndfp2,
     modelPar_given_ndfp2,
     modelPar_vthetafp2,
     modelPar_given_vthetafp2,
     modelPar_mthetafp2,
     modelPar_given_mthetafp2,
     modelPar_alphafp2,
     modelPar_given_alphafp2,
     modelPar_lgfp3,
     modelPar_given_lgfp3,
     modelPar_vtofp3,
     modelPar_given_vtofp3,
     modelPar_cgfp3,
     modelPar_given_cgfp3,
     modelPar_cfp3s,
     modelPar_given_cfp3s,
     modelPar_ccfp3,
     modelPar_given_ccfp3,
     modelPar_cbfp3,
     modelPar_given_cbfp3,
     modelPar_vx0fp3,
     modelPar_given_vx0fp3,
     modelPar_mu0fp3,
     modelPar_given_mu0fp3,
     modelPar_betafp3,
     modelPar_given_betafp3,
     modelPar_delta1fp3,
     modelPar_given_delta1fp3,
     modelPar_sfp3,
     modelPar_given_sfp3,
     modelPar_ndfp3,
     modelPar_given_ndfp3,
     modelPar_vthetafp3,
     modelPar_given_vthetafp3,
     modelPar_mthetafp3,
     modelPar_given_mthetafp3,
     modelPar_alphafp3,
     modelPar_given_alphafp3,
     modelPar_lgfp4,
     modelPar_given_lgfp4,
     modelPar_vtofp4,
     modelPar_given_vtofp4,
     modelPar_cgfp4,
     modelPar_given_cgfp4,
     modelPar_cfp4s,
     modelPar_given_cfp4s,
     modelPar_ccfp4,
     modelPar_given_ccfp4,
     modelPar_cbfp4,
     modelPar_given_cbfp4,
     modelPar_vx0fp4,
     modelPar_given_vx0fp4,
     modelPar_mu0fp4,
     modelPar_given_mu0fp4,
     modelPar_betafp4,
     modelPar_given_betafp4,
     modelPar_delta1fp4,
     modelPar_given_delta1fp4,
     modelPar_sfp4,
     modelPar_given_sfp4,
     modelPar_ndfp4,
     modelPar_given_ndfp4,
     modelPar_vthetafp4,
     modelPar_given_vthetafp4,
     modelPar_mthetafp4,
     modelPar_given_mthetafp4,
     modelPar_alphafp4,
     modelPar_given_alphafp4,
     modelPar_rgsp,
     modelPar_given_rgsp,
     modelPar_vjg,
     modelPar_given_vjg,
     modelPar_pg_param1,
     modelPar_given_pg_param1,
     modelPar_pg_params,
     modelPar_given_pg_params,
     modelPar_ijs,
     modelPar_given_ijs,
     modelPar_vgsats,
     modelPar_given_vgsats,
     modelPar_fracs,
     modelPar_given_fracs,
     modelPar_alphags,
     modelPar_given_alphags,
     modelPar_pg_paramd,
     modelPar_given_pg_paramd,
     modelPar_ijd,
     modelPar_given_ijd,
     modelPar_vgsatd,
     modelPar_given_vgsatd,
     modelPar_fracd,
     modelPar_given_fracd,
     modelPar_alphagd,
     modelPar_given_alphagd,
     modelPar_pgsrecs,
     modelPar_given_pgsrecs,
     modelPar_irecs,
     modelPar_given_irecs,
     modelPar_vgsatqs,
     modelPar_given_vgsatqs,
     modelPar_vbdgs,
     modelPar_given_vbdgs,
     modelPar_pbdgs,
     modelPar_given_pbdgs,
     modelPar_betarecs,
     modelPar_given_betarecs,
     modelPar_kbdgates,
     modelPar_given_kbdgates,
     modelPar_pgsrecd,
     modelPar_given_pgsrecd,
     modelPar_irecd,
     modelPar_given_irecd,
     modelPar_vgsatqd,
     modelPar_given_vgsatqd,
     modelPar_vbdgd,
     modelPar_given_vbdgd,
     modelPar_pbdgd,
     modelPar_given_pbdgd,
     modelPar_betarecd,
     modelPar_given_betarecd,
     modelPar_kbdgated,
     modelPar_given_kbdgated,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_taugmrf,
     modelPar_given_taugmrf,
     modelPar_ctrap,
     modelPar_given_ctrap,
     modelPar_vttrap,
     modelPar_given_vttrap,
     modelPar_taut,
     modelPar_given_taut,
     modelPar_alphat1,
     modelPar_given_alphat1,
     modelPar_alphat2,
     modelPar_given_alphat2,
     modelPar_tempt,
     modelPar_given_tempt,
     modelPar_shs,
     modelPar_given_shs,
     modelPar_shd,
     modelPar_given_shd,
     modelPar_kf,
     modelPar_given_kf,
     modelPar_af,
     modelPar_given_af,
     modelPar_ffe,
     modelPar_given_ffe,
     modelPar_minr,
     modelPar_given_minr,
     modelPar_minl,
     modelPar_given_minl,
     modelPar_minc,
     modelPar_given_minc,
     // non-reals (including hidden)
     modelPar_type,
     modelPar_given_type,
     modelPar_flagres,
     modelPar_given_flagres,
     modelPar_flagfp1,
     modelPar_given_flagfp1,
     modelPar_flagfp1s,
     modelPar_given_flagfp1s,
     modelPar_flagfp2,
     modelPar_given_flagfp2,
     modelPar_flagfp2s,
     modelPar_given_flagfp2s,
     modelPar_flagfp3,
     modelPar_given_flagfp3,
     modelPar_flagfp3s,
     modelPar_given_flagfp3s,
     modelPar_flagfp4,
     modelPar_given_flagfp4,
     modelPar_flagfp4s,
     modelPar_given_flagfp4s,
     modelPar_igmod,
     modelPar_given_igmod,
     modelPar_gmdisp,
     modelPar_given_gmdisp,
     modelPar_trapselect,
     modelPar_given_trapselect,
     modelPar_noisemod,
     modelPar_given_noisemod,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_drc_d,
     in.admsProbeID_V_gi_b,
     in.admsProbeID_V_s_b,
     in.admsProbeID_V_d_b,
     in.admsProbeID_V_d_s,
     in.admsProbeID_V_gi_d,
     in.admsProbeID_V_gi_s,
     in.admsProbeID_V_g_gi,
     in.admsProbeID_V_d_drc,
     in.admsProbeID_V_xt1_GND,
     in.admsProbeID_V_xt2_GND,
     in.admsProbeID_V_fp4_s,
     in.admsProbeID_V_fp4_d,
     in.admsProbeID_V_tr_GND,
     in.admsProbeID_V_tr1_tr,
     in.admsProbeID_V_d_g,
     in.admsProbeID_V_src_s,
     in.admsProbeID_V_src_d,
     in.admsProbeID_V_di_si,
     in.admsProbeID_V_gi_si,
     in.admsProbeID_V_drc_fp4,
     in.admsProbeID_V_drc_GND,
     in.admsProbeID_V_fp4_GND,
     in.admsProbeID_V_si_src,
     in.admsProbeID_V_si_GND,
     in.admsProbeID_V_src_GND,
     in.admsProbeID_V_s_GND,
     in.admsProbeID_V_d_GND,
     in.admsProbeID_V_fp1_di,
     in.admsProbeID_V_b_di,
     in.admsProbeID_V_s_di,
     in.admsProbeID_V_gi_di,
     in.admsProbeID_V_fp2_fp1,
     in.admsProbeID_V_b_fp1,
     in.admsProbeID_V_s_fp1,
     in.admsProbeID_V_gi_fp1,
     in.admsProbeID_V_fp3_fp2,
     in.admsProbeID_V_b_fp2,
     in.admsProbeID_V_s_fp2,
     in.admsProbeID_V_gi_fp2,
     in.admsProbeID_Temp_dt_GND,
     in.admsProbeID_V_fp4_fp3,
     in.admsProbeID_V_gi_fp4,
     in.admsProbeID_V_s_fp4,
     in.admsProbeID_V_b_fp3,
     in.admsProbeID_V_s_fp3,
     in.admsProbeID_V_gi_fp3,

     // node constants
     in.admsNodeID_d,
     in.admsNodeID_g,
     in.admsNodeID_s,
     in.admsNodeID_b,
     in.admsNodeID_di,
     in.admsNodeID_gi,
     in.admsNodeID_si,
     in.admsNodeID_fp1,
     in.admsNodeID_fp2,
     in.admsNodeID_fp3,
     in.admsNodeID_fp4,
     in.admsNodeID_drc,
     in.admsNodeID_src,
     in.admsNodeID_tr,
     in.admsNodeID_tr1,
     in.admsNodeID_xt1,
     in.admsNodeID_xt2,
     in.admsNodeID_dt,
     // instance parameters
     // reals
     instancePar_w,
     instancePar_given_w,
     instancePar_l,
     instancePar_given_l,
     instancePar_dtemp,
     instancePar_given_dtemp,
     // non-reals(including hidden)
     instancePar_ngf,
     instancePar_given_ngf,
     // instance variables
     // reals
     instanceVar_rcs_w,
     instanceVar_rcd_w,
     instanceVar_rg,
     instanceVar_vtdibli,
     instanceVar_vdsat1i,
     instanceVar_vtdiblrs,
     instanceVar_vdsatrs,
     instanceVar_vtdiblrd,
     instanceVar_vdsatrd,
     instanceVar_vtdiblfp1,
     instanceVar_vdsatfp1,
     instanceVar_vtdiblfp2,
     instanceVar_vdsatfp2,
     instanceVar_vtdiblfp3,
     instanceVar_vdsatfp3,
     instanceVar_vtdiblfp4,
     instanceVar_vdsatfp4,
     instanceVar_qgs,
     instanceVar_qgd,
     instanceVar_qc,
     instanceVar_qb,
     instanceVar_qs,
     instanceVar_igssdio,
     instanceVar_igdsdio,
     instanceVar_igsrec,
     instanceVar_igdrec,
     instanceVar_qgsrs,
     instanceVar_qgdrs,
     instanceVar_qcrs,
     instanceVar_qbrs,
     instanceVar_qsrs,
     instanceVar_qgsrd,
     instanceVar_qgdrd,
     instanceVar_qcrd,
     instanceVar_qbrd,
     instanceVar_qsrd,
     instanceVar_qgsfp1,
     instanceVar_qgdfp1,
     instanceVar_qcfp1,
     instanceVar_qbfp1,
     instanceVar_qsfp1,
     instanceVar_qgsfp2,
     instanceVar_qgdfp2,
     instanceVar_qcfp2,
     instanceVar_qbfp2,
     instanceVar_qsfp2,
     instanceVar_qgsfp3,
     instanceVar_qgdfp3,
     instanceVar_qcfp3,
     instanceVar_qbfp3,
     instanceVar_qsfp3,
     instanceVar_qgsfp4,
     instanceVar_qgdfp4,
     instanceVar_qcfp4,
     instanceVar_qbfp4,
     instanceVar_qsfp4,
     // model parameters
     // reals
     modelPar_version,
     modelPar_given_version,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_cg,
     modelPar_given_cg,
     modelPar_cofsm,
     modelPar_given_cofsm,
     modelPar_cofdm,
     modelPar_given_cofdm,
     modelPar_cofdsm,
     modelPar_given_cofdsm,
     modelPar_cofdsubm,
     modelPar_given_cofdsubm,
     modelPar_cofssubm,
     modelPar_given_cofssubm,
     modelPar_cofgsubm,
     modelPar_given_cofgsubm,
     modelPar_rsh,
     modelPar_given_rsh,
     modelPar_rcs,
     modelPar_given_rcs,
     modelPar_rcd,
     modelPar_given_rcd,
     modelPar_vx0,
     modelPar_given_vx0,
     modelPar_mu0,
     modelPar_given_mu0,
     modelPar_beta,
     modelPar_given_beta,
     modelPar_vto,
     modelPar_given_vto,
     modelPar_ss,
     modelPar_given_ss,
     modelPar_delta1,
     modelPar_given_delta1,
     modelPar_delta2,
     modelPar_given_delta2,
     modelPar_dibsat,
     modelPar_given_dibsat,
     modelPar_nd,
     modelPar_given_nd,
     modelPar_alpha,
     modelPar_given_alpha,
     modelPar_lambda,
     modelPar_given_lambda,
     modelPar_vtheta,
     modelPar_given_vtheta,
     modelPar_mtheta,
     modelPar_given_mtheta,
     modelPar_vzeta,
     modelPar_given_vzeta,
     modelPar_vtzeta,
     modelPar_given_vtzeta,
     modelPar_epsilon,
     modelPar_given_epsilon,
     modelPar_rct1,
     modelPar_given_rct1,
     modelPar_rct2,
     modelPar_given_rct2,
     modelPar_lgs,
     modelPar_given_lgs,
     modelPar_vtors,
     modelPar_given_vtors,
     modelPar_cgrs,
     modelPar_given_cgrs,
     modelPar_vx0rs,
     modelPar_given_vx0rs,
     modelPar_mu0rs,
     modelPar_given_mu0rs,
     modelPar_betars,
     modelPar_given_betars,
     modelPar_delta1rs,
     modelPar_given_delta1rs,
     modelPar_srs,
     modelPar_given_srs,
     modelPar_ndrs,
     modelPar_given_ndrs,
     modelPar_vthetars,
     modelPar_given_vthetars,
     modelPar_mthetars,
     modelPar_given_mthetars,
     modelPar_alphars,
     modelPar_given_alphars,
     modelPar_lgd,
     modelPar_given_lgd,
     modelPar_vtord,
     modelPar_given_vtord,
     modelPar_cgrd,
     modelPar_given_cgrd,
     modelPar_vx0rd,
     modelPar_given_vx0rd,
     modelPar_mu0rd,
     modelPar_given_mu0rd,
     modelPar_betard,
     modelPar_given_betard,
     modelPar_delta1rd,
     modelPar_given_delta1rd,
     modelPar_srd,
     modelPar_given_srd,
     modelPar_ndrd,
     modelPar_given_ndrd,
     modelPar_vthetard,
     modelPar_given_vthetard,
     modelPar_mthetard,
     modelPar_given_mthetard,
     modelPar_alphard,
     modelPar_given_alphard,
     modelPar_lgfp1,
     modelPar_given_lgfp1,
     modelPar_vtofp1,
     modelPar_given_vtofp1,
     modelPar_cgfp1,
     modelPar_given_cgfp1,
     modelPar_cfp1s,
     modelPar_given_cfp1s,
     modelPar_ccfp1,
     modelPar_given_ccfp1,
     modelPar_cbfp1,
     modelPar_given_cbfp1,
     modelPar_vx0fp1,
     modelPar_given_vx0fp1,
     modelPar_mu0fp1,
     modelPar_given_mu0fp1,
     modelPar_betafp1,
     modelPar_given_betafp1,
     modelPar_delta1fp1,
     modelPar_given_delta1fp1,
     modelPar_sfp1,
     modelPar_given_sfp1,
     modelPar_ndfp1,
     modelPar_given_ndfp1,
     modelPar_vthetafp1,
     modelPar_given_vthetafp1,
     modelPar_mthetafp1,
     modelPar_given_mthetafp1,
     modelPar_alphafp1,
     modelPar_given_alphafp1,
     modelPar_lgfp2,
     modelPar_given_lgfp2,
     modelPar_vtofp2,
     modelPar_given_vtofp2,
     modelPar_cgfp2,
     modelPar_given_cgfp2,
     modelPar_cfp2s,
     modelPar_given_cfp2s,
     modelPar_ccfp2,
     modelPar_given_ccfp2,
     modelPar_cbfp2,
     modelPar_given_cbfp2,
     modelPar_vx0fp2,
     modelPar_given_vx0fp2,
     modelPar_mu0fp2,
     modelPar_given_mu0fp2,
     modelPar_betafp2,
     modelPar_given_betafp2,
     modelPar_delta1fp2,
     modelPar_given_delta1fp2,
     modelPar_sfp2,
     modelPar_given_sfp2,
     modelPar_ndfp2,
     modelPar_given_ndfp2,
     modelPar_vthetafp2,
     modelPar_given_vthetafp2,
     modelPar_mthetafp2,
     modelPar_given_mthetafp2,
     modelPar_alphafp2,
     modelPar_given_alphafp2,
     modelPar_lgfp3,
     modelPar_given_lgfp3,
     modelPar_vtofp3,
     modelPar_given_vtofp3,
     modelPar_cgfp3,
     modelPar_given_cgfp3,
     modelPar_cfp3s,
     modelPar_given_cfp3s,
     modelPar_ccfp3,
     modelPar_given_ccfp3,
     modelPar_cbfp3,
     modelPar_given_cbfp3,
     modelPar_vx0fp3,
     modelPar_given_vx0fp3,
     modelPar_mu0fp3,
     modelPar_given_mu0fp3,
     modelPar_betafp3,
     modelPar_given_betafp3,
     modelPar_delta1fp3,
     modelPar_given_delta1fp3,
     modelPar_sfp3,
     modelPar_given_sfp3,
     modelPar_ndfp3,
     modelPar_given_ndfp3,
     modelPar_vthetafp3,
     modelPar_given_vthetafp3,
     modelPar_mthetafp3,
     modelPar_given_mthetafp3,
     modelPar_alphafp3,
     modelPar_given_alphafp3,
     modelPar_lgfp4,
     modelPar_given_lgfp4,
     modelPar_vtofp4,
     modelPar_given_vtofp4,
     modelPar_cgfp4,
     modelPar_given_cgfp4,
     modelPar_cfp4s,
     modelPar_given_cfp4s,
     modelPar_ccfp4,
     modelPar_given_ccfp4,
     modelPar_cbfp4,
     modelPar_given_cbfp4,
     modelPar_vx0fp4,
     modelPar_given_vx0fp4,
     modelPar_mu0fp4,
     modelPar_given_mu0fp4,
     modelPar_betafp4,
     modelPar_given_betafp4,
     modelPar_delta1fp4,
     modelPar_given_delta1fp4,
     modelPar_sfp4,
     modelPar_given_sfp4,
     modelPar_ndfp4,
     modelPar_given_ndfp4,
     modelPar_vthetafp4,
     modelPar_given_vthetafp4,
     modelPar_mthetafp4,
     modelPar_given_mthetafp4,
     modelPar_alphafp4,
     modelPar_given_alphafp4,
     modelPar_rgsp,
     modelPar_given_rgsp,
     modelPar_vjg,
     modelPar_given_vjg,
     modelPar_pg_param1,
     modelPar_given_pg_param1,
     modelPar_pg_params,
     modelPar_given_pg_params,
     modelPar_ijs,
     modelPar_given_ijs,
     modelPar_vgsats,
     modelPar_given_vgsats,
     modelPar_fracs,
     modelPar_given_fracs,
     modelPar_alphags,
     modelPar_given_alphags,
     modelPar_pg_paramd,
     modelPar_given_pg_paramd,
     modelPar_ijd,
     modelPar_given_ijd,
     modelPar_vgsatd,
     modelPar_given_vgsatd,
     modelPar_fracd,
     modelPar_given_fracd,
     modelPar_alphagd,
     modelPar_given_alphagd,
     modelPar_pgsrecs,
     modelPar_given_pgsrecs,
     modelPar_irecs,
     modelPar_given_irecs,
     modelPar_vgsatqs,
     modelPar_given_vgsatqs,
     modelPar_vbdgs,
     modelPar_given_vbdgs,
     modelPar_pbdgs,
     modelPar_given_pbdgs,
     modelPar_betarecs,
     modelPar_given_betarecs,
     modelPar_kbdgates,
     modelPar_given_kbdgates,
     modelPar_pgsrecd,
     modelPar_given_pgsrecd,
     modelPar_irecd,
     modelPar_given_irecd,
     modelPar_vgsatqd,
     modelPar_given_vgsatqd,
     modelPar_vbdgd,
     modelPar_given_vbdgd,
     modelPar_pbdgd,
     modelPar_given_pbdgd,
     modelPar_betarecd,
     modelPar_given_betarecd,
     modelPar_kbdgated,
     modelPar_given_kbdgated,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_taugmrf,
     modelPar_given_taugmrf,
     modelPar_ctrap,
     modelPar_given_ctrap,
     modelPar_vttrap,
     modelPar_given_vttrap,
     modelPar_taut,
     modelPar_given_taut,
     modelPar_alphat1,
     modelPar_given_alphat1,
     modelPar_alphat2,
     modelPar_given_alphat2,
     modelPar_tempt,
     modelPar_given_tempt,
     modelPar_shs,
     modelPar_given_shs,
     modelPar_shd,
     modelPar_given_shd,
     modelPar_kf,
     modelPar_given_kf,
     modelPar_af,
     modelPar_given_af,
     modelPar_ffe,
     modelPar_given_ffe,
     modelPar_minr,
     modelPar_given_minr,
     modelPar_minl,
     modelPar_given_minl,
     modelPar_minc,
     modelPar_given_minc,
     // non-reals (including hidden)
     modelPar_type,
     modelPar_given_type,
     modelPar_flagres,
     modelPar_given_flagres,
     modelPar_flagfp1,
     modelPar_given_flagfp1,
     modelPar_flagfp1s,
     modelPar_given_flagfp1s,
     modelPar_flagfp2,
     modelPar_given_flagfp2,
     modelPar_flagfp2s,
     modelPar_given_flagfp2s,
     modelPar_flagfp3,
     modelPar_given_flagfp3,
     modelPar_flagfp3s,
     modelPar_given_flagfp3s,
     modelPar_flagfp4,
     modelPar_given_flagfp4,
     modelPar_flagfp4s,
     modelPar_given_flagfp4s,
     modelPar_igmod,
     modelPar_given_igmod,
     modelPar_gmdisp,
     modelPar_given_gmdisp,
     modelPar_trapselect,
     modelPar_given_trapselect,
     modelPar_noisemod,
     modelPar_given_noisemod,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_d] += staticContributions[in.admsNodeID_d].dx(0);
  dqdp[in.admsNodeID_d] += dynamicContributions[in.admsNodeID_d].dx(0);
  Findices[in.admsNodeID_d] = in.li_d;
  Qindices[in.admsNodeID_d] = in.li_d;
  dfdp[in.admsNodeID_g] += staticContributions[in.admsNodeID_g].dx(0);
  dqdp[in.admsNodeID_g] += dynamicContributions[in.admsNodeID_g].dx(0);
  Findices[in.admsNodeID_g] = in.li_g;
  Qindices[in.admsNodeID_g] = in.li_g;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_di] += staticContributions[in.admsNodeID_di].dx(0);
  dqdp[in.admsNodeID_di] += dynamicContributions[in.admsNodeID_di].dx(0);
  Findices[in.admsNodeID_di] = in.li_di;
  Qindices[in.admsNodeID_di] = in.li_di;
  dfdp[in.admsNodeID_gi] += staticContributions[in.admsNodeID_gi].dx(0);
  dqdp[in.admsNodeID_gi] += dynamicContributions[in.admsNodeID_gi].dx(0);
  Findices[in.admsNodeID_gi] = in.li_gi;
  Qindices[in.admsNodeID_gi] = in.li_gi;
  dfdp[in.admsNodeID_si] += staticContributions[in.admsNodeID_si].dx(0);
  dqdp[in.admsNodeID_si] += dynamicContributions[in.admsNodeID_si].dx(0);
  Findices[in.admsNodeID_si] = in.li_si;
  Qindices[in.admsNodeID_si] = in.li_si;
  dfdp[in.admsNodeID_fp1] += staticContributions[in.admsNodeID_fp1].dx(0);
  dqdp[in.admsNodeID_fp1] += dynamicContributions[in.admsNodeID_fp1].dx(0);
  Findices[in.admsNodeID_fp1] = in.li_fp1;
  Qindices[in.admsNodeID_fp1] = in.li_fp1;
  dfdp[in.admsNodeID_fp2] += staticContributions[in.admsNodeID_fp2].dx(0);
  dqdp[in.admsNodeID_fp2] += dynamicContributions[in.admsNodeID_fp2].dx(0);
  Findices[in.admsNodeID_fp2] = in.li_fp2;
  Qindices[in.admsNodeID_fp2] = in.li_fp2;
  dfdp[in.admsNodeID_fp3] += staticContributions[in.admsNodeID_fp3].dx(0);
  dqdp[in.admsNodeID_fp3] += dynamicContributions[in.admsNodeID_fp3].dx(0);
  Findices[in.admsNodeID_fp3] = in.li_fp3;
  Qindices[in.admsNodeID_fp3] = in.li_fp3;
  dfdp[in.admsNodeID_fp4] += staticContributions[in.admsNodeID_fp4].dx(0);
  dqdp[in.admsNodeID_fp4] += dynamicContributions[in.admsNodeID_fp4].dx(0);
  Findices[in.admsNodeID_fp4] = in.li_fp4;
  Qindices[in.admsNodeID_fp4] = in.li_fp4;
  dfdp[in.admsNodeID_drc] += staticContributions[in.admsNodeID_drc].dx(0);
  dqdp[in.admsNodeID_drc] += dynamicContributions[in.admsNodeID_drc].dx(0);
  Findices[in.admsNodeID_drc] = in.li_drc;
  Qindices[in.admsNodeID_drc] = in.li_drc;
  dfdp[in.admsNodeID_src] += staticContributions[in.admsNodeID_src].dx(0);
  dqdp[in.admsNodeID_src] += dynamicContributions[in.admsNodeID_src].dx(0);
  Findices[in.admsNodeID_src] = in.li_src;
  Qindices[in.admsNodeID_src] = in.li_src;
  dfdp[in.admsNodeID_tr] += staticContributions[in.admsNodeID_tr].dx(0);
  dqdp[in.admsNodeID_tr] += dynamicContributions[in.admsNodeID_tr].dx(0);
  Findices[in.admsNodeID_tr] = in.li_tr;
  Qindices[in.admsNodeID_tr] = in.li_tr;
  dfdp[in.admsNodeID_tr1] += staticContributions[in.admsNodeID_tr1].dx(0);
  dqdp[in.admsNodeID_tr1] += dynamicContributions[in.admsNodeID_tr1].dx(0);
  Findices[in.admsNodeID_tr1] = in.li_tr1;
  Qindices[in.admsNodeID_tr1] = in.li_tr1;
  dfdp[in.admsNodeID_xt1] += staticContributions[in.admsNodeID_xt1].dx(0);
  dqdp[in.admsNodeID_xt1] += dynamicContributions[in.admsNodeID_xt1].dx(0);
  Findices[in.admsNodeID_xt1] = in.li_xt1;
  Qindices[in.admsNodeID_xt1] = in.li_xt1;
  dfdp[in.admsNodeID_xt2] += staticContributions[in.admsNodeID_xt2].dx(0);
  dqdp[in.admsNodeID_xt2] += dynamicContributions[in.admsNodeID_xt2].dx(0);
  Findices[in.admsNodeID_xt2] = in.li_xt2;
  Qindices[in.admsNodeID_xt2] = in.li_xt2;
  dfdp[in.admsNodeID_dt] += staticContributions[in.admsNodeID_dt].dx(0);
  dqdp[in.admsNodeID_dt] += dynamicContributions[in.admsNodeID_dt].dx(0);
  Findices[in.admsNodeID_dt] = in.li_dt;
  Qindices[in.admsNodeID_dt] = in.li_dt;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((18+0)*sizeInstance);
  dqdp.resize((18+0)*sizeInstance);
  Findices.resize((18+0)*sizeInstance);
  Qindices.resize((18+0)*sizeInstance);

  std::vector <double> probeVars(47);
  std::vector <AdmsSensFadType> staticContributions(18+0);
  std::vector <AdmsSensFadType> dynamicContributions(18+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_version=mod.version;
  bool modelPar_given_version=mod.given("version");
  modParamMap["version"] = &modelPar_version;
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  modParamMap["tnom"] = &modelPar_tnom;
  AdmsSensFadType modelPar_cg=mod.cg;
  bool modelPar_given_cg=mod.given("cg");
  modParamMap["cg"] = &modelPar_cg;
  AdmsSensFadType modelPar_cofsm=mod.cofsm;
  bool modelPar_given_cofsm=mod.given("cofsm");
  modParamMap["cofsm"] = &modelPar_cofsm;
  AdmsSensFadType modelPar_cofdm=mod.cofdm;
  bool modelPar_given_cofdm=mod.given("cofdm");
  modParamMap["cofdm"] = &modelPar_cofdm;
  AdmsSensFadType modelPar_cofdsm=mod.cofdsm;
  bool modelPar_given_cofdsm=mod.given("cofdsm");
  modParamMap["cofdsm"] = &modelPar_cofdsm;
  AdmsSensFadType modelPar_cofdsubm=mod.cofdsubm;
  bool modelPar_given_cofdsubm=mod.given("cofdsubm");
  modParamMap["cofdsubm"] = &modelPar_cofdsubm;
  AdmsSensFadType modelPar_cofssubm=mod.cofssubm;
  bool modelPar_given_cofssubm=mod.given("cofssubm");
  modParamMap["cofssubm"] = &modelPar_cofssubm;
  AdmsSensFadType modelPar_cofgsubm=mod.cofgsubm;
  bool modelPar_given_cofgsubm=mod.given("cofgsubm");
  modParamMap["cofgsubm"] = &modelPar_cofgsubm;
  AdmsSensFadType modelPar_rsh=mod.rsh;
  bool modelPar_given_rsh=mod.given("rsh");
  modParamMap["rsh"] = &modelPar_rsh;
  AdmsSensFadType modelPar_rcs=mod.rcs;
  bool modelPar_given_rcs=mod.given("rcs");
  modParamMap["rcs"] = &modelPar_rcs;
  AdmsSensFadType modelPar_rcd=mod.rcd;
  bool modelPar_given_rcd=mod.given("rcd");
  modParamMap["rcd"] = &modelPar_rcd;
  AdmsSensFadType modelPar_vx0=mod.vx0;
  bool modelPar_given_vx0=mod.given("vx0");
  modParamMap["vx0"] = &modelPar_vx0;
  AdmsSensFadType modelPar_mu0=mod.mu0;
  bool modelPar_given_mu0=mod.given("mu0");
  modParamMap["mu0"] = &modelPar_mu0;
  AdmsSensFadType modelPar_beta=mod.beta;
  bool modelPar_given_beta=mod.given("beta");
  modParamMap["beta"] = &modelPar_beta;
  AdmsSensFadType modelPar_vto=mod.vto;
  bool modelPar_given_vto=mod.given("vto");
  modParamMap["vto"] = &modelPar_vto;
  AdmsSensFadType modelPar_ss=mod.ss;
  bool modelPar_given_ss=mod.given("ss");
  modParamMap["ss"] = &modelPar_ss;
  AdmsSensFadType modelPar_delta1=mod.delta1;
  bool modelPar_given_delta1=mod.given("delta1");
  modParamMap["delta1"] = &modelPar_delta1;
  AdmsSensFadType modelPar_delta2=mod.delta2;
  bool modelPar_given_delta2=mod.given("delta2");
  modParamMap["delta2"] = &modelPar_delta2;
  AdmsSensFadType modelPar_dibsat=mod.dibsat;
  bool modelPar_given_dibsat=mod.given("dibsat");
  modParamMap["dibsat"] = &modelPar_dibsat;
  AdmsSensFadType modelPar_nd=mod.nd;
  bool modelPar_given_nd=mod.given("nd");
  modParamMap["nd"] = &modelPar_nd;
  AdmsSensFadType modelPar_alpha=mod.alpha;
  bool modelPar_given_alpha=mod.given("alpha");
  modParamMap["alpha"] = &modelPar_alpha;
  AdmsSensFadType modelPar_lambda=mod.lambda;
  bool modelPar_given_lambda=mod.given("lambda");
  modParamMap["lambda"] = &modelPar_lambda;
  AdmsSensFadType modelPar_vtheta=mod.vtheta;
  bool modelPar_given_vtheta=mod.given("vtheta");
  modParamMap["vtheta"] = &modelPar_vtheta;
  AdmsSensFadType modelPar_mtheta=mod.mtheta;
  bool modelPar_given_mtheta=mod.given("mtheta");
  modParamMap["mtheta"] = &modelPar_mtheta;
  AdmsSensFadType modelPar_vzeta=mod.vzeta;
  bool modelPar_given_vzeta=mod.given("vzeta");
  modParamMap["vzeta"] = &modelPar_vzeta;
  AdmsSensFadType modelPar_vtzeta=mod.vtzeta;
  bool modelPar_given_vtzeta=mod.given("vtzeta");
  modParamMap["vtzeta"] = &modelPar_vtzeta;
  AdmsSensFadType modelPar_epsilon=mod.epsilon;
  bool modelPar_given_epsilon=mod.given("epsilon");
  modParamMap["epsilon"] = &modelPar_epsilon;
  AdmsSensFadType modelPar_rct1=mod.rct1;
  bool modelPar_given_rct1=mod.given("rct1");
  modParamMap["rct1"] = &modelPar_rct1;
  AdmsSensFadType modelPar_rct2=mod.rct2;
  bool modelPar_given_rct2=mod.given("rct2");
  modParamMap["rct2"] = &modelPar_rct2;
  AdmsSensFadType modelPar_lgs=mod.lgs;
  bool modelPar_given_lgs=mod.given("lgs");
  modParamMap["lgs"] = &modelPar_lgs;
  AdmsSensFadType modelPar_vtors=mod.vtors;
  bool modelPar_given_vtors=mod.given("vtors");
  modParamMap["vtors"] = &modelPar_vtors;
  AdmsSensFadType modelPar_cgrs=mod.cgrs;
  bool modelPar_given_cgrs=mod.given("cgrs");
  modParamMap["cgrs"] = &modelPar_cgrs;
  AdmsSensFadType modelPar_vx0rs=mod.vx0rs;
  bool modelPar_given_vx0rs=mod.given("vx0rs");
  modParamMap["vx0rs"] = &modelPar_vx0rs;
  AdmsSensFadType modelPar_mu0rs=mod.mu0rs;
  bool modelPar_given_mu0rs=mod.given("mu0rs");
  modParamMap["mu0rs"] = &modelPar_mu0rs;
  AdmsSensFadType modelPar_betars=mod.betars;
  bool modelPar_given_betars=mod.given("betars");
  modParamMap["betars"] = &modelPar_betars;
  AdmsSensFadType modelPar_delta1rs=mod.delta1rs;
  bool modelPar_given_delta1rs=mod.given("delta1rs");
  modParamMap["delta1rs"] = &modelPar_delta1rs;
  AdmsSensFadType modelPar_srs=mod.srs;
  bool modelPar_given_srs=mod.given("srs");
  modParamMap["srs"] = &modelPar_srs;
  AdmsSensFadType modelPar_ndrs=mod.ndrs;
  bool modelPar_given_ndrs=mod.given("ndrs");
  modParamMap["ndrs"] = &modelPar_ndrs;
  AdmsSensFadType modelPar_vthetars=mod.vthetars;
  bool modelPar_given_vthetars=mod.given("vthetars");
  modParamMap["vthetars"] = &modelPar_vthetars;
  AdmsSensFadType modelPar_mthetars=mod.mthetars;
  bool modelPar_given_mthetars=mod.given("mthetars");
  modParamMap["mthetars"] = &modelPar_mthetars;
  AdmsSensFadType modelPar_alphars=mod.alphars;
  bool modelPar_given_alphars=mod.given("alphars");
  modParamMap["alphars"] = &modelPar_alphars;
  AdmsSensFadType modelPar_lgd=mod.lgd;
  bool modelPar_given_lgd=mod.given("lgd");
  modParamMap["lgd"] = &modelPar_lgd;
  AdmsSensFadType modelPar_vtord=mod.vtord;
  bool modelPar_given_vtord=mod.given("vtord");
  modParamMap["vtord"] = &modelPar_vtord;
  AdmsSensFadType modelPar_cgrd=mod.cgrd;
  bool modelPar_given_cgrd=mod.given("cgrd");
  modParamMap["cgrd"] = &modelPar_cgrd;
  AdmsSensFadType modelPar_vx0rd=mod.vx0rd;
  bool modelPar_given_vx0rd=mod.given("vx0rd");
  modParamMap["vx0rd"] = &modelPar_vx0rd;
  AdmsSensFadType modelPar_mu0rd=mod.mu0rd;
  bool modelPar_given_mu0rd=mod.given("mu0rd");
  modParamMap["mu0rd"] = &modelPar_mu0rd;
  AdmsSensFadType modelPar_betard=mod.betard;
  bool modelPar_given_betard=mod.given("betard");
  modParamMap["betard"] = &modelPar_betard;
  AdmsSensFadType modelPar_delta1rd=mod.delta1rd;
  bool modelPar_given_delta1rd=mod.given("delta1rd");
  modParamMap["delta1rd"] = &modelPar_delta1rd;
  AdmsSensFadType modelPar_srd=mod.srd;
  bool modelPar_given_srd=mod.given("srd");
  modParamMap["srd"] = &modelPar_srd;
  AdmsSensFadType modelPar_ndrd=mod.ndrd;
  bool modelPar_given_ndrd=mod.given("ndrd");
  modParamMap["ndrd"] = &modelPar_ndrd;
  AdmsSensFadType modelPar_vthetard=mod.vthetard;
  bool modelPar_given_vthetard=mod.given("vthetard");
  modParamMap["vthetard"] = &modelPar_vthetard;
  AdmsSensFadType modelPar_mthetard=mod.mthetard;
  bool modelPar_given_mthetard=mod.given("mthetard");
  modParamMap["mthetard"] = &modelPar_mthetard;
  AdmsSensFadType modelPar_alphard=mod.alphard;
  bool modelPar_given_alphard=mod.given("alphard");
  modParamMap["alphard"] = &modelPar_alphard;
  AdmsSensFadType modelPar_lgfp1=mod.lgfp1;
  bool modelPar_given_lgfp1=mod.given("lgfp1");
  modParamMap["lgfp1"] = &modelPar_lgfp1;
  AdmsSensFadType modelPar_vtofp1=mod.vtofp1;
  bool modelPar_given_vtofp1=mod.given("vtofp1");
  modParamMap["vtofp1"] = &modelPar_vtofp1;
  AdmsSensFadType modelPar_cgfp1=mod.cgfp1;
  bool modelPar_given_cgfp1=mod.given("cgfp1");
  modParamMap["cgfp1"] = &modelPar_cgfp1;
  AdmsSensFadType modelPar_cfp1s=mod.cfp1s;
  bool modelPar_given_cfp1s=mod.given("cfp1s");
  modParamMap["cfp1s"] = &modelPar_cfp1s;
  AdmsSensFadType modelPar_ccfp1=mod.ccfp1;
  bool modelPar_given_ccfp1=mod.given("ccfp1");
  modParamMap["ccfp1"] = &modelPar_ccfp1;
  AdmsSensFadType modelPar_cbfp1=mod.cbfp1;
  bool modelPar_given_cbfp1=mod.given("cbfp1");
  modParamMap["cbfp1"] = &modelPar_cbfp1;
  AdmsSensFadType modelPar_vx0fp1=mod.vx0fp1;
  bool modelPar_given_vx0fp1=mod.given("vx0fp1");
  modParamMap["vx0fp1"] = &modelPar_vx0fp1;
  AdmsSensFadType modelPar_mu0fp1=mod.mu0fp1;
  bool modelPar_given_mu0fp1=mod.given("mu0fp1");
  modParamMap["mu0fp1"] = &modelPar_mu0fp1;
  AdmsSensFadType modelPar_betafp1=mod.betafp1;
  bool modelPar_given_betafp1=mod.given("betafp1");
  modParamMap["betafp1"] = &modelPar_betafp1;
  AdmsSensFadType modelPar_delta1fp1=mod.delta1fp1;
  bool modelPar_given_delta1fp1=mod.given("delta1fp1");
  modParamMap["delta1fp1"] = &modelPar_delta1fp1;
  AdmsSensFadType modelPar_sfp1=mod.sfp1;
  bool modelPar_given_sfp1=mod.given("sfp1");
  modParamMap["sfp1"] = &modelPar_sfp1;
  AdmsSensFadType modelPar_ndfp1=mod.ndfp1;
  bool modelPar_given_ndfp1=mod.given("ndfp1");
  modParamMap["ndfp1"] = &modelPar_ndfp1;
  AdmsSensFadType modelPar_vthetafp1=mod.vthetafp1;
  bool modelPar_given_vthetafp1=mod.given("vthetafp1");
  modParamMap["vthetafp1"] = &modelPar_vthetafp1;
  AdmsSensFadType modelPar_mthetafp1=mod.mthetafp1;
  bool modelPar_given_mthetafp1=mod.given("mthetafp1");
  modParamMap["mthetafp1"] = &modelPar_mthetafp1;
  AdmsSensFadType modelPar_alphafp1=mod.alphafp1;
  bool modelPar_given_alphafp1=mod.given("alphafp1");
  modParamMap["alphafp1"] = &modelPar_alphafp1;
  AdmsSensFadType modelPar_lgfp2=mod.lgfp2;
  bool modelPar_given_lgfp2=mod.given("lgfp2");
  modParamMap["lgfp2"] = &modelPar_lgfp2;
  AdmsSensFadType modelPar_vtofp2=mod.vtofp2;
  bool modelPar_given_vtofp2=mod.given("vtofp2");
  modParamMap["vtofp2"] = &modelPar_vtofp2;
  AdmsSensFadType modelPar_cgfp2=mod.cgfp2;
  bool modelPar_given_cgfp2=mod.given("cgfp2");
  modParamMap["cgfp2"] = &modelPar_cgfp2;
  AdmsSensFadType modelPar_cfp2s=mod.cfp2s;
  bool modelPar_given_cfp2s=mod.given("cfp2s");
  modParamMap["cfp2s"] = &modelPar_cfp2s;
  AdmsSensFadType modelPar_ccfp2=mod.ccfp2;
  bool modelPar_given_ccfp2=mod.given("ccfp2");
  modParamMap["ccfp2"] = &modelPar_ccfp2;
  AdmsSensFadType modelPar_cbfp2=mod.cbfp2;
  bool modelPar_given_cbfp2=mod.given("cbfp2");
  modParamMap["cbfp2"] = &modelPar_cbfp2;
  AdmsSensFadType modelPar_vx0fp2=mod.vx0fp2;
  bool modelPar_given_vx0fp2=mod.given("vx0fp2");
  modParamMap["vx0fp2"] = &modelPar_vx0fp2;
  AdmsSensFadType modelPar_mu0fp2=mod.mu0fp2;
  bool modelPar_given_mu0fp2=mod.given("mu0fp2");
  modParamMap["mu0fp2"] = &modelPar_mu0fp2;
  AdmsSensFadType modelPar_betafp2=mod.betafp2;
  bool modelPar_given_betafp2=mod.given("betafp2");
  modParamMap["betafp2"] = &modelPar_betafp2;
  AdmsSensFadType modelPar_delta1fp2=mod.delta1fp2;
  bool modelPar_given_delta1fp2=mod.given("delta1fp2");
  modParamMap["delta1fp2"] = &modelPar_delta1fp2;
  AdmsSensFadType modelPar_sfp2=mod.sfp2;
  bool modelPar_given_sfp2=mod.given("sfp2");
  modParamMap["sfp2"] = &modelPar_sfp2;
  AdmsSensFadType modelPar_ndfp2=mod.ndfp2;
  bool modelPar_given_ndfp2=mod.given("ndfp2");
  modParamMap["ndfp2"] = &modelPar_ndfp2;
  AdmsSensFadType modelPar_vthetafp2=mod.vthetafp2;
  bool modelPar_given_vthetafp2=mod.given("vthetafp2");
  modParamMap["vthetafp2"] = &modelPar_vthetafp2;
  AdmsSensFadType modelPar_mthetafp2=mod.mthetafp2;
  bool modelPar_given_mthetafp2=mod.given("mthetafp2");
  modParamMap["mthetafp2"] = &modelPar_mthetafp2;
  AdmsSensFadType modelPar_alphafp2=mod.alphafp2;
  bool modelPar_given_alphafp2=mod.given("alphafp2");
  modParamMap["alphafp2"] = &modelPar_alphafp2;
  AdmsSensFadType modelPar_lgfp3=mod.lgfp3;
  bool modelPar_given_lgfp3=mod.given("lgfp3");
  modParamMap["lgfp3"] = &modelPar_lgfp3;
  AdmsSensFadType modelPar_vtofp3=mod.vtofp3;
  bool modelPar_given_vtofp3=mod.given("vtofp3");
  modParamMap["vtofp3"] = &modelPar_vtofp3;
  AdmsSensFadType modelPar_cgfp3=mod.cgfp3;
  bool modelPar_given_cgfp3=mod.given("cgfp3");
  modParamMap["cgfp3"] = &modelPar_cgfp3;
  AdmsSensFadType modelPar_cfp3s=mod.cfp3s;
  bool modelPar_given_cfp3s=mod.given("cfp3s");
  modParamMap["cfp3s"] = &modelPar_cfp3s;
  AdmsSensFadType modelPar_ccfp3=mod.ccfp3;
  bool modelPar_given_ccfp3=mod.given("ccfp3");
  modParamMap["ccfp3"] = &modelPar_ccfp3;
  AdmsSensFadType modelPar_cbfp3=mod.cbfp3;
  bool modelPar_given_cbfp3=mod.given("cbfp3");
  modParamMap["cbfp3"] = &modelPar_cbfp3;
  AdmsSensFadType modelPar_vx0fp3=mod.vx0fp3;
  bool modelPar_given_vx0fp3=mod.given("vx0fp3");
  modParamMap["vx0fp3"] = &modelPar_vx0fp3;
  AdmsSensFadType modelPar_mu0fp3=mod.mu0fp3;
  bool modelPar_given_mu0fp3=mod.given("mu0fp3");
  modParamMap["mu0fp3"] = &modelPar_mu0fp3;
  AdmsSensFadType modelPar_betafp3=mod.betafp3;
  bool modelPar_given_betafp3=mod.given("betafp3");
  modParamMap["betafp3"] = &modelPar_betafp3;
  AdmsSensFadType modelPar_delta1fp3=mod.delta1fp3;
  bool modelPar_given_delta1fp3=mod.given("delta1fp3");
  modParamMap["delta1fp3"] = &modelPar_delta1fp3;
  AdmsSensFadType modelPar_sfp3=mod.sfp3;
  bool modelPar_given_sfp3=mod.given("sfp3");
  modParamMap["sfp3"] = &modelPar_sfp3;
  AdmsSensFadType modelPar_ndfp3=mod.ndfp3;
  bool modelPar_given_ndfp3=mod.given("ndfp3");
  modParamMap["ndfp3"] = &modelPar_ndfp3;
  AdmsSensFadType modelPar_vthetafp3=mod.vthetafp3;
  bool modelPar_given_vthetafp3=mod.given("vthetafp3");
  modParamMap["vthetafp3"] = &modelPar_vthetafp3;
  AdmsSensFadType modelPar_mthetafp3=mod.mthetafp3;
  bool modelPar_given_mthetafp3=mod.given("mthetafp3");
  modParamMap["mthetafp3"] = &modelPar_mthetafp3;
  AdmsSensFadType modelPar_alphafp3=mod.alphafp3;
  bool modelPar_given_alphafp3=mod.given("alphafp3");
  modParamMap["alphafp3"] = &modelPar_alphafp3;
  AdmsSensFadType modelPar_lgfp4=mod.lgfp4;
  bool modelPar_given_lgfp4=mod.given("lgfp4");
  modParamMap["lgfp4"] = &modelPar_lgfp4;
  AdmsSensFadType modelPar_vtofp4=mod.vtofp4;
  bool modelPar_given_vtofp4=mod.given("vtofp4");
  modParamMap["vtofp4"] = &modelPar_vtofp4;
  AdmsSensFadType modelPar_cgfp4=mod.cgfp4;
  bool modelPar_given_cgfp4=mod.given("cgfp4");
  modParamMap["cgfp4"] = &modelPar_cgfp4;
  AdmsSensFadType modelPar_cfp4s=mod.cfp4s;
  bool modelPar_given_cfp4s=mod.given("cfp4s");
  modParamMap["cfp4s"] = &modelPar_cfp4s;
  AdmsSensFadType modelPar_ccfp4=mod.ccfp4;
  bool modelPar_given_ccfp4=mod.given("ccfp4");
  modParamMap["ccfp4"] = &modelPar_ccfp4;
  AdmsSensFadType modelPar_cbfp4=mod.cbfp4;
  bool modelPar_given_cbfp4=mod.given("cbfp4");
  modParamMap["cbfp4"] = &modelPar_cbfp4;
  AdmsSensFadType modelPar_vx0fp4=mod.vx0fp4;
  bool modelPar_given_vx0fp4=mod.given("vx0fp4");
  modParamMap["vx0fp4"] = &modelPar_vx0fp4;
  AdmsSensFadType modelPar_mu0fp4=mod.mu0fp4;
  bool modelPar_given_mu0fp4=mod.given("mu0fp4");
  modParamMap["mu0fp4"] = &modelPar_mu0fp4;
  AdmsSensFadType modelPar_betafp4=mod.betafp4;
  bool modelPar_given_betafp4=mod.given("betafp4");
  modParamMap["betafp4"] = &modelPar_betafp4;
  AdmsSensFadType modelPar_delta1fp4=mod.delta1fp4;
  bool modelPar_given_delta1fp4=mod.given("delta1fp4");
  modParamMap["delta1fp4"] = &modelPar_delta1fp4;
  AdmsSensFadType modelPar_sfp4=mod.sfp4;
  bool modelPar_given_sfp4=mod.given("sfp4");
  modParamMap["sfp4"] = &modelPar_sfp4;
  AdmsSensFadType modelPar_ndfp4=mod.ndfp4;
  bool modelPar_given_ndfp4=mod.given("ndfp4");
  modParamMap["ndfp4"] = &modelPar_ndfp4;
  AdmsSensFadType modelPar_vthetafp4=mod.vthetafp4;
  bool modelPar_given_vthetafp4=mod.given("vthetafp4");
  modParamMap["vthetafp4"] = &modelPar_vthetafp4;
  AdmsSensFadType modelPar_mthetafp4=mod.mthetafp4;
  bool modelPar_given_mthetafp4=mod.given("mthetafp4");
  modParamMap["mthetafp4"] = &modelPar_mthetafp4;
  AdmsSensFadType modelPar_alphafp4=mod.alphafp4;
  bool modelPar_given_alphafp4=mod.given("alphafp4");
  modParamMap["alphafp4"] = &modelPar_alphafp4;
  AdmsSensFadType modelPar_rgsp=mod.rgsp;
  bool modelPar_given_rgsp=mod.given("rgsp");
  modParamMap["rgsp"] = &modelPar_rgsp;
  AdmsSensFadType modelPar_vjg=mod.vjg;
  bool modelPar_given_vjg=mod.given("vjg");
  modParamMap["vjg"] = &modelPar_vjg;
  AdmsSensFadType modelPar_pg_param1=mod.pg_param1;
  bool modelPar_given_pg_param1=mod.given("pg_param1");
  modParamMap["pg_param1"] = &modelPar_pg_param1;
  AdmsSensFadType modelPar_pg_params=mod.pg_params;
  bool modelPar_given_pg_params=mod.given("pg_params");
  modParamMap["pg_params"] = &modelPar_pg_params;
  AdmsSensFadType modelPar_ijs=mod.ijs;
  bool modelPar_given_ijs=mod.given("ijs");
  modParamMap["ijs"] = &modelPar_ijs;
  AdmsSensFadType modelPar_vgsats=mod.vgsats;
  bool modelPar_given_vgsats=mod.given("vgsats");
  modParamMap["vgsats"] = &modelPar_vgsats;
  AdmsSensFadType modelPar_fracs=mod.fracs;
  bool modelPar_given_fracs=mod.given("fracs");
  modParamMap["fracs"] = &modelPar_fracs;
  AdmsSensFadType modelPar_alphags=mod.alphags;
  bool modelPar_given_alphags=mod.given("alphags");
  modParamMap["alphags"] = &modelPar_alphags;
  AdmsSensFadType modelPar_pg_paramd=mod.pg_paramd;
  bool modelPar_given_pg_paramd=mod.given("pg_paramd");
  modParamMap["pg_paramd"] = &modelPar_pg_paramd;
  AdmsSensFadType modelPar_ijd=mod.ijd;
  bool modelPar_given_ijd=mod.given("ijd");
  modParamMap["ijd"] = &modelPar_ijd;
  AdmsSensFadType modelPar_vgsatd=mod.vgsatd;
  bool modelPar_given_vgsatd=mod.given("vgsatd");
  modParamMap["vgsatd"] = &modelPar_vgsatd;
  AdmsSensFadType modelPar_fracd=mod.fracd;
  bool modelPar_given_fracd=mod.given("fracd");
  modParamMap["fracd"] = &modelPar_fracd;
  AdmsSensFadType modelPar_alphagd=mod.alphagd;
  bool modelPar_given_alphagd=mod.given("alphagd");
  modParamMap["alphagd"] = &modelPar_alphagd;
  AdmsSensFadType modelPar_pgsrecs=mod.pgsrecs;
  bool modelPar_given_pgsrecs=mod.given("pgsrecs");
  modParamMap["pgsrecs"] = &modelPar_pgsrecs;
  AdmsSensFadType modelPar_irecs=mod.irecs;
  bool modelPar_given_irecs=mod.given("irecs");
  modParamMap["irecs"] = &modelPar_irecs;
  AdmsSensFadType modelPar_vgsatqs=mod.vgsatqs;
  bool modelPar_given_vgsatqs=mod.given("vgsatqs");
  modParamMap["vgsatqs"] = &modelPar_vgsatqs;
  AdmsSensFadType modelPar_vbdgs=mod.vbdgs;
  bool modelPar_given_vbdgs=mod.given("vbdgs");
  modParamMap["vbdgs"] = &modelPar_vbdgs;
  AdmsSensFadType modelPar_pbdgs=mod.pbdgs;
  bool modelPar_given_pbdgs=mod.given("pbdgs");
  modParamMap["pbdgs"] = &modelPar_pbdgs;
  AdmsSensFadType modelPar_betarecs=mod.betarecs;
  bool modelPar_given_betarecs=mod.given("betarecs");
  modParamMap["betarecs"] = &modelPar_betarecs;
  AdmsSensFadType modelPar_kbdgates=mod.kbdgates;
  bool modelPar_given_kbdgates=mod.given("kbdgates");
  modParamMap["kbdgates"] = &modelPar_kbdgates;
  AdmsSensFadType modelPar_pgsrecd=mod.pgsrecd;
  bool modelPar_given_pgsrecd=mod.given("pgsrecd");
  modParamMap["pgsrecd"] = &modelPar_pgsrecd;
  AdmsSensFadType modelPar_irecd=mod.irecd;
  bool modelPar_given_irecd=mod.given("irecd");
  modParamMap["irecd"] = &modelPar_irecd;
  AdmsSensFadType modelPar_vgsatqd=mod.vgsatqd;
  bool modelPar_given_vgsatqd=mod.given("vgsatqd");
  modParamMap["vgsatqd"] = &modelPar_vgsatqd;
  AdmsSensFadType modelPar_vbdgd=mod.vbdgd;
  bool modelPar_given_vbdgd=mod.given("vbdgd");
  modParamMap["vbdgd"] = &modelPar_vbdgd;
  AdmsSensFadType modelPar_pbdgd=mod.pbdgd;
  bool modelPar_given_pbdgd=mod.given("pbdgd");
  modParamMap["pbdgd"] = &modelPar_pbdgd;
  AdmsSensFadType modelPar_betarecd=mod.betarecd;
  bool modelPar_given_betarecd=mod.given("betarecd");
  modParamMap["betarecd"] = &modelPar_betarecd;
  AdmsSensFadType modelPar_kbdgated=mod.kbdgated;
  bool modelPar_given_kbdgated=mod.given("kbdgated");
  modParamMap["kbdgated"] = &modelPar_kbdgated;
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  modParamMap["rth"] = &modelPar_rth;
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  modParamMap["cth"] = &modelPar_cth;
  AdmsSensFadType modelPar_taugmrf=mod.taugmrf;
  bool modelPar_given_taugmrf=mod.given("taugmrf");
  modParamMap["taugmrf"] = &modelPar_taugmrf;
  AdmsSensFadType modelPar_ctrap=mod.ctrap;
  bool modelPar_given_ctrap=mod.given("ctrap");
  modParamMap["ctrap"] = &modelPar_ctrap;
  AdmsSensFadType modelPar_vttrap=mod.vttrap;
  bool modelPar_given_vttrap=mod.given("vttrap");
  modParamMap["vttrap"] = &modelPar_vttrap;
  AdmsSensFadType modelPar_taut=mod.taut;
  bool modelPar_given_taut=mod.given("taut");
  modParamMap["taut"] = &modelPar_taut;
  AdmsSensFadType modelPar_alphat1=mod.alphat1;
  bool modelPar_given_alphat1=mod.given("alphat1");
  modParamMap["alphat1"] = &modelPar_alphat1;
  AdmsSensFadType modelPar_alphat2=mod.alphat2;
  bool modelPar_given_alphat2=mod.given("alphat2");
  modParamMap["alphat2"] = &modelPar_alphat2;
  AdmsSensFadType modelPar_tempt=mod.tempt;
  bool modelPar_given_tempt=mod.given("tempt");
  modParamMap["tempt"] = &modelPar_tempt;
  AdmsSensFadType modelPar_shs=mod.shs;
  bool modelPar_given_shs=mod.given("shs");
  modParamMap["shs"] = &modelPar_shs;
  AdmsSensFadType modelPar_shd=mod.shd;
  bool modelPar_given_shd=mod.given("shd");
  modParamMap["shd"] = &modelPar_shd;
  AdmsSensFadType modelPar_kf=mod.kf;
  bool modelPar_given_kf=mod.given("kf");
  modParamMap["kf"] = &modelPar_kf;
  AdmsSensFadType modelPar_af=mod.af;
  bool modelPar_given_af=mod.given("af");
  modParamMap["af"] = &modelPar_af;
  AdmsSensFadType modelPar_ffe=mod.ffe;
  bool modelPar_given_ffe=mod.given("ffe");
  modParamMap["ffe"] = &modelPar_ffe;
  AdmsSensFadType modelPar_minr=mod.minr;
  bool modelPar_given_minr=mod.given("minr");
  modParamMap["minr"] = &modelPar_minr;
  AdmsSensFadType modelPar_minl=mod.minl;
  bool modelPar_given_minl=mod.given("minl");
  modParamMap["minl"] = &modelPar_minl;
  AdmsSensFadType modelPar_minc=mod.minc;
  bool modelPar_given_minc=mod.given("minc");
  modParamMap["minc"] = &modelPar_minc;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");
  int modelPar_flagres=mod.flagres;
  bool modelPar_given_flagres=mod.given("flagres");
  int modelPar_flagfp1=mod.flagfp1;
  bool modelPar_given_flagfp1=mod.given("flagfp1");
  int modelPar_flagfp1s=mod.flagfp1s;
  bool modelPar_given_flagfp1s=mod.given("flagfp1s");
  int modelPar_flagfp2=mod.flagfp2;
  bool modelPar_given_flagfp2=mod.given("flagfp2");
  int modelPar_flagfp2s=mod.flagfp2s;
  bool modelPar_given_flagfp2s=mod.given("flagfp2s");
  int modelPar_flagfp3=mod.flagfp3;
  bool modelPar_given_flagfp3=mod.given("flagfp3");
  int modelPar_flagfp3s=mod.flagfp3s;
  bool modelPar_given_flagfp3s=mod.given("flagfp3s");
  int modelPar_flagfp4=mod.flagfp4;
  bool modelPar_given_flagfp4=mod.given("flagfp4");
  int modelPar_flagfp4s=mod.flagfp4s;
  bool modelPar_given_flagfp4s=mod.given("flagfp4s");
  int modelPar_igmod=mod.igmod;
  bool modelPar_given_igmod=mod.given("igmod");
  int modelPar_gmdisp=mod.gmdisp;
  bool modelPar_given_gmdisp=mod.given("gmdisp");
  int modelPar_trapselect=mod.trapselect;
  bool modelPar_given_trapselect=mod.given("trapselect");
  int modelPar_noisemod=mod.noisemod;
  bool modelPar_given_noisemod=mod.given("noisemod");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 18+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_w=in.w;
    bool instancePar_given_w=in.given("w");
    AdmsSensFadType instancePar_l=in.l;
    bool instancePar_given_l=in.given("l");
    AdmsSensFadType instancePar_dtemp=in.dtemp;
    bool instancePar_given_dtemp=in.given("dtemp");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:
    int instancePar_ngf=in.ngf;
    bool instancePar_given_ngf=in.given("ngf");




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_rcs_w=in.rcs_w;
    AdmsSensFadType instanceVar_rcd_w=in.rcd_w;
    AdmsSensFadType instanceVar_rg=in.rg;
    AdmsSensFadType instanceVar_vtdibli=in.vtdibli;
    AdmsSensFadType instanceVar_vdsat1i=in.vdsat1i;
    AdmsSensFadType instanceVar_vtdiblrs=in.vtdiblrs;
    AdmsSensFadType instanceVar_vdsatrs=in.vdsatrs;
    AdmsSensFadType instanceVar_vtdiblrd=in.vtdiblrd;
    AdmsSensFadType instanceVar_vdsatrd=in.vdsatrd;
    AdmsSensFadType instanceVar_vtdiblfp1=in.vtdiblfp1;
    AdmsSensFadType instanceVar_vdsatfp1=in.vdsatfp1;
    AdmsSensFadType instanceVar_vtdiblfp2=in.vtdiblfp2;
    AdmsSensFadType instanceVar_vdsatfp2=in.vdsatfp2;
    AdmsSensFadType instanceVar_vtdiblfp3=in.vtdiblfp3;
    AdmsSensFadType instanceVar_vdsatfp3=in.vdsatfp3;
    AdmsSensFadType instanceVar_vtdiblfp4=in.vtdiblfp4;
    AdmsSensFadType instanceVar_vdsatfp4=in.vdsatfp4;
    AdmsSensFadType instanceVar_qgs=in.qgs;
    AdmsSensFadType instanceVar_qgd=in.qgd;
    AdmsSensFadType instanceVar_qc=in.qc;
    AdmsSensFadType instanceVar_qb=in.qb;
    AdmsSensFadType instanceVar_qs=in.qs;
    AdmsSensFadType instanceVar_igssdio=in.igssdio;
    AdmsSensFadType instanceVar_igdsdio=in.igdsdio;
    AdmsSensFadType instanceVar_igsrec=in.igsrec;
    AdmsSensFadType instanceVar_igdrec=in.igdrec;
    AdmsSensFadType instanceVar_qgsrs=in.qgsrs;
    AdmsSensFadType instanceVar_qgdrs=in.qgdrs;
    AdmsSensFadType instanceVar_qcrs=in.qcrs;
    AdmsSensFadType instanceVar_qbrs=in.qbrs;
    AdmsSensFadType instanceVar_qsrs=in.qsrs;
    AdmsSensFadType instanceVar_qgsrd=in.qgsrd;
    AdmsSensFadType instanceVar_qgdrd=in.qgdrd;
    AdmsSensFadType instanceVar_qcrd=in.qcrd;
    AdmsSensFadType instanceVar_qbrd=in.qbrd;
    AdmsSensFadType instanceVar_qsrd=in.qsrd;
    AdmsSensFadType instanceVar_qgsfp1=in.qgsfp1;
    AdmsSensFadType instanceVar_qgdfp1=in.qgdfp1;
    AdmsSensFadType instanceVar_qcfp1=in.qcfp1;
    AdmsSensFadType instanceVar_qbfp1=in.qbfp1;
    AdmsSensFadType instanceVar_qsfp1=in.qsfp1;
    AdmsSensFadType instanceVar_qgsfp2=in.qgsfp2;
    AdmsSensFadType instanceVar_qgdfp2=in.qgdfp2;
    AdmsSensFadType instanceVar_qcfp2=in.qcfp2;
    AdmsSensFadType instanceVar_qbfp2=in.qbfp2;
    AdmsSensFadType instanceVar_qsfp2=in.qsfp2;
    AdmsSensFadType instanceVar_qgsfp3=in.qgsfp3;
    AdmsSensFadType instanceVar_qgdfp3=in.qgdfp3;
    AdmsSensFadType instanceVar_qcfp3=in.qcfp3;
    AdmsSensFadType instanceVar_qbfp3=in.qbfp3;
    AdmsSensFadType instanceVar_qsfp3=in.qsfp3;
    AdmsSensFadType instanceVar_qgsfp4=in.qgsfp4;
    AdmsSensFadType instanceVar_qgdfp4=in.qgdfp4;
    AdmsSensFadType instanceVar_qcfp4=in.qcfp4;
    AdmsSensFadType instanceVar_qbfp4=in.qbfp4;
    AdmsSensFadType instanceVar_qsfp4=in.qsfp4;


    //non-reals



    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_drc_d] = (*solVectorPtr)[in.li_drc] - (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_gi_b] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_b];
    probeVars[in.admsProbeID_V_s_b] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_b];
    probeVars[in.admsProbeID_V_d_b] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_b];
    probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_gi_d] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_gi_s] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_g_gi] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_gi];
    probeVars[in.admsProbeID_V_d_drc] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_drc];
    probeVars[in.admsProbeID_V_xt1_GND] = (in.collapseNode_xt1)?(0):((*solVectorPtr)[in.li_xt1]);
    probeVars[in.admsProbeID_V_xt2_GND] = (in.collapseNode_xt2)?(0):((*solVectorPtr)[in.li_xt2]);
    probeVars[in.admsProbeID_V_fp4_s] = (*solVectorPtr)[in.li_fp4] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_fp4_d] = (*solVectorPtr)[in.li_fp4] - (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_tr_GND] = (in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]);
    probeVars[in.admsProbeID_V_tr1_tr] = (in.collapseNode_tr1)?(0):((*solVectorPtr)[in.li_tr1]) - ((in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]));
    probeVars[in.admsProbeID_V_d_g] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_g];
    probeVars[in.admsProbeID_V_src_s] = (*solVectorPtr)[in.li_src] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_src_d] = (*solVectorPtr)[in.li_src] - (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_gi_si] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_drc_fp4] = (*solVectorPtr)[in.li_drc] - (*solVectorPtr)[in.li_fp4];
    probeVars[in.admsProbeID_V_drc_GND] = (*solVectorPtr)[in.li_drc];
    probeVars[in.admsProbeID_V_fp4_GND] = (*solVectorPtr)[in.li_fp4];
    probeVars[in.admsProbeID_V_si_src] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_src];
    probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
    probeVars[in.admsProbeID_V_src_GND] = (*solVectorPtr)[in.li_src];
    probeVars[in.admsProbeID_V_s_GND] = (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_d_GND] = (*solVectorPtr)[in.li_d];
    probeVars[in.admsProbeID_V_fp1_di] = (*solVectorPtr)[in.li_fp1] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_b_di] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_s_di] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_gi_di] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_di];
    probeVars[in.admsProbeID_V_fp2_fp1] = (*solVectorPtr)[in.li_fp2] - (*solVectorPtr)[in.li_fp1];
    probeVars[in.admsProbeID_V_b_fp1] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_fp1];
    probeVars[in.admsProbeID_V_s_fp1] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp1];
    probeVars[in.admsProbeID_V_gi_fp1] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp1];
    probeVars[in.admsProbeID_V_fp3_fp2] = (*solVectorPtr)[in.li_fp3] - (*solVectorPtr)[in.li_fp2];
    probeVars[in.admsProbeID_V_b_fp2] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_fp2];
    probeVars[in.admsProbeID_V_s_fp2] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp2];
    probeVars[in.admsProbeID_V_gi_fp2] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp2];
    probeVars[in.admsProbeID_Temp_dt_GND] = (in.collapseNode_dt)?(0):((*solVectorPtr)[in.li_dt]);
    probeVars[in.admsProbeID_V_fp4_fp3] = (*solVectorPtr)[in.li_fp4] - (*solVectorPtr)[in.li_fp3];
    probeVars[in.admsProbeID_V_gi_fp4] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp4];
    probeVars[in.admsProbeID_V_s_fp4] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp4];
    probeVars[in.admsProbeID_V_b_fp3] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_fp3];
    probeVars[in.admsProbeID_V_s_fp3] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp3];
    probeVars[in.admsProbeID_V_gi_fp3] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp3];


    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_w,
       instancePar_given_w,
       instancePar_l,
       instancePar_given_l,
       instancePar_dtemp,
       instancePar_given_dtemp,
       // non-reals(including hidden)
       instancePar_ngf,
       instancePar_given_ngf,
       // instance variables
       // reals
       instanceVar_rcs_w,
       instanceVar_rcd_w,
       instanceVar_rg,
       instanceVar_vtdibli,
       instanceVar_vdsat1i,
       instanceVar_vtdiblrs,
       instanceVar_vdsatrs,
       instanceVar_vtdiblrd,
       instanceVar_vdsatrd,
       instanceVar_vtdiblfp1,
       instanceVar_vdsatfp1,
       instanceVar_vtdiblfp2,
       instanceVar_vdsatfp2,
       instanceVar_vtdiblfp3,
       instanceVar_vdsatfp3,
       instanceVar_vtdiblfp4,
       instanceVar_vdsatfp4,
       instanceVar_qgs,
       instanceVar_qgd,
       instanceVar_qc,
       instanceVar_qb,
       instanceVar_qs,
       instanceVar_igssdio,
       instanceVar_igdsdio,
       instanceVar_igsrec,
       instanceVar_igdrec,
       instanceVar_qgsrs,
       instanceVar_qgdrs,
       instanceVar_qcrs,
       instanceVar_qbrs,
       instanceVar_qsrs,
       instanceVar_qgsrd,
       instanceVar_qgdrd,
       instanceVar_qcrd,
       instanceVar_qbrd,
       instanceVar_qsrd,
       instanceVar_qgsfp1,
       instanceVar_qgdfp1,
       instanceVar_qcfp1,
       instanceVar_qbfp1,
       instanceVar_qsfp1,
       instanceVar_qgsfp2,
       instanceVar_qgdfp2,
       instanceVar_qcfp2,
       instanceVar_qbfp2,
       instanceVar_qsfp2,
       instanceVar_qgsfp3,
       instanceVar_qgdfp3,
       instanceVar_qcfp3,
       instanceVar_qbfp3,
       instanceVar_qsfp3,
       instanceVar_qgsfp4,
       instanceVar_qgdfp4,
       instanceVar_qcfp4,
       instanceVar_qbfp4,
       instanceVar_qsfp4,
       // model parameters
       // reals
       modelPar_version,
       modelPar_given_version,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_cg,
       modelPar_given_cg,
       modelPar_cofsm,
       modelPar_given_cofsm,
       modelPar_cofdm,
       modelPar_given_cofdm,
       modelPar_cofdsm,
       modelPar_given_cofdsm,
       modelPar_cofdsubm,
       modelPar_given_cofdsubm,
       modelPar_cofssubm,
       modelPar_given_cofssubm,
       modelPar_cofgsubm,
       modelPar_given_cofgsubm,
       modelPar_rsh,
       modelPar_given_rsh,
       modelPar_rcs,
       modelPar_given_rcs,
       modelPar_rcd,
       modelPar_given_rcd,
       modelPar_vx0,
       modelPar_given_vx0,
       modelPar_mu0,
       modelPar_given_mu0,
       modelPar_beta,
       modelPar_given_beta,
       modelPar_vto,
       modelPar_given_vto,
       modelPar_ss,
       modelPar_given_ss,
       modelPar_delta1,
       modelPar_given_delta1,
       modelPar_delta2,
       modelPar_given_delta2,
       modelPar_dibsat,
       modelPar_given_dibsat,
       modelPar_nd,
       modelPar_given_nd,
       modelPar_alpha,
       modelPar_given_alpha,
       modelPar_lambda,
       modelPar_given_lambda,
       modelPar_vtheta,
       modelPar_given_vtheta,
       modelPar_mtheta,
       modelPar_given_mtheta,
       modelPar_vzeta,
       modelPar_given_vzeta,
       modelPar_vtzeta,
       modelPar_given_vtzeta,
       modelPar_epsilon,
       modelPar_given_epsilon,
       modelPar_rct1,
       modelPar_given_rct1,
       modelPar_rct2,
       modelPar_given_rct2,
       modelPar_lgs,
       modelPar_given_lgs,
       modelPar_vtors,
       modelPar_given_vtors,
       modelPar_cgrs,
       modelPar_given_cgrs,
       modelPar_vx0rs,
       modelPar_given_vx0rs,
       modelPar_mu0rs,
       modelPar_given_mu0rs,
       modelPar_betars,
       modelPar_given_betars,
       modelPar_delta1rs,
       modelPar_given_delta1rs,
       modelPar_srs,
       modelPar_given_srs,
       modelPar_ndrs,
       modelPar_given_ndrs,
       modelPar_vthetars,
       modelPar_given_vthetars,
       modelPar_mthetars,
       modelPar_given_mthetars,
       modelPar_alphars,
       modelPar_given_alphars,
       modelPar_lgd,
       modelPar_given_lgd,
       modelPar_vtord,
       modelPar_given_vtord,
       modelPar_cgrd,
       modelPar_given_cgrd,
       modelPar_vx0rd,
       modelPar_given_vx0rd,
       modelPar_mu0rd,
       modelPar_given_mu0rd,
       modelPar_betard,
       modelPar_given_betard,
       modelPar_delta1rd,
       modelPar_given_delta1rd,
       modelPar_srd,
       modelPar_given_srd,
       modelPar_ndrd,
       modelPar_given_ndrd,
       modelPar_vthetard,
       modelPar_given_vthetard,
       modelPar_mthetard,
       modelPar_given_mthetard,
       modelPar_alphard,
       modelPar_given_alphard,
       modelPar_lgfp1,
       modelPar_given_lgfp1,
       modelPar_vtofp1,
       modelPar_given_vtofp1,
       modelPar_cgfp1,
       modelPar_given_cgfp1,
       modelPar_cfp1s,
       modelPar_given_cfp1s,
       modelPar_ccfp1,
       modelPar_given_ccfp1,
       modelPar_cbfp1,
       modelPar_given_cbfp1,
       modelPar_vx0fp1,
       modelPar_given_vx0fp1,
       modelPar_mu0fp1,
       modelPar_given_mu0fp1,
       modelPar_betafp1,
       modelPar_given_betafp1,
       modelPar_delta1fp1,
       modelPar_given_delta1fp1,
       modelPar_sfp1,
       modelPar_given_sfp1,
       modelPar_ndfp1,
       modelPar_given_ndfp1,
       modelPar_vthetafp1,
       modelPar_given_vthetafp1,
       modelPar_mthetafp1,
       modelPar_given_mthetafp1,
       modelPar_alphafp1,
       modelPar_given_alphafp1,
       modelPar_lgfp2,
       modelPar_given_lgfp2,
       modelPar_vtofp2,
       modelPar_given_vtofp2,
       modelPar_cgfp2,
       modelPar_given_cgfp2,
       modelPar_cfp2s,
       modelPar_given_cfp2s,
       modelPar_ccfp2,
       modelPar_given_ccfp2,
       modelPar_cbfp2,
       modelPar_given_cbfp2,
       modelPar_vx0fp2,
       modelPar_given_vx0fp2,
       modelPar_mu0fp2,
       modelPar_given_mu0fp2,
       modelPar_betafp2,
       modelPar_given_betafp2,
       modelPar_delta1fp2,
       modelPar_given_delta1fp2,
       modelPar_sfp2,
       modelPar_given_sfp2,
       modelPar_ndfp2,
       modelPar_given_ndfp2,
       modelPar_vthetafp2,
       modelPar_given_vthetafp2,
       modelPar_mthetafp2,
       modelPar_given_mthetafp2,
       modelPar_alphafp2,
       modelPar_given_alphafp2,
       modelPar_lgfp3,
       modelPar_given_lgfp3,
       modelPar_vtofp3,
       modelPar_given_vtofp3,
       modelPar_cgfp3,
       modelPar_given_cgfp3,
       modelPar_cfp3s,
       modelPar_given_cfp3s,
       modelPar_ccfp3,
       modelPar_given_ccfp3,
       modelPar_cbfp3,
       modelPar_given_cbfp3,
       modelPar_vx0fp3,
       modelPar_given_vx0fp3,
       modelPar_mu0fp3,
       modelPar_given_mu0fp3,
       modelPar_betafp3,
       modelPar_given_betafp3,
       modelPar_delta1fp3,
       modelPar_given_delta1fp3,
       modelPar_sfp3,
       modelPar_given_sfp3,
       modelPar_ndfp3,
       modelPar_given_ndfp3,
       modelPar_vthetafp3,
       modelPar_given_vthetafp3,
       modelPar_mthetafp3,
       modelPar_given_mthetafp3,
       modelPar_alphafp3,
       modelPar_given_alphafp3,
       modelPar_lgfp4,
       modelPar_given_lgfp4,
       modelPar_vtofp4,
       modelPar_given_vtofp4,
       modelPar_cgfp4,
       modelPar_given_cgfp4,
       modelPar_cfp4s,
       modelPar_given_cfp4s,
       modelPar_ccfp4,
       modelPar_given_ccfp4,
       modelPar_cbfp4,
       modelPar_given_cbfp4,
       modelPar_vx0fp4,
       modelPar_given_vx0fp4,
       modelPar_mu0fp4,
       modelPar_given_mu0fp4,
       modelPar_betafp4,
       modelPar_given_betafp4,
       modelPar_delta1fp4,
       modelPar_given_delta1fp4,
       modelPar_sfp4,
       modelPar_given_sfp4,
       modelPar_ndfp4,
       modelPar_given_ndfp4,
       modelPar_vthetafp4,
       modelPar_given_vthetafp4,
       modelPar_mthetafp4,
       modelPar_given_mthetafp4,
       modelPar_alphafp4,
       modelPar_given_alphafp4,
       modelPar_rgsp,
       modelPar_given_rgsp,
       modelPar_vjg,
       modelPar_given_vjg,
       modelPar_pg_param1,
       modelPar_given_pg_param1,
       modelPar_pg_params,
       modelPar_given_pg_params,
       modelPar_ijs,
       modelPar_given_ijs,
       modelPar_vgsats,
       modelPar_given_vgsats,
       modelPar_fracs,
       modelPar_given_fracs,
       modelPar_alphags,
       modelPar_given_alphags,
       modelPar_pg_paramd,
       modelPar_given_pg_paramd,
       modelPar_ijd,
       modelPar_given_ijd,
       modelPar_vgsatd,
       modelPar_given_vgsatd,
       modelPar_fracd,
       modelPar_given_fracd,
       modelPar_alphagd,
       modelPar_given_alphagd,
       modelPar_pgsrecs,
       modelPar_given_pgsrecs,
       modelPar_irecs,
       modelPar_given_irecs,
       modelPar_vgsatqs,
       modelPar_given_vgsatqs,
       modelPar_vbdgs,
       modelPar_given_vbdgs,
       modelPar_pbdgs,
       modelPar_given_pbdgs,
       modelPar_betarecs,
       modelPar_given_betarecs,
       modelPar_kbdgates,
       modelPar_given_kbdgates,
       modelPar_pgsrecd,
       modelPar_given_pgsrecd,
       modelPar_irecd,
       modelPar_given_irecd,
       modelPar_vgsatqd,
       modelPar_given_vgsatqd,
       modelPar_vbdgd,
       modelPar_given_vbdgd,
       modelPar_pbdgd,
       modelPar_given_pbdgd,
       modelPar_betarecd,
       modelPar_given_betarecd,
       modelPar_kbdgated,
       modelPar_given_kbdgated,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_taugmrf,
       modelPar_given_taugmrf,
       modelPar_ctrap,
       modelPar_given_ctrap,
       modelPar_vttrap,
       modelPar_given_vttrap,
       modelPar_taut,
       modelPar_given_taut,
       modelPar_alphat1,
       modelPar_given_alphat1,
       modelPar_alphat2,
       modelPar_given_alphat2,
       modelPar_tempt,
       modelPar_given_tempt,
       modelPar_shs,
       modelPar_given_shs,
       modelPar_shd,
       modelPar_given_shd,
       modelPar_kf,
       modelPar_given_kf,
       modelPar_af,
       modelPar_given_af,
       modelPar_ffe,
       modelPar_given_ffe,
       modelPar_minr,
       modelPar_given_minr,
       modelPar_minl,
       modelPar_given_minl,
       modelPar_minc,
       modelPar_given_minc,
       // non-reals (including hidden)
       modelPar_type,
       modelPar_given_type,
       modelPar_flagres,
       modelPar_given_flagres,
       modelPar_flagfp1,
       modelPar_given_flagfp1,
       modelPar_flagfp1s,
       modelPar_given_flagfp1s,
       modelPar_flagfp2,
       modelPar_given_flagfp2,
       modelPar_flagfp2s,
       modelPar_given_flagfp2s,
       modelPar_flagfp3,
       modelPar_given_flagfp3,
       modelPar_flagfp3s,
       modelPar_given_flagfp3s,
       modelPar_flagfp4,
       modelPar_given_flagfp4,
       modelPar_flagfp4s,
       modelPar_given_flagfp4s,
       modelPar_igmod,
       modelPar_given_igmod,
       modelPar_gmdisp,
       modelPar_given_gmdisp,
       modelPar_trapselect,
       modelPar_given_trapselect,
       modelPar_noisemod,
       modelPar_given_noisemod,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_drc_d,
       in.admsProbeID_V_gi_b,
       in.admsProbeID_V_s_b,
       in.admsProbeID_V_d_b,
       in.admsProbeID_V_d_s,
       in.admsProbeID_V_gi_d,
       in.admsProbeID_V_gi_s,
       in.admsProbeID_V_g_gi,
       in.admsProbeID_V_d_drc,
       in.admsProbeID_V_xt1_GND,
       in.admsProbeID_V_xt2_GND,
       in.admsProbeID_V_fp4_s,
       in.admsProbeID_V_fp4_d,
       in.admsProbeID_V_tr_GND,
       in.admsProbeID_V_tr1_tr,
       in.admsProbeID_V_d_g,
       in.admsProbeID_V_src_s,
       in.admsProbeID_V_src_d,
       in.admsProbeID_V_di_si,
       in.admsProbeID_V_gi_si,
       in.admsProbeID_V_drc_fp4,
       in.admsProbeID_V_drc_GND,
       in.admsProbeID_V_fp4_GND,
       in.admsProbeID_V_si_src,
       in.admsProbeID_V_si_GND,
       in.admsProbeID_V_src_GND,
       in.admsProbeID_V_s_GND,
       in.admsProbeID_V_d_GND,
       in.admsProbeID_V_fp1_di,
       in.admsProbeID_V_b_di,
       in.admsProbeID_V_s_di,
       in.admsProbeID_V_gi_di,
       in.admsProbeID_V_fp2_fp1,
       in.admsProbeID_V_b_fp1,
       in.admsProbeID_V_s_fp1,
       in.admsProbeID_V_gi_fp1,
       in.admsProbeID_V_fp3_fp2,
       in.admsProbeID_V_b_fp2,
       in.admsProbeID_V_s_fp2,
       in.admsProbeID_V_gi_fp2,
       in.admsProbeID_Temp_dt_GND,
       in.admsProbeID_V_fp4_fp3,
       in.admsProbeID_V_gi_fp4,
       in.admsProbeID_V_s_fp4,
       in.admsProbeID_V_b_fp3,
       in.admsProbeID_V_s_fp3,
       in.admsProbeID_V_gi_fp3,

       // node constants
       in.admsNodeID_d,
       in.admsNodeID_g,
       in.admsNodeID_s,
       in.admsNodeID_b,
       in.admsNodeID_di,
       in.admsNodeID_gi,
       in.admsNodeID_si,
       in.admsNodeID_fp1,
       in.admsNodeID_fp2,
       in.admsNodeID_fp3,
       in.admsNodeID_fp4,
       in.admsNodeID_drc,
       in.admsNodeID_src,
       in.admsNodeID_tr,
       in.admsNodeID_tr1,
       in.admsNodeID_xt1,
       in.admsNodeID_xt2,
       in.admsNodeID_dt,
       // instance parameters
       // reals
       instancePar_w,
       instancePar_given_w,
       instancePar_l,
       instancePar_given_l,
       instancePar_dtemp,
       instancePar_given_dtemp,
       // non-reals(including hidden)
       instancePar_ngf,
       instancePar_given_ngf,
       // instance variables
       // reals
       instanceVar_rcs_w,
       instanceVar_rcd_w,
       instanceVar_rg,
       instanceVar_vtdibli,
       instanceVar_vdsat1i,
       instanceVar_vtdiblrs,
       instanceVar_vdsatrs,
       instanceVar_vtdiblrd,
       instanceVar_vdsatrd,
       instanceVar_vtdiblfp1,
       instanceVar_vdsatfp1,
       instanceVar_vtdiblfp2,
       instanceVar_vdsatfp2,
       instanceVar_vtdiblfp3,
       instanceVar_vdsatfp3,
       instanceVar_vtdiblfp4,
       instanceVar_vdsatfp4,
       instanceVar_qgs,
       instanceVar_qgd,
       instanceVar_qc,
       instanceVar_qb,
       instanceVar_qs,
       instanceVar_igssdio,
       instanceVar_igdsdio,
       instanceVar_igsrec,
       instanceVar_igdrec,
       instanceVar_qgsrs,
       instanceVar_qgdrs,
       instanceVar_qcrs,
       instanceVar_qbrs,
       instanceVar_qsrs,
       instanceVar_qgsrd,
       instanceVar_qgdrd,
       instanceVar_qcrd,
       instanceVar_qbrd,
       instanceVar_qsrd,
       instanceVar_qgsfp1,
       instanceVar_qgdfp1,
       instanceVar_qcfp1,
       instanceVar_qbfp1,
       instanceVar_qsfp1,
       instanceVar_qgsfp2,
       instanceVar_qgdfp2,
       instanceVar_qcfp2,
       instanceVar_qbfp2,
       instanceVar_qsfp2,
       instanceVar_qgsfp3,
       instanceVar_qgdfp3,
       instanceVar_qcfp3,
       instanceVar_qbfp3,
       instanceVar_qsfp3,
       instanceVar_qgsfp4,
       instanceVar_qgdfp4,
       instanceVar_qcfp4,
       instanceVar_qbfp4,
       instanceVar_qsfp4,
       // model parameters
       // reals
       modelPar_version,
       modelPar_given_version,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_cg,
       modelPar_given_cg,
       modelPar_cofsm,
       modelPar_given_cofsm,
       modelPar_cofdm,
       modelPar_given_cofdm,
       modelPar_cofdsm,
       modelPar_given_cofdsm,
       modelPar_cofdsubm,
       modelPar_given_cofdsubm,
       modelPar_cofssubm,
       modelPar_given_cofssubm,
       modelPar_cofgsubm,
       modelPar_given_cofgsubm,
       modelPar_rsh,
       modelPar_given_rsh,
       modelPar_rcs,
       modelPar_given_rcs,
       modelPar_rcd,
       modelPar_given_rcd,
       modelPar_vx0,
       modelPar_given_vx0,
       modelPar_mu0,
       modelPar_given_mu0,
       modelPar_beta,
       modelPar_given_beta,
       modelPar_vto,
       modelPar_given_vto,
       modelPar_ss,
       modelPar_given_ss,
       modelPar_delta1,
       modelPar_given_delta1,
       modelPar_delta2,
       modelPar_given_delta2,
       modelPar_dibsat,
       modelPar_given_dibsat,
       modelPar_nd,
       modelPar_given_nd,
       modelPar_alpha,
       modelPar_given_alpha,
       modelPar_lambda,
       modelPar_given_lambda,
       modelPar_vtheta,
       modelPar_given_vtheta,
       modelPar_mtheta,
       modelPar_given_mtheta,
       modelPar_vzeta,
       modelPar_given_vzeta,
       modelPar_vtzeta,
       modelPar_given_vtzeta,
       modelPar_epsilon,
       modelPar_given_epsilon,
       modelPar_rct1,
       modelPar_given_rct1,
       modelPar_rct2,
       modelPar_given_rct2,
       modelPar_lgs,
       modelPar_given_lgs,
       modelPar_vtors,
       modelPar_given_vtors,
       modelPar_cgrs,
       modelPar_given_cgrs,
       modelPar_vx0rs,
       modelPar_given_vx0rs,
       modelPar_mu0rs,
       modelPar_given_mu0rs,
       modelPar_betars,
       modelPar_given_betars,
       modelPar_delta1rs,
       modelPar_given_delta1rs,
       modelPar_srs,
       modelPar_given_srs,
       modelPar_ndrs,
       modelPar_given_ndrs,
       modelPar_vthetars,
       modelPar_given_vthetars,
       modelPar_mthetars,
       modelPar_given_mthetars,
       modelPar_alphars,
       modelPar_given_alphars,
       modelPar_lgd,
       modelPar_given_lgd,
       modelPar_vtord,
       modelPar_given_vtord,
       modelPar_cgrd,
       modelPar_given_cgrd,
       modelPar_vx0rd,
       modelPar_given_vx0rd,
       modelPar_mu0rd,
       modelPar_given_mu0rd,
       modelPar_betard,
       modelPar_given_betard,
       modelPar_delta1rd,
       modelPar_given_delta1rd,
       modelPar_srd,
       modelPar_given_srd,
       modelPar_ndrd,
       modelPar_given_ndrd,
       modelPar_vthetard,
       modelPar_given_vthetard,
       modelPar_mthetard,
       modelPar_given_mthetard,
       modelPar_alphard,
       modelPar_given_alphard,
       modelPar_lgfp1,
       modelPar_given_lgfp1,
       modelPar_vtofp1,
       modelPar_given_vtofp1,
       modelPar_cgfp1,
       modelPar_given_cgfp1,
       modelPar_cfp1s,
       modelPar_given_cfp1s,
       modelPar_ccfp1,
       modelPar_given_ccfp1,
       modelPar_cbfp1,
       modelPar_given_cbfp1,
       modelPar_vx0fp1,
       modelPar_given_vx0fp1,
       modelPar_mu0fp1,
       modelPar_given_mu0fp1,
       modelPar_betafp1,
       modelPar_given_betafp1,
       modelPar_delta1fp1,
       modelPar_given_delta1fp1,
       modelPar_sfp1,
       modelPar_given_sfp1,
       modelPar_ndfp1,
       modelPar_given_ndfp1,
       modelPar_vthetafp1,
       modelPar_given_vthetafp1,
       modelPar_mthetafp1,
       modelPar_given_mthetafp1,
       modelPar_alphafp1,
       modelPar_given_alphafp1,
       modelPar_lgfp2,
       modelPar_given_lgfp2,
       modelPar_vtofp2,
       modelPar_given_vtofp2,
       modelPar_cgfp2,
       modelPar_given_cgfp2,
       modelPar_cfp2s,
       modelPar_given_cfp2s,
       modelPar_ccfp2,
       modelPar_given_ccfp2,
       modelPar_cbfp2,
       modelPar_given_cbfp2,
       modelPar_vx0fp2,
       modelPar_given_vx0fp2,
       modelPar_mu0fp2,
       modelPar_given_mu0fp2,
       modelPar_betafp2,
       modelPar_given_betafp2,
       modelPar_delta1fp2,
       modelPar_given_delta1fp2,
       modelPar_sfp2,
       modelPar_given_sfp2,
       modelPar_ndfp2,
       modelPar_given_ndfp2,
       modelPar_vthetafp2,
       modelPar_given_vthetafp2,
       modelPar_mthetafp2,
       modelPar_given_mthetafp2,
       modelPar_alphafp2,
       modelPar_given_alphafp2,
       modelPar_lgfp3,
       modelPar_given_lgfp3,
       modelPar_vtofp3,
       modelPar_given_vtofp3,
       modelPar_cgfp3,
       modelPar_given_cgfp3,
       modelPar_cfp3s,
       modelPar_given_cfp3s,
       modelPar_ccfp3,
       modelPar_given_ccfp3,
       modelPar_cbfp3,
       modelPar_given_cbfp3,
       modelPar_vx0fp3,
       modelPar_given_vx0fp3,
       modelPar_mu0fp3,
       modelPar_given_mu0fp3,
       modelPar_betafp3,
       modelPar_given_betafp3,
       modelPar_delta1fp3,
       modelPar_given_delta1fp3,
       modelPar_sfp3,
       modelPar_given_sfp3,
       modelPar_ndfp3,
       modelPar_given_ndfp3,
       modelPar_vthetafp3,
       modelPar_given_vthetafp3,
       modelPar_mthetafp3,
       modelPar_given_mthetafp3,
       modelPar_alphafp3,
       modelPar_given_alphafp3,
       modelPar_lgfp4,
       modelPar_given_lgfp4,
       modelPar_vtofp4,
       modelPar_given_vtofp4,
       modelPar_cgfp4,
       modelPar_given_cgfp4,
       modelPar_cfp4s,
       modelPar_given_cfp4s,
       modelPar_ccfp4,
       modelPar_given_ccfp4,
       modelPar_cbfp4,
       modelPar_given_cbfp4,
       modelPar_vx0fp4,
       modelPar_given_vx0fp4,
       modelPar_mu0fp4,
       modelPar_given_mu0fp4,
       modelPar_betafp4,
       modelPar_given_betafp4,
       modelPar_delta1fp4,
       modelPar_given_delta1fp4,
       modelPar_sfp4,
       modelPar_given_sfp4,
       modelPar_ndfp4,
       modelPar_given_ndfp4,
       modelPar_vthetafp4,
       modelPar_given_vthetafp4,
       modelPar_mthetafp4,
       modelPar_given_mthetafp4,
       modelPar_alphafp4,
       modelPar_given_alphafp4,
       modelPar_rgsp,
       modelPar_given_rgsp,
       modelPar_vjg,
       modelPar_given_vjg,
       modelPar_pg_param1,
       modelPar_given_pg_param1,
       modelPar_pg_params,
       modelPar_given_pg_params,
       modelPar_ijs,
       modelPar_given_ijs,
       modelPar_vgsats,
       modelPar_given_vgsats,
       modelPar_fracs,
       modelPar_given_fracs,
       modelPar_alphags,
       modelPar_given_alphags,
       modelPar_pg_paramd,
       modelPar_given_pg_paramd,
       modelPar_ijd,
       modelPar_given_ijd,
       modelPar_vgsatd,
       modelPar_given_vgsatd,
       modelPar_fracd,
       modelPar_given_fracd,
       modelPar_alphagd,
       modelPar_given_alphagd,
       modelPar_pgsrecs,
       modelPar_given_pgsrecs,
       modelPar_irecs,
       modelPar_given_irecs,
       modelPar_vgsatqs,
       modelPar_given_vgsatqs,
       modelPar_vbdgs,
       modelPar_given_vbdgs,
       modelPar_pbdgs,
       modelPar_given_pbdgs,
       modelPar_betarecs,
       modelPar_given_betarecs,
       modelPar_kbdgates,
       modelPar_given_kbdgates,
       modelPar_pgsrecd,
       modelPar_given_pgsrecd,
       modelPar_irecd,
       modelPar_given_irecd,
       modelPar_vgsatqd,
       modelPar_given_vgsatqd,
       modelPar_vbdgd,
       modelPar_given_vbdgd,
       modelPar_pbdgd,
       modelPar_given_pbdgd,
       modelPar_betarecd,
       modelPar_given_betarecd,
       modelPar_kbdgated,
       modelPar_given_kbdgated,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_taugmrf,
       modelPar_given_taugmrf,
       modelPar_ctrap,
       modelPar_given_ctrap,
       modelPar_vttrap,
       modelPar_given_vttrap,
       modelPar_taut,
       modelPar_given_taut,
       modelPar_alphat1,
       modelPar_given_alphat1,
       modelPar_alphat2,
       modelPar_given_alphat2,
       modelPar_tempt,
       modelPar_given_tempt,
       modelPar_shs,
       modelPar_given_shs,
       modelPar_shd,
       modelPar_given_shd,
       modelPar_kf,
       modelPar_given_kf,
       modelPar_af,
       modelPar_given_af,
       modelPar_ffe,
       modelPar_given_ffe,
       modelPar_minr,
       modelPar_given_minr,
       modelPar_minl,
       modelPar_given_minl,
       modelPar_minc,
       modelPar_given_minc,
       // non-reals (including hidden)
       modelPar_type,
       modelPar_given_type,
       modelPar_flagres,
       modelPar_given_flagres,
       modelPar_flagfp1,
       modelPar_given_flagfp1,
       modelPar_flagfp1s,
       modelPar_given_flagfp1s,
       modelPar_flagfp2,
       modelPar_given_flagfp2,
       modelPar_flagfp2s,
       modelPar_given_flagfp2s,
       modelPar_flagfp3,
       modelPar_given_flagfp3,
       modelPar_flagfp3s,
       modelPar_given_flagfp3s,
       modelPar_flagfp4,
       modelPar_given_flagfp4,
       modelPar_flagfp4s,
       modelPar_given_flagfp4s,
       modelPar_igmod,
       modelPar_given_igmod,
       modelPar_gmdisp,
       modelPar_given_gmdisp,
       modelPar_trapselect,
       modelPar_given_trapselect,
       modelPar_noisemod,
       modelPar_given_noisemod,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);


    // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d+inst*(18+0)] += staticContributions[in.admsNodeID_d].dx(0);
    dqdp[in.admsNodeID_d+inst*(18+0)] += dynamicContributions[in.admsNodeID_d].dx(0);
    Findices[in.admsNodeID_d+inst*(18+0)] = in.li_d;
    Qindices[in.admsNodeID_d+inst*(18+0)] = in.li_d;
    dfdp[in.admsNodeID_g+inst*(18+0)] += staticContributions[in.admsNodeID_g].dx(0);
    dqdp[in.admsNodeID_g+inst*(18+0)] += dynamicContributions[in.admsNodeID_g].dx(0);
    Findices[in.admsNodeID_g+inst*(18+0)] = in.li_g;
    Qindices[in.admsNodeID_g+inst*(18+0)] = in.li_g;
    dfdp[in.admsNodeID_s+inst*(18+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(18+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(18+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(18+0)] = in.li_s;
    dfdp[in.admsNodeID_b+inst*(18+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(18+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(18+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(18+0)] = in.li_b;
    dfdp[in.admsNodeID_di+inst*(18+0)] += staticContributions[in.admsNodeID_di].dx(0);
    dqdp[in.admsNodeID_di+inst*(18+0)] += dynamicContributions[in.admsNodeID_di].dx(0);
    Findices[in.admsNodeID_di+inst*(18+0)] = in.li_di;
    Qindices[in.admsNodeID_di+inst*(18+0)] = in.li_di;
    dfdp[in.admsNodeID_gi+inst*(18+0)] += staticContributions[in.admsNodeID_gi].dx(0);
    dqdp[in.admsNodeID_gi+inst*(18+0)] += dynamicContributions[in.admsNodeID_gi].dx(0);
    Findices[in.admsNodeID_gi+inst*(18+0)] = in.li_gi;
    Qindices[in.admsNodeID_gi+inst*(18+0)] = in.li_gi;
    dfdp[in.admsNodeID_si+inst*(18+0)] += staticContributions[in.admsNodeID_si].dx(0);
    dqdp[in.admsNodeID_si+inst*(18+0)] += dynamicContributions[in.admsNodeID_si].dx(0);
    Findices[in.admsNodeID_si+inst*(18+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(18+0)] = in.li_si;
    dfdp[in.admsNodeID_fp1+inst*(18+0)] += staticContributions[in.admsNodeID_fp1].dx(0);
    dqdp[in.admsNodeID_fp1+inst*(18+0)] += dynamicContributions[in.admsNodeID_fp1].dx(0);
    Findices[in.admsNodeID_fp1+inst*(18+0)] = in.li_fp1;
    Qindices[in.admsNodeID_fp1+inst*(18+0)] = in.li_fp1;
    dfdp[in.admsNodeID_fp2+inst*(18+0)] += staticContributions[in.admsNodeID_fp2].dx(0);
    dqdp[in.admsNodeID_fp2+inst*(18+0)] += dynamicContributions[in.admsNodeID_fp2].dx(0);
    Findices[in.admsNodeID_fp2+inst*(18+0)] = in.li_fp2;
    Qindices[in.admsNodeID_fp2+inst*(18+0)] = in.li_fp2;
    dfdp[in.admsNodeID_fp3+inst*(18+0)] += staticContributions[in.admsNodeID_fp3].dx(0);
    dqdp[in.admsNodeID_fp3+inst*(18+0)] += dynamicContributions[in.admsNodeID_fp3].dx(0);
    Findices[in.admsNodeID_fp3+inst*(18+0)] = in.li_fp3;
    Qindices[in.admsNodeID_fp3+inst*(18+0)] = in.li_fp3;
    dfdp[in.admsNodeID_fp4+inst*(18+0)] += staticContributions[in.admsNodeID_fp4].dx(0);
    dqdp[in.admsNodeID_fp4+inst*(18+0)] += dynamicContributions[in.admsNodeID_fp4].dx(0);
    Findices[in.admsNodeID_fp4+inst*(18+0)] = in.li_fp4;
    Qindices[in.admsNodeID_fp4+inst*(18+0)] = in.li_fp4;
    dfdp[in.admsNodeID_drc+inst*(18+0)] += staticContributions[in.admsNodeID_drc].dx(0);
    dqdp[in.admsNodeID_drc+inst*(18+0)] += dynamicContributions[in.admsNodeID_drc].dx(0);
    Findices[in.admsNodeID_drc+inst*(18+0)] = in.li_drc;
    Qindices[in.admsNodeID_drc+inst*(18+0)] = in.li_drc;
    dfdp[in.admsNodeID_src+inst*(18+0)] += staticContributions[in.admsNodeID_src].dx(0);
    dqdp[in.admsNodeID_src+inst*(18+0)] += dynamicContributions[in.admsNodeID_src].dx(0);
    Findices[in.admsNodeID_src+inst*(18+0)] = in.li_src;
    Qindices[in.admsNodeID_src+inst*(18+0)] = in.li_src;
    dfdp[in.admsNodeID_tr+inst*(18+0)] += staticContributions[in.admsNodeID_tr].dx(0);
    dqdp[in.admsNodeID_tr+inst*(18+0)] += dynamicContributions[in.admsNodeID_tr].dx(0);
    Findices[in.admsNodeID_tr+inst*(18+0)] = in.li_tr;
    Qindices[in.admsNodeID_tr+inst*(18+0)] = in.li_tr;
    dfdp[in.admsNodeID_tr1+inst*(18+0)] += staticContributions[in.admsNodeID_tr1].dx(0);
    dqdp[in.admsNodeID_tr1+inst*(18+0)] += dynamicContributions[in.admsNodeID_tr1].dx(0);
    Findices[in.admsNodeID_tr1+inst*(18+0)] = in.li_tr1;
    Qindices[in.admsNodeID_tr1+inst*(18+0)] = in.li_tr1;
    dfdp[in.admsNodeID_xt1+inst*(18+0)] += staticContributions[in.admsNodeID_xt1].dx(0);
    dqdp[in.admsNodeID_xt1+inst*(18+0)] += dynamicContributions[in.admsNodeID_xt1].dx(0);
    Findices[in.admsNodeID_xt1+inst*(18+0)] = in.li_xt1;
    Qindices[in.admsNodeID_xt1+inst*(18+0)] = in.li_xt1;
    dfdp[in.admsNodeID_xt2+inst*(18+0)] += staticContributions[in.admsNodeID_xt2].dx(0);
    dqdp[in.admsNodeID_xt2+inst*(18+0)] += dynamicContributions[in.admsNodeID_xt2].dx(0);
    Findices[in.admsNodeID_xt2+inst*(18+0)] = in.li_xt2;
    Qindices[in.admsNodeID_xt2+inst*(18+0)] = in.li_xt2;
    dfdp[in.admsNodeID_dt+inst*(18+0)] += staticContributions[in.admsNodeID_dt].dx(0);
    dqdp[in.admsNodeID_dt+inst*(18+0)] += dynamicContributions[in.admsNodeID_dt].dx(0);
    Findices[in.admsNodeID_dt+inst*(18+0)] = in.li_dt;
    Qindices[in.admsNodeID_dt+inst*(18+0)] = in.li_dt;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSmvsg_cmc
} // namespace Device
} // namespace Xyce
